crystal_doc_search_index_callback({"repository_name":"github.com/crystal-lang/crystal","body":"# Crystal\n\n[![Travis CI Build Status](https://travis-ci.org/crystal-lang/crystal.svg)](https://travis-ci.org/crystal-lang/crystal)\n[![CircleCI Build Status](https://circleci.com/gh/crystal-lang/crystal/tree/master.svg?style=shield)](https://circleci.com/gh/crystal-lang/crystal)\n[![Join the chat at https://gitter.im/crystal-lang/crystal](https://badges.gitter.im/crystal-lang/crystal.svg)](https://gitter.im/crystal-lang/crystal)\n[![Bountysource](https://api.bountysource.com/badge/team?team_id=89730&style=raised)](https://www.bountysource.com/teams/crystal-lang/fundraisers/702-crystal-language)\n[![Code Triagers Badge](https://www.codetriage.com/crystal-lang/crystal/badges/users.svg)](https://www.codetriage.com/crystal-lang/crystal)\n\n---\n\n[![born-and-raised](https://cloud.githubusercontent.com/assets/209371/13291809/022e2360-daf8-11e5-8be7-d02c1c8b38fb.png)](https://manas.tech/)\n\nCrystal is a programming language with the following goals:\n\n* Have a syntax similar to Ruby (but compatibility with it is not a goal)\n* Statically type-checked but without having to specify the type of variables or method arguments.\n* Be able to call C code by writing bindings to it in Crystal.\n* Have compile-time evaluation and generation of code, to avoid boilerplate code.\n* Compile to efficient native code.\n\nWhy?\n----\n\nWe love Ruby's efficiency for writing code.\n\nWe love C's efficiency for running code.\n\nWe want the best of both worlds.\n\nWe want the compiler to understand what we mean without having to specify types everywhere.\n\nWe want full OOP.\n\nOh, and we don't want to write C code to make the code run faster.\n\nProject Status\n------\n\nCrystal is still under heavy development. There can be breaking changes but we're trying to keep them as minimum as possible.\n\nThe development is possible thanks to the community's effort, [84codes](https://www.84codes.com/)' support, and every [BountySource supporter](https://crystal-lang.org/sponsors).\n\nInstalling\n----------\n\n[Follow these instructions](https://crystal-lang.org/docs/installation/index.html)\n\nTry it online\n-------------\n\n[play.crystal-lang.org](https://play.crystal-lang.org/)\n\nDocumentation\n----------\n\n* [Official docs](http://crystal-lang.org/docs)\n* [Standard library API](https://crystal-lang.org/api)\n* [Roadmap](https://github.com/crystal-lang/crystal/wiki/Roadmap)\n\nCommunity\n---------\n\nQuestions or suggestions? Ask in our [Google Group](https://groups.google.com/forum/?fromgroups#!forum/crystal-lang), join our IRC channel [#crystal-lang](http://webchat.freenode.net/?channels=#crystal-lang) at chat.freenode.net, ask on our [Gitter channel](https://gitter.im/crystal-lang/crystal) or ask on Stack Overflow under the [crystal-lang](http://stackoverflow.com/questions/tagged/crystal-lang) tag.\n\nContributing\n---------\n\nRead the general [Contributing guide](https://github.com/crystal-lang/crystal/blob/master/CONTRIBUTING.md), and then:\n\n1. Fork it ( https://github.com/crystal-lang/crystal/fork )\n2. Create your feature branch (git checkout -b my-new-feature)\n3. Commit your changes (git commit -am 'Add some feature')\n4. Push to the branch (git push origin my-new-feature)\n5. Create a new Pull Request\n","program":{"html_id":"github.com/crystal-lang/crystal/toplevel","path":"toplevel.html","kind":"module","full_name":"Top Level Namespace","name":"Top Level Namespace","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"},{"html_id":"github.com/crystal-lang/crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"}],"locations":[],"repository_name":"github.com/crystal-lang/crystal","program":true,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"ARGF","name":"ARGF","value":"IO::ARGF.new(ARGV, STDIN)","doc":null,"summary":null},{"id":"ARGV","name":"ARGV","value":"Array.new(ARGC_UNSAFE - 1) do |i|\n  String.new(ARGV_UNSAFE[1 + i])\nend","doc":null,"summary":null},{"id":"PROGRAM_NAME","name":"PROGRAM_NAME","value":"String.new(ARGV_UNSAFE.value)","doc":null,"summary":null},{"id":"STDERR","name":"STDERR","value":"(IO::FileDescriptor.new(2, blocking: (LibC.isatty(2)) == 0)).tap do |f|\n  f.flush_on_newline = true\nend","doc":null,"summary":null},{"id":"STDIN","name":"STDIN","value":"IO::FileDescriptor.new(0, blocking: (LibC.isatty(0)) == 0)","doc":null,"summary":null},{"id":"STDOUT","name":"STDOUT","value":"(IO::FileDescriptor.new(1, blocking: (LibC.isatty(1)) == 0)).tap do |f|\n  f.flush_on_newline = true\nend","doc":null,"summary":null}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"},{"html_id":"github.com/crystal-lang/crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"}],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"},{"html_id":"github.com/crystal-lang/crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"}],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"`(command):String-class-method","html_id":"`(command):String-class-method","name":"`","doc":"Returns the standard output of executing *command* in a subshell.\nStandard input, and error are inherited.\nThe special `$?` variable is set to a `Process::Status` associated with this execution.\n\nExample:\n\n```\n`echo hi` # => \"hi\\n\"\n```","summary":"<p>Returns the standard output of executing <em>command</em> in a subshell.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"args_string":"(command) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L484","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L484","def":{"name":"`","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"process = Process.new(command, shell: true, input: Process::Redirect::Inherit, output: Process::Redirect::Pipe, error: Process::Redirect::Inherit)\noutput = process.output.gets_to_end\nstatus = process.wait\n$? = status\noutput\n"}},{"id":"abort(message,status=1):NoReturn-class-method","html_id":"abort(message,status=1):NoReturn-class-method","name":"abort","doc":"Terminates execution immediately, printing *message* to `STDERR` and\nthen calling `exit(status)`.","summary":"<p>Terminates execution immediately, printing <em>message</em> to <code><a href=\"toplevel.html#STDERR\">STDERR</a></code> and then calling <code><a href=\"toplevel.html#exit%28status%3D0%29%3ANoReturn-class-method\">exit(status)</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"status","doc":null,"default_value":"1","external_name":"status","restriction":""}],"args_string":"(message, status = <span class=\"n\">1</span>) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L454","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L454","def":{"name":"abort","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"status","doc":null,"default_value":"1","external_name":"status","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":"if message\n  STDERR.puts(message)\nend\nexit(status)\n"}},{"id":"at_exit(&handler:Int32,Exception?->):Nil-class-method","html_id":"at_exit(&amp;handler:Int32,Exception?-&gt;):Nil-class-method","name":"at_exit","doc":"Registers the given `Proc` for execution when the program exits.\nIf multiple handlers are registered, they are executed in reverse order of registration.\n\n```\ndef do_at_exit(str1)\n  at_exit { print str1 }\nend\n\nat_exit { puts \"cruel world\" }\ndo_at_exit(\"goodbye \")\nexit\n```\n\nProduces:\n\n```text\ngoodbye cruel world\n```\n\nThe exit status code that will be returned by this program is passed to\nthe block as its first argument. In case of any unhandled exception, it is\npassed as the second argument to the block, if the program terminates\nnormally or `exit(status)` is called explicitly, then the second argument\nwill be nil.","summary":"<p>Registers the given <code><a href=\"Proc.html\">Proc</a></code> for execution when the program exits.</p>","abstract":false,"args":[],"args_string":"(&handler : Int32, Exception? -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L436","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L436","def":{"name":"at_exit","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"(Int32, Exception | ::Nil -> )"},"return_type":"Nil","visibility":"Public","body":"AtExitHandlers.add(handler)"}},{"id":"caller-class-method","html_id":"caller-class-method","name":"caller","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/callstack.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/callstack.cr#L22","def":{"name":"caller","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CallStack.new.printable_backtrace"}},{"id":"delay(delay,&block:->_)-class-method","html_id":"delay(delay,&amp;block:-&gt;_)-class-method","name":"delay","doc":"Spawns a `Fiber` to compute *&block* in the background after *delay* has elapsed.\nAccess to get is synchronized between fibers.  *&block* is only called once.\nMay be canceled before *&block* is called by calling `cancel`.\n```\nd = delay(1) { Process.kill(Signal::KILL, Process.pid) }\n# ... long operations ...\nd.cancel\n```","summary":"<p>Spawns a <code><a href=\"Fiber.html\">Fiber</a></code> to compute <em>&block</em> in the background after <em>delay</em> has elapsed.</p>","abstract":false,"args":[{"name":"delay","doc":null,"default_value":"","external_name":"delay","restriction":""}],"args_string":"(delay, &block :  -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L127","def":{"name":"delay","args":[{"name":"delay","doc":null,"default_value":"","external_name":"delay","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(-> _)"},"return_type":"","visibility":"Public","body":"Concurrent::Future.new(delay: delay, &block)"}},{"id":"exit(status=0):NoReturn-class-method","html_id":"exit(status=0):NoReturn-class-method","name":"exit","doc":"Terminates execution immediately, returning the given status code\nto the invoking environment.\n\nRegistered `at_exit` procs are executed.","summary":"<p>Terminates execution immediately, returning the given status code to the invoking environment.</p>","abstract":false,"args":[{"name":"status","doc":null,"default_value":"0","external_name":"status","restriction":""}],"args_string":"(status = <span class=\"n\">0</span>) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L444","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L444","def":{"name":"exit","args":[{"name":"status","doc":null,"default_value":"0","external_name":"status","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":"status = AtExitHandlers.run(status)\nSTDOUT.flush\nSTDERR.flush\nCrystal.restore_blocking_state\nProcess.exit(status)\n"}},{"id":"fork-class-method","html_id":"fork-class-method","name":"fork","doc":"See also: `Process.fork`","summary":"<p>See also: <code>Process.fork</code></p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L498","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L498","def":{"name":"fork","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Process.fork"}},{"id":"fork(&block)-class-method","html_id":"fork(&amp;block)-class-method","name":"fork","doc":"See also: `Process.fork`","summary":"<p>See also: <code>Process.fork</code></p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L493","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L493","def":{"name":"fork","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"Process.fork do\n  yield\nend"}},{"id":"future(&exp:->_)-class-method","html_id":"future(&amp;exp:-&gt;_)-class-method","name":"future","doc":"Spawns a `Fiber` to compute *&block* in the background.\nAccess to get is synchronized between fibers.  *&block* is only called once.\n```\nf = future { `echo hello` }\n# ... other actions ...\nf.get # => \"hello\\n\"\n```","summary":"<p>Spawns a <code><a href=\"Fiber.html\">Fiber</a></code> to compute <em>&block</em> in the background.</p>","abstract":false,"args":[],"args_string":"(&exp :  -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L138","def":{"name":"future","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"(-> _)"},"return_type":"","visibility":"Public","body":"Concurrent::Future.new(&exp)"}},{"id":"gets(*args,**options)-class-method","html_id":"gets(*args,**options)-class-method","name":"gets","doc":"Reads a line from `STDIN`.\n\nSee also: `IO#gets`.","summary":"<p>Reads a line from <code><a href=\"toplevel.html#STDIN\">STDIN</a></code>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L35","def":{"name":"gets","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"STDIN.gets(*args, **options)"}},{"id":"lazy(&block:->_)-class-method","html_id":"lazy(&amp;block:-&gt;_)-class-method","name":"lazy","doc":"Conditionally spawns a `Fiber` to run *&block* in the background.\nAccess to get is synchronized between fibers.  *&block* is only called once.\n*&block* doesn't run by default, only when `get` is called.\n```\nl = lazy { expensive_computation }\nspawn { maybe_use_computation(l) }\nspawn { maybe_use_computation(l) }\n```","summary":"<p>Conditionally spawns a <code><a href=\"Fiber.html\">Fiber</a></code> to run <em>&block</em> in the background.</p>","abstract":false,"args":[],"args_string":"(&block :  -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/future.cr#L150","def":{"name":"lazy","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(-> _)"},"return_type":"","visibility":"Public","body":"Concurrent::Future.new(run_immediately: false, &block)"}},{"id":"loop(&block)-class-method","html_id":"loop(&amp;block)-class-method","name":"loop","doc":"Repeatedly executes the block.\n\n```\nloop do\n  line = gets\n  break unless line\n  # ...\nend\n```","summary":"<p>Repeatedly executes the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L26","def":{"name":"loop","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"while true\n  yield\nend"}},{"id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","html_id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main","doc":"Main function that acts as C's main function.\nInvokes `Crystal.main`.\n\nCan be redefined. See `Crystal.main` for examples.","summary":"<p>Main function that acts as C's main function.</p>","abstract":false,"args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":""},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":""}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L132","def":{"name":"main","args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":""},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal.main(argc, argv)"}},{"id":"p-class-method","html_id":"p-class-method","name":"p","doc":"Inspects *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\n```\np foo: 23, bar: 42 # => {foo: 23, bar: 42}\n```\n\nSee `Object#inspect(io)`","summary":"<p>Inspects <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L334","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L334","def":{"name":"p","args":[],"double_splat":{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if objects.empty?\nelse\n  p(objects)\nend"}},{"id":"p(object)-class-method","html_id":"p(object)-class-method","name":"p","doc":"Inspects *object* to `STDOUT` followed\nby a newline. Returns *object*.\n\nSee also: `Object#inspect(io)`.","summary":"<p>Inspects <em>object</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code> followed by a newline.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L309","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L309","def":{"name":"p","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"object.inspect(STDOUT)\nputs\nobject\n"}},{"id":"p(*objects)-class-method","html_id":"p(*objects)-class-method","name":"p","doc":"Inspects each object in *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\nSee also: `Object#inspect(io)`.","summary":"<p>Inspects each object in <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"args_string":"(*objects)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L319","def":{"name":"p","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"objects.each do |obj|\n  p(obj)\nend\nobjects\n"}},{"id":"pp(*objects)-class-method","html_id":"pp(*objects)-class-method","name":"pp","doc":"Pretty prints each object in *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\nSee also: `Object#pretty_print(pp)`.","summary":"<p>Pretty prints each object in <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"args_string":"(*objects)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L352","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L352","def":{"name":"pp","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"objects.each do |obj|\n  pp(obj)\nend\nobjects\n"}},{"id":"pp-class-method","html_id":"pp-class-method","name":"pp","doc":"Pretty prints *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\n```\np foo: 23, bar: 42 # => {foo: 23, bar: 42}\n```\n\nSee `Object#pretty_print(pp)`","summary":"<p>Pretty prints <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L367","def":{"name":"pp","args":[],"double_splat":{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if objects.empty?\nelse\n  pp(objects)\nend"}},{"id":"pp(object)-class-method","html_id":"pp(object)-class-method","name":"pp","doc":"Pretty prints *object* to `STDOUT` followed\nby a newline. Returns *object*.\n\nSee also: `Object#pretty_print(pp)`.","summary":"<p>Pretty prints <em>object</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code> followed by a newline.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L342","def":{"name":"pp","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"PrettyPrint.format(object, STDOUT, 79)\nputs\nobject\n"}},{"id":"print(*objects:_):Nil-class-method","html_id":"print(*objects:_):Nil-class-method","name":"print","doc":"Prints objects to STDOUT and then invokes `STDOUT.flush`.\n\nSee also: `IO#print`.","summary":"<p>Prints objects to STDOUT and then invokes <code>STDOUT.flush</code>.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L49","def":{"name":"print","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"STDOUT.print(*objects)\nSTDOUT.flush\n"}},{"id":"printf(format_string,*args):Nil-class-method","html_id":"printf(format_string,*args):Nil-class-method","name":"printf","doc":"Prints a formatted string to `STDOUT`.\n\nFor details on the format string, see `sprintf`.","summary":"<p>Prints a formatted string to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L57","def":{"name":"printf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"printf(format_string, args)"}},{"id":"printf(format_string,args:Array|Tuple):Nil-class-method","html_id":"printf(format_string,args:Array|Tuple):Nil-class-method","name":"printf","doc":"Prints a formatted string to `STDOUT`.\n\nFor details on the format string, see `sprintf`.","summary":"<p>Prints a formatted string to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L62","def":{"name":"printf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"STDOUT.printf(format_string, args)"}},{"id":"puts(*objects):Nil-class-method","html_id":"puts(*objects):Nil-class-method","name":"puts","doc":"Prints objects to `STDOUT`, each followed by a newline.\n\nSee also: `IO#puts`.","summary":"<p>Prints objects to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, each followed by a newline.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"args_string":"(*objects) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L301","def":{"name":"puts","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"STDOUT.puts(*objects)"}},{"id":"raise(exception:Exception):NoReturn-class-method","html_id":"raise(exception:Exception):NoReturn-class-method","name":"raise","doc":"Raises the *exception*.\n\nThis will set the exception's callstack if it hasn't been already.\nRe-raising a previously catched exception won't replace the callstack.","summary":"<p>Raises the <em>exception</em>.</p>","abstract":false,"args":[{"name":"exception","doc":null,"default_value":"","external_name":"exception","restriction":"Exception"}],"args_string":"(exception : Exception) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/raise.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/raise.cr#L202","def":{"name":"raise","args":[{"name":"exception","doc":null,"default_value":"","external_name":"exception","restriction":"Exception"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":"exception.callstack || (exception.callstack = CallStack.new)\nunwind_ex = Pointer(LibUnwind::Exception).malloc\nunwind_ex.value.exception_class = LibC::SizeT.zero\nunwind_ex.value.exception_cleanup = LibC::SizeT.zero\nunwind_ex.value.exception_object = exception.object_id\nunwind_ex.value.exception_type_id = exception.crystal_type_id\n__crystal_raise(unwind_ex)\n"}},{"id":"raise(message:String):NoReturn-class-method","html_id":"raise(message:String):NoReturn-class-method","name":"raise","doc":"Raises an Exception with the *message*.","summary":"<p>Raises an Exception with the <em>message</em>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"String"}],"args_string":"(message : String) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/raise.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/raise.cr#L219","def":{"name":"raise","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":"raise(Exception.new(message))"}},{"id":"rand(x)-class-method","html_id":"rand(x)-class-method","name":"rand","doc":"See `Random#rand(x)`.","summary":"<p>See <code>Random#rand(x)</code>.</p>","abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""}],"args_string":"(x)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L392","def":{"name":"rand","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Random.rand(x)"}},{"id":"rand-class-method","html_id":"rand-class-method","name":"rand","doc":"See `Random#rand`.","summary":"<p>See <code>Random#rand</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L387","def":{"name":"rand","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Random.rand"}},{"id":"read_line(*args,**options)-class-method","html_id":"read_line(*args,**options)-class-method","name":"read_line","doc":"Reads a line from `STDIN`.\n\nSee also: `IO#read_line`.","summary":"<p>Reads a line from <code><a href=\"toplevel.html#STDIN\">STDIN</a></code>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L42","def":{"name":"read_line","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"STDIN.read_line(*args, **options)"}},{"id":"sleep-class-method","html_id":"sleep-class-method","name":"sleep","doc":"Blocks the current fiber forever.\n\nMeanwhile, other ready-to-execute fibers might start their execution.","summary":"<p>Blocks the current fiber forever.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L27","def":{"name":"sleep","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Scheduler.reschedule"}},{"id":"sleep(time:Time::Span)-class-method","html_id":"sleep(time:Time::Span)-class-method","name":"sleep","doc":"Blocks the current Fiber for the specified time span.\n\nWhile this fiber is waiting this time other ready-to-execute\nfibers might start their execution.","summary":"<p>Blocks the current Fiber for the specified time span.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time::Span"}],"args_string":"(time : Time::Span)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L20","def":{"name":"sleep","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sleep(time.total_seconds)"}},{"id":"sleep(seconds:Number)-class-method","html_id":"sleep(seconds:Number)-class-method","name":"sleep","doc":"Blocks the current fiber for the specified number of seconds.\n\nWhile this fiber is waiting this time other ready-to-execute\nfibers might start their execution.","summary":"<p>Blocks the current fiber for the specified number of seconds.</p>","abstract":false,"args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Number"}],"args_string":"(seconds : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L8","def":{"name":"sleep","args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if seconds < 0\n  raise(ArgumentError.new(\"Sleep seconds must be positive\"))\nend\nFiber.sleep(seconds)\n"}},{"id":"spawn(*,name:String?=nil,&block)-class-method","html_id":"spawn(*,name:String?=nil,&amp;block)-class-method","name":"spawn","doc":"Spawns a new fiber.\n\nThe newly created fiber doesn't run as soon as spawned.\n\nExample:\n```\n# Write \"1\" every 1 second and \"2\" every 2 seconds for 6 seconds.\n\nch = Channel(Nil).new\n\nspawn do\n  6.times do\n    sleep 1\n    puts 1\n  end\n  ch.send(nil)\nend\n\nspawn do\n  3.times do\n    sleep 2\n    puts 2\n  end\n  ch.send(nil)\nend\n\n2.times { ch.receive }\n```","summary":"<p>Spawns a new fiber.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(*, name : String? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L59","def":{"name":"spawn","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":0,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"fiber = Fiber.new(name, &block)\nScheduler.enqueue(fiber)\nfiber\n"}},{"id":"sprintf(format_string,*args):String-class-method","html_id":"sprintf(format_string,*args):String-class-method","name":"sprintf","doc":"Returns a formatted string.\nThe string is produced according to the *format_string* with format specifiers\nbeing replaced by values from *args* formatted according to the specifier.\n\nWithin the format string, any characters other than format specifiers\n(specifiers beginning with `%`) are copied to the result.\n\nThe syntax for a format specifier is:\n\n```text\n%[flags][width][.precision]type\n```\n\nA format specifier consists of a percent sign, followed by optional flags,\nwidth, and precision indicators, then terminated with a field type\ncharacter.\n\nThe field type controls how the corresponding\n`sprintf` argument is to be interpreted, while the flags\nmodify that interpretation.\n\nThe field type characters are:\n\n```text\n    Field |  Integer Format\n    ------+--------------------------------------------------------------\n      b   | Formats argument as a binary number.\n      d   | Formats argument as a decimal number.\n      i   | Same as d.\n      o   | Formats argument as an octal number.\n      x   | Formats argument as a hexadecimal number using lowercase letters.\n      X   | Same as x, but uses uppercase letters.\n\n    Field |  Float Format\n    ------+--------------------------------------------------------------\n      e   | Formats floating point argument into exponential notation\n          | with one digit before the decimal point as [-]d.dddddde[+-]dd.\n          | The precision specifies the number of digits after the decimal\n          | point (defaulting to six).\n      E   | Equivalent to e, but uses an uppercase E to indicate\n          | the exponent.\n      f   | Formats floating point argument as [-]ddd.dddddd,\n          | where the precision specifies the number of digits after\n          | the decimal point.\n      g   | Formats a floating point number using exponential form\n          | if the exponent is less than -4 or greater than or\n          | equal to the precision, or in dd.dddd form otherwise.\n          | The precision specifies the number of significant digits.\n      G   | Equivalent to g, but use an uppercase E in exponent form.\n      a   | Formats floating point argument as [-]0xh.hhhhp[+-]dd,\n          | which is consisted from optional sign, \"0x\", fraction part\n          | as hexadecimal, \"p\", and exponential part as decimal.\n      A   | Equivalent to a, but use uppercase X and P.\n\n    Field |  Other Format\n    ------+--------------------------------------------------------------\n      c   | Argument is the numeric code for a single character or\n          | a single character string itself.\n      s   | Argument is a string to be substituted.  If the format\n          | sequence contains a precision, at most that many characters\n          | will be copied.\n      %   | A percent sign itself will be displayed.  No argument taken.\n\n```\nThe flags modifies the behavior of the formats.\nThe flag characters are:\n```text\n\n  Flag     | Applies to    | Meaning\n  ---------+---------------+-----------------------------------------\n  space    | bdiouxX       | Add a leading space character to\n           | aAeEfgG       | non-negative numbers.\n           | (numeric fmt) | For o, x, X, b, use\n           |               | a minus sign with absolute value for\n           |               | negative values.\n  ---------+---------------+-----------------------------------------\n  +        | bdiouxX       | Add a leading plus sign to non-negative\n           | aAeEfgG       | numbers.\n           | (numeric fmt) | For o, x, X, b, use\n           |               | a minus sign with absolute value for\n           |               | negative values.\n  ---------+---------------+-----------------------------------------\n  -        | all           | Left-justify the result of this conversion.\n  ---------+---------------+-----------------------------------------\n  0 (zero) | bdiouxX       | Pad with zeros, not spaces.\n           | aAeEfgG       | For o, x, X, b, radix-1\n           | (numeric fmt) | is used for negative numbers formatted as\n           |               | complements.\n```\n\nExamples of flags:\n\nDecimal number conversion\n```\nsprintf \"%d\", 123  # => \"123\"\nsprintf \"%+d\", 123 # => \"+123\"\nsprintf \"% d\", 123 # => \" 123\"\n```\n\nOctal number conversion\n```\nsprintf \"%o\", 123   # => \"173\"\nsprintf \"%+o\", 123  # => \"+173\"\nsprintf \"%o\", -123  # => \"-173\"\nsprintf \"%+o\", -123 # => \"-173\"\n```\n\nHexadecimal number conversion\n```\nsprintf \"%x\", 123   # => \"7b\"\nsprintf \"%+x\", 123  # => \"+7b\"\nsprintf \"%x\", -123  # => \"-7b\"\nsprintf \"%+x\", -123 # => \"-7b\"\nsprintf \"%#x\", 0    # => \"0\"\nsprintf \"% x\", 123  # => \" 7b\"\nsprintf \"% x\", -123 # => \"-7b\"\nsprintf \"%X\", 123   # => \"7B\"\nsprintf \"%#X\", -123 # => \"-7B\"\n```\n\nBinary number conversion\n```\nsprintf \"%b\", 123    # => \"1111011\"\nsprintf \"%+b\", 123   # => \"+1111011\"\nsprintf \"%+b\", -123  # => \"-1111011\"\nsprintf \"%b\", -123   # => \"-1111011\"\nsprintf \"%#b\", 0     # => \"0\"\nsprintf \"% b\", 123   # => \" 1111011\"\nsprintf \"%+ b\", 123  # => \"+ 1111011\"\nsprintf \"% b\", -123  # => \"-1111011\"\nsprintf \"%+ b\", -123 # => \"-1111011\"\n```\n\nFloating point conversion\n```\nsprintf \"%a\", 123 # => \"0x1.ecp+6\"\nsprintf \"%A\", 123 # => \"0X1.ECP+6\"\n```\n\nExponential form conversion\n```\nsprintf \"%g\", 123.4          # => \"123.4\"\nsprintf \"%g\", 123.4567       # => \"123.457\"\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%20.8G\", 123456789  # => \"       1.2345679E+08\"\nsprintf \"%20.8g\", -123456789 # => \"       -1.2345679e+08\"\nsprintf \"%20.8G\", -123456789 # => \"       -1.2345679E+08\"\n```\n\nThe field width is an optional integer, followed optionally by a\nperiod and a precision. The width specifies the minimum number of\ncharacters that will be written to the result for this field.\n\nExamples of width:\n```\nsprintf \"%20d\", 123   # => \"                 123\"\nsprintf \"%+20d\", 123  # => \"                +123\"\nsprintf \"%020d\", 123  # => \"00000000000000000123\"\nsprintf \"%+020d\", 12  # => \"+0000000000000000123\"\nsprintf \"% 020d\", 123 # => \" 0000000000000000123\"\nsprintf \"%-20d\", 123  # => \"123                 \"\nsprintf \"%-+20d\", 123 # => \"+123                \"\nsprintf \"%- 20d\", 123 # => \" 123                \"\nsprintf \"%020x\", -123 # => \"00000000000000000-7b\"\nsprintf \"%020X\", -123 # => \"00000000000000000-7B\"\n```\n\nFor numeric fields, the precision controls the number of decimal places\ndisplayed.\n\nFor string fields, the precision determines the maximum\nnumber of characters to be copied from the string.\n\nExamples of precisions:\n\nPrecision for `d`, `o`, `x` and `b` is\nminimum number of digits\n```\nsprintf \"%20.8d\", 123   # => \"                 123\"\nsprintf \"%020.8d\", 123  # => \"00000000000000000123\"\nsprintf \"%20.8o\", 123   # => \"                 173\"\nsprintf \"%020.8o\", 123  # => \"00000000000000000173\"\nsprintf \"%20.8x\", 123   # => \"                  7b\"\nsprintf \"%020.8x\", 123  # => \"0000000000000000007b\"\nsprintf \"%20.8b\", 123   # => \"            01111011\"\nsprintf \"%20.8d\", -123  # => \"                -123\"\nsprintf \"%020.8d\", -123 # => \"0000000000000000-123\"\nsprintf \"%20.8o\", -123  # => \"                -173\"\nsprintf \"%20.8x\", -123  # => \"                 -7b\"\nsprintf \"%20.8b\", -11   # => \"               -1011\"\n```\n\nPrecision for `e` is number of digits after the decimal point.\n```\nsprintf \"%20.8e\", 1234.56789 # => \"      1.23456789e+03\"\n```\n\nPrecision for `f` is number of digits after the decimal point.\n```\nsprintf \"%20.8f\", 1234.56789 # => \"       1234.56789000\"\n```\n\nPrecision for `g` is number of significant digits.\n```\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%-20.8g\", 123456789 # => \"1.2345679e+08       \"\n```\n\nPrecision for `s` is maximum number of characters.\n```\nsprintf \"%20.8s\", \"string test\" # => \"            string t\"\n```\n\nAdditional examples:\n```\nsprintf \"%d %04x\", 123, 123             # => \"123 007b\"\nsprintf \"%08b '%4s'\", 123, 123          # => \"01111011 ' 123'\"\nsprintf \"%+g:% g:%-g\", 1.23, 1.23, 1.23 # => \"+1.23: 1.23:1.23\"\n```","summary":"<p>Returns a formatted string.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L287","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L287","def":{"name":"sprintf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"sprintf(format_string, args)"}},{"id":"sprintf(format_string,args:Array|Tuple):String-class-method","html_id":"sprintf(format_string,args:Array|Tuple):String-class-method","name":"sprintf","doc":"Returns a formatted string.\nThe string is produced according to the *format_string* with format specifiers\nbeing replaced by values from *args* formatted according to the specifier.\n\nWithin the format string, any characters other than format specifiers\n(specifiers beginning with `%`) are copied to the result.\n\nThe syntax for a format specifier is:\n\n```text\n%[flags][width][.precision]type\n```\n\nA format specifier consists of a percent sign, followed by optional flags,\nwidth, and precision indicators, then terminated with a field type\ncharacter.\n\nThe field type controls how the corresponding\n`sprintf` argument is to be interpreted, while the flags\nmodify that interpretation.\n\nThe field type characters are:\n\n```text\n    Field |  Integer Format\n    ------+--------------------------------------------------------------\n      b   | Formats argument as a binary number.\n      d   | Formats argument as a decimal number.\n      i   | Same as d.\n      o   | Formats argument as an octal number.\n      x   | Formats argument as a hexadecimal number using lowercase letters.\n      X   | Same as x, but uses uppercase letters.\n\n    Field |  Float Format\n    ------+--------------------------------------------------------------\n      e   | Formats floating point argument into exponential notation\n          | with one digit before the decimal point as [-]d.dddddde[+-]dd.\n          | The precision specifies the number of digits after the decimal\n          | point (defaulting to six).\n      E   | Equivalent to e, but uses an uppercase E to indicate\n          | the exponent.\n      f   | Formats floating point argument as [-]ddd.dddddd,\n          | where the precision specifies the number of digits after\n          | the decimal point.\n      g   | Formats a floating point number using exponential form\n          | if the exponent is less than -4 or greater than or\n          | equal to the precision, or in dd.dddd form otherwise.\n          | The precision specifies the number of significant digits.\n      G   | Equivalent to g, but use an uppercase E in exponent form.\n      a   | Formats floating point argument as [-]0xh.hhhhp[+-]dd,\n          | which is consisted from optional sign, \"0x\", fraction part\n          | as hexadecimal, \"p\", and exponential part as decimal.\n      A   | Equivalent to a, but use uppercase X and P.\n\n    Field |  Other Format\n    ------+--------------------------------------------------------------\n      c   | Argument is the numeric code for a single character or\n          | a single character string itself.\n      s   | Argument is a string to be substituted.  If the format\n          | sequence contains a precision, at most that many characters\n          | will be copied.\n      %   | A percent sign itself will be displayed.  No argument taken.\n\n```\nThe flags modifies the behavior of the formats.\nThe flag characters are:\n```text\n\n  Flag     | Applies to    | Meaning\n  ---------+---------------+-----------------------------------------\n  space    | bdiouxX       | Add a leading space character to\n           | aAeEfgG       | non-negative numbers.\n           | (numeric fmt) | For o, x, X, b, use\n           |               | a minus sign with absolute value for\n           |               | negative values.\n  ---------+---------------+-----------------------------------------\n  +        | bdiouxX       | Add a leading plus sign to non-negative\n           | aAeEfgG       | numbers.\n           | (numeric fmt) | For o, x, X, b, use\n           |               | a minus sign with absolute value for\n           |               | negative values.\n  ---------+---------------+-----------------------------------------\n  -        | all           | Left-justify the result of this conversion.\n  ---------+---------------+-----------------------------------------\n  0 (zero) | bdiouxX       | Pad with zeros, not spaces.\n           | aAeEfgG       | For o, x, X, b, radix-1\n           | (numeric fmt) | is used for negative numbers formatted as\n           |               | complements.\n```\n\nExamples of flags:\n\nDecimal number conversion\n```\nsprintf \"%d\", 123  # => \"123\"\nsprintf \"%+d\", 123 # => \"+123\"\nsprintf \"% d\", 123 # => \" 123\"\n```\n\nOctal number conversion\n```\nsprintf \"%o\", 123   # => \"173\"\nsprintf \"%+o\", 123  # => \"+173\"\nsprintf \"%o\", -123  # => \"-173\"\nsprintf \"%+o\", -123 # => \"-173\"\n```\n\nHexadecimal number conversion\n```\nsprintf \"%x\", 123   # => \"7b\"\nsprintf \"%+x\", 123  # => \"+7b\"\nsprintf \"%x\", -123  # => \"-7b\"\nsprintf \"%+x\", -123 # => \"-7b\"\nsprintf \"%#x\", 0    # => \"0\"\nsprintf \"% x\", 123  # => \" 7b\"\nsprintf \"% x\", -123 # => \"-7b\"\nsprintf \"%X\", 123   # => \"7B\"\nsprintf \"%#X\", -123 # => \"-7B\"\n```\n\nBinary number conversion\n```\nsprintf \"%b\", 123    # => \"1111011\"\nsprintf \"%+b\", 123   # => \"+1111011\"\nsprintf \"%+b\", -123  # => \"-1111011\"\nsprintf \"%b\", -123   # => \"-1111011\"\nsprintf \"%#b\", 0     # => \"0\"\nsprintf \"% b\", 123   # => \" 1111011\"\nsprintf \"%+ b\", 123  # => \"+ 1111011\"\nsprintf \"% b\", -123  # => \"-1111011\"\nsprintf \"%+ b\", -123 # => \"-1111011\"\n```\n\nFloating point conversion\n```\nsprintf \"%a\", 123 # => \"0x1.ecp+6\"\nsprintf \"%A\", 123 # => \"0X1.ECP+6\"\n```\n\nExponential form conversion\n```\nsprintf \"%g\", 123.4          # => \"123.4\"\nsprintf \"%g\", 123.4567       # => \"123.457\"\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%20.8G\", 123456789  # => \"       1.2345679E+08\"\nsprintf \"%20.8g\", -123456789 # => \"       -1.2345679e+08\"\nsprintf \"%20.8G\", -123456789 # => \"       -1.2345679E+08\"\n```\n\nThe field width is an optional integer, followed optionally by a\nperiod and a precision. The width specifies the minimum number of\ncharacters that will be written to the result for this field.\n\nExamples of width:\n```\nsprintf \"%20d\", 123   # => \"                 123\"\nsprintf \"%+20d\", 123  # => \"                +123\"\nsprintf \"%020d\", 123  # => \"00000000000000000123\"\nsprintf \"%+020d\", 12  # => \"+0000000000000000123\"\nsprintf \"% 020d\", 123 # => \" 0000000000000000123\"\nsprintf \"%-20d\", 123  # => \"123                 \"\nsprintf \"%-+20d\", 123 # => \"+123                \"\nsprintf \"%- 20d\", 123 # => \" 123                \"\nsprintf \"%020x\", -123 # => \"00000000000000000-7b\"\nsprintf \"%020X\", -123 # => \"00000000000000000-7B\"\n```\n\nFor numeric fields, the precision controls the number of decimal places\ndisplayed.\n\nFor string fields, the precision determines the maximum\nnumber of characters to be copied from the string.\n\nExamples of precisions:\n\nPrecision for `d`, `o`, `x` and `b` is\nminimum number of digits\n```\nsprintf \"%20.8d\", 123   # => \"                 123\"\nsprintf \"%020.8d\", 123  # => \"00000000000000000123\"\nsprintf \"%20.8o\", 123   # => \"                 173\"\nsprintf \"%020.8o\", 123  # => \"00000000000000000173\"\nsprintf \"%20.8x\", 123   # => \"                  7b\"\nsprintf \"%020.8x\", 123  # => \"0000000000000000007b\"\nsprintf \"%20.8b\", 123   # => \"            01111011\"\nsprintf \"%20.8d\", -123  # => \"                -123\"\nsprintf \"%020.8d\", -123 # => \"0000000000000000-123\"\nsprintf \"%20.8o\", -123  # => \"                -173\"\nsprintf \"%20.8x\", -123  # => \"                 -7b\"\nsprintf \"%20.8b\", -11   # => \"               -1011\"\n```\n\nPrecision for `e` is number of digits after the decimal point.\n```\nsprintf \"%20.8e\", 1234.56789 # => \"      1.23456789e+03\"\n```\n\nPrecision for `f` is number of digits after the decimal point.\n```\nsprintf \"%20.8f\", 1234.56789 # => \"       1234.56789000\"\n```\n\nPrecision for `g` is number of significant digits.\n```\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%-20.8g\", 123456789 # => \"1.2345679e+08       \"\n```\n\nPrecision for `s` is maximum number of characters.\n```\nsprintf \"%20.8s\", \"string test\" # => \"            string t\"\n```\n\nAdditional examples:\n```\nsprintf \"%d %04x\", 123, 123             # => \"123 007b\"\nsprintf \"%08b '%4s'\", 123, 123          # => \"01111011 ' 123'\"\nsprintf \"%+g:% g:%-g\", 1.23, 1.23, 1.23 # => \"+1.23: 1.23:1.23\"\n```","summary":"<p>Returns a formatted string.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L292","def":{"name":"sprintf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build(format_string.bytesize) do |str|\n  (String::Formatter(typeof(args)).new(format_string, args, str)).format\nend"}},{"id":"system(command:String,args=nil):Bool-class-method","html_id":"system(command:String,args=nil):Bool-class-method","name":"system","doc":"Executes the given command in a subshell.\nStandard input, output and error are inherited.\nReturns `true` if the command gives zero exit code, `false` otherwise.\nThe special `$?` variable is set to a `Process::Status` associated with this execution.\n\nIf *command* contains no spaces and *args* is given, it will become\nits argument list.\n\nIf *command* contains spaces and *args* is given, *command* must include\n`\"${@}\"` (including the quotes) to receive the argument list.\n\nNo shell interpretation is done in *args*.\n\nExample:\n\n```\nsystem(\"echo *\")\n```\n\nProduces:\n\n```text\nLICENSE shard.yml Readme.md spec src\n```","summary":"<p>Executes the given command in a subshell.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""}],"args_string":"(command : String, args = <span class=\"n\">nil</span>) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L469","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L469","def":{"name":"system","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"status = Process.run(command, args, shell: true, input: Process::Redirect::Inherit, output: Process::Redirect::Inherit, error: Process::Redirect::Inherit)\n$? = status\nstatus.success?\n"}},{"id":"with_color(color:Symbol)-class-method","html_id":"with_color(color:Symbol)-class-method","name":"with_color","doc":null,"summary":null,"abstract":false,"args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L108","def":{"name":"with_color","args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"\".colorize(color)"}},{"id":"with_color-class-method","html_id":"with_color-class-method","name":"with_color","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L104","def":{"name":"with_color","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"\".colorize"}}],"constructors":[],"instance_methods":[],"macros":[{"id":"assert_responds_to(var,method)-macro","html_id":"assert_responds_to(var,method)-macro","name":"assert_responds_to","doc":null,"summary":null,"abstract":false,"args":[{"name":"var","doc":null,"default_value":"","external_name":"var","restriction":""},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""}],"args_string":"(var, method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/macros.cr#L189","def":{"name":"assert_responds_to","args":[{"name":"var","doc":null,"default_value":"","external_name":"var","restriction":""},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"  if \n{{ var }}\n.responds_to?(:\n{{ method }}\n)\n    \n{{ var }}\n\n  \nelse\n    raise \"Expected \n{{ var }}\n to respond to :\n{{ method }}\n, not #{ \n{{ var }}\n }\"\n  \nend\n\n"}},{"id":"debugger-macro","html_id":"debugger-macro","name":"debugger","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/intrinsics.cr#L25","def":{"name":"debugger","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"  Intrinsics.debugtrap\n"}},{"id":"p!(*exps)-macro","html_id":"p!(*exps)-macro","name":"p!","doc":"Prints a series of expressions together with their inspected values.\nUseful for print style debugging.\n\n```\na = 1\np! a # => \"a # => 1\"\n\np! [1, 2, 3].map(&.to_s) # => \"[1, 2, 3].map(&.to_s) # => [\"1\", \"2\", \"3\"]\"\n```\n\nSee also: `p`, `Object#inspect`.","summary":"<p>Prints a series of expressions together with their inspected values.</p>","abstract":false,"args":[{"name":"exps","doc":null,"default_value":"","external_name":"exps","restriction":""}],"args_string":"(*exps)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/macros.cr#L166","def":{"name":"p!","args":[{"name":"exps","doc":null,"default_value":"","external_name":"exps","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"  \n{% if exps.size == 0 %}\n    # Nothing\n  {% else %}{% if exps.size == 1 %}\n    {% exp = exps.first %}\n    %prefix = \"#{{{ exp.stringify }}} # => \"\n    ::print %prefix\n    ::p({{ exp }})\n  {% else %}\n    %names = { {{ *exps.map(&.stringify) }} }\n    %max_size = %names.max_of &.size\n    {\n      {% for exp, i in exps %}\n        begin\n          %prefix = \"#{%names[{{ i }}].ljust(%max_size)} # => \"\n          ::print %prefix\n          ::p({{ exp }})\n        end,\n      {% end %}\n    }\n  {% end %}{% end %}\n\n\n"}},{"id":"parallel(*jobs)-macro","html_id":"parallel(*jobs)-macro","name":"parallel","doc":"Runs the commands passed as arguments concurrently (in Fibers) and waits\nfor them to finish.\n\n```\ndef say(word)\n  puts word\nend\n\n# Will print out the three words concurrently\nparallel(\n  say(\"concurrency\"),\n  say(\"is\"),\n  say(\"easy\")\n)\n```\n\nCan also be used to conveniently collect the return values of the\nconcurrent operations.\n\n```\ndef concurrent_job(word)\n  word\nend\n\na, b, c =\n  parallel(\n    concurrent_job(\"concurrency\"),\n    concurrent_job(\"is\"),\n    concurrent_job(\"easy\")\n  )\n\nputs a # => \"concurrency\"\nputs b # => \"is\"\nputs c # => \"easy\"\n```\n\nDue to the concurrent nature of this macro, it is highly recommended\nto handle any exceptions within the concurrent calls. Unhandled\nexceptions raised within the concurrent operations will be re-raised\ninside the parent fiber as `ConcurrentExecutionException`, with the\n`cause` attribute set to the original exception.","summary":"<p>Runs the commands passed as arguments concurrently (in Fibers) and waits for them to finish.</p>","abstract":false,"args":[{"name":"jobs","doc":null,"default_value":"","external_name":"jobs","restriction":""}],"args_string":"(*jobs)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L177","def":{"name":"parallel","args":[{"name":"jobs","doc":null,"default_value":"","external_name":"jobs","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"  \n%channel\n = Channel(Exception | Nil).new\n\n  \n{% for job, i in jobs %}\n    %ret{i} = uninitialized typeof({{ job }})\n    spawn do\n      begin\n        %ret{i} = {{ job }}\n      rescue e : Exception\n        %channel.send e\n      else\n        %channel.send nil\n      end\n    end\n  {% end %}\n\n\n  \n{{ jobs.size }}\n.times do\n    \n%value\n = \n%channel\n.receive\n    if \n%value\n.is_a?(Exception)\n      raise ConcurrentExecutionException.new(\n        \"An unhandled error occured inside a `parallel` call\",\n        cause: \n%value\n\n      )\n    \nend\n  \nend\n\n  \n{\n    \n{% for job, i in jobs %}\n      %ret{i},\n    {% end %}\n\n  }\n\n"}},{"id":"pp!(*exps)-macro","html_id":"pp!(*exps)-macro","name":"pp!","doc":"Prints a series of expressions together with their pretty printed values.\nUseful for print style debugging.\n\n```\na = 1\npp! a # => \"a # => 1\"\n\npp! [1, 2, 3].map(&.to_s) # => \"[1, 2, 3].map(&.to_s) # => [\"1\", \"2\", \"3\"]\"\n```\n\nSee also: `pp`, `Object#pretty_inspect`.","summary":"<p>Prints a series of expressions together with their pretty printed values.</p>","abstract":false,"args":[{"name":"exps","doc":null,"default_value":"","external_name":"exps","restriction":""}],"args_string":"(*exps)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/macros.cr#L132","def":{"name":"pp!","args":[{"name":"exps","doc":null,"default_value":"","external_name":"exps","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"  \n{% if exps.size == 0 %}\n    # Nothing\n  {% else %}{% if exps.size == 1 %}\n    {% exp = exps.first %}\n    %prefix = \"#{{{ exp.stringify }}} # => \"\n    ::print %prefix\n    ::pp({{ exp }})\n  {% else %}\n    %names = { {{ *exps.map(&.stringify) }} }\n    %max_size = %names.max_of &.size\n    {\n      {% for exp, i in exps %}\n        begin\n          %prefix = \"#{%names[{{ i }}].ljust(%max_size)} # => \"\n          ::print %prefix\n          ::pp({{ exp }})\n        end,\n      {% end %}\n    }\n  {% end %}{% end %}\n\n\n"}},{"id":"record(name,*properties)-macro","html_id":"record(name,*properties)-macro","name":"record","doc":"Defines a **`Struct`** with the given name and properties.\n\nThe generated struct has a constructor with the given properties\nin the same order as declared. The struct only provides getters,\nnot setters, making it immutable by default.\n\nThe properties can be type declarations or assignments.\n\nYou can pass a block to this macro, that will be inserted inside\nthe struct definition.\n\n```\nrecord Point, x : Int32, y : Int32\n\nPoint.new 1, 2 # => #<Point(@x=1, @y=2)>\n```\n\nAn example with the block version:\n\n```\nrecord Person, first_name : String, last_name : String do\n  def full_name\n    \"#{first_name} #{last_name}\"\n  end\nend\n\nperson = Person.new \"John\", \"Doe\"\nperson.full_name # => \"John Doe\"\n```\n\nAn example with type declarations and default values:\n\n```\nrecord Point, x : Int32 = 0, y : Int32 = 0\n\nPoint.new      # => #<Point(@x=0, @y=0)>\nPoint.new y: 2 # => #<Point(@x=0, @y=2)>\n```\n\nAn example with assignments (in this case the compiler must be able to\ninfer the types from the default values):\n\n```\nrecord Point, x = 0, y = 0\n\nPoint.new      # => #<Point(@x=0, @y=0)>\nPoint.new y: 2 # => #<Point(@x=0, @y=2)>\n```\n\nThis macro also provides a `copy_with` method which returns\na copy of the record with the provided properties altered.\n\n```\nrecord Point, x = 0, y = 0\n\np = Point.new y: 2 # => #<Point(@x=0, @y=2)>\np.copy_with x: 3   # => #<Point(@x=3, @y=2)>\np                  # => #<Point(@x=0, @y=2)>\n```","summary":"<p>Defines a <strong><code><a href=\"Struct.html\">Struct</a></code></strong> with the given name and properties.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"properties","doc":null,"default_value":"","external_name":"properties","restriction":""}],"args_string":"(name, *properties)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/macros.cr#L60","def":{"name":"record","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"properties","doc":null,"default_value":"","external_name":"properties","restriction":""}],"double_splat":null,"splat_index":1,"block_arg":null,"visibility":"Public","body":"  struct \n{{ name.id }}\n\n    \n{% for property in properties %}\n      {% if property.is_a?(Assign) %}\n        getter {{ property.target.id }}\n      {% else %}{% if property.is_a?(TypeDeclaration) %}\n        getter {{ property.var }} : {{ property.type }}\n      {% else %}\n        getter :{{ property.id }}\n      {% end %}{% end %}\n    {% end %}\n\n\n    def initialize(\n{{ *properties.map do |field|\n  \"@#{field.id}\".id\nend }}\n)\n    \nend\n\n    \n{{ yield }}\n\n\n    def copy_with(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"#{property.target.id} _#{property.target.id} = @#{property.target.id}\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"#{property.var.id} _#{property.var.id} = @#{property.var.id}\".id\n    else\n      \"#{property.id} _#{property.id} = @#{property.id}\".id\n    end\n  end\nend }}\n)\n      \n{{ name.id }}\n.new(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"_#{property.target.id}\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"_#{property.var.id}\".id\n    else\n      \"_#{property.id}\".id\n    end\n  end\nend }}\n)\n    \nend\n\n    def clone\n      \n{{ name.id }}\n.new(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"@#{property.target.id}.clone\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"@#{property.var.id}.clone\".id\n    else\n      \"@#{property.id}.clone\".id\n    end\n  end\nend }}\n)\n    \nend\n  \nend\n\n"}},{"id":"spawn(call,*,name=nil)-macro","html_id":"spawn(call,*,name=nil)-macro","name":"spawn","doc":"Spawns a fiber by first creating a `Proc`, passing the *call*'s\nexpressions to it, and letting the `Proc` finally invoke the *call*.\n\nCompare this:\n\n```\ni = 0\nwhile i < 5\n  spawn { print(i) }\n  i += 1\nend\nFiber.yield\n# Output: 55555\n```\n\nTo this:\n\n```\ni = 0\nwhile i < 5\n  spawn print(i)\n  i += 1\nend\nFiber.yield\n# Output: 01234\n```\n\nThis is because in the first case all spawned fibers refer to\nthe same local variable, while in the second example copies of\n*i* are passed to a `Proc` that eventually invokes the call.","summary":"<p>Spawns a fiber by first creating a <code><a href=\"Proc.html\">Proc</a></code>, passing the <em>call</em>'s expressions to it, and letting the <code><a href=\"Proc.html\">Proc</a></code> finally invoke the <em>call</em>.</p>","abstract":false,"args":[{"name":"call","doc":null,"default_value":"","external_name":"call","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":""}],"args_string":"(call, *, name = nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr#L95","def":{"name":"spawn","args":[{"name":"call","doc":null,"default_value":"","external_name":"call","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":""}],"double_splat":null,"splat_index":1,"block_arg":null,"visibility":"Public","body":"  \n{% if call.is_a?(Call) %}\n    ->(\n      {% for arg, i in call.args %}\n        __arg{{ i }} : typeof({{ arg }}),\n      {% end %}\n      {% if call.named_args %}\n        {% for narg, i in call.named_args %}\n          __narg{{ i }} : typeof({{ narg.value }}),\n        {% end %}\n      {% end %}\n      ) {\n      spawn(name: {{ name }}) do\n        {% if call.receiver %}{{ call.receiver }}.{% end %}{{ call.name }}(\n          {% for arg, i in call.args %}\n            __arg{{ i }},\n          {% end %}\n          {% if call.named_args %}\n            {% for narg, i in call.named_args %}\n              {{ narg.name }}: __narg{{ i }},\n            {% end %}\n          {% end %}\n        )\n      end\n    {% if call.named_args %}\n      }.call({{ *call.args }}, {{ *call.named_args.map(&.value) }})\n    {% else %}\n      }.call({{ *call.args }})\n    {% end %}\n  {% else %}\n    spawn do\n      {{ call }}\n    end\n  {% end %}\n\n\n"}}],"types":[{"html_id":"github.com/crystal-lang/crystal/Adler32","path":"Adler32.html","kind":"module","full_name":"Adler32","name":"Adler32","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"adler32/adler32.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"checksum(data):UInt32-class-method","html_id":"checksum(data):UInt32-class-method","name":"checksum","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L8","def":{"name":"checksum","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"update(data, initial)"}},{"id":"combine(adler1:UInt32,adler2:UInt32,len):UInt32-class-method","html_id":"combine(adler1:UInt32,adler2:UInt32,len):UInt32-class-method","name":"combine","doc":null,"summary":null,"abstract":false,"args":[{"name":"adler1","doc":null,"default_value":"","external_name":"adler1","restriction":"UInt32"},{"name":"adler2","doc":null,"default_value":"","external_name":"adler2","restriction":"UInt32"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"args_string":"(adler1 : UInt32, adler2 : UInt32, len) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L17","def":{"name":"combine","args":[{"name":"adler1","doc":null,"default_value":"","external_name":"adler1","restriction":"UInt32"},{"name":"adler2","doc":null,"default_value":"","external_name":"adler2","restriction":"UInt32"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"(LibZ.adler32_combine(adler1, adler2, len)).to_u32"}},{"id":"initial:UInt32-class-method","html_id":"initial:UInt32-class-method","name":"initial","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L4","def":{"name":"initial","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"(LibZ.adler32(0, nil, 0)).to_u32"}},{"id":"update(data,adler32:UInt32):UInt32-class-method","html_id":"update(data,adler32:UInt32):UInt32-class-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"adler32","doc":null,"default_value":"","external_name":"adler32","restriction":"UInt32"}],"args_string":"(data, adler32 : UInt32) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/adler32/adler32.cr#L12","def":{"name":"update","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"adler32","doc":null,"default_value":"","external_name":"adler32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"slice = data.to_slice\n(LibZ.adler32(adler32, slice, slice.size)).to_u32\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/ArgumentError","path":"ArgumentError.html","kind":"class","full_name":"ArgumentError","name":"ArgumentError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":89,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when the arguments are wrong and there isn't a more specific `Exception` class.\n\n```\n[1, 2, 3].first(-4) # raises ArgumentError (attempt to take negative size)\n```","summary":"<p>Raised when the arguments are wrong and there isn't a more specific <code><a href=\"Exception.html\">Exception</a></code> class.</p>","class_methods":[],"constructors":[{"id":"new(message=&quot;Argumenterror&quot;)-class-method","html_id":"new(message=&amp;quot;Argumenterror&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Argument error\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Argument error&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L90","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Argument error\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Array","path":"Array.html","kind":"class","full_name":"Array(T)","name":"Array","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"array.cr","line_number":46,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr"},{"filename":"json/any.cr","line_number":282,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"json/to_json.cr","line_number":63,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/any.cr","line_number":293,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"},{"filename":"yaml/to_yaml.cr","line_number":34,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"An `Array` is an ordered, integer-indexed collection of objects of type T.\n\nArray indexing starts at 0. A negative index is assumed to be\nrelative to the end of the array: -1 indicates the last element,\n-2 is the next to last element, and so on.\n\nAn `Array` can be created using the usual `new` method (several are provided), or with an array literal:\n\n```\nArray(Int32).new  # => []\n[1, 2, 3]         # Array(Int32)\n[1, \"hello\", 'x'] # Array(Int32 | String | Char)\n```\n\nAn `Array` can have mixed types, meaning T will be a union of types, but these are determined\nwhen the array is created, either by specifying T or by using an array literal. In the latter\ncase, T will be set to the union of the array literal elements' types.\n\nWhen creating an empty array you must always specify T:\n\n```\n[] of Int32 # same as Array(Int32)\n[]          # syntax error\n```\n\nAn `Array` is implemented using an internal buffer of some capacity\nand is reallocated when elements are pushed to it when more capacity\nis needed. This is normally known as a [dynamic array](http://en.wikipedia.org/wiki/Dynamic_array).\n\nYou can use a special array literal syntax with other types too, as long as they define an argless\n`new` method and a `<<` method. `Set` is one such type:\n\n```\nset = Set{1, 2, 3} # => Set{1, 2, 3}\nset.class          # => Set(Int32)\n```\n\nThe above is the same as this:\n\n```\nset = Set(typeof(1, 2, 3)).new\nset << 1\nset << 2\nset << 3\n```","summary":"<p>An <code><a href=\"Array.html\">Array</a></code> is an ordered, integer-indexed collection of objects of type T.</p>","class_methods":[{"id":"each_product(arrays:Array(Array),reuse=false,&block)-class-method","html_id":"each_product(arrays:Array(Array),reuse=false,&amp;block)-class-method","name":"each_product","doc":null,"summary":null,"abstract":false,"args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array(Array)"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(arrays : Array(Array), reuse = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1190","def":{"name":"each_product","args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array(Array)"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"lens = arrays.map(&.size)\nif lens.any?(&.==(0))\n  return\nend\npool = arrays.map(&.first)\nn = arrays.size\nindices = Array.new(n, 0)\nif reuse\n  if reuse.is_a?(Array)\n  else\n    reuse = (typeof(pool)).new(n)\n  end\nelse\n  reuse = nil\nend\nyield pool_slice(pool, n, reuse)\nwhile true\n  i = n - 1\n  __temp_9 = i\n  indices[__temp_9] = indices[__temp_9] + 1\n  while indices[i] >= lens[i]\n    indices[i] = 0\n    pool[i] = arrays[i][indices[i]]\n    i = i - 1\n    if i < 0\n      return\n    end\n    __temp_11 = i\n    indices[__temp_11] = indices[__temp_11] + 1\n  end\n  pool[i] = arrays[i][indices[i]]\n  yield pool_slice(pool, n, reuse)\nend\n"}},{"id":"each_product(*arrays:Array,reuse=false,&block)-class-method","html_id":"each_product(*arrays:Array,reuse=false,&amp;block)-class-method","name":"each_product","doc":null,"summary":null,"abstract":false,"args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(*arrays : Array, reuse = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1225","def":{"name":"each_product","args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_product(arrays.to_a, reuse: reuse) do |result|\n  yield result\nend"}},{"id":"from_json(string_or_io,&block):Nil-class-method","html_id":"from_json(string_or_io,&amp;block):Nil-class-method","name":"from_json","doc":"Parses a `String` or `IO` denoting a JSON array, yielding\neach of its elements to the given block. This is useful\nfor decoding an array and processing its elements without\ncreating an Array in memory, which might be expensive.\n\n```\nrequire \"json\"\n\nArray(Int32).from_json(\"[1, 2, 3]\") do |element|\n  puts element\nend\n```\n\nOutput:\n\n```text\n1\n2\n3\n```\n\nTo parse and get an `Array`, use the block-less overload.","summary":"<p>Parses a <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code> denoting a JSON array, yielding each of its elements to the given block.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""}],"args_string":"(string_or_io, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L53","def":{"name":"from_json","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nnew(parser) do |element|\n  yield element\nend\nnil\n"}},{"id":"from_yaml(string_or_io:String|IO,&block)-class-method","html_id":"from_yaml(string_or_io:String|IO,&amp;block)-class-method","name":"from_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L5","def":{"name":"from_yaml","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"new(YAML::ParseContext.new, parse_yaml(string_or_io)) do |element|\n  yield element\nend"}},{"id":"product(arrays)-class-method","html_id":"product(arrays)-class-method","name":"product","doc":null,"summary":null,"abstract":false,"args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":""}],"args_string":"(arrays)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1178","def":{"name":"product","args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"result = [] of Array(typeof(arrays.first.first))\neach_product(arrays) do |product|\n  result << product\nend\nresult\n"}},{"id":"product(*arrays:Array)-class-method","html_id":"product(*arrays:Array)-class-method","name":"product","doc":null,"summary":null,"abstract":false,"args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array"}],"args_string":"(*arrays : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1186","def":{"name":"product","args":[{"name":"arrays","doc":null,"default_value":"","external_name":"arrays","restriction":"Array"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"product(arrays.to_a)"}}],"constructors":[{"id":"build(capacity:Int,&block):self-class-method","html_id":"build(capacity:Int,&amp;block):self-class-method","name":"build","doc":"Creates a new `Array`, allocating an internal buffer with the given *capacity*,\nand yielding that buffer. The given block must return the desired size of the array.\n\nThis method is **unsafe**, but is usually used to initialize the buffer\nby passing it to a C function.\n\n```\nArray.build(3) do |buffer|\n  LibSome.fill_buffer_and_return_number_of_elements_filled(buffer)\nend\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code>, allocating an internal buffer with the given <em>capacity</em>, and yielding that buffer.</p>","abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int, &block) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L147","def":{"name":"build","args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"self","visibility":"Public","body":"ary = Array(T).new(capacity)\nary.size = (yield ary.to_unsafe).to_i\nary\n"}},{"id":"new(size:Int,value:T)-class-method","html_id":"new(size:Int,value:T)-class-method","name":"new","doc":"Creates a new `Array` of the given *size* filled with the same *value* in each position.\n\n```\nArray.new(3, 'a') # => ['a', 'a', 'a']\n\nary = Array.new(3, [1])\nary # => [[1], [1], [1]]\nary[0][0] = 2\nary # => [[2], [2], [2]]\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code> of the given <em>size</em> filled with the same <em>value</em> in each position.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L101","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Array(T).allocate\n_.initialize(size, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L67","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ctx.read_alias(node, self) do |obj|\n  return obj\nend\nary = new\nctx.record_anchor(node, ary)\nnew(ctx, node) do |element|\n  ary << element\nend\nary\n"}},{"id":"new(initial_capacity:Int)-class-method","html_id":"new(initial_capacity:Int)-class-method","name":"new","doc":"Creates a new empty `Array` backed by a buffer that is initially\n`initial_capacity` big.\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffer in case of growth. If you have an estimate\nof the maximum number of elements an array will hold, the array should\nbe initialized with that capacity for improved performance.\n\n```\nary = Array(Int32).new(5)\nary.size # => 0\n```","summary":"<p>Creates a new empty <code><a href=\"Array.html\">Array</a></code> backed by a buffer that is initially <code>initial_capacity</code> big.</p>","abstract":false,"args":[{"name":"initial_capacity","doc":null,"default_value":"","external_name":"initial_capacity","restriction":"Int"}],"args_string":"(initial_capacity : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L77","def":{"name":"new","args":[{"name":"initial_capacity","doc":null,"default_value":"","external_name":"initial_capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Array(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L101","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = new\nnew(pull) do |element|\n  ary << element\nend\nary\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a new empty Array.","summary":"<p>Creates a new empty Array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L59","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Array(T).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&block)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&amp;block)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L82","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.class}\")\nend\nnode.each do |value|\n  yield T.new(ctx, value)\nend\n"}},{"id":"new(size:Int,&block:Int32->T)-class-method","html_id":"new(size:Int,&amp;block:Int32-&gt;T)-class-method","name":"new","doc":"Creates a new `Array` of the given *size* and invokes the given block once\nfor each index of `self`, assigning the block's value in that index.\n\n```\nArray.new(3) { |i| (i + 1) ** 2 } # => [1, 4, 9]\n\nary = Array.new(3) { [1] }\nary # => [[1], [1], [1]]\nary[0][0] = 2\nary # => [[2], [1], [1]]\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code> of the given <em>size</em> and invokes the given block once for each index of <code>self</code>, assigning the block's value in that index.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, &block : Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L127","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Int32 -> T)"},"return_type":"","visibility":"Public","body":"Array(T).build(size) do |buffer|\n  size.to_i.times do |i|\n    buffer[i] = yield i\n  end\n  size\nend"}},{"id":"new(pull:JSON::PullParser,&block)-class-method","html_id":"new(pull:JSON::PullParser,&amp;block)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L109","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"pull.read_array do\n  yield T.new(pull)\nend"}}],"instance_methods":[{"id":"&(other:Array(U))forallU-instance-method","html_id":"&amp;(other:Array(U))forallU-instance-method","name":"&","doc":"Set intersection: returns a new `Array` containing elements common to `self`\nand *other*, excluding any duplicates. The order is preserved from `self`.\n\n```\n[1, 1, 3, 5] & [1, 2, 3]               # => [ 1, 3 ]\n['a', 'b', 'b', 'z'] & ['a', 'b', 'c'] # => [ 'a', 'b' ]\n```\n\nSee also: `#uniq`.","summary":"<p>Set intersection: returns a new <code><a href=\"Array.html\">Array</a></code> containing elements common to <code>self</code> and <em>other</em>, excluding any duplicates.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L202","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if self.empty? || other.empty?\n  return Array(T).new\nend\nhash = other.to_lookup_hash\nhash_size = hash.size\nArray(T).build(Math.min(size, other.size)) do |buffer|\n  i = 0\n  each do |obj|\n    hash.delete(obj)\n    new_hash_size = hash.size\n    if hash_size != new_hash_size\n      hash_size = new_hash_size\n      buffer[i] = obj\n      i = i + 1\n    end\n  end\n  i\nend\n"}},{"id":"*(times:Int)-instance-method","html_id":"*(times:Int)-instance-method","name":"*","doc":"Repetition: Returns a new `Array` built by concatenating *times* copies of `self`.\n\n```\n[\"a\", \"b\", \"c\"] * 2 # => [ \"a\", \"b\", \"c\", \"a\", \"b\", \"c\" ]\n```","summary":"<p>Repetition: Returns a new <code><a href=\"Array.html\">Array</a></code> built by concatenating <em>times</em> copies of <code>self</code>.</p>","abstract":false,"args":[{"name":"times","doc":null,"default_value":"","external_name":"times","restriction":"Int"}],"args_string":"(times : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L288","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L288","def":{"name":"*","args":[{"name":"times","doc":null,"default_value":"","external_name":"times","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(T).new(size * times)\ntimes.times do\n  ary.concat(self)\nend\nary\n"}},{"id":"+(other:Array(U))forallU-instance-method","html_id":"+(other:Array(U))forallU-instance-method","name":"+","doc":"Concatenation. Returns a new `Array` built by concatenating `self` and *other*.\nThe type of the new array is the union of the types of both the original arrays.\n\n```\n[1, 2] + [\"a\"]  # => [1,2,\"a\"] of (Int32 | String)\n[1, 2] + [2, 3] # => [1,2,2,3]\n```","summary":"<p>Concatenation.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L259","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_size = size + other.size\nArray(T | U).build(new_size) do |buffer|\n  buffer.copy_from(@buffer, size)\n  (buffer + size).copy_from(other.to_unsafe, other.size)\n  new_size\nend\n"}},{"id":"-(other:Array(U))forallU-instance-method","html_id":"-(other:Array(U))forallU-instance-method","name":"-","doc":"Difference. Returns a new `Array` that is a copy of `self`, removing any items\nthat appear in *other*. The order of `self` is preserved.\n\n```\n[1, 2, 3] - [2, 1] # => [3]\n```","summary":"<p>Difference.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L274","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(T).new(Math.max(size - other.size, 0))\nhash = other.to_lookup_hash\neach do |obj|\n  if hash.has_key?(obj)\n  else\n    ary << obj\n  end\nend\nary\n"}},{"id":"<<(value:T)-instance-method","html_id":"&lt;&lt;(value:T)-instance-method","name":"<<","doc":"Append. Alias for `push`.\n\n```\na = [1, 2]\na << 3 # => [1,2,3]\n```","summary":"<p>Append.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L302","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L302","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"push(value)"}},{"id":"(other:Array)-instance-method","html_id":"(other:Array)-instance-method","name":"<=>","doc":"Combined comparison operator. Returns *0* if `self` equals *other*, *1* if\n`self` is greater than *other* and *-1* if `self` is smaller than *other*.\n\nIt compares the elements of both arrays in the same position using the\n`<=>` operator.  As soon as one of such comparisons returns a non-zero\nvalue, that result is the return value of the comparison.\n\nIf all elements are equal, the comparison is based on the size of the arrays.\n\n```\n[8] <=> [1, 2, 3] # => 1\n[2] <=> [4, 2, 3] # => -1\n[1, 2] <=> [1, 2] # => 0\n```","summary":"<p>Combined comparison operator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L184","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L184","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"min_size = Math.min(size, other.size)\n0.upto(min_size - 1) do |i|\n  n = @buffer[i] <=> other.to_unsafe[i]\n  if n != 0\n    return n\n  end\nend\nsize <=> other.size\n"}},{"id":"==(other:Array)-instance-method","html_id":"==(other:Array)-instance-method","name":"==","doc":"Equality. Returns `true` if each element in `self` is equal to each\ncorresponding element in *other*.\n\n```\nary = [1, 2, 3]\nary == [1, 2, 3] # => true\nary == [2, 3]    # => false\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L161","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"equals?(other) do |x, y|\n  x == y\nend"}},{"id":"==(other:JSON::Any)-instance-method","html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L283","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other:YAML::Any)-instance-method","html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L294","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"[](range:Range(Int,Int))-instance-method","html_id":"[](range:Range(Int,Int))-instance-method","name":"[]","doc":"Returns all elements that are within the given range.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na[1..3]    # => [\"b\", \"c\", \"d\"]\na[4..7]    # => [\"e\"]\na[6..10]   # raise IndexError\na[5..10]   # => []\na[-2...-1] # => [\"d\"]\n```","summary":"<p>Returns all elements that are within the given range.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L456","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L456","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[*Indexable.range_to_index_and_count(range, size)]"}},{"id":"[](start:Int,count:Int)-instance-method","html_id":"[](start:Int,count:Int)-instance-method","name":"[]","doc":"Returns count or less (if there aren't enough) elements starting at the\ngiven start index.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na[-3, 3] # => [\"c\", \"d\", \"e\"]\na[6, 1]  # raise IndexError\na[1, 2]  # => [\"b\", \"c\"]\na[5, 1]  # => []\n```","summary":"<p>Returns count or less (if there aren't enough) elements starting at the given start index.</p>","abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L476","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L476","def":{"name":"[]","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Negative count: #{count}\"))\nend\nif start == size\n  return Array(T).new\nend\nif start < 0\n  start = start + size\nend\nif 0 <= start && start <= size\nelse\n  raise(IndexError.new)\nend\nif count == 0\n  return Array(T).new\nend\ncount = Math.min(count, size - start)\nArray(T).build(count) do |buffer|\n  buffer.copy_from(@buffer + start, count)\n  count\nend\n"}},{"id":"[]=(index:Int,count:Int,value:T)-instance-method","html_id":"[]=(index:Int,count:Int,value:T)-instance-method","name":"[]=","doc":"Replaces a subrange with a single value. All elements in the range\n`index...index+count` are removed and replaced by a single element\n*value*.\n\nIf *count* is zero, *value* is inserted at *index*.\n\nNegative values of *index* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = 6\na # => [1, 6, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 0] = 6\na # => [1, 6, 2, 3, 4, 5]\n```","summary":"<p>Replaces a subrange with a single value.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, count : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L341","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Negative count: #{count}\"))\nend\nindex = check_index_out_of_bounds(index)\ncount = (index + count) <= size ? count : size - index\ncase count\nwhen 0\n  insert(index, value)\nwhen 1\n  @buffer[index] = value\nelse\n  diff = count - 1\n  ((@buffer + index) + 1).move_from((@buffer + index) + count, (size - index) - count)\n  ((@buffer + @size) - diff).clear(diff)\n  @buffer[index] = value\n  @size = @size - diff\nend\nvalue\n"}},{"id":"[]=(index:Int,count:Int,values:Array(T))-instance-method","html_id":"[]=(index:Int,count:Int,values:Array(T))-instance-method","name":"[]=","doc":"Replaces a subrange with the elements of the given array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8]\na # => [1, 6, 7, 8, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7]\na # => [1, 6, 7, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8, 9, 10]\na # => [1, 6, 7, 8, 9, 10, 5]\n```","summary":"<p>Replaces a subrange with the elements of the given array.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(T)"}],"args_string":"(index : Int, count : Int, values : Array(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L393","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Negative count: #{count}\"))\nend\nindex = check_index_out_of_bounds(index)\ncount = (index + count) <= size ? count : size - index\ndiff = values.size - count\nif diff == 0\n  (@buffer + index).copy_from(values.to_unsafe, values.size)\nelse\n  if diff < 0\n    diff = -diff\n    (@buffer + index).copy_from(values.to_unsafe, values.size)\n    ((@buffer + index) + values.size).move_from((@buffer + index) + count, (size - index) - count)\n    ((@buffer + @size) - diff).clear(diff)\n    @size = @size - diff\n  else\n    resize_to_capacity(Math.pw2ceil(@size + diff))\n    ((@buffer + index) + values.size).move_from((@buffer + index) + count, (size - index) - count)\n    (@buffer + index).copy_from(values.to_unsafe, values.size)\n    @size = @size + diff\n  end\nend\nvalues\n"}},{"id":"[]=(index:Int,value:T)-instance-method","html_id":"[]=(index:Int,value:T)-instance-method","name":"[]=","doc":"Sets the given value at the given index.\n\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to set an element outside the array's range.\n\n```\nary = [1, 2, 3]\nary[0] = 5\np ary # => [5,2,3]\n\nary[3] = 5 # raises IndexError\n```","summary":"<p>Sets the given value at the given index.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L319","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index)\n@buffer[index] = value\n"}},{"id":"[]=(range:Range(Int,Int),value:T)-instance-method","html_id":"[]=(range:Range(Int,Int),value:T)-instance-method","name":"[]=","doc":"Replaces a subrange with a single value.\n\n```\na = [1, 2, 3, 4, 5]\na[1..3] = 6\na # => [1, 6, 5]\n\na = [1, 2, 3, 4, 5]\na[1...1] = 6\na # => [1, 6, 2, 3, 4, 5]\n```","summary":"<p>Replaces a subrange with a single value.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(range : Range(Int, Int), value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L374","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L374","def":{"name":"[]=","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[*Indexable.range_to_index_and_count(range, size)] = value"}},{"id":"[]=(range:Range(Int,Int),values:Array(T))-instance-method","html_id":"[]=(range:Range(Int,Int),values:Array(T))-instance-method","name":"[]=","doc":"Replaces a subrange with the elements of the given array.\n\n```\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7, 8]\na # => [1, 6, 7, 8, 5]\n\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7]\na # => [1, 6, 7, 5]\n\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7, 8, 9, 10]\na # => [1, 6, 7, 8, 9, 10, 5]\n```","summary":"<p>Replaces a subrange with the elements of the given array.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(T)"}],"args_string":"(range : Range(Int, Int), values : Array(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L436","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L436","def":{"name":"[]=","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[*Indexable.range_to_index_and_count(range, size)] = values"}},{"id":"clear-instance-method","html_id":"clear-instance-method","name":"clear","doc":"Removes all elements from self.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na.clear # => []\n```","summary":"<p>Removes all elements from self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L509","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L509","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer.clear(@size)\n@size = 0\nself\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Array` that has `self`'s elements cloned.\nThat is, it returns a deep copy of `self`.\n\nUse `#dup` if you want a shallow copy.\n\n```\nary = [[1, 2], [3, 4]]\nary2 = ary.clone\nary[0][0] = 5\nary  # => [[5, 2], [3, 4]]\nary2 # => [[1, 2], [3, 4]]\n\nary2 << [7, 8]\nary  # => [[5, 2], [3, 4]]\nary2 # => [[1, 2], [3, 4], [7, 8]]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that has <code>self</code>'s elements cloned.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L531","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L531","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array(T).new(size) do |i|\n  @buffer[i].clone.as(T)\nend"}},{"id":"combinations(size:Int=self.size)-instance-method","html_id":"combinations(size:Int=self.size)-instance-method","name":"combinations","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = <span class=\"k\">self</span>.size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1042","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1042","def":{"name":"combinations","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of Array(T)\neach_combination(size) do |a|\n  ary << a\nend\nary\n"}},{"id":"compact-instance-method","html_id":"compact-instance-method","name":"compact","doc":"Returns a copy of `self` with all `nil` elements removed.\n\n```\n[\"a\", nil, \"b\", nil, \"c\", nil].compact # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Returns a copy of <code>self</code> with all <code>nil</code> elements removed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L540","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L540","def":{"name":"compact","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"compact_map(&.itself)"}},{"id":"compact!-instance-method","html_id":"compact!-instance-method","name":"compact!","doc":"Removes all `nil` elements from `self` and returns `self`.\n\n```\nary = [\"a\", nil, \"b\", nil, \"c\"]\nary.compact!\nary # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Removes all <code>nil</code> elements from <code>self</code> and returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L551","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L551","def":{"name":"compact!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reject! do |__arg1|\n  __arg1.nil?\nend"}},{"id":"concat(other:Array)-instance-method","html_id":"concat(other:Array)-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.\n\n```\nary = [\"a\", \"b\"]\nary.concat([\"c\", \"d\"])\nary # => [\"a\", \"b\", \"c\", \"d\"]\n```","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L562","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L562","def":{"name":"concat","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other_size = other.size\nnew_size = size + other_size\nif new_size > @capacity\n  resize_to_capacity(Math.pw2ceil(new_size))\nend\n(@buffer + @size).copy_from(other.to_unsafe, other_size)\n@size = @size + other_size\nself\n"}},{"id":"concat(other:Enumerable)-instance-method","html_id":"concat(other:Enumerable)-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.\n\n```\nary = [\"a\", \"b\"]\nary.concat([\"c\", \"d\"])\nary # => [\"a\", \"b\", \"c\", \"d\"]\n```","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L576","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L576","def":{"name":"concat","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"left_before_resize = @capacity - @size\nlen = @size\nbuf = @buffer + len\nother.each do |elem|\n  if left_before_resize == 0\n    double_capacity\n    left_before_resize = @capacity - len\n    buf = @buffer + len\n  end\n  buf.value = elem\n  buf = buf + 1\n  len = len + 1\n  left_before_resize = left_before_resize - 1\nend\n@size = len\nself\n"}},{"id":"delete(obj)-instance-method","html_id":"delete(obj)-instance-method","name":"delete","doc":"Removes all items from `self` that are equal to *obj*.\n\nReturns the last found element that was equal to *obj*,\nif any, or `nil` if not found.\n\n```\na = [\"a\", \"b\", \"b\", \"b\", \"c\"]\na.delete(\"b\") # => \"b\"\na             # => [\"a\", \"c\"]\n\na.delete(\"x\") # => nil\na             # => [\"a\", \"c\"]\n```","summary":"<p>Removes all items from <code>self</code> that are equal to <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L610","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L610","def":{"name":"delete","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"internal_delete do |e|\n  e == obj\nend[1]"}},{"id":"delete_at(index:Int,count:Int)-instance-method","html_id":"delete_at(index:Int,count:Int)-instance-method","name":"delete_at","doc":"Removes *count* elements from `self` starting at *index*.\nIf the size of `self` is less than *count*, removes values to the end of the array without error.\nReturns an array of the removed elements with the original order of `self` preserved.\nRaises `IndexError` if *index* is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(1, 2)  # => [\"bat\", \"cat\"]\na                  # => [\"ant\", \"dog\"]\na.delete_at(99, 1) # raises IndexError\n```","summary":"<p>Removes <em>count</em> elements from <code>self</code> starting at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(index : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L659","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L659","def":{"name":"delete_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"val = self[index, count]\ncount = (index + count) <= size ? count : size - index\n(@buffer + index).move_from((@buffer + index) + count, (size - index) - count)\n@size = @size - count\n(@buffer + @size).clear(count)\nval\n"}},{"id":"delete_at(index:Int)-instance-method","html_id":"delete_at(index:Int)-instance-method","name":"delete_at","doc":"Removes the element at *index*, returning that element.\nRaises `IndexError` if *index* is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(2)  # => \"cat\"\na               # => [\"ant\", \"bat\", \"dog\"]\na.delete_at(99) # raises IndexError\n```","summary":"<p>Removes the element at <em>index</em>, returning that element.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L623","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L623","def":{"name":"delete_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index)\nelem = @buffer[index]\n(@buffer + index).move_from((@buffer + index) + 1, (size - index) - 1)\n@size = @size - 1\n(@buffer + @size).clear\nelem\n"}},{"id":"delete_at(range:Range(Int,Int))-instance-method","html_id":"delete_at(range:Range(Int,Int))-instance-method","name":"delete_at","doc":"Removes all elements within the given *range*.\nReturns an array of the removed elements with the original order of `self` preserved.\nRaises `IndexError` if the index is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(1..2)    # => [\"bat\", \"cat\"]\na                    # => [\"ant\", \"dog\"]\na.delete_at(99..100) # raises IndexError\n```","summary":"<p>Removes all elements within the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L643","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L643","def":{"name":"delete_at","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index, count = Indexable.range_to_index_and_count(range, self.size)\ndelete_at(index, count)\n"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Array` that has exactly `self`'s elements.\nThat is, it returns a shallow copy of `self`.\n\nUse `#clone` if you want a deep copy.\n\n```\nary = [[1, 2], [3, 4]]\nary2 = ary.dup\nary[0][0] = 5\nary  # => [[5, 2], [3, 4]]\nary2 # => [[5, 2], [3, 4]]\n\nary2 << [7, 8]\nary  # => [[5, 2], [3, 4]]\nary2 # => [[5, 2], [3, 4], [7, 8]]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that has exactly <code>self</code>'s elements.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L684","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L684","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array(T).build(@capacity) do |buffer|\n  buffer.copy_from(@buffer, size)\n  size\nend"}},{"id":"each_combination(size:Int=self.size,reuse=false,&block):Nil-instance-method","html_id":"each_combination(size:Int=self.size,reuse=false,&amp;block):Nil-instance-method","name":"each_combination","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1050","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1050","def":{"name":"each_combination","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nreuse = check_reuse(reuse, size)\ncopy = self.dup\npool = self.dup\nindices = (0...size).to_a\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    if indices[i] != ((i + n) - size)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\n  __temp_7 = i\n  indices[__temp_7] = indices[__temp_7] + 1\n  pool[i] = copy[indices[i]]\n  (i + 1).upto(size - 1) do |j|\n    indices[j] = indices[j - 1] + 1\n    pool[j] = copy[indices[j]]\n  end\n  yield pool_slice(pool, size, reuse)\nend\n"}},{"id":"each_combination(size:Int=self.size,reuse=false)-instance-method","html_id":"each_combination(size:Int=self.size,reuse=false)-instance-method","name":"each_combination","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1098","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1098","def":{"name":"each_combination","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nCombinationIterator.new(self, size.to_i, reuse)\n"}},{"id":"each_permutation(size:Int=self.size,reuse=false,&block):Nil-instance-method","html_id":"each_permutation(size:Int=self.size,reuse=false,&amp;block):Nil-instance-method","name":"each_permutation","doc":"Yields each possible permutation of *size* of `self`.\n\n```\na = [1, 2, 3]\nsums = [] of Int32\na.each_permutation(2) { |p| sums << p.sum } # => nil\nsums                                        # => [3, 4, 3, 5, 4, 5]\n```\n\nBy default, a new array is created and yielded for each permutation.\nIf *reuse* is given, the array can be reused: if *reuse* is\nan `Array`, this array will be reused; if *reuse* if truthy,\nthe method will create a new array and reuse it. This can be\nused to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Yields each possible permutation of <em>size</em> of <code>self</code>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L983","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L983","def":{"name":"each_permutation","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nreuse = check_reuse(reuse, size)\npool = self.dup\ncycles = (((n - size) + 1)..n).to_a.reverse!\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    ci = ((    __temp_5 = i\n    cycles[__temp_5] = cycles[__temp_5] - 1))\n    if ci == 0\n      e = pool[i]\n      (i + 1).upto(n - 1) do |j|\n        pool[j - 1] = pool[j]\n      end\n      pool[n - 1] = e\n      cycles[i] = n - i\n    else\n      pool.swap(i, -ci)\n      yield pool_slice(pool, size, reuse)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\nend\n"}},{"id":"each_permutation(size:Int=self.size,reuse=false)-instance-method","html_id":"each_permutation(size:Int=self.size,reuse=false)-instance-method","name":"each_permutation","doc":"Returns an `Iterator` over each possible permutation of *size* of `self`.\n\n```\niter = [1, 2, 3].each_permutation\niter.next # => [1, 2, 3]\niter.next # => [1, 3, 2]\niter.next # => [2, 1, 3]\niter.next # => [2, 3, 1]\niter.next # => [3, 1, 2]\niter.next # => [3, 2, 1]\niter.next # => #<Iterator::Stop>\n```\n\nBy default, a new array is created and returned for each permutation.\nIf *reuse* is given, the array can be reused: if *reuse* is\nan `Array`, this array will be reused; if *reuse* if truthy,\nthe method will create a new array and reuse it. This can be\nused to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each possible permutation of <em>size</em> of <code>self</code>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1036","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1036","def":{"name":"each_permutation","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nPermutationIterator.new(self, size.to_i, reuse)\n"}},{"id":"each_repeated_combination(size:Int=self.size,reuse=false,&block):Nil-instance-method","html_id":"each_repeated_combination(size:Int=self.size,reuse=false,&amp;block):Nil-instance-method","name":"each_repeated_combination","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1138","def":{"name":"each_repeated_combination","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n && (n == 0)\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nreuse = check_reuse(reuse, size)\ncopy = self.dup\nindices = Array.new(size, 0)\npool = indices.map do |i|\n  copy[i]\nend\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    if indices[i] != (n - 1)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\n  ii = indices[i] + 1\n  tmp = copy[ii]\n  indices.fill(i, size - i) do\n    ii\n  end\n  pool.fill(i, size - i) do\n    tmp\n  end\n  yield pool_slice(pool, size, reuse)\nend\n"}},{"id":"each_repeated_combination(size:Int=self.size,reuse=false)-instance-method","html_id":"each_repeated_combination(size:Int=self.size,reuse=false)-instance-method","name":"each_repeated_combination","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1172","def":{"name":"each_repeated_combination","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nRepeatedCombinationIterator.new(self, size.to_i, reuse)\n"}},{"id":"each_repeated_permutation(size:Int=self.size,reuse=false,&block):Nil-instance-method","html_id":"each_repeated_permutation(size:Int=self.size,reuse=false,&amp;block):Nil-instance-method","name":"each_repeated_permutation","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1239","def":{"name":"each_repeated_permutation","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif (size != 0) && (n == 0)\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nif size == 0\n  yield [] of T\nelse\n  Array.each_product(Array.new(size, self), reuse: reuse) do |r|\n    yield r\n  end\nend\n"}},{"id":"fill(&block)-instance-method","html_id":"fill(&amp;block)-instance-method","name":"fill","doc":"Yields each index of `self` to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\n```\na = [1, 2, 3, 4]\na.fill { |i| i * i } # => [0, 1, 4, 9]\n```","summary":"<p>Yields each index of <code>self</code> to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L698","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L698","def":{"name":"fill","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_index do |i|\n  @buffer[i] = yield i\nend\nself\n"}},{"id":"fill(value:T,from:Int,count:Int)-instance-method","html_id":"fill(value:T,from:Int,count:Int)-instance-method","name":"fill","doc":"Replaces every element in `self`, starting at *from* and only *count* times,\nwith the given *value*. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces every element in <code>self</code>, starting at <em>from</em> and only <em>count</em> times, with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(value : T, from : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L794","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L794","def":{"name":"fill","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fill(from, count) do\n  value\nend"}},{"id":"fill(value:T,from:Int)-instance-method","html_id":"fill(value:T,from:Int)-instance-method","name":"fill","doc":"Replaces every element in `self`, starting at *from*, with the given *value*. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2) # => [1, 2, 9, 9, 9]\n```","summary":"<p>Replaces every element in <code>self</code>, starting at <em>from</em>, with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"}],"args_string":"(value : T, from : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L781","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L781","def":{"name":"fill","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fill(from) do\n  value\nend"}},{"id":"fill(value:T,range:Range(Int,Int))-instance-method","html_id":"fill(value:T,range:Range(Int,Int))-instance-method","name":"fill","doc":"Replaces every element in *range* with *value*. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2..3) # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces every element in <em>range</em> with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(value : T, range : Range(Int, Int))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L806","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L806","def":{"name":"fill","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fill(range) do\n  value\nend"}},{"id":"fill(value:T)-instance-method","html_id":"fill(value:T)-instance-method","name":"fill","doc":"Replaces every element in `self` with the given *value*. Returns `self`.\n\n```\na = [1, 2, 3]\na.fill(9) # => [9, 9, 9]\n```","summary":"<p>Replaces every element in <code>self</code> with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L769","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L769","def":{"name":"fill","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fill do\n  value\nend"}},{"id":"fill(range:Range(Int,Int),&block)-instance-method","html_id":"fill(range:Range(Int,Int),&amp;block)-instance-method","name":"fill","doc":"Yields each index of `self`, in the given *range*, to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2..3) { |i| i * i } # => [1, 2, 4, 9, 5, 6]\n```","summary":"<p>Yields each index of <code>self</code>, in the given <em>range</em>, to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int), &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L757","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L757","def":{"name":"fill","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"fill(*Indexable.range_to_index_and_count(range, size)) do |i|\n  yield i\nend"}},{"id":"fill(from:Int,count:Int,&block)-instance-method","html_id":"fill(from:Int,count:Int,&amp;block)-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *from* and just *count* times,\nto the given block and then assigns the block's value in that position. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\nRaises `IndexError` if *from* is outside the array range.\n\nHas no effect if *count* is zero or negative.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2, 2) { |i| i * i } # => [1, 2, 4, 9, 5, 6]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>from</em> and just <em>count</em> times, to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(from : Int, count : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L738","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L738","def":{"name":"fill","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if count <= 0\n  return self\nend\nif from < 0\n  from = from + size\nend\nif (0 <= from && from < size) && (from + count) <= size\nelse\n  raise(IndexError.new)\nend\nfrom.upto((from + count) - 1) do |i|\n  @buffer[i] = yield i\nend\nself\n"}},{"id":"fill(from:Int,&block)-instance-method","html_id":"fill(from:Int,&amp;block)-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *from*, to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\nRaises `IndexError` if *from* is outside the array range.\n\n```\na = [1, 2, 3, 4]\na.fill(2) { |i| i * i } # => [1, 2, 4, 9]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>from</em>, to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"}],"args_string":"(from : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L715","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L715","def":{"name":"fill","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if from < 0\n  from = from + size\nend\nif 0 <= from && from < size\nelse\n  raise(IndexError.new)\nend\nfrom.upto(size - 1) do |i|\n  @buffer[i] = yield i\nend\nself\n"}},{"id":"first(n:Int)-instance-method","html_id":"first(n:Int)-instance-method","name":"first","doc":"Returns the first *n* elements of the array.\n\n```\n[1, 2, 3].first(2) # => [1, 2]\n[1, 2, 3].first(4) # => [1, 2, 3]\n```","summary":"<p>Returns the first <em>n</em> elements of the array.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L816","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L816","def":{"name":"first","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[0, n]"}},{"id":"flatten-instance-method","html_id":"flatten-instance-method","name":"flatten","doc":"Returns a new `Array` that is a one-dimensional flattening of `self` (recursively).\n\nThat is, for every element that is an array or an iterator, extract its elements into the new array.\n\n```\ns = [1, 2, 3]          # => [1, 2, 3]\nt = [4, 5, 6, [7, 8]]  # => [4, 5, 6, [7, 8]]\nu = [9, [10, 11].each] # => [9, #<Indexable::ItemIterator>]\na = [s, t, u, 12, 13]  # => [[1, 2, 3], [4, 5, 6, [7, 8]], 9, #<Indexable::ItemIterator>, 12, 13]\na.flatten              # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that is a one-dimensional flattening of <code>self</code> (recursively).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1126","def":{"name":"flatten","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"FlattenHelper(typeof(FlattenHelper.element_type(self))).flatten(self)"}},{"id":"insert(index:Int,object:T)-instance-method","html_id":"insert(index:Int,object:T)-instance-method","name":"insert","doc":"Insert *object* before the element at *index* and shifting successive elements, if any.\nReturns `self`.\n\nNegative values of *index* count from the end of the array.\n\n```\na = [\"a\", \"b\", \"c\"]\na.insert(0, \"x\")  # => [\"x\", \"a\", \"b\", \"c\"]\na.insert(2, \"y\")  # => [\"x\", \"a\", \"y\", \"b\", \"c\"]\na.insert(-1, \"z\") # => [\"x\", \"a\", \"y\", \"b\", \"c\", \"z\"]\n```","summary":"<p>Insert <em>object</em> before the element at <em>index</em> and shifting successive elements, if any.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(index : Int, object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L831","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L831","def":{"name":"insert","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_needs_resize\nif index < 0\n  index = index + (size + 1)\nend\nif 0 <= index && index <= size\nelse\n  raise(IndexError.new)\nend\n((@buffer + index) + 1).move_from(@buffer + index, size - index)\n@buffer[index] = object\n@size = @size + 1\nself\n"}},{"id":"last(n:Int)-instance-method","html_id":"last(n:Int)-instance-method","name":"last","doc":"Returns the last *n* elements of the array.\n\n```\n[1, 2, 3].last(2) # => [2, 3]\n[1, 2, 3].last(4) # => [1, 2, 3]\n```","summary":"<p>Returns the last <em>n</em> elements of the array.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L859","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L859","def":{"name":"last","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < @size\n  self[@size - n, n]\nelse\n  dup\nend"}},{"id":"map(&block:T->U)forallU-instance-method","html_id":"map(&amp;block:T-&gt;U)forallU-instance-method","name":"map","doc":"Optimized version of `Enumerable#map`.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#map%28%26block%3AT-%3EU%29forallU-instance-method\">Enumerable#map</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L873","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L873","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Array(U).new(size) do |i|\n  yield @buffer[i]\nend"}},{"id":"map!(&block)-instance-method","html_id":"map!(&amp;block)-instance-method","name":"map!","doc":"Invokes the given block for each element of `self`, replacing the element\nwith the value returned by the block. Returns `self`.\n\n```\na = [1, 2, 3]\na.map! { |x| x * x }\na # => [1, 4, 9]\n```","summary":"<p>Invokes the given block for each element of <code>self</code>, replacing the element with the value returned by the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L885","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L885","def":{"name":"map!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer.map!(size) do |e|\n  yield e\nend\nself\n"}},{"id":"map_with_index(&block:T,Int32->U)forallU-instance-method","html_id":"map_with_index(&amp;block:T,Int32-&gt;U)forallU-instance-method","name":"map_with_index","doc":"Optimized version of `Enumerable#map_with_index`.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#map_with_index%28%26block%3AT%2CInt32-%3EU%29forallU-instance-method\">Enumerable#map_with_index</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L939","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L939","def":{"name":"map_with_index","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> U)"},"return_type":"","visibility":"Public","body":"Array(U).new(size) do |i|\n  yield @buffer[i], i\nend"}},{"id":"map_with_index!(&block:T,Int32->T)-instance-method","html_id":"map_with_index!(&amp;block:T,Int32-&gt;T)-instance-method","name":"map_with_index!","doc":"Like `map_with_index`, but mutates `self` instead of allocating a new object.","summary":"<p>Like <code><a href=\"Array.html#map_with_index%28%26block%3AT%2CInt32-%3EU%29forallU-instance-method\">#map_with_index</a></code>, but mutates <code>self</code> instead of allocating a new object.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L944","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L944","def":{"name":"map_with_index!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> T)"},"return_type":"","visibility":"Public","body":"to_unsafe.map_with_index!(size) do |e, i|\n  yield e, i\nend\nself\n"}},{"id":"permutations(size:Int=self.size)-instance-method","html_id":"permutations(size:Int=self.size)-instance-method","name":"permutations","doc":"Returns an `Array` with all possible permutations of *size*.\n\n```\na = [1, 2, 3]\na.permutations    # => [[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]\na.permutations(1) # => [[1],[2],[3]]\na.permutations(2) # => [[1,2],[1,3],[2,1],[2,3],[3,1],[3,2]]\na.permutations(3) # => [[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]\na.permutations(0) # => [[]]\na.permutations(4) # => []\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all possible permutations of <em>size</em>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = <span class=\"k\">self</span>.size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L960","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L960","def":{"name":"permutations","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of Array(T)\neach_permutation(size) do |a|\n  ary << a\nend\nary\n"}},{"id":"pop(&block)-instance-method","html_id":"pop(&amp;block)-instance-method","name":"pop","doc":"Removes the last value from `self`.\nIf the array is empty, the given block is called.\n\n```\na = [1]\na.pop { \"Testing\" } # => 1\na.pop { \"Testing\" } # => \"Testing\"\n```","summary":"<p>Removes the last value from <code>self</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1272","def":{"name":"pop","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size == 0\n  yield\nelse\n  @size = @size - 1\n  value = @buffer[@size]\n  (@buffer + @size).clear\n  value\nend"}},{"id":"pop-instance-method","html_id":"pop-instance-method","name":"pop","doc":"Removes the last value from `self`, at index *size - 1*.\nThis method returns the removed value.\nRaises `IndexError` if array is of 0 size.\n\n```\na = [\"a\", \"b\", \"c\"]\na.pop # => \"c\"\na     # => [\"a\", \"b\"]\n```","summary":"<p>Removes the last value from <code>self</code>, at index <em>size - 1</em>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1260","def":{"name":"pop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pop do\n  raise(IndexError.new)\nend"}},{"id":"pop(n:Int)-instance-method","html_id":"pop(n:Int)-instance-method","name":"pop","doc":"Removes the last *n* values from `self`, at index *size - 1*.\nThis method returns an array of the removed values, with the original order preserved.\n\nIf *n* is greater than the size of `self`, all values will be removed from `self`\nwithout raising an error.\n\n```\na = [\"a\", \"b\", \"c\"]\na.pop(2) # => [\"b\", \"c\"]\na        # => [\"a\"]\n\na = [\"a\", \"b\", \"c\"]\na.pop(4) # => [\"a\", \"b\", \"c\"]\na        # => []\n```","summary":"<p>Removes the last <em>n</em> values from <code>self</code>, at index <em>size - 1</em>.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1298","def":{"name":"pop","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't pop negative count\"))\nend\nn = Math.min(n, @size)\nary = Array(T).new(n) do |i|\n  @buffer[(@size - n) + i]\nend\n@size = @size - n\n(@buffer + @size).clear(n)\nary\n"}},{"id":"pop?-instance-method","html_id":"pop?-instance-method","name":"pop?","doc":"Like `pop`, but returns `nil` if `self` is empty.","summary":"<p>Like <code><a href=\"Array.html#pop%28%26block%29-instance-method\">#pop</a></code>, but returns <code>nil</code> if <code>self</code> is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1313","def":{"name":"pop?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pop do\n  nil\nend"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1667","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1667","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:pretty_print) do\n  pp.list(\"[\", self, \"]\")\nend\nif executed\nelse\n  pp.text(\"[...]\")\nend\n"}},{"id":"product(ary:Array(U))forallU-instance-method","html_id":"product(ary:Array(U))forallU-instance-method","name":"product","doc":null,"summary":null,"abstract":false,"args":[{"name":"ary","doc":null,"default_value":"","external_name":"ary","restriction":"Array(U)"}],"args_string":"(ary : Array(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1317","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1317","def":{"name":"product","args":[{"name":"ary","doc":null,"default_value":"","external_name":"ary","restriction":"Array(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"result = Array(::Tuple(T, U)).new(size * ary.size)\nproduct(ary) do |x, y|\n  result << {x, y}\nend\nresult\n"}},{"id":"product(enumerable:Enumerable,&block)-instance-method","html_id":"product(enumerable:Enumerable,&amp;block)-instance-method","name":"product","doc":null,"summary":null,"abstract":false,"args":[{"name":"enumerable","doc":null,"default_value":"","external_name":"enumerable","restriction":"Enumerable"}],"args_string":"(enumerable : Enumerable, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1325","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1325","def":{"name":"product","args":[{"name":"enumerable","doc":null,"default_value":"","external_name":"enumerable","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"self.each do |a|\n  enumerable.each do |b|\n    yield a, b\n  end\nend"}},{"id":"push(*values:T)-instance-method","html_id":"push(*values:T)-instance-method","name":"push","doc":"Append multiple values. The same as `push`, but takes an arbitrary number\nof values to push into `self`. Returns `self`.\n\n```\na = [\"a\"]\na.push(\"b\", \"c\") # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Append multiple values.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"T"}],"args_string":"(*values : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1357","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1357","def":{"name":"push","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"T"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_size = @size + values.size\nif new_size > @capacity\n  resize_to_capacity(Math.pw2ceil(new_size))\nend\nvalues.each_with_index do |value, i|\n  @buffer[@size + i] = value\nend\n@size = new_size\nself\n"}},{"id":"push(value:T)-instance-method","html_id":"push(value:T)-instance-method","name":"push","doc":"Append. Pushes one value to the end of `self`, given that the type of the value is *T*\n(which might be a single type or a union of types).\nThis method returns `self`, so several calls can be chained.\nSee `pop` for the opposite effect.\n\n```\na = [\"a\", \"b\"]\na.push(\"c\") # => [\"a\", \"b\", \"c\"]\na.push(1)   # Errors, because the array only accepts String.\n\na = [\"a\", \"b\"] of (Int32 | String)\na.push(\"c\") # => [\"a\", \"b\", \"c\"]\na.push(1)   # => [\"a\", \"b\", \"c\", 1]\n```","summary":"<p>Append.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1343","def":{"name":"push","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_needs_resize\n@buffer[@size] = value\n@size = @size + 1\nself\n"}},{"id":"reject!(&block)-instance-method","html_id":"reject!(&amp;block)-instance-method","name":"reject!","doc":"Modifies `self`, deleting the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\nSee also: `Array#reject`.","summary":"<p>Modifies <code>self</code>, deleting the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L902","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L902","def":{"name":"reject!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"internal_delete do |e|\n  yield e\nend\nself\n"}},{"id":"repeated_combinations(size:Int=self.size)-instance-method","html_id":"repeated_combinations(size:Int=self.size)-instance-method","name":"repeated_combinations","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = <span class=\"k\">self</span>.size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1130","def":{"name":"repeated_combinations","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of Array(T)\neach_repeated_combination(size) do |a|\n  ary << a\nend\nary\n"}},{"id":"repeated_permutations(size:Int=self.size)-instance-method","html_id":"repeated_permutations(size:Int=self.size)-instance-method","name":"repeated_permutations","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = <span class=\"k\">self</span>.size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1231","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1231","def":{"name":"repeated_permutations","args":[{"name":"size","doc":null,"default_value":"self.size","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of Array(T)\neach_repeated_permutation(size) do |a|\n  ary << a\nend\nary\n"}},{"id":"replace(other:Array)-instance-method","html_id":"replace(other:Array)-instance-method","name":"replace","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1367","def":{"name":"replace","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size = other.size\nif @size > @capacity\n  resize_to_capacity(Math.pw2ceil(@size))\nend\n@buffer.copy_from(other.to_unsafe, other.size)\nself\n"}},{"id":"reverse-instance-method","html_id":"reverse-instance-method","name":"reverse","doc":"Returns an array with all the elements in the collection reversed.\n\n```\na = [1, 2, 3]\na.reverse # => [3, 2, 1]\n```","summary":"<p>Returns an array with all the elements in the collection reversed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1380","def":{"name":"reverse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array(T).new(size) do |i|\n  @buffer[(size - i) - 1]\nend"}},{"id":"reverse!-instance-method","html_id":"reverse!-instance-method","name":"reverse!","doc":"Reverses in-place all the elements of `self`.","summary":"<p>Reverses in-place all the elements of <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1385","def":{"name":"reverse!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Slice.new(@buffer, size)).reverse!\nself\n"}},{"id":"rotate(n=1)-instance-method","html_id":"rotate(n=1)-instance-method","name":"rotate","doc":null,"summary":null,"abstract":false,"args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1406","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1406","def":{"name":"rotate","args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == 0\n  return self\nend\nn = n % size\nif n == 0\n  return self\nend\nres = Array(T).new(size)\nres.to_unsafe.copy_from(@buffer + n, size - n)\n((res.to_unsafe + size) - n).copy_from(@buffer, n)\nres.size = size\nres\n"}},{"id":"rotate!(n=1)-instance-method","html_id":"rotate!(n=1)-instance-method","name":"rotate!","doc":null,"summary":null,"abstract":false,"args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1390","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1390","def":{"name":"rotate!","args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == 0\n  return self\nend\nn = n % size\nif n == 0\n  return self\nend\nif n <= (size / 2)\n  tmp = self[0..n]\n  @buffer.move_from(@buffer + n, size - n)\n  ((@buffer + size) - n).copy_from(tmp.to_unsafe, n)\nelse\n  tmp = self[n..-1]\n  ((@buffer + size) - n).move_from(@buffer, n)\n  @buffer.copy_from(tmp.to_unsafe, size - n)\nend\nself\n"}},{"id":"sample(n:Int,random=Random::DEFAULT)-instance-method","html_id":"sample(n:Int,random=Random::DEFAULT)-instance-method","name":"sample","doc":"Returns *n* number of random elements from `self`, using the given *random* number generator.\nRaises IndexError if `self` is empty.\n\n```\na = [1, 2, 3]\na.sample(2)                # => [2, 1]\na.sample(2, Random.new(1)) # => [1, 3]\n```","summary":"<p>Returns <em>n</em> number of random elements from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(n : Int, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1425","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1425","def":{"name":"sample","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't get negative count sample\"))\nend\ncase n\nwhen 0\n  return [] of T\nwhen 1\n  return [sample(random)] of T\nelse\n  if n >= size\n    return dup.shuffle!(random)\n  end\n  ary = Array(T).new(n) do |i|\n    @buffer[i]\n  end\n  buffer = ary.to_unsafe\n  n.upto(size - 1) do |i|\n    j = random.rand(i + 1)\n    if j <= n\n      buffer[j] = @buffer[i]\n    end\n  end\n  ary.shuffle!(random)\n  ary\nend\n"}},{"id":"select!(&block)-instance-method","html_id":"select!(&amp;block)-instance-method","name":"select!","doc":"Modifies `self`, keeping only the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\nSee also: `Array#select`.","summary":"<p>Modifies <code>self</code>, keeping only the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L894","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L894","def":{"name":"select!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reject! do |elem|\n  !(yield elem)\nend"}},{"id":"shift(n:Int)-instance-method","html_id":"shift(n:Int)-instance-method","name":"shift","doc":"Removes the first *n* values of `self`, starting at index 0.\nThis method returns an array of the removed values.\n\nIf *n* is greater than the size of `self`, all values will be removed from `self`\nwithout raising an error.\n\n```\na = [\"a\", \"b\", \"c\"]\na.shift # => \"a\"\na       # => [\"b\", \"c\"]\n\na = [\"a\", \"b\", \"c\"]\na.shift(4) # => [\"a\", \"b\", \"c\"]\na          # => []\n```","summary":"<p>Removes the first <em>n</em> values of <code>self</code>, starting at index 0.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1494","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1494","def":{"name":"shift","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't shift negative count\"))\nend\nn = Math.min(n, @size)\nary = Array(T).new(n) do |i|\n  @buffer[i]\nend\n@buffer.move_from(@buffer + n, @size - n)\n@size = @size - n\n(@buffer + @size).clear(n)\nary\n"}},{"id":"shift-instance-method","html_id":"shift-instance-method","name":"shift","doc":"Removes the first value of `self`, at index 0. This method returns the removed value.\nIf the array is empty, it raises `IndexError`.\n\n```\na = [\"a\", \"b\", \"c\"]\na.shift # => \"a\"\na       # => [\"b\", \"c\"]\n```","summary":"<p>Removes the first value of <code>self</code>, at index 0.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1463","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1463","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"id":"shift(&block)-instance-method","html_id":"shift(&amp;block)-instance-method","name":"shift","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1467","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1467","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size == 0\n  yield\nelse\n  value = @buffer[0]\n  @size = @size - 1\n  @buffer.move_from(@buffer + 1, @size)\n  (@buffer + @size).clear\n  value\nend"}},{"id":"shift?-instance-method","html_id":"shift?-instance-method","name":"shift?","doc":"Removes the first value of `self`, at index 0. This method returns the removed value.\nIf the array is empty, it returns `nil` without raising any error.\n\n```\na = [\"a\", \"b\"]\na.shift? # => \"a\"\na        # => [\"b\"]\na.shift? # => \"b\"\na        # => []\na.shift? # => nil\na        # => []\n```","summary":"<p>Removes the first value of <code>self</code>, at index 0.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1521","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1521","def":{"name":"shift?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  nil\nend"}},{"id":"shuffle(random=Random::DEFAULT)-instance-method","html_id":"shuffle(random=Random::DEFAULT)-instance-method","name":"shuffle","doc":"Returns an array with all the elements in the collection randomized\nusing the given *random* number generator.","summary":"<p>Returns an array with all the elements in the collection randomized using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1527","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1527","def":{"name":"shuffle","args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dup.shuffle!(random)"}},{"id":"shuffle!(random=Random::DEFAULT)-instance-method","html_id":"shuffle!(random=Random::DEFAULT)-instance-method","name":"shuffle!","doc":"Modifies `self` by randomizing the order of elements in the collection\nusing the given *random* number generator.  Returns `self`.","summary":"<p>Modifies <code>self</code> by randomizing the order of elements in the collection using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1533","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1533","def":{"name":"shuffle!","args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer.shuffle!(size, random)\nself\n"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the array.\n\n```\n[:foo, :bar].size # => 2\n```","summary":"<p>Returns the number of elements in the array.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L55","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"sort:Array(T)-instance-method","html_id":"sort:Array(T)-instance-method","name":"sort","doc":"Returns a new array with all elements sorted based on the return value of\ntheir comparison method `#<=>`\n\n```\na = [3, 1, 2]\na.sort # => [1, 2, 3]\na      # => [3, 1, 2]\n```","summary":"<p>Returns a new array with all elements sorted based on the return value of their comparison method <code><a href=\"Array.html#%28other%3AArray%29-instance-method\">#<=></a></code></p>","abstract":false,"args":[],"args_string":" : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1546","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1546","def":{"name":"sort","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(T)","visibility":"Public","body":"dup.sort!"}},{"id":"sort(&block:T,T->Int32):Array(T)-instance-method","html_id":"sort(&amp;block:T,T-&gt;Int32):Array(T)-instance-method","name":"sort","doc":"Returns a new array with all elements sorted based on the comparator in the\ngiven block.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\nb = a.sort { |a, b| b <=> a }\n\nb # => [3, 2, 1]\na # => [3, 1, 2]\n```","summary":"<p>Returns a new array with all elements sorted based on the comparator in the given block.</p>","abstract":false,"args":[],"args_string":"(&block : T, T -> Int32) : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1564","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1564","def":{"name":"sort","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, T -> Int32)"},"return_type":"Array(T)","visibility":"Public","body":"dup.sort!(&block)"}},{"id":"sort!:Array(T)-instance-method","html_id":"sort!:Array(T)-instance-method","name":"sort!","doc":"Modifies `self` by sorting all elements based on the return value of their\ncomparison method `#<=>`\n\n```\na = [3, 1, 2]\na.sort!\na # => [1, 2, 3]\n```","summary":"<p>Modifies <code>self</code> by sorting all elements based on the return value of their comparison method <code><a href=\"Array.html#%28other%3AArray%29-instance-method\">#<=></a></code></p>","abstract":false,"args":[],"args_string":" : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1576","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1576","def":{"name":"sort!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(T)","visibility":"Public","body":"Array.intro_sort!(@buffer, @size)\nself\n"}},{"id":"sort!(&block:T,T->Int32):Array(T)-instance-method","html_id":"sort!(&amp;block:T,T-&gt;Int32):Array(T)-instance-method","name":"sort!","doc":"Modifies `self` by sorting all elements based on the comparator in the given\nblock.\n\nThe given block must implement a comparison between two elements\n*a* and *b*, where `a < b` returns `-1`, `a == b` returns `0`,\nand `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\na.sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```","summary":"<p>Modifies <code>self</code> by sorting all elements based on the comparator in the given block.</p>","abstract":false,"args":[],"args_string":"(&block : T, T -> Int32) : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1594","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1594","def":{"name":"sort!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, T -> Int32)"},"return_type":"Array(T)","visibility":"Public","body":"Array.intro_sort!(@buffer, @size, block)\nself\n"}},{"id":"sort_by(&block:T->_):Array(T)-instance-method","html_id":"sort_by(&amp;block:T-&gt;_):Array(T)-instance-method","name":"sort_by","doc":"Returns a new array with all elements sorted. The given block is called for\neach element, then the comparison method #<=> is called on the object\nreturned from the block to determine sort order.\n\n```\na = %w(apple pear fig)\nb = a.sort_by { |word| word.size }\nb # => [\"fig\", \"pear\", \"apple\"]\na # => [\"apple\", \"pear\", \"fig\"]\n```","summary":"<p>Returns a new array with all elements sorted.</p>","abstract":false,"args":[],"args_string":"(&block : T -> _) : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1609","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1609","def":{"name":"sort_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"dup.sort_by! do |e|\n  yield e\nend"}},{"id":"sort_by!(&block:T->_):Array(T)-instance-method","html_id":"sort_by!(&amp;block:T-&gt;_):Array(T)-instance-method","name":"sort_by!","doc":"Modifies `self` by sorting all elements. The given block is called for\neach element, then the comparison method #<=> is called on the object\nreturned from the block to determine sort order.\n\n```\na = %w(apple pear fig)\na.sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```","summary":"<p>Modifies <code>self</code> by sorting all elements.</p>","abstract":false,"args":[],"args_string":"(&block : T -> _) : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1622","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1622","def":{"name":"sort_by!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"sorted = map do |e|\n  {e, yield e}\nend.sort! do |x, y|\n  x[1] <=> y[1]\nend\n@size.times do |i|\n  @buffer[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"id":"swap(index0,index1):Array(T)-instance-method","html_id":"swap(index0,index1):Array(T)-instance-method","name":"swap","doc":"Swaps the elements at *index0* and *index1* and returns `self`.\nRaises an `IndexError` if either index is out of bounds.\n\n```\na = [\"first\", \"second\", \"third\"]\na.swap(1, 2)  # => [\"first\", \"third\", \"second\"]\na             # => [\"first\", \"third\", \"second\"]\na.swap(0, -1) # => [\"second\", \"third\", \"first\"]\na             # => [\"second\", \"third\", \"first\"]\na.swap(2, 3)  # => raises \"Index out of bounds (IndexError)\"\n```","summary":"<p>Swaps the elements at <em>index0</em> and <em>index1</em> and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"index0","doc":null,"default_value":"","external_name":"index0","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":""}],"args_string":"(index0, index1) : Array(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1641","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1641","def":{"name":"swap","args":[{"name":"index0","doc":null,"default_value":"","external_name":"index0","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(T)","visibility":"Public","body":"if index0 < 0\n  index0 = index0 + size\nend\nif index1 < 0\n  index1 = index1 + size\nend\nif (0 <= index0 && index0 < size) && (0 <= index1 && index1 < size)\nelse\n  raise(IndexError.new)\nend\n@buffer[index0], @buffer[index1] = @buffer[index1], @buffer[index0]\nself\n"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1654","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1654","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L64","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.array do\n  each(&.to_json(json))\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1658","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1658","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"executed = exec_recursive(:to_s) do\n  io << '['\n  join(\", \", io, &.inspect(io))\n  io << ']'\nend\nif executed\nelse\n  io << \"[...]\"\nend\n"}},{"id":"to_unsafe:Pointer(T)-instance-method","html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns a pointer to the internal buffer where `self`'s elements are stored.\n\nThis method is **unsafe** because it returns a pointer, and the pointed might eventually\nnot be that of `self` if the array grows and its internal buffer is reallocated.\n\n```\nary = [1, 2, 3]\nary.to_unsafe[0] # => 1\n```","summary":"<p>Returns a pointer to the internal buffer where <code>self</code>'s elements are stored.</p>","abstract":false,"args":[],"args_string":" : Pointer(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1683","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1683","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Pointer(T)","visibility":"Public","body":"@buffer"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L35","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.sequence(reference: self) do\n  each(&.to_yaml(yaml))\nend"}},{"id":"transpose-instance-method","html_id":"transpose-instance-method","name":"transpose","doc":"Assumes that `self` is an array of arrays and transposes the rows and columns.\n\n```\na = [[:a, :b], [:c, :d], [:e, :f]]\na.transpose # => [[:a, :c, :e], [:b, :d, :f]]\na           # => [[:a, :b], [:c, :d], [:e, :f]]\n```","summary":"<p>Assumes that <code>self</code> is an array of arrays and transposes the rows and columns.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1694","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1694","def":{"name":"transpose","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return Array(Array(typeof(first.first))).new\nend\nlen = (at(0)).size\n(1...@size).each do |i|\n  l = (at(i)).size\n  if len != l\n    raise(IndexError.new)\n  end\nend\nArray(Array(typeof(first.first))).new(len) do |i|\n  Array(typeof(first.first)).new(@size) do |j|\n    (at(j)).at(i)\n  end\nend\n"}},{"id":"uniq-instance-method","html_id":"uniq-instance-method","name":"uniq","doc":"Returns a new `Array` by removing duplicate values in `self`.\n\n```\na = [\"a\", \"a\", \"b\", \"b\", \"c\"]\na.uniq # => [\"a\", \"b\", \"c\"]\na      # => [ \"a\", \"a\", \"b\", \"b\", \"c\" ]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> by removing duplicate values in <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1717","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1717","def":{"name":"uniq","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uniq(&.itself)"}},{"id":"uniq(&block:T->_)-instance-method","html_id":"uniq(&amp;block:T-&gt;_)-instance-method","name":"uniq","doc":"Returns a new `Array` by removing duplicate values in `self`, using the block's\nvalue for comparison.\n\n```\na = [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\na.uniq { |s| s[0] } # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\na                   # => [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> by removing duplicate values in <code>self</code>, using the block's value for comparison.</p>","abstract":false,"args":[],"args_string":"(&block : T -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1729","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1729","def":{"name":"uniq","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> _)"},"return_type":"","visibility":"Public","body":"if size <= 1\n  dup\nelse\n  hash = to_lookup_hash do |elem|\n    yield elem\n  end\n  hash.values\nend"}},{"id":"uniq!-instance-method","html_id":"uniq!-instance-method","name":"uniq!","doc":"Removes duplicate elements from `self`. Returns `self`.\n\n```\na = [\"a\", \"a\", \"b\", \"b\", \"c\"]\na.uniq! # => [\"a\", \"b\", \"c\"]\na       # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Removes duplicate elements from <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1745","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1745","def":{"name":"uniq!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uniq!(&.itself)"}},{"id":"uniq!(&block)-instance-method","html_id":"uniq!(&amp;block)-instance-method","name":"uniq!","doc":"Removes duplicate elements from `self`, using the block's value for comparison. Returns `self`.\n\n```\na = [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\na.uniq! { |s| s[0] } # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\na                    # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\n```","summary":"<p>Removes duplicate elements from <code>self</code>, using the block's value for comparison.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1756","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1756","def":{"name":"uniq!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if size <= 1\n  return self\nend\nhash = to_lookup_hash do |elem|\n  yield elem\nend\nif size == hash.size\n  return self\nend\nold_size = @size\n@size = hash.size\nremoved = old_size - @size\nif removed == 0\n  return self\nend\nptr = @buffer\nhash.each do |k, v|\n  ptr.value = v\n  ptr = ptr + 1\nend\n(@buffer + @size).clear(removed)\nself\n"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L499","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L499","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer[index]"}},{"id":"unshift(obj:T)-instance-method","html_id":"unshift(obj:T)-instance-method","name":"unshift","doc":"Prepend. Adds *obj* to the beginning of `self`, given that the type of the value is *T*\n(which might be a single type or a union of types).\nThis method returns `self`, so several calls can be chained.\nSee `shift` for the opposite effect.\n\n```\na = [\"a\", \"b\"]\na.unshift(\"c\") # => [\"c\", \"a\", \"b\"]\na.unshift(1)   # Errors, because the array only accepts String.\n\na = [\"a\", \"b\"] of (Int32 | String)\na.unshift(\"c\") # => [\"c\", \"a\", \"b\"]\na.unshift(1)   # => [1, \"c\", \"a\", \"b\"]\n```","summary":"<p>Prepend.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":"T"}],"args_string":"(obj : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1796","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1796","def":{"name":"unshift","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"insert(0, obj)"}},{"id":"unshift(*values:T)-instance-method","html_id":"unshift(*values:T)-instance-method","name":"unshift","doc":"Prepend multiple values. The same as `unshift`, but takes an arbitrary number\nof values to add to the array. Returns `self`.","summary":"<p>Prepend multiple values.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"T"}],"args_string":"(*values : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1802","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1802","def":{"name":"unshift","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"T"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_size = @size + values.size\nif new_size > @capacity\n  resize_to_capacity(Math.pw2ceil(new_size))\nend\nmove_value = values.size\n@buffer.move_to(@buffer + move_value, @size)\nvalues.each_with_index do |value, i|\n  @buffer[i] = value\nend\n@size = new_size\nself\n"}},{"id":"update(index:Int,&block)-instance-method","html_id":"update(index:Int,&amp;block)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1815","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L1815","def":{"name":"update","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index)\n@buffer[index] = yield @buffer[index]\n"}},{"id":"|(other:Array(U))forallU-instance-method","html_id":"|(other:Array(U))forallU-instance-method","name":"|","doc":"Set union: returns a new `Array` by joining `self` with *other*, excluding\nany duplicates, and preserving the order from `self`.\n\n```\n[\"a\", \"b\", \"c\"] | [\"c\", \"d\", \"a\"] # => [ \"a\", \"b\", \"c\", \"d\" ]\n```\n\nSee also: `#uniq`.","summary":"<p>Set union: returns a new <code><a href=\"Array.html\">Array</a></code> by joining <code>self</code> with <em>other</em>, excluding any duplicates, and preserving the order from <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/array.cr#L230","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Array(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array(T | U).build(size + other.size) do |buffer|\n  hash = Hash(T, Bool).new\n  i = 0\n  each do |obj|\n    if hash.has_key?(obj)\n    else\n      buffer[i] = obj\n      hash[obj] = true\n      i = i + 1\n    end\n  end\n  other.each do |obj|\n    if hash.has_key?(obj)\n    else\n      buffer[i] = obj\n      hash[obj] = true\n      i = i + 1\n    end\n  end\n  i\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Atomic","path":"Atomic.html","kind":"struct","full_name":"Atomic(T)","name":"Atomic","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"atomic.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A value that may be updated atomically.\n\nOnly primitive integer types, reference types or nilable reference types\ncan be used with an Atomic type.","summary":"<p>A value that may be updated atomically.</p>","class_methods":[],"constructors":[{"id":"new(value:T)-class-method","html_id":"new(value:T)-class-method","name":"new","doc":"Creates an Atomic with the given initial value.","summary":"<p>Creates an Atomic with the given initial value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L7","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Atomic(T).allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add(value:T)-instance-method","html_id":"add(value:T)-instance-method","name":"add","doc":"Performs `atomic_value += value`. Returns the old value.\n\n```\natomic = Atomic.new(1)\natomic.add(2) # => 1\natomic.get    # => 3\n```","summary":"<p>Performs <code>atomic_value += value</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L55","def":{"name":"add","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:add, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"and(value:T)-instance-method","html_id":"and(value:T)-instance-method","name":"and","doc":"Performs `atomic_value &= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.and(3) # => 5\natomic.get    # => 1\n```","summary":"<p>Performs <code>atomic_value &= value</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L77","def":{"name":"and","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:and, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"compare_and_set(cmp:T,new:T):Tuple(T,Bool)-instance-method","html_id":"compare_and_set(cmp:T,new:T):Tuple(T,Bool)-instance-method","name":"compare_and_set","doc":"Compares this atomic's value with *cmp*:\n\n* if they are equal, sets the value to *new*, and returns `{old_value, true}`\n* if they are not equal the value remains the same, and returns `{old_value, false}`\n\n```\natomic = Atomic.new(1)\n\natomic.compare_and_set(2, 3) # => {1, false}\natomic.get                   # => 1\n\natomic.compare_and_set(1, 3) # => {1, true}\natomic.get                   # => 3\n```","summary":"<p>Compares this atomic's value with <em>cmp</em>:</p>","abstract":false,"args":[{"name":"cmp","doc":null,"default_value":"","external_name":"cmp","restriction":"T"},{"name":"new","doc":null,"default_value":"","external_name":"new","restriction":"T"}],"args_string":"(cmp : T, new : T) : Tuple(T, Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L31","def":{"name":"compare_and_set","args":[{"name":"cmp","doc":null,"default_value":"","external_name":"cmp","restriction":"T"},{"name":"new","doc":null,"default_value":"","external_name":"new","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(T, Bool)","visibility":"Public","body":"{% if T.union? && T.union_types.all? do |t|\n  (t == Nil) || t < Reference\nend %}\n      # If so, use addresses because LLVM < 3.9 doesn't support cmpxchg with pointers\n      address, success = Ops.cmpxchg(pointerof(@value).as(LibC::SizeT*), LibC::SizeT.new(cmp.as(T).object_id), LibC::SizeT.new(new.as(T).object_id), :sequentially_consistent, :sequentially_consistent)\n      {address == 0 ? nil : Pointer(T).new(address).as(T), success}\n    # Check if it's a reference type\n    {% else %}{% if T < Reference %}\n      # Use addresses again (but this can't return nil)\n      address, success = Ops.cmpxchg(pointerof(@value).as(LibC::SizeT*), LibC::SizeT.new(cmp.as(T).object_id), LibC::SizeT.new(new.as(T).object_id), :sequentially_consistent, :sequentially_consistent)\n      {Pointer(T).new(address).as(T), success}\n    {% else %}\n      # Otherwise, this is an integer type\n      Ops.cmpxchg(pointerof(@value), cmp, new, :sequentially_consistent, :sequentially_consistent)\n    {% end %}{% end %}"}},{"id":"get-instance-method","html_id":"get-instance-method","name":"get","doc":"Atomically returns this atomic's value.","summary":"<p>Atomically returns this atomic's value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L186","def":{"name":"get","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.load(pointerof(@value), :sequentially_consistent, true)"}},{"id":"lazy_get-instance-method","html_id":"lazy_get-instance-method","name":"lazy_get","doc":"**Non-atomically** returns this atomic's value.","summary":"<p><strong>Non-atomically</strong> returns this atomic's value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L191","def":{"name":"lazy_get","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value"}},{"id":"lazy_set(value:T)-instance-method","html_id":"lazy_set(value:T)-instance-method","name":"lazy_set","doc":"**Non-atomically** sets this atomic's value to *value*. Returns the **new** value.\n\n```\natomic = Atomic.new(5)\natomic.lazy_set(10) # => 10\natomic.get          # => 10\n```","summary":"<p><strong>Non-atomically</strong> sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L182","def":{"name":"lazy_set","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value = value"}},{"id":"max(value:T)-instance-method","html_id":"max(value:T)-instance-method","name":"max","doc":"Performs `atomic_value = max(atomic_value, value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\n\natomic.max(3) # => 5\natomic.get    # => 5\n\natomic.max(10) # => 5\natomic.get     # => 10\n```","summary":"<p>Performs <code>atomic_value = max(atomic_value, value)</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L125","def":{"name":"max","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T < Int::Signed %}\n      Ops.atomicrmw(:max, pointerof(@value), value, :sequentially_consistent, false)\n    {% else %}\n      Ops.atomicrmw(:umax, pointerof(@value), value, :sequentially_consistent, false)\n    {% end %}"}},{"id":"min(value:T)-instance-method","html_id":"min(value:T)-instance-method","name":"min","doc":"Performs `atomic_value = min(atomic_value, value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\n\natomic.min(10) # => 5\natomic.get     # => 5\n\natomic.min(3) # => 5\natomic.get    # => 3\n```","summary":"<p>Performs <code>atomic_value = min(atomic_value, value)</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L144","def":{"name":"min","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T < Int::Signed %}\n      Ops.atomicrmw(:min, pointerof(@value), value, :sequentially_consistent, false)\n    {% else %}\n      Ops.atomicrmw(:umin, pointerof(@value), value, :sequentially_consistent, false)\n    {% end %}"}},{"id":"nand(value:T)-instance-method","html_id":"nand(value:T)-instance-method","name":"nand","doc":"Performs `atomic_value = ~(atomic_value & value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.nand(3) # => 5\natomic.get     # => -2\n```","summary":"<p>Performs <code>atomic_value = ~(atomic_value & value)</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L88","def":{"name":"nand","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:nand, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"or(value:T)-instance-method","html_id":"or(value:T)-instance-method","name":"or","doc":"Performs `atomic_value |= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.or(2) # => 5\natomic.get   # => 7\n```","summary":"<p>Performs <code>atomic_value |= value</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L99","def":{"name":"or","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:or, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"set(value:T)-instance-method","html_id":"set(value:T)-instance-method","name":"set","doc":"Atomically sets this atomic's value to *value*. Returns the **new** value.\n\n```\natomic = Atomic.new(5)\natomic.set(10) # => 10\natomic.get     # => 10\n```","summary":"<p>Atomically sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L170","def":{"name":"set","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.store(pointerof(@value), value.as(T), :sequentially_consistent, true)\nvalue\n"}},{"id":"sub(value:T)-instance-method","html_id":"sub(value:T)-instance-method","name":"sub","doc":"Performs `atomic_value -= value`. Returns the old value.\n\n```\natomic = Atomic.new(9)\natomic.sub(2) # => 9\natomic.get    # => 7\n```","summary":"<p>Performs <code>atomic_value -= value</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L66","def":{"name":"sub","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:sub, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"swap(value:T)-instance-method","html_id":"swap(value:T)-instance-method","name":"swap","doc":"Atomically sets this atomic's value to *value*. Returns the **old** value.\n\n```\natomic = Atomic.new(5)\natomic.swap(10) # => 5\natomic.get      # => 10\n```","summary":"<p>Atomically sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L159","def":{"name":"swap","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:xchg, pointerof(@value), value, :sequentially_consistent, false)"}},{"id":"xor(value:T)-instance-method","html_id":"xor(value:T)-instance-method","name":"xor","doc":"Performs `atomic_value ^= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.xor(3) # => 5\natomic.get    # => 6\n```","summary":"<p>Performs <code>atomic_value ^= value</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/atomic.cr#L110","def":{"name":"xor","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Ops.atomicrmw(:xor, pointerof(@value), value, :sequentially_consistent, false)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Base64","path":"Base64.html","kind":"module","full_name":"Base64","name":"Base64","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"base64.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Base64","kind":"module","full_name":"Base64","name":"Base64"}],"subclasses":[],"including_types":[],"namespace":null,"doc":"The `Base64` module provides for the encoding (`encode`, `strict_encode`,\n`urlsafe_encode`) and decoding (`decode`)\nof binary data using a base64 representation.\n\n### Example\n\nA simple encoding and decoding.\n\n```\nrequire \"base64\"\n\nenc = Base64.encode(\"Send reinforcements\") # => \"U2VuZCByZWluZm9yY2VtZW50cw==\\n\"\nplain = Base64.decode_string(enc)          # => \"Send reinforcements\"\n```\n\nThe purpose of using base64 to encode data is that it translates any binary\ndata into purely printable characters.","summary":"<p>The <code><a href=\"Base64.html\">Base64</a></code> module provides for the encoding (<code><a href=\"Base64.html#encode%28data%2Cio%3AIO%29-instance-method\">#encode</a></code>, <code><a href=\"Base64.html#strict_encode%28data%2Cio%3AIO%29-instance-method\">#strict_encode</a></code>, <code><a href=\"Base64.html#urlsafe_encode%28data%2Cio%3AIO%29-instance-method\">#urlsafe_encode</a></code>) and decoding (<code><a href=\"Base64.html#decode%28data%2Cio%3AIO%29-instance-method\">#decode</a></code>) of binary data using a base64 representation.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"decode(data,io:IO)-instance-method","html_id":"decode(data,io:IO)-instance-method","name":"decode","doc":"Write the base64-decoded version of *data* to *io*.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Write the base64-decoded version of <em>data</em> to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L171","def":{"name":"decode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count = 0\nfrom_base64(data.to_slice) do |byte|\n  io.write_byte(byte)\n  count = count + 1\nend\nio.flush\ncount\n"}},{"id":"decode(data):Bytes-instance-method","html_id":"decode(data):Bytes-instance-method","name":"decode","doc":"Returns the base64-decoded version of *data* as a `Bytes`.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Returns the base64-decoded version of <em>data</em> as a <code><a href=\"Bytes.html\">Bytes</a></code>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L161","def":{"name":"decode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"slice = data.to_slice\nbuf = Pointer(UInt8).malloc(decode_size(slice.size))\nappender = buf.appender\nfrom_base64(slice) do |byte|\n  appender << byte\nend\nSlice.new(buf, appender.size.to_i32)\n"}},{"id":"decode_string(data):String-instance-method","html_id":"decode_string(data):String-instance-method","name":"decode_string","doc":"Returns the base64-decoded version of *data* as a string.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Returns the base64-decoded version of <em>data</em> as a string.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L183","def":{"name":"decode_string","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(decode_size(slice.size)) do |buf|\n  appender = buf.appender\n  from_base64(slice) do |byte|\n    appender << byte\n  end\n  {appender.size, 0}\nend\n"}},{"id":"encode(data,io:IO)-instance-method","html_id":"encode(data,io:IO)-instance-method","name":"encode","doc":"Write the base64-encoded version of *data* to *io*.\nThis method complies with [RFC 2045](https://tools.ietf.org/html/rfc2045).\nLine feeds are added to every 60 encoded characters.\n\n```\nBase64.encode(\"Now is the time for all good coders\\nto learn Crystal\", STDOUT)\n```","summary":"<p>Write the base64-encoded version of <em>data</em> to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L61","def":{"name":"encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count = 0\nencode_with_new_lines(data.to_slice) do |byte|\n  io.write_byte(byte)\n  count = count + 1\nend\nio.flush\ncount\n"}},{"id":"encode(data):String-instance-method","html_id":"encode(data):String-instance-method","name":"encode","doc":"Returns the base64-encoded version of *data*.\nThis method complies with [RFC 2045](https://tools.ietf.org/html/rfc2045).\nLine feeds are added to every 60 encoded characters.\n\n```\nputs Base64.encode(\"Now is the time for all good coders\\nto learn Crystal\")\n```\n\nGenerates:\n\n```text\nTm93IGlzIHRoZSB0aW1lIGZvciBhbGwgZ29vZCBjb2RlcnMKdG8gbGVhcm4g\nQ3J5c3RhbA==\n```","summary":"<p>Returns the base64-encoded version of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L44","def":{"name":"encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(encode_size(slice.size, new_lines: true)) do |buf|\n  appender = buf.appender\n  encode_with_new_lines(slice) do |byte|\n    appender << byte\n  end\n  size = appender.size\n  {size, size}\nend\n"}},{"id":"strict_encode(data,io:IO)-instance-method","html_id":"strict_encode(data,io:IO)-instance-method","name":"strict_encode","doc":"Write the base64-encoded version of *data* with no newlines to *io*.\nThis method complies with [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\n```\nBase64.strict_encode(\"Now is the time for all good coders\\nto learn Crystal\", STDOUT)\n```","summary":"<p>Write the base64-encoded version of <em>data</em> with no newlines to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L118","def":{"name":"strict_encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"strict_encode_to_io_internal(data, io, CHARS_STD, pad: true)"}},{"id":"strict_encode(data):String-instance-method","html_id":"strict_encode(data):String-instance-method","name":"strict_encode","doc":"Returns the base64-encoded version of *data* with no newlines.\nThis method complies with [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\n```\nputs Base64.strict_encode(\"Now is the time for all good coders\\nto learn Crystal\")\n```\n\nGenerates:\n\n```text\nTm93IGlzIHRoZSB0aW1lIGZvciBhbGwgZ29vZCBjb2RlcnMKdG8gbGVhcm4gQ3J5c3RhbA==\n```","summary":"<p>Returns the base64-encoded version of <em>data</em> with no newlines.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L98","def":{"name":"strict_encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"strict_encode(data, CHARS_STD, pad: true)"}},{"id":"urlsafe_encode(data,io:IO)-instance-method","html_id":"urlsafe_encode(data,io:IO)-instance-method","name":"urlsafe_encode","doc":"Write the base64-encoded version of *data* using a urlsafe alphabet to *io*.\nThis method complies with \"Base 64 Encoding with URL and Filename Safe\nAlphabet\" in [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\nThe alphabet uses `'-'` instead of `'+'` and `'_'` instead of `'/'`.","summary":"<p>Write the base64-encoded version of <em>data</em> using a urlsafe alphabet to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L155","def":{"name":"urlsafe_encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"strict_encode_to_io_internal(data, io, CHARS_SAFE, pad: true)"}},{"id":"urlsafe_encode(data,padding=true):String-instance-method","html_id":"urlsafe_encode(data,padding=true):String-instance-method","name":"urlsafe_encode","doc":"Returns the base64-encoded version of *data* using a urlsafe alphabet.\nThis method complies with \"Base 64 Encoding with URL and Filename Safe\nAlphabet\" in [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\nThe alphabet uses `'-'` instead of `'+'` and `'_'` instead of `'/'`.\n\nThe *padding* parameter defaults to `true`. When `false`, enough `=` characters\nare not added to make the output divisible by 4.","summary":"<p>Returns the base64-encoded version of <em>data</em> using a urlsafe alphabet.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"padding","doc":null,"default_value":"true","external_name":"padding","restriction":""}],"args_string":"(data, padding = <span class=\"n\">true</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr#L140","def":{"name":"urlsafe_encode","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"padding","doc":null,"default_value":"true","external_name":"padding","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(encode_size(slice.size)) do |buf|\n  appender = buf.appender\n  to_base64(slice, CHARS_SAFE, pad: padding) do |byte|\n    appender << byte\n  end\n  size = appender.size\n  {size, size}\nend\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Base64/Error","path":"Base64/Error.html","kind":"class","full_name":"Base64::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"base64.cr","line_number":21,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/base64.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Base64","kind":"module","full_name":"Base64","name":"Base64"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Benchmark","path":"Benchmark.html","kind":"module","full_name":"Benchmark","name":"Benchmark","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"benchmark/bm.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr"},{"filename":"benchmark/ips.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr"},{"filename":"benchmark.cr","line_number":83,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"}],"subclasses":[],"including_types":[],"namespace":null,"doc":"The Benchmark module provides methods for benchmarking Crystal code, giving\ndetailed reports on the time taken for each task.\n\n### Measure the number of iterations per second of each task\n\n```\nrequire \"benchmark\"\n\nBenchmark.ips do |x|\n  x.report(\"short sleep\") { sleep 0.01 }\n  x.report(\"shorter sleep\") { sleep 0.001 }\nend\n```\n\nThis generates the following output showing the mean iterations per second,\nthe mean times per iteration, the standard deviation relative to the mean, and a comparison:\n\n```text\n  short sleep   88.7  ( 11.27ms) (± 3.33%)  8.90× slower\nshorter sleep  789.7  (  1.27ms) (± 3.02%)       fastest\n```\n\n`Benchmark::IPS` defaults to 2 seconds of warmup time and 5 seconds of\ncalculation time. This can be configured:\n\n```\nBenchmark.ips(warmup: 4, calculation: 10) do |x|\n  x.report(\"sleep\") { sleep 0.01 }\nend\n```\n\nMake sure to always benchmark code by compiling with the `--release` flag.\n\n### Measure the time to construct the string given by the expression: `\"a\"*1_000_000_000`\n\n```\nrequire \"benchmark\"\n\nputs Benchmark.measure { \"a\"*1_000_000_000 }\n```\n\nThis generates the following output:\n\n```text\n 0.190000   0.220000   0.410000 (  0.420185)\n```\n\nThis report shows the user CPU time, system CPU time, the sum of\nthe user and system CPU times, and the elapsed real time. The unit\nof time is seconds.\n\n### Do some experiments sequentially using the `#bm` method:\n\n```\nrequire \"benchmark\"\n\nn = 5000000\nBenchmark.bm do |x|\n  x.report(\"times:\") do\n    n.times do\n      a = \"1\"\n    end\n  end\n  x.report(\"upto:\") do\n    1.upto(n) do\n      a = \"1\"\n    end\n  end\nend\n```\n\nThe result:\n\n```text\n           user     system      total        real\ntimes:   0.010000   0.000000   0.010000 (  0.008976)\nupto:    0.010000   0.000000   0.010000 (  0.010466)\n```\n\nMake sure to always benchmark code by compiling with the `--release` flag.","summary":"<p>The Benchmark module provides methods for benchmarking Crystal code, giving detailed reports on the time taken for each task.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"bm(&block)-instance-method","html_id":"bm(&amp;block)-instance-method","name":"bm","doc":"Main interface of the `Benchmark` module. Yields a `Job` to which\none can report the benchmarks. See the module's description.","summary":"<p>Main interface of the <code><a href=\"Benchmark.html\">Benchmark</a></code> module.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L88","def":{"name":"bm","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if !(flag?(:release)) %}\n      puts \"Warning: benchmarking without the `--release` flag won't yield useful results\"\n    {% end %}\nreport = BM::Job.new\nyield report\nreport.execute\nreport\n"}},{"id":"ips(calculation=5,warmup=2,interactive=STDOUT.tty?,&block)-instance-method","html_id":"ips(calculation=5,warmup=2,interactive=STDOUT.tty?,&amp;block)-instance-method","name":"ips","doc":"Instruction per second interface of the `Benchmark` module. Yields a `Job`\nto which one can report the benchmarks. See the module's description.\n\nThe optional parameters *calculation* and *warmup* set the duration of\nthose stages in seconds. For more detail on these stages see\n`Benchmark::IPS`. When the *interactive* parameter is `true`, results are\ndisplayed and updated as they are calculated, otherwise all at once.","summary":"<p>Instruction per second interface of the <code><a href=\"Benchmark.html\">Benchmark</a></code> module.</p>","abstract":false,"args":[{"name":"calculation","doc":null,"default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","doc":null,"default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","doc":null,"default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"args_string":"(calculation = <span class=\"n\">5</span>, warmup = <span class=\"n\">2</span>, interactive = <span class=\"t\">STDOUT</span>.tty?, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L106","def":{"name":"ips","args":[{"name":"calculation","doc":null,"default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","doc":null,"default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","doc":null,"default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if !(flag?(:release)) %}\n      puts \"Warning: benchmarking without the `--release` flag won't yield useful results\"\n    {% end %}\njob = IPS::Job.new(calculation, warmup, interactive)\nyield job\njob.execute\njob.report\njob\n"}},{"id":"measure(label=&quot;&quot;,&block):BM::Tms-instance-method","html_id":"measure(label=&amp;quot;&amp;quot;,&amp;block):BM::Tms-instance-method","name":"measure","doc":"Returns the time used to execute the given block.","summary":"<p>Returns the time used to execute the given block.</p>","abstract":false,"args":[{"name":"label","doc":null,"default_value":"\"\"","external_name":"label","restriction":""}],"args_string":"(label = <span class=\"s\">&quot;&quot;</span>, &block) : BM::Tms","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L119","def":{"name":"measure","args":[{"name":"label","doc":null,"default_value":"\"\"","external_name":"label","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"BM::Tms","visibility":"Public","body":"t0, r0 = Process.times, Time.monotonic\nyield\nt1, r1 = Process.times, Time.monotonic\nBM::Tms.new(t1.utime - t0.utime, t1.stime - t0.stime, t1.cutime - t0.cutime, t1.cstime - t0.cstime, (r1 - r0).total_seconds, label)\n"}},{"id":"realtime(&block):Time::Span-instance-method","html_id":"realtime(&amp;block):Time::Span-instance-method","name":"realtime","doc":"Returns the elapsed real time used to execute the given block.\n\n```\nBenchmark.realtime { \"a\" * 100_000 } # => 00:00:00.0005840\n```","summary":"<p>Returns the elapsed real time used to execute the given block.</p>","abstract":false,"args":[],"args_string":"(&block) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark.cr#L136","def":{"name":"realtime","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time.measure do\n  yield\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM","path":"Benchmark/BM.html","kind":"module","full_name":"Benchmark::BM","name":"BM","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"benchmark/bm.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM/Job","path":"Benchmark/BM/Job.html","kind":"class","full_name":"Benchmark::BM::Job","name":"Job","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"benchmark/bm.cr","line_number":39,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM","kind":"module","full_name":"Benchmark::BM","name":"BM"},"doc":"Yielded by `Benchmark#bm`, use `#report` to report benchmarks.","summary":"<p>Yielded by <code><a href=\"../../Benchmark.html#bm%28%26block%29-instance-method\">Benchmark#bm</a></code>, use <code><a href=\"../../Benchmark/BM/Job.html#report%28label%3D%26quot%3B%26quot%3B%2C%26block%29-instance-method\">#report</a></code> to report benchmarks.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"report(label=&quot;&quot;,&block)-instance-method","html_id":"report(label=&amp;quot;&amp;quot;,&amp;block)-instance-method","name":"report","doc":"Reports a single benchmark unit.","summary":"<p>Reports a single benchmark unit.</p>","abstract":false,"args":[{"name":"label","doc":null,"default_value":"\" \"","external_name":"label","restriction":""}],"args_string":"(label = <span class=\"s\">&quot; &quot;</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L47","def":{"name":"report","args":[{"name":"label","doc":null,"default_value":"\" \"","external_name":"label","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"if label.size > @label_width\n  @label_width = label.size\nend\n@reports << {label, block}\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM/Tms","path":"Benchmark/BM/Tms.html","kind":"class","full_name":"Benchmark::BM::Tms","name":"Tms","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"benchmark/bm.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM","kind":"module","full_name":"Benchmark::BM","name":"BM"},"doc":"A data object, representing the times associated with a benchmark measurement.","summary":"<p>A data object, representing the times associated with a benchmark measurement.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"cstime:Float64-instance-method","html_id":"cstime:Float64-instance-method","name":"cstime","doc":"System CPU time of children","summary":"<p>System CPU time of children</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L15","def":{"name":"cstime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@cstime"}},{"id":"cutime:Float64-instance-method","html_id":"cutime:Float64-instance-method","name":"cutime","doc":"User CPU time of children","summary":"<p>User CPU time of children</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L12","def":{"name":"cutime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@cutime"}},{"id":"label:String-instance-method","html_id":"label:String-instance-method","name":"label","doc":"The label associated with this measure","summary":"<p>The label associated with this measure</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L21","def":{"name":"label","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@label"}},{"id":"real:Float64-instance-method","html_id":"real:Float64-instance-method","name":"real","doc":"Elapsed real time","summary":"<p>Elapsed real time</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L18","def":{"name":"real","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@real"}},{"id":"stime:Float64-instance-method","html_id":"stime:Float64-instance-method","name":"stime","doc":"System CPU time","summary":"<p>System CPU time</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L9","def":{"name":"stime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@stime"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Prints *utime*, *stime*, *total* and *real* to the given IO.","summary":"<p>Prints <em>utime</em>, <em>stime</em>, <em>total</em> and <em>real</em> to the given IO.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L33","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io.printf(\"  %.6f   %.6f   %.6f (  %.6f)\", utime, stime, total, real)"}},{"id":"total-instance-method","html_id":"total-instance-method","name":"total","doc":"Total time, that is utime + stime + cutime + cstime","summary":"<p>Total time, that is utime + stime + cutime + cstime</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L28","def":{"name":"total","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((utime + stime) + cutime) + cstime"}},{"id":"utime:Float64-instance-method","html_id":"utime:Float64-instance-method","name":"utime","doc":"User CPU time","summary":"<p>User CPU time</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/bm.cr#L6","def":{"name":"utime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@utime"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS","path":"Benchmark/IPS.html","kind":"module","full_name":"Benchmark::IPS","name":"IPS","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"benchmark/ips.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"},"doc":"Benchmark IPS calculates the number of iterations per second for a given\nblock of code. The strategy is to use two stages: a warmup stage and a\ncalculation stage.\n\nThe warmup phase defaults to 2 seconds. During this stage we figure out how\nmany cycles are needed to run the block for roughly 100ms, and record it.\n\nThe calculation defaults to 5 seconds. During this stage we run the block\nin sets of the size calculated in the warmup stage. The measurements for\nthose sets are then used to calculate the mean and standard deviation,\nwhich are then reported. Additionally we compare the means to that of the\nfastest.","summary":"<p>Benchmark IPS calculates the number of iterations per second for a given block of code.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS/Entry","path":"Benchmark/IPS/Entry.html","kind":"class","full_name":"Benchmark::IPS::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"benchmark/ips.cr","line_number":123,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS","kind":"module","full_name":"Benchmark::IPS","name":"IPS"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(label:String,action:->)-class-method","html_id":"new(label:String,action:-&gt;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"label","doc":null,"default_value":"","external_name":"label","restriction":"String"},{"name":"action","doc":null,"default_value":"","external_name":"action","restriction":"(-> )"}],"args_string":"(label : String, action :  -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L158","def":{"name":"new","args":[{"name":"label","doc":null,"default_value":"","external_name":"label","restriction":"String"},{"name":"action","doc":null,"default_value":"","external_name":"action","restriction":"(-> )"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(label, action)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"action:->-instance-method","html_id":"action:-&gt;-instance-method","name":"action","doc":"Code to be benchmarked","summary":"<p>Code to be benchmarked</p>","abstract":false,"args":[],"args_string":" :  -> ","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L128","def":{"name":"action","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"(-> )","visibility":"Public","body":"@action"}},{"id":"action=(action:->)-instance-method","html_id":"action=(action:-&gt;)-instance-method","name":"action=","doc":"Code to be benchmarked","summary":"<p>Code to be benchmarked</p>","abstract":false,"args":[{"name":"action","doc":null,"default_value":"","external_name":"action","restriction":"(-> )"}],"args_string":"(action :  -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L128","def":{"name":"action=","args":[{"name":"action","doc":null,"default_value":"","external_name":"action","restriction":"(-> )"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@action = action"}},{"id":"bytes_per_op-instance-method","html_id":"bytes_per_op-instance-method","name":"bytes_per_op","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"bytes_per_op","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytes_per_op.not_nil!"}},{"id":"bytes_per_op=(bytes_per_op:Int32)-instance-method","html_id":"bytes_per_op=(bytes_per_op:Int32)-instance-method","name":"bytes_per_op=","doc":"Number of bytes allocated per operation","summary":"<p>Number of bytes allocated per operation</p>","abstract":false,"args":[{"name":"bytes_per_op","doc":null,"default_value":"","external_name":"bytes_per_op","restriction":"Int32"}],"args_string":"(bytes_per_op : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L153","def":{"name":"bytes_per_op=","args":[{"name":"bytes_per_op","doc":null,"default_value":"","external_name":"bytes_per_op","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytes_per_op = bytes_per_op"}},{"id":"bytes_per_op?:Int32?-instance-method","html_id":"bytes_per_op?:Int32?-instance-method","name":"bytes_per_op?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32?","source_link":null,"source_link":null,"def":{"name":"bytes_per_op?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytes_per_op"}},{"id":"calculate_stats(samples)-instance-method","html_id":"calculate_stats(samples)-instance-method","name":"calculate_stats","doc":null,"summary":null,"abstract":false,"args":[{"name":"samples","doc":null,"default_value":"","external_name":"samples","restriction":""}],"args_string":"(samples)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L178","def":{"name":"calculate_stats","args":[{"name":"samples","doc":null,"default_value":"","external_name":"samples","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ran = true\n@size = samples.size\n@mean = samples.sum.to_f / size.to_f\n@variance = (samples.reduce(0) do |acc, i|\n  acc + ((i - mean) ** 2)\nend).to_f / size.to_f\n@stddev = Math.sqrt(variance)\n@relative_stddev = 100.0 * (stddev / mean)\n"}},{"id":"call-instance-method","html_id":"call-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L165","def":{"name":"call","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"action.call"}},{"id":"call_for_100ms-instance-method","html_id":"call_for_100ms-instance-method","name":"call_for_100ms","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L169","def":{"name":"call_for_100ms","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cycles.times do\n  action.call\nend"}},{"id":"cycles-instance-method","html_id":"cycles-instance-method","name":"cycles","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"cycles","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cycles.not_nil!"}},{"id":"cycles=(cycles:Int32)-instance-method","html_id":"cycles=(cycles:Int32)-instance-method","name":"cycles=","doc":"Number of cycles needed to run for approx 100ms\nCalculated during the warmup stage","summary":"<p>Number of cycles needed to run for approx 100ms Calculated during the warmup stage</p>","abstract":false,"args":[{"name":"cycles","doc":null,"default_value":"","external_name":"cycles","restriction":"Int32"}],"args_string":"(cycles : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L132","def":{"name":"cycles=","args":[{"name":"cycles","doc":null,"default_value":"","external_name":"cycles","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cycles = cycles"}},{"id":"cycles?:Int32?-instance-method","html_id":"cycles?:Int32?-instance-method","name":"cycles?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32?","source_link":null,"source_link":null,"def":{"name":"cycles?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cycles"}},{"id":"human_compare-instance-method","html_id":"human_compare-instance-method","name":"human_compare","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L227","def":{"name":"human_compare","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if slower == 1.0\n  \"fastest\"\nelse\n  sprintf(\"%5.2f× slower\", slower)\nend"}},{"id":"human_iteration_time-instance-method","html_id":"human_iteration_time-instance-method","name":"human_iteration_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L206","def":{"name":"human_iteration_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"iteration_time = 1.0 / mean\ncase Math.log10(iteration_time)\nwhen 0..Float64::MAX\n  digits = iteration_time\n  suffix = \"s \"\nwhen -3..0\n  digits = iteration_time * 1000\n  suffix = \"ms\"\nwhen -6..-3\n  digits = iteration_time * 1000000\n  suffix = \"µs\"\nelse\n  digits = iteration_time * 1000000000\n  suffix = \"ns\"\nend\n\"#{(digits.round(2)).to_s.rjust(6)}#{suffix}\"\n"}},{"id":"human_mean-instance-method","html_id":"human_mean-instance-method","name":"human_mean","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L187","def":{"name":"human_mean","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case Math.log10(mean)\nwhen Float64::MIN..3\n  digits = mean\n  suffix = ' '\nwhen 3..6\n  digits = mean / 1000\n  suffix = 'k'\nwhen 6..9\n  digits = mean / 1000000\n  suffix = 'M'\nelse\n  digits = mean / 1000000000\n  suffix = 'G'\nend\n\"#{(digits.round(2)).to_s.rjust(6)}#{suffix}\"\n"}},{"id":"label:String-instance-method","html_id":"label:String-instance-method","name":"label","doc":"Label of the benchmark","summary":"<p>Label of the benchmark</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L125","def":{"name":"label","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@label"}},{"id":"label=(label:String)-instance-method","html_id":"label=(label:String)-instance-method","name":"label=","doc":"Label of the benchmark","summary":"<p>Label of the benchmark</p>","abstract":false,"args":[{"name":"label","doc":null,"default_value":"","external_name":"label","restriction":"String"}],"args_string":"(label : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L125","def":{"name":"label=","args":[{"name":"label","doc":null,"default_value":"","external_name":"label","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@label = label"}},{"id":"mean-instance-method","html_id":"mean-instance-method","name":"mean","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"mean","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mean.not_nil!"}},{"id":"mean=(mean:Float64)-instance-method","html_id":"mean=(mean:Float64)-instance-method","name":"mean=","doc":"Statistical mean from calculation stage","summary":"<p>Statistical mean from calculation stage</p>","abstract":false,"args":[{"name":"mean","doc":null,"default_value":"","external_name":"mean","restriction":"Float64"}],"args_string":"(mean : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L138","def":{"name":"mean=","args":[{"name":"mean","doc":null,"default_value":"","external_name":"mean","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mean = mean"}},{"id":"mean?:Float64?-instance-method","html_id":"mean?:Float64?-instance-method","name":"mean?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64?","source_link":null,"source_link":null,"def":{"name":"mean?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mean"}},{"id":"ran?:Bool-instance-method","html_id":"ran?:Bool-instance-method","name":"ran?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L161","def":{"name":"ran?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ran"}},{"id":"relative_stddev-instance-method","html_id":"relative_stddev-instance-method","name":"relative_stddev","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"relative_stddev","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@relative_stddev.not_nil!"}},{"id":"relative_stddev=(relative_stddev:Float64)-instance-method","html_id":"relative_stddev=(relative_stddev:Float64)-instance-method","name":"relative_stddev=","doc":"Relative standard deviation as a percentage","summary":"<p>Relative standard deviation as a percentage</p>","abstract":false,"args":[{"name":"relative_stddev","doc":null,"default_value":"","external_name":"relative_stddev","restriction":"Float64"}],"args_string":"(relative_stddev : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L147","def":{"name":"relative_stddev=","args":[{"name":"relative_stddev","doc":null,"default_value":"","external_name":"relative_stddev","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@relative_stddev = relative_stddev"}},{"id":"relative_stddev?:Float64?-instance-method","html_id":"relative_stddev?:Float64?-instance-method","name":"relative_stddev?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64?","source_link":null,"source_link":null,"def":{"name":"relative_stddev?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@relative_stddev"}},{"id":"set_cycles(duration,iterations)-instance-method","html_id":"set_cycles(duration,iterations)-instance-method","name":"set_cycles","doc":null,"summary":null,"abstract":false,"args":[{"name":"duration","doc":null,"default_value":"","external_name":"duration","restriction":""},{"name":"iterations","doc":null,"default_value":"","external_name":"iterations","restriction":""}],"args_string":"(duration, iterations)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L173","def":{"name":"set_cycles","args":[{"name":"duration","doc":null,"default_value":"","external_name":"duration","restriction":""},{"name":"iterations","doc":null,"default_value":"","external_name":"iterations","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cycles = ((iterations / duration.total_milliseconds) * 100).to_i\nif cycles <= 0\n  @cycles = 1\nend\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size.not_nil!"}},{"id":"size=(size:Int32)-instance-method","html_id":"size=(size:Int32)-instance-method","name":"size=","doc":"Number of 100ms runs during the calculation stage","summary":"<p>Number of 100ms runs during the calculation stage</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int32"}],"args_string":"(size : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L135","def":{"name":"size=","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size = size"}},{"id":"size?:Int32?-instance-method","html_id":"size?:Int32?-instance-method","name":"size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32?","source_link":null,"source_link":null,"def":{"name":"size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size"}},{"id":"slower-instance-method","html_id":"slower-instance-method","name":"slower","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"slower","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@slower.not_nil!"}},{"id":"slower=(slower:Float64)-instance-method","html_id":"slower=(slower:Float64)-instance-method","name":"slower=","doc":"Multiple slower than the fastest entry","summary":"<p>Multiple slower than the fastest entry</p>","abstract":false,"args":[{"name":"slower","doc":null,"default_value":"","external_name":"slower","restriction":"Float64"}],"args_string":"(slower : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L150","def":{"name":"slower=","args":[{"name":"slower","doc":null,"default_value":"","external_name":"slower","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@slower = slower"}},{"id":"slower?:Float64?-instance-method","html_id":"slower?:Float64?-instance-method","name":"slower?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64?","source_link":null,"source_link":null,"def":{"name":"slower?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@slower"}},{"id":"stddev-instance-method","html_id":"stddev-instance-method","name":"stddev","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"stddev","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@stddev.not_nil!"}},{"id":"stddev=(stddev:Float64)-instance-method","html_id":"stddev=(stddev:Float64)-instance-method","name":"stddev=","doc":"Statistical standard deviation from calculation stage","summary":"<p>Statistical standard deviation from calculation stage</p>","abstract":false,"args":[{"name":"stddev","doc":null,"default_value":"","external_name":"stddev","restriction":"Float64"}],"args_string":"(stddev : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L144","def":{"name":"stddev=","args":[{"name":"stddev","doc":null,"default_value":"","external_name":"stddev","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@stddev = stddev"}},{"id":"stddev?:Float64?-instance-method","html_id":"stddev?:Float64?-instance-method","name":"stddev?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64?","source_link":null,"source_link":null,"def":{"name":"stddev?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@stddev"}},{"id":"variance-instance-method","html_id":"variance-instance-method","name":"variance","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"variance","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@variance.not_nil!"}},{"id":"variance=(variance:Float64)-instance-method","html_id":"variance=(variance:Float64)-instance-method","name":"variance=","doc":"Statistical variance from calculation stage","summary":"<p>Statistical variance from calculation stage</p>","abstract":false,"args":[{"name":"variance","doc":null,"default_value":"","external_name":"variance","restriction":"Float64"}],"args_string":"(variance : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L141","def":{"name":"variance=","args":[{"name":"variance","doc":null,"default_value":"","external_name":"variance","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@variance = variance"}},{"id":"variance?:Float64?-instance-method","html_id":"variance?:Float64?-instance-method","name":"variance?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64?","source_link":null,"source_link":null,"def":{"name":"variance?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@variance"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS/Job","path":"Benchmark/IPS/Job.html","kind":"class","full_name":"Benchmark::IPS::Job","name":"Job","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"benchmark/ips.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS","kind":"module","full_name":"Benchmark::IPS","name":"IPS"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(calculation=5,warmup=2,interactive=STDOUT.tty?)-class-method","html_id":"new(calculation=5,warmup=2,interactive=STDOUT.tty?)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"calculation","doc":null,"default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","doc":null,"default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","doc":null,"default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"args_string":"(calculation = <span class=\"n\">5</span>, warmup = <span class=\"n\">2</span>, interactive = <span class=\"t\">STDOUT</span>.tty?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L23","def":{"name":"new","args":[{"name":"calculation","doc":null,"default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","doc":null,"default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","doc":null,"default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(calculation, warmup, interactive)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"execute-instance-method","html_id":"execute-instance-method","name":"execute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L37","def":{"name":"execute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"run_warmup\nrun_calculation\nrun_comparison\n"}},{"id":"items:Array(Entry)-instance-method","html_id":"items:Array(Entry)-instance-method","name":"items","doc":"List of all entries in the benchmark.\nAfter #execute, these are populated with the resulting statistics.","summary":"<p>List of all entries in the benchmark.</p>","abstract":false,"args":[],"args_string":" : Array(Entry)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L18","def":{"name":"items","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Entry)","visibility":"Public","body":"@items"}},{"id":"items=(items:Array(Entry))-instance-method","html_id":"items=(items:Array(Entry))-instance-method","name":"items=","doc":"List of all entries in the benchmark.\nAfter #execute, these are populated with the resulting statistics.","summary":"<p>List of all entries in the benchmark.</p>","abstract":false,"args":[{"name":"items","doc":null,"default_value":"","external_name":"items","restriction":"Array(Entry)"}],"args_string":"(items : Array(Entry))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L18","def":{"name":"items=","args":[{"name":"items","doc":null,"default_value":"","external_name":"items","restriction":"Array(Entry)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@items = items"}},{"id":"report(label=&quot;&quot;,&action)-instance-method","html_id":"report(label=&amp;quot;&amp;quot;,&amp;action)-instance-method","name":"report","doc":"Add code to be benchmarked","summary":"<p>Add code to be benchmarked</p>","abstract":false,"args":[{"name":"label","doc":null,"default_value":"\"\"","external_name":"label","restriction":""}],"args_string":"(label = <span class=\"s\">&quot;&quot;</span>, &action)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L31","def":{"name":"report","args":[{"name":"label","doc":null,"default_value":"\"\"","external_name":"label","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"action","doc":null,"default_value":"","external_name":"action","restriction":""},"return_type":"","visibility":"Public","body":"item = Entry.new(label, action)\n@items << item\nitem\n"}},{"id":"report-instance-method","html_id":"report-instance-method","name":"report","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/benchmark/ips.cr#L43","def":{"name":"report","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"max_label = ran_items.max_of do |__arg0|\n  __arg0.label.size\nend\nmax_compare = ran_items.max_of do |__arg1|\n  __arg1.human_compare.size\nend\nmax_bytes_per_op = ran_items.max_of do |__arg2|\n  __arg2.bytes_per_op.to_s.size\nend\nran_items.each do |item|\n  printf(\"%s %s (%s) (±%5.2f%%)  %s B/op  %s\\n\", item.label.rjust(max_label), item.human_mean, item.human_iteration_time, item.relative_stddev, item.bytes_per_op.to_s.rjust(max_bytes_per_op), item.human_compare.rjust(max_compare))\nend\n"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/BigDecimal","path":"BigDecimal.html","kind":"struct","full_name":"BigDecimal","name":"BigDecimal","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"big.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big.cr"},{"filename":"big/big_decimal.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEFAULT_MAX_DIV_ITERATIONS","name":"DEFAULT_MAX_DIV_ITERATIONS","value":"100_u64","doc":null,"summary":null},{"id":"TEN","name":"TEN","value":"BigInt.new(10)","doc":null,"summary":null},{"id":"ZERO","name":"ZERO","value":"BigInt.new(0)","doc":null,"summary":null}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(value:BigInt,scale:UInt64)-class-method","html_id":"new(value:BigInt,scale:UInt64)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `BigInt` *value* and `UInt64` *scale*,\nwhich matches the internal representation.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"BigInt.html\">BigInt</a></code> <em>value</em> and <code><a href=\"UInt64.html\">UInt64</a></code> <em>scale</em>, which matches the internal representation.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigInt"},{"name":"scale","doc":null,"default_value":"","external_name":"scale","restriction":"UInt64"}],"args_string":"(value : BigInt, scale : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L52","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigInt"},{"name":"scale","doc":null,"default_value":"","external_name":"scale","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(value, scale)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Float)-class-method","html_id":"new(num:Float)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `Float`.\n\nNOTE: Floats are fundamentally less precise than BigDecimals,\nwhich makes initialization from them risky.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"Float.html\">Float</a></code>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"args_string":"(num : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L35","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(num.to_s)"}},{"id":"new(num:BigRational)-class-method","html_id":"new(num:BigRational)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `BigRational`.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"BigRational.html\">BigRational</a></code>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L40","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"num.numerator.to_big_d / num.denominator.to_big_d"}},{"id":"new(num:BigDecimal)-class-method","html_id":"new(num:BigDecimal)-class-method","name":"new","doc":"Returns *num*. Useful for generic code that does `T.new(...)` with `T`\nbeing a `Number`.","summary":"<p>Returns <em>num</em>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigDecimal"}],"args_string":"(num : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L46","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"num"}},{"id":"new(num:Int=0,scale:Int=0)-class-method","html_id":"new(num:Int=0,scale:Int=0)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `Int`.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"Int.html\">Int</a></code>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"0","external_name":"num","restriction":"Int"},{"name":"scale","doc":null,"default_value":"0","external_name":"scale","restriction":"Int"}],"args_string":"(num : Int = <span class=\"n\">0</span>, scale : Int = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L56","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"0","external_name":"num","restriction":"Int"},{"name":"scale","doc":null,"default_value":"0","external_name":"scale","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num, scale)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(str:String)-class-method","html_id":"new(str:String)-class-method","name":"new","doc":"Creates a new `BigDecimal` from a `String`.\n\nAllows only valid number strings with an optional negative sign.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L63","def":{"name":"new","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"*(other:BigDecimal):BigDecimal-instance-method","html_id":"*(other:BigDecimal):BigDecimal-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L180","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(@value * other.value, @scale + other.scale)"}},{"id":"*(other:Int)-instance-method","html_id":"*(other:Int)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L184","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L184","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self * (BigDecimal.new(other))"}},{"id":"+(other:BigDecimal):BigDecimal-instance-method","html_id":"+(other:BigDecimal):BigDecimal-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L148","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"if @scale > other.scale\n  scaled = other.scale_to(self)\n  BigDecimal.new(@value + scaled.value, @scale)\nelse\n  if @scale < other.scale\n    scaled = scale_to(other)\n    BigDecimal.new(scaled.value + other.value, other.scale)\n  else\n    BigDecimal.new(@value + other.value, @scale)\n  end\nend"}},{"id":"+(other:Int)-instance-method","html_id":"+(other:Int)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L160","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self + (BigDecimal.new(other))"}},{"id":"-(other:BigDecimal):BigDecimal-instance-method","html_id":"-(other:BigDecimal):BigDecimal-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L164","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"if @scale > other.scale\n  scaled = other.scale_to(self)\n  BigDecimal.new(@value - scaled.value, @scale)\nelse\n  if @scale < other.scale\n    scaled = scale_to(other)\n    BigDecimal.new(scaled.value - other.value, other.scale)\n  else\n    BigDecimal.new(@value - other.value, @scale)\n  end\nend"}},{"id":"-(other:Int)-instance-method","html_id":"-(other:Int)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L176","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self - (BigDecimal.new(other))"}},{"id":"-:BigDecimal-instance-method","html_id":"-:BigDecimal-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L144","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(-@value, @scale)"}},{"id":"/(other:BigDecimal):BigDecimal-instance-method","html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L188","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"div(other)"}},{"id":"/(other:Int)-instance-method","html_id":"/(other:Int)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L192","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self / (BigDecimal.new(other))"}},{"id":"(other:Int|Float|BigRational)-instance-method","html_id":"(other:Int|Float|BigRational)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int | Float | BigRational"}],"args_string":"(other : Int | Float | BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L236","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int | Float | BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self <=> (BigDecimal.new(other))"}},{"id":"(other:BigDecimal):Int32-instance-method","html_id":"(other:BigDecimal):Int32-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L226","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"if @scale > other.scale\n  @value <=> (other.scale_to(self)).value\nelse\n  if @scale < other.scale\n    (scale_to(other)).value <=> other.value\n  else\n    @value <=> other.value\n  end\nend"}},{"id":"==(other:BigDecimal):Bool-instance-method","html_id":"==(other:BigDecimal):Bool-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L240","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"case @scale\nwhen  > other.scale\n  scaled = other.value * (power_ten_to(@scale - other.scale))\n  @value == scaled\nwhen  < other.scale\n  scaled = @value * (power_ten_to(other.scale - @scale))\n  scaled == other.value\nelse\n  @value == other.value\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L386","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L386","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"div(other:BigDecimal,max_div_iterations=DEFAULT_MAX_DIV_ITERATIONS):BigDecimal-instance-method","html_id":"div(other:BigDecimal,max_div_iterations=DEFAULT_MAX_DIV_ITERATIONS):BigDecimal-instance-method","name":"div","doc":"Divides `self` with another `BigDecimal`, with a optionally configurable *max_div_iterations*, which\ndefines a maximum number of iterations in case the division is not exact.\n\n```\nBigDecimal(1).div(BigDecimal(2))    # => BigDecimal(@value=5, @scale=2)\nBigDecimal(1).div(BigDecimal(3), 5) # => BigDecimal(@value=33333, @scale=5)\n```","summary":"<p>Divides <code>self</code> with another <code><a href=\"BigDecimal.html\">BigDecimal</a></code>, with a optionally configurable <em>max_div_iterations</em>, which defines a maximum number of iterations in case the division is not exact.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"},{"name":"max_div_iterations","doc":null,"default_value":"DEFAULT_MAX_DIV_ITERATIONS","external_name":"max_div_iterations","restriction":""}],"args_string":"(other : BigDecimal, max_div_iterations = <span class=\"t\">DEFAULT_MAX_DIV_ITERATIONS</span>) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L203","def":{"name":"div","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"},{"name":"max_div_iterations","doc":null,"default_value":"DEFAULT_MAX_DIV_ITERATIONS","external_name":"max_div_iterations","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"check_division_by_zero(other)\nscale = @scale - other.scale\nnumerator, denominator = @value, other.@value\nquotient, remainder = numerator.divmod(denominator)\nif remainder == ZERO\n  return BigDecimal.new(normalize_quotient(other, quotient), scale)\nend\nremainder = remainder * TEN\ni = 0\nwhile (remainder != ZERO) && i < max_div_iterations\n  inner_quotient, inner_remainder = remainder.divmod(denominator)\n  quotient = (quotient * TEN) + inner_quotient\n  remainder = inner_remainder * TEN\n  i = i + 1\nend\nBigDecimal.new(normalize_quotient(other, quotient), scale + i)\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L390","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L390","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.string(to_s)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L298","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)\nio << \"_big_d\"\n"}},{"id":"normalize_quotient(other:BigDecimal,quotient:BigInt):BigInt-instance-method","html_id":"normalize_quotient(other:BigDecimal,quotient:BigInt):BigInt-instance-method","name":"normalize_quotient","doc":"Returns the *quotient* as absolutely negative if `self` and *other* have\ndifferent signs, otherwise returns the *quotient*.","summary":"<p>Returns the <em>quotient</em> as absolutely negative if <code>self</code> and <em>other</em> have different signs, otherwise returns the <em>quotient</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"},{"name":"quotient","doc":null,"default_value":"","external_name":"quotient","restriction":"BigInt"}],"args_string":"(other : BigDecimal, quotient : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L396","def":{"name":"normalize_quotient","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"},{"name":"quotient","doc":null,"default_value":"","external_name":"quotient","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if (@value < 0 && other.value > 0) || (other.value < 0 && @value > 0)\n  -quotient.abs\nelse\n  quotient\nend"}},{"id":"scale:UInt64-instance-method","html_id":"scale:UInt64-instance-method","name":"scale","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L29","def":{"name":"scale","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@scale"}},{"id":"scale_to(new_scale:BigDecimal):BigDecimal-instance-method","html_id":"scale_to(new_scale:BigDecimal):BigDecimal-instance-method","name":"scale_to","doc":"Scales a `BigDecimal` to another `BigDecimal`, so they can be\ncomputed easier.","summary":"<p>Scales a <code><a href=\"BigDecimal.html\">BigDecimal</a></code> to another <code><a href=\"BigDecimal.html\">BigDecimal</a></code>, so they can be computed easier.</p>","abstract":false,"args":[{"name":"new_scale","doc":null,"default_value":"","external_name":"new_scale","restriction":"BigDecimal"}],"args_string":"(new_scale : BigDecimal) : BigDecimal","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L255","def":{"name":"scale_to","args":[{"name":"new_scale","doc":null,"default_value":"","external_name":"new_scale","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigDecimal","visibility":"Public","body":"new_scale = new_scale.scale\nif @value == 0\n  BigDecimal.new(0.to_big_i, new_scale)\nelse\n  if @scale > new_scale\n    scale_diff = @scale - new_scale.to_big_i\n    BigDecimal.new(@value / (power_ten_to(scale_diff)), new_scale)\n  else\n    if @scale < new_scale\n      scale_diff = new_scale - @scale.to_big_i\n      BigDecimal.new(@value * (power_ten_to(scale_diff)), new_scale)\n    else\n      self\n    end\n  end\nend\n"}},{"id":"to_big_d-instance-method","html_id":"to_big_d-instance-method","name":"to_big_d","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L303","def":{"name":"to_big_d","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":"Converts to `BigFloat`.","summary":"<p>Converts to <code><a href=\"BigFloat.html\">BigFloat</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L382","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L382","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new(to_s)"}},{"id":"to_f-instance-method","html_id":"to_f-instance-method","name":"to_f","doc":"Converts to `Float64`.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L377","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L377","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":"Converts to `Float32`.","summary":"<p>Converts to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L372","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L372","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64.to_f32"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":"Converts to `Float64`.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L367","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s.to_f64"}},{"id":"to_i-instance-method","html_id":"to_i-instance-method","name":"to_i","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L332","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L332","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32"}},{"id":"to_i16-instance-method","html_id":"to_i16-instance-method","name":"to_i16","doc":"Converts to `Int16`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L322","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L322","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i16"}},{"id":"to_i32-instance-method","html_id":"to_i32-instance-method","name":"to_i32","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L317","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L317","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i32"}},{"id":"to_i64-instance-method","html_id":"to_i64-instance-method","name":"to_i64","doc":"Converts to `Int64`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L308","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @value >= 0\n  (@value / (TEN ** @scale)).to_i64\nelse\n  -(@value.abs / (TEN ** @scale)).to_i64\nend"}},{"id":"to_i8-instance-method","html_id":"to_i8-instance-method","name":"to_i8","doc":"Converts to `Int8`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L327","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L327","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i8"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L271","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"factor_powers_of_ten\ns = @value.to_s\nif @scale == 0\n  io << s\n  return\nend\nif @scale >= s.size && @value >= 0\n  io << \"0.\"\n  (@scale - s.size).times do\n    io << '0'\n  end\n  io << s\nelse\n  if @scale >= s.size && @value < 0\n    io << \"-0.0\"\n    (@scale - s.size).times do\n      io << '0'\n    end\n    io << s[1..-1]\n  else\n    offset = s.size - @scale\n    ((io << s[0...offset]) << '.') << s[offset..-1]\n  end\nend\n"}},{"id":"to_u-instance-method","html_id":"to_u-instance-method","name":"to_u","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L362","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L362","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u32"}},{"id":"to_u16-instance-method","html_id":"to_u16-instance-method","name":"to_u16","doc":"Converts to `UInt16`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.","summary":"<p>Converts to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L350","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L350","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u16"}},{"id":"to_u32-instance-method","html_id":"to_u32-instance-method","name":"to_u32","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L344","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L344","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u32"}},{"id":"to_u64-instance-method","html_id":"to_u64-instance-method","name":"to_u64","doc":"Converts to `UInt64`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.","summary":"<p>Converts to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L338","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L338","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@value.abs / (TEN ** @scale)).to_u64"}},{"id":"to_u8-instance-method","html_id":"to_u8-instance-method","name":"to_u8","doc":"Converts to `UInt8`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.","summary":"<p>Converts to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L356","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u8"}},{"id":"value:BigInt-instance-method","html_id":"value:BigInt-instance-method","name":"value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L28","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"@value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/BigFloat","path":"BigFloat.html","kind":"struct","full_name":"BigFloat","name":"BigFloat","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"big.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big.cr"},{"filename":"big/big_float.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `BigFloat` can represent arbitrarily large floats.\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>A <code><a href=\"BigFloat.html\">BigFloat</a></code> can represent arbitrarily large floats.</p>","class_methods":[{"id":"default_precision-class-method","html_id":"default_precision-class-method","name":"default_precision","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L86","def":{"name":"default_precision","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_get_default_prec"}},{"id":"default_precision=(prec:Int)-class-method","html_id":"default_precision=(prec:Int)-class-method","name":"default_precision=","doc":null,"summary":null,"abstract":false,"args":[{"name":"prec","doc":null,"default_value":"","external_name":"prec","restriction":"Int"}],"args_string":"(prec : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L90","def":{"name":"default_precision=","args":[{"name":"prec","doc":null,"default_value":"","external_name":"prec","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_set_default_prec(prec.to_u64)"}}],"constructors":[{"id":"new(num:Float,precision:Int)-class-method","html_id":"new(num:Float,precision:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"},{"name":"precision","doc":null,"default_value":"","external_name":"precision","restriction":"Int"}],"args_string":"(num : Float, precision : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L69","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"},{"name":"precision","doc":null,"default_value":"","external_name":"precision","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num, precision)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(str:String)-class-method","html_id":"new(str:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L16","def":{"name":"new","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:BigInt)-class-method","html_id":"new(num:BigInt)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigInt"}],"args_string":"(num : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L24","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:BigRational)-class-method","html_id":"new(num:BigRational)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L29","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:BigFloat)-class-method","html_id":"new(num:BigFloat)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigFloat"}],"args_string":"(num : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L34","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Int8|Int16|Int32)-class-method","html_id":"new(num:Int8|Int16|Int32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int8 | Int16 | Int32"}],"args_string":"(num : Int8 | Int16 | Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L39","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int8 | Int16 | Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:UInt8|UInt16|UInt32)-class-method","html_id":"new(num:UInt8|UInt16|UInt32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"UInt8 | UInt16 | UInt32"}],"args_string":"(num : UInt8 | UInt16 | UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L43","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"UInt8 | UInt16 | UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Int64)-class-method","html_id":"new(num:Int64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int64"}],"args_string":"(num : Int64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L47","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:UInt64)-class-method","html_id":"new(num:UInt64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"UInt64"}],"args_string":"(num : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L56","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Number)-class-method","html_id":"new(num:Number)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Number"}],"args_string":"(num : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L65","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(mpf:LibGMP::MPF)-class-method","html_id":"new(mpf:LibGMP::MPF)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"mpf","doc":null,"default_value":"","external_name":"mpf","restriction":"LibGMP::MPF"}],"args_string":"(mpf : LibGMP::MPF)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L74","def":{"name":"new","args":[{"name":"mpf","doc":null,"default_value":"","external_name":"mpf","restriction":"LibGMP::MPF"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(mpf)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L12","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(&block)-class-method","html_id":"new(&amp;block)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L77","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_init(out mpf)\nyield pointerof(mpf)\nnew(mpf)\n"}}],"instance_methods":[{"id":"*(other:Number)-instance-method","html_id":"*(other:Number)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L128","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_mul(mpf, self, other.to_big_f)\nend"}},{"id":"**(other:Int)-instance-method","html_id":"**(other:Int)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L141","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_pow_ui(mpf, self, other.to_u64)\nend"}},{"id":"+(other:Number)-instance-method","html_id":"+(other:Number)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L120","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_add(mpf, self, other.to_big_f)\nend"}},{"id":"-(other:Number)-instance-method","html_id":"-(other:Number)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L124","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_sub(mpf, self, other.to_big_f)\nend"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L116","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_neg(mpf, self)\nend"}},{"id":"/(other:Number)-instance-method","html_id":"/(other:Number)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L132","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other == 0\n  raise(DivisionByZeroError.new)\nend\nif other.is_a?(UInt8 | UInt16 | UInt32) || ((LibGMP::ULong == UInt64) && other.is_a?(UInt64))\n  BigFloat.new do |mpf|\n    LibGMP.mpf_div_ui(mpf, self, other)\n  end\nelse\n  BigFloat.new do |mpf|\n    LibGMP.mpf_div(mpf, self, other.to_big_f)\n  end\nend\n"}},{"id":"(other:BigFloat)-instance-method","html_id":"(other:BigFloat)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L94","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_cmp(self, other)"}},{"id":"(other:BigInt)-instance-method","html_id":"(other:BigInt)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L98","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_cmp_z(self, other)"}},{"id":"(other:Float32|Float64)-instance-method","html_id":"(other:Float32|Float64)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32 | Float64"}],"args_string":"(other : Float32 | Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L102","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32 | Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_cmp_d(self, other.to_f64)"}},{"id":"(other:Number)-instance-method","html_id":"(other:Number)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L106","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other.is_a?(Int8 | Int16 | Int32) || ((LibGMP::Long == Int64) && other.is_a?(Int64))\n  LibGMP.mpf_cmp_si(self, other)\nelse\n  if other.is_a?(UInt8 | UInt16 | UInt32) || ((LibGMP::ULong == UInt64) && other.is_a?(UInt64))\n    LibGMP.mpf_cmp_ui(self, other)\n  else\n    LibGMP.mpf_cmp(self, other.to_big_f)\n  end\nend"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L145","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_abs(mpf, self)\nend"}},{"id":"ceil-instance-method","html_id":"ceil-instance-method","name":"ceil","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L149","def":{"name":"ceil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_ceil(mpf, self)\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L245","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"floor-instance-method","html_id":"floor-instance-method","name":"floor","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L153","def":{"name":"floor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_floor(mpf, self)\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: improve this","summary":"<p><span class=\"flag orange\">TODO</span>  improve this</p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L84","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = to_f64.hash(hasher)\nhasher\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L221","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)\nio << \"_big_f\"\n"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L173","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_f-instance-method","html_id":"to_f-instance-method","name":"to_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L169","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L165","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64.to_f32"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L161","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_get_d(self)"}},{"id":"to_i-instance-method","html_id":"to_i-instance-method","name":"to_i","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L193","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32"}},{"id":"to_i16-instance-method","html_id":"to_i16-instance-method","name":"to_i16","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L185","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i16"}},{"id":"to_i32-instance-method","html_id":"to_i32-instance-method","name":"to_i32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L181","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i32"}},{"id":"to_i64-instance-method","html_id":"to_i64-instance-method","name":"to_i64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L177","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_get_si(self)"}},{"id":"to_i8-instance-method","html_id":"to_i8-instance-method","name":"to_i8","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L189","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i64.to_i8"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L226","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cstr = LibGMP.mpf_get_str(nil, out expptr, 10, 0, self)\nlength = LibC.strlen(cstr)\nif self < 0\n  io << '-'\nend\nif expptr == 0\n  io << 0\nelse\n  if expptr < 0\n    (io << 0) << '.'\n    expptr.abs.times do\n      io << 0\n    end\n  end\nend\nif self < 0\n  expptr = expptr + 1\nend\nlength.times do |i|\n  if cstr[i] == 45\n    next\n  end\n  if i == expptr\n    io << '.'\n  end\n  io << cstr[i].unsafe_chr\nend\nif expptr > 0\n  (expptr - length).times do\n    io << 0\n  end\nend\n"}},{"id":"to_u-instance-method","html_id":"to_u-instance-method","name":"to_u","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L213","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u32"}},{"id":"to_u16-instance-method","html_id":"to_u16-instance-method","name":"to_u16","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L205","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u16"}},{"id":"to_u32-instance-method","html_id":"to_u32-instance-method","name":"to_u32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L201","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u32"}},{"id":"to_u64-instance-method","html_id":"to_u64-instance-method","name":"to_u64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L197","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_get_ui(self)"}},{"id":"to_u8-instance-method","html_id":"to_u8-instance-method","name":"to_u8","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L209","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u64.to_u8"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L217","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"mpf"}},{"id":"trunc-instance-method","html_id":"trunc-instance-method","name":"trunc","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L157","def":{"name":"trunc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_trunc(mpf, self)\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/BigInt","path":"BigInt.html","kind":"struct","full_name":"BigInt","name":"BigInt","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"big.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big.cr"},{"filename":"big/big_int.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `BigInt` can represent arbitrarily large integers.\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>A <code><a href=\"BigInt.html\">BigInt</a></code> can represent arbitrarily large integers.</p>","class_methods":[],"constructors":[{"id":"new(str:String,base=10)-class-method","html_id":"new(str:String,base=10)-class-method","name":"new","doc":"Creates a `BigInt` with the value denoted by *str* in the given *base*.\n\nRaises `ArgumentError` if the string doesn't denote a valid integer.\n\n```\nBigInt.new(\"123456789123456789123456789123456789\") # => 123456789123456789123456789123456789\nBigInt.new(\"1234567890ABCDEF\", base: 16)           # => 1311768467294899695\n```","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> with the value denoted by <em>str</em> in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(str : String, base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L31","def":{"name":"new","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(str, base)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Int::Signed)-class-method","html_id":"new(num:Int::Signed)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int::Signed"}],"args_string":"(num : Int::Signed)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L41","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int::Signed"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Int::Unsigned)-class-method","html_id":"new(num:Int::Unsigned)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int::Unsigned"}],"args_string":"(num : Int::Unsigned)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L50","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int::Unsigned"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Float)-class-method","html_id":"new(num:Float)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"args_string":"(num : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L59","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:BigInt)-class-method","html_id":"new(num:BigInt)-class-method","name":"new","doc":"Returns *num*. Useful for generic code that does `T.new(...)` with `T`\nbeing a `Number`.","summary":"<p>Returns <em>num</em>.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigInt"}],"args_string":"(num : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L65","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"num"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a `BigInt` with the value zero.\n\n```\nrequire \"big\"\nBigInt.new # => 0\n```","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> with the value zero.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L19","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"%(other:Int):BigInt-instance-method","html_id":"%(other:Int):BigInt-instance-method","name":"%","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L200","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nif other < 0\n  -((-self).unsafe_floored_mod(-other))\nelse\n  unsafe_floored_mod(other)\nend\n"}},{"id":"&(other:Int):BigInt-instance-method","html_id":"&amp;(other:Int):BigInt-instance-method","name":"&","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L299","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.and(mpz, self, other.to_big_i)\nend"}},{"id":"*(other:BigInt):BigInt-instance-method","html_id":"*(other:BigInt):BigInt-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L140","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul(mpz, self, other)\nend"}},{"id":"*(other:LibGMP::IntPrimitiveSigned):BigInt-instance-method","html_id":"*(other:LibGMP::IntPrimitiveSigned):BigInt-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitiveSigned"}],"args_string":"(other : LibGMP::IntPrimitiveSigned) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L144","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitiveSigned"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_si(mpz, self, other)\nend"}},{"id":"*(other:LibGMP::IntPrimitiveUnsigned):BigInt-instance-method","html_id":"*(other:LibGMP::IntPrimitiveUnsigned):BigInt-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitiveUnsigned"}],"args_string":"(other : LibGMP::IntPrimitiveUnsigned) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L148","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitiveUnsigned"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_ui(mpz, self, other)\nend"}},{"id":"*(other:Int):BigInt-instance-method","html_id":"*(other:Int):BigInt-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L152","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"self * other.to_big_i"}},{"id":"**(other:Int):BigInt-instance-method","html_id":"**(other:Int):BigInt-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L319","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  raise(ArgumentError.new(\"Negative exponent isn't supported\"))\nend\nBigInt.new do |mpz|\n  LibGMP.pow_ui(mpz, self, other)\nend\n"}},{"id":"+(other:BigInt):BigInt-instance-method","html_id":"+(other:BigInt):BigInt-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L104","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.add(mpz, self, other)\nend"}},{"id":"+(other:Int):BigInt-instance-method","html_id":"+(other:Int):BigInt-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L108","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  self - other.abs\nelse\n  if other <= LibGMP::ULong::MAX\n    BigInt.new do |mpz|\n      LibGMP.add_ui(mpz, self, other)\n    end\n  else\n    self + other.to_big_i\n  end\nend"}},{"id":"-(other:BigInt):BigInt-instance-method","html_id":"-(other:BigInt):BigInt-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L118","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.sub(mpz, self, other)\nend"}},{"id":"-(other:Int):BigInt-instance-method","html_id":"-(other:Int):BigInt-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L122","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  self + other.abs\nelse\n  if other <= LibGMP::ULong::MAX\n    BigInt.new do |mpz|\n      LibGMP.sub_ui(mpz, self, other)\n    end\n  else\n    self - other.to_big_i\n  end\nend"}},{"id":"-:BigInt-instance-method","html_id":"-:BigInt-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L132","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.neg(mpz, self)\nend"}},{"id":"/(other:Int):BigInt-instance-method","html_id":"/(other:Int):BigInt-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L156","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nif other < 0\n  (-self).unsafe_floored_div(-other)\nelse\n  unsafe_floored_div(other)\nend\n"}},{"id":"<<(other:Int):BigInt-instance-method","html_id":"&lt;&lt;(other:Int):BigInt-instance-method","name":"<<","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L315","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L315","def":{"name":"<<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_2exp(mpz, self, other)\nend"}},{"id":"(other:Int::Unsigned)-instance-method","html_id":"(other:Int::Unsigned)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int::Unsigned"}],"args_string":"(other : Int::Unsigned)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L92","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int::Unsigned"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other <= LibC::ULong::MAX\n  LibGMP.cmp_ui(mpz, other)\nelse\n  self <=> (BigInt.new(other))\nend"}},{"id":"(other:Int::Signed)-instance-method","html_id":"(other:Int::Signed)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int::Signed"}],"args_string":"(other : Int::Signed)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L84","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int::Signed"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if LibC::Long::MIN <= other && other <= LibC::Long::MAX\n  LibGMP.cmp_si(mpz, other)\nelse\n  self <=> (BigInt.new(other))\nend"}},{"id":"(other:Float)-instance-method","html_id":"(other:Float)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float"}],"args_string":"(other : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L100","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.cmp_d(mpz, other)"}},{"id":"(other:BigInt)-instance-method","html_id":"(other:BigInt)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L80","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.cmp(mpz, other)"}},{"id":">>(other:Int):BigInt-instance-method","html_id":"&gt;&gt;(other:Int):BigInt-instance-method","name":">>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L311","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L311","def":{"name":">>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_q_2exp(mpz, self, other)\nend"}},{"id":"^(other:Int):BigInt-instance-method","html_id":"^(other:Int):BigInt-instance-method","name":"^","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L307","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L307","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.xor(mpz, self, other.to_big_i)\nend"}},{"id":"abs:BigInt-instance-method","html_id":"abs:BigInt-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L136","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.abs(mpz, self)\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L457","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L457","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"digits:Array(Int32)-instance-method","html_id":"digits:Array(Int32)-instance-method","name":"digits","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L379","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L379","def":{"name":"digits","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Int32)","visibility":"Public","body":"ary = [] of Int32\nself.to_s.each_char do |c|\n  ary << (c - '0')\nend\nary\n"}},{"id":"divmod(number:BigInt)-instance-method","html_id":"divmod(number:BigInt)-instance-method","name":"divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L216","def":{"name":"divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_division_by_zero(number)\nunsafe_floored_divmod(number)\n"}},{"id":"divmod(number:Int::Unsigned)-instance-method","html_id":"divmod(number:Int::Unsigned)-instance-method","name":"divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int::Unsigned"}],"args_string":"(number : Int::Unsigned)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L236","def":{"name":"divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int::Unsigned"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_division_by_zero(number)\nif number <= LibC::ULong::MAX\n  unsafe_floored_divmod(LibGMP::ULong.new(number))\nelse\n  divmod(number.to_big_i)\nend\n"}},{"id":"divmod(number:Int::Signed)-instance-method","html_id":"divmod(number:Int::Signed)-instance-method","name":"divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int::Signed"}],"args_string":"(number : Int::Signed)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L227","def":{"name":"divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int::Signed"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_division_by_zero(number)\nif number > 0 && number <= LibC::Long::MAX\n  unsafe_floored_divmod(LibGMP::ULong.new(number))\nelse\n  divmod(number.to_big_i)\nend\n"}},{"id":"gcd(other:Int):Int-instance-method","html_id":"gcd(other:Int):Int-instance-method","name":"gcd","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L330","def":{"name":"gcd","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"result = LibGMP.gcd_ui(nil, self, other.abs.to_u64)\nresult == 0 ? self : result\n"}},{"id":"gcd(other:BigInt):BigInt-instance-method","html_id":"gcd(other:BigInt):BigInt-instance-method","name":"gcd","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L326","def":{"name":"gcd","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.gcd(mpz, self, other)\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: improve this","summary":"<p><span class=\"flag orange\">TODO</span>  improve this</p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L349","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L349","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = to_u64.hash(hasher)\nhasher\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L343","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)\nio << \"_big_i\"\n"}},{"id":"lcm(other:Int):BigInt-instance-method","html_id":"lcm(other:Int):BigInt-instance-method","name":"lcm","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L339","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L339","def":{"name":"lcm","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.lcm_ui(mpz, self, other.abs.to_u64)\nend"}},{"id":"lcm(other:BigInt):BigInt-instance-method","html_id":"lcm(other:BigInt):BigInt-instance-method","name":"lcm","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L335","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L335","def":{"name":"lcm","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.lcm(mpz, self, other)\nend"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L385","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.popcount(self)"}},{"id":"remainder(other:Int):BigInt-instance-method","html_id":"remainder(other:Int):BigInt-instance-method","name":"remainder","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L210","def":{"name":"remainder","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nunsafe_truncated_mod(other)\n"}},{"id":"tdiv(other:Int):BigInt-instance-method","html_id":"tdiv(other:Int):BigInt-instance-method","name":"tdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L166","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L166","def":{"name":"tdiv","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nunsafe_truncated_div(other)\n"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L453","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L453","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_set_z(mpf, mpz)\nend"}},{"id":"to_big_i-instance-method","html_id":"to_big_i-instance-method","name":"to_big_i","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L449","def":{"name":"to_big_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_f-instance-method","html_id":"to_f-instance-method","name":"to_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L437","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L437","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L441","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L441","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64.to_f32"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L445","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L445","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.get_d(self)"}},{"id":"to_i-instance-method","html_id":"to_i-instance-method","name":"to_i","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L389","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L389","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32"}},{"id":"to_i16-instance-method","html_id":"to_i16-instance-method","name":"to_i16","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L397","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L397","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32.to_i16"}},{"id":"to_i32-instance-method","html_id":"to_i32-instance-method","name":"to_i32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L401","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibGMP.get_si(self)).to_i32"}},{"id":"to_i64-instance-method","html_id":"to_i64-instance-method","name":"to_i64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L405","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibGMP::Long == Int64) || (self <= Int32::MAX && self >= Int32::MIN)\n  (LibGMP.get_si(self)).to_i64\nelse\n  to_s.to_i64\nend"}},{"id":"to_i8-instance-method","html_id":"to_i8-instance-method","name":"to_i8","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L393","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32.to_i8"}},{"id":"to_s(base:Int)-instance-method","html_id":"to_s(base:Int)-instance-method","name":"to_s","doc":"Returns a string containing the representation of big radix base (2 through 36).\n\n```\nBigInt.new(\"123456789101101987654321\").to_s(8)  # => \"32111154373025463465765261\"\nBigInt.new(\"123456789101101987654321\").to_s(16) # => \"1a249b1f61599cd7eab1\"\nBigInt.new(\"123456789101101987654321\").to_s(36) # => \"k3qmt029k48nmpd\"\n```","summary":"<p>Returns a string containing the representation of big radix base (2 through 36).</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"}],"args_string":"(base : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L373","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L373","def":{"name":"to_s","args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 2 <= base && base <= 36\nelse\n  raise(\"Invalid base #{base}\")\nend\ncstr = LibGMP.get_str(nil, base, self)\nString.new(cstr)\n"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Returns a string representation of self.\n\n```\nBigInt.new(\"123456789101101987654321\").to_s # => 123456789101101987654321\n```","summary":"<p>Returns a string representation of self.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L361","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L361","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"str = to_cstr\nio.write_utf8(Slice.new(str, LibC.strlen(str)))\n"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns a string representation of self.\n\n```\nBigInt.new(\"123456789101101987654321\").to_s # => 123456789101101987654321\n```","summary":"<p>Returns a string representation of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L356","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(to_cstr)"}},{"id":"to_u-instance-method","html_id":"to_u-instance-method","name":"to_u","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L413","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L413","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u32"}},{"id":"to_u16-instance-method","html_id":"to_u16-instance-method","name":"to_u16","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L421","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L421","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u32.to_u16"}},{"id":"to_u32-instance-method","html_id":"to_u32-instance-method","name":"to_u32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L425","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L425","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibGMP.get_ui(self)).to_u32"}},{"id":"to_u64-instance-method","html_id":"to_u64-instance-method","name":"to_u64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L429","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L429","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibGMP::ULong == UInt64) || (self <= UInt32::MAX && self >= UInt32::MIN)\n  (LibGMP.get_ui(self)).to_u64\nelse\n  to_s.to_u64\nend"}},{"id":"to_u8-instance-method","html_id":"to_u8-instance-method","name":"to_u8","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L417","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L417","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_u32.to_u8"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L475","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L475","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"mpz"}},{"id":"unsafe_floored_div(other:Int):BigInt-instance-method","html_id":"unsafe_floored_div(other:Int):BigInt-instance-method","name":"unsafe_floored_div","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L176","def":{"name":"unsafe_floored_div","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if (LibGMP::ULong == UInt32) && (other < Int32::MIN || other > UInt32::MAX)\n  unsafe_floored_div(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.fdiv_q_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.fdiv_q_ui(mpz, self, other)\n    end\n  end\nend"}},{"id":"unsafe_floored_div(other:BigInt):BigInt-instance-method","html_id":"unsafe_floored_div(other:BigInt):BigInt-instance-method","name":"unsafe_floored_div","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L172","def":{"name":"unsafe_floored_div","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_q(mpz, self, other)\nend"}},{"id":"unsafe_floored_divmod(number:LibGMP::ULong)-instance-method","html_id":"unsafe_floored_divmod(number:LibGMP::ULong)-instance-method","name":"unsafe_floored_divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"LibGMP::ULong"}],"args_string":"(number : LibGMP::ULong)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L277","def":{"name":"unsafe_floored_divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"LibGMP::ULong"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.fdiv_qr_ui(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"id":"unsafe_floored_divmod(number:BigInt)-instance-method","html_id":"unsafe_floored_divmod(number:BigInt)-instance-method","name":"unsafe_floored_divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L271","def":{"name":"unsafe_floored_divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.fdiv_qr(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"id":"unsafe_floored_mod(other:Int):BigInt-instance-method","html_id":"unsafe_floored_mod(other:Int):BigInt-instance-method","name":"unsafe_floored_mod","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L249","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L249","def":{"name":"unsafe_floored_mod","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if (other < LibGMP::Long::MIN || other > LibGMP::ULong::MAX)\n  unsafe_floored_mod(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.fdiv_r_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.fdiv_r_ui(mpz, self, other)\n    end\n  end\nend"}},{"id":"unsafe_floored_mod(other:BigInt):BigInt-instance-method","html_id":"unsafe_floored_mod(other:BigInt):BigInt-instance-method","name":"unsafe_floored_mod","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L245","def":{"name":"unsafe_floored_mod","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_r(mpz, self, other)\nend"}},{"id":"unsafe_truncated_div(other:Int):BigInt-instance-method","html_id":"unsafe_truncated_div(other:Int):BigInt-instance-method","name":"unsafe_truncated_div","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L190","def":{"name":"unsafe_truncated_div","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if (LibGMP::ULong == UInt32) && (other < Int32::MIN || other > UInt32::MAX)\n  unsafe_truncated_div(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.tdiv_q_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.tdiv_q_ui(mpz, self, other)\n    end\n  end\nend"}},{"id":"unsafe_truncated_div(other:BigInt):BigInt-instance-method","html_id":"unsafe_truncated_div(other:BigInt):BigInt-instance-method","name":"unsafe_truncated_div","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L186","def":{"name":"unsafe_truncated_div","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_q(mpz, self, other)\nend"}},{"id":"unsafe_truncated_divmod(number:LibGMP::ULong)-instance-method","html_id":"unsafe_truncated_divmod(number:LibGMP::ULong)-instance-method","name":"unsafe_truncated_divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"LibGMP::ULong"}],"args_string":"(number : LibGMP::ULong)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L289","def":{"name":"unsafe_truncated_divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"LibGMP::ULong"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.tdiv_qr_ui(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"id":"unsafe_truncated_divmod(number:BigInt)-instance-method","html_id":"unsafe_truncated_divmod(number:BigInt)-instance-method","name":"unsafe_truncated_divmod","doc":null,"summary":null,"abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L283","def":{"name":"unsafe_truncated_divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.tdiv_qr(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"id":"unsafe_truncated_mod(other:Int):BigInt-instance-method","html_id":"unsafe_truncated_mod(other:Int):BigInt-instance-method","name":"unsafe_truncated_mod","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L267","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L267","def":{"name":"unsafe_truncated_mod","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r_ui(mpz, self, other.abs.to_big_i)\nend"}},{"id":"unsafe_truncated_mod(other:LibGMP::IntPrimitive):BigInt-instance-method","html_id":"unsafe_truncated_mod(other:LibGMP::IntPrimitive):BigInt-instance-method","name":"unsafe_truncated_mod","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitive"}],"args_string":"(other : LibGMP::IntPrimitive) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L263","def":{"name":"unsafe_truncated_mod","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"LibGMP::IntPrimitive"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r_ui(mpz, self, other.abs)\nend"}},{"id":"unsafe_truncated_mod(other:BigInt):BigInt-instance-method","html_id":"unsafe_truncated_mod(other:BigInt):BigInt-instance-method","name":"unsafe_truncated_mod","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L259","def":{"name":"unsafe_truncated_mod","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r(mpz, self, other)\nend"}},{"id":"|(other:Int):BigInt-instance-method","html_id":"|(other:Int):BigInt-instance-method","name":"|","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L303","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.ior(mpz, self, other.to_big_i)\nend"}},{"id":"~:BigInt-instance-method","html_id":"~:BigInt-instance-method","name":"~","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L295","def":{"name":"~","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.com(mpz, self)\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/BigRational","path":"BigRational.html","kind":"struct","full_name":"BigRational","name":"BigRational","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"big.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big.cr"},{"filename":"big/big_rational.cr","line_number":19,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr"},{"filename":"big/big_decimal.cr","line_number":470,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Rational numbers are represented as the quotient of arbitrarily large\nnumerators and denominators. Rationals are canonicalized such that the\ndenominator and the numerator have no common factors, and that the\ndenominator is positive. Zero has the unique representation 0/1.\n\n```\nrequire \"big\"\n\nr = BigRational.new(7.to_big_i, 3.to_big_i)\nr.to_s # => \"7/3\"\n\nr = BigRational.new(3, -9)\nr.to_s # => \"-1/3\"\n```\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>Rational numbers are represented as the quotient of arbitrarily large numerators and denominators.</p>","class_methods":[],"constructors":[{"id":"new(numerator:Int,denominator:Int)-class-method","html_id":"new(numerator:Int,denominator:Int)-class-method","name":"new","doc":"Create a new `BigRational`.\n\nIf *denominator* is 0, this will raise an exception.","summary":"<p>Create a new <code><a href=\"BigRational.html\">BigRational</a></code>.</p>","abstract":false,"args":[{"name":"numerator","doc":null,"default_value":"","external_name":"numerator","restriction":"Int"},{"name":"denominator","doc":null,"default_value":"","external_name":"denominator","restriction":"Int"}],"args_string":"(numerator : Int, denominator : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L30","def":{"name":"new","args":[{"name":"numerator","doc":null,"default_value":"","external_name":"numerator","restriction":"Int"},{"name":"denominator","doc":null,"default_value":"","external_name":"denominator","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(numerator, denominator)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Int)-class-method","html_id":"new(num:Int)-class-method","name":"new","doc":"Creates a new `BigRational` with *num* as the numerator and 1 for denominator.","summary":"<p>Creates a new <code><a href=\"BigRational.html\">BigRational</a></code> with <em>num</em> as the numerator and 1 for denominator.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int"}],"args_string":"(num : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L43","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(num:Float)-class-method","html_id":"new(num:Float)-class-method","name":"new","doc":"Creates a exact representation of float as rational.","summary":"<p>Creates a exact representation of float as rational.</p>","abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"args_string":"(num : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L48","def":{"name":"new","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"*(other:BigRational)-instance-method","html_id":"*(other:BigRational)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L113","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_mul(mpq, self, other)\nend"}},{"id":"*(other:Int)-instance-method","html_id":"*(other:Int)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L117","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self * other.to_big_r"}},{"id":"+(other:BigRational)-instance-method","html_id":"+(other:BigRational)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L97","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_add(mpq, self, other)\nend"}},{"id":"+(other:Int)-instance-method","html_id":"+(other:Int)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L101","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self + other.to_big_r"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L148","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_neg(mpq, self)\nend"}},{"id":"-(other:BigRational)-instance-method","html_id":"-(other:BigRational)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L105","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_sub(mpq, self, other)\nend"}},{"id":"-(other:Int)-instance-method","html_id":"-(other:Int)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L109","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self - other.to_big_r"}},{"id":"/(other:Int)-instance-method","html_id":"/(other:Int)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L126","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self / other.to_big_r"}},{"id":"/(other:BigRational)-instance-method","html_id":"/(other:BigRational)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L121","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_division_by_zero(other)\nBigRational.new do |mpq|\n  LibGMP.mpq_div(mpq, self, other)\nend\n"}},{"id":"<<(other:Int)-instance-method","html_id":"&lt;&lt;(other:Int)-instance-method","name":"<<","doc":"Multiplies the rational by (2 ** *other*)\n\n```\nBigRational.new(2, 3) << 2 # => 8/3\n```","summary":"<p>Multiplies the rational by (2 ** <em>other</em>)</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L144","def":{"name":"<<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_mul_2exp(mpq, self, other)\nend"}},{"id":"(other:BigRational)-instance-method","html_id":"(other:BigRational)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L81","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpq_cmp(mpq, other)"}},{"id":"(other:Float32|Float64)-instance-method","html_id":"(other:Float32|Float64)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32 | Float64"}],"args_string":"(other : Float32 | Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L85","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32 | Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self <=> (BigRational.new(other))"}},{"id":"(other:Float)-instance-method","html_id":"(other:Float)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float"}],"args_string":"(other : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L89","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_f <=> other.to_big_f"}},{"id":"(other:Int)-instance-method","html_id":"(other:Int)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L93","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpq_cmp(mpq, other.to_big_r)"}},{"id":"(other:BigDecimal)-instance-method","html_id":"(other:BigDecimal)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L473","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L473","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_d <=> other"}},{"id":">>(other:Int)-instance-method","html_id":"&gt;&gt;(other:Int)-instance-method","name":">>","doc":"Divides the rational by (2 ** *other*)\n\n```\nBigRational.new(2, 3) >> 2 # => 1/6\n```","summary":"<p>Divides the rational by (2 ** <em>other</em>)</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L135","def":{"name":">>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_div_2exp(mpq, self, other)\nend"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L160","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_abs(mpq, self)\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L211","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"denominator-instance-method","html_id":"denominator-instance-method","name":"denominator","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L77","def":{"name":"denominator","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mpq_get_den(mpz, self)\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: improve this","summary":"<p><span class=\"flag orange\">TODO</span>  improve this</p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L165","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = to_f64.hash(hasher)\nhasher\n"}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L203","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L207","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"inv-instance-method","html_id":"inv-instance-method","name":"inv","doc":"Returns a new `BigRational` as 1/r.\n\nThis will raise an exception if rational is 0.","summary":"<p>Returns a new <code><a href=\"BigRational.html\">BigRational</a></code> as 1/r.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L155","def":{"name":"inv","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_division_by_zero(self)\nBigRational.new do |mpq|\n  LibGMP.mpq_inv(mpq, self)\nend\n"}},{"id":"numerator-instance-method","html_id":"numerator-instance-method","name":"numerator","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L73","def":{"name":"numerator","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mpq_get_num(mpz, self)\nend"}},{"id":"to_big_d-instance-method","html_id":"to_big_d-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L478","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L478","def":{"name":"to_big_d","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigDecimal.new(self)"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L180","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_set_q(mpf, mpq)\nend"}},{"id":"to_f-instance-method","html_id":"to_f-instance-method","name":"to_f","doc":"Returns the `Float64` representing this rational.","summary":"<p>Returns the <code><a href=\"Float64.html\">Float64</a></code> representing this rational.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L168","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L168","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L172","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64.to_f32"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L176","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpq_get_d(mpq)"}},{"id":"to_s(io:IO,base=10)-instance-method","html_id":"to_s(io:IO,base=10)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(io : IO, base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L198","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"str = to_cstr(base)\nio.write_utf8(Slice.new(str, LibC.strlen(str)))\n"}},{"id":"to_s(base=10)-instance-method","html_id":"to_s(base=10)-instance-method","name":"to_s","doc":"Returns the string representing this rational.\n\nOptionally takes a radix base (2 through 36).\n\n```\nr = BigRational.new(8243243, 562828882)\nr.to_s     # => \"8243243/562828882\"\nr.to_s(16) # => \"7dc82b/218c1652\"\nr.to_s(36) # => \"4woiz/9b3djm\"\n```","summary":"<p>Returns the string representing this rational.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L194","def":{"name":"to_s","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(to_cstr(base))"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L219","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"mpq"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/BitArray","path":"BitArray.html","kind":"struct","full_name":"BitArray","name":"BitArray","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"bit_array.cr","line_number":20,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"BitArray is an array data structure that compactly stores bits.\n\nBits externally represented as `Bool`s are stored internally as\n`UInt32`s. The total number of bits stored is set at creation and is\nimmutable.\n\n`BitArray` includes all the methods in `Enumerable`.\n\n### Example\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(12) # => \"BitArray[000000000000]\"\nba[2]                 # => false\n0.upto(5) { |i| ba[i * 2] = true }\nba    # => \"BitArray[101010101010]\"\nba[2] # => true\n```","summary":"<p>BitArray is an array data structure that compactly stores bits.</p>","class_methods":[],"constructors":[{"id":"new(size,initial:Bool=false)-class-method","html_id":"new(size,initial:Bool=false)-class-method","name":"new","doc":"Create a new `BitArray` of *size* bits.\n\n*initial* optionally sets the starting value, `true` or `false`, for all bits\nin the array.","summary":"<p>Create a new <code><a href=\"BitArray.html\">BitArray</a></code> of <em>size</em> bits.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""},{"name":"initial","doc":null,"default_value":"false","external_name":"initial","restriction":"Bool"}],"args_string":"(size, initial : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L30","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""},{"name":"initial","doc":null,"default_value":"false","external_name":"initial","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(size, initial)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:BitArray)-instance-method","html_id":"==(other:BitArray)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BitArray"}],"args_string":"(other : BitArray)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L35","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BitArray"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size != other.size\n  return false\nend\nreturn (LibC.memcmp(@bits, other.@bits, malloc_size)) == 0\n"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L43","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"[](start:Int,count:Int)-instance-method","html_id":"[](start:Int,count:Int)-instance-method","name":"[]","doc":"Returns count or less (if there aren't enough) elements starting at the\ngiven start index.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\nba = BitArray.new(5)\nba[0] = true; ba[2] = true; ba[4] = true\nba # => BitArray[10101]\n\nba[-3, 3] # => BitArray[101]\nba[6, 1]  # raise indexError\nba[1, 2]  # => BitArray[01]\nba[5, 1]  # => BitArray[]\n```","summary":"<p>Returns count or less (if there aren't enough) elements starting at the given start index.</p>","abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L111","def":{"name":"[]","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Negative count: #{count}\"))\nend\nif start == size\n  return BitArray.new(0)\nend\nif start < 0\n  start = start + size\nend\nif 0 <= start && start <= size\nelse\n  raise(IndexError.new)\nend\nif count == 0\n  return BitArray.new(0)\nend\ncount = Math.min(count, size - start)\nif size <= 32\n  bits = @bits[0]\n  bits = bits >> start\n  bits = bits & ((1 << count) - 1)\n  (BitArray.new(count)).tap do |ba|\n    (ba.@bits)[0] = bits\n  end\nelse\n  if size <= 64\n    bits = (@bits.as(::Pointer(UInt64)))[0]\n    bits = bits >> start\n    bits = bits & ((1 << count) - 1)\n    if count <= 32\n      (BitArray.new(count)).tap do |ba|\n        (ba.@bits)[0] = bits.to_u32\n      end\n    else\n      (BitArray.new(count)).tap do |ba|\n        ((ba.@bits).as(::Pointer(UInt64)))[0] = bits\n      end\n    end\n  else\n    ba = BitArray.new(count)\n    start_bit_index, start_sub_index = start.divmod(32)\n    end_bit_index = (start + count) / 32\n    i = 0\n    bits = @bits[start_bit_index]\n    while (start_bit_index + i) <= end_bit_index\n      low_bits = bits\n      low_bits = low_bits >> start_sub_index\n      bits = @bits[(start_bit_index + i) + 1]\n      high_bits = bits\n      high_bits = high_bits & ((1 << start_sub_index) - 1)\n      high_bits = high_bits << (32 - start_sub_index)\n      (ba.@bits)[i] = low_bits | high_bits\n      i = i + 1\n    end\n    ba\n  end\nend\n"}},{"id":"[](range:Range(Int,Int))-instance-method","html_id":"[](range:Range(Int,Int))-instance-method","name":"[]","doc":"Returns all elements that are within the given range.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\nba = BitArray.new(5)\nba[0] = true; ba[2] = true; ba[4] = true\nba # => BitArray[10101]\n\nba[1..3]    # => BitArray[010]\nba[4..7]    # => BitArray[1]\nba[6..10]   # raise IndexError\nba[5..10]   # => BitArray[]\nba[-2...-1] # => BitArray[0]\n```","summary":"<p>Returns all elements that are within the given range.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L88","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[*Indexable.range_to_index_and_count(range, size)]"}},{"id":"[]=(index,value:Bool)-instance-method","html_id":"[]=(index,value:Bool)-instance-method","name":"[]=","doc":"Sets the bit at the given *index*.\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to access a bit outside the array's range.\n\n```\nba = BitArray.new(5)\nba[3] = true\n```","summary":"<p>Sets the bit at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"args_string":"(index, value : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L60","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bit_index, sub_index = bit_index_and_sub_index(index)\nif value\n  __temp_73 = bit_index\n  @bits[__temp_73] = @bits[__temp_73] | (1 << sub_index)\nelse\n  __temp_75 = bit_index\n  @bits[__temp_75] = @bits[__temp_75] & (~(1 << sub_index))\nend\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L230","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = size.hash(hasher)\nhasher = to_slice.hash(hasher)\nhasher\n"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Creates a string representation of self.\n\n```\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\n```","summary":"<p>Creates a string representation of self.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L218","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"invert-instance-method","html_id":"invert-instance-method","name":"invert","doc":"Inverts all bits in the array. Falses become `true` and vice versa.\n\n```\nba = BitArray.new(5)\nba[2] = true; ba[3] = true\nba # => BitArray[00110]\nba.invert\nba # => BitArray[11001]\n```","summary":"<p>Inverts all bits in the array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L197","def":{"name":"invert","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"malloc_size.times do |i|\n  @bits[i] = ~@bits[i]\nend"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":"The number of bits the BitArray stores","summary":"<p>The number of bits the BitArray stores</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L24","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Creates a string representation of self.\n\n```\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\n```","summary":"<p>Creates a string representation of self.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L209","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"BitArray[\"\neach do |value|\n  io << (value ? '1' : '0')\nend\nio << ']'\n"}},{"id":"to_slice:Bytes-instance-method","html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns a `Bytes` able to read and write bytes from a buffer.\nThe slice will be long enough to hold all the bits groups in bytes despite the `UInt32` internal representation.\nIt's useful for reading and writing a bit array from a byte buffer directly.","summary":"<p>Returns a <code><a href=\"Bytes.html\">Bytes</a></code> able to read and write bytes from a buffer.</p>","abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L225","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"Slice.new(@bits.as(Pointer(UInt8)), (@size / 8.0).ceil.to_i)"}},{"id":"toggle(index)-instance-method","html_id":"toggle(index)-instance-method","name":"toggle","doc":"Toggles the bit at the given *index*. A false bit becomes a `true` bit, and\nvice versa.\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to access a bit outside the array's range.\n\n```\nba = BitArray.new(5)\nba[3] # => false\nba.toggle(3)\nba[3] # => true\n```","summary":"<p>Toggles the bit at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L183","def":{"name":"toggle","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bit_index, sub_index = bit_index_and_sub_index(index)\n__temp_77 = bit_index\n@bits[__temp_77] = @bits[__temp_77] ^ (1 << sub_index)\n"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bit_array.cr#L47","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bit_index, sub_index = index.divmod(32)\n(@bits[bit_index] & (1 << sub_index)) > 0\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Bool","path":"Bool.html","kind":"struct","full_name":"Bool","name":"Bool","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"bool.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr"},{"filename":"primitives.cr","line_number":61,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"json/to_json.cr","line_number":33,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":83,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Bool has only two possible values: `true` and `false`. They are constructed using these literals:\n\n```\ntrue  # A Bool that is true\nfalse # A Bool that is false\n```","summary":"<p>Bool has only two possible values: <code>true</code> and <code>false</code>.</p>","class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L45","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L65","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pull.read_bool"}}],"instance_methods":[{"id":"!=(other:Bool):Bool-instance-method","html_id":"!=(other:Bool):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L69","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Bool)-instance-method","html_id":"&amp;(other:Bool)-instance-method","name":"&","doc":"Bitwise AND. Returns `true` if this bool and *other* are `true`, otherwise returns `false`.\n\n```\nfalse & false # => false\nfalse & true  # => false\ntrue & false  # => false\ntrue & true   # => true\n```","summary":"<p>Bitwise AND.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L28","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ? other : false"}},{"id":"==(other:Bool):Bool-instance-method","html_id":"==(other:Bool):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L64","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Bool)-instance-method","html_id":"^(other:Bool)-instance-method","name":"^","doc":"Exclusive OR. Returns `true` if this bool is different from *other*, otherwise returns `false`.\n\n```\nfalse ^ false # => false\nfalse ^ true  # => true\ntrue ^ false  # => true\ntrue ^ true   # => false\n```","summary":"<p>Exclusive OR.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L40","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self != other"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L64","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L45","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.bool(self)"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L34","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.bool(self)"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Appends `\"true\"` for `true` and `\"false\"` for `false` to the given IO.","summary":"<p>Appends <code>\"true\"</code> for <code>true</code> and <code>\"false\"</code> for <code>false</code> to the given IO.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L60","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << to_s"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns `\"true\"` for `true` and `\"false\"` for `false`.","summary":"<p>Returns <code>\"true\"</code> for <code>true</code> and <code>\"false\"</code> for <code>false</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L55","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ? \"true\" : \"false\""}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":"Returns `1` for `true` and `0` for `false`.","summary":"<p>Returns <code>1</code> for <code>true</code> and <code>0</code> for <code>false</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L50","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ? 1 : 0"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L84","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(self)"}},{"id":"|(other:Bool)-instance-method","html_id":"|(other:Bool)-instance-method","name":"|","doc":"Bitwise OR. Returns `true` if this bool or *other* is `true`, otherwise returns `false`.\n\n```\nfalse | false # => false\nfalse | true  # => true\ntrue | false  # => true\ntrue | true   # => true\n```","summary":"<p>Bitwise OR.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/bool.cr#L16","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ? true : other"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Box","path":"Box.html","kind":"class","full_name":"Box(T)","name":"Box","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"box.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A Box allows turning any object to a `Void*` and back.\n\nA Box's purpose is passing data to C as a `Void*` and then converting that\nback to the original data type.\n\nFor an example usage, see `Proc`'s explanation about sending Procs to C.","summary":"<p>A Box allows turning any object to a <code>Void*</code> and back.</p>","class_methods":[{"id":"box(object):Pointer(Void)-class-method","html_id":"box(object):Pointer(Void)-class-method","name":"box","doc":"Creates a Box for an object and returns it as a `Void*`.","summary":"<p>Creates a Box for an object and returns it as a <code>Void*</code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object) : Pointer(Void)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L18","def":{"name":"box","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(Void)","visibility":"Public","body":"(new(object)).as(::Pointer(Void))"}},{"id":"unbox(pointer:Pointer(Void)):T-class-method","html_id":"unbox(pointer:Pointer(Void)):T-class-method","name":"unbox","doc":"Unboxes a `Void*` into an object of type `T`. Note that for this you must\nspecify T: `Box(T).unbox(data)`.","summary":"<p>Unboxes a <code>Void*</code> into an object of type <code>T</code>.</p>","abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void)) : T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L24","def":{"name":"unbox","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"T","visibility":"Public","body":"(pointer.as(self)).object"}}],"constructors":[{"id":"new(object:T)-class-method","html_id":"new(object:T)-class-method","name":"new","doc":"Creates a `Box` with the given object.\n\nThis method isn't usually used directly. Instead, `Box.box` is used.","summary":"<p>Creates a <code><a href=\"Box.html\">Box</a></code> with the given object.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L14","def":{"name":"new","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Box(T).allocate\n_.initialize(object)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"object:T-instance-method","html_id":"object:T-instance-method","name":"object","doc":"Returns the original object","summary":"<p>Returns the original object</p>","abstract":false,"args":[],"args_string":" : T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/box.cr#L9","def":{"name":"object","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"T","visibility":"Public","body":"@object"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Bytes","path":"Bytes.html","kind":"alias","full_name":"Bytes","name":"Bytes","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"slice.cr","line_number":554,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"Slice(UInt8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A convenient alias for the most common slice type,\na slice of bytes, used for example in `IO#read` and `IO#write`.","summary":"<p>A convenient alias for the most common slice type, a slice of bytes, used for example in <code><a href=\"IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code> and <code><a href=\"IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel","path":"Channel.html","kind":"class","full_name":"Channel(T)","name":"Channel","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Channel/Buffered","kind":"class","full_name":"Channel::Buffered(T)","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/Channel/Unbuffered","kind":"class","full_name":"Channel::Unbuffered(T)","name":"Unbuffered"}],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"receive_first(channels:Tuple|Array)-class-method","html_id":"receive_first(channels:Tuple|Array)-class-method","name":"receive_first","doc":null,"summary":null,"abstract":false,"args":[{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":"Tuple | Array"}],"args_string":"(channels : Tuple | Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L84","def":{"name":"receive_first","args":[{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":"Tuple | Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self.select(channels.map(&.receive_select_action)))[1]"}},{"id":"receive_first(*channels)-class-method","html_id":"receive_first(*channels)-class-method","name":"receive_first","doc":null,"summary":null,"abstract":false,"args":[{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":""}],"args_string":"(*channels)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L80","def":{"name":"receive_first","args":[{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"receive_first(channels)"}},{"id":"select(ops:Tuple|Array,has_else=false)-class-method","html_id":"select(ops:Tuple|Array,has_else=false)-class-method","name":"select","doc":null,"summary":null,"abstract":false,"args":[{"name":"ops","doc":null,"default_value":"","external_name":"ops","restriction":"Tuple | Array"},{"name":"has_else","doc":null,"default_value":"false","external_name":"has_else","restriction":""}],"args_string":"(ops : Tuple | Array, has_else = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L101","def":{"name":"select","args":[{"name":"ops","doc":null,"default_value":"","external_name":"ops","restriction":"Tuple | Array"},{"name":"has_else","doc":null,"default_value":"false","external_name":"has_else","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"loop do\n  ops.each_with_index do |op, index|\n    if op.ready?\n      result = op.execute\n      return {index, result}\n    end\n  end\n  if has_else\n    return {ops.size, nil}\n  end\n  ops.each(&.wait)\n  Scheduler.reschedule\n  ops.each(&.unwait)\nend"}},{"id":"select(*ops:SelectAction)-class-method","html_id":"select(*ops:SelectAction)-class-method","name":"select","doc":null,"summary":null,"abstract":false,"args":[{"name":"ops","doc":null,"default_value":"","external_name":"ops","restriction":"SelectAction"}],"args_string":"(*ops : SelectAction)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L97","def":{"name":"select","args":[{"name":"ops","doc":null,"default_value":"","external_name":"ops","restriction":"SelectAction"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.select(ops)"}},{"id":"send_first(value,channels:Tuple|Array)-class-method","html_id":"send_first(value,channels:Tuple|Array)-class-method","name":"send_first","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":"Tuple | Array"}],"args_string":"(value, channels : Tuple | Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L92","def":{"name":"send_first","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":"Tuple | Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.select(channels.map(&.send_select_action(value)))\nnil\n"}},{"id":"send_first(value,*channels)-class-method","html_id":"send_first(value,*channels)-class-method","name":"send_first","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":""}],"args_string":"(value, *channels)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L88","def":{"name":"send_first","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"channels","doc":null,"default_value":"","external_name":"channels","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"send_first(value, channels)"}}],"constructors":[{"id":"new(capacity):Channel::Buffered(T)-class-method","html_id":"new(capacity):Channel::Buffered(T)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":""}],"args_string":"(capacity) : Channel::Buffered(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L27","def":{"name":"new","args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Buffered(T)","visibility":"Public","body":"Buffered(T).new(capacity)"}},{"id":"new:Channel::Unbuffered(T)-class-method","html_id":"new:Channel::Unbuffered(T)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Channel::Unbuffered(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L23","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Unbuffered(T)","visibility":"Public","body":"Unbuffered(T).new"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L31","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed = true\nScheduler.enqueue(@senders)\n@senders.clear\nScheduler.enqueue(@receivers)\n@receivers.clear\nnil\n"}},{"id":"closed?-instance-method","html_id":"closed?-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L40","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L52","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L56","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.text(inspect)"}},{"id":"receive-instance-method","html_id":"receive-instance-method","name":"receive","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L44","def":{"name":"receive","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"receive_impl do\n  raise(ClosedError.new)\nend"}},{"id":"receive?-instance-method","html_id":"receive?-instance-method","name":"receive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L48","def":{"name":"receive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"receive_impl do\n  return nil\nend"}},{"id":"receive_select_action-instance-method","html_id":"receive_select_action-instance-method","name":"receive_select_action","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L124","def":{"name":"receive_select_action","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ReceiveAction.new(self)"}},{"id":"send_select_action(value:T)-instance-method","html_id":"send_select_action(value:T)-instance-method","name":"send_select_action","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L120","def":{"name":"send_select_action","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"SendAction.new(self, value)"}},{"id":"unwait_for_receive-instance-method","html_id":"unwait_for_receive-instance-method","name":"unwait_for_receive","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L64","def":{"name":"unwait_for_receive","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@receivers.delete(Fiber.current)"}},{"id":"unwait_for_send-instance-method","html_id":"unwait_for_send-instance-method","name":"unwait_for_send","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L72","def":{"name":"unwait_for_send","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@senders.delete(Fiber.current)"}},{"id":"wait_for_receive-instance-method","html_id":"wait_for_receive-instance-method","name":"wait_for_receive","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L60","def":{"name":"wait_for_receive","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@receivers << Fiber.current"}},{"id":"wait_for_send-instance-method","html_id":"wait_for_send-instance-method","name":"wait_for_send","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L68","def":{"name":"wait_for_send","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@senders << Fiber.current"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Channel/Buffered","path":"Channel/Buffered.html","kind":"class","full_name":"Channel::Buffered(T)","name":"Buffered","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel","name":"Channel"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel","name":"Channel"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":175,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(capacity=32)-class-method","html_id":"new(capacity=32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"32","external_name":"capacity","restriction":""}],"args_string":"(capacity = <span class=\"n\">32</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L176","def":{"name":"new","args":[{"name":"capacity","doc":null,"default_value":"32","external_name":"capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Buffered(T).allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L214","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L214","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@queue.empty?"}},{"id":"full?-instance-method","html_id":"full?-instance-method","name":"full?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L210","def":{"name":"full?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@queue.size >= @capacity"}},{"id":"send(value:T)-instance-method","html_id":"send(value:T)-instance-method","name":"send","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L181","def":{"name":"send","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"while full?\n  raise_if_closed\n  @senders << Fiber.current\n  Scheduler.reschedule\nend\nraise_if_closed\n@queue << value\nScheduler.enqueue(@receivers)\n@receivers.clear\nself\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel/ClosedError","path":"Channel/ClosedError.html","kind":"class","full_name":"Channel::ClosedError","name":"ClosedError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(msg=&quot;Channelisclosed&quot;)-class-method","html_id":"new(msg=&amp;quot;Channelisclosed&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"msg","doc":null,"default_value":"\"Channel is closed\"","external_name":"msg","restriction":""}],"args_string":"(msg = <span class=\"s\">&quot;Channel is closed&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L12","def":{"name":"new","args":[{"name":"msg","doc":null,"default_value":"\"Channel is closed\"","external_name":"msg","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(msg)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel/ReceiveAction","path":"Channel/ReceiveAction.html","kind":"struct","full_name":"Channel::ReceiveAction(C)","name":"ReceiveAction","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Channel/SelectAction","kind":"module","full_name":"Channel::SelectAction","name":"SelectAction"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":128,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Channel/SelectAction","kind":"module","full_name":"Channel::SelectAction","name":"SelectAction"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(channel:C)-class-method","html_id":"new(channel:C)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"channel","doc":null,"default_value":"","external_name":"channel","restriction":"C"}],"args_string":"(channel : C)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L131","def":{"name":"new","args":[{"name":"channel","doc":null,"default_value":"","external_name":"channel","restriction":"C"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = ReceiveAction(C).allocate\n_.initialize(channel)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"execute-instance-method","html_id":"execute-instance-method","name":"execute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L138","def":{"name":"execute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.receive"}},{"id":"ready?-instance-method","html_id":"ready?-instance-method","name":"ready?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L134","def":{"name":"ready?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!@channel.empty?"}},{"id":"unwait-instance-method","html_id":"unwait-instance-method","name":"unwait","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L146","def":{"name":"unwait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.unwait_for_receive"}},{"id":"wait-instance-method","html_id":"wait-instance-method","name":"wait","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L142","def":{"name":"wait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.wait_for_receive"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel/SelectAction","path":"Channel/SelectAction.html","kind":"module","full_name":"Channel::SelectAction","name":"SelectAction","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"concurrent/channel.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Channel/ReceiveAction","kind":"struct","full_name":"Channel::ReceiveAction(C)","name":"ReceiveAction"},{"html_id":"github.com/crystal-lang/crystal/Channel/SendAction","kind":"struct","full_name":"Channel::SendAction(C, T)","name":"SendAction"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"execute-instance-method","html_id":"execute-instance-method","name":"execute","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L6","def":{"name":"execute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"ready?-instance-method","html_id":"ready?-instance-method","name":"ready?","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L5","def":{"name":"ready?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"unwait-instance-method","html_id":"unwait-instance-method","name":"unwait","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L8","def":{"name":"unwait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"wait-instance-method","html_id":"wait-instance-method","name":"wait","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L7","def":{"name":"wait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel/SendAction","path":"Channel/SendAction.html","kind":"struct","full_name":"Channel::SendAction(C, T)","name":"SendAction","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Channel/SelectAction","kind":"module","full_name":"Channel::SelectAction","name":"SelectAction"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":151,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Channel/SelectAction","kind":"module","full_name":"Channel::SelectAction","name":"SelectAction"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(channel:C,value:T)-class-method","html_id":"new(channel:C,value:T)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"channel","doc":null,"default_value":"","external_name":"channel","restriction":"C"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(channel : C, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L154","def":{"name":"new","args":[{"name":"channel","doc":null,"default_value":"","external_name":"channel","restriction":"C"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = SendAction(C, T).allocate\n_.initialize(channel, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"execute-instance-method","html_id":"execute-instance-method","name":"execute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L161","def":{"name":"execute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.send(@value)"}},{"id":"ready?-instance-method","html_id":"ready?-instance-method","name":"ready?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L157","def":{"name":"ready?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!@channel.full?"}},{"id":"unwait-instance-method","html_id":"unwait-instance-method","name":"unwait","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L169","def":{"name":"unwait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.unwait_for_send"}},{"id":"wait-instance-method","html_id":"wait-instance-method","name":"wait","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L165","def":{"name":"wait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@channel.wait_for_send"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Channel/Unbuffered","path":"Channel/Unbuffered.html","kind":"class","full_name":"Channel::Unbuffered(T)","name":"Unbuffered","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel","name":"Channel"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel","name":"Channel"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/channel.cr","line_number":219,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L222","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L222","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Unbuffered(T).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L276","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"super()\nif sender = @sender\n  Scheduler.enqueue(sender)\n  @sender = nil\nend\n"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L268","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(!@has_value) && @senders.empty?"}},{"id":"full?-instance-method","html_id":"full?-instance-method","name":"full?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L272","def":{"name":"full?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@has_value || @receivers.empty?"}},{"id":"send(value:T)-instance-method","html_id":"send(value:T)-instance-method","name":"send","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L228","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/channel.cr#L228","def":{"name":"send","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"while @has_value\n  raise_if_closed\n  @senders << Fiber.current\n  Scheduler.reschedule\nend\nraise_if_closed\n@value = value\n@has_value = true\n@sender = Fiber.current\nif receiver = @receivers.shift?\n  receiver.resume\nelse\n  Scheduler.reschedule\nend\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Char","path":"Char.html","kind":"struct","full_name":"Char","name":"Char","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"char.cr","line_number":49,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr"},{"filename":"char/reader.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr"},{"filename":"primitives.cr","line_number":73,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"1114111.unsafe_chr","doc":"The maximum character.","summary":"<p>The maximum character.</p>"},{"id":"MAX_CODEPOINT","name":"MAX_CODEPOINT","value":"1114111","doc":"The maximum valid codepoint for a character.","summary":"<p>The maximum valid codepoint for a character.</p>"},{"id":"REPLACEMENT","name":"REPLACEMENT","value":"'�'","doc":"The replacement character, used on invalid utf-8 byte sequences","summary":"<p>The replacement character, used on invalid utf-8 byte sequences</p>"},{"id":"ZERO","name":"ZERO","value":"'\\u{0}'","doc":"The character representing the end of a C string.","summary":"<p>The character representing the end of a C string.</p>"}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Char` represents a [Unicode](http://en.wikipedia.org/wiki/Unicode) [code point](http://en.wikipedia.org/wiki/Code_point).\nIt occupies 32 bits.\n\nIt is created by enclosing an UTF-8 character in single quotes.\n\n```\n'a'\n'z'\n'0'\n'_'\n'あ'\n```\n\nYou can use a backslash to denote some characters:\n\n```\n'\\'' # single quote\n'\\\\' # backslash\n'\\e' # escape\n'\\f' # form feed\n'\\n' # newline\n'\\r' # carriage return\n'\\t' # tab\n'\\v' # vertical tab\n```\n\nYou can use a backslash followed by at most three digits to denote a code point written in octal:\n\n```\n'\\101' # == 'A'\n'\\123' # == 'S'\n'\\12'  # == '\\n'\n'\\1'   # code point 1\n```\n\nYou can use a backslash followed by an *u* and four hexadecimal characters to denote a unicode codepoint written:\n\n```\n'\\u0041' # == 'A'\n```\n\nOr you can use curly braces and specify up to four hexadecimal numbers:\n\n```\n'\\u{41}' # == 'A'\n```","summary":"<p>A <code><a href=\"Char.html\">Char</a></code> represents a <a href=\"http://en.wikipedia.org/wiki/Unicode\" target=\"_blank\">Unicode</a> <a href=\"http://en.wikipedia.org/wiki/Code_point\" target=\"_blank\">code point</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"!=(other:Char):Bool-instance-method","html_id":"!=(other:Char):Bool-instance-method","name":"!=","doc":"Returns `true` if `self`'s codepoint is not equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is not equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"+(str:String)-instance-method","html_id":"+(str:String)-instance-method","name":"+","doc":"Concatenates this char and *string*.\n\n```\n'f' + \"oo\" # => \"foo\"\n```","summary":"<p>Concatenates this char and <em>string</em>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L80","def":{"name":"+","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = str.bytesize + self.bytesize\nString.new(bytesize) do |buffer|\n  count = 0\n  each_byte do |byte|\n    buffer[count] = byte\n    count = count + 1\n  end\n  (buffer + count).copy_from(str.to_unsafe, str.bytesize)\n  {bytesize, str.size + 1}\nend\n"}},{"id":"+(other:Int):Char-instance-method","html_id":"+(other:Int):Char-instance-method","name":"+","doc":"Returns a char that has this char's codepoint plus *other*.\n\n```\n'a' + 1 # => 'b'\n'a' + 2 # => 'c'\n```","summary":"<p>Returns a char that has this char's codepoint plus <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L101","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"(ord + other).chr"}},{"id":"-(other:Char)-instance-method","html_id":"-(other:Char)-instance-method","name":"-","doc":"Returns the difference of the codepoint values of this char and *other*.\n\n```\n'a' - 'a' # => 0\n'b' - 'a' # => 1\n'c' - 'a' # => 2\n```","summary":"<p>Returns the difference of the codepoint values of this char and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L71","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ord - other.ord"}},{"id":"-(other:Int):Char-instance-method","html_id":"-(other:Int):Char-instance-method","name":"-","doc":"Returns a char that has this char's codepoint minus *other*.\n\n```\n'c' - 1 # => 'b'\n'c' - 2 # => 'a'\n```","summary":"<p>Returns a char that has this char's codepoint minus <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L111","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"(ord - other).chr"}},{"id":"<(other:Char):Bool-instance-method","html_id":"&lt;(other:Char):Bool-instance-method","name":"<","doc":"Returns `true` if `self`'s codepoint is less than *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is less than <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Char):Bool-instance-method","html_id":"&lt;=(other:Char):Bool-instance-method","name":"<=","doc":"Returns `true` if `self`'s codepoint is less than or equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is less than or equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"(other:Char)-instance-method","html_id":"(other:Char)-instance-method","name":"<=>","doc":"Implements the comparison operator.\n\n```\n'a' <=> 'c' # => -2\n```","summary":"<p>Implements the comparison operator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L120","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self - other"}},{"id":"==(other:Char):Bool-instance-method","html_id":"==(other:Char):Bool-instance-method","name":"==","doc":"Returns `true` if `self`'s codepoint is equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"===(byte:Int)-instance-method","html_id":"===(byte:Int)-instance-method","name":"===","doc":"Returns `true` if the codepoint is equal to *byte* ignoring the type.\n\n```\n'c'.ord       # => 99\n'c' === 99_u8 # => true\n'c' === 99    # => true\n'z' === 99    # => false\n```","summary":"<p>Returns <code>true</code> if the codepoint is equal to <em>byte</em> ignoring the type.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"Int"}],"args_string":"(byte : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L797","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L797","def":{"name":"===","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ord === byte"}},{"id":">(other:Char):Bool-instance-method","html_id":"&gt;(other:Char):Bool-instance-method","name":">","doc":"Returns `true` if `self`'s codepoint is greater than *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is greater than <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Char):Bool-instance-method","html_id":"&gt;=(other:Char):Bool-instance-method","name":">=","doc":"Returns `true` if `self`'s codepoint is greater than or equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is greater than or equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L93","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"alphanumeric?-instance-method","html_id":"alphanumeric?-instance-method","name":"alphanumeric?","doc":"Returns `true` if this char is a letter or a number according to unicode.\n\n```\n'c'.alphanumeric? # => true\n'8'.alphanumeric? # => true\n'.'.alphanumeric? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a letter or a number according to unicode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L241","def":{"name":"alphanumeric?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"letter? || number?"}},{"id":"ascii?-instance-method","html_id":"ascii?-instance-method","name":"ascii?","doc":"Returns `true` if this char is an ASCII character\n(codepoint is in (0..127))","summary":"<p>Returns <code>true</code> if this char is an ASCII character (codepoint is in (0..127))</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L126","def":{"name":"ascii?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ord < 128"}},{"id":"ascii_alphanumeric?-instance-method","html_id":"ascii_alphanumeric?-instance-method","name":"ascii_alphanumeric?","doc":"Returns `true` if this char is an ASCII letter or number ('0' to '9', 'a' to 'z', 'A' to 'Z').\n\n```\n'c'.ascii_alphanumeric? # => true\n'8'.ascii_alphanumeric? # => true\n'.'.ascii_alphanumeric? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII letter or number ('0' to '9', 'a' to 'z', 'A' to 'Z').</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L230","def":{"name":"ascii_alphanumeric?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii_letter? || ascii_number?"}},{"id":"ascii_control?-instance-method","html_id":"ascii_control?-instance-method","name":"ascii_control?","doc":"Returns `true` if this char is an ASCII control character.\n\n```\n('\\u0000'..'\\u0019').each do |char|\n  char.control? # => true\nend\n\n('\\u007F'..'\\u009F').each do |char|\n  char.control? # => true\nend\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII control character.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L455","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L455","def":{"name":"ascii_control?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ord < 32 || (127 <= (__temp_18 = ord) && __temp_18 <= 159)"}},{"id":"ascii_letter?-instance-method","html_id":"ascii_letter?-instance-method","name":"ascii_letter?","doc":"Returns `true` if this char is an ASCII letter ('a' to 'z', 'A' to 'Z').\n\n```\n'c'.ascii_letter? # => true\n'á'.ascii_letter? # => false\n'8'.ascii_letter? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII letter ('a' to 'z', 'A' to 'Z').</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L208","def":{"name":"ascii_letter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii_lowercase? || ascii_uppercase?"}},{"id":"ascii_lowercase?-instance-method","html_id":"ascii_lowercase?-instance-method","name":"ascii_lowercase?","doc":"Returns `true` if this char is a lowercase ASCII letter.\n\n```\n'c'.ascii_lowercase? # => true\n'ç'.lowercase?       # => true\n'G'.ascii_lowercase? # => false\n'.'.ascii_lowercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a lowercase ASCII letter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L161","def":{"name":"ascii_lowercase?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"'a' <= self && self <= 'z'"}},{"id":"ascii_number?(base:Int=10)-instance-method","html_id":"ascii_number?(base:Int=10)-instance-method","name":"ascii_number?","doc":"Returns `true` if this char is an ASCII number in specified base.\n\nBase can be from 0 to 36 with digits from '0' to '9' and 'a' to 'z' or 'A' to 'Z'.\n\n```\n'4'.ascii_number?     # => true\n'z'.ascii_number?     # => false\n'z'.ascii_number?(36) # => true\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII number in specified base.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L139","def":{"name":"ascii_number?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(!(to_i?(base)))"}},{"id":"ascii_uppercase?-instance-method","html_id":"ascii_uppercase?-instance-method","name":"ascii_uppercase?","doc":"Returns `true` if this char is an ASCII uppercase letter.\n\n```\n'H'.ascii_uppercase? # => true\n'Á'.ascii_uppercase? # => false\n'c'.ascii_uppercase? # => false\n'.'.ascii_uppercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII uppercase letter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L185","def":{"name":"ascii_uppercase?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"'A' <= self && self <= 'Z'"}},{"id":"ascii_whitespace?-instance-method","html_id":"ascii_whitespace?-instance-method","name":"ascii_whitespace?","doc":"Returns `true` if this char is an ASCII whitespace.\n\n```\n' '.ascii_whitespace?  # => true\n'\\t'.ascii_whitespace? # => true\n'b'.ascii_whitespace?  # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII whitespace.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L252","def":{"name":"ascii_whitespace?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self == ' ') || (9 <= (__temp_17 = ord) && __temp_17 <= 13)"}},{"id":"bytes-instance-method","html_id":"bytes-instance-method","name":"bytes","doc":"Returns this char bytes as encoded by UTF-8, as an `Array(UInt8)`.\n\n```\n'a'.bytes # => [97]\n'あ'.bytes # => [227, 129, 130]\n```","summary":"<p>Returns this char bytes as encoded by UTF-8, as an <code><a href=\"Array.html\">Array</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L743","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L743","def":{"name":"bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytes = [] of UInt8\neach_byte do |byte|\n  bytes << byte\nend\nbytes\n"}},{"id":"bytesize-instance-method","html_id":"bytesize-instance-method","name":"bytesize","doc":"Returns the number of UTF-8 bytes in this char.\n\n```\n'a'.bytesize # => 1\n'好'.bytesize # => 3\n```","summary":"<p>Returns the number of UTF-8 bytes in this char.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L716","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L716","def":{"name":"bytesize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"c = ord\nif c < 128\n  1\nelse\n  if c <= 2047\n    2\n  else\n    if c <= 65535\n      3\n    else\n      if c <= MAX_CODEPOINT\n        4\n      else\n        raise(InvalidByteSequenceError.new(\"Invalid char value #{dump}\"))\n      end\n    end\n  end\nend\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L801","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"control?-instance-method","html_id":"control?-instance-method","name":"control?","doc":"Returns `true` if this char is a control character according to unicode.","summary":"<p>Returns <code>true</code> if this char is a control character according to unicode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L460","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L460","def":{"name":"control?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_control? : Unicode.control?(self)"}},{"id":"downcase(options=Unicode::CaseOptions::None)-instance-method","html_id":"downcase(options=Unicode::CaseOptions::None)-instance-method","name":"downcase","doc":"Returns the downcase equivalent of this char.\n\nNote that this only works for characters whose downcase\nequivalent yields a single codepoint. There are a few\ncharacters, like 'İ', than when downcased result in multiple\ncharacters (in this case: 'I' and the dot mark).\n\nFor a more correct method see the method that receives a block.\n\n```\n'Z'.downcase # => 'z'\n'x'.downcase # => 'x'\n'.'.downcase # => '.'\n```","summary":"<p>Returns the downcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L372","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L372","def":{"name":"downcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Unicode.downcase(self, options)"}},{"id":"downcase(options=Unicode::CaseOptions::None,&block)-instance-method","html_id":"downcase(options=Unicode::CaseOptions::None,&amp;block)-instance-method","name":"downcase","doc":"Yields each char for the downcase equivalent of this char.\n\nThis method takes into account the possibility that an downcase\nversion of a char might result in multiple chars, like for\n'İ', which results in 'i' and a dot mark.","summary":"<p>Yields each char for the downcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L381","def":{"name":"downcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"Unicode.downcase(self, options) do |char|\n  yield char\nend"}},{"id":"dump-instance-method","html_id":"dump-instance-method","name":"dump","doc":"Returns this char as a string that contains a char literal as written in Crystal,\nwith characters with a codepoint greater than `0x79` written as `\\u{...}`.\n\n```\n'a'.dump      # => \"'a'\"\n'\\t'.dump     # => \"'\\\\t'\"\n'あ'.dump      # => \"'\\\\u{3042}'\"\n'\\u0012'.dump # => \"'\\\\u{12}'\"\n```","summary":"<p>Returns this char as a string that contains a char literal as written in Crystal, with characters with a codepoint greater than <code>0x79</code> written as <code>\\u{...}</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L505","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L505","def":{"name":"dump","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dump_or_inspect do |io|\n  if ascii_control? || ord >= 128\n    io << \"\\\\u{\"\n    ord.to_s(16, io)\n    io << '}'\n  else\n    to_s(io)\n  end\nend"}},{"id":"dump(io)-instance-method","html_id":"dump(io)-instance-method","name":"dump","doc":"Appends this char as a string that contains a char literal to the given `IO`.\n\nSee also: `#dump`.","summary":"<p>Appends this char as a string that contains a char literal to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L520","def":{"name":"dump","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '\\''\nio << dump\nio << '\\''\n"}},{"id":"each_byte(&block):Nil-instance-method","html_id":"each_byte(&amp;block):Nil-instance-method","name":"each_byte","doc":"Yields each of the bytes of this char as encoded by UTF-8.\n\n```\nputs \"'a'\"\n'a'.each_byte do |byte|\n  puts byte\nend\nputs\n\nputs \"'あ'\"\n'あ'.each_byte do |byte|\n  puts byte\nend\n```\n\nOutput:\n\n```text\n'a'\n97\n\n'あ'\n227\n129\n130\n```","summary":"<p>Yields each of the bytes of this char as encoded by UTF-8.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L683","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L683","def":{"name":"each_byte","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"c = ord\nif c < 128\n  yield c.to_u8\nelse\n  if c <= 2047\n    yield (192 | (c >> 6)).to_u8\n    yield (128 | (c & 63)).to_u8\n  else\n    if c <= 65535\n      yield (224 | (c >> 12)).to_u8\n      yield (128 | ((c >> 6) & 63)).to_u8\n      yield (128 | (c & 63)).to_u8\n    else\n      if c <= MAX_CODEPOINT\n        yield (240 | (c >> 18)).to_u8\n        yield (128 | ((c >> 12) & 63)).to_u8\n        yield (128 | ((c >> 6) & 63)).to_u8\n        yield (128 | (c & 63)).to_u8\n      else\n        raise(InvalidByteSequenceError.new(\"Invalid char value #{dump}\"))\n      end\n    end\n  end\nend\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L418","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L418","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.char(self)"}},{"id":"hex?-instance-method","html_id":"hex?-instance-method","name":"hex?","doc":"Returns `true` if this char is an ASCII hex digit ('0' to '9', 'a' to 'f', 'A' to 'F').\n\n```\n'5'.hex? # => true\n'a'.hex? # => true\n'F'.hex? # => true\n'g'.hex? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII hex digit ('0' to '9', 'a' to 'f', 'A' to 'F').</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L275","def":{"name":"hex?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii_number?(16)"}},{"id":"in_set?(*sets:String)-instance-method","html_id":"in_set?(*sets:String)-instance-method","name":"in_set?","doc":"Returns `true` if this char is matched by the given *sets*.\n\nEach parameter defines a set, the character is matched against\nthe intersection of those, in other words it needs to\nmatch all sets.\n\nIf a set starts with a ^, it is negated. The sequence c1-c2\nmeans all characters between and including c1 and c2\nand is known as a range.\n\nThe backslash character \\ can be used to escape ^ or - and\nis otherwise ignored unless it appears at the end of a range\nor set.\n\n```\n'l'.in_set? \"lo\"          # => true\n'l'.in_set? \"lo\", \"o\"     # => false\n'l'.in_set? \"hello\", \"^l\" # => false\n'l'.in_set? \"j-m\"         # => true\n\n'^'.in_set? \"\\\\^aeiou\" # => true\n'-'.in_set? \"a\\\\-eo\"   # => true\n\n'\\\\'.in_set? \"\\\\\"    # => true\n'\\\\'.in_set? \"\\\\A\"   # => false\n'\\\\'.in_set? \"X-\\\\w\" # => true\n```","summary":"<p>Returns <code>true</code> if this char is matched by the given <em>sets</em>.</p>","abstract":false,"args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":"String"}],"args_string":"(*sets : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L306","def":{"name":"in_set?","args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":"String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if sets.size > 1\n  return sets.all? do |set|\n    in_set?(set)\n  end\nend\nset = sets.first\nnot_negated = true\nrange = false\nprevious = nil\nset.each_char do |char|\n  case char\n  when '^'\n    if previous\n    else\n      not_negated = false\n      previous = char\n      next\n    end\n  when '-'\n    if previous && (previous != '\\\\')\n      range = true\n      if previous == '^'\n        previous = '^'\n        not_negated = true\n      end\n      next\n    else\n      if self == char\n        return not_negated\n      end\n    end\n  end\n  if range && previous\n    if previous > char\n      raise(ArgumentError.new(\"Invalid range #{previous}-#{char}\"))\n    end\n    if previous <= self && self <= char\n      return not_negated\n    end\n    range = false\n  else\n    if char != '\\\\'\n      if self == char\n        return not_negated\n      end\n    end\n  end\n  previous = char\nend\nif range && (self == '-')\n  return not_negated\nend\nif (previous == '\\\\') && (self == previous)\n  return not_negated\nend\n!not_negated\n"}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":"Returns this char as a string that contains a char literal.\n\n```\n'a'.inspect      # => \"'a'\"\n'\\t'.inspect     # => \"'\\\\t'\"\n'あ'.inspect      # => \"'あ'\"\n'\\u0012'.inspect # => \"'\\\\u{12}'\"\n```","summary":"<p>Returns this char as a string that contains a char literal.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L477","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L477","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dump_or_inspect do |io|\n  if ascii_control?\n    io << \"\\\\u{\"\n    ord.to_s(16, io)\n    io << '}'\n  else\n    to_s(io)\n  end\nend"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":"Appends this char as a string that contains a char literal to the given `IO`.\n\nSee also: `#inspect`.","summary":"<p>Appends this char as a string that contains a char literal to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L492","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L492","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << inspect"}},{"id":"letter?-instance-method","html_id":"letter?-instance-method","name":"letter?","doc":"Returns `true` if this char is a letter.\n\n```\n'c'.letter? # => true\n'á'.letter? # => true\n'8'.letter? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a letter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L219","def":{"name":"letter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_letter? : Unicode.letter?(self)"}},{"id":"lowercase?-instance-method","html_id":"lowercase?-instance-method","name":"lowercase?","doc":"Returns `true` if this char is a lowercase letter.\n\n```\n'c'.lowercase? # => true\n'ç'.lowercase? # => true\n'G'.lowercase? # => false\n'.'.lowercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a lowercase letter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L173","def":{"name":"lowercase?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_lowercase? : Unicode.lowercase?(self)"}},{"id":"mark?-instance-method","html_id":"mark?-instance-method","name":"mark?","doc":"Returns `true` if this is char is a mark character according to unicode.","summary":"<p>Returns <code>true</code> if this is char is a mark character according to unicode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L465","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L465","def":{"name":"mark?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Unicode.mark?(self)"}},{"id":"number?-instance-method","html_id":"number?-instance-method","name":"number?","doc":"Returns `true` if this char is a number according to unicode.\n\n```\n'1'.number? # => true\n'a'.number? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a number according to unicode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L149","def":{"name":"number?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_number? : Unicode.number?(self)"}},{"id":"ord:Int32-instance-method","html_id":"ord:Int32-instance-method","name":"ord","doc":"Returns the codepoint of this char.\n\nThe codepoint is the integer representation.\nThe Universal Coded Character Set (UCS) standard, commonly known as Unicode,\nassigns names and meanings to numbers, these numbers are called codepoints.\n\nFor values below and including 127 this matches the ASCII codes\nand thus its byte representation.\n\n```\n'a'.ord      # => 97\n'\\0'.ord     # => 0\n'\\u007f'.ord # => 127\n'☃'.ord      # => 9731\n```","summary":"<p>Returns the codepoint of this char.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L90","def":{"name":"ord","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"pred-instance-method","html_id":"pred-instance-method","name":"pred","doc":"Returns a Char that is one codepoint smaller than this char's codepoint.\n\n```\n'b'.pred # => 'a'\n'ぃ'.pred # => 'あ'\n```","summary":"<p>Returns a Char that is one codepoint smaller than this char's codepoint.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L440","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L440","def":{"name":"pred","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(ord - 1).chr"}},{"id":"succ-instance-method","html_id":"succ-instance-method","name":"succ","doc":"Returns a Char that is one codepoint bigger than this char's codepoint.\n\n```\n'a'.succ # => 'b'\n'あ'.succ # => 'ぃ'\n```\n\nThis method allows creating a `Range` of chars.","summary":"<p>Returns a Char that is one codepoint bigger than this char's codepoint.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L430","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L430","def":{"name":"succ","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(ord + 1).chr"}},{"id":"to_f-instance-method","html_id":"to_f-instance-method","name":"to_f","doc":"Returns the integer value of this char as a float if it's an ASCII char denoting a digit,\nraises otherwise.\n\n```\n'1'.to_i # => 1.0\n'8'.to_i # => 8.0\n'c'.to_i # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char as a float if it's an ASCII char denoting a digit, raises otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L621","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L621","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":"See also: `to_f`.","summary":"<p>See also: <code><a href=\"Char.html#to_f-instance-method\">#to_f</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L638","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L638","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i.to_f32"}},{"id":"to_f32?-instance-method","html_id":"to_f32?-instance-method","name":"to_f32?","doc":"See also: `to_f?`.","summary":"<p>See also: <code><a href=\"Char.html#to_f%3F-instance-method\">#to_f?</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L643","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L643","def":{"name":"to_f32?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i?.try(&.to_f32)"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":"Same as `to_f`.","summary":"<p>Same as <code><a href=\"Char.html#to_f-instance-method\">#to_f</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L648","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L648","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i.to_f64"}},{"id":"to_f64?-instance-method","html_id":"to_f64?-instance-method","name":"to_f64?","doc":"Same as `to_f?`.","summary":"<p>Same as <code><a href=\"Char.html#to_f%3F-instance-method\">#to_f?</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L653","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L653","def":{"name":"to_f64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i?.try(&.to_f64)"}},{"id":"to_f?-instance-method","html_id":"to_f?-instance-method","name":"to_f?","doc":"Returns the integer value of this char as a float if it's an ASCII char denoting a digit,\n`nil` otherwise.\n\n```\n'1'.to_i # => 1.0\n'8'.to_i # => 8.0\n'c'.to_i # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char as a float if it's an ASCII char denoting a digit, <code>nil</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L633","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L633","def":{"name":"to_f?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64?"}},{"id":"to_i(base:Int=10):Int32-instance-method","html_id":"to_i(base:Int=10):Int32-instance-method","name":"to_i","doc":"Returns the integer value of this char if it's an ASCII char denoting a digit\nin *base*, raises otherwise.\n\n```\n'1'.to_i     # => 1\n'8'.to_i     # => 8\n'c'.to_i     # raises ArgumentError\n'1'.to_i(16) # => 1\n'a'.to_i(16) # => 10\n'f'.to_i(16) # => 15\n'z'.to_i(16) # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char if it's an ASCII char denoting a digit in <em>base</em>, raises otherwise.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L559","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L559","def":{"name":"to_i","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"(to_i?(base)) || (raise(ArgumentError.new(\"Invalid integer: #{self}\")))"}},{"id":"to_i16(base:Int=10)-instance-method","html_id":"to_i16(base:Int=10)-instance-method","name":"to_i16","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_i16"}},{"id":"to_i16?(base:Int=10)-instance-method","html_id":"to_i16?(base:Int=10)-instance-method","name":"to_i16?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i16?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_i16)"}},{"id":"to_i32(base:Int=10):Int32-instance-method","html_id":"to_i32(base:Int=10):Int32-instance-method","name":"to_i32","doc":"Same as `to_i`.","summary":"<p>Same as <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L592","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L592","def":{"name":"to_i32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"to_i(base)"}},{"id":"to_i32?(base:Int=10):Int32?-instance-method","html_id":"to_i32?(base:Int=10):Int32?-instance-method","name":"to_i32?","doc":"Same as `to_i?`.","summary":"<p>Same as <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>) : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L597","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L597","def":{"name":"to_i32?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"to_i?(base)"}},{"id":"to_i64(base:Int=10)-instance-method","html_id":"to_i64(base:Int=10)-instance-method","name":"to_i64","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_i64"}},{"id":"to_i64?(base:Int=10)-instance-method","html_id":"to_i64?(base:Int=10)-instance-method","name":"to_i64?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i64?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_i64)"}},{"id":"to_i8(base:Int=10)-instance-method","html_id":"to_i8(base:Int=10)-instance-method","name":"to_i8","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_i8"}},{"id":"to_i8?(base:Int=10)-instance-method","html_id":"to_i8?(base:Int=10)-instance-method","name":"to_i8?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_i8?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_i8)"}},{"id":"to_i?(base:Int=10):Int32?-instance-method","html_id":"to_i?(base:Int=10):Int32?-instance-method","name":"to_i?","doc":"Returns the integer value of this char if it's an ASCII char denoting a digit\nin *base*, `nil` otherwise.\n\n```\n'1'.to_i     # => 1\n'8'.to_i     # => 8\n'c'.to_i     # raises ArgumentError\n'1'.to_i(16) # => 1\n'a'.to_i(16) # => 10\n'f'.to_i(16) # => 15\n'z'.to_i(16) # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char if it's an ASCII char denoting a digit in <em>base</em>, <code>nil</code> otherwise.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>) : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L575","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L575","def":{"name":"to_i?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"if 2 <= base && base <= 36\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}, expected 2 to 36\"))\nend\nif base == 10\n  if '0' <= self && self <= '9'\n  else\n    return\n  end\n  self - '0'\nelse\n  ord = ord()\n  if 0 <= ord && ord < 256\n    digit = String::CHAR_TO_DIGIT.to_unsafe[ord]\n    if (digit == -1) || digit >= base\n      return\n    end\n    digit.to_i32\n  end\nend\n"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns this char as a string containing this char as a single character.\n\n```\n'a'.to_s # => \"a\"\n'あ'.to_s # => \"あ\"\n```","summary":"<p>Returns this char as a string containing this char as a single character.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L757","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L757","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(4) do |buffer|\n  appender = buffer.appender\n  each_byte do |byte|\n    appender << byte\n  end\n  {appender.size, 1}\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends this char to the given `IO`.\n\nThis appends this char's bytes as encoded by UTF-8 to the given `IO`.","summary":"<p>Appends this char to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L768","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L768","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if ascii?\n  byte = ord.to_u8\n  if io.@encoding\n    io.write_utf8(Slice.new(pointerof(byte), 1))\n  else\n    io.write_byte(byte)\n  end\nelse\n  chars = uninitialized ::StaticArray(UInt8, 4)\n  i = 0\n  each_byte do |byte|\n    chars[i] = byte\n    i = i + 1\n  end\n  io.write_utf8(chars.to_slice[0, i])\nend"}},{"id":"to_u16(base:Int=10)-instance-method","html_id":"to_u16(base:Int=10)-instance-method","name":"to_u16","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_u16"}},{"id":"to_u16?(base:Int=10)-instance-method","html_id":"to_u16?(base:Int=10)-instance-method","name":"to_u16?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u16?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_u16)"}},{"id":"to_u32(base:Int=10)-instance-method","html_id":"to_u32(base:Int=10)-instance-method","name":"to_u32","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_u32"}},{"id":"to_u32?(base:Int=10)-instance-method","html_id":"to_u32?(base:Int=10)-instance-method","name":"to_u32?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u32?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_u32)"}},{"id":"to_u64(base:Int=10)-instance-method","html_id":"to_u64(base:Int=10)-instance-method","name":"to_u64","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_u64"}},{"id":"to_u64?(base:Int=10)-instance-method","html_id":"to_u64?(base:Int=10)-instance-method","name":"to_u64?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u64?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_u64)"}},{"id":"to_u8(base:Int=10)-instance-method","html_id":"to_u8(base:Int=10)-instance-method","name":"to_u8","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i(base)).to_u8"}},{"id":"to_u8?(base:Int=10)-instance-method","html_id":"to_u8?(base:Int=10)-instance-method","name":"to_u8?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L601","def":{"name":"to_u8?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(to_i?(base)).try(&.to_u8)"}},{"id":"upcase(options=Unicode::CaseOptions::None,&block)-instance-method","html_id":"upcase(options=Unicode::CaseOptions::None,&amp;block)-instance-method","name":"upcase","doc":"Yields each char for the upcase equivalent of this char.\n\nThis method takes into account the possibility that an upcase\nversion of a char might result in multiple chars, like for\n'ﬄ', which results in 'F', 'F' and 'L'.\n\n```\n'z'.upcase { |v| puts v } # prints 'Z'\n'ﬄ'.upcase { |v| puts v } # prints 'F', 'F', 'L'\n```","summary":"<p>Yields each char for the upcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L413","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L413","def":{"name":"upcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"Unicode.upcase(self, options) do |char|\n  yield char\nend"}},{"id":"upcase(options=Unicode::CaseOptions::None)-instance-method","html_id":"upcase(options=Unicode::CaseOptions::None)-instance-method","name":"upcase","doc":"Returns the upcase equivalent of this char.\n\nNote that this only works for characters whose upcase\nequivalent yields a single codepoint. There are a few\ncharacters, like 'ﬄ', than when upcased result in multiple\ncharacters (in this case: 'F', 'F', 'L').\n\nFor a more correct method see the method that receives a block.\n\n```\n'z'.upcase # => 'Z'\n'X'.upcase # => 'X'\n'.'.upcase # => '.'\n```","summary":"<p>Returns the upcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L399","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L399","def":{"name":"upcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Unicode.upcase(self, options)"}},{"id":"uppercase?-instance-method","html_id":"uppercase?-instance-method","name":"uppercase?","doc":"Returns `true` if this char is an uppercase letter.\n\n```\n'H'.uppercase? # => true\n'Á'.uppercase? # => true\n'c'.uppercase? # => false\n'.'.uppercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an uppercase letter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L197","def":{"name":"uppercase?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_uppercase? : Unicode.uppercase?(self)"}},{"id":"whitespace?-instance-method","html_id":"whitespace?-instance-method","name":"whitespace?","doc":"Returns `true` if this char is a whitespace according to unicode.\n\n```\n' '.whitespace?  # => true\n'\\t'.whitespace? # => true\n'b'.whitespace?  # => false\n```","summary":"<p>Returns <code>true</code> if this char is a whitespace according to unicode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char.cr#L263","def":{"name":"whitespace?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ascii? ? ascii_whitespace? : Unicode.whitespace?(self)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Char/Reader","path":"Char/Reader.html","kind":"struct","full_name":"Char::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"char/reader.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Char","kind":"struct","full_name":"Char","name":"Char"},"doc":"A `Char::Reader` allows iterating a `String` by Chars.\n\nAs soon as you instantiate a `Char::Reader` it will decode the first\nchar in the `String`, which can be accessed by invoking `current_char`.\nAt this point `pos`, the current position in the string, will equal zero.\nSuccessive calls to `next_char` return the next chars in the string,\nadvancing `pos`.\n\nNote that the null character `'\\0'` will be returned in `current_char` when\nthe end is reached (as well as when the string is empty). Thus, `has_next?`\nwill return `false` only when `pos` is equal to the string's bytesize, in which\ncase `current_char` will always be `'\\0'`.","summary":"<p>A <code><a href=\"../Char/Reader.html\">Char::Reader</a></code> allows iterating a <code><a href=\"../String.html\">String</a></code> by Chars.</p>","class_methods":[],"constructors":[{"id":"new(string:String,pos=0)-class-method","html_id":"new(string:String,pos=0)-class-method","name":"new","doc":"Creates a reader with the specified *string* positioned at\nbyte index *pos*.","summary":"<p>Creates a reader with the specified <em>string</em> positioned at byte index <em>pos</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""}],"args_string":"(string : String, pos = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L58","def":{"name":"new","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(string, pos)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(*,at_endstring:String)-class-method","html_id":"new(*,at_endstring:String)-class-method","name":"new","doc":"Creates a reader that will be positioned at the last char\nof the given string.","summary":"<p>Creates a reader that will be positioned at the last char of the given string.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"string","doc":null,"default_value":"","external_name":"at_end","restriction":"String"}],"args_string":"(*, at_end string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L68","def":{"name":"new","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"string","doc":null,"default_value":"","external_name":"at_end","restriction":"String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(string: string)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"current_char:Char-instance-method","html_id":"current_char:Char-instance-method","name":"current_char","doc":"Returns the current character.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.current_char # => 'a'\nreader.next_char\nreader.current_char # => 'b'\n```","summary":"<p>Returns the current character.</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L28","def":{"name":"current_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"@current_char"}},{"id":"current_char_width:Int32-instance-method","html_id":"current_char_width:Int32-instance-method","name":"current_char_width","doc":"Returns the size of the `#current_char` (in bytes) as if it were encoded in UTF-8.\n\n```\nreader = Char::Reader.new(\"aé\")\nreader.current_char_width # => 1\nreader.next_char\nreader.current_char_width # => 2\n```","summary":"<p>Returns the size of the <code><a href=\"../Char/Reader.html#current_char%3AChar-instance-method\">#current_char</a></code> (in bytes) as if it were encoded in UTF-8.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L38","def":{"name":"current_char_width","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@current_char_width"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Yields successive characters from `#string` starting from `#pos`.\n\n```\nreader = Char::Reader.new(\"abc\")\nreader.next_char\nreader.each do |c|\n  puts c.upcase\nend\n```\n\n``` text\nB\nC\n```","summary":"<p>Yields successive characters from <code><a href=\"../Char/Reader.html#string%3AString-instance-method\">#string</a></code> starting from <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L179","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while has_next?\n  yield current_char\n  @pos = @pos + @current_char_width\n  decode_current_char\nend"}},{"id":"error:UInt8?-instance-method","html_id":"error:UInt8?-instance-method","name":"error","doc":"If there was an error decoding the current char because\nof an invalid UTF-8 byte sequence, returns the byte\nthat produced the invalid encoding. Returns `0` if the char would've been\nout of bounds. Otherwise returns `nil`.","summary":"<p>If there was an error decoding the current char because of an invalid UTF-8 byte sequence, returns the byte that produced the invalid encoding.</p>","abstract":false,"args":[],"args_string":" : UInt8?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L54","def":{"name":"error","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8 | ::Nil","visibility":"Public","body":"@error"}},{"id":"has_next?-instance-method","html_id":"has_next?-instance-method","name":"has_next?","doc":"Returns `true` if there is a character left to read.\nThe terminating byte `'\\0'` is considered a valid character\nby this method.\n\n```\nreader = Char::Reader.new(\"a\")\nreader.has_next?      # => true\nreader.peek_next_char # => '\\0'\n```","summary":"<p>Returns <code>true</code> if there is a character left to read.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L85","def":{"name":"has_next?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!@end"}},{"id":"has_previous?-instance-method","html_id":"has_previous?-instance-method","name":"has_previous?","doc":"Returns `true` if there are characters before\nthe current one.","summary":"<p>Returns <code>true</code> if there are characters before the current one.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L130","def":{"name":"has_previous?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pos > 0"}},{"id":"next_char-instance-method","html_id":"next_char-instance-method","name":"next_char","doc":"Reads the next character in the string,\n`#pos` is incremented. Raises `IndexError` if the reader is\nat the end of the `#string`.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.next_char # => 'b'\n```","summary":"<p>Reads the next character in the string, <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> is incremented.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L97","def":{"name":"next_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pos = @pos + @current_char_width\nif @pos > @string.bytesize\n  raise(IndexError.new)\nend\ndecode_current_char\n"}},{"id":"peek_next_char-instance-method","html_id":"peek_next_char-instance-method","name":"peek_next_char","doc":"Returns the next character in the `#string`\nwithout incrementing `#pos`.\nRaises `IndexError` if the reader is at\nthe end of the `#string`.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.peek_next_char # => 'b'\nreader.current_char   # => 'a'\n```","summary":"<p>Returns the next character in the <code><a href=\"../Char/Reader.html#string%3AString-instance-method\">#string</a></code> without incrementing <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L116","def":{"name":"peek_next_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"next_pos = @pos + @current_char_width\nif next_pos > @string.bytesize\n  raise(IndexError.new)\nend\ndecode_char_at(next_pos) do |code_point|\n  code_point.unsafe_chr\nend\n"}},{"id":"pos:Int32-instance-method","html_id":"pos:Int32-instance-method","name":"pos","doc":"Returns the position of the current character.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.pos # => 0\nreader.next_char\nreader.pos # => 1\n```","summary":"<p>Returns the position of the current character.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L48","def":{"name":"pos","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@pos"}},{"id":"pos=(pos)-instance-method","html_id":"pos=(pos)-instance-method","name":"pos=","doc":"Sets `#pos` to *pos*.\n\n```\nreader = Char::Reader.new(\"abc\")\nreader.next_char\nreader.next_char\nreader.pos = 0\nreader.current_char # => 'a'\n```","summary":"<p>Sets <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> to <em>pos</em>.</p>","abstract":false,"args":[{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""}],"args_string":"(pos)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L155","def":{"name":"pos=","args":[{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if pos > @string.bytesize\n  raise(IndexError.new)\nend\n@pos = pos\ndecode_current_char\npos\n"}},{"id":"previous_char:Char-instance-method","html_id":"previous_char:Char-instance-method","name":"previous_char","doc":"Returns the previous character, `#pos`\nis decremented.\nRaises `IndexError` if the reader is at the begining of\nthe `#string`","summary":"<p>Returns the previous character, <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> is decremented.</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L138","def":{"name":"previous_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"if has_previous?\nelse\n  raise(IndexError.new)\nend\ndecode_previous_char.as(Char)\n"}},{"id":"string:String-instance-method","html_id":"string:String-instance-method","name":"string","doc":"Returns the reader's String.","summary":"<p>Returns the reader's String.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/char/reader.cr#L18","def":{"name":"string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@string"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Class","path":"Class.html","kind":"class","full_name":"Class","name":"Class","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"class.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr"},{"filename":"primitives.cr","line_number":54,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"<(other:T.class):BoolforallT-class-method","html_id":"&lt;(other:T.class):BoolforallT-class-method","name":"<","doc":"Returns whether this class inherits or includes *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 < Int32   # => false\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L29","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gt(self)\n"}},{"id":"<=(other:T.class):BoolforallT-class-method","html_id":"&lt;=(other:T.class):BoolforallT-class-method","name":"<=","doc":"Returns whether this class inherits or includes *other*, or\nis equal to *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 <= Int32  # => true\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>, or is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L44","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gte(self)\n"}},{"id":"==(other:Class):Bool-class-method","html_id":"==(other:Class):Bool-class-method","name":"==","doc":"Returns whether this class is the same as *other*.\n\n```\nInt32 == Int32  # => true\nInt32 == String # => false\n```","summary":"<p>Returns whether this class is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Class"}],"args_string":"(other : Class) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L17","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"crystal_type_id == other.crystal_type_id"}},{"id":"===(other)-class-method","html_id":"===(other)-class-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L97","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.is_a?(self)"}},{"id":">(other:T.class)forallT-class-method","html_id":"&gt;(other:T.class)forallT-class-method","name":">","doc":"Returns whether *other* inherits or includes `self`.\n\n```\nNumber > Int32  # => true\nNumber > Number # => false\nNumber > Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L57","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% @type %}\nother._lt(self)\n"}},{"id":">=(other:T.class)forallT-class-method","html_id":"&gt;=(other:T.class)forallT-class-method","name":">=","doc":"Returns whether *other* inherits or includes `self`, or is equal\nto `self`.\n\n```\nNumber >= Int32  # => true\nNumber >= Number # => true\nNumber >= Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>, or is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L71","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% @type %}\nother._lte(self)\n"}},{"id":"clone-class-method","html_id":"clone-class-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L156","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"dup-class-method","html_id":"dup-class-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L152","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"hash(hasher)-class-method","html_id":"hash(hasher)-class-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L7","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.class(self)"}},{"id":"inspect(io)-class-method","html_id":"inspect(io)-class-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L2","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"name:String-class-method","html_id":"name:String-class-method","name":"name","doc":"Returns the name of this class.\n\n```\nString.name # => \"String\"\n```","summary":"<p>Returns the name of this class.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L106","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"{{ @type.name.stringify }}"}},{"id":"nilable?-class-method","html_id":"nilable?-class-method","name":"nilable?","doc":"Returns `true` if this class is `Nil`.\n\n```\nInt32.nilable? # => false\nNil.nilable?   # => true\n```","summary":"<p>Returns <code>true</code> if this class is <code><a href=\"Nil.html\">Nil</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L144","def":{"name":"nilable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ::Nil"}},{"id":"to_s(io)-class-method","html_id":"to_s(io)-class-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L148","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << name"}},{"id":"|(other:U.class)forallU-class-method","html_id":"|(other:U.class)forallU-class-method","name":"|","doc":"Returns the union type of `self` and *other*.\n\n```\nInt32 | Char # => (Int32 | Char)\n```","summary":"<p>Returns the union type of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"U.class"}],"args_string":"(other : U.class) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L132","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"U.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"t = uninitialized self\nu = uninitialized U\ntypeof(t, u)\n"}}],"constructors":[{"id":"cast(other):self-class-method","html_id":"cast(other):self-class-method","name":"cast","doc":"Casts *other* to this class.\n\nThis is the same as using `as`, but allows the class to be passed around as\nan argument. See the\n[documentation on as](//crystal-lang.org/docs/syntax_and_semantics/as.html)\nfor more information.\n\n```\nklass = Int32\nnumber = [99, \"str\"][0]\ntypeof(number)             # => (String | Int32)\ntypeof(klass.cast(number)) # => Int32\n```","summary":"<p>Casts <em>other</em> to this class.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L123","def":{"name":"cast","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"other.as(self)"}}],"instance_methods":[{"id":"<(other:T.class):BoolforallT-instance-method","html_id":"&lt;(other:T.class):BoolforallT-instance-method","name":"<","doc":"Returns whether this class inherits or includes *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 < Int32   # => false\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L29","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gt(self)\n"}},{"id":"<=(other:T.class):BoolforallT-instance-method","html_id":"&lt;=(other:T.class):BoolforallT-instance-method","name":"<=","doc":"Returns whether this class inherits or includes *other*, or\nis equal to *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 <= Int32  # => true\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>, or is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L44","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gte(self)\n"}},{"id":"==(other:Class):Bool-instance-method","html_id":"==(other:Class):Bool-instance-method","name":"==","doc":"Returns whether this class is the same as *other*.\n\n```\nInt32 == Int32  # => true\nInt32 == String # => false\n```","summary":"<p>Returns whether this class is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Class"}],"args_string":"(other : Class) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L17","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"crystal_type_id == other.crystal_type_id"}},{"id":"===(other)-instance-method","html_id":"===(other)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L97","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.is_a?(self)"}},{"id":">(other:T.class)forallT-instance-method","html_id":"&gt;(other:T.class)forallT-instance-method","name":">","doc":"Returns whether *other* inherits or includes `self`.\n\n```\nNumber > Int32  # => true\nNumber > Number # => false\nNumber > Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L57","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% @type %}\nother._lt(self)\n"}},{"id":">=(other:T.class)forallT-instance-method","html_id":"&gt;=(other:T.class)forallT-instance-method","name":">=","doc":"Returns whether *other* inherits or includes `self`, or is equal\nto `self`.\n\n```\nNumber >= Int32  # => true\nNumber >= Number # => true\nNumber >= Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>, or is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L71","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% @type %}\nother._lte(self)\n"}},{"id":"cast(other):self-instance-method","html_id":"cast(other):self-instance-method","name":"cast","doc":"Casts *other* to this class.\n\nThis is the same as using `as`, but allows the class to be passed around as\nan argument. See the\n[documentation on as](//crystal-lang.org/docs/syntax_and_semantics/as.html)\nfor more information.\n\n```\nklass = Int32\nnumber = [99, \"str\"][0]\ntypeof(number)             # => (String | Int32)\ntypeof(klass.cast(number)) # => Int32\n```","summary":"<p>Casts <em>other</em> to this class.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L123","def":{"name":"cast","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"other.as(self)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L156","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L152","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L7","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.class(self)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L2","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":"Returns the name of this class.\n\n```\nString.name # => \"String\"\n```","summary":"<p>Returns the name of this class.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L106","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"{{ @type.name.stringify }}"}},{"id":"nilable?-instance-method","html_id":"nilable?-instance-method","name":"nilable?","doc":"Returns `true` if this class is `Nil`.\n\n```\nInt32.nilable? # => false\nNil.nilable?   # => true\n```","summary":"<p>Returns <code>true</code> if this class is <code><a href=\"Nil.html\">Nil</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L144","def":{"name":"nilable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ::Nil"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L148","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << name"}},{"id":"|(other:U.class)forallU-instance-method","html_id":"|(other:U.class)forallU-instance-method","name":"|","doc":"Returns the union type of `self` and *other*.\n\n```\nInt32 | Char # => (Int32 | Char)\n```","summary":"<p>Returns the union type of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"U.class"}],"args_string":"(other : U.class) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/class.cr#L132","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"U.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"t = uninitialized self\nu = uninitialized U\ntypeof(t, u)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize","path":"Colorize.html","kind":"module","full_name":"Colorize","name":"Colorize","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"colorize.cr","line_number":79,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"},{"filename":"colorize.cr","line_number":126,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"With Colorize you can change the fore- and background colors and text decorations when rendering text\non terminals supporting ANSI escape codes. It adds the `colorize` method to `Object` and thus all classes\nas its main interface, which calls `to_s` and surrounds it with the necessary escape codes\nwhen it comes to obtaining a string representation of the object.\n\nIts first argument changes the foreground color:\n```\nrequire \"colorize\"\n\n\"foo\".colorize(:green)\n100.colorize(:red)\n[1, 2, 3].colorize(:blue)\n```\n\nThere are alternative ways to change the foreground color:\n```\n\"foo\".colorize.fore(:green)\n\"foo\".colorize.green\n```\n\nTo change the background color, the following methods are available:\n```\n\"foo\".colorize.back(:green)\n\"foo\".colorize.on(:green)\n\"foo\".colorize.on_green\n```\n\nIt's also possible to change the text decoration:\n```\n\"foo\".colorize.mode(:underline)\n\"foo\".colorize.underline\n```\n\nThe `colorize` method returns a `Colorize::Object` instance,\nwhich allows chaining methods together:\n```\n\"foo\".colorize.fore(:yellow).back(:blue).mode(:underline)\n```\n\nWith the `toggle` method you can temporarily disable adding the escape codes.\nSettings of the instance are preserved however and can be turned back on later:\n```\n\"foo\".colorize(:red).toggle(false)\n# => \"foo\" without color\n\"foo\".colorize(:red).toggle(false).toggle(true)\n# => \"foo\" in red\n```\n\nAvailable colors are:\n```\n:black\n:red\n:green\n:yellow\n:blue\n:magenta\n:cyan\n:light_gray\n:dark_gray\n:light_red\n:light_green\n:light_yellow\n:light_blue\n:light_magenta\n:light_cyan\n:white\n```\n\nAvailable text decorations are:\n```\n:bold\n:bright\n:dim\n:underline\n:blink\n:reverse\n:hidden\n```","summary":"<p>With Colorize you can change the fore- and background colors and text decorations when rendering text on terminals supporting ANSI escape codes.</p>","class_methods":[{"id":"enabled=(enabled:Bool)-class-method","html_id":"enabled=(enabled:Bool)-class-method","name":"enabled=","doc":"If this value is `true`, `Colorize::Object` is enabled by default.\nBut if this value is `false`, `Colorize::Object` is disabled.\n\nThe default value is `true`.\n\n```\nColorize.enabled = true\n\"hello\".colorize.red.to_s # => \"\\e[31mhello\\e[0m\"\n\nColorize.enabled = false\n\"hello\".colorize.red.to_s # => \"hello\"\n```","summary":"<p>If this value is <code>true</code>, <code><a href=\"Colorize/Object.html\">Colorize::Object</a></code> is enabled by default.</p>","abstract":false,"args":[{"name":"enabled","doc":null,"default_value":"","external_name":"enabled","restriction":"Bool"}],"args_string":"(enabled : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L92","def":{"name":"enabled=","args":[{"name":"enabled","doc":null,"default_value":"","external_name":"enabled","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@enabled = enabled"}},{"id":"enabled?:Bool-class-method","html_id":"enabled?:Bool-class-method","name":"enabled?","doc":"If this value is `true`, `Colorize::Object` is enabled by default.\nBut if this value is `false`, `Colorize::Object` is disabled.\n\nThe default value is `true`.\n\n```\nColorize.enabled = true\n\"hello\".colorize.red.to_s # => \"\\e[31mhello\\e[0m\"\n\nColorize.enabled = false\n\"hello\".colorize.red.to_s # => \"hello\"\n```","summary":"<p>If this value is <code>true</code>, <code><a href=\"Colorize/Object.html\">Colorize::Object</a></code> is enabled by default.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L92","def":{"name":"enabled?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@@enabled"}},{"id":"on_tty_only!-class-method","html_id":"on_tty_only!-class-method","name":"on_tty_only!","doc":"Make `Colorize.enabled` `true` if and only if both of `STDOUT.tty?` and `STDERR.tty?` are `true`.","summary":"<p>Make <code>Colorize.enabled</code> <code>true</code> if and only if both of <code>STDOUT.tty?</code> and <code>STDERR.tty?</code> are <code>true</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L95","def":{"name":"on_tty_only!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.enabled = STDOUT.tty? && STDERR.tty?"}},{"id":"reset(io=STDOUT)-class-method","html_id":"reset(io=STDOUT)-class-method","name":"reset","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":""}],"args_string":"(io = <span class=\"t\">STDOUT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L99","def":{"name":"reset","args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if enabled?\n  io << \"\\e[0m\"\nend"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Colorize/Color","path":"Colorize/Color.html","kind":"alias","full_name":"Colorize::Color","name":"Color","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"colorize.cr","line_number":127,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Colorize::Color256 | Colorize::ColorANSI | Colorize::ColorRGB)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize/Color256","path":"Colorize/Color256.html","kind":"struct","full_name":"Colorize::Color256","name":"Color256","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"colorize.cr","line_number":157,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(value:UInt8)-class-method","html_id":"new(value:UInt8)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"UInt8"}],"args_string":"(value : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"back(io:IO):Nil-instance-method","html_id":"back(io:IO):Nil-instance-method","name":"back","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L164","def":{"name":"back","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"io << \"48;5;\"\nvalue.to_s(io)\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Color256.new(@value.clone)"}},{"id":"copy_with(value_value=@value)-instance-method","html_id":"copy_with(value_value=@value)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_value","doc":null,"default_value":"@value","external_name":"value","restriction":""}],"args_string":"(value _value = @value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L157","def":{"name":"copy_with","args":[{"name":"_value","doc":null,"default_value":"@value","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Color256.new(_value)"}},{"id":"fore(io:IO):Nil-instance-method","html_id":"fore(io:IO):Nil-instance-method","name":"fore","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L159","def":{"name":"fore","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"io << \"38;5;\"\nvalue.to_s(io)\n"}},{"id":"value:UInt8-instance-method","html_id":"value:UInt8-instance-method","name":"value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":null,"source_link":null,"def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize/ColorANSI","path":"Colorize/ColorANSI.html","kind":"enum","full_name":"Colorize::ColorANSI","name":"ColorANSI","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"colorize.cr","line_number":129,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Default","name":"Default","value":"39","doc":null,"summary":null},{"id":"Black","name":"Black","value":"30","doc":null,"summary":null},{"id":"Red","name":"Red","value":"31","doc":null,"summary":null},{"id":"Green","name":"Green","value":"32","doc":null,"summary":null},{"id":"Yellow","name":"Yellow","value":"33","doc":null,"summary":null},{"id":"Blue","name":"Blue","value":"34","doc":null,"summary":null},{"id":"Magenta","name":"Magenta","value":"35","doc":null,"summary":null},{"id":"Cyan","name":"Cyan","value":"36","doc":null,"summary":null},{"id":"LightGray","name":"LightGray","value":"37","doc":null,"summary":null},{"id":"DarkGray","name":"DarkGray","value":"90","doc":null,"summary":null},{"id":"LightRed","name":"LightRed","value":"91","doc":null,"summary":null},{"id":"LightGreen","name":"LightGreen","value":"92","doc":null,"summary":null},{"id":"LightYellow","name":"LightYellow","value":"93","doc":null,"summary":null},{"id":"LightBlue","name":"LightBlue","value":"94","doc":null,"summary":null},{"id":"LightMagenta","name":"LightMagenta","value":"95","doc":null,"summary":null},{"id":"LightCyan","name":"LightCyan","value":"96","doc":null,"summary":null},{"id":"White","name":"White","value":"97","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"back(io:IO):Nil-instance-method","html_id":"back(io:IO):Nil-instance-method","name":"back","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L152","def":{"name":"back","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"(to_i + 10).to_s(io)"}},{"id":"black?-instance-method","html_id":"black?-instance-method","name":"black?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L131","def":{"name":"black?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Black"}},{"id":"blue?-instance-method","html_id":"blue?-instance-method","name":"blue?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L135","def":{"name":"blue?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Blue"}},{"id":"cyan?-instance-method","html_id":"cyan?-instance-method","name":"cyan?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L137","def":{"name":"cyan?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Cyan"}},{"id":"dark_gray?-instance-method","html_id":"dark_gray?-instance-method","name":"dark_gray?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L139","def":{"name":"dark_gray?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DarkGray"}},{"id":"default?-instance-method","html_id":"default?-instance-method","name":"default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L130","def":{"name":"default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Default"}},{"id":"fore(io:IO):Nil-instance-method","html_id":"fore(io:IO):Nil-instance-method","name":"fore","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L148","def":{"name":"fore","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"to_i.to_s(io)"}},{"id":"green?-instance-method","html_id":"green?-instance-method","name":"green?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L133","def":{"name":"green?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Green"}},{"id":"light_blue?-instance-method","html_id":"light_blue?-instance-method","name":"light_blue?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L143","def":{"name":"light_blue?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightBlue"}},{"id":"light_cyan?-instance-method","html_id":"light_cyan?-instance-method","name":"light_cyan?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L145","def":{"name":"light_cyan?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightCyan"}},{"id":"light_gray?-instance-method","html_id":"light_gray?-instance-method","name":"light_gray?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L138","def":{"name":"light_gray?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightGray"}},{"id":"light_green?-instance-method","html_id":"light_green?-instance-method","name":"light_green?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L141","def":{"name":"light_green?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightGreen"}},{"id":"light_magenta?-instance-method","html_id":"light_magenta?-instance-method","name":"light_magenta?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L144","def":{"name":"light_magenta?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightMagenta"}},{"id":"light_red?-instance-method","html_id":"light_red?-instance-method","name":"light_red?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L140","def":{"name":"light_red?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightRed"}},{"id":"light_yellow?-instance-method","html_id":"light_yellow?-instance-method","name":"light_yellow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L142","def":{"name":"light_yellow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LightYellow"}},{"id":"magenta?-instance-method","html_id":"magenta?-instance-method","name":"magenta?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L136","def":{"name":"magenta?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Magenta"}},{"id":"red?-instance-method","html_id":"red?-instance-method","name":"red?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L132","def":{"name":"red?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Red"}},{"id":"white?-instance-method","html_id":"white?-instance-method","name":"white?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L146","def":{"name":"white?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == White"}},{"id":"yellow?-instance-method","html_id":"yellow?-instance-method","name":"yellow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L134","def":{"name":"yellow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Yellow"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize/ColorRGB","path":"Colorize/ColorRGB.html","kind":"struct","full_name":"Colorize::ColorRGB","name":"ColorRGB","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"colorize.cr","line_number":170,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(red:UInt8,green:UInt8,blue:UInt8)-class-method","html_id":"new(red:UInt8,green:UInt8,blue:UInt8)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"red","doc":null,"default_value":"","external_name":"red","restriction":"UInt8"},{"name":"green","doc":null,"default_value":"","external_name":"green","restriction":"UInt8"},{"name":"blue","doc":null,"default_value":"","external_name":"blue","restriction":"UInt8"}],"args_string":"(red : UInt8, green : UInt8, blue : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","def":{"name":"new","args":[{"name":"red","doc":null,"default_value":"","external_name":"red","restriction":"UInt8"},{"name":"green","doc":null,"default_value":"","external_name":"green","restriction":"UInt8"},{"name":"blue","doc":null,"default_value":"","external_name":"blue","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(red, green, blue)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"back(io:IO):Nil-instance-method","html_id":"back(io:IO):Nil-instance-method","name":"back","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L179","def":{"name":"back","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"io << \"48;2;\"\n{red, green, blue}.join(';', io, &.to_s(io))\n"}},{"id":"blue:UInt8-instance-method","html_id":"blue:UInt8-instance-method","name":"blue","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":null,"source_link":null,"def":{"name":"blue","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@blue"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ColorRGB.new(@red.clone, @green.clone, @blue.clone)"}},{"id":"copy_with(red_red=@red,green_green=@green,blue_blue=@blue)-instance-method","html_id":"copy_with(red_red=@red,green_green=@green,blue_blue=@blue)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_red","doc":null,"default_value":"@red","external_name":"red","restriction":""},{"name":"_green","doc":null,"default_value":"@green","external_name":"green","restriction":""},{"name":"_blue","doc":null,"default_value":"@blue","external_name":"blue","restriction":""}],"args_string":"(red _red = @red, green _green = @green, blue _blue = @blue)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L170","def":{"name":"copy_with","args":[{"name":"_red","doc":null,"default_value":"@red","external_name":"red","restriction":""},{"name":"_green","doc":null,"default_value":"@green","external_name":"green","restriction":""},{"name":"_blue","doc":null,"default_value":"@blue","external_name":"blue","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ColorRGB.new(_red, _green, _blue)"}},{"id":"fore(io:IO):Nil-instance-method","html_id":"fore(io:IO):Nil-instance-method","name":"fore","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L174","def":{"name":"fore","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"io << \"38;2;\"\n{red, green, blue}.join(';', io, &.to_s(io))\n"}},{"id":"green:UInt8-instance-method","html_id":"green:UInt8-instance-method","name":"green","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":null,"source_link":null,"def":{"name":"green","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@green"}},{"id":"red:UInt8-instance-method","html_id":"red:UInt8-instance-method","name":"red","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":null,"source_link":null,"def":{"name":"red","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@red"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize/Object","path":"Colorize/Object.html","kind":"struct","full_name":"Colorize::Object(T)","name":"Object","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"colorize.cr","line_number":186,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(object:T)-class-method","html_id":"new(object:T)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L210","def":{"name":"new","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Object(T).allocate\n_.initialize(object)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"back(back:Color)-instance-method","html_id":"back(back:Color)-instance-method","name":"back","doc":null,"summary":null,"abstract":false,"args":[{"name":"back","doc":null,"default_value":"","external_name":"back","restriction":"Color"}],"args_string":"(back : Color)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L262","def":{"name":"back","args":[{"name":"back","doc":null,"default_value":"","external_name":"back","restriction":"Color"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = back\nself\n"}},{"id":"back(color:Symbol)-instance-method","html_id":"back(color:Symbol)-instance-method","name":"back","doc":null,"summary":null,"abstract":false,"args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L251","def":{"name":"back","args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for name in COLORS %}\n      if color == :{{ name.id }}\n        @back = ColorANSI::{{ name.camelcase.id }}\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown color: #{color}\"))\n"}},{"id":"black-instance-method","html_id":"black-instance-method","name":"black","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"black","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Black\nself\n"}},{"id":"blink-instance-method","html_id":"blink-instance-method","name":"blink","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"blink","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_BLINK_FLAG\nself\n"}},{"id":"blue-instance-method","html_id":"blue-instance-method","name":"blue","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"blue","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Blue\nself\n"}},{"id":"bold-instance-method","html_id":"bold-instance-method","name":"bold","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"bold","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_BOLD_FLAG\nself\n"}},{"id":"bright-instance-method","html_id":"bright-instance-method","name":"bright","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"bright","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_BRIGHT_FLAG\nself\n"}},{"id":"cyan-instance-method","html_id":"cyan-instance-method","name":"cyan","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"cyan","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Cyan\nself\n"}},{"id":"dark_gray-instance-method","html_id":"dark_gray-instance-method","name":"dark_gray","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"dark_gray","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::DarkGray\nself\n"}},{"id":"dim-instance-method","html_id":"dim-instance-method","name":"dim","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"dim","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_DIM_FLAG\nself\n"}},{"id":"fore(fore:Color)-instance-method","html_id":"fore(fore:Color)-instance-method","name":"fore","doc":null,"summary":null,"abstract":false,"args":[{"name":"fore","doc":null,"default_value":"","external_name":"fore","restriction":"Color"}],"args_string":"(fore : Color)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L247","def":{"name":"fore","args":[{"name":"fore","doc":null,"default_value":"","external_name":"fore","restriction":"Color"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = fore\nself\n"}},{"id":"fore(color:Symbol)-instance-method","html_id":"fore(color:Symbol)-instance-method","name":"fore","doc":null,"summary":null,"abstract":false,"args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L236","def":{"name":"fore","args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for name in COLORS %}\n      if color == :{{ name.id }}\n        @fore = ColorANSI::{{ name.camelcase.id }}\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown color: #{color}\"))\n"}},{"id":"green-instance-method","html_id":"green-instance-method","name":"green","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"green","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Green\nself\n"}},{"id":"hidden-instance-method","html_id":"hidden-instance-method","name":"hidden","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"hidden","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_HIDDEN_FLAG\nself\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L292","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"surround(io) do\n  @object.inspect(io)\nend"}},{"id":"light_blue-instance-method","html_id":"light_blue-instance-method","name":"light_blue","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_blue","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightBlue\nself\n"}},{"id":"light_cyan-instance-method","html_id":"light_cyan-instance-method","name":"light_cyan","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_cyan","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightCyan\nself\n"}},{"id":"light_gray-instance-method","html_id":"light_gray-instance-method","name":"light_gray","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_gray","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightGray\nself\n"}},{"id":"light_green-instance-method","html_id":"light_green-instance-method","name":"light_green","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_green","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightGreen\nself\n"}},{"id":"light_magenta-instance-method","html_id":"light_magenta-instance-method","name":"light_magenta","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_magenta","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightMagenta\nself\n"}},{"id":"light_red-instance-method","html_id":"light_red-instance-method","name":"light_red","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_red","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightRed\nself\n"}},{"id":"light_yellow-instance-method","html_id":"light_yellow-instance-method","name":"light_yellow","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"light_yellow","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::LightYellow\nself\n"}},{"id":"magenta-instance-method","html_id":"magenta-instance-method","name":"magenta","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"magenta","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Magenta\nself\n"}},{"id":"mode(mode:Symbol)-instance-method","html_id":"mode(mode:Symbol)-instance-method","name":"mode","doc":null,"summary":null,"abstract":false,"args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"Symbol"}],"args_string":"(mode : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L266","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L266","def":{"name":"mode","args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for name in MODES %}\n      if mode == :{{ name.id }}\n        @mode |= MODE_{{ name.upcase.id }}_FLAG\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown mode: #{mode}\"))\n"}},{"id":"on(color:Symbol)-instance-method","html_id":"on(color:Symbol)-instance-method","name":"on","doc":null,"summary":null,"abstract":false,"args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L277","def":{"name":"on","args":[{"name":"color","doc":null,"default_value":"","external_name":"color","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"back(color)"}},{"id":"on_black-instance-method","html_id":"on_black-instance-method","name":"on_black","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_black","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Black\nself\n"}},{"id":"on_blue-instance-method","html_id":"on_blue-instance-method","name":"on_blue","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_blue","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Blue\nself\n"}},{"id":"on_cyan-instance-method","html_id":"on_cyan-instance-method","name":"on_cyan","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_cyan","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Cyan\nself\n"}},{"id":"on_dark_gray-instance-method","html_id":"on_dark_gray-instance-method","name":"on_dark_gray","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_dark_gray","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::DarkGray\nself\n"}},{"id":"on_green-instance-method","html_id":"on_green-instance-method","name":"on_green","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_green","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Green\nself\n"}},{"id":"on_light_blue-instance-method","html_id":"on_light_blue-instance-method","name":"on_light_blue","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_blue","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightBlue\nself\n"}},{"id":"on_light_cyan-instance-method","html_id":"on_light_cyan-instance-method","name":"on_light_cyan","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_cyan","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightCyan\nself\n"}},{"id":"on_light_gray-instance-method","html_id":"on_light_gray-instance-method","name":"on_light_gray","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_gray","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightGray\nself\n"}},{"id":"on_light_green-instance-method","html_id":"on_light_green-instance-method","name":"on_light_green","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_green","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightGreen\nself\n"}},{"id":"on_light_magenta-instance-method","html_id":"on_light_magenta-instance-method","name":"on_light_magenta","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_magenta","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightMagenta\nself\n"}},{"id":"on_light_red-instance-method","html_id":"on_light_red-instance-method","name":"on_light_red","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_red","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightRed\nself\n"}},{"id":"on_light_yellow-instance-method","html_id":"on_light_yellow-instance-method","name":"on_light_yellow","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_light_yellow","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::LightYellow\nself\n"}},{"id":"on_magenta-instance-method","html_id":"on_magenta-instance-method","name":"on_magenta","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_magenta","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Magenta\nself\n"}},{"id":"on_red-instance-method","html_id":"on_red-instance-method","name":"on_red","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_red","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Red\nself\n"}},{"id":"on_white-instance-method","html_id":"on_white-instance-method","name":"on_white","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_white","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::White\nself\n"}},{"id":"on_yellow-instance-method","html_id":"on_yellow-instance-method","name":"on_yellow","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"on_yellow","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@back = ColorANSI::Yellow\nself\n"}},{"id":"red-instance-method","html_id":"red-instance-method","name":"red","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"red","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Red\nself\n"}},{"id":"reverse-instance-method","html_id":"reverse-instance-method","name":"reverse","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"reverse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_REVERSE_FLAG\nself\n"}},{"id":"surround(io=STDOUT,&block)-instance-method","html_id":"surround(io=STDOUT,&amp;block)-instance-method","name":"surround","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":""}],"args_string":"(io = <span class=\"t\">STDOUT</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L298","def":{"name":"surround","args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if @enabled\nelse\n  return yield io\nend\nObject.surround(io, to_named_tuple) do |io|\n  yield io\nend\n"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L286","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"surround(io) do\n  io << @object\nend"}},{"id":"toggle(flag)-instance-method","html_id":"toggle(flag)-instance-method","name":"toggle","doc":null,"summary":null,"abstract":false,"args":[{"name":"flag","doc":null,"default_value":"","external_name":"flag","restriction":""}],"args_string":"(flag)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L281","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L281","def":{"name":"toggle","args":[{"name":"flag","doc":null,"default_value":"","external_name":"flag","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@enabled = !(!flag)\nself\n"}},{"id":"underline-instance-method","html_id":"underline-instance-method","name":"underline","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L229","def":{"name":"underline","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mode = @mode | MODE_UNDERLINE_FLAG\nself\n"}},{"id":"white-instance-method","html_id":"white-instance-method","name":"white","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"white","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::White\nself\n"}},{"id":"yellow-instance-method","html_id":"yellow-instance-method","name":"yellow","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L217","def":{"name":"yellow","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fore = ColorANSI::Yellow\nself\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Colorize/ObjectExtensions","path":"Colorize/ObjectExtensions.html","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"colorize.cr","line_number":112,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"colorize(fore)-instance-method","html_id":"colorize(fore)-instance-method","name":"colorize","doc":null,"summary":null,"abstract":false,"args":[{"name":"fore","doc":null,"default_value":"","external_name":"fore","restriction":""}],"args_string":"(fore)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L117","def":{"name":"colorize","args":[{"name":"fore","doc":null,"default_value":"","external_name":"fore","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Colorize::Object.new(self)).fore(fore)"}},{"id":"colorize-instance-method","html_id":"colorize-instance-method","name":"colorize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr#L113","def":{"name":"colorize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Colorize::Object.new(self)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Comparable","path":"Comparable.html","kind":"module","full_name":"Comparable(T)","name":"Comparable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"comparable.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"github.com/crystal-lang/crystal/BigDecimal","kind":"struct","full_name":"BigDecimal","name":"BigDecimal"},{"html_id":"github.com/crystal-lang/crystal/BigFloat","kind":"struct","full_name":"BigFloat","name":"BigFloat"},{"html_id":"github.com/crystal-lang/crystal/BigInt","kind":"struct","full_name":"BigInt","name":"BigInt"},{"html_id":"github.com/crystal-lang/crystal/BigRational","kind":"struct","full_name":"BigRational","name":"BigRational"},{"html_id":"github.com/crystal-lang/crystal/Char","kind":"struct","full_name":"Char","name":"Char"},{"html_id":"github.com/crystal-lang/crystal/Deque","kind":"class","full_name":"Deque(T)","name":"Deque"},{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},{"html_id":"github.com/crystal-lang/crystal/String","kind":"class","full_name":"String","name":"String"},{"html_id":"github.com/crystal-lang/crystal/Symbol","kind":"struct","full_name":"Symbol","name":"Symbol"},{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},{"html_id":"github.com/crystal-lang/crystal/Time/Span","kind":"struct","full_name":"Time::Span","name":"Span"},{"html_id":"github.com/crystal-lang/crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"}],"namespace":null,"doc":"The `Comparable` mixin is used by classes whose objects may be ordered.\n\nIncluding types must provide an `<=>` method, which compares the receiver against\nanother object, returning `-1`, `0`, or `+1` depending on whether the receiver is less than,\nequal to, or greater than the other object.\n\n`Comparable` uses `<=>` to implement the conventional comparison operators (`<`, `<=`, `==`, `>=`, and `>`).","summary":"<p>The <code><a href=\"Comparable.html\">Comparable</a></code> mixin is used by classes whose objects may be ordered.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<(other:T)-instance-method","html_id":"&lt;(other:T)-instance-method","name":"<","doc":"Compares this object to *other* based on the receiver’s `<=>` method, returning `true` if it returns `-1`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>-1</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L10","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self <=> other) < 0"}},{"id":"<=(other:T)-instance-method","html_id":"&lt;=(other:T)-instance-method","name":"<=","doc":"Compares this object to *other* based on the receiver’s `<=>` method, returning `true` if it returns `-1` or `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>-1</code> or <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L15","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self <=> other) <= 0"}},{"id":"(other:T)-instance-method","html_id":"(other:T)-instance-method","name":"<=>","doc":"Comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\nor a positive number otherwise.\n\nSubclasses define this method to provide class-specific ordering.\n\n```\n# Sort in a descending way\n[4, 7, 2].sort { |x, y| y <=> x } # => [7, 4, 2]\n```","summary":"<p>Comparison operator.</p>","abstract":true,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L53","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"==(other:T)-instance-method","html_id":"==(other:T)-instance-method","name":"==","doc":"Compares this object to *other* based on the receiver’s `<=>` method, returning `true` if it returns `0`.\nAlso returns `true` if this and *other* are the same object.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L21","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if self.is_a?(Reference)\n  if other.is_a?(Reference) && (self.same?(other))\n    return true\n  end\n  if other.is_a?(Nil) && (self.same?(other))\n    return true\n  end\nend\n(self <=> other) == 0\n"}},{"id":">(other:T)-instance-method","html_id":"&gt;(other:T)-instance-method","name":">","doc":"Compares this object to *other* based on the receiver’s `<=>` method, returning `true` if it returns `1`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>1</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L34","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self <=> other) > 0"}},{"id":">=(other:T)-instance-method","html_id":"&gt;=(other:T)-instance-method","name":">=","doc":"Compares this object to *other* based on the receiver’s `<=>` method, returning `true` if it returns `1` or `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>1</code> or <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/comparable.cr#L39","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self <=> other) >= 0"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Complex","path":"Complex.html","kind":"struct","full_name":"Complex","name":"Complex","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"complex.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A complex number is a number represented in the form a + bi. In this form,\na and b are real numbers, and i is an imaginary number such as i² = -1.\nThe a is the real part of the number, and the b is the imaginary part of\nthe number.\n\n```\nrequire \"complex\"\n\nComplex.new(1, 0)   # => 1.0 + 0.0i\nComplex.new(5, -12) # => 5.0 - 12.0i\n```","summary":"<p>A complex number is a number represented in the form a + bi.</p>","class_methods":[],"constructors":[{"id":"new(real:Number,imag:Number)-class-method","html_id":"new(real:Number,imag:Number)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"real","doc":null,"default_value":"","external_name":"real","restriction":"Number"},{"name":"imag","doc":null,"default_value":"","external_name":"imag","restriction":"Number"}],"args_string":"(real : Number, imag : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L19","def":{"name":"new","args":[{"name":"real","doc":null,"default_value":"","external_name":"real","restriction":"Number"},{"name":"imag","doc":null,"default_value":"","external_name":"imag","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(real, imag)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"zero:Complex-class-method","html_id":"zero:Complex-class-method","name":"zero","doc":"Returns the number `0` in complex form.","summary":"<p>Returns the number <code>0</code> in complex form.</p>","abstract":false,"args":[],"args_string":" : Complex","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L230","def":{"name":"zero","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Complex","visibility":"Public","body":"new(0, 0)"}}],"instance_methods":[{"id":"*(other:Number)-instance-method","html_id":"*(other:Number)-instance-method","name":"*","doc":"Multiplies `self` by *other*.","summary":"<p>Multiplies <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L196","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real * other, @imag * other)"}},{"id":"*(other:Complex)-instance-method","html_id":"*(other:Complex)-instance-method","name":"*","doc":"Multiplies `self` by *other*.","summary":"<p>Multiplies <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L191","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new((@real * other.real) - (@imag * other.imag), (@real * other.imag) + (@imag * other.real))"}},{"id":"+(other:Number)-instance-method","html_id":"+(other:Number)-instance-method","name":"+","doc":"Adds the value of `self` to *other*.","summary":"<p>Adds the value of <code>self</code> to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L171","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real + other, @imag)"}},{"id":"+(other:Complex)-instance-method","html_id":"+(other:Complex)-instance-method","name":"+","doc":"Adds the value of `self` to *other*.","summary":"<p>Adds the value of <code>self</code> to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L166","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L166","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real + other.real, @imag + other.imag)"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":"Returns the opposite of self.","summary":"<p>Returns the opposite of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L176","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(-@real, -@imag)"}},{"id":"-(other:Number)-instance-method","html_id":"-(other:Number)-instance-method","name":"-","doc":"Removes the value from *other* to self.","summary":"<p>Removes the value from <em>other</em> to self.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L186","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real - other, @imag)"}},{"id":"-(other:Complex)-instance-method","html_id":"-(other:Complex)-instance-method","name":"-","doc":"Removes the value from *other* to self.","summary":"<p>Removes the value from <em>other</em> to self.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L181","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real - other.real, @imag - other.imag)"}},{"id":"/(other:Number)-instance-method","html_id":"/(other:Number)-instance-method","name":"/","doc":"Divides `self` by *other*.","summary":"<p>Divides <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L214","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L214","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real / other, @imag / other)"}},{"id":"/(other:Complex)-instance-method","html_id":"/(other:Complex)-instance-method","name":"/","doc":"Divides `self` by *other*.","summary":"<p>Divides <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L201","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other.real <= other.imag\n  r = other.real / other.imag\n  d = other.imag + (r * other.real)\n  Complex.new(((@real * r) + @imag) / d, ((@imag * r) - @real) / d)\nelse\n  r = other.imag / other.real\n  d = other.real + (r * other.imag)\n  Complex.new((@real + (@imag * r)) / d, (@imag - (@real * r)) / d)\nend"}},{"id":"==(other:Complex)-instance-method","html_id":"==(other:Complex)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L25","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@real == other.real) && (@imag == other.imag)"}},{"id":"==(other:Number)-instance-method","html_id":"==(other:Number)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L30","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.to_c"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L35","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":"Returns the absolute value of this complex number in a\nnumber form, using the Pythagorean theorem.\n\n```\nComplex.new(42, 2).abs  # => 42.04759208325728\nComplex.new(-42, 2).abs # => 42.04759208325728\n```","summary":"<p>Returns the absolute value of this complex number in a number form, using the Pythagorean theorem.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L69","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Math.hypot(@real, @imag)"}},{"id":"abs2-instance-method","html_id":"abs2-instance-method","name":"abs2","doc":"Returns the square of absolute value in a number form.\n\n```\nComplex.new(42, 2).abs2 # => 1768\n```","summary":"<p>Returns the square of absolute value in a number form.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L78","def":{"name":"abs2","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@real * @real) + (@imag * @imag)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L218","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"conj-instance-method","html_id":"conj-instance-method","name":"conj","doc":"Returns the conjugate of self.\n\n```\nComplex.new(42, 2).conj  # => 42.0 - 2.0i\nComplex.new(42, -2).conj # => 42.0 + 2.0i\n```","summary":"<p>Returns the conjugate of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L106","def":{"name":"conj","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(@real, -@imag)"}},{"id":"exp-instance-method","html_id":"exp-instance-method","name":"exp","doc":"Calculates the exp of self.\n\n```\nComplex.new(4, 2).exp # => -22.720847417619233 + 49.645957334580565i\n```","summary":"<p>Calculates the exp of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L145","def":{"name":"exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"r = Math.exp(@real)\nComplex.new(r * (Math.cos(@imag)), r * (Math.sin(@imag)))\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L223","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = real.hash(hasher)\nif imag.zero?\nelse\n  hasher = imag.hash(hasher)\nend\nhasher\n"}},{"id":"imag:Float64-instance-method","html_id":"imag:Float64-instance-method","name":"imag","doc":"Returns the image part of self.","summary":"<p>Returns the image part of self.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L17","def":{"name":"imag","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@imag"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Write this complex object to an *io*, surrounded by parentheses.\n\n```\nComplex.new(42, 2).inspect # => \"(42.0 + 2.0i)\"\n```","summary":"<p>Write this complex object to an <em>io</em>, surrounded by parentheses.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L56","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '('\nto_s(io)\nio << ')'\n"}},{"id":"inv-instance-method","html_id":"inv-instance-method","name":"inv","doc":"Returns the inverse of self.","summary":"<p>Returns the inverse of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L111","def":{"name":"inv","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"conj / abs2"}},{"id":"log-instance-method","html_id":"log-instance-method","name":"log","doc":"Calculates the log of self.","summary":"<p>Calculates the log of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L151","def":{"name":"log","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(Math.log(abs), phase)"}},{"id":"log10-instance-method","html_id":"log10-instance-method","name":"log10","doc":"Calculates the log10 of self.","summary":"<p>Calculates the log10 of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L161","def":{"name":"log10","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log / Math::LOG10"}},{"id":"log2-instance-method","html_id":"log2-instance-method","name":"log2","doc":"Calculates the log2 of self.","summary":"<p>Calculates the log2 of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L156","def":{"name":"log2","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log / Math::LOG2"}},{"id":"phase-instance-method","html_id":"phase-instance-method","name":"phase","doc":"Returns the phase of self.","summary":"<p>Returns the phase of self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L87","def":{"name":"phase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Math.atan2(@imag, @real)"}},{"id":"polar-instance-method","html_id":"polar-instance-method","name":"polar","doc":"Returns a tuple with the abs value and the phase.\n\n```\nComplex.new(42, 2).polar # => {42.047592083257278, 0.047583103276983396}\n```","summary":"<p>Returns a tuple with the abs value and the phase.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L96","def":{"name":"polar","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{abs, phase}"}},{"id":"real:Float64-instance-method","html_id":"real:Float64-instance-method","name":"real","doc":"Returns the real part of self.","summary":"<p>Returns the real part of self.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L14","def":{"name":"real","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@real"}},{"id":"sign-instance-method","html_id":"sign-instance-method","name":"sign","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L82","def":{"name":"sign","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self / abs"}},{"id":"sqrt-instance-method","html_id":"sqrt-instance-method","name":"sqrt","doc":"`Complex#sqrt` was inspired by the [following blog post](https://pavpanchekha.com/casio/)\nof Pavel Panchekha on floating point precision.\n","summary":"<p><code><a href=\"Complex.html#sqrt-instance-method\">Complex#sqrt</a></code> was inspired by the <a href=\"https://pavpanchekha.com/casio/\" target=\"_blank\">following blog post</a> of Pavel Panchekha on floating point precision.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L118","def":{"name":"sqrt","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"r = abs\nre = if @real >= 0\n  0.5 * (Math.sqrt(2.0 * (r + @real)))\nelse\n  @imag.abs / (Math.sqrt(2 * (r - @real)))\nend\nim = if @real <= 0\n  0.5 * (Math.sqrt(2.0 * (r - @real)))\nelse\n  @imag.abs / (Math.sqrt(2 * (r + @real)))\nend\nif @imag >= 0\n  Complex.new(re, im)\nelse\n  Complex.new(re, -im)\nend\n"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Write this complex object to an *io*.\n\n```\nComplex.new(42, 2).to_s # => \"42.0 + 2.0i\"\n```","summary":"<p>Write this complex object to an <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L44","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << @real\nio << (@imag >= 0 ? \" + \" : \" - \")\nio << @imag.abs\nio << 'i'\n"}},{"id":"zero?:Bool-instance-method","html_id":"zero?:Bool-instance-method","name":"zero?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L234","def":{"name":"zero?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"(@real == 0) && (@imag == 0)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Concurrent","path":"Concurrent.html","kind":"module","full_name":"Concurrent","name":"Concurrent","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"concurrent/error.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Concurrent/CanceledError","path":"Concurrent/CanceledError.html","kind":"class","full_name":"Concurrent::CanceledError","name":"CanceledError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent/error.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Concurrent","kind":"module","full_name":"Concurrent","name":"Concurrent"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/ConcurrentExecutionException","path":"ConcurrentExecutionException.html","kind":"class","full_name":"ConcurrentExecutionException","name":"ConcurrentExecutionException","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"concurrent.cr","line_number":133,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/concurrent.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Wraps around exceptions re-raised from concurrent calls.\nThe original exception can be accessed via `#cause`.","summary":"<p>Wraps around exceptions re-raised from concurrent calls.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CRC32","path":"CRC32.html","kind":"module","full_name":"CRC32","name":"CRC32","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"crc32/crc32.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"checksum(data):UInt32-class-method","html_id":"checksum(data):UInt32-class-method","name":"checksum","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L8","def":{"name":"checksum","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"update(data, initial)"}},{"id":"combine(crc1:UInt32,crc2:UInt32,len):UInt32-class-method","html_id":"combine(crc1:UInt32,crc2:UInt32,len):UInt32-class-method","name":"combine","doc":null,"summary":null,"abstract":false,"args":[{"name":"crc1","doc":null,"default_value":"","external_name":"crc1","restriction":"UInt32"},{"name":"crc2","doc":null,"default_value":"","external_name":"crc2","restriction":"UInt32"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"args_string":"(crc1 : UInt32, crc2 : UInt32, len) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L17","def":{"name":"combine","args":[{"name":"crc1","doc":null,"default_value":"","external_name":"crc1","restriction":"UInt32"},{"name":"crc2","doc":null,"default_value":"","external_name":"crc2","restriction":"UInt32"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"(LibZ.crc32_combine(crc1, crc2, len)).to_u32"}},{"id":"initial:UInt32-class-method","html_id":"initial:UInt32-class-method","name":"initial","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L4","def":{"name":"initial","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"(LibZ.crc32(0, nil, 0)).to_u32"}},{"id":"update(data,crc32:UInt32):UInt32-class-method","html_id":"update(data,crc32:UInt32):UInt32-class-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"crc32","doc":null,"default_value":"","external_name":"crc32","restriction":"UInt32"}],"args_string":"(data, crc32 : UInt32) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crc32/crc32.cr#L12","def":{"name":"update","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"crc32","doc":null,"default_value":"","external_name":"crc32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"slice = data.to_slice\n(LibZ.crc32(crc32, slice, slice.size)).to_u32\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crypto","path":"Crypto.html","kind":"module","full_name":"Crypto","name":"Crypto","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"crypto/subtle.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt","path":"Crypto/Bcrypt.html","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"crypto/bcrypt.cr","line_number":32,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"COST_RANGE","name":"COST_RANGE","value":"4..31","doc":null,"summary":null},{"id":"DEFAULT_COST","name":"DEFAULT_COST","value":"11","doc":null,"summary":null},{"id":"PASSWORD_RANGE","name":"PASSWORD_RANGE","value":"1..72","doc":null,"summary":null},{"id":"SALT_SIZE","name":"SALT_SIZE","value":"16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"doc":"Pure Crystal implementation of the Bcrypt algorithm by Niels Provos and David\nMazières, as [presented at USENIX in\n1999](https://www.usenix.org/legacy/events/usenix99/provos/provos_html/index.html).\n\nThe algorithm has a maximum password length limit of 71 characters (see\n[this comment](https://security.stackexchange.com/questions/39849/does-bcrypt-have-a-maximum-password-length#answer-39851)\non stackoverflow).\n\nRefer to `Crypto::Bcrypt::Password` for a higher level interface.\n\nAbout the Cost\n\nBcrypt, like the PBKDF2 or scrypt ciphers, are designed to be slow, so\ngenerating rainbow tables or cracking passwords is nearly impossible. Yet,\ncomputers are always getting faster and faster, so the actual cost must be\nincremented every once in a while.\nAlways use the maximum cost that is tolerable, performance wise, for your\napplication. Be sure to test and select this based on your server, not your\nhome computer.\n\nThis implementation of Bcrypt is currently 50% slower than pure C solutions,\nso keep this in mind when selecting your cost. It may be wise to test with\nRuby's [bcrypt gem](https://github.com/codahale/bcrypt-ruby)\nwhich is a binding to OpenBSD's implementation.\n\nLast but not least: beware of denial of services! Always protect your\napplication using an external strategy (eg: rate limiting), otherwise\nendpoints that verifies bcrypt hashes will be an easy target.","summary":"<p>Pure Crystal implementation of the Bcrypt algorithm by Niels Provos and David Mazières, as <a href=\"https://www.usenix.org/legacy/events/usenix99/provos/provos_html/index.html\" target=\"_blank\">presented at USENIX in 1999</a>.</p>","class_methods":[{"id":"hash_secret(password,cost=DEFAULT_COST):String-class-method","html_id":"hash_secret(password,cost=DEFAULT_COST):String-class-method","name":"hash_secret","doc":null,"summary":null,"abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password, cost = <span class=\"t\">DEFAULT_COST</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L50","def":{"name":"hash_secret","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"passwordb = (password.to_unsafe.to_slice(password.bytesize + 1)).clone\nsaltb = Random::Secure.random_bytes(SALT_SIZE)\n(new(passwordb, saltb, cost)).to_s\n"}}],"constructors":[{"id":"new(password:String,salt:String,cost=DEFAULT_COST)-class-method","html_id":"new(password:String,salt:String,cost=DEFAULT_COST)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"String"},{"name":"salt","doc":null,"default_value":"","external_name":"salt","restriction":"String"},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password : String, salt : String, cost = <span class=\"t\">DEFAULT_COST</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L57","def":{"name":"new","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"String"},{"name":"salt","doc":null,"default_value":"","external_name":"salt","restriction":"String"},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"passwordb = (password.to_unsafe.to_slice(password.bytesize + 1)).clone\nsaltb = Base64.decode(salt, SALT_SIZE)\nnew(passwordb, saltb, cost)\n"}},{"id":"new(password:Bytes,salt:Bytes,cost=DEFAULT_COST)-class-method","html_id":"new(password:Bytes,salt:Bytes,cost=DEFAULT_COST)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"Bytes"},{"name":"salt","doc":null,"default_value":"","external_name":"salt","restriction":"Bytes"},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password : Bytes, salt : Bytes, cost = <span class=\"t\">DEFAULT_COST</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L68","def":{"name":"new","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"Bytes"},{"name":"salt","doc":null,"default_value":"","external_name":"salt","restriction":"Bytes"},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(password, salt, cost)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"cost:Int32-instance-method","html_id":"cost:Int32-instance-method","name":"cost","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L66","def":{"name":"cost","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@cost"}},{"id":"digest-instance-method","html_id":"digest-instance-method","name":"digest","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L76","def":{"name":"digest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest || (@digest = hash_password)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L94","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"password:Bytes-instance-method","html_id":"password:Bytes-instance-method","name":"password","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L64","def":{"name":"password","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"@password"}},{"id":"salt:Bytes-instance-method","html_id":"salt:Bytes-instance-method","name":"salt","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L65","def":{"name":"salt","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"@salt"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L90","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << to_s"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L82","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash || (@hash = (begin\n  salt64 = Base64.encode(salt, salt.size)\n  digest64 = Base64.encode(digest, digest.size - 1)\n  \"$2a$%02d$%s%s\" % {cost, salt64, digest64}\nend))"}},{"id":"to_slice(*args,**options)-instance-method","html_id":"to_slice(*args,**options)-instance-method","name":"to_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L98","def":{"name":"to_slice","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s.to_slice(*args, **options)"}},{"id":"to_slice(*args,**options,&block)-instance-method","html_id":"to_slice(*args,**options,&amp;block)-instance-method","name":"to_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr#L98","def":{"name":"to_slice","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s.to_slice(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt/Error","path":"Crypto/Bcrypt/Error.html","kind":"class","full_name":"Crypto::Bcrypt::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"crypto/bcrypt.cr","line_number":33,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt/Password","path":"Crypto/Bcrypt/Password.html","kind":"class","full_name":"Crypto::Bcrypt::Password","name":"Password","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"crypto/bcrypt/password.cr","line_number":17,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"},"doc":"Generate, read and verify `Crypto::Bcrypt` hashes.\n\n```\nrequire \"crypto/bcrypt/password\"\n\npassword = Crypto::Bcrypt::Password.create(\"super secret\", cost: 10)\n# => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq\n\npassword == \"wrong secret\" # => false\npassword == \"super secret\" # => true\n```\n\nSee `Crypto::Bcrypt` for hints to select the cost when generating hashes.","summary":"<p>Generate, read and verify <code><a href=\"../../Crypto/Bcrypt.html\">Crypto::Bcrypt</a></code> hashes.</p>","class_methods":[],"constructors":[{"id":"create(password,cost=DEFAULT_COST):self-class-method","html_id":"create(password,cost=DEFAULT_COST):self-class-method","name":"create","doc":"Hashes a password.\n\n```\npassword = Crypto::Bcrypt::Password.create(\"super secret\", cost: 10)\n# => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq\n```","summary":"<p>Hashes a password.</p>","abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password, cost = <span class=\"t\">DEFAULT_COST</span>) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L24","def":{"name":"create","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""},{"name":"cost","doc":null,"default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new((Bcrypt.hash_secret(password, cost)).to_s)"}},{"id":"new(raw_hash:String)-class-method","html_id":"new(raw_hash:String)-class-method","name":"new","doc":"Loads a bcrypt hash.\n\n```\npassword = Crypto::Bcrypt::Password.new(\"$2a$10$X6rw/jDiLBuzHV./JjBNXe8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya\")\npassword.version # => \"2a\"\npassword.salt    # => \"X6rw/jDiLBuzHV./JjBNXe\"\npassword.digest  # => \"8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya\"\n```","summary":"<p>Loads a bcrypt hash.</p>","abstract":false,"args":[{"name":"raw_hash","doc":null,"default_value":"","external_name":"raw_hash","restriction":"String"}],"args_string":"(raw_hash : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L41","def":{"name":"new","args":[{"name":"raw_hash","doc":null,"default_value":"","external_name":"raw_hash","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(raw_hash)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(password)-instance-method","html_id":"==(password)-instance-method","name":"==","doc":"Verifies a password against the hash.\n\n```\npassword = Crypto::Bcrypt::Password.create(\"super secret\")\npassword == \"wrong secret\" # => false\npassword == \"super secret\" # => true\n```","summary":"<p>Verifies a password against the hash.</p>","abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""}],"args_string":"(password)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L61","def":{"name":"==","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hashed_password = Bcrypt.new(password, salt, cost)\nCrypto::Subtle.constant_time_compare(@raw_hash, hashed_password)\n"}},{"id":"cost:Int32-instance-method","html_id":"cost:Int32-instance-method","name":"cost","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L29","def":{"name":"cost","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@cost"}},{"id":"digest:String-instance-method","html_id":"digest:String-instance-method","name":"digest","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L31","def":{"name":"digest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@digest"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L70","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"salt:String-instance-method","html_id":"salt:String-instance-method","name":"salt","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L30","def":{"name":"salt","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@salt"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L66","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << @raw_hash"}},{"id":"version:String-instance-method","html_id":"version:String-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/bcrypt/password.cr#L28","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@version"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Crypto/Blowfish","path":"Crypto/Blowfish.html","kind":"class","full_name":"Crypto::Blowfish","name":"Blowfish","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"crypto/blowfish.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEFAULT_ROUNDS","name":"DEFAULT_ROUNDS","value":"16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(rounds=DEFAULT_ROUNDS)-class-method","html_id":"new(rounds=DEFAULT_ROUNDS)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"rounds","doc":null,"default_value":"DEFAULT_ROUNDS","external_name":"rounds","restriction":""}],"args_string":"(rounds = <span class=\"t\">DEFAULT_ROUNDS</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L10","def":{"name":"new","args":[{"name":"rounds","doc":null,"default_value":"DEFAULT_ROUNDS","external_name":"rounds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(rounds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"decrypt_pair(l:UInt32,r:UInt32)-instance-method","html_id":"decrypt_pair(l:UInt32,r:UInt32)-instance-method","name":"decrypt_pair","doc":null,"summary":null,"abstract":false,"args":[{"name":"l","doc":null,"default_value":"","external_name":"l","restriction":"UInt32"},{"name":"r","doc":null,"default_value":"","external_name":"r","restriction":"UInt32"}],"args_string":"(l : UInt32, r : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L55","def":{"name":"decrypt_pair","args":[{"name":"l","doc":null,"default_value":"","external_name":"l","restriction":"UInt32"},{"name":"r","doc":null,"default_value":"","external_name":"r","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@rounds + 1).downto(2) do |i|\n  l = l ^ @p.to_unsafe[i]\n  r = r ^ (f(l))\n  l, r = r, l\nend\nl, r = r, l\nr = r ^ @p.to_unsafe[1]\nl = l ^ @p.to_unsafe[0]\n{l, r}\n"}},{"id":"encrypt_pair(l:UInt32,r:UInt32)-instance-method","html_id":"encrypt_pair(l:UInt32,r:UInt32)-instance-method","name":"encrypt_pair","doc":null,"summary":null,"abstract":false,"args":[{"name":"l","doc":null,"default_value":"","external_name":"l","restriction":"UInt32"},{"name":"r","doc":null,"default_value":"","external_name":"r","restriction":"UInt32"}],"args_string":"(l : UInt32, r : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L40","def":{"name":"encrypt_pair","args":[{"name":"l","doc":null,"default_value":"","external_name":"l","restriction":"UInt32"},{"name":"r","doc":null,"default_value":"","external_name":"r","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0.upto(@rounds - 1) do |i|\n  l = l ^ @p.to_unsafe[i]\n  r = r ^ (f(l))\n  l, r = r, l\nend\nl, r = r, l\nr = r ^ @p.to_unsafe[@rounds]\nl = l ^ @p.to_unsafe[@rounds + 1]\n{l, r}\n"}},{"id":"expand_key(key)-instance-method","html_id":"expand_key(key)-instance-method","name":"expand_key","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/blowfish.cr#L18","def":{"name":"expand_key","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pos = 0\n0.upto(17) do |i|\n  __temp_25 = i\n  __temp_26 = @p.to_unsafe\n  __temp_26[__temp_25] = __temp_26[__temp_25] ^ (next_word(key, pointerof(pos)))\nend\nl, r = 0_u32, 0_u32\n(0..17).step(2) do |i|\n  l, r = encrypt_pair(l, r)\n  @p.to_unsafe[i] = l\n  @p.to_unsafe[i + 1] = r\nend\n(0..1023).step(2) do |i|\n  l, r = encrypt_pair(l, r)\n  @s.to_unsafe[i] = l\n  @s.to_unsafe[i + 1] = r\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crypto/Subtle","path":"Crypto/Subtle.html","kind":"module","full_name":"Crypto::Subtle","name":"Subtle","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"crypto/subtle.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"doc":null,"summary":null,"class_methods":[{"id":"constant_time_byte_eq(x,y)-class-method","html_id":"constant_time_byte_eq(x,y)-class-method","name":"constant_time_byte_eq","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""}],"args_string":"(x, y)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr#L26","def":{"name":"constant_time_byte_eq","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"z = ~(x ^ y)\nz = z & (z >> 4)\nz = z & (z >> 2)\nz = z & (z >> 1)\nz\n"}},{"id":"constant_time_compare(x,y):Bool-class-method","html_id":"constant_time_compare(x,y):Bool-class-method","name":"constant_time_compare","doc":"Compares *x* and *y* in constant time and returns `true` if they are the same, and `false` if they are not.\n\n```\nrequire \"crypto/subtle\"\n\nCrypto::Subtle.constant_time_compare(\"foo\", \"bar\") # => false\nCrypto::Subtle.constant_time_compare(\"foo\", \"foo\") # => true\n```\n\nNOTE: *x* and *y* must be able to respond to `to_slice`.","summary":"<p>Compares <em>x</em> and <em>y</em> in constant time and returns <code>true</code> if they are the same, and <code>false</code> if they are not.</p>","abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""}],"args_string":"(x, y) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crypto/subtle.cr#L12","def":{"name":"constant_time_compare","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"x = x.to_slice\ny = y.to_slice\nif x.size != y.size\n  return false\nend\nv = 0_u8\nx.size.times do |i|\n  v = v | (x[i] ^ y[i])\nend\n(constant_time_byte_eq(v, 0)) == 1\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Crystal","path":"Crystal.html","kind":"module","full_name":"Crystal","name":"Crystal","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"crystal/main.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BUILD_COMMIT","name":"BUILD_COMMIT","value":"\"b782738\"","doc":null,"summary":null},{"id":"BUILD_DATE","name":"BUILD_DATE","value":"\"2018-06-27\"","doc":null,"summary":null},{"id":"CACHE_DIR","name":"CACHE_DIR","value":"\"/root/.cache/crystal\"","doc":null,"summary":null},{"id":"DEFAULT_PATH","name":"DEFAULT_PATH","value":"\"\"","doc":null,"summary":null},{"id":"DESCRIPTION","name":"DESCRIPTION","value":"\"Crystal 0.25.1 [b782738] (2018-06-27)\\n\\nLLVM: 4.0.1\\nDefault target: x86_64-alpine-linux-musl\"","doc":null,"summary":null},{"id":"LLVM_VERSION","name":"LLVM_VERSION","value":"\"4.0.1\"","doc":null,"summary":null},{"id":"PATH","name":"PATH","value":"\"/crystal/src:lib\"","doc":null,"summary":null},{"id":"VERSION","name":"VERSION","value":"\"0.25.1\"","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"main(&block)-class-method","html_id":"main(&amp;block)-class-method","name":"main","doc":"Defines the main routine run by normal Crystal programs:\n\n- Initializes the GC\n- Invokes the given *block*\n- Handles unhandled exceptions\n- Invokes `at_exit` handlers\n- Flushes `STDOUT` and `STDERR`\n\nThis method can be invoked if you need to define a custom\nmain (as in C main) function, doing all the above steps.\n\nFor example:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  Crystal.main do\n    elapsed = Time.measure do\n      Crystal.main_user_code(argc, argv)\n    end\n    puts \"Time to execute program: #{elapsed}\"\n  end\nend\n```\n\nNote that the above is really just an example, almost the\nsame can be accomplished with `at_exit`. But in some cases\nredefinition of C's main is needed.","summary":"<p>Defines the main routine run by normal Crystal programs:</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L38","def":{"name":"main","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"GC.init\nremember_blocking_state\nstatus = begin\n  yield\n  0\nrescue ex\n  1\nend\nif ex\n  AtExitHandlers.exception = ex\nend\nstatus = AtExitHandlers.run(status)\nSTDOUT.flush\nSTDERR.flush\nrestore_blocking_state\nstatus\n"}},{"id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","html_id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main","doc":"Main method run by all Crystal programs at startup.\n\nThis setups up the GC, invokes your program, rescuing\nany handled exception, and then runs `at_exit` handlers.\n\nThis method is automatically invoked for you, so you\ndon't need to invoke it.\n\nHowever, if you need to define a special main C function,\nyou can redefine main and invoke `Crystal.main` from it:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  # some setup before Crystal main\n  Crystal.main(argc, argv)\n  # some cleanup logic after Crystal main\nend\n```\n\nThe `Crystal.main` can also be passed as a callback:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  LibFoo.init_foo_and_invoke_main(argc, argv, ->Crystal.main)\nend\n```\n\nNote that before `Crystal.main` is invoked the GC\nis not setup yet, so nothing that allocates memory\nin Crystal (like `new` for classes) can be used.","summary":"<p>Main method run by all Crystal programs at startup.</p>","abstract":false,"args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":"Int32"},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L91","def":{"name":"main","args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":"Int32"},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"main do\n  main_user_code(argc, argv)\nend"}},{"id":"main_user_code(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","html_id":"main_user_code(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main_user_code","doc":"Executes the main user code. This normally is executed\nafter initializing the GC and before executing `at_exit` handlers.\n\nYou should never invoke this method unless you need to\nredefine C's main function. See `Crystal.main` for\nmore details.","summary":"<p>Executes the main user code.</p>","abstract":false,"args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":"Int32"},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/crystal/main.cr#L103","def":{"name":"main_user_code","args":[{"name":"argc","doc":null,"default_value":"","external_name":"argc","restriction":"Int32"},{"name":"argv","doc":null,"default_value":"","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrystalMain.__crystal_main(argc, argv)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","path":"Crystal/Macros.html","kind":"module","full_name":"Crystal::Macros","name":"Macros","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal","kind":"module","full_name":"Crystal","name":"Crystal"},"doc":"The `Macros` module is a fictitious module used to document macros\nand macro methods.\n\nYou can invoke a **fixed subset** of methods on AST nodes at compile-time. These methods\nare documented on the classes in this module. Additionally, methods of the\n`Macros` module are top-level methods that you can invoke, like `puts` and `run`.","summary":"<p>The <code><a href=\"../Crystal/Macros.html\">Macros</a></code> module is a fictitious module used to document macros and macro methods.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"`(command):MacroId-instance-method","html_id":"`(command):MacroId-instance-method","name":"`","doc":"Executes a system command and returns the output as a `MacroId`.\nGives a compile-time error if the command failed to execute.","summary":"<p>Executes a system command and returns the output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"args_string":"(command) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L47","def":{"name":"`","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"compare_versions(v1:StringLiteral,v2:StringLiteral):NumberLiteral-instance-method","html_id":"compare_versions(v1:StringLiteral,v2:StringLiteral):NumberLiteral-instance-method","name":"compare_versions","doc":"Compares two [semantic versions](http://semver.org/).\nReturns `-1` if `v1 < v2`, `0` if `v1 == v2` and `1` if `v1 > v2`.\n\n```\n{{ compare_versions(\"1.10.0\", \"1.2.0\") }} # => 1\n```","summary":"<p>Compares two <a href=\"http://semver.org/\" target=\"_blank\">semantic versions</a>.</p>","abstract":false,"args":[{"name":"v1","doc":null,"default_value":"","external_name":"v1","restriction":"StringLiteral"},{"name":"v2","doc":null,"default_value":"","external_name":"v2","restriction":"StringLiteral"}],"args_string":"(v1 : StringLiteral, v2 : StringLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L14","def":{"name":"compare_versions","args":[{"name":"v1","doc":null,"default_value":"","external_name":"v1","restriction":"StringLiteral"},{"name":"v2","doc":null,"default_value":"","external_name":"v2","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"debug(format=true):Nop-instance-method","html_id":"debug(format=true):Nop-instance-method","name":"debug","doc":"Outputs the current macro's buffer to the standard output. Useful for debugging\na macro to see what's being generated.\n\nBy default, the output is tried to be formatted using Crystal's\nformatter, but you can disable this by passing `false` to this method.","summary":"<p>Outputs the current macro's buffer to the standard output.</p>","abstract":false,"args":[{"name":"format","doc":null,"default_value":"true","external_name":"format","restriction":""}],"args_string":"(format = <span class=\"n\">true</span>) : Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L22","def":{"name":"debug","args":[{"name":"format","doc":null,"default_value":"true","external_name":"format","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nop","visibility":"Public","body":""}},{"id":"env(name):StringLiteral|NilLiteral-instance-method","html_id":"env(name):StringLiteral|NilLiteral-instance-method","name":"env","doc":"Gets the value of an environment variable at compile-time, or `nil` if it doesn't exist.","summary":"<p>Gets the value of an environment variable at compile-time, or <code>nil</code> if it doesn't exist.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name) : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L26","def":{"name":"env","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"flag?(name):BoolLiteral-instance-method","html_id":"flag?(name):BoolLiteral-instance-method","name":"flag?","doc":"Returns whether a [compile-time flag](https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html) is set.\n\n```\n{{ flag?(:x86_64) }} # true or false\n```","summary":"<p>Returns whether a <a href=\"https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html\" target=\"_blank\">compile-time flag</a> is set.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L34","def":{"name":"flag?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"p(expression):Nop-instance-method","html_id":"p(expression):Nop-instance-method","name":"p","doc":"Same as `puts`.","summary":"<p>Same as <code><a href=\"../Crystal/Macros.html#puts%28expression%29%3ANop-instance-method\">#puts</a></code>.</p>","abstract":false,"args":[{"name":"expression","doc":null,"default_value":"","external_name":"expression","restriction":""}],"args_string":"(expression) : Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L42","def":{"name":"p","args":[{"name":"expression","doc":null,"default_value":"","external_name":"expression","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nop","visibility":"Public","body":""}},{"id":"puts(expression):Nop-instance-method","html_id":"puts(expression):Nop-instance-method","name":"puts","doc":"Prints an AST node at compile-time. Useful for debugging macros.","summary":"<p>Prints an AST node at compile-time.</p>","abstract":false,"args":[{"name":"expression","doc":null,"default_value":"","external_name":"expression","restriction":""}],"args_string":"(expression) : Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L38","def":{"name":"puts","args":[{"name":"expression","doc":null,"default_value":"","external_name":"expression","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nop","visibility":"Public","body":""}},{"id":"raise(message):NoReturn-instance-method","html_id":"raise(message):NoReturn-instance-method","name":"raise","doc":"Gives a compile-time error with the given *message*.","summary":"<p>Gives a compile-time error with the given <em>message</em>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"args_string":"(message) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L55","def":{"name":"raise","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":""}},{"id":"run(filename,*args):MacroId-instance-method","html_id":"run(filename,*args):MacroId-instance-method","name":"run","doc":"Compiles and execute a Crystal program and returns its output\nas a `MacroId`.\n\nThe file denote by *filename* must be a valid Crystal program.\nThis macro invocation passes *args* to the program as regular\nprogram arguments. The program must output a valid Crystal expression.\nThis output is the result of this macro invocation, as a `MacroId`.\n\nThe `run` macro is useful when the subset of available macro methods\nare not enough for your purposes and you need something more powerful.\nWith `run` you can read files at compile time, connect to the internet\nor to a database.\n\nA simple example:\n\n```\n# read.cr\nputs File.read(ARGV[0])\n```\n\n```\n# main.cr\nmacro read_file_at_compile_time(filename)\n  {{ run(\"./read\", filename).stringify }}\nend\n\nputs read_file_at_compile_time(\"some_file.txt\")\n```\n\nThe above generates a program that will have the contents of `some_file.txt`.\nThe file, however, is read at compile time and will not be needed at runtime.\n\nNOTE: the compiler is allowed to cache the executable generated for\n*filename* and only recompile it if any of the files it depends on changes\n(their modified time). This is why it's **strongly discouraged** to use a program\nfor `run` that changes in subsequent compilations (for example, if it executes\nshell commands at compile time, or other macro run programs). It's also strongly\ndiscouraged to have a macro run program take a lot of time, because this will\nslow down compilation times. Reading files is OK, opening an HTTP connection\nat compile-time will most likely result if very slow compilations.","summary":"<p>Compiles and execute a Crystal program and returns its output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(filename, *args) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L98","def":{"name":"run","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"skip_file:Nop-instance-method","html_id":"skip_file:Nop-instance-method","name":"skip_file","doc":"Skips the rest of the file from which it is executed.\nTypical usage is to skip files that have platform specific code,\nwithout having to surround the most relevant code in `{% if flag?(...) %} ... {% end %}` macro blocks.\n\nExample:\n\n```\n# sth_for_osx.cr\n{% skip_file unless flag?(:darwin) %}\n\n# Class FooForMac will only be defined if we're compiling on OS X\nclass FooForMac\nend\n```","summary":"<p>Skips the rest of the file from which it is executed.</p>","abstract":false,"args":[],"args_string":" : Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L115","def":{"name":"skip_file","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nop","visibility":"Public","body":""}},{"id":"system(command):MacroId-instance-method","html_id":"system(command):MacroId-instance-method","name":"system","doc":"Executes a system command and returns the output as a `MacroId`.\nGives a compile-time error if the command failed to execute.","summary":"<p>Executes a system command and returns the output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"args_string":"(command) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L51","def":{"name":"system","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/And","path":"Crystal/Macros/And.html","kind":"class","full_name":"Crystal::Macros::And","name":"And","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":990,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `&&` (and) expression","summary":"<p>An <code>&&</code> (and) expression</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Annotation","path":"Crystal/Macros/Annotation.html","kind":"class","full_name":"Crystal::Macros::Annotation","name":"Annotation","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":822,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An annotation on top of a type or variable.","summary":"<p>An annotation on top of a type or variable.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"[](index:NumberLiteral):ASTNode-instance-method","html_id":"[](index:NumberLiteral):ASTNode-instance-method","name":"[]","doc":"Returns the value of a positional argument,\nor NilLiteral if out of bounds.","summary":"<p>Returns the value of a positional argument, or NilLiteral if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"}],"args_string":"(index : NumberLiteral) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L825","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L825","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"[](name:SymbolLiteral):ASTNode-instance-method","html_id":"[](name:SymbolLiteral):ASTNode-instance-method","name":"[]","doc":"Returns the value of a named argument,\nor NilLiteral if the named argument isn't\nused in this attribute.","summary":"<p>Returns the value of a named argument, or NilLiteral if the named argument isn't used in this attribute.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"SymbolLiteral"}],"args_string":"(name : SymbolLiteral) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L831","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L831","def":{"name":"[]","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"SymbolLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Arg","path":"Crystal/Macros/Arg.html","kind":"class","full_name":"Crystal::Macros::Arg","name":"Arg","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":998,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A def argument.","summary":"<p>A def argument.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"default_value:ASTNode|Nop-instance-method","html_id":"default_value:ASTNode|Nop-instance-method","name":"default_value","doc":"Returns the default value of this argument, if any.","summary":"<p>Returns the default value of this argument, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1012","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1012","def":{"name":"default_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"internal_name:MacroId-instance-method","html_id":"internal_name:MacroId-instance-method","name":"internal_name","doc":"Returns the internal name of this argument.\n\nFor example, for `def write(to file)` returns `file`.","summary":"<p>Returns the internal name of this argument.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1008","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1008","def":{"name":"internal_name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the external name of this argument.\n\nFor example, for `def write(to file)` returns `to`.","summary":"<p>Returns the external name of this argument.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1002","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1002","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"restriction:ASTNode|Nop-instance-method","html_id":"restriction:ASTNode|Nop-instance-method","name":"restriction","doc":"Returns the type restriction of this argument, if any.","summary":"<p>Returns the type restriction of this argument, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1016","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1016","def":{"name":"restriction","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ArrayLiteral","path":"Crystal/Macros/ArrayLiteral.html","kind":"class","full_name":"Crystal::Macros::ArrayLiteral","name":"ArrayLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":526,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An array literal.","summary":"<p>An array literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"+(other:ArrayLiteral):ArrayLiteral-instance-method","html_id":"+(other:ArrayLiteral):ArrayLiteral-instance-method","name":"+","doc":"Similar to `Array#+`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%2B%28other%3AArray%28U%29%29forallU-instance-method\">Array#+</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ArrayLiteral"}],"args_string":"(other : ArrayLiteral) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L626","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L626","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ArrayLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"<<(value:ASTNode):ArrayLiteral-instance-method","html_id":"&lt;&lt;(value:ASTNode):ArrayLiteral-instance-method","name":"<<","doc":"Similar to `Array#<<`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%3C%3C%28value%3AT%29-instance-method\">Array#<<</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"args_string":"(value : ASTNode) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L622","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L622","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"[](index:NumberLiteral):ASTNode-instance-method","html_id":"[](index:NumberLiteral):ASTNode-instance-method","name":"[]","doc":"Similar to `Array#[]`, but returns `NilLiteral` on out of bounds.","summary":"<p>Similar to <code><a href=\"../../Array.html#%5B%5D%28range%3ARange%28Int%2CInt%29%29-instance-method\">Array#[]</a></code>, but returns <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> on out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"}],"args_string":"(index : NumberLiteral) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L606","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L606","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"[]=(index:NumberLiteral,value:ASTNode)-instance-method","html_id":"[]=(index:NumberLiteral,value:ASTNode)-instance-method","name":"[]=","doc":"Similar to `Array#[]=`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%5B%5D%3D%28index%3AInt%2Ccount%3AInt%2Cvalue%3AT%29-instance-method\">Array#[]=</a></code>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"args_string":"(index : NumberLiteral, value : ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L610","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L610","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"NumberLiteral"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"all?(&block):BoolLiteral-instance-method","html_id":"all?(&amp;block):BoolLiteral-instance-method","name":"all?","doc":"Similar to `Enumerable#all?`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#all%3F%28%26block%29-instance-method\">Enumerable#all?</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L532","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L532","def":{"name":"all?","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"any?(&block):BoolLiteral-instance-method","html_id":"any?(&amp;block):BoolLiteral-instance-method","name":"any?","doc":"Similar to `Enumerable#any?`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#any%3F%28%26block%29-instance-method\">Enumerable#any?</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L528","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L528","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"clear:ArrayLiteral-instance-method","html_id":"clear:ArrayLiteral-instance-method","name":"clear","doc":"Similar to `Array#clear`","summary":"<p>Similar to <code><a href=\"../../Array.html#clear-instance-method\">Array#clear</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L546","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L546","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `Array#empty?`","summary":"<p>Similar to <code>Array#empty?</code></p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L550","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L550","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"find(&block):ASTNode|NilLiteral-instance-method","html_id":"find(&amp;block):ASTNode|NilLiteral-instance-method","name":"find","doc":"Similar to `Enumerable#find`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#find%28if_none%3Dnil%2C%26block%29-instance-method\">Enumerable#find</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L554","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L554","def":{"name":"find","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"id":"first:ASTNode|NilLiteral-instance-method","html_id":"first:ASTNode|NilLiteral-instance-method","name":"first","doc":"Similar to `Array#first`, but returns a `NilLiteral` if the array is empty.","summary":"<p>Similar to <code><a href=\"../../Array.html#first%28n%3AInt%29-instance-method\">Array#first</a></code>, but returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if the array is empty.</p>","abstract":false,"args":[],"args_string":" : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L558","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L558","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"id":"includes?(node:ASTNode):BoolLiteral-instance-method","html_id":"includes?(node:ASTNode):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `Enumerable#includes?(obj)`.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#includes%3F%28obj%29-instance-method\">Enumerable#includes?(obj)</a></code>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L562","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L562","def":{"name":"includes?","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"join(separator):StringLiteral-instance-method","html_id":"join(separator):StringLiteral-instance-method","name":"join","doc":"Similar to `Enumerable#join`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#join%28separator%2Cio%29-instance-method\">Enumerable#join</a></code></p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""}],"args_string":"(separator) : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L566","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L566","def":{"name":"join","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"last:ASTNode|NilLiteral-instance-method","html_id":"last:ASTNode|NilLiteral-instance-method","name":"last","doc":"Similar to `Array#last`, but returns a `NilLiteral` if the array is empty.","summary":"<p>Similar to <code><a href=\"../../Array.html#last%28n%3AInt%29-instance-method\">Array#last</a></code>, but returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if the array is empty.</p>","abstract":false,"args":[],"args_string":" : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L570","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L570","def":{"name":"last","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"id":"map(&block):ArrayLiteral-instance-method","html_id":"map(&amp;block):ArrayLiteral-instance-method","name":"map","doc":"Similar to `Enumerable#map`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#map%28%26block%3AT-%3EU%29forallU-instance-method\">Enumerable#map</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L578","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L578","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"of:ASTNode|Nop-instance-method","html_id":"of:ASTNode|Nop-instance-method","name":"of","doc":"Returns the type specified at the end of the array literal, if any.\n\nThis refers to the part after brackets in `[] of String`.","summary":"<p>Returns the type specified at the end of the array literal, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L632","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L632","def":{"name":"of","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"push(value:ASTNode):ArrayLiteral-instance-method","html_id":"push(value:ASTNode):ArrayLiteral-instance-method","name":"push","doc":"Similar to `Array#push`.","summary":"<p>Similar to <code><a href=\"../../Array.html#push%28%2Avalues%3AT%29-instance-method\">Array#push</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"args_string":"(value : ASTNode) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L618","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L618","def":{"name":"push","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"reduce(&block):ASTNode-instance-method","html_id":"reduce(&amp;block):ASTNode-instance-method","name":"reduce","doc":"Similar to `Enumerable#reduce`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#reduce%28%26block%29-instance-method\">Enumerable#reduce</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L590","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L590","def":{"name":"reduce","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"reject(&block):ArrayLiteral-instance-method","html_id":"reject(&amp;block):ArrayLiteral-instance-method","name":"reject","doc":"Similar to `Enumerable#reject`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#reject%28%26block%3AT-%3E%29-instance-method\">Enumerable#reject</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L586","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L586","def":{"name":"reject","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"select(&block):ArrayLiteral-instance-method","html_id":"select(&amp;block):ArrayLiteral-instance-method","name":"select","doc":"Similar to `Enumerable#select`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#select%28%26block%3AT-%3E%29-instance-method\">Enumerable#select</a></code></p>","abstract":false,"args":[],"args_string":"(&block) : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L582","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L582","def":{"name":"select","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"shuffle:ArrayLiteral-instance-method","html_id":"shuffle:ArrayLiteral-instance-method","name":"shuffle","doc":"Similar to `Array#shuffle`","summary":"<p>Similar to <code><a href=\"../../Array.html#shuffle%28random%3DRandom%3A%3ADEFAULT%29-instance-method\">Array#shuffle</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L594","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L594","def":{"name":"shuffle","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `Array#size`","summary":"<p>Similar to <code><a href=\"../../Array.html#size%3AInt32-instance-method\">Array#size</a></code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L574","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L574","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"sort:ArrayLiteral-instance-method","html_id":"sort:ArrayLiteral-instance-method","name":"sort","doc":"Similar to `Array#sort`","summary":"<p>Similar to <code><a href=\"../../Array.html#sort%3AArray%28T%29-instance-method\">Array#sort</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L598","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L598","def":{"name":"sort","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"splat(trailing_string:StringLiteral=nil):MacroId-instance-method","html_id":"splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"splat","doc":"Returns a `MacroId` with all of this array's elements joined\nby commas.\n\nIf *trailing_string* is given, it will be appended to\nthe result unless this array is empty. This lets you\nsplat an array and optionally write a trailing comma\nif needed.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> with all of this array's elements joined by commas.</p>","abstract":false,"args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = <span class=\"n\">nil</span>) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L542","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L542","def":{"name":"splat","args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"type:Path|Nop-instance-method","html_id":"type:Path|Nop-instance-method","name":"type","doc":"Returns the type that receives the items of the array.\n\nThis refers to the part before brackets in `MyArray{1, 2, 3}`","summary":"<p>Returns the type that receives the items of the array.</p>","abstract":false,"args":[],"args_string":" : Path | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L638","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L638","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Path | Nop","visibility":"Public","body":""}},{"id":"uniq:ArrayLiteral-instance-method","html_id":"uniq:ArrayLiteral-instance-method","name":"uniq","doc":"Similar to `Array#uniq`","summary":"<p>Similar to <code><a href=\"../../Array.html#uniq-instance-method\">Array#uniq</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L602","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L602","def":{"name":"uniq","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"unshift:ArrayLiteral-instance-method","html_id":"unshift:ArrayLiteral-instance-method","name":"unshift","doc":"Similar to `Array#unshift`.","summary":"<p>Similar to <code><a href=\"../../Array.html#unshift%28obj%3AT%29-instance-method\">Array#unshift</a></code>.</p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L614","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L614","def":{"name":"unshift","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Assign","path":"Crystal/Macros/Assign.html","kind":"class","full_name":"Crystal::Macros::Assign","name":"Assign","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":925,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Assign expression.","summary":"<p>Assign expression.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"target:ASTNode-instance-method","html_id":"target:ASTNode-instance-method","name":"target","doc":"Returns the target assigned to.","summary":"<p>Returns the target assigned to.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L927","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L927","def":{"name":"target","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"value:ASTNode-instance-method","html_id":"value:ASTNode-instance-method","name":"value","doc":"Returns the value that is being assigned.","summary":"<p>Returns the value that is being assigned.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L931","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L931","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","path":"Crystal/Macros/ASTNode.html","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":120,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Annotation","kind":"class","full_name":"Crystal::Macros::Annotation","name":"Annotation"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Arg","kind":"class","full_name":"Crystal::Macros::Arg","name":"Arg"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ArrayLiteral","kind":"class","full_name":"Crystal::Macros::ArrayLiteral","name":"ArrayLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Assign","kind":"class","full_name":"Crystal::Macros::Assign","name":"Assign"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Block","kind":"class","full_name":"Crystal::Macros::Block","name":"Block"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BoolLiteral","kind":"class","full_name":"Crystal::Macros::BoolLiteral","name":"BoolLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Call","kind":"class","full_name":"Crystal::Macros::Call","name":"Call"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Case","kind":"class","full_name":"Crystal::Macros::Case","name":"Case"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Cast","kind":"class","full_name":"Crystal::Macros::Cast","name":"Cast"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/CharLiteral","kind":"class","full_name":"Crystal::Macros::CharLiteral","name":"CharLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ClassDef","kind":"class","full_name":"Crystal::Macros::ClassDef","name":"ClassDef"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ClassVar","kind":"class","full_name":"Crystal::Macros::ClassVar","name":"ClassVar"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Def","kind":"class","full_name":"Crystal::Macros::Def","name":"Def"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Expressions","kind":"class","full_name":"Crystal::Macros::Expressions","name":"Expressions"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Generic","kind":"class","full_name":"Crystal::Macros::Generic","name":"Generic"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Global","kind":"class","full_name":"Crystal::Macros::Global","name":"Global"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/HashLiteral","kind":"class","full_name":"Crystal::Macros::HashLiteral","name":"HashLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/If","kind":"class","full_name":"Crystal::Macros::If","name":"If"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ImplicitObj","kind":"class","full_name":"Crystal::Macros::ImplicitObj","name":"ImplicitObj"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/InstanceVar","kind":"class","full_name":"Crystal::Macros::InstanceVar","name":"InstanceVar"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/IsA","kind":"class","full_name":"Crystal::Macros::IsA","name":"IsA"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Macro","kind":"class","full_name":"Crystal::Macros::Macro","name":"Macro"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MacroId","kind":"class","full_name":"Crystal::Macros::MacroId","name":"MacroId"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MetaVar","kind":"class","full_name":"Crystal::Macros::MetaVar","name":"MetaVar"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MultiAssign","kind":"class","full_name":"Crystal::Macros::MultiAssign","name":"MultiAssign"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NamedArgument","kind":"class","full_name":"Crystal::Macros::NamedArgument","name":"NamedArgument"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NamedTupleLiteral","kind":"class","full_name":"Crystal::Macros::NamedTupleLiteral","name":"NamedTupleLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NilableCast","kind":"class","full_name":"Crystal::Macros::NilableCast","name":"NilableCast"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NilLiteral","kind":"class","full_name":"Crystal::Macros::NilLiteral","name":"NilLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Nop","kind":"class","full_name":"Crystal::Macros::Nop","name":"Nop"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NumberLiteral","kind":"class","full_name":"Crystal::Macros::NumberLiteral","name":"NumberLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Path","kind":"class","full_name":"Crystal::Macros::Path","name":"Path"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcLiteral","kind":"class","full_name":"Crystal::Macros::ProcLiteral","name":"ProcLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcNotation","kind":"class","full_name":"Crystal::Macros::ProcNotation","name":"ProcNotation"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcPointer","kind":"class","full_name":"Crystal::Macros::ProcPointer","name":"ProcPointer"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RangeLiteral","kind":"class","full_name":"Crystal::Macros::RangeLiteral","name":"RangeLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ReadInstanceVar","kind":"class","full_name":"Crystal::Macros::ReadInstanceVar","name":"ReadInstanceVar"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RegexLiteral","kind":"class","full_name":"Crystal::Macros::RegexLiteral","name":"RegexLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Require","kind":"class","full_name":"Crystal::Macros::Require","name":"Require"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RespondsTo","kind":"class","full_name":"Crystal::Macros::RespondsTo","name":"RespondsTo"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Splat","kind":"class","full_name":"Crystal::Macros::Splat","name":"Splat"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/StringInterpolation","kind":"class","full_name":"Crystal::Macros::StringInterpolation","name":"StringInterpolation"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/StringLiteral","kind":"class","full_name":"Crystal::Macros::StringLiteral","name":"StringLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/SymbolLiteral","kind":"class","full_name":"Crystal::Macros::SymbolLiteral","name":"SymbolLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TupleLiteral","kind":"class","full_name":"Crystal::Macros::TupleLiteral","name":"TupleLiteral"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TypeDeclaration","kind":"class","full_name":"Crystal::Macros::TypeDeclaration","name":"TypeDeclaration"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TypeNode","kind":"class","full_name":"Crystal::Macros::TypeNode","name":"TypeNode"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UninitializedVar","kind":"class","full_name":"Crystal::Macros::UninitializedVar","name":"UninitializedVar"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Union","kind":"class","full_name":"Crystal::Macros::Union","name":"Union"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Var","kind":"class","full_name":"Crystal::Macros::Var","name":"Var"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/VisibilityModifier","kind":"class","full_name":"Crystal::Macros::VisibilityModifier","name":"VisibilityModifier"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/When","kind":"class","full_name":"Crystal::Macros::When","name":"When"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/While","kind":"class","full_name":"Crystal::Macros::While","name":"While"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"This is the base class of all AST nodes. This methods are\navailable to all AST nodes.","summary":"<p>This is the base class of all AST nodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"!=(other:ASTNode):BoolLiteral-instance-method","html_id":"!=(other:ASTNode):BoolLiteral-instance-method","name":"!=","doc":"Returns `true` if this node's textual representation is not the same as\nthe *other* node.","summary":"<p>Returns <code>true</code> if this node's textual representation is not the same as the <em>other</em> node.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ASTNode"}],"args_string":"(other : ASTNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L216","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"==(other:ASTNode):BoolLiteral-instance-method","html_id":"==(other:ASTNode):BoolLiteral-instance-method","name":"==","doc":"Returns `true` if this node's textual representation is the same as\nthe *other* node.","summary":"<p>Returns <code>true</code> if this node's textual representation is the same as the <em>other</em> node.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ASTNode"}],"args_string":"(other : ASTNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L211","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"class_name:StringLiteral-instance-method","html_id":"class_name:StringLiteral-instance-method","name":"class_name","doc":"Returns a `StringLiteral` that contains this node's name.\n\n```\nmacro test\n  {{ \"foo\".class_name }}\nend\n\nputs test # => prints StringLiteral\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a></code> that contains this node's name.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L173","def":{"name":"class_name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"column_number:StringLiteral|NilLiteral-instance-method","html_id":"column_number:StringLiteral|NilLiteral-instance-method","name":"column_number","doc":"Returns the column number where this node begins.\nMight return `nil` if the location is not known.\n\nThe first column number in a line is `1`.","summary":"<p>Returns the column number where this node begins.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L192","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"end_column_number:StringLiteral|NilLiteral-instance-method","html_id":"end_column_number:StringLiteral|NilLiteral-instance-method","name":"end_column_number","doc":"Returns the column number where this node ends.\nMight return `nil` if the location is not known.\n\nThe first column number in a line is `1`.","summary":"<p>Returns the column number where this node ends.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L206","def":{"name":"end_column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"end_line_number:StringLiteral|NilLiteral-instance-method","html_id":"end_line_number:StringLiteral|NilLiteral-instance-method","name":"end_line_number","doc":"Returns the line number where this node ends.\nMight return `nil` if the location is not known.\n\nThe first line number in a file is `1`.","summary":"<p>Returns the line number where this node ends.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L199","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L199","def":{"name":"end_line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"filename:StringLiteral|NilLiteral-instance-method","html_id":"filename:StringLiteral|NilLiteral-instance-method","name":"filename","doc":"Returns the filename where this node is located.\nMight return `nil` if the location is not known.","summary":"<p>Returns the filename where this node is located.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L178","def":{"name":"filename","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this node as a `MacroId`. Useful when you need an identifier\nout of a `StringLiteral`, `SymbolLiteral`, `Var` or `Call`.\n\n```\nmacro define_method(name, content)\n  def {{name.id}}\n    {{content}}\n  end\nend\n\ndefine_method :foo, 1\ndefine_method \"bar\", 2\ndefine_method baz, 3\n\nputs foo # => prints 1\nputs bar # => prints 2\nputs baz # => prints 3\n```","summary":"<p>Returns this node as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L139","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"line_number:StringLiteral|NilLiteral-instance-method","html_id":"line_number:StringLiteral|NilLiteral-instance-method","name":"line_number","doc":"Returns the line number where this node begins.\nMight return `nil` if the location is not known.\n\nThe first line number in a file is 1.","summary":"<p>Returns the line number where this node begins.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L185","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"raise(message):NoReturn-instance-method","html_id":"raise(message):NoReturn-instance-method","name":"raise","doc":"Gives a compile-time error with the given *message*. This will\nhighlight this node in the error message.","summary":"<p>Gives a compile-time error with the given <em>message</em>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"args_string":"(message) : NoReturn","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L221","def":{"name":"raise","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NoReturn","visibility":"Public","body":""}},{"id":"stringify:StringLiteral-instance-method","html_id":"stringify:StringLiteral-instance-method","name":"stringify","doc":"Returns a `StringLiteral` that contains this node's textual representation.\nNote that invoking stringify on a string literal will return a `StringLiteral`\nthat contains a string literal.\n\n```\nmacro test\n  {{ \"foo\".stringify }}\nend\n\nputs test # prints \"foo\" (including the double quotes)\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a></code> that contains this node's textual representation.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L153","def":{"name":"stringify","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"symbolize:SymbolLiteral-instance-method","html_id":"symbolize:SymbolLiteral-instance-method","name":"symbolize","doc":"Returns a `SymbolLiteral` that contains this node's textual representation.\n\n```\n{{ \"foo\".id.symbolize }} # => :foo\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a></code> that contains this node's textual representation.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L161","def":{"name":"symbolize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","path":"Crystal/Macros/BinaryOp.html","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":979,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/And","kind":"class","full_name":"Crystal::Macros::And","name":"And"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Or","kind":"class","full_name":"Crystal::Macros::Or","name":"Or"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A binary expression like `And` and `Or`.","summary":"<p>A binary expression like <code><a href=\"../../Crystal/Macros/And.html\">And</a></code> and <code><a href=\"../../Crystal/Macros/Or.html\">Or</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"left:ASTNode-instance-method","html_id":"left:ASTNode-instance-method","name":"left","doc":"Returns the left hand side of this node.","summary":"<p>Returns the left hand side of this node.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L981","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L981","def":{"name":"left","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"right:ASTNode-instance-method","html_id":"right:ASTNode-instance-method","name":"right","doc":"Returns the left hand side of this node.","summary":"<p>Returns the left hand side of this node.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L985","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L985","def":{"name":"right","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Block","path":"Crystal/Macros/Block.html","kind":"class","full_name":"Crystal::Macros::Block","name":"Block","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":843,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A code block.","summary":"<p>A code block.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"args:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","html_id":"args:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","name":"args","doc":"Returns the blocks arguments.","summary":"<p>Returns the blocks arguments.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(MacroId)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L849","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L849","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the block's body, if any.","summary":"<p>Returns the block's body, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L845","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L845","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"splat_index:NumberLiteral|NilLiteral-instance-method","html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L853","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L853","def":{"name":"splat_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BoolLiteral","path":"Crystal/Macros/BoolLiteral.html","kind":"class","full_name":"Crystal::Macros::BoolLiteral","name":"BoolLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":236,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A bool literal.","summary":"<p>A bool literal.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Call","path":"Crystal/Macros/Call.html","kind":"class","full_name":"Crystal::Macros::Call","name":"Call","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":865,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A method call.","summary":"<p>A method call.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"args:ArrayLiteral-instance-method","html_id":"args:ArrayLiteral-instance-method","name":"args","doc":"Returns this call's arguments.","summary":"<p>Returns this call's arguments.</p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L879","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L879","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"block:Block|Nop-instance-method","html_id":"block:Block|Nop-instance-method","name":"block","doc":"Returns this call's block, if any.","summary":"<p>Returns this call's block, if any.</p>","abstract":false,"args":[],"args_string":" : Block | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L887","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L887","def":{"name":"block","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Block | Nop","visibility":"Public","body":""}},{"id":"block_arg:ASTNode|Nop-instance-method","html_id":"block_arg:ASTNode|Nop-instance-method","name":"block_arg","doc":"Returns this call's block argument, if any","summary":"<p>Returns this call's block argument, if any</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L891","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L891","def":{"name":"block_arg","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this call's name as a `MacroId`.","summary":"<p>Returns this call's name as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L867","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L867","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the method name of this call.","summary":"<p>Returns the method name of this call.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L871","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L871","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"named_args:Crystal::Macros::ArrayLiteral(NamedArgument)-instance-method","html_id":"named_args:Crystal::Macros::ArrayLiteral(NamedArgument)-instance-method","name":"named_args","doc":"Returns this call's named arguments.","summary":"<p>Returns this call's named arguments.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(NamedArgument)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L883","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L883","def":{"name":"named_args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(NamedArgument)","visibility":"Public","body":""}},{"id":"receiver:ASTNode|Nop-instance-method","html_id":"receiver:ASTNode|Nop-instance-method","name":"receiver","doc":"Returns this call's receiver, if any.","summary":"<p>Returns this call's receiver, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L875","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L875","def":{"name":"receiver","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Case","path":"Crystal/Macros/Case.html","kind":"class","full_name":"Crystal::Macros::Case","name":"Case","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1186,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `case` expression.","summary":"<p>A <code>case</code> expression.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"cond:ASTNode-instance-method","html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns the condition (target) of this `case`.","summary":"<p>Returns the condition (target) of this <code>case</code>.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1188","def":{"name":"cond","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"else:Crystal::Macros::ArrayLiteral(When)-instance-method","html_id":"else:Crystal::Macros::ArrayLiteral(When)-instance-method","name":"else","doc":"Returns the `else` of this `case`.","summary":"<p>Returns the <code><a href=\"../../Crystal/Macros/Case.html#else%3ACrystal%3A%3AMacros%3A%3AArrayLiteral%28When%29-instance-method\">#else</a></code> of this <code>case</code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(When)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1196","def":{"name":"else","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(When)","visibility":"Public","body":""}},{"id":"whens:Crystal::Macros::ArrayLiteral(When)-instance-method","html_id":"whens:Crystal::Macros::ArrayLiteral(When)-instance-method","name":"whens","doc":"Returns the `when`s of this `case`.","summary":"<p>Returns the <code>when</code>s of this <code>case</code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(When)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1192","def":{"name":"whens","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(When)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Cast","path":"Crystal/Macros/Cast.html","kind":"class","full_name":"Crystal::Macros::Cast","name":"Cast","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1397,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A cast call: `obj.as(to)`","summary":"<p>A cast call: <code>obj.as(to)</code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"obj:ASTNode-instance-method","html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object part of the cast.","summary":"<p>Returns the object part of the cast.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1399","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1399","def":{"name":"obj","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"to:ASTNode-instance-method","html_id":"to:ASTNode-instance-method","name":"to","doc":"Returns the target type of the cast.","summary":"<p>Returns the target type of the cast.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1403","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1403","def":{"name":"to","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/CharLiteral","path":"Crystal/Macros/CharLiteral.html","kind":"class","full_name":"Crystal::Macros::CharLiteral","name":"CharLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":323,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A character literal.","summary":"<p>A character literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this character's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this character's contents.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L325","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L325","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ClassDef","path":"Crystal/Macros/ClassDef.html","kind":"class","full_name":"Crystal::Macros::ClassDef","name":"ClassDef","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1236,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A class definition.","summary":"<p>A class definition.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ClassVar","path":"Crystal/Macros/ClassVar.html","kind":"class","full_name":"Crystal::Macros::ClassVar","name":"ClassVar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":965,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A class variable.","summary":"<p>A class variable.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L967","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L967","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Def","path":"Crystal/Macros/Def.html","kind":"class","full_name":"Crystal::Macros::Def","name":"Def","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1032,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A method definition.","summary":"<p>A method definition.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"annotation(type:TypeNode):Annotation-instance-method","html_id":"annotation(type:TypeNode):Annotation-instance-method","name":"annotation","doc":"Returns any `Annotation` with the given `type`\nattached to this method.","summary":"<p>Returns any <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code>type</code> attached to this method.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1072","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1072","def":{"name":"annotation","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Annotation","visibility":"Public","body":""}},{"id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","html_id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this method.","summary":"<p>Returns the arguments of this method.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(Arg)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1038","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1038","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"id":"block_arg:Arg|Nop-instance-method","html_id":"block_arg:Arg|Nop-instance-method","name":"block_arg","doc":"Returns the block argument, if any.","summary":"<p>Returns the block argument, if any.</p>","abstract":false,"args":[],"args_string":" : Arg | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1050","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1050","def":{"name":"block_arg","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Arg | Nop","visibility":"Public","body":""}},{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this method.","summary":"<p>Returns the body of this method.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1058","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1058","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"double_splat:Arg|Nop-instance-method","html_id":"double_splat:Arg|Nop-instance-method","name":"double_splat","doc":"Returns the double splat argument, if any.","summary":"<p>Returns the double splat argument, if any.</p>","abstract":false,"args":[],"args_string":" : Arg | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1046","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1046","def":{"name":"double_splat","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Arg | Nop","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this method.","summary":"<p>Returns the name of this method.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1034","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1034","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"receiver:ASTNode|Nop-instance-method","html_id":"receiver:ASTNode|Nop-instance-method","name":"receiver","doc":"Returns the receiver (for example `self`) of this method definition,\nor `Nop` if not specified.","summary":"<p>Returns the receiver (for example <code>self</code>) of this method definition, or <code><a href=\"../../Crystal/Macros/Nop.html\">Nop</a></code> if not specified.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1063","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1063","def":{"name":"receiver","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"return_type:ASTNode|Nop-instance-method","html_id":"return_type:ASTNode|Nop-instance-method","name":"return_type","doc":"Returns the return type of the method, if specified.","summary":"<p>Returns the return type of the method, if specified.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1054","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1054","def":{"name":"return_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"splat_index:NumberLiteral|NilLiteral-instance-method","html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1042","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1042","def":{"name":"splat_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"visibility:SymbolLiteral-instance-method","html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this def: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this def: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1067","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1067","def":{"name":"visibility","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Expressions","path":"Crystal/Macros/Expressions.html","kind":"class","full_name":"Crystal::Macros::Expressions","name":"Expressions","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":858,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A group of expressions.","summary":"<p>A group of expressions.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"expressions:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"expressions:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"expressions","doc":"Returns the list of expressions in this node","summary":"<p>Returns the list of expressions in this node</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L860","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L860","def":{"name":"expressions","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Generic","path":"Crystal/Macros/Generic.html","kind":"class","full_name":"Crystal::Macros::Generic","name":"Generic","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1258,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A generic instantiation, like `Foo(T)` or `Foo::Bar::Baz(T)`","summary":"<p>A generic instantiation, like <code>Foo(T)</code> or <code>Foo::Bar::Baz(T)</code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:Path-instance-method","html_id":"name:Path-instance-method","name":"name","doc":"Returns the path to the generic.","summary":"<p>Returns the path to the generic.</p>","abstract":false,"args":[],"args_string":" : Path","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1260","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Path","visibility":"Public","body":""}},{"id":"named_args:NamedTupleLiteral|NilLiteral-instance-method","html_id":"named_args:NamedTupleLiteral|NilLiteral-instance-method","name":"named_args","doc":"Returns the named arguments of this instantiation, if any.","summary":"<p>Returns the named arguments of this instantiation, if any.</p>","abstract":false,"args":[],"args_string":" : NamedTupleLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1268","def":{"name":"named_args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NamedTupleLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"type_vars:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"type_vars:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"type_vars","doc":"Returns the arguments (the type variables) of this instantiation.","summary":"<p>Returns the arguments (the type variables) of this instantiation.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1264","def":{"name":"type_vars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Global","path":"Crystal/Macros/Global.html","kind":"class","full_name":"Crystal::Macros::Global","name":"Global","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":972,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A global variable.","summary":"<p>A global variable.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L974","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L974","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/HashLiteral","path":"Crystal/Macros/HashLiteral.html","kind":"class","full_name":"Crystal::Macros::HashLiteral","name":"HashLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":643,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A hash literal.","summary":"<p>A hash literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"[](key:ASTNode):ASTNode-instance-method","html_id":"[](key:ASTNode):ASTNode-instance-method","name":"[]","doc":"Similar to `Hash#[]`","summary":"<p>Similar to <code><a href=\"../../Hash.html#%5B%5D%28key%29-instance-method\">Hash#[]</a></code></p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"args_string":"(key : ASTNode) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L673","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L673","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"[]=(key:ASTNode):ASTNode-instance-method","html_id":"[]=(key:ASTNode):ASTNode-instance-method","name":"[]=","doc":"Similar to `Hash#[]=`","summary":"<p>Similar to <code><a href=\"../../Hash.html#%5B%5D%3D%28key%3AK%2Cvalue%3AV%29-instance-method\">Hash#[]=</a></code></p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"args_string":"(key : ASTNode) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L677","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L677","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"clear:HashLiteral-instance-method","html_id":"clear:HashLiteral-instance-method","name":"clear","doc":"Similar to `Hash#clear`","summary":"<p>Similar to <code><a href=\"../../Hash.html#clear-instance-method\">Hash#clear</a></code></p>","abstract":false,"args":[],"args_string":" : HashLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L645","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L645","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HashLiteral","visibility":"Public","body":""}},{"id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","html_id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"double_splat","doc":"Returns a `MacroId` with all of this hash elements joined\nby commas.\n\nIf *trailing_string* is given, it will be appended to\nthe result unless this hash is empty. This lets you\nsplat a hash and optionally write a trailing comma\nif needed.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> with all of this hash elements joined by commas.</p>","abstract":false,"args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = <span class=\"n\">nil</span>) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L705","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L705","def":{"name":"double_splat","args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `Hash#empty?`","summary":"<p>Similar to <code><a href=\"../../Hash.html#empty%3F-instance-method\">Hash#empty?</a></code></p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L649","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L649","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"keys:ArrayLiteral-instance-method","html_id":"keys:ArrayLiteral-instance-method","name":"keys","doc":"Similar to `Hash#keys`","summary":"<p>Similar to <code><a href=\"../../Hash.html#keys-instance-method\">Hash#keys</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L653","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L653","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"map:ArrayLiteral-instance-method","html_id":"map:ArrayLiteral-instance-method","name":"map","doc":"Similar to `Hash#map`","summary":"<p>Similar to <code>Hash#map</code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L669","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L669","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"of_key:ASTNode|Nop-instance-method","html_id":"of_key:ASTNode|Nop-instance-method","name":"of_key","doc":"Returns the type specified at the end of the Hash literal, if any.\n\nThis refers to the key type after brackets in `{} of String => Int32`.","summary":"<p>Returns the type specified at the end of the Hash literal, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L683","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L683","def":{"name":"of_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"of_value:ASTNode|Nop-instance-method","html_id":"of_value:ASTNode|Nop-instance-method","name":"of_value","doc":"Returns the type specified at the end of the Hash literal, if any.\n\nThis refers to the value type after brackets in `{} of String => Int32`.","summary":"<p>Returns the type specified at the end of the Hash literal, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L689","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L689","def":{"name":"of_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `Hash#size`","summary":"<p>Similar to <code><a href=\"../../Hash.html#size%3AInt32-instance-method\">Hash#size</a></code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L657","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L657","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"to_a:Crystal::Macros::ArrayLiteral(TupleLiteral)-instance-method","html_id":"to_a:Crystal::Macros::ArrayLiteral(TupleLiteral)-instance-method","name":"to_a","doc":"Similar to `Hash#to_a`","summary":"<p>Similar to <code>Hash#to_a</code></p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TupleLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L661","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L661","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TupleLiteral)","visibility":"Public","body":""}},{"id":"type:Path|Nop-instance-method","html_id":"type:Path|Nop-instance-method","name":"type","doc":"Returns the type that receives the items of the array.\n\nThis refers to the part before brackets in `MyHash{'a' => 1, 'b' => 2}`","summary":"<p>Returns the type that receives the items of the array.</p>","abstract":false,"args":[],"args_string":" : Path | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L695","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L695","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Path | Nop","visibility":"Public","body":""}},{"id":"values:ArrayLiteral-instance-method","html_id":"values:ArrayLiteral-instance-method","name":"values","doc":"Similar to `Hash#values`","summary":"<p>Similar to <code><a href=\"../../Hash.html#values-instance-method\">Hash#values</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L665","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L665","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/If","path":"Crystal/Macros/If.html","kind":"class","full_name":"Crystal::Macros::If","name":"If","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":907,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An if expression.","summary":"<p>An if expression.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"cond:ASTNode-instance-method","html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns this if's condition.","summary":"<p>Returns this if's condition.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L909","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L909","def":{"name":"cond","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"else:ASTNode-instance-method","html_id":"else:ASTNode-instance-method","name":"else","doc":"Returns this if's `else` clause's body.","summary":"<p>Returns this if's <code><a href=\"../../Crystal/Macros/If.html#else%3AASTNode-instance-method\">#else</a></code> clause's body.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L917","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L917","def":{"name":"else","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"then:ASTNode-instance-method","html_id":"then:ASTNode-instance-method","name":"then","doc":"Returns this if's `then` clause's body.","summary":"<p>Returns this if's <code><a href=\"../../Crystal/Macros/If.html#then%3AASTNode-instance-method\">#then</a></code> clause's body.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L913","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L913","def":{"name":"then","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ImplicitObj","path":"Crystal/Macros/ImplicitObj.html","kind":"class","full_name":"Crystal::Macros::ImplicitObj","name":"ImplicitObj","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1209,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Node that represents an implicit object in:\n\n    case foo\n    when .bar? # this is a call with an implicit object\n    end","summary":"<p>Node that represents an implicit object in:</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/InstanceSizeOf","path":"Crystal/Macros/InstanceSizeOf.html","kind":"class","full_name":"Crystal::Macros::InstanceSizeOf","name":"InstanceSizeOf","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1127,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `instance_sizeof` expression.","summary":"<p>An <code>instance_sizeof</code> expression.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/InstanceVar","path":"Crystal/Macros/InstanceVar.html","kind":"class","full_name":"Crystal::Macros::InstanceVar","name":"InstanceVar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":947,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An instance variable.","summary":"<p>An instance variable.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L949","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L949","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/IsA","path":"Crystal/Macros/IsA.html","kind":"class","full_name":"Crystal::Macros::IsA","name":"IsA","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1146,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `.is_a?` or `.nil?` call.","summary":"<p>An <code>.is_a?</code> or <code>.nil?</code> call.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"arg:ASTNode-instance-method","html_id":"arg:ASTNode-instance-method","name":"arg","doc":"Returns this call's argument.","summary":"<p>Returns this call's argument.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1152","def":{"name":"arg","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"receiver:ASTNode-instance-method","html_id":"receiver:ASTNode-instance-method","name":"receiver","doc":"Returns this call's receiver.","summary":"<p>Returns this call's receiver.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1148","def":{"name":"receiver","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Macro","path":"Crystal/Macros/Macro.html","kind":"class","full_name":"Crystal::Macros::Macro","name":"Macro","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1077,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A macro definition.","summary":"<p>A macro definition.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","html_id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this macro.","summary":"<p>Returns the arguments of this macro.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(Arg)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1083","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1083","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"id":"block_arg:Arg|Nop-instance-method","html_id":"block_arg:Arg|Nop-instance-method","name":"block_arg","doc":"Returns the block argument, if any.","summary":"<p>Returns the block argument, if any.</p>","abstract":false,"args":[],"args_string":" : Arg | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1095","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1095","def":{"name":"block_arg","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Arg | Nop","visibility":"Public","body":""}},{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this macro.","summary":"<p>Returns the body of this macro.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1099","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1099","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"double_splat:Arg|Nop-instance-method","html_id":"double_splat:Arg|Nop-instance-method","name":"double_splat","doc":"Returns the double splat argument, if any.","summary":"<p>Returns the double splat argument, if any.</p>","abstract":false,"args":[],"args_string":" : Arg | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1091","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1091","def":{"name":"double_splat","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Arg | Nop","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this macro.","summary":"<p>Returns the name of this macro.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1079","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1079","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"splat_index:NumberLiteral|NilLiteral-instance-method","html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1087","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1087","def":{"name":"splat_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}},{"id":"visibility:SymbolLiteral-instance-method","html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this macro: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this macro: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1103","def":{"name":"visibility","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MacroId","path":"Crystal/Macros/MacroId.html","kind":"class","full_name":"Crystal::Macros::MacroId","name":"MacroId","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1502,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A fictitious node representing an idenfitifer like, `foo`, `Bar` or `something_else`.\n\nThe parser doesn't create this nodes. Instead, you create them by invoking `id`\non some nodes. For example, invoking `id` on a `StringLiteral` returns a `MacroId`\nfor the string's content. Similarly, invoking ID on a `SymbolLiteral`, `Call`, `Var` and `Path`\nreturn MacroIds for the node's content.\n\nThis allows you to treat strings, symbols, variables and calls uniformly. For example:\n\n```text\nmacro getter(name)\n  def {{name.id}}\n    @{{name.id}}\n  end\nend\n\ngetter unicorns\ngetter :unicorns\ngetter \"unicorns\"\n```\n\nAll of the above macro calls work because we invoked `id`, and the generated code\nlooks like this:\n\n```\ndef unicorns\n  @unicorns\nend\n```\n\nIf we hand't use `id`, the generated code would have been this:\n\n```text\ndef unicorns\n  @unicorns\nend\n\ndef :unicorns\n  @:unicorns\nend\n\ndef \"unicorns\"\n  @\"unicorns\"\nend\n```\n\nThe last two definitions are invalid and so will give a compile-time error.","summary":"<p>A fictitious node representing an idenfitifer like, <code>foo</code>, <code>Bar</code> or <code>something_else</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"+(other:StringLiteral|CharLiteral):MacroId-instance-method","html_id":"+(other:StringLiteral|CharLiteral):MacroId-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28char%3AChar%29-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1516","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1516","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"=~(range:RegexLiteral):BoolLiteral-instance-method","html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1512","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1512","def":{"name":"=~","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"[](range:RangeLiteral):MacroId-instance-method","html_id":"[](range:RangeLiteral):MacroId-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1508","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1508","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"capitalize:MacroId-instance-method","html_id":"capitalize:MacroId-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1520","def":{"name":"capitalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","html_id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars-instance-method\">String#chars</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(CharLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1524","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1524","def":{"name":"chars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"id":"chomp:MacroId-instance-method","html_id":"chomp:MacroId-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp-instance-method\">String#chomp</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1528","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1528","def":{"name":"chomp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"downcase:MacroId-instance-method","html_id":"downcase:MacroId-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#downcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1532","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1532","def":{"name":"downcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F-instance-method\">String#empty?</a></code>.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1536","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1536","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28char%3AChar%29-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1540","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1540","def":{"name":"ends_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"gsub(regex:RegexLiteral,replacement:StringLiteral):MacroId-instance-method","html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):MacroId-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1544","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1544","def":{"name":"gsub","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns self.","summary":"<p>Returns self.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1504","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1504","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1548","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1548","def":{"name":"includes?","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1556","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1556","def":{"name":"lines","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size-instance-method\">String#size</a></code>.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1552","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1552","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1564","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1564","def":{"name":"split","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1560","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1560","def":{"name":"split","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28re%3ARegex%29-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1568","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1568","def":{"name":"starts_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"strip:MacroId-instance-method","html_id":"strip:MacroId-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip-instance-method\">String#strip</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1572","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1572","def":{"name":"strip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"tr(from:StringLiteral,to:StringLiteral):MacroId-instance-method","html_id":"tr(from:StringLiteral,to:StringLiteral):MacroId-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1576","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1576","def":{"name":"tr","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"upcase:MacroId-instance-method","html_id":"upcase:MacroId-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#upcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1580","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1580","def":{"name":"upcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MetaVar","path":"Crystal/Macros/MetaVar.html","kind":"class","full_name":"Crystal::Macros::MetaVar","name":"MetaVar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":793,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A fictitious node representing a variable or instance\nvariable, together with type information.","summary":"<p>A fictitious node representing a variable or instance variable, together with type information.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"annotation(type:TypeNode):Annotation-instance-method","html_id":"annotation(type:TypeNode):Annotation-instance-method","name":"annotation","doc":"Returns any `Annotation` with the given `type`\nattached to this variable.","summary":"<p>Returns any <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code><a href=\"../../Crystal/Macros/MetaVar.html#type%3ATypeNode%7CNilLiteral-instance-method\">#type</a></code> attached to this variable.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L817","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L817","def":{"name":"annotation","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Annotation","visibility":"Public","body":""}},{"id":"default_value:ASTNode-instance-method","html_id":"default_value:ASTNode-instance-method","name":"default_value","doc":"Returns the default value of this variable.\nNote that if the variable doesn't have a default value,\nor the default value is `nil`, a `NilLiteral` will be\nreturned. To distinguish between these cases, use\n`has_default_value?`.","summary":"<p>Returns the default value of this variable.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L807","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L807","def":{"name":"default_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"has_default_value?:BoolLiteral-instance-method","html_id":"has_default_value?:BoolLiteral-instance-method","name":"has_default_value?","doc":"Returns whether this variable has a default value (which.\ncan in turn be `nil`).","summary":"<p>Returns whether this variable has a default value (which.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L812","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L812","def":{"name":"has_default_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L795","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L795","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"type:TypeNode|NilLiteral-instance-method","html_id":"type:TypeNode|NilLiteral-instance-method","name":"type","doc":"Returns the type of this variable, if known, or `nil`.","summary":"<p>Returns the type of this variable, if known, or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":" : TypeNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L799","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L799","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/MultiAssign","path":"Crystal/Macros/MultiAssign.html","kind":"class","full_name":"Crystal::Macros::MultiAssign","name":"MultiAssign","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":936,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Multiple assign expression.","summary":"<p>Multiple assign expression.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"targets:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"targets:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"targets","doc":"Returns the targets assigned to.","summary":"<p>Returns the targets assigned to.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L938","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L938","def":{"name":"targets","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"id":"values:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"values:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"values","doc":"Returns the values that are being assigned.","summary":"<p>Returns the values that are being assigned.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L942","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L942","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NamedArgument","path":"Crystal/Macros/NamedArgument.html","kind":"class","full_name":"Crystal::Macros::NamedArgument","name":"NamedArgument","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":896,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A call's named argument.","summary":"<p>A call's named argument.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns this named argument name.","summary":"<p>Returns this named argument name.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L898","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L898","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"value:ASTNode-instance-method","html_id":"value:ASTNode-instance-method","name":"value","doc":"Returns this named argument value.","summary":"<p>Returns this named argument value.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L902","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L902","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NamedTupleLiteral","path":"Crystal/Macros/NamedTupleLiteral.html","kind":"class","full_name":"Crystal::Macros::NamedTupleLiteral","name":"NamedTupleLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":710,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A named tuple literal.","summary":"<p>A named tuple literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"[](key:ASTNode):ASTNode-instance-method","html_id":"[](key:ASTNode):ASTNode-instance-method","name":"[]","doc":"Similar to `NamedTuple#[]` but returns `NilLiteral` if *key* is undefined.","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#%5B%5D%28key%3ASymbol%7CString%29-instance-method\">NamedTuple#[]</a></code> but returns <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if <em>key</em> is undefined.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"args_string":"(key : ASTNode) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L740","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L740","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"[]=(key:ASTNode):ASTNode-instance-method","html_id":"[]=(key:ASTNode):ASTNode-instance-method","name":"[]=","doc":"Adds or replaces a key.","summary":"<p>Adds or replaces a key.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"args_string":"(key : ASTNode) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L744","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L744","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","html_id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"double_splat","doc":"Similar to `HashLiteral#double_splat`","summary":"<p>Similar to <code><a href=\"../../Crystal/Macros/HashLiteral.html#double_splat%28trailing_string%3AStringLiteral%3Dnil%29%3AMacroId-instance-method\">HashLiteral#double_splat</a></code></p>","abstract":false,"args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = <span class=\"n\">nil</span>) : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L736","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L736","def":{"name":"double_splat","args":[{"name":"trailing_string","doc":null,"default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `NamedTuple#empty?`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#empty%3F-instance-method\">NamedTuple#empty?</a></code></p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L712","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L712","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"keys:ArrayLiteral-instance-method","html_id":"keys:ArrayLiteral-instance-method","name":"keys","doc":"Similar to `NamedTuple#keys`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#keys-instance-method\">NamedTuple#keys</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L716","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L716","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"map:ArrayLiteral-instance-method","html_id":"map:ArrayLiteral-instance-method","name":"map","doc":"Similar to `NamedTuple#map`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#map%28%26block%29-instance-method\">NamedTuple#map</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L732","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `NamedTuple#size`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#size-instance-method\">NamedTuple#size</a></code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L720","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L720","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"to_a:Crystal::Macros::ArrayLiteral(TupleLiteral)-instance-method","html_id":"to_a:Crystal::Macros::ArrayLiteral(TupleLiteral)-instance-method","name":"to_a","doc":"Similar to `NamedTuple#to_a`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#to_a-instance-method\">NamedTuple#to_a</a></code></p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TupleLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L724","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L724","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TupleLiteral)","visibility":"Public","body":""}},{"id":"values:ArrayLiteral-instance-method","html_id":"values:ArrayLiteral-instance-method","name":"values","doc":"Similar to `NamedTuple#values`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#values-instance-method\">NamedTuple#values</a></code></p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L728","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L728","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NilableCast","path":"Crystal/Macros/NilableCast.html","kind":"class","full_name":"Crystal::Macros::NilableCast","name":"NilableCast","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1408,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A cast call: `obj.as?(to)`","summary":"<p>A cast call: <code>obj.as?(to)</code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"obj:ASTNode-instance-method","html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object part of the cast.","summary":"<p>Returns the object part of the cast.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1410","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1410","def":{"name":"obj","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"to:ASTNode-instance-method","html_id":"to:ASTNode-instance-method","name":"to","doc":"Returns the target type of the cast.","summary":"<p>Returns the target type of the cast.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1414","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1414","def":{"name":"to","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NilLiteral","path":"Crystal/Macros/NilLiteral.html","kind":"class","full_name":"Crystal::Macros::NilLiteral","name":"NilLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":232,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The nil literal.","summary":"<p>The nil literal.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Nop","path":"Crystal/Macros/Nop.html","kind":"class","full_name":"Crystal::Macros::Nop","name":"Nop","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":228,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The empty node. Similar to a `NilLiteral` but its textual representation\nis the empty string. This corresponds, for example, to the missing `else` branch of\nan `if` without an `else`.","summary":"<p>The empty node.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Not","path":"Crystal/Macros/Not.html","kind":"class","full_name":"Crystal::Macros::Not","name":"Not","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1115,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An unary `not` (`!`).","summary":"<p>An unary <code>not</code> (<code>!</code>).</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/NumberLiteral","path":"Crystal/Macros/NumberLiteral.html","kind":"class","full_name":"Crystal::Macros::NumberLiteral","name":"NumberLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":240,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Any number literal.","summary":"<p>Any number literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"%(other:NumberLiteral):NumberLiteral-instance-method","html_id":"%(other:NumberLiteral):NumberLiteral-instance-method","name":"%","doc":"Same as `Number#%`","summary":"<p>Same as <code><a href=\"../../Number.html\">Number</a>#%</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L278","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"&(other:NumberLiteral):NumberLiteral-instance-method","html_id":"&amp;(other:NumberLiteral):NumberLiteral-instance-method","name":"&","doc":"Same as `Number#&`","summary":"<p>Same as <code>Number#&</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L282","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"*(other:NumberLiteral):NumberLiteral-instance-method","html_id":"*(other:NumberLiteral):NumberLiteral-instance-method","name":"*","doc":"Same as `Number#*`","summary":"<p>Same as <code><a href=\"../../Number.html#%2A%28other%3AComplex%29-instance-method\">Number#*</a></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L270","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"**(other:NumberLiteral):NumberLiteral-instance-method","html_id":"**(other:NumberLiteral):NumberLiteral-instance-method","name":"**","doc":"Same as `Number#**`","summary":"<p>Same as <code>Number#**</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L294","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"+(other:NumberLiteral):NumberLiteral-instance-method","html_id":"+(other:NumberLiteral):NumberLiteral-instance-method","name":"+","doc":"Same as `Number#+`","summary":"<p>Same as <code><a href=\"../../Number.html#%2B-instance-method\">Number#+</a></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L262","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"+:NumberLiteral-instance-method","html_id":"+:NumberLiteral-instance-method","name":"+","doc":"Same as `Number#+`","summary":"<p>Same as <code><a href=\"../../Number.html#%2B-instance-method\">Number#+</a></code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L306","def":{"name":"+","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"-(other:NumberLiteral):NumberLiteral-instance-method","html_id":"-(other:NumberLiteral):NumberLiteral-instance-method","name":"-","doc":"Same as `Number#-`","summary":"<p>Same as <code><a href=\"../../Number.html#-%28other%3AComplex%29-instance-method\">Number#-</a></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L266","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L266","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"-:NumberLiteral-instance-method","html_id":"-:NumberLiteral-instance-method","name":"-","doc":"Same as `Number#-`","summary":"<p>Same as <code><a href=\"../../Number.html#-%28other%3AComplex%29-instance-method\">Number#-</a></code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L310","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"/(other:NumberLiteral):NumberLiteral-instance-method","html_id":"/(other:NumberLiteral):NumberLiteral-instance-method","name":"/","doc":"Same as `Number#/`","summary":"<p>Same as <code><a href=\"../../Number.html#%2F%28other%3AComplex%29-instance-method\">Number#/</a></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L274","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"<(other:NumberLiteral):BoolLiteral-instance-method","html_id":"&lt;(other:NumberLiteral):BoolLiteral-instance-method","name":"<","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L242","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"<<(other:NumberLiteral):NumberLiteral-instance-method","html_id":"&lt;&lt;(other:NumberLiteral):NumberLiteral-instance-method","name":"<<","doc":"Same as `Number#<<`","summary":"<p>Same as <code>Number#<<</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L298","def":{"name":"<<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"<=(other:NumberLiteral):BoolLiteral-instance-method","html_id":"&lt;=(other:NumberLiteral):BoolLiteral-instance-method","name":"<=","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L246","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"(other:NumberLiteral):NumberLiteral-instance-method","html_id":"(other:NumberLiteral):NumberLiteral-instance-method","name":"<=>","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L258","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L258","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":">(other:NumberLiteral):BoolLiteral-instance-method","html_id":"&gt;(other:NumberLiteral):BoolLiteral-instance-method","name":">","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L250","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":">=(other:NumberLiteral):BoolLiteral-instance-method","html_id":"&gt;=(other:NumberLiteral):BoolLiteral-instance-method","name":">=","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L254","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L254","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":">>(other:NumberLiteral):NumberLiteral-instance-method","html_id":"&gt;&gt;(other:NumberLiteral):NumberLiteral-instance-method","name":">>","doc":"Same as `Number#>>`","summary":"<p>Same as <code>Number#>></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L302","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L302","def":{"name":">>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"^(other:NumberLiteral):NumberLiteral-instance-method","html_id":"^(other:NumberLiteral):NumberLiteral-instance-method","name":"^","doc":"Same as `Number#^`","summary":"<p>Same as <code>Number#^</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L290","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"kind:SymbolLiteral-instance-method","html_id":"kind:SymbolLiteral-instance-method","name":"kind","doc":"The type of the literal: `:i32`, `:u16`, `:f32`, `:f64`, etc.","summary":"<p>The type of the literal: <code>:i32</code>, <code>:u16</code>, <code>:f32</code>, <code>:f64</code>, etc.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L318","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L318","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"|(other:NumberLiteral):NumberLiteral-instance-method","html_id":"|(other:NumberLiteral):NumberLiteral-instance-method","name":"|","doc":"Same as `Number#|`","summary":"<p>Same as <code>Number#|</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L286","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NumberLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"~:NumberLiteral-instance-method","html_id":"~:NumberLiteral-instance-method","name":"~","doc":"Same as `Number#~`","summary":"<p>Same as <code>Number#~</code></p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L314","def":{"name":"~","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Or","path":"Crystal/Macros/Or.html","kind":"class","full_name":"Crystal::Macros::Or","name":"Or","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":994,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `||` (or) expression","summary":"<p>An <code>||</code> (or) expression</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Out","path":"Crystal/Macros/Out.html","kind":"class","full_name":"Crystal::Macros::Out","name":"Out","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1131,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `out` expression.","summary":"<p>An <code>out</code> expression.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Path","path":"Crystal/Macros/Path.html","kind":"class","full_name":"Crystal::Macros::Path","name":"Path","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1213,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A Path to a constant or type, like `Foo` or `Foo::Bar::Baz`.","summary":"<p>A Path to a constant or type, like <code>Foo</code> or <code>Foo::Bar::Baz</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"global?:BoolLiteral-instance-method","html_id":"global?:BoolLiteral-instance-method","name":"global?","doc":"Returns `true` if this is a global path (starts with `::`)","summary":"<p>Returns <code>true</code> if this is a global path (starts with <code>::</code>)</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1219","def":{"name":"global?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"names:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","html_id":"names:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","name":"names","doc":"Returns an array with each separate part of this path.","summary":"<p>Returns an array with each separate part of this path.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(MacroId)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1215","def":{"name":"names","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"id":"resolve:ASTNode-instance-method","html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this path to a `TypeNode` if it denotes a type, to\nthe value of a constant if it denotes a constant, or otherwise\ngives a compile-time error.","summary":"<p>Resolves this path to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, to the value of a constant if it denotes a constant, or otherwise gives a compile-time error.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1225","def":{"name":"resolve","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"resolve?:ASTNode|NilLiteral-instance-method","html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this path to a `TypeNode` if it denotes a type, to\nthe value of a constant if it denotes a constant, or otherwise\nreturns a `NilLiteral`.","summary":"<p>Resolves this path to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, to the value of a constant if it denotes a constant, or otherwise returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code>.</p>","abstract":false,"args":[],"args_string":" : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1231","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1231","def":{"name":"resolve?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/PointerOf","path":"Crystal/Macros/PointerOf.html","kind":"class","full_name":"Crystal::Macros::PointerOf","name":"PointerOf","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1119,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `pointerof` expression.","summary":"<p>A <code>pointerof</code> expression.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcLiteral","path":"Crystal/Macros/ProcLiteral.html","kind":"class","full_name":"Crystal::Macros::ProcLiteral","name":"ProcLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1310,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A proc method, written like:\n```\n->(arg : String) {\n  puts arg\n}\n```","summary":"<p>A proc method, written like: <code></code>` ->(arg : String) {   puts arg } <code></code>`</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","html_id":"args:Crystal::Macros::ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this proc.","summary":"<p>Returns the arguments of this proc.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(Arg)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1312","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1312","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this proc.","summary":"<p>Returns the body of this proc.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1316","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1316","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcNotation","path":"Crystal/Macros/ProcNotation.html","kind":"class","full_name":"Crystal::Macros::ProcNotation","name":"ProcNotation","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1021,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The type of a proc or block argument, like `String -> Int32`.","summary":"<p>The type of a proc or block argument, like <code><a href=\"../../String.html\">String</a> -> <a href=\"../../Int32.html\">Int32</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"inputs:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"inputs:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"inputs","doc":"Returns the argument types, or an empty list if no arguments.","summary":"<p>Returns the argument types, or an empty list if no arguments.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1023","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1023","def":{"name":"inputs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"id":"output:ASTNode|NilLiteral-instance-method","html_id":"output:ASTNode|NilLiteral-instance-method","name":"output","doc":"Returns the output type, or nil if there is no return type.","summary":"<p>Returns the output type, or nil if there is no return type.</p>","abstract":false,"args":[],"args_string":" : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1027","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1027","def":{"name":"output","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ProcPointer","path":"Crystal/Macros/ProcPointer.html","kind":"class","full_name":"Crystal::Macros::ProcPointer","name":"ProcPointer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1321,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A proc pointer, like `->my_var.some_method(String)`","summary":"<p>A proc pointer, like <code>->my_var.some_method(String)</code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"args:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"args:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"args","doc":"Returns the types of the arguments of the proc.","summary":"<p>Returns the types of the arguments of the proc.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1323","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1323","def":{"name":"args","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of the method this proc points to.","summary":"<p>Returns the name of the method this proc points to.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1331","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1331","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"obj:ASTNode|NilLiteral-instance-method","html_id":"obj:ASTNode|NilLiteral-instance-method","name":"obj","doc":"Returns the receiver of the proc, or nil if the proc is not attached to an object.","summary":"<p>Returns the receiver of the proc, or nil if the proc is not attached to an object.</p>","abstract":false,"args":[],"args_string":" : ASTNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1327","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1327","def":{"name":"obj","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RangeLiteral","path":"Crystal/Macros/RangeLiteral.html","kind":"class","full_name":"Crystal::Macros::RangeLiteral","name":"RangeLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":749,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A range literal.","summary":"<p>A range literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"begin:ASTNode-instance-method","html_id":"begin:ASTNode-instance-method","name":"begin","doc":"Similar to `Range#begin`","summary":"<p>Similar to <code><a href=\"../../Range.html#begin%3AB-instance-method\">Range#begin</a></code></p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L751","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L751","def":{"name":"begin","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"end:ASTNode-instance-method","html_id":"end:ASTNode-instance-method","name":"end","doc":"Similar to `Range#end`","summary":"<p>Similar to <code><a href=\"../../Range.html#end%3AE-instance-method\">Range#end</a></code></p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L755","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L755","def":{"name":"end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"excludes_end?:ASTNode-instance-method","html_id":"excludes_end?:ASTNode-instance-method","name":"excludes_end?","doc":"Similar to `Range#excludes_end?`","summary":"<p>Similar to <code><a href=\"../../Range.html#excludes_end%3F-instance-method\">Range#excludes_end?</a></code></p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L759","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L759","def":{"name":"excludes_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"map:ArrayLiteral-instance-method","html_id":"map:ArrayLiteral-instance-method","name":"map","doc":"Similar to `Enumerable#map` for a `Range`.\nOnly works on ranges of `NumberLiteral`s considered as integers.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#map%28%26block%3AT-%3EU%29forallU-instance-method\">Enumerable#map</a></code> for a <code><a href=\"../../Range.html\">Range</a></code>.</p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L764","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L764","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"id":"to_a:ArrayLiteral-instance-method","html_id":"to_a:ArrayLiteral-instance-method","name":"to_a","doc":"Similar to `Enumerable#to_a` for a `Range`.\nOnly works on ranges of `NumberLiteral`s considered as integers.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#to_a-instance-method\">Enumerable#to_a</a></code> for a <code><a href=\"../../Range.html\">Range</a></code>.</p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L769","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L769","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ReadInstanceVar","path":"Crystal/Macros/ReadInstanceVar.html","kind":"class","full_name":"Crystal::Macros::ReadInstanceVar","name":"ReadInstanceVar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":954,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Access to an instance variable, e.g. `obj.@var`.","summary":"<p>Access to an instance variable, e.g.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of the instance variable being accessed.","summary":"<p>Returns the name of the instance variable being accessed.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L960","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L960","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"obj:ASTNode-instance-method","html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object whose variable is being accessed.","summary":"<p>Returns the object whose variable is being accessed.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L956","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L956","def":{"name":"obj","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RegexLiteral","path":"Crystal/Macros/RegexLiteral.html","kind":"class","full_name":"Crystal::Macros::RegexLiteral","name":"RegexLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":774,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A regular expression literal.","summary":"<p>A regular expression literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"options:Crystal::Macros::ArrayLiteral(SymbolLiteral)-instance-method","html_id":"options:Crystal::Macros::ArrayLiteral(SymbolLiteral)-instance-method","name":"options","doc":"Similar to `Regex#options`,\nbut returns an array of symbols such as `[:i, :m, :x]`","summary":"<p>Similar to <code><a href=\"../../Regex.html#options%3AOptions-instance-method\">Regex#options</a></code>, but returns an array of symbols such as <code>[:i, :m, :x]</code></p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(SymbolLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L781","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L781","def":{"name":"options","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(SymbolLiteral)","visibility":"Public","body":""}},{"id":"source:StringLiteral|StringInterpolation-instance-method","html_id":"source:StringLiteral|StringInterpolation-instance-method","name":"source","doc":"Similar to `Regex#source`.","summary":"<p>Similar to <code><a href=\"../../Regex.html#source%3AString-instance-method\">Regex#source</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral | StringInterpolation","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L776","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L776","def":{"name":"source","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral | StringInterpolation","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Require","path":"Crystal/Macros/Require.html","kind":"class","full_name":"Crystal::Macros::Require","name":"Require","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1168,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `require` statement.","summary":"<p>A <code>require</code> statement.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"path:StringLiteral-instance-method","html_id":"path:StringLiteral-instance-method","name":"path","doc":"Returns the argument of the `require`.","summary":"<p>Returns the argument of the <code>require</code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1170","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/RespondsTo","path":"Crystal/Macros/RespondsTo.html","kind":"class","full_name":"Crystal::Macros::RespondsTo","name":"RespondsTo","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1157,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `.responds_to?` call.","summary":"<p>A <code>.responds_to?</code> call.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"name:StringLiteral-instance-method","html_id":"name:StringLiteral-instance-method","name":"name","doc":"Returns the method name that is being checked for.","summary":"<p>Returns the method name that is being checked for.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1163","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"receiver:ASTNode-instance-method","html_id":"receiver:ASTNode-instance-method","name":"receiver","doc":"Returns this call's receiver.","summary":"<p>Returns this call's receiver.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1159","def":{"name":"receiver","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/SizeOf","path":"Crystal/Macros/SizeOf.html","kind":"class","full_name":"Crystal::Macros::SizeOf","name":"SizeOf","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1123,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `sizeof` expression.","summary":"<p>A <code>sizeof</code> expression.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Splat","path":"Crystal/Macros/Splat.html","kind":"class","full_name":"Crystal::Macros::Splat","name":"Splat","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1446,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A splat expression: `*exp`.","summary":"<p>A splat expression: <code>*exp</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"exp:ASTNode-instance-method","html_id":"exp:ASTNode-instance-method","name":"exp","doc":"Returns the splatted expression.","summary":"<p>Returns the splatted expression.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1448","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1448","def":{"name":"exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/StringInterpolation","path":"Crystal/Macros/StringInterpolation.html","kind":"class","full_name":"Crystal::Macros::StringInterpolation","name":"StringInterpolation","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":433,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An interpolated string like `\"Hello, #{name}!\"`.","summary":"<p>An interpolated string like <code>\"Hello, #{name}!\"</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"expressions:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"expressions:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"expressions","doc":"Returns a list of expressions that comprise the interpolated string.\n\nThese alternate between `StringLiteral` for the plaintext parts and\n`ASTNode`s of any type for the interpolated expressions.","summary":"<p>Returns a list of expressions that comprise the interpolated string.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L438","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L438","def":{"name":"expressions","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/StringLiteral","path":"Crystal/Macros/StringLiteral.html","kind":"class","full_name":"Crystal::Macros::StringLiteral","name":"StringLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":330,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A string literal.","summary":"<p>A string literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"+(other:StringLiteral|CharLiteral):StringLiteral-instance-method","html_id":"+(other:StringLiteral|CharLiteral):StringLiteral-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28char%3AChar%29-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L352","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L352","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"<(other:StringLiteral|MacroId):BoolLiteral-instance-method","html_id":"&lt;(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":"<","doc":"Similar to `String#<`","summary":"<p>Similar to <code>String#<</code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L348","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L348","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | MacroId"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"=~(range:RegexLiteral):BoolLiteral-instance-method","html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L340","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L340","def":{"name":"=~","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":">(other:StringLiteral|MacroId):BoolLiteral-instance-method","html_id":"&gt;(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":">","doc":"Similar to `String#>`","summary":"<p>Similar to <code>String#></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L344","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L344","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | MacroId"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"[](range:RangeLiteral):StringLiteral-instance-method","html_id":"[](range:RangeLiteral):StringLiteral-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L336","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L336","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"camelcase:StringLiteral-instance-method","html_id":"camelcase:StringLiteral-instance-method","name":"camelcase","doc":"Similar to `String#camelcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#camelcase-instance-method\">String#camelcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L356","def":{"name":"camelcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"capitalize:StringLiteral-instance-method","html_id":"capitalize:StringLiteral-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L360","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L360","def":{"name":"capitalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","html_id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars-instance-method\">String#chars</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(CharLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L364","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L364","def":{"name":"chars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"id":"chomp:StringLiteral-instance-method","html_id":"chomp:StringLiteral-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp-instance-method\">String#chomp</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L368","def":{"name":"chomp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"downcase:StringLiteral-instance-method","html_id":"downcase:StringLiteral-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#downcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L372","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L372","def":{"name":"downcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F-instance-method\">String#empty?</a></code>.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L376","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L376","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28char%3AChar%29-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L380","def":{"name":"ends_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"gsub(regex:RegexLiteral,replacement:StringLiteral):StringLiteral-instance-method","html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):StringLiteral-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L384","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L384","def":{"name":"gsub","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this string's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this string's contents.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L332","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L332","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L388","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L388","def":{"name":"includes?","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L396","def":{"name":"lines","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size-instance-method\">String#size</a></code>.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L392","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L404","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L404","def":{"name":"split","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L400","def":{"name":"split","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28re%3ARegex%29-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L408","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L408","def":{"name":"starts_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"strip:StringLiteral-instance-method","html_id":"strip:StringLiteral-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip-instance-method\">String#strip</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L412","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L412","def":{"name":"strip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"to_i(base=10)-instance-method","html_id":"to_i(base=10)-instance-method","name":"to_i","doc":"Similar to `String#to_i`.","summary":"<p>Similar to <code><a href=\"../../String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">String#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L416","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L416","def":{"name":"to_i","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"tr(from:StringLiteral,to:StringLiteral):StringLiteral-instance-method","html_id":"tr(from:StringLiteral,to:StringLiteral):StringLiteral-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L420","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L420","def":{"name":"tr","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"underscore:StringLiteral-instance-method","html_id":"underscore:StringLiteral-instance-method","name":"underscore","doc":"Similar to `String#underscore`.","summary":"<p>Similar to <code><a href=\"../../String.html#underscore-instance-method\">String#underscore</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L424","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L424","def":{"name":"underscore","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}},{"id":"upcase:StringLiteral-instance-method","html_id":"upcase:StringLiteral-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#upcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : StringLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L428","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L428","def":{"name":"upcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"StringLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/SymbolLiteral","path":"Crystal/Macros/SymbolLiteral.html","kind":"class","full_name":"Crystal::Macros::SymbolLiteral","name":"SymbolLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":443,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A symbol literal.","summary":"<p>A symbol literal.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"+(other:StringLiteral|CharLiteral):SymbolLiteral-instance-method","html_id":"+(other:StringLiteral|CharLiteral):SymbolLiteral-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28char%3AChar%29-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L457","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L457","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"=~(range:RegexLiteral):BoolLiteral-instance-method","html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L453","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L453","def":{"name":"=~","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RegexLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"[](range:RangeLiteral):SymbolLiteral-instance-method","html_id":"[](range:RangeLiteral):SymbolLiteral-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L449","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"RangeLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"capitalize:SymbolLiteral-instance-method","html_id":"capitalize:SymbolLiteral-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L461","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L461","def":{"name":"capitalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","html_id":"chars:Crystal::Macros::ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars-instance-method\">String#chars</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(CharLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L465","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L465","def":{"name":"chars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"id":"chomp:SymbolLiteral-instance-method","html_id":"chomp:SymbolLiteral-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp-instance-method\">String#chomp</a></code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L469","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L469","def":{"name":"chomp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"downcase:SymbolLiteral-instance-method","html_id":"downcase:SymbolLiteral-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#downcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L473","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L473","def":{"name":"downcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"empty?:BoolLiteral-instance-method","html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F-instance-method\">String#empty?</a></code>.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L477","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L477","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28char%3AChar%29-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L481","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L481","def":{"name":"ends_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"gsub(regex:RegexLiteral,replacement:StringLiteral):SymbolLiteral-instance-method","html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):SymbolLiteral-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L485","def":{"name":"gsub","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this symbol's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this symbol's contents.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L445","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L445","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L489","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L489","def":{"name":"includes?","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"lines:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L497","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L497","def":{"name":"lines","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size-instance-method\">String#size</a></code>.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L493","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L493","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split(node:ASTNode):Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L505","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L505","def":{"name":"split","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"ASTNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","html_id":"split:Crystal::Macros::ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28separator%3AString%2Climit%3Dnil%2C%2A%2Cremove_empty%3Dfalse%2C%26block%3AString-%3E_%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(StringLiteral)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L501","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L501","def":{"name":"split","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28re%3ARegex%29-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L509","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L509","def":{"name":"starts_with?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"strip:SymbolLiteral-instance-method","html_id":"strip:SymbolLiteral-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip-instance-method\">String#strip</a></code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L513","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L513","def":{"name":"strip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"tr(from:StringLiteral,to:StringLiteral):SymbolLiteral-instance-method","html_id":"tr(from:StringLiteral,to:StringLiteral):SymbolLiteral-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L517","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L517","def":{"name":"tr","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"StringLiteral"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"StringLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"id":"upcase:SymbolLiteral-instance-method","html_id":"upcase:SymbolLiteral-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3DUnicode%3A%3ACaseOptions%3A%3ANone%29-instance-method\">String#upcase</a></code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L521","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L521","def":{"name":"upcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TupleLiteral","path":"Crystal/Macros/TupleLiteral.html","kind":"class","full_name":"Crystal::Macros::TupleLiteral","name":"TupleLiteral","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":788,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A tuple literal.\n\nIt's macro methods are the same as `ArrayLiteral`","summary":"<p>A tuple literal.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TypeDeclaration","path":"Crystal/Macros/TypeDeclaration.html","kind":"class","full_name":"Crystal::Macros::TypeDeclaration","name":"TypeDeclaration","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1273,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A type declaration like `x : Int32`","summary":"<p>A type declaration like <code>x : <a href=\"../../Int32.html\">Int32</a></code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"type:ASTNode-instance-method","html_id":"type:ASTNode-instance-method","name":"type","doc":"Returns the type part of the declaration.","summary":"<p>Returns the type part of the declaration.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1279","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1279","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"value:ASTNode|Nop-instance-method","html_id":"value:ASTNode|Nop-instance-method","name":"value","doc":"The value assigned to the variable, if any.","summary":"<p>The value assigned to the variable, if any.</p>","abstract":false,"args":[],"args_string":" : ASTNode | Nop","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1283","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"id":"var:MacroId-instance-method","html_id":"var:MacroId-instance-method","name":"var","doc":"Returns the variable part of the declaration.","summary":"<p>Returns the variable part of the declaration.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1275","def":{"name":"var","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/TypeNode","path":"Crystal/Macros/TypeNode.html","kind":"class","full_name":"Crystal::Macros::TypeNode","name":"TypeNode","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1585,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Represents a type in the program, like `Int32` or `String`.","summary":"<p>Represents a type in the program, like <code><a href=\"../../Int32.html\">Int32</a></code> or <code><a href=\"../../String.html\">String</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<(other:TypeNode):BoolLiteral-instance-method","html_id":"&lt;(other:TypeNode):BoolLiteral-instance-method","name":"<","doc":"Returns `true` if *other* is an ancestor of `self`.","summary":"<p>Returns <code>true</code> if <em>other</em> is an ancestor of <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1727","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1727","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"<=(other:TypeNode):BoolLiteral-instance-method","html_id":"&lt;=(other:TypeNode):BoolLiteral-instance-method","name":"<=","doc":"Returns `true` if `self` is the same as *other* or if\n*other* is an ancestor of `self`.","summary":"<p>Returns <code>true</code> if <code>self</code> is the same as <em>other</em> or if <em>other</em> is an ancestor of <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1732","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":">(other:TypeNode):BoolLiteral-instance-method","html_id":"&gt;(other:TypeNode):BoolLiteral-instance-method","name":">","doc":"Returns `true` if `self` is an ancestor of *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is an ancestor of <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1736","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1736","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":">=(other:TypeNode):BoolLiteral-instance-method","html_id":"&gt;=(other:TypeNode):BoolLiteral-instance-method","name":">=","doc":"Returns `true` if *other* is the same as `self` or if\n`self` is an ancestor of *other*.","summary":"<p>Returns <code>true</code> if <em>other</em> is the same as <code>self</code> or if <code>self</code> is an ancestor of <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1741","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1741","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"[](key:SymbolLiteral|MacroId):TypeNode|NilLiteral-instance-method","html_id":"[](key:SymbolLiteral|MacroId):TypeNode|NilLiteral-instance-method","name":"[]","doc":"Returns the type for the given key in this named tuple type.\nGives a compile error if this is not a named tuple type.","summary":"<p>Returns the type for the given key in this named tuple type.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"SymbolLiteral | MacroId"}],"args_string":"(key : SymbolLiteral | MacroId) : TypeNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1688","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1688","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"SymbolLiteral | MacroId"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}},{"id":"abstract?:BoolLiteral-instance-method","html_id":"abstract?:BoolLiteral-instance-method","name":"abstract?","doc":"Returns `true` if this type is abstract.","summary":"<p>Returns <code>true</code> if this type is abstract.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1587","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1587","def":{"name":"abstract?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"all_subclasses:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","html_id":"all_subclasses:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","name":"all_subclasses","doc":"Returns all subclasses of this type.","summary":"<p>Returns all subclasses of this type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TypeNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1633","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1633","def":{"name":"all_subclasses","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"id":"ancestors:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","html_id":"ancestors:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","name":"ancestors","doc":"Returns all ancestors of this type.","summary":"<p>Returns all ancestors of this type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TypeNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1621","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1621","def":{"name":"ancestors","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"id":"annotation(type:TypeNode):Annotation-instance-method","html_id":"annotation(type:TypeNode):Annotation-instance-method","name":"annotation","doc":"Returns any `Annotation` with the given `type`\nattached to this type.","summary":"<p>Returns any <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code>type</code> attached to this type.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1673","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1673","def":{"name":"annotation","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Annotation","visibility":"Public","body":""}},{"id":"class:TypeNode-instance-method","html_id":"class:TypeNode-instance-method","name":"class","doc":"Returns the class of this type. With this you can, for example, obtain class\nmethods by invoking `type.class.methods`.","summary":"<p>Returns the class of this type.</p>","abstract":false,"args":[],"args_string":" : TypeNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1693","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1693","def":{"name":"class","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TypeNode","visibility":"Public","body":""}},{"id":"constant(name:StringLiteral|SymbolLiteral|MacroId):ASTNode-instance-method","html_id":"constant(name:StringLiteral|SymbolLiteral|MacroId):ASTNode-instance-method","name":"constant","doc":"Returns a constant defined in this type.\n\nIf the constant is a constant (like `A = 1`), then its value\nas an `ASTNode` is returned. If the constant is a type, the\ntype is returned as a `TypeNode`. Otherwise, `NilLiteral` is returned.","summary":"<p>Returns a constant defined in this type.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"args_string":"(name : StringLiteral | SymbolLiteral | MacroId) : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1645","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1645","def":{"name":"constant","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"constants:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","html_id":"constants:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","name":"constants","doc":"Returns the constants and types defined by this type.","summary":"<p>Returns the constants and types defined by this type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(MacroId)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1637","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1637","def":{"name":"constants","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"id":"has_attribute?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","html_id":"has_attribute?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","name":"has_attribute?","doc":"Returns `true` if this type has an attribute. For example `@[Flags]`\nor `@[Packed]` (the name you pass to this method is `\"Flags\"` or `\"Packed\"`\nin these cases).","summary":"<p>Returns <code>true</code> if this type has an attribute.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"args_string":"(name : StringLiteral | SymbolLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1668","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1668","def":{"name":"has_attribute?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"has_constant?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","html_id":"has_constant?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","name":"has_constant?","doc":"Returns `true` if this type has a constant. For example `DEFAULT_OPTIONS`\n(the name you pass to this method is `\"DEFAULT_OPTIONS\"` or `:DEFAULT_OPTIONS`\nin this cases).","summary":"<p>Returns <code>true</code> if this type has a constant.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"args_string":"(name : StringLiteral | SymbolLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1651","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1651","def":{"name":"has_constant?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"has_method?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","html_id":"has_method?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","name":"has_method?","doc":"Returns `true` if this type has a method. For example `default_options`\n(the name you pass to this method is `\"default_options\"` or `:default_options`\nin this cases).","summary":"<p>Returns <code>true</code> if this type has a method.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"args_string":"(name : StringLiteral | SymbolLiteral) : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1662","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1662","def":{"name":"has_method?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"instance:TypeNode-instance-method","html_id":"instance:TypeNode-instance-method","name":"instance","doc":"Returns the instance type of this type, if it's a class type,\nor `self` otherwise. This is the opposite of `#class`.","summary":"<p>Returns the instance type of this type, if it's a class type, or <code>self</code> otherwise.</p>","abstract":false,"args":[],"args_string":" : TypeNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1698","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1698","def":{"name":"instance","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TypeNode","visibility":"Public","body":""}},{"id":"instance_vars:Crystal::Macros::ArrayLiteral(MetaVar)-instance-method","html_id":"instance_vars:Crystal::Macros::ArrayLiteral(MetaVar)-instance-method","name":"instance_vars","doc":"Returns the instance variables of this type.","summary":"<p>Returns the instance variables of this type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(MetaVar)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1617","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1617","def":{"name":"instance_vars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(MetaVar)","visibility":"Public","body":""}},{"id":"keys:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","html_id":"keys:Crystal::Macros::ArrayLiteral(MacroId)-instance-method","name":"keys","doc":"Returns the keys in this named tuple type.\nGives a compile error if this is not a named tuple type.","summary":"<p>Returns the keys in this named tuple type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(MacroId)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1683","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1683","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"id":"methods:Crystal::Macros::ArrayLiteral(Def)-instance-method","html_id":"methods:Crystal::Macros::ArrayLiteral(Def)-instance-method","name":"methods","doc":"Returns the instance methods defined by this type, without including\ninherited methods.","summary":"<p>Returns the instance methods defined by this type, without including inherited methods.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(Def)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1656","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1656","def":{"name":"methods","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(Def)","visibility":"Public","body":""}},{"id":"name:MacroId-instance-method","html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the fully qualified name of this type.","summary":"<p>Returns the fully qualified name of this type.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1608","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1608","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}},{"id":"nilable?:BoolLiteral-instance-method","html_id":"nilable?:BoolLiteral-instance-method","name":"nilable?","doc":"Returns `true` if this type is nilable (if it has `Nil` amongst its types).","summary":"<p>Returns <code>true</code> if this type is nilable (if it has <code><a href=\"../../Nil.html\">Nil</a></code> amongst its types).</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1597","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1597","def":{"name":"nilable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"overrides?(type:TypeNode,method:StringLiteral|SymbolLiteral|MacroId):Bool-instance-method","html_id":"overrides?(type:TypeNode,method:StringLiteral|SymbolLiteral|MacroId):Bool-instance-method","name":"overrides?","doc":"Determines if `self` overrides any method named *method* from type *type*.\n\n```\nclass Foo\n  def one\n    1\n  end\n\n  def two\n    2\n  end\nend\n\nclass Bar < Foo\n  def one\n    11\n  end\nend\n\n{{ Bar.overrides?(Foo, \"one\") }} # => true\n{{ Bar.overrides?(Foo, \"two\") }} # => false\n```","summary":"<p>Determines if <code>self</code> overrides any method named <em>method</em> from type <em>type</em>.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"args_string":"(type : TypeNode, method : StringLiteral | SymbolLiteral | MacroId) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1723","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1723","def":{"name":"overrides?","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"TypeNode"},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":""}},{"id":"size:NumberLiteral-instance-method","html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Returns the number of elements in this tuple type or tuple metaclass type.\nGives a compile error if this is not one of those types.","summary":"<p>Returns the number of elements in this tuple type or tuple metaclass type.</p>","abstract":false,"args":[],"args_string":" : NumberLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1678","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1678","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"NumberLiteral","visibility":"Public","body":""}},{"id":"subclasses:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","html_id":"subclasses:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","name":"subclasses","doc":"Returns the direct subclasses of this type.","summary":"<p>Returns the direct subclasses of this type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TypeNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1629","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1629","def":{"name":"subclasses","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"id":"superclass:TypeNode|NilLiteral-instance-method","html_id":"superclass:TypeNode|NilLiteral-instance-method","name":"superclass","doc":"Returns the direct superclass of this type.","summary":"<p>Returns the direct superclass of this type.</p>","abstract":false,"args":[],"args_string":" : TypeNode | NilLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1625","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1625","def":{"name":"superclass","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}},{"id":"type_vars:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","html_id":"type_vars:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","name":"type_vars","doc":"Returns the type variables of the generic type. If the type is not\ngeneric, an empty array is returned.","summary":"<p>Returns the type variables of the generic type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TypeNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1613","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1613","def":{"name":"type_vars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"id":"union?:BoolLiteral-instance-method","html_id":"union?:BoolLiteral-instance-method","name":"union?","doc":"Returns `true` if this type is a union type, `false` otherwise.\n\nSee also: `union_types`.","summary":"<p>Returns <code>true</code> if this type is a union type, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":" : BoolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1593","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1593","def":{"name":"union?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"id":"union_types:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","html_id":"union_types:Crystal::Macros::ArrayLiteral(TypeNode)-instance-method","name":"union_types","doc":"Returns the types comforming a union type, if this is a union type.\nGives a compile error otherwise.\n\nSee also: `union?`.","summary":"<p>Returns the types comforming a union type, if this is a union type.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(TypeNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1604","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1604","def":{"name":"union_types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UnaryExpression","path":"Crystal/Macros/UnaryExpression.html","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1108,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/InstanceSizeOf","kind":"class","full_name":"Crystal::Macros::InstanceSizeOf","name":"InstanceSizeOf"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Not","kind":"class","full_name":"Crystal::Macros::Not","name":"Not"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Out","kind":"class","full_name":"Crystal::Macros::Out","name":"Out"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/PointerOf","kind":"class","full_name":"Crystal::Macros::PointerOf","name":"PointerOf"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/SizeOf","kind":"class","full_name":"Crystal::Macros::SizeOf","name":"SizeOf"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An unary expression","summary":"<p>An unary expression</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"exp:ASTNode-instance-method","html_id":"exp:ASTNode-instance-method","name":"exp","doc":"Returns the expression that this unary operation is applied to.","summary":"<p>Returns the expression that this unary operation is applied to.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1110","def":{"name":"exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/UninitializedVar","path":"Crystal/Macros/UninitializedVar.html","kind":"class","full_name":"Crystal::Macros::UninitializedVar","name":"UninitializedVar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1288,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An uninitialized variable declaration: `a = uninitialized Int32`","summary":"<p>An uninitialized variable declaration: <code>a = uninitialized <a href=\"../../Int32.html\">Int32</a></code></p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"type:ASTNode-instance-method","html_id":"type:ASTNode-instance-method","name":"type","doc":"Returns the type part of the declaration.","summary":"<p>Returns the type part of the declaration.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1294","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"var:MacroId-instance-method","html_id":"var:MacroId-instance-method","name":"var","doc":"Returns the variable part of the declaration.","summary":"<p>Returns the variable part of the declaration.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1290","def":{"name":"var","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Union","path":"Crystal/Macros/Union.html","kind":"class","full_name":"Crystal::Macros::Union","name":"Union","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1336,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A type union, like `(Int32 | String)`.","summary":"<p>A type union, like <code>(<a href=\"../../Int32.html\">Int32</a> | <a href=\"../../String.html\">String</a>)</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"types:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","html_id":"types:Crystal::Macros::ArrayLiteral(ASTNode)-instance-method","name":"types","doc":"Returns the types of this union.","summary":"<p>Returns the types of this union.</p>","abstract":false,"args":[],"args_string":" : Crystal::Macros::ArrayLiteral(ASTNode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1338","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1338","def":{"name":"types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/Var","path":"Crystal/Macros/Var.html","kind":"class","full_name":"Crystal::Macros::Var","name":"Var","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":836,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A local variable or block argument.","summary":"<p>A local variable or block argument.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"id:MacroId-instance-method","html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this var's name as a `MacroId`.","summary":"<p>Returns this var's name as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[],"args_string":" : MacroId","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L838","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L838","def":{"name":"id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MacroId","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/VisibilityModifier","path":"Crystal/Macros/VisibilityModifier.html","kind":"class","full_name":"Crystal::Macros::VisibilityModifier","name":"VisibilityModifier","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1135,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A visibility modifier","summary":"<p>A visibility modifier</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"exp:ASTNode-instance-method","html_id":"exp:ASTNode-instance-method","name":"exp","doc":"Returns the expression that the modifier is applied to.","summary":"<p>Returns the expression that the modifier is applied to.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1141","def":{"name":"exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"visibility:SymbolLiteral-instance-method","html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this modifier: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this modifier: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"args":[],"args_string":" : SymbolLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1137","def":{"name":"visibility","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SymbolLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/When","path":"Crystal/Macros/When.html","kind":"class","full_name":"Crystal::Macros::When","name":"When","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1175,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `when` inside a `case`.","summary":"<p>A <code>when</code> inside a <code>case</code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this `when`.","summary":"<p>Returns the body of this <code>when</code>.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1181","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"conds:ArrayLiteral-instance-method","html_id":"conds:ArrayLiteral-instance-method","name":"conds","doc":"Returns the conditions of this `when`.","summary":"<p>Returns the conditions of this <code>when</code>.</p>","abstract":false,"args":[],"args_string":" : ArrayLiteral","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1177","def":{"name":"conds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArrayLiteral","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/While","path":"Crystal/Macros/While.html","kind":"class","full_name":"Crystal::Macros::While","name":"While","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"compiler/crystal/macros.cr","line_number":1244,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `while` expression","summary":"<p>A <code>while</code> expression</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"body:ASTNode-instance-method","html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns this while's body.","summary":"<p>Returns this while's body.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1250","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}},{"id":"cond:ASTNode-instance-method","html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns this while's condition.","summary":"<p>Returns this while's condition.</p>","abstract":false,"args":[],"args_string":" : ASTNode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/compiler/crystal/macros.cr#L1246","def":{"name":"cond","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ASTNode","visibility":"Public","body":""}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/CSV","path":"CSV.html","kind":"class","full_name":"CSV","name":"CSV","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv.cr","line_number":58,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr"},{"filename":"csv/error.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEFAULT_QUOTE_CHAR","name":"DEFAULT_QUOTE_CHAR","value":"'\"'","doc":null,"summary":null},{"id":"DEFAULT_SEPARATOR","name":"DEFAULT_SEPARATOR","value":"','","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Provides methods and classes for parsing and generating CSV\n(comma-separated values) strings.\n\nThis module conforms to [RFC 4180](https://tools.ietf.org/html/rfc4180).\n\n### Parsing\n\nSeveral ways of parsing CSV are provided. The most straight-forward, but\nslow or inefficient for some scenarios, is `CSV#parse`, which returns\nan array of arrays of all data.\n\nRows can be traversed in a linear fashion with `CSV#each_row`, or\nusing an `Iterator`.\n\nTo parse a CSV in an efficient way, optionally being able to access\nrow values from header names, create an instance of a `CSV`.\n\n### Parsing with `CSV#new`\n\nA CSV instance holds a cursor to the current row in the CSV. The cursor\nis advanced by invoking `#next`, which returns `true` if a next row was found,\nand `false` otherwise. A first call to `#next` is required to position the\ncsv parser in the first row.\n\nOnce positioned in a row, values can be obtained with the several `#[]` methods,\nwhich can accept a header name, column position, or header name pattern as a `Regex`.\n\nAdditionally, a `Row` object can be obtained with the `#row` method which\nprovides similar methods and can be converted to an `Array` or `Hash`.\n\n### Example\n\n```\nrequire \"csv\"\n\ncsv = CSV.new(\"Name, Age\\nJohn, 20\\nPeter, 30\", headers: true)\ncsv.next # => true\n\ncsv[\"Name\"]  # => \"John\"\ncsv[0]       # => \"John\"\ncsv[-2]      # => \"John\"\ncsv[/name/i] # => \"John\"\n\ncsv[\"Age\"] # => \" 20\"\n\ncsv.row.to_a # => [\"John\", \" 20\"]\ncsv.row.to_h # => {\"Name\" => \"John\", \"Age\" => \" 20\"}\n\ncsv.next    # => true\ncsv[\"Name\"] # => \"Peter\"\n\ncsv.next # => false\n```\n\n### Building\n\nTo create CSV data, check `CSV#build` and the `CSV::Builder` class.","summary":"<p>Provides methods and classes for parsing and generating CSV (comma-separated values) strings.</p>","class_methods":[{"id":"build(separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&block):String-class-method","html_id":"build(separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&amp;block):String-class-method","name":"build","doc":"Builds a CSV. This yields a `CSV::Builder` to the given block.\n\n```\nresult = CSV.build do |csv|\n  csv.row \"one\", \"two\"\n  csv.row \"three\"\nend\nresult # => \"one,two\\nthree\\n\"\n```","summary":"<p>Builds a CSV.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L121","def":{"name":"build","args":[{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  build(io, separator, quote_char) do |builder|\n    yield builder\n  end\nend"}},{"id":"build(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&block)-class-method","html_id":"build(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&amp;block)-class-method","name":"build","doc":"Appends CSV data to the given `IO`. This yields a `CSV::Builder`\nthat writes to the given `IO`.\n\n```\nio = IO::Memory.new\nio.puts \"HEADER\"\nCSV.build(io) do |csv|\n  csv.row \"one\", \"two\"\n  csv.row \"three\"\nend\nio.to_s # => \"HEADER\\none,two\\nthree\\n\"\n```","summary":"<p>Appends CSV data to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(io : IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L139","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"builder = Builder.new(io, separator, quote_char)\nyield builder\n"}},{"id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&block)-class-method","html_id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&amp;block)-class-method","name":"each_row","doc":"Yields each of a CSV's rows as an `Array(String)`.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.\n\n```\nCSV.each_row(\"one,two\\nthree\") do |row|\n  puts row\nend\n```\n\nOutput:\n\n```\n[\"one\", \"two\"]\n[\"three\"]\n```","summary":"<p>Yields each of a CSV's rows as an <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code>.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L93","def":{"name":"each_row","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).each_row do |row|\n  yield row\nend"}},{"id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"each_row","doc":"Returns an `Iterator` of `Array(String)` over a CSV's rows.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.\n\n```\nrows = CSV.each_row(\"one,two\\nthree\")\nrows.next # => [\"one\", \"two\"]\nrows.next # => [\"three\"]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> of <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code> over a CSV's rows.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L108","def":{"name":"each_row","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).each_row"}},{"id":"parse(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR):Array(Array(String))-class-method","html_id":"parse(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR):Array(Array(String))-class-method","name":"parse","doc":"Parses a CSV or `IO` into an array.\n\nTakes optional *separator* and *quote_char* arguments for defining\nnon-standard csv cell separators and quote characters.\n\n```\nCSV.parse(\"one,two\\nthree\")\n# => [[\"one\", \"two\"], [\"three\"]]\nCSV.parse(\"one;two\\n'three;'\", separator: ';', quote_char: '\\'')\n# => [[\"one\", \"two\"], [\"three;\"]]\n```","summary":"<p>Parses a CSV or <code><a href=\"IO.html\">IO</a></code> into an array.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>) : Array(Array(String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L73","def":{"name":"parse","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Array(String))","visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).parse"}}],"constructors":[{"id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a new instance from the given `String` or `IO`.\n\n* If *strip* is `true`, row values are stripped with `String#strip` before being\nreturned from methods.\n* If *headers* is `true`, row values can be accessed with header names or patterns.\nHeaders are always stripped.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.","summary":"<p>Creates a new instance from the given <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","doc":null,"default_value":"false","external_name":"headers","restriction":""},{"name":"strip","doc":null,"default_value":"false","external_name":"strip","restriction":""},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, headers = <span class=\"n\">false</span>, strip = <span class=\"n\">false</span>, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L155","def":{"name":"new","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","doc":null,"default_value":"false","external_name":"headers","restriction":""},{"name":"strip","doc":null,"default_value":"false","external_name":"strip","restriction":""},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io, headers, strip, separator, quote_char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&block)-class-method","html_id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&amp;block)-class-method","name":"new","doc":"Creates a new instance from the given `String` or `IO`, and yields it to\nthe given block once for each row in the CSV.\n\n* If *strip* is `true`, row values are stripped with `String#strip` before being\nreturned from methods.\n* If *headers* is `true`, row values can be accessed with header names or patterns.\nHeaders are always stripped.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.","summary":"<p>Creates a new instance from the given <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code>, and yields it to the given block once for each row in the CSV.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","doc":null,"default_value":"false","external_name":"headers","restriction":""},{"name":"strip","doc":null,"default_value":"false","external_name":"strip","restriction":""},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, headers = <span class=\"n\">false</span>, strip = <span class=\"n\">false</span>, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L177","def":{"name":"new","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","doc":null,"default_value":"false","external_name":"headers","restriction":""},{"name":"strip","doc":null,"default_value":"false","external_name":"strip","restriction":""},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"csv = new(string_or_io, headers, strip, separator, quote_char)\ncsv.each do\n  yield csv\nend\ncsv\n"}}],"instance_methods":[{"id":"[](header:String):String-instance-method","html_id":"[](header:String):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header* name.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L218","def":{"name":"[]","args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"row_internal[header]"}},{"id":"[](column:Int):String-instance-method","html_id":"[](column:Int):String-instance-method","name":"[]","doc":"Returns the current row's value at the given column index.\nA negative index counts from the end.\nRaises `IndexError` if no such column exists.","summary":"<p>Returns the current row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L232","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L232","def":{"name":"[]","args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"row_internal[column]"}},{"id":"[](header_pattern:Regex):String-instance-method","html_id":"[](header_pattern:Regex):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header_pattern*.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L246","def":{"name":"[]","args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"row_internal[header_pattern]"}},{"id":"[]?(header:String):String?-instance-method","html_id":"[]?(header:String):String?-instance-method","name":"[]?","doc":"Returns the current row's value corresponding to the given *header* name.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L225","def":{"name":"[]?","args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[header]?"}},{"id":"[]?(column:Int):String?-instance-method","html_id":"[]?(column:Int):String?-instance-method","name":"[]?","doc":"Returns the current row's value at the given column index.\nA negative index counts from the end.\nReturns `nil` if no such column exists.","summary":"<p>Returns the current row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L239","def":{"name":"[]?","args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[column]?"}},{"id":"[]?(header_pattern:Regex):String?-instance-method","html_id":"[]?(header_pattern:Regex):String?-instance-method","name":"[]?","doc":"Returns the current row's value corresponding to the given *header_pattern*.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L253","def":{"name":"[]?","args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[header_pattern]?"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Invokes the block once for each row in this CSV, yielding `self`.","summary":"<p>Invokes the block once for each row in this CSV, yielding <code>self</code>.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L192","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while self.next\n  yield self\nend"}},{"id":"headers:Array(String)-instance-method","html_id":"headers:Array(String)-instance-method","name":"headers","doc":"Returns this CSV headers. Their values are always stripped.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this CSV headers.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L187","def":{"name":"headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"@headers || (raise(Error.new(\"Headers not requested\")))"}},{"id":"next-instance-method","html_id":"next-instance-method","name":"next","doc":"Advanced the cursor to the next row. Must be called once to position\nthe cursor in the first row. Returns `true` if a next row was found,\n`false` otherwise.","summary":"<p>Advanced the cursor to the next row.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L201","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @traversed\n  return false\nend\nrow = @row || (@row = [] of String)\nrow.clear\n@row = @parser.next_row(row)\nif @row\n  true\nelse\n  @traversed = true\n  false\nend\n"}},{"id":"row:Row-instance-method","html_id":"row:Row-instance-method","name":"row","doc":"Returns the current row as a `Row` instance.","summary":"<p>Returns the current row as a <code><a href=\"CSV/Row.html\">Row</a></code> instance.</p>","abstract":false,"args":[],"args_string":" : Row","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L274","def":{"name":"row","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Row","visibility":"Public","body":"Row.new(self, current_row.dup)"}},{"id":"values_at(*columns:Int)-instance-method","html_id":"values_at(*columns:Int)-instance-method","name":"values_at","doc":"Returns a tuple of the current row's values at given indices\nA negative index counts from the end.\nRaises `IndexError` if any column doesn't exist\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of the current row's values at given indices A negative index counts from the end.</p>","abstract":false,"args":[{"name":"columns","doc":null,"default_value":"","external_name":"columns","restriction":"Int"}],"args_string":"(*columns : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L261","def":{"name":"values_at","args":[{"name":"columns","doc":null,"default_value":"","external_name":"columns","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"columns.map do |column|\n  row_internal[column]\nend"}},{"id":"values_at(*headers:String)-instance-method","html_id":"values_at(*headers:String)-instance-method","name":"values_at","doc":"Returns a tuple of the current row's values corresponding to the given *headers*\nRaises `KeyError` if any header doesn't exist.\nRaises `CSV::Error` if headers were not requested\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of the current row's values corresponding to the given <em>headers</em> Raises <code><a href=\"KeyError.html\">KeyError</a></code> if any header doesn't exist.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"String"}],"args_string":"(*headers : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L269","def":{"name":"values_at","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers.map do |header|\n  row_internal[header]\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/CSV/Builder","path":"CSV/Builder.html","kind":"class","full_name":"CSV::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/builder.cr","line_number":37,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV Builder writes CSV to an `IO`.\n\n```\nrequire \"csv\"\n\nresult = CSV.build do |csv|\n  # A row can be written by specifying several values\n  csv.row \"Hello\", 1, 'a', \"String with \\\"quotes\\\"\"\n\n  # Or an enumerable\n  csv.row [1, 2, 3]\n\n  # Or using a block, and appending to the row\n  csv.row do |row|\n    # Appending a single value\n    row << 4\n\n    # Or multiple values\n    row.concat 5, 6\n\n    # Or an enumerable\n    row.concat [7, 8]\n  end\nend\nputs result\n```\n\nOutput:\n\n```text\nHello,1,a,\"String with \"\"quotes\"\"\"\n1,2,3\n4,5,6,7,8\n```","summary":"<p>A CSV Builder writes CSV to an <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"new(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a builder that will write to the given `IO`.","summary":"<p>Creates a builder that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(io : IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L39","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, separator, quote_char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"row(&block)-instance-method","html_id":"row(&amp;block)-instance-method","name":"row","doc":"Yields a `CSV::Row` to append a row. A newline is appended\nto `IO` after the block exits.","summary":"<p>Yields a <code><a href=\"../CSV/Row.html\">CSV::Row</a></code> to append a row.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L45","def":{"name":"row","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"yield Row.new(self, @separator, @quote_char)\n@io << '\\n'\n@first_cell_in_row = true\n"}},{"id":"row(values:Enumerable)-instance-method","html_id":"row(values:Enumerable)-instance-method","name":"row","doc":"Appends the given values as a single row, and then a newline.","summary":"<p>Appends the given values as a single row, and then a newline.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Enumerable"}],"args_string":"(values : Enumerable)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L52","def":{"name":"row","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"row do |row|\n  values.each do |value|\n    row << value\n  end\nend"}},{"id":"row(*values)-instance-method","html_id":"row(*values)-instance-method","name":"row","doc":"Appends the given values as a single row, and then a newline.","summary":"<p>Appends the given values as a single row, and then a newline.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"args_string":"(*values)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L61","def":{"name":"row","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"row(values)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/CSV/Builder/Row","path":"CSV/Builder/Row.html","kind":"struct","full_name":"CSV::Builder::Row","name":"Row","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/builder.cr","line_number":95,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV/Builder","kind":"class","full_name":"CSV::Builder","name":"Builder"},"doc":"A CSV Row being built.","summary":"<p>A CSV Row being built.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<<(value:String)-instance-method","html_id":"&lt;&lt;(value:String)-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L103","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if needs_quotes?(value)\n  @builder.quote_cell(value)\nelse\n  @builder.cell do |io|\n    io << value\n  end\nend"}},{"id":"<<(value:Nil|Bool|Char|Number|Symbol)-instance-method","html_id":"&lt;&lt;(value:Nil|Bool|Char|Number|Symbol)-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Nil | Bool | Char | Number | Symbol"}],"args_string":"(value : Nil | Bool | Char | Number | Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L112","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Nil | Bool | Char | Number | Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@builder.cell do |io|\n  io << value\nend"}},{"id":"<<(value)-instance-method","html_id":"&lt;&lt;(value)-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L117","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self << value.to_s"}},{"id":"concat(values:Enumerable)-instance-method","html_id":"concat(values:Enumerable)-instance-method","name":"concat","doc":"Appends the given values to this row.","summary":"<p>Appends the given values to this row.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Enumerable"}],"args_string":"(values : Enumerable)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L122","def":{"name":"concat","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"values.each do |value|\n  self << value\nend"}},{"id":"concat(*values)-instance-method","html_id":"concat(*values)-instance-method","name":"concat","doc":"Appends the given values to this row.","summary":"<p>Appends the given values to this row.</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"args_string":"(*values)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L129","def":{"name":"concat","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"concat(values)"}},{"id":"skip_cell-instance-method","html_id":"skip_cell-instance-method","name":"skip_cell","doc":"Appends a comma, thus skipping a cell.","summary":"<p>Appends a comma, thus skipping a cell.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/builder.cr#L134","def":{"name":"skip_cell","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self << nil"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/CSV/Error","path":"CSV/Error.html","kind":"class","full_name":"CSV::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/error.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/CSV/MalformedCSVError","kind":"class","full_name":"CSV::MalformedCSVError","name":"MalformedCSVError"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"Raises when an error related to a CSV is found.","summary":"<p>Raises when an error related to a CSV is found.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CSV/Lexer","path":"CSV/Lexer.html","kind":"class","full_name":"CSV::Lexer","name":"Lexer","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/lexer.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV lexer lets you consume a CSV token by token. You can use this to efficiently\nparse a CSV without the need to allocate intermediate arrays.\n\n```\nrequire \"csv\"\n\nlexer = CSV::Lexer.new \"one,two\\nthree\"\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"one\")\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"two\")\nlexer.next_token # => CSV::Token(@kind=Newline, @value=\"two\")\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"three\")\nlexer.next_token # => CSV::Token(@kind=Eof, @value=\"three\")\n```","summary":"<p>A CSV lexer lets you consume a CSV token by token.</p>","class_methods":[],"constructors":[{"id":"new(string:String,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"new(string:String,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a CSV lexer from a `String`.","summary":"<p>Creates a CSV lexer from a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"args_string":"(string : String, separator = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L18","def":{"name":"new","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StringBased.new(string, separator, quote_char)"}},{"id":"new(io:IO,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"new(io:IO,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a CSV lexer from an `IO`.","summary":"<p>Creates a CSV lexer from an <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"args_string":"(io : IO, separator = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L23","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"IOBased.new(io, separator, quote_char)"}}],"instance_methods":[{"id":"next_token-instance-method","html_id":"next_token-instance-method","name":"next_token","doc":"Returns the next `Token` in this CSV.","summary":"<p>Returns the next <code><a href=\"../CSV/Token.html\">Token</a></code> in this CSV.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L49","def":{"name":"next_token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @last_empty_column\n  @last_empty_column = false\n  @token.kind = Token::Kind::Cell\n  @token.value = \"\"\n  return @token\nend\ncase current_char\nwhen '\\u{0}'\n  @token.kind = Token::Kind::Eof\nwhen @separator\n  @token.kind = Token::Kind::Cell\n  @token.value = \"\"\n  check_last_empty_column\nwhen '\\r'\n  @token.kind = case next_char\n  when '\\u{0}'\n    Token::Kind::Eof\n  when '\\n'\n    case next_char\n    when '\\u{0}'\n      Token::Kind::Eof\n    else\n      Token::Kind::Newline\n    end\n  else\n    Token::Kind::Newline\n  end\nwhen '\\n'\n  @token.kind = next_char == '\\u{0}' ? Token::Kind::Eof : Token::Kind::Newline\nwhen @quote_char\n  @token.kind = Token::Kind::Cell\n  @token.value = consume_quoted_cell\nelse\n  @token.kind = Token::Kind::Cell\n  @token.value = consume_unquoted_cell\nend\n@token\n"}},{"id":"quote_char:Char-instance-method","html_id":"quote_char:Char-instance-method","name":"quote_char","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L30","def":{"name":"quote_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"@quote_char"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds this lexer to its beginning.","summary":"<p>Rewinds this lexer to its beginning.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L46","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"separator:Char-instance-method","html_id":"separator:Char-instance-method","name":"separator","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L29","def":{"name":"separator","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"@separator"}},{"id":"token:Token-instance-method","html_id":"token:Token-instance-method","name":"token","doc":"Returns the current `Token`.","summary":"<p>Returns the current <code><a href=\"../CSV/Token.html\">Token</a></code>.</p>","abstract":false,"args":[],"args_string":" : Token","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/lexer.cr#L28","def":{"name":"token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Token","visibility":"Public","body":"@token"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CSV/MalformedCSVError","path":"CSV/MalformedCSVError.html","kind":"class","full_name":"CSV::MalformedCSVError","name":"MalformedCSVError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/error.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"Raised when an error is encountered during CSV parsing.","summary":"<p>Raised when an error is encountered during CSV parsing.</p>","class_methods":[],"constructors":[{"id":"new(message,line_number,column_number)-class-method","html_id":"new(message,line_number,column_number)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""}],"args_string":"(message, line_number, column_number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L13","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"column_number:Int32-instance-method","html_id":"column_number:Int32-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L11","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column_number"}},{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/error.cr#L10","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CSV/Parser","path":"CSV/Parser.html","kind":"class","full_name":"CSV::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/parser.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV parser. It lets you consume a CSV row by row.\n\nMost of the time `CSV#parse` and `CSV#each_row` are more convenient.","summary":"<p>A CSV parser.</p>","class_methods":[],"constructors":[{"id":"new(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","html_id":"new(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a parser from a `String` or `IO`.\nOptionally takes the optional *separator* and *quote_char* arguments for\nspecifying non-standard cell separators and quote characters","summary":"<p>Creates a parser from a <code><a href=\"../String.html\">String</a></code> or <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : Char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L10","def":{"name":"new","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","doc":null,"default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","doc":null,"default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io, separator, quote_char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"each_row(&block):Nil-instance-method","html_id":"each_row(&amp;block):Nil-instance-method","name":"each_row","doc":"Yields each of the remaining rows as an `Array(String)`.","summary":"<p>Yields each of the remaining rows as an <code><a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)</code>.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L23","def":{"name":"each_row","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while row = next_row\n  yield row\nend"}},{"id":"each_row-instance-method","html_id":"each_row-instance-method","name":"each_row","doc":"Returns an `Iterator` of `Array(String)` for the remaining rows.","summary":"<p>Returns an <code><a href=\"../Iterator.html\">Iterator</a></code> of <code><a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)</code> for the remaining rows.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L30","def":{"name":"each_row","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"RowIterator.new(self)"}},{"id":"next_row(array:Array(String)):Array(String)?-instance-method","html_id":"next_row(array:Array(String)):Array(String)?-instance-method","name":"next_row","doc":"Reads the next row into the given *array*.\nReturns that same array, if a row was found, or `nil`.","summary":"<p>Reads the next row into the given <em>array</em>.</p>","abstract":false,"args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array(String)"}],"args_string":"(array : Array(String)) : Array(String)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L47","def":{"name":"next_row","args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String) | Nil","visibility":"Public","body":"token = @lexer.next_token\nif token.kind == Token::Kind::Eof\n  return nil\nend\nnext_row_internal(token, array)\n"}},{"id":"next_row:Array(String)?-instance-method","html_id":"next_row:Array(String)?-instance-method","name":"next_row","doc":"Returns the next row in the CSV, if any, or `nil`.","summary":"<p>Returns the next row in the CSV, if any, or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":" : Array(String)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L35","def":{"name":"next_row","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String) | Nil","visibility":"Public","body":"token = @lexer.next_token\nif token.kind == Token::Kind::Eof\n  return nil\nend\nrow = Array(String).new(@max_row_size)\nnext_row_internal(token, row)\n"}},{"id":"parse:Array(Array(String))-instance-method","html_id":"parse:Array(Array(String))-instance-method","name":"parse","doc":"Returns the remaining rows.","summary":"<p>Returns the remaining rows.</p>","abstract":false,"args":[],"args_string":" : Array(Array(String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L16","def":{"name":"parse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Array(String))","visibility":"Public","body":"rows = [] of Array(String)\neach_row do |row|\n  rows << row\nend\nrows\n"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds this parser to the first row.","summary":"<p>Rewinds this parser to the first row.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/parser.cr#L70","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@lexer.rewind"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CSV/Row","path":"CSV/Row.html","kind":"struct","full_name":"CSV::Row","name":"Row","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv.cr","line_number":307,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A Row of a `CSV::WithHeaders` instance.","summary":"<p>A Row of a <code>CSV::WithHeaders</code> instance.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"[](header:String):String-instance-method","html_id":"[](header:String):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header* name.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L318","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L318","def":{"name":"[]","args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"value = self[header]?\nif value\nelse\n  raise(KeyError.new(\"Missing header: #{header}\"))\nend\nvalue\n"}},{"id":"[](column:Int):String-instance-method","html_id":"[](column:Int):String-instance-method","name":"[]","doc":"Returns this row's value at the given column index.\nA negative index counts from the end.\nRaises `IndexError` if no such column exists.","summary":"<p>Returns this row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L339","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L339","def":{"name":"[]","args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"value = self[column]?\nif value\nelse\n  raise(IndexError.new(\"Missing column index: #{column}\"))\nend\nvalue\n"}},{"id":"[](header_pattern:Regex):String-instance-method","html_id":"[](header_pattern:Regex):String-instance-method","name":"[]","doc":"Returns this row's value corresponding to the given *header_pattern*.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L361","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L361","def":{"name":"[]","args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"value = self[header_pattern]?\nif value\nelse\n  raise(KeyError.new(\"Missing header pattern: #{header_pattern}\"))\nend\nvalue\n"}},{"id":"[]?(header:String):String?-instance-method","html_id":"[]?(header:String):String?-instance-method","name":"[]?","doc":"Returns this row's value corresponding to the given *header* name.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L327","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L327","def":{"name":"[]?","args":[{"name":"header","doc":null,"default_value":"","external_name":"header","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"index = csv.indices[header]?\nif index\n  maybe_strip(@row[index]? || \"\")\nelse\n  nil\nend\n"}},{"id":"[]?(column:Int):String?-instance-method","html_id":"[]?(column:Int):String?-instance-method","name":"[]?","doc":"Returns this row's value at the given column index.\nA negative index counts from the end.\nReturns `nil` if no such column exists.","summary":"<p>Returns this row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L348","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L348","def":{"name":"[]?","args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"size = csv.headers?.try(&.size) || @row.size\nif column < 0\n  column = column + size\nend\nvalue = @row[column]?\nif 0 <= column && column < size\n  value || (value = \"\")\nend\nvalue ? maybe_strip(value) : nil\n"}},{"id":"[]?(header_pattern:Regex):String?-instance-method","html_id":"[]?(header_pattern:Regex):String?-instance-method","name":"[]?","doc":"Returns this row's value corresponding to the given *header_pattern*.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L370","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L370","def":{"name":"[]?","args":[{"name":"header_pattern","doc":null,"default_value":"","external_name":"header_pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"csv.headers.each_with_index do |header, i|\n  if header =~ header_pattern\n    return maybe_strip(@row[i]? || \"\")\n  end\nend\nnil\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of columns in this row, regardless of the number\nof headers (if requested).","summary":"<p>Returns the number of columns in this row, regardless of the number of headers (if requested).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L381","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@row.size"}},{"id":"to_a:Array(String)-instance-method","html_id":"to_a:Array(String)-instance-method","name":"to_a","doc":"Converts this row to an `Array`.","summary":"<p>Converts this row to an <code><a href=\"../Array.html\">Array</a></code>.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L386","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L386","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"if csv.strip?\n  @row.map!(&.strip)\nend\n@row\n"}},{"id":"to_h:Hash(String,String)-instance-method","html_id":"to_h:Hash(String,String)-instance-method","name":"to_h","doc":"Converts this row to a `Hash`.","summary":"<p>Converts this row to a <code><a href=\"../Hash.html\">Hash</a></code>.</p>","abstract":false,"args":[],"args_string":" : Hash(String, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L392","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(String, String)","visibility":"Public","body":"h = {} of String => String\ncsv.headers.each_with_index do |header, i|\n  h[header] = maybe_strip(@row[i]? || \"\")\nend\nh\n"}},{"id":"values_at(*columns:Int)-instance-method","html_id":"values_at(*columns:Int)-instance-method","name":"values_at","doc":"Returns a tuple of this row's values at given indices\nA negative index counts from the end.\nRaises `IndexError` if any column doesn't exist\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of this row's values at given indices A negative index counts from the end.</p>","abstract":false,"args":[{"name":"columns","doc":null,"default_value":"","external_name":"columns","restriction":"Int"}],"args_string":"(*columns : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L404","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L404","def":{"name":"values_at","args":[{"name":"columns","doc":null,"default_value":"","external_name":"columns","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"columns.map do |column|\n  self[column]\nend"}},{"id":"values_at(*headers:String)-instance-method","html_id":"values_at(*headers:String)-instance-method","name":"values_at","doc":"Returns a tuple of this row's values corresponding to the given *headers*\nRaises `KeyError` if any header doesn't exist.\nRaises `CSV::Error` if headers were not requested\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of this row's values corresponding to the given <em>headers</em> Raises <code><a href=\"../KeyError.html\">KeyError</a></code> if any header doesn't exist.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"String"}],"args_string":"(*headers : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L412","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv.cr#L412","def":{"name":"values_at","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers.map do |header|\n  self[header]\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/CSV/Token","path":"CSV/Token.html","kind":"struct","full_name":"CSV::Token","name":"Token","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/token.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A token in a CSV. It consists of a `Kind` and a value.\nThe value only makes sense when the *kind* is `Cell`.","summary":"<p>A token in a CSV.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"kind:Kind-instance-method","html_id":"kind:Kind-instance-method","name":"kind","doc":"The `Kind`.","summary":"<p>The <code><a href=\"../CSV/Token/Kind.html\">Kind</a></code>.</p>","abstract":false,"args":[],"args_string":" : Kind","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L14","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Kind","visibility":"Public","body":"@kind"}},{"id":"kind=(kind:Kind)-instance-method","html_id":"kind=(kind:Kind)-instance-method","name":"kind=","doc":"The `Kind`.","summary":"<p>The <code><a href=\"../CSV/Token/Kind.html\">Kind</a></code>.</p>","abstract":false,"args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":"Kind"}],"args_string":"(kind : Kind)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L14","def":{"name":"kind=","args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":"Kind"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@kind = kind"}},{"id":"value:String-instance-method","html_id":"value:String-instance-method","name":"value","doc":"The string value. Only makes sense for a `Cell`.","summary":"<p>The string value.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L17","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@value"}},{"id":"value=(value:String)-instance-method","html_id":"value=(value:String)-instance-method","name":"value=","doc":"The string value. Only makes sense for a `Cell`.","summary":"<p>The string value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L17","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value = value"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/CSV/Token/Kind","path":"CSV/Token/Kind.html","kind":"enum","full_name":"CSV::Token::Kind","name":"Kind","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"csv/token.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Cell","name":"Cell","value":"0","doc":null,"summary":null},{"id":"Newline","name":"Newline","value":"1","doc":null,"summary":null},{"id":"Eof","name":"Eof","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/CSV/Token","kind":"struct","full_name":"CSV::Token","name":"Token"},"doc":"Token kinds.","summary":"<p>Token kinds.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"cell?-instance-method","html_id":"cell?-instance-method","name":"cell?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L8","def":{"name":"cell?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Cell"}},{"id":"eof?-instance-method","html_id":"eof?-instance-method","name":"eof?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L10","def":{"name":"eof?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Eof"}},{"id":"newline?-instance-method","html_id":"newline?-instance-method","name":"newline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/csv/token.cr#L9","def":{"name":"newline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Newline"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/Debug","path":"Debug.html","kind":"module","full_name":"Debug","name":"Debug","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"debug/elf.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"},{"filename":"debug/dwarf/abbrev.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"},{"filename":"debug/dwarf/info.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr"},{"filename":"debug/dwarf/line_numbers.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"},{"filename":"debug/dwarf/strings.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr"},{"filename":"debug/dwarf.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","path":"Debug/DWARF.html","kind":"module","full_name":"Debug::DWARF","name":"DWARF","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"},{"filename":"debug/dwarf/info.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr"},{"filename":"debug/dwarf/line_numbers.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"},{"filename":"debug/dwarf/strings.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr"},{"filename":"debug/dwarf.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug","kind":"module","full_name":"Debug","name":"Debug"},"doc":"DWARF reader.\n\nDocumentation:\n- <http://dwarfstd.org>","summary":"<p>DWARF reader.</p>","class_methods":[{"id":"read_signed_leb128(io:IO)-class-method","html_id":"read_signed_leb128(io:IO)-class-method","name":"read_signed_leb128","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr#L22","def":{"name":"read_signed_leb128","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"result = 0\nshift = 0\nsize = 32\nbyte = 0_u8\nloop do\n  byte = io.read_byte.not_nil!.to_i\n  result = result | ((byte & 127) << shift)\n  shift = shift + 7\n  if (byte.bit(7)) == 0\n    break\n  end\nend\nif (shift < size) && ((byte.bit(6)) == 1)\n  result = result | (-(1 << shift))\nend\nresult\n"}},{"id":"read_unsigned_leb128(io:IO)-class-method","html_id":"read_unsigned_leb128(io:IO)-class-method","name":"read_unsigned_leb128","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf.cr#L8","def":{"name":"read_unsigned_leb128","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"result = 0_u32\nshift = 0\nloop do\n  byte = io.read_byte.not_nil!.to_i\n  result = result | ((byte & 127) << shift)\n  if (byte.bit(7)) == 0\n    break\n  end\n  shift = shift + 7\nend\nresult\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Abbrev","path":"Debug/DWARF/Abbrev.html","kind":"struct","full_name":"Debug::DWARF::Abbrev","name":"Abbrev","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":196,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[{"id":"read(io:IO::FileDescriptor,offset)-class-method","html_id":"read(io:IO::FileDescriptor,offset)-class-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"args_string":"(io : IO::FileDescriptor, offset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L211","def":{"name":"read","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"abbreviations = [] of Abbrev\nio.seek(io.tell + offset)\nloop do\n  code = DWARF.read_unsigned_leb128(io)\n  if code == 0\n    break\n  end\n  tag = TAG.new(DWARF.read_unsigned_leb128(io))\n  children = io.read_byte == 1\n  abbrev = Abbrev.new(code, tag, children)\n  loop do\n    at = AT.new(DWARF.read_unsigned_leb128(io))\n    form = FORM.new(DWARF.read_unsigned_leb128(io))\n    if (at.value == 0) && (form.value == 0)\n      break\n    end\n    abbrev.attributes << (Attribute.new(at, form))\n  end\n  abbreviations << abbrev\nend\nabbreviations\n"}}],"constructors":[{"id":"new(code,tag,children:Bool)-class-method","html_id":"new(code,tag,children:Bool)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"code","doc":null,"default_value":"","external_name":"code","restriction":""},{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":""},{"name":"children","doc":null,"default_value":"","external_name":"children","restriction":"Bool"}],"args_string":"(code, tag, children : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L203","def":{"name":"new","args":[{"name":"code","doc":null,"default_value":"","external_name":"code","restriction":""},{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":""},{"name":"children","doc":null,"default_value":"","external_name":"children","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(code, tag, children)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"attributes:Array(Attribute)-instance-method","html_id":"attributes:Array(Attribute)-instance-method","name":"attributes","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(Attribute)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L201","def":{"name":"attributes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Attribute)","visibility":"Public","body":"@attributes"}},{"id":"attributes=(attributes:Array(Attribute))-instance-method","html_id":"attributes=(attributes:Array(Attribute))-instance-method","name":"attributes=","doc":null,"summary":null,"abstract":false,"args":[{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Array(Attribute)"}],"args_string":"(attributes : Array(Attribute))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L201","def":{"name":"attributes=","args":[{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Array(Attribute)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@attributes = attributes"}},{"id":"children?:Bool-instance-method","html_id":"children?:Bool-instance-method","name":"children?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L207","def":{"name":"children?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@children"}},{"id":"code:UInt32-instance-method","html_id":"code:UInt32-instance-method","name":"code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L199","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L199","def":{"name":"code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@code"}},{"id":"code=(code:UInt32)-instance-method","html_id":"code=(code:UInt32)-instance-method","name":"code=","doc":null,"summary":null,"abstract":false,"args":[{"name":"code","doc":null,"default_value":"","external_name":"code","restriction":"UInt32"}],"args_string":"(code : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L199","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L199","def":{"name":"code=","args":[{"name":"code","doc":null,"default_value":"","external_name":"code","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@code = code"}},{"id":"tag:TAG-instance-method","html_id":"tag:TAG-instance-method","name":"tag","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : TAG","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L200","def":{"name":"tag","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TAG","visibility":"Public","body":"@tag"}},{"id":"tag=(tag:TAG)-instance-method","html_id":"tag=(tag:TAG)-instance-method","name":"tag=","doc":null,"summary":null,"abstract":false,"args":[{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":"TAG"}],"args_string":"(tag : TAG)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L200","def":{"name":"tag=","args":[{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":"TAG"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@tag = tag"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Abbrev/Attribute","path":"Debug/DWARF/Abbrev/Attribute.html","kind":"struct","full_name":"Debug::DWARF::Abbrev::Attribute","name":"Attribute","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":197,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Abbrev","kind":"struct","full_name":"Debug::DWARF::Abbrev","name":"Abbrev"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(at:AT,form:FORM)-class-method","html_id":"new(at:AT,form:FORM)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"at","doc":null,"default_value":"","external_name":"at","restriction":"AT"},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"FORM"}],"args_string":"(at : AT, form : FORM)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","def":{"name":"new","args":[{"name":"at","doc":null,"default_value":"","external_name":"at","restriction":"AT"},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"FORM"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(at, form)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"at:AT-instance-method","html_id":"at:AT-instance-method","name":"at","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : AT","source_link":null,"source_link":null,"def":{"name":"at","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"AT","visibility":"Public","body":"@at"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Attribute.new(@at.clone, @form.clone)"}},{"id":"copy_with(at_at=@at,form_form=@form)-instance-method","html_id":"copy_with(at_at=@at,form_form=@form)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_at","doc":null,"default_value":"@at","external_name":"at","restriction":""},{"name":"_form","doc":null,"default_value":"@form","external_name":"form","restriction":""}],"args_string":"(at _at = @at, form _form = @form)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L197","def":{"name":"copy_with","args":[{"name":"_at","doc":null,"default_value":"@at","external_name":"at","restriction":""},{"name":"_form","doc":null,"default_value":"@form","external_name":"form","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Attribute.new(_at, _form)"}},{"id":"form:FORM-instance-method","html_id":"form:FORM-instance-method","name":"form","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : FORM","source_link":null,"source_link":null,"def":{"name":"form","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"FORM","visibility":"Public","body":"@form"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/AT","path":"Debug/DWARF/AT.html","kind":"enum","full_name":"Debug::DWARF::AT","name":"AT","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":69,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"DW_AT_sibling","name":"DW_AT_sibling","value":"1_u32","doc":null,"summary":null},{"id":"DW_AT_location","name":"DW_AT_location","value":"2_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_name","name":"DW_AT_name","value":"3_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_ordering","name":"DW_AT_ordering","value":"9_u32","doc":"string","summary":"<p>string</p>"},{"id":"DW_AT_byte_size","name":"DW_AT_byte_size","value":"11_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_bit_offset","name":"DW_AT_bit_offset","value":"12_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_bit_size","name":"DW_AT_bit_size","value":"13_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_stmt_list","name":"DW_AT_stmt_list","value":"16_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_low_pc","name":"DW_AT_low_pc","value":"17_u32","doc":"lineptr","summary":"<p>lineptr</p>"},{"id":"DW_AT_high_pc","name":"DW_AT_high_pc","value":"18_u32","doc":"address","summary":"<p>address</p>"},{"id":"DW_AT_language","name":"DW_AT_language","value":"19_u32","doc":"address, constant","summary":"<p>address, constant</p>"},{"id":"DW_AT_discr","name":"DW_AT_discr","value":"21_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_discr_value","name":"DW_AT_discr_value","value":"22_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_visibility","name":"DW_AT_visibility","value":"23_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_import","name":"DW_AT_import","value":"24_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_string_length","name":"DW_AT_string_length","value":"25_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_common_reference","name":"DW_AT_common_reference","value":"26_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_comp_dir","name":"DW_AT_comp_dir","value":"27_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_const_value","name":"DW_AT_const_value","value":"28_u32","doc":"string","summary":"<p>string</p>"},{"id":"DW_AT_containing_type","name":"DW_AT_containing_type","value":"29_u32","doc":"block, constant, string","summary":"<p>block, constant, string</p>"},{"id":"DW_AT_default_value","name":"DW_AT_default_value","value":"30_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_inline","name":"DW_AT_inline","value":"32_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_is_optional","name":"DW_AT_is_optional","value":"33_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_lower_bound","name":"DW_AT_lower_bound","value":"34_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_producer","name":"DW_AT_producer","value":"37_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_prototyped","name":"DW_AT_prototyped","value":"39_u32","doc":"string","summary":"<p>string</p>"},{"id":"DW_AT_return_addr","name":"DW_AT_return_addr","value":"42_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_start_scope","name":"DW_AT_start_scope","value":"44_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_bit_stride","name":"DW_AT_bit_stride","value":"46_u32","doc":"constant, rangelistptr","summary":"<p>constant, rangelistptr</p>"},{"id":"DW_AT_upper_bound","name":"DW_AT_upper_bound","value":"47_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_abstract_origin","name":"DW_AT_abstract_origin","value":"49_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_accessibility","name":"DW_AT_accessibility","value":"50_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_address_class","name":"DW_AT_address_class","value":"51_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_artificial","name":"DW_AT_artificial","value":"52_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_base_types","name":"DW_AT_base_types","value":"53_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_calling_convention","name":"DW_AT_calling_convention","value":"54_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_count","name":"DW_AT_count","value":"55_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_data_member_location","name":"DW_AT_data_member_location","value":"56_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_decl_column","name":"DW_AT_decl_column","value":"57_u32","doc":"constant, exprloc, loclistptr","summary":"<p>constant, exprloc, loclistptr</p>"},{"id":"DW_AT_decl_file","name":"DW_AT_decl_file","value":"58_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_decl_line","name":"DW_AT_decl_line","value":"59_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_declaration","name":"DW_AT_declaration","value":"60_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_discr_list","name":"DW_AT_discr_list","value":"61_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_encoding","name":"DW_AT_encoding","value":"62_u32","doc":"block","summary":"<p>block</p>"},{"id":"DW_AT_external","name":"DW_AT_external","value":"63_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_frame_base","name":"DW_AT_frame_base","value":"64_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_friend","name":"DW_AT_friend","value":"65_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_identifier_case","name":"DW_AT_identifier_case","value":"66_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_macro_info","name":"DW_AT_macro_info","value":"67_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_namelist_item","name":"DW_AT_namelist_item","value":"68_u32","doc":"macptr","summary":"<p>macptr</p>"},{"id":"DW_AT_priority","name":"DW_AT_priority","value":"69_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_segment","name":"DW_AT_segment","value":"70_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_specification","name":"DW_AT_specification","value":"71_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_static_link","name":"DW_AT_static_link","value":"72_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_type","name":"DW_AT_type","value":"73_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_use_location","name":"DW_AT_use_location","value":"74_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_variable_parameter","name":"DW_AT_variable_parameter","value":"75_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_virtuality","name":"DW_AT_virtuality","value":"76_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_vtable_elem_location","name":"DW_AT_vtable_elem_location","value":"77_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_allocated","name":"DW_AT_allocated","value":"78_u32","doc":"exprloc, loclistptr","summary":"<p>exprloc, loclistptr</p>"},{"id":"DW_AT_associated","name":"DW_AT_associated","value":"79_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_data_location","name":"DW_AT_data_location","value":"80_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_byte_stride","name":"DW_AT_byte_stride","value":"81_u32","doc":"exprloc","summary":"<p>exprloc</p>"},{"id":"DW_AT_entry_pc","name":"DW_AT_entry_pc","value":"82_u32","doc":"constant, exprloc, reference","summary":"<p>constant, exprloc, reference</p>"},{"id":"DW_AT_use_UTF8","name":"DW_AT_use_UTF8","value":"83_u32","doc":"address","summary":"<p>address</p>"},{"id":"DW_AT_extension","name":"DW_AT_extension","value":"84_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_ranges","name":"DW_AT_ranges","value":"85_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_trampoline","name":"DW_AT_trampoline","value":"86_u32","doc":"rangelistptr","summary":"<p>rangelistptr</p>"},{"id":"DW_AT_call_column","name":"DW_AT_call_column","value":"87_u32","doc":"address, flag, reference, string","summary":"<p>address, flag, reference, string</p>"},{"id":"DW_AT_call_file","name":"DW_AT_call_file","value":"88_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_call_line","name":"DW_AT_call_line","value":"89_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_description","name":"DW_AT_description","value":"90_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_binary_scale","name":"DW_AT_binary_scale","value":"91_u32","doc":"string","summary":"<p>string</p>"},{"id":"DW_AT_decimal_scale","name":"DW_AT_decimal_scale","value":"92_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_small","name":"DW_AT_small","value":"93_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_decimal_sign","name":"DW_AT_decimal_sign","value":"94_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_digit_count","name":"DW_AT_digit_count","value":"95_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_picture_string","name":"DW_AT_picture_string","value":"96_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_mutable","name":"DW_AT_mutable","value":"97_u32","doc":"string","summary":"<p>string</p>"},{"id":"DW_AT_threads_scaled","name":"DW_AT_threads_scaled","value":"98_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_explicit","name":"DW_AT_explicit","value":"99_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_object_pointer","name":"DW_AT_object_pointer","value":"100_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_endianity","name":"DW_AT_endianity","value":"101_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_elemental","name":"DW_AT_elemental","value":"102_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_pure","name":"DW_AT_pure","value":"103_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_recursive","name":"DW_AT_recursive","value":"104_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_signature","name":"DW_AT_signature","value":"105_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_main_subprogram","name":"DW_AT_main_subprogram","value":"106_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"DW_AT_data_bit_offset","name":"DW_AT_data_bit_offset","value":"107_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_const_expr","name":"DW_AT_const_expr","value":"108_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"DW_AT_enum_class","name":"DW_AT_enum_class","value":"109_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"DW_AT_linkage_name","name":"DW_AT_linkage_name","value":"110_u32","doc":"flag","summary":"<p>flag</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"dw_at_abstract_origin?-instance-method","html_id":"dw_at_abstract_origin?-instance-method","name":"dw_at_abstract_origin?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L100","def":{"name":"dw_at_abstract_origin?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_abstract_origin"}},{"id":"dw_at_accessibility?-instance-method","html_id":"dw_at_accessibility?-instance-method","name":"dw_at_accessibility?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L101","def":{"name":"dw_at_accessibility?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_accessibility"}},{"id":"dw_at_address_class?-instance-method","html_id":"dw_at_address_class?-instance-method","name":"dw_at_address_class?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L102","def":{"name":"dw_at_address_class?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_address_class"}},{"id":"dw_at_allocated?-instance-method","html_id":"dw_at_allocated?-instance-method","name":"dw_at_allocated?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L129","def":{"name":"dw_at_allocated?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_allocated"}},{"id":"dw_at_artificial?-instance-method","html_id":"dw_at_artificial?-instance-method","name":"dw_at_artificial?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L103","def":{"name":"dw_at_artificial?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_artificial"}},{"id":"dw_at_associated?-instance-method","html_id":"dw_at_associated?-instance-method","name":"dw_at_associated?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L130","def":{"name":"dw_at_associated?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_associated"}},{"id":"dw_at_base_types?-instance-method","html_id":"dw_at_base_types?-instance-method","name":"dw_at_base_types?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L104","def":{"name":"dw_at_base_types?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_base_types"}},{"id":"dw_at_binary_scale?-instance-method","html_id":"dw_at_binary_scale?-instance-method","name":"dw_at_binary_scale?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L142","def":{"name":"dw_at_binary_scale?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_binary_scale"}},{"id":"dw_at_bit_offset?-instance-method","html_id":"dw_at_bit_offset?-instance-method","name":"dw_at_bit_offset?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L75","def":{"name":"dw_at_bit_offset?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_bit_offset"}},{"id":"dw_at_bit_size?-instance-method","html_id":"dw_at_bit_size?-instance-method","name":"dw_at_bit_size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L76","def":{"name":"dw_at_bit_size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_bit_size"}},{"id":"dw_at_bit_stride?-instance-method","html_id":"dw_at_bit_stride?-instance-method","name":"dw_at_bit_stride?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L98","def":{"name":"dw_at_bit_stride?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_bit_stride"}},{"id":"dw_at_byte_size?-instance-method","html_id":"dw_at_byte_size?-instance-method","name":"dw_at_byte_size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L74","def":{"name":"dw_at_byte_size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_byte_size"}},{"id":"dw_at_byte_stride?-instance-method","html_id":"dw_at_byte_stride?-instance-method","name":"dw_at_byte_stride?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L132","def":{"name":"dw_at_byte_stride?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_byte_stride"}},{"id":"dw_at_call_column?-instance-method","html_id":"dw_at_call_column?-instance-method","name":"dw_at_call_column?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L138","def":{"name":"dw_at_call_column?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_call_column"}},{"id":"dw_at_call_file?-instance-method","html_id":"dw_at_call_file?-instance-method","name":"dw_at_call_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L139","def":{"name":"dw_at_call_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_call_file"}},{"id":"dw_at_call_line?-instance-method","html_id":"dw_at_call_line?-instance-method","name":"dw_at_call_line?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L140","def":{"name":"dw_at_call_line?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_call_line"}},{"id":"dw_at_calling_convention?-instance-method","html_id":"dw_at_calling_convention?-instance-method","name":"dw_at_calling_convention?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L105","def":{"name":"dw_at_calling_convention?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_calling_convention"}},{"id":"dw_at_common_reference?-instance-method","html_id":"dw_at_common_reference?-instance-method","name":"dw_at_common_reference?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L86","def":{"name":"dw_at_common_reference?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_common_reference"}},{"id":"dw_at_comp_dir?-instance-method","html_id":"dw_at_comp_dir?-instance-method","name":"dw_at_comp_dir?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L87","def":{"name":"dw_at_comp_dir?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_comp_dir"}},{"id":"dw_at_const_expr?-instance-method","html_id":"dw_at_const_expr?-instance-method","name":"dw_at_const_expr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L159","def":{"name":"dw_at_const_expr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_const_expr"}},{"id":"dw_at_const_value?-instance-method","html_id":"dw_at_const_value?-instance-method","name":"dw_at_const_value?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L88","def":{"name":"dw_at_const_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_const_value"}},{"id":"dw_at_containing_type?-instance-method","html_id":"dw_at_containing_type?-instance-method","name":"dw_at_containing_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L89","def":{"name":"dw_at_containing_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_containing_type"}},{"id":"dw_at_count?-instance-method","html_id":"dw_at_count?-instance-method","name":"dw_at_count?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L106","def":{"name":"dw_at_count?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_count"}},{"id":"dw_at_data_bit_offset?-instance-method","html_id":"dw_at_data_bit_offset?-instance-method","name":"dw_at_data_bit_offset?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L158","def":{"name":"dw_at_data_bit_offset?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_data_bit_offset"}},{"id":"dw_at_data_location?-instance-method","html_id":"dw_at_data_location?-instance-method","name":"dw_at_data_location?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L131","def":{"name":"dw_at_data_location?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_data_location"}},{"id":"dw_at_data_member_location?-instance-method","html_id":"dw_at_data_member_location?-instance-method","name":"dw_at_data_member_location?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L107","def":{"name":"dw_at_data_member_location?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_data_member_location"}},{"id":"dw_at_decimal_scale?-instance-method","html_id":"dw_at_decimal_scale?-instance-method","name":"dw_at_decimal_scale?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L143","def":{"name":"dw_at_decimal_scale?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_decimal_scale"}},{"id":"dw_at_decimal_sign?-instance-method","html_id":"dw_at_decimal_sign?-instance-method","name":"dw_at_decimal_sign?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L145","def":{"name":"dw_at_decimal_sign?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_decimal_sign"}},{"id":"dw_at_decl_column?-instance-method","html_id":"dw_at_decl_column?-instance-method","name":"dw_at_decl_column?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L108","def":{"name":"dw_at_decl_column?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_decl_column"}},{"id":"dw_at_decl_file?-instance-method","html_id":"dw_at_decl_file?-instance-method","name":"dw_at_decl_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L109","def":{"name":"dw_at_decl_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_decl_file"}},{"id":"dw_at_decl_line?-instance-method","html_id":"dw_at_decl_line?-instance-method","name":"dw_at_decl_line?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L110","def":{"name":"dw_at_decl_line?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_decl_line"}},{"id":"dw_at_declaration?-instance-method","html_id":"dw_at_declaration?-instance-method","name":"dw_at_declaration?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L111","def":{"name":"dw_at_declaration?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_declaration"}},{"id":"dw_at_default_value?-instance-method","html_id":"dw_at_default_value?-instance-method","name":"dw_at_default_value?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L90","def":{"name":"dw_at_default_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_default_value"}},{"id":"dw_at_description?-instance-method","html_id":"dw_at_description?-instance-method","name":"dw_at_description?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L141","def":{"name":"dw_at_description?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_description"}},{"id":"dw_at_digit_count?-instance-method","html_id":"dw_at_digit_count?-instance-method","name":"dw_at_digit_count?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L146","def":{"name":"dw_at_digit_count?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_digit_count"}},{"id":"dw_at_discr?-instance-method","html_id":"dw_at_discr?-instance-method","name":"dw_at_discr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L81","def":{"name":"dw_at_discr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_discr"}},{"id":"dw_at_discr_list?-instance-method","html_id":"dw_at_discr_list?-instance-method","name":"dw_at_discr_list?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L112","def":{"name":"dw_at_discr_list?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_discr_list"}},{"id":"dw_at_discr_value?-instance-method","html_id":"dw_at_discr_value?-instance-method","name":"dw_at_discr_value?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L82","def":{"name":"dw_at_discr_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_discr_value"}},{"id":"dw_at_elemental?-instance-method","html_id":"dw_at_elemental?-instance-method","name":"dw_at_elemental?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L153","def":{"name":"dw_at_elemental?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_elemental"}},{"id":"dw_at_encoding?-instance-method","html_id":"dw_at_encoding?-instance-method","name":"dw_at_encoding?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L113","def":{"name":"dw_at_encoding?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_encoding"}},{"id":"dw_at_endianity?-instance-method","html_id":"dw_at_endianity?-instance-method","name":"dw_at_endianity?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L152","def":{"name":"dw_at_endianity?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_endianity"}},{"id":"dw_at_entry_pc?-instance-method","html_id":"dw_at_entry_pc?-instance-method","name":"dw_at_entry_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L133","def":{"name":"dw_at_entry_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_entry_pc"}},{"id":"dw_at_enum_class?-instance-method","html_id":"dw_at_enum_class?-instance-method","name":"dw_at_enum_class?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L160","def":{"name":"dw_at_enum_class?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_enum_class"}},{"id":"dw_at_explicit?-instance-method","html_id":"dw_at_explicit?-instance-method","name":"dw_at_explicit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L150","def":{"name":"dw_at_explicit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_explicit"}},{"id":"dw_at_extension?-instance-method","html_id":"dw_at_extension?-instance-method","name":"dw_at_extension?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L135","def":{"name":"dw_at_extension?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_extension"}},{"id":"dw_at_external?-instance-method","html_id":"dw_at_external?-instance-method","name":"dw_at_external?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L114","def":{"name":"dw_at_external?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_external"}},{"id":"dw_at_frame_base?-instance-method","html_id":"dw_at_frame_base?-instance-method","name":"dw_at_frame_base?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L115","def":{"name":"dw_at_frame_base?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_frame_base"}},{"id":"dw_at_friend?-instance-method","html_id":"dw_at_friend?-instance-method","name":"dw_at_friend?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L116","def":{"name":"dw_at_friend?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_friend"}},{"id":"dw_at_high_pc?-instance-method","html_id":"dw_at_high_pc?-instance-method","name":"dw_at_high_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L79","def":{"name":"dw_at_high_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_high_pc"}},{"id":"dw_at_identifier_case?-instance-method","html_id":"dw_at_identifier_case?-instance-method","name":"dw_at_identifier_case?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L117","def":{"name":"dw_at_identifier_case?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_identifier_case"}},{"id":"dw_at_import?-instance-method","html_id":"dw_at_import?-instance-method","name":"dw_at_import?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L84","def":{"name":"dw_at_import?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_import"}},{"id":"dw_at_inline?-instance-method","html_id":"dw_at_inline?-instance-method","name":"dw_at_inline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L91","def":{"name":"dw_at_inline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_inline"}},{"id":"dw_at_is_optional?-instance-method","html_id":"dw_at_is_optional?-instance-method","name":"dw_at_is_optional?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L92","def":{"name":"dw_at_is_optional?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_is_optional"}},{"id":"dw_at_language?-instance-method","html_id":"dw_at_language?-instance-method","name":"dw_at_language?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L80","def":{"name":"dw_at_language?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_language"}},{"id":"dw_at_linkage_name?-instance-method","html_id":"dw_at_linkage_name?-instance-method","name":"dw_at_linkage_name?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L161","def":{"name":"dw_at_linkage_name?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_linkage_name"}},{"id":"dw_at_location?-instance-method","html_id":"dw_at_location?-instance-method","name":"dw_at_location?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L71","def":{"name":"dw_at_location?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_location"}},{"id":"dw_at_low_pc?-instance-method","html_id":"dw_at_low_pc?-instance-method","name":"dw_at_low_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L78","def":{"name":"dw_at_low_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_low_pc"}},{"id":"dw_at_lower_bound?-instance-method","html_id":"dw_at_lower_bound?-instance-method","name":"dw_at_lower_bound?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L93","def":{"name":"dw_at_lower_bound?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_lower_bound"}},{"id":"dw_at_macro_info?-instance-method","html_id":"dw_at_macro_info?-instance-method","name":"dw_at_macro_info?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L118","def":{"name":"dw_at_macro_info?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_macro_info"}},{"id":"dw_at_main_subprogram?-instance-method","html_id":"dw_at_main_subprogram?-instance-method","name":"dw_at_main_subprogram?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L157","def":{"name":"dw_at_main_subprogram?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_main_subprogram"}},{"id":"dw_at_mutable?-instance-method","html_id":"dw_at_mutable?-instance-method","name":"dw_at_mutable?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L148","def":{"name":"dw_at_mutable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_mutable"}},{"id":"dw_at_name?-instance-method","html_id":"dw_at_name?-instance-method","name":"dw_at_name?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L72","def":{"name":"dw_at_name?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_name"}},{"id":"dw_at_namelist_item?-instance-method","html_id":"dw_at_namelist_item?-instance-method","name":"dw_at_namelist_item?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L119","def":{"name":"dw_at_namelist_item?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_namelist_item"}},{"id":"dw_at_object_pointer?-instance-method","html_id":"dw_at_object_pointer?-instance-method","name":"dw_at_object_pointer?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L151","def":{"name":"dw_at_object_pointer?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_object_pointer"}},{"id":"dw_at_ordering?-instance-method","html_id":"dw_at_ordering?-instance-method","name":"dw_at_ordering?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L73","def":{"name":"dw_at_ordering?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_ordering"}},{"id":"dw_at_picture_string?-instance-method","html_id":"dw_at_picture_string?-instance-method","name":"dw_at_picture_string?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L147","def":{"name":"dw_at_picture_string?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_picture_string"}},{"id":"dw_at_priority?-instance-method","html_id":"dw_at_priority?-instance-method","name":"dw_at_priority?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L120","def":{"name":"dw_at_priority?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_priority"}},{"id":"dw_at_producer?-instance-method","html_id":"dw_at_producer?-instance-method","name":"dw_at_producer?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L94","def":{"name":"dw_at_producer?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_producer"}},{"id":"dw_at_prototyped?-instance-method","html_id":"dw_at_prototyped?-instance-method","name":"dw_at_prototyped?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L95","def":{"name":"dw_at_prototyped?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_prototyped"}},{"id":"dw_at_pure?-instance-method","html_id":"dw_at_pure?-instance-method","name":"dw_at_pure?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L154","def":{"name":"dw_at_pure?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_pure"}},{"id":"dw_at_ranges?-instance-method","html_id":"dw_at_ranges?-instance-method","name":"dw_at_ranges?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L136","def":{"name":"dw_at_ranges?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_ranges"}},{"id":"dw_at_recursive?-instance-method","html_id":"dw_at_recursive?-instance-method","name":"dw_at_recursive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L155","def":{"name":"dw_at_recursive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_recursive"}},{"id":"dw_at_return_addr?-instance-method","html_id":"dw_at_return_addr?-instance-method","name":"dw_at_return_addr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L96","def":{"name":"dw_at_return_addr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_return_addr"}},{"id":"dw_at_segment?-instance-method","html_id":"dw_at_segment?-instance-method","name":"dw_at_segment?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L121","def":{"name":"dw_at_segment?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_segment"}},{"id":"dw_at_sibling?-instance-method","html_id":"dw_at_sibling?-instance-method","name":"dw_at_sibling?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L70","def":{"name":"dw_at_sibling?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_sibling"}},{"id":"dw_at_signature?-instance-method","html_id":"dw_at_signature?-instance-method","name":"dw_at_signature?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L156","def":{"name":"dw_at_signature?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_signature"}},{"id":"dw_at_small?-instance-method","html_id":"dw_at_small?-instance-method","name":"dw_at_small?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L144","def":{"name":"dw_at_small?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_small"}},{"id":"dw_at_specification?-instance-method","html_id":"dw_at_specification?-instance-method","name":"dw_at_specification?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L122","def":{"name":"dw_at_specification?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_specification"}},{"id":"dw_at_start_scope?-instance-method","html_id":"dw_at_start_scope?-instance-method","name":"dw_at_start_scope?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L97","def":{"name":"dw_at_start_scope?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_start_scope"}},{"id":"dw_at_static_link?-instance-method","html_id":"dw_at_static_link?-instance-method","name":"dw_at_static_link?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L123","def":{"name":"dw_at_static_link?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_static_link"}},{"id":"dw_at_stmt_list?-instance-method","html_id":"dw_at_stmt_list?-instance-method","name":"dw_at_stmt_list?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L77","def":{"name":"dw_at_stmt_list?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_stmt_list"}},{"id":"dw_at_string_length?-instance-method","html_id":"dw_at_string_length?-instance-method","name":"dw_at_string_length?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L85","def":{"name":"dw_at_string_length?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_string_length"}},{"id":"dw_at_threads_scaled?-instance-method","html_id":"dw_at_threads_scaled?-instance-method","name":"dw_at_threads_scaled?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L149","def":{"name":"dw_at_threads_scaled?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_threads_scaled"}},{"id":"dw_at_trampoline?-instance-method","html_id":"dw_at_trampoline?-instance-method","name":"dw_at_trampoline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L137","def":{"name":"dw_at_trampoline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_trampoline"}},{"id":"dw_at_type?-instance-method","html_id":"dw_at_type?-instance-method","name":"dw_at_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L124","def":{"name":"dw_at_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_type"}},{"id":"dw_at_upper_bound?-instance-method","html_id":"dw_at_upper_bound?-instance-method","name":"dw_at_upper_bound?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L99","def":{"name":"dw_at_upper_bound?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_upper_bound"}},{"id":"dw_at_use_location?-instance-method","html_id":"dw_at_use_location?-instance-method","name":"dw_at_use_location?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L125","def":{"name":"dw_at_use_location?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_use_location"}},{"id":"dw_at_use_utf8?-instance-method","html_id":"dw_at_use_utf8?-instance-method","name":"dw_at_use_utf8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L134","def":{"name":"dw_at_use_utf8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_use_UTF8"}},{"id":"dw_at_variable_parameter?-instance-method","html_id":"dw_at_variable_parameter?-instance-method","name":"dw_at_variable_parameter?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L126","def":{"name":"dw_at_variable_parameter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_variable_parameter"}},{"id":"dw_at_virtuality?-instance-method","html_id":"dw_at_virtuality?-instance-method","name":"dw_at_virtuality?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L127","def":{"name":"dw_at_virtuality?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_virtuality"}},{"id":"dw_at_visibility?-instance-method","html_id":"dw_at_visibility?-instance-method","name":"dw_at_visibility?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L83","def":{"name":"dw_at_visibility?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_visibility"}},{"id":"dw_at_vtable_elem_location?-instance-method","html_id":"dw_at_vtable_elem_location?-instance-method","name":"dw_at_vtable_elem_location?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L128","def":{"name":"dw_at_vtable_elem_location?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DW_AT_vtable_elem_location"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L163","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"AT.from_value?(value).nil?"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/FORM","path":"Debug/DWARF/FORM.html","kind":"enum","full_name":"Debug::DWARF::FORM","name":"FORM","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":168,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Addr","name":"Addr","value":"1_u32","doc":null,"summary":null},{"id":"Block2","name":"Block2","value":"3_u32","doc":"address","summary":"<p>address</p>"},{"id":"Block4","name":"Block4","value":"4_u32","doc":"block","summary":"<p>block</p>"},{"id":"Data2","name":"Data2","value":"5_u32","doc":"block","summary":"<p>block</p>"},{"id":"Data4","name":"Data4","value":"6_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"Data8","name":"Data8","value":"7_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"String","name":"String","value":"8_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"Block","name":"Block","value":"9_u32","doc":"string","summary":"<p>string</p>"},{"id":"Block1","name":"Block1","value":"10_u32","doc":"block","summary":"<p>block</p>"},{"id":"Data1","name":"Data1","value":"11_u32","doc":"block","summary":"<p>block</p>"},{"id":"Flag","name":"Flag","value":"12_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"Sdata","name":"Sdata","value":"13_u32","doc":"flag","summary":"<p>flag</p>"},{"id":"Strp","name":"Strp","value":"14_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"Udata","name":"Udata","value":"15_u32","doc":"string","summary":"<p>string</p>"},{"id":"RefAddr","name":"RefAddr","value":"16_u32","doc":"constant","summary":"<p>constant</p>"},{"id":"Ref1","name":"Ref1","value":"17_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"Ref2","name":"Ref2","value":"18_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"Ref4","name":"Ref4","value":"19_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"Ref8","name":"Ref8","value":"20_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"RefUdata","name":"RefUdata","value":"21_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"Indirect","name":"Indirect","value":"22_u32","doc":"reference","summary":"<p>reference</p>"},{"id":"SecOffset","name":"SecOffset","value":"23_u32","doc":"(see Section 7.5.3)","summary":"<p>(see Section 7.5.3)</p>"},{"id":"Exprloc","name":"Exprloc","value":"24_u32","doc":"lineptr, loclistptr, macptr, rangelistptr","summary":"<p>lineptr, loclistptr, macptr, rangelistptr</p>"},{"id":"FlagPresent","name":"FlagPresent","value":"25_u32","doc":"exprloc","summary":"<p>exprloc</p>"},{"id":"RefSig8","name":"RefSig8","value":"32_u32","doc":"flag","summary":"<p>flag</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"addr?-instance-method","html_id":"addr?-instance-method","name":"addr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L169","def":{"name":"addr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Addr"}},{"id":"block1?-instance-method","html_id":"block1?-instance-method","name":"block1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L177","def":{"name":"block1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Block1"}},{"id":"block2?-instance-method","html_id":"block2?-instance-method","name":"block2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L170","def":{"name":"block2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Block2"}},{"id":"block4?-instance-method","html_id":"block4?-instance-method","name":"block4?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L171","def":{"name":"block4?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Block4"}},{"id":"block?-instance-method","html_id":"block?-instance-method","name":"block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L176","def":{"name":"block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Block"}},{"id":"data1?-instance-method","html_id":"data1?-instance-method","name":"data1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L178","def":{"name":"data1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Data1"}},{"id":"data2?-instance-method","html_id":"data2?-instance-method","name":"data2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L172","def":{"name":"data2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Data2"}},{"id":"data4?-instance-method","html_id":"data4?-instance-method","name":"data4?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L173","def":{"name":"data4?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Data4"}},{"id":"data8?-instance-method","html_id":"data8?-instance-method","name":"data8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L174","def":{"name":"data8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Data8"}},{"id":"exprloc?-instance-method","html_id":"exprloc?-instance-method","name":"exprloc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L191","def":{"name":"exprloc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Exprloc"}},{"id":"flag?-instance-method","html_id":"flag?-instance-method","name":"flag?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L179","def":{"name":"flag?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Flag"}},{"id":"flag_present?-instance-method","html_id":"flag_present?-instance-method","name":"flag_present?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L192","def":{"name":"flag_present?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FlagPresent"}},{"id":"indirect?-instance-method","html_id":"indirect?-instance-method","name":"indirect?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L189","def":{"name":"indirect?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Indirect"}},{"id":"ref1?-instance-method","html_id":"ref1?-instance-method","name":"ref1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L184","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L184","def":{"name":"ref1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ref1"}},{"id":"ref2?-instance-method","html_id":"ref2?-instance-method","name":"ref2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L185","def":{"name":"ref2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ref2"}},{"id":"ref4?-instance-method","html_id":"ref4?-instance-method","name":"ref4?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L186","def":{"name":"ref4?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ref4"}},{"id":"ref8?-instance-method","html_id":"ref8?-instance-method","name":"ref8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L187","def":{"name":"ref8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ref8"}},{"id":"ref_addr?-instance-method","html_id":"ref_addr?-instance-method","name":"ref_addr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L183","def":{"name":"ref_addr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RefAddr"}},{"id":"ref_sig8?-instance-method","html_id":"ref_sig8?-instance-method","name":"ref_sig8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L193","def":{"name":"ref_sig8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RefSig8"}},{"id":"ref_udata?-instance-method","html_id":"ref_udata?-instance-method","name":"ref_udata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L188","def":{"name":"ref_udata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RefUdata"}},{"id":"sdata?-instance-method","html_id":"sdata?-instance-method","name":"sdata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L180","def":{"name":"sdata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Sdata"}},{"id":"sec_offset?-instance-method","html_id":"sec_offset?-instance-method","name":"sec_offset?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L190","def":{"name":"sec_offset?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SecOffset"}},{"id":"string?-instance-method","html_id":"string?-instance-method","name":"string?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L175","def":{"name":"string?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == String"}},{"id":"strp?-instance-method","html_id":"strp?-instance-method","name":"strp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L181","def":{"name":"strp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Strp"}},{"id":"udata?-instance-method","html_id":"udata?-instance-method","name":"udata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L182","def":{"name":"udata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Udata"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Info","path":"Debug/DWARF/Info.html","kind":"struct","full_name":"Debug::DWARF::Info","name":"Info","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/info.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(io:IO::FileDescriptor,offset)-class-method","html_id":"new(io:IO::FileDescriptor,offset)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"args_string":"(io : IO::FileDescriptor, offset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L17","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, offset)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"abbreviations-instance-method","html_id":"abbreviations-instance-method","name":"abbreviations","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"abbreviations","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@abbreviations.not_nil!"}},{"id":"abbreviations=(abbreviations:Array(Abbrev))-instance-method","html_id":"abbreviations=(abbreviations:Array(Abbrev))-instance-method","name":"abbreviations=","doc":null,"summary":null,"abstract":false,"args":[{"name":"abbreviations","doc":null,"default_value":"","external_name":"abbreviations","restriction":"Array(Abbrev)"}],"args_string":"(abbreviations : Array(Abbrev))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L11","def":{"name":"abbreviations=","args":[{"name":"abbreviations","doc":null,"default_value":"","external_name":"abbreviations","restriction":"Array(Abbrev)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@abbreviations = abbreviations"}},{"id":"abbreviations?:Array(Debug::DWARF::Abbrev)?-instance-method","html_id":"abbreviations?:Array(Debug::DWARF::Abbrev)?-instance-method","name":"abbreviations?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(Debug::DWARF::Abbrev)?","source_link":null,"source_link":null,"def":{"name":"abbreviations?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@abbreviations"}},{"id":"address_size:UInt8-instance-method","html_id":"address_size:UInt8-instance-method","name":"address_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L10","def":{"name":"address_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@address_size"}},{"id":"address_size=(address_size:UInt8)-instance-method","html_id":"address_size=(address_size:UInt8)-instance-method","name":"address_size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"address_size","doc":null,"default_value":"","external_name":"address_size","restriction":"UInt8"}],"args_string":"(address_size : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L10","def":{"name":"address_size=","args":[{"name":"address_size","doc":null,"default_value":"","external_name":"address_size","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@address_size = address_size"}},{"id":"debug_abbrev_offset:UInt32|UInt64-instance-method","html_id":"debug_abbrev_offset:UInt32|UInt64-instance-method","name":"debug_abbrev_offset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L9","def":{"name":"debug_abbrev_offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32 | UInt64","visibility":"Public","body":"@debug_abbrev_offset"}},{"id":"debug_abbrev_offset=(debug_abbrev_offset:UInt32|UInt64)-instance-method","html_id":"debug_abbrev_offset=(debug_abbrev_offset:UInt32|UInt64)-instance-method","name":"debug_abbrev_offset=","doc":null,"summary":null,"abstract":false,"args":[{"name":"debug_abbrev_offset","doc":null,"default_value":"","external_name":"debug_abbrev_offset","restriction":"UInt32 | UInt64"}],"args_string":"(debug_abbrev_offset : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L9","def":{"name":"debug_abbrev_offset=","args":[{"name":"debug_abbrev_offset","doc":null,"default_value":"","external_name":"debug_abbrev_offset","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@debug_abbrev_offset = debug_abbrev_offset"}},{"id":"dwarf64:Bool-instance-method","html_id":"dwarf64:Bool-instance-method","name":"dwarf64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L13","def":{"name":"dwarf64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@dwarf64"}},{"id":"dwarf64=(dwarf64:Bool)-instance-method","html_id":"dwarf64=(dwarf64:Bool)-instance-method","name":"dwarf64=","doc":null,"summary":null,"abstract":false,"args":[{"name":"dwarf64","doc":null,"default_value":"","external_name":"dwarf64","restriction":"Bool"}],"args_string":"(dwarf64 : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L13","def":{"name":"dwarf64=","args":[{"name":"dwarf64","doc":null,"default_value":"","external_name":"dwarf64","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@dwarf64 = dwarf64"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L40","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":3,"block_arg":null,"return_type":"","visibility":"Public","body":"end_offset = @offset + @unit_length\nattributes = [] of ::Tuple(AT, FORM, Value)\nwhile @io.tell < end_offset\n  code = DWARF.read_unsigned_leb128(@io)\n  attributes.clear\n  if abbrev = abbreviations[code - 1]?\n    abbrev.attributes.each do |attr|\n      value = read_attribute_value(attr.form)\n      attributes << {attr.at, attr.form, value}\n    end\n    yield code, abbrev, attributes\n  else\n    yield code, nil, attributes\n  end\nend\n"}},{"id":"read_abbreviations(io)-instance-method","html_id":"read_abbreviations(io)-instance-method","name":"read_abbreviations","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L36","def":{"name":"read_abbreviations","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@abbreviations = Abbrev.read(io, debug_abbrev_offset)"}},{"id":"unit_length:UInt32|UInt64-instance-method","html_id":"unit_length:UInt32|UInt64-instance-method","name":"unit_length","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L7","def":{"name":"unit_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32 | UInt64","visibility":"Public","body":"@unit_length"}},{"id":"unit_length=(unit_length:UInt32|UInt64)-instance-method","html_id":"unit_length=(unit_length:UInt32|UInt64)-instance-method","name":"unit_length=","doc":null,"summary":null,"abstract":false,"args":[{"name":"unit_length","doc":null,"default_value":"","external_name":"unit_length","restriction":"UInt32 | UInt64"}],"args_string":"(unit_length : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L7","def":{"name":"unit_length=","args":[{"name":"unit_length","doc":null,"default_value":"","external_name":"unit_length","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unit_length = unit_length"}},{"id":"version:UInt16-instance-method","html_id":"version:UInt16-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L8","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"@version"}},{"id":"version=(version:UInt16)-instance-method","html_id":"version=(version:UInt16)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"args_string":"(version : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr#L8","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Info/Value","path":"Debug/DWARF/Info/Value.html","kind":"alias","full_name":"Debug::DWARF::Info::Value","name":"Value","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"debug/dwarf/info.cr","line_number":34,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Bool | Int32 | Int64 | Slice(UInt8) | String | UInt16 | UInt32 | UInt64 | UInt8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Info","kind":"struct","full_name":"Debug::DWARF::Info","name":"Info"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers","path":"Debug/DWARF/LineNumbers.html","kind":"struct","full_name":"Debug::DWARF::LineNumbers","name":"LineNumbers","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":42,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":"DWARF Line Numbers parser. Supports DWARF versions 2, 3 and 4.\n\nUsually located in the `.debug_line` section of ELF executables, or the\n`__debug_line` section of Mach-O files.\n\nDocumentation:\n- [DWARF2](http://dwarfstd.org/doc/dwarf-2.0.0.pdf) section 6.2\n- [DWARF3](http://dwarfstd.org/doc/Dwarf3.pdf) section 6.2\n- [DWARF4](http://dwarfstd.org/doc/DWARF4.pdf) section 6.2","summary":"<p>DWARF Line Numbers parser.</p>","class_methods":[],"constructors":[{"id":"new(io:IO::FileDescriptor,size)-class-method","html_id":"new(io:IO::FileDescriptor,size)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(io : IO::FileDescriptor, size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L179","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"directories:Array(String)-instance-method","html_id":"directories:Array(String)-instance-method","name":"directories","doc":"The array of indexed directory paths.","summary":"<p>The array of indexed directory paths.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L172","def":{"name":"directories","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"@directories"}},{"id":"files:Array(String)-instance-method","html_id":"files:Array(String)-instance-method","name":"files","doc":"The array of indexed file names.","summary":"<p>The array of indexed file names.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L175","def":{"name":"files","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"@files"}},{"id":"find(address)-instance-method","html_id":"find(address)-instance-method","name":"find","doc":"Returns the `Row` for the given Program Counter (PC) address if found.","summary":"<p>Returns the <code><a href=\"../../Debug/DWARF/LineNumbers/Row.html\">Row</a></code> for the given Program Counter (PC) address if found.</p>","abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":""}],"args_string":"(address)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L188","def":{"name":"find","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"matrix.each do |rows|\n  if row = rows.first?\n    if address < row.address\n      next\n    end\n  end\n  if row = rows.last?\n    if address > row.address\n      next\n    end\n  end\n  rows.each_with_index do |current_row, index|\n    if current_row.address == address\n      return current_row\n    end\n    if address < current_row.address\n      if previous_row = rows[index - 1]?\n        return previous_row\n      end\n    end\n  end\nend\nnil\n"}},{"id":"matrix:Array(Array(Row))-instance-method","html_id":"matrix:Array(Array(Row))-instance-method","name":"matrix","doc":"Matrix of decompressed `Row` to search line number informations from the\naddress of an instruction.\n\nThe matrix contains indexed references to `directories` and `files` to\nreduce the memory usage of repeating a String many times.","summary":"<p>Matrix of decompressed <code><a href=\"../../Debug/DWARF/LineNumbers/Row.html\">Row</a></code> to search line number informations from the address of an instruction.</p>","abstract":false,"args":[],"args_string":" : Array(Array(Row))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L169","def":{"name":"matrix","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Array(Row))","visibility":"Public","body":"@matrix"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Register","path":"Debug/DWARF/LineNumbers/Register.html","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Register","name":"Register","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":47,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers","kind":"struct","full_name":"Debug::DWARF::LineNumbers","name":"LineNumbers"},"doc":"The state machine registers used to decompress the line number\nsequences.\n\n:nodoc:","summary":"<p>The state machine registers used to decompress the line number sequences.</p>","class_methods":[],"constructors":[{"id":"new(is_stmt)-class-method","html_id":"new(is_stmt)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"is_stmt","doc":null,"default_value":"","external_name":"is_stmt","restriction":""}],"args_string":"(is_stmt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L92","def":{"name":"new","args":[{"name":"is_stmt","doc":null,"default_value":"","external_name":"is_stmt","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(is_stmt)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"address:UInt64-instance-method","html_id":"address:UInt64-instance-method","name":"address","doc":"The Program Counter (PC) value corresponding to a machine instruction\ngenerated by the compiler.","summary":"<p>The Program Counter (PC) value corresponding to a machine instruction generated by the compiler.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L50","def":{"name":"address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@address"}},{"id":"address=(address:UInt64)-instance-method","html_id":"address=(address:UInt64)-instance-method","name":"address=","doc":"The Program Counter (PC) value corresponding to a machine instruction\ngenerated by the compiler.","summary":"<p>The Program Counter (PC) value corresponding to a machine instruction generated by the compiler.</p>","abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"}],"args_string":"(address : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L50","def":{"name":"address=","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@address = address"}},{"id":"basic_block:Bool-instance-method","html_id":"basic_block:Bool-instance-method","name":"basic_block","doc":"Indicates that the instruction is the beginning of a basic block.","summary":"<p>Indicates that the instruction is the beginning of a basic block.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L72","def":{"name":"basic_block","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@basic_block"}},{"id":"basic_block=(basic_block:Bool)-instance-method","html_id":"basic_block=(basic_block:Bool)-instance-method","name":"basic_block=","doc":"Indicates that the instruction is the beginning of a basic block.","summary":"<p>Indicates that the instruction is the beginning of a basic block.</p>","abstract":false,"args":[{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":"Bool"}],"args_string":"(basic_block : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L72","def":{"name":"basic_block=","args":[{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@basic_block = basic_block"}},{"id":"column:UInt32-instance-method","html_id":"column:UInt32-instance-method","name":"column","doc":"Column number within the source file. Starting at 1; the value 0 means\nthat a statement begins at the \"left edge\" of the line.","summary":"<p>Column number within the source file.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L66","def":{"name":"column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@column"}},{"id":"column=(column:UInt32)-instance-method","html_id":"column=(column:UInt32)-instance-method","name":"column=","doc":"Column number within the source file. Starting at 1; the value 0 means\nthat a statement begins at the \"left edge\" of the line.","summary":"<p>Column number within the source file.</p>","abstract":false,"args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"UInt32"}],"args_string":"(column : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L66","def":{"name":"column=","args":[{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@column = column"}},{"id":"discriminator:UInt32-instance-method","html_id":"discriminator:UInt32-instance-method","name":"discriminator","doc":"Identifies the block to which the instruction belongs.","summary":"<p>Identifies the block to which the instruction belongs.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L90","def":{"name":"discriminator","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@discriminator"}},{"id":"discriminator=(discriminator:UInt32)-instance-method","html_id":"discriminator=(discriminator:UInt32)-instance-method","name":"discriminator=","doc":"Identifies the block to which the instruction belongs.","summary":"<p>Identifies the block to which the instruction belongs.</p>","abstract":false,"args":[{"name":"discriminator","doc":null,"default_value":"","external_name":"discriminator","restriction":"UInt32"}],"args_string":"(discriminator : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L90","def":{"name":"discriminator=","args":[{"name":"discriminator","doc":null,"default_value":"","external_name":"discriminator","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@discriminator = discriminator"}},{"id":"end_sequence:Bool-instance-method","html_id":"end_sequence:Bool-instance-method","name":"end_sequence","doc":"Terminates a sequence of lines. Other information in the same row (of\nthe decoded matrix) isn't meaningful.","summary":"<p>Terminates a sequence of lines.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L76","def":{"name":"end_sequence","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@end_sequence"}},{"id":"end_sequence=(end_sequence:Bool)-instance-method","html_id":"end_sequence=(end_sequence:Bool)-instance-method","name":"end_sequence=","doc":"Terminates a sequence of lines. Other information in the same row (of\nthe decoded matrix) isn't meaningful.","summary":"<p>Terminates a sequence of lines.</p>","abstract":false,"args":[{"name":"end_sequence","doc":null,"default_value":"","external_name":"end_sequence","restriction":"Bool"}],"args_string":"(end_sequence : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L76","def":{"name":"end_sequence=","args":[{"name":"end_sequence","doc":null,"default_value":"","external_name":"end_sequence","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@end_sequence = end_sequence"}},{"id":"epilogue_begin:Bool-instance-method","html_id":"epilogue_begin:Bool-instance-method","name":"epilogue_begin","doc":"Indicates the instruction is one where execution should be\nsuspended (for an exit breakpoint).","summary":"<p>Indicates the instruction is one where execution should be suspended (for an exit breakpoint).</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L84","def":{"name":"epilogue_begin","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@epilogue_begin"}},{"id":"epilogue_begin=(epilogue_begin:Bool)-instance-method","html_id":"epilogue_begin=(epilogue_begin:Bool)-instance-method","name":"epilogue_begin=","doc":"Indicates the instruction is one where execution should be\nsuspended (for an exit breakpoint).","summary":"<p>Indicates the instruction is one where execution should be suspended (for an exit breakpoint).</p>","abstract":false,"args":[{"name":"epilogue_begin","doc":null,"default_value":"","external_name":"epilogue_begin","restriction":"Bool"}],"args_string":"(epilogue_begin : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L84","def":{"name":"epilogue_begin=","args":[{"name":"epilogue_begin","doc":null,"default_value":"","external_name":"epilogue_begin","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@epilogue_begin = epilogue_begin"}},{"id":"file:UInt32-instance-method","html_id":"file:UInt32-instance-method","name":"file","doc":"Source file for the instruction.","summary":"<p>Source file for the instruction.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L58","def":{"name":"file","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@file"}},{"id":"file=(file:UInt32)-instance-method","html_id":"file=(file:UInt32)-instance-method","name":"file=","doc":"Source file for the instruction.","summary":"<p>Source file for the instruction.</p>","abstract":false,"args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":"UInt32"}],"args_string":"(file : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L58","def":{"name":"file=","args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@file = file"}},{"id":"is_stmt:Bool-instance-method","html_id":"is_stmt:Bool-instance-method","name":"is_stmt","doc":"Recommended breakpoint location.","summary":"<p>Recommended breakpoint location.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L69","def":{"name":"is_stmt","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@is_stmt"}},{"id":"is_stmt=(is_stmt:Bool)-instance-method","html_id":"is_stmt=(is_stmt:Bool)-instance-method","name":"is_stmt=","doc":"Recommended breakpoint location.","summary":"<p>Recommended breakpoint location.</p>","abstract":false,"args":[{"name":"is_stmt","doc":null,"default_value":"","external_name":"is_stmt","restriction":"Bool"}],"args_string":"(is_stmt : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L69","def":{"name":"is_stmt=","args":[{"name":"is_stmt","doc":null,"default_value":"","external_name":"is_stmt","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@is_stmt = is_stmt"}},{"id":"isa:UInt32-instance-method","html_id":"isa:UInt32-instance-method","name":"isa","doc":"Applicable Instruction Set Architecture for the instruction.","summary":"<p>Applicable Instruction Set Architecture for the instruction.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L87","def":{"name":"isa","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@isa"}},{"id":"isa=(isa:UInt32)-instance-method","html_id":"isa=(isa:UInt32)-instance-method","name":"isa=","doc":"Applicable Instruction Set Architecture for the instruction.","summary":"<p>Applicable Instruction Set Architecture for the instruction.</p>","abstract":false,"args":[{"name":"isa","doc":null,"default_value":"","external_name":"isa","restriction":"UInt32"}],"args_string":"(isa : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L87","def":{"name":"isa=","args":[{"name":"isa","doc":null,"default_value":"","external_name":"isa","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@isa = isa"}},{"id":"line:UInt32-instance-method","html_id":"line:UInt32-instance-method","name":"line","doc":"Line number within the source file. Starting at 1; the value 0 means\nthat the instruction can't be attributed to any source line.","summary":"<p>Line number within the source file.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L62","def":{"name":"line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@line"}},{"id":"line=(line:UInt32)-instance-method","html_id":"line=(line:UInt32)-instance-method","name":"line=","doc":"Line number within the source file. Starting at 1; the value 0 means\nthat the instruction can't be attributed to any source line.","summary":"<p>Line number within the source file.</p>","abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":"UInt32"}],"args_string":"(line : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L62","def":{"name":"line=","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line = line"}},{"id":"op_index:UInt32-instance-method","html_id":"op_index:UInt32-instance-method","name":"op_index","doc":"The index of an operation inside a Very Long Instruction Word (VLIW)\ninstruction. Together with `address` they reference an individual\noperation.","summary":"<p>The index of an operation inside a Very Long Instruction Word (VLIW) instruction.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L55","def":{"name":"op_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@op_index"}},{"id":"op_index=(op_index:UInt32)-instance-method","html_id":"op_index=(op_index:UInt32)-instance-method","name":"op_index=","doc":"The index of an operation inside a Very Long Instruction Word (VLIW)\ninstruction. Together with `address` they reference an individual\noperation.","summary":"<p>The index of an operation inside a Very Long Instruction Word (VLIW) instruction.</p>","abstract":false,"args":[{"name":"op_index","doc":null,"default_value":"","external_name":"op_index","restriction":"UInt32"}],"args_string":"(op_index : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L55","def":{"name":"op_index=","args":[{"name":"op_index","doc":null,"default_value":"","external_name":"op_index","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@op_index = op_index"}},{"id":"prologue_end:Bool-instance-method","html_id":"prologue_end:Bool-instance-method","name":"prologue_end","doc":"Indicates the instruction is one where execution should be\nsuspended (for an entry breakpoint).","summary":"<p>Indicates the instruction is one where execution should be suspended (for an entry breakpoint).</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L80","def":{"name":"prologue_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@prologue_end"}},{"id":"prologue_end=(prologue_end:Bool)-instance-method","html_id":"prologue_end=(prologue_end:Bool)-instance-method","name":"prologue_end=","doc":"Indicates the instruction is one where execution should be\nsuspended (for an entry breakpoint).","summary":"<p>Indicates the instruction is one where execution should be suspended (for an entry breakpoint).</p>","abstract":false,"args":[{"name":"prologue_end","doc":null,"default_value":"","external_name":"prologue_end","restriction":"Bool"}],"args_string":"(prologue_end : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L80","def":{"name":"prologue_end=","args":[{"name":"prologue_end","doc":null,"default_value":"","external_name":"prologue_end","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@prologue_end = prologue_end"}},{"id":"reset-instance-method","html_id":"reset-instance-method","name":"reset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L106","def":{"name":"reset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@basic_block = false\n@prologue_end = false\n@epilogue_begin = false\n@discriminator = 0_u32\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Row","path":"Debug/DWARF/LineNumbers/Row.html","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Row","name":"Row","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":115,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers","kind":"struct","full_name":"Debug::DWARF::LineNumbers","name":"LineNumbers"},"doc":"The decoded line number information for an instruction.","summary":"<p>The decoded line number information for an instruction.</p>","class_methods":[],"constructors":[{"id":"new(address:UInt64,op_index:UInt32,directory:Int32,file:Int32,line:Int32,column:Int32,end_sequence:Bool)-class-method","html_id":"new(address:UInt64,op_index:UInt32,directory:Int32,file:Int32,line:Int32,column:Int32,end_sequence:Bool)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"},{"name":"op_index","doc":null,"default_value":"","external_name":"op_index","restriction":"UInt32"},{"name":"directory","doc":null,"default_value":"","external_name":"directory","restriction":"Int32"},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":"Int32"},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":"Int32"},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int32"},{"name":"end_sequence","doc":null,"default_value":"","external_name":"end_sequence","restriction":"Bool"}],"args_string":"(address : UInt64, op_index : UInt32, directory : Int32, file : Int32, line : Int32, column : Int32, end_sequence : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","def":{"name":"new","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"},{"name":"op_index","doc":null,"default_value":"","external_name":"op_index","restriction":"UInt32"},{"name":"directory","doc":null,"default_value":"","external_name":"directory","restriction":"Int32"},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":"Int32"},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":"Int32"},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":"Int32"},{"name":"end_sequence","doc":null,"default_value":"","external_name":"end_sequence","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(address, op_index, directory, file, line, column, end_sequence)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"address:UInt64-instance-method","html_id":"address:UInt64-instance-method","name":"address","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64","source_link":null,"source_link":null,"def":{"name":"address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@address"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Row.new(@address.clone, @op_index.clone, @directory.clone, @file.clone, @line.clone, @column.clone, @end_sequence.clone)"}},{"id":"column:Int32-instance-method","html_id":"column:Int32-instance-method","name":"column","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":null,"source_link":null,"def":{"name":"column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column"}},{"id":"copy_with(address_address=@address,op_index_op_index=@op_index,directory_directory=@directory,file_file=@file,line_line=@line,column_column=@column,end_sequence_end_sequence=@end_sequence)-instance-method","html_id":"copy_with(address_address=@address,op_index_op_index=@op_index,directory_directory=@directory,file_file=@file,line_line=@line,column_column=@column,end_sequence_end_sequence=@end_sequence)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_address","doc":null,"default_value":"@address","external_name":"address","restriction":""},{"name":"_op_index","doc":null,"default_value":"@op_index","external_name":"op_index","restriction":""},{"name":"_directory","doc":null,"default_value":"@directory","external_name":"directory","restriction":""},{"name":"_file","doc":null,"default_value":"@file","external_name":"file","restriction":""},{"name":"_line","doc":null,"default_value":"@line","external_name":"line","restriction":""},{"name":"_column","doc":null,"default_value":"@column","external_name":"column","restriction":""},{"name":"_end_sequence","doc":null,"default_value":"@end_sequence","external_name":"end_sequence","restriction":""}],"args_string":"(address _address = @address, op_index _op_index = @op_index, directory _directory = @directory, file _file = @file, line _line = @line, column _column = @column, end_sequence _end_sequence = @end_sequence)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L115","def":{"name":"copy_with","args":[{"name":"_address","doc":null,"default_value":"@address","external_name":"address","restriction":""},{"name":"_op_index","doc":null,"default_value":"@op_index","external_name":"op_index","restriction":""},{"name":"_directory","doc":null,"default_value":"@directory","external_name":"directory","restriction":""},{"name":"_file","doc":null,"default_value":"@file","external_name":"file","restriction":""},{"name":"_line","doc":null,"default_value":"@line","external_name":"line","restriction":""},{"name":"_column","doc":null,"default_value":"@column","external_name":"column","restriction":""},{"name":"_end_sequence","doc":null,"default_value":"@end_sequence","external_name":"end_sequence","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Row.new(_address, _op_index, _directory, _file, _line, _column, _end_sequence)"}},{"id":"directory:Int32-instance-method","html_id":"directory:Int32-instance-method","name":"directory","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":null,"source_link":null,"def":{"name":"directory","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@directory"}},{"id":"end_sequence:Bool-instance-method","html_id":"end_sequence:Bool-instance-method","name":"end_sequence","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":null,"source_link":null,"def":{"name":"end_sequence","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@end_sequence"}},{"id":"file:Int32-instance-method","html_id":"file:Int32-instance-method","name":"file","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":null,"source_link":null,"def":{"name":"file","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@file"}},{"id":"line:Int32-instance-method","html_id":"line:Int32-instance-method","name":"line","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":null,"source_link":null,"def":{"name":"line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line"}},{"id":"op_index:UInt32-instance-method","html_id":"op_index:UInt32-instance-method","name":"op_index","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32","source_link":null,"source_link":null,"def":{"name":"op_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"@op_index"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Sequence","path":"Debug/DWARF/LineNumbers/Sequence.html","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Sequence","name":"Sequence","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":127,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers","kind":"struct","full_name":"Debug::DWARF::LineNumbers","name":"LineNumbers"},"doc":"An individual compressed sequence.\n\n:nodoc:","summary":"<p>An individual compressed sequence.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L151","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"default_is_stmt-instance-method","html_id":"default_is_stmt-instance-method","name":"default_is_stmt","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"default_is_stmt","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@default_is_stmt.not_nil!"}},{"id":"default_is_stmt=(default_is_stmt:Bool)-instance-method","html_id":"default_is_stmt=(default_is_stmt:Bool)-instance-method","name":"default_is_stmt=","doc":null,"summary":null,"abstract":false,"args":[{"name":"default_is_stmt","doc":null,"default_value":"","external_name":"default_is_stmt","restriction":"Bool"}],"args_string":"(default_is_stmt : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L134","def":{"name":"default_is_stmt=","args":[{"name":"default_is_stmt","doc":null,"default_value":"","external_name":"default_is_stmt","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@default_is_stmt = default_is_stmt"}},{"id":"default_is_stmt?:Bool?-instance-method","html_id":"default_is_stmt?:Bool?-instance-method","name":"default_is_stmt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool?","source_link":null,"source_link":null,"def":{"name":"default_is_stmt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@default_is_stmt"}},{"id":"file_names:Array({String,Int32,Int32,Int32})-instance-method","html_id":"file_names:Array({String,Int32,Int32,Int32})-instance-method","name":"file_names","doc":"An array of file names. Starts at 1; 0 means that the information is\nmissing.","summary":"<p>An array of file names.</p>","abstract":false,"args":[],"args_string":" : Array({String, Int32, Int32, Int32})","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L149","def":{"name":"file_names","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@file_names"}},{"id":"header_length-instance-method","html_id":"header_length-instance-method","name":"header_length","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"header_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@header_length.not_nil!"}},{"id":"header_length=(header_length:UInt32)-instance-method","html_id":"header_length=(header_length:UInt32)-instance-method","name":"header_length=","doc":null,"summary":null,"abstract":false,"args":[{"name":"header_length","doc":null,"default_value":"","external_name":"header_length","restriction":"UInt32"}],"args_string":"(header_length : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L131","def":{"name":"header_length=","args":[{"name":"header_length","doc":null,"default_value":"","external_name":"header_length","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@header_length = header_length"}},{"id":"header_length?:UInt32?-instance-method","html_id":"header_length?:UInt32?-instance-method","name":"header_length?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"header_length?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@header_length"}},{"id":"include_directories:Array(String)-instance-method","html_id":"include_directories:Array(String)-instance-method","name":"include_directories","doc":"An array of directory names. Starts at 1; 0 means that the information\nis missing.","summary":"<p>An array of directory names.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L145","def":{"name":"include_directories","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@include_directories"}},{"id":"line_base-instance-method","html_id":"line_base-instance-method","name":"line_base","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"line_base","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_base.not_nil!"}},{"id":"line_base=(line_base:Int8)-instance-method","html_id":"line_base=(line_base:Int8)-instance-method","name":"line_base=","doc":null,"summary":null,"abstract":false,"args":[{"name":"line_base","doc":null,"default_value":"","external_name":"line_base","restriction":"Int8"}],"args_string":"(line_base : Int8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L135","def":{"name":"line_base=","args":[{"name":"line_base","doc":null,"default_value":"","external_name":"line_base","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_base = line_base"}},{"id":"line_base?:Int8?-instance-method","html_id":"line_base?:Int8?-instance-method","name":"line_base?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int8?","source_link":null,"source_link":null,"def":{"name":"line_base?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_base"}},{"id":"line_range-instance-method","html_id":"line_range-instance-method","name":"line_range","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"line_range","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_range.not_nil!"}},{"id":"line_range=(line_range:UInt8)-instance-method","html_id":"line_range=(line_range:UInt8)-instance-method","name":"line_range=","doc":null,"summary":null,"abstract":false,"args":[{"name":"line_range","doc":null,"default_value":"","external_name":"line_range","restriction":"UInt8"}],"args_string":"(line_range : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L136","def":{"name":"line_range=","args":[{"name":"line_range","doc":null,"default_value":"","external_name":"line_range","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_range = line_range"}},{"id":"line_range?:UInt8?-instance-method","html_id":"line_range?:UInt8?-instance-method","name":"line_range?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8?","source_link":null,"source_link":null,"def":{"name":"line_range?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_range"}},{"id":"maximum_operations_per_instruction:UInt8-instance-method","html_id":"maximum_operations_per_instruction:UInt8-instance-method","name":"maximum_operations_per_instruction","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L133","def":{"name":"maximum_operations_per_instruction","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@maximum_operations_per_instruction"}},{"id":"maximum_operations_per_instruction=(maximum_operations_per_instruction:UInt8)-instance-method","html_id":"maximum_operations_per_instruction=(maximum_operations_per_instruction:UInt8)-instance-method","name":"maximum_operations_per_instruction=","doc":null,"summary":null,"abstract":false,"args":[{"name":"maximum_operations_per_instruction","doc":null,"default_value":"","external_name":"maximum_operations_per_instruction","restriction":"UInt8"}],"args_string":"(maximum_operations_per_instruction : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L133","def":{"name":"maximum_operations_per_instruction=","args":[{"name":"maximum_operations_per_instruction","doc":null,"default_value":"","external_name":"maximum_operations_per_instruction","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@maximum_operations_per_instruction = maximum_operations_per_instruction"}},{"id":"minimum_instruction_length-instance-method","html_id":"minimum_instruction_length-instance-method","name":"minimum_instruction_length","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"minimum_instruction_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@minimum_instruction_length.not_nil!"}},{"id":"minimum_instruction_length=(minimum_instruction_length:UInt8)-instance-method","html_id":"minimum_instruction_length=(minimum_instruction_length:UInt8)-instance-method","name":"minimum_instruction_length=","doc":"FIXME: UInt64 for DWARF64 (uncommon)","summary":"<p><span class=\"flag yellow\">FIXME</span>  UInt64 for DWARF64 (uncommon)</p>","abstract":false,"args":[{"name":"minimum_instruction_length","doc":null,"default_value":"","external_name":"minimum_instruction_length","restriction":"UInt8"}],"args_string":"(minimum_instruction_length : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L132","def":{"name":"minimum_instruction_length=","args":[{"name":"minimum_instruction_length","doc":null,"default_value":"","external_name":"minimum_instruction_length","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@minimum_instruction_length = minimum_instruction_length"}},{"id":"minimum_instruction_length?:UInt8?-instance-method","html_id":"minimum_instruction_length?:UInt8?-instance-method","name":"minimum_instruction_length?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8?","source_link":null,"source_link":null,"def":{"name":"minimum_instruction_length?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@minimum_instruction_length"}},{"id":"offset-instance-method","html_id":"offset-instance-method","name":"offset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset.not_nil!"}},{"id":"offset=(offset:LibC::OffT)-instance-method","html_id":"offset=(offset:LibC::OffT)-instance-method","name":"offset=","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"LibC::OffT"}],"args_string":"(offset : LibC::OffT)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L128","def":{"name":"offset=","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"LibC::OffT"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset = offset"}},{"id":"offset?:Int64?-instance-method","html_id":"offset?:Int64?-instance-method","name":"offset?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int64?","source_link":null,"source_link":null,"def":{"name":"offset?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset"}},{"id":"opcode_base-instance-method","html_id":"opcode_base-instance-method","name":"opcode_base","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"opcode_base","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@opcode_base.not_nil!"}},{"id":"opcode_base=(opcode_base:UInt8)-instance-method","html_id":"opcode_base=(opcode_base:UInt8)-instance-method","name":"opcode_base=","doc":null,"summary":null,"abstract":false,"args":[{"name":"opcode_base","doc":null,"default_value":"","external_name":"opcode_base","restriction":"UInt8"}],"args_string":"(opcode_base : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L137","def":{"name":"opcode_base=","args":[{"name":"opcode_base","doc":null,"default_value":"","external_name":"opcode_base","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@opcode_base = opcode_base"}},{"id":"opcode_base?:UInt8?-instance-method","html_id":"opcode_base?:UInt8?-instance-method","name":"opcode_base?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8?","source_link":null,"source_link":null,"def":{"name":"opcode_base?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@opcode_base"}},{"id":"standard_opcode_lengths:Array(UInt8)-instance-method","html_id":"standard_opcode_lengths:Array(UInt8)-instance-method","name":"standard_opcode_lengths","doc":"An array of how many args an array. Starts at 1 because 0 means an\nextended opcode.","summary":"<p>An array of how many args an array.</p>","abstract":false,"args":[],"args_string":" : Array(UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L141","def":{"name":"standard_opcode_lengths","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@standard_opcode_lengths"}},{"id":"total_length-instance-method","html_id":"total_length-instance-method","name":"total_length","doc":"Returns the unit length, adding the size of the `unit_length`.","summary":"<p>Returns the unit length, adding the size of the <code><a href=\"../../../Debug/DWARF/LineNumbers/Sequence.html#unit_length-instance-method\">#unit_length</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L159","def":{"name":"total_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"unit_length + (sizeof(typeof(unit_length)))"}},{"id":"unit_length-instance-method","html_id":"unit_length-instance-method","name":"unit_length","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"unit_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unit_length.not_nil!"}},{"id":"unit_length=(unit_length:UInt32)-instance-method","html_id":"unit_length=(unit_length:UInt32)-instance-method","name":"unit_length=","doc":null,"summary":null,"abstract":false,"args":[{"name":"unit_length","doc":null,"default_value":"","external_name":"unit_length","restriction":"UInt32"}],"args_string":"(unit_length : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L129","def":{"name":"unit_length=","args":[{"name":"unit_length","doc":null,"default_value":"","external_name":"unit_length","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unit_length = unit_length"}},{"id":"unit_length?:UInt32?-instance-method","html_id":"unit_length?:UInt32?-instance-method","name":"unit_length?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"unit_length?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unit_length"}},{"id":"version-instance-method","html_id":"version-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version.not_nil!"}},{"id":"version=(version:UInt16)-instance-method","html_id":"version=(version:UInt16)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"args_string":"(version : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L130","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}},{"id":"version?:UInt16?-instance-method","html_id":"version?:UInt16?-instance-method","name":"version?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"version?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LNE","path":"Debug/DWARF/LNE.html","kind":"enum","full_name":"Debug::DWARF::LNE","name":"LNE","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":26,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"EndSequence","name":"EndSequence","value":"1_u8","doc":null,"summary":null},{"id":"SetAddress","name":"SetAddress","value":"2_u8","doc":null,"summary":null},{"id":"DefineFile","name":"DefineFile","value":"3_u8","doc":null,"summary":null},{"id":"SetDiscriminator","name":"SetDiscriminator","value":"4_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":"Extended Line Number opcodes.\n:nodoc:","summary":"<p>Extended Line Number opcodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"define_file?-instance-method","html_id":"define_file?-instance-method","name":"define_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L29","def":{"name":"define_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DefineFile"}},{"id":"end_sequence?-instance-method","html_id":"end_sequence?-instance-method","name":"end_sequence?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L27","def":{"name":"end_sequence?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == EndSequence"}},{"id":"set_address?-instance-method","html_id":"set_address?-instance-method","name":"set_address?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L28","def":{"name":"set_address?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetAddress"}},{"id":"set_discriminator?-instance-method","html_id":"set_discriminator?-instance-method","name":"set_discriminator?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L30","def":{"name":"set_discriminator?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetDiscriminator"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LNS","path":"Debug/DWARF/LNS.html","kind":"enum","full_name":"Debug::DWARF::LNS","name":"LNS","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/line_numbers.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Copy","name":"Copy","value":"1_u8","doc":null,"summary":null},{"id":"AdvancePc","name":"AdvancePc","value":"2_u8","doc":null,"summary":null},{"id":"AdvanceLine","name":"AdvanceLine","value":"3_u8","doc":null,"summary":null},{"id":"SetFile","name":"SetFile","value":"4_u8","doc":null,"summary":null},{"id":"SetColumn","name":"SetColumn","value":"5_u8","doc":null,"summary":null},{"id":"NegateStmt","name":"NegateStmt","value":"6_u8","doc":null,"summary":null},{"id":"SetBasicBlock","name":"SetBasicBlock","value":"7_u8","doc":null,"summary":null},{"id":"ConstAddPc","name":"ConstAddPc","value":"8_u8","doc":null,"summary":null},{"id":"FixedAdvancePc","name":"FixedAdvancePc","value":"9_u8","doc":null,"summary":null},{"id":"SetPrologueEnd","name":"SetPrologueEnd","value":"10_u8","doc":null,"summary":null},{"id":"SetEpiloqueBegin","name":"SetEpiloqueBegin","value":"11_u8","doc":null,"summary":null},{"id":"SetIsa","name":"SetIsa","value":"12_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":"Standard Line Number opcodes.\n:nodoc:","summary":"<p>Standard Line Number opcodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"advance_line?-instance-method","html_id":"advance_line?-instance-method","name":"advance_line?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L12","def":{"name":"advance_line?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AdvanceLine"}},{"id":"advance_pc?-instance-method","html_id":"advance_pc?-instance-method","name":"advance_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L11","def":{"name":"advance_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AdvancePc"}},{"id":"const_add_pc?-instance-method","html_id":"const_add_pc?-instance-method","name":"const_add_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L17","def":{"name":"const_add_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstAddPc"}},{"id":"copy?-instance-method","html_id":"copy?-instance-method","name":"copy?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L10","def":{"name":"copy?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Copy"}},{"id":"fixed_advance_pc?-instance-method","html_id":"fixed_advance_pc?-instance-method","name":"fixed_advance_pc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L18","def":{"name":"fixed_advance_pc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FixedAdvancePc"}},{"id":"negate_stmt?-instance-method","html_id":"negate_stmt?-instance-method","name":"negate_stmt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L15","def":{"name":"negate_stmt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NegateStmt"}},{"id":"set_basic_block?-instance-method","html_id":"set_basic_block?-instance-method","name":"set_basic_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L16","def":{"name":"set_basic_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetBasicBlock"}},{"id":"set_column?-instance-method","html_id":"set_column?-instance-method","name":"set_column?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L14","def":{"name":"set_column?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetColumn"}},{"id":"set_epiloque_begin?-instance-method","html_id":"set_epiloque_begin?-instance-method","name":"set_epiloque_begin?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L20","def":{"name":"set_epiloque_begin?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetEpiloqueBegin"}},{"id":"set_file?-instance-method","html_id":"set_file?-instance-method","name":"set_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L13","def":{"name":"set_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetFile"}},{"id":"set_isa?-instance-method","html_id":"set_isa?-instance-method","name":"set_isa?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L21","def":{"name":"set_isa?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetIsa"}},{"id":"set_prologue_end?-instance-method","html_id":"set_prologue_end?-instance-method","name":"set_prologue_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/line_numbers.cr#L19","def":{"name":"set_prologue_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetPrologueEnd"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Strings","path":"Debug/DWARF/Strings.html","kind":"struct","full_name":"Debug::DWARF::Strings","name":"Strings","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/strings.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(io:IO::FileDescriptor,offset:UInt32|UInt64)-class-method","html_id":"new(io:IO::FileDescriptor,offset:UInt32|UInt64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"UInt32 | UInt64"}],"args_string":"(io : IO::FileDescriptor, offset : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr#L4","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, offset)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"decode(strp)-instance-method","html_id":"decode(strp)-instance-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"strp","doc":null,"default_value":"","external_name":"strp","restriction":""}],"args_string":"(strp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/strings.cr#L7","def":{"name":"decode","args":[{"name":"strp","doc":null,"default_value":"","external_name":"strp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.seek(@offset + strp) do\n  (@io.gets('\\u{0}')).to_s.chomp('\\u{0}')\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/TAG","path":"Debug/DWARF/TAG.html","kind":"enum","full_name":"Debug::DWARF::TAG","name":"TAG","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/dwarf/abbrev.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ArrayType","name":"ArrayType","value":"1_u32","doc":null,"summary":null},{"id":"ClassType","name":"ClassType","value":"2_u32","doc":null,"summary":null},{"id":"EntryPoint","name":"EntryPoint","value":"3_u32","doc":null,"summary":null},{"id":"EnumerationType","name":"EnumerationType","value":"4_u32","doc":null,"summary":null},{"id":"FormalParameter","name":"FormalParameter","value":"5_u32","doc":null,"summary":null},{"id":"ImportedDeclaration","name":"ImportedDeclaration","value":"8_u32","doc":null,"summary":null},{"id":"Label","name":"Label","value":"10_u32","doc":null,"summary":null},{"id":"LexicalBlock","name":"LexicalBlock","value":"11_u32","doc":null,"summary":null},{"id":"Member","name":"Member","value":"13_u32","doc":null,"summary":null},{"id":"PointerType","name":"PointerType","value":"15_u32","doc":null,"summary":null},{"id":"ReferenceType","name":"ReferenceType","value":"16_u32","doc":null,"summary":null},{"id":"CompileUnit","name":"CompileUnit","value":"17_u32","doc":null,"summary":null},{"id":"StringType","name":"StringType","value":"18_u32","doc":null,"summary":null},{"id":"StructureType","name":"StructureType","value":"19_u32","doc":null,"summary":null},{"id":"SubroutineType","name":"SubroutineType","value":"21_u32","doc":null,"summary":null},{"id":"Typedef","name":"Typedef","value":"22_u32","doc":null,"summary":null},{"id":"UnionType","name":"UnionType","value":"23_u32","doc":null,"summary":null},{"id":"UnspecifiedParameters","name":"UnspecifiedParameters","value":"24_u32","doc":null,"summary":null},{"id":"Variant","name":"Variant","value":"25_u32","doc":null,"summary":null},{"id":"CommonBlock","name":"CommonBlock","value":"26_u32","doc":null,"summary":null},{"id":"CommonInclusion","name":"CommonInclusion","value":"27_u32","doc":null,"summary":null},{"id":"Inheritance","name":"Inheritance","value":"28_u32","doc":null,"summary":null},{"id":"InlinedSubroutine","name":"InlinedSubroutine","value":"29_u32","doc":null,"summary":null},{"id":"Module","name":"Module","value":"30_u32","doc":null,"summary":null},{"id":"PtrToMemberType","name":"PtrToMemberType","value":"31_u32","doc":null,"summary":null},{"id":"SetType","name":"SetType","value":"32_u32","doc":null,"summary":null},{"id":"SubrangeType","name":"SubrangeType","value":"33_u32","doc":null,"summary":null},{"id":"WithStmt","name":"WithStmt","value":"34_u32","doc":null,"summary":null},{"id":"AccessDeclaration","name":"AccessDeclaration","value":"35_u32","doc":null,"summary":null},{"id":"BaseType","name":"BaseType","value":"36_u32","doc":null,"summary":null},{"id":"CatchBlock","name":"CatchBlock","value":"37_u32","doc":null,"summary":null},{"id":"ConstType","name":"ConstType","value":"38_u32","doc":null,"summary":null},{"id":"Constant","name":"Constant","value":"39_u32","doc":null,"summary":null},{"id":"Enumerator","name":"Enumerator","value":"40_u32","doc":null,"summary":null},{"id":"FileType","name":"FileType","value":"41_u32","doc":null,"summary":null},{"id":"Friend","name":"Friend","value":"42_u32","doc":null,"summary":null},{"id":"Namelist","name":"Namelist","value":"43_u32","doc":null,"summary":null},{"id":"NamelistItem","name":"NamelistItem","value":"44_u32","doc":null,"summary":null},{"id":"PackedType","name":"PackedType","value":"45_u32","doc":null,"summary":null},{"id":"Subprogram","name":"Subprogram","value":"46_u32","doc":null,"summary":null},{"id":"TemplateTypeParameter","name":"TemplateTypeParameter","value":"47_u32","doc":null,"summary":null},{"id":"TemplateValueParameter","name":"TemplateValueParameter","value":"48_u32","doc":null,"summary":null},{"id":"ThrownType","name":"ThrownType","value":"49_u32","doc":null,"summary":null},{"id":"TryBlock","name":"TryBlock","value":"50_u32","doc":null,"summary":null},{"id":"VariantPart","name":"VariantPart","value":"51_u32","doc":null,"summary":null},{"id":"Variable","name":"Variable","value":"52_u32","doc":null,"summary":null},{"id":"VolatileType","name":"VolatileType","value":"53_u32","doc":null,"summary":null},{"id":"DwarfProcedure","name":"DwarfProcedure","value":"54_u32","doc":null,"summary":null},{"id":"RestrictType","name":"RestrictType","value":"55_u32","doc":null,"summary":null},{"id":"InterfaceType","name":"InterfaceType","value":"56_u32","doc":null,"summary":null},{"id":"Namespace","name":"Namespace","value":"57_u32","doc":null,"summary":null},{"id":"ImportedModule","name":"ImportedModule","value":"58_u32","doc":null,"summary":null},{"id":"UnspecifiedType","name":"UnspecifiedType","value":"59_u32","doc":null,"summary":null},{"id":"PartialUnit","name":"PartialUnit","value":"60_u32","doc":null,"summary":null},{"id":"ImportedUnit","name":"ImportedUnit","value":"61_u32","doc":null,"summary":null},{"id":"Condition","name":"Condition","value":"63_u32","doc":null,"summary":null},{"id":"SharedType","name":"SharedType","value":"64_u32","doc":null,"summary":null},{"id":"TypeUnit","name":"TypeUnit","value":"65_u32","doc":null,"summary":null},{"id":"RvalueReferenceType","name":"RvalueReferenceType","value":"66_u32","doc":null,"summary":null},{"id":"TemplateAlias","name":"TemplateAlias","value":"67_u32","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF","kind":"module","full_name":"Debug::DWARF","name":"DWARF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"access_declaration?-instance-method","html_id":"access_declaration?-instance-method","name":"access_declaration?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L35","def":{"name":"access_declaration?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AccessDeclaration"}},{"id":"array_type?-instance-method","html_id":"array_type?-instance-method","name":"array_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L6","def":{"name":"array_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ArrayType"}},{"id":"base_type?-instance-method","html_id":"base_type?-instance-method","name":"base_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L36","def":{"name":"base_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BaseType"}},{"id":"catch_block?-instance-method","html_id":"catch_block?-instance-method","name":"catch_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L37","def":{"name":"catch_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CatchBlock"}},{"id":"class_type?-instance-method","html_id":"class_type?-instance-method","name":"class_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L7","def":{"name":"class_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ClassType"}},{"id":"common_block?-instance-method","html_id":"common_block?-instance-method","name":"common_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L26","def":{"name":"common_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CommonBlock"}},{"id":"common_inclusion?-instance-method","html_id":"common_inclusion?-instance-method","name":"common_inclusion?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L27","def":{"name":"common_inclusion?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CommonInclusion"}},{"id":"compile_unit?-instance-method","html_id":"compile_unit?-instance-method","name":"compile_unit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L18","def":{"name":"compile_unit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CompileUnit"}},{"id":"condition?-instance-method","html_id":"condition?-instance-method","name":"condition?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L62","def":{"name":"condition?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Condition"}},{"id":"const_type?-instance-method","html_id":"const_type?-instance-method","name":"const_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L38","def":{"name":"const_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstType"}},{"id":"constant?-instance-method","html_id":"constant?-instance-method","name":"constant?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L39","def":{"name":"constant?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Constant"}},{"id":"dwarf_procedure?-instance-method","html_id":"dwarf_procedure?-instance-method","name":"dwarf_procedure?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L54","def":{"name":"dwarf_procedure?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DwarfProcedure"}},{"id":"entry_point?-instance-method","html_id":"entry_point?-instance-method","name":"entry_point?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L8","def":{"name":"entry_point?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == EntryPoint"}},{"id":"enumeration_type?-instance-method","html_id":"enumeration_type?-instance-method","name":"enumeration_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L9","def":{"name":"enumeration_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == EnumerationType"}},{"id":"enumerator?-instance-method","html_id":"enumerator?-instance-method","name":"enumerator?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L40","def":{"name":"enumerator?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Enumerator"}},{"id":"file_type?-instance-method","html_id":"file_type?-instance-method","name":"file_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L41","def":{"name":"file_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FileType"}},{"id":"formal_parameter?-instance-method","html_id":"formal_parameter?-instance-method","name":"formal_parameter?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L10","def":{"name":"formal_parameter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FormalParameter"}},{"id":"friend?-instance-method","html_id":"friend?-instance-method","name":"friend?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L42","def":{"name":"friend?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Friend"}},{"id":"imported_declaration?-instance-method","html_id":"imported_declaration?-instance-method","name":"imported_declaration?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L12","def":{"name":"imported_declaration?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ImportedDeclaration"}},{"id":"imported_module?-instance-method","html_id":"imported_module?-instance-method","name":"imported_module?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L58","def":{"name":"imported_module?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ImportedModule"}},{"id":"imported_unit?-instance-method","html_id":"imported_unit?-instance-method","name":"imported_unit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L61","def":{"name":"imported_unit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ImportedUnit"}},{"id":"inheritance?-instance-method","html_id":"inheritance?-instance-method","name":"inheritance?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L28","def":{"name":"inheritance?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Inheritance"}},{"id":"inlined_subroutine?-instance-method","html_id":"inlined_subroutine?-instance-method","name":"inlined_subroutine?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L29","def":{"name":"inlined_subroutine?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == InlinedSubroutine"}},{"id":"interface_type?-instance-method","html_id":"interface_type?-instance-method","name":"interface_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L56","def":{"name":"interface_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == InterfaceType"}},{"id":"label?-instance-method","html_id":"label?-instance-method","name":"label?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L13","def":{"name":"label?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Label"}},{"id":"lexical_block?-instance-method","html_id":"lexical_block?-instance-method","name":"lexical_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L14","def":{"name":"lexical_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LexicalBlock"}},{"id":"member?-instance-method","html_id":"member?-instance-method","name":"member?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L15","def":{"name":"member?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Member"}},{"id":"module?-instance-method","html_id":"module?-instance-method","name":"module?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L30","def":{"name":"module?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Module"}},{"id":"namelist?-instance-method","html_id":"namelist?-instance-method","name":"namelist?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L43","def":{"name":"namelist?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Namelist"}},{"id":"namelist_item?-instance-method","html_id":"namelist_item?-instance-method","name":"namelist_item?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L44","def":{"name":"namelist_item?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NamelistItem"}},{"id":"namespace?-instance-method","html_id":"namespace?-instance-method","name":"namespace?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L57","def":{"name":"namespace?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Namespace"}},{"id":"packed_type?-instance-method","html_id":"packed_type?-instance-method","name":"packed_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L45","def":{"name":"packed_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PackedType"}},{"id":"partial_unit?-instance-method","html_id":"partial_unit?-instance-method","name":"partial_unit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L60","def":{"name":"partial_unit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PartialUnit"}},{"id":"pointer_type?-instance-method","html_id":"pointer_type?-instance-method","name":"pointer_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L16","def":{"name":"pointer_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PointerType"}},{"id":"ptr_to_member_type?-instance-method","html_id":"ptr_to_member_type?-instance-method","name":"ptr_to_member_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L31","def":{"name":"ptr_to_member_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PtrToMemberType"}},{"id":"reference_type?-instance-method","html_id":"reference_type?-instance-method","name":"reference_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L17","def":{"name":"reference_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ReferenceType"}},{"id":"restrict_type?-instance-method","html_id":"restrict_type?-instance-method","name":"restrict_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L55","def":{"name":"restrict_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RestrictType"}},{"id":"rvalue_reference_type?-instance-method","html_id":"rvalue_reference_type?-instance-method","name":"rvalue_reference_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L65","def":{"name":"rvalue_reference_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RvalueReferenceType"}},{"id":"set_type?-instance-method","html_id":"set_type?-instance-method","name":"set_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L32","def":{"name":"set_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SetType"}},{"id":"shared_type?-instance-method","html_id":"shared_type?-instance-method","name":"shared_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L63","def":{"name":"shared_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SharedType"}},{"id":"string_type?-instance-method","html_id":"string_type?-instance-method","name":"string_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L19","def":{"name":"string_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == StringType"}},{"id":"structure_type?-instance-method","html_id":"structure_type?-instance-method","name":"structure_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L20","def":{"name":"structure_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == StructureType"}},{"id":"subprogram?-instance-method","html_id":"subprogram?-instance-method","name":"subprogram?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L46","def":{"name":"subprogram?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Subprogram"}},{"id":"subrange_type?-instance-method","html_id":"subrange_type?-instance-method","name":"subrange_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L33","def":{"name":"subrange_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SubrangeType"}},{"id":"subroutine_type?-instance-method","html_id":"subroutine_type?-instance-method","name":"subroutine_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L21","def":{"name":"subroutine_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SubroutineType"}},{"id":"template_alias?-instance-method","html_id":"template_alias?-instance-method","name":"template_alias?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L66","def":{"name":"template_alias?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TemplateAlias"}},{"id":"template_type_parameter?-instance-method","html_id":"template_type_parameter?-instance-method","name":"template_type_parameter?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L47","def":{"name":"template_type_parameter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TemplateTypeParameter"}},{"id":"template_value_parameter?-instance-method","html_id":"template_value_parameter?-instance-method","name":"template_value_parameter?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L48","def":{"name":"template_value_parameter?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TemplateValueParameter"}},{"id":"thrown_type?-instance-method","html_id":"thrown_type?-instance-method","name":"thrown_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L49","def":{"name":"thrown_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ThrownType"}},{"id":"try_block?-instance-method","html_id":"try_block?-instance-method","name":"try_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L50","def":{"name":"try_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TryBlock"}},{"id":"type_unit?-instance-method","html_id":"type_unit?-instance-method","name":"type_unit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L64","def":{"name":"type_unit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TypeUnit"}},{"id":"typedef?-instance-method","html_id":"typedef?-instance-method","name":"typedef?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L22","def":{"name":"typedef?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Typedef"}},{"id":"union_type?-instance-method","html_id":"union_type?-instance-method","name":"union_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L23","def":{"name":"union_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UnionType"}},{"id":"unspecified_parameters?-instance-method","html_id":"unspecified_parameters?-instance-method","name":"unspecified_parameters?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L24","def":{"name":"unspecified_parameters?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UnspecifiedParameters"}},{"id":"unspecified_type?-instance-method","html_id":"unspecified_type?-instance-method","name":"unspecified_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L59","def":{"name":"unspecified_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UnspecifiedType"}},{"id":"variable?-instance-method","html_id":"variable?-instance-method","name":"variable?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L52","def":{"name":"variable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Variable"}},{"id":"variant?-instance-method","html_id":"variant?-instance-method","name":"variant?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L25","def":{"name":"variant?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Variant"}},{"id":"variant_part?-instance-method","html_id":"variant_part?-instance-method","name":"variant_part?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L51","def":{"name":"variant_part?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == VariantPart"}},{"id":"volatile_type?-instance-method","html_id":"volatile_type?-instance-method","name":"volatile_type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L53","def":{"name":"volatile_type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == VolatileType"}},{"id":"with_stmt?-instance-method","html_id":"with_stmt?-instance-method","name":"with_stmt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/dwarf/abbrev.cr#L34","def":{"name":"with_stmt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WithStmt"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","path":"Debug/ELF.html","kind":"struct","full_name":"Debug::ELF","name":"ELF","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAGIC","name":"MAGIC","value":"UInt8.slice(127, 'E'.ord, 'L'.ord, 'F'.ord)","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug","kind":"module","full_name":"Debug","name":"Debug"},"doc":"ELF reader.\n\nDocumentation:\n- <http://www.sco.com/developers/gabi/latest/contents.html>","summary":"<p>ELF reader.</p>","class_methods":[{"id":"open(path,&block)-class-method","html_id":"open(path,&amp;block)-class-method","name":"open","doc":null,"summary":null,"abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L147","def":{"name":"open","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"File.open(path, \"r\") do |file|\n  yield new(file)\nend"}}],"constructors":[{"id":"new(io:IO::FileDescriptor)-class-method","html_id":"new(io:IO::FileDescriptor)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"}],"args_string":"(io : IO::FileDescriptor)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L153","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO::FileDescriptor"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"ehsize-instance-method","html_id":"ehsize-instance-method","name":"ehsize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"ehsize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ehsize.not_nil!"}},{"id":"ehsize=(ehsize:UInt16)-instance-method","html_id":"ehsize=(ehsize:UInt16)-instance-method","name":"ehsize=","doc":null,"summary":null,"abstract":false,"args":[{"name":"ehsize","doc":null,"default_value":"","external_name":"ehsize","restriction":"UInt16"}],"args_string":"(ehsize : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L140","def":{"name":"ehsize=","args":[{"name":"ehsize","doc":null,"default_value":"","external_name":"ehsize","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ehsize = ehsize"}},{"id":"ehsize?:UInt16?-instance-method","html_id":"ehsize?:UInt16?-instance-method","name":"ehsize?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"ehsize?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ehsize"}},{"id":"entry-instance-method","html_id":"entry-instance-method","name":"entry","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"entry","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entry.not_nil!"}},{"id":"entry=(entry:UInt32|UInt64)-instance-method","html_id":"entry=(entry:UInt32|UInt64)-instance-method","name":"entry=","doc":null,"summary":null,"abstract":false,"args":[{"name":"entry","doc":null,"default_value":"","external_name":"entry","restriction":"UInt32 | UInt64"}],"args_string":"(entry : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L136","def":{"name":"entry=","args":[{"name":"entry","doc":null,"default_value":"","external_name":"entry","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entry = entry"}},{"id":"entry?:UInt32|UInt64|Nil-instance-method","html_id":"entry?:UInt32|UInt64|Nil-instance-method","name":"entry?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"entry?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entry"}},{"id":"flags-instance-method","html_id":"flags-instance-method","name":"flags","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"flags","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags.not_nil!"}},{"id":"flags=(flags:UInt32)-instance-method","html_id":"flags=(flags:UInt32)-instance-method","name":"flags=","doc":null,"summary":null,"abstract":false,"args":[{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":"UInt32"}],"args_string":"(flags : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L139","def":{"name":"flags=","args":[{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags = flags"}},{"id":"flags?:UInt32?-instance-method","html_id":"flags?:UInt32?-instance-method","name":"flags?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"flags?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags"}},{"id":"ident-instance-method","html_id":"ident-instance-method","name":"ident","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L132","def":{"name":"ident","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ident.not_nil!"}},{"id":"ident?:Debug::ELF::Ident?-instance-method","html_id":"ident?:Debug::ELF::Ident?-instance-method","name":"ident?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Debug::ELF::Ident?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L132","def":{"name":"ident?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ident"}},{"id":"machine-instance-method","html_id":"machine-instance-method","name":"machine","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"machine","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@machine.not_nil!"}},{"id":"machine=(machine:Machine)-instance-method","html_id":"machine=(machine:Machine)-instance-method","name":"machine=","doc":null,"summary":null,"abstract":false,"args":[{"name":"machine","doc":null,"default_value":"","external_name":"machine","restriction":"Machine"}],"args_string":"(machine : Machine)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L134","def":{"name":"machine=","args":[{"name":"machine","doc":null,"default_value":"","external_name":"machine","restriction":"Machine"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@machine = machine"}},{"id":"machine?:Debug::ELF::Machine?-instance-method","html_id":"machine?:Debug::ELF::Machine?-instance-method","name":"machine?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Debug::ELF::Machine?","source_link":null,"source_link":null,"def":{"name":"machine?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@machine"}},{"id":"phentsize-instance-method","html_id":"phentsize-instance-method","name":"phentsize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"phentsize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phentsize.not_nil!"}},{"id":"phentsize=(phentsize:UInt16)-instance-method","html_id":"phentsize=(phentsize:UInt16)-instance-method","name":"phentsize=","doc":null,"summary":null,"abstract":false,"args":[{"name":"phentsize","doc":null,"default_value":"","external_name":"phentsize","restriction":"UInt16"}],"args_string":"(phentsize : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L141","def":{"name":"phentsize=","args":[{"name":"phentsize","doc":null,"default_value":"","external_name":"phentsize","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phentsize = phentsize"}},{"id":"phentsize?:UInt16?-instance-method","html_id":"phentsize?:UInt16?-instance-method","name":"phentsize?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"phentsize?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phentsize"}},{"id":"phnum-instance-method","html_id":"phnum-instance-method","name":"phnum","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"phnum","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phnum.not_nil!"}},{"id":"phnum=(phnum:UInt16)-instance-method","html_id":"phnum=(phnum:UInt16)-instance-method","name":"phnum=","doc":null,"summary":null,"abstract":false,"args":[{"name":"phnum","doc":null,"default_value":"","external_name":"phnum","restriction":"UInt16"}],"args_string":"(phnum : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L142","def":{"name":"phnum=","args":[{"name":"phnum","doc":null,"default_value":"","external_name":"phnum","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phnum = phnum"}},{"id":"phnum?:UInt16?-instance-method","html_id":"phnum?:UInt16?-instance-method","name":"phnum?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"phnum?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phnum"}},{"id":"phoff-instance-method","html_id":"phoff-instance-method","name":"phoff","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"phoff","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phoff.not_nil!"}},{"id":"phoff=(phoff:UInt32|UInt64)-instance-method","html_id":"phoff=(phoff:UInt32|UInt64)-instance-method","name":"phoff=","doc":null,"summary":null,"abstract":false,"args":[{"name":"phoff","doc":null,"default_value":"","external_name":"phoff","restriction":"UInt32 | UInt64"}],"args_string":"(phoff : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L137","def":{"name":"phoff=","args":[{"name":"phoff","doc":null,"default_value":"","external_name":"phoff","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phoff = phoff"}},{"id":"phoff?:UInt32|UInt64|Nil-instance-method","html_id":"phoff?:UInt32|UInt64|Nil-instance-method","name":"phoff?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"phoff?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@phoff"}},{"id":"read_section?(name:String,&block)-instance-method","html_id":"read_section?(name:String,&amp;block)-instance-method","name":"read_section?","doc":"Searches for a section then yield the `SectionHeader` and the IO object\nready for parsing if the section was found. Returns the valure returned by\nthe block or nil if the section wasn't found.","summary":"<p>Searches for a section then yield the <code><a href=\"../Debug/ELF/SectionHeader.html\">SectionHeader</a></code> and the IO object ready for parsing if the section was found.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L211","def":{"name":"read_section?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"if sh = section_headers.find do |sh|\n  (sh_name(sh.name)) == name\nend\n  @io.seek(sh.offset) do\n    yield sh, @io\n  end\nend"}},{"id":"section_headers-instance-method","html_id":"section_headers-instance-method","name":"section_headers","doc":"Parses and returns an Array of `SectionHeader`.","summary":"<p>Parses and returns an Array of <code><a href=\"../Debug/ELF/SectionHeader.html\">SectionHeader</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L181","def":{"name":"section_headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sections || (@sections = Array(SectionHeader).new(shnum.to_i) do |i|\n  @io.seek(shoff + (i * shentsize))\n  sh = SectionHeader.new\n  sh.name = read_word\n  sh.type = SectionHeader::Type.new(read_word)\n  sh.flags = SectionHeader::Flags.new(read_ulong.to_u64)\n  sh.addr = read_ulong\n  sh.offset = read_ulong\n  sh.size = read_ulong\n  sh.link = read_word\n  sh.info = read_word\n  sh.addralign = read_ulong\n  sh.entsize = read_ulong\n  sh\nend)"}},{"id":"sh_name(index)-instance-method","html_id":"sh_name(index)-instance-method","name":"sh_name","doc":"Returns the name of a section, using the `SectionHeader#name` index.","summary":"<p>Returns the name of a section, using the <code><a href=\"../Debug/ELF/SectionHeader.html#name-instance-method\">SectionHeader#name</a></code> index.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L201","def":{"name":"sh_name","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sh = section_headers[shstrndx]\n@io.seek(sh.offset + index) do\n  (@io.gets('\\u{0}')).to_s.chomp('\\u{0}')\nend\n"}},{"id":"shentsize-instance-method","html_id":"shentsize-instance-method","name":"shentsize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"shentsize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shentsize.not_nil!"}},{"id":"shentsize=(shentsize:UInt16)-instance-method","html_id":"shentsize=(shentsize:UInt16)-instance-method","name":"shentsize=","doc":null,"summary":null,"abstract":false,"args":[{"name":"shentsize","doc":null,"default_value":"","external_name":"shentsize","restriction":"UInt16"}],"args_string":"(shentsize : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L143","def":{"name":"shentsize=","args":[{"name":"shentsize","doc":null,"default_value":"","external_name":"shentsize","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shentsize = shentsize"}},{"id":"shentsize?:UInt16?-instance-method","html_id":"shentsize?:UInt16?-instance-method","name":"shentsize?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"shentsize?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shentsize"}},{"id":"shnum-instance-method","html_id":"shnum-instance-method","name":"shnum","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"shnum","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shnum.not_nil!"}},{"id":"shnum=(shnum:UInt16)-instance-method","html_id":"shnum=(shnum:UInt16)-instance-method","name":"shnum=","doc":null,"summary":null,"abstract":false,"args":[{"name":"shnum","doc":null,"default_value":"","external_name":"shnum","restriction":"UInt16"}],"args_string":"(shnum : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L144","def":{"name":"shnum=","args":[{"name":"shnum","doc":null,"default_value":"","external_name":"shnum","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shnum = shnum"}},{"id":"shnum?:UInt16?-instance-method","html_id":"shnum?:UInt16?-instance-method","name":"shnum?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"shnum?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shnum"}},{"id":"shoff-instance-method","html_id":"shoff-instance-method","name":"shoff","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"shoff","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shoff.not_nil!"}},{"id":"shoff=(shoff:UInt32|UInt64)-instance-method","html_id":"shoff=(shoff:UInt32|UInt64)-instance-method","name":"shoff=","doc":null,"summary":null,"abstract":false,"args":[{"name":"shoff","doc":null,"default_value":"","external_name":"shoff","restriction":"UInt32 | UInt64"}],"args_string":"(shoff : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L138","def":{"name":"shoff=","args":[{"name":"shoff","doc":null,"default_value":"","external_name":"shoff","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shoff = shoff"}},{"id":"shoff?:UInt32|UInt64|Nil-instance-method","html_id":"shoff?:UInt32|UInt64|Nil-instance-method","name":"shoff?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"shoff?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shoff"}},{"id":"shstrndx-instance-method","html_id":"shstrndx-instance-method","name":"shstrndx","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"shstrndx","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shstrndx.not_nil!"}},{"id":"shstrndx=(shstrndx:UInt16)-instance-method","html_id":"shstrndx=(shstrndx:UInt16)-instance-method","name":"shstrndx=","doc":null,"summary":null,"abstract":false,"args":[{"name":"shstrndx","doc":null,"default_value":"","external_name":"shstrndx","restriction":"UInt16"}],"args_string":"(shstrndx : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L145","def":{"name":"shstrndx=","args":[{"name":"shstrndx","doc":null,"default_value":"","external_name":"shstrndx","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shstrndx = shstrndx"}},{"id":"shstrndx?:UInt16?-instance-method","html_id":"shstrndx?:UInt16?-instance-method","name":"shstrndx?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16?","source_link":null,"source_link":null,"def":{"name":"shstrndx?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@shstrndx"}},{"id":"type-instance-method","html_id":"type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type.not_nil!"}},{"id":"type=(type:Type)-instance-method","html_id":"type=(type:Type)-instance-method","name":"type=","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L133","def":{"name":"type=","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type = type"}},{"id":"type?:Debug::ELF::Type?-instance-method","html_id":"type?:Debug::ELF::Type?-instance-method","name":"type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Debug::ELF::Type?","source_link":null,"source_link":null,"def":{"name":"type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type"}},{"id":"version-instance-method","html_id":"version-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version.not_nil!"}},{"id":"version=(version:UInt32)-instance-method","html_id":"version=(version:UInt32)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt32"}],"args_string":"(version : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L135","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}},{"id":"version?:UInt32?-instance-method","html_id":"version?:UInt32?-instance-method","name":"version?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"version?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Endianness","path":"Debug/ELF/Endianness.html","kind":"enum","full_name":"Debug::ELF::Endianness","name":"Endianness","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":52,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Little","name":"Little","value":"1","doc":null,"summary":null},{"id":"Big","name":"Big","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"big?-instance-method","html_id":"big?-instance-method","name":"big?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L54","def":{"name":"big?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Big"}},{"id":"little?-instance-method","html_id":"little?-instance-method","name":"little?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L53","def":{"name":"little?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Little"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Error","path":"Debug/ELF/Error.html","kind":"class","full_name":"Debug::ELF::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":129,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Ident","path":"Debug/ELF/Ident.html","kind":"struct","full_name":"Debug::ELF::Ident","name":"Ident","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":57,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(klass,data,version,osabi,abiversion)-class-method","html_id":"new(klass,data,version,osabi,abiversion)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":""},{"name":"osabi","doc":null,"default_value":"","external_name":"osabi","restriction":""},{"name":"abiversion","doc":null,"default_value":"","external_name":"abiversion","restriction":""}],"args_string":"(klass, data, version, osabi, abiversion)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L64","def":{"name":"new","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""},{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":""},{"name":"osabi","doc":null,"default_value":"","external_name":"osabi","restriction":""},{"name":"abiversion","doc":null,"default_value":"","external_name":"abiversion","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(klass, data, version, osabi, abiversion)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"abiversion:UInt8-instance-method","html_id":"abiversion:UInt8-instance-method","name":"abiversion","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L62","def":{"name":"abiversion","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@abiversion"}},{"id":"abiversion=(abiversion:UInt8)-instance-method","html_id":"abiversion=(abiversion:UInt8)-instance-method","name":"abiversion=","doc":null,"summary":null,"abstract":false,"args":[{"name":"abiversion","doc":null,"default_value":"","external_name":"abiversion","restriction":"UInt8"}],"args_string":"(abiversion : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L62","def":{"name":"abiversion=","args":[{"name":"abiversion","doc":null,"default_value":"","external_name":"abiversion","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@abiversion = abiversion"}},{"id":"data:Endianness-instance-method","html_id":"data:Endianness-instance-method","name":"data","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Endianness","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L59","def":{"name":"data","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Endianness","visibility":"Public","body":"@data"}},{"id":"data=(data:Endianness)-instance-method","html_id":"data=(data:Endianness)-instance-method","name":"data=","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Endianness"}],"args_string":"(data : Endianness)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L59","def":{"name":"data=","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Endianness"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@data = data"}},{"id":"klass:Klass-instance-method","html_id":"klass:Klass-instance-method","name":"klass","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Klass","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L58","def":{"name":"klass","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Klass","visibility":"Public","body":"@klass"}},{"id":"klass=(klass:Klass)-instance-method","html_id":"klass=(klass:Klass)-instance-method","name":"klass=","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Klass"}],"args_string":"(klass : Klass)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L58","def":{"name":"klass=","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Klass"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@klass = klass"}},{"id":"osabi:OSABI-instance-method","html_id":"osabi:OSABI-instance-method","name":"osabi","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : OSABI","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L61","def":{"name":"osabi","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"OSABI","visibility":"Public","body":"@osabi"}},{"id":"osabi=(osabi:OSABI)-instance-method","html_id":"osabi=(osabi:OSABI)-instance-method","name":"osabi=","doc":null,"summary":null,"abstract":false,"args":[{"name":"osabi","doc":null,"default_value":"","external_name":"osabi","restriction":"OSABI"}],"args_string":"(osabi : OSABI)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L61","def":{"name":"osabi=","args":[{"name":"osabi","doc":null,"default_value":"","external_name":"osabi","restriction":"OSABI"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@osabi = osabi"}},{"id":"version:UInt8-instance-method","html_id":"version:UInt8-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L60","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@version"}},{"id":"version=(version:UInt8)-instance-method","html_id":"version=(version:UInt8)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt8"}],"args_string":"(version : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L60","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Klass","path":"Debug/ELF/Klass.html","kind":"enum","full_name":"Debug::ELF::Klass","name":"Klass","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ELF32","name":"ELF32","value":"1_u8","doc":null,"summary":null},{"id":"ELF64","name":"ELF64","value":"2_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"elf32?-instance-method","html_id":"elf32?-instance-method","name":"elf32?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L10","def":{"name":"elf32?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ELF32"}},{"id":"elf64?-instance-method","html_id":"elf64?-instance-method","name":"elf64?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L11","def":{"name":"elf64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ELF64"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Machine","path":"Debug/ELF/Machine.html","kind":"enum","full_name":"Debug::ELF::Machine","name":"Machine","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":39,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"UNKNOWN","name":"UNKNOWN","value":"0_u16","doc":null,"summary":null},{"id":"SPARC","name":"SPARC","value":"2_u16","doc":null,"summary":null},{"id":"X86","name":"X86","value":"3_u16","doc":null,"summary":null},{"id":"MIPS","name":"MIPS","value":"8_u16","doc":null,"summary":null},{"id":"POWERPC","name":"POWERPC","value":"20_u16","doc":null,"summary":null},{"id":"ARM","name":"ARM","value":"40_u16","doc":null,"summary":null},{"id":"SUPERH","name":"SUPERH","value":"42_u16","doc":null,"summary":null},{"id":"IA_64","name":"IA_64","value":"50_u16","doc":null,"summary":null},{"id":"X86_64","name":"X86_64","value":"62_u16","doc":null,"summary":null},{"id":"AARCH64","name":"AARCH64","value":"183_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"aarch64?-instance-method","html_id":"aarch64?-instance-method","name":"aarch64?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L49","def":{"name":"aarch64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AARCH64"}},{"id":"arm?-instance-method","html_id":"arm?-instance-method","name":"arm?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L45","def":{"name":"arm?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ARM"}},{"id":"ia_64?-instance-method","html_id":"ia_64?-instance-method","name":"ia_64?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L47","def":{"name":"ia_64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IA_64"}},{"id":"mips?-instance-method","html_id":"mips?-instance-method","name":"mips?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L43","def":{"name":"mips?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MIPS"}},{"id":"powerpc?-instance-method","html_id":"powerpc?-instance-method","name":"powerpc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L44","def":{"name":"powerpc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == POWERPC"}},{"id":"sparc?-instance-method","html_id":"sparc?-instance-method","name":"sparc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L41","def":{"name":"sparc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SPARC"}},{"id":"superh?-instance-method","html_id":"superh?-instance-method","name":"superh?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L46","def":{"name":"superh?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SUPERH"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L40","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNKNOWN"}},{"id":"x86?-instance-method","html_id":"x86?-instance-method","name":"x86?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L42","def":{"name":"x86?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86"}},{"id":"x86_64?-instance-method","html_id":"x86_64?-instance-method","name":"x86_64?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L48","def":{"name":"x86_64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86_64"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/OSABI","path":"Debug/ELF/OSABI.html","kind":"enum","full_name":"Debug::ELF::OSABI","name":"OSABI","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"SYSTEM_V","name":"SYSTEM_V","value":"0_u8","doc":null,"summary":null},{"id":"HP_UX","name":"HP_UX","value":"1_u8","doc":null,"summary":null},{"id":"NETBSD","name":"NETBSD","value":"2_u8","doc":null,"summary":null},{"id":"LINUX","name":"LINUX","value":"3_u8","doc":null,"summary":null},{"id":"SOLARIS","name":"SOLARIS","value":"6_u8","doc":null,"summary":null},{"id":"AIX","name":"AIX","value":"7_u8","doc":null,"summary":null},{"id":"IRIX","name":"IRIX","value":"8_u8","doc":null,"summary":null},{"id":"FREEBSD","name":"FREEBSD","value":"9_u8","doc":null,"summary":null},{"id":"OPENBSD","name":"OPENBSD","value":"12_u8","doc":null,"summary":null},{"id":"OPENVMS","name":"OPENVMS","value":"13_u8","doc":null,"summary":null},{"id":"NSK_OS","name":"NSK_OS","value":"14_u8","doc":null,"summary":null},{"id":"AROS","name":"AROS","value":"15_u8","doc":null,"summary":null},{"id":"FENIS_OS","name":"FENIS_OS","value":"16_u8","doc":null,"summary":null},{"id":"CLOUDABI","name":"CLOUDABI","value":"17_u8","doc":null,"summary":null},{"id":"SORTIX","name":"SORTIX","value":"83_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"aix?-instance-method","html_id":"aix?-instance-method","name":"aix?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L20","def":{"name":"aix?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AIX"}},{"id":"aros?-instance-method","html_id":"aros?-instance-method","name":"aros?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L26","def":{"name":"aros?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AROS"}},{"id":"cloudabi?-instance-method","html_id":"cloudabi?-instance-method","name":"cloudabi?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L28","def":{"name":"cloudabi?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CLOUDABI"}},{"id":"fenis_os?-instance-method","html_id":"fenis_os?-instance-method","name":"fenis_os?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L27","def":{"name":"fenis_os?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FENIS_OS"}},{"id":"freebsd?-instance-method","html_id":"freebsd?-instance-method","name":"freebsd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L22","def":{"name":"freebsd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FREEBSD"}},{"id":"hp_ux?-instance-method","html_id":"hp_ux?-instance-method","name":"hp_ux?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L16","def":{"name":"hp_ux?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HP_UX"}},{"id":"irix?-instance-method","html_id":"irix?-instance-method","name":"irix?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L21","def":{"name":"irix?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IRIX"}},{"id":"linux?-instance-method","html_id":"linux?-instance-method","name":"linux?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L18","def":{"name":"linux?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LINUX"}},{"id":"netbsd?-instance-method","html_id":"netbsd?-instance-method","name":"netbsd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L17","def":{"name":"netbsd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NETBSD"}},{"id":"nsk_os?-instance-method","html_id":"nsk_os?-instance-method","name":"nsk_os?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L25","def":{"name":"nsk_os?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NSK_OS"}},{"id":"openbsd?-instance-method","html_id":"openbsd?-instance-method","name":"openbsd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L23","def":{"name":"openbsd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OPENBSD"}},{"id":"openvms?-instance-method","html_id":"openvms?-instance-method","name":"openvms?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L24","def":{"name":"openvms?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OPENVMS"}},{"id":"solaris?-instance-method","html_id":"solaris?-instance-method","name":"solaris?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L19","def":{"name":"solaris?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SOLARIS"}},{"id":"sortix?-instance-method","html_id":"sortix?-instance-method","name":"sortix?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L29","def":{"name":"sortix?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SORTIX"}},{"id":"system_v?-instance-method","html_id":"system_v?-instance-method","name":"system_v?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L15","def":{"name":"system_v?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SYSTEM_V"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader","path":"Debug/ELF/SectionHeader.html","kind":"struct","full_name":"Debug::ELF::SectionHeader","name":"SectionHeader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":68,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L68","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"id":"addr-instance-method","html_id":"addr-instance-method","name":"addr","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"addr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addr.not_nil!"}},{"id":"addr=(addr:UInt32|UInt64)-instance-method","html_id":"addr=(addr:UInt32|UInt64)-instance-method","name":"addr=","doc":null,"summary":null,"abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":"UInt32 | UInt64"}],"args_string":"(addr : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L120","def":{"name":"addr=","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addr = addr"}},{"id":"addr?:UInt32|UInt64|Nil-instance-method","html_id":"addr?:UInt32|UInt64|Nil-instance-method","name":"addr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"addr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addr"}},{"id":"addralign-instance-method","html_id":"addralign-instance-method","name":"addralign","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"addralign","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addralign.not_nil!"}},{"id":"addralign=(addralign:UInt32|UInt64)-instance-method","html_id":"addralign=(addralign:UInt32|UInt64)-instance-method","name":"addralign=","doc":null,"summary":null,"abstract":false,"args":[{"name":"addralign","doc":null,"default_value":"","external_name":"addralign","restriction":"UInt32 | UInt64"}],"args_string":"(addralign : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L125","def":{"name":"addralign=","args":[{"name":"addralign","doc":null,"default_value":"","external_name":"addralign","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addralign = addralign"}},{"id":"addralign?:UInt32|UInt64|Nil-instance-method","html_id":"addralign?:UInt32|UInt64|Nil-instance-method","name":"addralign?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"addralign?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@addralign"}},{"id":"entsize-instance-method","html_id":"entsize-instance-method","name":"entsize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"entsize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entsize.not_nil!"}},{"id":"entsize=(entsize:UInt32|UInt64)-instance-method","html_id":"entsize=(entsize:UInt32|UInt64)-instance-method","name":"entsize=","doc":null,"summary":null,"abstract":false,"args":[{"name":"entsize","doc":null,"default_value":"","external_name":"entsize","restriction":"UInt32 | UInt64"}],"args_string":"(entsize : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L126","def":{"name":"entsize=","args":[{"name":"entsize","doc":null,"default_value":"","external_name":"entsize","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entsize = entsize"}},{"id":"entsize?:UInt32|UInt64|Nil-instance-method","html_id":"entsize?:UInt32|UInt64|Nil-instance-method","name":"entsize?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"entsize?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@entsize"}},{"id":"flags-instance-method","html_id":"flags-instance-method","name":"flags","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"flags","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags.not_nil!"}},{"id":"flags=(flags:Flags)-instance-method","html_id":"flags=(flags:Flags)-instance-method","name":"flags=","doc":null,"summary":null,"abstract":false,"args":[{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":"Flags"}],"args_string":"(flags : Flags)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L119","def":{"name":"flags=","args":[{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":"Flags"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags = flags"}},{"id":"flags?:Debug::ELF::SectionHeader::Flags?-instance-method","html_id":"flags?:Debug::ELF::SectionHeader::Flags?-instance-method","name":"flags?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Debug::ELF::SectionHeader::Flags?","source_link":null,"source_link":null,"def":{"name":"flags?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags"}},{"id":"info-instance-method","html_id":"info-instance-method","name":"info","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"info","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@info.not_nil!"}},{"id":"info=(info:UInt32)-instance-method","html_id":"info=(info:UInt32)-instance-method","name":"info=","doc":null,"summary":null,"abstract":false,"args":[{"name":"info","doc":null,"default_value":"","external_name":"info","restriction":"UInt32"}],"args_string":"(info : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L124","def":{"name":"info=","args":[{"name":"info","doc":null,"default_value":"","external_name":"info","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@info = info"}},{"id":"info?:UInt32?-instance-method","html_id":"info?:UInt32?-instance-method","name":"info?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"info?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@info"}},{"id":"link-instance-method","html_id":"link-instance-method","name":"link","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"link","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@link.not_nil!"}},{"id":"link=(link:UInt32)-instance-method","html_id":"link=(link:UInt32)-instance-method","name":"link=","doc":null,"summary":null,"abstract":false,"args":[{"name":"link","doc":null,"default_value":"","external_name":"link","restriction":"UInt32"}],"args_string":"(link : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L123","def":{"name":"link=","args":[{"name":"link","doc":null,"default_value":"","external_name":"link","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@link = link"}},{"id":"link?:UInt32?-instance-method","html_id":"link?:UInt32?-instance-method","name":"link?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"link?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@link"}},{"id":"name-instance-method","html_id":"name-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name.not_nil!"}},{"id":"name=(name:UInt32)-instance-method","html_id":"name=(name:UInt32)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"UInt32"}],"args_string":"(name : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L117","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name = name"}},{"id":"name?:UInt32?-instance-method","html_id":"name?:UInt32?-instance-method","name":"name?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32?","source_link":null,"source_link":null,"def":{"name":"name?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name"}},{"id":"offset-instance-method","html_id":"offset-instance-method","name":"offset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset.not_nil!"}},{"id":"offset=(offset:UInt32|UInt64)-instance-method","html_id":"offset=(offset:UInt32|UInt64)-instance-method","name":"offset=","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"UInt32 | UInt64"}],"args_string":"(offset : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L121","def":{"name":"offset=","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset = offset"}},{"id":"offset?:UInt32|UInt64|Nil-instance-method","html_id":"offset?:UInt32|UInt64|Nil-instance-method","name":"offset?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"offset?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size.not_nil!"}},{"id":"size=(size:UInt32|UInt64)-instance-method","html_id":"size=(size:UInt32|UInt64)-instance-method","name":"size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt32 | UInt64"}],"args_string":"(size : UInt32 | UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L122","def":{"name":"size=","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt32 | UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size = size"}},{"id":"size?:UInt32|UInt64|Nil-instance-method","html_id":"size?:UInt32|UInt64|Nil-instance-method","name":"size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt32 | UInt64 | Nil","source_link":null,"source_link":null,"def":{"name":"size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size"}},{"id":"type-instance-method","html_id":"type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type.not_nil!"}},{"id":"type=(type:Type)-instance-method","html_id":"type=(type:Type)-instance-method","name":"type=","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L118","def":{"name":"type=","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type = type"}},{"id":"type?:Debug::ELF::SectionHeader::Type?-instance-method","html_id":"type?:Debug::ELF::SectionHeader::Type?-instance-method","name":"type?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Debug::ELF::SectionHeader::Type?","source_link":null,"source_link":null,"def":{"name":"type?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader/Flags","path":"Debug/ELF/SectionHeader/Flags.html","kind":"enum","full_name":"Debug::ELF::SectionHeader::Flags","name":"Flags","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":90,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"WRITE","name":"WRITE","value":"1_u64","doc":null,"summary":null},{"id":"ALLOC","name":"ALLOC","value":"2_u64","doc":null,"summary":null},{"id":"EXECINSTR","name":"EXECINSTR","value":"4_u64","doc":null,"summary":null},{"id":"MERGE","name":"MERGE","value":"16_u64","doc":null,"summary":null},{"id":"STRINGS","name":"STRINGS","value":"32_u64","doc":null,"summary":null},{"id":"INFO_LINK","name":"INFO_LINK","value":"64_u64","doc":null,"summary":null},{"id":"LINK_ORDER","name":"LINK_ORDER","value":"128_u64","doc":null,"summary":null},{"id":"OS_NONCONFORMING","name":"OS_NONCONFORMING","value":"256_u64","doc":null,"summary":null},{"id":"GROUP","name":"GROUP","value":"512_u64","doc":null,"summary":null},{"id":"TLS","name":"TLS","value":"1024_u64","doc":null,"summary":null},{"id":"COMPRESSED","name":"COMPRESSED","value":"2048_u64","doc":null,"summary":null},{"id":"MASKOS","name":"MASKOS","value":"267386880_u64","doc":null,"summary":null},{"id":"MASKPROC","name":"MASKPROC","value":"4026531840_u64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader","kind":"struct","full_name":"Debug::ELF::SectionHeader","name":"SectionHeader"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"alloc?-instance-method","html_id":"alloc?-instance-method","name":"alloc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L92","def":{"name":"alloc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ALLOC)"}},{"id":"compressed?-instance-method","html_id":"compressed?-instance-method","name":"compressed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L101","def":{"name":"compressed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(COMPRESSED)"}},{"id":"execinstr?-instance-method","html_id":"execinstr?-instance-method","name":"execinstr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L93","def":{"name":"execinstr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(EXECINSTR)"}},{"id":"group?-instance-method","html_id":"group?-instance-method","name":"group?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L99","def":{"name":"group?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(GROUP)"}},{"id":"info_link?-instance-method","html_id":"info_link?-instance-method","name":"info_link?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L96","def":{"name":"info_link?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(INFO_LINK)"}},{"id":"link_order?-instance-method","html_id":"link_order?-instance-method","name":"link_order?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L97","def":{"name":"link_order?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(LINK_ORDER)"}},{"id":"maskos?-instance-method","html_id":"maskos?-instance-method","name":"maskos?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L102","def":{"name":"maskos?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(MASKOS)"}},{"id":"maskproc?-instance-method","html_id":"maskproc?-instance-method","name":"maskproc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L103","def":{"name":"maskproc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(MASKPROC)"}},{"id":"merge?-instance-method","html_id":"merge?-instance-method","name":"merge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L94","def":{"name":"merge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(MERGE)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L90","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"os_nonconforming?-instance-method","html_id":"os_nonconforming?-instance-method","name":"os_nonconforming?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L98","def":{"name":"os_nonconforming?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OS_NONCONFORMING)"}},{"id":"short-instance-method","html_id":"short-instance-method","name":"short","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L105","def":{"name":"short","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  if write?\n    str << 'W'\n  end\n  if alloc?\n    str << 'A'\n  end\n  if execinstr?\n    str << 'X'\n  end\n  if merge?\n    str << 'M'\n  end\n  if strings?\n    str << 'S'\n  end\n  if tls?\n    str << 'T'\n  end\nend"}},{"id":"strings?-instance-method","html_id":"strings?-instance-method","name":"strings?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L95","def":{"name":"strings?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(STRINGS)"}},{"id":"tls?-instance-method","html_id":"tls?-instance-method","name":"tls?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L100","def":{"name":"tls?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TLS)"}},{"id":"write?-instance-method","html_id":"write?-instance-method","name":"write?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L91","def":{"name":"write?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(WRITE)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader/Type","path":"Debug/ELF/SectionHeader/Type.html","kind":"enum","full_name":"Debug::ELF::SectionHeader::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":69,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"NULL","name":"NULL","value":"0_u32","doc":null,"summary":null},{"id":"PROGBITS","name":"PROGBITS","value":"1_u32","doc":null,"summary":null},{"id":"SYMTAB","name":"SYMTAB","value":"2_u32","doc":null,"summary":null},{"id":"STRTAB","name":"STRTAB","value":"3_u32","doc":null,"summary":null},{"id":"RELA","name":"RELA","value":"4_u32","doc":null,"summary":null},{"id":"HASH","name":"HASH","value":"5_u32","doc":null,"summary":null},{"id":"DYNAMIC","name":"DYNAMIC","value":"6_u32","doc":null,"summary":null},{"id":"NOTE","name":"NOTE","value":"7_u32","doc":null,"summary":null},{"id":"NOBITS","name":"NOBITS","value":"8_u32","doc":null,"summary":null},{"id":"REL","name":"REL","value":"9_u32","doc":null,"summary":null},{"id":"SHLIB","name":"SHLIB","value":"10_u32","doc":null,"summary":null},{"id":"DYNSYM","name":"DYNSYM","value":"11_u32","doc":null,"summary":null},{"id":"INIT_ARRAY","name":"INIT_ARRAY","value":"14_u32","doc":null,"summary":null},{"id":"FINI_ARRAY","name":"FINI_ARRAY","value":"15_u32","doc":null,"summary":null},{"id":"PREINIT_ARRAY","name":"PREINIT_ARRAY","value":"16_u32","doc":null,"summary":null},{"id":"GROUP","name":"GROUP","value":"17_u32","doc":null,"summary":null},{"id":"SYMTAB_SHNDX","name":"SYMTAB_SHNDX","value":"18_u32","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader","kind":"struct","full_name":"Debug::ELF::SectionHeader","name":"SectionHeader"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"dynamic?-instance-method","html_id":"dynamic?-instance-method","name":"dynamic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L76","def":{"name":"dynamic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DYNAMIC"}},{"id":"dynsym?-instance-method","html_id":"dynsym?-instance-method","name":"dynsym?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L81","def":{"name":"dynsym?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DYNSYM"}},{"id":"fini_array?-instance-method","html_id":"fini_array?-instance-method","name":"fini_array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L83","def":{"name":"fini_array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FINI_ARRAY"}},{"id":"group?-instance-method","html_id":"group?-instance-method","name":"group?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L85","def":{"name":"group?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == GROUP"}},{"id":"hash?-instance-method","html_id":"hash?-instance-method","name":"hash?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L75","def":{"name":"hash?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HASH"}},{"id":"init_array?-instance-method","html_id":"init_array?-instance-method","name":"init_array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L82","def":{"name":"init_array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == INIT_ARRAY"}},{"id":"nobits?-instance-method","html_id":"nobits?-instance-method","name":"nobits?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L78","def":{"name":"nobits?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NOBITS"}},{"id":"note?-instance-method","html_id":"note?-instance-method","name":"note?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L77","def":{"name":"note?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NOTE"}},{"id":"null?-instance-method","html_id":"null?-instance-method","name":"null?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L70","def":{"name":"null?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NULL"}},{"id":"preinit_array?-instance-method","html_id":"preinit_array?-instance-method","name":"preinit_array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L84","def":{"name":"preinit_array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PREINIT_ARRAY"}},{"id":"progbits?-instance-method","html_id":"progbits?-instance-method","name":"progbits?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L71","def":{"name":"progbits?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PROGBITS"}},{"id":"rel?-instance-method","html_id":"rel?-instance-method","name":"rel?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L79","def":{"name":"rel?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == REL"}},{"id":"rela?-instance-method","html_id":"rela?-instance-method","name":"rela?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L74","def":{"name":"rela?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RELA"}},{"id":"shlib?-instance-method","html_id":"shlib?-instance-method","name":"shlib?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L80","def":{"name":"shlib?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SHLIB"}},{"id":"strtab?-instance-method","html_id":"strtab?-instance-method","name":"strtab?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L73","def":{"name":"strtab?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STRTAB"}},{"id":"symtab?-instance-method","html_id":"symtab?-instance-method","name":"symtab?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L72","def":{"name":"symtab?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SYMTAB"}},{"id":"symtab_shndx?-instance-method","html_id":"symtab_shndx?-instance-method","name":"symtab_shndx?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L86","def":{"name":"symtab_shndx?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SYMTAB_SHNDX"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Type","path":"Debug/ELF/Type.html","kind":"enum","full_name":"Debug::ELF::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"debug/elf.cr","line_number":32,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"REL","name":"REL","value":"1_u16","doc":null,"summary":null},{"id":"EXEC","name":"EXEC","value":"2_u16","doc":null,"summary":null},{"id":"DYN","name":"DYN","value":"3_u16","doc":null,"summary":null},{"id":"CORE","name":"CORE","value":"4_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"core?-instance-method","html_id":"core?-instance-method","name":"core?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L36","def":{"name":"core?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CORE"}},{"id":"dyn?-instance-method","html_id":"dyn?-instance-method","name":"dyn?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L35","def":{"name":"dyn?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DYN"}},{"id":"exec?-instance-method","html_id":"exec?-instance-method","name":"exec?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L34","def":{"name":"exec?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == EXEC"}},{"id":"rel?-instance-method","html_id":"rel?-instance-method","name":"rel?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/debug/elf.cr#L33","def":{"name":"rel?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == REL"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/Deque","path":"Deque.html","kind":"class","full_name":"Deque(T)","name":"Deque","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"deque.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A Deque (\"[double-ended queue](https://en.wikipedia.org/wiki/Double-ended_queue)\") is a collection of objects of type\nT that behaves much like an Array.\n\nDeque has a subset of Array's API. It performs better than an `Array` when there are frequent insertions or deletions\nof items near the beginning or the end.\n\nThe most typical use case of a Deque is a queue: use `push` to add items to the end of the queue and `shift` to get\nand remove the item at the beginning of the queue.\n\nThis Deque is implemented with a [dynamic array](http://en.wikipedia.org/wiki/Dynamic_array) used as a\n[circular buffer](https://en.wikipedia.org/wiki/Circular_buffer).","summary":"<p>A Deque (\"<a href=\"https://en.wikipedia.org/wiki/Double-ended_queue\" target=\"_blank\">double-ended queue</a>\") is a collection of objects of type T that behaves much like an Array.</p>","class_methods":[],"constructors":[{"id":"new(size:Int,value:T)-class-method","html_id":"new(size:Int,value:T)-class-method","name":"new","doc":"Creates a new `Deque` of the given size filled with the same value in each position.\n\n```\nDeque.new(3, 'a') # => Deque{'a', 'a', 'a'}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> of the given size filled with the same value in each position.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L61","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize(size, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(initial_capacity:Int)-class-method","html_id":"new(initial_capacity:Int)-class-method","name":"new","doc":"Creates a new empty `Deque` backed by a buffer that is initially `initial_capacity` big.\n\nThe `initial_capacity` is useful to avoid unnecessary reallocations of the internal buffer in case of growth. If you\nhave an estimate of the maximum number of elements a deque will hold, you should initialize it with that capacity\nfor improved execution performance.\n\n```\ndeq = Deque(Int32).new(5)\ndeq.size # => 0\n```","summary":"<p>Creates a new empty <code><a href=\"Deque.html\">Deque</a></code> backed by a buffer that is initially <code>initial_capacity</code> big.</p>","abstract":false,"args":[{"name":"initial_capacity","doc":null,"default_value":"","external_name":"initial_capacity","restriction":"Int"}],"args_string":"(initial_capacity : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L42","def":{"name":"new","args":[{"name":"initial_capacity","doc":null,"default_value":"","external_name":"initial_capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(array:Array(T))-class-method","html_id":"new(array:Array(T))-class-method","name":"new","doc":"Creates a new `Deque` that copies its items from an Array.\n\n```\nDeque.new([1, 2, 3]) # => Deque{1, 2, 3}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> that copies its items from an Array.</p>","abstract":false,"args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array(T)"}],"args_string":"(array : Array(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L99","def":{"name":"new","args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Deque(T).new(array.size) do |i|\n  array[i]\nend"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a new empty Deque","summary":"<p>Creates a new empty Deque</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L26","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(size:Int,&block:Int32->T)-class-method","html_id":"new(size:Int,&amp;block:Int32-&gt;T)-class-method","name":"new","doc":"Creates a new `Deque` of the given size and invokes the block once for\neach index of the deque, assigning the block's value in that index.\n\n```\nDeque.new(3) { |i| (i + 1) ** 2 } # => Deque{1, 4, 9}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> of the given size and invokes the block once for each index of the deque, assigning the block's value in that index.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, &block : Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L81","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Int32 -> T)"},"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative deque size: #{size}\"))\nend\ndeque = Deque(T).new(size)\ndeque.size = size\nsize.to_i.times do |i|\n  deque.buffer[i] = yield i\nend\ndeque\n"}}],"instance_methods":[{"id":"+(other:Deque(U))forallU-instance-method","html_id":"+(other:Deque(U))forallU-instance-method","name":"+","doc":"Concatenation. Returns a new `Deque` built by concatenating\ntwo deques together to create a third. The type of the new deque\nis the union of the types of both the other deques.","summary":"<p>Concatenation.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Deque(U)"}],"args_string":"(other : Deque(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L124","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Deque(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Deque(T | U).new.concat(self)).concat(other)"}},{"id":"<<(value:T)-instance-method","html_id":"&lt;&lt;(value:T)-instance-method","name":"<<","doc":"Alias for `push`.","summary":"<p>Alias for <code><a href=\"Deque.html#push%28value%3AT%29-instance-method\">#push</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L134","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"push(value)"}},{"id":"==(other:Deque)-instance-method","html_id":"==(other:Deque)-instance-method","name":"==","doc":"Returns `true` if it is passed a `Deque` and `equals?` returns `true`\nfor both deques, the caller and the argument.\n\n```\ndeq = Deque{2, 3}\ndeq.unshift 1\ndeq == Deque{1, 2, 3} # => true\ndeq == Deque{2, 3}    # => false\n```","summary":"<p>Returns <code>true</code> if it is passed a <code><a href=\"Deque.html\">Deque</a></code> and <code>equals?</code> returns <code>true</code> for both deques, the caller and the argument.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Deque"}],"args_string":"(other : Deque)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L112","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Deque"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"equals?(other) do |x, y|\n  x == y\nend"}},{"id":"[]=(index:Int,value:T)-instance-method","html_id":"[]=(index:Int,value:T)-instance-method","name":"[]=","doc":"Sets the given value at the given *index*.\n\nRaises `IndexError` if the deque had no previous value at the given *index*.","summary":"<p>Sets the given value at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L141","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + @size\nend\nif 0 <= index && index < @size\nelse\n  raise(IndexError.new)\nend\nindex = index + @start\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index] = value\n"}},{"id":"clear-instance-method","html_id":"clear-instance-method","name":"clear","doc":"Removes all elements from `self`.","summary":"<p>Removes all elements from <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L158","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"halfs do |r|\n  (@buffer + r.begin).clear(r.end - r.begin)\nend\n@size = 0\n@start = 0\nself\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Deque` that has this deque's elements cloned.\nThat is, it returns a deep copy of this deque.\n\nUse `#dup` if you want a shallow copy.","summary":"<p>Returns a new <code><a href=\"Deque.html\">Deque</a></code> that has this deque's elements cloned.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L171","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Deque(T).new(size) do |i|\n  self[i].clone.as(T)\nend"}},{"id":"concat(other:Enumerable(T))-instance-method","html_id":"concat(other:Enumerable(T))-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable(T)"}],"args_string":"(other : Enumerable(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L176","def":{"name":"concat","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.each do |x|\n  push(x)\nend\nself\n"}},{"id":"delete(obj)-instance-method","html_id":"delete(obj)-instance-method","name":"delete","doc":"Removes all items from `self` that are equal to *obj*.\n\n```\na = Deque{\"a\", \"b\", \"b\", \"b\", \"c\"}\na.delete(\"b\") # => true\na             # => Deque{\"a\", \"c\"}\n```","summary":"<p>Removes all items from <code>self</code> that are equal to <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L190","def":{"name":"delete","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"found = false\ni = 0\nwhile i < @size\n  if self[i] == obj\n    delete_at(i)\n    found = true\n  else\n    i = i + 1\n  end\nend\nfound\n"}},{"id":"delete_at(index:Int)-instance-method","html_id":"delete_at(index:Int)-instance-method","name":"delete_at","doc":"Delete the item that is present at the *index*. Items to the right\nof this one will have their indices decremented.\nRaises `IndexError` if trying to delete an element outside the deque's range.\n\n```\na = Deque{1, 2, 3}\na.delete_at(1) # => 2\na              # => Deque{1, 3}\n```","summary":"<p>Delete the item that is present at the <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L213","def":{"name":"delete_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + @size\nend\nif 0 <= index && index < @size\nelse\n  raise(IndexError.new)\nend\nif index == 0\n  return shift\nend\nif index == (@size - 1)\n  return pop\nend\nrindex = @start + index\nif rindex >= @capacity\n  rindex = rindex - @capacity\nend\nvalue = @buffer[rindex]\nif index > (@size / 2)\n  dst = rindex\n  finish = ((@start + @size) - 1) % @capacity\n  loop do\n    src = dst + 1\n    if src >= @capacity\n      src = src - @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == finish\n      break\n    end\n    dst = src\n  end\n  (@buffer + finish).clear\nelse\n  dst = rindex\n  finish = @start\n  @start = @start + 1\n  if @start >= @capacity\n    @start = @start - @capacity\n  end\n  loop do\n    src = dst - 1\n    if src < 0\n      src = src + @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == finish\n      break\n    end\n    dst = src\n  end\n  (@buffer + finish).clear\nend\n@size = @size - 1\nvalue\n"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Deque` that has exactly this deque's elements.\nThat is, it returns a shallow copy of this deque.","summary":"<p>Returns a new <code><a href=\"Deque.html\">Deque</a></code> that has exactly this deque's elements.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L263","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Deque(T).new(size) do |i|\n  self[i].as(T)\nend"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Yields each item in this deque, from first to last.\n\nDo not modify the deque while using this variant of `each`!","summary":"<p>Yields each item in this deque, from first to last.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L270","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"halfs do |r|\n  r.each do |i|\n    yield @buffer[i]\n  end\nend"}},{"id":"insert(index:Int,value:T)-instance-method","html_id":"insert(index:Int,value:T)-instance-method","name":"insert","doc":"Insert a new item before the item at *index*. Items to the right\nof this one will have their indices incremented.\n\n```\na = Deque{0, 1, 2}\na.insert(1, 7) # => Deque{0, 7, 1, 2}\n```","summary":"<p>Insert a new item before the item at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L285","def":{"name":"insert","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + (@size + 1)\nend\nif 0 <= index && index <= @size\nelse\n  raise(IndexError.new)\nend\nif index == 0\n  return unshift(value)\nend\nif index == @size\n  return push(value)\nend\nif @size >= @capacity\n  increase_capacity\nend\nrindex = @start + index\nif rindex >= @capacity\n  rindex = rindex - @capacity\nend\nif index > (@size / 2)\n  dst = @start + @size\n  if dst >= @capacity\n    dst = dst - @capacity\n  end\n  loop do\n    src = dst - 1\n    if src < 0\n      src = src + @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == rindex\n      break\n    end\n    dst = src\n  end\nelse\n  @start = @start - 1\n  if @start < 0\n    @start = @start + @capacity\n  end\n  rindex = rindex - 1\n  if rindex < 0\n    rindex = rindex + @capacity\n  end\n  dst = @start\n  loop do\n    src = dst + 1\n    if src >= @capacity\n      src = src - @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == rindex\n      break\n    end\n    dst = src\n  end\nend\n@size = @size + 1\n@buffer[rindex] = value\nself\n"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L333","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L333","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"executed = exec_recursive(:inspect) do\n  io << \"Deque{\"\n  join(\", \", io, &.inspect(io))\n  io << '}'\nend\nif executed\nelse\n  io << \"Deque{...}\"\nend\n"}},{"id":"pop(&block)-instance-method","html_id":"pop(&amp;block)-instance-method","name":"pop","doc":"Removes and returns the last item, if not empty, otherwise executes\nthe given block and returns its value.","summary":"<p>Removes and returns the last item, if not empty, otherwise executes the given block and returns its value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L371","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L371","def":{"name":"pop","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size == 0\n  yield\nelse\n  @size = @size - 1\n  index = @start + @size\n  if index >= @capacity\n    index = index - @capacity\n  end\n  value = @buffer[index]\n  (@buffer + index).clear\n  value\nend"}},{"id":"pop-instance-method","html_id":"pop-instance-method","name":"pop","doc":"Removes and returns the last item. Raises `IndexError` if empty.\n\n```\na = Deque{1, 2, 3}\na.pop # => 3\na     # => Deque{1, 2}\n```","summary":"<p>Removes and returns the last item.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L365","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L365","def":{"name":"pop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pop do\n  raise(IndexError.new)\nend"}},{"id":"pop(n:Int)-instance-method","html_id":"pop(n:Int)-instance-method","name":"pop","doc":"Removes the last *n* (at most) items in the deque.","summary":"<p>Removes the last <em>n</em> (at most) items in the deque.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L390","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L390","def":{"name":"pop","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't pop negative count\"))\nend\nn = Math.min(n, @size)\nn.times do\n  pop\nend\nnil\n"}},{"id":"pop?-instance-method","html_id":"pop?-instance-method","name":"pop?","doc":"Removes and returns the last item, if not empty, otherwise `nil`.","summary":"<p>Removes and returns the last item, if not empty, otherwise <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L385","def":{"name":"pop?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pop do\n  nil\nend"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L342","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"executed = exec_recursive(:inspect) do\n  pp.list(\"Deque{\", self, \"}\")\nend\nif executed\nelse\n  pp.text(\"Deque{...}\")\nend\n"}},{"id":"push(value:T)-instance-method","html_id":"push(value:T)-instance-method","name":"push","doc":"Adds an item to the end of the deque.\n\n```\na = Deque{1, 2}\na.push 3 # => Deque{1, 2, 3}\n```","summary":"<p>Adds an item to the end of the deque.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L405","def":{"name":"push","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size >= @capacity\n  increase_capacity\nend\nindex = @start + @size\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index] = value\n@size = @size + 1\nself\n"}},{"id":"rotate!(n:Int=1)-instance-method","html_id":"rotate!(n:Int=1)-instance-method","name":"rotate!","doc":"Rotates this deque in place so that the element at *n* becomes first.\n\n* For positive *n*, equivalent to `n.times { push(shift) }`.\n* For negative *n*, equivalent to `(-n).times { unshift(pop) }`.","summary":"<p>Rotates this deque in place so that the element at <em>n</em> becomes first.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L418","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L418","def":{"name":"rotate!","args":[{"name":"n","doc":null,"default_value":"1","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size <= 1\n  return\nend\nif @size == @capacity\n  @start = (@start + n) % @capacity\nelse\n  half = @size / 2\n  if n.abs >= half\n    n = ((n + half) % @size) - half\n  end\n  while n > 0\n    push(shift)\n    n = n - 1\n  end\n  while n < 0\n    n = n + 1\n    unshift(pop)\n  end\nend\n"}},{"id":"shift(n:Int)-instance-method","html_id":"shift(n:Int)-instance-method","name":"shift","doc":"Removes the first *n* (at most) items in the deque.","summary":"<p>Removes the first <em>n</em> (at most) items in the deque.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L471","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L471","def":{"name":"shift","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't shift negative count\"))\nend\nn = Math.min(n, @size)\nn.times do\n  shift\nend\nnil\n"}},{"id":"shift-instance-method","html_id":"shift-instance-method","name":"shift","doc":"Removes and returns the first item. Raises `IndexError` if empty.\n\n```\na = Deque{1, 2, 3}\na.shift # => 1\na       # => Deque{2, 3}\n```","summary":"<p>Removes and returns the first item.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L446","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L446","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"id":"shift(&block)-instance-method","html_id":"shift(&amp;block)-instance-method","name":"shift","doc":"Removes and returns the first item, if not empty, otherwise executes\nthe given block and returns its value.","summary":"<p>Removes and returns the first item, if not empty, otherwise executes the given block and returns its value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L452","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L452","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size == 0\n  yield\nelse\n  value = @buffer[@start]\n  (@buffer + @start).clear\n  @size = @size - 1\n  @start = @start + 1\n  if @start >= @capacity\n    @start = @start - @capacity\n  end\n  value\nend"}},{"id":"shift?-instance-method","html_id":"shift?-instance-method","name":"shift?","doc":"Removes and returns the first item, if not empty, otherwise `nil`.","summary":"<p>Removes and returns the first item, if not empty, otherwise <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L466","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L466","def":{"name":"shift?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  nil\nend"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in the deque.\n\n```\nDeque{:foo, :bar}.size # => 2\n```","summary":"<p>Returns the number of elements in the deque.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L354","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L354","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size"}},{"id":"swap(i,j)-instance-method","html_id":"swap(i,j)-instance-method","name":"swap","doc":"Swaps the items at the indices *i* and *j*.","summary":"<p>Swaps the items at the indices <em>i</em> and <em>j</em>.</p>","abstract":false,"args":[{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"j","doc":null,"default_value":"","external_name":"j","restriction":""}],"args_string":"(i, j)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L481","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L481","def":{"name":"swap","args":[{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"j","doc":null,"default_value":"","external_name":"j","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[i], self[j] = self[j], self[i]\nself\n"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L486","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L486","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"inspect(io)"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L151","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = index + @start\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index]\n"}},{"id":"unshift(value:T)-instance-method","html_id":"unshift(value:T)-instance-method","name":"unshift","doc":"Adds an item to the beginning of the deque.\n\n```\na = Deque{1, 2}\na.unshift 0 # => Deque{0, 1, 2}\n```","summary":"<p>Adds an item to the beginning of the deque.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L496","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/deque.cr#L496","def":{"name":"unshift","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size >= @capacity\n  increase_capacity\nend\n@start = @start - 1\nif @start < 0\n  @start = @start + @capacity\nend\n@buffer[@start] = value\n@size = @size + 1\nself\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Digest","path":"Digest.html","kind":"module","full_name":"Digest","name":"Digest","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"digest/base.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Digest/Base","path":"Digest/Base.html","kind":"class","full_name":"Digest::Base","name":"Base","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"digest/base.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Digest/MD5","kind":"class","full_name":"Digest::MD5","name":"MD5"},{"html_id":"github.com/crystal-lang/crystal/Digest/SHA1","kind":"class","full_name":"Digest::SHA1","name":"SHA1"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Digest","kind":"module","full_name":"Digest","name":"Digest"},"doc":null,"summary":null,"class_methods":[{"id":"base64digest(data):String-class-method","html_id":"base64digest(data):String-class-method","name":"base64digest","doc":"Returns the base64-encoded hash of *data*.\n\n```\nDigest::SHA1.base64digest(\"foo\") # => \"C+7Hteo/D9vJXQ3UfzxbwnXaijM=\"\n```","summary":"<p>Returns the base64-encoded hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L61","def":{"name":"base64digest","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"base64digest(&.update(data))"}},{"id":"base64digest(&block):String-class-method","html_id":"base64digest(&amp;block):String-class-method","name":"base64digest","doc":"Returns the base64-encoded hash of *data*.\n\n```\nDigest::SHA1.base64digest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\n# => \"C+7Hteo/D9vJXQ3UfzxbwnXaijM=\"\n```","summary":"<p>Returns the base64-encoded hash of <em>data</em>.</p>","abstract":false,"args":[],"args_string":"(&block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L74","def":{"name":"base64digest","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"hashsum = digest do |ctx|\n  yield ctx\nend\nBase64.strict_encode(hashsum)\n"}},{"id":"digest(data)-class-method","html_id":"digest(data)-class-method","name":"digest","doc":"Returns the hash of *data*. *data* must respond to `#to_slice`.","summary":"<p>Returns the hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L5","def":{"name":"digest","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"digest do |ctx|\n  ctx.update(data.to_slice)\nend"}},{"id":"digest(&block)-class-method","html_id":"digest(&amp;block)-class-method","name":"digest","doc":"Yields a context object with an `#update(data : String | Bytes)`\nmethod available. Returns the resulting digest afterwards.\n\n```\ndigest = Digest::MD5.digest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\ndigest.to_slice.hexstring # => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Yields a context object with an <code>#update(data : String | Bytes)</code> method available.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L21","def":{"name":"digest","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"context = new\nyield context\ncontext.final\ncontext.result\n"}},{"id":"hexdigest(data):String-class-method","html_id":"hexdigest(data):String-class-method","name":"hexdigest","doc":"Returns the hexadecimal representation of the hash of *data*.\n\n```\nDigest::MD5.hexdigest(\"foo\") # => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Returns the hexadecimal representation of the hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L33","def":{"name":"hexdigest","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"hexdigest(&.update(data))"}},{"id":"hexdigest(&block):String-class-method","html_id":"hexdigest(&amp;block):String-class-method","name":"hexdigest","doc":"Yields a context object with an `#update(data : String | Bytes)`\nmethod available. Returns the resulting digest in hexadecimal representation\nafterwards.\n\n```\nDigest::MD5.hexdigest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\n# => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Yields a context object with an <code>#update(data : String | Bytes)</code> method available.</p>","abstract":false,"args":[],"args_string":"(&block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/base.cr#L48","def":{"name":"hexdigest","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"hashsum = digest do |ctx|\n  yield ctx\nend\nhashsum.to_slice.hexstring\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Digest/MD5","path":"Digest/MD5.html","kind":"class","full_name":"Digest::MD5","name":"MD5","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Digest/Base","kind":"class","full_name":"Digest::Base","name":"Base"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Digest/Base","kind":"class","full_name":"Digest::Base","name":"Base"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"digest/md5.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"PADDING","name":"PADDING","value":"begin\n  padding = StaticArray(UInt8, 64).new(0_u8)\n  padding[0] = 128_u8\n  padding\nend","doc":null,"summary":null},{"id":"S11","name":"S11","value":"7","doc":null,"summary":null},{"id":"S12","name":"S12","value":"12","doc":null,"summary":null},{"id":"S13","name":"S13","value":"17","doc":null,"summary":null},{"id":"S14","name":"S14","value":"22","doc":null,"summary":null},{"id":"S21","name":"S21","value":"5","doc":null,"summary":null},{"id":"S22","name":"S22","value":"9","doc":null,"summary":null},{"id":"S23","name":"S23","value":"14","doc":null,"summary":null},{"id":"S24","name":"S24","value":"20","doc":null,"summary":null},{"id":"S31","name":"S31","value":"4","doc":null,"summary":null},{"id":"S32","name":"S32","value":"11","doc":null,"summary":null},{"id":"S33","name":"S33","value":"16","doc":null,"summary":null},{"id":"S34","name":"S34","value":"23","doc":null,"summary":null},{"id":"S41","name":"S41","value":"6","doc":null,"summary":null},{"id":"S42","name":"S42","value":"10","doc":null,"summary":null},{"id":"S43","name":"S43","value":"15","doc":null,"summary":null},{"id":"S44","name":"S44","value":"21","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Digest","kind":"module","full_name":"Digest","name":"Digest"},"doc":"Implements the MD5 digest algorithm.\n\nWarning: MD5 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Implements the MD5 digest algorithm.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L10","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"f(x,y,z)-instance-method","html_id":"f(x,y,z)-instance-method","name":"f","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"args_string":"(x, y, z)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L85","def":{"name":"f","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(x & y) | ((~x) & z)"}},{"id":"ff(a,b,c,d,x,s,ac)-instance-method","html_id":"ff(a,b,c,d,x,s,ac)-instance-method","name":"ff","doc":null,"summary":null,"abstract":false,"args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"args_string":"(a, b, c, d, x, s, ac)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L105","def":{"name":"ff","args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a = a + (((f(b, c, d)) + x) + ac.to_u32)\na = rotate_left(a, s)\na = a + b\n"}},{"id":"final-instance-method","html_id":"final-instance-method","name":"final","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L210","def":{"name":"final","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"in = uninitialized ::StaticArray(UInt32, 16)\nin[14] = @i[0]\nin[15] = @i[1]\nmdi = ((@i[0] >> 3) & 63).to_i32\npad_len = (mdi < 56) ? (56 - mdi) : (120 - mdi)\nupdate(PADDING.to_unsafe, pad_len)\nii = 0\n14.times do |i|\n  in[i] = (((@in[ii + 3].to_u32 << 24) | (@in[ii + 2].to_u32 << 16)) | (@in[ii + 1].to_u32 << 8)) | (@in[ii])\n  ii = ii + 4\nend\ntransform(in)\nii = 0\n4.times do |i|\n  @digest[ii] = (@buf[i] & 255).to_u8\n  @digest[ii + 1] = ((@buf[i] >> 8) & 255).to_u8\n  @digest[ii + 2] = ((@buf[i] >> 16) & 255).to_u8\n  @digest[ii + 3] = ((@buf[i] >> 24) & 255).to_u8\n  ii = ii + 4\nend\n"}},{"id":"g(x,y,z)-instance-method","html_id":"g(x,y,z)-instance-method","name":"g","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"args_string":"(x, y, z)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L89","def":{"name":"g","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(x & z) | (y & (~z))"}},{"id":"gg(a,b,c,d,x,s,ac)-instance-method","html_id":"gg(a,b,c,d,x,s,ac)-instance-method","name":"gg","doc":null,"summary":null,"abstract":false,"args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"args_string":"(a, b, c, d, x, s, ac)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L111","def":{"name":"gg","args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a = a + (((g(b, c, d)) + x) + ac.to_u32)\na = rotate_left(a, s)\na = a + b\n"}},{"id":"h(x,y,z)-instance-method","html_id":"h(x,y,z)-instance-method","name":"h","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"args_string":"(x, y, z)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L93","def":{"name":"h","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(x ^ y) ^ z"}},{"id":"hh(a,b,c,d,x,s,ac)-instance-method","html_id":"hh(a,b,c,d,x,s,ac)-instance-method","name":"hh","doc":null,"summary":null,"abstract":false,"args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"args_string":"(a, b, c, d, x, s, ac)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L117","def":{"name":"hh","args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a = a + (((h(b, c, d)) + x) + ac.to_u32)\na = rotate_left(a, s)\na = a + b\n"}},{"id":"i(x,y,z)-instance-method","html_id":"i(x,y,z)-instance-method","name":"i","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"args_string":"(x, y, z)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L97","def":{"name":"i","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"y","doc":null,"default_value":"","external_name":"y","restriction":""},{"name":"z","doc":null,"default_value":"","external_name":"z","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"y ^ (x | (~z))"}},{"id":"ii(a,b,c,d,x,s,ac)-instance-method","html_id":"ii(a,b,c,d,x,s,ac)-instance-method","name":"ii","doc":null,"summary":null,"abstract":false,"args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"args_string":"(a, b, c, d, x, s, ac)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L123","def":{"name":"ii","args":[{"name":"a","doc":null,"default_value":"","external_name":"a","restriction":""},{"name":"b","doc":null,"default_value":"","external_name":"b","restriction":""},{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":""},{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":""},{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"s","doc":null,"default_value":"","external_name":"s","restriction":""},{"name":"ac","doc":null,"default_value":"","external_name":"ac","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a = a + (((i(b, c, d)) + x) + ac.to_u32)\na = rotate_left(a, s)\na = a + b\n"}},{"id":"result:StaticArray(UInt8,16)-instance-method","html_id":"result:StaticArray(UInt8,16)-instance-method","name":"result","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : StaticArray(UInt8, 16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L246","def":{"name":"result","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest"}},{"id":"rotate_left(x,n)-instance-method","html_id":"rotate_left(x,n)-instance-method","name":"rotate_left","doc":null,"summary":null,"abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(x, n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L101","def":{"name":"rotate_left","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""},{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(x << n) | (x >> (32 - n))"}},{"id":"transform(in)-instance-method","html_id":"transform(in)-instance-method","name":"transform","doc":null,"summary":null,"abstract":false,"args":[{"name":"in","doc":null,"default_value":"","external_name":"in","restriction":""}],"args_string":"(in)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L129","def":{"name":"transform","args":[{"name":"in","doc":null,"default_value":"","external_name":"in","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a, b, c, d = @buf\na = ff(a, b, c, d, in[0], S11, 3614090360_i64)\nd = ff(d, a, b, c, in[1], S12, 3905402710_i64)\nc = ff(c, d, a, b, in[2], S13, 606105819)\nb = ff(b, c, d, a, in[3], S14, 3250441966_i64)\na = ff(a, b, c, d, in[4], S11, 4118548399_i64)\nd = ff(d, a, b, c, in[5], S12, 1200080426)\nc = ff(c, d, a, b, in[6], S13, 2821735955_i64)\nb = ff(b, c, d, a, in[7], S14, 4249261313_i64)\na = ff(a, b, c, d, in[8], S11, 1770035416)\nd = ff(d, a, b, c, in[9], S12, 2336552879_i64)\nc = ff(c, d, a, b, in[10], S13, 4294925233_i64)\nb = ff(b, c, d, a, in[11], S14, 2304563134_i64)\na = ff(a, b, c, d, in[12], S11, 1804603682)\nd = ff(d, a, b, c, in[13], S12, 4254626195_i64)\nc = ff(c, d, a, b, in[14], S13, 2792965006_i64)\nb = ff(b, c, d, a, in[15], S14, 1236535329)\na = gg(a, b, c, d, in[1], S21, 4129170786_i64)\nd = gg(d, a, b, c, in[6], S22, 3225465664_i64)\nc = gg(c, d, a, b, in[11], S23, 643717713)\nb = gg(b, c, d, a, in[0], S24, 3921069994_i64)\na = gg(a, b, c, d, in[5], S21, 3593408605_i64)\nd = gg(d, a, b, c, in[10], S22, 38016083)\nc = gg(c, d, a, b, in[15], S23, 3634488961_i64)\nb = gg(b, c, d, a, in[4], S24, 3889429448_i64)\na = gg(a, b, c, d, in[9], S21, 568446438)\nd = gg(d, a, b, c, in[14], S22, 3275163606_i64)\nc = gg(c, d, a, b, in[3], S23, 4107603335_i64)\nb = gg(b, c, d, a, in[8], S24, 1163531501)\na = gg(a, b, c, d, in[13], S21, 2850285829_i64)\nd = gg(d, a, b, c, in[2], S22, 4243563512_i64)\nc = gg(c, d, a, b, in[7], S23, 1735328473)\nb = gg(b, c, d, a, in[12], S24, 2368359562_i64)\na = hh(a, b, c, d, in[5], S31, 4294588738_i64)\nd = hh(d, a, b, c, in[8], S32, 2272392833_i64)\nc = hh(c, d, a, b, in[11], S33, 1839030562)\nb = hh(b, c, d, a, in[14], S34, 4259657740_i64)\na = hh(a, b, c, d, in[1], S31, 2763975236_i64)\nd = hh(d, a, b, c, in[4], S32, 1272893353)\nc = hh(c, d, a, b, in[7], S33, 4139469664_i64)\nb = hh(b, c, d, a, in[10], S34, 3200236656_i64)\na = hh(a, b, c, d, in[13], S31, 681279174)\nd = hh(d, a, b, c, in[0], S32, 3936430074_i64)\nc = hh(c, d, a, b, in[3], S33, 3572445317_i64)\nb = hh(b, c, d, a, in[6], S34, 76029189)\na = hh(a, b, c, d, in[9], S31, 3654602809_i64)\nd = hh(d, a, b, c, in[12], S32, 3873151461_i64)\nc = hh(c, d, a, b, in[15], S33, 530742520)\nb = hh(b, c, d, a, in[2], S34, 3299628645_i64)\na = ii(a, b, c, d, in[0], S41, 4096336452_i64)\nd = ii(d, a, b, c, in[7], S42, 1126891415)\nc = ii(c, d, a, b, in[14], S43, 2878612391_i64)\nb = ii(b, c, d, a, in[5], S44, 4237533241_i64)\na = ii(a, b, c, d, in[12], S41, 1700485571)\nd = ii(d, a, b, c, in[3], S42, 2399980690_i64)\nc = ii(c, d, a, b, in[10], S43, 4293915773_i64)\nb = ii(b, c, d, a, in[1], S44, 2240044497_i64)\na = ii(a, b, c, d, in[8], S41, 1873313359)\nd = ii(d, a, b, c, in[15], S42, 4264355552_i64)\nc = ii(c, d, a, b, in[6], S43, 2734768916_i64)\nb = ii(b, c, d, a, in[13], S44, 1309151649)\na = ii(a, b, c, d, in[4], S41, 4149444226_i64)\nd = ii(d, a, b, c, in[11], S42, 3174756917_i64)\nc = ii(c, d, a, b, in[2], S43, 718787259)\nb = ii(b, c, d, a, in[9], S44, 3951481745_i64)\n@buf[0] = @buf[0] + a\n@buf[1] = @buf[1] + b\n@buf[2] = @buf[2] + c\n@buf[3] = @buf[3] + d\n"}},{"id":"update(inBuf,inLen)-instance-method","html_id":"update(inBuf,inLen)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"inBuf","doc":null,"default_value":"","external_name":"inBuf","restriction":""},{"name":"inLen","doc":null,"default_value":"","external_name":"inLen","restriction":""}],"args_string":"(inBuf, inLen)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L26","def":{"name":"update","args":[{"name":"inBuf","doc":null,"default_value":"","external_name":"inBuf","restriction":""},{"name":"inLen","doc":null,"default_value":"","external_name":"inLen","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"in = uninitialized ::StaticArray(UInt32, 16)\nmdi = (@i[0] >> 3) & 63\nif (@i[0] + (inLen << 3)) < @i[0]\n  @i[1] = @i[1] + 1\nend\n@i[0] = @i[0] + (inLen << 3)\n@i[1] = @i[1] + (inLen >> 29)\ninLen.times do\n  @in[mdi] = inBuf.value\n  mdi = mdi + 1\n  inBuf = inBuf + 1\n  if mdi == 64\n    ii = 0\n    16.times do |i|\n      in[i] = (((@in[ii + 3].to_u32 << 24) | (@in[ii + 2].to_u32 << 16)) | (@in[ii + 1].to_u32 << 8)) | (@in[ii])\n      ii = ii + 4\n    end\n    transform(in)\n    mdi = 0\n  end\nend\n"}},{"id":"update(data)-instance-method","html_id":"update(data)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/md5.cr#L21","def":{"name":"update","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"slice = data.to_slice\nupdate(slice.to_unsafe, slice.bytesize.to_u32)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Digest/SHA1","path":"Digest/SHA1.html","kind":"class","full_name":"Digest::SHA1","name":"SHA1","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Digest/Base","kind":"class","full_name":"Digest::Base","name":"Base"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Digest/Base","kind":"class","full_name":"Digest::Base","name":"Base"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"digest/sha1.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Digest","kind":"module","full_name":"Digest","name":"Digest"},"doc":"Implements the SHA1 digest algorithm.\n\nWarning: SHA1 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Implements the SHA1 digest algorithm.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L13","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"circular_shift(bits,word)-instance-method","html_id":"circular_shift(bits,word)-instance-method","name":"circular_shift","doc":null,"summary":null,"abstract":false,"args":[{"name":"bits","doc":null,"default_value":"","external_name":"bits","restriction":""},{"name":"word","doc":null,"default_value":"","external_name":"word","restriction":""}],"args_string":"(bits, word)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L116","def":{"name":"circular_shift","args":[{"name":"bits","doc":null,"default_value":"","external_name":"bits","restriction":""},{"name":"word","doc":null,"default_value":"","external_name":"word","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(word << bits) | (word >> (32 - bits))"}},{"id":"final-instance-method","html_id":"final-instance-method","name":"final","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L120","def":{"name":"final","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"pad_message-instance-method","html_id":"pad_message-instance-method","name":"pad_message","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L136","def":{"name":"pad_message","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @message_block_index > 55\n  @message_block[@message_block_index] = 128_u8\n  @message_block_index = @message_block_index + 1\n  while @message_block_index < 64\n    @message_block[@message_block_index] = 0_u8\n    @message_block_index = @message_block_index + 1\n  end\n  process_message_block\n  while @message_block_index < 56\n    @message_block[@message_block_index] = 0_u8\n    @message_block_index = @message_block_index + 1\n  end\nelse\n  @message_block[@message_block_index] = 128_u8\n  @message_block_index = @message_block_index + 1\n  while @message_block_index < 56\n    @message_block[@message_block_index] = 0_u8\n    @message_block_index = @message_block_index + 1\n  end\nend\n@message_block[56] = (@length_high >> 24).to_u8\n@message_block[57] = (@length_high >> 16).to_u8\n@message_block[58] = (@length_high >> 8).to_u8\n@message_block[59] = (@length_high).to_u8\n@message_block[60] = (@length_low >> 24).to_u8\n@message_block[61] = (@length_low >> 16).to_u8\n@message_block[62] = (@length_low >> 8).to_u8\n@message_block[63] = (@length_low).to_u8\nprocess_message_block\n"}},{"id":"process_message_block-instance-method","html_id":"process_message_block-instance-method","name":"process_message_block","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L47","def":{"name":"process_message_block","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"k = {1518500249_u32, 1859775393_u32, 2400959708_u32, 3395469782_u32}\nw = uninitialized ::StaticArray(UInt32, 80)\n{% for t in (0...16) %}\n      w[{{ t }}] = @message_block[{{ t }} * 4].to_u32 << 24\n      w[{{ t }}] |= @message_block[{{ t }} * 4 + 1].to_u32 << 16\n      w[{{ t }}] |= @message_block[{{ t }} * 4 + 2].to_u32 << 8\n      w[{{ t }}] |= @message_block[{{ t }} * 4 + 3].to_u32\n    {% end %}\n{% for t in (16...80) %}\n      w[{{ t }}] = circular_shift(1, w[{{ t - 3 }}] ^ w[{{ t - 8 }}] ^ w[{{ t - 14 }}] ^ w[{{ t - 16 }}])\n    {% end %}\na = @intermediate_hash[0]\nb = @intermediate_hash[1]\nc = @intermediate_hash[2]\nd = @intermediate_hash[3]\ne = @intermediate_hash[4]\n{% for t in (0...20) %}\n      temp = circular_shift(5, a) +\n        ((b & c) | ((~b) & d)) + e + w[{{ t }}] + k[0]\n      e = d\n      d = c\n      c = circular_shift(30, b)\n      b = a\n      a = temp\n    {% end %}\n{% for t in (20...40) %}\n      temp = circular_shift(5, a) + (b ^ c ^ d) + e + w[{{ t }}] + k[1]\n      e = d\n      d = c\n      c = circular_shift(30, b)\n      b = a\n      a = temp\n    {% end %}\n{% for t in (40...60) %}\n      temp = circular_shift(5, a) +\n        ((b & c) | (b & d) | (c & d)) + e + w[{{ t }}] + k[2]\n      e = d\n      d = c\n      c = circular_shift(30, b)\n      b = a\n      a = temp\n    {% end %}\n{% for t in (60...80) %}\n      temp = circular_shift(5, a) + (b ^ c ^ d) + e + w[{{ t }}] + k[3]\n      e = d\n      d = c\n      c = circular_shift(30, b)\n      b = a\n      a = temp\n    {% end %}\n@intermediate_hash[0] = @intermediate_hash[0] + a\n@intermediate_hash[1] = @intermediate_hash[1] + b\n@intermediate_hash[2] = @intermediate_hash[2] + c\n@intermediate_hash[3] = @intermediate_hash[3] + d\n@intermediate_hash[4] = @intermediate_hash[4] + e\n@message_block_index = 0\n"}},{"id":"result-instance-method","html_id":"result-instance-method","name":"result","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L123","def":{"name":"result","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"message_digest = uninitialized ::StaticArray(UInt8, 20)\npad_message\n@length_low = 0_u32\n@length_high = 0_u32\n{% for i in 0...20 %}\n      message_digest[{{ i }}] = (@intermediate_hash[{{ i >> 2 }}] >> 8 * (3 - ({{ i & 3 }}))).to_u8\n    {% end %}\nmessage_digest\n"}},{"id":"update(data)-instance-method","html_id":"update(data)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/digest/sha1.cr#L27","def":{"name":"update","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"message_array = data.to_slice\nmessage_array.each do |byte|\n  @message_block[@message_block_index] = byte & 255_u8\n  @message_block_index = @message_block_index + 1\n  @length_low = @length_low + 8\n  if @length_low == 0\n    @length_high = @length_high + 1\n    if @length_high == 0\n      raise(ArgumentError.new(\"Crypto.sha1: message too long\"))\n    end\n  end\n  if @message_block_index == 64\n    process_message_block\n  end\nend\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Dir","path":"Dir.html","kind":"class","full_name":"Dir","name":"Dir","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"dir.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr"},{"filename":"dir/glob.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Objects of class `Dir` are directory streams representing directories in the underlying file system.\nThey provide a variety of ways to list directories and their contents.\n\nThe directory used in these examples contains the two regular files (`config.h` and `main.rb`),\nthe parent directory (`..`), and the directory itself (`.`).\n\nSee also: `File`.","summary":"<p>Objects of class <code><a href=\"Dir.html\">Dir</a></code> are directory streams representing directories in the underlying file system.</p>","class_methods":[{"id":"[](*patterns):Array(String)-class-method","html_id":"[](*patterns):Array(String)-class-method","name":"[]","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""}],"args_string":"(*patterns) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L7","def":{"name":"[]","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"glob(patterns)"}},{"id":"[](patterns:Enumerable(String)):Array(String)-class-method","html_id":"[](patterns:Enumerable(String)):Array(String)-class-method","name":"[]","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"}],"args_string":"(patterns : Enumerable(String)) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L12","def":{"name":"[]","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"glob(patterns)"}},{"id":"cd(path)-class-method","html_id":"cd(path)-class-method","name":"cd","doc":"Changes the current working directory of the process to the given string.","summary":"<p>Changes the current working directory of the process to the given string.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L145","def":{"name":"cd","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Dir.current = path"}},{"id":"cd(path,&block)-class-method","html_id":"cd(path,&amp;block)-class-method","name":"cd","doc":"Changes the current working directory of the process to the given string\nand invokes the block, restoring the original working directory\nwhen the block exits.","summary":"<p>Changes the current working directory of the process to the given string and invokes the block, restoring the original working directory when the block exits.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L152","def":{"name":"cd","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"old = current\nbegin\n  cd(path)\n  yield\nensure\n  cd(old)\nend\n"}},{"id":"children(dirname):Array(String)-class-method","html_id":"children(dirname):Array(String)-class-method","name":"children","doc":"See `#children`.","summary":"<p>See <code><a href=\"Dir.html#children%3AArray%28String%29-instance-method\">#children</a></code>.</p>","abstract":false,"args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"args_string":"(dirname) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L188","def":{"name":"children","args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  return dir.children\nend"}},{"id":"current:String-class-method","html_id":"current:String-class-method","name":"current","doc":"Returns the current working directory.","summary":"<p>Returns the current working directory.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L140","def":{"name":"current","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Crystal::System::Dir.current"}},{"id":"each(dirname,&block)-class-method","html_id":"each(dirname,&amp;block)-class-method","name":"each","doc":"See `#each`.","summary":"<p>See <code><a href=\"Dir.html#each%28%26block%29%3ANil-instance-method\">#each</a></code>.</p>","abstract":false,"args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"args_string":"(dirname, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L163","def":{"name":"each","args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  dir.each do |filename|\n    yield filename\n  end\nend"}},{"id":"each_child(dirname,&block)-class-method","html_id":"each_child(dirname,&amp;block)-class-method","name":"each_child","doc":"See `#each_child`.","summary":"<p>See <code><a href=\"Dir.html#each_child%28%26block%29%3ANil-instance-method\">#each_child</a></code>.</p>","abstract":false,"args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"args_string":"(dirname, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L179","def":{"name":"each_child","args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  dir.each_child do |filename|\n    yield filename\n  end\nend"}},{"id":"empty?(path):Bool-class-method","html_id":"empty?(path):Bool-class-method","name":"empty?","doc":"Returns `true` if the directory at *path* is empty, otherwise returns `false`.\nRaises `Errno` if the directory at *path* does not exist.\n\n```\nDir.mkdir(\"bar\")\nDir.empty?(\"bar\") # => true\nFile.write(\"bar/a_file\", \"The content\")\nDir.empty?(\"bar\") # => false\n```","summary":"<p>Returns <code>true</code> if the directory at <em>path</em> is empty, otherwise returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L212","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L212","def":{"name":"empty?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if exists?(path)\nelse\n  raise(Errno.new(\"Error determining size of '#{path}'\"))\nend\neach_child(path) do |f|\n  return false\nend\ntrue\n"}},{"id":"entries(dirname):Array(String)-class-method","html_id":"entries(dirname):Array(String)-class-method","name":"entries","doc":"See `#entries`.","summary":"<p>See <code><a href=\"Dir.html#entries%3AArray%28String%29-instance-method\">#entries</a></code>.</p>","abstract":false,"args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"args_string":"(dirname) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L172","def":{"name":"entries","args":[{"name":"dirname","doc":null,"default_value":"","external_name":"dirname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  return dir.entries\nend"}},{"id":"exists?(path):Bool-class-method","html_id":"exists?(path):Bool-class-method","name":"exists?","doc":"Returns `true` if the given path exists and is a directory","summary":"<p>Returns <code>true</code> if the given path exists and is a directory</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L195","def":{"name":"exists?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if info = File.info?(path)\n  info.type.directory?\nelse\n  false\nend"}},{"id":"glob(patterns:Enumerable(String),match_hidden=false,&block:String->_)-class-method","html_id":"glob(patterns:Enumerable(String),match_hidden=false,&amp;block:String-&gt;_)-class-method","name":"glob","doc":"Yields all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Yields all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"args_string":"(patterns : Enumerable(String), match_hidden = <span class=\"n\">false</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L50","def":{"name":"glob","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"Globber.glob(patterns, match_hidden: match_hidden) do |path|\n  yield path\nend"}},{"id":"glob(*patterns,match_hidden=false):Array(String)-class-method","html_id":"glob(*patterns,match_hidden=false):Array(String)-class-method","name":"glob","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"args_string":"(*patterns, match_hidden = <span class=\"n\">false</span>) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L23","def":{"name":"glob","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"glob(patterns, match_hidden: match_hidden)"}},{"id":"glob(patterns:Enumerable(String),match_hidden=false):Array(String)-class-method","html_id":"glob(patterns:Enumerable(String),match_hidden=false):Array(String)-class-method","name":"glob","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"args_string":"(patterns : Enumerable(String), match_hidden = <span class=\"n\">false</span>) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L28","def":{"name":"glob","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(String)"},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"paths = [] of String\nglob(patterns, match_hidden: match_hidden) do |path|\n  paths << path\nend\npaths\n"}},{"id":"glob(*patterns,match_hidden=false,&block:String->_)-class-method","html_id":"glob(*patterns,match_hidden=false,&amp;block:String-&gt;_)-class-method","name":"glob","doc":"Yields all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Yields all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"args_string":"(*patterns, match_hidden = <span class=\"n\">false</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir/glob.cr#L43","def":{"name":"glob","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":""},{"name":"match_hidden","doc":null,"default_value":"false","external_name":"match_hidden","restriction":""}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"glob(patterns, match_hidden: match_hidden) do |path|\n  yield path\nend"}},{"id":"mkdir(path,mode=511)-class-method","html_id":"mkdir(path,mode=511)-class-method","name":"mkdir","doc":"Creates a new directory at the given path. The linux-style permission mode\ncan be specified, with a default of 777 (0o777).","summary":"<p>Creates a new directory at the given path.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path, mode = <span class=\"n\">511</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L223","def":{"name":"mkdir","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Dir.create(path, mode)"}},{"id":"mkdir_p(path,mode=511)-class-method","html_id":"mkdir_p(path,mode=511)-class-method","name":"mkdir_p","doc":"Creates a new directory at the given path, including any non-existing\nintermediate directories. The linux-style permission mode can be specified,\nwith a default of 777 (0o777).","summary":"<p>Creates a new directory at the given path, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path, mode = <span class=\"n\">511</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L230","def":{"name":"mkdir_p","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(path)\n  return 0\nend\ncomponents = path.split(File::SEPARATOR)\ncase components.first\nwhen \"\"\n  components.shift\n  subpath = \"/\"\nwhen \".\"\n  subpath = components.shift\nelse\n  subpath = \".\"\nend\ncomponents.each do |component|\n  subpath = File.join(subpath, component)\n  if Dir.exists?(subpath)\n  else\n    mkdir(subpath, mode)\n  end\nend\n0\n"}},{"id":"open(path,&block)-class-method","html_id":"open(path,&amp;block)-class-method","name":"open","doc":"Opens a directory and yields it, closing it at the end of the block.\nReturns the value of the block.","summary":"<p>Opens a directory and yields it, closing it at the end of the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L29","def":{"name":"open","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"dir = new(path)\nbegin\n  yield dir\nensure\n  dir.close\nend\n"}},{"id":"rmdir(path)-class-method","html_id":"rmdir(path)-class-method","name":"rmdir","doc":"Removes the directory at the given path.","summary":"<p>Removes the directory at the given path.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L254","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L254","def":{"name":"rmdir","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Dir.delete(path)"}}],"constructors":[{"id":"new(path)-class-method","html_id":"new(path)-class-method","name":"new","doc":"Returns a new directory object for the named directory.","summary":"<p>Returns a new directory object for the named directory.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L17","def":{"name":"new","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"open(path):self-class-method","html_id":"open(path):self-class-method","name":"open","doc":"Alias for `new(path)`","summary":"<p>Alias for <code>new(path)</code></p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L23","def":{"name":"open","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(path)"}}],"instance_methods":[{"id":"children:Array(String)-instance-method","html_id":"children:Array(String)-instance-method","name":"children","doc":"Returns an array containing all of the filenames except for `.` and `..`\nin the given directory.","summary":"<p>Returns an array containing all of the filenames except for <code>.</code> and <code>..</code> in the given directory.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L104","def":{"name":"children","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"entries = [] of String\neach_child do |filename|\n  entries << filename\nend\nentries\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes the directory stream.","summary":"<p>Closes the directory stream.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L133","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\nCrystal::System::Dir.close(@dir)\n@closed = true\n"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Calls the block once for each entry in this directory,\npassing the filename of each entry as a parameter to the block.\n\n```\nDir.mkdir(\"testdir\")\nFile.write(\"testdir/config.h\", \"\")\n\nd = Dir.new(\"testdir\")\nd.each { |x| puts \"Got #{x}\" }\n```\n\nproduces:\n\n```text\nGot .\nGot ..\nGot config.h\n```","summary":"<p>Calls the block once for each entry in this directory, passing the filename of each entry as a parameter to the block.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L56","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while entry = read\n  yield entry\nend"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L62","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"EntryIterator.new(self)"}},{"id":"each_child(&block):Nil-instance-method","html_id":"each_child(&amp;block):Nil-instance-method","name":"each_child","doc":"Calls the block once for each entry except for `.` and `..` in this directory,\npassing the filename of each entry as a parameter to the block.\n\n```\nDir.mkdir(\"testdir\")\nFile.write(\"testdir/config.h\", \"\")\n\nd = Dir.new(\"testdir\")\nd.each_child { |x| puts \"Got #{x}\" }\n```\n\nproduces:\n\n```text\nGot config.h\n```","summary":"<p>Calls the block once for each entry except for <code>.</code> and <code>..</code> in this directory, passing the filename of each entry as a parameter to the block.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L91","def":{"name":"each_child","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"excluded = {\".\", \"..\"}\nwhile entry = read\n  if excluded.includes?(entry)\n  else\n    yield entry\n  end\nend\n"}},{"id":"each_child-instance-method","html_id":"each_child-instance-method","name":"each_child","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L98","def":{"name":"each_child","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ChildIterator.new(self)"}},{"id":"entries:Array(String)-instance-method","html_id":"entries:Array(String)-instance-method","name":"entries","doc":"Returns an array containing all of the filenames in the given directory.","summary":"<p>Returns an array containing all of the filenames in the given directory.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L67","def":{"name":"entries","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"entries = [] of String\neach do |filename|\n  entries << filename\nend\nentries\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L262","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L14","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L266","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L266","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.text(inspect)"}},{"id":"read-instance-method","html_id":"read-instance-method","name":"read","doc":"Reads the next entry from dir and returns it as a string. Returns `nil` at the end of the stream.\n\n```\nd = Dir.new(\"testdir\")\narray = [] of String\nwhile file = d.read\n  array << file\nend\narray.sort # => [\".\", \"..\", \"config.h\"]\n```","summary":"<p>Reads the next entry from dir and returns it as a string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L122","def":{"name":"read","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Dir.next(@dir)"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Repositions this directory to the first entry.","summary":"<p>Repositions this directory to the first entry.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L127","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Dir.rewind(@dir)\nself\n"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L258","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dir.cr#L258","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((io << \"#<Dir:\") << @path) << '>'"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/DivisionByZeroError","path":"DivisionByZeroError.html","kind":"class","full_name":"DivisionByZeroError","name":"DivisionByZeroError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":126,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when attempting to divide an integer by 0.\n\n```\n1 / 0 # raises DivisionByZeroError (Division by 0)\n```","summary":"<p>Raised when attempting to divide an integer by 0.</p>","class_methods":[],"constructors":[{"id":"new(message=&quot;Divisionby0&quot;)-class-method","html_id":"new(message=&amp;quot;Divisionby0&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Division by 0\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Division by 0&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L127","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Division by 0\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/DL","path":"DL.html","kind":"module","full_name":"DL","name":"DL","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"dl.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"dlopen(path,mode=LibC::RTLD_LAZY|LibC::RTLD_GLOBAL):Pointer(Void)-class-method","html_id":"dlopen(path,mode=LibC::RTLD_LAZY|LibC::RTLD_GLOBAL):Pointer(Void)-class-method","name":"dlopen","doc":null,"summary":null,"abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"LibC::RTLD_LAZY | LibC::RTLD_GLOBAL","external_name":"mode","restriction":""}],"args_string":"(path, mode = <span class=\"t\">LibC</span><span class=\"t\">::</span><span class=\"t\">RTLD_LAZY</span> <span class=\"o\">|</span> <span class=\"t\">LibC</span><span class=\"t\">::</span><span class=\"t\">RTLD_GLOBAL</span>) : Pointer(Void)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dl.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/dl.cr#L4","def":{"name":"dlopen","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"mode","doc":null,"default_value":"LibC::RTLD_LAZY | LibC::RTLD_GLOBAL","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(Void)","visibility":"Public","body":"LibC.dlopen(path, mode)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/ECR","path":"ECR.html","kind":"module","full_name":"ECR","name":"ECR","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"ecr.cr","line_number":73,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ecr.cr"},{"filename":"ecr/macros.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ecr/macros.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Embedded Crystal (ECR) is a template language for embedding Crystal code into other text,\nthat includes but is not limited to HTML. The template is read and transformed\nat compile time and then embedded into the binary.\n\nThere are `<%= %>` and `<% %>` syntax. The former will render returned values.\nThe latter will not, but instead serve to control the structure as we do in Crystal.\n\nUsing a dash inside `<...>` either eliminates previous indentation or removes the next newline:\n\n* `<%- ... %>`: removes previous indentation\n* `<% ... -%>`: removes next newline\n* `<%-= ... %>`: removes previous indentation\n* `<%= ... -%>`: removes next newline\n\nQuick Example:\n\n```\nrequire \"ecr\"\n\nclass Greeting\n  def initialize(@name : String)\n  end\n\n  ECR.def_to_s \"greeting.ecr\"\nend\n\n# greeting.ecr\nGreeting, <%= @name %>!\n\nGreeting.new(\"John\").to_s #=> Greeting, John!\n```\n\nUsing logical statements:\n\n```\n# greeting.ecr\n<%- if @name -%>\nGreeting, <%= @name %>!\n<%- else -%>\nGreeting!\n<%- end -%>\n\nGreeting.new(nil).to_s #=> Greeting!\n```\n\nUsing loops:\n\n```\nrequire \"ecr\"\n\nclass Greeting\n  @names : Array(String)\n\n  def initialize(*names)\n   @names = names.to_a\n  end\n\n  ECR.def_to_s \"greeting.ecr\"\nend\n\n# greeting.ecr\n<%- @names.each do |name| -%>\nHi, <%= name %>!\n<%- end -%>\n\nGreeting.new(\"John\", \"Zoe\", \"Ben\").to_s\n#=> Hi, John!\n#=> Hi, Zoe!\n#=> Hi, Ben!\n```\n\nLikewise, other Crystal logic can be implemented in ECR text.","summary":"<p>Embedded Crystal (ECR) is a template language for embedding Crystal code into other text, that includes but is not limited to HTML.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[{"id":"def_to_s(filename)-macro","html_id":"def_to_s(filename)-macro","name":"def_to_s","doc":"Defines a `to_s(io)` method whose body is the ECR contained\nin *filename*, translated to Crystal code.\n\n```text\n# greeting.ecr\nHello <%= @name %>!\n```\n\n```\nrequire \"ecr/macros\"\n\nclass Greeting\n  def initialize(@name : String)\n  end\n\n  ECR.def_to_s \"greeting.ecr\"\nend\n\nGreeting.new(\"World\").to_s # => \"Hello World!\"\n```\n\nThe macro basically translates the text inside the given file\nto Crystal code that appends to the IO:\n\n```\nclass Greeting\n  def to_s(io)\n    io << \"Hello \"\n    io << @name\n    io << '!'\n  end\nend\n```","summary":"<p>Defines a <code>to_s(io)</code> method whose body is the ECR contained in <em>filename</em>, translated to Crystal code.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(filename)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ecr/macros.cr#L35","def":{"name":"def_to_s","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    def to_s(__io__)\n      ECR.embed \n{{ filename }}\n, \"__io__\"\n    \nend\n  \n"}},{"id":"embed(filename,io_name)-macro","html_id":"embed(filename,io_name)-macro","name":"embed","doc":"Embeds an ECR file contained in *filename* into the program.\n\nThe generated code is the result of translating the contents of\nthe ECR file to Crystal, a program that appends to the IO\nwith the given *io_name*.\n\n```text\n# greeting.ecr\nHello <%= name %>!\n```\n\n```\nrequire \"ecr/macros\"\n\nname = \"World\"\n\nio = IO::Memory.new\nECR.embed \"greeting.ecr\", io\nio.to_s # => \"Hello World!\"\n```\n\nThe `ECR.embed` line basically generates this:\n\n```\nio << \"Hello \"\nio << name\nio << '!'\n```","summary":"<p>Embeds an ECR file contained in <em>filename</em> into the program.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"io_name","doc":null,"default_value":"","external_name":"io_name","restriction":""}],"args_string":"(filename, io_name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ecr/macros.cr#L69","def":{"name":"embed","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"io_name","doc":null,"default_value":"","external_name":"io_name","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    \n\\{\n{ run(\"ecr/process\", \n{{ filename }}\n, \n{{ io_name.id.stringify }}\n) }}\n  \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Enum","path":"Enum.html","kind":"struct","full_name":"Enum","name":"Enum","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"enum.cr","line_number":89,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr"},{"filename":"json/to_json.cr","line_number":119,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":103,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Enum is the base type of all enums.\n\nAn enum is a set of integer values, where each value has an associated name. For example:\n\n```\nenum Color\n  Red   # 0\n  Green # 1\n  Blue  # 2\nend\n```\n\nValues start with the value `0` and are incremented by one, but can be overwritten.\n\nTo get the underlying value you invoke value on it:\n\n```\nColor::Green.value # => 1\n```\n\nEach constant (member) in the enum has the type of the enum:\n\n```\ntypeof(Color::Red) # => Color\n```\n\n### Flags enum\n\nAn enum can be marked with the `@[Flags]` attribute. This changes the default values:\n\n```\n@[Flags]\nenum IOMode\n  Read  # 1\n  Write # 2\n  Async # 4\nend\n```\n\nAdditionally, some methods change their behaviour.\n\n### Enums from integers\n\nAn enum can be created from an integer:\n\n```\nColor.new(1).to_s # => \"Green\"\n```\n\nValues that don't correspond to an enum's constants are allowed: the value\nwill still be of type Color, but when printed you will get the underlying value:\n\n```\nColor.new(10).to_s # => \"10\"\n```\n\nThis method is mainly intended to convert integers from C to enums in Crystal.\n\n### Question methods\n\nAn enum automatically defines question methods for each member, using\n`String#underscore` for the method name.\n* In the case of regular enums, this compares by equality (`==`).\n* In the case of flags enums, this invokes `includes?`.\n\nFor example:\n\n```\ncolor = Color::Blue\ncolor.red?  # => false\ncolor.blue? # => true\n\nmode = IOMode::Read | IOMode::Async\nmode.read?  # => true\nmode.write? # => false\nmode.async? # => true\n```\n\nThis is very convenient in `case` expressions:\n\n```\ncase color\nwhen .red?\n  puts \"Got red\"\nwhen .blue?\n  puts \"Got blue\"\nend\n```","summary":"<p>Enum is the base type of all enums.</p>","class_methods":[{"id":"each(&block)-class-method","html_id":"each(&amp;block)-class-method","name":"each","doc":"Iterates each member of the enum.\nIt won't iterate the `None` and `All` members of flags enums.\n\n```\nIOMode.each do |member, value|\n  # yield IOMode::Read, 1\n  # yield IOMode::Write, 2\n  # yield IOMode::Async, 3\nend\n```","summary":"<p>Iterates each member of the enum.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L442","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L442","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for member in @type.constants %}\n      {% if (@type.has_attribute?(\"Flags\")) && (([\"none\", \"all\"] of ::String).includes?(member.stringify.downcase)) %}{% else %}\n        yield {{ @type }}::{{ member }}, {{ @type }}::{{ member }}.value\n      {% end %}\n    {% end %}"}},{"id":"names:Array(String)-class-method","html_id":"names:Array(String)-class-method","name":"names","doc":"Returns all enum members as an `Array(String)`.\n\n```\nColor.names # => [\"Red\", \"Green\", \"Blue\"]\n```","summary":"<p>Returns all enum members as an <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code>.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L310","def":{"name":"names","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      {{ @type.constants.select do |e|\n  (e.stringify != \"None\") && (e.stringify != \"All\")\nend.map(&.stringify) }}\n    {% else %}\n      {{ @type.constants.map(&.stringify) }}\n    {% end %}"}},{"id":"values:Array(self)-class-method","html_id":"values:Array(self)-class-method","name":"values","doc":"Returns all enum members as an `Array(self)`.\n\n```\nColor.values # => [Color::Red, Color::Green, Color::Blue]\n```","summary":"<p>Returns all enum members as an <code><a href=\"Array.html\">Array</a>(self)</code>.</p>","abstract":false,"args":[],"args_string":" : Array(self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L323","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L323","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(self)","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      {{ @type.constants.select do |e|\n  (e.stringify != \"None\") && (e.stringify != \"All\")\nend.map do |e|\n  \"#{@type}::#{e.id}\".id\nend }}\n    {% else %}\n      {{ @type.constants.map do |e|\n  \"#{@type}::#{e.id}\".id\nend }}\n    {% end %}"}}],"constructors":[{"id":"from_value(value):self-class-method","html_id":"from_value(value):self-class-method","name":"from_value","doc":"Returns the enum member that has the given value, or raises\nif no such member exists.\n\n```\nColor.from_value(0) # => Color::Red\nColor.from_value(1) # => Color::Green\nColor.from_value(2) # => Color::Blue\nColor.from_value(3) # raises Exception\n```","summary":"<p>Returns the enum member that has the given value, or raises if no such member exists.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L364","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L364","def":{"name":"from_value","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"(from_value?(value)) || (raise(\"Unknown enum #{self} value: #{value}\"))"}},{"id":"from_value?(value):self?-class-method","html_id":"from_value?(value):self?-class-method","name":"from_value?","doc":"Returns the enum member that has the given value, or `nil` if\nno such member exists.\n\n```\nColor.from_value?(0) # => Color::Red\nColor.from_value?(1) # => Color::Green\nColor.from_value?(2) # => Color::Blue\nColor.from_value?(3) # => nil\n```","summary":"<p>Returns the enum member that has the given value, or <code>nil</code> if no such member exists.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value) : self?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L340","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L340","def":{"name":"from_value?","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self | ::Nil","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      mask = {% for member, i in @type.constants %}{% if i != 0 %} | {% end %}{{ @type }}::{{ member }}.value{% end %}\n      return if (mask & value != value) || (value == 0 && values.none? { |val| val.to_i == 0 })\n      return new(value)\n    {% else %}\n      {% for member in @type.constants %}\n        return {{ @type }}::{{ member }} if {{ @type }}::{{ member }}.value == value\n      {% end %}\n    {% end %}\nnil\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L169","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.class}\")\nend\nstring = node.value\nif value = string.to_i64?\n  from_value(value)\nelse\n  parse(string)\nend\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L181","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case pull.kind\nwhen :int\n  from_value(pull.read_int)\nwhen :string\n  parse(pull.read_string)\nelse\n  raise(\"Expecting int or string in JSON for #{self.class}, not #{pull.kind}\")\nend"}},{"id":"parse(string):self-class-method","html_id":"parse(string):self-class-method","name":"parse","doc":"Returns the enum member that has the given name, or\nraises `ArgumentError` if no such member exists. The comparison is made by using\n`String#camelcase` and `String#downcase` between *string* and\nthe enum members names, so a member named \"FourtyTwo\" or \"FOURTY_TWO\"\nis found with any of these strings: \"fourty_two\", \"FourtyTwo\", \"FOURTY_TWO\",\n\"FOURTYTWO\", \"fourtytwo\".\n\n```\nColor.parse(\"Red\")    # => Color::Red\nColor.parse(\"BLUE\")   # => Color::Blue\nColor.parse(\"Yellow\") # raises ArgumentError\n```","summary":"<p>Returns the enum member that has the given name, or raises <code><a href=\"ArgumentError.html\">ArgumentError</a></code> if no such member exists.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L388","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L388","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"(parse?(string)) || (raise(ArgumentError.new(\"Unknown enum #{self} value: #{string}\")))"}},{"id":"parse?(string):self?-class-method","html_id":"parse?(string):self?-class-method","name":"parse?","doc":"Returns the enum member that has the given name, or\n`nil` if no such member exists. The comparison is made by using\n`String#camelcase` and `String#downcase` between *string* and\nthe enum members names, so a member named \"FourtyTwo\" or \"FOURTY_TWO\"\nis found with any of these strings: \"fourty_two\", \"FourtyTwo\", \"FOURTY_TWO\",\n\"FOURTYTWO\", \"fourtytwo\".\n\n```\nColor.parse?(\"Red\")    # => Color::Red\nColor.parse?(\"BLUE\")   # => Color::Blue\nColor.parse?(\"Yellow\") # => nil\n```","summary":"<p>Returns the enum member that has the given name, or <code>nil</code> if no such member exists.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string) : self?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L404","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L404","def":{"name":"parse?","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self | ::Nil","visibility":"Public","body":"{% if true %}\n      case string.camelcase.downcase\n      {% for member in @type.constants %}\n        when {{ member.stringify.camelcase.downcase }}\n          {{ @type }}::{{ member }}\n      {% end %}\n      else\n        nil\n      end\n    {% end %}"}}],"instance_methods":[{"id":"&(other:self)-instance-method","html_id":"&amp;(other:self)-instance-method","name":"&","doc":"Returns the enum member that results from applying a logical\n\"and\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.\n\n```\n(IOMode::Read | IOMode::Async) & IOMode::Read # => IOMode::Read\n```","summary":"<p>Returns the enum member that results from applying a logical \"and\" operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L211","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(value & other.value)"}},{"id":"+(other:Int)-instance-method","html_id":"+(other:Int)-instance-method","name":"+","doc":"Returns the enum member that results from adding *other*\nto this enum member's value.\n\n```\nColor::Red + 1 # => Color::Green\nColor::Red + 2 # => Color::Blue\nColor::Red + 3 # => Color.new(3)\n```","summary":"<p>Returns the enum member that results from adding <em>other</em> to this enum member's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L177","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(value + other)"}},{"id":"-(other:Int)-instance-method","html_id":"-(other:Int)-instance-method","name":"-","doc":"Returns the enum member that results from subtracting *other*\nto this enum member's value.\n\n```\nColor::Blue - 1 # => Color::Green\nColor::Blue - 2 # => Color::Red\nColor::Blue - 3 # => Color.new(-1)\n```","summary":"<p>Returns the enum member that results from subtracting <em>other</em> to this enum member's value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L189","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(value - other)"}},{"id":"(other:self)-instance-method","html_id":"(other:self)-instance-method","name":"<=>","doc":"Compares this enum member against another, according to their underlying\nvalue.\n\n```\nColor::Red <=> Color::Blue  # => -1\nColor::Blue <=> Color::Red  # => 1\nColor::Blue <=> Color::Blue # => 0\n```","summary":"<p>Compares this enum member against another, according to their underlying value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L236","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value <=> other.value"}},{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this enum member and *other* have the same underlying value.\n\n```\nColor::Red == Color::Red  # => true\nColor::Red == Color::Blue # => false\n```","summary":"<p>Returns <code>true</code> if this enum member and <em>other</em> have the same underlying value.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L273","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == other.value"}},{"id":"^(other:self)-instance-method","html_id":"^(other:self)-instance-method","name":"^","doc":"Returns the enum member that results from applying a logical\n\"xor\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.","summary":"<p>Returns the enum member that results from applying a logical \"xor\" operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L218","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(value ^ other.value)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L417","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L417","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":"Iterates each values in a Flags Enum.\n\n```\n(IOMode::Read | IOMode::Async).each do |member, value|\n  # yield IOMode::Read, 1\n  # yield IOMode::Async, 3\nend\n```","summary":"<p>Iterates each values in a Flags Enum.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L290","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      return if value == 0\n      {% for member in @type.constants %}\n        {% if member.stringify != \"All\" %}\n          if includes?({{ @type }}::{{ member }})\n            yield {{ @type }}::{{ member }}, {{ @type }}::{{ member }}.value\n          end\n        {% end %}\n      {% end %}\n    {% else %}\n      {% raise(\"Can't iterate #{@type}: only Flags Enum can be iterated\") %}\n    {% end %}"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L278","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.enum(self)"}},{"id":"includes?(other:self)-instance-method","html_id":"includes?(other:self)-instance-method","name":"includes?","doc":"Returns `true` if this enum member's value includes *other*. This\nperforms a logical \"and\" between this enum member's value and *other*'s,\nso instead of writing:\n\n```\n(member & value) != 0\n```\n\nyou can write:\n\n```\nmember.includes?(value)\n```\n\nThe above is mostly useful with flag enums.\n\nFor example:\n\n```\nmode = IOMode::Read | IOMode::Write\nmode.includes?(IOMode::Read)  # => true\nmode.includes?(IOMode::Async) # => false\n```","summary":"<p>Returns <code>true</code> if this enum member's value includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L263","def":{"name":"includes?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(value & other.value) != 0"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns the value of this enum member as a `Float32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float32.html\">Float32</a></code></p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"value.to_f32"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns the value of this enum member as a `Float64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float64.html\">Float64</a></code></p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"value.to_f64"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns the value of this enum member as an `Int32`.\n\n```\nColor::Blue.to_i                    # => 2\n(IOMode::Read | IOMode::Write).to_i # => 3\n\nColor.new(10).to_i # => 10\n```","summary":"<p>Returns the value of this enum member as an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L156","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"value.to_i32"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns the value of this enum member as a `Int16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int16.html\">Int16</a></code></p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"value.to_i16"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns the value of this enum member as a `Int32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int32.html\">Int32</a></code></p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"value.to_i32"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns the value of this enum member as a `Int64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int64.html\">Int64</a></code></p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"value.to_i64"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns the value of this enum member as a `Int8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int8.html\">Int8</a></code></p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"value.to_i8"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L120","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.number(value)"}},{"id":"to_s(io:IO):Nil-instance-method","html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this enum member to the given *io*.\n\nSee also: `to_s`.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this enum member to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L95","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      if value == 0\n        io << \"None\"\n      else\n        found = false\n        {% for member in @type.constants %}\n          {% if member.stringify != \"All\" %}\n            if {{ @type }}::{{ member }}.value != 0 && value.bits_set? {{ @type }}::{{ member }}.value\n              io << \" | \" if found\n              io << {{ member.stringify }}\n              found = true\n            end\n          {% end %}\n        {% end %}\n        io << value unless found\n      end\n    {% else %}\n      io << to_s\n    {% end %}\nnil\n"}},{"id":"to_s:String-instance-method","html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a `String` representation of this enum member.\nIn the case of regular enums, this is just the name of the member.\nIn the case of flag enums, it's the names joined by vertical bars, or \"None\",\nif the value is zero.\n\nIf an enum's value doesn't match a member's value, the raw value\nis returned as a string.\n\n```\nColor::Red.to_s                     # => \"Red\"\nIOMode::None.to_s                   # => \"None\"\n(IOMode::Read | IOMode::Write).to_s # => \"Read | Write\"\n\nColor.new(10).to_s # => \"10\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> representation of this enum member.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L133","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"{% if @type.has_attribute?(\"Flags\") %}\n      String.build { |io| to_s(io) }\n    {% else %}\n      case value\n      {% for member in @type.constants %}\n      when {{ @type }}::{{ member }}.value\n        {{ member.stringify }}\n      {% end %}\n      else\n        value.to_s\n      end\n    {% end %}"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns the value of this enum member as a `UInt16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt16.html\">UInt16</a></code></p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"value.to_u16"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns the value of this enum member as a `UInt32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt32.html\">UInt32</a></code></p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"value.to_u32"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns the value of this enum member as a `UInt64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt64.html\">UInt64</a></code></p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"value.to_u64"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns the value of this enum member as a `UInt8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt8.html\">UInt8</a></code></p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L160","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"value.to_u8"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L104","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(value)"}},{"id":"|(other:self)-instance-method","html_id":"|(other:self)-instance-method","name":"|","doc":"Returns the enum member that results from applying a logical\n\"or\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.\n\n```\n(IOMode::Read | IOMode::Async) # => IOMode::Read | IOMode::Async\n```","summary":"<p>Returns the enum member that results from applying a logical \"or\" operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L200","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(value | other.value)"}},{"id":"~-instance-method","html_id":"~-instance-method","name":"~","doc":"Returns the enum member that results from applying a logical\n\"not\" operation of this enum member's value.","summary":"<p>Returns the enum member that results from applying a logical \"not\" operation of this enum member's value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L224","def":{"name":"~","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(~value)"}}],"macros":[{"id":"flags(*values)-macro","html_id":"flags(*values)-macro","name":"flags","doc":"Convenience macro to create a combined enum (combines given members using `|` (or) logical operator)\n\n```\nIOMode.flags(Read, Write) # => IOMode::Read | IOMode::Write\n```","summary":"<p>Convenience macro to create a combined enum (combines given members using <code><a href=\"Enum.html#%7C%28other%3Aself%29-instance-method\">#|</a></code> (or) logical operator)</p>","abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"args_string":"(*values)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enum.cr#L426","def":{"name":"flags","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n{% for value, i in values %}{% if i != 0 %} | {% end %}{{ @type }}::{{ value }}{% end %}\n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Enumerable","path":"Enumerable.html","kind":"module","full_name":"Enumerable(T)","name":"Enumerable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"enumerable.cr","line_number":29,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr"},{"filename":"set.cr","line_number":424,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Char/Reader","kind":"struct","full_name":"Char::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"github.com/crystal-lang/crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Cookies","kind":"class","full_name":"HTTP::Cookies","name":"Cookies"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Headers","kind":"struct","full_name":"HTTP::Headers","name":"Headers"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Params","kind":"struct","full_name":"HTTP::Params","name":"Params"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable(T)","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},{"html_id":"github.com/crystal-lang/crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"github.com/crystal-lang/crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"},{"html_id":"github.com/crystal-lang/crystal/XML/Attributes","kind":"struct","full_name":"XML::Attributes","name":"Attributes"},{"html_id":"github.com/crystal-lang/crystal/XML/NodeSet","kind":"struct","full_name":"XML::NodeSet","name":"NodeSet"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Sequence","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence"}],"namespace":null,"doc":"The `Enumerable` mixin provides collection classes with several traversal, searching,\nfiltering and querying methods.\n\nIncluding types must provide an `each` method, which yields successive members\nof the collection.\n\nFor example:\n\n```\nclass Three\n  include Enumerable(Int32)\n\n  def each\n    yield 1\n    yield 2\n    yield 3\n  end\nend\n\nthree = Three.new\nthree.to_a                # => [1, 2, 3]\nthree.select &.odd?       # => [1, 3]\nthree.all? { |x| x < 10 } # => true\n```\n\nNote that most search and filter methods traverse an Enumerable eagerly,\nproducing an `Array` as the result. For a lazy alternative refer to\nthe `Iterator` and `Iterable` modules.","summary":"<p>The <code><a href=\"Enumerable.html\">Enumerable</a></code> mixin provides collection classes with several traversal, searching, filtering and querying methods.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"all?(&block)-instance-method","html_id":"all?(&amp;block)-instance-method","name":"all?","doc":"Returns `true` if the passed block returns a value other than `false` or `nil`\nfor all elements of the collection.\n\n```\n[\"ant\", \"bear\", \"cat\"].all? { |word| word.size >= 3 } # => true\n[\"ant\", \"bear\", \"cat\"].all? { |word| word.size >= 4 } # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns a value other than <code>false</code> or <code>nil</code> for all elements of the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L46","def":{"name":"all?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |e|\n  if yield e\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"all?-instance-method","html_id":"all?-instance-method","name":"all?","doc":"Returns `true` if none of the elements of the collection is `false` or `nil`.\n\n```\n[nil, true, 99].all? # => false\n[15].all?            # => true\n```","summary":"<p>Returns <code>true</code> if none of the elements of the collection is <code>false</code> or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L57","def":{"name":"all?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"all?(&.itself)"}},{"id":"any?(&block)-instance-method","html_id":"any?(&amp;block)-instance-method","name":"any?","doc":"Returns `true` if the passed block returns a value other than `false` or `nil`\nfor at least one element of the collection.\n\n```\n[\"ant\", \"bear\", \"cat\"].any? { |word| word.size >= 4 } # => true\n[\"ant\", \"bear\", \"cat\"].any? { |word| word.size > 4 }  # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns a value other than <code>false</code> or <code>nil</code> for at least one element of the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L68","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |e|\n  if yield e\n    return true\n  end\nend\nfalse\n"}},{"id":"any?-instance-method","html_id":"any?-instance-method","name":"any?","doc":"Returns `true` if at least one of the collection members is not `false` or `nil`.\n\n```\n[nil, true, 99].any? # => true\n[nil, false].any?    # => false\n```","summary":"<p>Returns <code>true</code> if at least one of the collection members is not <code>false</code> or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L79","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"any?(&.itself)"}},{"id":"chunks(&block:T->U)forallU-instance-method","html_id":"chunks(&amp;block:T-&gt;U)forallU-instance-method","name":"chunks","doc":"Enumerates over the items, chunking them together based on\nthe return value of the block.\n\nConsecutive elements which return the same block value are chunked together.\n\nFor example, consecutive even numbers and odd numbers can be chunked as follows.\n\n```\nary = [3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5].chunks { |n| n.even? }\nary # => [{false, [3, 1]}, {true, [4]}, {false, [1, 5, 9]}, {true, [2, 6]}, {false, [5, 3, 5]}]\n```\n\nThe following key values have special meaning:\n\n* `Enumerable::Chunk::Drop` specifies that the elements should be dropped\n* `Enumerable::Chunk::Alone` specifies that the element should be chunked by itself\n\nSee also: `Iterator#chunk`.","summary":"<p>Enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L101","def":{"name":"chunks","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"res = [] of Tuple(U, Array(T))\nchunks_internal(block) do |k, v|\n  res << {k, v}\nend\nres\n"}},{"id":"compact_map(&block)-instance-method","html_id":"compact_map(&amp;block)-instance-method","name":"compact_map","doc":"Returns an `Array` with the results of running the block against each element\nof the collection, removing `nil` values.\n\n```\n[\"Alice\", \"Bob\"].map { |name| name.match(/^A./) }         # => [#<Regex::MatchData \"Al\">, nil]\n[\"Alice\", \"Bob\"].compact_map { |name| name.match(/^A./) } # => [#<Regex::MatchData \"Al\">]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the results of running the block against each element of the collection, removing <code>nil</code> values.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L196","def":{"name":"compact_map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of typeof((yield first).not_nil!)\neach do |e|\n  v = yield e\n  if v.is_a?(Nil)\n  else\n    ary << v\n  end\nend\nary\n"}},{"id":"count(&block)-instance-method","html_id":"count(&amp;block)-instance-method","name":"count","doc":"Returns the number of elements in the collection for which\nthe passed block returns `true`.\n\n```\n[1, 2, 3, 4].count { |i| i % 2 == 0 } # => 2\n```","summary":"<p>Returns the number of elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L213","def":{"name":"count","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"count = 0\neach do |e|\n  if yield e\n    count = count + 1\n  end\nend\ncount\n"}},{"id":"count(item)-instance-method","html_id":"count(item)-instance-method","name":"count","doc":"Returns the number of times that the passed item is present in the collection.\n\n```\n[1, 2, 3, 4].count(3) # => 1\n```","summary":"<p>Returns the number of times that the passed item is present in the collection.</p>","abstract":false,"args":[{"name":"item","doc":null,"default_value":"","external_name":"item","restriction":""}],"args_string":"(item)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L224","def":{"name":"count","args":[{"name":"item","doc":null,"default_value":"","external_name":"item","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count do |e|\n  e == item\nend"}},{"id":"cycle(n,&block)-instance-method","html_id":"cycle(n,&amp;block)-instance-method","name":"cycle","doc":"Calls the given block for each element in this enumerable *n* times.","summary":"<p>Calls the given block for each element in this enumerable <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L234","def":{"name":"cycle","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"n.times do\n  each do |x|\n    yield x\n  end\nend"}},{"id":"cycle(&block)-instance-method","html_id":"cycle(&amp;block)-instance-method","name":"cycle","doc":"Calls the given block for each element in this enumerable forever.","summary":"<p>Calls the given block for each element in this enumerable forever.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L229","def":{"name":"cycle","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"loop do\n  each do |x|\n    yield x\n  end\nend"}},{"id":"each(&block:T->_)-instance-method","html_id":"each(&amp;block:T-&gt;_)-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":true,"args":[],"args_string":"(&block : T -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L37","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> _)"},"return_type":"","visibility":"Public","body":""}},{"id":"each_cons(count:Int,reuse=false,&block)-instance-method","html_id":"each_cons(count:Int,reuse=false,&amp;block)-instance-method","name":"each_cons","doc":"Iterates over the collection yielding chunks of size *count*,\nbut advancing one by one.\n\n```\n[1, 2, 3, 4, 5].each_cons(2) do |cons|\n  puts cons\nend\n```\n\nPrints:\n\n```text\n[1, 2]\n[2, 3]\n[3, 4]\n[4, 5]\n```\n\nBy default, a new array is created and yielded for each consecutive slice of elements.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Iterates over the collection yielding chunks of size <em>count</em>, but advancing one by one.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L263","def":{"name":"each_cons","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if reuse\n  if reuse.is_a?(Array)\n  else\n    reuse = Array(T).new(count)\n  end\n  cons = reuse\nelse\n  cons = Array(T).new(count)\n  reuse = nil\nend\neach do |elem|\n  cons << elem\n  if cons.size > count\n    cons.shift\n  end\n  if cons.size == count\n    if reuse\n      yield cons\n    else\n      yield cons.dup\n    end\n  end\nend\nnil\n"}},{"id":"each_slice(count:Int,reuse=false,&block)-instance-method","html_id":"each_slice(count:Int,reuse=false,&amp;block)-instance-method","name":"each_slice","doc":"Iterates over the collection in slices of size *count*,\nand runs the block for each of those.\n\n```\n[1, 2, 3, 4, 5].each_slice(2) do |slice|\n  puts slice\nend\n```\n\nPrints:\n\n```text\n[1, 2]\n[3, 4]\n[5]\n```\n\nNote that the last one can be smaller.\n\nBy default, a new array is created and yielded for each slice.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Iterates over the collection in slices of size <em>count</em>, and runs the block for each of those.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L314","def":{"name":"each_slice","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_slice_internal(count, Array(T), reuse) do |slice|\n  yield slice\nend"}},{"id":"each_with_index(offset=0,&block)-instance-method","html_id":"each_with_index(offset=0,&amp;block)-instance-method","name":"each_with_index","doc":"Iterates over the collection, yielding both the elements and their index.\n\n```\n[\"Alice\", \"Bob\"].each_with_index do |user, i|\n  puts \"User ##{i}: #{user}\"\nend\n```\n\nPrints:\n\n```text\nUser # 0: Alice\nUser # 1: Bob\n```\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there. So, a more human friendly version of the previous snippet would be:\n\n```\n[\"Alice\", \"Bob\"].each_with_index(1) do |user, i|\n  puts \"User ##{i}: #{user}\"\nend\n```\n\nWhich would print:\n\n```text\nUser # 1: Alice\nUser # 2: Bob\n```","summary":"<p>Iterates over the collection, yielding both the elements and their index.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = <span class=\"n\">0</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L375","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L375","def":{"name":"each_with_index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"i = offset\neach do |elem|\n  yield elem, i\n  i = i + 1\nend\n"}},{"id":"each_with_object(obj,&block)-instance-method","html_id":"each_with_object(obj,&amp;block)-instance-method","name":"each_with_object","doc":"Iterates over the collection, passing each element and the initial object *obj*.\nReturns that object.\n\n```\nhash = [\"Alice\", \"Bob\"].each_with_object({} of String => Int32) do |user, sizes|\n  sizes[user] = user.size\nend\nhash # => {\"Alice\" => 5, \"Bob\" => 3}\n```","summary":"<p>Iterates over the collection, passing each element and the initial object <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L392","def":{"name":"each_with_object","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |elem|\n  yield elem, obj\nend\nobj\n"}},{"id":"find(if_none=nil,&block)-instance-method","html_id":"find(if_none=nil,&amp;block)-instance-method","name":"find","doc":"Returns the first element in the collection for which the passed block is `true`.\n\nAccepts an optional parameter *if_none*, to set what gets returned if\nno element is found (defaults to `nil`).\n\n```\n[1, 2, 3, 4].find { |i| i > 2 }     # => 3\n[1, 2, 3, 4].find { |i| i > 8 }     # => nil\n[1, 2, 3, 4].find(-1) { |i| i > 8 } # => -1\n```","summary":"<p>Returns the first element in the collection for which the passed block is <code>true</code>.</p>","abstract":false,"args":[{"name":"if_none","doc":null,"default_value":"nil","external_name":"if_none","restriction":""}],"args_string":"(if_none = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L409","def":{"name":"find","args":[{"name":"if_none","doc":null,"default_value":"nil","external_name":"if_none","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |elem|\n  if yield elem\n    return elem\n  end\nend\nif_none\n"}},{"id":"first(count:Int)-instance-method","html_id":"first(count:Int)-instance-method","name":"first","doc":"Returns an `Array` with the first *count* elements in the collection.\n\nIf *count* is bigger than the number of elements in the collection,\nreturns as many as possible. This include the case of calling it over\nan empty collection, in which case it returns an empty array.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the first <em>count</em> elements in the collection.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1245","def":{"name":"first","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Attempt to take negative size\"))\nend\nary = Array(T).new(count)\neach_with_index do |e, i|\n  if i == count\n    break\n  end\n  ary << e\nend\nary\n"}},{"id":"first-instance-method","html_id":"first-instance-method","name":"first","doc":"Returns the first element in the collection. Raises `Enumerable::EmptyError`\nif the collection is empty.","summary":"<p>Returns the first element in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L418","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L418","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |e|\n  return e\nend\nraise(Enumerable::EmptyError.new)\n"}},{"id":"first?-instance-method","html_id":"first?-instance-method","name":"first?","doc":"Returns the first element in the collection.\nWhen the collection is empty, returns `nil`.","summary":"<p>Returns the first element in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L425","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L425","def":{"name":"first?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |e|\n  return e\nend\nnil\n"}},{"id":"flat_map(&block:T->Array(U)|Iterator(U)|U)forallU-instance-method","html_id":"flat_map(&amp;block:T-&gt;Array(U)|Iterator(U)|U)forallU-instance-method","name":"flat_map","doc":"Returns a new array with the concatenated results of running the block\n(which is expected to return arrays) once for every element in the collection.\n\n```\narray = [\"Alice\", \"Bob\"].flat_map do |user|\n  user.chars\nend\narray # => ['A', 'l', 'i', 'c', 'e', 'B', 'o', 'b']\n```","summary":"<p>Returns a new array with the concatenated results of running the block (which is expected to return arrays) once for every element in the collection.</p>","abstract":false,"args":[],"args_string":"(&block : T -> Array(U) | Iterator(U) | U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L439","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L439","def":{"name":"flat_map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> Array(U) | Iterator(U) | U)"},"return_type":"","visibility":"Public","body":"ary = [] of U\neach do |e|\n  case v = yield e\n  when Array, Iterator\n    ary.concat(v)\n  else\n    ary.push(v)\n  end\nend\nary\n"}},{"id":"grep(pattern)-instance-method","html_id":"grep(pattern)-instance-method","name":"grep","doc":"Returns an `Array` with all the elements in the collection that\nmatch the `RegExp` *pattern*.\n\n```\n[\"Alice\", \"Bob\"].grep(/^A/) # => [\"Alice\"]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection that match the <code>RegExp</code> <em>pattern</em>.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L458","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L458","def":{"name":"grep","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.select do |elem|\n  pattern === elem\nend"}},{"id":"group_by(&block:T->U)forallU-instance-method","html_id":"group_by(&amp;block:T-&gt;U)forallU-instance-method","name":"group_by","doc":"Returns a `Hash` whose keys are each different value that the passed block\nreturned when run for each element in the collection, and which values are\nan `Array` of the elements for which the block returned that value.\n\n```\n[\"Alice\", \"Bob\", \"Ary\"].group_by { |name| name.size } # => {5 => [\"Alice\"], 3 => [\"Bob\", \"Ary\"]}\n```","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> whose keys are each different value that the passed block returned when run for each element in the collection, and which values are an <code><a href=\"Array.html\">Array</a></code> of the elements for which the block returned that value.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L469","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L469","def":{"name":"group_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"h = Hash(U, Array(T)).new\neach do |e|\n  v = yield e\n  if h.has_key?(v)\n    h[v].push(e)\n  else\n    h[v] = [e]\n  end\nend\nh\n"}},{"id":"in_groups_of(size:Int,filled_up_with:U=nil)forallU-instance-method","html_id":"in_groups_of(size:Int,filled_up_with:U=nil)forallU-instance-method","name":"in_groups_of","doc":"Returns an `Array` with chunks in the given size, eventually filled up\nwith given value or `nil`.\n\n```\n[1, 2, 3].in_groups_of(2, 0) # => [[1, 2], [3, 0]]\n[1, 2, 3].in_groups_of(2)    # => [[1, 2], [3, nil]]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with chunks in the given size, eventually filled up with given value or <code>nil</code>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":"U"}],"args_string":"(size : Int, filled_up_with : U = <span class=\"n\">nil</span>) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L489","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L489","def":{"name":"in_groups_of","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":"U"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nary = Array(Array(T | U)).new\nin_groups_of(size, filled_up_with) do |group|\n  ary << group\nend\nary\n"}},{"id":"in_groups_of(size:Int,filled_up_with:U=nil,reuse=false,&block)forallU-instance-method","html_id":"in_groups_of(size:Int,filled_up_with:U=nil,reuse=false,&amp;block)forallU-instance-method","name":"in_groups_of","doc":"Yields a block with the chunks in the given size.\n\n```\n[1, 2, 4].in_groups_of(2, 0) { |e| p e.sum }\n# => 3\n# => 4\n```\n\nBy default, a new array is created and yielded for each group.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Yields a block with the chunks in the given size.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":"U"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int, filled_up_with : U = <span class=\"n\">nil</span>, reuse = <span class=\"n\">false</span>, &block) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L514","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L514","def":{"name":"in_groups_of","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":"U"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\neach_slice_internal(size, Array(T | U), reuse) do |slice|\n  (size - slice.size).times do\n    slice << filled_up_with\n  end\n  yield slice\nend\n"}},{"id":"includes?(obj)-instance-method","html_id":"includes?(obj)-instance-method","name":"includes?","doc":"Returns `true` if the collection contains *obj*, `false` otherwise.\n\n```\n[1, 2, 3].includes?(2) # => true\n[1, 2, 3].includes?(5) # => false\n```","summary":"<p>Returns <code>true</code> if the collection contains <em>obj</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L529","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L529","def":{"name":"includes?","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"any? do |e|\n  e == obj\nend"}},{"id":"index(&block)-instance-method","html_id":"index(&amp;block)-instance-method","name":"index","doc":"Returns the index of the first element for which the passed block returns `true`.\n\n```\n[\"Alice\", \"Bob\"].index { |name| name.size < 4 } # => 1 (Bob's index)\n```\n\nReturns `nil` if the block didn't return `true` for any element.","summary":"<p>Returns the index of the first element for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L540","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L540","def":{"name":"index","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_with_index do |e, i|\n  if yield e\n    return i\n  end\nend\nnil\n"}},{"id":"index(obj)-instance-method","html_id":"index(obj)-instance-method","name":"index","doc":"Returns the index of the object *obj* in the collection.\n\n```\n[\"Alice\", \"Bob\"].index(\"Alice\") # => 0\n```\n\nReturns `nil` if *obj* is not in the collection.","summary":"<p>Returns the index of the object <em>obj</em> in the collection.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L554","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L554","def":{"name":"index","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index do |e|\n  e == obj\nend"}},{"id":"index_by(&block:T->U)forallU-instance-method","html_id":"index_by(&amp;block:T-&gt;U)forallU-instance-method","name":"index_by","doc":"Converts an `Enumerable` to a `Hash` by using the value returned by the block\nas the hash key.\nBe aware, if two elements return the same value as a key one will override\nthe other. If you want to keep all values, then you should probably use\n`group_by` instead.\n\n```\n[\"Anna\", \"Ary\", \"Alice\"].index_by { |e| e.size }\n# => {4 => \"Anna\", 3 => \"Ary\", 5 => \"Alice\"}\n[\"Anna\", \"Ary\", \"Alice\", \"Bob\"].index_by { |e| e.size }\n# => {4 => \"Anna\", 3 => \"Bob\", 5 => \"Alice\"}\n```","summary":"<p>Converts an <code><a href=\"Enumerable.html\">Enumerable</a></code> to a <code><a href=\"Hash.html\">Hash</a></code> by using the value returned by the block as the hash key.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L570","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L570","def":{"name":"index_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"hash = {} of U => T\neach do |elem|\n  hash[yield elem] = elem\nend\nhash\n"}},{"id":"join(separator,io)-instance-method","html_id":"join(separator,io)-instance-method","name":"join","doc":"Prints to *io* all the elements in the collection, separated by *separator*.\n\n```\n[1, 2, 3, 4, 5].join(\", \", STDOUT)\n```\n\nPrints:\n\n```text\n1, 2, 3, 4, 5\n```","summary":"<p>Prints to <em>io</em> all the elements in the collection, separated by <em>separator</em>.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(separator, io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L649","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L649","def":{"name":"join","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"join(separator, io) do |elem|\n  elem.to_s(io)\nend"}},{"id":"join(separator=&quot;&quot;)-instance-method","html_id":"join(separator=&amp;quot;&amp;quot;)-instance-method","name":"join","doc":"Returns a `String` created by concatenating the elements in the collection,\nseparated by *separator* (defaults to none).\n\n```\n[1, 2, 3, 4, 5].join(\", \") # => \"1, 2, 3, 4, 5\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> created by concatenating the elements in the collection, separated by <em>separator</em> (defaults to none).</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(separator = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L618","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L618","def":{"name":"join","args":[{"name":"separator","doc":null,"default_value":"\"\"","external_name":"separator","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  join(separator, io)\nend"}},{"id":"join(separator,io,&block)-instance-method","html_id":"join(separator,io,&amp;block)-instance-method","name":"join","doc":"Prints to *io* the concatenation of the elements, with the possibility of\ncontrolling how the printing is done via a block.\n\n```\n[1, 2, 3, 4, 5].join(\", \", STDOUT) { |i, io| io << \"(#{i})\" }\n```\n\nPrints:\n\n```text\n(1), (2), (3), (4), (5)\n```","summary":"<p>Prints to <em>io</em> the concatenation of the elements, with the possibility of controlling how the printing is done via a block.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(separator, io, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L667","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L667","def":{"name":"join","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"each_with_index do |elem, i|\n  if i > 0\n    io << separator\n  end\n  yield elem, io\nend"}},{"id":"join(separator=&quot;&quot;,&block)-instance-method","html_id":"join(separator=&amp;quot;&amp;quot;,&amp;block)-instance-method","name":"join","doc":"Returns a `String` created by concatenating the results of passing the elements\nin the collection to the passed block, separated by *separator* (defaults to none).\n\n```\n[1, 2, 3, 4, 5].join(\", \") { |i| -i } # => \"-1, -2, -3, -4, -5\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> created by concatenating the results of passing the elements in the collection to the passed block, separated by <em>separator</em> (defaults to none).</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(separator = <span class=\"s\">&quot;&quot;</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L630","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L630","def":{"name":"join","args":[{"name":"separator","doc":null,"default_value":"\"\"","external_name":"separator","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  join(separator, io) do |elem|\n    io << (yield elem)\n  end\nend"}},{"id":"map(&block:T->U)forallU-instance-method","html_id":"map(&amp;block:T-&gt;U)forallU-instance-method","name":"map","doc":"Returns an `Array` with the results of running the block against each element of the collection.\n\n```\n[1, 2, 3].map { |i| i * 10 } # => [10, 20, 30]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the results of running the block against each element of the collection.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L679","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L679","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"ary = [] of U\neach do |e|\n  ary << (yield e)\nend\nary\n"}},{"id":"map_with_index(&block:T,Int32->U)forallU-instance-method","html_id":"map_with_index(&amp;block:T,Int32-&gt;U)forallU-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\n```\n[\"Alice\", \"Bob\"].map_with_index { |name, i| \"User ##{i}: #{name}\" }\n# => [\"User #0: Alice\", \"User #1: Bob\"]\n```","summary":"<p>Like <code><a href=\"Enumerable.html#map%28%26block%3AT-%3EU%29forallU-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L691","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L691","def":{"name":"map_with_index","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> U)"},"return_type":"","visibility":"Public","body":"ary = [] of U\neach_with_index do |e, i|\n  ary << (yield e, i)\nend\nary\n"}},{"id":"max-instance-method","html_id":"max-instance-method","name":"max","doc":"Returns the element with the maximum value in the collection.\n\nIt compares using `>` so it will work for any type that supports that method.\n\n```\n[1, 2, 3].max        # => 3\n[\"Alice\", \"Bob\"].max # => \"Bob\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element with the maximum value in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L707","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L707","def":{"name":"max","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"max_by(&.itself)"}},{"id":"max?-instance-method","html_id":"max?-instance-method","name":"max?","doc":"Like `max` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max-instance-method\">#max</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L712","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L712","def":{"name":"max?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"max_by?(&.itself)"}},{"id":"max_by(&block:T->U)forallU-instance-method","html_id":"max_by(&amp;block:T-&gt;U)forallU-instance-method","name":"max_by","doc":"Returns the element for which the passed block returns with the maximum value.\n\nIt compares using `>` so the block must return a type that supports that method\n\n```\n[\"Alice\", \"Bob\"].max_by { |name| name.size } # => \"Alice\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element for which the passed block returns with the maximum value.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L725","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L725","def":{"name":"max_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = max_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"max_by?(&block:T->U)forallU-instance-method","html_id":"max_by?(&amp;block:T-&gt;U)forallU-instance-method","name":"max_by?","doc":"Like `max_by` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max_by%28%26block%3AT-%3EU%29forallU-instance-method\">#max_by</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L732","def":{"name":"max_by?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = max_by_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"id":"max_of(&block:T->U)forallU-instance-method","html_id":"max_of(&amp;block:T-&gt;U)forallU-instance-method","name":"max_of","doc":"Like `max_by` but instead of the element, returns the value returned by the block.\n\n```\n[\"Alice\", \"Bob\"].max_of { |name| name.size } # => 5 (Alice's size)\n```","summary":"<p>Like <code><a href=\"Enumerable.html#max_by%28%26block%3AT-%3EU%29forallU-instance-method\">#max_by</a></code> but instead of the element, returns the value returned by the block.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L759","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L759","def":{"name":"max_of","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = max_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"max_of?(&block:T->U)forallU-instance-method","html_id":"max_of?(&amp;block:T-&gt;U)forallU-instance-method","name":"max_of?","doc":"Like `max_of` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max_of%28%26block%3AT-%3EU%29forallU-instance-method\">#max_of</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L766","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L766","def":{"name":"max_of?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = max_of_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"id":"min-instance-method","html_id":"min-instance-method","name":"min","doc":"Returns the element with the minimum value in the collection.\n\nIt compares using `<` so it will work for any type that supports that method.\n\n```\n[1, 2, 3].min        # => 1\n[\"Alice\", \"Bob\"].min # => \"Alice\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element with the minimum value in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L796","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L796","def":{"name":"min","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"min_by(&.itself)"}},{"id":"min?-instance-method","html_id":"min?-instance-method","name":"min?","doc":"Like `min` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min-instance-method\">#min</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L801","def":{"name":"min?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"min_by?(&.itself)"}},{"id":"min_by(&block:T->U)forallU-instance-method","html_id":"min_by(&amp;block:T-&gt;U)forallU-instance-method","name":"min_by","doc":"Returns the element for which the passed block returns with the minimum value.\n\nIt compares using `<` so the block must return a type that supports that method\n\n```\n[\"Alice\", \"Bob\"].min_by { |name| name.size } # => \"Bob\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element for which the passed block returns with the minimum value.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L814","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L814","def":{"name":"min_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = min_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"min_by?(&block:T->U)forallU-instance-method","html_id":"min_by?(&amp;block:T-&gt;U)forallU-instance-method","name":"min_by?","doc":"Like `min_by` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min_by%28%26block%3AT-%3EU%29forallU-instance-method\">#min_by</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L821","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L821","def":{"name":"min_by?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = min_by_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"id":"min_of(&block:T->U)forallU-instance-method","html_id":"min_of(&amp;block:T-&gt;U)forallU-instance-method","name":"min_of","doc":"Like `min_by` but instead of the element, returns the value returned by the block.\n\n```\n[\"Alice\", \"Bob\"].min_of { |name| name.size } # => 3 (Bob's size)\n```","summary":"<p>Like <code><a href=\"Enumerable.html#min_by%28%26block%3AT-%3EU%29forallU-instance-method\">#min_by</a></code> but instead of the element, returns the value returned by the block.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L848","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L848","def":{"name":"min_of","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = min_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"min_of?(&block:T->U)forallU-instance-method","html_id":"min_of?(&amp;block:T-&gt;U)forallU-instance-method","name":"min_of?","doc":"Like `min_of` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min_of%28%26block%3AT-%3EU%29forallU-instance-method\">#min_of</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L855","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L855","def":{"name":"min_of?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = min_of_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"id":"minmax-instance-method","html_id":"minmax-instance-method","name":"minmax","doc":"Returns a `Tuple` with both the minimum and maximum value.\n\n```\n[1, 2, 3].minmax # => {1, 3}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L882","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L882","def":{"name":"minmax","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"minmax_by(&.itself)"}},{"id":"minmax?-instance-method","html_id":"minmax?-instance-method","name":"minmax?","doc":"Like `minmax` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax-instance-method\">#minmax</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L887","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L887","def":{"name":"minmax?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"minmax_by?(&.itself)"}},{"id":"minmax_by(&block:T->U)forallU-instance-method","html_id":"minmax_by(&amp;block:T-&gt;U)forallU-instance-method","name":"minmax_by","doc":"Returns a `Tuple` with both the minimum and maximum values according to the passed block.\n\n```\n[\"Alice\", \"Bob\", \"Carl\"].minmax_by { |name| name.size } # => {\"Bob\", \"Alice\"}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum values according to the passed block.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L898","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L898","def":{"name":"minmax_by","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = minmax_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"minmax_by?(&block:T->U)forallU-instance-method","html_id":"minmax_by?(&amp;block:T-&gt;U)forallU-instance-method","name":"minmax_by?","doc":"Like `minmax_by` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax_by%28%26block%3AT-%3EU%29forallU-instance-method\">#minmax_by</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L905","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L905","def":{"name":"minmax_by?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = minmax_by_internal do |value|\n  yield value\nend\nfound ? value : {nil, nil}\n"}},{"id":"minmax_of(&block:T->U)forallU-instance-method","html_id":"minmax_of(&amp;block:T-&gt;U)forallU-instance-method","name":"minmax_of","doc":"Returns a `Tuple` with both the minimum and maximum value\nthe block returns when passed the elements in the collection.\n\n```\n[\"Alice\", \"Bob\", \"Carl\"].minmax_of { |name| name.size } # => {3, 5}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum value the block returns when passed the elements in the collection.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L941","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L941","def":{"name":"minmax_of","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = minmax_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"id":"minmax_of?(&block:T->U)forallU-instance-method","html_id":"minmax_of?(&amp;block:T-&gt;U)forallU-instance-method","name":"minmax_of?","doc":"Like `minmax_of` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax_of%28%26block%3AT-%3EU%29forallU-instance-method\">#minmax_of</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L948","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L948","def":{"name":"minmax_of?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"found, value = minmax_of_internal do |value|\n  yield value\nend\nfound ? value : {nil, nil}\n"}},{"id":"none?(&block)-instance-method","html_id":"none?(&amp;block)-instance-method","name":"none?","doc":"Returns `true` if the passed block returns `true`\nfor none of the elements of the collection.\n\n```\n[1, 2, 3].none? { |i| i > 5 } # => true\n```\n\nIt's the opposite of `all?`.","summary":"<p>Returns <code>true</code> if the passed block returns <code>true</code> for none of the elements of the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L980","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L980","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |e|\n  if yield e\n    return false\n  end\nend\ntrue\n"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":"Returns `true` if all of the elements of the collection are `false` or `nil`.\n\n```\n[nil, false].none?       # => true\n[nil, false, true].none? # => false\n```\n\nIt's the opposite of `all?`.","summary":"<p>Returns <code>true</code> if all of the elements of the collection are <code>false</code> or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L993","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L993","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"none?(&.itself)"}},{"id":"one?(&block)-instance-method","html_id":"one?(&amp;block)-instance-method","name":"one?","doc":"Returns `true` if the passed block returns `true`\nfor exactly one of the elements of the collection.\n\n```\n[1, 2, 3].one? { |i| i > 2 } # => true\n[1, 2, 3].one? { |i| i > 1 } # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns <code>true</code> for exactly one of the elements of the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1004","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1004","def":{"name":"one?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"c = 0\neach do |e|\n  if yield e\n    c = c + 1\n  end\n  if c > 1\n    return false\n  end\nend\nc == 1\n"}},{"id":"partition(&block)-instance-method","html_id":"partition(&amp;block)-instance-method","name":"partition","doc":"Returns a `Tuple` with two arrays. The first one contains the elements\nin the collection for which the passed block returned `true`,\nand the second one those for which it returned `false`.\n\n```\n[1, 2, 3, 4, 5, 6].partition { |i| i % 2 == 0 } # => {[2, 4, 6], [1, 3, 5]}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with two arrays.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1020","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1020","def":{"name":"partition","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"a, b = [] of T, [] of T\neach do |e|\n  value = yield e\n  value ? a.push(e) : b.push(e)\nend\n{a, b}\n"}},{"id":"product(&block)-instance-method","html_id":"product(&amp;block)-instance-method","name":"product","doc":"Multiplies all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].product { |name| name.size } # => 15 (5 * 3)\n```\n\nIf the collection is empty, returns `1`.\n\n```\n([] of Int32).product { |x| x + 1 } # => 1\n```","summary":"<p>Multiplies all results of the passed block for each element in the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1218","def":{"name":"product","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"product(Reflect(typeof(yield first)).first.zero + 1) do |value|\n  yield value\nend"}},{"id":"product(initial:Number,&block)-instance-method","html_id":"product(initial:Number,&amp;block)-instance-method","name":"product","doc":"Multiplies *initial* and all results of the passed block for each element\nin the collection.\n\n```\n[\"Alice\", \"Bob\"].product(2) { |name| name.size } # => 30 (2 * 5 * 3)\n```\n\nIf the collection is empty, returns `1`.\n\n```\n([] of String).product(1) { |name| name.size } # => 1\n```","summary":"<p>Multiplies <em>initial</em> and all results of the passed block for each element in the collection.</p>","abstract":false,"args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":"Number"}],"args_string":"(initial : Number, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1236","def":{"name":"product","args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reduce(initial) do |memo, e|\n  memo * (yield e)\nend"}},{"id":"product-instance-method","html_id":"product-instance-method","name":"product","doc":"Multiplies all the elements in the collection together.\n\nOnly collections of numbers (objects that can be multiplied via a `*` method)\nare supported.\n\n```\n[1, 2, 3, 4, 5, 6].product # => 720\n```\n\nIf the collection is empty, returns `1`.\n\n```\n([] of Int32).product # => 1\n```","summary":"<p>Multiplies all the elements in the collection together.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1182","def":{"name":"product","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"product(Reflect(T).first.zero + 1)"}},{"id":"product(initial:Number)-instance-method","html_id":"product(initial:Number)-instance-method","name":"product","doc":"Multiplies *initial* and all the elements in the collection\ntogether.  The type of *initial* will be the type of the product,\nso use this if (for instance) you need to specify a large enough\ntype to avoid overflow.\n\nOnly collections of numbers (objects that can be multiplied via a `*` method)\nare supported.\n\n```\n[1, 2, 3, 4, 5, 6].product(7) # => 5040\n```\n\nIf the collection is empty, returns *initial*.\n\n```\n([] of Int32).product(7) # => 7\n```","summary":"<p>Multiplies <em>initial</em> and all the elements in the collection together.</p>","abstract":false,"args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":"Number"}],"args_string":"(initial : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1203","def":{"name":"product","args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"product(initial, &.itself)"}},{"id":"reduce(&block)-instance-method","html_id":"reduce(&amp;block)-instance-method","name":"reduce","doc":"Combines all elements in the collection by applying a binary operation, specified by a block, so as\nto reduce them to a single value.\n\nFor each element in the collection the block is passed an accumulator value (*memo*) and the element. The\nresult becomes the new value for *memo*. At the end of the iteration, the final value of *memo* is\nthe return value for the method. The initial value for the accumulator is the first element in the collection.\n\n```\n[1, 2, 3, 4, 5].reduce { |acc, i| acc + i } # => 15\n```","summary":"<p>Combines all elements in the collection by applying a binary operation, specified by a block, so as to reduce them to a single value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L588","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L588","def":{"name":"reduce","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"memo = uninitialized T\nfound = false\neach do |elem|\n  memo = found ? (  yield memo, elem) : elem\n  found = true\nend\nfound ? memo : raise(Enumerable::EmptyError.new)\n"}},{"id":"reduce(memo,&block)-instance-method","html_id":"reduce(memo,&amp;block)-instance-method","name":"reduce","doc":"Just like the other variant, but you can set the initial value of the accumulator.\n\n```\n[1, 2, 3, 4, 5].reduce(10) { |acc, i| acc + i } # => 25\n```","summary":"<p>Just like the other variant, but you can set the initial value of the accumulator.</p>","abstract":false,"args":[{"name":"memo","doc":null,"default_value":"","external_name":"memo","restriction":""}],"args_string":"(memo, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L605","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L605","def":{"name":"reduce","args":[{"name":"memo","doc":null,"default_value":"","external_name":"memo","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |elem|\n  memo = yield memo, elem\nend\nmemo\n"}},{"id":"reject(&block:T->)-instance-method","html_id":"reject(&amp;block:T-&gt;)-instance-method","name":"reject","doc":"Returns an `Array` with all the elements in the collection for which\nthe passed block returns `false`.\n\n```\n[1, 2, 3, 4, 5, 6].reject { |i| i % 2 == 0 } # => [1, 3, 5]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which the passed block returns <code>false</code>.</p>","abstract":false,"args":[],"args_string":"(&block : T -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1035","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1035","def":{"name":"reject","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> )"},"return_type":"","visibility":"Public","body":"ary = [] of T\neach do |e|\n  if yield e\n  else\n    ary << e\n  end\nend\nary\n"}},{"id":"select(&block:T->)-instance-method","html_id":"select(&amp;block:T-&gt;)-instance-method","name":"select","doc":"Returns an `Array` with all the elements in the collection for which\nthe passed block returns `true`.\n\n```\n[1, 2, 3, 4, 5, 6].select { |i| i % 2 == 0 } # => [2, 4, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block : T -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1047","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1047","def":{"name":"select","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> )"},"return_type":"","visibility":"Public","body":"ary = [] of T\neach do |e|\n  if yield e\n    ary << e\n  end\nend\nary\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in the collection.\n\n```\n[1, 2, 3, 4].size # => 4\n```","summary":"<p>Returns the number of elements in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1058","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1058","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count do\n  true\nend"}},{"id":"skip(count:Int)-instance-method","html_id":"skip(count:Int)-instance-method","name":"skip","doc":"Returns an `Array` with the first *count* elements removed\nfrom the original collection.\n\nIf *count* is bigger than the number of elements in the collection, returns an empty array.\n\n```\n[1, 2, 3, 4, 5, 6].skip(3) # => [4, 5, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the first <em>count</em> elements removed from the original collection.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1070","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1070","def":{"name":"skip","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Attempt to skip negative size\"))\nend\narray = Array(T).new\neach_with_index do |e, i|\n  if i >= count\n    array << e\n  end\nend\narray\n"}},{"id":"skip_while(&block)-instance-method","html_id":"skip_while(&amp;block)-instance-method","name":"skip_while","doc":"Skips elements up to, but not including, the first element for which\nthe block returns `nil` or `false` and returns an `Array`\ncontaining the remaining elements.\n\n```\n[1, 2, 3, 4, 5, 0].skip_while { |i| i < 3 } # => [3, 4, 5, 0]\n```","summary":"<p>Skips elements up to, but not including, the first element for which the block returns <code>nil</code> or <code>false</code> and returns an <code><a href=\"Array.html\">Array</a></code> containing the remaining elements.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1087","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1087","def":{"name":"skip_while","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"result = Array(T).new\nblock_returned_false = false\neach do |x|\n  if block_returned_false || (yield x)\n  else\n    block_returned_false = true\n  end\n  if block_returned_false\n    result << x\n  end\nend\nresult\n"}},{"id":"sum(initial)-instance-method","html_id":"sum(initial)-instance-method","name":"sum","doc":"Adds *initial* and all the elements in the collection together.\nThe type of *initial* will be the type of the sum, so use this if\n(for instance) you need to specify a large enough type to avoid\noverflow.\n\nOnly collections of numbers (objects that can be added via an `+` method)\nare supported.\n\n```\n[1, 2, 3, 4, 5, 6].sum(7) # => 28\n```\n\nIf the collection is empty, returns *initial*.\n\n```\n([] of Int32).sum(7) # => 7\n```","summary":"<p>Adds <em>initial</em> and all the elements in the collection together.</p>","abstract":false,"args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"args_string":"(initial)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1132","def":{"name":"sum","args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sum(initial, &.itself)"}},{"id":"sum-instance-method","html_id":"sum-instance-method","name":"sum","doc":"Adds all the elements in the collection together.\n\nOnly collections of numbers (objects that can be added via an `+` method)\nare supported.\n\n```\n[1, 2, 3, 4, 5, 6].sum # => 21\n```\n\nIf the collection is empty, returns `0`.\n\n```\n([] of Int32).sum # => 0\n```","summary":"<p>Adds all the elements in the collection together.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1111","def":{"name":"sum","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sum(Reflect(T).first.zero)"}},{"id":"sum(initial,&block)-instance-method","html_id":"sum(initial,&amp;block)-instance-method","name":"sum","doc":"Adds *initial* and all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].sum(1) { |name| name.size } # => 9 (1 + 5 + 3)\n```\n\nIf the collection is empty, returns `0`.\n\n```\n([] of String).sum(1) { |name| name.size } # => 1\n```","summary":"<p>Adds <em>initial</em> and all results of the passed block for each element in the collection.</p>","abstract":false,"args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"args_string":"(initial, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1164","def":{"name":"sum","args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reduce(initial) do |memo, e|\n  memo + (yield e)\nend"}},{"id":"sum(&block)-instance-method","html_id":"sum(&amp;block)-instance-method","name":"sum","doc":"Adds all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].sum { |name| name.size } # => 8 (5 + 3)\n```\n\nIf the collection is empty, returns `0`.\n\n```\n([] of Int32).sum { |x| x + 1 } # => 0\n```","summary":"<p>Adds all results of the passed block for each element in the collection.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1147","def":{"name":"sum","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sum(Reflect(typeof(yield first)).first.zero) do |value|\n  yield value\nend"}},{"id":"take_while(&block)-instance-method","html_id":"take_while(&amp;block)-instance-method","name":"take_while","doc":"Passes elements to the block until the block returns `nil` or `false`,\nthen stops iterating and returns an `Array` of all prior elements.\n\n```\n[1, 2, 3, 4, 5, 0].take_while { |i| i < 3 } # => [1, 2]\n```","summary":"<p>Passes elements to the block until the block returns <code>nil</code> or <code>false</code>, then stops iterating and returns an <code><a href=\"Array.html\">Array</a></code> of all prior elements.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1262","def":{"name":"take_while","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"result = Array(T).new\neach do |x|\n  if yield x\n  else\n    break\n  end\n  result << x\nend\nresult\n"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n(1..5).to_a # => [1, 2, 3, 4, 5]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1276","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = [] of T\neach do |e|\n  ary << e\nend\nary\n"}},{"id":"to_h-instance-method","html_id":"to_h-instance-method","name":"to_h","doc":"Creates a `Hash` out of an Enumerable where each element is a\n2 element structure (for instance a `Tuple` or an `Array`).\n\n```\n[[:a, :b], [:c, :d]].to_h        # => {:a => :b, :c => :d}\nTuple.new({:a, 1}, {:c, 2}).to_h # => {:a => 1, :c => 2}\n```","summary":"<p>Creates a <code><a href=\"Hash.html\">Hash</a></code> out of an Enumerable where each element is a 2 element structure (for instance a <code><a href=\"Tuple.html\">Tuple</a></code> or an <code><a href=\"Array.html\">Array</a></code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L1289","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_with_object(Hash(typeof(first[0]), typeof(first[1])).new) do |item, hash|\n  hash[item[0]] = item[1]\nend"}},{"id":"to_set-instance-method","html_id":"to_set-instance-method","name":"to_set","doc":"Returns a new `Set` with each unique element in the enumerable.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with each unique element in the enumerable.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L426","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L426","def":{"name":"to_set","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Set.new(self)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Enumerable/EmptyError","path":"Enumerable/EmptyError.html","kind":"class","full_name":"Enumerable::EmptyError","name":"EmptyError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"enumerable.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable(T)","name":"Enumerable"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(message=&quot;Emptyenumerable&quot;)-class-method","html_id":"new(message=&amp;quot;Emptyenumerable&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Empty enumerable\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Empty enumerable&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/enumerable.cr#L31","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Empty enumerable\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/ENV","path":"ENV.html","kind":"module","full_name":"ENV","name":"ENV","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"env.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"subclasses":[],"including_types":[],"namespace":null,"doc":"`ENV` is a hash-like accessor for environment variables.\n\n### Example\n\n```\n# Set env var PORT to a default if not already set\nENV[\"PORT\"] ||= \"5000\"\n# Later use that env var.\nputs ENV[\"PORT\"].to_i\n```\n\nNOTE: All keys and values are strings. You must take care to cast other types\nat runtime, e.g. integer port numbers.","summary":"<p><code><a href=\"ENV.html\">ENV</a></code> is a hash-like accessor for environment variables.</p>","class_methods":[{"id":"[](key:String):String-class-method","html_id":"[](key:String):String-class-method","name":"[]","doc":"Retrieves the value for environment variable named *key* as a `String`.\nRaises `KeyError` if the named variable does not exist.","summary":"<p>Retrieves the value for environment variable named <em>key</em> as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L21","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"fetch(key)"}},{"id":"[]=(key:String,value:String?)-class-method","html_id":"[]=(key:String,value:String?)-class-method","name":"[]=","doc":"Sets the value for environment variable named *key* as *value*.\nOverwrites existing environment variable if already present.\nReturns *value* if successful, otherwise raises an exception.\nIf *value* is `nil`, the environment variable is deleted.\n\nIf *key* or *value* contains a null-byte an `ArgumentError` is raised.","summary":"<p>Sets the value for environment variable named <em>key</em> as <em>value</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String | ::Nil"}],"args_string":"(key : String, value : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L37","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if key.byte_index(0)\n  raise(ArgumentError.new(\"Key contains null byte\"))\nend\nif value\n  if value.byte_index(0)\n    raise(ArgumentError.new(\"Value contains null byte\"))\n  end\n  if (LibC.setenv(key, value, 1)) != 0\n    raise(Errno.new(\"Error setting environment variable #{key.inspect}\"))\n  end\nelse\n  LibC.unsetenv(key)\nend\nvalue\n"}},{"id":"[]?(key:String):String?-class-method","html_id":"[]?(key:String):String?-class-method","name":"[]?","doc":"Retrieves the value for environment variable named *key* as a `String?`.\nReturns `nil` if the named variable does not exist.","summary":"<p>Retrieves the value for environment variable named <em>key</em> as a <code><a href=\"String.html\">String</a>?</code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L27","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"fetch(key, nil)"}},{"id":"clear-class-method","html_id":"clear-class-method","name":"clear","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L129","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"keys.each do |k|\n  delete(k)\nend"}},{"id":"delete(key:String):String?-class-method","html_id":"delete(key:String):String?-class-method","name":"delete","doc":"Removes the environment variable named *key*. Returns the previous value if\nthe environment variable existed, otherwise returns `nil`.","summary":"<p>Removes the environment variable named <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L96","def":{"name":"delete","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"if value = self[key]?\n  LibC.unsetenv(key)\n  value\nelse\n  nil\nend"}},{"id":"each(&block)-class-method","html_id":"each(&amp;block)-class-method","name":"each","doc":"Iterates over all `KEY=VALUE` pairs of environment variables, yielding both\nthe *key* and *value*.\n\n```\nENV.each do |key, value|\n  puts \"#{key} => #{value}\"\nend\n```","summary":"<p>Iterates over all <code>KEY=VALUE</code> pairs of environment variables, yielding both the <em>key</em> and <em>value</em>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L113","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"environ_ptr = LibC.environ\nwhile environ_ptr\n  environ_value = environ_ptr.value\n  if environ_value\n    key_value = (String.new(environ_value)).split('=', 2)\n    key = key_value[0]\n    value = key_value[1]? || \"\"\n    yield {key, value}\n    environ_ptr = environ_ptr + 1\n  else\n    break\n  end\nend\n"}},{"id":"fetch(key,default)-class-method","html_id":"fetch(key,default)-class-method","name":"fetch","doc":"Retrieves a value corresponding to the given *key*. Return the second argument's value\nif the *key* does not exist.","summary":"<p>Retrieves a value corresponding to the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"args_string":"(key, default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L68","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key) do\n  default\nend"}},{"id":"fetch(key):String-class-method","html_id":"fetch(key):String-class-method","name":"fetch","doc":"Retrieves a value corresponding to the given *key*. Raises a `KeyError` exception if the\nkey does not exist.","summary":"<p>Retrieves a value corresponding to the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L60","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"fetch(key) do\n  raise(KeyError.new(\"Missing ENV key: #{key.inspect}\"))\nend"}},{"id":"fetch(key:String,&block:String->String?)-class-method","html_id":"fetch(key:String,&amp;block:String-&gt;String?)-class-method","name":"fetch","doc":"Retrieves a value corresponding to a given *key*. Return the value of the block if\nthe *key* does not exist.","summary":"<p>Retrieves a value corresponding to a given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String, &block : String -> String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L74","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> String | ::Nil)"},"return_type":"","visibility":"Public","body":"value = LibC.getenv(key)\nif value\n  return String.new(value)\nend\nyield key\n"}},{"id":"has_key?(key:String):Bool-class-method","html_id":"has_key?(key:String):Bool-class-method","name":"has_key?","doc":"Returns `true` if the environment variable named *key* exists and `false`\nif it doesn't.","summary":"<p>Returns <code>true</code> if the environment variable named <em>key</em> exists and <code>false</code> if it doesn't.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L54","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"!(!(LibC.getenv(key)))"}},{"id":"inspect(io)-class-method","html_id":"inspect(io)-class-method","name":"inspect","doc":"Writes the contents of the environment to *io*.","summary":"<p>Writes the contents of the environment to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L134","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '{'\nfound_one = false\neach do |key, value|\n  if found_one\n    io << \", \"\n  end\n  key.inspect(io)\n  io << \" => \"\n  value.inspect(io)\n  found_one = true\nend\nio << '}'\n"}},{"id":"keys:Array(String)-class-method","html_id":"keys:Array(String)-class-method","name":"keys","doc":"Returns an array of all the environment variable names.","summary":"<p>Returns an array of all the environment variable names.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L81","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"keys = [] of String\neach do |key, v|\n  keys << key\nend\nkeys\n"}},{"id":"pretty_print(pp)-class-method","html_id":"pretty_print(pp)-class-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L147","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.list(\"{\", keys.sort, \"}\") do |key|\n  pp.group do\n    key.pretty_print(pp)\n    pp.text(\" =>\")\n    pp.nest do\n      pp.breakable\n      self[key].pretty_print(pp)\n    end\n  end\nend"}},{"id":"values:Array(String)-class-method","html_id":"values:Array(String)-class-method","name":"values","doc":"Returns an array of all the environment variable values.","summary":"<p>Returns an array of all the environment variable values.</p>","abstract":false,"args":[],"args_string":" : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/env.cr#L88","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"values = [] of String\neach do |k, value|\n  values << value\nend\nvalues\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Errno","path":"Errno.html","kind":"class","full_name":"Errno","name":"Errno","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"errno.cr","line_number":26,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"E2BIG","name":"E2BIG","value":"LibC::E2BIG","doc":"Argument list too long","summary":"<p>Argument list too long</p>"},{"id":"EACCES","name":"EACCES","value":"LibC::EACCES","doc":"Permission denied","summary":"<p>Permission denied</p>"},{"id":"EADDRINUSE","name":"EADDRINUSE","value":"LibC::EADDRINUSE","doc":"Address already in use","summary":"<p>Address already in use</p>"},{"id":"EADDRNOTAVAIL","name":"EADDRNOTAVAIL","value":"LibC::EADDRNOTAVAIL","doc":"Can't assign requested address","summary":"<p>Can't assign requested address</p>"},{"id":"EAFNOSUPPORT","name":"EAFNOSUPPORT","value":"LibC::EAFNOSUPPORT","doc":"Address family not supported by protocol family","summary":"<p>Address family not supported by protocol family</p>"},{"id":"EAGAIN","name":"EAGAIN","value":"LibC::EAGAIN","doc":"Resource temporarily unavailable","summary":"<p>Resource temporarily unavailable</p>"},{"id":"EALREADY","name":"EALREADY","value":"LibC::EALREADY","doc":"Operation already in progress","summary":"<p>Operation already in progress</p>"},{"id":"EBADF","name":"EBADF","value":"LibC::EBADF","doc":"Bad file descriptor","summary":"<p>Bad file descriptor</p>"},{"id":"EBADMSG","name":"EBADMSG","value":"LibC::EBADMSG","doc":"Bad message","summary":"<p>Bad message</p>"},{"id":"EBUSY","name":"EBUSY","value":"LibC::EBUSY","doc":"Device / Resource busy","summary":"<p>Device / Resource busy</p>"},{"id":"ECANCELED","name":"ECANCELED","value":"LibC::ECANCELED","doc":"Operation canceled","summary":"<p>Operation canceled</p>"},{"id":"ECHILD","name":"ECHILD","value":"LibC::ECHILD","doc":"No child processes","summary":"<p>No child processes</p>"},{"id":"ECONNABORTED","name":"ECONNABORTED","value":"LibC::ECONNABORTED","doc":"Software caused connection abort","summary":"<p>Software caused connection abort</p>"},{"id":"ECONNREFUSED","name":"ECONNREFUSED","value":"LibC::ECONNREFUSED","doc":"Connection refused","summary":"<p>Connection refused</p>"},{"id":"ECONNRESET","name":"ECONNRESET","value":"LibC::ECONNRESET","doc":"Connection reset by peer","summary":"<p>Connection reset by peer</p>"},{"id":"EDEADLK","name":"EDEADLK","value":"LibC::EDEADLK","doc":"Resource deadlock avoided","summary":"<p>Resource deadlock avoided</p>"},{"id":"EDESTADDRREQ","name":"EDESTADDRREQ","value":"LibC::EDESTADDRREQ","doc":"Destination address required","summary":"<p>Destination address required</p>"},{"id":"EDOM","name":"EDOM","value":"LibC::EDOM","doc":"Numerical argument out of domain","summary":"<p>Numerical argument out of domain</p>"},{"id":"EDQUOT","name":"EDQUOT","value":"LibC::EDQUOT","doc":"Disc quota exceeded","summary":"<p>Disc quota exceeded</p>"},{"id":"EEXIST","name":"EEXIST","value":"LibC::EEXIST","doc":"File exists","summary":"<p>File exists</p>"},{"id":"EFAULT","name":"EFAULT","value":"LibC::EFAULT","doc":"Bad address","summary":"<p>Bad address</p>"},{"id":"EFBIG","name":"EFBIG","value":"LibC::EFBIG","doc":"File too large","summary":"<p>File too large</p>"},{"id":"EHOSTDOWN","name":"EHOSTDOWN","value":"LibC::EHOSTDOWN","doc":"Host is down","summary":"<p>Host is down</p>"},{"id":"EHOSTUNREACH","name":"EHOSTUNREACH","value":"LibC::EHOSTUNREACH","doc":"No route to host","summary":"<p>No route to host</p>"},{"id":"EIDRM","name":"EIDRM","value":"LibC::EIDRM","doc":"Identifier removed","summary":"<p>Identifier removed</p>"},{"id":"EILSEQ","name":"EILSEQ","value":"LibC::EILSEQ","doc":"Illegal byte sequence","summary":"<p>Illegal byte sequence</p>"},{"id":"EINPROGRESS","name":"EINPROGRESS","value":"LibC::EINPROGRESS","doc":"Operation now in progress","summary":"<p>Operation now in progress</p>"},{"id":"EINTR","name":"EINTR","value":"LibC::EINTR","doc":"Interrupted system call","summary":"<p>Interrupted system call</p>"},{"id":"EINVAL","name":"EINVAL","value":"LibC::EINVAL","doc":"Invalid argument","summary":"<p>Invalid argument</p>"},{"id":"EIO","name":"EIO","value":"LibC::EIO","doc":"Input/output error","summary":"<p>Input/output error</p>"},{"id":"EISCONN","name":"EISCONN","value":"LibC::EISCONN","doc":"Socket is already connected","summary":"<p>Socket is already connected</p>"},{"id":"EISDIR","name":"EISDIR","value":"LibC::EISDIR","doc":"Is a directory","summary":"<p>Is a directory</p>"},{"id":"ELOOP","name":"ELOOP","value":"LibC::ELOOP","doc":"Too many levels of symbolic links","summary":"<p>Too many levels of symbolic links</p>"},{"id":"EMFILE","name":"EMFILE","value":"LibC::EMFILE","doc":"Too many open files","summary":"<p>Too many open files</p>"},{"id":"EMLINK","name":"EMLINK","value":"LibC::EMLINK","doc":"Too many links","summary":"<p>Too many links</p>"},{"id":"EMSGSIZE","name":"EMSGSIZE","value":"LibC::EMSGSIZE","doc":"Message too long","summary":"<p>Message too long</p>"},{"id":"EMULTIHOP","name":"EMULTIHOP","value":"LibC::EMULTIHOP","doc":"Reserved","summary":"<p>Reserved</p>"},{"id":"ENAMETOOLONG","name":"ENAMETOOLONG","value":"LibC::ENAMETOOLONG","doc":"File name too long","summary":"<p>File name too long</p>"},{"id":"ENETDOWN","name":"ENETDOWN","value":"LibC::ENETDOWN","doc":"Network is down","summary":"<p>Network is down</p>"},{"id":"ENETRESET","name":"ENETRESET","value":"LibC::ENETRESET","doc":"Network dropped connection on reset","summary":"<p>Network dropped connection on reset</p>"},{"id":"ENETUNREACH","name":"ENETUNREACH","value":"LibC::ENETUNREACH","doc":"Network is unreachable","summary":"<p>Network is unreachable</p>"},{"id":"ENFILE","name":"ENFILE","value":"LibC::ENFILE","doc":"Too many open files in system","summary":"<p>Too many open files in system</p>"},{"id":"ENOBUFS","name":"ENOBUFS","value":"LibC::ENOBUFS","doc":"No buffer space available","summary":"<p>No buffer space available</p>"},{"id":"ENODATA","name":"ENODATA","value":"LibC::ENODATA","doc":"No message available on STREAM","summary":"<p>No message available on STREAM</p>"},{"id":"ENODEV","name":"ENODEV","value":"LibC::ENODEV","doc":"Operation not supported by device","summary":"<p>Operation not supported by device</p>"},{"id":"ENOENT","name":"ENOENT","value":"LibC::ENOENT","doc":"No such file or directory","summary":"<p>No such file or directory</p>"},{"id":"ENOEXEC","name":"ENOEXEC","value":"LibC::ENOEXEC","doc":"Exec format error","summary":"<p>Exec format error</p>"},{"id":"ENOLCK","name":"ENOLCK","value":"LibC::ENOLCK","doc":"No locks available","summary":"<p>No locks available</p>"},{"id":"ENOLINK","name":"ENOLINK","value":"LibC::ENOLINK","doc":"Reserved","summary":"<p>Reserved</p>"},{"id":"ENOMEM","name":"ENOMEM","value":"LibC::ENOMEM","doc":"Cannot allocate memory","summary":"<p>Cannot allocate memory</p>"},{"id":"ENOMSG","name":"ENOMSG","value":"LibC::ENOMSG","doc":"No message of desired type","summary":"<p>No message of desired type</p>"},{"id":"ENOPROTOOPT","name":"ENOPROTOOPT","value":"LibC::ENOPROTOOPT","doc":"Protocol not available","summary":"<p>Protocol not available</p>"},{"id":"ENOSPC","name":"ENOSPC","value":"LibC::ENOSPC","doc":"No space left on device","summary":"<p>No space left on device</p>"},{"id":"ENOSR","name":"ENOSR","value":"LibC::ENOSR","doc":"No STREAM resources","summary":"<p>No STREAM resources</p>"},{"id":"ENOSTR","name":"ENOSTR","value":"LibC::ENOSTR","doc":"Not a STREAM","summary":"<p>Not a STREAM</p>"},{"id":"ENOSYS","name":"ENOSYS","value":"LibC::ENOSYS","doc":"Function not implemented","summary":"<p>Function not implemented</p>"},{"id":"ENOTBLK","name":"ENOTBLK","value":"LibC::ENOTBLK","doc":"Block device required","summary":"<p>Block device required</p>"},{"id":"ENOTCONN","name":"ENOTCONN","value":"LibC::ENOTCONN","doc":"Socket is not connected","summary":"<p>Socket is not connected</p>"},{"id":"ENOTDIR","name":"ENOTDIR","value":"LibC::ENOTDIR","doc":"Not a directory","summary":"<p>Not a directory</p>"},{"id":"ENOTEMPTY","name":"ENOTEMPTY","value":"LibC::ENOTEMPTY","doc":"Directory not empty","summary":"<p>Directory not empty</p>"},{"id":"ENOTRECOVERABLE","name":"ENOTRECOVERABLE","value":"LibC::ENOTRECOVERABLE","doc":"State not recoverable","summary":"<p>State not recoverable</p>"},{"id":"ENOTSOCK","name":"ENOTSOCK","value":"LibC::ENOTSOCK","doc":"Socket operation on non-socket","summary":"<p>Socket operation on non-socket</p>"},{"id":"ENOTTY","name":"ENOTTY","value":"LibC::ENOTTY","doc":"Inappropriate ioctl for device","summary":"<p>Inappropriate ioctl for device</p>"},{"id":"ENXIO","name":"ENXIO","value":"LibC::ENXIO","doc":"Device not configured","summary":"<p>Device not configured</p>"},{"id":"EOPNOTSUPP","name":"EOPNOTSUPP","value":"LibC::EOPNOTSUPP","doc":"Operation not supported on socket","summary":"<p>Operation not supported on socket</p>"},{"id":"EOVERFLOW","name":"EOVERFLOW","value":"LibC::EOVERFLOW","doc":"Value too large to be stored in data type","summary":"<p>Value too large to be stored in data type</p>"},{"id":"EOWNERDEAD","name":"EOWNERDEAD","value":"LibC::EOWNERDEAD","doc":"Previous owner died","summary":"<p>Previous owner died</p>"},{"id":"EPERM","name":"EPERM","value":"LibC::EPERM","doc":"Operation not permitted","summary":"<p>Operation not permitted</p>"},{"id":"EPFNOSUPPORT","name":"EPFNOSUPPORT","value":"LibC::EPFNOSUPPORT","doc":"Protocol family not supported","summary":"<p>Protocol family not supported</p>"},{"id":"EPIPE","name":"EPIPE","value":"LibC::EPIPE","doc":"Broken pipe","summary":"<p>Broken pipe</p>"},{"id":"EPROTO","name":"EPROTO","value":"LibC::EPROTO","doc":"Protocol error","summary":"<p>Protocol error</p>"},{"id":"EPROTONOSUPPORT","name":"EPROTONOSUPPORT","value":"LibC::EPROTONOSUPPORT","doc":"Protocol not supported","summary":"<p>Protocol not supported</p>"},{"id":"EPROTOTYPE","name":"EPROTOTYPE","value":"LibC::EPROTOTYPE","doc":"Protocol wrong type for socket","summary":"<p>Protocol wrong type for socket</p>"},{"id":"ERANGE","name":"ERANGE","value":"LibC::ERANGE","doc":"Result too large","summary":"<p>Result too large</p>"},{"id":"EREMOTE","name":"EREMOTE","value":"LibC::EREMOTE","doc":"Too many levels of remote in path","summary":"<p>Too many levels of remote in path</p>"},{"id":"EROFS","name":"EROFS","value":"LibC::EROFS","doc":"Read-only file system","summary":"<p>Read-only file system</p>"},{"id":"ESHUTDOWN","name":"ESHUTDOWN","value":"LibC::ESHUTDOWN","doc":"Can't send after socket shutdown","summary":"<p>Can't send after socket shutdown</p>"},{"id":"ESOCKTNOSUPPORT","name":"ESOCKTNOSUPPORT","value":"LibC::ESOCKTNOSUPPORT","doc":"Socket type not supported","summary":"<p>Socket type not supported</p>"},{"id":"ESPIPE","name":"ESPIPE","value":"LibC::ESPIPE","doc":"Illegal seek","summary":"<p>Illegal seek</p>"},{"id":"ESRCH","name":"ESRCH","value":"LibC::ESRCH","doc":"No such process","summary":"<p>No such process</p>"},{"id":"ESTALE","name":"ESTALE","value":"LibC::ESTALE","doc":"Stale NFS file handle","summary":"<p>Stale NFS file handle</p>"},{"id":"ETIME","name":"ETIME","value":"LibC::ETIME","doc":"STREAM ioctl timeout","summary":"<p>STREAM ioctl timeout</p>"},{"id":"ETIMEDOUT","name":"ETIMEDOUT","value":"LibC::ETIMEDOUT","doc":"Operation timed out","summary":"<p>Operation timed out</p>"},{"id":"ETOOMANYREFS","name":"ETOOMANYREFS","value":"LibC::ETOOMANYREFS","doc":"Too many references: can't splice","summary":"<p>Too many references: can't splice</p>"},{"id":"ETXTBSY","name":"ETXTBSY","value":"LibC::ETXTBSY","doc":"Text file busy","summary":"<p>Text file busy</p>"},{"id":"EUSERS","name":"EUSERS","value":"LibC::EUSERS","doc":"Too many users","summary":"<p>Too many users</p>"},{"id":"EWOULDBLOCK","name":"EWOULDBLOCK","value":"LibC::EWOULDBLOCK","doc":"Operation would block","summary":"<p>Operation would block</p>"},{"id":"EXDEV","name":"EXDEV","value":"LibC::EXDEV","doc":"Cross-device link","summary":"<p>Cross-device link</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Errno wraps and gives access to libc's errno. This is mostly useful when\ndealing with C libraries.\n\nThis class is the exception thrown when errno errors are encountered.","summary":"<p>Errno wraps and gives access to libc's errno.</p>","class_methods":[{"id":"value:LibC::Int-class-method","html_id":"value:LibC::Int-class-method","name":"value","doc":"Returns the value of libc's errno.","summary":"<p>Returns the value of libc's errno.</p>","abstract":false,"args":[],"args_string":" : LibC::Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L224","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::Int","visibility":"Public","body":"{% if flag?(:linux) %}\n      {% if flag?(:musl) %}\n        LibC.__errno_location.value\n      {% else %}\n        LibC.errno\n      {% end %}\n    {% else %}{% if ((flag?(:darwin)) || (flag?(:freebsd))) || (flag?(:openbsd)) %}\n      LibC.__error.value\n    {% else %}{% if flag?(:win32) %}\n      ret = LibC._get_errno(out errno)\n      raise Errno.new(\"get_errno\", ret) unless ret == 0\n      errno\n    {% end %}{% end %}{% end %}"}},{"id":"value=(value)-class-method","html_id":"value=(value)-class-method","name":"value=","doc":"Sets the value of libc's errno.","summary":"<p>Sets the value of libc's errno.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L241","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:linux) %}\n      {% if flag?(:musl) %}\n        LibC.__errno_location.value = value\n      {% else %}\n        LibC.errno = value\n      {% end %}\n    {% else %}{% if ((flag?(:darwin)) || (flag?(:freebsd))) || (flag?(:openbsd)) %}\n      LibC.__error.value = value\n    {% else %}{% if flag?(:win32) %}\n      ret = LibC._set_errno(value)\n      raise Errno.new(\"set_errno\", ret) unless ret == 0\n      value\n    {% end %}{% end %}{% end %}"}}],"constructors":[{"id":"new(message,errno=Errno.value)-class-method","html_id":"new(message,errno=Errno.value)-class-method","name":"new","doc":"Creates a new Errno with the given message. The message will\nhave concatenated the message denoted by `Errno#value`.\n\nTypical usage:\n\n```\nerr = LibC.some_call\nif err == -1\n  raise Errno.new(\"some_call\")\nend\n```","summary":"<p>Creates a new Errno with the given message.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"errno","doc":null,"default_value":"Errno.value","external_name":"errno","restriction":""}],"args_string":"(message, errno = <span class=\"t\">Errno</span>.value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L218","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"errno","doc":null,"default_value":"Errno.value","external_name":"errno","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, errno)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"errno:Int32-instance-method","html_id":"errno:Int32-instance-method","name":"errno","doc":"Returns the numeric value of errno.","summary":"<p>Returns the numeric value of errno.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/errno.cr#L205","def":{"name":"errno","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@errno"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Exception","path":"Exception.html","kind":"class","full_name":"Exception","name":"Exception","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/ArgumentError","kind":"class","full_name":"ArgumentError","name":"ArgumentError"},{"html_id":"github.com/crystal-lang/crystal/Base64/Error","kind":"class","full_name":"Base64::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Channel/ClosedError","kind":"class","full_name":"Channel::ClosedError","name":"ClosedError"},{"html_id":"github.com/crystal-lang/crystal/Concurrent/CanceledError","kind":"class","full_name":"Concurrent::CanceledError","name":"CanceledError"},{"html_id":"github.com/crystal-lang/crystal/ConcurrentExecutionException","kind":"class","full_name":"ConcurrentExecutionException","name":"ConcurrentExecutionException"},{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt/Error","kind":"class","full_name":"Crypto::Bcrypt::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Error","kind":"class","full_name":"Debug::ELF::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/DivisionByZeroError","kind":"class","full_name":"DivisionByZeroError","name":"DivisionByZeroError"},{"html_id":"github.com/crystal-lang/crystal/Enumerable/EmptyError","kind":"class","full_name":"Enumerable::EmptyError","name":"EmptyError"},{"html_id":"github.com/crystal-lang/crystal/Errno","kind":"class","full_name":"Errno","name":"Errno"},{"html_id":"github.com/crystal-lang/crystal/File/BadPatternError","kind":"class","full_name":"File::BadPatternError","name":"BadPatternError"},{"html_id":"github.com/crystal-lang/crystal/Flate/Error","kind":"class","full_name":"Flate::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Gzip/Error","kind":"class","full_name":"Gzip::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Error","kind":"class","full_name":"HTTP::FormData::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Error","kind":"class","full_name":"HTTP::Multipart::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/IndexError","kind":"class","full_name":"IndexError","name":"IndexError"},{"html_id":"github.com/crystal-lang/crystal/INI/ParseException","kind":"class","full_name":"INI::ParseException","name":"ParseException"},{"html_id":"github.com/crystal-lang/crystal/InvalidBigDecimalException","kind":"class","full_name":"InvalidBigDecimalException","name":"InvalidBigDecimalException"},{"html_id":"github.com/crystal-lang/crystal/InvalidByteSequenceError","kind":"class","full_name":"InvalidByteSequenceError","name":"InvalidByteSequenceError"},{"html_id":"github.com/crystal-lang/crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/IO/Timeout","kind":"class","full_name":"IO::Timeout","name":"Timeout"},{"html_id":"github.com/crystal-lang/crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/KeyError","kind":"class","full_name":"KeyError","name":"KeyError"},{"html_id":"github.com/crystal-lang/crystal/NotImplementedError","kind":"class","full_name":"NotImplementedError","name":"NotImplementedError"},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Error","kind":"class","full_name":"OAuth2::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/OAuth/Error","kind":"class","full_name":"OAuth::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Time/FloatingTimeConversionError","kind":"class","full_name":"Time::FloatingTimeConversionError","name":"FloatingTimeConversionError"},{"html_id":"github.com/crystal-lang/crystal/Time/Format/Error","kind":"class","full_name":"Time::Format::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidLocationNameError","kind":"class","full_name":"Time::Location::InvalidLocationNameError","name":"InvalidLocationNameError"},{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidTimezoneOffsetError","kind":"class","full_name":"Time::Location::InvalidTimezoneOffsetError","name":"InvalidTimezoneOffsetError"},{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidTZDataError","kind":"class","full_name":"Time::Location::InvalidTZDataError","name":"InvalidTZDataError"},{"html_id":"github.com/crystal-lang/crystal/TypeCastError","kind":"class","full_name":"TypeCastError","name":"TypeCastError"},{"html_id":"github.com/crystal-lang/crystal/URI/Error","kind":"class","full_name":"URI::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/XML/Error","kind":"class","full_name":"XML::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Zip/Error","kind":"class","full_name":"Zip::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Zlib/Error","kind":"class","full_name":"Zlib::Error","name":"Error"}],"including_types":[],"namespace":null,"doc":"Represents errors that occur during application execution.\n\nException and it's descendants are used to communicate between raise and\nrescue statements in `begin ... end` blocks.\nException objects carry information about the exception – its type (the\nexception’s class name), an optional descriptive string, and\noptional traceback information.\nException subclasses may add additional information.","summary":"<p>Represents errors that occur during application execution.</p>","class_methods":[],"constructors":[{"id":"new(message:String?=nil,cause:Exception?=nil)-class-method","html_id":"new(message:String?=nil,cause:Exception?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","doc":null,"default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"args_string":"(message : String? = <span class=\"n\">nil</span>, cause : Exception? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L21","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","doc":null,"default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"backtrace-instance-method","html_id":"backtrace-instance-method","name":"backtrace","doc":"Returns any backtrace associated with the exception.\nThe backtrace is an array of strings, each containing\n“0xAddress: Function at File Line Column”.","summary":"<p>Returns any backtrace associated with the exception.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L27","def":{"name":"backtrace","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.backtrace?.not_nil!"}},{"id":"backtrace?-instance-method","html_id":"backtrace?-instance-method","name":"backtrace?","doc":"Returns any backtrace associated with the exception if the call stack exists.\nThe backtrace is an array of strings, each containing\n“0xAddress: Function at File Line Column”.","summary":"<p>Returns any backtrace associated with the exception if the call stack exists.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L34","def":{"name":"backtrace?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:win32) %}\n      Array(String).new\n    {% else %}\n      @callstack.try &.printable_backtrace\n    {% end %}"}},{"id":"callstack:CallStack?-instance-method","html_id":"callstack:CallStack?-instance-method","name":"callstack","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : CallStack?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L19","def":{"name":"callstack","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"CallStack | ::Nil","visibility":"Public","body":"@callstack"}},{"id":"callstack=(callstack:CallStack?)-instance-method","html_id":"callstack=(callstack:CallStack?)-instance-method","name":"callstack=","doc":null,"summary":null,"abstract":false,"args":[{"name":"callstack","doc":null,"default_value":"","external_name":"callstack","restriction":"CallStack | ::Nil"}],"args_string":"(callstack : CallStack?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L19","def":{"name":"callstack=","args":[{"name":"callstack","doc":null,"default_value":"","external_name":"callstack","restriction":"CallStack | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@callstack = callstack"}},{"id":"cause:Exception?-instance-method","html_id":"cause:Exception?-instance-method","name":"cause","doc":"Returns the previous exception at the time this exception was raised.\nThis is useful for wrapping exceptions and retaining the original\nexception information.","summary":"<p>Returns the previous exception at the time this exception was raised.</p>","abstract":false,"args":[],"args_string":" : Exception?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L18","def":{"name":"cause","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Exception | ::Nil","visibility":"Public","body":"@cause"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L46","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((((io << \"#<\") << self.class.name) << ':') << message) << '>'"}},{"id":"inspect_with_backtrace(io:IO)-instance-method","html_id":"inspect_with_backtrace(io:IO)-instance-method","name":"inspect_with_backtrace","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L56","def":{"name":"inspect_with_backtrace","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(((io << message) << \" (\") << self.class) << \")\\n\"\nbacktrace?.try(&.each do |frame|\n  io.print(\"  from \")\n  io.puts(frame)\nend)\nif cause = @cause\n  io << \"Caused by: \"\n  cause.inspect_with_backtrace(io)\nend\nio.flush\n"}},{"id":"inspect_with_backtrace-instance-method","html_id":"inspect_with_backtrace-instance-method","name":"inspect_with_backtrace","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L50","def":{"name":"inspect_with_backtrace","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  inspect_with_backtrace(io)\nend"}},{"id":"message:String?-instance-method","html_id":"message:String?-instance-method","name":"message","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L14","def":{"name":"message","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@message"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L42","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << message"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Fiber","path":"Fiber.html","kind":"class","full_name":"Fiber","name":"Fiber","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"fiber.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"STACK_SIZE","name":"STACK_SIZE","value":"(8 * 1024) * 1024","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"sleep(time)-class-method","html_id":"sleep(time)-class-method","name":"sleep","doc":null,"summary":null,"abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":""}],"args_string":"(time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L286","def":{"name":"sleep","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Fiber.current.sleep(time)"}},{"id":"stack_pool_collect-class-method","html_id":"stack_pool_collect-class-method","name":"stack_pool_collect","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L110","def":{"name":"stack_pool_collect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @@stack_pool.size == 0\n  return\nend\nfree_count = @@stack_pool.size > 1 ? @@stack_pool.size / 2 : 1\nfree_count.times do\n  stack = @@stack_pool.pop\n  LibC.munmap(stack, Fiber::STACK_SIZE)\nend\n"}},{"id":"yield-class-method","html_id":"yield-class-method","name":"yield","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L290","def":{"name":"yield","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Fiber.current.yield"}}],"constructors":[{"id":"current:self-class-method","html_id":"current:self-class-method","name":"current","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L320","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L320","def":{"name":"current","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"Thread.current.current_fiber"}},{"id":"new(name:String?=nil,&proc:->)-class-method","html_id":"new(name:String?=nil,&amp;proc:-&gt;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String? = <span class=\"n\">nil</span>, &proc :  -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L26","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"proc","doc":null,"default_value":"","external_name":"proc","restriction":"(-> )"},"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, &proc) do\n  yield\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L82","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"root:self-class-method","html_id":"root:self-class-method","name":"root","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L314","def":{"name":"root","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"@@root"}}],"instance_methods":[{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L303","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"name:String?-instance-method","html_id":"name:String?-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L24","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@name"}},{"id":"name=(name:String?)-instance-method","html_id":"name=(name:String?)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L24","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name = name"}},{"id":"resume:Nil-instance-method","html_id":"resume:Nil-instance-method","name":"resume","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L262","def":{"name":"resume","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"current, Thread.current.current_fiber = Thread.current.current_fiber, self\nGC.stack_bottom = @stack_bottom\n{% if flag?(:aarch64) %}\n      Fiber.switch_stacks(pointerof(current.@stack_top), @stack_top)\n    {% else %}\n      Fiber.switch_stacks(pointerof(current.@stack_top), pointerof(@stack_top))\n    {% end %}\n"}},{"id":"run-instance-method","html_id":"run-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L119","def":{"name":"run","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  @proc.call\nrescue ex\n  if name = @name\n    STDERR.puts(\"Unhandled exception in spawn(name: #{name}):\")\n  else\n    STDERR.puts(\"Unhandled exception in spawn:\")\n  end\n  ex.inspect_with_backtrace(STDERR)\n  STDERR.flush\nensure\n  @@stack_pool << @stack\n  if prev_fiber = @prev_fiber\n    prev_fiber.next_fiber = @next_fiber\n  else\n    @@first_fiber = @next_fiber\n  end\n  if next_fiber = @next_fiber\n    next_fiber.prev_fiber = @prev_fiber\n  else\n    @@last_fiber = @prev_fiber\n  end\n  @resume_event.try(&.free)\n  Scheduler.reschedule\nend"}},{"id":"sleep(time:Number)-instance-method","html_id":"sleep(time:Number)-instance-method","name":"sleep","doc":null,"summary":null,"abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Number"}],"args_string":"(time : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L278","def":{"name":"sleep","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sleep(time.seconds)"}},{"id":"sleep(time:Time::Span)-instance-method","html_id":"sleep(time:Time::Span)-instance-method","name":"sleep","doc":null,"summary":null,"abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time::Span"}],"args_string":"(time : Time::Span)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L272","def":{"name":"sleep","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"event = @resume_event || (@resume_event = Scheduler.create_resume_event(self))\nevent.add(time)\nScheduler.reschedule\n"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L294","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((io << \"#<\") << self.class.name) << \":0x\"\nobject_id.to_s(16, io)\nif name = @name\n  (io << \": \") << name\nend\nio << '>'\n"}},{"id":"yield-instance-method","html_id":"yield-instance-method","name":"yield","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/fiber.cr#L282","def":{"name":"yield","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sleep(0)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/File","path":"File.html","kind":"class","full_name":"File","name":"File","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Crystal/System/File","kind":"module","full_name":"Crystal::System::File","name":"File"},{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr"},{"filename":"file/info.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"SEPARATOR","name":"SEPARATOR","value":"{% if flag?(:windows) %}\n    '\\\\'\n  {% else %}\n    '/'\n  {% end %}","doc":"The file/directory separator character. `'/'` in Unix, `'\\\\'` in Windows.","summary":"<p>The file/directory separator character.</p>"},{"id":"SEPARATOR_STRING","name":"SEPARATOR_STRING","value":"{% if flag?(:windows) %}\n    \"\\\\\"\n  {% else %}\n    \"/\"\n  {% end %}","doc":"The file/directory separator string. `\"/\"` in Unix, `\"\\\\\"` in Windows.","summary":"<p>The file/directory separator string.</p>"}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Crystal/System/File","kind":"module","full_name":"Crystal::System::File","name":"File"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Tempfile","kind":"class","full_name":"Tempfile","name":"Tempfile"}],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"basename(path):String-class-method","html_id":"basename(path):String-class-method","name":"basename","doc":"Returns the last component of the given *path*.\n\n```\nFile.basename(\"/foo/bar/file.cr\") # => \"file.cr\"\n```","summary":"<p>Returns the last component of the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L202","def":{"name":"basename","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"if path.bytesize == 0\n  return \"\"\nend\nif path == SEPARATOR_STRING\n  return SEPARATOR_STRING\nend\npath.check_no_null_byte\nlast = path.size - 1\nif path[last] == SEPARATOR\n  last = last - 1\nend\nindex = path.rindex(SEPARATOR, last)\nif index\n  path[index + 1, last - index]\nelse\n  path\nend\n"}},{"id":"basename(path,suffix):String-class-method","html_id":"basename(path,suffix):String-class-method","name":"basename","doc":"Returns the last component of the given *path*.\n\nIf *suffix* is present at the end of *path*, it is removed.\n\n```\nFile.basename(\"/foo/bar/file.cr\", \".cr\") # => \"file\"\n```","summary":"<p>Returns the last component of the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":""}],"args_string":"(path, suffix) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L226","def":{"name":"basename","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"suffix.check_no_null_byte\n(basename(path)).chomp(suffix)\n"}},{"id":"chmod(path,permissions:Int|Permissions)-class-method","html_id":"chmod(path,permissions:Int|Permissions)-class-method","name":"chmod","doc":"Changes the permissions of the specified file.\n\nSymlinks are dereferenced, so that only the permissions of the symlink\ndestination are changed, never the permissions of the symlink itself.\n\n```\nFile.chmod(\"foo\", 0o755)\nFile.info(\"foo\").permissions # => 0o755\n\nFile.chmod(\"foo\", 0o700)\nFile.info(\"foo\").permissions # => 0o700\n```","summary":"<p>Changes the permissions of the specified file.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"permissions","doc":null,"default_value":"","external_name":"permissions","restriction":"Int | Permissions"}],"args_string":"(path, permissions : Int | Permissions)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L262","def":{"name":"chmod","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"permissions","doc":null,"default_value":"","external_name":"permissions","restriction":"Int | Permissions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::File.chmod(path, permissions)"}},{"id":"chown(path,uid:Int=-1,gid:Int=-1,follow_symlinks=false)-class-method","html_id":"chown(path,uid:Int=-1,gid:Int=-1,follow_symlinks=false)-class-method","name":"chown","doc":"Changes the owner of the specified file.\n\n```\nFile.chown(\"/foo/bar/baz.cr\", 1001, 100)\nFile.chown(\"/foo/bar\", gid: 100)\n```\n\nUnless *follow_symlinks* is set to `true`, then the owner symlink itself will\nbe changed, otherwise the owner of the symlink destination file will be\nchanged. For example, assuming symlinks as `foo -> bar -> baz`:\n\n```\nFile.chown(\"foo\", gid: 100)                        # changes foo's gid\nFile.chown(\"foo\", gid: 100, follow_symlinks: true) # changes baz's gid\n```","summary":"<p>Changes the owner of the specified file.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"uid","doc":null,"default_value":"-1","external_name":"uid","restriction":"Int"},{"name":"gid","doc":null,"default_value":"-1","external_name":"gid","restriction":"Int"},{"name":"follow_symlinks","doc":null,"default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(path, uid : Int = <span class=\"n\">-1</span>, gid : Int = <span class=\"n\">-1</span>, follow_symlinks = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L246","def":{"name":"chown","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"uid","doc":null,"default_value":"-1","external_name":"uid","restriction":"Int"},{"name":"gid","doc":null,"default_value":"-1","external_name":"gid","restriction":"Int"},{"name":"follow_symlinks","doc":null,"default_value":"false","external_name":"follow_symlinks","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::File.chown(path, uid, gid, follow_symlinks)"}},{"id":"delete(path)-class-method","html_id":"delete(path)-class-method","name":"delete","doc":"Delete the file at *path*. Deleting non-existent file will raise an exception.\n\n```\nFile.write(\"foo\", \"\")\nFile.delete(\"./foo\")\nFile.delete(\"./bar\") # raises Errno (No such file or directory)\n```","summary":"<p>Delete the file at <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L273","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::File.delete(path)"}},{"id":"directory?(path):Bool-class-method","html_id":"directory?(path):Bool-class-method","name":"directory?","doc":"Returns `true` if the given *path* exists and is a directory.\n\n```\nFile.write(\"foo\", \"\")\nDir.mkdir(\"dir2\")\nFile.directory?(\"foo\")    # => false\nFile.directory?(\"dir2\")   # => true\nFile.directory?(\"foobar\") # => false\n```","summary":"<p>Returns <code>true</code> if the given <em>path</em> exists and is a directory.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L174","def":{"name":"directory?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"Dir.exists?(path)"}},{"id":"dirname(path):String-class-method","html_id":"dirname(path):String-class-method","name":"dirname","doc":"Returns all components of the given *path* except the last one.\n\n```\nFile.dirname(\"/foo/bar/file.cr\") # => \"/foo/bar\"\n```","summary":"<p>Returns all components of the given <em>path</em> except the last one.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L183","def":{"name":"dirname","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"path.check_no_null_byte\nindex = path.rindex(SEPARATOR)\nif index\n  if index == 0\n    SEPARATOR_STRING\n  else\n    path[0, index]\n  end\nelse\n  \".\"\nend\n"}},{"id":"each_line(filename,encoding=nil,invalid=nil,chomp=true)-class-method","html_id":"each_line(filename,encoding=nil,invalid=nil,chomp=true)-class-method","name":"each_line","doc":"Returns an `Iterator` for each line in *filename*.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for each line in <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(filename, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, chomp = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L660","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L660","def":{"name":"each_line","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(open(filename, \"r\", encoding: encoding, invalid: invalid)).each_line(chomp: chomp)"}},{"id":"each_line(filename,encoding=nil,invalid=nil,chomp=true,&block)-class-method","html_id":"each_line(filename,encoding=nil,invalid=nil,chomp=true,&amp;block)-class-method","name":"each_line","doc":"Yields each line in *filename* to the given block.\n\n```\nFile.write(\"foobar\", \"foo\\nbar\")\n\narray = [] of String\nFile.each_line(\"foobar\") do |line|\n  array << line\nend\narray # => [\"foo\", \"bar\"]\n```","summary":"<p>Yields each line in <em>filename</em> to the given block.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(filename, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, chomp = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L651","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L651","def":{"name":"each_line","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"open(filename, \"r\", encoding: encoding, invalid: invalid) do |file|\n  file.each_line(chomp: chomp) do |line|\n    yield line\n  end\nend"}},{"id":"empty?(path):Bool-class-method","html_id":"empty?(path):Bool-class-method","name":"empty?","doc":"Returns `true` if the file at *path* is empty, otherwise returns `false`.\nRaises `Errno` if the file at *path* does not exist.\n\n```\nFile.write(\"foo\", \"\")\nFile.empty?(\"foo\") # => true\nFile.write(\"foo\", \"foo\")\nFile.empty?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if the file at <em>path</em> is empty, otherwise returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L114","def":{"name":"empty?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"(size(path)) == 0"}},{"id":"executable?(path):Bool-class-method","html_id":"executable?(path):Bool-class-method","name":"executable?","doc":"Returns `true` if *path* is executable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.executable?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is executable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L144","def":{"name":"executable?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.executable?(path)"}},{"id":"exists?(path):Bool-class-method","html_id":"exists?(path):Bool-class-method","name":"exists?","doc":"Returns `true` if *path* exists else returns `false`\n\n```\nFile.delete(\"foo\") if File.exists?(\"foo\")\nFile.exists?(\"foo\") # => false\nFile.write(\"foo\", \"foo\")\nFile.exists?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> exists else returns <code>false</code></p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L81","def":{"name":"exists?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.exists?(path)"}},{"id":"expand_path(path,dir=nil):String-class-method","html_id":"expand_path(path,dir=nil):String-class-method","name":"expand_path","doc":"Converts *path* to an absolute path. Relative paths are\nreferenced from the current working directory of the process unless\n*dir* is given, in which case it will be used as the starting point.\n\n```\nFile.expand_path(\"foo\")             # => \"/home/.../foo\"\nFile.expand_path(\"~/crystal/foo\")   # => \"/home/crystal/foo\"\nFile.expand_path(\"baz\", \"/foo/bar\") # => \"/foo/bar/baz\"\n```","summary":"<p>Converts <em>path</em> to an absolute path.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"dir","doc":null,"default_value":"nil","external_name":"dir","restriction":""}],"args_string":"(path, dir = <span class=\"n\">nil</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L330","def":{"name":"expand_path","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"dir","doc":null,"default_value":"nil","external_name":"dir","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"path.check_no_null_byte\nif path.starts_with?('~')\n  home = ENV[\"HOME\"]\n  if home == \"/\"\n  else\n    home = home.chomp('/')\n  end\n  if path.size >= 2 && (path[1] == SEPARATOR)\n    path = home + path[1..-1]\n  else\n    if path.size < 2\n      return home\n    end\n  end\nend\nif path.starts_with?(SEPARATOR)\nelse\n  dir = dir ? expand_path(dir) : Dir.current\n  path = \"#{dir}#{SEPARATOR}#{path}\"\nend\nparts = path.split(SEPARATOR)\nitems = [] of String\nparts.each do |part|\n  case part\n  when \"\", \".\"\n  when \"..\"\n    items.pop?\n  else\n    items << part\n  end\nend\nString.build do |str|\n  {% if !(flag?(:windows)) %}\n        str << SEPARATOR_STRING\n      {% end %}\n  items.join(SEPARATOR_STRING, str)\nend\n"}},{"id":"extname(filename):String-class-method","html_id":"extname(filename):String-class-method","name":"extname","doc":"Returns *filename*'s extension, or an empty string if it has no extension.\n\n```\nFile.extname(\"foo.cr\") # => \".cr\"\n```","summary":"<p>Returns <em>filename</em>'s extension, or an empty string if it has no extension.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(filename) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L282","def":{"name":"extname","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"filename.check_no_null_byte\nbytes = filename.to_slice\nif bytes.empty?\n  return \"\"\nend\ncurrent = bytes.size - 1\nif bytes[current] == '.'.ord\n  return \"\"\nend\nwhile ((bytes[current] != SEPARATOR.ord) && (bytes[current] != '.'.ord)) && current > 0\n  current = current - 1\nend\nif current > 0\nelse\n  return \"\"\nend\nif bytes[current] == SEPARATOR.ord\n  return \"\"\nend\nif bytes[current - 1] == SEPARATOR.ord\n  return \"\"\nend\nString.new(bytes[current, bytes.size - current])\n"}},{"id":"file?(path):Bool-class-method","html_id":"file?(path):Bool-class-method","name":"file?","doc":"Returns `true` if given *path* exists and is a file.\n\n```\nFile.write(\"foo\", \"\")\nDir.mkdir(\"dir1\")\nFile.file?(\"foo\")    # => true\nFile.file?(\"dir1\")   # => false\nFile.file?(\"foobar\") # => false\n```","summary":"<p>Returns <code>true</code> if given <em>path</em> exists and is a file.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L157","def":{"name":"file?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if info = info?(path)\n  info.type.file?\nelse\n  false\nend"}},{"id":"info(path,follow_symlinks=true):Info-class-method","html_id":"info(path,follow_symlinks=true):Info-class-method","name":"info","doc":"Returns a `File::Info` object for the file given by *path* or raises\n`Errno` in case of an error.\n\nIf *follow_symlinks* is set (the default), symbolic links are followed. Otherwise,\nsymbolic links return information on the symlink itself.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.info(\"foo\").size              # => 3\nFile.info(\"foo\").modification_time # => 2015-09-23 06:24:19 UTC\n\nFile.symlink(\"foo\", \"bar\")\nFile.info(\"bar\", follow_symlinks: false).type.symlink? # => true\n```","summary":"<p>Returns a <code><a href=\"File/Info.html\">File::Info</a></code> object for the file given by <em>path</em> or raises <code><a href=\"Errno.html\">Errno</a></code> in case of an error.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"follow_symlinks","doc":null,"default_value":"true","external_name":"follow_symlinks","restriction":""}],"args_string":"(path, follow_symlinks = <span class=\"n\">true</span>) : Info","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L69","def":{"name":"info","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"follow_symlinks","doc":null,"default_value":"true","external_name":"follow_symlinks","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Info","visibility":"Public","body":"(info?(path, follow_symlinks)) || (raise(Errno.new(\"Unable to get info for #{path.inspect}\")))"}},{"id":"info?(path:String,follow_symlinks=true):Info?-class-method","html_id":"info?(path:String,follow_symlinks=true):Info?-class-method","name":"info?","doc":"Returns a `File::Info` object for the file given by *path* or returns `nil`\nif the file does not exist.\n\nIf *follow_symlinks* is set (the default), symbolic links are followed. Otherwise,\nsymbolic links return information on the symlink itself.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.info?(\"foo\").try(&.size) # => 3\nFile.info?(\"non_existent\")    # => nil\n\nFile.symlink(\"foo\", \"bar\")\nFile.info?(\"bar\", follow_symlinks: false).try(&.type.symlink?) # => true\n```","summary":"<p>Returns a <code><a href=\"File/Info.html\">File::Info</a></code> object for the file given by <em>path</em> or returns <code>nil</code> if the file does not exist.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"follow_symlinks","doc":null,"default_value":"true","external_name":"follow_symlinks","restriction":""}],"args_string":"(path : String, follow_symlinks = <span class=\"n\">true</span>) : Info?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L51","def":{"name":"info?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"follow_symlinks","doc":null,"default_value":"true","external_name":"follow_symlinks","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Info | ::Nil","visibility":"Public","body":"Crystal::System::File.info?(path, follow_symlinks)"}},{"id":"join(parts:Array|Tuple):String-class-method","html_id":"join(parts:Array|Tuple):String-class-method","name":"join","doc":"Returns a new string formed by joining the strings using `File::SEPARATOR`.\n\n```\nFile.join({\"foo\", \"bar\", \"baz\"})       # => \"foo/bar/baz\"\nFile.join({\"foo/\", \"/bar/\", \"/baz\"})   # => \"foo/bar/baz\"\nFile.join([\"/foo/\", \"/bar/\", \"/baz/\"]) # => \"/foo/bar/baz/\"\n```","summary":"<p>Returns a new string formed by joining the strings using <code><a href=\"File.html#SEPARATOR\">File::SEPARATOR</a></code>.</p>","abstract":false,"args":[{"name":"parts","doc":null,"default_value":"","external_name":"parts","restriction":"Array | Tuple"}],"args_string":"(parts : Array | Tuple) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L726","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L726","def":{"name":"join","args":[{"name":"parts","doc":null,"default_value":"","external_name":"parts","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |str|\n  first = true\n  parts.each_with_index do |part, index|\n    part.check_no_null_byte\n    if part.empty? && (index != (parts.size - 1))\n      next\n    end\n    if first\n    else\n      str << SEPARATOR\n    end\n    byte_start = 0\n    byte_count = part.bytesize\n    if (!first) && (part.starts_with?(SEPARATOR))\n      byte_start = byte_start + 1\n      byte_count = byte_count - 1\n    end\n    if (index != (parts.size - 1)) && (part.ends_with?(SEPARATOR))\n      byte_count = byte_count - 1\n    end\n    str.write(part.unsafe_byte_slice(byte_start, byte_count))\n    first = false\n  end\nend"}},{"id":"join(*parts):String-class-method","html_id":"join(*parts):String-class-method","name":"join","doc":"Returns a new string formed by joining the strings using `File::SEPARATOR`.\n\n```\nFile.join(\"foo\", \"bar\", \"baz\")       # => \"foo/bar/baz\"\nFile.join(\"foo/\", \"/bar/\", \"/baz\")   # => \"foo/bar/baz\"\nFile.join(\"/foo/\", \"/bar/\", \"/baz/\") # => \"/foo/bar/baz/\"\n```","summary":"<p>Returns a new string formed by joining the strings using <code><a href=\"File.html#SEPARATOR\">File::SEPARATOR</a></code>.</p>","abstract":false,"args":[{"name":"parts","doc":null,"default_value":"","external_name":"parts","restriction":""}],"args_string":"(*parts) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L715","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L715","def":{"name":"join","args":[{"name":"parts","doc":null,"default_value":"","external_name":"parts","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"join(parts)"}},{"id":"link(old_path,new_path)-class-method","html_id":"link(old_path,new_path)-class-method","name":"link","doc":"Creates a new link (also known as a hard link) at *new_path* to an existing file\ngiven by *old_path*.","summary":"<p>Creates a new link (also known as a hard link) at <em>new_path</em> to an existing file given by <em>old_path</em>.</p>","abstract":false,"args":[{"name":"old_path","doc":null,"default_value":"","external_name":"old_path","restriction":""},{"name":"new_path","doc":null,"default_value":"","external_name":"new_path","restriction":""}],"args_string":"(old_path, new_path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L580","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L580","def":{"name":"link","args":[{"name":"old_path","doc":null,"default_value":"","external_name":"old_path","restriction":""},{"name":"new_path","doc":null,"default_value":"","external_name":"new_path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::File.link(old_path, new_path)"}},{"id":"match?(pattern:String,path:String)-class-method","html_id":"match?(pattern:String,path:String)-class-method","name":"match?","doc":"Matches *path* against *pattern*.\n\nThe pattern syntax is similar to shell filename globbing. It may contain the following metacharacters:\n\n* `*` matches an unlimited number of arbitrary characters excluding `/`.\n  * `\"*\"` matches all regular files.\n  * `\"c*\"` matches all files beginning with `c`.\n  * `\"*c\"` matches all files ending with `c`.\n  * `\"*c*\"` matches all files that have `c` in them (including at the beginning or end).\n* `**` matches an unlimited number of arbitrary charachters including `/`.\n* `?` matches any one charachter excluding `/`.\n* character sets:\n  * `[abc]` matches any one of these character.\n  * `[^abc]` matches any one character other than these.\n  * `[a-z]` matches any one charachter in the range.\n* `{a,b}` matches subpattern `a` or `b`.\n* `\\\\` escapes the next character.\n\nNOTE: Only `/` is recognized as path separator in both *pattern* and *path*.","summary":"<p>Matches <em>path</em> against <em>pattern</em>.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(pattern : String, path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L392","def":{"name":"match?","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expanded_patterns = [] of String\nFile.expand_brace_pattern(pattern, expanded_patterns)\nexpanded_patterns.each do |expanded_pattern|\n  if match_single_pattern(expanded_pattern, path)\n    return true\n  end\nend\nfalse\n"}},{"id":"open(filename,mode=&quot;r&quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,&block)-class-method","html_id":"open(filename,mode=&amp;quot;r&amp;quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,&amp;block)-class-method","name":"open","doc":"Opens the file named by *filename*. If a file is being created, its initial\npermissions may be set using the *perm* parameter. Then given block will be passed the opened\nfile as an argument, the file will be automatically closed when the block returns.","summary":"<p>Opens the file named by <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L607","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L607","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"file = new(filename, mode, perm, encoding, invalid)\nbegin\n  yield file\nensure\n  file.close\nend\n"}},{"id":"read(filename,encoding=nil,invalid=nil):String-class-method","html_id":"read(filename,encoding=nil,invalid=nil):String-class-method","name":"read","doc":"Returns the content of *filename* as a string.\n\n```\nFile.write(\"bar\", \"foo\")\nFile.read(\"bar\") # => \"foo\"\n```","summary":"<p>Returns the content of <em>filename</em> as a string.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L622","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L622","def":{"name":"read","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"open(filename, \"r\") do |file|\n  if encoding\n    file.set_encoding(encoding, invalid: invalid)\n    file.gets_to_end\n  else\n    size = file.size.to_i\n    if size == 0\n      size = 256\n    end\n    String.build(size) do |io|\n      IO.copy(file, io)\n    end\n  end\nend"}},{"id":"read_lines(filename,encoding=nil,invalid=nil,chomp=true):Array(String)-class-method","html_id":"read_lines(filename,encoding=nil,invalid=nil,chomp=true):Array(String)-class-method","name":"read_lines","doc":"Returns all lines in *filename* as an array of strings.\n\n```\nFile.write(\"foobar\", \"foo\\nbar\")\nFile.read_lines(\"foobar\") # => [\"foo\", \"bar\"]\n```","summary":"<p>Returns all lines in <em>filename</em> as an array of strings.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(filename, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, chomp = <span class=\"n\">true</span>) : Array(String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L670","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L670","def":{"name":"read_lines","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(String)","visibility":"Public","body":"lines = [] of String\neach_line(filename, encoding: encoding, invalid: invalid, chomp: chomp) do |line|\n  lines << line\nend\nlines\n"}},{"id":"readable?(path):Bool-class-method","html_id":"readable?(path):Bool-class-method","name":"readable?","doc":"Returns `true` if *path* is readable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.readable?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is readable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L124","def":{"name":"readable?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.readable?(path)"}},{"id":"real_path(path):String-class-method","html_id":"real_path(path):String-class-method","name":"real_path","doc":"Resolves the real path of *path* by following symbolic links.","summary":"<p>Resolves the real path of <em>path</em> by following symbolic links.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L574","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L574","def":{"name":"real_path","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Crystal::System::File.real_path(path)"}},{"id":"rename(old_filename,new_filename):Nil-class-method","html_id":"rename(old_filename,new_filename):Nil-class-method","name":"rename","doc":"Moves *old_filename* to *new_filename*.\n\n```\nFile.write(\"afile\", \"foo\")\nFile.exists?(\"afile\") # => true\n\nFile.rename(\"afile\", \"afile.cr\")\nFile.exists?(\"afile\")    # => false\nFile.exists?(\"afile.cr\") # => true\n```","summary":"<p>Moves <em>old_filename</em> to <em>new_filename</em>.</p>","abstract":false,"args":[{"name":"old_filename","doc":null,"default_value":"","external_name":"old_filename","restriction":""},{"name":"new_filename","doc":null,"default_value":"","external_name":"new_filename","restriction":""}],"args_string":"(old_filename, new_filename) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L764","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L764","def":{"name":"rename","args":[{"name":"old_filename","doc":null,"default_value":"","external_name":"old_filename","restriction":""},{"name":"new_filename","doc":null,"default_value":"","external_name":"new_filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.rename(old_filename, new_filename)"}},{"id":"same?(path1:String,path2:String,follow_symlinks=false):Bool-class-method","html_id":"same?(path1:String,path2:String,follow_symlinks=false):Bool-class-method","name":"same?","doc":"Returns `true` if *path1* and *path2* represents the same file.\nThe comparison take symlinks in consideration if *follow_symlinks* is `true`.","summary":"<p>Returns <code>true</code> if <em>path1</em> and <em>path2</em> represents the same file.</p>","abstract":false,"args":[{"name":"path1","doc":null,"default_value":"","external_name":"path1","restriction":"String"},{"name":"path2","doc":null,"default_value":"","external_name":"path2","restriction":"String"},{"name":"follow_symlinks","doc":null,"default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(path1 : String, path2 : String, follow_symlinks = <span class=\"n\">false</span>) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L87","def":{"name":"same?","args":[{"name":"path1","doc":null,"default_value":"","external_name":"path1","restriction":"String"},{"name":"path2","doc":null,"default_value":"","external_name":"path2","restriction":"String"},{"name":"follow_symlinks","doc":null,"default_value":"false","external_name":"follow_symlinks","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"(info(path1, follow_symlinks)).same_file?(info(path2, follow_symlinks))"}},{"id":"size(filename):UInt64-class-method","html_id":"size(filename):UInt64-class-method","name":"size","doc":"Returns the size of *filename* bytes. Raises `Errno` if the file at *path*\ndoes not exist.\n\n```\nFile.size(\"foo\") # raises Errno\nFile.write(\"foo\", \"foo\")\nFile.size(\"foo\") # => 3\n```","summary":"<p>Returns the size of <em>filename</em> bytes.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(filename) : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L99","def":{"name":"size","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"begin\n  (info(filename)).size\nrescue ex : Errno\n  raise(Errno.new(\"Error determining size of #{filename.inspect}\", ex.errno))\nend"}},{"id":"symlink(old_path,new_path)-class-method","html_id":"symlink(old_path,new_path)-class-method","name":"symlink","doc":"Creates a symbolic link at *new_path* to an existing file given by *old_path*.","summary":"<p>Creates a symbolic link at <em>new_path</em> to an existing file given by <em>old_path</em>.</p>","abstract":false,"args":[{"name":"old_path","doc":null,"default_value":"","external_name":"old_path","restriction":""},{"name":"new_path","doc":null,"default_value":"","external_name":"new_path","restriction":""}],"args_string":"(old_path, new_path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L585","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L585","def":{"name":"symlink","args":[{"name":"old_path","doc":null,"default_value":"","external_name":"old_path","restriction":""},{"name":"new_path","doc":null,"default_value":"","external_name":"new_path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::File.symlink(old_path, new_path)"}},{"id":"symlink?(path):Bool-class-method","html_id":"symlink?(path):Bool-class-method","name":"symlink?","doc":"Returns `true` if the *path* is a symbolic link.","summary":"<p>Returns <code>true</code> if the <em>path</em> is a symbolic link.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L590","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L590","def":{"name":"symlink?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if info = info?(path, follow_symlinks: false)\n  info.type.symlink?\nelse\n  false\nend"}},{"id":"touch(filename:String,time:Time=Time.now)-class-method","html_id":"touch(filename:String,time:Time=Time.now)-class-method","name":"touch","doc":"Attempts to set the access and modification times of the file named\nin the *filename* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.","summary":"<p>Attempts to set the access and modification times of the file named in the <em>filename</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"args_string":"(filename : String, time : Time = <span class=\"t\">Time</span>.now)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L777","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L777","def":{"name":"touch","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if exists?(filename)\nelse\n  open(filename, \"a\") do\n  end\nend\nutime(time, time, filename)\n"}},{"id":"utime(atime:Time,mtime:Time,filename:String):Nil-class-method","html_id":"utime(atime:Time,mtime:Time,filename:String):Nil-class-method","name":"utime","doc":"Sets the access and modification times of *filename*.","summary":"<p>Sets the access and modification times of <em>filename</em>.</p>","abstract":false,"args":[{"name":"atime","doc":null,"default_value":"","external_name":"atime","restriction":"Time"},{"name":"mtime","doc":null,"default_value":"","external_name":"mtime","restriction":"Time"},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(atime : Time, mtime : Time, filename : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L769","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L769","def":{"name":"utime","args":[{"name":"atime","doc":null,"default_value":"","external_name":"atime","restriction":"Time"},{"name":"mtime","doc":null,"default_value":"","external_name":"mtime","restriction":"Time"},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.utime(atime, mtime, filename)"}},{"id":"writable?(path):Bool-class-method","html_id":"writable?(path):Bool-class-method","name":"writable?","doc":"Returns `true` if *path* is writable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.writable?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is writable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L134","def":{"name":"writable?","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.writable?(path)"}},{"id":"write(filename,content,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,mode=&quot;w&quot;)-class-method","html_id":"write(filename,content,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,mode=&amp;quot;w&amp;quot;)-class-method","name":"write","doc":"Write the given *content* to *filename*.\n\nThe *mode* parameter can be used to change the file's `open` mode, e.g. to `\"a\"` for appending.\n\nBy default, an existing file will be overwritten.\n\n*filename* will be created if it does not already exist.\n\n```\nFile.write(\"foo\", \"bar\")\nFile.write(\"foo\", \"baz\", mode: \"a\")\n```\n\nNOTE: If the content is a `Slice(UInt8)`, those bytes will be written.\nIf it's an `IO`, all bytes from the `IO` will be written.\nOtherwise, the string representation of *content* will be written\n(the result of invoking `to_s` on *content*).","summary":"<p>Write the given <em>content</em> to <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"mode","doc":null,"default_value":"\"w\"","external_name":"mode","restriction":""}],"args_string":"(filename, content, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, mode = <span class=\"s\">&quot;w&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L695","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L695","def":{"name":"write","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""},{"name":"mode","doc":null,"default_value":"\"w\"","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"open(filename, mode, perm, encoding: encoding, invalid: invalid) do |file|\n  case content\n  when Bytes\n    file.write(content)\n  when IO\n    IO.copy(content, file)\n  else\n    file.print(content)\n  end\nend"}}],"constructors":[{"id":"new(filename:String,mode=&quot;r&quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil)-class-method","html_id":"new(filename:String,mode=&amp;quot;r&amp;quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename : String, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L30","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fd = Crystal::System::File.open(filename, mode, perm)\nnew(filename, fd, blocking: true, encoding: encoding, invalid: invalid)\n"}},{"id":"open(filename,mode=&quot;r&quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil):self-class-method","html_id":"open(filename,mode=&amp;quot;r&amp;quot;,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil):self-class-method","name":"open","doc":"Opens the file named by *filename*. If a file is being created, its initial\npermissions may be set using the *perm* parameter.","summary":"<p>Opens the file named by <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L600","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L600","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"mode","doc":null,"default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","doc":null,"default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(filename, mode, perm, encoding, invalid)"}}],"instance_methods":[{"id":"flock_exclusive(blocking=true,&block)-instance-method","html_id":"flock_exclusive(blocking=true,&amp;block)-instance-method","name":"flock_exclusive","doc":null,"summary":null,"abstract":false,"args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L840","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L840","def":{"name":"flock_exclusive","args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"flock_exclusive(blocking)\nbegin\n  yield\nensure\n  flock_unlock\nend\n"}},{"id":"flock_exclusive(blocking=true)-instance-method","html_id":"flock_exclusive(blocking=true)-instance-method","name":"flock_exclusive","doc":"Place an exclusive advisory lock. Only one process may hold an exclusive lock for a given file at a given time.\n`Errno::EWOULDBLOCK` is raised if *blocking* is set to `false` and any existing lock is set.","summary":"<p>Place an exclusive advisory lock.</p>","abstract":false,"args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L851","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L851","def":{"name":"flock_exclusive","args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_flock_exclusive(blocking)"}},{"id":"flock_shared(blocking=true,&block)-instance-method","html_id":"flock_shared(blocking=true,&amp;block)-instance-method","name":"flock_shared","doc":null,"summary":null,"abstract":false,"args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L825","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L825","def":{"name":"flock_shared","args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"flock_shared(blocking)\nbegin\n  yield\nensure\n  flock_unlock\nend\n"}},{"id":"flock_shared(blocking=true)-instance-method","html_id":"flock_shared(blocking=true)-instance-method","name":"flock_shared","doc":"Place a shared advisory lock. More than one process may hold a shared lock for a given file at a given time.\n`Errno::EWOULDBLOCK` is raised if *blocking* is set to `false` and an existing exclusive lock is set.","summary":"<p>Place a shared advisory lock.</p>","abstract":false,"args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L836","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L836","def":{"name":"flock_shared","args":[{"name":"blocking","doc":null,"default_value":"true","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_flock_shared(blocking)"}},{"id":"flock_unlock-instance-method","html_id":"flock_unlock-instance-method","name":"flock_unlock","doc":"Remove an existing advisory lock held by this process.","summary":"<p>Remove an existing advisory lock held by this process.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L856","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L856","def":{"name":"flock_unlock","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_flock_unlock"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L815","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L815","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(io << \"#<File:\") << @path\nif closed?\n  io << \" (closed)\"\nend\nio << '>'\nio\n"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L35","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}},{"id":"read_at(offset,bytesize,&block)-instance-method","html_id":"read_at(offset,bytesize,&amp;block)-instance-method","name":"read_at","doc":"Yields an `IO` to read a section inside this file.\nMultiple sections can be read concurrently.","summary":"<p>Yields an <code><a href=\"IO.html\">IO</a></code> to read a section inside this file.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L796","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L796","def":{"name":"read_at","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"self_bytesize = self.size\nif 0 <= offset && offset <= self_bytesize\nelse\n  raise(ArgumentError.new(\"Offset out of bounds\"))\nend\nif bytesize < 0\n  raise(ArgumentError.new(\"Negative bytesize\"))\nend\nif 0 <= (__temp_19 = offset + bytesize) && __temp_19 <= self_bytesize\nelse\n  raise(ArgumentError.new(\"Bytesize out of bounds\"))\nend\nio = PReader.new(fd, offset, bytesize)\nbegin\n  yield io\nensure\n  io.close\nend\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Return the size in bytes of the currently opened file.","summary":"<p>Return the size in bytes of the currently opened file.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L783","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L783","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"info.size"}},{"id":"truncate(size=0):Nil-instance-method","html_id":"truncate(size=0):Nil-instance-method","name":"truncate","doc":"Truncates the file to the specified *size*. Requires that the current file is opened\nfor writing.","summary":"<p>Truncates the file to the specified <em>size</em>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"0","external_name":"size","restriction":""}],"args_string":"(size = <span class=\"n\">0</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L789","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr#L789","def":{"name":"truncate","args":[{"name":"size","doc":null,"default_value":"0","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"flush\nsystem_truncate(size)\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/File/BadPatternError","path":"File/BadPatternError.html","kind":"class","full_name":"File::BadPatternError","name":"BadPatternError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file.cr","line_number":370,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/File/Flags","path":"File/Flags.html","kind":"enum","full_name":"File::Flags","name":"Flags","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file/info.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"SetUser","name":"SetUser","value":"1_u8","doc":null,"summary":null},{"id":"SetGroup","name":"SetGroup","value":"2_u8","doc":null,"summary":null},{"id":"Sticky","name":"Sticky","value":"4_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents the various behaviour-altering flags which can be set on files.\nNot all flags will be supported on all platforms.","summary":"<p>Represents the various behaviour-altering flags which can be set on files.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L5","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"set_group?-instance-method","html_id":"set_group?-instance-method","name":"set_group?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L7","def":{"name":"set_group?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SetGroup)"}},{"id":"set_user?-instance-method","html_id":"set_user?-instance-method","name":"set_user?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L6","def":{"name":"set_user?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SetUser)"}},{"id":"sticky?-instance-method","html_id":"sticky?-instance-method","name":"sticky?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L8","def":{"name":"sticky?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Sticky)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/File/Info","path":"File/Info.html","kind":"struct","full_name":"File::Info","name":"Info","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file/info.cr","line_number":80,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Crystal/System/FileInfo","kind":"struct","full_name":"Crystal::System::FileInfo","name":"FileInfo"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"A `File::Info` contains metadata regarding a file. It is returned by\n`File.info`, and `File#info`.","summary":"<p>A <code><a href=\"../File/Info.html\">File::Info</a></code> contains metadata regarding a file.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L80","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"id":"directory?-instance-method","html_id":"directory?-instance-method","name":"directory?","doc":"Returns true if this `Info` represents a directory. Shortcut for\n`type.directory?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a directory.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L116","def":{"name":"directory?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type.directory?"}},{"id":"file?-instance-method","html_id":"file?-instance-method","name":"file?","doc":"Returns true if this `Info` represents a standard file. Shortcut for\n`type.file?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a standard file.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L110","def":{"name":"file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type.file?"}},{"id":"flags:Flags-instance-method","html_id":"flags:Flags-instance-method","name":"flags","doc":"The special flags this file has set.","summary":"<p>The special flags this file has set.</p>","abstract":true,"args":[],"args_string":" : Flags","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L91","def":{"name":"flags","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Flags","visibility":"Public","body":""}},{"id":"group:UInt32-instance-method","html_id":"group:UInt32-instance-method","name":"group","doc":"The group ID that the file belongs to.","summary":"<p>The group ID that the file belongs to.</p>","abstract":true,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L100","def":{"name":"group","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":""}},{"id":"modification_time:Time-instance-method","html_id":"modification_time:Time-instance-method","name":"modification_time","doc":"The last time this file was modified.","summary":"<p>The last time this file was modified.</p>","abstract":true,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L94","def":{"name":"modification_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":""}},{"id":"owner:UInt32-instance-method","html_id":"owner:UInt32-instance-method","name":"owner","doc":"The user ID of the file's owner.","summary":"<p>The user ID of the file's owner.</p>","abstract":true,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L97","def":{"name":"owner","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":""}},{"id":"permissions:Permissions-instance-method","html_id":"permissions:Permissions-instance-method","name":"permissions","doc":"The permissions of the file.","summary":"<p>The permissions of the file.</p>","abstract":true,"args":[],"args_string":" : Permissions","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L85","def":{"name":"permissions","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Permissions","visibility":"Public","body":""}},{"id":"same_file?(other:File::Info):Bool-instance-method","html_id":"same_file?(other:File::Info):Bool-instance-method","name":"same_file?","doc":"Returns true if this `Info` and *other* are of the same file.\n\nOn unix, this compares device and inode fields, and will compare equal for\nhard linked files.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> and <em>other</em> are of the same file.</p>","abstract":true,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"File::Info"}],"args_string":"(other : File::Info) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L106","def":{"name":"same_file?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"File::Info"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":""}},{"id":"size:UInt64-instance-method","html_id":"size:UInt64-instance-method","name":"size","doc":"Size of the file, in bytes.","summary":"<p>Size of the file, in bytes.</p>","abstract":true,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L82","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":""}},{"id":"symlink?-instance-method","html_id":"symlink?-instance-method","name":"symlink?","doc":"Returns true if this `Info` represents a symbolic link to another file.\nShortcut for `type.symlink?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a symbolic link to another file.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L122","def":{"name":"symlink?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type.symlink?"}},{"id":"type:Type-instance-method","html_id":"type:Type-instance-method","name":"type","doc":"The type of the file.","summary":"<p>The type of the file.</p>","abstract":true,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L88","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/File/Permissions","path":"File/Permissions.html","kind":"enum","full_name":"File::Permissions","name":"Permissions","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file/info.cr","line_number":41,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"OtherExecute","name":"OtherExecute","value":"1_i16","doc":null,"summary":null},{"id":"OtherWrite","name":"OtherWrite","value":"2_i16","doc":null,"summary":null},{"id":"OtherRead","name":"OtherRead","value":"4_i16","doc":null,"summary":null},{"id":"OtherAll","name":"OtherAll","value":"7_i16","doc":null,"summary":null},{"id":"GroupExecute","name":"GroupExecute","value":"8_i16","doc":null,"summary":null},{"id":"GroupWrite","name":"GroupWrite","value":"16_i16","doc":null,"summary":null},{"id":"GroupRead","name":"GroupRead","value":"32_i16","doc":null,"summary":null},{"id":"GroupAll","name":"GroupAll","value":"56_i16","doc":null,"summary":null},{"id":"OwnerExecute","name":"OwnerExecute","value":"64_i16","doc":null,"summary":null},{"id":"OwnerWrite","name":"OwnerWrite","value":"128_i16","doc":null,"summary":null},{"id":"OwnerRead","name":"OwnerRead","value":"256_i16","doc":null,"summary":null},{"id":"OwnerAll","name":"OwnerAll","value":"448_i16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents a set of access permissions for a file. Not all permission sets\nwill be supported on all platforms.\n\nThe binary representation of this enum is defined to be same representation\nas the permission bits of a unix `st_mode` field. `File::Permissions`\ncan also be compared to it's underlying bitset, for example\n`File::Permissions::All == 0o777` will always be `true`.\n\nOn windows, only the `OwnerWrite` bit is effective. All file permissions\nwill either be `0o444` for read-only files or `0o666` for read-write files.\nDirectories are always mode `0o555` for read-only or `0o777`.","summary":"<p>Represents a set of access permissions for a file.</p>","class_methods":[],"constructors":[{"id":"new(int:Int)-class-method","html_id":"new(int:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int"}],"args_string":"(int : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L57","def":{"name":"new","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(int.to_i16)"}}],"instance_methods":[{"id":"group_all?-instance-method","html_id":"group_all?-instance-method","name":"group_all?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L50","def":{"name":"group_all?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(GroupAll)"}},{"id":"group_execute?-instance-method","html_id":"group_execute?-instance-method","name":"group_execute?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L47","def":{"name":"group_execute?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(GroupExecute)"}},{"id":"group_read?-instance-method","html_id":"group_read?-instance-method","name":"group_read?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L49","def":{"name":"group_read?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(GroupRead)"}},{"id":"group_write?-instance-method","html_id":"group_write?-instance-method","name":"group_write?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L48","def":{"name":"group_write?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(GroupWrite)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L41","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"other_all?-instance-method","html_id":"other_all?-instance-method","name":"other_all?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L45","def":{"name":"other_all?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OtherAll)"}},{"id":"other_execute?-instance-method","html_id":"other_execute?-instance-method","name":"other_execute?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L42","def":{"name":"other_execute?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OtherExecute)"}},{"id":"other_read?-instance-method","html_id":"other_read?-instance-method","name":"other_read?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L44","def":{"name":"other_read?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OtherRead)"}},{"id":"other_write?-instance-method","html_id":"other_write?-instance-method","name":"other_write?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L43","def":{"name":"other_write?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OtherWrite)"}},{"id":"owner_all?-instance-method","html_id":"owner_all?-instance-method","name":"owner_all?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L55","def":{"name":"owner_all?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OwnerAll)"}},{"id":"owner_execute?-instance-method","html_id":"owner_execute?-instance-method","name":"owner_execute?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L52","def":{"name":"owner_execute?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OwnerExecute)"}},{"id":"owner_read?-instance-method","html_id":"owner_read?-instance-method","name":"owner_read?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L54","def":{"name":"owner_read?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OwnerRead)"}},{"id":"owner_write?-instance-method","html_id":"owner_write?-instance-method","name":"owner_write?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L53","def":{"name":"owner_write?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OwnerWrite)"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L61","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << (owner_read? ? 'r' : '-')\nio << (owner_write? ? 'w' : '-')\nio << (owner_execute? ? 'x' : '-')\nio << (group_read? ? 'r' : '-')\nio << (group_write? ? 'w' : '-')\nio << (group_execute? ? 'x' : '-')\nio << (other_read? ? 'r' : '-')\nio << (other_write? ? 'w' : '-')\nio << (other_execute? ? 'x' : '-')\n((io << \" (0o\") << (self.to_i.to_s(8))) << ')'\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/File/Type","path":"File/Type.html","kind":"enum","full_name":"File::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"file/info.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"File","name":"File","value":"0_u8","doc":null,"summary":null},{"id":"Directory","name":"Directory","value":"1_u8","doc":null,"summary":null},{"id":"Symlink","name":"Symlink","value":"2_u8","doc":null,"summary":null},{"id":"Socket","name":"Socket","value":"3_u8","doc":null,"summary":null},{"id":"Pipe","name":"Pipe","value":"4_u8","doc":null,"summary":null},{"id":"CharacterDevice","name":"CharacterDevice","value":"5_u8","doc":null,"summary":null},{"id":"BlockDevice","name":"BlockDevice","value":"6_u8","doc":null,"summary":null},{"id":"Unknown","name":"Unknown","value":"7_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents the type of a file. Not all types will be supported on all\nplatforms.","summary":"<p>Represents the type of a file.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"block_device?-instance-method","html_id":"block_device?-instance-method","name":"block_device?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L20","def":{"name":"block_device?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BlockDevice"}},{"id":"character_device?-instance-method","html_id":"character_device?-instance-method","name":"character_device?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L19","def":{"name":"character_device?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CharacterDevice"}},{"id":"device?-instance-method","html_id":"device?-instance-method","name":"device?","doc":"Returns true if `self` is a `CharacterDevice` or a `BlockDevice`.","summary":"<p>Returns true if <code>self</code> is a <code><a href=\"../File/Type.html#CharacterDevice\">CharacterDevice</a></code> or a <code><a href=\"../File/Type.html#BlockDevice\">BlockDevice</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L24","def":{"name":"device?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"character_device? || block_device?"}},{"id":"directory?-instance-method","html_id":"directory?-instance-method","name":"directory?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L15","def":{"name":"directory?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Directory"}},{"id":"file?-instance-method","html_id":"file?-instance-method","name":"file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L14","def":{"name":"file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == File"}},{"id":"pipe?-instance-method","html_id":"pipe?-instance-method","name":"pipe?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L18","def":{"name":"pipe?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Pipe"}},{"id":"socket?-instance-method","html_id":"socket?-instance-method","name":"socket?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L17","def":{"name":"socket?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Socket"}},{"id":"symlink?-instance-method","html_id":"symlink?-instance-method","name":"symlink?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L16","def":{"name":"symlink?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Symlink"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file/info.cr#L21","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Unknown"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/FileUtils","path":"FileUtils.html","kind":"module","full_name":"FileUtils","name":"FileUtils","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"file_utils.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/FileUtils","kind":"module","full_name":"FileUtils","name":"FileUtils"}],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"cd(path:String)-instance-method","html_id":"cd(path:String)-instance-method","name":"cd","doc":"Changes the current working directory of the process to the given string *path*.\n\n```\nrequire \"file_utils\"\n\nFileUtils.cd(\"/tmp\")\n```\n\nNOTE: Alias of `Dir.cd`","summary":"<p>Changes the current working directory of the process to the given string <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L13","def":{"name":"cd","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Dir.cd(path)"}},{"id":"cd(path:String,&block)-instance-method","html_id":"cd(path:String,&amp;block)-instance-method","name":"cd","doc":"Changes the current working directory of the process to the given string *path*\nand invoked the block, restoring the original working directory when the block exits.\n\n```\nFileUtils.cd(\"/tmp\") { Dir.current } # => \"/tmp\"\n```\n\nNOTE: Alias of `Dir.cd` with block","summary":"<p>Changes the current working directory of the process to the given string <em>path</em> and invoked the block, restoring the original working directory when the block exits.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L25","def":{"name":"cd","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"Dir.cd(path) do\n  yield\nend"}},{"id":"cmp(filename1:String,filename2:String)-instance-method","html_id":"cmp(filename1:String,filename2:String)-instance-method","name":"cmp","doc":"Compares two files *filename1* to *filename2* to determine if they are identical.\nReturns `true` if content are the same, `false` otherwise.\n\n```\nFile.write(\"file.cr\", \"1\")\nFile.write(\"bar.cr\", \"1\")\nFileUtils.cmp(\"file.cr\", \"bar.cr\") # => true\n```","summary":"<p>Compares two files <em>filename1</em> to <em>filename2</em> to determine if they are identical.</p>","abstract":false,"args":[{"name":"filename1","doc":null,"default_value":"","external_name":"filename1","restriction":"String"},{"name":"filename2","doc":null,"default_value":"","external_name":"filename2","restriction":"String"}],"args_string":"(filename1 : String, filename2 : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L37","def":{"name":"cmp","args":[{"name":"filename1","doc":null,"default_value":"","external_name":"filename1","restriction":"String"},{"name":"filename2","doc":null,"default_value":"","external_name":"filename2","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (File.size(filename1)) == (File.size(filename2))\nelse\n  return false\nend\nFile.open(filename1, \"rb\") do |file1|\n  File.open(filename2, \"rb\") do |file2|\n    cmp(file1, file2)\n  end\nend\n"}},{"id":"cmp(stream1:IO,stream2:IO)-instance-method","html_id":"cmp(stream1:IO,stream2:IO)-instance-method","name":"cmp","doc":"Compares two streams *stream1* to *stream2* to determine if they are identical.\nReturns `true` if content are the same, `false` otherwise.\n\n```\nFile.write(\"afile\", \"123\")\nstream1 = File.open(\"afile\")\nstream2 = IO::Memory.new(\"123\")\nFileUtils.cmp(stream1, stream2) # => true\n```","summary":"<p>Compares two streams <em>stream1</em> to <em>stream2</em> to determine if they are identical.</p>","abstract":false,"args":[{"name":"stream1","doc":null,"default_value":"","external_name":"stream1","restriction":"IO"},{"name":"stream2","doc":null,"default_value":"","external_name":"stream2","restriction":"IO"}],"args_string":"(stream1 : IO, stream2 : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L56","def":{"name":"cmp","args":[{"name":"stream1","doc":null,"default_value":"","external_name":"stream1","restriction":"IO"},{"name":"stream2","doc":null,"default_value":"","external_name":"stream2","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buf1 = uninitialized ::StaticArray(UInt8, 1024)\nbuf2 = uninitialized ::StaticArray(UInt8, 1024)\nwhile true\n  read1 = stream1.read(buf1.to_slice)\n  read2 = stream2.read_fully?(buf2.to_slice[0, read1])\n  if read2\n  else\n    return false\n  end\n  if (buf1.to_unsafe.memcmp(buf2.to_unsafe, read1)) != 0\n    return false\n  end\n  if read1 == 0\n    return true\n  end\nend\n"}},{"id":"cp(src_path:String,dest:String)-instance-method","html_id":"cp(src_path:String,dest:String)-instance-method","name":"cp","doc":"Copies the file *src_path* to the file or directory *dest*.\nIf *dest* is a directory, a file with the same basename as *src_path* is created in *dest*\nPermission bits are copied too.\n\n```\nFile.chmod(\"afile\", 0o600)\nFileUtils.cp(\"afile\", \"afile_copy\")\nFile.info(\"afile_copy\").permissions # => 0o600\n```","summary":"<p>Copies the file <em>src_path</em> to the file or directory <em>dest</em>.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"args_string":"(src_path : String, dest : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L107","def":{"name":"cp","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"File.open(src_path) do |s|\n  if Dir.exists?(dest)\n    dest = dest + (File::SEPARATOR + (File.basename(src_path)))\n  end\n  File.open(dest, \"wb\", s.info.permissions) do |d|\n    IO.copy(s, d)\n  end\nend"}},{"id":"cp(srcs:Enumerable(String),dest:String)-instance-method","html_id":"cp(srcs:Enumerable(String),dest:String)-instance-method","name":"cp","doc":"Copies a list of files *src* to *dest*.\n*dest* must be an existing directory.\n\n```\nDir.mkdir(\"files\")\nFileUtils.cp({\"bar.cr\", \"afile\"}, \"files\")\n```","summary":"<p>Copies a list of files <em>src</em> to <em>dest</em>.</p>","abstract":false,"args":[{"name":"srcs","doc":null,"default_value":"","external_name":"srcs","restriction":"Enumerable(String)"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"args_string":"(srcs : Enumerable(String), dest : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L123","def":{"name":"cp","args":[{"name":"srcs","doc":null,"default_value":"","external_name":"srcs","restriction":"Enumerable(String)"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest}\"))\nend\nsrcs.each do |src|\n  cp(src, dest)\nend\n"}},{"id":"cp_r(src_path:String,dest_path:String)-instance-method","html_id":"cp_r(src_path:String,dest_path:String)-instance-method","name":"cp_r","doc":"Copies a file or directory *src_path* to *dest_path*.\nIf *src_path* is a directory, this method copies all its contents recursively.\n\n```\nFileUtils.cp_r(\"files\", \"dir\")\n```","summary":"<p>Copies a file or directory <em>src_path</em> to <em>dest_path</em>.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"args_string":"(src_path : String, dest_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L136","def":{"name":"cp_r","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(src_path)\n  Dir.mkdir(dest_path)\n  Dir.each_child(src_path) do |entry|\n    src = File.join(src_path, entry)\n    dest = File.join(dest_path, entry)\n    cp_r(src, dest)\n  end\nelse\n  cp(src_path, dest_path)\nend"}},{"id":"ln(src_path:String,dest_path:String)-instance-method","html_id":"ln(src_path:String,dest_path:String)-instance-method","name":"ln","doc":"Creates a hard link *dest_path* which points to *src_path*.\nIf *dest_path* already exists and is a directory, creates a link *dest_path/src_path*.\n\n```\n# Create a hard link, pointing from /usr/bin/emacs to /usr/bin/vim\nFileUtils.ln(\"/usr/bin/vim\", \"/usr/bin/emacs\")\n# Create a hard link, pointing from /tmp/foo.c to foo.c\nFileUtils.ln(\"foo.c\", \"/tmp\")\n```","summary":"<p>Creates a hard link <em>dest_path</em> which points to <em>src_path</em>.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"args_string":"(src_path : String, dest_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L158","def":{"name":"ln","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest_path)\n  File.link(src_path, File.join(dest_path, File.basename(src_path)))\nelse\n  File.link(src_path, dest_path)\nend"}},{"id":"ln(src_paths:Enumerable(String),dest_dir:String)-instance-method","html_id":"ln(src_paths:Enumerable(String),dest_dir:String)-instance-method","name":"ln","doc":"Creates a hard link to each path in *src_paths* inside the *dest_dir* directory.\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\n# Create /usr/bin/vim, /usr/bin/emacs, and /usr/bin/nano as hard links\nFileUtils.ln([\"vim\", \"emacs\", \"nano\"], \"/usr/bin\")\n```","summary":"<p>Creates a hard link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory.</p>","abstract":false,"args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"args_string":"(src_paths : Enumerable(String), dest_dir : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L173","def":{"name":"ln","args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln(path, dest_dir)\nend\n"}},{"id":"ln_s(src_path:String,dest_path:String)-instance-method","html_id":"ln_s(src_path:String,dest_path:String)-instance-method","name":"ln_s","doc":"Creates a symbolic link *dest_path* which points to *src_path*.\nIf *dest_path* already exists and is a directory, creates a link *dest_path/src_path*.\n\n```\n# Create a symbolic link pointing from logs to /var/log\nFileUtils.ln_s(\"/var/log\", \"logs\")\n# Create a symbolic link pointing from /tmp/src to src\nFileUtils.ln_s(\"src\", \"/tmp\")\n```","summary":"<p>Creates a symbolic link <em>dest_path</em> which points to <em>src_path</em>.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"args_string":"(src_path : String, dest_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L190","def":{"name":"ln_s","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest_path)\n  File.symlink(src_path, File.join(dest_path, File.basename(src_path)))\nelse\n  File.symlink(src_path, dest_path)\nend"}},{"id":"ln_s(src_paths:Enumerable(String),dest_dir:String)-instance-method","html_id":"ln_s(src_paths:Enumerable(String),dest_dir:String)-instance-method","name":"ln_s","doc":"Creates a symbolic link to each path in *src_paths* inside the *dest_dir* directory.\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\n# Create symbolic links in src/ pointing to every .c file in the current directory\nFileUtils.ln_s(Dir[\"*.c\"], \"src\")\n```","summary":"<p>Creates a symbolic link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory.</p>","abstract":false,"args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"args_string":"(src_paths : Enumerable(String), dest_dir : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L205","def":{"name":"ln_s","args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln_s(path, dest_dir)\nend\n"}},{"id":"ln_sf(src_path:String,dest_path:String)-instance-method","html_id":"ln_sf(src_path:String,dest_path:String)-instance-method","name":"ln_sf","doc":"Like `#ln_s(String, String)`, but overwrites `dest_path` if it exists and is not a directory\nor if `dest_path/src_path` exists.\n\n```\n# Create a symbolic link pointing from bar.c to foo.c, even if bar.c already exists\nFileUtils.ln_sf(\"foo.c\", \"bar.c\")\n```","summary":"<p>Like <code><a href=\"FileUtils.html#ln_s%28src_path%3AString%2Cdest_path%3AString%29-instance-method\">#ln_s(String, String)</a></code>, but overwrites <code>dest_path</code> if it exists and is not a directory or if <code>dest_path/src_path</code> exists.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"args_string":"(src_path : String, dest_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L220","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L220","def":{"name":"ln_sf","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if File.directory?(dest_path)\n  dest_path = File.join(dest_path, File.basename(src_path))\nend\nif File.file?(dest_path)\n  File.delete(dest_path)\nend\nFile.symlink(src_path, dest_path)\n"}},{"id":"ln_sf(src_paths:Enumerable(String),dest_dir:String)-instance-method","html_id":"ln_sf(src_paths:Enumerable(String),dest_dir:String)-instance-method","name":"ln_sf","doc":"Creates a symbolic link to each path in *src_paths* inside the *dest_dir* directory,\nignoring any overwritten paths.\n\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\n# Create symbolic links in src/ pointing to every .c file in the current directory,\n# even if it means overwriting files in src/\nFileUtils.ln_sf(Dir[\"*.c\"], \"src\")\n```","summary":"<p>Creates a symbolic link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory, ignoring any overwritten paths.</p>","abstract":false,"args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"args_string":"(src_paths : Enumerable(String), dest_dir : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L239","def":{"name":"ln_sf","args":[{"name":"src_paths","doc":null,"default_value":"","external_name":"src_paths","restriction":"Enumerable(String)"},{"name":"dest_dir","doc":null,"default_value":"","external_name":"dest_dir","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln_sf(path, dest_dir)\nend\n"}},{"id":"mkdir(paths:Enumerable(String),mode=511):Nil-instance-method","html_id":"mkdir(paths:Enumerable(String),mode=511):Nil-instance-method","name":"mkdir","doc":"Creates a new directory at the given *paths*. The linux-style permission *mode*\ncan be specified, with a default of 777 (0o777).\n\n```\nFileUtils.mkdir([\"foo\", \"bar\"])\n```","summary":"<p>Creates a new directory at the given <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(paths : Enumerable(String), mode = <span class=\"n\">511</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L265","def":{"name":"mkdir","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.mkdir(path, mode)\nend"}},{"id":"mkdir(path:String,mode=511):Nil-instance-method","html_id":"mkdir(path:String,mode=511):Nil-instance-method","name":"mkdir","doc":"Creates a new directory at the given *path*. The linux-style permission *mode*\ncan be specified, with a default of 777 (0o777).\n\n```\nFileUtils.mkdir(\"src\")\n```\n\nNOTE: Alias of `Dir.mkdir`","summary":"<p>Creates a new directory at the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : String, mode = <span class=\"n\">511</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L255","def":{"name":"mkdir","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Dir.mkdir(path, mode)"}},{"id":"mkdir_p(path:String,mode=511):Nil-instance-method","html_id":"mkdir_p(path:String,mode=511):Nil-instance-method","name":"mkdir_p","doc":"Creates a new directory at the given *path*, including any non-existing\nintermediate directories. The linux-style permission *mode* can be specified,\nwith a default of 777 (0o777).\n\n```\nFileUtils.mkdir_p(\"foo\")\n```\n\nNOTE: Alias of `Dir.mkdir_p`","summary":"<p>Creates a new directory at the given <em>path</em>, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : String, mode = <span class=\"n\">511</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L280","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L280","def":{"name":"mkdir_p","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Dir.mkdir_p(path, mode)"}},{"id":"mkdir_p(paths:Enumerable(String),mode=511):Nil-instance-method","html_id":"mkdir_p(paths:Enumerable(String),mode=511):Nil-instance-method","name":"mkdir_p","doc":"Creates a new directory at the given *paths*, including any non-existing\nintermediate directories. The linux-style permission *mode* can be specified,\nwith a default of 777 (0o777).\n\n```\nFileUtils.mkdir_p([\"foo\", \"bar\", \"baz\", \"dir1\", \"dir2\", \"dir3\"])\n```","summary":"<p>Creates a new directory at the given <em>paths</em>, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"args_string":"(paths : Enumerable(String), mode = <span class=\"n\">511</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L291","def":{"name":"mkdir_p","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"mode","doc":null,"default_value":"511","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.mkdir_p(path, mode)\nend"}},{"id":"mv(src_path:String,dest_path:String):Nil-instance-method","html_id":"mv(src_path:String,dest_path:String):Nil-instance-method","name":"mv","doc":"Moves *src_path* to *dest_path*.\n\n```\nFileUtils.mv(\"afile\", \"afile.cr\")\n```\n\nNOTE: Alias of `File.rename`","summary":"<p>Moves <em>src_path</em> to <em>dest_path</em>.</p>","abstract":false,"args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"args_string":"(src_path : String, dest_path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L304","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L304","def":{"name":"mv","args":[{"name":"src_path","doc":null,"default_value":"","external_name":"src_path","restriction":"String"},{"name":"dest_path","doc":null,"default_value":"","external_name":"dest_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"File.rename(src_path, dest_path)"}},{"id":"mv(srcs:Enumerable(String),dest:String):Nil-instance-method","html_id":"mv(srcs:Enumerable(String),dest:String):Nil-instance-method","name":"mv","doc":"Moves every *srcs* to *dest*.\n\n```\nFileUtils.mv([\"foo\", \"bar\"], \"src\")\n```","summary":"<p>Moves every <em>srcs</em> to <em>dest</em>.</p>","abstract":false,"args":[{"name":"srcs","doc":null,"default_value":"","external_name":"srcs","restriction":"Enumerable(String)"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"args_string":"(srcs : Enumerable(String), dest : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L313","def":{"name":"mv","args":[{"name":"srcs","doc":null,"default_value":"","external_name":"srcs","restriction":"Enumerable(String)"},{"name":"dest","doc":null,"default_value":"","external_name":"dest","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest}\"))\nend\nsrcs.each do |src|\n  begin\n    mv(src, File.join(dest, File.basename(src)))\n  rescue Errno\n  end\nend\n"}},{"id":"pwd:String-instance-method","html_id":"pwd:String-instance-method","name":"pwd","doc":"Returns the current working directory.\n\n```\nFileUtils.pwd\n```\n\nNOTE: Alias of `Dir.current`","summary":"<p>Returns the current working directory.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L330","def":{"name":"pwd","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Dir.current"}},{"id":"rm(path:String):Nil-instance-method","html_id":"rm(path:String):Nil-instance-method","name":"rm","doc":"Deletes the *path* file given.\n\n```\nFileUtils.rm(\"afile.cr\")\n```\n\nNOTE: Alias of `File.delete`","summary":"<p>Deletes the <em>path</em> file given.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L341","def":{"name":"rm","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"File.delete(path)"}},{"id":"rm(paths:Enumerable(String)):Nil-instance-method","html_id":"rm(paths:Enumerable(String)):Nil-instance-method","name":"rm","doc":"Deletes all *paths* file given.\n\n```\nFileUtils.rm([\"dir/afile\", \"afile_copy\"])\n```","summary":"<p>Deletes all <em>paths</em> file given.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"args_string":"(paths : Enumerable(String)) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L350","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L350","def":{"name":"rm","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  File.delete(path)\nend"}},{"id":"rm_r(path:String):Nil-instance-method","html_id":"rm_r(path:String):Nil-instance-method","name":"rm_r","doc":"Deletes a file or directory *path*.\nIf *path* is a directory, this method removes all its contents recursively.\n\n```\nFileUtils.rm_r(\"dir\")\nFileUtils.rm_r(\"file.cr\")\n```","summary":"<p>Deletes a file or directory <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L363","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L363","def":{"name":"rm_r","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if (Dir.exists?(path)) && (!(File.symlink?(path)))\n  Dir.each_child(path) do |entry|\n    src = File.join(path, entry)\n    rm_r(src)\n  end\n  Dir.rmdir(path)\nelse\n  File.delete(path)\nend"}},{"id":"rm_r(paths:Enumerable(String)):Nil-instance-method","html_id":"rm_r(paths:Enumerable(String)):Nil-instance-method","name":"rm_r","doc":"Deletes a list of files or directories *paths*.\nIf one path is a directory, this method removes all its contents recursively.\n\n```\nFileUtils.rm_r([\"files\", \"bar.cr\"])\n```","summary":"<p>Deletes a list of files or directories <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"args_string":"(paths : Enumerable(String)) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L381","def":{"name":"rm_r","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  rm_r(path)\nend"}},{"id":"rm_rf(path:String):Nil-instance-method","html_id":"rm_rf(path:String):Nil-instance-method","name":"rm_rf","doc":"Deletes a file or directory *path*.\nIf *path* is a directory, this method removes all its contents recursively.\nIgnore all errors.\n\n```\nFileUtils.rm_rf(\"dir\")\nFileUtils.rm_rf(\"file.cr\")\nFileUtils.rm_rf(\"non_existent_file\")\n```","summary":"<p>Deletes a file or directory <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L396","def":{"name":"rm_rf","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"begin\n  rm_r(path)\nrescue Errno\nend"}},{"id":"rm_rf(paths:Enumerable(String)):Nil-instance-method","html_id":"rm_rf(paths:Enumerable(String)):Nil-instance-method","name":"rm_rf","doc":"Deletes a list of files or directories *paths*.\nIf one path is a directory, this method removes all its contents recursively.\nIgnore all errors.\n\n```\nFileUtils.rm_rf([\"dir\", \"file.cr\", \"non_existent_file\"])\n```","summary":"<p>Deletes a list of files or directories <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"args_string":"(paths : Enumerable(String)) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L410","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L410","def":{"name":"rm_rf","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  begin\n    rm_r(path)\n  rescue Errno\n  end\nend"}},{"id":"rmdir(path:String):Nil-instance-method","html_id":"rmdir(path:String):Nil-instance-method","name":"rmdir","doc":"Removes the directory at the given *path*.\n\n```\nFileUtils.rmdir(\"baz\")\n```\n\nNOTE: Alias of `Dir.rmdir`","summary":"<p>Removes the directory at the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L426","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L426","def":{"name":"rmdir","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Dir.rmdir(path)"}},{"id":"rmdir(paths:Enumerable(String)):Nil-instance-method","html_id":"rmdir(paths:Enumerable(String)):Nil-instance-method","name":"rmdir","doc":"Removes all directories at the given *paths*.\n\n```\nFileUtils.rmdir([\"dir1\", \"dir2\", \"dir3\"])\n```","summary":"<p>Removes all directories at the given <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"args_string":"(paths : Enumerable(String)) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L435","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L435","def":{"name":"rmdir","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.rmdir(path)\nend"}},{"id":"touch(paths:Enumerable(String),time:Time=Time.now)-instance-method","html_id":"touch(paths:Enumerable(String),time:Time=Time.now)-instance-method","name":"touch","doc":"Attempts to set the access and modification times of each file given\nin the *paths* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.\n\n```\nFileUtils.touch([\"foo\", \"bar\"])\n```","summary":"<p>Attempts to set the access and modification times of each file given in the <em>paths</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"args_string":"(paths : Enumerable(String), time : Time = <span class=\"t\">Time</span>.now)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L92","def":{"name":"touch","args":[{"name":"paths","doc":null,"default_value":"","external_name":"paths","restriction":"Enumerable(String)"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"paths.each do |path|\n  touch(path, time)\nend"}},{"id":"touch(path:String,time:Time=Time.now)-instance-method","html_id":"touch(path:String,time:Time=Time.now)-instance-method","name":"touch","doc":"Attempts to set the access and modification times of the file named\nin the *path* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.\n\n```\nFileUtils.touch(\"afile.cr\")\n```\n\nNOTE: Alias of `File.touch`","summary":"<p>Attempts to set the access and modification times of the file named in the <em>path</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"args_string":"(path : String, time : Time = <span class=\"t\">Time</span>.now)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/file_utils.cr#L80","def":{"name":"touch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"File.touch(path, time)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Flate","path":"Flate.html","kind":"module","full_name":"Flate","name":"Flate","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"flate/reader.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr"},{"filename":"flate/flate.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"9","doc":null,"summary":null},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"1","doc":null,"summary":null},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"-1","doc":null,"summary":null},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"0","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The Flate module contains readers and writers of DEFLATE format compressed\ndata, as specified in [RFC 1951](https://www.ietf.org/rfc/rfc1951.txt).\n\nSee `Gzip`, `Zip` and `Zlib` for modules that provide access\nto DEFLATE-based file formats.","summary":"<p>The Flate module contains readers and writers of DEFLATE format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1951.txt\" target=\"_blank\">RFC 1951</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Flate/Error","path":"Flate/Error.html","kind":"class","full_name":"Flate::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"flate/flate.cr","line_number":23,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Flate","kind":"module","full_name":"Flate","name":"Flate"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ret,stream)-class-method","html_id":"new(ret,stream)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ret","doc":null,"default_value":"","external_name":"ret","restriction":""},{"name":"stream","doc":null,"default_value":"","external_name":"stream","restriction":""}],"args_string":"(ret, stream)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L24","def":{"name":"new","args":[{"name":"ret","doc":null,"default_value":"","external_name":"ret","restriction":""},{"name":"stream","doc":null,"default_value":"","external_name":"stream","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(ret, stream)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Flate/Reader","path":"Flate/Reader.html","kind":"class","full_name":"Flate::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"flate/reader.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Flate","kind":"module","full_name":"Flate","name":"Flate"},"doc":"A read-only `IO` object to decompress data in the DEFLATE format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.","summary":"<p>A read-only <code><a href=\"../IO.html\">IO</a></code> object to decompress data in the DEFLATE format.</p>","class_methods":[{"id":"gzip(input,sync_close:Bool=false,&block)-class-method","html_id":"gzip(input,sync_close:Bool=false,&amp;block)-class-method","name":"gzip","doc":"Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes\nit at its end.","summary":"<p>Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(input, sync_close : Bool = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L45","def":{"name":"gzip","args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = gzip(input, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"id":"open(io:IO,sync_close:Bool=false,dict:Bytes?=nil,&block)-class-method","html_id":"open(io:IO,sync_close:Bool=false,dict:Bytes?=nil,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at its end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close : Bool = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L32","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(io, sync_close: sync_close, dict: dict)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"id":"gzip(input,sync_close:Bool=false):self-class-method","html_id":"gzip(input,sync_close:Bool=false):self-class-method","name":"gzip","doc":"Creates an instance of Flate::Reader for the gzip format.\nhas written.","summary":"<p>Creates an instance of Flate::Reader for the gzip format.</p>","abstract":false,"args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(input, sync_close : Bool = <span class=\"n\">false</span>) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L39","def":{"name":"gzip","args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(input, wbits: GZIP, sync_close: sync_close)"}},{"id":"new(io:IO,sync_close:Bool=false,dict:Bytes?=nil)-class-method","html_id":"new(io:IO,sync_close:Bool=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates an instance of Flate::Reader.","summary":"<p>Creates an instance of Flate::Reader.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close : Bool = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L17","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this reader.","summary":"<p>Closes this reader.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L122","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nLibZ.inflateEnd(pointerof(@stream))\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L11","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L56","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nif @end\n  return 0\nend\nwhile true\n  if @stream.avail_in == 0\n    @peek = @io.peek\n    if peek = @peek\n      @stream.next_in = peek\n      @stream.avail_in = peek.size\n    else\n      @stream.next_in = @buf.to_unsafe\n      @stream.avail_in = (@io.read(@buf.to_slice)).to_u32\n    end\n  end\n  old_avail_in = @stream.avail_in\n  @stream.avail_out = slice.size.to_u32\n  @stream.next_out = slice.to_unsafe\n  ret = LibZ.inflate(pointerof(@stream), LibZ::Flush::NO_FLUSH)\n  read_bytes = slice.size - @stream.avail_out\n  avail_in_diff = old_avail_in - @stream.avail_in\n  if @peek && avail_in_diff > 0\n    @io.skip(avail_in_diff)\n  end\n  case ret\n  when LibZ::Error::NEED_DICT\n    if dict = @dict\n      ret = LibZ.inflateSetDictionary(pointerof(@stream), dict, dict.size)\n      if ret == LibZ::Error::OK\n        next\n      end\n    end\n    raise(Flate::Error.new(ret, @stream))\n  when LibZ::Error::DATA_ERROR, LibZ::Error::MEM_ERROR\n    raise(Flate::Error.new(ret, @stream))\n  when LibZ::Error::STREAM_END\n    @end = true\n    return read_bytes\n  else\n    if read_bytes == 0\n      next\n    else\n      return read_bytes\n    end\n  end\nend\n"}},{"id":"sync_close=(sync_close:Bool)-instance-method","html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../Flate/Reader.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L8","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../Flate/Reader.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L8","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/reader.cr#L51","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Flate::Reader\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Flate/Strategy","path":"Flate/Strategy.html","kind":"enum","full_name":"Flate::Strategy","name":"Strategy","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"flate/flate.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"FILTERED","name":"FILTERED","value":"1","doc":null,"summary":null},{"id":"HUFFMAN_ONLY","name":"HUFFMAN_ONLY","value":"2","doc":null,"summary":null},{"id":"RLE","name":"RLE","value":"3","doc":null,"summary":null},{"id":"FIXED","name":"FIXED","value":"4","doc":null,"summary":null},{"id":"DEFAULT","name":"DEFAULT","value":"0","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Flate","kind":"module","full_name":"Flate","name":"Flate"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"default?-instance-method","html_id":"default?-instance-method","name":"default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L20","def":{"name":"default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DEFAULT"}},{"id":"filtered?-instance-method","html_id":"filtered?-instance-method","name":"filtered?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L16","def":{"name":"filtered?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FILTERED"}},{"id":"fixed?-instance-method","html_id":"fixed?-instance-method","name":"fixed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L19","def":{"name":"fixed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FIXED"}},{"id":"huffman_only?-instance-method","html_id":"huffman_only?-instance-method","name":"huffman_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L17","def":{"name":"huffman_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HUFFMAN_ONLY"}},{"id":"rle?-instance-method","html_id":"rle?-instance-method","name":"rle?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/flate.cr#L18","def":{"name":"rle?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RLE"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Flate/Writer","path":"Flate/Writer.html","kind":"class","full_name":"Flate::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"flate/writer.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Flate","kind":"module","full_name":"Flate","name":"Flate"},"doc":"A write-only `IO` object to compress data in the DEFLATE format.\n\nInstances of this class wrap another IO object. When you write to this\ninstance, it compresses the data and writes it to the underlying IO.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a Flate::Writer instance.","summary":"<p>A write-only <code><a href=\"../IO.html\">IO</a></code> object to compress data in the DEFLATE format.</p>","class_methods":[{"id":"open(io:IO,level:Int32=Flate::DEFAULT_COMPRESSION,strategy:Flate::Strategy=Flate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil,&block)-class-method","html_id":"open(io:IO,level:Int32=Flate::DEFAULT_COMPRESSION,strategy:Flate::Strategy=Flate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil,&amp;block)-class-method","name":"open","doc":"Creates a new writer for the given *io*, yields it to the given block,\nand closes it at its end.","summary":"<p>Creates a new writer for the given <em>io</em>, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Flate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","doc":null,"default_value":"Flate::Strategy::DEFAULT","external_name":"strategy","restriction":"Flate::Strategy"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level : Int32 = <span class=\"t\">Flate</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, strategy : Flate::Strategy = <span class=\"t\">Flate</span><span class=\"t\">::</span><span class=\"t\">Strategy</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>, sync_close : Bool = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L35","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Flate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","doc":null,"default_value":"Flate::Strategy::DEFAULT","external_name":"strategy","restriction":"Flate::Strategy"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(io, level: level, strategy: strategy, sync_close: sync_close, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"id":"new(output:IO,level:Int32=Flate::DEFAULT_COMPRESSION,strategy:Flate::Strategy=Flate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil)-class-method","html_id":"new(output:IO,level:Int32=Flate::DEFAULT_COMPRESSION,strategy:Flate::Strategy=Flate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates an instance of Flate::Writer. `close` must be invoked after all data\nhas written.","summary":"<p>Creates an instance of Flate::Writer.</p>","abstract":false,"args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"},{"name":"level","doc":null,"default_value":"Flate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","doc":null,"default_value":"Flate::Strategy::DEFAULT","external_name":"strategy","restriction":"Flate::Strategy"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(output : IO, level : Int32 = <span class=\"t\">Flate</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, strategy : Flate::Strategy = <span class=\"t\">Flate</span><span class=\"t\">::</span><span class=\"t\">Strategy</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>, sync_close : Bool = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L14","def":{"name":"new","args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"},{"name":"level","doc":null,"default_value":"Flate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","doc":null,"default_value":"Flate::Strategy::DEFAULT","external_name":"strategy","restriction":"Flate::Strategy"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(output, level, strategy, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L66","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@stream.avail_in = 0\n@stream.next_in = Pointer(UInt8).null\nconsume_output(LibZ::Flush::FINISH)\nLibZ.deflateEnd(pointerof(@stream))\nif @sync_close\n  @output.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this IO is closed.","summary":"<p>Returns <code>true</code> if this IO is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L79","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"See `IO#flush`.","summary":"<p>See <code><a href=\"../IO.html#flush-instance-method\">IO#flush</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L59","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\nconsume_output(LibZ::Flush::SYNC_FLUSH)\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L43","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(\"Can't read from Flate::Writer\")"}},{"id":"sync_close=(sync_close:Bool)-instance-method","html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../Flate/Writer.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L10","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../Flate/Writer.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L10","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/flate/writer.cr#L48","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@stream.avail_in = slice.size\n@stream.next_in = slice\nconsume_output(LibZ::Flush::NO_FLUSH)\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Float","path":"Float.html","kind":"struct","full_name":"Float","name":"Float","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"float.cr","line_number":37,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr"},{"filename":"time/span.cr","line_number":473,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr"},{"filename":"big/big_int.cr","line_number":530,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr"},{"filename":"big/big_rational.cr","line_number":262,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr"},{"filename":"big/big_decimal.cr","line_number":454,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"},{"filename":"json/to_json.cr","line_number":45,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/BigFloat","kind":"struct","full_name":"BigFloat","name":"BigFloat"},{"html_id":"github.com/crystal-lang/crystal/Float32","kind":"struct","full_name":"Float32","name":"Float32"},{"html_id":"github.com/crystal-lang/crystal/Float64","kind":"struct","full_name":"Float64","name":"Float64"}],"including_types":[],"namespace":null,"doc":"Float is the base type of all floating point numbers.\n\nThere are two floating point types, `Float32` and `Float64`,\nwhich correspond to the [binary32](http://en.wikipedia.org/wiki/Single_precision_floating-point_format)\nand [binary64](http://en.wikipedia.org/wiki/Double_precision_floating-point_format)\ntypes defined by IEEE.\n\nA floating point literal is an optional `+` or `-` sign, followed by\na sequence of numbers or underscores, followed by a dot,\nfollowed by numbers or underscores, followed by an optional exponent suffix,\nfollowed by an optional type suffix. If no suffix is present, the literal's type is `Float64`.\n\n```\n1.0     # Float64\n1.0_f32 # Float32\n1_f32   # Float32\n\n1e10   # Float64\n1.5e10 # Float64\n1.5e-7 # Float64\n\n+1.3 # Float64\n-0.5 # Float64\n```\n\nThe underscore `_` before the suffix is optional.\n\nUnderscores can be used to make some numbers more readable:\n\n```\n1_000_000.111_111 # better than 1000000.111111\n```","summary":"<p>Float is the base type of all floating point numbers.</p>","class_methods":[],"constructors":[{"id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","html_id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","name":"from_io","doc":"Reads a float from the given *io* in the given *format*.\nSee also: `IO#read_bytes`.","summary":"<p>Reads a float from the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L102","def":{"name":"from_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"format.decode(self, io)"}}],"instance_methods":[{"id":"%(other)-instance-method","html_id":"%(other)-instance-method","name":"%","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L44","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"modulo(other)"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L40","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.zero - self"}},{"id":"(other:BigDecimal)-instance-method","html_id":"(other:BigDecimal)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L457","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L457","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_d <=> other"}},{"id":"(other:BigRational)-instance-method","html_id":"(other:BigRational)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L270","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"-(other <=> self)"}},{"id":"(other:BigInt)-instance-method","html_id":"(other:BigInt)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L533","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L533","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"-(other <=> self)"}},{"id":"days:Time::Span-instance-method","html_id":"days:Time::Span-instance-method","name":"days","doc":"Returns a `Time::Span` of `self` days.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> days.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L475","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L475","def":{"name":"days","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(self * 24).hours"}},{"id":"fdiv(other)-instance-method","html_id":"fdiv(other)-instance-method","name":"fdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L64","def":{"name":"fdiv","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self / other"}},{"id":"finite?-instance-method","html_id":"finite?-instance-method","name":"finite?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L60","def":{"name":"finite?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(!nan?) && (!infinite?)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L90","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.float(self)"}},{"id":"hours:Time::Span-instance-method","html_id":"hours:Time::Span-instance-method","name":"hours","doc":"Returns a `Time::Span` of `self` hours.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> hours.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L480","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L480","def":{"name":"hours","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(self * 60).minutes"}},{"id":"infinite?-instance-method","html_id":"infinite?-instance-method","name":"infinite?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L52","def":{"name":"infinite?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (nan? || (self == 0)) || (self != (2 * self))\n  nil\nelse\n  self > 0 ? 1 : -1\nend"}},{"id":"microseconds:Time::Span-instance-method","html_id":"microseconds:Time::Span-instance-method","name":"microseconds","doc":"Returns a `Time::Span` of `self` microseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> microseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L509","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L509","def":{"name":"microseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(self / 1000000).seconds"}},{"id":"milliseconds:Time::Span-instance-method","html_id":"milliseconds:Time::Span-instance-method","name":"milliseconds","doc":"Returns a `Time::Span` of `self` milliseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> milliseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L504","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L504","def":{"name":"milliseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(self / 1000).seconds"}},{"id":"minutes:Time::Span-instance-method","html_id":"minutes:Time::Span-instance-method","name":"minutes","doc":"Returns a `Time::Span` of `self` minutes.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> minutes.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L485","def":{"name":"minutes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(self * 60).seconds"}},{"id":"modulo(other)-instance-method","html_id":"modulo(other)-instance-method","name":"modulo","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L68","def":{"name":"modulo","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other == 0.0\n  raise(DivisionByZeroError.new)\nelse\n  self - (other * (self.fdiv(other)).floor)\nend"}},{"id":"nan?-instance-method","html_id":"nan?-instance-method","name":"nan?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L48","def":{"name":"nan?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(self == self)"}},{"id":"nanoseconds:Time::Span-instance-method","html_id":"nanoseconds:Time::Span-instance-method","name":"nanoseconds","doc":"Returns a `Time::Span` of `self` nanoseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> nanoseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L514","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L514","def":{"name":"nanoseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"seconds = (self / Time::NANOSECONDS_PER_SECOND).to_i64\nnanoseconds = self.remainder(Time::NANOSECONDS_PER_SECOND)\nnanoseconds = (nanoseconds < 0 ? (nanoseconds - 0.5) : (nanoseconds + 0.5)).to_i64\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"id":"remainder(other)-instance-method","html_id":"remainder(other)-instance-method","name":"remainder","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L76","def":{"name":"remainder","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other == 0.0\n  raise(DivisionByZeroError.new)\nelse\n  mod = self % other\n  if mod == 0.0\n    return self.class.zero\n  end\n  if self > 0 && other > 0\n    return mod\n  end\n  if self < 0 && other < 0\n    return mod\n  end\n  mod - other\nend"}},{"id":"seconds:Time::Span-instance-method","html_id":"seconds:Time::Span-instance-method","name":"seconds","doc":"Returns a `Time::Span` of `self` seconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> seconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L490","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L490","def":{"name":"seconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"seconds = self.to_i64\nnanoseconds = (self - seconds) * Time::NANOSECONDS_PER_SECOND\nnanoseconds = (nanoseconds < 0 ? (nanoseconds - 0.5) : (nanoseconds + 0.5)).to_i64\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"id":"to_big_d-instance-method","html_id":"to_big_d-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.\n\nNOTE: Floats are fundamentally less precise than BigDecimals,\nwhich makes conversion to them risky.","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L465","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L465","def":{"name":"to_big_d","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigDecimal.new(self)"}},{"id":"to_big_i:BigInt-instance-method","html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this float (rounded using `floor`).","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this float (rounded using <code>floor</code>).</p>","abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L538","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L538","def":{"name":"to_big_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new(self)"}},{"id":"to_big_r-instance-method","html_id":"to_big_r-instance-method","name":"to_big_r","doc":"Returns a `BigRational` representing this float.","summary":"<p>Returns a <code><a href=\"BigRational.html\">BigRational</a></code> representing this float.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L266","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L266","def":{"name":"to_big_r","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new(self)"}},{"id":"to_io(io:IO,format:IO::ByteFormat)-instance-method","html_id":"to_io(io:IO,format:IO::ByteFormat)-instance-method","name":"to_io","doc":"Writes this float to the given *io* in the given *format*.\nSee also: `IO#write_bytes`.","summary":"<p>Writes this float to the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L96","def":{"name":"to_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"format.encode(self, io)"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L46","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.number(self)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Float/Primitive","path":"Float/Primitive.html","kind":"alias","full_name":"Float::Primitive","name":"Primitive","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"float.cr","line_number":38,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Float32 | Float64)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Float/Printer","path":"Float/Printer.html","kind":"module","full_name":"Float::Printer","name":"Printer","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"float/printer/cached_powers.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr"},{"filename":"float/printer.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BUFFER_SIZE","name":"BUFFER_SIZE","value":"128","doc":null,"summary":null}],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Float/Printer","kind":"module","full_name":"Float::Printer","name":"Printer"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"doc":"Float::Printer is based on Grisu3 algorithm described in the 2004 paper\n\"Printing Floating-Point Numbers Quickly and Accurately with Integers\" by\nFlorian Loitsch.","summary":"<p>Float::Printer is based on Grisu3 algorithm described in the 2004 paper \"Printing Floating-Point Numbers Quickly and Accurately with Integers\" by Florian Loitsch.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"print(v:Float64|Float32,io:IO)-instance-method","html_id":"print(v:Float64|Float32,io:IO)-instance-method","name":"print","doc":"Converts Float *v* to a string representation and prints it onto *io*\n\nIt is used by `Float64#to_s` and it is probably not necessary to use\nthis directly.","summary":"<p>Converts Float <em>v</em> to a string representation and prints it onto <em>io</em></p>","abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(v : Float64 | Float32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer.cr#L14","def":{"name":"print","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"d = IEEE.to_uint(v)\nif (IEEE.sign(d)) < 0\n  io << '-'\n  v = -v\nend\nif v == 0.0\n  io << \"0.0\"\nelse\n  if IEEE.special?(d)\n    if IEEE.inf?(d)\n      io << \"Infinity\"\n    else\n      io << \"NaN\"\n    end\n  else\n    internal(v, io)\n  end\nend\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Float/Printer/CachedPowers","path":"Float/Printer/CachedPowers.html","kind":"module","full_name":"Float::Printer::CachedPowers","name":"CachedPowers","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"float/printer/cached_powers.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"CACHED_EXP_STEP","name":"CACHED_EXP_STEP","value":"8","doc":"Not all powers of ten are cached. The decimal exponent of two neighboring\ncached numbers will differ by `CACHED_EXP_STEP`","summary":"<p>Not all powers of ten are cached.</p>"},{"id":"CACHED_POWER_OFFSET","name":"CACHED_POWER_OFFSET","value":"348","doc":null,"summary":null},{"id":"D_1_LOG2_10","name":"D_1_LOG2_10","value":"0.30102999566398114","doc":null,"summary":null},{"id":"MAX_CACHED_EXP","name":"MAX_CACHED_EXP","value":"340","doc":null,"summary":null},{"id":"MAX_TARGET_EXP","name":"MAX_TARGET_EXP","value":"-32","doc":null,"summary":null},{"id":"MIN_CACHED_EXP","name":"MIN_CACHED_EXP","value":"-348","doc":null,"summary":null},{"id":"MIN_TARGET_EXP","name":"MIN_TARGET_EXP","value":"-60","doc":"The minimal and maximal target exponent define the range of w's binary\nexponent, where 'w' is the result of multiplying the input by a cached power\nof ten.\n\nA different range might be chosen on a different platform, to optimize digit\ngeneration, but a smaller range requires more powers of ten to be cached.","summary":"<p>The minimal and maximal target exponent define the range of w's binary exponent, where 'w' is the result of multiplying the input by a cached power of ten.</p>"},{"id":"Pow10Cache","name":"Pow10Cache","value":"{0, 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000}","doc":null,"summary":null},{"id":"PowCache","name":"PowCache","value":"[{18054884314459144840_u64, -1220_i16, -348_i16}, {13451937075301367670_u64, -1193_i16, -340_i16}, {10022474136428063862_u64, -1166_i16, -332_i16}, {14934650266808366570_u64, -1140_i16, -324_i16}, {11127181549972568877_u64, -1113_i16, -316_i16}, {16580792590934885855_u64, -1087_i16, -308_i16}, {12353653155963782858_u64, -1060_i16, -300_i16}, {18408377700990114895_u64, -1034_i16, -292_i16}, {13715310171984221708_u64, -1007_i16, -284_i16}, {10218702384817765436_u64, -980_i16, -276_i16}, {15227053142812498563_u64, -954_i16, -268_i16}, {11345038669416679861_u64, -927_i16, -260_i16}, {16905424996341287883_u64, -901_i16, -252_i16}, {12595523146049147757_u64, -874_i16, -244_i16}, {9384396036005875287_u64, -847_i16, -236_i16}, {13983839803942852151_u64, -821_i16, -228_i16}, {10418772551374772303_u64, -794_i16, -220_i16}, {15525180923007089351_u64, -768_i16, -212_i16}, {11567161174868858868_u64, -741_i16, -204_i16}, {17236413322193710309_u64, -715_i16, -196_i16}, {12842128665889583758_u64, -688_i16, -188_i16}, {9568131466127621947_u64, -661_i16, -180_i16}, {14257626930069360058_u64, -635_i16, -172_i16}, {10622759856335341974_u64, -608_i16, -164_i16}, {15829145694278690180_u64, -582_i16, -156_i16}, {11793632577567316726_u64, -555_i16, -148_i16}, {17573882009934360870_u64, -529_i16, -140_i16}, {13093562431584567480_u64, -502_i16, -132_i16}, {9755464219737475723_u64, -475_i16, -124_i16}, {14536774485912137811_u64, -449_i16, -116_i16}, {10830740992659433045_u64, -422_i16, -108_i16}, {16139061738043178685_u64, -396_i16, -100_i16}, {12024538023802026127_u64, -369_i16, -92_i16}, {17917957937422433684_u64, -343_i16, -84_i16}, {13349918974505688015_u64, -316_i16, -76_i16}, {9946464728195732843_u64, -289_i16, -68_i16}, {14821387422376473014_u64, -263_i16, -60_i16}, {11042794154864902060_u64, -236_i16, -52_i16}, {16455045573212060422_u64, -210_i16, -44_i16}, {12259964326927110867_u64, -183_i16, -36_i16}, {18268770466636286478_u64, -157_i16, -28_i16}, {13611294676837538539_u64, -130_i16, -20_i16}, {10141204801825835212_u64, -103_i16, -12_i16}, {15111572745182864684_u64, -77_i16, -4_i16}, {11258999068426240000_u64, -50_i16, 4_i16}, {16777216000000000000_u64, -24_i16, 12_i16}, {12500000000000000000_u64, 3_i16, 20_i16}, {9313225746154785156_u64, 30_i16, 28_i16}, {13877787807814456755_u64, 56_i16, 36_i16}, {10339757656912845936_u64, 83_i16, 44_i16}, {15407439555097886824_u64, 109_i16, 52_i16}, {11479437019748901445_u64, 136_i16, 60_i16}, {17105694144590052135_u64, 162_i16, 68_i16}, {12744735289059618216_u64, 189_i16, 76_i16}, {9495567745759798747_u64, 216_i16, 84_i16}, {14149498560666738074_u64, 242_i16, 92_i16}, {10542197943230523224_u64, 269_i16, 100_i16}, {15709099088952724970_u64, 295_i16, 108_i16}, {11704190886730495818_u64, 322_i16, 116_i16}, {17440603504673385349_u64, 348_i16, 124_i16}, {12994262207056124023_u64, 375_i16, 132_i16}, {9681479787123295682_u64, 402_i16, 140_i16}, {14426529090290212157_u64, 428_i16, 148_i16}, {10748601772107342003_u64, 455_i16, 156_i16}, {16016664761464807395_u64, 481_i16, 164_i16}, {11933345169920330789_u64, 508_i16, 172_i16}, {17782069995880619868_u64, 534_i16, 180_i16}, {13248674568444952270_u64, 561_i16, 188_i16}, {9871031767461413346_u64, 588_i16, 196_i16}, {14708983551653345445_u64, 614_i16, 204_i16}, {10959046745042015199_u64, 641_i16, 212_i16}, {16330252207878254650_u64, 667_i16, 220_i16}, {12166986024289022870_u64, 694_i16, 228_i16}, {18130221999122236476_u64, 720_i16, 236_i16}, {13508068024458167312_u64, 747_i16, 244_i16}, {10064294952495520794_u64, 774_i16, 252_i16}, {14996968138956309548_u64, 800_i16, 260_i16}, {11173611982879273257_u64, 827_i16, 268_i16}, {16649979327439178909_u64, 853_i16, 276_i16}, {12405201291620119593_u64, 880_i16, 284_i16}, {9242595204427927429_u64, 907_i16, 292_i16}, {13772540099066387757_u64, 933_i16, 300_i16}, {10261342003245940623_u64, 960_i16, 308_i16}, {15290591125556738113_u64, 986_i16, 316_i16}, {11392378155556871081_u64, 1013_i16, 324_i16}, {16975966327722178521_u64, 1039_i16, 332_i16}, {12648080533535911531_u64, 1066_i16, 340_i16}].map do |t|\n  Power.new(t[0], t[1], t[2])\nend","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float/Printer","kind":"module","full_name":"Float::Printer","name":"Printer"},"doc":null,"summary":null,"class_methods":[{"id":"get_cached_power_for_binary_exponent(exp):Tuple(DiyFP,Int32)-class-method","html_id":"get_cached_power_for_binary_exponent(exp):Tuple(DiyFP,Int32)-class-method","name":"get_cached_power_for_binary_exponent","doc":"Returns a cached power-of-ten with a binary exponent in the range\naround *exp* (boundaries included).","summary":"<p>Returns a cached power-of-ten with a binary exponent in the range around <em>exp</em> (boundaries included).</p>","abstract":false,"args":[{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"args_string":"(exp) : Tuple(DiyFP, Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L156","def":{"name":"get_cached_power_for_binary_exponent","args":[{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(DiyFP, Int32)","visibility":"Public","body":"min_exp = MIN_TARGET_EXP - (exp + DiyFP::SIGNIFICAND_SIZE)\nmax_exp = MAX_TARGET_EXP - (exp + DiyFP::SIGNIFICAND_SIZE)\nk = (((min_exp + DiyFP::SIGNIFICAND_SIZE) - 1) * D_1_LOG2_10).ceil\nindex = (((CACHED_POWER_OFFSET + k.to_i) - 1) / CACHED_EXP_STEP) + 1\npow = PowCache[index]\nreturn {DiyFP.new(pow.significand, pow.binary_exp), pow.decimal_exp.to_i}\n"}},{"id":"largest_pow10(n,n_bits)-class-method","html_id":"largest_pow10(n,n_bits)-class-method","name":"largest_pow10","doc":null,"summary":null,"abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""},{"name":"n_bits","doc":null,"default_value":"","external_name":"n_bits","restriction":""}],"args_string":"(n, n_bits)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L143","def":{"name":"largest_pow10","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""},{"name":"n_bits","doc":null,"default_value":"","external_name":"n_bits","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"guess = (((n_bits + 1) * 1233) >> 12) + 1\nif n < Pow10Cache[guess]\n  guess = guess - 1\nend\nreturn {Pow10Cache[guess], guess}\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Float/Printer/CachedPowers/Power","path":"Float/Printer/CachedPowers/Power.html","kind":"struct","full_name":"Float::Printer::CachedPowers::Power","name":"Power","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"float/printer/cached_powers.cr","line_number":31,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float/Printer/CachedPowers","kind":"module","full_name":"Float::Printer::CachedPowers","name":"CachedPowers"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(significand:UInt64,binary_exp:Int16,decimal_exp:Int16)-class-method","html_id":"new(significand:UInt64,binary_exp:Int16,decimal_exp:Int16)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"significand","doc":null,"default_value":"","external_name":"significand","restriction":"UInt64"},{"name":"binary_exp","doc":null,"default_value":"","external_name":"binary_exp","restriction":"Int16"},{"name":"decimal_exp","doc":null,"default_value":"","external_name":"decimal_exp","restriction":"Int16"}],"args_string":"(significand : UInt64, binary_exp : Int16, decimal_exp : Int16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","def":{"name":"new","args":[{"name":"significand","doc":null,"default_value":"","external_name":"significand","restriction":"UInt64"},{"name":"binary_exp","doc":null,"default_value":"","external_name":"binary_exp","restriction":"Int16"},{"name":"decimal_exp","doc":null,"default_value":"","external_name":"decimal_exp","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(significand, binary_exp, decimal_exp)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"binary_exp:Int16-instance-method","html_id":"binary_exp:Int16-instance-method","name":"binary_exp","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int16","source_link":null,"source_link":null,"def":{"name":"binary_exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"@binary_exp"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Power.new(@significand.clone, @binary_exp.clone, @decimal_exp.clone)"}},{"id":"copy_with(significand_significand=@significand,binary_exp_binary_exp=@binary_exp,decimal_exp_decimal_exp=@decimal_exp)-instance-method","html_id":"copy_with(significand_significand=@significand,binary_exp_binary_exp=@binary_exp,decimal_exp_decimal_exp=@decimal_exp)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_significand","doc":null,"default_value":"@significand","external_name":"significand","restriction":""},{"name":"_binary_exp","doc":null,"default_value":"@binary_exp","external_name":"binary_exp","restriction":""},{"name":"_decimal_exp","doc":null,"default_value":"@decimal_exp","external_name":"decimal_exp","restriction":""}],"args_string":"(significand _significand = @significand, binary_exp _binary_exp = @binary_exp, decimal_exp _decimal_exp = @decimal_exp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/cached_powers.cr#L31","def":{"name":"copy_with","args":[{"name":"_significand","doc":null,"default_value":"@significand","external_name":"significand","restriction":""},{"name":"_binary_exp","doc":null,"default_value":"@binary_exp","external_name":"binary_exp","restriction":""},{"name":"_decimal_exp","doc":null,"default_value":"@decimal_exp","external_name":"decimal_exp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Power.new(_significand, _binary_exp, _decimal_exp)"}},{"id":"decimal_exp:Int16-instance-method","html_id":"decimal_exp:Int16-instance-method","name":"decimal_exp","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int16","source_link":null,"source_link":null,"def":{"name":"decimal_exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"@decimal_exp"}},{"id":"significand:UInt64-instance-method","html_id":"significand:UInt64-instance-method","name":"significand","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64","source_link":null,"source_link":null,"def":{"name":"significand","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@significand"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Float/Printer/DiyFP","path":"Float/Printer/DiyFP.html","kind":"struct","full_name":"Float::Printer::DiyFP","name":"DiyFP","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"float/printer/diy_fp.cr","line_number":37,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MASK32","name":"MASK32","value":"4294967295_u32","doc":null,"summary":null},{"id":"SIGNIFICAND_SIZE","name":"SIGNIFICAND_SIZE","value":"64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float/Printer","kind":"module","full_name":"Float::Printer","name":"Printer"},"doc":"This \"Do It Yourself Floating Point\" struct implements a floating-point number\nwith a `UIht64` significand and an `Int32` exponent. Normalized DiyFP numbers will\nhave the most significant bit of the significand set.\nMultiplication and Subtraction do not normalize their results.\nDiyFP is not designed to contain special Floats (NaN and Infinity).","summary":"<p>This \"Do It Yourself Floating Point\" struct implements a floating-point number with a <code>UIht64</code> significand and an <code><a href=\"../../Int32.html\">Int32</a></code> exponent.</p>","class_methods":[{"id":"from_f(d:Float64|Float32)-class-method","html_id":"from_f(d:Float64|Float32)-class-method","name":"from_f","doc":null,"summary":null,"abstract":false,"args":[{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":"Float64 | Float32"}],"args_string":"(d : Float64 | Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L117","def":{"name":"from_f","args":[{"name":"d","doc":null,"default_value":"","external_name":"d","restriction":"Float64 | Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"frac, exp = IEEE.frac_and_exp(d)\nnew(frac, exp)\n"}},{"id":"from_f_normalized(v:Float64|Float32)-class-method","html_id":"from_f_normalized(v:Float64|Float32)-class-method","name":"from_f_normalized","doc":"Normalize such that the most signficiant bit of frac is set","summary":"<p>Normalize such that the most signficiant bit of frac is set</p>","abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"}],"args_string":"(v : Float64 | Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L123","def":{"name":"from_f_normalized","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pre_normalized = from_f(v)\nf = pre_normalized.frac\ne = pre_normalized.exp\nwhile (f & IEEE::HIDDEN_BIT_64) == 0\n  f = f << 1\n  e = e - 1\nend\nf = f << (DiyFP::SIGNIFICAND_SIZE - IEEE::SIGNIFICAND_SIZE_64)\ne = e - (DiyFP::SIGNIFICAND_SIZE - IEEE::SIGNIFICAND_SIZE_64)\nDiyFP.new(f, e)\n"}}],"constructors":[{"id":"new(frac,exp:Int16)-class-method","html_id":"new(frac,exp:Int16)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int16"}],"args_string":"(frac, exp : Int16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L47","def":{"name":"new","args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(frac, exp)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(frac,exp)-class-method","html_id":"new(frac,exp)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"args_string":"(frac, exp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L44","def":{"name":"new","args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(frac, exp)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"*(other:DiyFP)-instance-method","html_id":"*(other:DiyFP)-instance-method","name":"*","doc":"Returns a new `DiyFP` caculated as self * *other*.\n\nSimply \"emulates\" a 128 bit multiplication.\nHowever: the resulting number only contains 64 bits. The least\nsignificant 64 bits are only used for rounding the most significant 64\nbits.\n\nThis result is not normalized.","summary":"<p>Returns a new <code><a href=\"../../Float/Printer/DiyFP.html\">DiyFP</a></code> caculated as self * <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"DiyFP"}],"args_string":"(other : DiyFP)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L75","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"DiyFP"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"a = frac >> 32\nb = frac & MASK32\nc = other.frac >> 32\nd = other.frac & MASK32\nac = a * c\nbc = b * c\nad = a * d\nbd = b * d\ntmp = ((bd >> 32) + (ad & MASK32)) + (bc & MASK32)\ntmp = tmp + (1_u32 << 31)\nf = ((ac + (ad >> 32)) + (bc >> 32)) + (tmp >> 32)\ne = (exp + other.exp) + 64\nself.class.new(f, e)\n"}},{"id":"-(other:DiyFP)-instance-method","html_id":"-(other:DiyFP)-instance-method","name":"-","doc":"Returns a new `DiyFP` caculated as self - *other*.\n\nThe exponents of both numbers must be the same and the frac of self must be\ngreater than the other.\n\nThis result is not normalized.","summary":"<p>Returns a new <code><a href=\"../../Float/Printer/DiyFP.html\">DiyFP</a></code> caculated as self - <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"DiyFP"}],"args_string":"(other : DiyFP)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L61","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"DiyFP"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.new(frac - other.frac, exp)"}},{"id":"exp:Int32-instance-method","html_id":"exp:Int32-instance-method","name":"exp","doc":"exponent","summary":"<p>exponent</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L42","def":{"name":"exp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@exp"}},{"id":"exp=(exp:Int32)-instance-method","html_id":"exp=(exp:Int32)-instance-method","name":"exp=","doc":"exponent","summary":"<p>exponent</p>","abstract":false,"args":[{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int32"}],"args_string":"(exp : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L42","def":{"name":"exp=","args":[{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@exp = exp"}},{"id":"frac:UInt64-instance-method","html_id":"frac:UInt64-instance-method","name":"frac","doc":"Also known as the significand","summary":"<p>Also known as the significand</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L40","def":{"name":"frac","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@frac"}},{"id":"frac=(frac:UInt64)-instance-method","html_id":"frac=(frac:UInt64)-instance-method","name":"frac=","doc":"Also known as the significand","summary":"<p>Also known as the significand</p>","abstract":false,"args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":"UInt64"}],"args_string":"(frac : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L40","def":{"name":"frac=","args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@frac = frac"}},{"id":"new(frac:Int32,exp)-instance-method","html_id":"new(frac:Int32,exp)-instance-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":"Int32"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"args_string":"(frac : Int32, exp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L51","def":{"name":"new","args":[{"name":"frac","doc":null,"default_value":"","external_name":"frac","restriction":"Int32"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(frac.to_u64, exp)"}},{"id":"normalize-instance-method","html_id":"normalize-instance-method","name":"normalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/diy_fp.cr#L94","def":{"name":"normalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"f = frac\ne = exp\nk10MSBits = 18428729675200069632_u64\nkUint64MSB = 9223372036854775808_u64\nwhile (f & k10MSBits) == 0\n  f = f << 10_u64\n  e = e - 10\nend\nwhile (f & kUint64MSB) == 0\n  f = f << 1_u64\n  e = e - 1\nend\nDiyFP.new(f, e)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Float/Printer/Grisu3","path":"Float/Printer/Grisu3.html","kind":"module","full_name":"Float::Printer::Grisu3","name":"Grisu3","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"float/printer/grisu3.cr","line_number":34,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Float/Printer/Grisu3","kind":"module","full_name":"Float::Printer::Grisu3","name":"Grisu3"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float/Printer","kind":"module","full_name":"Float::Printer","name":"Printer"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"digit_gen(low:DiyFP,w:DiyFP,high:DiyFP,buffer_p):Tuple(Bool,Int32,Int32)-instance-method","html_id":"digit_gen(low:DiyFP,w:DiyFP,high:DiyFP,buffer_p):Tuple(Bool,Int32,Int32)-instance-method","name":"digit_gen","doc":"Generates the digits of input number w.\nw is a floating-point number (DiyFp), consisting of a significand and an\nexponent. Its exponent is bounded by kMinimalTargetExponent and\nkMaximalTargetExponent.\n      Hence -60 <= w.e() <= -32.\n\nReturns false if it fails, in which case the generated digits in the buffer\nshould not be used.\nPreconditions:\n * low, w and high are correct up to 1 ulp (unit in the last place). That\n   is, their error must be less than a unit of their last digits.\n * low.e() == w.e() == high.e()\n * low < w < high, and taking into account their error: low~ <= high~\n * kMinimalTargetExponent <= w.e() <= kMaximalTargetExponent\nPostconditions: returns false if procedure fails.\n  otherwise:\n    * buffer is not null-terminated, but len contains the number of digits.\n    * buffer contains the shortest possible decimal digit-sequence\n      such that LOW < buffer * 10^kappa < HIGH, where LOW and HIGH are the\n      correct values of low and high (without their error).\n    * if more than one decimal representation gives the minimal number of\n      decimal digits then the one closest to W (where W is the correct value\n      of w) is chosen.\nRemark: this procedure takes into account the imprecision of its input\n  numbers. If the precision is not enough to guarantee all the postconditions\n  then false is returned. This usually happens rarely (~0.5%).\n\nSay, for the sake of example, that\n  w.e() == -48, and w.f() == 0x1234567890abcdef\nw's value can be computed by w.f() * 2^w.e()\nWe can obtain w's integral digits by simply shifting w.f() by -w.e().\n -> w's integral part is 0x1234\n w's fractional part is therefore 0x567890abcdef.\nPrinting w's integral part is easy (simply print 0x1234 in decimal).\nIn order to print its fraction we repeatedly multiply the fraction by 10 and\nget each digit. Example the first digit after the point would be computed by\n  (0x567890abcdef * 10) >> 48. -> 3\nThe whole thing becomes slightly more complicated because we want to stop\nonce we have enough digits. That is, once the digits inside the buffer\nrepresent 'w' we can stop. Everything inside the interval low - high\nrepresents w. However we have to pay attention to low, high and w's\nimprecision.","summary":"<p>Generates the digits of input number w.</p>","abstract":false,"args":[{"name":"low","doc":null,"default_value":"","external_name":"low","restriction":"DiyFP"},{"name":"w","doc":null,"default_value":"","external_name":"w","restriction":"DiyFP"},{"name":"high","doc":null,"default_value":"","external_name":"high","restriction":"DiyFP"},{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""}],"args_string":"(low : DiyFP, w : DiyFP, high : DiyFP, buffer_p) : Tuple(Bool, Int32, Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L199","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L199","def":{"name":"digit_gen","args":[{"name":"low","doc":null,"default_value":"","external_name":"low","restriction":"DiyFP"},{"name":"w","doc":null,"default_value":"","external_name":"w","restriction":"DiyFP"},{"name":"high","doc":null,"default_value":"","external_name":"high","restriction":"DiyFP"},{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(Bool, Int32, Int32)","visibility":"Public","body":"buffer = buffer_p.to_slice(128)\nunit = 1_u64\ntoo_low = DiyFP.new(low.frac - unit, low.exp)\ntoo_high = DiyFP.new(high.frac + unit, low.exp)\nunsafe_interval = too_high - too_low\none = DiyFP.new(1_u64 << (-w.exp), w.exp)\nintegrals = (too_high.frac >> (-one.exp)).to_u32\nfractionals = too_high.frac & (one.frac - 1)\ndivisor, kappa = CachedPowers.largest_pow10(integrals, DiyFP::SIGNIFICAND_SIZE + one.exp)\nlength = 0\nwhile kappa > 0\n  digit = integrals / divisor\n  buffer[length] = 48_u8 + digit\n  length = length + 1\n  integrals = integrals % divisor\n  kappa = kappa - 1\n  rest = (integrals.to_u64 << (-one.exp)) + fractionals\n  if rest < unsafe_interval.frac\n    weeded = round_weed(buffer_p, length, (too_high - w).frac, unsafe_interval.frac, rest, divisor.to_u64 << (-one.exp), unit)\n    return {weeded, kappa, length}\n  end\n  divisor = divisor / 10\nend\nloop do\n  fractionals = fractionals * 10\n  unit = unit * 10\n  unsafe_interval = DiyFP.new(unsafe_interval.frac * 10, unsafe_interval.exp)\n  digit = (fractionals >> (-one.exp)).to_i\n  buffer[length] = 48_u8 + digit\n  length = length + 1\n  fractionals = fractionals & (one.frac - 1)\n  kappa = kappa - 1\n  if fractionals < unsafe_interval.frac\n    weeded = round_weed(buffer_p, length, (too_high - w).frac * unit, unsafe_interval.frac, fractionals, one.frac, unit)\n    return {weeded, kappa, length}\n  end\nend\n"}},{"id":"grisu3(v:Float64|Float32,buffer_p):Tuple(Bool,Int32,Int32)-instance-method","html_id":"grisu3(v:Float64|Float32,buffer_p):Tuple(Bool,Int32,Int32)-instance-method","name":"grisu3","doc":"Provides a decimal representation of *v*.\n\nReturns a `Tuple` of `{status, decimal_exponent, length}`\n*status* will be true if it succeeds, otherwise the result cannot be\ntrusted.\nThere will be *length* digits inside the buffer (not null-terminated).\nIf the function returns satatus as true true then\n       v == (buffer * 10^decimal_exponent).to_f\nThe digits in the buffer are the shortest representation possible: no\n0.09999999999999999 instead of 0.1. The shorter representation will even be\nchosen even if the longer one would be closer to *v*.\nThe last digit will be closest to the actual *v*. That is, even if several\ndigits might correctly yield *v* when read again, the closest will be\ncomputed.","summary":"<p>Provides a decimal representation of <em>v</em>.</p>","abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"},{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""}],"args_string":"(v : Float64 | Float32, buffer_p) : Tuple(Bool, Int32, Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L301","def":{"name":"grisu3","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64 | Float32"},{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(Bool, Int32, Int32)","visibility":"Public","body":"buffer = buffer_p.to_slice(128)\nw = DiyFP.from_f_normalized(v)\nboundaries = IEEE.normalized_boundaries(v)\nten_mk, mk = CachedPowers.get_cached_power_for_binary_exponent(w.exp)\nscaled_w = w * ten_mk\nscaled_boundary_minus = boundaries[:minus] * ten_mk\nscaled_boundary_plus = boundaries[:plus] * ten_mk\nresult, kappa, length = digit_gen(scaled_boundary_minus, scaled_w, scaled_boundary_plus, buffer_p)\ndecimal_exponent = (-mk) + kappa\nreturn {result, decimal_exponent, length}\n"}},{"id":"round_weed(buffer_p,length,distance_too_high_w,unsafe_interval,rest,ten_kappa,unit)-instance-method","html_id":"round_weed(buffer_p,length,distance_too_high_w,unsafe_interval,rest,ten_kappa,unit)-instance-method","name":"round_weed","doc":"Adjusts the last digit of the generated number, and screens out generated\nsolutions that may be inaccurate. A solution may be inaccurate if it is\noutside the safe interval, or if we cannot prove that it is closer to the\ninput than a neighboring representation of the same length.\n\nInput: * buffer pointer containing the digits of too_high / 10^kappa\n       * the buffer's length\n       * distance_too_high_w == (too_high - w).frac * unit\n       * unsafe_interval == (too_high - too_low).frac * unit\n       * rest = (too_high - buffer * 10^kappa).frac * unit\n       * ten_kappa = 10^kappa * unit\n       * unit = the common multiplier\nOutput: returns true if the buffer is guaranteed to contain the closest\n   representable number to the input.\n Modifies the generated digits in the buffer to approach (round towards) w.","summary":"<p>Adjusts the last digit of the generated number, and screens out generated solutions that may be inaccurate.</p>","abstract":false,"args":[{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""},{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":""},{"name":"distance_too_high_w","doc":null,"default_value":"","external_name":"distance_too_high_w","restriction":""},{"name":"unsafe_interval","doc":null,"default_value":"","external_name":"unsafe_interval","restriction":""},{"name":"rest","doc":null,"default_value":"","external_name":"rest","restriction":""},{"name":"ten_kappa","doc":null,"default_value":"","external_name":"ten_kappa","restriction":""},{"name":"unit","doc":null,"default_value":"","external_name":"unit","restriction":""}],"args_string":"(buffer_p, length, distance_too_high_w, unsafe_interval, rest, ten_kappa, unit)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/grisu3.cr#L52","def":{"name":"round_weed","args":[{"name":"buffer_p","doc":null,"default_value":"","external_name":"buffer_p","restriction":""},{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":""},{"name":"distance_too_high_w","doc":null,"default_value":"","external_name":"distance_too_high_w","restriction":""},{"name":"unsafe_interval","doc":null,"default_value":"","external_name":"unsafe_interval","restriction":""},{"name":"rest","doc":null,"default_value":"","external_name":"rest","restriction":""},{"name":"ten_kappa","doc":null,"default_value":"","external_name":"ten_kappa","restriction":""},{"name":"unit","doc":null,"default_value":"","external_name":"unit","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = buffer_p.to_slice(128)\nsmall_distance = distance_too_high_w - unit\nbig_distance = distance_too_high_w + unit\nwhile ((rest < small_distance && (unsafe_interval - rest) >= ten_kappa) && ((rest + ten_kappa) < small_distance || (small_distance - rest) >= ((rest + ten_kappa) - small_distance)))\n  __temp_20 = length - 1\n  buffer[__temp_20] = buffer[__temp_20] - 1\n  rest = rest + ten_kappa\nend\nif ((rest < big_distance && (unsafe_interval - rest) >= ten_kappa) && ((rest + ten_kappa) < big_distance || (big_distance - rest) > ((rest + ten_kappa) - big_distance)))\n  return false\nend\nreturn ((2 * unit) <= rest) && (rest <= (unsafe_interval - (4 * unit)))\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Float/Printer/IEEE","path":"Float/Printer/IEEE.html","kind":"module","full_name":"Float::Printer::IEEE","name":"IEEE","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"float/printer/ieee.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DENORMAL_EXPONENT_32","name":"DENORMAL_EXPONENT_32","value":"(-EXPONENT_BIAS_32) + 1","doc":null,"summary":null},{"id":"DENORMAL_EXPONENT_64","name":"DENORMAL_EXPONENT_64","value":"(-EXPONENT_BIAS_64) + 1","doc":null,"summary":null},{"id":"EXPONENT_BIAS_32","name":"EXPONENT_BIAS_32","value":"127 + PHYSICAL_SIGNIFICAND_SIZE_32","doc":null,"summary":null},{"id":"EXPONENT_BIAS_64","name":"EXPONENT_BIAS_64","value":"1023 + PHYSICAL_SIGNIFICAND_SIZE_64","doc":null,"summary":null},{"id":"EXPONENT_MASK_32","name":"EXPONENT_MASK_32","value":"2139095040_u32","doc":null,"summary":null},{"id":"EXPONENT_MASK_64","name":"EXPONENT_MASK_64","value":"9218868437227405312_u64","doc":null,"summary":null},{"id":"HIDDEN_BIT_32","name":"HIDDEN_BIT_32","value":"8388608_u32","doc":null,"summary":null},{"id":"HIDDEN_BIT_64","name":"HIDDEN_BIT_64","value":"4503599627370496_u64","doc":null,"summary":null},{"id":"PHYSICAL_SIGNIFICAND_SIZE_32","name":"PHYSICAL_SIGNIFICAND_SIZE_32","value":"23","doc":null,"summary":null},{"id":"PHYSICAL_SIGNIFICAND_SIZE_64","name":"PHYSICAL_SIGNIFICAND_SIZE_64","value":"52","doc":null,"summary":null},{"id":"SIGN_MASK_32","name":"SIGN_MASK_32","value":"2147483648_u32","doc":null,"summary":null},{"id":"SIGN_MASK_64","name":"SIGN_MASK_64","value":"9223372036854775808_u64","doc":null,"summary":null},{"id":"SIGNIFICAND_MASK_32","name":"SIGNIFICAND_MASK_32","value":"8388607_u32","doc":null,"summary":null},{"id":"SIGNIFICAND_MASK_64","name":"SIGNIFICAND_MASK_64","value":"4503599627370495_u64","doc":null,"summary":null},{"id":"SIGNIFICAND_SIZE_32","name":"SIGNIFICAND_SIZE_32","value":"24","doc":"Excludes the hidden bit","summary":"<p>Excludes the hidden bit</p>"},{"id":"SIGNIFICAND_SIZE_64","name":"SIGNIFICAND_SIZE_64","value":"53","doc":"Excludes the hidden bit","summary":"<p>Excludes the hidden bit</p>"}],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Float/Printer/IEEE","kind":"module","full_name":"Float::Printer::IEEE","name":"IEEE"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Float/Printer","kind":"module","full_name":"Float::Printer","name":"Printer"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"frac_and_exp(v:Float64)-instance-method","html_id":"frac_and_exp(v:Float64)-instance-method","name":"frac_and_exp","doc":null,"summary":null,"abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"args_string":"(v : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L143","def":{"name":"frac_and_exp","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"d64 = to_uint(v)\nif (d64 & EXPONENT_MASK_64) == 0\n  frac = d64 & SIGNIFICAND_MASK_64\n  exp = 1 - EXPONENT_BIAS_64\nelse\n  frac = (d64 & SIGNIFICAND_MASK_64) + HIDDEN_BIT_64\n  exp = (((d64 & EXPONENT_MASK_64) >> PHYSICAL_SIGNIFICAND_SIZE_64) - EXPONENT_BIAS_64).to_i\nend\n{frac, exp}\n"}},{"id":"frac_and_exp(v:Float32)-instance-method","html_id":"frac_and_exp(v:Float32)-instance-method","name":"frac_and_exp","doc":null,"summary":null,"abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"args_string":"(v : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L157","def":{"name":"frac_and_exp","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"d32 = to_uint(v)\nif (d32 & EXPONENT_MASK_32) == 0\n  frac = d32 & SIGNIFICAND_MASK_32\n  exp = 1 - EXPONENT_BIAS_32\nelse\n  frac = (d32 & SIGNIFICAND_MASK_32) + HIDDEN_BIT_32\n  exp = (((d32 & EXPONENT_MASK_32) >> PHYSICAL_SIGNIFICAND_SIZE_32) - EXPONENT_BIAS_32).to_i\nend\n{frac.to_u64, exp}\n"}},{"id":"inf?(d64:UInt64)-instance-method","html_id":"inf?(d64:UInt64)-instance-method","name":"inf?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"args_string":"(d64 : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L75","def":{"name":"inf?","args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(special?(d64)) && ((d64 & SIGNIFICAND_MASK_64) == 0)"}},{"id":"inf?(d32:UInt32)-instance-method","html_id":"inf?(d32:UInt32)-instance-method","name":"inf?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"args_string":"(d32 : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L79","def":{"name":"inf?","args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(special?(d32)) && ((d32 & SIGNIFICAND_MASK_32) == 0)"}},{"id":"nan?(d64:UInt64)-instance-method","html_id":"nan?(d64:UInt64)-instance-method","name":"nan?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"args_string":"(d64 : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L83","def":{"name":"nan?","args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(special?(d64)) && ((d64 & SIGNIFICAND_MASK_64) != 0)"}},{"id":"nan?(d32:UInt32)-instance-method","html_id":"nan?(d32:UInt32)-instance-method","name":"nan?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"args_string":"(d32 : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L87","def":{"name":"nan?","args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(special?(d32)) && ((d32 & SIGNIFICAND_MASK_32) != 0)"}},{"id":"normalized_boundaries(v:Float64)-instance-method","html_id":"normalized_boundaries(v:Float64)-instance-method","name":"normalized_boundaries","doc":"Computes the two boundaries of *v*.\nThe bigger boundary (m_plus) is normalized. The lower boundary has the same\nexponent as m_plus.\nPrecondition: the value encoded by this Flaot must be greater than 0.","summary":"<p>Computes the two boundaries of <em>v</em>.</p>","abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"args_string":"(v : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L95","def":{"name":"normalized_boundaries","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"w = DiyFP.from_f(v)\nm_plus = (DiyFP.new((w.frac << 1) + 1, w.exp - 1)).normalize\nd64 = to_uint(v)\nphysical_significand_is_zero = (d64 & SIGNIFICAND_MASK_64) == 0\nlower_bound_closer = physical_significand_is_zero && ((exponent(d64)) != DENORMAL_EXPONENT_64)\ncalcualted_exp = exponent(d64)\ncalc_denormal = denormal?(d64)\nf, e = if lower_bound_closer\n  {(w.frac << 2) - 1, w.exp - 2}\nelse\n  {(w.frac << 1) - 1, w.exp - 1}\nend\nm_minus = DiyFP.new(f << (e - m_plus.exp), m_plus.exp)\nreturn {minus: m_minus, plus: m_plus}\n"}},{"id":"normalized_boundaries(v:Float32)-instance-method","html_id":"normalized_boundaries(v:Float32)-instance-method","name":"normalized_boundaries","doc":null,"summary":null,"abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"args_string":"(v : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L123","def":{"name":"normalized_boundaries","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"w = DiyFP.from_f(v)\nm_plus = (DiyFP.new((w.frac << 1) + 1, w.exp - 1)).normalize\nd32 = to_uint(v)\nphysical_significand_is_zero = (d32 & SIGNIFICAND_MASK_32) == 0\nlower_bound_closer = physical_significand_is_zero && ((exponent(d32)) != DENORMAL_EXPONENT_32)\ncalcualted_exp = exponent(d32)\ncalc_denormal = denormal?(d32)\nf, e = if lower_bound_closer\n  {(w.frac << 2) - 1, w.exp - 2}\nelse\n  {(w.frac << 1) - 1, w.exp - 1}\nend\nm_minus = DiyFP.new(f << (e - m_plus.exp), m_plus.exp)\nreturn {minus: m_minus, plus: m_plus}\n"}},{"id":"sign(d64:UInt64)-instance-method","html_id":"sign(d64:UInt64)-instance-method","name":"sign","doc":null,"summary":null,"abstract":false,"args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"args_string":"(d64 : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L59","def":{"name":"sign","args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(d64 & SIGN_MASK_64) == 0 ? 1 : -1"}},{"id":"sign(d32:UInt32)-instance-method","html_id":"sign(d32:UInt32)-instance-method","name":"sign","doc":null,"summary":null,"abstract":false,"args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"args_string":"(d32 : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L63","def":{"name":"sign","args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(d32 & SIGN_MASK_32) == 0 ? 1 : -1"}},{"id":"special?(d64:UInt64)-instance-method","html_id":"special?(d64:UInt64)-instance-method","name":"special?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"args_string":"(d64 : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L67","def":{"name":"special?","args":[{"name":"d64","doc":null,"default_value":"","external_name":"d64","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(d64 & EXPONENT_MASK_64) == EXPONENT_MASK_64"}},{"id":"special?(d32:UInt32)-instance-method","html_id":"special?(d32:UInt32)-instance-method","name":"special?","doc":null,"summary":null,"abstract":false,"args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"args_string":"(d32 : UInt32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L71","def":{"name":"special?","args":[{"name":"d32","doc":null,"default_value":"","external_name":"d32","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(d32 & EXPONENT_MASK_32) == EXPONENT_MASK_32"}},{"id":"to_uint(v:Float64)-instance-method","html_id":"to_uint(v:Float64)-instance-method","name":"to_uint","doc":null,"summary":null,"abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"args_string":"(v : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L51","def":{"name":"to_uint","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"v.unsafe_as(UInt64)"}},{"id":"to_uint(v:Float32)-instance-method","html_id":"to_uint(v:Float32)-instance-method","name":"to_uint","doc":null,"summary":null,"abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"args_string":"(v : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float/printer/ieee.cr#L55","def":{"name":"to_uint","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"v.unsafe_as(UInt32)"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/Float32","path":"Float32.html","kind":"struct","full_name":"Float32","name":"Float32","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"float.cr","line_number":107,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DIGITS","name":"DIGITS","value":"6","doc":"The number of decimal digits that can be represented without losing precision","summary":"<p>The number of decimal digits that can be represented without losing precision</p>"},{"id":"EPSILON","name":"EPSILON","value":"1.19209290e-07_f32","doc":"The machine epsilon (difference between 1.0 and the next representable value)","summary":"<p>The machine epsilon (difference between 1.0 and the next representable value)</p>"},{"id":"INFINITY","name":"INFINITY","value":"(1_f32 / 0_f32).as(Float32)","doc":null,"summary":null},{"id":"MANT_DIGITS","name":"MANT_DIGITS","value":"24","doc":"The number of digits that can be represented without losing precision (in base RADIX)","summary":"<p>The number of digits that can be represented without losing precision (in base RADIX)</p>"},{"id":"MAX","name":"MAX","value":"3.40282347e+38_f32","doc":"Largest finite value","summary":"<p>Largest finite value</p>"},{"id":"MAX_10_EXP","name":"MAX_10_EXP","value":"38","doc":"The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)","summary":"<p>The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)</p>"},{"id":"MAX_EXP","name":"MAX_EXP","value":"128","doc":"The maximum possible normal power of 2 exponent","summary":"<p>The maximum possible normal power of 2 exponent</p>"},{"id":"MIN","name":"MIN","value":"-3.40282347e+38_f32","doc":"Smallest finite value","summary":"<p>Smallest finite value</p>"},{"id":"MIN_10_EXP","name":"MIN_10_EXP","value":"-37","doc":"The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)","summary":"<p>The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)</p>"},{"id":"MIN_EXP","name":"MIN_EXP","value":"-125","doc":"The minimum possible normal power of 2 exponent","summary":"<p>The minimum possible normal power of 2 exponent</p>"},{"id":"MIN_POSITIVE","name":"MIN_POSITIVE","value":"1.17549435e-38_f32","doc":"Smallest representable positive value","summary":"<p>Smallest representable positive value</p>"},{"id":"NAN","name":"NAN","value":"(0_f32 / 0_f32).as(Float32)","doc":null,"summary":null},{"id":"RADIX","name":"RADIX","value":"2","doc":"The radix or integer base used by the internal representation","summary":"<p>The radix or integer base used by the internal representation</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L59","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(parse_scalar(ctx, node, Float64)).to_f32"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L75","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case pull.kind\nwhen :int\n  value = pull.int_value.to_f32\n  pull.read_next\n  value\nelse\n  pull.read_float.to_f32\nend"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns a `Float32` by invoking `to_f32` on *value*.","summary":"<p>Returns a <code><a href=\"Float32.html\">Float32</a></code> by invoking <code><a href=\"Float32.html#to_f32%3AFloat32-instance-method\">#to_f32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L134","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_f32"}}],"instance_methods":[{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):self-instance-method","html_id":"*(other:Float32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):self-instance-method","html_id":"*(other:Float64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"**(other:Int32)-instance-method","html_id":"**(other:Int32)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L154","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:win32) %}\n      self ** other.to_f32\n    {% else %}\n      LibM.powi_f32(self, other)\n    {% end %}"}},{"id":"**(other:Float32)-instance-method","html_id":"**(other:Float32)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L162","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.pow_f32(self, other)"}},{"id":"**(other)-instance-method","html_id":"**(other)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L166","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L166","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ** other.to_f32"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):self-instance-method","html_id":"+(other:Float32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):self-instance-method","html_id":"+(other:Float64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):self-instance-method","html_id":"-(other:Float64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):self-instance-method","html_id":"-(other:Float32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):self-instance-method","html_id":"/(other:Float32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt64):self-instance-method","html_id":"/(other:UInt64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt32):self-instance-method","html_id":"/(other:UInt32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt16):self-instance-method","html_id":"/(other:UInt16):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt8):self-instance-method","html_id":"/(other:UInt8):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int128):self-instance-method","html_id":"/(other:Int128):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int64):self-instance-method","html_id":"/(other:Int64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int32):self-instance-method","html_id":"/(other:Int32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int16):self-instance-method","html_id":"/(other:Int16):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int8):self-instance-method","html_id":"/(other:Int8):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt128):self-instance-method","html_id":"/(other:UInt128):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):self-instance-method","html_id":"/(other:Float64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"ceil-instance-method","html_id":"ceil-instance-method","name":"ceil","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L138","def":{"name":"ceil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ceil_f32(self)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L185","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"floor-instance-method","html_id":"floor-instance-method","name":"floor","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L142","def":{"name":"floor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.floor_f32(self)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L180","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)\nio << \"_f32\"\n"}},{"id":"round-instance-method","html_id":"round-instance-method","name":"round","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L146","def":{"name":"round","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.round_f32(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L170","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build(22) do |buffer|\n  Printer.print(self, buffer)\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L176","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Printer.print(self, io)"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"trunc-instance-method","html_id":"trunc-instance-method","name":"trunc","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L150","def":{"name":"trunc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.trunc_f32(self)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Float64","path":"Float64.html","kind":"struct","full_name":"Float64","name":"Float64","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"float.cr","line_number":190,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DIGITS","name":"DIGITS","value":"15","doc":"The number of decimal digits that can be represented without losing precision","summary":"<p>The number of decimal digits that can be represented without losing precision</p>"},{"id":"EPSILON","name":"EPSILON","value":"2.2204460492503131e-16","doc":"The machine epsilon (difference between 1.0 and the next representable value)","summary":"<p>The machine epsilon (difference between 1.0 and the next representable value)</p>"},{"id":"INFINITY","name":"INFINITY","value":"(1_f64 / 0_f64).as(Float64)","doc":null,"summary":null},{"id":"MANT_DIGITS","name":"MANT_DIGITS","value":"53","doc":"The number of digits that can be represented without losing precision (in base RADIX)","summary":"<p>The number of digits that can be represented without losing precision (in base RADIX)</p>"},{"id":"MAX","name":"MAX","value":"1.7976931348623157e+308","doc":"Largest finite value","summary":"<p>Largest finite value</p>"},{"id":"MAX_10_EXP","name":"MAX_10_EXP","value":"308","doc":"The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)","summary":"<p>The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)</p>"},{"id":"MAX_EXP","name":"MAX_EXP","value":"1024","doc":"The maximum possible normal power of 2 exponent","summary":"<p>The maximum possible normal power of 2 exponent</p>"},{"id":"MIN","name":"MIN","value":"-1.7976931348623157e+308","doc":"Smallest finite value","summary":"<p>Smallest finite value</p>"},{"id":"MIN_10_EXP","name":"MIN_10_EXP","value":"-307","doc":"The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)","summary":"<p>The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)</p>"},{"id":"MIN_EXP","name":"MIN_EXP","value":"-1021","doc":"The minimum possible normal power of 2 exponent","summary":"<p>The minimum possible normal power of 2 exponent</p>"},{"id":"MIN_POSITIVE","name":"MIN_POSITIVE","value":"2.2250738585072014e-308","doc":"Smallest representable positive value","summary":"<p>Smallest representable positive value</p>"},{"id":"NAN","name":"NAN","value":"(0_f64 / 0_f64).as(Float64)","doc":null,"summary":null},{"id":"RADIX","name":"RADIX","value":"2","doc":"The radix or integer base used by the internal representation","summary":"<p>The radix or integer base used by the internal representation</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L63","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L86","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case pull.kind\nwhen :int\n  value = pull.int_value.to_f\n  pull.read_next\n  value\nelse\n  pull.read_float.to_f\nend"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns a `Float64` by invoking `to_f64` on *value*.","summary":"<p>Returns a <code><a href=\"Float64.html\">Float64</a></code> by invoking <code><a href=\"Float64.html#to_f64%3AFloat64-instance-method\">#to_f64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L218","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_f64"}}],"instance_methods":[{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):self-instance-method","html_id":"*(other:Float32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):self-instance-method","html_id":"*(other:Float64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"**(other:Int32)-instance-method","html_id":"**(other:Int32)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L238","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L238","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:win32) %}\n      self ** other.to_f64\n    {% else %}\n      LibM.powi_f64(self, other)\n    {% end %}"}},{"id":"**(other:Float64)-instance-method","html_id":"**(other:Float64)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L246","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.pow_f64(self, other)"}},{"id":"**(other)-instance-method","html_id":"**(other)-instance-method","name":"**","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L250","def":{"name":"**","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ** other.to_f64"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):self-instance-method","html_id":"+(other:Float32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):self-instance-method","html_id":"+(other:Float64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):self-instance-method","html_id":"-(other:Float64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):self-instance-method","html_id":"-(other:Float32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int8):self-instance-method","html_id":"/(other:Int8):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int16):self-instance-method","html_id":"/(other:Int16):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int32):self-instance-method","html_id":"/(other:Int32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int64):self-instance-method","html_id":"/(other:Int64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Int128):self-instance-method","html_id":"/(other:Int128):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt8):self-instance-method","html_id":"/(other:UInt8):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt16):self-instance-method","html_id":"/(other:UInt16):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt32):self-instance-method","html_id":"/(other:UInt32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt64):self-instance-method","html_id":"/(other:UInt64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):self-instance-method","html_id":"/(other:Float32):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:UInt128):self-instance-method","html_id":"/(other:UInt128):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):self-instance-method","html_id":"/(other:Float64):self-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"ceil-instance-method","html_id":"ceil-instance-method","name":"ceil","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L222","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L222","def":{"name":"ceil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ceil_f64(self)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L264","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"floor-instance-method","html_id":"floor-instance-method","name":"floor","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L226","def":{"name":"floor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.floor_f64(self)"}},{"id":"round-instance-method","html_id":"round-instance-method","name":"round","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L230","def":{"name":"round","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.round_f64(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L254","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L254","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build(22) do |buffer|\n  Printer.print(self, buffer)\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L260","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Printer.print(self, io)"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"trunc-instance-method","html_id":"trunc-instance-method","name":"trunc","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/float.cr#L234","def":{"name":"trunc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.trunc_f64(self)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/GC","path":"GC.html","kind":"module","full_name":"GC","name":"GC","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"gc.cr","line_number":49,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr"},{"filename":"gc/boehm.cr","line_number":68,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr"},{"filename":"gc/none.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"add_finalizer(object:Reference)-class-method","html_id":"add_finalizer(object:Reference)-class-method","name":"add_finalizer","doc":null,"summary":null,"abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"Reference"}],"args_string":"(object : Reference)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L111","def":{"name":"add_finalizer","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"Reference"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"add_finalizer_impl(object)"}},{"id":"add_finalizer(object)-class-method","html_id":"add_finalizer(object)-class-method","name":"add_finalizer","doc":null,"summary":null,"abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L43","def":{"name":"add_finalizer","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"add_root(object:Reference)-class-method","html_id":"add_root(object:Reference)-class-method","name":"add_root","doc":null,"summary":null,"abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"Reference"}],"args_string":"(object : Reference)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L126","def":{"name":"add_root","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"Reference"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"roots = @@roots || (@@roots = [] of Pointer(Void))\nroots << (Pointer(Void).new(object.object_id))\n"}},{"id":"collect-class-method","html_id":"collect-class-method","name":"collect","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L26","def":{"name":"collect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"disable-class-method","html_id":"disable-class-method","name":"disable","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L32","def":{"name":"disable","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"enable-class-method","html_id":"enable-class-method","name":"enable","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L29","def":{"name":"enable","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"free(pointer:Pointer(Void))-class-method","html_id":"free(pointer:Pointer(Void))-class-method","name":"free","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L35","def":{"name":"free","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibC.free(pointer)"}},{"id":"init-class-method","html_id":"init-class-method","name":"init","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L8","def":{"name":"init","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"is_heap_ptr(pointer:Pointer(Void))-class-method","html_id":"is_heap_ptr(pointer:Pointer(Void))-class-method","name":"is_heap_ptr","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L39","def":{"name":"is_heap_ptr","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"malloc(size:Int)-class-method","html_id":"malloc(size:Int)-class-method","name":"malloc","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L59","def":{"name":"malloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"malloc(LibC::SizeT.new(size))"}},{"id":"malloc_atomic(size:Int)-class-method","html_id":"malloc_atomic(size:Int)-class-method","name":"malloc_atomic","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L63","def":{"name":"malloc_atomic","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"malloc_atomic(LibC::SizeT.new(size))"}},{"id":"realloc(pointer:Pointer(Void),size:Int)-class-method","html_id":"realloc(pointer:Pointer(Void),size:Int)-class-method","name":"realloc","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(pointer : Pointer(Void), size : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L67","def":{"name":"realloc","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"realloc(pointer, LibC::SizeT.new(size))"}},{"id":"register_disappearing_link(pointer:Pointer(Pointer(Void)))-class-method","html_id":"register_disappearing_link(pointer:Pointer(Pointer(Void)))-class-method","name":"register_disappearing_link","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(::Pointer(Void))"}],"args_string":"(pointer : Pointer(Pointer(Void)))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/boehm.cr#L131","def":{"name":"register_disappearing_link","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(::Pointer(Void))"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"base = LibGC.base(pointer.value)\nLibGC.general_register_disappearing_link(pointer, base)\n"}},{"id":"stats-class-method","html_id":"stats-class-method","name":"stats","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc/none.cr#L46","def":{"name":"stats","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"zero = LibC::ULong.new(0)\nStats.new(zero, zero, zero, zero, zero)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/GC/Stats","path":"GC/Stats.html","kind":"struct","full_name":"GC::Stats","name":"Stats","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"gc.cr","line_number":50,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/GC","kind":"module","full_name":"GC","name":"GC"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(heap_size:LibC::ULong,free_bytes:LibC::ULong,unmapped_bytes:LibC::ULong,bytes_since_gc:LibC::ULong,total_bytes:LibC::ULong)-class-method","html_id":"new(heap_size:LibC::ULong,free_bytes:LibC::ULong,unmapped_bytes:LibC::ULong,bytes_since_gc:LibC::ULong,total_bytes:LibC::ULong)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"heap_size","doc":null,"default_value":"","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","doc":null,"default_value":"","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","doc":null,"default_value":"","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","doc":null,"default_value":"","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"total_bytes","doc":null,"default_value":"","external_name":"total_bytes","restriction":"LibC::ULong"}],"args_string":"(heap_size : LibC::ULong, free_bytes : LibC::ULong, unmapped_bytes : LibC::ULong, bytes_since_gc : LibC::ULong, total_bytes : LibC::ULong)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","def":{"name":"new","args":[{"name":"heap_size","doc":null,"default_value":"","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","doc":null,"default_value":"","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","doc":null,"default_value":"","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","doc":null,"default_value":"","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"total_bytes","doc":null,"default_value":"","external_name":"total_bytes","restriction":"LibC::ULong"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(heap_size, free_bytes, unmapped_bytes, bytes_since_gc, total_bytes)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"bytes_since_gc:LibC::ULong-instance-method","html_id":"bytes_since_gc:LibC::ULong-instance-method","name":"bytes_since_gc","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibC::ULong","source_link":null,"source_link":null,"def":{"name":"bytes_since_gc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::ULong","visibility":"Public","body":"@bytes_since_gc"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Stats.new(@heap_size.clone, @free_bytes.clone, @unmapped_bytes.clone, @bytes_since_gc.clone, @total_bytes.clone)"}},{"id":"copy_with(heap_size_heap_size=@heap_size,free_bytes_free_bytes=@free_bytes,unmapped_bytes_unmapped_bytes=@unmapped_bytes,bytes_since_gc_bytes_since_gc=@bytes_since_gc,total_bytes_total_bytes=@total_bytes)-instance-method","html_id":"copy_with(heap_size_heap_size=@heap_size,free_bytes_free_bytes=@free_bytes,unmapped_bytes_unmapped_bytes=@unmapped_bytes,bytes_since_gc_bytes_since_gc=@bytes_since_gc,total_bytes_total_bytes=@total_bytes)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_heap_size","doc":null,"default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","doc":null,"default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","doc":null,"default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","doc":null,"default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_total_bytes","doc":null,"default_value":"@total_bytes","external_name":"total_bytes","restriction":""}],"args_string":"(heap_size _heap_size = @heap_size, free_bytes _free_bytes = @free_bytes, unmapped_bytes _unmapped_bytes = @unmapped_bytes, bytes_since_gc _bytes_since_gc = @bytes_since_gc, total_bytes _total_bytes = @total_bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gc.cr#L50","def":{"name":"copy_with","args":[{"name":"_heap_size","doc":null,"default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","doc":null,"default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","doc":null,"default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","doc":null,"default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_total_bytes","doc":null,"default_value":"@total_bytes","external_name":"total_bytes","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Stats.new(_heap_size, _free_bytes, _unmapped_bytes, _bytes_since_gc, _total_bytes)"}},{"id":"free_bytes:LibC::ULong-instance-method","html_id":"free_bytes:LibC::ULong-instance-method","name":"free_bytes","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibC::ULong","source_link":null,"source_link":null,"def":{"name":"free_bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::ULong","visibility":"Public","body":"@free_bytes"}},{"id":"heap_size:LibC::ULong-instance-method","html_id":"heap_size:LibC::ULong-instance-method","name":"heap_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibC::ULong","source_link":null,"source_link":null,"def":{"name":"heap_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::ULong","visibility":"Public","body":"@heap_size"}},{"id":"total_bytes:LibC::ULong-instance-method","html_id":"total_bytes:LibC::ULong-instance-method","name":"total_bytes","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibC::ULong","source_link":null,"source_link":null,"def":{"name":"total_bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::ULong","visibility":"Public","body":"@total_bytes"}},{"id":"unmapped_bytes:LibC::ULong-instance-method","html_id":"unmapped_bytes:LibC::ULong-instance-method","name":"unmapped_bytes","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibC::ULong","source_link":null,"source_link":null,"def":{"name":"unmapped_bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::ULong","visibility":"Public","body":"@unmapped_bytes"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Gzip","path":"Gzip.html","kind":"module","full_name":"Gzip","name":"Gzip","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"gzip/gzip.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/gzip.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"Flate::BEST_COMPRESSION","doc":null,"summary":null},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"Flate::BEST_SPEED","doc":null,"summary":null},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"Flate::DEFAULT_COMPRESSION","doc":null,"summary":null},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"Flate::NO_COMPRESSION","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The Gzip module contains readers and writers of gzip format compressed\ndata, as specified in [RFC 1952](https://www.ietf.org/rfc/rfc1952.txt).","summary":"<p>The Gzip module contains readers and writers of gzip format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1952.txt\" target=\"_blank\">RFC 1952</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Gzip/Error","path":"Gzip/Error.html","kind":"class","full_name":"Gzip::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"gzip/gzip.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/gzip.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Gzip","kind":"module","full_name":"Gzip","name":"Gzip"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Gzip/Header","path":"Gzip/Header.html","kind":"class","full_name":"Gzip::Header","name":"Header","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"gzip/header.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Gzip","kind":"module","full_name":"Gzip","name":"Gzip"},"doc":"A header in a gzip stream.","summary":"<p>A header in a gzip stream.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"comment:String?-instance-method","html_id":"comment:String?-instance-method","name":"comment","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L7","def":{"name":"comment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@comment"}},{"id":"comment=(comment:String?)-instance-method","html_id":"comment=(comment:String?)-instance-method","name":"comment=","doc":null,"summary":null,"abstract":false,"args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":"String | ::Nil"}],"args_string":"(comment : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L7","def":{"name":"comment=","args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@comment = comment"}},{"id":"extra:Slice(UInt8)-instance-method","html_id":"extra:Slice(UInt8)-instance-method","name":"extra","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Slice(UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L5","def":{"name":"extra","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra"}},{"id":"extra=(extra)-instance-method","html_id":"extra=(extra)-instance-method","name":"extra=","doc":null,"summary":null,"abstract":false,"args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":""}],"args_string":"(extra)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L5","def":{"name":"extra=","args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra = extra"}},{"id":"modification_time:Time-instance-method","html_id":"modification_time:Time-instance-method","name":"modification_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L3","def":{"name":"modification_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"@modification_time"}},{"id":"modification_time=(modification_time:Time)-instance-method","html_id":"modification_time=(modification_time:Time)-instance-method","name":"modification_time=","doc":null,"summary":null,"abstract":false,"args":[{"name":"modification_time","doc":null,"default_value":"","external_name":"modification_time","restriction":"Time"}],"args_string":"(modification_time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L3","def":{"name":"modification_time=","args":[{"name":"modification_time","doc":null,"default_value":"","external_name":"modification_time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@modification_time = modification_time"}},{"id":"name:String?-instance-method","html_id":"name:String?-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L6","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@name"}},{"id":"name=(name:String?)-instance-method","html_id":"name=(name:String?)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L6","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name = name"}},{"id":"os:UInt8-instance-method","html_id":"os:UInt8-instance-method","name":"os","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L4","def":{"name":"os","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"@os"}},{"id":"os=(os:UInt8)-instance-method","html_id":"os=(os:UInt8)-instance-method","name":"os=","doc":null,"summary":null,"abstract":false,"args":[{"name":"os","doc":null,"default_value":"","external_name":"os","restriction":"UInt8"}],"args_string":"(os : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/header.cr#L4","def":{"name":"os=","args":[{"name":"os","doc":null,"default_value":"","external_name":"os","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@os = os"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Gzip/Reader","path":"Gzip/Reader.html","kind":"class","full_name":"Gzip::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"gzip/reader.cr","line_number":29,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Gzip","kind":"module","full_name":"Gzip","name":"Gzip"},"doc":"A read-only `IO` object to decompress data in the gzip format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.\n\nNOTE: A gzip stream can contain zero or more members. If it contains\nno members, `header` will be `nil`. If it contains one or more\nmembers, only the first header will be recorded here. This is\nbecause gzipping multiple members is not common as one usually\ncombines gzip with tar. If, however, multiple members are present\nthen reading from this reader will return the concatenation of\nall the members.\n\n### Example: decompress a gzip file\n\n```\nrequire \"gzip\"\n\nFile.write(\"file.gzip\", Bytes[31, 139, 8, 0, 0, 0, 0, 0, 0, 3, 75, 76, 74, 6, 0, 194, 65, 36, 53, 3, 0, 0, 0])\n\nstring = File.open(\"file.gzip\") do |file|\n  Gzip::Reader.open(file) do |gzip|\n    gzip.gets_to_end\n  end\nend\nstring # => \"abc\"\n```","summary":"<p>A read-only <code><a href=\"../IO.html\">IO</a></code> object to decompress data in the gzip format.</p>","class_methods":[{"id":"open(io:IO,sync_close=false,&block)-class-method","html_id":"open(io:IO,sync_close=false,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L63","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(io, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"id":"open(filename:String,&block)-class-method","html_id":"open(filename:String,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L70","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(filename)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"id":"new(io:IO,sync_close=false)-class-method","html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L42","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String)-class-method","html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new reader from the given *filename*.","summary":"<p>Creates a new reader from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L57","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this reader.","summary":"<p>Closes this reader.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L129","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@flate_io.try(&.close)\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L34","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"header:Header?-instance-method","html_id":"header:Header?-instance-method","name":"header","doc":"Returns the first header in the gzip stream, if any.","summary":"<p>Returns the first header in the gzip stream, if any.</p>","abstract":false,"args":[],"args_string":" : Header?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L37","def":{"name":"header","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Header | ::Nil","visibility":"Public","body":"@header"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L76","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nwhile true\n  flate_io = @flate_io\n  if flate_io\n  else\n    return 0\n  end\n  read_bytes = flate_io.read(slice)\n  if read_bytes == 0\n    crc32 = @io.read_bytes(UInt32, IO::ByteFormat::LittleEndian)\n    isize = @io.read_bytes(UInt32, IO::ByteFormat::LittleEndian)\n    if crc32 != @crc32\n      raise(Gzip::Error.new(\"CRC32 checksum mismatch\"))\n    end\n    if isize != @isize\n      raise(Gzip::Error.new(\"isize mismatch\"))\n    end\n    @crc32 = CRC32.initial\n    @isize = 0_u32\n    first_byte = @io.read_byte\n    if first_byte\n      Header.new(first_byte, @io)\n      @flate_io = Flate::Reader.new(@io)\n    else\n      @flate_io = nil\n      break\n    end\n  else\n    @crc32 = CRC32.update(slice[0, read_bytes], @crc32)\n    @isize = @isize + read_bytes\n    break\n  end\nend\nread_bytes\n"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L31","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L31","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes):Nil-instance-method","html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/reader.cr#L124","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Gzip::Reader\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Gzip/Writer","path":"Gzip/Writer.html","kind":"class","full_name":"Gzip::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"gzip/writer.cr","line_number":24,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Gzip","kind":"module","full_name":"Gzip","name":"Gzip"},"doc":"A write-only `IO` object to compress data in the gzip format.\n\nInstances of this class wrap another `IO` object. When you write to this\ninstance, it compresses the data and writes it to the underlying `IO`.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a `Gzip::Writer` instance.\n\n### Example: compress a file\n\n```\nrequire \"gzip\"\n\nFile.write(\"file.txt\", \"abc\")\n\nFile.open(\"./file.txt\", \"r\") do |input_file|\n  File.open(\"./file.gzip\", \"w\") do |output_file|\n    Gzip::Writer.open(output_file) do |gzip|\n      IO.copy(input_file, gzip)\n    end\n  end\nend\n```","summary":"<p>A write-only <code><a href=\"../IO.html\">IO</a></code> object to compress data in the gzip format.</p>","class_methods":[{"id":"open(io:IO,level=Gzip::DEFAULT_COMPRESSION,sync_close=false,&block)-class-method","html_id":"open(io:IO,level=Gzip::DEFAULT_COMPRESSION,sync_close=false,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, level = <span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L50","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(io, level: level, sync_close: sync_close)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"id":"open(filename:String,level=Gzip::DEFAULT_COMPRESSION,&block)-class-method","html_id":"open(filename:String,level=Gzip::DEFAULT_COMPRESSION,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"args_string":"(filename : String, level = <span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L57","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(filename, level: level)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"id":"new(io:IO,level=Gzip::DEFAULT_COMPRESSION,sync_close=false)-class-method","html_id":"new(io:IO,level=Gzip::DEFAULT_COMPRESSION,sync_close=false)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, level = <span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L38","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, level, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String,level=Gzip::DEFAULT_COMPRESSION)-class-method","html_id":"new(filename:String,level=Gzip::DEFAULT_COMPRESSION)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"args_string":"(filename : String, level = <span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L44","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename, \"w\"), level: level, sync_close: true)"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L93","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nflate_io = write_header\nflate_io.close\n@io.write_bytes(@crc32, IO::ByteFormat::LittleEndian)\n@io.write_bytes(@isize, IO::ByteFormat::LittleEndian)\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L29","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes data, forcing writing the gzip header if no\ndata has been written yet.\n\nSee `IO#flush`.","summary":"<p>Flushes data, forcing writing the gzip header if no data has been written yet.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L85","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nflate_io = write_header\nflate_io.flush\n"}},{"id":"header:Gzip::Header-instance-method","html_id":"header:Gzip::Header-instance-method","name":"header","doc":"The header to write to the gzip stream. It will be\nwritten just before the first write to this writer.\nChanges to the header after the first write are\nignored.","summary":"<p>The header to write to the gzip stream.</p>","abstract":false,"args":[],"args_string":" : Gzip::Header","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L35","def":{"name":"header","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@header"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L63","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from Gzip::Writer\"))"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L26","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L26","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes):Nil-instance-method","html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/gzip/writer.cr#L68","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\nflate_io = write_header\nflate_io.write(slice)\n@crc32 = CRC32.update(slice, @crc32)\n@isize = @isize + slice.size\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Hash","path":"Hash.html","kind":"class","full_name":"Hash(K, V)","name":"Hash","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"hash.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr"},{"filename":"json/any.cr","line_number":288,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"json/to_json.cr","line_number":79,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/any.cr","line_number":299,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"},{"filename":"yaml/to_yaml.cr","line_number":23,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Hash` represents a mapping of keys to values.\n\nSee the [official docs](http://crystal-lang.org/docs/syntax_and_semantics/literals/hash.html) for the basics.","summary":"<p>A <code><a href=\"Hash.html\">Hash</a></code> represents a mapping of keys to values.</p>","class_methods":[{"id":"zip(ary1:Array(K),ary2:Array(V))-class-method","html_id":"zip(ary1:Array(K),ary2:Array(V))-class-method","name":"zip","doc":"Zips two arrays into a `Hash`, taking keys from *ary1* and values from *ary2*.\n\n```\nHash.zip([\"key1\", \"key2\", \"key3\"], [\"value1\", \"value2\", \"value3\"])\n# => {\"key1\" => \"value1\", \"key2\" => \"value2\", \"key3\" => \"value3\"}\n```","summary":"<p>Zips two arrays into a <code><a href=\"Hash.html\">Hash</a></code>, taking keys from <em>ary1</em> and values from <em>ary2</em>.</p>","abstract":false,"args":[{"name":"ary1","doc":null,"default_value":"","external_name":"ary1","restriction":"Array(K)"},{"name":"ary2","doc":null,"default_value":"","external_name":"ary2","restriction":"Array(V)"}],"args_string":"(ary1 : Array(K), ary2 : Array(V))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L599","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L599","def":{"name":"zip","args":[{"name":"ary1","doc":null,"default_value":"","external_name":"ary1","restriction":"Array(K)"},{"name":"ary2","doc":null,"default_value":"","external_name":"ary2","restriction":"Array(V)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = {} of K => V\nary1.each_with_index do |key, i|\n  hash[key] = ary2[i]\nend\nhash\n"}}],"constructors":[{"id":"new(block:Hash(K,V),K->V?=nil,initial_capacity=nil)-class-method","html_id":"new(block:Hash(K,V),K-&gt;V?=nil,initial_capacity=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"block","doc":null,"default_value":"nil","external_name":"block","restriction":"(Hash(K, V), K -> V) | ::Nil"},{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(block : Hash(K, V), K -> V? = <span class=\"n\">nil</span>, initial_capacity = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L16","def":{"name":"new","args":[{"name":"block","doc":null,"default_value":"nil","external_name":"block","restriction":"(Hash(K, V), K -> V) | ::Nil"},{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Hash(K, V).allocate\n_.initialize(block, initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&block)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&amp;block)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L107","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Mapping)\nelse\n  node.raise(\"Expected mapping, not #{node.class}\")\nend\nYAML::Schema::Core.each(node) do |key, value|\n  yield K.new(ctx, key), V.new(ctx, value)\nend\n"}},{"id":"new(initial_capacity=nil,&block:Hash(K,V),K->V)-class-method","html_id":"new(initial_capacity=nil,&amp;block:Hash(K,V),K-&gt;V)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(initial_capacity = <span class=\"n\">nil</span>, &block : Hash(K, V), K -> V)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L26","def":{"name":"new","args":[{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Hash(K, V), K -> V)"},"return_type":"","visibility":"Public","body":"new(block, initial_capacity: initial_capacity)"}},{"id":"new(default_value:V,initial_capacity=nil)-class-method","html_id":"new(default_value:V,initial_capacity=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"default_value","doc":null,"default_value":"","external_name":"default_value","restriction":"V"},{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(default_value : V, initial_capacity = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L30","def":{"name":"new","args":[{"name":"default_value","doc":null,"default_value":"","external_name":"default_value","restriction":"V"},{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(initial_capacity: initial_capacity) do\n  default_value\nend"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L92","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ctx.read_alias(node, self) do |obj|\n  return obj\nend\nhash = new\nctx.record_anchor(node, hash)\nnew(ctx, node) do |key, value|\n  hash[key] = value\nend\nhash\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L123","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = new\npull.read_object do |key|\n  if pull.kind == (:null)\n    pull.read_next\n  else\n    hash[key] = V.new(pull)\n  end\nend\nhash\n"}}],"instance_methods":[{"id":"==(other:YAML::Any)-instance-method","html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L300","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L300","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other:JSON::Any)-instance-method","html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L289","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other:Hash)-instance-method","html_id":"==(other:Hash)-instance-method","name":"==","doc":"Compares with *other*. Returns `true` if all key-value pairs are the same.","summary":"<p>Compares with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L743","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L743","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\neach do |key, value|\n  entry = other.find_entry(key)\n  if entry && (entry.value == value)\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"[](key)-instance-method","html_id":"[](key)-instance-method","name":"[]","doc":"See also: `Hash#fetch`.","summary":"<p>See also: <code><a href=\"Hash.html#fetch%28key%2Cdefault%29-instance-method\">Hash#fetch</a></code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L61","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key)"}},{"id":"[]=(key:K,value:V)-instance-method","html_id":"[]=(key:K,value:V)-instance-method","name":"[]=","doc":"Sets the value of *key* to the given *value*.\n\n```\nh = {} of String => String\nh[\"foo\"] = \"bar\"\nh[\"foo\"] # => \"bar\"\n```","summary":"<p>Sets the value of <em>key</em> to the given <em>value</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"K"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"V"}],"args_string":"(key : K, value : V)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L41","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"K"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"V"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @size > (5 * @buckets_size)\n  rehash\nend\nindex = bucket_index(key)\nentry = insert_in_bucket(index, key, value)\nif entry\nelse\n  return value\nend\n@size = @size + 1\nif last = @last\n  last.fore = entry\n  entry.back = last\nend\n@last = entry\nif @first\nelse\n  @first = entry\nend\nvalue\n"}},{"id":"[]?(key)-instance-method","html_id":"[]?(key)-instance-method","name":"[]?","doc":"Returns the value for the key given by *key*.\nIf not found, returns `nil`. This ignores the default value set by `Hash.new`.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"foo\"]? # => \"bar\"\nh[\"bar\"]? # => nil\n\nh = Hash(String, String).new(\"bar\")\nh[\"foo\"]? # => nil\n```","summary":"<p>Returns the value for the key given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L76","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key, nil)"}},{"id":"clear-instance-method","html_id":"clear-instance-method","name":"clear","doc":"Empties a `Hash` and returns it.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.clear # => {}\n```","summary":"<p>Empties a <code><a href=\"Hash.html\">Hash</a></code> and returns it.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L732","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buckets_size.times do |i|\n  @buckets[i] = nil\nend\n@size = 0\n@first = nil\n@last = nil\nself\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Similar to `#dup`, but duplicates the values as well.\n\n```\nhash_a = {\"foobar\" => {\"foo\" => \"bar\"}}\nhash_b = hash_a.clone\nhash_b[\"foobar\"][\"foo\"] = \"baz\"\nhash_a # => {\"foobar\" => {\"foo\" => \"bar\"}}\n```","summary":"<p>Similar to <code><a href=\"Hash.html#dup-instance-method\">#dup</a></code>, but duplicates the values as well.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L792","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L792","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = Hash(K, V).new(initial_capacity: @buckets_size)\neach do |key, value|\n  hash[key] = value.clone\nend\nhash\n"}},{"id":"compact-instance-method","html_id":"compact-instance-method","name":"compact","doc":"Returns new `Hash` without `nil` values.\n\n```\nhash = {\"hello\" => \"world\", \"foo\" => nil}\nhash.compact # => {\"hello\" => \"world\"}\n```","summary":"<p>Returns new <code><a href=\"Hash.html\">Hash</a></code> without <code>nil</code> values.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L576","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L576","def":{"name":"compact","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_with_object({} of K => typeof(self.first_value.not_nil!)) do |__arg2, memo|\n  key = __arg2[0]\n  value = __arg2[1]\n  if value.nil?\n  else\n    memo[key] = value\n  end\nend"}},{"id":"compact!-instance-method","html_id":"compact!-instance-method","name":"compact!","doc":"Removes all `nil` value from `self`. Returns `nil` if no changes were made.\n\n```\nhash = {\"hello\" => \"world\", \"foo\" => nil}\nhash.compact! # => {\"hello\" => \"world\"}\nhash.compact! # => nil\n```","summary":"<p>Removes all <code>nil</code> value from <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L589","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L589","def":{"name":"compact!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reject! do |key, value|\n  value.nil?\nend"}},{"id":"delete(key)-instance-method","html_id":"delete(key)-instance-method","name":"delete","doc":"Deletes the key-value pair and returns the value, otherwise returns `nil`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.delete(\"foo\")     # => \"bar\"\nh.fetch(\"foo\", nil) # => nil\n```","summary":"<p>Deletes the key-value pair and returns the value, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L210","def":{"name":"delete","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"delete(key) do\n  nil\nend"}},{"id":"delete(key,&block)-instance-method","html_id":"delete(key,&amp;block)-instance-method","name":"delete","doc":"Deletes the key-value pair and returns the value, else yields *key* with given block.\n\n```\nh = {\"foo\" => \"bar\"}\nh.delete(\"foo\") { |key| \"#{key} not found\" } # => \"bar\"\nh.fetch(\"foo\", nil)                          # => nil\nh.delete(\"baz\") { |key| \"#{key} not found\" } # => \"baz not found\"\n```","summary":"<p>Deletes the key-value pair and returns the value, else yields <em>key</em> with given block.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L222","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L222","def":{"name":"delete","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"index = bucket_index(key)\nentry = @buckets[index]\nprevious_entry = nil\nwhile entry\n  if entry.key == key\n    back_entry = entry.back\n    fore_entry = entry.fore\n    if fore_entry\n      if back_entry\n        back_entry.fore = fore_entry\n        fore_entry.back = back_entry\n      else\n        @first = fore_entry\n        fore_entry.back = nil\n      end\n    else\n      if back_entry\n        back_entry.fore = nil\n        @last = back_entry\n      else\n        @first = nil\n        @last = nil\n      end\n    end\n    if previous_entry\n      previous_entry.next = entry.next\n    else\n      @buckets[index] = entry.next\n    end\n    @size = @size - 1\n    return entry.value\n  end\n  previous_entry = entry\n  entry = entry.next\nend\nyield key\n"}},{"id":"delete_if(&block)-instance-method","html_id":"delete_if(&amp;block)-instance-method","name":"delete_if","doc":"Deletes each key-value pair for which the given block returns `true`.\n\n```\nh = {\"foo\" => \"bar\", \"fob\" => \"baz\", \"bar\" => \"qux\"}\nh.delete_if { |key, value| key.starts_with?(\"fo\") }\nh # => { \"bar\" => \"qux\" }\n```","summary":"<p>Deletes each key-value pair for which the given block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L269","def":{"name":"delete_if","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"keys_to_delete = [] of K\neach do |key, value|\n  if yield key, value\n    keys_to_delete << key\n  end\nend\nkeys_to_delete.each do |key|\n  delete(key)\nend\nself\n"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Duplicates a `Hash`.\n\n```\nhash_a = {\"foo\" => \"bar\"}\nhash_b = hash_a.dup\nhash_b.merge!({\"baz\" => \"qux\"})\nhash_a # => {\"foo\" => \"bar\"}\n```","summary":"<p>Duplicates a <code><a href=\"Hash.html\">Hash</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L776","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L776","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = Hash(K, V).new(initial_capacity: @buckets_size)\neach do |key, value|\n  hash[key] = value\nend\nhash\n"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Returns an iterator over the hash entries.\nWhich behaves like an `Iterator` returning a `Tuple` consisting of the key and value types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each\n\niterator.next # => {\"foo\", \"bar\"}\niterator.next # => {\"baz\", \"qux\"}\n```","summary":"<p>Returns an iterator over the hash entries.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L325","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L325","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"EntryIterator(K, V).new(self, @first)"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Calls the given block for each key-value pair and passes in the key and the value.\n\n```\nh = {\"foo\" => \"bar\"}\n\nh.each do |key, value|\n  key   # => \"foo\"\n  value # => \"bar\"\nend\n\nh.each do |key_and_value|\n  key_and_value # => {\"foo\", \"bar\"}\nend\n```","summary":"<p>Calls the given block for each key-value pair and passes in the key and the value.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L307","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L307","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"current = @first\nwhile current\n  yield {current.key, current.value}\n  current = current.fore\nend\n"}},{"id":"each_key-instance-method","html_id":"each_key-instance-method","name":"each_key","doc":"Returns an iterator over the hash keys.\nWhich behaves like an `Iterator` consisting of the key's types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each_key\n\nkey = iterator.next\nkey # => \"foo\"\n\nkey = iterator.next\nkey # => \"baz\"\n```","summary":"<p>Returns an iterator over the hash keys.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L356","def":{"name":"each_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"KeyIterator(K, V).new(self, @first)"}},{"id":"each_key(&block)-instance-method","html_id":"each_key(&amp;block)-instance-method","name":"each_key","doc":"Calls the given block for each key-value pair and passes in the key.\n\n```\nh = {\"foo\" => \"bar\"}\nh.each_key do |key|\n  key # => \"foo\"\nend\n```","summary":"<p>Calls the given block for each key-value pair and passes in the key.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L337","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L337","def":{"name":"each_key","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |key, value|\n  yield key\nend"}},{"id":"each_value(&block)-instance-method","html_id":"each_value(&amp;block)-instance-method","name":"each_value","doc":"Calls the given block for each key-value pair and passes in the value.\n\n```\nh = {\"foo\" => \"bar\"}\nh.each_value do |value|\n  value # => \"bar\"\nend\n```","summary":"<p>Calls the given block for each key-value pair and passes in the value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L368","def":{"name":"each_value","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |key, value|\n  yield value\nend"}},{"id":"each_value-instance-method","html_id":"each_value-instance-method","name":"each_value","doc":"Returns an iterator over the hash values.\nWhich behaves like an `Iterator` consisting of the value's types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each_value\n\nvalue = iterator.next\nvalue # => \"bar\"\n\nvalue = iterator.next\nvalue # => \"qux\"\n```","summary":"<p>Returns an iterator over the hash values.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L387","def":{"name":"each_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ValueIterator(K, V).new(self, @first)"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` when hash contains no key-value pairs.\n\n```\nh = Hash(String, String).new\nh.empty? # => true\n\nh = {\"foo\" => \"bar\"}\nh.empty? # => false\n```","summary":"<p>Returns <code>true</code> when hash contains no key-value pairs.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L289","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size == 0"}},{"id":"fetch(key,default)-instance-method","html_id":"fetch(key,default)-instance-method","name":"fetch","doc":"Returns the value for the key given by *key*, or when not found the value given by *default*.\nThis ignores the default value set by `Hash.new`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.fetch(\"foo\", \"foo\") # => \"bar\"\nh.fetch(\"bar\", \"foo\") # => \"foo\"\n```","summary":"<p>Returns the value for the key given by <em>key</em>, or when not found the value given by <em>default</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"args_string":"(key, default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L139","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key) do\n  default\nend"}},{"id":"fetch(key)-instance-method","html_id":"fetch(key)-instance-method","name":"fetch","doc":"Returns the value for the key given by *key*.\nIf not found, returns the default value given by `Hash.new`, otherwise raises `KeyError`.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new(\"bar\")\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new { \"bar\" }\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new\nh[\"foo\"] # raises KeyError\n```","summary":"<p>Returns the value for the key given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L121","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key) do\n  if (block = @block) && key.is_a?(K)\n    block.call(self, key.as(K))\n  else\n    raise(KeyError.new(\"Missing hash key: #{key.inspect}\"))\n  end\nend"}},{"id":"fetch(key,&block)-instance-method","html_id":"fetch(key,&amp;block)-instance-method","name":"fetch","doc":"Returns the value for the key given by *key*, or when not found calls the given block with the key.\n\n```\nh = {\"foo\" => \"bar\"}\nh.fetch(\"foo\") { |key| key.upcase } # => \"bar\"\nh.fetch(\"bar\") { |key| key.upcase } # => \"BAR\"\n```","summary":"<p>Returns the value for the key given by <em>key</em>, or when not found calls the given block with the key.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L150","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"entry = find_entry(key)\nentry ? entry.value : yield key\n"}},{"id":"first_key-instance-method","html_id":"first_key-instance-method","name":"first_key","doc":"Returns the first key in the hash.","summary":"<p>Returns the first key in the hash.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L608","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L608","def":{"name":"first_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@first.not_nil!.key"}},{"id":"first_key?-instance-method","html_id":"first_key?-instance-method","name":"first_key?","doc":"Returns the first key if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.first_key? # => \"foo1\"\nhash.clear\nhash.first_key? # => nil\n```","summary":"<p>Returns the first key if it exists, or returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L620","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L620","def":{"name":"first_key?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@first.try(&.key)"}},{"id":"first_value-instance-method","html_id":"first_value-instance-method","name":"first_value","doc":"Returns the first value in the hash.","summary":"<p>Returns the first value in the hash.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L625","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L625","def":{"name":"first_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@first.not_nil!.value"}},{"id":"first_value?-instance-method","html_id":"first_value?-instance-method","name":"first_value?","doc":"Returns the first value if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.first_value? # => \"bar1\"\nhash.clear\nhash.first_value? # => nil\n```","summary":"<p>Returns the first value if it exists, or returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L637","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L637","def":{"name":"first_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@first.try(&.value)"}},{"id":"has_key?(key)-instance-method","html_id":"has_key?(key)-instance-method","name":"has_key?","doc":"Returns `true` when key given by *key* exists, otherwise `false`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.has_key?(\"foo\") # => true\nh.has_key?(\"bar\") # => false\n```","summary":"<p>Returns <code>true</code> when key given by <em>key</em> exists, otherwise <code>false</code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L87","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(!(find_entry(key)))"}},{"id":"has_value?(val)-instance-method","html_id":"has_value?(val)-instance-method","name":"has_value?","doc":"Returns `true` when value given by *value* exists, otherwise `false`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.has_value?(\"foo\") # => false\nh.has_value?(\"bar\") # => true\n```","summary":"<p>Returns <code>true</code> when value given by <em>value</em> exists, otherwise <code>false</code>.</p>","abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":""}],"args_string":"(val)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L98","def":{"name":"has_value?","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_value do |value|\n  if value == val\n    return true\n  end\nend\nfalse\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L753","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L753","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"result = hasher.result\neach do |key, value|\n  copy = hasher\n  copy = key.hash(copy)\n  copy = value.hash(copy)\n  result = result + copy.result\nend\nresult.hash(hasher)\n"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L800","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L800","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"invert-instance-method","html_id":"invert-instance-method","name":"invert","doc":"Inverts keys and values. If there are duplicated values, the last key becomes the new value.\n\n```\n{\"foo\" => \"bar\"}.invert                 # => {\"bar\" => \"foo\"}\n{\"foo\" => \"bar\", \"baz\" => \"bar\"}.invert # => {\"bar\" => \"baz\"}\n```","summary":"<p>Inverts keys and values.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L868","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L868","def":{"name":"invert","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = Hash(V, K).new(initial_capacity: @buckets_size)\nself.each do |k, v|\n  hash[v] = k\nend\nhash\n"}},{"id":"key_for(value)-instance-method","html_id":"key_for(value)-instance-method","name":"key_for","doc":"Returns a key with the given *value*, else raises `KeyError`.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.key_for(\"bar\")    # => \"foo\"\nhash.key_for(\"qux\")    # => \"baz\"\nhash.key_for(\"foobar\") # raises KeyError (Missing hash key for value: foobar)\n```","summary":"<p>Returns a key with the given <em>value</em>, else raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L173","def":{"name":"key_for","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"key_for(value) do\n  raise(KeyError.new(\"Missing hash key for value: #{value}\"))\nend"}},{"id":"key_for(value,&block)-instance-method","html_id":"key_for(value,&amp;block)-instance-method","name":"key_for","doc":"Returns a key with the given *value*, else yields *value* with the given block.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.key_for(\"bar\") { |value| value.upcase } # => \"foo\"\nhash.key_for(\"qux\") { |value| value.upcase } # => \"QUX\"\n```","summary":"<p>Returns a key with the given <em>value</em>, else yields <em>value</em> with the given block.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L196","def":{"name":"key_for","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |k, v|\n  if v == value\n    return k\n  end\nend\nyield value\n"}},{"id":"key_for?(value)-instance-method","html_id":"key_for?(value)-instance-method","name":"key_for?","doc":"Returns a key with the given *value*, else `nil`.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.key_for?(\"bar\")    # => \"foo\"\nhash.key_for?(\"qux\")    # => \"baz\"\nhash.key_for?(\"foobar\") # => nil\n```","summary":"<p>Returns a key with the given <em>value</em>, else <code>nil</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L185","def":{"name":"key_for?","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"key_for(value) do\n  nil\nend"}},{"id":"key_index(key)-instance-method","html_id":"key_index(key)-instance-method","name":"key_index","doc":"Returns the index of the given key, or `nil` when not found.\nThe keys are ordered based on when they were inserted.\n\n```\nh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nh.key_index(\"foo\") # => 0\nh.key_index(\"qux\") # => nil\n```","summary":"<p>Returns the index of the given key, or <code>nil</code> when not found.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L423","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L423","def":{"name":"key_index","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_with_index do |__arg0, index|\n  my_key = __arg0[0]\n  my_value = __arg0[1]\n  if key == my_key\n    return index\n  end\nend\nnil\n"}},{"id":"keys-instance-method","html_id":"keys-instance-method","name":"keys","doc":"Returns a new `Array` with all the keys.\n\n```\nh = {\"foo\" => \"bar\", \"baz\" => \"bar\"}\nh.keys # => [\"foo\", \"baz\"]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> with all the keys.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L397","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L397","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"keys = Array(K).new(@size)\neach_key do |key|\n  keys << key\nend\nkeys\n"}},{"id":"last_key-instance-method","html_id":"last_key-instance-method","name":"last_key","doc":"Returns the last key in the hash.","summary":"<p>Returns the last key in the hash.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L642","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L642","def":{"name":"last_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last.not_nil!.key"}},{"id":"last_key?-instance-method","html_id":"last_key?-instance-method","name":"last_key?","doc":"Returns the last key if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.last_key? # => \"foz2\"\nhash.clear\nhash.last_key? # => nil\n```","summary":"<p>Returns the last key if it exists, or returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L654","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L654","def":{"name":"last_key?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last.try(&.key)"}},{"id":"last_value-instance-method","html_id":"last_value-instance-method","name":"last_value","doc":"Returns the last value in the hash.","summary":"<p>Returns the last value in the hash.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L659","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L659","def":{"name":"last_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last.not_nil!.value"}},{"id":"last_value?-instance-method","html_id":"last_value?-instance-method","name":"last_value?","doc":"Returns the last value if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.last_value? # => \"baz2\"\nhash.clear\nhash.last_value? # => nil\n```","summary":"<p>Returns the last value if it exists, or returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L671","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L671","def":{"name":"last_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last.try(&.value)"}},{"id":"merge(other:Hash(L,W))forallL,W-instance-method","html_id":"merge(other:Hash(L,W))forallL,W-instance-method","name":"merge","doc":"Returns a new `Hash` with the keys and values of this hash and *other* combined.\nA value in *other* takes precedence over the one in this hash.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.merge({\"baz\" => \"qux\"})\n# => {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash\n# => {\"foo\" => \"bar\"}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> with the keys and values of this hash and <em>other</em> combined.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash(L, W)"}],"args_string":"(other : Hash(L, W)) forall L, W","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L440","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L440","def":{"name":"merge","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash(L, W)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = Hash(K | L, V | W).new\nhash.merge!(self)\nhash.merge!(other)\nhash\n"}},{"id":"merge(other:Hash(L,W),&block:K,V,W->V|W)forallL,W-instance-method","html_id":"merge(other:Hash(L,W),&amp;block:K,V,W-&gt;V|W)forallL,W-instance-method","name":"merge","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash(L, W)"}],"args_string":"(other : Hash(L, W), &block : K, V, W -> V | W) forall L, W","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L447","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L447","def":{"name":"merge","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash(L, W)"}],"double_splat":null,"splat_index":null,"yields":3,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(K, V, W -> V | W)"},"return_type":"","visibility":"Public","body":"hash = Hash(K | L, V | W).new\nhash.merge!(self)\nhash.merge!(other) do |k, v1, v2|\n  yield k, v1, v2\nend\nhash\n"}},{"id":"merge!(other:Hash,&block)-instance-method","html_id":"merge!(other:Hash,&amp;block)-instance-method","name":"merge!","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L468","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L468","def":{"name":"merge!","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":3,"block_arg":null,"return_type":"","visibility":"Public","body":"other.each do |k, v|\n  if self.has_key?(k)\n    self[k] = yield k, self[k], v\n  else\n    self[k] = v\n  end\nend\nself\n"}},{"id":"merge!(other:Hash)-instance-method","html_id":"merge!(other:Hash)-instance-method","name":"merge!","doc":"Similar to `#merge`, but the receiver is modified.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.merge!({\"baz\" => \"qux\"})\nhash # => {\"foo\" => \"bar\", \"baz\" => \"qux\"}\n```","summary":"<p>Similar to <code><a href=\"Hash.html#merge%28other%3AHash%28L%2CW%29%29forallL%2CW-instance-method\">#merge</a></code>, but the receiver is modified.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L461","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L461","def":{"name":"merge!","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.each do |k, v|\n  self[k] = v\nend\nself\n"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L827","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L827","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:pretty_print) do\n  pp.list(\"{\", self, \"}\") do |key, value|\n    pp.group do\n      key.pretty_print(pp)\n      pp.text(\" =>\")\n      pp.nest do\n        pp.breakable\n        value.pretty_print(pp)\n      end\n    end\n  end\nend\nif executed\nelse\n  pp.text(\"{...}\")\nend\n"}},{"id":"rehash-instance-method","html_id":"rehash-instance-method","name":"rehash","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L848","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L848","def":{"name":"rehash","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_size = calculate_new_size(@size)\n@buckets = @buckets.realloc(new_size)\nnew_size.times do |i|\n  @buckets[i] = nil\nend\n@buckets_size = new_size\nentry = @last\nwhile entry\n  index = bucket_index(entry.key)\n  entry.next = @buckets[index]\n  @buckets[index] = entry\n  entry = entry.back\nend\n"}},{"id":"reject(*keys)-instance-method","html_id":"reject(*keys)-instance-method","name":"reject","doc":"Returns a new `Hash` without the given keys.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.reject(\"a\", \"c\") # => {\"b\" => 2, \"d\" => 4}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> without the given keys.</p>","abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"args_string":"(*keys)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L520","def":{"name":"reject","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = self.dup\nhash.reject!(*keys)\n"}},{"id":"reject(&block:K,V->_)-instance-method","html_id":"reject(&amp;block:K,V-&gt;_)-instance-method","name":"reject","doc":"Returns a new hash consisting of entries for which the block returns `false`.\n```\nh = {\"a\" => 100, \"b\" => 200, \"c\" => 300}\nh.reject { |k, v| k > \"a\" } # => {\"a\" => 100}\nh.reject { |k, v| v < 200 } # => {\"b\" => 200, \"c\" => 300}\n```","summary":"<p>Returns a new hash consisting of entries for which the block returns <code>false</code>.</p>","abstract":false,"args":[],"args_string":"(&block : K, V -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L500","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L500","def":{"name":"reject","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(K, V -> _)"},"return_type":"","visibility":"Public","body":"each_with_object({} of K => V) do |__arg1, memo|\n  k = __arg1[0]\n  v = __arg1[1]\n  if yield k, v\n  else\n    memo[k] = v\n  end\nend"}},{"id":"reject!(*keys)-instance-method","html_id":"reject!(*keys)-instance-method","name":"reject!","doc":null,"summary":null,"abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"args_string":"(*keys)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L536","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L536","def":{"name":"reject!","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reject!(keys)"}},{"id":"reject!(keys:Array|Tuple)-instance-method","html_id":"reject!(keys:Array|Tuple)-instance-method","name":"reject!","doc":"Removes a list of keys out of hash.\n\n```\nh = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.reject!(\"a\", \"c\")\nh # => {\"b\" => 2, \"d\" => 4}\n```","summary":"<p>Removes a list of keys out of hash.</p>","abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L531","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L531","def":{"name":"reject!","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"keys.each do |k|\n  delete(k)\nend\nself\n"}},{"id":"reject!(&block:K,V->_)-instance-method","html_id":"reject!(&amp;block:K,V-&gt;_)-instance-method","name":"reject!","doc":"Equivalent to `Hash#reject`, but makes modification on the current object rather that returning a new one. Returns `nil` if no changes were made.","summary":"<p>Equivalent to <code><a href=\"Hash.html#reject%28%26block%3AK%2CV-%3E_%29-instance-method\">Hash#reject</a></code>, but makes modification on the current object rather that returning a new one.</p>","abstract":false,"args":[],"args_string":"(&block : K, V -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L507","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L507","def":{"name":"reject!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(K, V -> _)"},"return_type":"","visibility":"Public","body":"num_entries = size\neach do |key, value|\n  if yield key, value\n    delete(key)\n  end\nend\nnum_entries == size ? nil : self\n"}},{"id":"select(*keys)-instance-method","html_id":"select(*keys)-instance-method","name":"select","doc":null,"summary":null,"abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"args_string":"(*keys)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L551","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L551","def":{"name":"select","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.select(keys)"}},{"id":"select(keys:Array|Tuple)-instance-method","html_id":"select(keys:Array|Tuple)-instance-method","name":"select","doc":"Returns a new `Hash` with the given keys.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select(\"a\", \"c\") # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> with the given keys.</p>","abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L545","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L545","def":{"name":"select","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = {} of K => V\nkeys.each do |k|\n  if has_key?(k)\n    hash[k] = self[k]\n  end\nend\nhash\n"}},{"id":"select(&block:K,V->_)-instance-method","html_id":"select(&amp;block:K,V-&gt;_)-instance-method","name":"select","doc":"Returns a new hash consisting of entries for which the block returns `true`.\n```\nh = {\"a\" => 100, \"b\" => 200, \"c\" => 300}\nh.select { |k, v| k > \"a\" } # => {\"b\" => 200, \"c\" => 300}\nh.select { |k, v| v < 200 } # => {\"a\" => 100}\n```","summary":"<p>Returns a new hash consisting of entries for which the block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block : K, V -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L485","def":{"name":"select","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(K, V -> _)"},"return_type":"","visibility":"Public","body":"reject do |k, v|\n  !(yield k, v)\nend"}},{"id":"select!(*keys)-instance-method","html_id":"select!(*keys)-instance-method","name":"select!","doc":null,"summary":null,"abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"args_string":"(*keys)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L566","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L566","def":{"name":"select!","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"select!(keys)"}},{"id":"select!(&block:K,V->_)-instance-method","html_id":"select!(&amp;block:K,V-&gt;_)-instance-method","name":"select!","doc":"Equivalent to `Hash#select` but makes modification on the current object rather that returning a new one. Returns `nil` if no changes were made","summary":"<p>Equivalent to <code><a href=\"Hash.html#select%28%26block%3AK%2CV-%3E_%29-instance-method\">Hash#select</a></code> but makes modification on the current object rather that returning a new one.</p>","abstract":false,"args":[],"args_string":"(&block : K, V -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L490","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L490","def":{"name":"select!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(K, V -> _)"},"return_type":"","visibility":"Public","body":"reject! do |k, v|\n  !(yield k, v)\nend"}},{"id":"select!(keys:Array|Tuple)-instance-method","html_id":"select!(keys:Array|Tuple)-instance-method","name":"select!","doc":"Removes every element except the given ones.\n\n```\nh = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!(\"a\", \"c\")\nh # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Removes every element except the given ones.</p>","abstract":false,"args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L561","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L561","def":{"name":"select!","args":[{"name":"keys","doc":null,"default_value":"","external_name":"keys","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each do |k, v|\n  if keys.includes?(k)\n  else\n    delete(k)\n  end\nend\nself\n"}},{"id":"shift(&block)-instance-method","html_id":"shift(&amp;block)-instance-method","name":"shift","doc":"Deletes and returns the first key-value pair in the hash.\nYields to the given block if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift { true } # => {\"foo\", \"bar\"}\nhash                # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift { true } # => true\nhash                # => {}\n```","summary":"<p>Deletes and returns the first key-value pair in the hash.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L716","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L716","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"first = @first\nif first\n  delete(first.key)\n  {first.key, first.value}\nelse\n  yield\nend\n"}},{"id":"shift-instance-method","html_id":"shift-instance-method","name":"shift","doc":"Deletes and returns the first key-value pair in the hash,\nor raises `IndexError` if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift # => {\"foo\", \"bar\"}\nhash       # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift # raises IndexError\n```","summary":"<p>Deletes and returns the first key-value pair in the hash, or raises <code><a href=\"IndexError.html\">IndexError</a></code> if the hash is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L686","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L686","def":{"name":"shift","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"id":"shift?-instance-method","html_id":"shift?-instance-method","name":"shift?","doc":"Same as `#shift`, but returns `nil` if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift? # => {\"foo\", \"bar\"}\nhash        # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift? # => nil\n```","summary":"<p>Same as <code><a href=\"Hash.html#shift%28%26block%29-instance-method\">#shift</a></code>, but returns <code>nil</code> if the hash is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L700","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L700","def":{"name":"shift?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shift do\n  nil\nend"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L10","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"to_h-instance-method","html_id":"to_h-instance-method","name":"to_h","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L844","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L844","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L80","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.object do\n  each do |key, value|\n    json.field(key) do\n      value.to_json(json)\n    end\n  end\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Converts to a `String`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.to_s       # => \"{\\\"foo\\\" => \\\"bar\\\"}\"\nh.to_s.class # => String\n```","summary":"<p>Converts to a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L811","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L811","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"executed = exec_recursive(:to_s) do\n  io << '{'\n  found_one = false\n  each do |key, value|\n    if found_one\n      io << \", \"\n    end\n    key.inspect(io)\n    io << \" => \"\n    value.inspect(io)\n    found_one = true\n  end\n  io << '}'\nend\nif executed\nelse\n  io << \"{...}\"\nend\n"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L24","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.mapping(reference: self) do\n  each do |key, value|\n    key.to_yaml(yaml)\n    value.to_yaml(yaml)\n  end\nend"}},{"id":"values-instance-method","html_id":"values-instance-method","name":"values","doc":"Returns only the values as an `Array`.\n\n```\nh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nh.values # => [\"bar\", \"qux\"]\n```","summary":"<p>Returns only the values as an <code><a href=\"Array.html\">Array</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L409","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"values = Array(V).new(@size)\neach_value do |value|\n  values << value\nend\nvalues\n"}},{"id":"values_at(*indexes:K)-instance-method","html_id":"values_at(*indexes:K)-instance-method","name":"values_at","doc":"Returns a tuple populated with the elements at the given *indexes*.\nRaises if any index is invalid.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.values_at(\"a\", \"c\") # => {1, 3}\n```","summary":"<p>Returns a tuple populated with the elements at the given <em>indexes</em>.</p>","abstract":false,"args":[{"name":"indexes","doc":null,"default_value":"","external_name":"indexes","restriction":"K"}],"args_string":"(*indexes : K)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/hash.cr#L161","def":{"name":"values_at","args":[{"name":"indexes","doc":null,"default_value":"","external_name":"indexes","restriction":"K"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indexes.map do |index|\n  self[index]\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTML","path":"HTML.html","kind":"module","full_name":"HTML","name":"HTML","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"html/entities.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html/entities.cr"},{"filename":"html.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Provides HTML escaping and unescaping methods.\n\nFor HTML *parsing* see module XML, especially `XML.parse_html`.","summary":"<p>Provides HTML escaping and unescaping methods.</p>","class_methods":[{"id":"escape(string:String,io:IO):Nil-class-method","html_id":"escape(string:String,io:IO):Nil-class-method","name":"escape","doc":"Same as `escape(string)` but ouputs the result to\nthe given *io*.\n\n```\nio = IO::Memory.new\nHTML.escape(\"Crystal & You\", io) # => nil\nio.to_s                          # => \"Crystal &amp; You\"\n```","summary":"<p>Same as <code><a href=\"HTML.html#escape%28string%3AString%29%3AString-class-method\">.escape(string)</a></code> but ouputs the result to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(string : String, io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L35","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"string.each_char do |char|\n  io << (SUBSTITUTIONS.fetch(char, char))\nend"}},{"id":"escape(string:String):String-class-method","html_id":"escape(string:String):String-class-method","name":"escape","doc":"Escapes special characters in HTML, namely\n`&`, `<`, `>`, `\"` and `'`.\n\n```\nrequire \"html\"\n\nHTML.escape(\"Crystal & You\") # => \"Crystal &amp; You\"\n```","summary":"<p>Escapes special characters in HTML, namely <code>&</code>, <code><</code>, <code>></code>, <code>\"</code> and <code>'</code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L23","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"string.gsub(SUBSTITUTIONS)"}},{"id":"unescape(string:String):String-class-method","html_id":"unescape(string:String):String-class-method","name":"unescape","doc":"Returns a string where named and numeric character references\n(e.g. &gt;, &#62;, &x3e;) in *string* are replaced with the corresponding\nunicode characters. This method decodes all HTML5 entities including those\nwithout a trailing semicolon (such as `&copy`).\n\n```\nHTML.unescape(\"Crystal &amp; You\") # => \"Crystal & You\"\n```","summary":"<p>Returns a string where named and numeric character references (e.g.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/html.cr#L89","def":{"name":"unescape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"string.gsub(/&(?:([a-zA-Z0-9]{2,32};?)|\\#([0-9]+);?|\\#[xX]([0-9A-Fa-f]+);?)/) do |string, match|\n  if code = match[1]?\n    value = named_entity(code)\n    if value || (code.ends_with?(';'))\n    else\n      removed = 0\n      while !code.empty?\n        code = code.rchop\n        removed = removed + 1\n        value = named_entity(code)\n        if value\n          value = value + string[(-removed)..-1]\n          break\n        end\n      end\n    end\n    value || string\n  else\n    if code = match[2]?\n      (decode_codepoint(code.to_i)) || string\n    else\n      if code = match[3]?\n        (decode_codepoint(code.to_i(16))) || string\n      else\n        string\n      end\n    end\n  end\nend"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP","path":"HTTP.html","kind":"module","full_name":"HTTP","name":"HTTP","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/client.cr","line_number":55,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr"},{"filename":"http/common.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr"},{"filename":"http/params.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr"},{"filename":"http/content.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/content.cr"},{"filename":"http/cookie.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr"},{"filename":"http.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"SUPPORTED_VERSIONS","name":"SUPPORTED_VERSIONS","value":"{\"HTTP/1.0\", \"HTTP/1.1\"}","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The HTTP module contains `HTTP::Client`, `HTTP::Server` and `HTTP::WebSocket` implementations.","summary":"<p>The HTTP module contains <code><a href=\"HTTP/Client.html\">HTTP::Client</a></code>, <code><a href=\"HTTP/Server.html\">HTTP::Server</a></code> and <code><a href=\"HTTP/WebSocket.html\">HTTP::WebSocket</a></code> implementations.</p>","class_methods":[{"id":"default_status_message_for(status_code:Int):String-class-method","html_id":"default_status_message_for(status_code:Int):String-class-method","name":"default_status_message_for","doc":"Returns the default status message of the given HTTP status code.\n\nBased on [Hypertext Transfer Protocol (HTTP) Status Code Registry](https://www.iana.org/assignments/http-status-codes/http-status-codes.xhtml)\n\nLast Updated 2017-04-14\n\nHTTP Status Codes (source: [http-status-codes-1.csv](https://www.iana.org/assignments/http-status-codes/http-status-codes-1.csv))\n\n* 1xx: Informational - Request received, continuing process\n* 2xx: Success - The action was successfully received, understood, and accepted\n* 3xx: Redirection - Further action must be taken in order to complete the request\n* 4xx: Client Error - The request contains bad syntax or cannot be fulfilled\n* 5xx: Server Error - The server failed to fulfill an apparently valid request\n","summary":"<p>Returns the default status message of the given HTTP status code.</p>","abstract":false,"args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":"Int"}],"args_string":"(status_code : Int) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L333","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L333","def":{"name":"default_status_message_for","args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"case status_code\nwhen 100\n  \"Continue\"\nwhen 101\n  \"Switching Protocols\"\nwhen 102\n  \"Processing\"\nwhen 200\n  \"OK\"\nwhen 201\n  \"Created\"\nwhen 202\n  \"Accepted\"\nwhen 203\n  \"Non-Authoritative Information\"\nwhen 204\n  \"No Content\"\nwhen 205\n  \"Reset Content\"\nwhen 206\n  \"Partial Content\"\nwhen 207\n  \"Multi-Status\"\nwhen 208\n  \"Already Reported\"\nwhen 226\n  \"IM Used\"\nwhen 300\n  \"Multiple Choices\"\nwhen 301\n  \"Moved Permanently\"\nwhen 302\n  \"Found\"\nwhen 303\n  \"See Other\"\nwhen 304\n  \"Not Modified\"\nwhen 305\n  \"Use Proxy\"\nwhen 307\n  \"Temporary Redirect\"\nwhen 308\n  \"Permanent Redirect\"\nwhen 400\n  \"Bad Request\"\nwhen 401\n  \"Unauthorized\"\nwhen 402\n  \"Payment Required\"\nwhen 403\n  \"Forbidden\"\nwhen 404\n  \"Not Found\"\nwhen 405\n  \"Method Not Allowed\"\nwhen 406\n  \"Not Acceptable\"\nwhen 407\n  \"Proxy Authentication Required\"\nwhen 408\n  \"Request Timeout\"\nwhen 409\n  \"Conflict\"\nwhen 410\n  \"Gone\"\nwhen 411\n  \"Length Required\"\nwhen 412\n  \"Precondition Failed\"\nwhen 413\n  \"Payload Too Large\"\nwhen 414\n  \"URI Too Long\"\nwhen 415\n  \"Unsupported Media Type\"\nwhen 416\n  \"Range Not Satisfiable\"\nwhen 417\n  \"Expectation Failed\"\nwhen 421\n  \"Misdirected Request\"\nwhen 422\n  \"Unprocessable Entity\"\nwhen 423\n  \"Locked\"\nwhen 424\n  \"Failed Dependency\"\nwhen 426\n  \"Upgrade Required\"\nwhen 428\n  \"Precondition Required\"\nwhen 429\n  \"Too Many Requests\"\nwhen 431\n  \"Request Header Fields Too Large\"\nwhen 451\n  \"Unavailable For Legal Reasons\"\nwhen 500\n  \"Internal Server Error\"\nwhen 501\n  \"Not Implemented\"\nwhen 502\n  \"Bad Gateway\"\nwhen 503\n  \"Service Unavailable\"\nwhen 504\n  \"Gateway Timeout\"\nwhen 505\n  \"HTTP Version Not Supported\"\nwhen 506\n  \"Variant Also Negotiates\"\nwhen 507\n  \"Insufficient Storage\"\nwhen 508\n  \"Loop Detected\"\nwhen 510\n  \"Not Extended\"\nwhen 511\n  \"Network Authentication Required\"\nelse\n  \"\"\nend"}},{"id":"dequote_string(str)-class-method","html_id":"dequote_string(str)-class-method","name":"dequote_string","doc":"Dequotes an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string.\n\n```\nquoted = %q(\\\"foo\\\\bar\\\")\nHTTP.dequote_string(quoted) # => %q(\"foo\\bar\")\n```","summary":"<p>Dequotes an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\" target=\"_blank\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"args_string":"(str)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L264","def":{"name":"dequote_string","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"data = str.to_slice\nquoted_pair_index = data.index('\\\\'.ord)\nif quoted_pair_index\nelse\n  return str\nend\nString.build do |io|\n  while quoted_pair_index\n    io.write(data[0, quoted_pair_index])\n    io << data[quoted_pair_index + 1].chr\n    data = data + (quoted_pair_index + 2)\n    quoted_pair_index = data.index('\\\\'.ord)\n  end\n  io.write(data)\nend\n"}},{"id":"format_time(time:Time):String-class-method","html_id":"format_time(time:Time):String-class-method","name":"format_time","doc":"Format a `Time` object as a `String` using the format specified as `sane-cookie-date`\nby [RFC 6265](https://tools.ietf.org/html/rfc6265#section-4.1.1) which is\naccording to [RFC 2616](https://tools.ietf.org/html/rfc2616#section-3.3.1) a\n[RFC 1123](https://tools.ietf.org/html/rfc1123#page-55) format with explicit\ntimezone `GMT` (interpreted as `UTC`).\n\n```\nHTTP.format_time(Time.new(2016, 2, 15)) # => \"Sun, 14 Feb 2016 21:00:00 GMT\"\n```\n\nUses `Time::Format::HTTP_DATE` as formatter.","summary":"<p>Format a <code><a href=\"Time.html\">Time</a></code> object as a <code><a href=\"String.html\">String</a></code> using the format specified as <code>sane-cookie-date</code> by <a href=\"https://tools.ietf.org/html/rfc6265#section-4.1.1\" target=\"_blank\">RFC 6265</a> which is according to <a href=\"https://tools.ietf.org/html/rfc2616#section-3.3.1\" target=\"_blank\">RFC 2616</a> a <a href=\"https://tools.ietf.org/html/rfc1123#page-55\" target=\"_blank\">RFC 1123</a> format with explicit timezone <code>GMT</code> (interpreted as <code>UTC</code>).</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L253","def":{"name":"format_time","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Time::Format::HTTP_DATE.format(time)"}},{"id":"parse_time(time_str:String):Time?-class-method","html_id":"parse_time(time_str:String):Time?-class-method","name":"parse_time","doc":"Parse a time string using the formats specified by [RFC 2616](https://tools.ietf.org/html/rfc2616#section-3.3.1)\n\n```\nHTTP.parse_time(\"Sun, 14 Feb 2016 21:00:00 GMT\")  # => \"2016-02-14 21:00:00 UTC\"\nHTTP.parse_time(\"Sunday, 14-Feb-16 21:00:00 GMT\") # => \"2016-02-14 21:00:00 UTC\"\nHTTP.parse_time(\"Sun Feb 14 21:00:00 2016\")       # => \"2016-02-14 21:00:00 UTC\"\n```\n\nUses `Time::Format::HTTP_DATE` as parser.","summary":"<p>Parse a time string using the formats specified by <a href=\"https://tools.ietf.org/html/rfc2616#section-3.3.1\" target=\"_blank\">RFC 2616</a></p>","abstract":false,"args":[{"name":"time_str","doc":null,"default_value":"","external_name":"time_str","restriction":"String"}],"args_string":"(time_str : String) : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L237","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L237","def":{"name":"parse_time","args":[{"name":"time_str","doc":null,"default_value":"","external_name":"time_str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"begin\n  Time::Format::HTTP_DATE.parse(time_str)\nrescue Time::Format::Error\nend"}},{"id":"quote_string(string,io)-class-method","html_id":"quote_string(string,io)-class-method","name":"quote_string","doc":"Encodes a string to an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string. Encoded string is written to *io*. May raise when *string*\ncontains an invalid character.\n\n```\nstring = %q(\"foo\\ bar\")\nio = IO::Memory.new\nHTTP.quote_string(string, io)\nio.rewind\nio.gets_to_end # => %q(\\\"foo\\\\\\ bar\\\")\n```","summary":"<p>Encodes a string to an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\" target=\"_blank\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(string, io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L292","def":{"name":"quote_string","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string.each_byte do |byte|\n  case byte\n  when '\\t'.ord, ' '.ord, '\"'.ord, '\\\\'.ord\n    io << '\\\\'\n  when 0..31, 127\n    raise(ArgumentError.new(\"String contained invalid character #{byte.chr.inspect}\"))\n  end\n  io.write_byte(byte)\nend"}},{"id":"quote_string(string)-class-method","html_id":"quote_string(string)-class-method","name":"quote_string","doc":"Encodes a string to an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string. May raise when *string* contains an invalid character.\n\n```\nstring = %q(\"foo\\ bar\")\nHTTP.quote_string(string) # => %q(\\\"foo\\\\\\ bar\\\")\n```","summary":"<p>Encodes a string to an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\" target=\"_blank\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L313","def":{"name":"quote_string","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  quote_string(string, io)\nend"}},{"id":"serialize_chunked_body(io,body)-class-method","html_id":"serialize_chunked_body(io,body)-class-method","name":"serialize_chunked_body","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":""}],"args_string":"(io, body)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L158","def":{"name":"serialize_chunked_body","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buf = uninitialized ::StaticArray(UInt8, 8192)\nwhile (buf_length = body.read(buf.to_slice)) > 0\n  buf_length.to_s(16, io)\n  io << \"\\r\\n\"\n  io.write(buf.to_slice[0, buf_length])\n  io << \"\\r\\n\"\nend\nio << \"0\\r\\n\\r\\n\"\n"}},{"id":"serialize_headers(io,headers)-class-method","html_id":"serialize_headers(io,headers)-class-method","name":"serialize_headers","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"args_string":"(io, headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L149","def":{"name":"serialize_headers","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers.each do |name, values|\n  values.each do |value|\n    (((io << name) << \": \") << value) << \"\\r\\n\"\n  end\nend\nio << \"\\r\\n\"\n"}},{"id":"serialize_headers_and_string_body(io,headers,body)-class-method","html_id":"serialize_headers_and_string_body(io,headers,body)-class-method","name":"serialize_headers_and_string_body","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":""}],"args_string":"(io, headers, body)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L143","def":{"name":"serialize_headers_and_string_body","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers[\"Content-Length\"] = body.bytesize.to_s\nserialize_headers(io, headers)\nio << body\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Client","path":"HTTP/Client.html","kind":"class","full_name":"HTTP::Client","name":"Client","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/client.cr","line_number":55,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An HTTP Client.\n\n### One-shot usage\n\nWithout a block, an `HTTP::Client::Response` is returned and the response's body\nis available as a `String` by invoking `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.get \"http://www.example.com\"\nresponse.status_code      # => 200\nresponse.body.lines.first # => \"<!doctype html>\"\n```\n\n### Streaming\n\nWith a block, an `HTTP::Client::Response` body is returned and the response's body\nis available as an `IO` by invoking `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.get(\"http://www.example.com\") do |response|\n  response.status_code  # => 200\n  response.body_io.gets # => \"<!doctype html>\"\nend\n```\n\n### Reusing a connection\n\nSimilar to the above cases, but creating an instance of an `HTTP::Client`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\"\nresponse.status_code      # => 200\nresponse.body.lines.first # => \"<!doctype html>\"\nclient.close\n```\n\n### Compression\n\nIf `compress` isn't set to `false`, and no `Accept-Encoding` header is explicitly specified,\nan HTTP::Client will add an `\"Accept-Encoding\": \"gzip, deflate\"` header, and automatically decompress\nthe response body/body_io.\n\n### Encoding\n\nIf a response has a `Content-Type` header with a charset, that charset is set as the encoding\nof the returned IO (or used for creating a String for the body). Invalid bytes in the given encoding\nare silently ignored when reading text content.","summary":"<p>An HTTP Client.</p>","class_methods":[{"id":"delete(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"delete(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.delete(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.delete(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"delete(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"delete(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.delete \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.delete(path, form: form, headers: headers)\nend"}},{"id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"delete","doc":"Executes a DELETE request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a DELETE request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"DELETE\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"delete","doc":"Executes a DELETE request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a DELETE request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"DELETE\", url, headers, body, tls)"}},{"id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.exec(\"GET\", \"http://www.example.com\") do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(method, url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L630","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L630","def":{"name":"exec","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.exec(method, path, headers, body) do |response|\n    yield response\n  end\nend"}},{"id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nresponse = HTTP::Client.exec \"GET\", \"http://www.example.com\"\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(method, url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L616","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L616","def":{"name":"exec","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.exec(method, path, headers, body)\nend"}},{"id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"get","doc":"Executes a GET request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a GET request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"GET\", url, headers, body, tls)"}},{"id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"get","doc":"Executes a GET request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a GET request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"GET\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"get(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"get(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.get \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.get(path, form: form, headers: headers)\nend"}},{"id":"get(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"get(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.get(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.get(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"head(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"head(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.head(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.head(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"head(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"head(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.head \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.head(path, form: form, headers: headers)\nend"}},{"id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"head","doc":"Executes a HEAD request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a HEAD request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"HEAD\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"head","doc":"Executes a HEAD request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a HEAD request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"HEAD\", url, headers, body, tls)"}},{"id":"options(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"options(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.options(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.options(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"options(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"options(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.options \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.options(path, form: form, headers: headers)\nend"}},{"id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"options","doc":"Executes a OPTIONS request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a OPTIONS request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"OPTIONS\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"options","doc":"Executes a OPTIONS request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a OPTIONS request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"OPTIONS\", url, headers, body, tls)"}},{"id":"patch(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"patch(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.patch(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.patch(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"patch(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"patch(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.patch \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.patch(path, form: form, headers: headers)\nend"}},{"id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"patch","doc":"Executes a PATCH request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PATCH request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"PATCH\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"patch","doc":"Executes a PATCH request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PATCH request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PATCH\", url, headers, body, tls)"}},{"id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"post","doc":"Executes a POST request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a POST request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"POST\", url, headers, body, tls)"}},{"id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"post","doc":"Executes a POST request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a POST request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"POST\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"post(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"post(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.post \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.post(path, form: form, headers: headers)\nend"}},{"id":"post(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"post(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.post(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.post(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","html_id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil):HTTP::Client::Response-class-method","name":"put","doc":"Executes a PUT request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nresponse = HTTP::Client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PUT request.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PUT\", url, headers, body, tls)"}},{"id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&block)-class-method","html_id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls=nil,&amp;block)-class-method","name":"put","doc":"Executes a PUT request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nHTTP::Client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PUT request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(url : String | URI, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":"String | URI"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"PUT\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"id":"put(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&block)-class-method","html_id":"put(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash,&amp;block)-class-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nHTTP::Client.put(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.put(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"id":"put(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","html_id":"put(url,headers:HTTP::Headers?=nil,tls=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nresponse = HTTP::Client.put \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = <span class=\"n\">nil</span>, tls = <span class=\"n\">nil</span>, *, form : String | IO | Hash) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO | Hash"}],"double_splat":null,"splat_index":3,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.put(path, form: form, headers: headers)\nend"}}],"constructors":[{"id":"new(host:String,port=nil,tls:Bool|OpenSSL::SSL::Context::Client=false)-class-method","html_id":"new(host:String,port=nil,tls:Bool|OpenSSL::SSL::Context::Client=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":"Bool | OpenSSL::SSL::Context::Client"}],"args_string":"(host : String, port = <span class=\"n\">nil</span>, tls : Bool | OpenSSL::SSL::Context::Client = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L107","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":"Bool | OpenSSL::SSL::Context::Client"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(host, port, tls)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(uri:URI,tls=nil)-class-method","html_id":"new(uri:URI,tls=nil)-class-method","name":"new","doc":"Creates a new HTTP client from a URI. Parses the *host*, *port*,\nand *tls* configuration from the URI provided. Port defaults to\n80 if not specified unless using the https protocol, which defaults\nto port 443 and sets tls to `true`.\n\n```\nuri = URI.parse(\"https://secure.example.com\")\nclient = HTTP::Client.new(uri)\n\nclient.tls? # => #<OpenSSL::SSL::Context::Client>\nclient.get(\"/\")\n```\nThis constructor will *ignore* any path or query segments in the URI\nas those will need to be passed to the client when a request is made.\n\nIf *tls* is given it will be used, if not a new TLS context will be created.\nIf *tls* is given and *uri* is a HTTP URI, `ArgumentError` is raised.\nIn any case the active context can be accessed through `tls`.\n\nThis constructor will raise an exception if any scheme but HTTP or HTTPS\nis used.","summary":"<p>Creates a new HTTP client from a URI.</p>","abstract":false,"args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(uri : URI, tls = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L154","def":{"name":"new","args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"tls = tls_flag(uri, tls)\nhost = validate_host(uri)\nnew(host, uri.port, tls)\n"}},{"id":"new(uri:URI,tls=nil,&block)-class-method","html_id":"new(uri:URI,tls=nil,&amp;block)-class-method","name":"new","doc":"Creates a new HTTP client from a URI, yields it to the block and closes the\nclient afterwards. Parses the *host*, *port*, and *tls* configuration from\nthe URI provided. Port defaults to 80 if not specified unless using the\nhttps protocol, which defaults to port 443 and sets tls to `true`.\n\n```\nuri = URI.parse(\"https://secure.example.com\")\nHTTP::Client.new(uri) do |client|\n  client.tls? # => #<OpenSSL::SSL::Context::Client>\n  client.get(\"/\")\nend\n```\nThis constructor will *ignore* any path or query segments in the URI\nas those will need to be passed to the client when a request is made.\n\nIf *tls* is given it will be used, if not a new TLS context will be created.\nIf *tls* is given and *uri* is a HTTP URI, `ArgumentError` is raised.\nIn any case the active context can be accessed through `tls`.\n\nThis constructor will raise an exception if any scheme but HTTP or HTTPS\nis used.","summary":"<p>Creates a new HTTP client from a URI, yields it to the block and closes the client afterwards.</p>","abstract":false,"args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"args_string":"(uri : URI, tls = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L181","def":{"name":"new","args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI"},{"name":"tls","doc":null,"default_value":"nil","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"tls = tls_flag(uri, tls)\nhost = validate_host(uri)\nclient = new(host, uri.port, tls)\nbegin\n  yield client\nensure\n  client.close\nend\n"}},{"id":"new(host:String,port=nil,tls=false,&block)-class-method","html_id":"new(host:String,port=nil,tls=false,&amp;block)-class-method","name":"new","doc":"Creates a new HTTP client, yields it to the block, and closes\nthe client afterwards.\n\n```\nHTTP::Client.new(\"www.example.com\") do |client|\n  client.get \"/\"\nend\n```","summary":"<p>Creates a new HTTP client, yields it to the block, and closes the client afterwards.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":""}],"args_string":"(host : String, port = <span class=\"n\">nil</span>, tls = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L200","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"client = new(host, port, tls)\nbegin\n  yield client\nensure\n  client.close\nend\n"}}],"instance_methods":[{"id":"basic_auth(username,password)-instance-method","html_id":"basic_auth(username,password)-instance-method","name":"basic_auth","doc":"Configures this client to perform basic authentication in every\nrequest.","summary":"<p>Configures this client to perform basic authentication in every request.</p>","abstract":false,"args":[{"name":"username","doc":null,"default_value":"","external_name":"username","restriction":""},{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""}],"args_string":"(username, password)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L211","def":{"name":"basic_auth","args":[{"name":"username","doc":null,"default_value":"","external_name":"username","restriction":""},{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"header = \"Basic #{Base64.strict_encode(\"#{username}:#{password}\")}\"\nbefore_request do |request|\n  request.headers[\"Authorization\"] = header\nend\n"}},{"id":"before_request(&callback:HTTP::Request->)-instance-method","html_id":"before_request(&amp;callback:HTTP::Request-&gt;)-instance-method","name":"before_request","doc":"Adds a callback to execute before each request. This is usually\nused to set an authorization header. Any number of callbacks\ncan be added.\n\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.before_request do |request|\n  request.headers[\"Authorization\"] = \"XYZ123\"\nend\nclient.get \"/\"\n```","summary":"<p>Adds a callback to execute before each request.</p>","abstract":false,"args":[],"args_string":"(&callback : HTTP::Request -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L324","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L324","def":{"name":"before_request","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"callback","doc":null,"default_value":"","external_name":"callback","restriction":"(HTTP::Request -> )"},"return_type":"","visibility":"Public","body":"before_request = @before_request || (@before_request = [] of (HTTP::Request -> ))\nbefore_request << callback\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this client. If used again, a new connection will be opened.","summary":"<p>Closes this client.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L639","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L639","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@socket.try(&.close)\n@socket = nil\n"}},{"id":"compress=(compress:Bool)-instance-method","html_id":"compress=(compress:Bool)-instance-method","name":"compress=","doc":"Whether automatic compression/decompression is enabled.","summary":"<p>Whether automatic compression/decompression is enabled.</p>","abstract":false,"args":[{"name":"compress","doc":null,"default_value":"","external_name":"compress","restriction":"Bool"}],"args_string":"(compress : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L90","def":{"name":"compress=","args":[{"name":"compress","doc":null,"default_value":"","external_name":"compress","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@compress = compress"}},{"id":"compress?:Bool-instance-method","html_id":"compress?:Bool-instance-method","name":"compress?","doc":"Whether automatic compression/decompression is enabled.","summary":"<p>Whether automatic compression/decompression is enabled.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L90","def":{"name":"compress?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@compress"}},{"id":"connect_timeout=(connect_timeout:Time::Span)-instance-method","html_id":"connect_timeout=(connect_timeout:Time::Span)-instance-method","name":"connect_timeout=","doc":"Set the open timeout with a `Time::Span` to wait when connecting, before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.connect_timeout = 5.minutes\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p>Set the open timeout with a <code><a href=\"../Time/Span.html\">Time::Span</a></code> to wait when connecting, before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"connect_timeout","doc":null,"default_value":"","external_name":"connect_timeout","restriction":"Time::Span"}],"args_string":"(connect_timeout : Time::Span)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L274","def":{"name":"connect_timeout=","args":[{"name":"connect_timeout","doc":null,"default_value":"","external_name":"connect_timeout","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.connect_timeout = connect_timeout.total_seconds"}},{"id":"connect_timeout=(connect_timeout:Number)-instance-method","html_id":"connect_timeout=(connect_timeout:Number)-instance-method","name":"connect_timeout=","doc":"Set the number of seconds to wait when connecting, before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.connect_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p>Set the number of seconds to wait when connecting, before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"connect_timeout","doc":null,"default_value":"","external_name":"connect_timeout","restriction":"Number"}],"args_string":"(connect_timeout : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L259","def":{"name":"connect_timeout=","args":[{"name":"connect_timeout","doc":null,"default_value":"","external_name":"connect_timeout","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@connect_timeout = connect_timeout.to_f"}},{"id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.delete(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\ndelete(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a DELETE request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"DELETE\", path, headers, body)"}},{"id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"delete","doc":"Executes a DELETE request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a DELETE request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"DELETE\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.delete \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"DELETE\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.delete(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"DELETE\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.delete \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"delete","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\ndelete(path, form: body, headers: headers)\n"}},{"id":"dns_timeout=(dns_timeout:Number)-instance-method","html_id":"dns_timeout=(dns_timeout:Number)-instance-method","name":"dns_timeout=","doc":"**This method has no effect right now**\n\nSet the number of seconds to wait when resolving a name, before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.dns_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p><strong>This method has no effect right now</strong></p>","abstract":false,"args":[{"name":"dns_timeout","doc":null,"default_value":"","external_name":"dns_timeout","restriction":"Number"}],"args_string":"(dns_timeout : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L291","def":{"name":"dns_timeout=","args":[{"name":"dns_timeout","doc":null,"default_value":"","external_name":"dns_timeout","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@dns_timeout = dns_timeout.to_f"}},{"id":"dns_timeout=(dns_timeout:Time::Span)-instance-method","html_id":"dns_timeout=(dns_timeout:Time::Span)-instance-method","name":"dns_timeout=","doc":"**This method has no effect right now**\n\nSet the number of seconds to wait when resolving a name with a `Time::Span`, before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.dns_timeout = 1.5.seconds\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p><strong>This method has no effect right now</strong></p>","abstract":false,"args":[{"name":"dns_timeout","doc":null,"default_value":"","external_name":"dns_timeout","restriction":"Time::Span"}],"args_string":"(dns_timeout : Time::Span)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L308","def":{"name":"dns_timeout=","args":[{"name":"dns_timeout","doc":null,"default_value":"","external_name":"dns_timeout","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.dns_timeout = dns_timeout.total_seconds"}},{"id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.exec \"GET\", \"/\"\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(method : String, path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L590","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L590","def":{"name":"exec","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(new_request(method, path, headers, body))"}},{"id":"exec(request:HTTP::Request):HTTP::Client::Response-instance-method","html_id":"exec(request:HTTP::Request):HTTP::Client::Response-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.exec HTTP::Request.new(\"GET\", \"/\")\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L480","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L480","def":{"name":"exec","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec_internal(request)"}},{"id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.exec(\"GET\", \"/\") do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(method : String, path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L603","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L603","def":{"name":"exec","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(new_request(method, path, headers, body)) do |response|\n  yield response\nend"}},{"id":"exec(request:HTTP::Request,&block)-instance-method","html_id":"exec(request:HTTP::Request,&amp;block)-instance-method","name":"exec","doc":"Executes a request request and yields an `HTTP::Client::Response` to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.exec(HTTP::Request.new(\"GET\", \"/\")) do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request request and yields an <code><a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> to the block.</p>","abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L516","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L516","def":{"name":"exec","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec_internal(request) do |response|\n  yield response\nend"}},{"id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.get(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\nget(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\nget(path, form: body, headers: headers)\n"}},{"id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.get(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"GET\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"GET\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"get","doc":"Executes a GET request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a GET request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"GET\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a GET request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"get","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"GET\", path, headers, body)"}},{"id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.head(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\nhead(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.head \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\nhead(path, form: body, headers: headers)\n"}},{"id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.head(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"HEAD\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.head \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"HEAD\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"head","doc":"Executes a HEAD request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a HEAD request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"HEAD\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a HEAD request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"head","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"HEAD\", path, headers, body)"}},{"id":"host:String-instance-method","html_id":"host:String-instance-method","name":"host","doc":"Returns the target host.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.host # => \"www.example.com\"\n```","summary":"<p>Returns the target host.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L65","def":{"name":"host","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@host"}},{"id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a OPTIONS request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"OPTIONS\", path, headers, body)"}},{"id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.options(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\noptions(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.options \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\noptions(path, form: body, headers: headers)\n"}},{"id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.options(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"OPTIONS\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"options","doc":"Executes a OPTIONS request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a OPTIONS request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"OPTIONS\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.options \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"options","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"OPTIONS\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.patch(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\npatch(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.patch \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\npatch(path, form: body, headers: headers)\n"}},{"id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.patch(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"PATCH\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"patch","doc":"Executes a PATCH request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PATCH request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"PATCH\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PATCH request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PATCH\", path, headers, body)"}},{"id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.patch \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"patch","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"PATCH\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"port:Int32-instance-method","html_id":"port:Int32-instance-method","name":"port","doc":"Returns the target port.\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.port # => 80\n```","summary":"<p>Returns the target port.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L73","def":{"name":"port","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@port"}},{"id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a POST request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"POST\", path, headers, body)"}},{"id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.post \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"POST\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.post(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"POST\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.post \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\npost(path, form: body, headers: headers)\n"}},{"id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.post(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\npost(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"post","doc":"Executes a POST request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a POST request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"post","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"POST\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&block)-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&amp;block)-instance-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.put(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = HTTP::Params.encode(form)\nput(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PUT request.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PUT\", path, headers, body)"}},{"id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&block)-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&amp;block)-instance-method","name":"put","doc":"Executes a PUT request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nclient = HTTP::Client.new(\"www.example.com\")\nclient.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PUT request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, body : BodyType = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"BodyType"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"exec(\"PUT\", path, headers, body) do |response|\n  yield response\nend"}},{"id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.put \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"PUT\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO,&block)-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO,&amp;block)-instance-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nclient.put(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : String | IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"String | IO"}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"request = new_request(\"PUT\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","html_id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.put \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = <span class=\"n\">nil</span>, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L329","def":{"name":"put","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"form","doc":null,"default_value":"","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = HTTP::Params.encode(form)\nput(path, form: body, headers: headers)\n"}},{"id":"read_timeout=(read_timeout:Time::Span)-instance-method","html_id":"read_timeout=(read_timeout:Time::Span)-instance-method","name":"read_timeout=","doc":"Set the read timeout with a `Time::Span`, to wait when reading before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.read_timeout = 5.minutes\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p>Set the read timeout with a <code><a href=\"../Time/Span.html\">Time::Span</a></code>, to wait when reading before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Time::Span"}],"args_string":"(read_timeout : Time::Span)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L244","def":{"name":"read_timeout=","args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.read_timeout = read_timeout.total_seconds"}},{"id":"read_timeout=(read_timeout:Number)-instance-method","html_id":"read_timeout=(read_timeout:Number)-instance-method","name":"read_timeout=","doc":"Set the number of seconds to wait when reading before raising an `IO::Timeout`.\n\n```\nclient = HTTP::Client.new(\"example.org\")\nclient.read_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::Timeout\n  puts \"Timeout!\"\nend\n```","summary":"<p>Set the number of seconds to wait when reading before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Number"}],"args_string":"(read_timeout : Number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr#L229","def":{"name":"read_timeout=","args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@read_timeout = read_timeout.to_f"}},{"id":"tls-instance-method","html_id":"tls-instance-method","name":"tls","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":null,"source_link":null,"def":{"name":"tls","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@tls.not_nil!"}},{"id":"tls?:OpenSSL::SSL::Context::Client?-instance-method","html_id":"tls?:OpenSSL::SSL::Context::Client?-instance-method","name":"tls?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : OpenSSL::SSL::Context::Client?","source_link":null,"source_link":null,"def":{"name":"tls?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@tls"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Client/BodyType","path":"HTTP/Client/BodyType.html","kind":"alias","full_name":"HTTP::Client::BodyType","name":"BodyType","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/client.cr","line_number":57,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(IO | Slice(UInt8) | String | Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},"doc":"The set of possible valid body types.","summary":"<p>The set of possible valid body types.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Client/Response","path":"HTTP/Client/Response.html","kind":"class","full_name":"HTTP::Client::Response","name":"Response","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/client/response.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},"doc":null,"summary":null,"class_methods":[{"id":"from_io(io,ignore_body=false,decompress=true)-class-method","html_id":"from_io(io,ignore_body=false,decompress=true)-class-method","name":"from_io","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L86","def":{"name":"from_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(from_io?(io, ignore_body, decompress)) || (raise(\"Unexpected end of http request\"))"}},{"id":"from_io(io,ignore_body=false,decompress=true,&block)-class-method","html_id":"from_io(io,ignore_body=false,decompress=true,&amp;block)-class-method","name":"from_io","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L105","def":{"name":"from_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"from_io?(io, ignore_body, decompress) do |response|\n  if response\n    yield response\n  else\n    raise(\"Unexpected end of http request\")\n  end\nend"}},{"id":"from_io?(io,ignore_body=false,decompress=true)-class-method","html_id":"from_io?(io,ignore_body=false,decompress=true)-class-method","name":"from_io?","doc":"Parses an `HTTP::Client::Response` from the given `IO`.\nMight return `nil` if there's no data in the `IO`,\nwhich probably means that the connection was closed.","summary":"<p>Parses an <code><a href=\"../../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> from the given <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L94","def":{"name":"from_io?","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"from_io?(io, ignore_body: ignore_body, decompress: decompress) do |response|\n  if response\n    response.consume_body_io\n    return response\n  else\n    return nil\n  end\nend"}},{"id":"from_io?(io,ignore_body=false,decompress=true,&block)-class-method","html_id":"from_io?(io,ignore_body=false,decompress=true,&amp;block)-class-method","name":"from_io?","doc":"Parses an `HTTP::Client::Response` from the given `IO` and yields\nit to the block. Might yield `nil` if there's no data in the `IO`,\nwhich probably means that the connection was closed.","summary":"<p>Parses an <code><a href=\"../../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> from the given <code><a href=\"../../IO.html\">IO</a></code> and yields it to the block.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L118","def":{"name":"from_io?","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"ignore_body","doc":null,"default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","doc":null,"default_value":"true","external_name":"decompress","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"line = io.gets(4096, chomp: true)\nif line\nelse\n  return yield nil\nend\npieces = line.split(3)\nif pieces.size < 2\n  raise(\"Invalid HTTP response\")\nend\nhttp_version = pieces[0]\nif HTTP::SUPPORTED_VERSIONS.includes?(http_version)\nelse\n  raise(\"Unsupported HTTP version: #{http_version}\")\nend\nstatus_code = pieces[1].to_i?\nif status_code && (100 <= status_code && status_code < 1000)\nelse\n  raise(\"Invalid HTTP status code: #{pieces[1]}\")\nend\nstatus_message = pieces[2]? ? pieces[2].chomp : \"\"\nbody_type = HTTP::BodyType::OnDemand\nif mandatory_body?(status_code)\n  body_type = HTTP::BodyType::Mandatory\nend\nif ignore_body\n  body_type = HTTP::BodyType::Prohibited\nend\nHTTP.parse_headers_and_body(io, body_type: body_type, decompress: decompress) do |headers, body|\n  return yield new(status_code, nil, headers, status_message, http_version, body)\nend\n"}},{"id":"mandatory_body?(status_code):Bool-class-method","html_id":"mandatory_body?(status_code):Bool-class-method","name":"mandatory_body?","doc":null,"summary":null,"abstract":false,"args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":""}],"args_string":"(status_code) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L78","def":{"name":"mandatory_body?","args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"!((((status_code / 100) == 1) || (status_code == 204)) || (status_code == 304))"}},{"id":"supports_chunked?(version):Bool-class-method","html_id":"supports_chunked?(version):Bool-class-method","name":"supports_chunked?","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":""}],"args_string":"(version) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L82","def":{"name":"supports_chunked?","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"version == \"HTTP/1.1\""}}],"constructors":[{"id":"new(status_code,body:String?=nil,headers:Headers=Headers.new,status_message=nil,version=&quot;HTTP/1.1&quot;,body_io=nil)-class-method","html_id":"new(status_code,body:String?=nil,headers:Headers=Headers.new,status_message=nil,version=&amp;quot;HTTP/1.1&amp;quot;,body_io=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":""},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","doc":null,"default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","doc":null,"default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","doc":null,"default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","doc":null,"default_value":"nil","external_name":"body_io","restriction":""}],"args_string":"(status_code, body : String? = <span class=\"n\">nil</span>, headers : Headers = <span class=\"t\">Headers</span>.<span class=\"k\">new</span>, status_message = <span class=\"n\">nil</span>, version = <span class=\"s\">&quot;HTTP/1.1&quot;</span>, body_io = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L12","def":{"name":"new","args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":""},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","doc":null,"default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","doc":null,"default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","doc":null,"default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","doc":null,"default_value":"nil","external_name":"body_io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(status_code, body, headers, status_message, version, body_io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"body-instance-method","html_id":"body-instance-method","name":"body","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L24","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body || \"\""}},{"id":"body?:String?-instance-method","html_id":"body?:String?-instance-method","name":"body?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L28","def":{"name":"body?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body"}},{"id":"body_io-instance-method","html_id":"body_io-instance-method","name":"body_io","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L9","def":{"name":"body_io","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body_io.not_nil!"}},{"id":"body_io?:IO?-instance-method","html_id":"body_io?:IO?-instance-method","name":"body_io?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : IO?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L9","def":{"name":"body_io?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body_io"}},{"id":"charset-instance-method","html_id":"charset-instance-method","name":"charset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L51","def":{"name":"charset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"process_content_type_header.charset"}},{"id":"content_type-instance-method","html_id":"content_type-instance-method","name":"content_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L47","def":{"name":"content_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"process_content_type_header.content_type"}},{"id":"cookies-instance-method","html_id":"cookies-instance-method","name":"cookies","doc":"Returns a convenience wrapper around querying and setting cookie related\nheaders, see `HTTP::Cookies`.","summary":"<p>Returns a convenience wrapper around querying and setting cookie related headers, see <code><a href=\"../../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L39","def":{"name":"cookies","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies || (@cookies = Cookies.from_headers(headers))"}},{"id":"headers:Headers-instance-method","html_id":"headers:Headers-instance-method","name":"headers","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Headers","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L8","def":{"name":"headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Headers","visibility":"Public","body":"@headers"}},{"id":"keep_alive?-instance-method","html_id":"keep_alive?-instance-method","name":"keep_alive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L43","def":{"name":"keep_alive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"HTTP.keep_alive?(self)"}},{"id":"status_code:Int32-instance-method","html_id":"status_code:Int32-instance-method","name":"status_code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L6","def":{"name":"status_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@status_code"}},{"id":"status_message:String-instance-method","html_id":"status_message:String-instance-method","name":"status_message","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L7","def":{"name":"status_message","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@status_message"}},{"id":"success?-instance-method","html_id":"success?-instance-method","name":"success?","doc":"Returns `true` if the response status code is between 200 and 299.","summary":"<p>Returns <code>true</code> if the response status code is between 200 and 299.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L33","def":{"name":"success?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(200..299).includes?(status_code)"}},{"id":"to_io(io)-instance-method","html_id":"to_io(io)-instance-method","name":"to_io","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L63","def":{"name":"to_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(((((io << @version) << ' ') << @status_code) << ' ') << @status_message) << \"\\r\\n\"\ncookies = @cookies\nheaders = cookies ? cookies.add_response_headers(@headers) : @headers\nHTTP.serialize_headers_and_body(io, headers, @body, @body_io, @version)\n"}},{"id":"version:String-instance-method","html_id":"version:String-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/client/response.cr#L5","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@version"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/CompressHandler","path":"HTTP/CompressHandler.html","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/compress_handler.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/compress_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that configures an `HTTP::Server::Response` to compress the response\noutput, either using gzip or deflate, depending on the `Accept-Encoding` request header.","summary":"<p>A handler that configures an <code><a href=\"../HTTP/Server/Response.html\">HTTP::Server::Response</a></code> to compress the response output, either using gzip or deflate, depending on the <code>Accept-Encoding</code> request header.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"call(context)-instance-method","html_id":"call(context)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/compress_handler.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/compress_handler.cr#L11","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:without_zlib) %}\n      call_next(context)\n    {% else %}\n      request_headers = context.request.headers\n\n      if request_headers.includes_word?(\"Accept-Encoding\", \"gzip\")\n        context.response.headers[\"Content-Encoding\"] = \"gzip\"\n        context.response.output = Gzip::Writer.new(context.response.output, sync_close: true)\n      elsif request_headers.includes_word?(\"Accept-Encoding\", \"deflate\")\n        context.response.headers[\"Content-Encoding\"] = \"deflate\"\n        context.response.output = Flate::Writer.new(context.response.output, sync_close: true)\n      end\n\n      call_next(context)\n    {% end %}"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/ComputedContentTypeHeader","path":"HTTP/ComputedContentTypeHeader.html","kind":"struct","full_name":"HTTP::ComputedContentTypeHeader","name":"ComputedContentTypeHeader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/common.cr","line_number":197,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(content_type:String?,charset:String?)-class-method","html_id":"new(content_type:String?,charset:String?)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":"String | ::Nil"},{"name":"charset","doc":null,"default_value":"","external_name":"charset","restriction":"String | ::Nil"}],"args_string":"(content_type : String?, charset : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","def":{"name":"new","args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":"String | ::Nil"},{"name":"charset","doc":null,"default_value":"","external_name":"charset","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(content_type, charset)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"charset:String?-instance-method","html_id":"charset:String?-instance-method","name":"charset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":null,"source_link":null,"def":{"name":"charset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@charset"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ComputedContentTypeHeader.new(@content_type.clone, @charset.clone)"}},{"id":"content_type:String?-instance-method","html_id":"content_type:String?-instance-method","name":"content_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":null,"source_link":null,"def":{"name":"content_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@content_type"}},{"id":"copy_with(content_type_content_type=@content_type,charset_charset=@charset)-instance-method","html_id":"copy_with(content_type_content_type=@content_type,charset_charset=@charset)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_content_type","doc":null,"default_value":"@content_type","external_name":"content_type","restriction":""},{"name":"_charset","doc":null,"default_value":"@charset","external_name":"charset","restriction":""}],"args_string":"(content_type _content_type = @content_type, charset _charset = @charset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/common.cr#L197","def":{"name":"copy_with","args":[{"name":"_content_type","doc":null,"default_value":"@content_type","external_name":"content_type","restriction":""},{"name":"_charset","doc":null,"default_value":"@charset","external_name":"charset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ComputedContentTypeHeader.new(_content_type, _charset)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Cookie","path":"HTTP/Cookie.html","kind":"class","full_name":"HTTP::Cookie","name":"Cookie","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/cookie.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Represents a cookie with all its attributes. Provides convenient\naccess and modification of them.","summary":"<p>Represents a cookie with all its attributes.</p>","class_methods":[],"constructors":[{"id":"new(name:String,value:String,path:String=&quot;/&quot;,expires:Time?=nil,domain:String?=nil,secure:Bool=false,http_only:Bool=false,extension:String?=nil)-class-method","html_id":"new(name:String,value:String,path:String=&amp;quot;/&amp;quot;,expires:Time?=nil,domain:String?=nil,secure:Bool=false,http_only:Bool=false,extension:String?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"path","doc":null,"default_value":"\"/\"","external_name":"path","restriction":"String"},{"name":"expires","doc":null,"default_value":"nil","external_name":"expires","restriction":"Time | ::Nil"},{"name":"domain","doc":null,"default_value":"nil","external_name":"domain","restriction":"String | ::Nil"},{"name":"secure","doc":null,"default_value":"false","external_name":"secure","restriction":"Bool"},{"name":"http_only","doc":null,"default_value":"false","external_name":"http_only","restriction":"Bool"},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":"String | ::Nil"}],"args_string":"(name : String, value : String, path : String = <span class=\"s\">&quot;/&quot;</span>, expires : Time? = <span class=\"n\">nil</span>, domain : String? = <span class=\"n\">nil</span>, secure : Bool = <span class=\"n\">false</span>, http_only : Bool = <span class=\"n\">false</span>, extension : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L18","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"path","doc":null,"default_value":"\"/\"","external_name":"path","restriction":"String"},{"name":"expires","doc":null,"default_value":"nil","external_name":"expires","restriction":"Time | ::Nil"},{"name":"domain","doc":null,"default_value":"nil","external_name":"domain","restriction":"String | ::Nil"},{"name":"secure","doc":null,"default_value":"false","external_name":"secure","restriction":"Bool"},{"name":"http_only","doc":null,"default_value":"false","external_name":"http_only","restriction":"Bool"},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, value, path, expires, domain, secure, http_only, extension)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":null,"source_link":null,"def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if name == other.name\nelse\n  return false\nend\nif value == other.value\nelse\n  return false\nend\nif path == other.path\nelse\n  return false\nend\nif expires == other.expires\nelse\n  return false\nend\nif domain == other.domain\nelse\n  return false\nend\nif secure == other.secure\nelse\n  return false\nend\nif http_only == other.http_only\nelse\n  return false\nend\ntrue\n"}},{"id":"domain:String?-instance-method","html_id":"domain:String?-instance-method","name":"domain","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L11","def":{"name":"domain","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@domain"}},{"id":"domain=(domain:String?)-instance-method","html_id":"domain=(domain:String?)-instance-method","name":"domain=","doc":null,"summary":null,"abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":"String | ::Nil"}],"args_string":"(domain : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L11","def":{"name":"domain=","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@domain = domain"}},{"id":"expired?-instance-method","html_id":"expired?-instance-method","name":"expired?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L45","def":{"name":"expired?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if e = expires\n  e < Time.now\nelse\n  false\nend"}},{"id":"expires:Time?-instance-method","html_id":"expires:Time?-instance-method","name":"expires","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L10","def":{"name":"expires","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@expires"}},{"id":"expires=(expires:Time?)-instance-method","html_id":"expires=(expires:Time?)-instance-method","name":"expires=","doc":null,"summary":null,"abstract":false,"args":[{"name":"expires","doc":null,"default_value":"","external_name":"expires","restriction":"Time | ::Nil"}],"args_string":"(expires : Time?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L10","def":{"name":"expires=","args":[{"name":"expires","doc":null,"default_value":"","external_name":"expires","restriction":"Time | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@expires = expires"}},{"id":"extension:String?-instance-method","html_id":"extension:String?-instance-method","name":"extension","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L14","def":{"name":"extension","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@extension"}},{"id":"extension=(extension:String?)-instance-method","html_id":"extension=(extension:String?)-instance-method","name":"extension=","doc":null,"summary":null,"abstract":false,"args":[{"name":"extension","doc":null,"default_value":"","external_name":"extension","restriction":"String | ::Nil"}],"args_string":"(extension : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L14","def":{"name":"extension=","args":[{"name":"extension","doc":null,"default_value":"","external_name":"extension","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extension = extension"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":null,"source_link":null,"def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = name.hash(hasher)\nhasher = value.hash(hasher)\nhasher = path.hash(hasher)\nhasher = expires.hash(hasher)\nhasher = domain.hash(hasher)\nhasher = secure.hash(hasher)\nhasher = http_only.hash(hasher)\nhasher\n"}},{"id":"http_only:Bool-instance-method","html_id":"http_only:Bool-instance-method","name":"http_only","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L13","def":{"name":"http_only","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@http_only"}},{"id":"http_only=(http_only:Bool)-instance-method","html_id":"http_only=(http_only:Bool)-instance-method","name":"http_only=","doc":null,"summary":null,"abstract":false,"args":[{"name":"http_only","doc":null,"default_value":"","external_name":"http_only","restriction":"Bool"}],"args_string":"(http_only : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L13","def":{"name":"http_only=","args":[{"name":"http_only","doc":null,"default_value":"","external_name":"http_only","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@http_only = http_only"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L7","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name"}},{"id":"name=(name:String)-instance-method","html_id":"name=(name:String)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L7","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name = name"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L9","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}},{"id":"path=(path:String)-instance-method","html_id":"path=(path:String)-instance-method","name":"path=","doc":null,"summary":null,"abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L9","def":{"name":"path=","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@path = path"}},{"id":"secure:Bool-instance-method","html_id":"secure:Bool-instance-method","name":"secure","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L12","def":{"name":"secure","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@secure"}},{"id":"secure=(secure:Bool)-instance-method","html_id":"secure=(secure:Bool)-instance-method","name":"secure=","doc":null,"summary":null,"abstract":false,"args":[{"name":"secure","doc":null,"default_value":"","external_name":"secure","restriction":"Bool"}],"args_string":"(secure : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L12","def":{"name":"secure=","args":[{"name":"secure","doc":null,"default_value":"","external_name":"secure","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@secure = secure"}},{"id":"to_cookie_header-instance-method","html_id":"to_cookie_header-instance-method","name":"to_cookie_header","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L41","def":{"name":"to_cookie_header","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"#{@name}=#{URI.escape(value)}\""}},{"id":"to_set_cookie_header-instance-method","html_id":"to_set_cookie_header-instance-method","name":"to_set_cookie_header","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L26","def":{"name":"to_set_cookie_header","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"path = @path\nexpires = @expires\ndomain = @domain\nString.build do |header|\n  header << \"#{URI.escape(@name)}=#{URI.escape(value)}\"\n  if domain\n    header << \"; domain=#{domain}\"\n  end\n  if path\n    header << \"; path=#{path}\"\n  end\n  if expires\n    header << \"; expires=#{HTTP.format_time(expires)}\"\n  end\n  if @secure\n    header << \"; Secure\"\n  end\n  if @http_only\n    header << \"; HttpOnly\"\n  end\n  if @extension\n    header << \"; #{@extension}\"\n  end\nend\n"}},{"id":"value:String-instance-method","html_id":"value:String-instance-method","name":"value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L8","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@value"}},{"id":"value=(value:String)-instance-method","html_id":"value=(value:String)-instance-method","name":"value=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L8","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value = value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Cookies","path":"HTTP/Cookies.html","kind":"class","full_name":"HTTP::Cookies","name":"Cookies","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/cookie.cr","line_number":130,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Represents a collection of cookies as it can be present inside\na HTTP request or response.","summary":"<p>Represents a collection of cookies as it can be present inside a HTTP request or response.</p>","class_methods":[],"constructors":[{"id":"from_headers(headers):self-class-method","html_id":"from_headers(headers):self-class-method","name":"from_headers","doc":"Create a new instance by parsing the `Cookie` and `Set-Cookie`\nheaders in the given `HTTP::Headers`.\n\nSee `HTTP::Request#cookies` and `HTTP::Client::Response#cookies`.","summary":"<p>Create a new instance by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> and <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"args_string":"(headers) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L137","def":{"name":"from_headers","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new.tap do |cookies|\n  cookies.fill_from_headers(headers)\nend"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Create a new empty instance.","summary":"<p>Create a new empty instance.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L159","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"<<(cookie:Cookie)-instance-method","html_id":"&lt;&lt;(cookie:Cookie)-instance-method","name":"<<","doc":"Add the given *cookie* to this collection, overrides an existing cookie\nwith the same name if present.\n\n```\nresponse.cookies << HTTP::Cookie.new(\"foo\", \"bar\", http_only: true)\n```","summary":"<p>Add the given <em>cookie</em> to this collection, overrides an existing cookie with the same name if present.</p>","abstract":false,"args":[{"name":"cookie","doc":null,"default_value":"","external_name":"cookie","restriction":"Cookie"}],"args_string":"(cookie : Cookie)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L227","def":{"name":"<<","args":[{"name":"cookie","doc":null,"default_value":"","external_name":"cookie","restriction":"Cookie"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[cookie.name] = cookie"}},{"id":"[](key)-instance-method","html_id":"[](key)-instance-method","name":"[]","doc":"Get the current `HTTP::Cookie` for the given *key*.\n\n```\nrequest.cookies[\"foo\"].value # => \"bar\"\n```","summary":"<p>Get the current <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> for the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L196","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies[key]"}},{"id":"[]=(key,value:String)-instance-method","html_id":"[]=(key,value:String)-instance-method","name":"[]=","doc":"Set a new cookie in the collection with a string value.\nThis creates a never expiring, insecure, not HTTP only cookie with\nno explicit domain restriction and the path `/`.\n\n```\nrequest = HTTP::Request.new \"GET\", \"/\"\nrequest.cookies[\"foo\"] = \"bar\"\n```","summary":"<p>Set a new cookie in the collection with a string value.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L171","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[key] = Cookie.new(key, value)"}},{"id":"[]=(key,value:Cookie)-instance-method","html_id":"[]=(key,value:Cookie)-instance-method","name":"[]=","doc":"Set a new cookie in the collection to the given `HTTP::Cookie`\ninstance. The name attribute must match the given *key*, else\n`ArgumentError` is raised.\n\n```\nresponse = HTTP::Client::Response.new(200)\nresponse.cookies[\"foo\"] = HTTP::Cookie.new(\"foo\", \"bar\", \"/admin\", Time.now + 12.hours, secure: true)\n```","summary":"<p>Set a new cookie in the collection to the given <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> instance.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Cookie"}],"args_string":"(key, value : Cookie)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L183","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Cookie"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if key == value.name\nelse\n  raise(ArgumentError.new(\"Cookie name must match the given key\"))\nend\n@cookies[key] = value\n"}},{"id":"[]?(key)-instance-method","html_id":"[]?(key)-instance-method","name":"[]?","doc":"Get the current `HTTP::Cookie` for the given *key* or `nil` if none is set.\n\n```\nrequest = HTTP::Request.new \"GET\", \"/\"\nrequest.cookies[\"foo\"]? # => nil\nrequest.cookies[\"foo\"] = \"bar\"\nrequest.cookies[\"foo\"]?.try &.value # > \"bar\"\n```","summary":"<p>Get the current <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> for the given <em>key</em> or <code>nil</code> if none is set.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L208","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies[key]?"}},{"id":"add_request_headers(headers)-instance-method","html_id":"add_request_headers(headers)-instance-method","name":"add_request_headers","doc":"Adds `Cookie` headers for the cookies in this collection to the\ngiven `HTTP::Header` instance and returns it. Removes any existing\n`Cookie` headers in it.","summary":"<p>Adds <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers for the cookies in this collection to the given <code>HTTP::Header</code> instance and returns it.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"args_string":"(headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L251","def":{"name":"add_request_headers","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers.delete(\"Cookie\")\nif empty?\nelse\n  headers.add(\"Cookie\", map(&.to_cookie_header).join(\"; \"))\nend\nheaders\n"}},{"id":"add_response_headers(headers)-instance-method","html_id":"add_response_headers(headers)-instance-method","name":"add_response_headers","doc":"Adds `Set-Cookie` headers for the cookies in this collection to the\ngiven `HTTP::Header` instance and returns it. Removes any existing\n`Set-Cookie` headers in it.","summary":"<p>Adds <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers for the cookies in this collection to the given <code>HTTP::Header</code> instance and returns it.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"args_string":"(headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L261","def":{"name":"add_response_headers","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers.delete(\"Set-Cookie\")\neach do |cookie|\n  headers.add(\"Set-Cookie\", cookie.to_set_cookie_header)\nend\nheaders\n"}},{"id":"each(&block:Cookie->)-instance-method","html_id":"each(&amp;block:Cookie-&gt;)-instance-method","name":"each","doc":"Yields each `HTTP::Cookie` in the collection.","summary":"<p>Yields each <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> in the collection.</p>","abstract":false,"args":[],"args_string":"(&block : Cookie -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L232","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L232","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Cookie -> )"},"return_type":"","visibility":"Public","body":"@cookies.values.each do |cookie|\n  yield cookie\nend"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Returns an iterator over the cookies of this collection.","summary":"<p>Returns an iterator over the cookies of this collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L239","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies.each_value"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Whether the collection contains any cookies.","summary":"<p>Whether the collection contains any cookies.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L244","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies.empty?"}},{"id":"fill_from_headers(headers)-instance-method","html_id":"fill_from_headers(headers)-instance-method","name":"fill_from_headers","doc":"Filling cookies by parsing the `Cookie` and `Set-Cookie`\nheaders in the given `HTTP::Headers`.","summary":"<p>Filling cookies by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> and <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"args_string":"(headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L143","def":{"name":"fill_from_headers","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if values = headers.get?(\"Cookie\")\n  values.each do |header|\n    Cookie::Parser.parse_cookies(header) do |cookie|\n      self << cookie\n    end\n  end\nend\nif values = headers.get?(\"Set-Cookie\")\n  values.each do |header|\n    (Cookie::Parser.parse_set_cookie(header)).try do |cookie|\n      self << cookie\n    end\n  end\nend\nself\n"}},{"id":"has_key?(key)-instance-method","html_id":"has_key?(key)-instance-method","name":"has_key?","doc":"Returns `true` if a cookie with the given *key* exists.\n\n```\nrequest.cookies.has_key?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if a cookie with the given <em>key</em> exists.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L217","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies.has_key?(key)"}},{"id":"to_h-instance-method","html_id":"to_h-instance-method","name":"to_h","doc":"Returns this collection as a plain `Hash`.","summary":"<p>Returns this collection as a plain <code><a href=\"../Hash.html\">Hash</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/cookie.cr#L271","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies.dup"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/ErrorHandler","path":"HTTP/ErrorHandler.html","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/error_handler.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/error_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that invokes the next handler and, if that next handler raises\nan exception, returns with a 500 (Internal Server Error) status code.\n\nIn verbose mode prints the exception with its backtrace to the response,\nelse a generic error message is returned to the client.\nUse the `HTTP::LogHandler` before this to log the exception on the server side.","summary":"<p>A handler that invokes the next handler and, if that next handler raises an exception, returns with a 500 (Internal Server Error) status code.</p>","class_methods":[],"constructors":[{"id":"new(verbose:Bool=false)-class-method","html_id":"new(verbose:Bool=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"verbose","doc":null,"default_value":"false","external_name":"verbose","restriction":"Bool"}],"args_string":"(verbose : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/error_handler.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/error_handler.cr#L10","def":{"name":"new","args":[{"name":"verbose","doc":null,"default_value":"false","external_name":"verbose","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(verbose)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"call(context)-instance-method","html_id":"call(context)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/error_handler.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/error_handler.cr#L13","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  call_next(context)\nrescue ex : Exception\n  if @verbose\n    context.response.reset\n    context.response.status_code = 500\n    context.response.content_type = \"text/plain\"\n    context.response.print(\"ERROR: \")\n    ex.inspect_with_backtrace(context.response)\n  else\n    context.response.respond_with_error\n  end\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","path":"HTTP/FormData.html","kind":"module","full_name":"HTTP::FormData","name":"FormData","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/formdata/builder.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr"},{"filename":"http/formdata/parser.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr"},{"filename":"http/formdata/part.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr"},{"filename":"http/formdata.cr","line_number":79,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Contains utilities for parsing `multipart/form-data` messages, which are\ncommonly used for encoding HTML form data.\n\n### Examples\n\nCommonly, you'll want to parse a from response from a HTTP request, and\nprocess it. An example server which performs this task is shown below.\n\n```\nrequire \"http\"\nrequire \"tempfile\"\n\nserver = HTTP::Server.new do |context|\n  name = nil\n  file = nil\n  HTTP::FormData.parse(context.request) do |part|\n    case part.name\n    when \"name\"\n      name = part.body.gets_to_end\n    when \"file\"\n      file = Tempfile.open(\"upload\") do |file|\n        IO.copy(part.body, file)\n      end\n    end\n  end\n\n  unless name && file\n    context.response.status_code = 400\n    next\n  end\n\n  context.response << file.path\nend\n\nserver.bind_tcp 8085\nserver.listen\n```\n\nTo test the server, use the curl command below.\n\n```console\n$ curl http://localhost:8085/ -F name=foo -F file=@/path/to/test.file\n/tmp/upload.Yxn7cc\n```\n\nAnother common case is sending formdata to a server using HTTP::Client. Here\nis an example showing how to upload a file to the server above in crystal.\n\n```\nrequire \"http\"\n\nIO.pipe do |reader, writer|\n  channel = Channel(String).new(1)\n\n  spawn do\n    HTTP::FormData.build(writer) do |formdata|\n      channel.send(formdata.content_type)\n\n      formdata.field(\"name\", \"foo\")\n      File.open(\"foo.png\") do |file|\n        metadata = HTTP::FormData::FileMetadata.new(filename: \"foo.png\")\n        headers = HTTP::Headers{\"Content-Type\" => \"image/png\"}\n        formdata.file(\"file\", file, metadata, headers)\n      end\n    end\n\n    writer.close\n  end\n\n  headers = HTTP::Headers{\"Content-Type\" => channel.receive}\n  response = HTTP::Client.post(\"http://localhost:8085/\", body: reader, headers: headers)\n\n  puts \"Response code #{response.status_code}\"\n  puts \"File path: #{response.body}\"\nend\n```","summary":"<p>Contains utilities for parsing <code>multipart/form-data</code> messages, which are commonly used for encoding HTML form data.</p>","class_methods":[{"id":"build(response:HTTP::Server::Response,boundary=Multipart.generate_boundary,&block)-class-method","html_id":"build(response:HTTP::Server::Response,boundary=Multipart.generate_boundary,&amp;block)-class-method","name":"build","doc":"Builds a multipart/form-data message, yielding a `FormData::Builder`\nobject to the block which writes to *response* using *boundary.\nContent-Type is set on *response* and `Builder#finish` is called on the\nbuilder when the block returns.\n\n```\nio = IO::Memory.new\nresponse = HTTP::Server::Response.new io\nHTTP::FormData.build(response, \"boundary\") do |builder|\n  builder.field(\"foo\", \"bar\")\nend\nresponse.close\n\nresponse.headers[\"Content-Type\"] # => \"multipart/form-data; boundary=\\\"boundary\\\"\"\nio.to_s                          # => \"HTTP/1.1 200 OK\\r\\nContent-Type: multipart/form-data; boundary=\\\"boundary\\\"\\r\\nContent-Length: 75\\r\\n\\r\\n--boundary\\r\\nContent-Disposition: form-data; name=\\\"foo\\\"\\r\\n\\r\\nbar\\r\\n--boundary--\"\n```\n\nSee: `FormData::Builder`","summary":"<p>Builds a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Builder.html\">FormData::Builder</a></code> object to the block which writes to <em>response</em> using *boundary.</p>","abstract":false,"args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":"HTTP::Server::Response"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(response : HTTP::Server::Response, boundary = <span class=\"t\">Multipart</span>.generate_boundary, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L205","def":{"name":"build","args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":"HTTP::Server::Response"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"builder = Builder.new(response, boundary)\nyield builder\nbuilder.finish\nresponse.headers[\"Content-Type\"] = builder.content_type\n"}},{"id":"build(io,boundary=Multipart.generate_boundary,&block)-class-method","html_id":"build(io,boundary=Multipart.generate_boundary,&amp;block)-class-method","name":"build","doc":"Builds a multipart/form-data message, yielding a `FormData::Builder`\nobject to the block which writes to *io* using *boundary*.\n`Builder#finish` is called on the builder when the block returns.\n\n```\nio = IO::Memory.new\nHTTP::FormData.build(io, \"boundary\") do |builder|\n  builder.field(\"foo\", \"bar\")\nend\nio.to_s # => \"--boundary\\r\\nContent-Disposition: form-data; name=\\\"foo\\\"\\r\\n\\r\\nbar\\r\\n--boundary--\"\n```\n\nSee: `FormData::Builder`","summary":"<p>Builds a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Builder.html\">FormData::Builder</a></code> object to the block which writes to <em>io</em> using <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io, boundary = <span class=\"t\">Multipart</span>.generate_boundary, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L181","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"builder = Builder.new(io, boundary)\nyield builder\nbuilder.finish\n"}},{"id":"parse(io,boundary,&block)-class-method","html_id":"parse(io,boundary,&amp;block)-class-method","name":"parse","doc":"Parses a multipart/form-data message, yielding a `FormData::Parser`.\n\n```\nform_data = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nHTTP::FormData.parse(IO::Memory.new(form_data), \"aA40\") do |part|\n  part.name             # => \"field1\"\n  part.body.gets_to_end # => \"field data\"\nend\n```\n\nSee: `FormData::Parser`","summary":"<p>Parses a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Parser.html\">FormData::Parser</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"args_string":"(io, boundary, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L91","def":{"name":"parse","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"parser = Parser.new(io, boundary)\nwhile parser.has_next?\n  parser.next do |part|\n    yield part\n  end\nend\n"}},{"id":"parse(request:HTTP::Request,&block)-class-method","html_id":"parse(request:HTTP::Request,&amp;block)-class-method","name":"parse","doc":"Parses a multipart/form-data message, yielding a `FormData::Parser`.\n\n```\nheaders = HTTP::Headers{\"Content-Type\" => \"multipart/form-data; boundary=aA40\"}\nbody = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nrequest = HTTP::Request.new(\"POST\", \"/\", headers, body)\n\nHTTP::FormData.parse(request) do |part|\n  part.name             # => \"field1\"\n  part.body.gets_to_end # => \"field data\"\nend\n```\n\nSee: `FormData::Parser`","summary":"<p>Parses a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Parser.html\">FormData::Parser</a></code>.</p>","abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L112","def":{"name":"parse","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body = request.body\nif body\nelse\n  raise(Error.new(\"Cannot extract form-data from HTTP request: body is empty\"))\nend\nboundary = request.headers[\"Content-Type\"]?.try do |header|\n  Multipart.parse_boundary(header)\nend\nif boundary\nelse\n  raise(Error.new(\"Cannot extract form-data from HTTP request: could not find boundary in Content-Type\"))\nend\nparse(body, boundary) do |part|\n  yield part\nend\n"}},{"id":"parse_content_disposition(content_disposition):Tuple(String,FileMetadata)-class-method","html_id":"parse_content_disposition(content_disposition):Tuple(String,FileMetadata)-class-method","name":"parse_content_disposition","doc":"Parses a `Content-Disposition` header string into a field name and\n`FileMetadata`. Please note that the `Content-Disposition` header for\n`multipart/form-data` is not compatible with the original definition in\n[RFC 2183](https://tools.ietf.org/html/rfc2183), but are instead specified\nin [RFC 2388](https://tools.ietf.org/html/rfc2388).","summary":"<p>Parses a <code>Content-Disposition</code> header string into a field name and <code><a href=\"../HTTP/FormData/FileMetadata.html\">FileMetadata</a></code>.</p>","abstract":false,"args":[{"name":"content_disposition","doc":null,"default_value":"","external_name":"content_disposition","restriction":""}],"args_string":"(content_disposition) : Tuple(String, FileMetadata)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L127","def":{"name":"parse_content_disposition","args":[{"name":"content_disposition","doc":null,"default_value":"","external_name":"content_disposition","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(String, FileMetadata)","visibility":"Public","body":"filename = nil\ncreation_time = nil\nmodification_time = nil\nread_time = nil\nsize = nil\nname = nil\nparts = content_disposition.split(';')\ntype = parts[0]\nif type == \"form-data\"\nelse\n  raise(Error.new(\"Invalid Content-Disposition: not form-data\"))\nend\n(1...parts.size).each do |i|\n  part = parts[i]\n  key, value = part.split('=', 2)\n  key = key.strip\n  value = value.strip\n  if value[0] == '\"'\n    value = HTTP.dequote_string(value[1...-1])\n  end\n  case key\n  when \"filename\"\n    filename = value\n  when \"creation-date\"\n    creation_time = HTTP.parse_time(value)\n  when \"modification-date\"\n    modification_time = HTTP.parse_time(value)\n  when \"read-date\"\n    read_time = HTTP.parse_time(value)\n  when \"size\"\n    size = value.to_u64\n  when \"name\"\n    name = value\n  end\nend\nif name\nelse\n  raise(Error.new(\"Invalid Content-Disposition: no name field\"))\nend\n{name, FileMetadata.new(filename, creation_time, modification_time, read_time, size)}\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Builder","path":"HTTP/FormData/Builder.html","kind":"class","full_name":"HTTP::FormData::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/formdata/builder.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":"Builds a multipart/form-data message.\n\n### Example\n\n```\nio = IO::Memory.new\nbuilder = HTTP::FormData::Builder.new(io, \"aA47\")\nbuilder.field(\"name\", \"joe\")\nfile = IO::Memory.new(\"file contents\")\nbuilder.file(\"upload\", file, HTTP::FormData::FileMetadata.new(filename: \"test.txt\"))\nbuilder.finish\nio.to_s # => \"--aA47\\r\\nContent-Disposition: form-data; name=\\\"name\\\"\\r\\n\\r\\njoe\\r\\n--aA47\\r\\nContent-Disposition: form-data; name=\\\"upload\\\"; filename=\\\"test.txt\\\"\\r\\n\\r\\nfile contents\\r\\n--aA47--\"\n```","summary":"<p>Builds a multipart/form-data message.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,boundary=Multipart.generate_boundary)-class-method","html_id":"new(io:IO,boundary=Multipart.generate_boundary)-class-method","name":"new","doc":"Creates a new `FormData::Builder` which writes to *io*, using the\nmultipart boundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../HTTP/FormData/Builder.html\">FormData::Builder</a></code> which writes to <em>io</em>, using the multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io : IO, boundary = <span class=\"t\">Multipart</span>.generate_boundary)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L18","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"boundary:String-instance-method","html_id":"boundary:String-instance-method","name":"boundary","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L22","def":{"name":"boundary","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@boundary"}},{"id":"content_type-instance-method","html_id":"content_type-instance-method","name":"content_type","doc":"Returns a content type header with correct boundary parameter.\n\n```\nbuilder = HTTP::FormData::Builder.new(io, \"a4VF\")\nbuilder.content_type # => \"multipart/form-data; boundary=\\\"a4VF\\\"\"\n```","summary":"<p>Returns a content type header with correct boundary parameter.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L30","def":{"name":"content_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  str << \"multipart/form-data; boundary=\\\"\"\n  HTTP.quote_string(@boundary, str)\n  str << '\"'\nend"}},{"id":"field(name:String,value,headers:HTTP::Headers=HTTP::Headers.new)-instance-method","html_id":"field(name:String,value,headers:HTTP::Headers=HTTP::Headers.new)-instance-method","name":"field","doc":"Adds a form part with the given *name* and *value*. *Headers* can\noptionally be provided for the form part.","summary":"<p>Adds a form part with the given <em>name</em> and <em>value</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(name : String, value, headers : HTTP::Headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L40","def":{"name":"field","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"file(name, IO::Memory.new(value.to_s), headers: headers)"}},{"id":"file(name:String,io,metadata:FileMetadata=FileMetadata.new,headers:HTTP::Headers=HTTP::Headers.new)-instance-method","html_id":"file(name:String,io,metadata:FileMetadata=FileMetadata.new,headers:HTTP::Headers=HTTP::Headers.new)-instance-method","name":"file","doc":"Adds a form part called *name*, with data from *io* as the value.\n*Metadata* can be provided to add extra metadata about the file to the\nContent-Disposition header for the form part. Other headers can be added\nusing *headers*.","summary":"<p>Adds a form part called <em>name</em>, with data from <em>io</em> as the value.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"metadata","doc":null,"default_value":"FileMetadata.new","external_name":"metadata","restriction":"FileMetadata"},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(name : String, io, metadata : FileMetadata = <span class=\"t\">FileMetadata</span>.<span class=\"k\">new</span>, headers : HTTP::Headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L48","def":{"name":"file","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"metadata","doc":null,"default_value":"FileMetadata.new","external_name":"metadata","restriction":"FileMetadata"},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @state == (:FINISHED)\n  fail(\"Cannot add form part: already finished\")\nend\nheaders[\"Content-Disposition\"] = generate_content_disposition(name, metadata)\nif @state == (:START)\nelse\n  @io << \"\\r\\n\"\nend\n(@io << \"--\") << @boundary\nheaders.each do |name, values|\n  values.each do |value|\n    (((@io << \"\\r\\n\") << name) << \": \") << value\n  end\nend\n@io << \"\\r\\n\\r\\n\"\nIO.copy(io, @io)\n@state = :FIELD\n"}},{"id":"finish-instance-method","html_id":"finish-instance-method","name":"finish","doc":"Finalizes the multipart message, this method must be called before the\ngenerated multipart message written to the IO is considered valid.","summary":"<p>Finalizes the multipart message, this method must be called before the generated multipart message written to the IO is considered valid.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/builder.cr#L69","def":{"name":"finish","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @state == (:START)\n  fail(\"Cannot finish form-data: no body parts\")\nend\nif @state == (:FINISHED)\n  fail(\"Cannot finish form-data: already finished\")\nend\n((@io << \"\\r\\n--\") << @boundary) << \"--\"\n@state = :FINISHED\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Error","path":"HTTP/FormData/Error.html","kind":"class","full_name":"HTTP::FormData::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/formdata.cr","line_number":220,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/FileMetadata","path":"HTTP/FormData/FileMetadata.html","kind":"struct","full_name":"HTTP::FormData::FileMetadata","name":"FileMetadata","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/formdata.cr","line_number":213,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":"Metadata which may be available for uploaded files.","summary":"<p>Metadata which may be available for uploaded files.</p>","class_methods":[],"constructors":[{"id":"new(filename:String?=nil,creation_time:Time?=nil,modification_time:Time?=nil,read_time:Time?=nil,size:UInt64?=nil)-class-method","html_id":"new(filename:String?=nil,creation_time:Time?=nil,modification_time:Time?=nil,read_time:Time?=nil,size:UInt64?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"nil","external_name":"filename","restriction":"String | ::Nil"},{"name":"creation_time","doc":null,"default_value":"nil","external_name":"creation_time","restriction":"Time | ::Nil"},{"name":"modification_time","doc":null,"default_value":"nil","external_name":"modification_time","restriction":"Time | ::Nil"},{"name":"read_time","doc":null,"default_value":"nil","external_name":"read_time","restriction":"Time | ::Nil"},{"name":"size","doc":null,"default_value":"nil","external_name":"size","restriction":"UInt64 | ::Nil"}],"args_string":"(filename : String? = <span class=\"n\">nil</span>, creation_time : Time? = <span class=\"n\">nil</span>, modification_time : Time? = <span class=\"n\">nil</span>, read_time : Time? = <span class=\"n\">nil</span>, size : UInt64? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"nil","external_name":"filename","restriction":"String | ::Nil"},{"name":"creation_time","doc":null,"default_value":"nil","external_name":"creation_time","restriction":"Time | ::Nil"},{"name":"modification_time","doc":null,"default_value":"nil","external_name":"modification_time","restriction":"Time | ::Nil"},{"name":"read_time","doc":null,"default_value":"nil","external_name":"read_time","restriction":"Time | ::Nil"},{"name":"size","doc":null,"default_value":"nil","external_name":"size","restriction":"UInt64 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(filename, creation_time, modification_time, read_time, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"FileMetadata.new(@filename.clone, @creation_time.clone, @modification_time.clone, @read_time.clone, @size.clone)"}},{"id":"copy_with(filename_filename=@filename,creation_time_creation_time=@creation_time,modification_time_modification_time=@modification_time,read_time_read_time=@read_time,size_size=@size)-instance-method","html_id":"copy_with(filename_filename=@filename,creation_time_creation_time=@creation_time,modification_time_modification_time=@modification_time,read_time_read_time=@read_time,size_size=@size)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_filename","doc":null,"default_value":"@filename","external_name":"filename","restriction":""},{"name":"_creation_time","doc":null,"default_value":"@creation_time","external_name":"creation_time","restriction":""},{"name":"_modification_time","doc":null,"default_value":"@modification_time","external_name":"modification_time","restriction":""},{"name":"_read_time","doc":null,"default_value":"@read_time","external_name":"read_time","restriction":""},{"name":"_size","doc":null,"default_value":"@size","external_name":"size","restriction":""}],"args_string":"(filename _filename = @filename, creation_time _creation_time = @creation_time, modification_time _modification_time = @modification_time, read_time _read_time = @read_time, size _size = @size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata.cr#L213","def":{"name":"copy_with","args":[{"name":"_filename","doc":null,"default_value":"@filename","external_name":"filename","restriction":""},{"name":"_creation_time","doc":null,"default_value":"@creation_time","external_name":"creation_time","restriction":""},{"name":"_modification_time","doc":null,"default_value":"@modification_time","external_name":"modification_time","restriction":""},{"name":"_read_time","doc":null,"default_value":"@read_time","external_name":"read_time","restriction":""},{"name":"_size","doc":null,"default_value":"@size","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"FileMetadata.new(_filename, _creation_time, _modification_time, _read_time, _size)"}},{"id":"creation_time:Time?-instance-method","html_id":"creation_time:Time?-instance-method","name":"creation_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":null,"source_link":null,"def":{"name":"creation_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@creation_time"}},{"id":"filename:String?-instance-method","html_id":"filename:String?-instance-method","name":"filename","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":null,"source_link":null,"def":{"name":"filename","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@filename"}},{"id":"modification_time:Time?-instance-method","html_id":"modification_time:Time?-instance-method","name":"modification_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":null,"source_link":null,"def":{"name":"modification_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@modification_time"}},{"id":"read_time:Time?-instance-method","html_id":"read_time:Time?-instance-method","name":"read_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":null,"source_link":null,"def":{"name":"read_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@read_time"}},{"id":"size:UInt64?-instance-method","html_id":"size:UInt64?-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64?","source_link":null,"source_link":null,"def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64 | ::Nil","visibility":"Public","body":"@size"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Parser","path":"HTTP/FormData/Parser.html","kind":"class","full_name":"HTTP::FormData::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/formdata/parser.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(io,boundary)-class-method","html_id":"new(io,boundary)-class-method","name":"new","doc":"Create a new parser which parses *io* with multipart boundary *boundary*.","summary":"<p>Create a new parser which parses <em>io</em> with multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"args_string":"(io, boundary)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L4","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"has_next?-instance-method","html_id":"has_next?-instance-method","name":"has_next?","doc":"True if `#next` can be called legally.","summary":"<p>True if <code><a href=\"../../HTTP/FormData/Parser.html#next%28%26block%29-instance-method\">#next</a></code> can be called legally.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L39","def":{"name":"has_next?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@multipart.has_next?"}},{"id":"next(&block)-instance-method","html_id":"next(&amp;block)-instance-method","name":"next","doc":"Parses the next form-data part and yields field name, io, `FileMetadata`,\nand raw headers.\n\nThis method yields once instead of returning the values, because the IO\nobject yielded to the block is only valid while the block is executing.\nThe IO object will be closed as soon as the block returns. To store the\ncontent of the body part for longer than the block, the IO must be read\ninto memory.\n\n```\nform_data = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"; filename=\\\"foo.txt\\\"; size=13\\r\\nContent-Type: text/plain\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nparser = HTTP::FormData::Parser.new(IO::Memory.new(form_data), \"aA40\")\nparser.next do |part|\n  part.name                    # => \"field1\"\n  part.body.gets_to_end        # => \"field data\"\n  part.filename                # => \"foo.txt\"\n  part.size                    # => 13\n  part.headers[\"Content-Type\"] # => \"text/plain\"\nend\n```","summary":"<p>Parses the next form-data part and yields field name, io, <code><a href=\"../../HTTP/FormData/FileMetadata.html\">FileMetadata</a></code>, and raw headers.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/parser.cr#L28","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if has_next?\nelse\n  raise(FormData::Error.new(\"Parser has already finished parsing\"))\nend\nwhile @multipart.has_next?\n  @multipart.next do |headers, io|\n    yield HTTP::FormData::Part.new(headers, io)\n  end\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Part","path":"HTTP/FormData/Part.html","kind":"struct","full_name":"HTTP::FormData::Part","name":"Part","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/formdata/part.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(headers:HTTP::Headers,body:IO)-class-method","html_id":"new(headers:HTTP::Headers,body:IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"IO"}],"args_string":"(headers : HTTP::Headers, body : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L13","def":{"name":"new","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(headers, body)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"body:IO-instance-method","html_id":"body:IO-instance-method","name":"body","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : IO","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L4","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IO","visibility":"Public","body":"@body"}},{"id":"creation_time:Time?-instance-method","html_id":"creation_time:Time?-instance-method","name":"creation_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L8","def":{"name":"creation_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@creation_time"}},{"id":"filename:String?-instance-method","html_id":"filename:String?-instance-method","name":"filename","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L7","def":{"name":"filename","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@filename"}},{"id":"headers:HTTP::Headers-instance-method","html_id":"headers:HTTP::Headers-instance-method","name":"headers","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : HTTP::Headers","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L5","def":{"name":"headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Headers","visibility":"Public","body":"@headers"}},{"id":"modification_time:Time?-instance-method","html_id":"modification_time:Time?-instance-method","name":"modification_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L9","def":{"name":"modification_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@modification_time"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L3","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name"}},{"id":"read_time:Time?-instance-method","html_id":"read_time:Time?-instance-method","name":"read_time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L10","def":{"name":"read_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@read_time"}},{"id":"size:UInt64?-instance-method","html_id":"size:UInt64?-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/formdata/part.cr#L11","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64 | ::Nil","visibility":"Public","body":"@size"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","path":"HTTP/Handler.html","kind":"module","full_name":"HTTP::Handler","name":"Handler","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/server/handler.cr","line_number":17,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/CompressHandler","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/ErrorHandler","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/LogHandler","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocketHandler","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler is a class which includes `HTTP::Handler` and implements the `call` method.\nYou can use a handler to intercept any incoming request and can modify the response.\nThese can be used for request throttling, ip-based whitelisting, adding custom headers e.g.\n\n### A custom handler\n\n```\nclass CustomHandler\n  include HTTP::Handler\n\n  def call(context)\n    puts \"Doing some stuff\"\n    call_next(context)\n  end\nend\n```","summary":"<p>A handler is a class which includes <code><a href=\"../HTTP/Handler.html\">HTTP::Handler</a></code> and implements the <code><a href=\"../HTTP/Handler.html#call%28context%3AHTTP%3A%3AServer%3A%3AContext%29-instance-method\">#call</a></code> method.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"call(context:HTTP::Server::Context)-instance-method","html_id":"call(context:HTTP::Server::Context)-instance-method","name":"call","doc":null,"summary":null,"abstract":true,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"HTTP::Server::Context"}],"args_string":"(context : HTTP::Server::Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L20","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"HTTP::Server::Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"call_next(context:HTTP::Server::Context)-instance-method","html_id":"call_next(context:HTTP::Server::Context)-instance-method","name":"call_next","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"HTTP::Server::Context"}],"args_string":"(context : HTTP::Server::Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L22","def":{"name":"call_next","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"HTTP::Server::Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if next_handler = @next\n  next_handler.call(context)\nelse\n  context.response.status_code = 404\n  context.response.headers[\"Content-Type\"] = \"text/plain\"\n  context.response.puts(\"Not Found\")\nend"}},{"id":"next:Handler|Proc|Nil-instance-method","html_id":"next:Handler|Proc|Nil-instance-method","name":"next","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Handler | Proc | Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L18","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Handler | Proc | Nil","visibility":"Public","body":"@next"}},{"id":"next=(next:Handler|Proc|Nil)-instance-method","html_id":"next=(next:Handler|Proc|Nil)-instance-method","name":"next=","doc":null,"summary":null,"abstract":false,"args":[{"name":"next","doc":null,"default_value":"","external_name":"next","restriction":"Handler | Proc | Nil"}],"args_string":"(next : Handler | Proc | Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr#L18","def":{"name":"next=","args":[{"name":"next","doc":null,"default_value":"","external_name":"next","restriction":"Handler | Proc | Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@next = next"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler/Proc","path":"HTTP/Handler/Proc.html","kind":"alias","full_name":"HTTP::Handler::Proc","name":"Proc","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/server/handler.cr","line_number":32,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"Proc(HTTP::Server::Context, Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Headers","path":"HTTP/Headers.html","kind":"struct","full_name":"HTTP::Headers","name":"Headers","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/headers.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A `Hash`-like object that holds HTTP headers.\n\nTwo headers are considered the same if their downcase representation is the same\n(in which `_` is the downcase version of `-`).","summary":"<p>A <code><a href=\"../Hash.html\">Hash</a></code>-like object that holds HTTP headers.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L51","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:Hash)-instance-method","html_id":"==(other:Hash)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L166","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L166","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @hash.size == other.size\nelse\n  return false\nend\nother.each do |key, value|\n  this_value = @hash[wrap(key)]?\n  if this_value\n    case value\n    when String\n      if (this_value.size == 1) && (this_value[0] == value)\n      else\n        return false\n      end\n    when Array(String)\n      if this_value == value\n      else\n        return false\n      end\n    else\n      false\n    end\n  else\n    if value.nil?\n    else\n      return false\n    end\n  end\nend\ntrue\n"}},{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L162","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == (other.@hash)"}},{"id":"[](key)-instance-method","html_id":"[](key)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L65","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(wrap(key))"}},{"id":"[]=(key,value:String)-instance-method","html_id":"[]=(key,value:String)-instance-method","name":"[]=","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L55","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[wrap(key)] = [value]"}},{"id":"[]=(key,value:Array(String))-instance-method","html_id":"[]=(key,value:Array(String))-instance-method","name":"[]=","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L59","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.each do |val|\n  check_invalid_header_content(val)\nend\n@hash[wrap(key)] = value\n"}},{"id":"[]?(key)-instance-method","html_id":"[]?(key)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L69","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"values = @hash[wrap(key)]?\nvalues ? concat(values) : nil\n"}},{"id":"add(key,value:String)-instance-method","html_id":"add(key,value:String)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L104","def":{"name":"add","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_invalid_header_content(value)\nunsafe_add(key, value)\nself\n"}},{"id":"add(key,value:Array(String))-instance-method","html_id":"add(key,value:Array(String))-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L110","def":{"name":"add","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.each do |val|\n  check_invalid_header_content(val)\nend\nunsafe_add(key, value)\nself\n"}},{"id":"add?(key,value:String)-instance-method","html_id":"add?(key,value:String)-instance-method","name":"add?","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L116","def":{"name":"add?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if valid_value?(value)\nelse\n  return false\nend\nunsafe_add(key, value)\ntrue\n"}},{"id":"add?(key,value:Array(String))-instance-method","html_id":"add?(key,value:Array(String))-instance-method","name":"add?","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L122","def":{"name":"add?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Array(String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.each do |val|\n  if valid_value?(val)\n  else\n    return false\n  end\nend\nunsafe_add(key, value)\ntrue\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L210","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dup"}},{"id":"delete(key)-instance-method","html_id":"delete(key)-instance-method","name":"delete","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L150","def":{"name":"delete","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"values = @hash.delete(wrap(key))\nvalues ? concat(values) : nil\n"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L202","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dup = HTTP::Headers.new\n@hash.each do |key, value|\n  (dup.@hash)[key] = value\nend\ndup\n"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L188","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.each do |key, value|\n  yield {key.name, value}\nend"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L146","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.empty?"}},{"id":"fetch(key,&block)-instance-method","html_id":"fetch(key,&amp;block)-instance-method","name":"fetch","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L137","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"values = @hash[wrap(key)]?\nvalues ? concat(values) : yield key\n"}},{"id":"fetch(key)-instance-method","html_id":"fetch(key)-instance-method","name":"fetch","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L128","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"values = @hash.fetch(wrap(key))\nconcat(values)\n"}},{"id":"fetch(key,default)-instance-method","html_id":"fetch(key,default)-instance-method","name":"fetch","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"args_string":"(key, default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L133","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(wrap(key)) do\n  default\nend"}},{"id":"get(key)-instance-method","html_id":"get(key)-instance-method","name":"get","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L194","def":{"name":"get","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash[wrap(key)]"}},{"id":"get?(key)-instance-method","html_id":"get?(key)-instance-method","name":"get?","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L198","def":{"name":"get?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash[wrap(key)]?"}},{"id":"has_key?(key)-instance-method","html_id":"has_key?(key)-instance-method","name":"has_key?","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L142","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.has_key?(wrap(key))"}},{"id":"includes_word?(key,word)-instance-method","html_id":"includes_word?(key,word)-instance-method","name":"includes_word?","doc":"Returns if among the headers for *key* there is some that contains *word* as a value.\nThe *word* is expected to match between word boundaries (i.e. non-alphanumeric chars).\n\n```\nheaders = HTTP::Headers{\"Connection\" => \"keep-alive, Upgrade\"}\nheaders.includes_word?(\"Connection\", \"Upgrade\") # => true\n```","summary":"<p>Returns if among the headers for <em>key</em> there is some that contains <em>word</em> as a value.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"word","doc":null,"default_value":"","external_name":"word","restriction":""}],"args_string":"(key, word)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L81","def":{"name":"includes_word?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"word","doc":null,"default_value":"","external_name":"word","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if word.empty?\n  return false\nend\nword = word.downcase\n(get?(key)).try(&.each do |value|\n  value = value.downcase\n  offset = 0\n  while true\n    start = value.index(word, offset)\n    if start\n    else\n      break\n    end\n    offset = start + word.size\n    if start > 0 && value[start - 1].ascii_alphanumeric?\n      next\n    end\n    if (start + word.size) < value.size && value[start + word.size].ascii_alphanumeric?\n      next\n    end\n    return true\n  end\nend)\nfalse\n"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L233","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L233","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"merge!(other)-instance-method","html_id":"merge!(other)-instance-method","name":"merge!","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L155","def":{"name":"merge!","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.each do |key, value|\n  self[wrap(key)] = value\nend\nself\n"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L237","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L237","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.list(\"HTTP::Headers{\", @hash.keys.sort_by(&.name), \"}\") do |key|\n  pp.group do\n    key.name.pretty_print(pp)\n    pp.text(\" =>\")\n    pp.nest do\n      pp.breakable\n      values = get(key)\n      if values.size == 1\n        values.first.pretty_print(pp)\n      else\n        values.pretty_print(pp)\n      end\n    end\n  end\nend"}},{"id":"same?(other:HTTP::Headers)-instance-method","html_id":"same?(other:HTTP::Headers)-instance-method","name":"same?","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"HTTP::Headers"}],"args_string":"(other : HTTP::Headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L214","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L214","def":{"name":"same?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"HTTP::Headers"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"object_id == other.object_id"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L218","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"HTTP::Headers{\"\n@hash.each_with_index do |__arg1, index|\n  key = __arg1[0]\n  values = __arg1[1]\n  if index > 0\n    io << \", \"\n  end\n  key.name.inspect(io)\n  io << \" => \"\n  if values.size == 1\n    values.first.inspect(io)\n  else\n    values.inspect(io)\n  end\nend\nio << '}'\n"}},{"id":"valid_value?(value)-instance-method","html_id":"valid_value?(value)-instance-method","name":"valid_value?","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L255","def":{"name":"valid_value?","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"return invalid_value_char(value).nil?"}}],"macros":[{"id":"method_missing(call)-macro","html_id":"method_missing(call)-macro","name":"method_missing","doc":null,"summary":null,"abstract":false,"args":[{"name":"call","doc":null,"default_value":"","external_name":"call","restriction":""}],"args_string":"(call)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/headers.cr#L259","def":{"name":"method_missing","args":[{"name":"call","doc":null,"default_value":"","external_name":"call","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"      @hash.\n{{ call }}\n\n    \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/LogHandler","path":"HTTP/LogHandler.html","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/log_handler.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/log_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that logs the request method, resource, status code, and\nthe time used to execute the next handler, to the given `IO`.","summary":"<p>A handler that logs the request method, resource, status code, and the time used to execute the next handler, to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[],"constructors":[{"id":"new(io:IO=STDOUT)-class-method","html_id":"new(io:IO=STDOUT)-class-method","name":"new","doc":"Initializes this handler to log to the given `IO`.","summary":"<p>Initializes this handler to log to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":"IO"}],"args_string":"(io : IO = <span class=\"t\">STDOUT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/log_handler.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/log_handler.cr#L7","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"STDOUT","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"call(context)-instance-method","html_id":"call(context)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/log_handler.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/log_handler.cr#L10","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  elapsed = Time.measure do\n    call_next(context)\n  end\n  elapsed_text = elapsed_text(elapsed)\n  @io.puts(\"#{context.request.method} #{context.request.resource} - #{context.response.status_code} (#{elapsed_text})\")\nrescue e\n  @io.puts(\"#{context.request.method} #{context.request.resource} - Unhandled exception:\")\n  e.inspect_with_backtrace(@io)\n  raise(e)\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart","path":"HTTP/Multipart.html","kind":"module","full_name":"HTTP::Multipart","name":"Multipart","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"http/multipart/builder.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr"},{"filename":"http/multipart/parser.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr"},{"filename":"http/multipart.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"The `HTTP::Multipart` module contains utilities for parsing MIME multipart\nmessages, which contain multiple body parts, each containing a header section\nand binary body. The `multipart/form-data` content-type has a separate set of\nutilities in the `HTTP::FormData` module.","summary":"<p>The <code><a href=\"../HTTP/Multipart.html\">HTTP::Multipart</a></code> module contains utilities for parsing MIME multipart messages, which contain multiple body parts, each containing a header section and binary body.</p>","class_methods":[{"id":"build(boundary=Multipart.generate_boundary,&block)-class-method","html_id":"build(boundary=Multipart.generate_boundary,&amp;block)-class-method","name":"build","doc":"Yields a `Multipart::Builder` to the given block, returning the generated\nmessage as a `String`.","summary":"<p>Yields a <code><a href=\"../HTTP/Multipart/Builder.html\">Multipart::Builder</a></code> to the given block, returning the generated message as a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(boundary = <span class=\"t\">Multipart</span>.generate_boundary, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L81","def":{"name":"build","args":[{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  build(io, boundary) do |g|\n    yield g\n  end\nend"}},{"id":"generate_boundary-class-method","html_id":"generate_boundary-class-method","name":"generate_boundary","doc":"Returns a unique string suitable for use as a multipart boundary.\n\n```\nHTTP::Multipart.generate_boundary # => \"---------------------------dQu6bXHYb4m5zrRC3xPTGwV\"\n```","summary":"<p>Returns a unique string suitable for use as a multipart boundary.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L92","def":{"name":"generate_boundary","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"--------------------------#{Random::Secure.urlsafe_base64(18)}\""}},{"id":"parse(io,boundary,&block)-class-method","html_id":"parse(io,boundary,&amp;block)-class-method","name":"parse","doc":"Parses a MIME multipart message, yielding `HTTP::Headers` and an `IO` for\neach body part.\n\nPlease note that the IO object yielded to the block is only valid while the\nblock is executing. The IO is closed as soon as the supplied block returns.\n\n```\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nHTTP::Multipart.parse(IO::Memory.new(multipart), \"aA40\") do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```\n\nSee: `Multipart::Parser`","summary":"<p>Parses a MIME multipart message, yielding <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> and an <code><a href=\"../IO.html\">IO</a></code> for each body part.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"args_string":"(io, boundary, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L24","def":{"name":"parse","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"parser = Parser.new(io, boundary)\nwhile parser.has_next?\n  parser.next do |headers, io|\n    yield headers, io\n  end\nend\n"}},{"id":"parse(request:HTTP::Request,&block)-class-method","html_id":"parse(request:HTTP::Request,&amp;block)-class-method","name":"parse","doc":"Parses a MIME multipart message, yielding `HTTP::Headers` and an `IO` for\neach body part.\n\nPlease note that the IO object yielded to the block is only valid while the\nblock is executing. The IO is closed as soon as the supplied block returns.\n\n```\nheaders = HTTP::Headers{\"Content-Type\" => \"multipart/mixed; boundary=aA40\"}\nbody = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nrequest = HTTP::Request.new(\"POST\", \"/\", headers, body)\n\nHTTP::Multipart.parse(request) do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```\n\nSee: `Multipart::Parser`","summary":"<p>Parses a MIME multipart message, yielding <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> and an <code><a href=\"../IO.html\">IO</a></code> for each body part.</p>","abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L62","def":{"name":"parse","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"boundary = parse_boundary(request.headers[\"Content-Type\"])\nif boundary\nelse\n  return nil\nend\nbody = request.body\nif body\nelse\n  return nil\nend\nparse(body, boundary) do |headers, io|\n  yield headers, io\nend\n"}},{"id":"parse_boundary(content_type)-class-method","html_id":"parse_boundary(content_type)-class-method","name":"parse_boundary","doc":"Extracts the multipart boundary from the Content-Type header. May return\n`nil` is the boundary was not found.\n\n```\nHTTP::Multipart.parse_boundary(\"multipart/mixed; boundary=\\\"abcde\\\"\") # => \"abcde\"\n```","summary":"<p>Extracts the multipart boundary from the Content-Type header.</p>","abstract":false,"args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":""}],"args_string":"(content_type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr#L37","def":{"name":"parse_boundary","args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = content_type.match(/\\Amultipart\\/.*boundary=\"?([^\";,]+)\"?/i)\nif match\nelse\n  return nil\nend\nHTTP.dequote_string(match[1])\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Builder","path":"HTTP/Multipart/Builder.html","kind":"class","full_name":"HTTP::Multipart::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/multipart/builder.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart","kind":"module","full_name":"HTTP::Multipart","name":"Multipart"},"doc":"Builds a multipart MIME message.\n\n### Example\n\n```\nio = IO::Memory.new # This is a stub. Actually, any IO can be used.\nmultipart = HTTP::Multipart::Builder.new(io)\nmultipart.body_part HTTP::Headers{\"Content-Type\" => \"text/plain\"}, \"hello!\"\nmultipart.finish\nio.to_s # => \"----------------------------DTf61dRTHYzprx7rwVQhTWr7\\r\\nContent-Type: text/plain\\r\\n\\r\\nhello!\\r\\n----------------------------DTf61dRTHYzprx7rwVQhTWr7--\"\n```","summary":"<p>Builds a multipart MIME message.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,boundary=Multipart.generate_boundary)-class-method","html_id":"new(io:IO,boundary=Multipart.generate_boundary)-class-method","name":"new","doc":"Creates a new `Multipart::Builder` which writes the generated multipart\nmessage to *io*, using the multipart boundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../HTTP/Multipart/Builder.html\">Multipart::Builder</a></code> which writes the generated multipart message to <em>io</em>, using the multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io : IO, boundary = <span class=\"t\">Multipart</span>.generate_boundary)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L16","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"body_part(headers:HTTP::Headers,string:String)-instance-method","html_id":"body_part(headers:HTTP::Headers,string:String)-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand *string*. Throws if `#finish` or `#epilogue` is called before this\nmethod.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and <em>string</em>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(headers : HTTP::Headers, string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L79","def":{"name":"body_part","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"body_part_impl(headers) do |io|\n  string.to_s(io)\nend"}},{"id":"body_part(headers:HTTP::Headers,data:Bytes)-instance-method","html_id":"body_part(headers:HTTP::Headers,data:Bytes)-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand *data*. Throws if `#finish` or `#epilogue` is called before this\nmethod.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and <em>data</em>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"args_string":"(headers : HTTP::Headers, data : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L86","def":{"name":"body_part","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"body_part_impl(headers) do |io|\n  io.write(data)\nend"}},{"id":"body_part(headers:HTTP::Headers,body_io:IO)-instance-method","html_id":"body_part(headers:HTTP::Headers,body_io:IO)-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand data from *body_io*. Throws if `#finish` or `#epilogue` is called\nbefore this method.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and data from <em>body_io</em>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body_io","doc":null,"default_value":"","external_name":"body_io","restriction":"IO"}],"args_string":"(headers : HTTP::Headers, body_io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L93","def":{"name":"body_part","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body_io","doc":null,"default_value":"","external_name":"body_io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"body_part_impl(headers) do |io|\n  IO.copy(body_io, io)\nend"}},{"id":"body_part(headers:HTTP::Headers,&block)-instance-method","html_id":"body_part(headers:HTTP::Headers,&amp;block)-instance-method","name":"body_part","doc":"Yields an IO that can be used to write to a body part which is appended\nto the multipart message with the given *headers*. Throws if `#finish` or\n`#epilogue` is called before this method.","summary":"<p>Yields an IO that can be used to write to a body part which is appended to the multipart message with the given <em>headers</em>.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(headers : HTTP::Headers, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L100","def":{"name":"body_part","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"body_part_impl(headers) do |io|\n  yield io\nend"}},{"id":"body_part(headers:HTTP::Headers)-instance-method","html_id":"body_part(headers:HTTP::Headers)-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand no body data. Throws is `#finish` or `#epilogue` is called before\nthis method.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and no body data.</p>","abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(headers : HTTP::Headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L107","def":{"name":"body_part","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"HTTP::Headers"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"body_part_impl(headers, empty: true) do\nend"}},{"id":"boundary:String-instance-method","html_id":"boundary:String-instance-method","name":"boundary","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L20","def":{"name":"boundary","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@boundary"}},{"id":"content_type(subtype=&quot;mixed&quot;)-instance-method","html_id":"content_type(subtype=&amp;quot;mixed&amp;quot;)-instance-method","name":"content_type","doc":"Returns a content type header with multipart subtype *subtype*, and\nboundary parameter added.\n\n```\nio = IO::Memory.new # This is a stub. Actually, any IO can be used.\nbuilder = HTTP::Multipart::Builder.new(io, \"a4VF\")\nbuilder.content_type(\"mixed\") # => \"multipart/mixed; boundary=\\\"a4VF\\\"\"\n```","summary":"<p>Returns a content type header with multipart subtype <em>subtype</em>, and boundary parameter added.</p>","abstract":false,"args":[{"name":"subtype","doc":null,"default_value":"\"mixed\"","external_name":"subtype","restriction":""}],"args_string":"(subtype = <span class=\"s\">&quot;mixed&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L32","def":{"name":"content_type","args":[{"name":"subtype","doc":null,"default_value":"\"mixed\"","external_name":"subtype","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  str << \"multipart/\"\n  str << subtype\n  str << \"; boundary=\\\"\"\n  HTTP.quote_string(@boundary, str)\n  str << '\"'\nend"}},{"id":"epilogue(string:String)-instance-method","html_id":"epilogue(string:String)-instance-method","name":"epilogue","doc":"Appends *string* to the epilogue segment of the multipart message. Throws\nif `#finish` is called before this method, or no body parts have been\nappended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>string</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L136","def":{"name":"epilogue","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"epilogue do |io|\n  string.to_s(io)\nend"}},{"id":"epilogue(data:Bytes)-instance-method","html_id":"epilogue(data:Bytes)-instance-method","name":"epilogue","doc":"Appends *data* to the epilogue segment of the multipart message. Throws\nif `#finish` is called before this method, or no body parts have been\nappended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>data</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L145","def":{"name":"epilogue","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"epilogue do |io|\n  io.write(data)\nend"}},{"id":"epilogue(epilogue_io:IO)-instance-method","html_id":"epilogue(epilogue_io:IO)-instance-method","name":"epilogue","doc":"Appends *preamble_io* to the epilogue segment of the multipart message.\nThrows if `#finish` is called before this method, or no body parts have\nbeen appended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>preamble_io</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"epilogue_io","doc":null,"default_value":"","external_name":"epilogue_io","restriction":"IO"}],"args_string":"(epilogue_io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L154","def":{"name":"epilogue","args":[{"name":"epilogue_io","doc":null,"default_value":"","external_name":"epilogue_io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"epilogue do |io|\n  IO.copy(epilogue_io, io)\nend"}},{"id":"epilogue(&block)-instance-method","html_id":"epilogue(&amp;block)-instance-method","name":"epilogue","doc":"Yields an IO that can be used to append to the epilogue of the multipart\nmessage. Throws if `#finish` is called before this method, or no body\nparts have been appended.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Yields an IO that can be used to append to the epilogue of the multipart message.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L163","def":{"name":"epilogue","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if @state == (:FINISHED)\n  fail(\"Cannot generate epilogue: already finished\")\nend\nif (@state == (:START)) || (@state == (:PREAMBLE))\n  fail(\"Cannot generate epilogue: no body parts\")\nend\nif @state != (:EPILOGUE)\n  ((@io << \"\\r\\n--\") << @boundary) << \"--\\r\\n\"\nend\nyield @io\n@state = :EPILOGUE\n"}},{"id":"finish-instance-method","html_id":"finish-instance-method","name":"finish","doc":"Finalizes the multipart message, this method must be called to properly\nend the multipart message.","summary":"<p>Finalizes the multipart message, this method must be called to properly end the multipart message.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L179","def":{"name":"finish","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@state == (:START)) || (@state == (:PREAMBLE))\n  fail(\"Cannot finish multipart: no body parts\")\nend\nif @state == (:FINISHED)\n  fail(\"Cannot finish multipart: already finished\")\nend\nif @state == (:BODY_PART)\n  ((@io << \"\\r\\n--\") << @boundary) << \"--\"\nend\n@state = :FINISHED\n"}},{"id":"preamble(string:String)-instance-method","html_id":"preamble(string:String)-instance-method","name":"preamble","doc":"Appends *string* to the preamble segment of the multipart message. Throws\nif `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>string</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L46","def":{"name":"preamble","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"preamble do |io|\n  string.to_s(io)\nend"}},{"id":"preamble(data:Bytes)-instance-method","html_id":"preamble(data:Bytes)-instance-method","name":"preamble","doc":"Appends *data* to the preamble segment of the multipart message. Throws\nif `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>data</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L54","def":{"name":"preamble","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"preamble do |io|\n  io.write(data)\nend"}},{"id":"preamble(preamble_io:IO)-instance-method","html_id":"preamble(preamble_io:IO)-instance-method","name":"preamble","doc":"Appends *preamble_io* to the preamble segment of the multipart message.\nThrows if `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>preamble_io</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"preamble_io","doc":null,"default_value":"","external_name":"preamble_io","restriction":"IO"}],"args_string":"(preamble_io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L62","def":{"name":"preamble","args":[{"name":"preamble_io","doc":null,"default_value":"","external_name":"preamble_io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"preamble do |io|\n  IO.copy(preamble_io, io)\nend"}},{"id":"preamble(&block)-instance-method","html_id":"preamble(&amp;block)-instance-method","name":"preamble","doc":"Yields an IO that can be used to append to the preamble of the multipart\nmessage. Throws if `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Yields an IO that can be used to append to the preamble of the multipart message.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/builder.cr#L70","def":{"name":"preamble","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@state != (:START)) && (@state != (:PREAMBLE))\n  fail(\"Cannot generate preamble: body already started\")\nend\nyield @io\n@state = :PREAMBLE\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Error","path":"HTTP/Multipart/Error.html","kind":"class","full_name":"HTTP::Multipart::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/multipart.cr","line_number":96,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart","kind":"module","full_name":"HTTP::Multipart","name":"Multipart"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Parser","path":"HTTP/Multipart/Parser.html","kind":"class","full_name":"HTTP::Multipart::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/multipart/parser.cr","line_number":20,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart","kind":"module","full_name":"HTTP::Multipart","name":"Multipart"},"doc":"Parses multipart MIME messages.\n\n### Example\n\n```\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nparser = HTTP::Multipart::Parser.new(IO::Memory.new(multipart), \"aA40\")\n\nwhile parser.has_next?\n  parser.next do |headers, io|\n    headers[\"Content-Type\"] # => \"text/plain\"\n    io.gets_to_end          # => \"body\"\n  end\nend\n```\n\nPlease note that the IO object yielded by `#next` is only valid until the\nblock returns.","summary":"<p>Parses multipart MIME messages.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,boundary:String)-class-method","html_id":"new(io:IO,boundary:String)-class-method","name":"new","doc":"Creates a new `Multipart::Parser` which parses *io* with multipart\nboundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../HTTP/Multipart/Parser.html\">Multipart::Parser</a></code> which parses <em>io</em> with multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":"String"}],"args_string":"(io : IO, boundary : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L23","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"boundary","doc":null,"default_value":"","external_name":"boundary","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"has_next?-instance-method","html_id":"has_next?-instance-method","name":"has_next?","doc":"True if `#next` can be called legally.","summary":"<p>True if <code><a href=\"../../HTTP/Multipart/Parser.html#next%28%26block%29-instance-method\">#next</a></code> can be called legally.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L78","def":{"name":"has_next?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@state != (:FINISHED)) && (@state != (:ERRORED))"}},{"id":"next(&block)-instance-method","html_id":"next(&amp;block)-instance-method","name":"next","doc":"Parses the next body part and yields headers as `HTTP::Headers` and the\nbody text as an `IO`.\n\nThis method yields once instead of returning the values, because the IO\nobject yielded to the block is only valid while the block is executing.\nThe IO object will be closed as soon as the block returns. To store the\ncontent of the body part for longer than the block, the IO must be read\ninto memory.\n\n```\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nparser = HTTP::Multipart::Parser.new(IO::Memory.new(multipart), \"aA40\")\nparser.next do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```","summary":"<p>Parses the next body part and yields headers as <code><a href=\"../../HTTP/Headers.html\">HTTP::Headers</a></code> and the body text as an <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/multipart/parser.cr#L46","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  if @state == (:FINISHED)\n    raise(Multipart::Error.new(\"Multipart parser already finished parsing\"))\n  end\n  if @state == (:ERRORED)\n    raise(Multipart::Error.new(\"Multipart parser is in an errored state\"))\n  end\n  if @state == (:PREAMBLE)\n    preamble_io = IO::Delimited.new(@io, read_delimiter: @dash_boundary)\n    preamble_io.skip_to_end\n    if close_delimiter?\n      fail(\"no parts\")\n    end\n    @state = :PART_START\n  end\n  if @state == (:PART_START)\n    body_io = IO::Delimited.new(@io, read_delimiter: @delimiter)\n    headers = parse_headers(body_io)\n    begin\n      yield headers, body_io\n    ensure\n      body_io.skip_to_end\n      body_io.close\n      if close_delimiter?\n        @state = :FINISHED\n      end\n    end\n  end\nrescue ex\n  @state = :ERRORED\n  raise(ex)\nend"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Params","path":"HTTP/Params.html","kind":"struct","full_name":"HTTP::Params","name":"Params","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/params.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Represents a collection of http parameters and their respective values.","summary":"<p>Represents a collection of http parameters and their respective values.</p>","class_methods":[{"id":"build(&block:Builder->):String-class-method","html_id":"build(&amp;block:Builder-&gt;):String-class-method","name":"build","doc":"Builds an url-encoded HTTP form/query.\n\nThe yielded object has an `add` method that accepts two arguments,\na key (`String`) and a value (`String` or `Nil`).\nKeys and values are escaped using `URI#escape`.\n\n```\nparams = HTTP::Params.build do |form|\n  form.add \"color\", \"black\"\n  form.add \"name\", \"crystal\"\n  form.add \"year\", \"2012 - today\"\nend\nparams # => \"color=black&name=crystal&year=2012+-+today\"\n```","summary":"<p>Builds an url-encoded HTTP form/query.</p>","abstract":false,"args":[],"args_string":"(&block : Builder -> ) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L119","def":{"name":"build","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Builder -> )"},"return_type":"String","visibility":"Public","body":"form_builder = Builder.new\nyield form_builder\nform_builder.to_s\n"}},{"id":"encode(hash:Hash(String,String))-class-method","html_id":"encode(hash:Hash(String,String))-class-method","name":"encode","doc":"Returns the given key value pairs as a url-encoded HTTP form/query.\n\n```\nHTTP::Params.encode({\"foo\" => \"bar\", \"baz\" => \"qux\"}) # => \"foo=bar&baz=qux\"\n```","summary":"<p>Returns the given key value pairs as a url-encoded HTTP form/query.</p>","abstract":false,"args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, String)"}],"args_string":"(hash : Hash(String, String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L84","def":{"name":"encode","args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"build do |builder|\n  hash.each do |key, value|\n    builder.add(key, value)\n  end\nend"}},{"id":"encode(named_tuple:NamedTuple)-class-method","html_id":"encode(named_tuple:NamedTuple)-class-method","name":"encode","doc":"Returns the given key value pairs as a url-encoded HTTP form/query.\n\n```\nHTTP::Params.encode({foo: \"bar\", baz: \"qux\"}) # => \"foo=bar&baz=qux\"\n```","summary":"<p>Returns the given key value pairs as a url-encoded HTTP form/query.</p>","abstract":false,"args":[{"name":"named_tuple","doc":null,"default_value":"","external_name":"named_tuple","restriction":"NamedTuple"}],"args_string":"(named_tuple : NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L97","def":{"name":"encode","args":[{"name":"named_tuple","doc":null,"default_value":"","external_name":"named_tuple","restriction":"NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"build do |builder|\n  named_tuple.each do |key, value|\n    builder.add(key.to_s, value)\n  end\nend"}},{"id":"parse(query:String,&block)-class-method","html_id":"parse(query:String,&amp;block)-class-method","name":"parse","doc":"Parses an HTTP query and yields each key-value pair.\n\n```\nquery = \"foo=bar&foo=baz&qux=zoo\"\nHTTP::Params.parse(query) do |key, value|\n  # ...\nend\n```","summary":"<p>Parses an HTTP query and yields each key-value pair.</p>","abstract":false,"args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String"}],"args_string":"(query : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L31","def":{"name":"parse","args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"if query.empty?\n  return\nend\nkey = nil\nbuffer = IO::Memory.new\ni = 0\nfirst_equal = true\nbytesize = query.bytesize\nwhile i < bytesize\n  byte = query.unsafe_byte_at(i)\n  char = byte.unsafe_chr\n  case char\n  when '='\n    if first_equal\n      key = buffer.to_s\n      buffer.clear\n      i = i + 1\n      first_equal = false\n    else\n      i = decode_one_www_form_component(query, bytesize, i, byte, char, buffer)\n    end\n  when '&', ';'\n    value = buffer.to_s\n    buffer.clear\n    if key\n      yield key.not_nil!, value\n    else\n      if value.empty?\n      else\n        yield value, \"\"\n      end\n    end\n    key = nil\n    first_equal = true\n    i = i + 1\n  else\n    i = decode_one_www_form_component(query, bytesize, i, byte, char, buffer)\n  end\nend\nif key\n  yield key.not_nil!, buffer.to_s\nelse\n  if buffer.empty?\n  else\n    yield buffer.to_s, \"\"\n  end\nend\n"}}],"constructors":[{"id":"new(raw_params:Hash(String,Array(String)))-class-method","html_id":"new(raw_params:Hash(String,Array(String)))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"raw_params","doc":null,"default_value":"","external_name":"raw_params","restriction":"Hash(String, Array(String))"}],"args_string":"(raw_params : Hash(String, Array(String)))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L127","def":{"name":"new","args":[{"name":"raw_params","doc":null,"default_value":"","external_name":"raw_params","restriction":"Hash(String, Array(String))"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(raw_params)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"parse(query:String):self-class-method","html_id":"parse(query:String):self-class-method","name":"parse","doc":"Parses an HTTP query string into a `HTTP::Params`\n\n```\nHTTP::Params.parse(\"foo=bar&foo=baz&qux=zoo\")\n# => #<HTTP::Params @raw_params = {\"foo\" => [\"bar\", \"baz\"], \"qux\" => [\"zoo\"]}>\n```","summary":"<p>Parses an HTTP query string into a <code><a href=\"../HTTP/Params.html\">HTTP::Params</a></code></p>","abstract":false,"args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String"}],"args_string":"(query : String) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L14","def":{"name":"parse","args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"parsed = {} of String => Array(String)\nparse(query) do |key, value|\n  ary = (  __temp_57 = key\n  parsed[__temp_57]? || (parsed[__temp_57] = [] of String)\n)\n  ary.push(value)\nend\nParams.new(parsed)\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L130","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.raw_params == other.raw_params"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L134","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"[](name)-instance-method","html_id":"[](name)-instance-method","name":"[]","doc":"Returns first value for specified param name.\n\n```\nparams = HTTP::Params.parse(\"email=john@example.org\")\nparams[\"email\"]              # => \"john@example.org\"\nparams[\"non_existent_param\"] # KeyError\n```","summary":"<p>Returns first value for specified param name.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L145","def":{"name":"[]","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params[name].first"}},{"id":"[]=(name,value)-instance-method","html_id":"[]=(name,value)-instance-method","name":"[]=","doc":"Sets first *value* for specified param *name*.\n\n```\nparams[\"item\"] = \"pencil\"\n```","summary":"<p>Sets first <em>value</em> for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L172","def":{"name":"[]=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"__temp_59 = name\n__temp_60 = raw_params\n__temp_60[__temp_59]? || (__temp_60[__temp_59] = [\"\"])\nraw_params[name][0] = value\n"}},{"id":"[]?(name)-instance-method","html_id":"[]?(name)-instance-method","name":"[]?","doc":"Returns first value or `nil` for specified param *name*.\n\n```\nparams[\"email\"]?              # => \"john@example.org\"\nparams[\"non_existent_param\"]? # nil\n```","summary":"<p>Returns first value or <code>nil</code> for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L155","def":{"name":"[]?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(name) do\n  nil\nend"}},{"id":"add(name,value)-instance-method","html_id":"add(name,value)-instance-method","name":"add","doc":"Appends new value for specified param *name*.\nCreates param when there was no such param.\n\n```\nparams.add(\"item\", \"keychain\")\nparams.fetch_all(\"item\") # => [\"pencil\", \"book\", \"workbook\", \"keychain\"]\n```","summary":"<p>Appends new value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L228","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L228","def":{"name":"add","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"__temp_61 = name\n__temp_62 = raw_params\n__temp_62[__temp_61]? || (__temp_62[__temp_61] = [] of String)\nif raw_params[name] == [\"\"]\n  raw_params[name] = [] of String\nend\nraw_params[name] << value\n"}},{"id":"delete(name)-instance-method","html_id":"delete(name)-instance-method","name":"delete","doc":"Deletes first value for provided param *name*. If there are no values left,\ndeletes param itself. Returns deleted value.\n\n```\nparams.delete(\"item\")    # => \"keychain\"\nparams.fetch_all(\"item\") # => [\"keynote\"]\n\nparams.delete(\"item\") # => \"keynote\"\nparams[\"item\"]        # KeyError\n\nparams.delete(\"non_existent_param\") # KeyError\n```","summary":"<p>Deletes first value for provided param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L276","def":{"name":"delete","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value = raw_params[name].shift\nif raw_params[name].size == 0\n  raw_params.delete(name)\nend\nvalue\n"}},{"id":"delete_all(name)-instance-method","html_id":"delete_all(name)-instance-method","name":"delete_all","doc":"Deletes all values for provided param *name*. Returns array of deleted\nvalues.\n\n```\nparams.set_all(\"comments\", [\"hello, world!\", \":+1:\"])\nparams.delete_all(\"comments\") # => [\"hello, world!\", \":+1:\"]\nparams.has_key?(\"comments\")   # => false\n```","summary":"<p>Deletes all values for provided param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L290","def":{"name":"delete_all","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params.delete(name)"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":"Allows to iterate over all name-value pairs.\n\n```\nparams.each do |name, value|\n  puts \"#{name} => #{value}\"\nend\n\n# Outputs:\n# email => john@example.org\n# item => keychain\n# item => keynote\n```","summary":"<p>Allows to iterate over all name-value pairs.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L256","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params.each do |name, values|\n  values.each do |value|\n    yield {name, value}\n  end\nend"}},{"id":"fetch(name,&block)-instance-method","html_id":"fetch(name,&amp;block)-instance-method","name":"fetch","doc":"Returns first value for specified param *name*. Fallbacks to return value\nof provided block when there is no such param.\n\n```\nparams.fetch(\"email\") { raise \"Email is missing\" }              # raises \"Email is missing\"\nparams.fetch(\"non_existent_param\") { \"default computed value\" } # => \"default computed value\"\n```","summary":"<p>Returns first value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L216","def":{"name":"fetch","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if has_key?(name)\nelse\n  return yield\nend\nfetch(name)\n"}},{"id":"fetch(name)-instance-method","html_id":"fetch(name)-instance-method","name":"fetch","doc":"Returns first value for specified param *name*.\n\n```\nparams.fetch(\"email\")              # => \"john@example.org\"\nparams.fetch(\"non_existent_param\") # KeyError\n```","summary":"<p>Returns first value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L193","def":{"name":"fetch","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(raw_params.fetch(name)).first"}},{"id":"fetch(name,default)-instance-method","html_id":"fetch(name,default)-instance-method","name":"fetch","doc":"Returns first value for specified param *name*. Fallbacks to provided\n*default* value when there is no such param.\n\n```\nparams.fetch(\"email\", \"none@example.org\")           # => \"john@example.org\"\nparams.fetch(\"non_existent_param\", \"default value\") # => \"default value\"\n```","summary":"<p>Returns first value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"args_string":"(name, default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L204","def":{"name":"fetch","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"default","doc":null,"default_value":"","external_name":"default","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if has_key?(name)\nelse\n  return default\nend\nfetch(name)\n"}},{"id":"fetch_all(name)-instance-method","html_id":"fetch_all(name)-instance-method","name":"fetch_all","doc":"Returns all values for specified param *name*.\n\n```\nparams.set_all(\"item\", [\"pencil\", \"book\", \"workbook\"])\nparams.fetch_all(\"item\") # => [\"pencil\", \"book\", \"workbook\"]\n```","summary":"<p>Returns all values for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L183","def":{"name":"fetch_all","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params.fetch(name) do\n  [] of String\nend"}},{"id":"has_key?(*args,**options,&block)-instance-method","html_id":"has_key?(*args,**options,&amp;block)-instance-method","name":"has_key?","doc":"Returns `true` if param with provided name exists.\n\n```\nparams.has_key?(\"email\")   # => true\nparams.has_key?(\"garbage\") # => false\n```","summary":"<p>Returns <code>true</code> if param with provided name exists.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L165","def":{"name":"has_key?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params.has_key?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"has_key?(*args,**options)-instance-method","html_id":"has_key?(*args,**options)-instance-method","name":"has_key?","doc":"Returns `true` if param with provided name exists.\n\n```\nparams.has_key?(\"email\")   # => true\nparams.has_key?(\"garbage\") # => false\n```","summary":"<p>Returns <code>true</code> if param with provided name exists.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L165","def":{"name":"has_key?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params.has_key?(*args, **options)"}},{"id":"set_all(name,values)-instance-method","html_id":"set_all(name,values)-instance-method","name":"set_all","doc":"Sets all *values* for specified param *name* at once.\n\n```\nparams.set_all(\"item\", [\"keychain\", \"keynote\"])\nparams.fetch_all(\"item\") # => [\"keychain\", \"keynote\"]\n```","summary":"<p>Sets all <em>values</em> for specified param <em>name</em> at once.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"args_string":"(name, values)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L240","def":{"name":"set_all","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw_params[name] = values"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Serializes to string representation as http url-encoded form.\n\n```\nparams = HTTP::Params.parse(\"item=keychain&item=keynote&email=john@example.org\")\nparams.to_s # => \"item=keychain&item=keynote&email=john%40example.org\"\n```\nTODO: `to_s` should escape @ to %40 ?","summary":"<p>Serializes to string representation as http url-encoded form.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L301","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"builder = Builder.new(io)\neach do |name, value|\n  builder.add(name, value)\nend\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Params/Builder","path":"HTTP/Params/Builder.html","kind":"class","full_name":"HTTP::Params::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/params.cr","line_number":322,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Params","kind":"struct","full_name":"HTTP::Params","name":"Params"},"doc":"HTTP params builder.\n\nEvery parameter added is directly written to an `IO`,\nwhere keys and values are properly escaped.","summary":"<p>HTTP params builder.</p>","class_methods":[],"constructors":[{"id":"new(io=IO::Memory.new)-class-method","html_id":"new(io=IO::Memory.new)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"IO::Memory.new","external_name":"io","restriction":""}],"args_string":"(io = <span class=\"t\">IO</span><span class=\"t\">::</span><span class=\"t\">Memory</span>.<span class=\"k\">new</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L326","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"IO::Memory.new","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add(key,value)-instance-method","html_id":"add(key,value)-instance-method","name":"add","doc":"Adds a key-value pair to the params being built.","summary":"<p>Adds a key-value pair to the params being built.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(key, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L331","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L331","def":{"name":"add","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @first\nelse\n  @io << '&'\nend\n@first = false\nURI.escape(key, @io)\n@io << '='\nif value\n  Params.encode_www_form_component(value, @io)\nend\nself\n"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L340","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/params.cr#L340","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << @io.to_s"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Request","path":"HTTP/Request.html","kind":"class","full_name":"HTTP::Request","name":"Request","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/request.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An HTTP request.\n\nIt serves both to perform requests by an `HTTP::Client` and to\nrepresent requests received by an `HTTP::Server`.\n\nA request always holds an `IO` as a body.\nWhen creating a request with a `String` or `Bytes` its body\nwill be a `IO::Memory` wrapping these, and the `Content-Length`\nheader will be set appropriately.","summary":"<p>An HTTP request.</p>","class_methods":[{"id":"from_io(io)-class-method","html_id":"from_io(io)-class-method","name":"from_io","doc":"Returns a `HTTP::Request` instance if successfully parsed,\n`nil` on EOF or `BadRequest` otherwise.","summary":"<p>Returns a <code><a href=\"../HTTP/Request.html\">HTTP::Request</a></code> instance if successfully parsed, <code>nil</code> on EOF or <code>BadRequest</code> otherwise.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L90","def":{"name":"from_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"request_line = io.gets(4096, chomp: true)\nif request_line\nelse\n  return\nend\nparts = request_line.split\nif parts.size == 3\nelse\n  return BadRequest.new\nend\nmethod, resource, http_version = parts\nif HTTP::SUPPORTED_VERSIONS.includes?(http_version)\nelse\n  return BadRequest.new\nend\nHTTP.parse_headers_and_body(io) do |headers, body|\n  return new(method, resource, headers, body, http_version)\nend\nBadRequest.new\n"}}],"constructors":[{"id":"new(method:String,resource:String,headers:Headers?=nil,body:String|Bytes|IO|Nil=nil,version=&quot;HTTP/1.1&quot;)-class-method","html_id":"new(method:String,resource:String,headers:Headers?=nil,body:String|Bytes|IO|Nil=nil,version=&amp;quot;HTTP/1.1&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"resource","doc":null,"default_value":"","external_name":"resource","restriction":"String"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"String | Bytes | IO | Nil"},{"name":"version","doc":null,"default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""}],"args_string":"(method : String, resource : String, headers : Headers? = <span class=\"n\">nil</span>, body : String | Bytes | IO | Nil = <span class=\"n\">nil</span>, version = <span class=\"s\">&quot;HTTP/1.1&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L23","def":{"name":"new","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"},{"name":"resource","doc":null,"default_value":"","external_name":"resource","restriction":"String"},{"name":"headers","doc":null,"default_value":"nil","external_name":"headers","restriction":"Headers | ::Nil"},{"name":"body","doc":null,"default_value":"nil","external_name":"body","restriction":"String | Bytes | IO | Nil"},{"name":"version","doc":null,"default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(method, resource, headers, body, version)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"body:IO?-instance-method","html_id":"body:IO?-instance-method","name":"body","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : IO?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L17","def":{"name":"body","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IO | ::Nil","visibility":"Public","body":"@body"}},{"id":"body=(body:Nil)-instance-method","html_id":"body=(body:Nil)-instance-method","name":"body=","doc":null,"summary":null,"abstract":false,"args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"Nil"}],"args_string":"(body : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L74","def":{"name":"body=","args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body = body\nif (@method == \"POST\") || (@method == \"PUT\")\n  @headers[\"Content-Length\"] = \"0\"\nend\n"}},{"id":"body=(body:IO)-instance-method","html_id":"body=(body:IO)-instance-method","name":"body=","doc":null,"summary":null,"abstract":false,"args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"IO"}],"args_string":"(body : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L71","def":{"name":"body=","args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body = body"}},{"id":"body=(body:Bytes)-instance-method","html_id":"body=(body:Bytes)-instance-method","name":"body=","doc":null,"summary":null,"abstract":false,"args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"Bytes"}],"args_string":"(body : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L66","def":{"name":"body=","args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body = IO::Memory.new(body)\nself.content_length = body.size\n"}},{"id":"body=(body:String)-instance-method","html_id":"body=(body:String)-instance-method","name":"body=","doc":null,"summary":null,"abstract":false,"args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"String"}],"args_string":"(body : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L61","def":{"name":"body=","args":[{"name":"body","doc":null,"default_value":"","external_name":"body","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@body = IO::Memory.new(body)\nself.content_length = body.bytesize\n"}},{"id":"content_length-instance-method","html_id":"content_length-instance-method","name":"content_length","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L57","def":{"name":"content_length","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"HTTP.content_length(headers)"}},{"id":"content_length=(length:Int)-instance-method","html_id":"content_length=(length:Int)-instance-method","name":"content_length=","doc":null,"summary":null,"abstract":false,"args":[{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":"Int"}],"args_string":"(length : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L53","def":{"name":"content_length=","args":[{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers[\"Content-Length\"] = length.to_s"}},{"id":"cookies-instance-method","html_id":"cookies-instance-method","name":"cookies","doc":"Returns a convenience wrapper around querying and setting cookie related\nheaders, see `HTTP::Cookies`.","summary":"<p>Returns a convenience wrapper around querying and setting cookie related headers, see <code><a href=\"../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L30","def":{"name":"cookies","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies || (@cookies = Cookies.from_headers(headers))"}},{"id":"headers:Headers-instance-method","html_id":"headers:Headers-instance-method","name":"headers","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Headers","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L16","def":{"name":"headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Headers","visibility":"Public","body":"@headers"}},{"id":"headers=(headers:Headers)-instance-method","html_id":"headers=(headers:Headers)-instance-method","name":"headers=","doc":null,"summary":null,"abstract":false,"args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"Headers"}],"args_string":"(headers : Headers)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L16","def":{"name":"headers=","args":[{"name":"headers","doc":null,"default_value":"","external_name":"headers","restriction":"Headers"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@headers = headers"}},{"id":"host-instance-method","html_id":"host-instance-method","name":"host","doc":"Return request host from headers.","summary":"<p>Return request host from headers.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L133","def":{"name":"host","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"host = @headers[\"Host\"]?\nif host\nelse\n  return\nend\nindex = host.index(\":\")\nindex ? host[0...index] : host\n"}},{"id":"host_with_port-instance-method","html_id":"host_with_port-instance-method","name":"host_with_port","doc":"Return request host with port from headers.","summary":"<p>Return request host with port from headers.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L141","def":{"name":"host_with_port","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@headers[\"Host\"]?"}},{"id":"ignore_body?-instance-method","html_id":"ignore_body?-instance-method","name":"ignore_body?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L49","def":{"name":"ignore_body?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@method == \"HEAD\""}},{"id":"keep_alive?-instance-method","html_id":"keep_alive?-instance-method","name":"keep_alive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L45","def":{"name":"keep_alive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"HTTP.keep_alive?(self)"}},{"id":"method:String-instance-method","html_id":"method:String-instance-method","name":"method","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L15","def":{"name":"method","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@method"}},{"id":"method=(method:String)-instance-method","html_id":"method=(method:String)-instance-method","name":"method=","doc":null,"summary":null,"abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"}],"args_string":"(method : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L15","def":{"name":"method=","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@method = method"}},{"id":"path-instance-method","html_id":"path-instance-method","name":"path","doc":"Lazily parses and return the request's path component.","summary":"<p>Lazily parses and return the request's path component.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L110","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uri.path || \"/\""}},{"id":"path=(path)-instance-method","html_id":"path=(path)-instance-method","name":"path=","doc":"Sets request's path component.","summary":"<p>Sets request's path component.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"args_string":"(path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L115","def":{"name":"path=","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uri.path = path"}},{"id":"query-instance-method","html_id":"query-instance-method","name":"query","doc":"Lazily parses and returns the request's query component.","summary":"<p>Lazily parses and returns the request's query component.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L120","def":{"name":"query","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"update_uri\nuri.query\n"}},{"id":"query=(value)-instance-method","html_id":"query=(value)-instance-method","name":"query=","doc":"Sets request's query component.","summary":"<p>Sets request's query component.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L126","def":{"name":"query=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uri.query = value\nupdate_query_params\nvalue\n"}},{"id":"query_params-instance-method","html_id":"query_params-instance-method","name":"query_params","doc":"Returns a convenience wrapper around querying and setting query params,\nsee `HTTP::Params`.","summary":"<p>Returns a convenience wrapper around querying and setting query params, see <code><a href=\"../HTTP/Params.html\">HTTP::Params</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L36","def":{"name":"query_params","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@query_params || (@query_params = parse_query_params)"}},{"id":"resource-instance-method","html_id":"resource-instance-method","name":"resource","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L40","def":{"name":"resource","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"update_uri\n@uri.try(&.full_path) || @resource\n"}},{"id":"to_io(io)-instance-method","html_id":"to_io(io)-instance-method","name":"to_io","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L78","def":{"name":"to_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(((((io << @method) << ' ') << resource) << ' ') << @version) << \"\\r\\n\"\ncookies = @cookies\nheaders = cookies ? cookies.add_request_headers(@headers) : @headers\nHTTP.serialize_headers_and_body(io, headers, nil, @body, @version)\n"}},{"id":"version:String-instance-method","html_id":"version:String-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L18","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@version"}},{"id":"version=(version:String)-instance-method","html_id":"version=(version:String)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"String"}],"args_string":"(version : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/request.cr#L18","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server","path":"HTTP/Server.html","kind":"class","full_name":"HTTP::Server","name":"Server","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/context.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr"},{"filename":"http/server/response.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr"},{"filename":"http/server.cr","line_number":97,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An HTTP server.\n\nA server is given a handler that receives an `HTTP::Server::Context` that holds\nthe `HTTP::Request` to process and must in turn configure and write to an `HTTP::Server::Response`.\n\nThe `HTTP::Server::Response` object has `status` and `headers` properties that can be\nconfigured before writing the response body. Once response output is written,\nchanging the `status` and `headers` properties has no effect.\n\nThe `HTTP::Server::Response` is also a write-only `IO`, so all `IO` methods are available\nin it.\n\nThe handler given to a server can simply be a block that receives an `HTTP::Server::Context`,\nor it can be an `HTTP::Handler`. An `HTTP::Handler` has an optional `next` handler,\nso handlers can be chained. For example, an initial handler may handle exceptions\nin a subsequent handler and return a 500 status code (see `HTTP::ErrorHandler`),\nthe next handler might log the incoming request (see `HTTP::LogHandler`), and\nthe final handler deals with routing and application logic.\n\n### Simple Setup\n\nA handler is given with a block.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new do |context|\n  context.response.content_type = \"text/plain\"\n  context.response.print \"Hello world!\"\nend\n\nserver.bind_tcp 8080\nputs \"Listening on http://127.0.0.1:8080\"\nserver.listen\n```\n\n### With non-localhost bind address\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new do |context|\n  context.response.content_type = \"text/plain\"\n  context.response.print \"Hello world!\"\nend\n\nserver.bind_tcp \"0.0.0.0\", 8080\nputs \"Listening on http://0.0.0.0:8080\"\nserver.listen\n```\n\n### Add handlers\n\nA series of handlers are chained.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new([\n  HTTP::ErrorHandler.new,\n  HTTP::LogHandler.new,\n  HTTP::CompressHandler.new,\n  HTTP::StaticFileHandler.new(\".\"),\n])\n\nserver.bind_tcp \"127.0.0.1\", 8080\nserver.listen\n```\n\n### Add handlers and block\n\nA series of handlers is chained, the last one being the given block.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new([\n  HTTP::ErrorHandler.new,\n  HTTP::LogHandler.new,\n]) do |context|\n  context.response.content_type = \"text/plain\"\n  context.response.print \"Hello world!\"\nend\n\nserver.bind_tcp \"0.0.0.0\", 8080\nserver.listen\n```","summary":"<p>An HTTP server.</p>","class_methods":[{"id":"build_middleware(handlers,last_handler:Context->?=nil)-class-method","html_id":"build_middleware(handlers,last_handler:Context-&gt;?=nil)-class-method","name":"build_middleware","doc":"Builds all handlers as the middleware for `HTTP::Server`.","summary":"<p>Builds all handlers as the middleware for <code><a href=\"../HTTP/Server.html\">HTTP::Server</a></code>.</p>","abstract":false,"args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":""},{"name":"last_handler","doc":null,"default_value":"nil","external_name":"last_handler","restriction":"(Context -> ) | ::Nil"}],"args_string":"(handlers, last_handler : Context -> ? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L285","def":{"name":"build_middleware","args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":""},{"name":"last_handler","doc":null,"default_value":"nil","external_name":"last_handler","restriction":"(Context -> ) | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if handlers.empty?\n  raise(ArgumentError.new(\"You must specify at least one HTTP Handler.\"))\nend\n0.upto(handlers.size - 2) do |i|\n  handlers[i].next = handlers[i + 1]\nend\nif last_handler\n  handlers.last.next = last_handler\nend\nhandlers.first\n"}}],"constructors":[{"id":"new(handlers:Array(HTTP::Handler),&handler:HTTP::Handler::Proc):self-class-method","html_id":"new(handlers:Array(HTTP::Handler),&amp;handler:HTTP::Handler::Proc):self-class-method","name":"new","doc":"Creates a new HTTP server with a handler chain constructed from the *handlers*\narray and the given block.","summary":"<p>Creates a new HTTP server with a handler chain constructed from the <em>handlers</em> array and the given block.</p>","abstract":false,"args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"args_string":"(handlers : Array(HTTP::Handler), &handler : HTTP::Handler::Proc) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L117","def":{"name":"new","args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler::Proc"},"return_type":"self","visibility":"Public","body":"new(HTTP::Server.build_middleware(handlers, handler))"}},{"id":"new(&handler:HTTP::Handler::Proc):self-class-method","html_id":"new(&amp;handler:HTTP::Handler::Proc):self-class-method","name":"new","doc":"Creates a new HTTP server with the given block as handler.","summary":"<p>Creates a new HTTP server with the given block as handler.</p>","abstract":false,"args":[],"args_string":"(&handler : HTTP::Handler::Proc) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L111","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler::Proc"},"return_type":"self","visibility":"Public","body":"new(handler)"}},{"id":"new(handlers:Array(HTTP::Handler)):self-class-method","html_id":"new(handlers:Array(HTTP::Handler)):self-class-method","name":"new","doc":"Creates a new HTTP server with the *handlers* array as handler chain.","summary":"<p>Creates a new HTTP server with the <em>handlers</em> array as handler chain.</p>","abstract":false,"args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"args_string":"(handlers : Array(HTTP::Handler)) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L122","def":{"name":"new","args":[{"name":"handlers","doc":null,"default_value":"","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(HTTP::Server.build_middleware(handlers))"}},{"id":"new(handler:HTTP::Handler|HTTP::Handler::Proc)-class-method","html_id":"new(handler:HTTP::Handler|HTTP::Handler::Proc)-class-method","name":"new","doc":"Creates a new HTTP server with the given *handler*.","summary":"<p>Creates a new HTTP server with the given <em>handler</em>.</p>","abstract":false,"args":[{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::Proc"}],"args_string":"(handler : HTTP::Handler | HTTP::Handler::Proc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L127","def":{"name":"new","args":[{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::Proc"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(handler)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"addresses:Array(Socket::Address)-instance-method","html_id":"addresses:Array(Socket::Address)-instance-method","name":"addresses","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(Socket::Address)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L204","def":{"name":"addresses","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Socket::Address)","visibility":"Public","body":"array = [] of Socket::Address\neach_address do |address|\n  array << address\nend\narray\n"}},{"id":"bind(socket:Socket::Server):Nil-instance-method","html_id":"bind(socket:Socket::Server):Nil-instance-method","name":"bind","doc":"Adds a `Socket::Server` *socket* to this server.","summary":"<p>Adds a <code><a href=\"../Socket/Server.html\">Socket::Server</a></code> <em>socket</em> to this server.</p>","abstract":false,"args":[{"name":"socket","doc":null,"default_value":"","external_name":"socket","restriction":"Socket::Server"}],"args_string":"(socket : Socket::Server) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L190","def":{"name":"bind","args":[{"name":"socket","doc":null,"default_value":"","external_name":"socket","restriction":"Socket::Server"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if listening?\n  raise(\"Can't add socket to running server\")\nend\nif closed?\n  raise(\"Can't add socket to closed server\")\nend\n@sockets << socket\n"}},{"id":"bind_tcp(host:String,port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","html_id":"bind_tcp(host:String,port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tcp","doc":"Creates a `TCPServer` listenting on `host:port` and adds it as a socket, returning the local address\nand port the server listens on.\n\n```\nserver = HTTP::Server.new { }\nserver.bind_tcp(\"127.0.0.100\", 8080) # => Socket::IPAddress.new(\"127.0.0.100\", 8080)\n```\n\nIf *reuse_port* is `true`, it enables the `SO_REUSEPORT` socket option,\nwhich allows multiple processes to bind to the same port.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listenting on <code>host:port</code> and adds it as a socket, returning the local address and port the server listens on.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int32, reuse_port : Bool = <span class=\"n\">false</span>) : Socket::IPAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L141","def":{"name":"bind_tcp","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Socket::IPAddress","visibility":"Public","body":"tcp_server = TCPServer.new(host, port, reuse_port: reuse_port)\nbind(tcp_server)\ntcp_server.local_address\n"}},{"id":"bind_tcp(port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","html_id":"bind_tcp(port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tcp","doc":"Creates a `TCPServer` listenting on `127.0.0.1:port` and adds it as a socket,\nreturning the local address and port the server listens on.\n\n```\nserver = HTTP::Server.new { }\nserver.bind_tcp(8080) # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\n```\n\nIf *reuse_port* is `true`, it enables the `SO_REUSEPORT` socket option,\nwhich allows multiple processes to bind to the same port.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listenting on <code>127.0.0.1:port</code> and adds it as a socket, returning the local address and port the server listens on.</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(port : Int32, reuse_port : Bool = <span class=\"n\">false</span>) : Socket::IPAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L159","def":{"name":"bind_tcp","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tcp(\"127.0.0.1\", port, reuse_port)"}},{"id":"bind_unix(path:String):Socket::UNIXAddress-instance-method","html_id":"bind_unix(path:String):Socket::UNIXAddress-instance-method","name":"bind_unix","doc":"Creates a `UNIXServer` bound to *path* and adds it as a socket.\n\n```\nserver = HTTP::Server.new { }\nserver.bind_unix \"/tmp/my-socket.sock\"\n```","summary":"<p>Creates a <code><a href=\"../UNIXServer.html\">UNIXServer</a></code> bound to <em>path</em> and adds it as a socket.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Socket::UNIXAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L181","def":{"name":"bind_unix","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Socket::UNIXAddress","visibility":"Public","body":"server = UNIXServer.new(path)\nbind(server)\nserver.local_address\n"}},{"id":"bind_unused_port(host:String=&quot;127.0.0.1&quot;,reuse_port:Bool=false):Socket::IPAddress-instance-method","html_id":"bind_unused_port(host:String=&amp;quot;127.0.0.1&amp;quot;,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_unused_port","doc":"Creates a `TCPServer` listening on an unused port and adds it as a socket.\n\nReturns the `Socket::IPAddress` with the determined port number.\n\n```\nserver = HTTP::Server.new { }\nserver.bind_unused_port # => Socket::IPAddress.new(\"127.0.0.1\", 12345)\n```","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on an unused port and adds it as a socket.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"\"127.0.0.1\"","external_name":"host","restriction":"String"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String = <span class=\"s\">&quot;127.0.0.1&quot;</span>, reuse_port : Bool = <span class=\"n\">false</span>) : Socket::IPAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L171","def":{"name":"bind_unused_port","args":[{"name":"host","doc":null,"default_value":"\"127.0.0.1\"","external_name":"host","restriction":"String"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tcp(host, 0, reuse_port)"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Gracefully terminates the server. It will process currently accepted\nrequests, but it won't accept new connections.","summary":"<p>Gracefully terminates the server.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L256","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if closed?\n  raise(\"Can't close server, it's already closed\")\nend\n@closed = true\n@processor.close\n@sockets.each do |socket|\n  begin\n    socket.close\n  rescue\n  end\nend\n@listening = false\n@sockets.clear\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this server is closed.","summary":"<p>Returns <code>true</code> if this server is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L105","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@closed"}},{"id":"each_address(&block:Socket::Address->)-instance-method","html_id":"each_address(&amp;block:Socket::Address-&gt;)-instance-method","name":"each_address","doc":"Enumerates all addresses this server is bound to.","summary":"<p>Enumerates all addresses this server is bound to.</p>","abstract":false,"args":[],"args_string":"(&block : Socket::Address -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L198","def":{"name":"each_address","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Socket::Address -> )"},"return_type":"","visibility":"Public","body":"@sockets.each do |socket|\n  yield socket.local_address\nend"}},{"id":"listen(port:Int32,reuse_port:Bool=false)-instance-method","html_id":"listen(port:Int32,reuse_port:Bool=false)-instance-method","name":"listen","doc":"Creates a `TCPServer` listenting on `127.0.0.1:port`, adds it as a socket\nand starts the server. Blocks until the server is closed.\n\nSee `#bind(port : Int32)` for details.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listenting on <code>127.0.0.1:port</code>, adds it as a socket and starts the server.</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(port : Int32, reuse_port : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L216","def":{"name":"listen","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bind_tcp(port, reuse_port)\nlisten\n"}},{"id":"listen(host:String,port:Int32,reuse_port:Bool=false)-instance-method","html_id":"listen(host:String,port:Int32,reuse_port:Bool=false)-instance-method","name":"listen","doc":"Creates a `TCPServer` listenting on `host:port`, adds it as a socket\nand starts the server. Blocks until the server is closed.\n\nSee `#bind(host : String, port : Int32)` for details.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listenting on <code>host:port</code>, adds it as a socket and starts the server.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int32, reuse_port : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L226","def":{"name":"listen","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bind_tcp(host, port, reuse_port)\nlisten\n"}},{"id":"listen-instance-method","html_id":"listen-instance-method","name":"listen","doc":"Starts the server. Blocks until the server is closed.","summary":"<p>Starts the server.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L233","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L233","def":{"name":"listen","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if closed?\n  raise(\"Can't re-start closed server\")\nend\nif @sockets.empty?\n  raise(\"Can't start server with no sockets to listen to, use HTTP::Server#bind first\")\nend\nif listening?\n  raise(\"Can't start running server\")\nend\n@listening = true\ndone = Channel(Nil).new\n@sockets.each do |socket|\n  spawn do\n    begin\n      while !closed?\n        spawn(handle_client(socket.accept? || (break)))\n      end\n    ensure\n      done.send(nil)\n    end\n  end\nend\n@sockets.size.times do\n  done.receive\nend\n"}},{"id":"listening?:Bool-instance-method","html_id":"listening?:Bool-instance-method","name":"listening?","doc":"Returns `true` if this server is listening on it's sockets.","summary":"<p>Returns <code>true</code> if this server is listening on it's sockets.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server.cr#L108","def":{"name":"listening?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@listening"}},{"id":"tls:OpenSSL::SSL::Context::Server?-instance-method","html_id":"tls:OpenSSL::SSL::Context::Server?-instance-method","name":"tls","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : OpenSSL::SSL::Context::Server?","source_link":null,"source_link":null,"def":{"name":"tls","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"OpenSSL::SSL::Context::Server | ::Nil","visibility":"Public","body":"@tls"}},{"id":"tls=(tls:OpenSSL::SSL::Context::Server?)-instance-method","html_id":"tls=(tls:OpenSSL::SSL::Context::Server?)-instance-method","name":"tls=","doc":null,"summary":null,"abstract":false,"args":[{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":"OpenSSL::SSL::Context::Server | ::Nil"}],"args_string":"(tls : OpenSSL::SSL::Context::Server?)","source_link":null,"source_link":null,"def":{"name":"tls=","args":[{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":"OpenSSL::SSL::Context::Server | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@tls = tls"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/Context","path":"HTTP/Server/Context.html","kind":"class","full_name":"HTTP::Server::Context","name":"Context","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/context.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"doc":"Instances of this class are passed to an `HTTP::Server` handler.","summary":"<p>Instances of this class are passed to an <code><a href=\"../../HTTP/Server.html\">HTTP::Server</a></code> handler.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"request:Request-instance-method","html_id":"request:Request-instance-method","name":"request","doc":"The `HTTP::Request` to process.","summary":"<p>The <code><a href=\"../../HTTP/Request.html\">HTTP::Request</a></code> to process.</p>","abstract":false,"args":[],"args_string":" : Request","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr#L5","def":{"name":"request","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Request","visibility":"Public","body":"@request"}},{"id":"response:Response-instance-method","html_id":"response:Response-instance-method","name":"response","doc":"The `HTTP::Server::Response` to configure and write to.","summary":"<p>The <code><a href=\"../../HTTP/Server/Response.html\">HTTP::Server::Response</a></code> to configure and write to.</p>","abstract":false,"args":[],"args_string":" : Response","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/context.cr#L8","def":{"name":"response","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Response","visibility":"Public","body":"@response"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/RequestProcessor","path":"HTTP/Server/RequestProcessor.html","kind":"class","full_name":"HTTP::Server::RequestProcessor","name":"RequestProcessor","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/request_processor.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(&handler:HTTP::Handler::Proc)-class-method","html_id":"new(&amp;handler:HTTP::Handler::Proc)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&handler : HTTP::Handler::Proc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L4","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler::Proc"},"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(&handler) do\n  yield\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(handler:HTTP::Handler|HTTP::Handler::Proc)-class-method","html_id":"new(handler:HTTP::Handler|HTTP::Handler::Proc)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::Proc"}],"args_string":"(handler : HTTP::Handler | HTTP::Handler::Proc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L8","def":{"name":"new","args":[{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::Proc"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(handler)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L12","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@wants_close = true"}},{"id":"process(input,output,error=STDERR)-instance-method","html_id":"process(input,output,error=STDERR)-instance-method","name":"process","doc":null,"summary":null,"abstract":false,"args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":""},{"name":"error","doc":null,"default_value":"STDERR","external_name":"error","restriction":""}],"args_string":"(input, output, error = <span class=\"t\">STDERR</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/request_processor.cr#L16","def":{"name":"process","args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""},{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":""},{"name":"error","doc":null,"default_value":"STDERR","external_name":"error","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"must_close = true\nresponse = Response.new(output)\nbegin\n  while !@wants_close\n    request = HTTP::Request.from_io(input)\n    if request\n    else\n      break\n    end\n    if request.is_a?(HTTP::Request::BadRequest)\n      response.respond_with_error(\"Bad Request\", 400)\n      response.close\n      return\n    end\n    response.version = request.version\n    response.reset\n    if request.keep_alive?\n      response.headers[\"Connection\"] = \"keep-alive\"\n    end\n    context = Context.new(request, response)\n    begin\n      @handler.call(context)\n    rescue ex\n      response.respond_with_error\n      response.close\n      error.puts(\"Unhandled exception on HTTP::Handler\")\n      ex.inspect_with_backtrace(error)\n      return\n    end\n    if response.upgraded?\n      must_close = false\n      return\n    end\n    response.output.close\n    output.flush\n    if request.keep_alive?\n    else\n      break\n    end\n    request.body.try(&.close)\n  end\nrescue ex : Errno\nensure\n  begin\n    if must_close\n      input.close\n    end\n  rescue ex : Errno\n  end\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/Response","path":"HTTP/Server/Response.html","kind":"class","full_name":"HTTP::Server::Response","name":"Response","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/response.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"doc":"The response to configure and write to in an `HTTP::Server` handler.\n\nThe response `status_code` and `headers` must be configured before writing\nthe response body. Once response output is written, changing the `status`\nand `headers` properties has no effect.\n\nThe `HTTP::Server::Response` is a write-only `IO`, so all `IO` methods are available\nin it.\n\nA response can be upgraded with the `upgrade` method. Once invoked, headers\nare written and the connection `IO` (a socket) is yielded to the given block.\nThe block must invoke `close` afterwards, the server won't do it in this case.\nThis is useful to implement protocol upgrades, such as websockets.","summary":"<p>The response to configure and write to in an <code><a href=\"../../HTTP/Server.html\">HTTP::Server</a></code> handler.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this response, writing headers and body if not done yet.\nThis method must be implemented if wrapping the response output.","summary":"<p>Closes this response, writing headers and body if not done yet.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L103","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@output.close"}},{"id":"content_length=(content_length:Int)-instance-method","html_id":"content_length=(content_length:Int)-instance-method","name":"content_length=","doc":"Convenience method to set the `Content-Length` header.","summary":"<p>Convenience method to set the <code>Content-Length</code> header.</p>","abstract":false,"args":[{"name":"content_length","doc":null,"default_value":"","external_name":"content_length","restriction":"Int"}],"args_string":"(content_length : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L60","def":{"name":"content_length=","args":[{"name":"content_length","doc":null,"default_value":"","external_name":"content_length","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers[\"Content-Length\"] = content_length.to_s"}},{"id":"content_type=(content_type:String)-instance-method","html_id":"content_type=(content_type:String)-instance-method","name":"content_type=","doc":"Convenience method to set the `Content-Type` header.","summary":"<p>Convenience method to set the <code>Content-Type</code> header.</p>","abstract":false,"args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":"String"}],"args_string":"(content_type : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L55","def":{"name":"content_type=","args":[{"name":"content_type","doc":null,"default_value":"","external_name":"content_type","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"headers[\"Content-Type\"] = content_type"}},{"id":"cookies-instance-method","html_id":"cookies-instance-method","name":"cookies","doc":"Convenience method to set cookies, see `HTTP::Cookies`.","summary":"<p>Convenience method to set cookies, see <code><a href=\"../../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L72","def":{"name":"cookies","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@cookies || (@cookies = HTTP::Cookies.new)"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes the output. This method must be implemented if wrapping the response output.","summary":"<p>Flushes the output.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L97","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@output.flush"}},{"id":"headers:HTTP::Headers-instance-method","html_id":"headers:HTTP::Headers-instance-method","name":"headers","doc":"The response headers (`HTTP::Headers`). These must be set before writing to the response.","summary":"<p>The response headers (<code><a href=\"../../HTTP/Headers.html\">HTTP::Headers</a></code>).</p>","abstract":false,"args":[],"args_string":" : HTTP::Headers","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L17","def":{"name":"headers","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"HTTP::Headers","visibility":"Public","body":"@headers"}},{"id":"output:IO-instance-method","html_id":"output:IO-instance-method","name":"output","doc":"The `IO` to which output is written. This can be changed/wrapped to filter\nthe response body (for example to compress the output).","summary":"<p>The <code><a href=\"../../IO.html\">IO</a></code> to which output is written.</p>","abstract":false,"args":[],"args_string":" : IO","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L24","def":{"name":"output","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IO","visibility":"Public","body":"@output"}},{"id":"output=(output:IO)-instance-method","html_id":"output=(output:IO)-instance-method","name":"output=","doc":"The `IO` to which output is written. This can be changed/wrapped to filter\nthe response body (for example to compress the output).","summary":"<p>The <code><a href=\"../../IO.html\">IO</a></code> to which output is written.</p>","abstract":false,"args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"}],"args_string":"(output : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L24","def":{"name":"output=","args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@output = output"}},{"id":"respond_with_error(message=&quot;InternalServerError&quot;,code=500)-instance-method","html_id":"respond_with_error(message=&amp;quot;InternalServerError&amp;quot;,code=500)-instance-method","name":"respond_with_error","doc":"Generates an error response using *message* and *code*.\n\nCalls `reset` and then writes the given message.","summary":"<p>Generates an error response using <em>message</em> and <em>code</em>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Internal Server Error\"","external_name":"message","restriction":""},{"name":"code","doc":null,"default_value":"500","external_name":"code","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Internal Server Error&quot;</span>, code = <span class=\"n\">500</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L110","def":{"name":"respond_with_error","args":[{"name":"message","doc":null,"default_value":"\"Internal Server Error\"","external_name":"message","restriction":""},{"name":"code","doc":null,"default_value":"500","external_name":"code","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reset\n@status_code = code\nself.content_type = \"text/plain\"\n(((self << code) << ' ') << message) << '\\n'\nflush\n"}},{"id":"status_code:Int32-instance-method","html_id":"status_code:Int32-instance-method","name":"status_code","doc":"The status code of this response, which must be set before writing the response\nbody. If not set, the default value is 200 (OK).","summary":"<p>The status code of this response, which must be set before writing the response body.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L31","def":{"name":"status_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@status_code"}},{"id":"status_code=(status_code:Int32)-instance-method","html_id":"status_code=(status_code:Int32)-instance-method","name":"status_code=","doc":"The status code of this response, which must be set before writing the response\nbody. If not set, the default value is 200 (OK).","summary":"<p>The status code of this response, which must be set before writing the response body.</p>","abstract":false,"args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":"Int32"}],"args_string":"(status_code : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L31","def":{"name":"status_code=","args":[{"name":"status_code","doc":null,"default_value":"","external_name":"status_code","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@status_code = status_code"}},{"id":"upgrade(&block)-instance-method","html_id":"upgrade(&amp;block)-instance-method","name":"upgrade","doc":"Upgrades this response, writing headers and yieling the connection `IO` (a socket) to the given block.\nThe block must invoke `close` afterwards, the server won't do it in this case.\nThis is useful to implement protocol upgrades, such as websockets.","summary":"<p>Upgrades this response, writing headers and yieling the connection <code><a href=\"../../IO.html\">IO</a></code> (a socket) to the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L84","def":{"name":"upgrade","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@upgraded = true\nwrite_headers\nflush\nyield @io\n"}},{"id":"version:String-instance-method","html_id":"version:String-instance-method","name":"version","doc":"The version of the HTTP::Request that created this response.","summary":"<p>The version of the HTTP::Request that created this response.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L20","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@version"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"See `IO#write(slice)`.","summary":"<p>See <code><a href=\"../../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/response.cr#L65","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if slice.empty?\n  return\nend\n@output.write(slice)\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler","path":"HTTP/StaticFileHandler.html","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/static_file_handler.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A simple handler that lists directories and serves files under a given public directory.","summary":"<p>A simple handler that lists directories and serves files under a given public directory.</p>","class_methods":[],"constructors":[{"id":"new(public_dir:String,fallthrough=true,directory_listing=true)-class-method","html_id":"new(public_dir:String,fallthrough=true,directory_listing=true)-class-method","name":"new","doc":"Creates a handler that will serve files in the given *public_dir*, after\nexpanding it (using `File#expand_path`).\n\nIf *fallthrough* is `false`, this handler does not call next handler when\nrequest method is neither GET or HEAD, then serves `405 Method Not Allowed`.\nOtherwise, it calls next handler.\n\nIf *directory_listing* is `false`, directory listing is disabled. This means that\npaths matching directories are ignored and next handler is called.","summary":"<p>Creates a handler that will serve files in the given <em>public_dir</em>, after expanding it (using <code><a href=\"../File.html#expand_path%28path%2Cdir%3Dnil%29%3AString-class-method\">File#expand_path</a></code>).</p>","abstract":false,"args":[{"name":"public_dir","doc":null,"default_value":"","external_name":"public_dir","restriction":"String"},{"name":"fallthrough","doc":null,"default_value":"true","external_name":"fallthrough","restriction":""},{"name":"directory_listing","doc":null,"default_value":"true","external_name":"directory_listing","restriction":""}],"args_string":"(public_dir : String, fallthrough = <span class=\"n\">true</span>, directory_listing = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L20","def":{"name":"new","args":[{"name":"public_dir","doc":null,"default_value":"","external_name":"public_dir","restriction":"String"},{"name":"fallthrough","doc":null,"default_value":"true","external_name":"fallthrough","restriction":""},{"name":"directory_listing","doc":null,"default_value":"true","external_name":"directory_listing","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(public_dir, fallthrough, directory_listing)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"call(context)-instance-method","html_id":"call(context)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L26","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if {\"GET\", \"HEAD\"}.includes?(context.request.method)\nelse\n  if @fallthrough\n    call_next(context)\n  else\n    context.response.status_code = 405\n    context.response.headers.add(\"Allow\", \"GET, HEAD\")\n  end\n  return\nend\noriginal_path = context.request.path.not_nil!\nis_dir_path = original_path.ends_with?(\"/\")\nrequest_path = self.request_path(URI.unescape(original_path))\nif request_path.includes?('\\u{0}')\n  context.response.status_code = 400\n  return\nend\nexpanded_path = File.expand_path(request_path, \"/\")\nif is_dir_path && (!(expanded_path.ends_with?(\"/\")))\n  expanded_path = \"#{expanded_path}/\"\nend\nis_dir_path = expanded_path.ends_with?(\"/\")\nfile_path = File.join(@public_dir, expanded_path)\nis_dir = Dir.exists?(file_path)\nis_file = (!is_dir) && (File.exists?(file_path))\nif (request_path != expanded_path) || (is_dir && (!is_dir_path))\n  redirect_to(context, \"#{expanded_path}#{is_dir && (!is_dir_path) ? \"/\" : \"\"}\")\n  return\nend\nif @directory_listing && is_dir\n  context.response.content_type = \"text/html\"\n  directory_listing(context.response, request_path, file_path)\nelse\n  if is_file\n    last_modified = modification_time(file_path)\n    add_cache_headers(context.response.headers, last_modified)\n    if cache_request?(context, last_modified)\n      context.response.status_code = 304\n      return\n    end\n    context.response.content_type = mime_type(file_path)\n    context.response.content_length = File.size(file_path)\n    File.open(file_path) do |file|\n      IO.copy(file, context.response)\n    end\n  else\n    call_next(context)\n  end\nend\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler/DirectoryListing","path":"HTTP/StaticFileHandler/DirectoryListing.html","kind":"struct","full_name":"HTTP::StaticFileHandler::DirectoryListing","name":"DirectoryListing","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/static_file_handler.cr","line_number":139,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(request_path:String,path:String)-class-method","html_id":"new(request_path:String,path:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"request_path","doc":null,"default_value":"","external_name":"request_path","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(request_path : String, path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","def":{"name":"new","args":[{"name":"request_path","doc":null,"default_value":"","external_name":"request_path","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(request_path, path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DirectoryListing.new(@request_path.clone, @path.clone)"}},{"id":"copy_with(request_path_request_path=@request_path,path_path=@path)-instance-method","html_id":"copy_with(request_path_request_path=@request_path,path_path=@path)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_request_path","doc":null,"default_value":"@request_path","external_name":"request_path","restriction":""},{"name":"_path","doc":null,"default_value":"@path","external_name":"path","restriction":""}],"args_string":"(request_path _request_path = @request_path, path _path = @path)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L139","def":{"name":"copy_with","args":[{"name":"_request_path","doc":null,"default_value":"@request_path","external_name":"request_path","restriction":""},{"name":"_path","doc":null,"default_value":"@path","external_name":"path","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DirectoryListing.new(_request_path, _path)"}},{"id":"escaped_request_path-instance-method","html_id":"escaped_request_path-instance-method","name":"escaped_request_path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L142","def":{"name":"escaped_request_path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@escaped_request_path || (@escaped_request_path = ((esc_path = URI.escape(request_path) do |b|\n  (URI.unreserved?(b)) || (b != '/')\nend\nesc_path = esc_path.chomp('/')\nesc_path)))"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":null,"source_link":null,"def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}},{"id":"request_path:String-instance-method","html_id":"request_path:String-instance-method","name":"request_path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":null,"source_link":null,"def":{"name":"request_path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@request_path"}},{"id":"to_s(__io__)-instance-method","html_id":"to_s(__io__)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"__io__","doc":null,"default_value":"","external_name":"__io__","restriction":""}],"args_string":"(__io__)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/static_file_handler.cr#L150","def":{"name":"to_s","args":[{"name":"__io__","doc":null,"default_value":"","external_name":"__io__","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ECR.embed(\"/crystal/src/http/server/handlers/static_file_handler.html\", \"__io__\")"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocket","path":"HTTP/WebSocket.html","kind":"class","full_name":"HTTP::WebSocket","name":"WebSocket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/web_socket.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(host:String,path:String,port=nil,tls=false,headers=HTTP::Headers.new)-class-method","html_id":"new(host:String,path:String,port=nil,tls=false,headers=HTTP::Headers.new)-class-method","name":"new","doc":"Opens a new websocket to the target host. This will also handle the handshake\nand will raise an exception if the handshake did not complete successfully.\n\n```\nHTTP::WebSocket.new(\"websocket.example.com\", \"/chat\")            # Creates a new WebSocket to `websocket.example.com`\nHTTP::WebSocket.new(\"websocket.example.com\", \"/chat\", tls: true) # Creates a new WebSocket with TLS to `ẁebsocket.example.com`\n```","summary":"<p>Opens a new websocket to the target host.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":""},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"args_string":"(host : String, path : String, port = <span class=\"n\">nil</span>, tls = <span class=\"n\">false</span>, headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L40","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"tls","doc":null,"default_value":"false","external_name":"tls","restriction":""},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(Protocol.new(host, path, port, tls, headers))"}},{"id":"new(uri:URI|String,headers=HTTP::Headers.new)-class-method","html_id":"new(uri:URI|String,headers=HTTP::Headers.new)-class-method","name":"new","doc":"Opens a new websocket using the information provided by the URI. This will also handle the handshake\nand will raise an exception if the handshake did not complete successfully. This method will also raise\nan exception if the URI is missing the host and/or the path.\n\nPlease note that the scheme will only be used to identify if TLS should be used or not. Therefore, schemes\napart from `wss` and `https` will be treated as the default which is `ws`.\n\n```\nHTTP::WebSocket.new(URI.parse(\"ws://websocket.example.com/chat\"))        # Creates a new WebSocket to `websocket.example.com`\nHTTP::WebSocket.new(URI.parse(\"wss://websocket.example.com/chat\"))       # Creates a new WebSocket with TLS to `websocket.example.com`\nHTTP::WebSocket.new(URI.parse(\"http://websocket.example.com:8080/chat\")) # Creates a new WebSocket to `websocket.example.com` on port `8080`\nHTTP::WebSocket.new(URI.parse(\"ws://websocket.example.com/chat\"),        # Creates a new WebSocket to `websocket.example.com` with an Authorization header\n  HTTP::Headers{\"Authorization\" => \"Bearer authtoken\"})\n```","summary":"<p>Opens a new websocket using the information provided by the URI.</p>","abstract":false,"args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI | String"},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"args_string":"(uri : URI | String, headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L29","def":{"name":"new","args":[{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":"URI | String"},{"name":"headers","doc":null,"default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(Protocol.new(uri, headers: headers))"}}],"instance_methods":[{"id":"close(message=nil)-instance-method","html_id":"close(message=nil)-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L93","def":{"name":"close","args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if closed?\n  return\nend\n@closed = true\n@ws.close(message)\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L2","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"on_binary(&on_binary:Bytes->)-instance-method","html_id":"on_binary(&amp;on_binary:Bytes-&gt;)-instance-method","name":"on_binary","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&on_binary : Bytes -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L53","def":{"name":"on_binary","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"on_binary","doc":null,"default_value":"","external_name":"on_binary","restriction":"(Bytes -> )"},"return_type":"","visibility":"Public","body":"@on_binary = on_binary"}},{"id":"on_close(&on_close:String->)-instance-method","html_id":"on_close(&amp;on_close:String-&gt;)-instance-method","name":"on_close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&on_close : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L56","def":{"name":"on_close","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"on_close","doc":null,"default_value":"","external_name":"on_close","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@on_close = on_close"}},{"id":"on_message(&on_message:String->)-instance-method","html_id":"on_message(&amp;on_message:String-&gt;)-instance-method","name":"on_message","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&on_message : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L50","def":{"name":"on_message","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"on_message","doc":null,"default_value":"","external_name":"on_message","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@on_message = on_message"}},{"id":"on_ping(&on_ping:String->)-instance-method","html_id":"on_ping(&amp;on_ping:String-&gt;)-instance-method","name":"on_ping","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&on_ping : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L44","def":{"name":"on_ping","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"on_ping","doc":null,"default_value":"","external_name":"on_ping","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@on_ping = on_ping"}},{"id":"on_pong(&on_pong:String->)-instance-method","html_id":"on_pong(&amp;on_pong:String-&gt;)-instance-method","name":"on_pong","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&on_pong : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L47","def":{"name":"on_pong","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"on_pong","doc":null,"default_value":"","external_name":"on_pong","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@on_pong = on_pong"}},{"id":"ping(message=nil)-instance-method","html_id":"ping(message=nil)-instance-method","name":"ping","doc":"It's possible to send a PING frame, which the client must respond to\nwith a PONG, or the server can send an unsolicited PONG frame\nwhich the client should not respond to.\n\nSee `#pong`.","summary":"<p>It's possible to send a PING frame, which the client must respond to with a PONG, or the server can send an unsolicited PONG frame which the client should not respond to.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L73","def":{"name":"ping","args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\n@ws.ping(message)\n"}},{"id":"pong(message=nil)-instance-method","html_id":"pong(message=nil)-instance-method","name":"pong","doc":"Server can send an unsolicited PONG frame which the client should not respond to.\n\nSee `#ping`.","summary":"<p>Server can send an unsolicited PONG frame which the client should not respond to.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L81","def":{"name":"pong","args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\n@ws.pong(message)\n"}},{"id":"run-instance-method","html_id":"run-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L99","def":{"name":"run","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"loop do\n  begin\n    info = @ws.receive(@buffer)\n  rescue IO::EOFError\n    @on_close.try(&.call(\"\"))\n    break\n  end\n  case info.opcode\n  when Protocol::Opcode::PING\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      message = @current_message.to_s\n      @on_ping.try(&.call(message))\n      if closed?\n      else\n        pong(message)\n      end\n      @current_message.clear\n    end\n  when Protocol::Opcode::PONG\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_pong.try(&.call(@current_message.to_s))\n      @current_message.clear\n    end\n  when Protocol::Opcode::TEXT\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_message.try(&.call(@current_message.to_s))\n      @current_message.clear\n    end\n  when Protocol::Opcode::BINARY\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_binary.try(&.call(@current_message.to_slice))\n      @current_message.clear\n    end\n  when Protocol::Opcode::CLOSE\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      message = @current_message.to_s\n      @on_close.try(&.call(message))\n      if closed?\n      else\n        close(message)\n      end\n      @current_message.clear\n      break\n    end\n  end\nend"}},{"id":"send(message)-instance-method","html_id":"send(message)-instance-method","name":"send","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"args_string":"(message)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L63","def":{"name":"send","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\n@ws.send(message)\n"}},{"id":"stream(binary=true,frame_size=1024,&block)-instance-method","html_id":"stream(binary=true,frame_size=1024,&amp;block)-instance-method","name":"stream","doc":null,"summary":null,"abstract":false,"args":[{"name":"binary","doc":null,"default_value":"true","external_name":"binary","restriction":""},{"name":"frame_size","doc":null,"default_value":"1024","external_name":"frame_size","restriction":""}],"args_string":"(binary = <span class=\"n\">true</span>, frame_size = <span class=\"n\">1024</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/web_socket.cr#L86","def":{"name":"stream","args":[{"name":"binary","doc":null,"default_value":"true","external_name":"binary","restriction":""},{"name":"frame_size","doc":null,"default_value":"1024","external_name":"frame_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\n@ws.stream(binary: binary, frame_size: frame_size) do |io|\n  yield io\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocketHandler","path":"HTTP/WebSocketHandler.html","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"http/server/handlers/websocket_handler.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/websocket_handler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(&proc:WebSocket,Server::Context->)-class-method","html_id":"new(&amp;proc:WebSocket,Server::Context-&gt;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&proc : WebSocket, Server::Context -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/websocket_handler.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/websocket_handler.cr#L13","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"proc","doc":null,"default_value":"","external_name":"proc","restriction":"(WebSocket, Server::Context -> )"},"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(&proc) do |_arg0, _arg1|\n  yield _arg0, _arg1\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"call(context)-instance-method","html_id":"call(context)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/websocket_handler.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/http/server/handlers/websocket_handler.cr#L16","def":{"name":"call","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if websocket_upgrade_request?(context.request)\n  response = context.response\n  version = context.request.headers[\"Sec-WebSocket-Version\"]?\n  if version == WebSocket::Protocol::VERSION\n  else\n    response.status_code = 426\n    response.headers[\"Sec-WebSocket-Version\"] = WebSocket::Protocol::VERSION\n    return\n  end\n  key = context.request.headers[\"Sec-WebSocket-Key\"]?\n  if key\n  else\n    response.status_code = 400\n    return\n  end\n  accept_code = WebSocket::Protocol.key_challenge(key)\n  response.status_code = 101\n  response.headers[\"Upgrade\"] = \"websocket\"\n  response.headers[\"Connection\"] = \"Upgrade\"\n  response.headers[\"Sec-WebSocket-Accept\"] = accept_code\n  response.upgrade do |io|\n    ws_session = WebSocket.new(io)\n    @proc.call(ws_session, context)\n    ws_session.run\n    io.close\n  end\nelse\n  call_next(context)\nend"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Indexable","path":"Indexable.html","kind":"module","full_name":"Indexable(T)","name":"Indexable","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"locations":[{"filename":"indexable.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"github.com/crystal-lang/crystal/BitArray","kind":"struct","full_name":"BitArray","name":"BitArray"},{"html_id":"github.com/crystal-lang/crystal/Deque","kind":"class","full_name":"Deque(T)","name":"Deque"},{"html_id":"github.com/crystal-lang/crystal/Slice","kind":"struct","full_name":"Slice(T)","name":"Slice"},{"html_id":"github.com/crystal-lang/crystal/StaticArray","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray"},{"html_id":"github.com/crystal-lang/crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"}],"namespace":null,"doc":"A container that allows accessing elements via a numeric index.\n\nIndexing starts at `0`. A negative index is assumed to be\nrelative to the end of the container: `-1` indicates the last element,\n`-2` is the next to last element, and so on.\n\nTypes including this module are typically `Array`-like types.","summary":"<p>A container that allows accessing elements via a numeric index.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"[](index:Int)-instance-method","html_id":"[](index:Int)-instance-method","name":"[]","doc":"Returns the element at the given *index*.\n\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to access an element outside the array's range.\n\n```\nary = ['a', 'b', 'c']\nary[0]  # => 'a'\nary[2]  # => 'c'\nary[-1] # => 'c'\nary[-2] # => 'b'\n\nary[3]  # raises IndexError\nary[-4] # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L72","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index)"}},{"id":"[]?(index:Int)-instance-method","html_id":"[]?(index:Int)-instance-method","name":"[]?","doc":"Returns the element at the given *index*.\n\nNegative indices can be used to start counting from the end of the array.\nReturns `nil` if trying to access an element outside the array's range.\n\n```\nary = ['a', 'b', 'c']\nary[0]?  # => 'a'\nary[2]?  # => 'c'\nary[-1]? # => 'c'\nary[-2]? # => 'b'\n\nary[3]?  # nil\nary[-4]? # nil\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L92","def":{"name":"[]?","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  nil\nend"}},{"id":"at(index:Int,&block)-instance-method","html_id":"at(index:Int,&amp;block)-instance-method","name":"at","doc":"Returns the element at the given *index*, if in bounds,\notherwise executes the given block and returns its value.\n\n```\na = [:foo, :bar]\na.at(0) { :baz } # => :foo\na.at(2) { :baz } # => :baz\n```","summary":"<p>Returns the element at the given <em>index</em>, if in bounds, otherwise executes the given block and returns its value.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L36","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index) do\n  return yield\nend\nunsafe_at(index)\n"}},{"id":"at(index:Int)-instance-method","html_id":"at(index:Int)-instance-method","name":"at","doc":"Returns the element at the given *index*, if in bounds,\notherwise raises `IndexError`.\n\n```\na = [:foo, :bar]\na.at(0) # => :foo\na.at(2) # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em>, if in bounds, otherwise raises <code><a href=\"IndexError.html\">IndexError</a></code>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L52","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  raise(IndexError.new)\nend"}},{"id":"bsearch(&block)-instance-method","html_id":"bsearch(&amp;block)-instance-method","name":"bsearch","doc":"By using binary search, returns the first element\nfor which the passed block returns `true`.\n\nIf the block returns `false`, the finding element exists\nbehind. If the block returns `true`, the finding element\nis itself or exists infront.\n\nBinary search needs sorted array, so `self` has to be sorted.\n\nReturns `nil` if the block didn't return `true` for any element.\n\n```\n[2, 5, 7, 10].bsearch { |x| x >= 4 } # => 5\n[2, 5, 7, 10].bsearch { |x| x > 10 } # => nil\n```","summary":"<p>By using binary search, returns the first element for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L111","def":{"name":"bsearch","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"bsearch_index do |value|\n  yield value\nend.try do |index|\n  unsafe_at(index)\nend"}},{"id":"bsearch_index(&block)-instance-method","html_id":"bsearch_index(&amp;block)-instance-method","name":"bsearch_index","doc":"By using binary search, returns the index of the first element\nfor which the passed block returns `true`.\n\nIf the block returns `false`, the finding element exists\nbehind. If the block returns `true`, the finding element\nis itself or exists infront.\n\nBinary search needs sorted array, so `self` has to be sorted.\n\nReturns `nil` if the block didn't return `true` for any element.\n\n```\n[2, 5, 7, 10].bsearch_index { |x, i| x >= 4 } # => 1\n[2, 5, 7, 10].bsearch_index { |x, i| x > 10 } # => nil\n```","summary":"<p>By using binary search, returns the index of the first element for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L130","def":{"name":"bsearch_index","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"(0...size).bsearch do |index|\n  yield unsafe_at(index), index\nend"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":"Calls the given block once for each element in `self`, passing that\nelement as a parameter.\n\n```\na = [\"a\", \"b\", \"c\"]\na.each { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\na -- b -- c --\n```","summary":"<p>Calls the given block once for each element in <code>self</code>, passing that element as a parameter.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L147","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_index do |i|\n  yield unsafe_at(i)\nend"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Returns an `Iterator` for the elements of `self`.\n\n```\na = [\"a\", \"b\", \"c\"]\niter = a.each\niter.next # => \"a\"\niter.next # => \"b\"\n```\n\nThe returned iterator keeps a reference to `self`: if the array\nchanges, the returned values of the iterator change as well.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the elements of <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L164","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ItemIterator(self, T).new(self)"}},{"id":"each(*,start:Int,count:Int,&block)-instance-method","html_id":"each(*,start:Int,count:Int,&amp;block)-instance-method","name":"each","doc":"Calls the given block once for `count` number of elements in `self`\nstarting from index `start`, passing each element as a parameter.\n\nNegative indices count backward from the end of the array. (-1 is the\nlast element).\n\nRaises `IndexError` if the starting index is out of range.\nRaises `ArgumentError` if `count` is a negative number.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each(start: 1, count: 3) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\nb -- c -- d --\n```","summary":"<p>Calls the given block once for <code>count</code> number of elements in <code>self</code> starting from index <code>start</code>, passing each element as a parameter.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(*, start : Int, count : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L187","def":{"name":"each","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_index(start: start, count: count) do |i|\n  yield unsafe_at(i)\nend"}},{"id":"each(*,withinrange:Range(Int,Int),&block)-instance-method","html_id":"each(*,withinrange:Range(Int,Int),&amp;block)-instance-method","name":"each","doc":"Calls the given block once for all elements at indices within the given\n`range`, passing each element as a parameter.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each(within: 1..3) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\nb -- c -- d --\n```","summary":"<p>Calls the given block once for all elements at indices within the given <code>range</code>, passing each element as a parameter.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"range","doc":null,"default_value":"","external_name":"within","restriction":"Range(Int, Int)"}],"args_string":"(*, within range : Range(Int, Int), &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L208","def":{"name":"each","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"range","doc":null,"default_value":"","external_name":"within","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"start, count = Indexable.range_to_index_and_count(range, size)\neach(start: start, count: count) do |element|\n  yield element\nend\n"}},{"id":"each_index(*,start:Int,count:Int,&block)-instance-method","html_id":"each_index(*,start:Int,count:Int,&amp;block)-instance-method","name":"each_index","doc":"Calls the given block once for `count` number of indices in `self`\nstarting from index `start`, passing each index as a parameter.\n\nNegative indices count backward from the end of the array. (-1 is the\nlast element).\n\nRaises `IndexError` if the starting index is out of range.\nRaises `ArgumentError` if `count` is a negative number.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each_index(start: -3, count: 2) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\n2 -- 3 --\n```","summary":"<p>Calls the given block once for <code>count</code> number of indices in <code>self</code> starting from index <code>start</code>, passing each index as a parameter.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(*, start : Int, count : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L268","def":{"name":"each_index","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"negative count: #{count}\"))\nend\nif start < 0\n  start = start + size\nend\nif 0 <= start && start <= size\nelse\n  raise(IndexError.new)\nend\ni = start\nwhile i < (Math.min(start + count, size))\n  yield i\n  i = i + 1\nend\nself\n"}},{"id":"each_index(&block):Nil-instance-method","html_id":"each_index(&amp;block):Nil-instance-method","name":"each_index","doc":"Calls the given block once for each index in `self`, passing that\nindex as a parameter.\n\n```\na = [\"a\", \"b\", \"c\"]\na.each_index { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\n0 -- 1 -- 2 --\n```","summary":"<p>Calls the given block once for each index in <code>self</code>, passing that index as a parameter.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L226","def":{"name":"each_index","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"i = 0\nwhile i < size\n  yield i\n  i = i + 1\nend\n"}},{"id":"each_index-instance-method","html_id":"each_index-instance-method","name":"each_index","doc":"Returns an `Iterator` for each index in `self`.\n\n```\na = [\"a\", \"b\", \"c\"]\niter = a.each_index\niter.next # => 0\niter.next # => 1\n```\n\nThe returned iterator keeps a reference to `self`. If the array\nchanges, the returned values of the iterator will change as well.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for each index in <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L245","def":{"name":"each_index","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"IndexIterator.new(self)"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L301","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size == 0"}},{"id":"equals?(other,&block)-instance-method","html_id":"equals?(other,&amp;block)-instance-method","name":"equals?","doc":"Determines if `self` equals *other* according to a comparison\ndone by the given block.\n\nIf `self`'s size is the same as *other*'s size, this method yields\nelements from `self` and *other* in tandem: if the block returns true\nfor all of them, this method returns `true`. Otherwise it returns `false`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"ab\", \"abc\"]\na.equals?(b) { |x, y| x == y.size } # => true\na.equals?(b) { |x, y| x == y }      # => false\n```","summary":"<p>Determines if <code>self</code> equals <em>other</em> according to a comparison done by the given block.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L327","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L327","def":{"name":"equals?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"if size != other.size\n  return false\nend\neach_with_index do |item, i|\n  if yield item, other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"equals?(other:Indexable,&block)-instance-method","html_id":"equals?(other:Indexable,&amp;block)-instance-method","name":"equals?","doc":"Optimized version of `equals?` used when `other` is also an `Indexable`.","summary":"<p>Optimized version of <code><a href=\"Indexable.html#equals%3F%28other%2C%26block%29-instance-method\">#equals?</a></code> used when <code>other</code> is also an <code><a href=\"Indexable.html\">Indexable</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable"}],"args_string":"(other : Indexable, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L306","def":{"name":"equals?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"if size != other.size\n  return false\nend\neach_with_index do |item, i|\n  if yield item, other.unsafe_at(i)\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"first(&block)-instance-method","html_id":"first(&amp;block)-instance-method","name":"first","doc":"Returns the first element of `self` if it's not empty, or the given block's value.\n\n```\n([1, 2, 3]).first { 4 }   # => 1\n([] of Int32).first { 4 } # => 4\n```","summary":"<p>Returns the first element of <code>self</code> if it's not empty, or the given block's value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L351","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L351","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"size == 0 ? yield : unsafe_at(0)"}},{"id":"first-instance-method","html_id":"first-instance-method","name":"first","doc":"Returns the first element of `self` if it's not empty, or raises `IndexError`.\n\n```\n([1, 2, 3]).first   # => 1\n([] of Int32).first # raises IndexError\n```","summary":"<p>Returns the first element of <code>self</code> if it's not empty, or raises <code><a href=\"IndexError.html\">IndexError</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L341","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"first do\n  raise(IndexError.new)\nend"}},{"id":"first?-instance-method","html_id":"first?-instance-method","name":"first?","doc":"Returns the first element of `self` if it's not empty, or `nil`.\n\n```\n([1, 2, 3]).first?   # => 1\n([] of Int32).first? # => nil\n```","summary":"<p>Returns the first element of <code>self</code> if it's not empty, or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L361","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L361","def":{"name":"first?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"first do\n  nil\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L366","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = size.hash(hasher)\neach do |elem|\n  hasher = elem.hash(hasher)\nend\nhasher\n"}},{"id":"index(object,offset:Int=0)-instance-method","html_id":"index(object,offset:Int=0)-instance-method","name":"index","doc":"Returns the index of the first appearance of *value* in `self`\nstarting from the given *offset*, or `nil` if the value is not in `self`.\n\n```\n[1, 2, 3, 1, 2, 3].index(2, offset: 2) # => 4\n```","summary":"<p>Returns the index of the first appearance of <em>value</em> in <code>self</code> starting from the given <em>offset</em>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(object, offset : Int = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L380","def":{"name":"index","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index(offset) do |e|\n  e == object\nend"}},{"id":"index(offset:Int=0,&block)-instance-method","html_id":"index(offset:Int=0,&amp;block)-instance-method","name":"index","doc":"Returns the index of the first object in `self` for which the block\nreturns `true`, starting from the given *offset*, or `nil` if no match\nis found.\n\n```\n[1, 2, 3, 1, 2, 3].index(offset: 2) { |x| x < 2 } # => 3\n```","summary":"<p>Returns the index of the first object in <code>self</code> for which the block returns <code>true</code>, starting from the given <em>offset</em>, or <code>nil</code> if no match is found.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = <span class=\"n\">0</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L391","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L391","def":{"name":"index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\noffset.upto(size - 1) do |i|\n  if yield unsafe_at(i)\n    return i\n  end\nend\nnil\n"}},{"id":"last(&block)-instance-method","html_id":"last(&amp;block)-instance-method","name":"last","doc":"Returns the last element of `self` if it's not empty, or the given block's value.\n\n```\n([1, 2, 3]).last { 4 }   # => 3\n([] of Int32).last { 4 } # => 4\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or the given block's value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L419","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L419","def":{"name":"last","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"size == 0 ? yield : unsafe_at(size - 1)"}},{"id":"last-instance-method","html_id":"last-instance-method","name":"last","doc":"Returns the last element of `self` if it's not empty, or raises `IndexError`.\n\n```\n([1, 2, 3]).last   # => 3\n([] of Int32).last # raises IndexError\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or raises <code><a href=\"IndexError.html\">IndexError</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L409","def":{"name":"last","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"last do\n  raise(IndexError.new)\nend"}},{"id":"last?-instance-method","html_id":"last?-instance-method","name":"last?","doc":"Returns the last element of `self` if it's not empty, or `nil`.\n\n```\n([1, 2, 3]).last?   # => 3\n([] of Int32).last? # => nil\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L429","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L429","def":{"name":"last?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"last do\n  nil\nend"}},{"id":"reverse_each(&block):Nil-instance-method","html_id":"reverse_each(&amp;block):Nil-instance-method","name":"reverse_each","doc":"Same as `#each`, but works in reverse.","summary":"<p>Same as <code><a href=\"Indexable.html#each%28%26block%29-instance-method\">#each</a></code>, but works in reverse.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L434","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L434","def":{"name":"reverse_each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"(size - 1).downto(0) do |i|\n  yield unsafe_at(i)\nend"}},{"id":"reverse_each-instance-method","html_id":"reverse_each-instance-method","name":"reverse_each","doc":"Returns an `Iterator` over the elements of `self` in reverse order.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of <code>self</code> in reverse order.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L441","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L441","def":{"name":"reverse_each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ReverseItemIterator(self, T).new(self)"}},{"id":"rindex(value,offset=size-1)-instance-method","html_id":"rindex(value,offset=size-1)-instance-method","name":"rindex","doc":"Returns the index of the last appearance of *value* in `self`, or\n`nil` if the value is not in `self`.\n\nIf *offset* is given, it defines the position to _end_ the search\n(elements beyond this point are ignored).\n\n```\n[1, 2, 3, 2, 3].rindex(2)            # => 3\n[1, 2, 3, 2, 3].rindex(2, offset: 2) # => 1\n```","summary":"<p>Returns the index of the last appearance of <em>value</em> in <code>self</code>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(value, offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L455","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L455","def":{"name":"rindex","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"rindex(offset) do |elem|\n  elem == value\nend"}},{"id":"rindex(offset=size-1,&block)-instance-method","html_id":"rindex(offset=size-1,&amp;block)-instance-method","name":"rindex","doc":"Returns the index of the first object in `self` for which the block\nreturns `true`, starting from the last object, or `nil` if no match\nis found.\n\nIf *offset* is given, the search starts from that index towards the\nfirst elements in `self`.\n\n```\n[1, 2, 3, 2, 3].rindex { |x| x < 3 }            # => 3\n[1, 2, 3, 2, 3].rindex(offset: 2) { |x| x < 3 } # => 1\n```","summary":"<p>Returns the index of the first object in <code>self</code> for which the block returns <code>true</code>, starting from the last object, or <code>nil</code> if no match is found.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L470","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L470","def":{"name":"rindex","args":[{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset >= size\n  return nil\nend\noffset.downto(0) do |i|\n  if yield unsafe_at(i)\n    return i\n  end\nend\nnil\n"}},{"id":"sample(random=Random::DEFAULT)-instance-method","html_id":"sample(random=Random::DEFAULT)-instance-method","name":"sample","doc":"Returns a random element from `self`, using the given *random* number generator.\nRaises `IndexError` if `self` is empty.\n\n```\na = [1, 2, 3]\na.sample                # => 2\na.sample                # => 1\na.sample(Random.new(1)) # => 3\n```","summary":"<p>Returns a random element from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L491","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L491","def":{"name":"sample","args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == 0\n  raise(IndexError.new)\nend\nunsafe_at(random.rand(size))\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this container.","summary":"<p>Returns the number of elements in this container.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L13","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L289","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(T).new(size)\neach do |e|\n  ary << e\nend\nary\n"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":true,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L26","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"values_at(*indexes:Int)-instance-method","html_id":"values_at(*indexes:Int)-instance-method","name":"values_at","doc":"Returns a `Tuple` populated with the elements at the given indexes.\nRaises `IndexError` if any index is invalid.\n\n```\n[\"a\", \"b\", \"c\", \"d\"].values_at(0, 2) # => {\"a\", \"c\"}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> populated with the elements at the given indexes.</p>","abstract":false,"args":[{"name":"indexes","doc":null,"default_value":"","external_name":"indexes","restriction":"Int"}],"args_string":"(*indexes : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L502","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L502","def":{"name":"values_at","args":[{"name":"indexes","doc":null,"default_value":"","external_name":"indexes","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indexes.map do |index|\n  self[index]\nend"}},{"id":"zip(other:Indexable(U),&block:T,U->)forallU-instance-method","html_id":"zip(other:Indexable(U),&amp;block:T,U-&gt;)forallU-instance-method","name":"zip","doc":"Calls the given block for each index in `self`, passing in the elements\n`{self[i], other[i]}` for each index.\n\nRaises an `IndexError` if `other` is shorter than `self`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\", \"c\"]\n\na.zip(b) { |x, y| puts \"#{x} -- #{y}\" }\n```\n\nThe above produces:\n\n```text\n1 --- a\n2 --- b\n3 --- c\n```","summary":"<p>Calls the given block for each index in <code>self</code>, passing in the elements <code>{self[i], other[i]}</code> for each index.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"args_string":"(other : Indexable(U), &block : T, U -> ) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L525","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L525","def":{"name":"zip","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, U -> )"},"return_type":"","visibility":"Public","body":"each_with_index do |elem, i|\n  yield elem, other[i]\nend"}},{"id":"zip(other:Indexable(U)):Array(Tuple(T,U))forallU-instance-method","html_id":"zip(other:Indexable(U)):Array(Tuple(T,U))forallU-instance-method","name":"zip","doc":"Returns an `Array` of tuples populated with the *i*th indexed element from\n`self` followed by the *i*th indexed element from `other`.\n\nRaises an `IndexError` if `other` is shorter than `self`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\", \"c\"]\n\na.zip(b) # => [{1, \"a\"}, {2, \"b\"}, {3, \"c\"}]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of tuples populated with the <em>i</em>th indexed element from <code>self</code> followed by the <em>i</em>th indexed element from <code>other</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"args_string":"(other : Indexable(U)) : Array(Tuple(T, U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L542","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L542","def":{"name":"zip","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(::Tuple(T, U))","visibility":"Public","body":"pairs = Array(::Tuple(T, U)).new(size)\nzip(other) do |x, y|\n  pairs << {x, y}\nend\npairs\n"}},{"id":"zip?(other:Indexable(U),&block:T,U?->)forallU-instance-method","html_id":"zip?(other:Indexable(U),&amp;block:T,U?-&gt;)forallU-instance-method","name":"zip?","doc":"Calls the given block for each index in `self`, passing in the elements\n`{self[i], other[i]}` for each index.\n\nIf `other` is shorter than `self`, missing values are filled up with `nil`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\"]\n\na.zip?(b) { |x, y| puts \"#{x} -- #{y}\" }\n```\n\nThe above produces:\n\n```text\n1 --- a\n2 --- b\n3 ---\n```","summary":"<p>Calls the given block for each index in <code>self</code>, passing in the elements <code>{self[i], other[i]}</code> for each index.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"args_string":"(other : Indexable(U), &block : T, U? -> ) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L567","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L567","def":{"name":"zip?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, U | ::Nil -> )"},"return_type":"","visibility":"Public","body":"each_with_index do |elem, i|\n  yield elem, other[i]?\nend"}},{"id":"zip?(other:Indexable(U)):Array(Tuple(T,U?))forallU-instance-method","html_id":"zip?(other:Indexable(U)):Array(Tuple(T,U?))forallU-instance-method","name":"zip?","doc":"Returns an `Array` of tuples populated with the *i*th indexed element from\n`self` followed by the *i*th indexed element from `other`.\n\nIf `other` is shorter than `self`, missing values are filled up with `nil`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\"]\n\na.zip?(b) # => [{1, \"a\"}, {2, \"b\"}, {3, nil}]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of tuples populated with the <em>i</em>th indexed element from <code>self</code> followed by the <em>i</em>th indexed element from <code>other</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"args_string":"(other : Indexable(U)) : Array(Tuple(T, U?)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L584","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/indexable.cr#L584","def":{"name":"zip?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(::Tuple(T, U | ::Nil))","visibility":"Public","body":"pairs = Array(::Tuple(T, U | ::Nil)).new(size)\nzip?(other) do |x, y|\n  pairs << {x, y}\nend\npairs\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IndexError","path":"IndexError.html","kind":"class","full_name":"IndexError","name":"IndexError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":78,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when the given index is invalid.\n\n```\na = [:foo, :bar]\na[2] # raises IndexError\n```","summary":"<p>Raised when the given index is invalid.</p>","class_methods":[],"constructors":[{"id":"new(message=&quot;Indexoutofbounds&quot;)-class-method","html_id":"new(message=&amp;quot;Indexoutofbounds&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Index out of bounds\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Index out of bounds&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L79","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Index out of bounds\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/INI","path":"INI.html","kind":"class","full_name":"INI","name":"INI","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"ini.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"build(ini,space:Bool=false):String-class-method","html_id":"build(ini,space:Bool=false):String-class-method","name":"build","doc":"Generates an INI-style configuration from a given hash.\n\n```\nINI.build({\"foo\" => {\"a\" => \"1\"}}, true) # => \"[foo]\\na = 1\\n\\n\"\n```","summary":"<p>Generates an INI-style configuration from a given hash.</p>","abstract":false,"args":[{"name":"ini","doc":null,"default_value":"","external_name":"ini","restriction":""},{"name":"space","doc":null,"default_value":"false","external_name":"space","restriction":"Bool"}],"args_string":"(ini, space : Bool = <span class=\"n\">false</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L64","def":{"name":"build","args":[{"name":"ini","doc":null,"default_value":"","external_name":"ini","restriction":""},{"name":"space","doc":null,"default_value":"false","external_name":"space","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |str|\n  build(str, ini, space)\nend"}},{"id":"build(io:IO,ini,space:Bool=false)-class-method","html_id":"build(io:IO,ini,space:Bool=false)-class-method","name":"build","doc":"Appends INI data to the given IO.","summary":"<p>Appends INI data to the given IO.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"ini","doc":null,"default_value":"","external_name":"ini","restriction":""},{"name":"space","doc":null,"default_value":"false","external_name":"space","restriction":"Bool"}],"args_string":"(io : IO, ini, space : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L69","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"ini","doc":null,"default_value":"","external_name":"ini","restriction":""},{"name":"space","doc":null,"default_value":"false","external_name":"space","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ini.each do |section, contents|\n  ((io << '[') << section) << \"]\\n\"\n  contents.each do |key, value|\n    (((io << key) << (space ? \" = \" : '=')) << value) << '\\n'\n  end\n  io.puts\nend"}},{"id":"parse(str):Hash(String,Hash(String,String))-class-method","html_id":"parse(str):Hash(String,Hash(String,String))-class-method","name":"parse","doc":"Parses INI-style configuration from the given string.\nRaises a `ParseException` on any errors.\n\n```\nINI.parse(\"[foo]\\na = 1\") # => {\"foo\" => {\"a\" => \"1\"}}\n```","summary":"<p>Parses INI-style configuration from the given string.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"args_string":"(str) : Hash(String, Hash(String, String))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L22","def":{"name":"parse","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(String, Hash(String, String))","visibility":"Public","body":"ini = Hash(String, Hash(String, String)).new\ncurrent_section = ini[\"\"] = Hash(String, String).new\nlineno = 0\nstr.each_line do |line|\n  lineno = lineno + 1\n  if line.empty?\n    next\n  end\n  offset = 0\n  line.each_char do |char|\n    if char.ascii_whitespace?\n    else\n      break\n    end\n    offset = offset + 1\n  end\n  case line[offset]\n  when '#', ';'\n    next\n  when '['\n    end_idx = line.index(']', offset)\n    if end_idx\n    else\n      raise(ParseException.new(\"unterminated section\", lineno, line.size))\n    end\n    if end_idx == (line.size - 1)\n    else\n      raise(ParseException.new(\"data after section\", lineno, end_idx + 1))\n    end\n    current_section_name = line[(offset + 1)...end_idx]\n    current_section = (    __temp_79 = current_section_name\n    ini[__temp_79]? || (ini[__temp_79] = Hash(String, String).new)\n)\n  else\n    key, eq, value = line.partition('=')\n    if eq != \"=\"\n      raise(ParseException.new(\"expected declaration\", lineno, key.size))\n    end\n    current_section[key.strip] = value.strip\n  end\nend\nif ini[\"\"].empty?\n  ini.delete(\"\")\nend\nini\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/INI/ParseException","path":"INI/ParseException.html","kind":"class","full_name":"INI::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"ini.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/INI","kind":"class","full_name":"INI","name":"INI"},"doc":"Exception thrown on an INI parse error.","summary":"<p>Exception thrown on an INI parse error.</p>","class_methods":[],"constructors":[{"id":"new(message,line_number,column_number)-class-method","html_id":"new(message,line_number,column_number)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""}],"args_string":"(message, line_number, column_number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L7","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"column_number:Int32-instance-method","html_id":"column_number:Int32-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L5","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column_number"}},{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L4","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}},{"id":"location-instance-method","html_id":"location-instance-method","name":"location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/ini.cr#L11","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{line_number, column_number}"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Int","path":"Int.html","kind":"struct","full_name":"Int","name":"Int","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":58,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"time/span.cr","line_number":396,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr"},{"filename":"time/span.cr","line_number":554,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr"},{"filename":"big/big_int.cr","line_number":480,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr"},{"filename":"big/big_rational.cr","line_number":233,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr"},{"filename":"big/big_decimal.cr","line_number":425,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"},{"filename":"json/to_json.cr","line_number":39,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/BigInt","kind":"struct","full_name":"BigInt","name":"BigInt"},{"html_id":"github.com/crystal-lang/crystal/Int128","kind":"struct","full_name":"Int128","name":"Int128"},{"html_id":"github.com/crystal-lang/crystal/Int16","kind":"struct","full_name":"Int16","name":"Int16"},{"html_id":"github.com/crystal-lang/crystal/Int32","kind":"struct","full_name":"Int32","name":"Int32"},{"html_id":"github.com/crystal-lang/crystal/Int64","kind":"struct","full_name":"Int64","name":"Int64"},{"html_id":"github.com/crystal-lang/crystal/Int8","kind":"struct","full_name":"Int8","name":"Int8"},{"html_id":"github.com/crystal-lang/crystal/UInt128","kind":"struct","full_name":"UInt128","name":"UInt128"},{"html_id":"github.com/crystal-lang/crystal/UInt16","kind":"struct","full_name":"UInt16","name":"UInt16"},{"html_id":"github.com/crystal-lang/crystal/UInt32","kind":"struct","full_name":"UInt32","name":"UInt32"},{"html_id":"github.com/crystal-lang/crystal/UInt64","kind":"struct","full_name":"UInt64","name":"UInt64"},{"html_id":"github.com/crystal-lang/crystal/UInt8","kind":"struct","full_name":"UInt8","name":"UInt8"}],"including_types":[],"namespace":null,"doc":"Int is the base type of all integer types.\n\nThere are four signed integer types: `Int8`, `Int16`, `Int32` and `Int64`,\nbeing able to represent numbers of 8, 16, 32 and 64 bits respectively.\nThere are four unsigned integer types: `UInt8`, `UInt16`, `UInt32` and `UInt64`.\n\nAn integer literal is an optional `+` or `-` sign, followed by\na sequence of digits and underscores, optionally followed by a suffix.\nIf no suffix is present, the literal's type is the lowest between `Int32`, `Int64` and `UInt64`\nin which the number fits:\n\n```\n1 # Int32\n\n1_i8  # Int8\n1_i16 # Int16\n1_i32 # Int32\n1_i64 # Int64\n\n1_u8  # UInt8\n1_u16 # UInt16\n1_u32 # UInt32\n1_u64 # UInt64\n\n+10 # Int32\n-20 # Int32\n\n2147483648          # Int64\n9223372036854775808 # UInt64\n```\n\nThe underscore `_` before the suffix is optional.\n\nUnderscores can be used to make some numbers more readable:\n\n```\n1_000_000 # better than 1000000\n```\n\nBinary numbers start with `0b`:\n\n```\n0b1101 # == 13\n```\n\nOctal numbers start with `0o`:\n\n```\n0o123 # == 83\n```\n\nHexadecimal numbers start with `0x`:\n\n```\n0xFE012D # == 16646445\n0xfe012d # == 16646445\n```","summary":"<p>Int is the base type of all integer types.</p>","class_methods":[],"constructors":[{"id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","html_id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","name":"from_io","doc":"Reads an integer from the given *io* in the given *format*.\n\nSee also: `IO#read_bytes`.","summary":"<p>Reads an integer from the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L499","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L499","def":{"name":"from_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"format.decode(self, io)"}}],"instance_methods":[{"id":"%(other:Int)-instance-method","html_id":"%(other:Int)-instance-method","name":"%","doc":"Returns `self` modulo *other*.\n\nThis uses floored division.\n\nSee `Int#/` for more details.","summary":"<p>Returns <code>self</code> modulo <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L157","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other == 0\n  raise(DivisionByZeroError.new)\nelse\n  if (self ^ other) >= 0\n    self.unsafe_mod(other)\n  else\n    me = self.unsafe_mod(other)\n    me == 0 ? me : me + other\n  end\nend"}},{"id":"%(other:BigInt):BigInt-instance-method","html_id":"%(other:BigInt):BigInt-instance-method","name":"%","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L512","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L512","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"to_big_i % other"}},{"id":"*(other:BigDecimal)-instance-method","html_id":"*(other:BigDecimal)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L445","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L445","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other * self"}},{"id":"*(other:BigInt):BigInt-instance-method","html_id":"*(other:BigInt):BigInt-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L504","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L504","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"other * self"}},{"id":"*(other:BigRational)-instance-method","html_id":"*(other:BigRational)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L257","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L257","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other * self"}},{"id":"**(exponent:Float):Float64-instance-method","html_id":"**(exponent:Float):Float64-instance-method","name":"**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\n```\n2 ** 3.0  # => 8.0\n2 ** 0.0  # => 1.0\n2 ** -1.0 # => 0.5\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"exponent","doc":null,"default_value":"","external_name":"exponent","restriction":"Float"}],"args_string":"(exponent : Float) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L278","def":{"name":"**","args":[{"name":"exponent","doc":null,"default_value":"","external_name":"exponent","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"to_f ** exponent"}},{"id":"**(exponent:Int):self-instance-method","html_id":"**(exponent:Int):self-instance-method","name":"**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\nRaises `ArgumentError` if *exponent* is negative: if this is needed,\neither use a float base or a float exponent.\n\n```\n2 ** 3  # => 8\n2 ** 0  # => 1\n2 ** -1 # ArgumentError\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"exponent","doc":null,"default_value":"","external_name":"exponent","restriction":"Int"}],"args_string":"(exponent : Int) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L256","def":{"name":"**","args":[{"name":"exponent","doc":null,"default_value":"","external_name":"exponent","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"if exponent < 0\n  raise(ArgumentError.new(\"Cannot raise an integer to a negative integer power, use floats for that\"))\nend\nresult = self.class.new(1)\nk = self\nwhile exponent > 0\n  if (exponent & 1) != 0\n    result = result * k\n  end\n  k = k * k\n  exponent = exponent.unsafe_shr(1)\nend\nresult\n"}},{"id":"+(other:BigInt):BigInt-instance-method","html_id":"+(other:BigInt):BigInt-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L487","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L487","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"other + self"}},{"id":"+(other:BigRational)-instance-method","html_id":"+(other:BigRational)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L245","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other + self"}},{"id":"+(other:BigDecimal)-instance-method","html_id":"+(other:BigDecimal)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L437","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L437","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other + self"}},{"id":"-(other:BigDecimal)-instance-method","html_id":"-(other:BigDecimal)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L441","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L441","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_d - other"}},{"id":"-(other:BigRational)-instance-method","html_id":"-(other:BigRational)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L249","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L249","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.to_big_r - other"}},{"id":"-(other:BigInt):BigInt-instance-method","html_id":"-(other:BigInt):BigInt-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L491","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L491","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"if self < 0\n  -(abs + other)\nelse\n  to_big_i - other\nend"}},{"id":"/(other:BigDecimal)-instance-method","html_id":"/(other:BigDecimal)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L449","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_d / other"}},{"id":"/(other:BigRational)-instance-method","html_id":"/(other:BigRational)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L253","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.to_big_r / other"}},{"id":"/(other:Int)-instance-method","html_id":"/(other:Int)-instance-method","name":"/","doc":"Divides `self` by *other* using floored division.\n\nIn floored division, given two integers x and y:\n* q = x / y is rounded toward negative infinity\n* r = x % y has the sign of the second argument\n* x == q*y + r\n\nFor example:\n\n```text\n x     y     x / y     x % y\n 5     3       1         2\n-5     3      -2         1\n 5    -3      -2        -1\n-5    -3       1        -2\n```\n\nRaises if *other* is zero, or if *other* is -1 and\n`self` is signed and is the minimum value for that\ninteger type.","summary":"<p>Divides <code>self</code> by <em>other</em> using floored division.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L101","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_div_argument(other)\ndiv = unsafe_div(other)\nmod = unsafe_mod(other)\nif other > 0 ? mod < 0 : mod > 0\n  div = div - 1\nend\ndiv\n"}},{"id":"/(other:BigInt):BigInt-instance-method","html_id":"/(other:BigInt):BigInt-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L508","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L508","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"to_big_i / other"}},{"id":"<<(count:Int)-instance-method","html_id":"&lt;&lt;(count:Int)-instance-method","name":"<<","doc":"Returns the result of shifting this number's bits *count* positions to the left.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a right shift is performed\n\n```\n8000 << 1  # => 16000\n8000 << 2  # => 32000\n8000 << 32 # => 0\n8000 << -1 # => 4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the left.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L216","def":{"name":"<<","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  self >> count.abs\nelse\n  if count < ((sizeof(self)) * 8)\n    self.unsafe_shl(count)\n  else\n    self.class.zero\n  end\nend"}},{"id":"(other:BigDecimal)-instance-method","html_id":"(other:BigDecimal)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L433","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L433","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigDecimal"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_d <=> other"}},{"id":"(other:BigInt)-instance-method","html_id":"(other:BigInt)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L483","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L483","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"-(other <=> self)"}},{"id":"(other:BigRational)-instance-method","html_id":"(other:BigRational)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L241","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"-(other <=> self)"}},{"id":"===(char:Char)-instance-method","html_id":"===(char:Char)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L282","def":{"name":"===","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self === char.ord"}},{"id":">>(count:Int)-instance-method","html_id":"&gt;&gt;(count:Int)-instance-method","name":">>","doc":"Returns the result of shifting this number's bits *count* positions to the right.\nAlso known as arithmetic right shift.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a left shift is performed\n\n```\n8000 >> 1  # => 4000\n8000 >> 2  # => 2000\n8000 >> 32 # => 0\n8000 >> -1 # => 16000\n\n-8000 >> 1 # => -4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the right.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L195","def":{"name":">>","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if count < 0\n  self << count.abs\nelse\n  if count < ((sizeof(self)) * 8)\n    self.unsafe_shr(count)\n  else\n    self.class.zero\n  end\nend"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L226","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self >= 0 ? self : -self"}},{"id":"bit(bit)-instance-method","html_id":"bit(bit)-instance-method","name":"bit","doc":"Returns this number's *bit*th bit, starting with the least-significant.\n\n```\n11.bit(0) # => 1\n11.bit(1) # => 1\n11.bit(2) # => 0\n11.bit(3) # => 1\n11.bit(4) # => 0\n```","summary":"<p>Returns this number's <em>bit</em>th bit, starting with the least-significant.</p>","abstract":false,"args":[{"name":"bit","doc":null,"default_value":"","external_name":"bit","restriction":""}],"args_string":"(bit)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L295","def":{"name":"bit","args":[{"name":"bit","doc":null,"default_value":"","external_name":"bit","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self >> bit) & 1"}},{"id":"bits_set?(mask)-instance-method","html_id":"bits_set?(mask)-instance-method","name":"bits_set?","doc":"Returns `true` if all bits in *mask* are set on `self`.\n\n```\n0b0110.bits_set?(0b0110) # => true\n0b1101.bits_set?(0b0111) # => false\n0b1101.bits_set?(0b1100) # => true\n```","summary":"<p>Returns <code>true</code> if all bits in <em>mask</em> are set on <code>self</code>.</p>","abstract":false,"args":[{"name":"mask","doc":null,"default_value":"","external_name":"mask","restriction":""}],"args_string":"(mask)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L306","def":{"name":"bits_set?","args":[{"name":"mask","doc":null,"default_value":"","external_name":"mask","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self & mask) == mask"}},{"id":"ceil-instance-method","html_id":"ceil-instance-method","name":"ceil","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L230","def":{"name":"ceil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"chr-instance-method","html_id":"chr-instance-method","name":"chr","doc":"Returns a `Char` that has the unicode codepoint of `self`.\n\nRaises `ArgumentError` if this integer's value doesn't fit a char's range (`0..0x10ffff`).\n\n```\n97.chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L70","def":{"name":"chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= self && self <= Char::MAX_CODEPOINT\nelse\n  raise(ArgumentError.new(\"#{self} out of char range\"))\nend\nunsafe_chr\n"}},{"id":"days:Time::Span-instance-method","html_id":"days:Time::Span-instance-method","name":"days","doc":"Returns a `Time::Span` of `self` days.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> days.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L413","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L413","def":{"name":"days","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(self, 0, 0, 0)"}},{"id":"divisible_by?(num)-instance-method","html_id":"divisible_by?(num)-instance-method","name":"divisible_by?","doc":null,"summary":null,"abstract":false,"args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":""}],"args_string":"(num)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L318","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L318","def":{"name":"divisible_by?","args":[{"name":"num","doc":null,"default_value":"","external_name":"num","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self % num) == 0"}},{"id":"downto(to)-instance-method","html_id":"downto(to)-instance-method","name":"downto","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L375","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L375","def":{"name":"downto","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DowntoIterator(typeof(self), typeof(to)).new(self, to)"}},{"id":"downto(to,&block:self->):Nil-instance-method","html_id":"downto(to,&amp;block:self-&gt;):Nil-instance-method","name":"downto","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L367","def":{"name":"downto","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(self -> )"},"return_type":"Nil","visibility":"Public","body":"x = self\nwhile x >= to\n  yield x\n  x = x - 1\nend\n"}},{"id":"even?-instance-method","html_id":"even?-instance-method","name":"even?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L322","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L322","def":{"name":"even?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"divisible_by?(2)"}},{"id":"fdiv(other)-instance-method","html_id":"fdiv(other)-instance-method","name":"fdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L148","def":{"name":"fdiv","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f / other"}},{"id":"floor-instance-method","html_id":"floor-instance-method","name":"floor","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L234","def":{"name":"floor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"gcd(other:Int)-instance-method","html_id":"gcd(other:Int)-instance-method","name":"gcd","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L310","def":{"name":"gcd","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == 0 ? other.abs : (other % self).gcd(self)"}},{"id":"gcm(other:BigInt):Int-instance-method","html_id":"gcm(other:BigInt):Int-instance-method","name":"gcm","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L516","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L516","def":{"name":"gcm","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"other.gcm(self)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L331","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L331","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.int(self)"}},{"id":"hours:Time::Span-instance-method","html_id":"hours:Time::Span-instance-method","name":"hours","doc":"Returns a `Time::Span` of `self` hours.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> hours.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L423","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L423","def":{"name":"hours","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(self, 0, 0)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L470","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L470","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type = case self\nwhen Int8\n  \"_i8\"\nwhen Int16\n  \"_i16\"\nwhen Int32\n  \"\"\nwhen Int64\n  \"_i64\"\nwhen Int128\n  \"_i128\"\nwhen UInt8\n  \"_u8\"\nwhen UInt16\n  \"_u16\"\nwhen UInt32\n  \"_u32\"\nwhen UInt64\n  \"_u64\"\nwhen UInt128\n  \"_u128\"\nelse\n  raise(\"BUG: impossible\")\nend\nto_s(io)\nio << type\n"}},{"id":"lcm(other:Int)-instance-method","html_id":"lcm(other:Int)-instance-method","name":"lcm","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L314","def":{"name":"lcm","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self * other).abs / (gcd(other))"}},{"id":"lcm(other:BigInt):BigInt-instance-method","html_id":"lcm(other:BigInt):BigInt-instance-method","name":"lcm","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L520","def":{"name":"lcm","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"other.lcm(self)"}},{"id":"microseconds:Time::Span-instance-method","html_id":"microseconds:Time::Span-instance-method","name":"microseconds","doc":"Returns a `Time::Span` of `self` microseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> microseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L458","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L458","def":{"name":"microseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(0, 0, 0, 0, (self.to_i64 * Time::NANOSECONDS_PER_MICROSECOND))"}},{"id":"milliseconds:Time::Span-instance-method","html_id":"milliseconds:Time::Span-instance-method","name":"milliseconds","doc":"Returns a `Time::Span` of `self` milliseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> milliseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L453","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L453","def":{"name":"milliseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(0, 0, 0, 0, (self.to_i64 * Time::NANOSECONDS_PER_MILLISECOND))"}},{"id":"minutes:Time::Span-instance-method","html_id":"minutes:Time::Span-instance-method","name":"minutes","doc":"Returns a `Time::Span` of `self` minutes.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> minutes.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L433","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L433","def":{"name":"minutes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(0, self, 0)"}},{"id":"modulo(other)-instance-method","html_id":"modulo(other)-instance-method","name":"modulo","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L393","def":{"name":"modulo","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self % other"}},{"id":"months:Time::MonthSpan-instance-method","html_id":"months:Time::MonthSpan-instance-method","name":"months","doc":"Returns a `Time::MonthSpan` of `self` months.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> months.</p>","abstract":false,"args":[],"args_string":" : Time::MonthSpan","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L561","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L561","def":{"name":"months","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::MonthSpan","visibility":"Public","body":"Time::MonthSpan.new(self)"}},{"id":"nanoseconds:Time::Span-instance-method","html_id":"nanoseconds:Time::Span-instance-method","name":"nanoseconds","doc":"Returns a `Time::Span` of `self` nanoseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> nanoseconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L468","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L468","def":{"name":"nanoseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(nanoseconds: self.to_i64)"}},{"id":"odd?-instance-method","html_id":"odd?-instance-method","name":"odd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L326","def":{"name":"odd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!even?"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L509","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L509","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"pred-instance-method","html_id":"pred-instance-method","name":"pred","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L339","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L339","def":{"name":"pred","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self - 1"}},{"id":"remainder(other:Int)-instance-method","html_id":"remainder(other:Int)-instance-method","name":"remainder","doc":"Returns `self` remainder *other*.\n\nThis uses truncated division.\n\nSee `Int#div` for more details.","summary":"<p>Returns <code>self</code> remainder <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L173","def":{"name":"remainder","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other == 0\n  raise(DivisionByZeroError.new)\nelse\n  unsafe_mod(other)\nend"}},{"id":"round-instance-method","html_id":"round-instance-method","name":"round","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L238","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L238","def":{"name":"round","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"seconds:Time::Span-instance-method","html_id":"seconds:Time::Span-instance-method","name":"seconds","doc":"Returns a `Time::Span` of `self` seconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> seconds.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L443","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L443","def":{"name":"seconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(0, 0, self)"}},{"id":"succ-instance-method","html_id":"succ-instance-method","name":"succ","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L335","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L335","def":{"name":"succ","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self + 1"}},{"id":"tdiv(other:Int)-instance-method","html_id":"tdiv(other:Int)-instance-method","name":"tdiv","doc":"Divides `self` by *other* using truncated division.\n\nIn truncated division, given two integers x and y:\n* `q = x.tdiv(y)` is rounded toward zero\n* `r = x.remainder(y)` has the sign of the first argument\n* `x == q*y + r`\n\nFor example:\n\n```text\n x     y     x / y     x % y\n 5     3       1         2\n-5     3      -1        -2\n 5    -3      -1         2\n-5    -3       1        -2\n```\n\nRaises if *other* is `0`, or if *other* is `-1` and\n`self` is signed and is the minimum value for that\ninteger type.","summary":"<p>Divides <code>self</code> by <em>other</em> using truncated division.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L130","def":{"name":"tdiv","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_div_argument(other)\nunsafe_div(other)\n"}},{"id":"times(&block:self->):Nil-instance-method","html_id":"times(&amp;block:self-&gt;):Nil-instance-method","name":"times","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block : self -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L343","def":{"name":"times","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(self -> )"},"return_type":"Nil","visibility":"Public","body":"i = self ^ self\nwhile i < self\n  yield i\n  i = i + 1\nend\n"}},{"id":"times-instance-method","html_id":"times-instance-method","name":"times","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L351","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L351","def":{"name":"times","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"TimesIterator(typeof(self)).new(self)"}},{"id":"to(to,&block:self->):Nil-instance-method","html_id":"to(to,&amp;block:self-&gt;):Nil-instance-method","name":"to","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L379","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L379","def":{"name":"to","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(self -> )"},"return_type":"Nil","visibility":"Public","body":"if self < to\n  upto(to) do |i|\n    yield i\n  end\nelse\n  if self > to\n    downto(to) do |i|\n      yield i\n    end\n  else\n    yield self\n  end\nend"}},{"id":"to(to)-instance-method","html_id":"to(to)-instance-method","name":"to","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L389","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L389","def":{"name":"to","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self <= to ? upto(to) : downto(to)"}},{"id":"to_big_d-instance-method","html_id":"to_big_d-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L429","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L429","def":{"name":"to_big_d","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigDecimal.new(self)"}},{"id":"to_big_i:BigInt-instance-method","html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this integer.","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this integer.</p>","abstract":false,"args":[],"args_string":" : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L525","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L525","def":{"name":"to_big_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new(self)"}},{"id":"to_big_r-instance-method","html_id":"to_big_r-instance-method","name":"to_big_r","doc":"Returns a `BigRational` representing this integer.","summary":"<p>Returns a <code><a href=\"BigRational.html\">BigRational</a></code> representing this integer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L237","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L237","def":{"name":"to_big_r","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigRational.new(self, 1)"}},{"id":"to_io(io:IO,format:IO::ByteFormat)-instance-method","html_id":"to_io(io:IO,format:IO::ByteFormat)-instance-method","name":"to_io","doc":"Writes this integer to the given *io* in the given *format*.\n\nSee also: `IO#write_bytes`.","summary":"<p>Writes this integer to the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L492","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L492","def":{"name":"to_io","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"format.encode(self, io)"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L40","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.number(self)"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L401","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(10)"}},{"id":"to_s(base:Int,upcase:Bool=false)-instance-method","html_id":"to_s(base:Int,upcase:Bool=false)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"},{"name":"upcase","doc":null,"default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(base : Int, upcase : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L409","def":{"name":"to_s","args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"},{"name":"upcase","doc":null,"default_value":"false","external_name":"upcase","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\ncase self\nwhen 0\n  return \"0\"\nwhen 1\n  return \"1\"\nend\ninternal_to_s(base, upcase) do |ptr, count|\n  String.new(ptr, count, count)\nend\n"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L405","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(10, io)"}},{"id":"to_s(base:Int,io:IO,upcase:Bool=false)-instance-method","html_id":"to_s(base:Int,io:IO,upcase:Bool=false)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"upcase","doc":null,"default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(base : Int, io : IO, upcase : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L425","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L425","def":{"name":"to_s","args":[{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":"Int"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"upcase","doc":null,"default_value":"false","external_name":"upcase","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\ncase self\nwhen 0\n  io << '0'\n  return\nwhen 1\n  io << '1'\n  return\nend\ninternal_to_s(base, upcase) do |ptr, count|\n  io.write_utf8(Slice.new(ptr, count))\nend\n"}},{"id":"trunc-instance-method","html_id":"trunc-instance-method","name":"trunc","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L242","def":{"name":"trunc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"upto(to)-instance-method","html_id":"upto(to)-instance-method","name":"upto","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L363","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L363","def":{"name":"upto","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UptoIterator(typeof(self), typeof(to)).new(self, to)"}},{"id":"upto(to,&block:self->):Nil-instance-method","html_id":"upto(to,&amp;block:self-&gt;):Nil-instance-method","name":"upto","doc":null,"summary":null,"abstract":false,"args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L355","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L355","def":{"name":"upto","args":[{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(self -> )"},"return_type":"Nil","visibility":"Public","body":"x = self\nwhile x <= to\n  yield x\n  x = x + 1\nend\n"}},{"id":"weeks:Time::Span-instance-method","html_id":"weeks:Time::Span-instance-method","name":"weeks","doc":"Returns a `Time::Span` of `self` weeks.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> weeks.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L403","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L403","def":{"name":"weeks","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(7 * self, 0, 0, 0)"}},{"id":"years:Time::MonthSpan-instance-method","html_id":"years:Time::MonthSpan-instance-method","name":"years","doc":"Returns a `Time::MonthSpan` of `self` years.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> years.</p>","abstract":false,"args":[],"args_string":" : Time::MonthSpan","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L571","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L571","def":{"name":"years","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::MonthSpan","visibility":"Public","body":"Time::MonthSpan.new(self * 12)"}},{"id":"~-instance-method","html_id":"~-instance-method","name":"~","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L77","def":{"name":"~","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self ^ -1"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Int/Primitive","path":"Int/Primitive.html","kind":"alias","full_name":"Int::Primitive","name":"Primitive","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"int.cr","line_number":61,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Int128 | Int16 | Int32 | Int64 | Int8 | UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int/Signed","path":"Int/Signed.html","kind":"alias","full_name":"Int::Signed","name":"Signed","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"int.cr","line_number":59,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Int128 | Int16 | Int32 | Int64 | Int8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int/Unsigned","path":"Int/Unsigned.html","kind":"alias","full_name":"Int::Unsigned","name":"Unsigned","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"int.cr","line_number":60,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Int128","path":"Int128.html","kind":"struct","full_name":"Int128","name":"Int128","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":679,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"~MIN","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"(new(1)) << 127","doc":"TODO: eventually update to literals once UInt128 bit support is finished","summary":"<p><span class=\"flag orange\">TODO</span>  eventually update to literals once UInt128 bit support is finished</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `Int128` by invoking `to_i128` on *value*.","summary":"<p>Returns an <code><a href=\"Int128.html\">Int128</a></code> by invoking <code><a href=\"Int128.html#to_i128%3AInt128-instance-method\">#to_i128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L685","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L685","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_i128"}}],"instance_methods":[{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L689","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L689","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Int128.new(0)) - self"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L698","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L698","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L694","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L694","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount128(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int16","path":"Int16.html","kind":"struct","full_name":"Int16","name":"Int16","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":613,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"32767_i16","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"-32768_i16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int16.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int16.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `Int16` by invoking `to_i16` on *value*.","summary":"<p>Returns an <code><a href=\"Int16.html\">Int16</a></code> by invoking <code><a href=\"Int16.html#to_i16%3AInt16-instance-method\">#to_i16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L618","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L618","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_i16"}}],"instance_methods":[{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L622","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L622","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0_i16 - self"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L630","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L630","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L626","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L626","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount16(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int32","path":"Int32.html","kind":"struct","full_name":"Int32","name":"Int32","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":635,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"2147483647","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"-2147483648","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int32.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int32.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `Int32` by invoking `to_i32` on *value*.","summary":"<p>Returns an <code><a href=\"Int32.html\">Int32</a></code> by invoking <code><a href=\"Int32.html#to_i32%3AInt32-instance-method\">#to_i32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L640","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L640","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_i32"}}],"instance_methods":[{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L644","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L644","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0 - self"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L652","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L652","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L648","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L648","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount32(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int64","path":"Int64.html","kind":"struct","full_name":"Int64","name":"Int64","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":657,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"9223372036854775807_i64","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"-9223372036854775808_i64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int64.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int64.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `Int64` by invoking `to_i64` on *value*.","summary":"<p>Returns an <code><a href=\"Int64.html\">Int64</a></code> by invoking <code><a href=\"Int64.html#to_i64%3AInt64-instance-method\">#to_i64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L662","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L662","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_i64"}}],"instance_methods":[{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L666","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L666","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0_i64 - self"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L674","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L674","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L670","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L670","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount64(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Int8","path":"Int8.html","kind":"struct","full_name":"Int8","name":"Int8","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":591,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"127_i8","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"-128_i8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int8.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Int8.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `Int8` by invoking `to_i8` on *value*.","summary":"<p>Returns an <code><a href=\"Int8.html\">Int8</a></code> by invoking <code><a href=\"Int8.html#to_i8%3AInt8-instance-method\">#to_i8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L596","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L596","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_i8"}}],"instance_methods":[{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"--instance-method","html_id":"--instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L600","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L600","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0_i8 - self"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L608","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L608","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L604","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L604","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount8(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/InvalidBigDecimalException","path":"InvalidBigDecimalException.html","kind":"class","full_name":"InvalidBigDecimalException","name":"InvalidBigDecimalException","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"big/big_decimal.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(big_decimal_str:String,reason:String)-class-method","html_id":"new(big_decimal_str:String,reason:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"big_decimal_str","doc":null,"default_value":"","external_name":"big_decimal_str","restriction":"String"},{"name":"reason","doc":null,"default_value":"","external_name":"reason","restriction":"String"}],"args_string":"(big_decimal_str : String, reason : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L13","def":{"name":"new","args":[{"name":"big_decimal_str","doc":null,"default_value":"","external_name":"big_decimal_str","restriction":"String"},{"name":"reason","doc":null,"default_value":"","external_name":"reason","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(big_decimal_str, reason)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/InvalidByteSequenceError","path":"InvalidByteSequenceError.html","kind":"class","full_name":"InvalidByteSequenceError","name":"InvalidByteSequenceError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":106,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(message=&quot;InvalidbytesequenceinUTF-8string&quot;)-class-method","html_id":"new(message=&amp;quot;InvalidbytesequenceinUTF-8string&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Invalid byte sequence in UTF-8 string\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Invalid byte sequence in UTF-8 string&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L107","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Invalid byte sequence in UTF-8 string\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO","path":"IO.html","kind":"class","full_name":"IO","name":"IO","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io.cr","line_number":61,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr"},{"filename":"io/encoding.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr"},{"filename":"io/error.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Flate/Reader","kind":"class","full_name":"Flate::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Flate/Writer","kind":"class","full_name":"Flate::Writer","name":"Writer"},{"html_id":"github.com/crystal-lang/crystal/Gzip/Reader","kind":"class","full_name":"Gzip::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Gzip/Writer","kind":"class","full_name":"Gzip::Writer","name":"Writer"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/Response","kind":"class","full_name":"HTTP::Server::Response","name":"Response"},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocket/Protocol/StreamIO","kind":"class","full_name":"HTTP::WebSocket::Protocol::StreamIO","name":"StreamIO"},{"html_id":"github.com/crystal-lang/crystal/IO/Delimited","kind":"class","full_name":"IO::Delimited","name":"Delimited"},{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Hexdump","kind":"class","full_name":"IO::Hexdump","name":"Hexdump"},{"html_id":"github.com/crystal-lang/crystal/IO/Memory","kind":"class","full_name":"IO::Memory","name":"Memory"},{"html_id":"github.com/crystal-lang/crystal/IO/MultiWriter","kind":"class","full_name":"IO::MultiWriter","name":"MultiWriter"},{"html_id":"github.com/crystal-lang/crystal/IO/Sized","kind":"class","full_name":"IO::Sized","name":"Sized"},{"html_id":"github.com/crystal-lang/crystal/IO/Stapled","kind":"class","full_name":"IO::Stapled","name":"Stapled"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestIO","kind":"class","full_name":"OpenSSL::DigestIO","name":"DigestIO"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/String/Builder","kind":"class","full_name":"String::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/Zlib/Reader","kind":"class","full_name":"Zlib::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Zlib/Writer","kind":"class","full_name":"Zlib::Writer","name":"Writer"}],"including_types":[],"namespace":null,"doc":"The `IO` class is the basis for all input and output in Crystal.\n\nThis class is inherited by types like `File`, `Socket` and `IO::Memory` and\nprovides many useful methods for reading from and writing to an IO, like `print`, `puts`,\n`gets` and `printf`.\n\nThe only requirement for a type including the `IO` module is to define\nthese two methods:\n\n* `read(slice : Bytes)`: read at most *slice.size* bytes from IO into *slice* and return the number of bytes read\n* `write(slice : Bytes)`: write the whole *slice* into the IO\n\nFor example, this is a simple `IO` on top of a `Bytes`:\n\n```\nclass SimpleSliceIO < IO\n  def initialize(@slice : Bytes)\n  end\n\n  def read(slice : Bytes)\n    slice.size.times { |i| slice[i] = @slice[i] }\n    @slice += slice.size\n    slice.size\n  end\n\n  def write(slice : Bytes)\n    slice.size.times { |i| @slice[i] = slice[i] }\n    @slice += slice.size\n    nil\n  end\nend\n\nslice = Slice.new(9) { |i| ('a'.ord + i).to_u8 }\nString.new(slice) # => \"abcdefghi\"\n\nio = SimpleSliceIO.new(slice)\nio.gets(3) # => \"abc\"\nio.print \"xyz\"\nString.new(slice) # => \"abcxyzghi\"\n```\n\n### Encoding\n\nAn `IO` can be set an encoding with the `#set_encoding` method. When this is\nset, all string operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts`\n`printf`) will write in the given encoding, and read from the given encoding.\nByte operations (`read`, `write`, `read_byte`, `write_byte`) never do\nencoding/decoding operations.\n\nIf an encoding is not set, the default one is UTF-8.\n\nMixing string and byte operations might not give correct results and should be\navoided, as string operations might need to read extra bytes in order to get characters\nin the given encoding.","summary":"<p>The <code><a href=\"IO.html\">IO</a></code> class is the basis for all input and output in Crystal.</p>","class_methods":[{"id":"copy(src,dst,limit:Int)-class-method","html_id":"copy(src,dst,limit:Int)-class-method","name":"copy","doc":"Copy at most *limit* bytes from *src* to *dst*.\n\n```\nio = IO::Memory.new \"hello\"\nio2 = IO::Memory.new\n\nIO.copy io, io2, 3\n\nio2.to_s # => \"hel\"\n```","summary":"<p>Copy at most <em>limit</em> bytes from <em>src</em> to <em>dst</em>.</p>","abstract":false,"args":[{"name":"src","doc":null,"default_value":"","external_name":"src","restriction":""},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":""},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"}],"args_string":"(src, dst, limit : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1155","def":{"name":"copy","args":[{"name":"src","doc":null,"default_value":"","external_name":"src","restriction":""},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":""},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if limit < 0\n  raise(ArgumentError.new(\"Negative limit\"))\nend\nbuffer = uninitialized ::StaticArray(UInt8, 4096)\nremaining = limit\nwhile (len = src.read(buffer.to_slice[0, Math.min(buffer.size, Math.max(remaining, 0))])) > 0\n  dst.write(buffer.to_slice[0, len])\n  remaining = remaining - len\nend\nlimit - remaining\n"}},{"id":"copy(src,dst)-class-method","html_id":"copy(src,dst)-class-method","name":"copy","doc":"Copy all contents from *src* to *dst*.\n\n```\nio = IO::Memory.new \"hello\"\nio2 = IO::Memory.new\n\nIO.copy io, io2\n\nio2.to_s # => \"hello\"\n```","summary":"<p>Copy all contents from <em>src</em> to <em>dst</em>.</p>","abstract":false,"args":[{"name":"src","doc":null,"default_value":"","external_name":"src","restriction":""},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":""}],"args_string":"(src, dst)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1135","def":{"name":"copy","args":[{"name":"src","doc":null,"default_value":"","external_name":"src","restriction":""},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\ncount = 0\nwhile (len = (src.read(buffer.to_slice)).to_i32) > 0\n  dst.write(buffer.to_slice[0, len])\n  count = count + len\nend\nlen < 0 ? len : count\n"}},{"id":"pipe(read_blocking=false,write_blocking=false):Tuple(IO::FileDescriptor,IO::FileDescriptor)-class-method","html_id":"pipe(read_blocking=false,write_blocking=false):Tuple(IO::FileDescriptor,IO::FileDescriptor)-class-method","name":"pipe","doc":"Creates a pair of pipe endpoints (connected to each other)\nand returns them as a two-element `Tuple`.\n\n```\nreader, writer = IO.pipe\nwriter.puts \"hello\"\nwriter.puts \"world\"\nreader.gets # => \"hello\"\nreader.gets # => \"world\"\n```","summary":"<p>Creates a pair of pipe endpoints (connected to each other) and returns them as a two-element <code><a href=\"Tuple.html\">Tuple</a></code>.</p>","abstract":false,"args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":""}],"args_string":"(read_blocking = <span class=\"n\">false</span>, write_blocking = <span class=\"n\">false</span>) : Tuple(IO::FileDescriptor, IO::FileDescriptor)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L137","def":{"name":"pipe","args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(IO::FileDescriptor, IO::FileDescriptor)","visibility":"Public","body":"pipe_fds = uninitialized StaticArray(LibC::Int, 2)\nif (LibC.pipe(pipe_fds)) != 0\n  raise(Errno.new(\"Could not create pipe\"))\nend\nr = IO::FileDescriptor.new(pipe_fds[0], read_blocking)\nw = IO::FileDescriptor.new(pipe_fds[1], write_blocking)\nr.close_on_exec = true\nw.close_on_exec = true\nw.sync = true\n{r, w}\n"}},{"id":"pipe(read_blocking=false,write_blocking=false,&block)-class-method","html_id":"pipe(read_blocking=false,write_blocking=false,&amp;block)-class-method","name":"pipe","doc":"Creates a pair of pipe endpoints (connected to each other) and passes them\nto the given block. Both endpoints are closed after the block.\n\n```\nIO.pipe do |reader, writer|\n  writer.puts \"hello\"\n  writer.puts \"world\"\n  reader.gets # => \"hello\"\n  reader.gets # => \"world\"\nend\n```","summary":"<p>Creates a pair of pipe endpoints (connected to each other) and passes them to the given block.</p>","abstract":false,"args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":""}],"args_string":"(read_blocking = <span class=\"n\">false</span>, write_blocking = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L137","def":{"name":"pipe","args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"r, w = IO.pipe(read_blocking, write_blocking)\nbegin\n  yield r, w\nensure\n  w.flush\n  r.close\n  w.close\nend\n"}}],"constructors":[],"instance_methods":[{"id":"<<(obj):self-instance-method","html_id":"&lt;&lt;(obj):self-instance-method","name":"<<","doc":"Writes the given object into this `IO`.\nThis ends up calling `to_s(io)` on the object.\n\n```\nio = IO::Memory.new\nio << 1\nio << '-'\nio << \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Writes the given object into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L196","def":{"name":"<<","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"obj.to_s(self)\nself\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this `IO`.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Closes this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L117","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"closed?-instance-method","html_id":"closed?-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is closed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L123","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"each_byte(&block):Nil-instance-method","html_id":"each_byte(&amp;block):Nil-instance-method","name":"each_byte","doc":"Invokes the given block with each byte (`UInt8`) in this `IO`.\n\n```\nio = IO::Memory.new(\"aあ\")\nio.each_byte do |byte|\n  puts byte\nend\n```\n\nOutput:\n\n```text\n97\n227\n129\n130\n```","summary":"<p>Invokes the given block with each byte (<code><a href=\"UInt8.html\">UInt8</a></code>) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1004","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1004","def":{"name":"each_byte","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while byte = read_byte\n  yield byte\nend"}},{"id":"each_byte-instance-method","html_id":"each_byte-instance-method","name":"each_byte","doc":"Returns an `Iterator` for the bytes in this `IO`.\n\n```\nio = IO::Memory.new(\"aあ\")\niter = io.each_byte\niter.next # => 97\niter.next # => 227\niter.next # => 129\niter.next # => 130\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the bytes in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1020","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1020","def":{"name":"each_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ByteIterator.new(self)"}},{"id":"each_char(&block):Nil-instance-method","html_id":"each_char(&amp;block):Nil-instance-method","name":"each_char","doc":"Invokes the given block with each `Char` in this `IO`.\n\n```\nio = IO::Memory.new(\"あめ\")\nio.each_char do |char|\n  puts char\nend\n```\n\nOutput:\n\n```text\nあ\nめ\n```","summary":"<p>Invokes the given block with each <code><a href=\"Char.html\">Char</a></code> in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L969","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L969","def":{"name":"each_char","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while char = read_char\n  yield char\nend"}},{"id":"each_char-instance-method","html_id":"each_char-instance-method","name":"each_char","doc":"Returns an `Iterator` for the chars in this `IO`.\n\n```\nio = IO::Memory.new(\"あめ\")\niter = io.each_char\niter.next # => 'あ'\niter.next # => 'め'\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the chars in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L983","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L983","def":{"name":"each_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CharIterator.new(self)"}},{"id":"each_line(*args,**options,&block):Nil-instance-method","html_id":"each_line(*args,**options,&amp;block):Nil-instance-method","name":"each_line","doc":"Invokes the given block with each *line* in this `IO`, where a line\nis defined by the arguments passed to this method, which can be the same\nones as in the `gets` methods.\n\n```\nio = IO::Memory.new(\"hello\\nworld\")\nio.each_line do |line|\n  puts line.chomp.reverse\nend\n```\n\nOutput:\n\n```text\nolleh\ndlrow\n```","summary":"<p>Invokes the given block with each <em>line</em> in this <code><a href=\"IO.html\">IO</a></code>, where a line is defined by the arguments passed to this method, which can be the same ones as in the <code><a href=\"IO.html#gets%28delimiter%3AChar%2Climit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code> methods.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L934","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L934","def":{"name":"each_line","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while line = gets(*args, **options)\n  yield line\nend"}},{"id":"each_line(*args,**options)-instance-method","html_id":"each_line(*args,**options)-instance-method","name":"each_line","doc":"Returns an `Iterator` for the *lines* in this `IO`, where a line\nis defined by the arguments passed to this method, which can be the same\nones as in the `gets` methods.\n\n```\nio = IO::Memory.new(\"hello\\nworld\")\niter = io.each_line\niter.next # => \"hello\"\niter.next # => \"world\"\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the <em>lines</em> in this <code><a href=\"IO.html\">IO</a></code>, where a line is defined by the arguments passed to this method, which can be the same ones as in the <code><a href=\"IO.html#gets%28delimiter%3AChar%2Climit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code> methods.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L950","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L950","def":{"name":"each_line","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LineIterator.new(self, args, options)"}},{"id":"encoding:String-instance-method","html_id":"encoding:String-instance-method","name":"encoding","doc":"Returns this `IO`'s encoding. The default is `UTF-8`.","summary":"<p>Returns this <code><a href=\"IO.html\">IO</a></code>'s encoding.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1052","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1052","def":{"name":"encoding","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@encoding.try(&.name) || \"UTF-8\""}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes buffered data, if any.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Flushes buffered data, if any.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L134","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","html_id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found, *limit* bytes are read, or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets('o', 3)  # => \"hel\"\nio.gets('r', 10) # => \"lo\\nwor\"\nio.gets('z', 10) # => \"ld\"\nio.gets('w', 10) # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found, <em>limit</em> bytes are read, or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, limit : Int, chomp = <span class=\"n\">false</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L631","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L631","def":{"name":"gets","args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"if limit < 0\n  raise(ArgumentError.new(\"Negative limit\"))\nend\nascii = delimiter.ascii?\ndecoder = decoder()\nif ascii && decoder\n  return decoder.gets(self, delimiter.ord.to_u8, limit: limit, chomp: chomp)\nend\nif (ascii && (!decoder)) && (peek = self.peek)\n  if peek.empty?\n    nil\n  else\n    gets_peek(delimiter, limit, chomp, peek)\n  end\nelse\n  gets_slow(delimiter, limit, chomp)\nend\n"}},{"id":"gets(delimiter:Char,chomp=false):String?-instance-method","html_id":"gets(delimiter:Char,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found, or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets('o') # => \"hello\"\nio.gets('r') # => \"\\nwor\"\nio.gets('z') # => \"ld\"\nio.gets('w') # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found, or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, chomp = <span class=\"n\">false</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L617","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L617","def":{"name":"gets","args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"gets(delimiter, Int32::MAX, chomp: chomp)"}},{"id":"gets(chomp=true):String?-instance-method","html_id":"gets(chomp=true):String?-instance-method","name":"gets","doc":"Reads a line from this `IO`. A line is terminated by the `\\n` character.\nReturns `nil` if called at the end of this `IO`.\n\nBy default the newline is removed from the returned string,\nunless *chomp* is `false`.\n\n```\nio = IO::Memory.new \"hello\\nworld\\nfoo\\n\"\nio.gets               # => \"hello\"\nio.gets(chomp: false) # => \"world\\n\"\nio.gets               # => \"foo\"\nio.gets               # => nil\n```","summary":"<p>Reads a line from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = <span class=\"n\">true</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L587","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L587","def":{"name":"gets","args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"gets('\\n', chomp: chomp)"}},{"id":"gets(limit:Int,chomp=false):String?-instance-method","html_id":"gets(limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Reads a line of at most *limit* bytes from this `IO`.\nA line is terminated by the `\\n` character.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets(3) # => \"hel\"\nio.gets(3) # => \"lo\\n\"\nio.gets(3) # => \"wor\"\nio.gets(3) # => \"ld\"\nio.gets(3) # => nil\n```","summary":"<p>Reads a line of at most <em>limit</em> bytes from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(limit : Int, chomp = <span class=\"n\">false</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L603","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L603","def":{"name":"gets","args":[{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"gets('\\n', limit: limit, chomp: chomp)"}},{"id":"gets(delimiter:String,chomp=false):String?-instance-method","html_id":"gets(delimiter:String,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets(\"wo\") # => \"hello\\nwo\"\nio.gets(\"wo\") # => \"rld\"\nio.gets(\"wo\") # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"String"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : String, chomp = <span class=\"n\">false</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L786","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L786","def":{"name":"gets","args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"String"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"if delimiter.empty?\n  return gets_to_end\nend\nif delimiter.bytesize == 1\n  return gets((delimiter.unsafe_byte_at(0)).unsafe_chr, chomp: chomp)\nend\nif delimiter.size == 1\n  return gets(delimiter[0], chomp: chomp)\nend\nlast_byte = delimiter.byte_at(delimiter.bytesize - 1)\ntotal_bytes = 0\nbuffer = String::Builder.new\nwhile true\n  if byte = read_utf8_byte\n  else\n    return buffer.empty? ? nil : buffer.to_s\n  end\n  buffer.write_byte(byte)\n  total_bytes = total_bytes + 1\n  if ((byte == last_byte) && (buffer.bytesize >= delimiter.bytesize)) && ((((buffer.buffer + total_bytes) - delimiter.bytesize).memcmp(delimiter.to_unsafe, delimiter.bytesize)) == 0)\n    if chomp\n      buffer.back(delimiter.bytesize)\n    end\n    break\n  end\nend\nbuffer.to_s\n"}},{"id":"gets_to_end:String-instance-method","html_id":"gets_to_end:String-instance-method","name":"gets_to_end","doc":"Reads the rest of this `IO` data as a `String`.\n\n```\nio = IO::Memory.new \"hello world\"\nio.gets_to_end # => \"hello world\"\n```","summary":"<p>Reads the rest of this <code><a href=\"IO.html\">IO</a></code> data as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L556","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L556","def":{"name":"gets_to_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |str|\n  if decoder = decoder()\n    while true\n      decoder.read(self)\n      if decoder.out_slice.empty?\n        break\n      end\n      decoder.write(str)\n    end\n  else\n    buffer = uninitialized ::StaticArray(UInt8, 4096)\n    while (read_bytes = read(buffer.to_slice)) > 0\n      str.write(buffer.to_slice[0, read_bytes])\n    end\n  end\nend"}},{"id":"peek:Bytes?-instance-method","html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Peeks into this IO, if possible.\n\nIt returns:\n- `nil` if this IO isn't peekable\n- an empty slice if it is, but EOF was reached\n- a non-empty slice if some data can be peeked\n\nThe returned bytes are only valid data until a next call\nto any method that reads from this IO is invoked.\n\nBy default this method returns `nil`, but IO implementations\nthat provide buffering or wrap other IOs should override\nthis method.","summary":"<p>Peeks into this IO, if possible.</p>","abstract":false,"args":[],"args_string":" : Bytes?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L485","def":{"name":"peek","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes | ::Nil","visibility":"Public","body":"nil"}},{"id":"pos-instance-method","html_id":"pos-instance-method","name":"pos","doc":"Returns the current position (in bytes) in this `IO`.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos     # => 0\nfile.gets(2) # => \"he\"\nfile.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1090","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1090","def":{"name":"pos","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(Error.new(\"Unable to pos\"))"}},{"id":"pos=(value)-instance-method","html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) in this `IO`.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos = 3\nfile.gets_to_end # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1106","def":{"name":"pos=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(Error.new(\"Unable to pos=\"))"}},{"id":"print(*objects:_):Nil-instance-method","html_id":"print(*objects:_):Nil-instance-method","name":"print","doc":"Writes the given objects into this `IO` by invoking `to_s(io)`\non each of the objects.\n\n```\nio = IO::Memory.new\nio.print 1, '-', \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Writes the given objects into this <code><a href=\"IO.html\">IO</a></code> by invoking <code>to_s(io)</code> on each of the objects.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L223","def":{"name":"print","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"objects.each do |obj|\n  print(obj)\nend\nnil\n"}},{"id":"print(obj):Nil-instance-method","html_id":"print(obj):Nil-instance-method","name":"print","doc":"Same as `<<`.\n\n```\nio = IO::Memory.new\nio.print 1\nio.print '-'\nio.print \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Same as <code><a href=\"IO.html#%3C%3C%28obj%29%3Aself-instance-method\">#<<</a></code>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L210","def":{"name":"print","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"self << obj\nnil\n"}},{"id":"printf(format_string,*args):Nil-instance-method","html_id":"printf(format_string,*args):Nil-instance-method","name":"printf","doc":"Writes a formatted string to this IO.\nFor details on the format string, see `Kernel::sprintf`.","summary":"<p>Writes a formatted string to this IO.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L286","def":{"name":"printf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"printf(format_string, args)"}},{"id":"printf(format_string,args:Array|Tuple):Nil-instance-method","html_id":"printf(format_string,args:Array|Tuple):Nil-instance-method","name":"printf","doc":"Writes a formatted string to this IO.\nFor details on the format string, see `Kernel::sprintf`.","summary":"<p>Writes a formatted string to this IO.</p>","abstract":false,"args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L291","def":{"name":"printf","args":[{"name":"format_string","doc":null,"default_value":"","external_name":"format_string","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array | Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"(String::Formatter(typeof(args)).new(format_string, args, self)).format\nnil\n"}},{"id":"puts(*objects:_):Nil-instance-method","html_id":"puts(*objects:_):Nil-instance-method","name":"puts","doc":"Writes the given objects, each followed by a newline character.\n\n```\nio = IO::Memory.new\nio.puts 1, '-', \"Crystal\"\nio.to_s # => \"1\\n-\\nCrystal\\n\"\n```","summary":"<p>Writes the given objects, each followed by a newline character.</p>","abstract":false,"args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L277","def":{"name":"puts","args":[{"name":"objects","doc":null,"default_value":"","external_name":"objects","restriction":"_"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"objects.each do |obj|\n  puts(obj)\nend\nnil\n"}},{"id":"puts:Nil-instance-method","html_id":"puts:Nil-instance-method","name":"puts","doc":"Writes a newline character.\n\n```\nio = IO::Memory.new\nio.puts\nio.to_s # => \"\\n\"\n```","summary":"<p>Writes a newline character.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L265","def":{"name":"puts","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"print('\\n')\nnil\n"}},{"id":"puts(obj):Nil-instance-method","html_id":"puts(obj):Nil-instance-method","name":"puts","doc":"Writes the given object to this `IO` followed by a newline character.\n\n```\nio = IO::Memory.new\nio.puts 1\nio.puts \"Crystal\"\nio.to_s # => \"1\\nCrystal\\n\"\n```","summary":"<p>Writes the given object to this <code><a href=\"IO.html\">IO</a></code> followed by a newline character.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L253","def":{"name":"puts","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"self << obj\nputs\n"}},{"id":"puts(string:String):Nil-instance-method","html_id":"puts(string:String):Nil-instance-method","name":"puts","doc":"Writes the given string to this `IO` followed by a newline character\nunless the string already ends with one.\n\n```\nio = IO::Memory.new\nio.puts \"hello\\n\"\nio.puts \"world\"\nio.to_s # => \"hello\\nworld\\n\"\n```","summary":"<p>Writes the given string to this <code><a href=\"IO.html\">IO</a></code> followed by a newline character unless the string already ends with one.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L239","def":{"name":"puts","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"self << string\nif string.ends_with?('\\n')\nelse\n  puts\nend\nnil\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":true,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L102","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"read_at(offset,bytesize,&block)-instance-method","html_id":"read_at(offset,bytesize,&amp;block)-instance-method","name":"read_at","doc":"Yields an `IO` to read a section inside this IO.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`File` and `IO::Memory` implement it.\n\nMultiple sections can be read concurrently.","summary":"<p>Yields an <code><a href=\"IO.html\">IO</a></code> to read a section inside this IO.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1121","def":{"name":"read_at","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(Error.new(\"Unable to read_at\"))"}},{"id":"read_byte:UInt8?-instance-method","html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from this `IO`. Returns `nil` if there is no more\ndata to read.\n\n```\nio = IO::Memory.new \"a\"\nio.read_byte # => 97\nio.read_byte # => nil\n```","summary":"<p>Reads a single byte from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L304","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L304","def":{"name":"read_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8 | ::Nil","visibility":"Public","body":"byte = uninitialized UInt8\nif (read(Slice.new(pointerof(byte), 1))) == 1\n  byte\nelse\n  nil\nend\n"}},{"id":"read_bytes(type,format:IO::ByteFormat=IO::ByteFormat::SystemEndian)-instance-method","html_id":"read_bytes(type,format:IO::ByteFormat=IO::ByteFormat::SystemEndian)-instance-method","name":"read_bytes","doc":"Reads an instance of the given *type* from this `IO` using the specified *format*.\n\nThis ends up invoking `type.from_io(self, format)`, so any type defining a\n`from_io(io : IO, format : IO::ByteFormat = IO::ByteFormat::SystemEndian)`\nmethod can be read in this way.\n\nSee `Int.from_io` and `Float.from_io`.\n\n```\nio = IO::Memory.new\nio.puts \"\\u{4}\\u{3}\\u{2}\\u{1}\"\nio.rewind\nio.read_bytes(Int32, IO::ByteFormat::LittleEndian) # => 0x01020304\n```","summary":"<p>Reads an instance of the given <em>type</em> from this <code><a href=\"IO.html\">IO</a></code> using the specified <em>format</em>.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"format","doc":null,"default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(type, format : IO::ByteFormat = <span class=\"t\">IO</span><span class=\"t\">::</span><span class=\"t\">ByteFormat</span><span class=\"t\">::</span><span class=\"t\">SystemEndian</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L901","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L901","def":{"name":"read_bytes","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"format","doc":null,"default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type.from_io(self, format)"}},{"id":"read_char:Char?-instance-method","html_id":"read_char:Char?-instance-method","name":"read_char","doc":"Reads a single `Char` from this `IO`. Returns `nil` if there is no\nmore data to read.\n\n```\nio = IO::Memory.new \"あ\"\nio.read_char # => 'あ'\nio.read_char # => nil\n```","summary":"<p>Reads a single <code><a href=\"Char.html\">Char</a></code> from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Char?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L321","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L321","def":{"name":"read_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char | ::Nil","visibility":"Public","body":"info = read_char_with_bytesize\ninfo ? info[0] : nil\n"}},{"id":"read_fully(slice:Bytes)-instance-method","html_id":"read_fully(slice:Bytes)-instance-method","name":"read_fully","doc":"Tries to read exactly `slice.size` bytes from this `IO` into *slice*.\nRaises `EOFError` if there aren't `slice.size` bytes of data.\n\n```\nio = IO::Memory.new \"123451234\"\nslice = Bytes.new(5)\nio.read_fully(slice) # => 5\nslice                # => Bytes[49, 50, 51, 52, 53]\nio.read_fully(slice) # raises IO::EOFError\n```","summary":"<p>Tries to read exactly <code>slice.size</code> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L525","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L525","def":{"name":"read_fully","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(read_fully?(slice)) || (raise(EOFError.new))"}},{"id":"read_fully?(slice:Bytes)-instance-method","html_id":"read_fully?(slice:Bytes)-instance-method","name":"read_fully?","doc":"Tries to read exactly `slice.size` bytes from this `IO` into *slice*.\nReturns `nil` if there aren't `slice.size` bytes of data, otherwise\nreturns the number of bytes read.\n\n```\nio = IO::Memory.new \"123451234\"\nslice = Bytes.new(5)\nio.read_fully?(slice) # => 5\nslice                 # => Bytes[49, 50, 51, 52, 53]\nio.read_fully?(slice) # => nil\n```","summary":"<p>Tries to read exactly <code>slice.size</code> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L540","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L540","def":{"name":"read_fully?","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count = slice.size\nwhile slice.size > 0\n  read_bytes = read(slice)\n  if read_bytes == 0\n    return nil\n  end\n  slice = slice + read_bytes\nend\ncount\n"}},{"id":"read_line(*args,**options):String-instance-method","html_id":"read_line(*args,**options):String-instance-method","name":"read_line","doc":"Same as `gets`, but raises `EOFError` if called at the end of this `IO`.","summary":"<p>Same as <code><a href=\"IO.html#gets%28delimiter%3AChar%2Climit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code>, but raises <code><a href=\"IO/EOFError.html\">EOFError</a></code> if called at the end of this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L826","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L826","def":{"name":"read_line","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"(gets(*args, **options)) || (raise(EOFError.new))"}},{"id":"read_string(bytesize:Int):String-instance-method","html_id":"read_string(bytesize:Int):String-instance-method","name":"read_string","doc":"Reads an UTF-8 encoded string of exactly *bytesize* bytes.\nRaises `EOFError` if there are not enough bytes to build\nthe string.\n\n```\nio = IO::Memory.new(\"hello world\")\nio.read_string(5) # => \"hello\"\nio.read_string(1) # => \" \"\nio.read_string(6) # raises IO::EOFError\n```","summary":"<p>Reads an UTF-8 encoded string of exactly <em>bytesize</em> bytes.</p>","abstract":false,"args":[{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"Int"}],"args_string":"(bytesize : Int) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L458","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L458","def":{"name":"read_string","args":[{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.new(bytesize) do |ptr|\n  if decoder = decoder()\n    read = decoder.read_utf8(self, Slice.new(ptr, bytesize))\n    if read != bytesize\n      raise(IO::EOFError.new)\n    end\n  else\n    read_fully(Slice.new(ptr, bytesize))\n  end\n  {bytesize, 0}\nend"}},{"id":"read_utf8(slice:Bytes)-instance-method","html_id":"read_utf8(slice:Bytes)-instance-method","name":"read_utf8","doc":"Reads UTF-8 decoded bytes into the given *slice*.\nReturns the number of UTF-8 bytes read.\n\nIf no encoding is set, this is the same as `#read(slice)`.\n\n```\nbytes = \"你\".encode(\"GB2312\") # => Bytes[196, 227]\n\nio = IO::Memory.new(bytes)\nio.set_encoding(\"GB2312\")\n\nbuffer = uninitialized UInt8[1024]\nbytes_read = io.read_utf8(buffer.to_slice) # => 3\nbuffer.to_slice[0, bytes_read]             # => Bytes[228, 189, 160]\n\n\"你\".bytes # => [228, 189, 160]\n```","summary":"<p>Reads UTF-8 decoded bytes into the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L440","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L440","def":{"name":"read_utf8","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if decoder = decoder()\n  decoder.read_utf8(self, slice)\nelse\n  read(slice)\nend"}},{"id":"read_utf8_byte-instance-method","html_id":"read_utf8_byte-instance-method","name":"read_utf8_byte","doc":"Reads a single decoded UTF-8 byte from this `IO`.\nReturns `nil` if there is no more data to read.\n\nIf no encoding is set, this is the same as `#read_byte`.\n\n```\nbytes = \"你\".encode(\"GB2312\") # => Bytes[196, 227]\n\nio = IO::Memory.new(bytes)\nio.set_encoding(\"GB2312\")\nio.read_utf8_byte # => 228\nio.read_utf8_byte # => 189\nio.read_utf8_byte # => 160\nio.read_utf8_byte # => nil\n\n\"你\".bytes # => [228, 189, 160]\n```","summary":"<p>Reads a single decoded UTF-8 byte from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L415","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L415","def":{"name":"read_utf8_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if decoder = decoder()\n  decoder.read_byte(self)\nelse\n  read_byte\nend"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds this `IO`. By default this method raises, but including types\nmay implement it.","summary":"<p>Rewinds this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1026","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1026","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't rewind\"))"}},{"id":"seek(offset,whence:Seek=Seek::Set)-instance-method","html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\nReturns `self`.\n\n```\nFile.write(\"testfile\", \"abc\")\n\nfile = File.new(\"testfile\")\nfile.gets(3) # => \"abc\"\nfile.seek(1, IO::Seek::Set)\nfile.gets(2) # => \"bc\"\nfile.seek(-1, IO::Seek::Current)\nfile.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1073","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1073","def":{"name":"seek","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(Error.new(\"Unable to seek\"))"}},{"id":"set_encoding(encoding:String,invalid:Symbol?=nil)-instance-method","html_id":"set_encoding(encoding:String,invalid:Symbol?=nil)-instance-method","name":"set_encoding","doc":"Sets the encoding of this `IO`.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\nString operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts`\n`printf`) will use this encoding.","summary":"<p>Sets the encoding of this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(encoding : String, invalid : Symbol? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1038","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1038","def":{"name":"set_encoding","args":[{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (encoding == \"UTF-8\") && (invalid != (:skip))\n  @encoding = nil\nelse\n  @encoding = EncodingOptions.new(encoding, invalid)\nend\n@encoder.try(&.close)\n@decoder.try(&.close)\n@encoder = nil\n@decoder = nil\nnil\n"}},{"id":"skip(bytes_count:Int):Nil-instance-method","html_id":"skip(bytes_count:Int):Nil-instance-method","name":"skip","doc":"Reads and discards exactly *bytes_count* bytes.\nRaises `IO::EOFError` if there aren't at least *bytes_count* bytes.\n\n```\nio = IO::Memory.new \"hello world\"\nio.skip(6)\nio.gets    # => \"world\"\nio.skip(1) # raises IO::EOFError\n```","summary":"<p>Reads and discards exactly <em>bytes_count</em> bytes.</p>","abstract":false,"args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":"Int"}],"args_string":"(bytes_count : Int) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L839","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L839","def":{"name":"skip","args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile bytes_count > 0\n  read_count = read(buffer.to_slice[0, Math.min(bytes_count, 4096)])\n  if read_count == 0\n    raise(IO::EOFError.new)\n  end\n  bytes_count = bytes_count - read_count\nend\n"}},{"id":"skip_to_end:Nil-instance-method","html_id":"skip_to_end:Nil-instance-method","name":"skip_to_end","doc":"Reads and discards bytes from `self` until there\nare no more bytes.","summary":"<p>Reads and discards bytes from <code>self</code> until there are no more bytes.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L851","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L851","def":{"name":"skip_to_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile (read(buffer.to_slice)) > 0\nend\n"}},{"id":"tell-instance-method","html_id":"tell-instance-method","name":"tell","doc":"Same as `pos`.","summary":"<p>Same as <code><a href=\"IO.html#pos-instance-method\">#pos</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L1111","def":{"name":"tell","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pos"}},{"id":"tty?:Bool-instance-method","html_id":"tty?:Bool-instance-method","name":"tty?","doc":"Returns `true` if this `IO` is associated with a terminal device (tty), `false` otherwise.\n\nIO returns `false`, but including types may override.\n\n```\nSTDIN.tty?          # => true\nIO::Memory.new.tty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is associated with a terminal device (tty), <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L913","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L913","def":{"name":"tty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"false"}},{"id":"write(slice:Bytes):Nil-instance-method","html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":true,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L112","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":""}},{"id":"write_byte(byte:UInt8)-instance-method","html_id":"write_byte(byte:UInt8)-instance-method","name":"write_byte","doc":"Writes a single byte into this `IO`.\n\n```\nio = IO::Memory.new\nio.write_byte 97_u8\nio.to_s # => \"a\"\n```","summary":"<p>Writes a single byte into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L864","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L864","def":{"name":"write_byte","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = byte\nwrite(Slice.new(pointerof(x), 1))\n"}},{"id":"write_bytes(object,format:IO::ByteFormat=IO::ByteFormat::SystemEndian)-instance-method","html_id":"write_bytes(object,format:IO::ByteFormat=IO::ByteFormat::SystemEndian)-instance-method","name":"write_bytes","doc":"Writes the given object to this `IO` using the specified *format*.\n\nThis ends up invoking `object.to_io(self, format)`, so any object defining a\n`to_io(io : IO, format : IO::ByteFormat = IO::ByteFormat::SystemEndian)`\nmethod can be written in this way.\n\nSee `Int#to_io` and `Float#to_io`.\n\n```\nio = IO::Memory.new\nio.write_bytes(0x01020304, IO::ByteFormat::LittleEndian)\nio.rewind\nio.gets(4) # => \"\\u{4}\\u{3}\\u{2}\\u{1}\"\n```","summary":"<p>Writes the given object to this <code><a href=\"IO.html\">IO</a></code> using the specified <em>format</em>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"format","doc":null,"default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(object, format : IO::ByteFormat = <span class=\"t\">IO</span><span class=\"t\">::</span><span class=\"t\">ByteFormat</span><span class=\"t\">::</span><span class=\"t\">SystemEndian</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L883","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L883","def":{"name":"write_bytes","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"format","doc":null,"default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"object.to_io(self, format)"}},{"id":"write_utf8(slice:Bytes)-instance-method","html_id":"write_utf8(slice:Bytes)-instance-method","name":"write_utf8","doc":"Writes a slice of UTF-8 encoded bytes to this `IO`, using the current encoding.","summary":"<p>Writes a slice of UTF-8 encoded bytes to this <code><a href=\"IO.html\">IO</a></code>, using the current encoding.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L490","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L490","def":{"name":"write_utf8","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if encoder = encoder()\n  encoder.write(self, slice)\nelse\n  write(slice)\nend\nnil\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","path":"IO/Buffered.html","kind":"module","full_name":"IO::Buffered","name":"Buffered","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/buffered.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BUFFER_SIZE","name":"BUFFER_SIZE","value":"8192","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"The `IO::Buffered` mixin enhances an `IO` with input/output buffering.\n\nThe buffering behaviour can be turned on/off with the `#sync=` method.\n\nAdditionally, several methods, like `#gets`, are implemented in a more\nefficient way.","summary":"<p>The <code><a href=\"../IO/Buffered.html\">IO::Buffered</a></code> mixin enhances an <code><a href=\"../IO.html\">IO</a></code> with input/output buffering.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"close:Nil-instance-method","html_id":"close:Nil-instance-method","name":"close","doc":"Flushes and closes the underlying `IO`.","summary":"<p>Flushes and closes the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L200","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"begin\n  if @out_count > 0\n    flush\n  end\nensure\n  unbuffered_close\nend"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes any buffered data and the underlying `IO`. Returns `self`.","summary":"<p>Flushes any buffered data and the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L192","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @out_count > 0\n  unbuffered_write(Slice.new(out_buffer, @out_count))\nend\nunbuffered_flush\n@out_count = 0\nself\n"}},{"id":"flush_on_newline=(flush_on_newline)-instance-method","html_id":"flush_on_newline=(flush_on_newline)-instance-method","name":"flush_on_newline=","doc":"Turns on/off flushing the underlying `IO` when a newline is written.","summary":"<p>Turns on/off flushing the underlying <code><a href=\"../IO.html\">IO</a></code> when a newline is written.</p>","abstract":false,"args":[{"name":"flush_on_newline","doc":null,"default_value":"","external_name":"flush_on_newline","restriction":""}],"args_string":"(flush_on_newline)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L169","def":{"name":"flush_on_newline=","args":[{"name":"flush_on_newline","doc":null,"default_value":"","external_name":"flush_on_newline","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flush_on_newline = !(!flush_on_newline)"}},{"id":"flush_on_newline?-instance-method","html_id":"flush_on_newline?-instance-method","name":"flush_on_newline?","doc":"Determines if this `IO` flushes automatically when a newline is written.","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> flushes automatically when a newline is written.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L174","def":{"name":"flush_on_newline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flush_on_newline"}},{"id":"peek:Bytes?-instance-method","html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Returns the bytes hold in the read buffer.\n\nThis method only performs a read to return\npeek data if the current buffer is empty:\notherwise no read is performed and whatever\nis in the buffer is returned.","summary":"<p>Returns the bytes hold in the read buffer.</p>","abstract":false,"args":[],"args_string":" : Bytes?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L84","def":{"name":"peek","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes | ::Nil","visibility":"Public","body":"check_open\nif @in_buffer_rem.empty?\n  fill_buffer\n  if @in_buffer_rem.empty?\n    return Bytes.empty\n  end\nend\n@in_buffer_rem\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Buffered implementation of `IO#read(slice)`.","summary":"<p>Buffered implementation of <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L54","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncount = slice.size\nif count == 0\n  return 0\nend\nif @in_buffer_rem.empty?\n  if sync? || count >= (BUFFER_SIZE / 2)\n    return (unbuffered_read(slice[0, count])).to_i\n  else\n    fill_buffer\n    if @in_buffer_rem.empty?\n      return 0\n    end\n  end\nend\nto_read = Math.min(count, @in_buffer_rem.size)\nslice.copy_from(@in_buffer_rem.pointer(to_read), to_read)\n@in_buffer_rem = @in_buffer_rem + to_read\nto_read\n"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds the underlying `IO`. Returns `self`.","summary":"<p>Rewinds the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L207","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"unbuffered_rewind\n@in_buffer_rem = Bytes.empty\nself\n"}},{"id":"sync=(sync)-instance-method","html_id":"sync=(sync)-instance-method","name":"sync=","doc":"Turns on/off `IO` buffering. When *sync* is set to `true`, no buffering\nwill be done (that is, writing to this `IO` is immediately synced to the\nunderlying `IO`).","summary":"<p>Turns on/off <code><a href=\"../IO.html\">IO</a></code> buffering.</p>","abstract":false,"args":[{"name":"sync","doc":null,"default_value":"","external_name":"sync","restriction":""}],"args_string":"(sync)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L181","def":{"name":"sync=","args":[{"name":"sync","doc":null,"default_value":"","external_name":"sync","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if sync && (!@sync)\n  flush\nend\n@sync = !(!sync)\n"}},{"id":"sync?-instance-method","html_id":"sync?-instance-method","name":"sync?","doc":"Determines if this `IO` does buffering. If `true`, no buffering is done.","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> does buffering.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L187","def":{"name":"sync?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync"}},{"id":"unbuffered_close-instance-method","html_id":"unbuffered_close-instance-method","name":"unbuffered_close","doc":"Closes the wrapped `IO`.","summary":"<p>Closes the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L27","def":{"name":"unbuffered_close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"unbuffered_flush-instance-method","html_id":"unbuffered_flush-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L24","def":{"name":"unbuffered_flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"unbuffered_read(slice:Bytes)-instance-method","html_id":"unbuffered_read(slice:Bytes)-instance-method","name":"unbuffered_read","doc":"Reads at most *slice.size* bytes from the wrapped `IO` into *slice*.\nReturns the number of bytes read.","summary":"<p>Reads at most <em>slice.size</em> bytes from the wrapped <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":true,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L17","def":{"name":"unbuffered_read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"unbuffered_rewind-instance-method","html_id":"unbuffered_rewind-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L30","def":{"name":"unbuffered_rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"unbuffered_write(slice:Bytes)-instance-method","html_id":"unbuffered_write(slice:Bytes)-instance-method","name":"unbuffered_write","doc":"Writes at most *slice.size* bytes from *slice* into the wrapped `IO`.\nReturns the number of bytes written.","summary":"<p>Writes at most <em>slice.size</em> bytes from <em>slice</em> into the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L21","def":{"name":"unbuffered_write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"Buffered implementation of `IO#write(slice)`.","summary":"<p>Buffered implementation of <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/buffered.cr#L113","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\ncount = slice.size\nif sync?\n  return unbuffered_write(slice)\nend\nif flush_on_newline?\n  index = slice[0, count.to_i32].rindex('\\n'.ord.to_u8)\n  if index\n    flush\n    index = index + 1\n    unbuffered_write(slice[0, index])\n    slice = slice + index\n    count = count - index\n  end\nend\nif count >= BUFFER_SIZE\n  flush\n  return unbuffered_write(slice[0, count])\nend\nif count > (BUFFER_SIZE - @out_count)\n  flush\nend\nslice.copy_to(out_buffer + @out_count, count)\n@out_count = @out_count + count\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","path":"IO/ByteFormat.html","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/byte_format.cr","line_number":35,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Defines a byte format to encode integers and floats\nfrom/to `Bytes` and `IO`.\n\n### Decode from bytes\n\n```\nbytes = Bytes[0x34, 0x12]\nint16 = IO::ByteFormat::LittleEndian.decode(Int16, bytes)\nint16 # => 0x1234_i16\n```\n\n### Decode from an IO\n\n```\nio = IO::Memory.new(Bytes[0x34, 0x12])\nint16 = io.read_bytes(Int16, IO::ByteFormat::LittleEndian)\nint16 # => 0x1234_i16\n```\n\n### Encode to bytes\n\n```\nraw = uninitialized UInt8[2]\nIO::ByteFormat::LittleEndian.encode(0x1234_i16, raw.to_slice)\nraw # => StaticArray[0x34, 0x12]\n```\n\n### Encode to IO\n\n```\nio = IO::Memory.new\nio.write_bytes(0x1234_i16, IO::ByteFormat::LittleEndian)\nio.to_slice # => Bytes[0x34, 0x12]\n```","summary":"<p>Defines a byte format to encode integers and floats from/to <code><a href=\"../Bytes.html\">Bytes</a></code> and <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"decode(int:Int8.class,io:IO)-instance-method","html_id":"decode(int:Int8.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L62","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt8.class,io:IO)-instance-method","html_id":"decode(int:UInt8.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L63","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int16.class,io:IO)-instance-method","html_id":"decode(int:Int16.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L64","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt16.class,io:IO)-instance-method","html_id":"decode(int:UInt16.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L65","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int32.class,io:IO)-instance-method","html_id":"decode(int:Int32.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L66","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt32.class,io:IO)-instance-method","html_id":"decode(int:UInt32.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L67","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int64.class,io:IO)-instance-method","html_id":"decode(int:Int64.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L68","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt64.class,io:IO)-instance-method","html_id":"decode(int:UInt64.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L69","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int128.class,io:IO)-instance-method","html_id":"decode(int:Int128.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L70","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt128.class,io:IO)-instance-method","html_id":"decode(int:UInt128.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L71","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(type:Float32.class,io:IO)-instance-method","html_id":"decode(type:Float32.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Float32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L96","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(decode(Int32, io)).unsafe_as(Float32)"}},{"id":"decode(type:Float64.class,io:IO)-instance-method","html_id":"decode(type:Float64.class,io:IO)-instance-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Float64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L112","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(decode(Int64, io)).unsafe_as(Float64)"}},{"id":"decode(int:Int8.class,bytes:Bytes)-instance-method","html_id":"decode(int:Int8.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L75","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt8.class,bytes:Bytes)-instance-method","html_id":"decode(int:UInt8.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L76","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int16.class,bytes:Bytes)-instance-method","html_id":"decode(int:Int16.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L77","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt16.class,bytes:Bytes)-instance-method","html_id":"decode(int:UInt16.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L78","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int32.class,bytes:Bytes)-instance-method","html_id":"decode(int:Int32.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L79","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt32.class,bytes:Bytes)-instance-method","html_id":"decode(int:UInt32.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L80","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int64.class,bytes:Bytes)-instance-method","html_id":"decode(int:Int64.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L81","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt64.class,bytes:Bytes)-instance-method","html_id":"decode(int:UInt64.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L82","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:Int128.class,bytes:Bytes)-instance-method","html_id":"decode(int:Int128.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L83","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(int:UInt128.class,bytes:Bytes)-instance-method","html_id":"decode(int:UInt128.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L84","def":{"name":"decode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"decode(type:Float32.class,bytes:Bytes)-instance-method","html_id":"decode(type:Float32.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Float32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L100","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(decode(Int32, bytes)).unsafe_as(Float32)"}},{"id":"decode(type:Float64.class,bytes:Bytes)-instance-method","html_id":"decode(type:Float64.class,bytes:Bytes)-instance-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Float64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L116","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Float64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(decode(Int64, bytes)).unsafe_as(Float64)"}},{"id":"encode(float:Float64,bytes:Bytes)-instance-method","html_id":"encode(float:Float64,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(float : Float64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L108","def":{"name":"encode","args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"encode(float.unsafe_as(Int64), bytes)"}},{"id":"encode(int:UInt8,io:IO)-instance-method","html_id":"encode(int:UInt8,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L37","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int16,io:IO)-instance-method","html_id":"encode(int:Int16,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L38","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt16,io:IO)-instance-method","html_id":"encode(int:UInt16,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L39","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int32,io:IO)-instance-method","html_id":"encode(int:Int32,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L40","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt32,io:IO)-instance-method","html_id":"encode(int:UInt32,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L41","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int64,io:IO)-instance-method","html_id":"encode(int:Int64,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L42","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt64,io:IO)-instance-method","html_id":"encode(int:UInt64,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L43","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int128,io:IO)-instance-method","html_id":"encode(int:Int128,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L44","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt128,io:IO)-instance-method","html_id":"encode(int:UInt128,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L45","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(float:Float32,io:IO)-instance-method","html_id":"encode(float:Float32,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(float : Float32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L88","def":{"name":"encode","args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"encode(float.unsafe_as(Int32), io)"}},{"id":"encode(float:Float64,io:IO)-instance-method","html_id":"encode(float:Float64,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(float : Float64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L104","def":{"name":"encode","args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"encode(float.unsafe_as(Int64), io)"}},{"id":"encode(int:Int8,bytes:Bytes)-instance-method","html_id":"encode(int:Int8,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L49","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt8,bytes:Bytes)-instance-method","html_id":"encode(int:UInt8,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L50","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int16,bytes:Bytes)-instance-method","html_id":"encode(int:Int16,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L51","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt16,bytes:Bytes)-instance-method","html_id":"encode(int:UInt16,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L52","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int32,bytes:Bytes)-instance-method","html_id":"encode(int:Int32,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L53","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt32,bytes:Bytes)-instance-method","html_id":"encode(int:UInt32,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L54","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int64,bytes:Bytes)-instance-method","html_id":"encode(int:Int64,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L55","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt64,bytes:Bytes)-instance-method","html_id":"encode(int:UInt64,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L56","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:Int128,bytes:Bytes)-instance-method","html_id":"encode(int:Int128,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L57","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(int:UInt128,bytes:Bytes)-instance-method","html_id":"encode(int:UInt128,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L58","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"encode(float:Float32,bytes:Bytes)-instance-method","html_id":"encode(float:Float32,bytes:Bytes)-instance-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(float : Float32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L92","def":{"name":"encode","args":[{"name":"float","doc":null,"default_value":"","external_name":"float","restriction":"Float32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"encode(float.unsafe_as(Int32), bytes)"}},{"id":"encode(int:Int8,io:IO)-instance-method","html_id":"encode(int:Int8,io:IO)-instance-method","name":"encode","doc":null,"summary":null,"abstract":true,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L36","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat/BigEndian","path":"IO/ByteFormat/BigEndian.html","kind":"module","full_name":"IO::ByteFormat::BigEndian","name":"BigEndian","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/byte_format.cr","line_number":124,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"},{"filename":"io/byte_format.cr","line_number":131,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"doc":null,"summary":null,"class_methods":[{"id":"decode(type:Int8.class,io:IO)-class-method","html_id":"decode(type:Int8.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"id":"decode(type:Int8.class,bytes:Bytes)-class-method","html_id":"decode(type:Int8.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"id":"decode(type:UInt8.class,io:IO)-class-method","html_id":"decode(type:UInt8.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"id":"decode(type:UInt8.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt8.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"id":"decode(type:Int16.class,io:IO)-class-method","html_id":"decode(type:Int16.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"id":"decode(type:Int16.class,bytes:Bytes)-class-method","html_id":"decode(type:Int16.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"id":"decode(type:UInt16.class,io:IO)-class-method","html_id":"decode(type:UInt16.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"id":"decode(type:UInt16.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt16.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"id":"decode(type:Int32.class,io:IO)-class-method","html_id":"decode(type:Int32.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"id":"decode(type:Int32.class,bytes:Bytes)-class-method","html_id":"decode(type:Int32.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"id":"decode(type:UInt32.class,io:IO)-class-method","html_id":"decode(type:UInt32.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"id":"decode(type:UInt32.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt32.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"id":"decode(type:Int64.class,io:IO)-class-method","html_id":"decode(type:Int64.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"id":"decode(type:Int64.class,bytes:Bytes)-class-method","html_id":"decode(type:Int64.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"id":"decode(type:UInt64.class,io:IO)-class-method","html_id":"decode(type:UInt64.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"id":"decode(type:UInt64.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt64.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"id":"decode(type:Int128.class,io:IO)-class-method","html_id":"decode(type:Int128.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"id":"decode(type:Int128.class,bytes:Bytes)-class-method","html_id":"decode(type:Int128.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"id":"decode(type:UInt128.class,io:IO)-class-method","html_id":"decode(type:UInt128.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"id":"decode(type:UInt128.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt128.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"id":"encode(int:UInt128,bytes:Bytes)-class-method","html_id":"encode(int:UInt128,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int8,bytes:Bytes)-class-method","html_id":"encode(int:Int8,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt8,io:IO)-class-method","html_id":"encode(int:UInt8,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt8,bytes:Bytes)-class-method","html_id":"encode(int:UInt8,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int16,io:IO)-class-method","html_id":"encode(int:Int16,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int16,bytes:Bytes)-class-method","html_id":"encode(int:Int16,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt16,io:IO)-class-method","html_id":"encode(int:UInt16,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt16,bytes:Bytes)-class-method","html_id":"encode(int:UInt16,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int32,io:IO)-class-method","html_id":"encode(int:Int32,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int32,bytes:Bytes)-class-method","html_id":"encode(int:Int32,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt32,io:IO)-class-method","html_id":"encode(int:UInt32,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt32,bytes:Bytes)-class-method","html_id":"encode(int:UInt32,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int64,io:IO)-class-method","html_id":"encode(int:Int64,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int64,bytes:Bytes)-class-method","html_id":"encode(int:Int64,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt64,io:IO)-class-method","html_id":"encode(int:UInt64,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt64,bytes:Bytes)-class-method","html_id":"encode(int:UInt64,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int128,io:IO)-class-method","html_id":"encode(int:Int128,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int128,bytes:Bytes)-class-method","html_id":"encode(int:Int128,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt128,io:IO)-class-method","html_id":"encode(int:UInt128,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int8,io:IO)-class-method","html_id":"encode(int:Int8,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat/LittleEndian","path":"IO/ByteFormat/LittleEndian.html","kind":"module","full_name":"IO::ByteFormat::LittleEndian","name":"LittleEndian","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/byte_format.cr","line_number":120,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"},{"filename":"io/byte_format.cr","line_number":131,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"doc":null,"summary":null,"class_methods":[{"id":"decode(type:Int8.class,io:IO)-class-method","html_id":"decode(type:Int8.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"id":"decode(type:Int8.class,bytes:Bytes)-class-method","html_id":"decode(type:Int8.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"id":"decode(type:UInt8.class,io:IO)-class-method","html_id":"decode(type:UInt8.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt8.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"id":"decode(type:UInt8.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt8.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt8.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"id":"decode(type:Int16.class,io:IO)-class-method","html_id":"decode(type:Int16.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"id":"decode(type:Int16.class,bytes:Bytes)-class-method","html_id":"decode(type:Int16.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"id":"decode(type:UInt16.class,io:IO)-class-method","html_id":"decode(type:UInt16.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt16.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"id":"decode(type:UInt16.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt16.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt16.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"id":"decode(type:Int32.class,io:IO)-class-method","html_id":"decode(type:Int32.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"id":"decode(type:Int32.class,bytes:Bytes)-class-method","html_id":"decode(type:Int32.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"id":"decode(type:UInt32.class,io:IO)-class-method","html_id":"decode(type:UInt32.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt32.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"id":"decode(type:UInt32.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt32.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt32.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"id":"decode(type:Int64.class,io:IO)-class-method","html_id":"decode(type:Int64.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"id":"decode(type:Int64.class,bytes:Bytes)-class-method","html_id":"decode(type:Int64.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"id":"decode(type:UInt64.class,io:IO)-class-method","html_id":"decode(type:UInt64.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt64.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"id":"decode(type:UInt64.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt64.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt64.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"id":"decode(type:Int128.class,io:IO)-class-method","html_id":"decode(type:Int128.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : Int128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"id":"decode(type:Int128.class,bytes:Bytes)-class-method","html_id":"decode(type:Int128.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Int128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"id":"decode(type:UInt128.class,io:IO)-class-method","html_id":"decode(type:UInt128.class,io:IO)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt128.class, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"id":"decode(type:UInt128.class,bytes:Bytes)-class-method","html_id":"decode(type:UInt128.class,bytes:Bytes)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt128.class, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"decode","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"id":"encode(int:UInt128,bytes:Bytes)-class-method","html_id":"encode(int:UInt128,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int8,bytes:Bytes)-class-method","html_id":"encode(int:Int8,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt8,io:IO)-class-method","html_id":"encode(int:UInt8,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt8,bytes:Bytes)-class-method","html_id":"encode(int:UInt8,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt8"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int16,io:IO)-class-method","html_id":"encode(int:Int16,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int16,bytes:Bytes)-class-method","html_id":"encode(int:Int16,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt16,io:IO)-class-method","html_id":"encode(int:UInt16,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt16,bytes:Bytes)-class-method","html_id":"encode(int:UInt16,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt16"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int32,io:IO)-class-method","html_id":"encode(int:Int32,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int32,bytes:Bytes)-class-method","html_id":"encode(int:Int32,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt32,io:IO)-class-method","html_id":"encode(int:UInt32,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt32,bytes:Bytes)-class-method","html_id":"encode(int:UInt32,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt32"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int64,io:IO)-class-method","html_id":"encode(int:Int64,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int64,bytes:Bytes)-class-method","html_id":"encode(int:Int64,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt64,io:IO)-class-method","html_id":"encode(int:UInt64,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:UInt64,bytes:Bytes)-class-method","html_id":"encode(int:UInt64,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt64"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:Int128,io:IO)-class-method","html_id":"encode(int:Int128,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int128,bytes:Bytes)-class-method","html_id":"encode(int:Int128,bytes:Bytes)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int128"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"id":"encode(int:UInt128,io:IO)-class-method","html_id":"encode(int:UInt128,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"UInt128"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"id":"encode(int:Int8,io:IO)-class-method","html_id":"encode(int:Int8,io:IO)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr#L131","def":{"name":"encode","args":[{"name":"int","doc":null,"default_value":"","external_name":"int","restriction":"Int8"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat/NetworkEndian","path":"IO/ByteFormat/NetworkEndian.html","kind":"alias","full_name":"IO::ByteFormat::NetworkEndian","name":"NetworkEndian","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/byte_format.cr","line_number":129,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"IO::ByteFormat::BigEndian","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat/SystemEndian","path":"IO/ByteFormat/SystemEndian.html","kind":"alias","full_name":"IO::ByteFormat::SystemEndian","name":"SystemEndian","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/byte_format.cr","line_number":128,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/byte_format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"IO::ByteFormat::LittleEndian","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/IO/Delimited","path":"IO/Delimited.html","kind":"class","full_name":"IO::Delimited","name":"Delimited","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/delimited.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that wraps another `IO`, and only reads up to the beginning of a\nspecified delimiter.\n\nThis is useful for exposing part of an underlying stream to a client.\n\n```\nio = IO::Memory.new \"abc||123\"\ndelimited = IO::Delimited.new(io, read_delimiter: \"||\")\n\ndelimited.gets_to_end # => \"abc\"\ndelimited.gets_to_end # => \"\"\nio.gets_to_end        # => \"123\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that wraps another <code><a href=\"../IO.html\">IO</a></code>, and only reads up to the beginning of a specified delimiter.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,read_delimiter:String,sync_close:Bool=false)-class-method","html_id":"new(io:IO,read_delimiter:String,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Delimited` which wraps *io*, and can read until the\nbyte sequence *read_delimiter* (interpreted as UTF-8) is found. If\n*sync_close* is set, calling `#close` calls `#close` on the underlying\n`IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Delimited.html\">IO::Delimited</a></code> which wraps <em>io</em>, and can read until the byte sequence <em>read_delimiter</em> (interpreted as UTF-8) is found.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_delimiter","doc":null,"default_value":"","external_name":"read_delimiter","restriction":"String"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io : IO, read_delimiter : String, sync_close : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L28","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_delimiter","doc":null,"default_value":"","external_name":"read_delimiter","restriction":"String"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(io, read_delimiter.to_slice, sync_close)"}},{"id":"new(io:IO,read_delimiter:Bytes,sync_close:Bool=false)-class-method","html_id":"new(io:IO,read_delimiter:Bytes,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Delimited` which wraps *io*, and can read until the\nbyte sequence *read_delimiter* is found. If *sync_close* is set, calling\n`#close` calls `#close` on the underlying `IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Delimited.html\">IO::Delimited</a></code> which wraps <em>io</em>, and can read until the byte sequence <em>read_delimiter</em> is found.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_delimiter","doc":null,"default_value":"","external_name":"read_delimiter","restriction":"Bytes"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io : IO, read_delimiter : Bytes, sync_close : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L35","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_delimiter","doc":null,"default_value":"","external_name":"read_delimiter","restriction":"Bytes"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, read_delimiter, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L114","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L19","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@closed"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L45","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif @finished\n  return 0\nend\nfirst_byte = @read_delimiter[0]\nread_bytes = 0\nwhile read_bytes < slice.size\n  if @active_delimiter_buffer.size > 0\n    byte = @active_delimiter_buffer[0]\n    @active_delimiter_buffer = @active_delimiter_buffer + 1\n  else\n    byte = @io.read_byte\n  end\n  if byte.nil?\n    break\n  end\n  if (byte == first_byte) && (@delimiter_buffer.size == @read_delimiter.size)\n    buffer = @delimiter_buffer\n    buffer[0] = byte\n    read_start = 1\n    if @active_delimiter_buffer.size > 0\n      (buffer + 1).move_from(@active_delimiter_buffer)\n      read_start = read_start + @active_delimiter_buffer.size\n    end\n    read_buffer = buffer + read_start\n    bytes = 0\n    while read_buffer.size > 0\n      partial_bytes = @io.read(read_buffer)\n      if partial_bytes == 0\n        break\n      end\n      read_buffer = read_buffer + partial_bytes\n      bytes = bytes + partial_bytes\n    end\n    if bytes != (buffer.size - read_start)\n      buffer = buffer[0, read_start + bytes]\n    end\n    if buffer == @read_delimiter\n      @finished = true\n      return read_bytes\n    end\n    @delimiter_buffer = buffer\n    @active_delimiter_buffer = buffer + 1\n  end\n  slice[read_bytes] = byte\n  read_bytes = read_bytes + 1\nend\nread_bytes\n"}},{"id":"read_delimiter:Slice(UInt8)-instance-method","html_id":"read_delimiter:Slice(UInt8)-instance-method","name":"read_delimiter","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Slice(UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L18","def":{"name":"read_delimiter","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@read_delimiter"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Delimited.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L16","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Delimited.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L16","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/delimited.cr#L110","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to IO::Delimited\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/EncodingOptions","path":"IO/EncodingOptions.html","kind":"struct","full_name":"IO::EncodingOptions","name":"EncodingOptions","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/encoding.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Has the `name` and the `invalid` option.","summary":"<p>Has the <code><a href=\"../IO/EncodingOptions.html#name%3AString-instance-method\">#name</a></code> and the <code><a href=\"../IO/EncodingOptions.html#invalid%3ASymbol%3F-instance-method\">#invalid</a></code> option.</p>","class_methods":[{"id":"check_invalid(invalid)-class-method","html_id":"check_invalid(invalid)-class-method","name":"check_invalid","doc":null,"summary":null,"abstract":false,"args":[{"name":"invalid","doc":null,"default_value":"","external_name":"invalid","restriction":""}],"args_string":"(invalid)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L11","def":{"name":"check_invalid","args":[{"name":"invalid","doc":null,"default_value":"","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if invalid && (invalid != (:skip))\n  raise(ArgumentError.new(\"Valid values for `invalid` option are `nil` and `:skip`, not #{invalid.inspect}\"))\nend"}}],"constructors":[{"id":"new(name:String,invalid:Symbol?)-class-method","html_id":"new(name:String,invalid:Symbol?)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"invalid","doc":null,"default_value":"","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(name : String, invalid : Symbol?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L7","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"invalid","doc":null,"default_value":"","external_name":"invalid","restriction":"Symbol | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, invalid)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"invalid:Symbol?-instance-method","html_id":"invalid:Symbol?-instance-method","name":"invalid","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Symbol?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L5","def":{"name":"invalid","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Symbol | ::Nil","visibility":"Public","body":"@invalid"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/encoding.cr#L4","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/EOFError","path":"IO/EOFError.html","kind":"class","full_name":"IO::EOFError","name":"EOFError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/error.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(message=&quot;Endoffilereached&quot;)-class-method","html_id":"new(message=&amp;quot;Endoffilereached&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"End of file reached\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;End of file reached&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/error.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/error.cr#L6","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"End of file reached\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Error","path":"IO/Error.html","kind":"class","full_name":"IO::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/error.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/IO/EOFError","kind":"class","full_name":"IO::EOFError","name":"EOFError"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","path":"IO/FileDescriptor.html","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/console.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr"},{"filename":"io/file_descriptor.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` over a file descriptor.","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> over a file descriptor.</p>","class_methods":[{"id":"fcntl(fd,cmd,arg=0)-class-method","html_id":"fcntl(fd,cmd,arg=0)-class-method","name":"fcntl","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"args_string":"(fd, cmd, arg = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L37","def":{"name":"fcntl","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::FileDescriptor.fcntl(fd, cmd, arg)"}}],"constructors":[{"id":"new(fd,blocking=false)-class-method","html_id":"new(fd,blocking=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(fd, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L13","def":{"name":"new","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(fd, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"blocking-instance-method","html_id":"blocking-instance-method","name":"blocking","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L21","def":{"name":"blocking","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_blocking?"}},{"id":"blocking=(value)-instance-method","html_id":"blocking=(value)-instance-method","name":"blocking=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L25","def":{"name":"blocking=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.system_blocking = value"}},{"id":"close_on_exec=(value:Bool)-instance-method","html_id":"close_on_exec=(value:Bool)-instance-method","name":"close_on_exec=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L33","def":{"name":"close_on_exec=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.system_close_on_exec = value"}},{"id":"close_on_exec?-instance-method","html_id":"close_on_exec?-instance-method","name":"close_on_exec?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L29","def":{"name":"close_on_exec?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_close_on_exec?"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L125","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"cooked(&block)-instance-method","html_id":"cooked(&amp;block)-instance-method","name":"cooked","doc":"Enable character processing for the duration of the given block.\nThe so called cooked mode is the standard behavior of a terminal,\ndoing line wise editing by the terminal and only sending the input to\nthe program on a newline.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enable character processing for the duration of the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L42","def":{"name":"cooked","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"preserving_tc_mode(\"can't set IO#cooked\") do |mode|\n  cooked_from_tc_mode!\n  yield self\nend"}},{"id":"cooked!-instance-method","html_id":"cooked!-instance-method","name":"cooked!","doc":"Enable character processing for this IO.\nThe so called cooked mode is the standard behavior of a terminal,\ndoing line wise editing by the terminal and only sending the input to\nthe program on a newline.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enable character processing for this IO.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L54","def":{"name":"cooked!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(Errno.new(\"can't set IO#cooked!\"))\nend\ncooked_from_tc_mode!\n"}},{"id":"fcntl(cmd,arg=0)-instance-method","html_id":"fcntl(cmd,arg=0)-instance-method","name":"fcntl","doc":null,"summary":null,"abstract":false,"args":[{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"args_string":"(cmd, arg = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L37","def":{"name":"fcntl","args":[{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::FileDescriptor.fcntl(@fd, cmd, arg)"}},{"id":"fd:Int32-instance-method","html_id":"fd:Int32-instance-method","name":"fd","doc":"The raw file-descriptor. It is defined to be an `Int`, but it's size is\nplatform-specific.","summary":"<p>The raw file-descriptor.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L11","def":{"name":"fd","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fd"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L119","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if closed?\n  return\nend\nbegin\n  close\nrescue\n  nil\nend\n"}},{"id":"info-instance-method","html_id":"info-instance-method","name":"info","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L47","def":{"name":"info","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_info"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L139","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<IO::FileDescriptor:\"\nif closed?\n  io << \"(closed)\"\nelse\n  (io << \" fd=\") << @fd\nend\nio << '>'\nio\n"}},{"id":"noecho(&block)-instance-method","html_id":"noecho(&amp;block)-instance-method","name":"noecho","doc":"Turn off character echoing for the duration of the given block.\nThis will prevent displaying back to the user what they enter on the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.\n\n```\nprint \"Enter password: \"\npassword = STDIN.noecho &.gets.try &.chomp\nputs\n```","summary":"<p>Turn off character echoing for the duration of the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L15","def":{"name":"noecho","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"preserving_tc_mode(\"can't set IO#noecho\") do |mode|\n  noecho_from_tc_mode!\n  yield self\nend"}},{"id":"noecho!-instance-method","html_id":"noecho!-instance-method","name":"noecho!","doc":"Turn off character echoing for this IO.\nThis will prevent displaying back to the user what they enter on the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Turn off character echoing for this IO.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L25","def":{"name":"noecho!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(Errno.new(\"can't set IO#noecho!\"))\nend\nnoecho_from_tc_mode!\n"}},{"id":"pos-instance-method","html_id":"pos-instance-method","name":"pos","doc":"Returns the current position (in bytes) in this `IO`.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos     # => 0\nfile.gets(2) # => \"he\"\nfile.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L99","def":{"name":"pos","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nsystem_pos - @in_buffer_rem.size\n"}},{"id":"pos=(value)-instance-method","html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) in this `IO`.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos = 3\nfile.gets_to_end # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L114","def":{"name":"pos=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"seek(value)\nvalue\n"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L150","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.text(inspect)"}},{"id":"raw(&block)-instance-method","html_id":"raw(&amp;block)-instance-method","name":"raw","doc":"Enable raw mode for the duration of the given block.\nIn raw mode every keypress is directly sent to the program, no interpretation\nis done by the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enable raw mode for the duration of the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L81","def":{"name":"raw","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"preserving_tc_mode(\"can't set IO#raw\") do |mode|\n  raw_from_tc_mode!\n  yield self\nend"}},{"id":"raw!-instance-method","html_id":"raw!-instance-method","name":"raw!","doc":"Enable raw mode for this IO.\nIn raw mode every keypress is directly sent to the program, no interpretation\nis done by the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enable raw mode for this IO.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L92","def":{"name":"raw!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(Errno.new(\"can't set IO#raw!\"))\nend\nraw_from_tc_mode!\n"}},{"id":"reopen(other:IO::FileDescriptor)-instance-method","html_id":"reopen(other:IO::FileDescriptor)-instance-method","name":"reopen","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"IO::FileDescriptor"}],"args_string":"(other : IO::FileDescriptor)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L133","def":{"name":"reopen","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"IO::FileDescriptor"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_reopen(other)\nother\n"}},{"id":"seek(offset,whence:Seek=Seek::Set)-instance-method","html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\nReturns `self`.\n\n```\nFile.write(\"testfile\", \"abc\")\n\nfile = File.new(\"testfile\")\nfile.gets(3) # => \"abc\"\nfile.seek(1, IO::Seek::Set)\nfile.gets(2) # => \"bc\"\nfile.seek(-1, IO::Seek::Current)\nfile.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L64","def":{"name":"seek","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nflush\nif whence.current?\n  offset = offset - @in_buffer_rem.size\nend\nsystem_seek(offset, whence)\n@in_buffer_rem = Bytes.empty\nself\n"}},{"id":"seek(offset,whence:Seek=Seek::Set,&block)-instance-method","html_id":"seek(offset,whence:Seek=Seek::Set,&amp;block)-instance-method","name":"seek","doc":"Same as `seek` but yields to the block after seeking and eventually seeks\nback to the original position when the block returns.","summary":"<p>Same as <code><a href=\"../IO/FileDescriptor.html#seek%28offset%2Cwhence%3ASeek%3DSeek%3A%3ASet%29-instance-method\">#seek</a></code> but yields to the block after seeking and eventually seeks back to the original position when the block returns.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L79","def":{"name":"seek","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"original_pos = tell\nbegin\n  seek(offset, whence)\n  yield\nensure\n  seek(original_pos)\nend\n"}},{"id":"tty?-instance-method","html_id":"tty?-instance-method","name":"tty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/file_descriptor.cr#L129","def":{"name":"tty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"system_tty?"}}],"macros":[{"id":"cooked_from_tc_mode!-macro","html_id":"cooked_from_tc_mode!-macro","name":"cooked_from_tc_mode!","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L61","def":{"name":"cooked_from_tc_mode!","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    mode.c_iflag |= (Termios::InputMode::BRKINT |\n                    Termios::InputMode::ISTRIP |\n                    Termios::InputMode::ICRNL  |\n                    Termios::InputMode::IXON).value\n    mode.c_oflag |= Termios::OutputMode::OPOST.value\n    mode.c_lflag |= (Termios::LocalMode::ECHO   |\n                    Termios::LocalMode::ECHOE  |\n                    Termios::LocalMode::ECHOK  |\n                    Termios::LocalMode::ECHONL |\n                    Termios::LocalMode::ICANON |\n                    Termios::LocalMode::ISIG   |\n                    Termios::LocalMode::IEXTEN).value\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}},{"id":"noecho_from_tc_mode!-macro","html_id":"noecho_from_tc_mode!-macro","name":"noecho_from_tc_mode!","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L32","def":{"name":"noecho_from_tc_mode!","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    mode.c_lflag &= ~(Termios::LocalMode.flags(ECHO, ECHOE, ECHOK, ECHONL).value)\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}},{"id":"raw_from_tc_mode!-macro","html_id":"raw_from_tc_mode!-macro","name":"raw_from_tc_mode!","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/console.cr#L100","def":{"name":"raw_from_tc_mode!","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    LibC.cfmakeraw(pointerof(mode))\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Hexdump","path":"IO/Hexdump.html","kind":"class","full_name":"IO::Hexdump","name":"Hexdump","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/hexdump.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"IO object that prints an hexadecimal dump of all transfered data.\n\nEspecially useful for debugging binary protocols on an IO, to understand\nbetter when and how data is sent or received.\n\nBy default `IO::Hexdump` won't print anything; you must specify which of\n`read`, `write` or both you want to print.\n\nExample:\n```\nrequire \"io/hexdump\"\nsocket = IO::Memory.new(\"abc\")\nio = IO::Hexdump.new(socket, output: STDERR, read: true)\n```\n\nWhen data is read from *io* it will print something akin to the following on\nSTDERR:\n```text\n00000000  50 52 49 20 2a 20 48 54  54 50 2f 32 2e 30 0d 0a  PRI * HTTP/2.0..\n00000010  0d 0a 53 4d 0d 0a 0d 0a                           ..SM....\n00000000  00 00 00 04                                       ....\n00000000  00                                                .\n00000000  00 00 00 00                                       ....\n```","summary":"<p>IO object that prints an hexadecimal dump of all transfered data.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,output:IO=STDERR,read=false,write=false)-class-method","html_id":"new(io:IO,output:IO=STDERR,read=false,write=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"output","doc":null,"default_value":"STDERR","external_name":"output","restriction":"IO"},{"name":"read","doc":null,"default_value":"false","external_name":"read","restriction":""},{"name":"write","doc":null,"default_value":"false","external_name":"write","restriction":""}],"args_string":"(io : IO, output : IO = <span class=\"t\">STDERR</span>, read = <span class=\"n\">false</span>, write = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L26","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"output","doc":null,"default_value":"STDERR","external_name":"output","restriction":"IO"},{"name":"read","doc":null,"default_value":"false","external_name":"read","restriction":""},{"name":"write","doc":null,"default_value":"false","external_name":"write","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, output, read, write)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L51","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.close"}},{"id":"closed?-instance-method","html_id":"closed?-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L47","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.closed?"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L55","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.flush"}},{"id":"peek-instance-method","html_id":"peek-instance-method","name":"peek","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L43","def":{"name":"peek","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.peek"}},{"id":"read(buf:Bytes)-instance-method","html_id":"read(buf:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L29","def":{"name":"read","args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@io.read(buf)).tap do |read_bytes|\n  if @read && read_bytes\n    @output.puts(buf[0, read_bytes].hexdump)\n  end\nend"}},{"id":"tty?-instance-method","html_id":"tty?-instance-method","name":"tty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L59","def":{"name":"tty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.tty?"}},{"id":"write(buf:Bytes)-instance-method","html_id":"write(buf:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/hexdump.cr#L35","def":{"name":"write","args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if buf.empty?\n  return\nend\n(@io.write(buf)).tap do\n  if @write\n    @output.puts(buf.hexdump)\n  end\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Memory","path":"IO/Memory.html","kind":"class","full_name":"IO::Memory","name":"Memory","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/memory.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that reads and writes from a buffer in memory.\n\nThe internal buffer can be resizeable and/or writeable depending\non how an `IO::Memory` is constructed.","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that reads and writes from a buffer in memory.</p>","class_methods":[],"constructors":[{"id":"new(capacity:Int=64)-class-method","html_id":"new(capacity:Int=64)-class-method","name":"new","doc":"Creates an empty, resizeable and writeable `IO::Memory` with the given\ninitialize capactiy for the internal buffer.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(1)\nio.pos         # => 0\nio.read(slice) # => 0\nslice          # => Bytes[0]\n```","summary":"<p>Creates an empty, resizeable and writeable <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> with the given initialize capactiy for the internal buffer.</p>","abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = <span class=\"n\">64</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L24","def":{"name":"new","args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(string:String)-class-method","html_id":"new(string:String)-class-method","name":"new","doc":"Creates an `IO::Memory` whose contents are the exact contents of *string*.\nThe created `IO::Memory` is non-resizeable and non-writeable.\n\nThe `IO` starts at position zero for reading.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos        # => 0\nio.gets(2)    # => \"he\"\nio.print \"hi\" # raises IO::Error\n```","summary":"<p>Creates an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> whose contents are the exact contents of <em>string</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L68","def":{"name":"new","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(string.to_slice, writeable: false)"}},{"id":"new(slice:Bytes,writeable=true)-class-method","html_id":"new(slice:Bytes,writeable=true)-class-method","name":"new","doc":"Creates an `IO::Memory` that will read, and optionally write, from/to\nthe given slice. The created `IO::Memory` is non-resizeable.\n\nThe IO starts at position zero for reading.\n\n```\nslice = Slice.new(6) { |i| ('a'.ord + i).to_u8 }\nio = IO::Memory.new slice, writeable: false\nio.pos            # => 0\nio.read(slice)    # => 6\nString.new(slice) # => \"abcdef\"\n```","summary":"<p>Creates an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> that will read, and optionally write, from/to the given slice.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"writeable","doc":null,"default_value":"true","external_name":"writeable","restriction":""}],"args_string":"(slice : Bytes, writeable = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L48","def":{"name":"new","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"writeable","doc":null,"default_value":"true","external_name":"writeable","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(slice, writeable)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"buffer:Pointer(UInt8)-instance-method","html_id":"buffer:Pointer(UInt8)-instance-method","name":"buffer","doc":"Returns the internal buffer as a `Pointer(UInt8)`.","summary":"<p>Returns the internal buffer as a <code><a href=\"../Pointer.html\">Pointer</a>(<a href=\"../UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"args":[],"args_string":" : Pointer(UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L7","def":{"name":"buffer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Pointer(UInt8)","visibility":"Public","body":"@buffer"}},{"id":"bytesize:Int32-instance-method","html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Same as `size`.","summary":"<p>Same as <code><a href=\"../IO/Memory.html#size%3AInt32-instance-method\">#size</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L10","def":{"name":"bytesize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"id":"clear-instance-method","html_id":"clear-instance-method","name":"clear","doc":"Clears the internal buffer and resets the position to zero.\nRaises if this `IO::Memory` is non-resizeable.\n\n```\nio = IO::Memory.new\nio << \"abc\"\nio.rewind\nio.gets(1) # => \"a\"\nio.clear\nio.pos         # => 0\nio.gets_to_end # => \"\"\n\nio = IO::Memory.new \"hello\"\nio.clear # raises IO::Error\n```","summary":"<p>Clears the internal buffer and resets the position to zero.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L247","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncheck_resizeable\n@bytesize = 0\n@pos = 0\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this `IO`. Further operations on this `IO` will raise an `IO::Error`.\n\n```\nio = IO::Memory.new \"hello\"\nio.close\nio.gets_to_end # raises IO::Error (closed stream)\n```","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L377","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L377","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed = true"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Determines if this `IO` is closed.\n\n```\nio = IO::Memory.new \"hello\"\nio.closed? # => false\nio.close\nio.closed? # => true\n```","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L389","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L389","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if this `IO::Memory` has no contents.\n\n```\nio = IO::Memory.new\nio.empty? # => true\nio.print \"hello\"\nio.empty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> has no contents.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L262","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytesize == 0"}},{"id":"pos:Int32-instance-method","html_id":"pos:Int32-instance-method","name":"pos","doc":"Returns the current position (in bytes) of this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos     # => 0\nio.gets(2) # => \"he\"\nio.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) of this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L322","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L322","def":{"name":"pos","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pos"}},{"id":"pos=(value)-instance-method","html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) of this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos = 3\nio.gets # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) of this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L333","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L333","def":{"name":"pos=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if value < 0\n  raise(ArgumentError.new(\"Negative pos\"))\nend\n@pos = value.to_i\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"See `IO#read(slice)`.","summary":"<p>See <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L73","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncount = slice.size\ncount = Math.min(count, @bytesize - @pos)\nslice.copy_from(@buffer + @pos, count)\n@pos = @pos + count\ncount\n"}},{"id":"read_at(offset,bytesize,&block)-instance-method","html_id":"read_at(offset,bytesize,&amp;block)-instance-method","name":"read_at","doc":"Yields an `IO::Memory` to read a section of this `IO`'s buffer.\n\nDuring the block duration `self` becomes read-only,\nso multiple concurrent open are allowed.","summary":"<p>Yields an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> to read a section of this <code><a href=\"../IO.html\">IO</a></code>'s buffer.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L343","def":{"name":"read_at","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= offset && offset <= @bytesize\nelse\n  raise(ArgumentError.new(\"Offset out of bounds\"))\nend\nif bytesize < 0\n  raise(ArgumentError.new(\"Negative bytesize\"))\nend\nif 0 <= (__temp_2 = offset + bytesize) && __temp_2 <= @bytesize\nelse\n  raise(ArgumentError.new(\"Bytesize out of bounds\"))\nend\nold_writeable = @writeable\nold_resizeable = @resizeable\nio = IO::Memory.new(to_slice[offset, bytesize], writeable: false)\nbegin\n  @writeable = false\n  @resizeable = false\n  yield io\nensure\n  io.close\n  @writeable = old_writeable\n  @resizeable = old_resizeable\nend\n"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds this `IO` to the initial position (zero).\n\n```\nio = IO::Memory.new \"hello\"\nio.gets(2) # => \"he\"\nio.rewind\nio.gets(2) # => \"he\"\n```","summary":"<p>Rewinds this <code><a href=\"../IO.html\">IO</a></code> to the initial position (zero).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L274","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pos = 0\nself\n"}},{"id":"seek(offset,whence:Seek=Seek::Set)-instance-method","html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\n\n```\nio = IO::Memory.new(\"abcdef\")\nio.gets(3) # => \"abc\"\nio.seek(1, IO::Seek::Set)\nio.gets(2) # => \"bc\"\nio.seek(-1, IO::Seek::Current)\nio.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L299","def":{"name":"seek","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"whence","doc":null,"default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncase whence\nwhen Seek::Set\nwhen Seek::Current\n  offset = offset + @pos\nwhen Seek::End\n  offset = offset + @bytesize\nend\nself.pos = offset\n"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":"Returns the total number of bytes in this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.size # => 5\n```","summary":"<p>Returns the total number of bytes in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L285","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytesize"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Appends this internal buffer to the given `IO`.","summary":"<p>Appends this internal buffer to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L417","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L417","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io.write(to_slice)"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns a new `String` that contains the contents of the internal buffer.\n\n```\nio = IO::Memory.new\nio.print 1, 2, 3\nio.to_s # => \"123\"\n```","summary":"<p>Returns a new <code><a href=\"../String.html\">String</a></code> that contains the contents of the internal buffer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L400","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(@buffer, @bytesize)"}},{"id":"to_slice:Bytes-instance-method","html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns the underlying bytes.\n\n```\nio = IO::Memory.new\nio.print \"hello\"\n\nio.to_slice # => Bytes[104, 101, 108, 108, 111]\n```","summary":"<p>Returns the underlying bytes.</p>","abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L412","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L412","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"Slice.new(@buffer, @bytesize, read_only: !@writeable)"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"See `IO#write(slice)`. Raises if this `IO::Memory` is non-writeable,\nor if it's non-resizeable and a resize is needed.","summary":"<p>See <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L85","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writeable\ncheck_open\ncount = slice.size\nif count == 0\n  return\nend\nnew_bytesize = @pos + count\nif new_bytesize > @capacity\n  check_resizeable\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\nslice.copy_to(@buffer + @pos, count)\nif @pos > @bytesize\n  (@buffer + @bytesize).clear(@pos - @bytesize)\nend\n@pos = @pos + count\nif @pos > @bytesize\n  @bytesize = @pos\nend\nnil\n"}},{"id":"write_byte(byte:UInt8)-instance-method","html_id":"write_byte(byte:UInt8)-instance-method","name":"write_byte","doc":"See `IO#write_byte`. Raises if this `IO::Memory` is non-writeable,\nor if it's non-resizeable and a resize is needed.","summary":"<p>See <code><a href=\"../IO.html#write_byte%28byte%3AUInt8%29-instance-method\">IO#write_byte</a></code>.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/memory.cr#L113","def":{"name":"write_byte","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writeable\ncheck_open\nnew_bytesize = @pos + 1\nif new_bytesize > @capacity\n  check_resizeable\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\n(@buffer + @pos).value = byte\nif @pos > @bytesize\n  (@buffer + @bytesize).clear(@pos - @bytesize)\nend\n@pos = @pos + 1\nif @pos > @bytesize\n  @bytesize = @pos\nend\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/MultiWriter","path":"IO/MultiWriter.html","kind":"class","full_name":"IO::MultiWriter","name":"MultiWriter","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/multi_writer.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` which writes to a number of underlying writer IOs.\n\n```\nio1 = IO::Memory.new\nio2 = IO::Memory.new\nwriter = IO::MultiWriter.new(io1, io2)\nwriter.puts \"foo bar\"\nio1.to_s # => \"foo bar\\n\"\nio2.to_s # => \"foo bar\\n\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> which writes to a number of underlying writer IOs.</p>","class_methods":[],"constructors":[{"id":"new(writers:Array(IO),sync_close=false)-class-method","html_id":"new(writers:Array(IO),sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::MultiWriter` which writes to *writers*. If\n*sync_close* is set, calling `#close` calls `#close` on all underlying\nwriters.","summary":"<p>Creates a new <code><a href=\"../IO/MultiWriter.html\">IO::MultiWriter</a></code> which writes to <em>writers</em>.</p>","abstract":false,"args":[{"name":"writers","doc":null,"default_value":"","external_name":"writers","restriction":"Array(IO)"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(writers : Array(IO), sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L22","def":{"name":"new","args":[{"name":"writers","doc":null,"default_value":"","external_name":"writers","restriction":"Array(IO)"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(writers, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(*writers:IO,sync_close=false)-class-method","html_id":"new(*writers:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::MultiWriter` which writes to *writers*. If\n*sync_close* is set, calling `#close` calls `#close` on all underlying\nwriters.","summary":"<p>Creates a new <code><a href=\"../IO/MultiWriter.html\">IO::MultiWriter</a></code> which writes to <em>writers</em>.</p>","abstract":false,"args":[{"name":"writers","doc":null,"default_value":"","external_name":"writers","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(*writers : IO, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L28","def":{"name":"new","args":[{"name":"writers","doc":null,"default_value":"","external_name":"writers","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(*writers, sync_close: sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L44","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif sync_close?\n  @writers.each do |writer|\n    writer.close\n  end\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L15","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L40","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from IO::MultiWriter\"))"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close all of the underlying\nIOs.","summary":"<p>If <code><a href=\"../IO/MultiWriter.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close all of the underlying IOs.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L14","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close all of the underlying\nIOs.","summary":"<p>If <code><a href=\"../IO/MultiWriter.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close all of the underlying IOs.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L14","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/multi_writer.cr#L32","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@writers.each do |writer|\n  writer.write(slice)\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Seek","path":"IO/Seek.html","kind":"enum","full_name":"IO::Seek","name":"Seek","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io.cr","line_number":63,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Set","name":"Set","value":"0","doc":"Seeks to an absolute location","summary":"<p>Seeks to an absolute location</p>"},{"id":"Current","name":"Current","value":"1","doc":"Seeks to a location relative to the current location\nin the stream","summary":"<p>Seeks to a location relative to the current location in the stream</p>"},{"id":"End","name":"End","value":"2","doc":"Seeks to a location relative to the end of the stream\n(you probably want a negative value for the amount)","summary":"<p>Seeks to a location relative to the end of the stream (you probably want a negative value for the amount)</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Argument to a `seek` operation.","summary":"<p>Argument to a <code>seek</code> operation.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"current?-instance-method","html_id":"current?-instance-method","name":"current?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L69","def":{"name":"current?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Current"}},{"id":"end?-instance-method","html_id":"end?-instance-method","name":"end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L73","def":{"name":"end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == End"}},{"id":"set?-instance-method","html_id":"set?-instance-method","name":"set?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr#L65","def":{"name":"set?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Set"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Sized","path":"IO/Sized.html","kind":"class","full_name":"IO::Sized","name":"Sized","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/sized.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that wraps another `IO`, setting a limit for the number of bytes that can be read.\n\n```\nio = IO::Memory.new \"abcde\"\nsized = IO::Sized.new(io, read_size: 3)\n\nsized.gets_to_end # => \"abc\"\nsized.gets_to_end # => \"\"\nio.gets_to_end    # => \"de\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that wraps another <code><a href=\"../IO.html\">IO</a></code>, setting a limit for the number of bytes that can be read.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,read_size:Int,sync_close=false)-class-method","html_id":"new(io:IO,read_size:Int,sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::Sized` which wraps *io*, and can read a maximum of\n*read_size* bytes. If *sync_close* is set, calling `#close` calls\n`#close` on the underlying `IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Sized.html\">IO::Sized</a></code> which wraps <em>io</em>, and can read a maximum of <em>read_size</em> bytes.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_size","doc":null,"default_value":"","external_name":"read_size","restriction":"Int"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, read_size : Int, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L22","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"read_size","doc":null,"default_value":"","external_name":"read_size","restriction":"Int"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, read_size, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L79","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L17","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@closed"}},{"id":"peek-instance-method","html_id":"peek-instance-method","name":"peek","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L49","def":{"name":"peek","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif @read_remaining == 0\n  return Bytes.empty\nend\npeek = @io.peek\nif peek\nelse\n  return nil\nend\nif @read_remaining < peek.size\n  peek = peek[0, @read_remaining]\nend\npeek\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L28","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncount = {slice.size.to_u64, @read_remaining}.min\nbytes_read = @io.read(slice[0, count])\n@read_remaining = @read_remaining - bytes_read\nbytes_read\n"}},{"id":"read_byte-instance-method","html_id":"read_byte-instance-method","name":"read_byte","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L37","def":{"name":"read_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif @read_remaining > 0\n  byte = @io.read_byte\n  if byte\n    @read_remaining = @read_remaining - 1\n  end\n  byte\nelse\n  nil\nend\n"}},{"id":"read_remaining:UInt64-instance-method","html_id":"read_remaining:UInt64-instance-method","name":"read_remaining","doc":"The number of remaining bytes to be read.","summary":"<p>The number of remaining bytes to be read.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L16","def":{"name":"read_remaining","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"@read_remaining"}},{"id":"skip(bytes_count):Nil-instance-method","html_id":"skip(bytes_count):Nil-instance-method","name":"skip","doc":null,"summary":null,"abstract":false,"args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":""}],"args_string":"(bytes_count) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L64","def":{"name":"skip","args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\nif bytes_count <= @read_remaining\n  @io.skip(bytes_count)\n  @read_remaining = @read_remaining - bytes_count\nelse\n  raise(IO::EOFError.new)\nend\n"}},{"id":"sync_close=(sync_close:Bool)-instance-method","html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Sized.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L13","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Sized.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L13","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/sized.cr#L75","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to IO::Sized\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Stapled","path":"IO/Stapled.html","kind":"class","full_name":"IO::Stapled","name":"Stapled","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io/stapled.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"This class staples together two unidirectional `IO`s to form a single,\nbidirectional `IO`.\n\nExample (loopback):\n```\nio = IO::Stapled.new(*IO.pipe)\nio.puts \"linus\"\nio.gets # => \"linus\"\n```\n\nMost methods simply delegate to the underlying `IO`s.","summary":"<p>This class staples together two unidirectional <code><a href=\"../IO.html\">IO</a></code>s to form a single, bidirectional <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[{"id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false,&block)-class-method","html_id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false,&amp;block)-class-method","name":"pipe","doc":"Creates a pair of bidirectional pipe endpoints connected with each other\nand passes them to the given block.\n\nBoth endpoints and the underlying ÌO`s are closed after the block\n(even if `sync_close?` is `false`).","summary":"<p>Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.</p>","abstract":false,"args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"args_string":"(read_blocking : Bool = <span class=\"n\">false</span>, write_blocking : Bool = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L103","def":{"name":"pipe","args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"IO.pipe(read_blocking, write_blocking) do |a_read, a_write|\n  IO.pipe(read_blocking, write_blocking) do |b_read, b_write|\n    a, b = new(a_read, b_write, true), new(b_read, a_write, true)\n    begin\n      yield a, b\n    ensure\n      a.close\n      b.close\n    end\n  end\nend"}},{"id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false):Tuple(self,self)-class-method","html_id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false):Tuple(self,self)-class-method","name":"pipe","doc":"Creates a pair of bidirectional pipe endpoints connected with each other\nand returns them in a `Tuple`.","summary":"<p>Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a <code><a href=\"../Tuple.html\">Tuple</a></code>.</p>","abstract":false,"args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"args_string":"(read_blocking : Bool = <span class=\"n\">false</span>, write_blocking : Bool = <span class=\"n\">false</span>) : Tuple(self, self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L119","def":{"name":"pipe","args":[{"name":"read_blocking","doc":null,"default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","doc":null,"default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(self, self)","visibility":"Public","body":"a_read, a_write = IO.pipe(read_blocking, write_blocking)\nb_read, b_write = IO.pipe(read_blocking, write_blocking)\nreturn {new(a_read, b_write, true), new(b_read, a_write, true)}\n"}}],"constructors":[{"id":"new(reader:IO,writer:IO,sync_close:Bool=false)-class-method","html_id":"new(reader:IO,writer:IO,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Stapled` which reads from *reader*  and writes to *writer*-","summary":"<p>Creates a new <code><a href=\"../IO/Stapled.html\">IO::Stapled</a></code> which reads from <em>reader</em>  and writes to <em>writer</em>-</p>","abstract":false,"args":[{"name":"reader","doc":null,"default_value":"","external_name":"reader","restriction":"IO"},{"name":"writer","doc":null,"default_value":"","external_name":"writer","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(reader : IO, writer : IO, sync_close : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L22","def":{"name":"new","args":[{"name":"reader","doc":null,"default_value":"","external_name":"reader","restriction":"IO"},{"name":"writer","doc":null,"default_value":"","external_name":"writer","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(reader, writer, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close:Nil-instance-method","html_id":"close:Nil-instance-method","name":"close","doc":"Closes this ÌO`.\n\nIf `sync_close?` is `true`it will also close the underlying ÌO`s.","summary":"<p>Closes this ÌO`.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L88","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @reader.close\n  @writer.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\nUnderlying ÌO`s might have a different status.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L19","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@closed"}},{"id":"flush:self-instance-method","html_id":"flush:self-instance-method","name":"flush","doc":"`Flushes `writer`.","summary":"<p>`Flushes <code>writer</code>.</p>","abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L77","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"check_open\n@writer.flush\nself\n"}},{"id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","html_id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Gets a string from `reader`.","summary":"<p>Gets a string from <code>reader</code>.</p>","abstract":false,"args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, limit : Int, chomp = <span class=\"n\">false</span>) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L40","def":{"name":"gets","args":[{"name":"delimiter","doc":null,"default_value":"","external_name":"delimiter","restriction":"Char"},{"name":"limit","doc":null,"default_value":"","external_name":"limit","restriction":"Int"},{"name":"chomp","doc":null,"default_value":"false","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"check_open\n@reader.gets(delimiter, limit, chomp)\n"}},{"id":"peek:Bytes?-instance-method","html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Peeks into *reader*.","summary":"<p>Peeks into <em>reader</em>.</p>","abstract":false,"args":[],"args_string":" : Bytes?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L47","def":{"name":"peek","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes | ::Nil","visibility":"Public","body":"check_open\n@reader.peek\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Reads a slice from `reader`.","summary":"<p>Reads a slice from <code>reader</code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L33","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\n@reader.read(slice)\n"}},{"id":"read_byte:UInt8?-instance-method","html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from `reader`.","summary":"<p>Reads a single byte from <code>reader</code>.</p>","abstract":false,"args":[],"args_string":" : UInt8?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L26","def":{"name":"read_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8 | ::Nil","visibility":"Public","body":"check_open\n@reader.read_byte\n"}},{"id":"skip(bytes_count:Int):Nil-instance-method","html_id":"skip(bytes_count:Int):Nil-instance-method","name":"skip","doc":"Skips `reader`.","summary":"<p>Skips <code>reader</code>.</p>","abstract":false,"args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":"Int"}],"args_string":"(bytes_count : Int) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L54","def":{"name":"skip","args":[{"name":"bytes_count","doc":null,"default_value":"","external_name":"bytes_count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\n@reader.skip(bytes_count)\n"}},{"id":"sync_close=(sync_close:Bool)-instance-method","html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.","summary":"<p>If <code><a href=\"../IO/Stapled.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>s.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L14","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.","summary":"<p>If <code><a href=\"../IO/Stapled.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>s.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L14","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes):Nil-instance-method","html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes a slice to `writer`.","summary":"<p>Writes a slice to <code>writer</code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L68","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@writer.write(slice)\n"}},{"id":"write_byte(byte:UInt8):Nil-instance-method","html_id":"write_byte(byte:UInt8):Nil-instance-method","name":"write_byte","doc":"Writes a byte to `writer`.","summary":"<p>Writes a byte to <code>writer</code>.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/stapled.cr#L61","def":{"name":"write_byte","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\n@writer.write_byte(byte)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","path":"IO/Syscall.html","kind":"module","full_name":"IO::Syscall","name":"Syscall","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"io/syscall.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"read_syscall_helper(slice:Bytes,errno_msg:String,&block):Int32-instance-method","html_id":"read_syscall_helper(slice:Bytes,errno_msg:String,&amp;block):Int32-instance-method","name":"read_syscall_helper","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","doc":null,"default_value":"","external_name":"errno_msg","restriction":"String"}],"args_string":"(slice : Bytes, errno_msg : String, &block) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L45","def":{"name":"read_syscall_helper","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","doc":null,"default_value":"","external_name":"errno_msg","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"begin\n  loop do\n    bytes_read = yield\n    if bytes_read != -1\n      return bytes_read\n    end\n    if Errno.value == Errno::EAGAIN\n      wait_readable\n    else\n      raise(Errno.new(errno_msg))\n    end\n  end\nensure\n  if (readers = @readers) && (!readers.empty?)\n    add_read_event\n  end\nend"}},{"id":"read_timeout:Time::Span?-instance-method","html_id":"read_timeout:Time::Span?-instance-method","name":"read_timeout","doc":"Returns the time to wait when reading before raising an `IO::Timeout`.","summary":"<p>Returns the time to wait when reading before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[],"args_string":" : Time::Span?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L14","def":{"name":"read_timeout","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span | ::Nil","visibility":"Public","body":"@read_timeout"}},{"id":"read_timeout=(read_timeout:Number):Number-instance-method","html_id":"read_timeout=(read_timeout:Number):Number-instance-method","name":"read_timeout=","doc":"Set the number of seconds to wait when reading before raising an `IO::Timeout`.","summary":"<p>Set the number of seconds to wait when reading before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Number"}],"args_string":"(read_timeout : Number) : Number","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L24","def":{"name":"read_timeout=","args":[{"name":"read_timeout","doc":null,"default_value":"","external_name":"read_timeout","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Number","visibility":"Public","body":"self.read_timeout = read_timeout.seconds\nread_timeout\n"}},{"id":"read_timeout=(timeout:Time::Span?):Time::Span?-instance-method","html_id":"read_timeout=(timeout:Time::Span?):Time::Span?-instance-method","name":"read_timeout=","doc":"Sets the time to wait when reading before raising an `IO::Timeout`.","summary":"<p>Sets the time to wait when reading before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"timeout","doc":null,"default_value":"","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"args_string":"(timeout : Time::Span?) : Time::Span?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L19","def":{"name":"read_timeout=","args":[{"name":"timeout","doc":null,"default_value":"","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Time::Span | ::Nil","visibility":"Public","body":"@read_timeout = timeout"}},{"id":"write_syscall_helper(slice:Bytes,errno_msg:String,&block):Nil-instance-method","html_id":"write_syscall_helper(slice:Bytes,errno_msg:String,&amp;block):Nil-instance-method","name":"write_syscall_helper","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","doc":null,"default_value":"","external_name":"errno_msg","restriction":"String"}],"args_string":"(slice : Bytes, errno_msg : String, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L64","def":{"name":"write_syscall_helper","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","doc":null,"default_value":"","external_name":"errno_msg","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if slice.empty?\n  return\nend\nbegin\n  loop do\n    bytes_written = yield slice\n    if bytes_written != -1\n      slice = slice + bytes_written\n      if slice.size == 0\n        return\n      end\n    else\n      if Errno.value == Errno::EAGAIN\n        wait_writable\n      else\n        raise(Errno.new(errno_msg))\n      end\n    end\n  end\nensure\n  if (writers = @writers) && (!writers.empty?)\n    add_write_event\n  end\nend\n"}},{"id":"write_timeout:Time::Span?-instance-method","html_id":"write_timeout:Time::Span?-instance-method","name":"write_timeout","doc":"Returns the time to wait when writing before raising an `IO::Timeout`.","summary":"<p>Returns the time to wait when writing before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[],"args_string":" : Time::Span?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L30","def":{"name":"write_timeout","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span | ::Nil","visibility":"Public","body":"@write_timeout"}},{"id":"write_timeout=(write_timeout:Number):Number-instance-method","html_id":"write_timeout=(write_timeout:Number):Number-instance-method","name":"write_timeout=","doc":"Set the number of seconds to wait when writing before raising an `IO::Timeout`.","summary":"<p>Set the number of seconds to wait when writing before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"write_timeout","doc":null,"default_value":"","external_name":"write_timeout","restriction":"Number"}],"args_string":"(write_timeout : Number) : Number","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L40","def":{"name":"write_timeout=","args":[{"name":"write_timeout","doc":null,"default_value":"","external_name":"write_timeout","restriction":"Number"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Number","visibility":"Public","body":"self.write_timeout = write_timeout.seconds\nwrite_timeout\n"}},{"id":"write_timeout=(timeout:Time::Span?):Time::Span?-instance-method","html_id":"write_timeout=(timeout:Time::Span?):Time::Span?-instance-method","name":"write_timeout=","doc":"Sets the time to wait when writing before raising an `IO::Timeout`.","summary":"<p>Sets the time to wait when writing before raising an <code><a href=\"../IO/Timeout.html\">IO::Timeout</a></code>.</p>","abstract":false,"args":[{"name":"timeout","doc":null,"default_value":"","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"args_string":"(timeout : Time::Span?) : Time::Span?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io/syscall.cr#L35","def":{"name":"write_timeout=","args":[{"name":"timeout","doc":null,"default_value":"","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Time::Span | ::Nil","visibility":"Public","body":"@write_timeout = timeout"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/IO/Timeout","path":"IO/Timeout.html","kind":"class","full_name":"IO::Timeout","name":"Timeout","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"io.cr","line_number":86,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/io.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Raised when an `IO` operation times out.\n\n```\nSTDIN.read_timeout = 1\nSTDIN.gets # raises IO::Timeout (after 1 second)\n```","summary":"<p>Raised when an <code><a href=\"../IO.html\">IO</a></code> operation times out.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/IPSocket","path":"IPSocket.html","kind":"class","full_name":"IPSocket","name":"IPSocket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/ip_socket.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/ip_socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},{"html_id":"github.com/crystal-lang/crystal/UDPSocket","kind":"class","full_name":"UDPSocket","name":"UDPSocket"}],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"local_address-instance-method","html_id":"local_address-instance-method","name":"local_address","doc":"Returns the `IPAddress` for the local end of the IP socket.","summary":"<p>Returns the <code><a href=\"Socket/IPAddress.html\">IPAddress</a></code> for the local end of the IP socket.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/ip_socket.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/ip_socket.cr#L3","def":{"name":"local_address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sockaddr6 = uninitialized LibC::SockaddrIn6\nsockaddr = (pointerof(sockaddr6)).as(::Pointer(LibC::Sockaddr))\naddrlen = LibC::SocklenT.new(sizeof(LibC::SockaddrIn6))\nif (LibC.getsockname(fd, sockaddr, pointerof(addrlen))) != 0\n  raise(Errno.new(\"getsockname\"))\nend\nIPAddress.from(sockaddr, addrlen)\n"}},{"id":"remote_address-instance-method","html_id":"remote_address-instance-method","name":"remote_address","doc":"Returns the `IPAddress` for the remote end of the IP socket.","summary":"<p>Returns the <code><a href=\"Socket/IPAddress.html\">IPAddress</a></code> for the remote end of the IP socket.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/ip_socket.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/ip_socket.cr#L16","def":{"name":"remote_address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sockaddr6 = uninitialized LibC::SockaddrIn6\nsockaddr = (pointerof(sockaddr6)).as(::Pointer(LibC::Sockaddr))\naddrlen = LibC::SocklenT.new(sizeof(LibC::SockaddrIn6))\nif (LibC.getpeername(fd, sockaddr, pointerof(addrlen))) != 0\n  raise(Errno.new(\"getpeername\"))\nend\nIPAddress.from(sockaddr, addrlen)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Iterable","path":"Iterable.html","kind":"module","full_name":"Iterable(T)","name":"Iterable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"iterable.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"github.com/crystal-lang/crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable(T)","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"github.com/crystal-lang/crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"}],"namespace":null,"doc":"The `Iterable` mixin provides convenience methods to collection classes\nthat provide an `each` method that returns an `Iterator` over the collection.","summary":"<p>The <code><a href=\"Iterable.html\">Iterable</a></code> mixin provides convenience methods to collection classes that provide an <code><a href=\"Iterable.html#each-instance-method\">#each</a></code> method that returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the collection.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"chunk(reuse=false,&block:T->U)forallU-instance-method","html_id":"chunk(reuse=false,&amp;block:T-&gt;U)forallU-instance-method","name":"chunk","doc":"Returns an Iterator that enumerates over the items, chunking them together\nbased on the return value of the block.\n\n```\n(0..7).chunk(&./(3)).to_a # => [{0, [0, 1, 2]}, {1, [3, 4, 5]}, {2, [6, 7]}]\n```\n\nSee also: `Iterator#chunks`.","summary":"<p>Returns an Iterator that enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"args":[{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(reuse = <span class=\"n\">false</span>, &block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L25","def":{"name":"chunk","args":[{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"each.chunk(reuse, &block)"}},{"id":"cycle(n)-instance-method","html_id":"cycle(n)-instance-method","name":"cycle","doc":"Same as `each.cycle(n)`.","summary":"<p>Same as <code>each<a href=\"Iterable.html#cycle%28n%29-instance-method\">.cycle(n)</a></code>.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L13","def":{"name":"cycle","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.cycle(n)"}},{"id":"cycle-instance-method","html_id":"cycle-instance-method","name":"cycle","doc":"Same as `each.cycle`.","summary":"<p>Same as <code>each<a href=\"Iterable.html#cycle-instance-method\">.cycle</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L8","def":{"name":"cycle","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.cycle"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Must return an `Iterator` over the elements in this collection.","summary":"<p>Must return an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements in this collection.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L5","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"each_cons(count:Int,reuse=false)-instance-method","html_id":"each_cons(count:Int,reuse=false)-instance-method","name":"each_cons","doc":"Same as `each.cons(count)`.","summary":"<p>Same as <code>each.cons(count)</code>.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L35","def":{"name":"each_cons","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.cons(count, reuse)"}},{"id":"each_slice(count:Int,reuse=false)-instance-method","html_id":"each_slice(count:Int,reuse=false)-instance-method","name":"each_slice","doc":"Same as `each.slice(count, reuse)`.","summary":"<p>Same as <code>each.slice(count, reuse)</code>.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L30","def":{"name":"each_slice","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.slice(count, reuse)"}},{"id":"each_with_index(offset=0)-instance-method","html_id":"each_with_index(offset=0)-instance-method","name":"each_with_index","doc":"Same as `each.with_index(offset)`.","summary":"<p>Same as <code>each.with_index(offset)</code>.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L40","def":{"name":"each_with_index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.with_index(offset)"}},{"id":"each_with_object(obj)-instance-method","html_id":"each_with_object(obj)-instance-method","name":"each_with_object","doc":"Same as `each.with_object(obj)`.","summary":"<p>Same as <code>each.with_object(obj)</code>.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterable.cr#L45","def":{"name":"each_with_object","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.with_object(obj)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Iterator","path":"Iterator.html","kind":"module","full_name":"Iterator(T)","name":"Iterator","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"locations":[{"filename":"iterator.cr","line_number":75,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"An `Iterator` allows processing sequences lazily, as opposed to `Enumerable` which processes\nsequences eagerly and produces an `Array` in most of its methods.\n\nAs an example, let's compute the first three numbers in the range `1..10_000_000` that are even,\nmultiplied by three. One way to do this is:\n\n```\n(1..10_000_000).select(&.even?).map { |x| x * 3 }.first(3) # => [6, 12, 18]\n```\n\nThe above works, but creates many intermediate arrays: one for the *select* call,\none for the *map* call and one for the *take* call. A more efficient way is to invoke\n`Range#each` without a block, which gives us an `Iterator` so we can process the operations\nlazily:\n\n```\n(1..10_000_000).each.select(&.even?).map { |x| x * 3 }.first(3) # => #< Iterator(T)::First...\n```\n\n`Iterator` redefines many of `Enumerable`'s method in a lazy way, returning iterators\ninstead of arrays.\n\nAt the end of the call chain we get back a new iterator: we need to consume it, either\nusing `each` or `Enumerable#to_a`:\n\n```\n(1..10_000_000).each.select(&.even?).map { |x| x * 3 }.first(3).to_a # => [6, 12, 18]\n```\n\nTo implement an `Iterator` you need to define a `next` method that must return the next\nelement in the sequence or `Iterator::Stop::INSTANCE`, which signals the end of the sequence\n(you can invoke `stop` inside an iterator as a shortcut).\n\nAdditionally, an `Iterator` can implement `rewind`, which must rewind the iterator to\nits initial state. This is needed to implement the `cycle` method.\n\nFor example, this is an iterator that returns a sequence of `N` zeros:\n\n```\nclass Zeros\n  include Iterator(Int32)\n\n  def initialize(@size : Int32)\n    @produced = 0\n  end\n\n  def next\n    if @produced < @size\n      @produced += 1\n      0\n    else\n      stop\n    end\n  end\n\n  def rewind\n    @produced = 0\n    self\n  end\nend\n\nzeros = Zeros.new(5)\nzeros.to_a # => [0, 0, 0, 0, 0]\n\nzeros.rewind\nzeros.first(3).to_a # => [0, 0, 0]\n```\n\nThe standard library provides iterators for many classes, like `Array`, `Hash`, `Range`, `String` and `IO`.\nUsually to get an iterator you invoke a method that would usually yield elements to a block,\nbut without passing a block: `Array#each`, `Array#each_index`, `Hash#each`, `String#each_char`,\n`IO#each_line`, etc.","summary":"<p>An <code><a href=\"Iterator.html\">Iterator</a></code> allows processing sequences lazily, as opposed to <code><a href=\"Enumerable.html\">Enumerable</a></code> which processes sequences eagerly and produces an <code><a href=\"Array.html\">Array</a></code> in most of its methods.</p>","class_methods":[{"id":"of(element:T)-class-method","html_id":"of(element:T)-class-method","name":"of","doc":null,"summary":null,"abstract":false,"args":[{"name":"element","doc":null,"default_value":"","external_name":"element","restriction":"T"}],"args_string":"(element : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L114","def":{"name":"of","args":[{"name":"element","doc":null,"default_value":"","external_name":"element","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Singleton(T).new(element)"}},{"id":"of(&block:->T)-class-method","html_id":"of(&amp;block:-&gt;T)-class-method","name":"of","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block :  -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L133","def":{"name":"of","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(-> T)"},"return_type":"","visibility":"Public","body":"SingletonProc(typeof(without_stop(&block))).new(block)"}},{"id":"stop-class-method","html_id":"stop-class-method","name":"stop","doc":"Shortcut for `Iterator::Stop::INSTANCE`, to signal that there are no more elements in an iterator.","summary":"<p>Shortcut for <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code>, to signal that there are no more elements in an iterator.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L110","def":{"name":"stop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Stop::INSTANCE"}}],"constructors":[],"instance_methods":[{"id":"chain(other:Iterator(U))forallU-instance-method","html_id":"chain(other:Iterator(U))forallU-instance-method","name":"chain","doc":"Returns an iterator that returns elements from the original iterator until\nit is exhausted and then returns the elements of the second iterator.\n\n```\niter = (1..2).each.chain(('a'..'b').each)\niter.next # => 1\niter.next # => 2\niter.next # => 'a'\niter.next # => 'b'\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns elements from the original iterator until it is exhausted and then returns the elements of the second iterator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Iterator(U)"}],"args_string":"(other : Iterator(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L172","def":{"name":"chain","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Iterator(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Chain(typeof(self), typeof(other), T, U).new(self, other)"}},{"id":"chunk(reuse=false,&block:T->U)forallT,U-instance-method","html_id":"chunk(reuse=false,&amp;block:T-&gt;U)forallT,U-instance-method","name":"chunk","doc":"Returns an Iterator that enumerates over the items,\nchunking them together based on the return value of the block.\n\nConsecutive elements which return the same block value are chunked together.\n\nFor example, consecutive even numbers and odd numbers can be chunked as follows.\n\n```\n[3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5].chunk(&.even?).each do |even, ary|\n  p [even, ary]\nend\n\n# => [false, [3, 1]]\n#    [true, [4]]\n#    [false, [1, 5, 9]]\n#    [true, [2, 6]]\n#    [false, [5, 3, 5]]\n```\n\nThe following key values have special meaning:\n\n* `Enumerable::Chunk::Drop` specifies that the elements should be dropped\n* `Enumerable::Chunk::Alone` specifies that the element should be chunked by itself\n\nBy default, a new array is created and yielded for each chunk when invoking `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nSee also: `Enumerable#chunks`.","summary":"<p>Returns an Iterator that enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"args":[{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(reuse = <span class=\"n\">false</span>, &block : T -> U) forall T, U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1188","def":{"name":"chunk","args":[{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Chunk(typeof(self), T, U).new(self, reuse, &block)"}},{"id":"compact_map(&func:T->_)-instance-method","html_id":"compact_map(&amp;func:T-&gt;_)-instance-method","name":"compact_map","doc":"Return an iterator that applies the given function to the element and then\nreturns it unless it is `nil`. If the returned value would be `nil` it instead\nreturns the next non `nil` value.\n\n```\niter = [1, nil, 2, nil].each.compact_map { |e| e.try &.*(2) }\niter.next # => 2\niter.next # => 4\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Return an iterator that applies the given function to the element and then returns it unless it is <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"(&func : T -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L213","def":{"name":"compact_map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> _)"},"return_type":"","visibility":"Public","body":"CompactMap(typeof(self), T, typeof((func.call(first)).not_nil!)).new(self, func)"}},{"id":"cons(n:Int,reuse=false)-instance-method","html_id":"cons(n:Int,reuse=false)-instance-method","name":"cons","doc":"Returns an iterator that returns consecutive chunks of the size *n*.\n\n```\niter = (1..5).each.cons(3)\niter.next # => [1, 2, 3]\niter.next # => [2, 3, 4]\niter.next # => [3, 4, 5]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each consecutive when invoking `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that returns consecutive chunks of the size <em>n</em>.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n : Int, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L251","def":{"name":"cons","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n <= 0\n  raise(ArgumentError.new(\"Invalid cons size: #{n}\"))\nend\nCons(typeof(self), T, typeof(n)).new(self, n, reuse)\n"}},{"id":"cycle(n:Int)-instance-method","html_id":"cycle(n:Int)-instance-method","name":"cycle","doc":"Returns an iterator that repeatedly returns the elements of the original\niterator starting back at the beginning when the end was reached,\nbut only *n* times.\n\n```\niter = [\"a\", \"b\", \"c\"].each.cycle(2)\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that repeatedly returns the elements of the original iterator starting back at the beginning when the end was reached, but only <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L345","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L345","def":{"name":"cycle","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CycleN(typeof(self), T, typeof(n)).new(self, n)"}},{"id":"cycle-instance-method","html_id":"cycle-instance-method","name":"cycle","doc":"Returns an iterator that repeatedly returns the elements of the original\niterator forever starting back at the beginning when the end was reached.\n\n```\niter = [\"a\", \"b\", \"c\"].each.cycle\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\n# and so an and so on\n```","summary":"<p>Returns an iterator that repeatedly returns the elements of the original iterator forever starting back at the beginning when the end was reached.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L309","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L309","def":{"name":"cycle","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Cycle(typeof(self), T).new(self)"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L377","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L377","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Calls the given block once for each element, passing that element\nas a parameter.\n\n```\niter = [\"a\", \"b\", \"c\"].each\niter.each { |x| print x, \" \" } # Prints \"a b c\"\n```","summary":"<p>Calls the given block once for each element, passing that element as a parameter.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L388","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L388","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"while true\n  value = self.next\n  if value.is_a?(Stop)\n    break\n  end\n  yield value\nend"}},{"id":"each_slice(n,reuse=false)-instance-method","html_id":"each_slice(n,reuse=false)-instance-method","name":"each_slice","doc":"Returns an iterator that then returns slices of *n* elements of the initial\niterator.\n\n```\niter = (1..9).each.each_slice(3)\niter.next # => [1, 2, 3]\niter.next # => [4, 5, 6]\niter.next # => [7, 8, 9]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each consecutive when invoking `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that then returns slices of <em>n</em> elements of the initial iterator.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L414","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L414","def":{"name":"each_slice","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"slice(n, reuse)"}},{"id":"first(n:Int)-instance-method","html_id":"first(n:Int)-instance-method","name":"first","doc":"Returns an iterator that only returns the first *n* elements of the\ninitial iterator.\n\n```\niter = [\"a\", \"b\", \"c\"].each.first 2\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns the first <em>n</em> elements of the initial iterator.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L897","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L897","def":{"name":"first","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Attempted to take negative size: #{n}\"))\nend\nFirst(typeof(self), T, typeof(n)).new(self, n)\n"}},{"id":"flat_map(&func:T->Array(U)|Iterator(U)|U)forallU-instance-method","html_id":"flat_map(&amp;func:T-&gt;Array(U)|Iterator(U)|U)forallU-instance-method","name":"flat_map","doc":"Returns a new iterator with the concatenated results of running the block\n(which is expected to return arrays or iterators)\nonce for every element in the collection.\n\n```\niter = [1, 2, 3].each.flat_map { |x| [x, x] }\n\niter.next # => 1\niter.next # => 1\niter.next # => 2\n\niter = [1, 2, 3].each.flat_map { |x| [x, x].each }\n\niter.to_a # => [1, 1, 2, 2, 3, 3]\n```","summary":"<p>Returns a new iterator with the concatenated results of running the block (which is expected to return arrays or iterators) once for every element in the collection.</p>","abstract":false,"args":[],"args_string":"(&func : T -> Array(U) | Iterator(U) | U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L515","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L515","def":{"name":"flat_map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> Array(U) | Iterator(U) | U)"},"return_type":"","visibility":"Public","body":"FlatMap(typeof(self), U, typeof(FlatMap.iterator_type(self, func)), typeof(func)).new(self, func)"}},{"id":"flatten-instance-method","html_id":"flatten-instance-method","name":"flatten","doc":"Returns an iterator that flattens nested iterators and arrays into a single iterator\nwhose type is the union of the simple types of all of the nested iterators and arrays\n(and their nested iterators and arrays, and so on).\n\n```\niter = [(1..2).each, ('a'..'b').each].each.flatten\niter.next # => 1\niter.next # => 2\niter.next # => 'a'\niter.next # => 'b'\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that flattens nested iterators and arrays into a single iterator whose type is the union of the simple types of all of the nested iterators and arrays (and their nested iterators and arrays, and so on).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L430","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L430","def":{"name":"flatten","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Flatten(typeof(Flatten.iterator_type(self)), typeof(Flatten.element_type(self))).new(self)"}},{"id":"in_groups_of(size:Int,filled_up_with=nil,reuse=false)-instance-method","html_id":"in_groups_of(size:Int,filled_up_with=nil,reuse=false)-instance-method","name":"in_groups_of","doc":"Returns an iterator that chunks the iterator's elements in arrays of *size*\nfilling up the remaining elements if no element remains with `nil` or a given\noptional parameter.\n\n```\niter = (1..3).each.in_groups_of(2)\niter.next # => [1, 2]\niter.next # => [3, nil]\niter.next # => Iterator::Stop::INSTANCE\n```\n```\niter = (1..3).each.in_groups_of(2, 'z')\niter.next # => [1, 2]\niter.next # => [3, 'z']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each group.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that chunks the iterator's elements in arrays of <em>size</em> filling up the remaining elements if no element remains with <code>nil</code> or a given optional parameter.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":""},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int, filled_up_with = <span class=\"n\">nil</span>, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L604","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L604","def":{"name":"in_groups_of","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"filled_up_with","doc":null,"default_value":"nil","external_name":"filled_up_with","restriction":""},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nInGroupsOf(typeof(self), T, typeof(size), typeof(filled_up_with)).new(self, size, filled_up_with, reuse)\n"}},{"id":"map(&func:T->U)forallU-instance-method","html_id":"map(&amp;func:T-&gt;U)forallU-instance-method","name":"map","doc":"Returns an iterator that applies the given block to the next element and\nreturns the result.\n\n```\niter = [1, 2, 3].each.map &.*(2)\niter.next # => 2\niter.next # => 4\niter.next # => 6\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that applies the given block to the next element and returns the result.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L657","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L657","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Map(typeof(self), T, U).new(self, func)"}},{"id":"next-instance-method","html_id":"next-instance-method","name":"next","doc":"Returns the next element in this iterator, or `Iterator::Stop::INSTANCE` if there\nare no more elements.","summary":"<p>Returns the next element in this iterator, or <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code> if there are no more elements.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L156","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"reject(&func:T->U)forallU-instance-method","html_id":"reject(&amp;func:T-&gt;U)forallU-instance-method","name":"reject","doc":"Returns an iterator that only returns elements for which the passed in\nblock returns a falsey value.\n\n```\niter = [1, 2, 3].each.reject &.odd?\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements for which the passed in block returns a falsey value.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L682","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L682","def":{"name":"reject","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Reject(typeof(self), T, U).new(self, func)"}},{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds the iterator to its original state.","summary":"<p>Rewinds the iterator to its original state.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L159","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"select(&func:T->U)forallU-instance-method","html_id":"select(&amp;func:T-&gt;U)forallU-instance-method","name":"select","doc":"Returns an iterator that only returns elements for which the passed\nin block returns a truthy value.\n\n```\niter = [1, 2, 3].each.select &.odd?\niter.next # => 1\niter.next # => 3\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements for which the passed in block returns a truthy value.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L712","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L712","def":{"name":"select","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Select(typeof(self), T, U).new(self, func)"}},{"id":"skip(n:Int)-instance-method","html_id":"skip(n:Int)-instance-method","name":"skip","doc":"Returns an iterator that skips the first *n* elements and only returns\nthe elements after that.\n\n```\niter = (1..3).each.skip(2)\niter.next # -> 3\niter.next # -> Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that skips the first <em>n</em> elements and only returns the elements after that.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L741","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L741","def":{"name":"skip","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Attempted to skip negative size: #{n}\"))\nend\nSkip(typeof(self), T, typeof(n)).new(self, n)\n"}},{"id":"skip_while(&func:T->U)forallU-instance-method","html_id":"skip_while(&amp;func:T-&gt;U)forallU-instance-method","name":"skip_while","doc":"Returns an iterator that only starts to return elements once the given block\nhas returned falsey value for one element.\n\n```\niter = [1, 2, 3, 4, 0].each.skip_while { |i| i < 3 }\niter.next # => 3\niter.next # => 4\niter.next # => 0\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only starts to return elements once the given block has returned falsey value for one element.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L778","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L778","def":{"name":"skip_while","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"SkipWhile(typeof(self), T, U).new(self, func)"}},{"id":"slice(n:Int,reuse=false)-instance-method","html_id":"slice(n:Int,reuse=false)-instance-method","name":"slice","doc":"Alias of `each_slice`.","summary":"<p>Alias of <code><a href=\"Iterator.html#each_slice%28n%2Creuse%3Dfalse%29-instance-method\">#each_slice</a></code>.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n : Int, reuse = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L808","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L808","def":{"name":"slice","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"},{"name":"reuse","doc":null,"default_value":"false","external_name":"reuse","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if n <= 0\n  raise(ArgumentError.new(\"Invalid slice size: #{n}\"))\nend\nSlice(typeof(self), T, typeof(n)).new(self, n, reuse)\n"}},{"id":"step(n:Int)-instance-method","html_id":"step(n:Int)-instance-method","name":"step","doc":"Returns an iterator that only returns every *n*th element, starting with the\nfirst.\n\n```\niter = (1..6).each.step(2)\niter.next # => 1\niter.next # => 3\niter.next # => 5\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns every <em>n</em>th element, starting with the first.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L864","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L864","def":{"name":"step","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Step(self, T, typeof(n)).new(self, n)"}},{"id":"stop-instance-method","html_id":"stop-instance-method","name":"stop","doc":"Shortcut for `Iterator::Stop::INSTANCE`, to signal that there are no more elements in an iterator.","summary":"<p>Shortcut for <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code>, to signal that there are no more elements in an iterator.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L105","def":{"name":"stop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Iterator.stop"}},{"id":"take_while(&func:T->U)forallU-instance-method","html_id":"take_while(&amp;func:T-&gt;U)forallU-instance-method","name":"take_while","doc":"Returns an iterator that returns elements while the given block returns a\ntruthy value.\n\n```\niter = (1..5).each.take_while { |i| i < 3 }\niter.next # => 1\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns elements while the given block returns a truthy value.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L934","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L934","def":{"name":"take_while","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"TakeWhile(typeof(self), T, U).new(self, func)"}},{"id":"tap(&block:T->)-instance-method","html_id":"tap(&amp;block:T-&gt;)-instance-method","name":"tap","doc":"Returns an iterator that calls the given block with the next element of the\niterator when calling `next`, still returning the original element.\n\n```\na = 0\niter = (1..3).each.tap { |x| a += x }\niter.next # => 1\na         # => 1\niter.next # => 2\na         # => 3\niter.next # => 3\na         # => 6\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that calls the given block with the next element of the iterator when calling <code><a href=\"Iterator.html#next-instance-method\">#next</a></code>, still returning the original element.</p>","abstract":false,"args":[],"args_string":"(&block : T -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L977","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L977","def":{"name":"tap","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> )"},"return_type":"","visibility":"Public","body":"Tap(typeof(self), T).new(self, block)"}},{"id":"uniq-instance-method","html_id":"uniq-instance-method","name":"uniq","doc":"Returns an iterator that only returns unique values of the original\niterator.\n\n```\niter = [1, 2, 1].each.uniq\niter.next # => 1\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns unique values of the original iterator.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1004","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1004","def":{"name":"uniq","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uniq(&.itself)"}},{"id":"uniq(&func:T->U)forallU-instance-method","html_id":"uniq(&amp;func:T-&gt;U)forallU-instance-method","name":"uniq","doc":"Returns an iterator that only returns unique values of the original\niterator. The provided block is applied to the elements to determine the\nvalue to be checked for uniqueness.\n\n```\niter = [[\"a\", \"a\"], [\"b\", \"a\"], [\"a\", \"c\"]].each.uniq &.first\niter.next # => [\"a\", \"a\"]\niter.next # => [\"b\", \"a\"]\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns unique values of the original iterator.</p>","abstract":false,"args":[],"args_string":"(&func : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1018","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1018","def":{"name":"uniq","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Uniq(typeof(self), T, U).new(self, func)"}},{"id":"with_index(offset:Int=0)-instance-method","html_id":"with_index(offset:Int=0)-instance-method","name":"with_index","doc":"Returns an iterator that returns a `Tuple` of the element and its index.\n\n```\niter = (1..3).each.with_index\niter.next # => {1, 0}\niter.next # => {2, 1}\niter.next # => {3, 2}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns a <code><a href=\"Tuple.html\">Tuple</a></code> of the element and its index.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1057","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1057","def":{"name":"with_index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"WithIndex(typeof(self), T, typeof(offset)).new(self, offset)"}},{"id":"with_index(offset:Int=0,&block)-instance-method","html_id":"with_index(offset:Int=0,&amp;block)-instance-method","name":"with_index","doc":"Yields each element in this iterator together with its index.","summary":"<p>Yields each element in this iterator together with its index.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = <span class=\"n\">0</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1062","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1062","def":{"name":"with_index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"index = offset\neach do |value|\n  yield value, index\n  index = index + 1\nend\n"}},{"id":"with_object(obj)-instance-method","html_id":"with_object(obj)-instance-method","name":"with_object","doc":"Returns an iterator that returns a `Tuple` of the element and a given object.\n\n```\niter = (1..3).each.with_object(\"a\")\niter.next # => {1, \"a\"}\niter.next # => {2, \"a\"}\niter.next # => {3, \"a\"}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns a <code><a href=\"Tuple.html\">Tuple</a></code> of the element and a given object.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1099","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1099","def":{"name":"with_object","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"WithObject(typeof(self), T, typeof(obj)).new(self, obj)"}},{"id":"zip(other:Iterator(U))forallU-instance-method","html_id":"zip(other:Iterator(U))forallU-instance-method","name":"zip","doc":"Returns an iterator that returns the elements of this iterator and the given\none pairwise as `Tuple`s.\n\n```\niter1 = [4, 5, 6].each\niter2 = [7, 8, 9].each\niter = iter1.zip(iter2)\niter.next # => {4, 7}\niter.next # => {5, 8}\niter.next # => {6, 9}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns the elements of this iterator and the given one pairwise as <code><a href=\"Tuple.html\">Tuple</a></code>s.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Iterator(U)"}],"args_string":"(other : Iterator(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L1128","def":{"name":"zip","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Iterator(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Zip(typeof(self), typeof(other), T, U).new(self, other)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Iterator/IteratorWrapper","path":"Iterator/IteratorWrapper.html","kind":"module","full_name":"Iterator::IteratorWrapper","name":"IteratorWrapper","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"iterator.cr","line_number":88,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},"doc":"`IteratorWrapper` eliminates some boilerplate when defining\nan `Iterator` that wraps another iterator.\n\nTo use it, include this module in your iterator and make sure that the wrapped\niterator is stored in the `@iterator` instance variable.","summary":"<p><code><a href=\"../Iterator/IteratorWrapper.html\">IteratorWrapper</a></code> eliminates some boilerplate when defining an <code><a href=\"../Iterator.html\">Iterator</a></code> that wraps another iterator.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"rewind-instance-method","html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds the wrapped iterator and returns `self`.","summary":"<p>Rewinds the wrapped iterator and returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L90","def":{"name":"rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@iterator.rewind\nself\n"}}],"macros":[{"id":"wrapped_next-macro","html_id":"wrapped_next-macro","name":"wrapped_next","doc":"Invokes `next` on the wrapped iterator and returns `stop` if\nthe given value was a `Iterator::Stop`. Otherwise, returns the value.","summary":"<p>Invokes <code>next</code> on the wrapped iterator and returns <code>stop</code> if the given value was a <code><a href=\"../Iterator/Stop.html\">Iterator::Stop</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr#L97","def":{"name":"wrapped_next","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"      \n%value\n = @iterator.next\n      return stop if \n%value\n.is_a?(Stop)\n      \n%value\n\n    \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Iterator/Stop","path":"Iterator/Stop.html","kind":"class","full_name":"Iterator::Stop","name":"Stop","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"iterator.cr","line_number":79,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/iterator.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"INSTANCE","name":"INSTANCE","value":"new","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},"doc":"The class that signals that there are no more elements in an `Iterator`.","summary":"<p>The class that signals that there are no more elements in an <code><a href=\"../Iterator.html\">Iterator</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/JSON","path":"JSON.html","kind":"module","full_name":"JSON","name":"JSON","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json.cr","line_number":70,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr"},{"filename":"json/builder.cr","line_number":353,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"},{"filename":"json/mapping.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr"},{"filename":"json/serialization.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The JSON module allows parsing and generating [JSON](http://json.org/) documents.\n\n### Parsing and generating with `JSON.mapping`\n\nUse `JSON.mapping` to define how an object is mapped to JSON, making it\nthe recommended easy, type-safe and efficient option for parsing and generating\nJSON. Refer to that module's documentation to learn about it.\n\n### Parsing with `JSON.parse`\n\n`JSON.parse` will return an `Any`, which is a convenient wrapper around all possible JSON types,\nmaking it easy to traverse a complex JSON structure but requires some casts from time to time,\nmostly via some method invocations.\n\n```\nrequire \"json\"\n\nvalue = JSON.parse(\"[1, 2, 3]\") # : JSON::Any\n\nvalue[0]              # => 1\ntypeof(value[0])      # => JSON::Any\nvalue[0].as_i         # => 1\ntypeof(value[0].as_i) # => Int32\n\nvalue[0] + 1       # Error, because value[0] is JSON::Any\nvalue[0].as_i + 10 # => 11\n```\n\n`JSON.parse` can read from an `IO` directly (such as a file) which saves\nallocating a string:\n\n```\nrequire \"json\"\n\njson = File.open(\"path/to/file.json\") do |file|\n  JSON.parse(file)\nend\n```\n\nParsing with `JSON.parse` is useful for dealing with a dynamic JSON structure but is slower than using `JSON.mapping`.\n\n### Generating with `JSON.build`\n\nUse `JSON.build`, which uses `JSON::Builder`, to generate JSON\nby emitting scalars, arrays and objects:\n\n```\nrequire \"json\"\n\nstring = JSON.build do |json|\n  json.object do\n    json.field \"name\", \"foo\"\n    json.field \"values\" do\n      json.array do\n        json.number 1\n        json.number 2\n        json.number 3\n      end\n    end\n  end\nend\nstring # => %<{\"name\":\"foo\",\"values\":[1,2,3]}>\n```\n\n### Generating with `to_json`\n\n`to_json`, `to_json(IO)` and `to_json(JSON::Builder)` methods are provided\nfor primitive types, but you need to define `to_json(JSON::Builder)`\nfor custom objects, either manually or using `JSON.mapping`.","summary":"<p>The JSON module allows parsing and generating <a href=\"http://json.org/\" target=\"_blank\">JSON</a> documents.</p>","class_methods":[{"id":"build(io:IO,indent=nil,&block)-class-method","html_id":"build(io:IO,indent=nil,&amp;block)-class-method","name":"build","doc":"Writes JSON into the given `IO`. A `JSON::Builder` is yielded to the block.","summary":"<p>Writes JSON into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""}],"args_string":"(io : IO, indent = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L382","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L382","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"builder = JSON::Builder.new(io)\nif indent\n  builder.indent = indent\nend\nbuilder.document do\n  yield builder\nend\n"}},{"id":"build(indent=nil,&block)-class-method","html_id":"build(indent=nil,&amp;block)-class-method","name":"build","doc":"Returns the resulting `String` of writing JSON to the yielded `JSON::Builder`.\n\n```\nrequire \"json\"\n\nstring = JSON.build do |json|\n  json.object do\n    json.field \"name\", \"foo\"\n    json.field \"values\" do\n      json.array do\n        json.number 1\n        json.number 2\n        json.number 3\n      end\n    end\n  end\nend\nstring # => %<{\"name\":\"foo\",\"values\":[1,2,3]}>\n```","summary":"<p>Returns the resulting <code><a href=\"String.html\">String</a></code> of writing JSON to the yielded <code><a href=\"JSON/Builder.html\">JSON::Builder</a></code>.</p>","abstract":false,"args":[{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""}],"args_string":"(indent = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L373","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L373","def":{"name":"build","args":[{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  build(str, indent) do |json|\n    yield json\n  end\nend"}},{"id":"parse(input:String|IO):Any-class-method","html_id":"parse(input:String|IO):Any-class-method","name":"parse","doc":"Parses a JSON document as a `JSON::Any`.","summary":"<p>Parses a JSON document as a <code><a href=\"JSON/Any.html\">JSON::Any</a></code>.</p>","abstract":false,"args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":"String | IO"}],"args_string":"(input : String | IO) : Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L90","def":{"name":"parse","args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Any","visibility":"Public","body":"(Parser.new(input)).parse"}}],"constructors":[],"instance_methods":[],"macros":[{"id":"mapping(_properties_,strict=false)-macro","html_id":"mapping(_properties_,strict=false)-macro","name":"mapping","doc":"The `JSON.mapping` macro defines how an object is mapped to JSON.\n\n### Example\n\n```\nrequire \"json\"\n\nclass Location\n  JSON.mapping(\n    lat: Float64,\n    lng: Float64,\n  )\nend\n\nclass House\n  JSON.mapping(\n    address: String,\n    location: {type: Location, nilable: true},\n  )\nend\n\nhouse = House.from_json(%({\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}))\nhouse.address  # => \"Crystal Road 1234\"\nhouse.location # => #<Location:0x10cd93d80 @lat=12.3, @lng=34.5>\nhouse.to_json  # => %({\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}})\n\nhouses = Array(House).from_json(%([{\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}]))\nhouses.size    # => 1\nhouses.to_json # => [{\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}}]\n```\n\n### Usage\n\n`JSON.mapping` must receive a series of named arguments, or a named tuple literal, or a hash literal,\nwhose keys will define Crystal properties.\n\nThe value of each key can be a type. Primitive types (numbers, string, boolean and nil)\nare supported, as well as custom objects which use `JSON.mapping` or define a `new` method\nthat accepts a `JSON::PullParser` and returns an object from it. Union types are supported,\nif multiple types in the union can be mapped from the JSON, it is undefined which one will be chosen.\n\nThe value can also be another hash literal with the following options:\n* **type**: (required) the type described above (you can use `JSON::Any` too)\n* **key**: the property name in the JSON document (as opposed to the property name in the Crystal code)\n* **nilable**: if `true`, the property can be `Nil`. Passing `T?` as a type has the same effect.\n* **default**: value to use if the property is missing in the JSON document, or if it's `null` and `nilable` was not set to `true`. If the default value creates a new instance of an object (for example `[1, 2, 3]` or `SomeObject.new`), a different instance will be used each time a JSON document is parsed.\n* **emit_null**: if `true`, emits a `null` value for nilable properties (by default nulls are not emitted)\n* **converter**: specify an alternate type for parsing and generation. The converter must define `from_json(JSON::PullParser)` and `to_json(value, JSON::Builder)` as class methods. Examples of converters are `Time::Format` and `Time::EpochConverter` for `Time`.\n* **root**: assume the value is inside a JSON object with a given key (see `Object.from_json(string_or_io, root)`)\n* **setter**: if `true`, will generate a setter for the variable, `true` by default\n* **getter**: if `true`, will generate a getter for the variable, `true` by default\n* **presence**: if `true`, a `{{key}}_present?` method will be generated when the key was present (even if it has a `null` value), `false` by default\n\nThis macro by default defines getters and setters for each variable (this can be overrided with *setter* and *getter*).\nThe mapping doesn't define a constructor accepting these variables as arguments, but you can provide an overload.\n\nThe macro basically defines a constructor accepting a `JSON::PullParser` that reads from\nit and initializes this type's instance variables. It also defines a `to_json(JSON::Builder)` method\nby invoking `to_json(JSON::Builder)` on each of the properties (unless a converter is specified, in\nwhich case `to_json(value, JSON::Builder)` is invoked).\n\nThis macro also declares instance variables of the types given in the mapping.\n\nIf *strict* is `true`, unknown properties in the JSON\ndocument will raise a parse exception. The default is `false`, so unknown properties\nare silently ignored.","summary":"<p>The <code><a href=\"JSON.html#mapping-macro\">JSON.mapping</a></code> macro defines how an object is mapped to JSON.</p>","abstract":false,"args":[{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},{"name":"strict","doc":null,"default_value":"false","external_name":"strict","restriction":""}],"args_string":"(_properties_, strict = false)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L68","def":{"name":"mapping","args":[{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},{"name":"strict","doc":null,"default_value":"false","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    \n{% for key, value in _properties_ %}\n      {% unless value.is_a?(HashLiteral) || value.is_a?(NamedTupleLiteral)\n  _properties_[key] = {type: value}\nend %}\n    {% end %}\n\n\n    \n{% for key, value in _properties_ %}\n      {% _properties_[key][:key_id] = key.id.gsub(/\\?$/, \"\") %}\n    {% end %}\n\n\n    \n{% for key, value in _properties_ %}\n      @{{ value[:key_id] }} : {{ value[:type] }}{{ (value[:nilable] ? \"?\" : \"\").id }}\n\n      {% if value[:setter] == nil ? true : value[:setter] %}\n        def {{ value[:key_id] }}=(_{{ value[:key_id] }} : {{ value[:type] }}{{ (value[:nilable] ? \"?\" : \"\").id }})\n          @{{ value[:key_id] }} = _{{ value[:key_id] }}\n        end\n      {% end %}\n\n      {% if value[:getter] == nil ? true : value[:getter] %}\n        def {{ key.id }} : {{ value[:type] }}{{ (value[:nilable] ? \"?\" : \"\").id }}\n          @{{ value[:key_id] }}\n        end\n      {% end %}\n\n      {% if value[:presence] %}\n        @{{ value[:key_id] }}_present : Bool = false\n\n        def {{ value[:key_id] }}_present?\n          @{{ value[:key_id] }}_present\n        end\n      {% end %}\n    {% end %}\n\n\n    def initialize(\n%pull\n : ::JSON::PullParser)\n      \n{% for key, value in _properties_ %}\n        %var{key.id} = nil\n        %found{key.id} = false\n      {% end %}\n\n\n      \n%location\n = \n%pull\n.location\n      begin\n        \n%pull\n.read_begin_object\n      rescue \nexc : ::JSON::ParseException\n        raise ::JSON::MappingError.new(\nexc.message, self.class.to_s, nil, *\n%location\n, \nexc)\n      \nend\n      while \n%pull\n.kind != :end_object\n        \n%key_location\n = \n%pull\n.location\n        key = \n%pull\n.read_object_key\n        case key\n        \n{% for key, value in _properties_ %}\n          when {{ value[:key] || value[:key_id].stringify }}\n            %found{key.id} = true\n            begin\n              %var{key.id} =\n                {% if value[:nilable] || (value[:default] != nil) %} %pull.read_null_or { {% end %}\n\n                {% if value[:root] %}\n                  %pull.on_key!({{ value[:root] }}) do\n                {% end %}\n\n                {% if value[:converter] %}\n                  {{ value[:converter] }}.from_json(%pull)\n                {% else %}{% if value[:type].is_a?(Path) || value[:type].is_a?(Generic) %}\n                  {{ value[:type] }}.new(%pull)\n                {% else %}\n                  ::Union({{ value[:type] }}).new(%pull)\n                {% end %}{% end %}\n\n                {% if value[:root] %}\n                  end\n                {% end %}\n\n              {% if value[:nilable] || (value[:default] != nil) %} } {% end %}\n            rescue exc : ::JSON::ParseException\n              raise ::JSON::MappingError.new(exc.message, self.class.to_s, {{ value[:key] || value[:key_id].stringify }}, *%key_location, exc)\n            end\n        {% end %}\n\n        \nelse\n          \n{% if strict %}\n            raise ::JSON::MappingError.new(\"Unknown JSON attribute: #{key}\", self.class.to_s, nil, *%key_location, nil)\n          {% else %}\n            %pull.skip\n          {% end %}\n\n        \nend\n      \nend\n      \n%pull\n.read_next\n\n      \n{% for key, value in _properties_ %}\n        {% if value[:nilable] || (value[:default] != nil) %}{% else %}\n          if %var{key.id}.nil? && !%found{key.id} && !::Union({{ value[:type] }}).nilable?\n            raise ::JSON::MappingError.new(\"Missing JSON attribute: {{ (value[:key] || value[:key_id]).id }}\", self.class.to_s, nil, *%location, nil)\n          end\n        {% end %}\n\n        {% if value[:nilable] %}\n          {% if value[:default] != nil %}\n            @{{ value[:key_id] }} = %found{key.id} ? %var{key.id} : {{ value[:default] }}\n          {% else %}\n            @{{ value[:key_id] }} = %var{key.id}\n          {% end %}\n        {% else %}{% if value[:default] != nil %}\n          @{{ value[:key_id] }} = %var{key.id}.nil? ? {{ value[:default] }} : %var{key.id}\n        {% else %}\n          @{{ value[:key_id] }} = (%var{key.id}).as({{ value[:type] }})\n        {% end %}{% end %}\n\n        {% if value[:presence] %}\n          @{{ value[:key_id] }}_present = %found{key.id}\n        {% end %}\n      {% end %}\n\n    \nend\n\n    def to_json(json : ::JSON::Builder)\n      json.object do\n        \n{% for key, value in _properties_ %}\n          _{{ value[:key_id] }} = @{{ value[:key_id] }}\n\n          {% if value[:emit_null] %}{% else %}\n            unless _{{ value[:key_id] }}.nil?\n          {% end %}\n\n            json.field({{ value[:key] || value[:key_id].stringify }}) do\n              {% if value[:root] %}\n                {% if value[:emit_null] %}\n                  if _{{ value[:key_id] }}.nil?\n                    nil.to_json(json)\n                  else\n                {% end %}\n\n                json.object do\n                  json.field({{ value[:root] }}) do\n              {% end %}\n\n              {% if value[:converter] %}\n                if _{{ value[:key_id] }}\n                  {{ value[:converter] }}.to_json(_{{ value[:key_id] }}, json)\n                else\n                  nil.to_json(json)\n                end\n              {% else %}\n                _{{ value[:key_id] }}.to_json(json)\n              {% end %}\n\n              {% if value[:root] %}\n                {% if value[:emit_null] %}\n                  end\n                {% end %}\n                  end\n                end\n              {% end %}\n            end\n\n          {% if value[:emit_null] %}{% else %}\n            end\n          {% end %}\n        {% end %}\n\n      \nend\n    \nend\n  \n"}},{"id":"mapping-macro","html_id":"mapping-macro","name":"mapping","doc":"This is a convenience method to allow invoking `JSON.mapping`\nwith named arguments instead of with a hash/named-tuple literal.","summary":"<p>This is a convenience method to allow invoking <code><a href=\"JSON.html#mapping-macro\">JSON.mapping</a></code> with named arguments instead of with a hash/named-tuple literal.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L230","def":{"name":"mapping","args":[],"double_splat":{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},"splat_index":null,"block_arg":null,"visibility":"Public","body":"    ::JSON.mapping(\n{{ _properties_ }}\n)\n  \n"}}],"types":[{"html_id":"github.com/crystal-lang/crystal/JSON/Any","path":"JSON/Any.html","kind":"struct","full_name":"JSON::Any","name":"Any","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/any.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"`JSON::Any` is a convenient wrapper around all possible JSON types (`JSON::Any::Type`)\nand can be used for traversing dynamic or unknown JSON structures.\n\n```\nobj = JSON.parse(%({\"access\": [{\"name\": \"mapping\", \"speed\": \"fast\"}, {\"name\": \"any\", \"speed\": \"slow\"}]}))\nobj[\"access\"][1][\"name\"].as_s  # => \"any\"\nobj[\"access\"][1][\"speed\"].as_s # => \"slow\"\n```\n\nNote that methods used to traverse a JSON structure, `#[]`, `#[]?` and `#each`,\nalways return a `JSON::Any` to allow further traversal. To convert them to `String`,\n`Int32`, etc., use the `as_` methods, such as `#as_s`, `#as_i`, which perform\na type check against the raw underlying value. This means that invoking `#as_s`\nwhen the underlying value is not a String will raise: the value won't automatically\nbe converted (parsed) to a `String`.","summary":"<p><code><a href=\"../JSON/Any.html\">JSON::Any</a></code> is a convenient wrapper around all possible JSON types (<code><a href=\"../JSON/Any/Type.html\">JSON::Any::Type</a></code>) and can be used for traversing dynamic or unknown JSON structures.</p>","class_methods":[],"constructors":[{"id":"new(raw:Type)-class-method","html_id":"new(raw:Type)-class-method","name":"new","doc":"Creates a `JSON::Any` that wraps the given value.","summary":"<p>Creates a <code><a href=\"../JSON/Any.html\">JSON::Any</a></code> that wraps the given value.</p>","abstract":false,"args":[{"name":"raw","doc":null,"default_value":"","external_name":"raw","restriction":"Type"}],"args_string":"(raw : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L54","def":{"name":"new","args":[{"name":"raw","doc":null,"default_value":"","external_name":"raw","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(raw)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a `JSON::Any` value from the given pull parser.","summary":"<p>Reads a <code><a href=\"../JSON/Any.html\">JSON::Any</a></code> value from the given pull parser.</p>","abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L21","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case pull.kind\nwhen :null\n  new(pull.read_null)\nwhen :bool\n  new(pull.read_bool)\nwhen :int\n  new(pull.read_int)\nwhen :float\n  new(pull.read_float)\nwhen :string\n  new(pull.read_string)\nwhen :begin_array\n  ary = [] of JSON::Any\n  pull.read_array do\n    ary << (new(pull))\n  end\n  new(ary)\nwhen :begin_object\n  hash = {} of String => JSON::Any\n  pull.read_object do |key|\n    hash[key] = new(pull)\n  end\n  new(hash)\nelse\n  raise(\"Unknown pull kind: #{pull.kind}\")\nend"}}],"instance_methods":[{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if the raw object is equal to *other*.","summary":"<p>Returns <code>true</code> if the raw object is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L241","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw == other"}},{"id":"==(other:JSON::Any)-instance-method","html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":"Returns `true` if both `self` and *other*'s raw object are equal.","summary":"<p>Returns <code>true</code> if both <code>self</code> and <em>other</em>'s raw object are equal.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L236","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw == other.raw"}},{"id":"[](index:Int):JSON::Any-instance-method","html_id":"[](index:Int):JSON::Any-instance-method","name":"[]","doc":"Assumes the underlying value is an `Array` and returns the element\nat the given index.\nRaises if the underlying value is not an `Array`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> and returns the element at the given index.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : JSON::Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L73","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"JSON::Any","visibility":"Public","body":"case object = @raw\nwhen Array\n  object[index]\nelse\n  raise(\"Expected Array for #[](index : Int), not #{object.class}\")\nend"}},{"id":"[](key:String):JSON::Any-instance-method","html_id":"[](key:String):JSON::Any-instance-method","name":"[]","doc":"Assumes the underlying value is a `Hash` and returns the element\nwith the given key.\nRaises if the underlying value is not a `Hash`.","summary":"<p>Assumes the underlying value is a <code><a href=\"../Hash.html\">Hash</a></code> and returns the element with the given key.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : JSON::Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L97","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"JSON::Any","visibility":"Public","body":"case object = @raw\nwhen Hash\n  object[key]\nelse\n  raise(\"Expected Hash for #[](key : String), not #{object.class}\")\nend"}},{"id":"[]?(index:Int):JSON::Any?-instance-method","html_id":"[]?(index:Int):JSON::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is an `Array` and returns the element\nat the given index, or `nil` if out of bounds.\nRaises if the underlying value is not an `Array`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> and returns the element at the given index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : JSON::Any?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L85","def":{"name":"[]?","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"JSON::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Array\n  object[index]?\nelse\n  raise(\"Expected Array for #[]?(index : Int), not #{object.class}\")\nend"}},{"id":"[]?(key:String):JSON::Any?-instance-method","html_id":"[]?(key:String):JSON::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is a `Hash` and returns the element\nwith the given key, or `nil` if the key is not present.\nRaises if the underlying value is not a `Hash`.","summary":"<p>Assumes the underlying value is a <code><a href=\"../Hash.html\">Hash</a></code> and returns the element with the given key, or <code>nil</code> if the key is not present.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : JSON::Any?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L109","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"JSON::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Hash\n  object[key]?\nelse\n  raise(\"Expected Hash for #[]?(key : String), not #{object.class}\")\nend"}},{"id":"as_a:Array(Any)-instance-method","html_id":"as_a:Array(Any)-instance-method","name":"as_a","doc":"Checks that the underlying value is `Array`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Array(Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L198","def":{"name":"as_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Any)","visibility":"Public","body":"@raw.as(Array)"}},{"id":"as_a?:Array(Any)?-instance-method","html_id":"as_a?:Array(Any)?-instance-method","name":"as_a?","doc":"Checks that the underlying value is `Array`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Array(Any)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L204","def":{"name":"as_a?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Any) | ::Nil","visibility":"Public","body":"if @raw.is_a?(Array)\n  as_a\nend"}},{"id":"as_bool:Bool-instance-method","html_id":"as_bool:Bool-instance-method","name":"as_bool","doc":"Checks that the underlying value is `Bool`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L126","def":{"name":"as_bool","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@raw.as(Bool)"}},{"id":"as_bool?:Bool?-instance-method","html_id":"as_bool?:Bool?-instance-method","name":"as_bool?","doc":"Checks that the underlying value is `Bool`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Bool?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L132","def":{"name":"as_bool?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool | ::Nil","visibility":"Public","body":"if @raw.is_a?(Bool)\n  as_bool\nend"}},{"id":"as_f:Float64-instance-method","html_id":"as_f:Float64-instance-method","name":"as_f","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float64`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L162","def":{"name":"as_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"(@raw.as(Float)).to_f"}},{"id":"as_f32:Float32-instance-method","html_id":"as_f32:Float32-instance-method","name":"as_f32","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L174","def":{"name":"as_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"(@raw.as(Float)).to_f32"}},{"id":"as_f32?:Float32?-instance-method","html_id":"as_f32?:Float32?-instance-method","name":"as_f32?","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L180","def":{"name":"as_f32?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32 | ::Nil","visibility":"Public","body":"if (@raw.is_a?(Float32) || @raw.is_a?(Float64))\n  as_f32\nend"}},{"id":"as_f?:Float64?-instance-method","html_id":"as_f?:Float64?-instance-method","name":"as_f?","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float64`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L168","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L168","def":{"name":"as_f?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Float64)\n  as_f\nend"}},{"id":"as_h:Hash(String,Any)-instance-method","html_id":"as_h:Hash(String,Any)-instance-method","name":"as_h","doc":"Checks that the underlying value is `Hash`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Hash(String, Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L210","def":{"name":"as_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(String, Any)","visibility":"Public","body":"@raw.as(Hash)"}},{"id":"as_h?:Hash(String,Any)?-instance-method","html_id":"as_h?:Hash(String,Any)?-instance-method","name":"as_h?","doc":"Checks that the underlying value is `Hash`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Hash(String, Any)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L216","def":{"name":"as_h?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(String, Any) | ::Nil","visibility":"Public","body":"if @raw.is_a?(Hash)\n  as_h\nend"}},{"id":"as_i:Int32-instance-method","html_id":"as_i:Int32-instance-method","name":"as_i","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L138","def":{"name":"as_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"(@raw.as(Int)).to_i"}},{"id":"as_i64:Int64-instance-method","html_id":"as_i64:Int64-instance-method","name":"as_i64","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int64`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L150","def":{"name":"as_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"(@raw.as(Int)).to_i64"}},{"id":"as_i64?:Int64?-instance-method","html_id":"as_i64?:Int64?-instance-method","name":"as_i64?","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int64`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L156","def":{"name":"as_i64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Int64)\n  as_i64\nend"}},{"id":"as_i?:Int32?-instance-method","html_id":"as_i?:Int32?-instance-method","name":"as_i?","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L144","def":{"name":"as_i?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Int)\n  as_i\nend"}},{"id":"as_nil:Nil-instance-method","html_id":"as_nil:Nil-instance-method","name":"as_nil","doc":"Checks that the underlying value is `Nil`, and returns `nil`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Nil.html\">Nil</a></code>, and returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L120","def":{"name":"as_nil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"@raw.as(Nil)"}},{"id":"as_s:String-instance-method","html_id":"as_s:String-instance-method","name":"as_s","doc":"Checks that the underlying value is `String`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L186","def":{"name":"as_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@raw.as(String)"}},{"id":"as_s?:String?-instance-method","html_id":"as_s?:String?-instance-method","name":"as_s?","doc":"Checks that the underlying value is `String`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L192","def":{"name":"as_s?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"if @raw.is_a?(String)\n  as_s\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new JSON::Any instance with the `raw` value `clone`ed.","summary":"<p>Returns a new JSON::Any instance with the <code><a href=\"../JSON/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../JSON/Any.html#clone-instance-method\">#clone</a></code>ed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L259","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Any.new(raw.clone)"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a new JSON::Any instance with the `raw` value `dup`ed.","summary":"<p>Returns a new JSON::Any instance with the <code><a href=\"../JSON/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../JSON/Any.html#dup-instance-method\">#dup</a></code>ed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L254","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L254","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Any.new(raw.dup)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L246","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = raw.hash(hasher)\nhasher\n"}},{"id":"raw:Type-instance-method","html_id":"raw:Type-instance-method","name":"raw","doc":"Returns the raw underlying value.","summary":"<p>Returns the raw underlying value.</p>","abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L51","def":{"name":"raw","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"@raw"}},{"id":"size:Int-instance-method","html_id":"size:Int-instance-method","name":"size","doc":"Assumes the underlying value is an `Array` or `Hash` and returns its size.\nRaises if the underlying value is not an `Array` or `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns its size.</p>","abstract":false,"args":[],"args_string":" : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L59","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"case object = @raw\nwhen Array\n  object.size\nwhen Hash\n  object.size\nelse\n  raise(\"Expected Array or Hash for #size, not #{object.class}\")\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/JSON/Any/Type","path":"JSON/Any/Type.html","kind":"alias","full_name":"JSON::Any::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/any.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Array(JSON::Any) | Bool | Float64 | Hash(String, JSON::Any) | Int64 | String | Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Any","kind":"struct","full_name":"JSON::Any","name":"Any"},"doc":"All possible JSON types.","summary":"<p>All possible JSON types.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","path":"JSON/Builder.html","kind":"class","full_name":"JSON::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"A JSON builder generates valid JSON.\n\nA `JSON::Error` is raised if attempting to generate an invalid JSON\n(for example, if invoking `end_array` without a matching `start_array`,\nor trying to use a non-string value as an object's field name).","summary":"<p>A JSON builder generates valid JSON.</p>","class_methods":[],"constructors":[{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a `JSON::Builder` that will write to the given `IO`.","summary":"<p>Creates a <code><a href=\"../JSON/Builder.html\">JSON::Builder</a></code> that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L20","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"array(&block)-instance-method","html_id":"array(&amp;block)-instance-method","name":"array","doc":"Writes the start of an array, invokes the block,\nand the writes the end of it.","summary":"<p>Writes the start of an array, invokes the block, and the writes the end of it.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L182","def":{"name":"array","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_array\n(yield).tap do\n  end_array\nend\n"}},{"id":"bool(value:Bool)-instance-method","html_id":"bool(value:Bool)-instance-method","name":"bool","doc":"Writes a boolean value.","summary":"<p>Writes a boolean value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L64","def":{"name":"bool","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalar do\n  @io << value\nend"}},{"id":"document(&block)-instance-method","html_id":"document(&amp;block)-instance-method","name":"document","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L51","def":{"name":"document","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_document\n(yield).tap do\n  end_document\nend\n"}},{"id":"end_array-instance-method","html_id":"end_array-instance-method","name":"end_array","doc":"Writes the end of an array.","summary":"<p>Writes the end of an array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L167","def":{"name":"end_array","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case state = @state.last\nwhen ArrayState\n  @state.pop\nelse\n  raise(JSON::Error.new(\"Can't do end_array: not inside an array\"))\nend\nwrite_indent(state)\n@io << ']'\n@current_indent = @current_indent - 1\nend_scalar\n"}},{"id":"end_document:Nil-instance-method","html_id":"end_document:Nil-instance-method","name":"end_document","doc":"Signals the end of a JSON document.","summary":"<p>Signals the end of a JSON document.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L38","def":{"name":"end_document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"case state = @state.last\nwhen StartState\n  raise(JSON::Error.new(\"Empty JSON\"))\nwhen DocumentStartState\n  raise(JSON::Error.new(\"Empty JSON\"))\nwhen ArrayState\n  raise(JSON::Error.new(\"Unterminated JSON array\"))\nwhen ObjectState\n  raise(JSON::Error.new(\"Unterminated JSON object\"))\nend"}},{"id":"end_object-instance-method","html_id":"end_object-instance-method","name":"end_object","doc":"Writes the end of an object.","summary":"<p>Writes the end of an object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L196","def":{"name":"end_object","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case state = @state.last\nwhen ObjectState\n  if state.name\n  else\n    raise(JSON::Error.new(\"Missing object value\"))\n  end\n  @state.pop\nelse\n  raise(JSON::Error.new(\"Can't do end_object: not inside an object\"))\nend\nwrite_indent(state)\n@io << '}'\n@current_indent = @current_indent - 1\nend_scalar\n"}},{"id":"field(name,value)-instance-method","html_id":"field(name,value)-instance-method","name":"field","doc":"Writes an object's field and value.\nThe field's name is first converted to a `String` by invoking\n`to_s` on it.","summary":"<p>Writes an object's field and value.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L242","def":{"name":"field","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string(name)\nvalue.to_json(self)\n"}},{"id":"field(name,&block)-instance-method","html_id":"field(name,&amp;block)-instance-method","name":"field","doc":"Writes an object's field and then invokes the block.\nThis is equivalent of invoking `string(value)` and then\ninvoking the block.","summary":"<p>Writes an object's field and then invokes the block.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L250","def":{"name":"field","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"string(name)\nyield\n"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes the underlying `IO`.","summary":"<p>Flushes the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L256","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.flush"}},{"id":"indent=(string:String)-instance-method","html_id":"indent=(string:String)-instance-method","name":"indent=","doc":"Sets the indent *string*.","summary":"<p>Sets the indent <em>string</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L261","def":{"name":"indent=","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if string.empty?\n  @indent = nil\nelse\n  @indent = string\nend"}},{"id":"indent=(level:Int)-instance-method","html_id":"indent=(level:Int)-instance-method","name":"indent=","doc":"Sets the indent *level* (number of spaces).","summary":"<p>Sets the indent <em>level</em> (number of spaces).</p>","abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Int"}],"args_string":"(level : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L270","def":{"name":"indent=","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if level < 0\n  @indent = nil\nelse\n  @indent = \" \" * level\nend"}},{"id":"null-instance-method","html_id":"null-instance-method","name":"null","doc":"Writes a `null` value.","summary":"<p>Writes a <code><a href=\"../JSON/Builder.html#null-instance-method\">#null</a></code> value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L57","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalar do\n  @io << \"null\"\nend"}},{"id":"number(number:Float)-instance-method","html_id":"number(number:Float)-instance-method","name":"number","doc":"Writes a float.","summary":"<p>Writes a float.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"args_string":"(number : Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L78","def":{"name":"number","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalar do\n  case number\n  when .nan?\n    raise(JSON::Error.new(\"NaN not allowed in JSON\"))\n  when .infinite?\n    raise(JSON::Error.new(\"Infinity not allowed in JSON\"))\n  else\n    @io << number\n  end\nend"}},{"id":"number(number:Int)-instance-method","html_id":"number(number:Int)-instance-method","name":"number","doc":"Writes an integer.","summary":"<p>Writes an integer.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"args_string":"(number : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L71","def":{"name":"number","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalar do\n  @io << number\nend"}},{"id":"object(&block)-instance-method","html_id":"object(&amp;block)-instance-method","name":"object","doc":"Writes the start of an object, invokes the block,\nand the writes the end of it.","summary":"<p>Writes the start of an object, invokes the block, and the writes the end of it.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L214","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L214","def":{"name":"object","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_object\n(yield).tap do\n  end_object\nend\n"}},{"id":"raw(string:String)-instance-method","html_id":"raw(string:String)-instance-method","name":"raw","doc":"Writes a raw value, considered a scalar, directly into\nthe IO without processing. This is the only method that\nmight lead to invalid JSON being generated, so you must\nbe sure that *string* contains a valid JSON string.","summary":"<p>Writes a raw value, considered a scalar, directly into the IO without processing.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L152","def":{"name":"raw","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalar do\n  @io << string\nend"}},{"id":"scalar(value:Nil)-instance-method","html_id":"scalar(value:Nil)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Nil"}],"args_string":"(value : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L220","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L220","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"null"}},{"id":"scalar(value:Bool)-instance-method","html_id":"scalar(value:Bool)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L225","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bool(value)"}},{"id":"scalar(value:Int|Float)-instance-method","html_id":"scalar(value:Int|Float)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Int | Float"}],"args_string":"(value : Int | Float)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L230","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Int | Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"number(value)"}},{"id":"scalar(value:String)-instance-method","html_id":"scalar(value:String)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L235","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string(value)"}},{"id":"start_array-instance-method","html_id":"start_array-instance-method","name":"start_array","doc":"Writes the start of an array.","summary":"<p>Writes the start of an array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L159","def":{"name":"start_array","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"start_scalar\n@current_indent = @current_indent + 1\n@state.push(ArrayState.new(empty: true))\n@io << '['\n"}},{"id":"start_document-instance-method","html_id":"start_document-instance-method","name":"start_document","doc":"Starts a document.","summary":"<p>Starts a document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L26","def":{"name":"start_document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case state = @state.last\nwhen StartState\n  @state[-1] = DocumentStartState.new\nwhen DocumentEndState\n  @state[-1] = DocumentStartState.new\nelse\n  raise(JSON::Error.new(\"Starting document before ending previous one\"))\nend"}},{"id":"start_object-instance-method","html_id":"start_object-instance-method","name":"start_object","doc":"Writes the start of an object.","summary":"<p>Writes the start of an object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L188","def":{"name":"start_object","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"start_scalar\n@current_indent = @current_indent + 1\n@state.push(ObjectState.new(empty: true, name: true))\n@io << '{'\n"}},{"id":"string(value)-instance-method","html_id":"string(value)-instance-method","name":"string","doc":"Writes a string. The given *value* is first converted to a `String`\nby invoking `to_s` on it.\n\nThis method can also be used to write the name of an object field.","summary":"<p>Writes a string.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L95","def":{"name":"string","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string = value.to_s\nscalar(string: true) do\n  io << '\"'\n  start_pos = 0\n  reader = Char::Reader.new(string)\n  while reader.has_next?\n    case char = reader.current_char\n    when '\\\\'\n      escape = \"\\\\\\\\\"\n    when '\"'\n      escape = \"\\\\\\\"\"\n    when '\\b'\n      escape = \"\\\\b\"\n    when '\\f'\n      escape = \"\\\\f\"\n    when '\\n'\n      escape = \"\\\\n\"\n    when '\\r'\n      escape = \"\\\\r\"\n    when '\\t'\n      escape = \"\\\\t\"\n    when .ascii_control?\n      io.write(string.to_slice[start_pos, reader.pos - start_pos])\n      io << \"\\\\u\"\n      ord = char.ord\n      if ord < 4096\n        io << '0'\n      end\n      if ord < 256\n        io << '0'\n      end\n      if ord < 16\n        io << '0'\n      end\n      ord.to_s(16, io)\n      reader.next_char\n      start_pos = reader.pos\n      next\n    else\n      reader.next_char\n      next\n    end\n    io.write(string.to_slice[start_pos, reader.pos - start_pos])\n    io << escape\n    reader.next_char\n    start_pos = reader.pos\n  end\n  io.write(string.to_slice[start_pos, reader.pos - start_pos])\n  io << '\"'\nend\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/ArrayState","path":"JSON/Builder/ArrayState.html","kind":"struct","full_name":"JSON::Builder::ArrayState","name":"ArrayState","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(empty:Bool)-class-method","html_id":"new(empty:Bool)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"empty","doc":null,"default_value":"","external_name":"empty","restriction":"Bool"}],"args_string":"(empty : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","def":{"name":"new","args":[{"name":"empty","doc":null,"default_value":"","external_name":"empty","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(empty)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ArrayState.new(@empty.clone)"}},{"id":"copy_with(empty_empty=@empty)-instance-method","html_id":"copy_with(empty_empty=@empty)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_empty","doc":null,"default_value":"@empty","external_name":"empty","restriction":""}],"args_string":"(empty _empty = @empty)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L11","def":{"name":"copy_with","args":[{"name":"_empty","doc":null,"default_value":"@empty","external_name":"empty","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ArrayState.new(_empty)"}},{"id":"empty:Bool-instance-method","html_id":"empty:Bool-instance-method","name":"empty","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":null,"source_link":null,"def":{"name":"empty","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@empty"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/DocumentEndState","path":"JSON/Builder/DocumentEndState.html","kind":"struct","full_name":"JSON::Builder::DocumentEndState","name":"DocumentEndState","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DocumentEndState.new"}},{"id":"copy_with-instance-method","html_id":"copy_with-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L13","def":{"name":"copy_with","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DocumentEndState.new"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/DocumentStartState","path":"JSON/Builder/DocumentStartState.html","kind":"struct","full_name":"JSON::Builder::DocumentStartState","name":"DocumentStartState","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DocumentStartState.new"}},{"id":"copy_with-instance-method","html_id":"copy_with-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L10","def":{"name":"copy_with","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DocumentStartState.new"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/ObjectState","path":"JSON/Builder/ObjectState.html","kind":"struct","full_name":"JSON::Builder::ObjectState","name":"ObjectState","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(empty:Bool,name:Bool)-class-method","html_id":"new(empty:Bool,name:Bool)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"empty","doc":null,"default_value":"","external_name":"empty","restriction":"Bool"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"Bool"}],"args_string":"(empty : Bool, name : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","def":{"name":"new","args":[{"name":"empty","doc":null,"default_value":"","external_name":"empty","restriction":"Bool"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(empty, name)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ObjectState.new(@empty.clone, @name.clone)"}},{"id":"copy_with(empty_empty=@empty,name_name=@name)-instance-method","html_id":"copy_with(empty_empty=@empty,name_name=@name)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_empty","doc":null,"default_value":"@empty","external_name":"empty","restriction":""},{"name":"_name","doc":null,"default_value":"@name","external_name":"name","restriction":""}],"args_string":"(empty _empty = @empty, name _name = @name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L12","def":{"name":"copy_with","args":[{"name":"_empty","doc":null,"default_value":"@empty","external_name":"empty","restriction":""},{"name":"_name","doc":null,"default_value":"@name","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ObjectState.new(_empty, _name)"}},{"id":"empty:Bool-instance-method","html_id":"empty:Bool-instance-method","name":"empty","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":null,"source_link":null,"def":{"name":"empty","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@empty"}},{"id":"name:Bool-instance-method","html_id":"name:Bool-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":null,"source_link":null,"def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@name"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/StartState","path":"JSON/Builder/StartState.html","kind":"struct","full_name":"JSON::Builder::StartState","name":"StartState","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/builder.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StartState.new"}},{"id":"copy_with-instance-method","html_id":"copy_with-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr#L9","def":{"name":"copy_with","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StartState.new"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/State","path":"JSON/Builder/State.html","kind":"alias","full_name":"JSON::Builder::State","name":"State","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/builder.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(JSON::Builder::ArrayState | JSON::Builder::DocumentEndState | JSON::Builder::DocumentStartState | JSON::Builder::ObjectState | JSON::Builder::StartState)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/JSON/Error","path":"JSON/Error.html","kind":"class","full_name":"JSON::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json.cr","line_number":72,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Generic JSON error.","summary":"<p>Generic JSON error.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Field","path":"JSON/Field.html","kind":"annotation","full_name":"JSON::Field","name":"Field","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/serialization.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Lexer","path":"JSON/Lexer.html","kind":"class","full_name":"JSON::Lexer","name":"Lexer","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/lexer.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(string:String)-class-method","html_id":"new(string:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L4","def":{"name":"new","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StringBased.new(string)"}},{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L8","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"IOBased.new(io)"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L15","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"next_token-instance-method","html_id":"next_token-instance-method","name":"next_token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L32","def":{"name":"next_token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"skip_whitespace\n@token.line_number = @line_number\n@token.column_number = @column_number\ncase current_char\nwhen '\\u{0}'\n  @token.type = :EOF\nwhen '{'\n  next_char(:\"{\")\nwhen '}'\n  next_char(:\"}\")\nwhen '['\n  next_char(:\"[\")\nwhen ']'\n  next_char(:\"]\")\nwhen ','\n  next_char(:\",\")\nwhen ':'\n  next_char(:\":\")\nwhen 'f'\n  consume_false\nwhen 'n'\n  consume_null\nwhen 't'\n  consume_true\nwhen '\"'\n  @token.type = :STRING\n  @skip ? consume_string_skip : consume_string\nelse\n  consume_number\nend\n@token\n"}},{"id":"next_token_expect_object_key-instance-method","html_id":"next_token_expect_object_key-instance-method","name":"next_token_expect_object_key","doc":"Requests the next token where the parser expects a json\nobject key. In this case the lexer tries to reuse the String\ninstances by using a StringPool.","summary":"<p>Requests the next token where the parser expects a json object key.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L72","def":{"name":"next_token_expect_object_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@expects_object_key = true\nnext_token\n@expects_object_key = false\n@token\n"}},{"id":"skip:Bool-instance-method","html_id":"skip:Bool-instance-method","name":"skip","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L13","def":{"name":"skip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@skip"}},{"id":"skip=(skip:Bool)-instance-method","html_id":"skip=(skip:Bool)-instance-method","name":"skip=","doc":null,"summary":null,"abstract":false,"args":[{"name":"skip","doc":null,"default_value":"","external_name":"skip","restriction":"Bool"}],"args_string":"(skip : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L13","def":{"name":"skip=","args":[{"name":"skip","doc":null,"default_value":"","external_name":"skip","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@skip = skip"}},{"id":"token:Token-instance-method","html_id":"token:Token-instance-method","name":"token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Token","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/lexer.cr#L12","def":{"name":"token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Token","visibility":"Public","body":"@token"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/MappingError","path":"JSON/MappingError.html","kind":"class","full_name":"JSON::MappingError","name":"MappingError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"},{"html_id":"github.com/crystal-lang/crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/mapping.cr","line_number":234,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(message:String?,klass:String,attribute:String?,line_number:Int32,column_number:Int32,cause)-class-method","html_id":"new(message:String?,klass:String,attribute:String?,line_number:Int32,column_number:Int32,cause)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"String | ::Nil"},{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"String"},{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String | ::Nil"},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":"Int32"},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":"Int32"},{"name":"cause","doc":null,"default_value":"","external_name":"cause","restriction":""}],"args_string":"(message : String?, klass : String, attribute : String?, line_number : Int32, column_number : Int32, cause)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L238","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L238","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"String | ::Nil"},{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"String"},{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String | ::Nil"},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":"Int32"},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":"Int32"},{"name":"cause","doc":null,"default_value":"","external_name":"cause","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, klass, attribute, line_number, column_number, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"attribute:String?-instance-method","html_id":"attribute:String?-instance-method","name":"attribute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L236","def":{"name":"attribute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@attribute"}},{"id":"klass:String-instance-method","html_id":"klass:String-instance-method","name":"klass","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/mapping.cr#L235","def":{"name":"klass","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@klass"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/ParseException","path":"JSON/ParseException.html","kind":"class","full_name":"JSON::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json.cr","line_number":76,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/JSON/MappingError","kind":"class","full_name":"JSON::MappingError","name":"MappingError"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Exception thrown on a JSON parse error.","summary":"<p>Exception thrown on a JSON parse error.</p>","class_methods":[],"constructors":[{"id":"new(message,line_number,column_number,cause=nil)-class-method","html_id":"new(message,line_number,column_number,cause=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""},{"name":"cause","doc":null,"default_value":"nil","external_name":"cause","restriction":""}],"args_string":"(message, line_number, column_number, cause = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L80","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""},{"name":"cause","doc":null,"default_value":"nil","external_name":"cause","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"column_number:Int32-instance-method","html_id":"column_number:Int32-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L78","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column_number"}},{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L77","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}},{"id":"location-instance-method","html_id":"location-instance-method","name":"location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json.cr#L84","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{line_number, column_number}"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Parser","path":"JSON/Parser.html","kind":"class","full_name":"JSON::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/parser.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(string_or_io:String|IO)-class-method","html_id":"new(string_or_io:String|IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L6","def":{"name":"new","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"max_nesting:Int32-instance-method","html_id":"max_nesting:Int32-instance-method","name":"max_nesting","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L4","def":{"name":"max_nesting","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@max_nesting"}},{"id":"max_nesting=(max_nesting)-instance-method","html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","doc":null,"summary":null,"abstract":false,"args":[{"name":"max_nesting","doc":null,"default_value":"","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L4","def":{"name":"max_nesting=","args":[{"name":"max_nesting","doc":null,"default_value":"","external_name":"max_nesting","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@max_nesting = max_nesting"}},{"id":"parse:Any-instance-method","html_id":"parse:Any-instance-method","name":"parse","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/parser.cr#L12","def":{"name":"parse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Any","visibility":"Public","body":"json = parse_value\ncheck(:EOF)\njson\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/PullParser","path":"JSON/PullParser.html","kind":"class","full_name":"JSON::PullParser","name":"PullParser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/pull_parser.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"This class allows you to consume JSON on demand, token by token.","summary":"<p>This class allows you to consume JSON on demand, token by token.</p>","class_methods":[],"constructors":[{"id":"new(input)-class-method","html_id":"new(input)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""}],"args_string":"(input)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L12","def":{"name":"new","args":[{"name":"input","doc":null,"default_value":"","external_name":"input","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(input)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"bool_value:Bool-instance-method","html_id":"bool_value:Bool-instance-method","name":"bool_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L4","def":{"name":"bool_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@bool_value"}},{"id":"column_number-instance-method","html_id":"column_number-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L404","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L404","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@location[1]"}},{"id":"float_value:Float64-instance-method","html_id":"float_value:Float64-instance-method","name":"float_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L6","def":{"name":"float_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@float_value"}},{"id":"int_value:Int64-instance-method","html_id":"int_value:Int64-instance-method","name":"int_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L5","def":{"name":"int_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@int_value"}},{"id":"kind:Symbol-instance-method","html_id":"kind:Symbol-instance-method","name":"kind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Symbol","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L3","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Symbol","visibility":"Public","body":"@kind"}},{"id":"line_number-instance-method","html_id":"line_number-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L400","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@location[0]"}},{"id":"location:{Int32,Int32}-instance-method","html_id":"location:{Int32,Int32}-instance-method","name":"location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : {Int32, Int32}","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L408","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L408","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@location"}},{"id":"max_nesting:Int32-instance-method","html_id":"max_nesting:Int32-instance-method","name":"max_nesting","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L10","def":{"name":"max_nesting","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@max_nesting"}},{"id":"max_nesting=(max_nesting)-instance-method","html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","doc":null,"summary":null,"abstract":false,"args":[{"name":"max_nesting","doc":null,"default_value":"","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L10","def":{"name":"max_nesting=","args":[{"name":"max_nesting","doc":null,"default_value":"","external_name":"max_nesting","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@max_nesting = max_nesting"}},{"id":"on_key(key,&block)-instance-method","html_id":"on_key(key,&amp;block)-instance-method","name":"on_key","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L217","def":{"name":"on_key","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_object do |some_key|\n  some_key == key ? yield : skip\nend"}},{"id":"on_key!(key,&block)-instance-method","html_id":"on_key!(key,&amp;block)-instance-method","name":"on_key!","doc":null,"summary":null,"abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"args_string":"(key, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L223","def":{"name":"on_key!","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"found = false\nvalue = uninitialized typeof(yield)\nread_object do |some_key|\n  if some_key == key\n    found = true\n    value = yield\n  else\n    skip\n  end\nend\nif found\nelse\n  raise(\"JSON key not found: #{key}\")\nend\nvalue\n"}},{"id":"raw_value:String-instance-method","html_id":"raw_value:String-instance-method","name":"raw_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L8","def":{"name":"raw_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@raw_value"}},{"id":"read?(klass:Int8.class)-instance-method","html_id":"read?(klass:Int8.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int8.class"}],"args_string":"(klass : Int8.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L252","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int8.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_i8\nend"}},{"id":"read?(klass:Int16.class)-instance-method","html_id":"read?(klass:Int16.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int16.class"}],"args_string":"(klass : Int16.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L256","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int16.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_i16\nend"}},{"id":"read?(klass:Int32.class)-instance-method","html_id":"read?(klass:Int32.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int32.class"}],"args_string":"(klass : Int32.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L260","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int32.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_i32\nend"}},{"id":"read?(klass:Int64.class)-instance-method","html_id":"read?(klass:Int64.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int64.class"}],"args_string":"(klass : Int64.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L264","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Int64.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_i64\nend"}},{"id":"read?(klass:UInt8.class)-instance-method","html_id":"read?(klass:UInt8.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt8.class"}],"args_string":"(klass : UInt8.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L268","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt8.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_u8\nend"}},{"id":"read?(klass:UInt16.class)-instance-method","html_id":"read?(klass:UInt16.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt16.class"}],"args_string":"(klass : UInt16.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L272","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt16.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_u16\nend"}},{"id":"read?(klass:UInt32.class)-instance-method","html_id":"read?(klass:UInt32.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt32.class"}],"args_string":"(klass : UInt32.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L276","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt32.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_u32\nend"}},{"id":"read?(klass:UInt64.class)-instance-method","html_id":"read?(klass:UInt64.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt64.class"}],"args_string":"(klass : UInt64.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L280","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L280","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"UInt64.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  read_int.to_u64\nend"}},{"id":"read?(klass:Float32.class)-instance-method","html_id":"read?(klass:Float32.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Float32.class"}],"args_string":"(klass : Float32.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L284","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L284","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Float32.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  return read_int.to_f32\nend\nif kind == (:float)\n  return read_float.to_f32\nend\n"}},{"id":"read?(klass:Float64.class)-instance-method","html_id":"read?(klass:Float64.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Float64.class"}],"args_string":"(klass : Float64.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L289","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Float64.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:int)\n  return read_int.to_f64\nend\nif kind == (:float)\n  return read_float.to_f64\nend\n"}},{"id":"read?(klass:String.class)-instance-method","html_id":"read?(klass:String.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"String.class"}],"args_string":"(klass : String.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L294","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"String.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:string)\n  read_string\nend"}},{"id":"read?(klass:Bool.class)-instance-method","html_id":"read?(klass:Bool.class)-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Bool.class"}],"args_string":"(klass : Bool.class)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L248","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L248","def":{"name":"read?","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"Bool.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == (:bool)\n  read_bool\nend"}},{"id":"read_array(&block)-instance-method","html_id":"read_array(&amp;block)-instance-method","name":"read_array","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L64","def":{"name":"read_array","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_begin_array\nwhile kind != (:end_array)\n  yield\nend\nread_end_array\n"}},{"id":"read_array_or_null(&block)-instance-method","html_id":"read_array_or_null(&amp;block)-instance-method","name":"read_array_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L200","def":{"name":"read_array_or_null","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_array do\n    yield\n  end\nend"}},{"id":"read_begin_array-instance-method","html_id":"read_begin_array-instance-method","name":"read_begin_array","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L54","def":{"name":"read_begin_array","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:begin_array)\nread_next\n"}},{"id":"read_begin_object-instance-method","html_id":"read_begin_object-instance-method","name":"read_begin_object","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L72","def":{"name":"read_begin_object","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:begin_object)\nread_next\n"}},{"id":"read_bool-instance-method","html_id":"read_bool-instance-method","name":"read_bool","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L101","def":{"name":"read_bool","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:bool)\n@bool_value.tap do\n  read_next\nend\n"}},{"id":"read_bool_or_null-instance-method","html_id":"read_bool_or_null-instance-method","name":"read_bool_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L184","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L184","def":{"name":"read_bool_or_null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_bool\nend"}},{"id":"read_end_array-instance-method","html_id":"read_end_array-instance-method","name":"read_end_array","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L59","def":{"name":"read_end_array","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:end_array)\nread_next\n"}},{"id":"read_end_object-instance-method","html_id":"read_end_object-instance-method","name":"read_end_object","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L77","def":{"name":"read_end_object","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:end_object)\nread_next\n"}},{"id":"read_float-instance-method","html_id":"read_float-instance-method","name":"read_float","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L111","def":{"name":"read_float","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case @kind\nwhen :int\n  @int_value.to_f.tap do\n    read_next\n  end\nwhen :float\n  @float_value.tap do\n    read_next\n  end\nelse\n  parse_exception(\"expecting int or float but was #{@kind}\")\nend"}},{"id":"read_float_or_null-instance-method","html_id":"read_float_or_null-instance-method","name":"read_float_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L192","def":{"name":"read_float_or_null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_float\nend"}},{"id":"read_int-instance-method","html_id":"read_int-instance-method","name":"read_int","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L106","def":{"name":"read_int","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:int)\n@int_value.tap do\n  read_next\nend\n"}},{"id":"read_int_or_null-instance-method","html_id":"read_int_or_null-instance-method","name":"read_int_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L188","def":{"name":"read_int_or_null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_int\nend"}},{"id":"read_next-instance-method","html_id":"read_next-instance-method","name":"read_next","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L243","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L243","def":{"name":"read_next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_next_internal\n@kind\n"}},{"id":"read_null-instance-method","html_id":"read_null-instance-method","name":"read_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L95","def":{"name":"read_null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:null)\nread_next\nnil\n"}},{"id":"read_null_or(&block)-instance-method","html_id":"read_null_or(&amp;block)-instance-method","name":"read_null_or","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L208","def":{"name":"read_null_or","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @kind == (:null)\n  read_next\n  nil\nelse\n  yield\nend"}},{"id":"read_object(&block)-instance-method","html_id":"read_object(&amp;block)-instance-method","name":"read_object","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L86","def":{"name":"read_object","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"read_begin_object\nwhile kind != (:end_object)\n  key = read_object_key\n  yield key\nend\nread_end_object\n"}},{"id":"read_object_key-instance-method","html_id":"read_object_key-instance-method","name":"read_object_key","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L82","def":{"name":"read_object_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_string"}},{"id":"read_object_or_null(&block)-instance-method","html_id":"read_object_or_null(&amp;block)-instance-method","name":"read_object_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L204","def":{"name":"read_object_or_null","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_object do |key|\n    yield key\n  end\nend"}},{"id":"read_raw-instance-method","html_id":"read_raw-instance-method","name":"read_raw","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L122","def":{"name":"read_raw","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case @kind\nwhen :null\n  read_next\n  \"null\"\nwhen :bool\n  @bool_value.to_s.tap do\n    read_next\n  end\nwhen :int, :float\n  @raw_value.tap do\n    read_next\n  end\nwhen :string\n  @string_value.to_json.tap do\n    read_next\n  end\nwhen :begin_array\n  JSON.build do |json|\n    read_raw(json)\n  end\nwhen :begin_object\n  JSON.build do |json|\n    read_raw(json)\n  end\nelse\n  unexpected_token\nend"}},{"id":"read_raw(json)-instance-method","html_id":"read_raw(json)-instance-method","name":"read_raw","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":""}],"args_string":"(json)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L142","def":{"name":"read_raw","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case @kind\nwhen :null\n  read_next\n  json.null\nwhen :bool\n  json.bool(@bool_value)\n  read_next\nwhen :int, :float\n  json.raw(@raw_value)\n  read_next\nwhen :string\n  json.string(@string_value)\n  read_next\nwhen :begin_array\n  json.array do\n    read_begin_array\n    while kind != (:end_array)\n      read_raw(json)\n    end\n    read_end_array\n  end\nwhen :begin_object\n  json.object do\n    read_begin_object\n    while kind != (:end_object)\n      json.string(@string_value)\n      read_object_key\n      read_raw(json)\n    end\n    read_end_object\n  end\nelse\n  unexpected_token\nend"}},{"id":"read_string-instance-method","html_id":"read_string-instance-method","name":"read_string","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L179","def":{"name":"read_string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(:string)\n@string_value.tap do\n  read_next\nend\n"}},{"id":"read_string_or_null-instance-method","html_id":"read_string_or_null-instance-method","name":"read_string_or_null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L196","def":{"name":"read_string_or_null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_null_or do\n  read_string\nend"}},{"id":"skip-instance-method","html_id":"skip-instance-method","name":"skip","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L394","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L394","def":{"name":"skip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@lexer.skip = true\nskip_internal\n@lexer.skip = false\n"}},{"id":"string_value:String-instance-method","html_id":"string_value:String-instance-method","name":"string_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/pull_parser.cr#L7","def":{"name":"string_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@string_value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable","path":"JSON/Serializable.html","kind":"module","full_name":"JSON::Serializable","name":"Serializable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/serialization.cr","line_number":110,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"The `JSON::Serializable` module automatically generates methods for JSON serialization when included.\n\n### Example\n\n```\nrequire \"json\"\n\nclass Location\n  include JSON::Serializable\n\n  @[JSON::Field(key: \"lat\")]\n  property latitude : Float64\n\n  @[JSON::Field(key: \"lng\")]\n  property longitude : Float64\nend\n\nclass House\n  include JSON::Serializable\n  property address : String\n  property location : Location?\nend\n\nhouse = House.from_json(%({\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}))\nhouse.address  # => \"Crystal Road 1234\"\nhouse.location # => #<Location:0x10cd93d80 @latitude=12.3, @longitude=34.5>\nhouse.to_json  # => %({\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}})\n\nhouses = Array(House).from_json(%([{\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}]))\nhouses.size    # => 1\nhouses.to_json # => [{\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}}]\n```\n\n### Usage\n\nIncluding `JSON::Serializable` will create `#to_json` and `self.from_json` methods on the current class,\nand a constructor which takes a `JSON::PullParser`. By default, these methods serialize into a json\nobject containing the value of every instance variable, the keys being the instance variable name.\nMost primitives and collections supported as instance variable values (string, integer, array, hash, etc.),\nalong with objects which define to_json and a constructor taking a `JSON::PullParser`.\nUnion types are also supported, including unions with nil. If multiple types in a union parse correctly,\nit is undefined which one will be chosen.\n\nTo change how individual instance variables are parsed and serialized, the annotation `JSON::Field`\ncan be placed on the instance variable. Annotating property, getter and setter macros is also allowed.\n```\nclass A\n  include JSON::Serializable\n\n  @[JSON::Field(key: \"my_key\", emit_null: true)]\n  getter a : Int32?\nend\n```\n\n`JSON::Field` properties:\n* **ignore**: if `true` skip this field in seriazation and deserialization (by default false)\n* **key**: the value of the key in the json object (by default the name of the instance variable)\n* **root**: assume the value is inside a JSON object with a given key (see `Object.from_json(string_or_io, root)`)\n* **converter**: specify an alternate type for parsing and generation. The converter must define `from_json(JSON::PullParser)` and `to_json(value, JSON::Builder)` as class methods. Examples of converters are `Time::Format` and `Time::EpochConverter` for `Time`.\n* **presense**: if `true`, a `@{{key}}_present` instance variable will be generated when the key was present (even if it has a `null` value), `false` by default\n* **emit_null**: if `true`, emits a `null` value for nilable property (by default nulls are not emitted)\n\nDeserialization also respects default values of variables:\n```\nstruct A\n  include JSON::Serializable\n  @a : Int32\n  @b : Float64 = 1.0\nend\n\nA.from_json(%<{\"a\":1}>) # => A(@a=1, @b=1.0)\n```\n\n### Extensions: `JSON::Serializable::Strict` and `JSON::Serializable::Unmapped`.\n\nIf the `JSON::Serializable::Strict` module is included, unknown properties in the JSON\ndocument will raise a parse exception. By default the unknown properties\nare silently ignored.\nIf the `JSON::Serializable::Unmapped` module is included, unknown properties in the JSON\ndocument will be stored in a `Hash(String, JSON::Any)`. On serialization, any keys inside json_unmapped\nwill be serialized appended to the current json object.\n```\nstruct A\n  include JSON::Serializable\n  include JSON::Serializable::Unmapped\n  @a : Int32\nend\n\na = A.from_json(%({\"a\":1,\"b\":2})) # => A(@json_unmapped={\"b\" => 2_i64}, @a=1)\na.to_json                         # => {\"a\":1,\"b\":2}\n```\n\n\n### Class annotation `JSON::Serializable::Options`\n\nsupported properties:\n* **emit_nulls**: if `true`, emits a `null` value for all nilable properties (by default nulls are not emitted)\n\n```\n@[JSON::Serializable::Options(emit_nulls: true)]\nclass A\n  include JSON::Serializable\n  @a : Int32?\nend\n```","summary":"<p>The <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> module automatically generates methods for JSON serialization when included.</p>","class_methods":[],"constructors":[{"id":"new(pull:JSON::PullParser,dummy:Nil)-class-method","html_id":"new(pull:JSON::PullParser,dummy:Nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"::JSON::PullParser"},{"name":"dummy","doc":null,"default_value":"","external_name":"dummy","restriction":"Nil"}],"args_string":"(pull : JSON::PullParser, dummy : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L135","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"::JSON::PullParser"},{"name":"dummy","doc":null,"default_value":"","external_name":"dummy","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(pull, dummy)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"::JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L244","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"::JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n        {% options = @type.annotation(::JSON::Serializable::Options) %}\n        {% emit_nulls = options && options[:emit_nulls] %}\n\n        {% properties = {} of Nil => Nil %}\n        {% for ivar in @type.instance_vars %}\n          {% ann = ivar.annotation(::JSON::Field) %}\n          {% if ann && ann[:ignore] %}{% else %}\n            {% properties[ivar.id] = {type: ivar.type, key: ((ann && ann[:key]) || ivar).id.stringify, root: ann && ann[:root], converter: ann && ann[:converter], emit_null: (ann && (ann[:emit_null] != nil) ? ann[:emit_null] : emit_nulls)} %}\n          {% end %}\n        {% end %}\n\n        json.object do\n          {% for name, value in properties %}\n            _{{ name }} = @{{ name }}\n\n            {% if value[:emit_null] %}{% else %}\n              unless _{{ name }}.nil?\n            {% end %}\n\n              json.field({{ value[:key] }}) do\n                {% if value[:root] %}\n                  {% if value[:emit_null] %}\n                    if _{{ name }}.nil?\n                      nil.to_json(json)\n                    else\n                  {% end %}\n\n                  json.object do\n                    json.field({{ value[:root] }}) do\n                {% end %}\n\n                {% if value[:converter] %}\n                  if _{{ name }}\n                    {{ value[:converter] }}.to_json(_{{ name }}, json)\n                  else\n                    nil.to_json(json)\n                  end\n                {% else %}\n                  _{{ name }}.to_json(json)\n                {% end %}\n\n                {% if value[:root] %}\n                  {% if value[:emit_null] %}\n                    end\n                  {% end %}\n                    end\n                  end\n                {% end %}\n              end\n\n            {% if value[:emit_null] %}{% else %}\n              end\n            {% end %}\n          {% end %}\n          on_to_json(json)\n        end\n      {% end %}"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable/Options","path":"JSON/Serializable/Options.html","kind":"annotation","full_name":"JSON::Serializable::Options","name":"Options","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/serialization.cr","line_number":111,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable/Strict","path":"JSON/Serializable/Strict.html","kind":"module","full_name":"JSON::Serializable::Strict","name":"Strict","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/serialization.cr","line_number":313,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable/Unmapped","path":"JSON/Serializable/Unmapped.html","kind":"module","full_name":"JSON::Serializable::Unmapped","name":"Unmapped","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/serialization.cr","line_number":319,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"json_unmapped-instance-method","html_id":"json_unmapped-instance-method","name":"json_unmapped","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L321","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L321","def":{"name":"json_unmapped","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@json_unmapped"}},{"id":"json_unmapped=(json_unmapped)-instance-method","html_id":"json_unmapped=(json_unmapped)-instance-method","name":"json_unmapped=","doc":null,"summary":null,"abstract":false,"args":[{"name":"json_unmapped","doc":null,"default_value":"","external_name":"json_unmapped","restriction":""}],"args_string":"(json_unmapped)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L321","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/serialization.cr#L321","def":{"name":"json_unmapped=","args":[{"name":"json_unmapped","doc":null,"default_value":"","external_name":"json_unmapped","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@json_unmapped = json_unmapped"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/JSON/Token","path":"JSON/Token.html","kind":"class","full_name":"JSON::Token","name":"Token","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"json/token.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L10","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"column_number:Int32-instance-method","html_id":"column_number:Int32-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L7","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column_number"}},{"id":"column_number=(column_number:Int32)-instance-method","html_id":"column_number=(column_number:Int32)-instance-method","name":"column_number=","doc":null,"summary":null,"abstract":false,"args":[{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":"Int32"}],"args_string":"(column_number : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L7","def":{"name":"column_number=","args":[{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@column_number = column_number"}},{"id":"float_value:Float64-instance-method","html_id":"float_value:Float64-instance-method","name":"float_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L5","def":{"name":"float_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@float_value"}},{"id":"float_value=(float_value:Float64)-instance-method","html_id":"float_value=(float_value:Float64)-instance-method","name":"float_value=","doc":null,"summary":null,"abstract":false,"args":[{"name":"float_value","doc":null,"default_value":"","external_name":"float_value","restriction":"Float64"}],"args_string":"(float_value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L5","def":{"name":"float_value=","args":[{"name":"float_value","doc":null,"default_value":"","external_name":"float_value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@float_value = float_value"}},{"id":"int_value:Int64-instance-method","html_id":"int_value:Int64-instance-method","name":"int_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L4","def":{"name":"int_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@int_value"}},{"id":"int_value=(int_value:Int64)-instance-method","html_id":"int_value=(int_value:Int64)-instance-method","name":"int_value=","doc":null,"summary":null,"abstract":false,"args":[{"name":"int_value","doc":null,"default_value":"","external_name":"int_value","restriction":"Int64"}],"args_string":"(int_value : Int64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L4","def":{"name":"int_value=","args":[{"name":"int_value","doc":null,"default_value":"","external_name":"int_value","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@int_value = int_value"}},{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L6","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}},{"id":"line_number=(line_number:Int32)-instance-method","html_id":"line_number=(line_number:Int32)-instance-method","name":"line_number=","doc":null,"summary":null,"abstract":false,"args":[{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":"Int32"}],"args_string":"(line_number : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L6","def":{"name":"line_number=","args":[{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@line_number = line_number"}},{"id":"raw_value:String-instance-method","html_id":"raw_value:String-instance-method","name":"raw_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L8","def":{"name":"raw_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@raw_value"}},{"id":"raw_value=(raw_value:String)-instance-method","html_id":"raw_value=(raw_value:String)-instance-method","name":"raw_value=","doc":null,"summary":null,"abstract":false,"args":[{"name":"raw_value","doc":null,"default_value":"","external_name":"raw_value","restriction":"String"}],"args_string":"(raw_value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L8","def":{"name":"raw_value=","args":[{"name":"raw_value","doc":null,"default_value":"","external_name":"raw_value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@raw_value = raw_value"}},{"id":"string_value:String-instance-method","html_id":"string_value:String-instance-method","name":"string_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L3","def":{"name":"string_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@string_value"}},{"id":"string_value=(string_value:String)-instance-method","html_id":"string_value=(string_value:String)-instance-method","name":"string_value=","doc":null,"summary":null,"abstract":false,"args":[{"name":"string_value","doc":null,"default_value":"","external_name":"string_value","restriction":"String"}],"args_string":"(string_value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L3","def":{"name":"string_value=","args":[{"name":"string_value","doc":null,"default_value":"","external_name":"string_value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@string_value = string_value"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L20","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case @type\nwhen :INT\n  @int_value.to_s(io)\nwhen :FLOAT\n  @float_value.to_s(io)\nwhen :STRING\n  @string_value.to_s(io)\nelse\n  @type.to_s(io)\nend"}},{"id":"type:Symbol-instance-method","html_id":"type:Symbol-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Symbol","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L2","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Symbol","visibility":"Public","body":"@type"}},{"id":"type=(type:Symbol)-instance-method","html_id":"type=(type:Symbol)-instance-method","name":"type=","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Symbol"}],"args_string":"(type : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/token.cr#L2","def":{"name":"type=","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@type = type"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/KeyError","path":"KeyError.html","kind":"class","full_name":"KeyError","name":"KeyError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":118,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when the specified key is not found.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"baz\"] # raises KeyError (Missing hash key: \"baz\")\n```","summary":"<p>Raised when the specified key is not found.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Levenshtein","path":"Levenshtein.html","kind":"module","full_name":"Levenshtein","name":"Levenshtein","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"levenshtein.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Levensthein distance methods.","summary":"<p>Levensthein distance methods.</p>","class_methods":[{"id":"distance(string1:String,string2:String):Int32-class-method","html_id":"distance(string1:String,string2:String):Int32-class-method","name":"distance","doc":"Computes the [levenshtein distance](http://en.wikipedia.org/wiki/Levenshtein_distance) of two strings.\n\n```\nrequire \"levenshtein\"\n\nLevenshtein.distance(\"algorithm\", \"altruistic\") # => 6\nLevenshtein.distance(\"hello\", \"hallo\")          # => 1\nLevenshtein.distance(\"こんにちは\", \"こんちは\")           # => 1\nLevenshtein.distance(\"hey\", \"hey\")              # => 0\n```","summary":"<p>Computes the <a href=\"http://en.wikipedia.org/wiki/Levenshtein_distance\" target=\"_blank\">levenshtein distance</a> of two strings.</p>","abstract":false,"args":[{"name":"string1","doc":null,"default_value":"","external_name":"string1","restriction":"String"},{"name":"string2","doc":null,"default_value":"","external_name":"string2","restriction":"String"}],"args_string":"(string1 : String, string2 : String) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L13","def":{"name":"distance","args":[{"name":"string1","doc":null,"default_value":"","external_name":"string1","restriction":"String"},{"name":"string2","doc":null,"default_value":"","external_name":"string2","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"if string1 == string2\n  return 0\nend\ns = string1.chars\nt = string2.chars\ns_size = s.size\nt_size = t.size\nif s_size == 0\n  return t_size\nend\nif t_size == 0\n  return s_size\nend\nif t_size > s_size\n  t, s = s, t\n  t_size, s_size = s_size, t_size\nend\nv = Pointer(Int32).malloc(t_size + 1) do |i|\n  i\nend\ns_size.times do |i|\n  last_cost = i + 1\n  t_size.times do |j|\n    sub_cost = s[i] == t[j] ? 0 : 1\n    cost = Math.min(Math.min(last_cost + 1, v[j + 1] + 1), v[j] + sub_cost)\n    v[j] = last_cost\n    last_cost = cost\n  end\n  v[t_size] = last_cost\nend\nv[t_size]\n"}},{"id":"find(name,tolerance=nil,&block)-class-method","html_id":"find(name,tolerance=nil,&amp;block)-class-method","name":"find","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, tolerance = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L102","def":{"name":"find","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"Finder.find(name, tolerance) do |sn|\n  yield sn\nend"}},{"id":"find(name,all_names,tolerance=nil)-class-method","html_id":"find(name,all_names,tolerance=nil)-class-method","name":"find","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"all_names","doc":null,"default_value":"","external_name":"all_names","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, all_names, tolerance = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L108","def":{"name":"find","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"all_names","doc":null,"default_value":"","external_name":"all_names","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Finder.find(name, all_names, tolerance)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Levenshtein/Finder","path":"Levenshtein/Finder.html","kind":"class","full_name":"Levenshtein::Finder","name":"Finder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"levenshtein.cr","line_number":58,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Levenshtein","kind":"module","full_name":"Levenshtein","name":"Levenshtein"},"doc":"Finds the closest string to a given string amongst many strings.\n\n```\nfinder = Levenshtein::Finder.new \"hallo\"\nfinder.test \"hay\"\nfinder.test \"hall\"\nfinder.test \"hallo world\"\n\nfinder.best_match # => \"hall\"\n```","summary":"<p>Finds the closest string to a given string amongst many strings.</p>","class_methods":[{"id":"find(name,tolerance=nil,&block)-class-method","html_id":"find(name,tolerance=nil,&amp;block)-class-method","name":"find","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, tolerance = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L87","def":{"name":"find","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sn = new(name, tolerance)\nyield sn\nsn.best_match\n"}},{"id":"find(name,all_names,tolerance=nil)-class-method","html_id":"find(name,all_names,tolerance=nil)-class-method","name":"find","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"all_names","doc":null,"default_value":"","external_name":"all_names","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, all_names, tolerance = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L93","def":{"name":"find","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"all_names","doc":null,"default_value":"","external_name":"all_names","restriction":""},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"find(name, tolerance) do |similar|\n  all_names.each do |a_name|\n    similar.test(a_name)\n  end\nend"}}],"constructors":[{"id":"new(target:String,tolerance:Int?=nil)-class-method","html_id":"new(target:String,tolerance:Int?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"String"},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":"Int | ::Nil"}],"args_string":"(target : String, tolerance : Int? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L66","def":{"name":"new","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"String"},{"name":"tolerance","doc":null,"default_value":"nil","external_name":"tolerance","restriction":"Int | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(target, tolerance)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"best_match-instance-method","html_id":"best_match-instance-method","name":"best_match","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L83","def":{"name":"best_match","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@best_entry.try(&.value)"}},{"id":"test(name:String,value:String=name)-instance-method","html_id":"test(name:String,value:String=name)-instance-method","name":"test","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"name","external_name":"value","restriction":"String"}],"args_string":"(name : String, value : String = name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/levenshtein.cr#L70","def":{"name":"test","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"name","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"distance = Levenshtein.distance(@target, name)\nif distance <= @tolerance\n  if best_entry = @best_entry\n    if distance < best_entry.distance\n      @best_entry = Entry.new(value, distance)\n    end\n  else\n    @best_entry = Entry.new(value, distance)\n  end\nend\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/LLVM","path":"LLVM.html","kind":"module","full_name":"LLVM","name":"LLVM","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"llvm/abi.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr"},{"filename":"llvm/enums.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"},{"filename":"llvm.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEBUG_METADATA_VERSION","name":"DEBUG_METADATA_VERSION","value":"3","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"default_target_triple:String-class-method","html_id":"default_target_triple:String-class-method","name":"default_target_triple","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L76","def":{"name":"default_target_triple","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"chars = LibLLVM.get_default_target_triple\ntriple = string_and_dispose(chars)\nif triple =~ (/x86_64-apple-macosx|x86_64-apple-darwin/)\n  \"x86_64-apple-macosx\"\nelse\n  triple\nend\n"}},{"id":"init_aarch64-class-method","html_id":"init_aarch64-class-method","name":"init_aarch64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L24","def":{"name":"init_aarch64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @@initialized_aarch64\n  return\nend\n@@initialized_aarch64 = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:aarch64) %}\n      LibLLVM.initialize_aarch64_target_info\n      LibLLVM.initialize_aarch64_target\n      LibLLVM.initialize_aarch64_target_mc\n      LibLLVM.initialize_aarch64_asm_printer\n      LibLLVM.initialize_aarch64_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without AArch64 target\"\n    {% end %}\n"}},{"id":"init_arm-class-method","html_id":"init_arm-class-method","name":"init_arm","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L41","def":{"name":"init_arm","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @@initialized_arm\n  return\nend\n@@initialized_arm = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:arm) %}\n      LibLLVM.initialize_arm_target_info\n      LibLLVM.initialize_arm_target\n      LibLLVM.initialize_arm_target_mc\n      LibLLVM.initialize_arm_asm_printer\n      LibLLVM.initialize_arm_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without ARM target\"\n    {% end %}\n"}},{"id":"init_x86-class-method","html_id":"init_x86-class-method","name":"init_x86","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L7","def":{"name":"init_x86","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @@initialized_x86\n  return\nend\n@@initialized_x86 = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:x86) %}\n      LibLLVM.initialize_x86_target_info\n      LibLLVM.initialize_x86_target\n      LibLLVM.initialize_x86_target_mc\n      LibLLVM.initialize_x86_asm_printer\n      LibLLVM.initialize_x86_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without X86 target\"\n    {% end %}\n"}},{"id":"multithreaded?:Bool-class-method","html_id":"multithreaded?:Bool-class-method","name":"multithreaded?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L72","def":{"name":"multithreaded?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"LibLLVM.is_multithreaded != 0"}},{"id":"start_multithreaded:Bool-class-method","html_id":"start_multithreaded:Bool-class-method","name":"start_multithreaded","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L58","def":{"name":"start_multithreaded","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if multithreaded?\n  true\nelse\n  LibLLVM.start_multithreaded != 0\nend"}},{"id":"stop_multithreaded-class-method","html_id":"stop_multithreaded-class-method","name":"stop_multithreaded","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L66","def":{"name":"stop_multithreaded","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if multithreaded?\n  LibLLVM.stop_multithreaded\nend"}},{"id":"string_and_dispose(chars):String-class-method","html_id":"string_and_dispose(chars):String-class-method","name":"string_and_dispose","doc":null,"summary":null,"abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":""}],"args_string":"(chars) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L91","def":{"name":"string_and_dispose","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"string = String.new(chars)\nLibLLVM.dispose_message(chars)\nstring\n"}},{"id":"to_io(chars,io)-class-method","html_id":"to_io(chars,io)-class-method","name":"to_io","doc":null,"summary":null,"abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(chars, io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm.cr#L86","def":{"name":"to_io","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io.write(Slice.new(chars, LibC.strlen(chars)))\nLibLLVM.dispose_message(chars)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","path":"LLVM/ABI.html","kind":"class","full_name":"LLVM::ABI","name":"ABI","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/AArch64","kind":"class","full_name":"LLVM::ABI::AArch64","name":"AArch64"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/ARM","kind":"class","full_name":"LLVM::ABI::ARM","name":"ARM"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86","kind":"class","full_name":"LLVM::ABI::X86","name":"X86"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86_64","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(target_machine:TargetMachine)-class-method","html_id":"new(target_machine:TargetMachine)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"target_machine","doc":null,"default_value":"","external_name":"target_machine","restriction":"TargetMachine"}],"args_string":"(target_machine : TargetMachine)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L6","def":{"name":"new","args":[{"name":"target_machine","doc":null,"default_value":"","external_name":"target_machine","restriction":"TargetMachine"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(target_machine)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","doc":null,"summary":null,"abstract":true,"args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L13","def":{"name":"abi_info","args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"align(type:Type,pointer_size)-instance-method","html_id":"align(type:Type,pointer_size)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"pointer_size","doc":null,"default_value":"","external_name":"pointer_size","restriction":""}],"args_string":"(type : Type, pointer_size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L50","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"pointer_size","doc":null,"default_value":"","external_name":"pointer_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) / 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  pointer_size\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    1\n  else\n    type.struct_element_types.reduce(1) do |memo, elem|\n      Math.max(memo, align(elem))\n    end\n  end\nwhen Type::Kind::Array\n  align(type.element_type)\nelse\n  raise(\"Unhandled Type::Kind in align: #{type.kind}\")\nend"}},{"id":"align(type:Type)-instance-method","html_id":"align(type:Type)-instance-method","name":"align","doc":null,"summary":null,"abstract":true,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L15","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"align_offset(offset,type)-instance-method","html_id":"align_offset(offset,type)-instance-method","name":"align_offset","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(offset, type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L45","def":{"name":"align_offset","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"align = align(type)\n(((offset + align) - 1) / align) * align\n"}},{"id":"osx?:Bool-instance-method","html_id":"osx?:Bool-instance-method","name":"osx?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L3","def":{"name":"osx?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@osx"}},{"id":"size(type:Type,pointer_size)-instance-method","html_id":"size(type:Type,pointer_size)-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"pointer_size","doc":null,"default_value":"","external_name":"pointer_size","restriction":""}],"args_string":"(type : Type, pointer_size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L17","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"pointer_size","doc":null,"default_value":"","external_name":"pointer_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) / 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  pointer_size\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    type.struct_element_types.reduce(0) do |memo, elem|\n      memo + (size(elem))\n    end\n  else\n    size = type.struct_element_types.reduce(0) do |memo, elem|\n      (align_offset(memo, elem)) + (size(elem))\n    end\n    align_offset(size, type)\n  end\nwhen Type::Kind::Array\n  (size(type.element_type)) * type.array_size\nelse\n  raise(\"Unhandled Type::Kind in size: #{type.kind}\")\nend"}},{"id":"size(type:Type)-instance-method","html_id":"size(type:Type)-instance-method","name":"size","doc":null,"summary":null,"abstract":true,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L14","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"target_data:TargetData-instance-method","html_id":"target_data:TargetData-instance-method","name":"target_data","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : TargetData","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L2","def":{"name":"target_data","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"TargetData","visibility":"Public","body":"@target_data"}},{"id":"windows?:Bool-instance-method","html_id":"windows?:Bool-instance-method","name":"windows?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L4","def":{"name":"windows?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@windows"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/AArch64","path":"LLVM/ABI/AArch64.html","kind":"class","full_name":"LLVM::ABI::AArch64","name":"AArch64","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi/aarch64.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on\nhttps://github.com/rust-lang/rust/blob/master/src/librustc_trans/cabi_aarch64.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/master/src/librustc_trans/cabi_aarch64.rs</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","doc":null,"summary":null,"abstract":false,"args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L6","def":{"name":"abi_info","args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = atys.map do |aty|\n  compute_arg_type(aty, context)\nend\nFunctionType.new(arg_tys, ret_ty)\n"}},{"id":"align(type:Type)-instance-method","html_id":"align(type:Type)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L12","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"align(type, 8)"}},{"id":"homogeneous_aggregate?(type)-instance-method","html_id":"homogeneous_aggregate?(type)-instance-method","name":"homogeneous_aggregate?","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L20","def":{"name":"homogeneous_aggregate?","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"homog_agg = case type\nwhen Type::Kind::Float\n  return {type, 1}\nwhen Type::Kind::Double\n  return {type, 1}\nwhen Type::Kind::Array\n  check_array(type)\nwhen Type::Kind::Struct\n  check_struct(type)\nend\nif homog_agg\n  if 0 < (__temp_68 = homog_agg[1]) && __temp_68 <= 4\n    return homog_agg\n  end\nend\n"}},{"id":"register?(type)-instance-method","html_id":"register?(type)-instance-method","name":"register?","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L142","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L142","def":{"name":"register?","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Float, Type::Kind::Double, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"id":"size(type:Type)-instance-method","html_id":"size(type:Type)-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/aarch64.cr#L16","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size(type, 8)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/ArgKind","path":"LLVM/ABI/ArgKind.html","kind":"enum","full_name":"LLVM::ABI::ArgKind","name":"ArgKind","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi.cr","line_number":75,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Direct","name":"Direct","value":"0","doc":null,"summary":null},{"id":"Indirect","name":"Indirect","value":"1","doc":null,"summary":null},{"id":"Ignore","name":"Ignore","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"direct?-instance-method","html_id":"direct?-instance-method","name":"direct?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L76","def":{"name":"direct?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Direct"}},{"id":"ignore?-instance-method","html_id":"ignore?-instance-method","name":"ignore?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L78","def":{"name":"ignore?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ignore"}},{"id":"indirect?-instance-method","html_id":"indirect?-instance-method","name":"indirect?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L77","def":{"name":"indirect?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Indirect"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/ArgType","path":"LLVM/ABI/ArgType.html","kind":"struct","full_name":"LLVM::ABI::ArgType","name":"ArgType","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi.cr","line_number":81,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":null,"summary":null,"class_methods":[{"id":"direct(type,cast=nil,pad=nil,attr=nil)-class-method","html_id":"direct(type,cast=nil,pad=nil,attr=nil)-class-method","name":"direct","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"cast","doc":null,"default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","doc":null,"default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","doc":null,"default_value":"nil","external_name":"attr","restriction":""}],"args_string":"(type, cast = <span class=\"n\">nil</span>, pad = <span class=\"n\">nil</span>, attr = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L88","def":{"name":"direct","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"cast","doc":null,"default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","doc":null,"default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","doc":null,"default_value":"nil","external_name":"attr","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(ArgKind::Direct, type, cast, pad, attr)"}},{"id":"ignore(type)-class-method","html_id":"ignore(type)-class-method","name":"ignore","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L96","def":{"name":"ignore","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(ArgKind::Ignore, type)"}},{"id":"indirect(type,attr)-class-method","html_id":"indirect(type,attr)-class-method","name":"indirect","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"attr","doc":null,"default_value":"","external_name":"attr","restriction":""}],"args_string":"(type, attr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L92","def":{"name":"indirect","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"attr","doc":null,"default_value":"","external_name":"attr","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(ArgKind::Indirect, type, attr: attr)"}}],"constructors":[{"id":"new(kind,type,cast=nil,pad=nil,attr=nil)-class-method","html_id":"new(kind,type,cast=nil,pad=nil,attr=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"cast","doc":null,"default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","doc":null,"default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","doc":null,"default_value":"nil","external_name":"attr","restriction":""}],"args_string":"(kind, type, cast = <span class=\"n\">nil</span>, pad = <span class=\"n\">nil</span>, attr = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L100","def":{"name":"new","args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"cast","doc":null,"default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","doc":null,"default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","doc":null,"default_value":"nil","external_name":"attr","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(kind, type, cast, pad, attr)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"attr:Attribute?-instance-method","html_id":"attr:Attribute?-instance-method","name":"attr","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Attribute?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L86","def":{"name":"attr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Attribute | ::Nil","visibility":"Public","body":"@attr"}},{"id":"cast:Type?-instance-method","html_id":"cast:Type?-instance-method","name":"cast","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L84","def":{"name":"cast","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type | ::Nil","visibility":"Public","body":"@cast"}},{"id":"kind:ArgKind-instance-method","html_id":"kind:ArgKind-instance-method","name":"kind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : ArgKind","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L82","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArgKind","visibility":"Public","body":"@kind"}},{"id":"pad:Nil-instance-method","html_id":"pad:Nil-instance-method","name":"pad","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L85","def":{"name":"pad","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"@pad"}},{"id":"type:Type-instance-method","html_id":"type:Type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L83","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"@type"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/ARM","path":"LLVM/ABI/ARM.html","kind":"class","full_name":"LLVM::ABI::ARM","name":"ARM","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi/arm.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on https://github.com/rust-lang/rust/blob/dfe8bd10fe6763e0a1d5d55fa2574ecba27d3e2e/src/librustc_trans/cabi_arm.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/dfe8bd10fe6763e0a1d5d55fa2574ecba27d3e2e/src/librustc_trans/cabi_arm.rs</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","doc":null,"summary":null,"abstract":false,"args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L5","def":{"name":"abi_info","args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = compute_arg_types(atys, context)\nFunctionType.new(arg_tys, ret_ty)\n"}},{"id":"align(type:Type)-instance-method","html_id":"align(type:Type)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L11","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"align(type, 4)"}},{"id":"register?(type)-instance-method","html_id":"register?(type)-instance-method","name":"register?","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L19","def":{"name":"register?","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Float, Type::Kind::Double, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"id":"size(type:Type)-instance-method","html_id":"size(type:Type)-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/arm.cr#L15","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size(type, 4)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/FunctionType","path":"LLVM/ABI/FunctionType.html","kind":"class","full_name":"LLVM::ABI::FunctionType","name":"FunctionType","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi.cr","line_number":104,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(arg_types,return_type)-class-method","html_id":"new(arg_types,return_type)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":""},{"name":"return_type","doc":null,"default_value":"","external_name":"return_type","restriction":""}],"args_string":"(arg_types, return_type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L108","def":{"name":"new","args":[{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":""},{"name":"return_type","doc":null,"default_value":"","external_name":"return_type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(arg_types, return_type)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"arg_types:Array(ArgType)-instance-method","html_id":"arg_types:Array(ArgType)-instance-method","name":"arg_types","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(ArgType)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L105","def":{"name":"arg_types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(ArgType)","visibility":"Public","body":"@arg_types"}},{"id":"return_type:ArgType-instance-method","html_id":"return_type:ArgType-instance-method","name":"return_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : ArgType","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi.cr#L106","def":{"name":"return_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ArgType","visibility":"Public","body":"@return_type"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86","path":"LLVM/ABI/X86.html","kind":"class","full_name":"LLVM::ABI::X86","name":"X86","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi/x86.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","doc":null,"summary":null,"abstract":false,"args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L4","def":{"name":"abi_info","args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = compute_arg_types(atys, context)\nFunctionType.new(arg_tys, ret_ty)\n"}},{"id":"align(type:Type)-instance-method","html_id":"align(type:Type)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L14","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(target_data.abi_alignment(type)).to_i32"}},{"id":"size(type:Type)-instance-method","html_id":"size(type:Type)-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86.cr#L10","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(target_data.abi_size(type)).to_i32"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86_64","path":"LLVM/ABI/X86_64.html","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi/x86_64.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","doc":null,"summary":null,"abstract":false,"args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L4","def":{"name":"abi_info","args":[{"name":"atys","doc":null,"default_value":"","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","doc":null,"default_value":"","external_name":"rty","restriction":"Type"},{"name":"ret_def","doc":null,"default_value":"","external_name":"ret_def","restriction":"Bool"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"arg_tys = Array(LLVM::Type).new(atys.size)\narg_tys = atys.map do |arg_type|\n  x86_64_type(arg_type, Attribute::ByVal, context) do |cls|\n    pass_by_val?(cls)\n  end\nend\nif ret_def\n  ret_ty = x86_64_type(rty, Attribute::StructRet, context) do |cls|\n    sret?(cls)\n  end\nelse\n  ret_ty = ArgType.direct(context.void)\nend\nFunctionType.new(arg_tys, ret_ty)\n"}},{"id":"align(offset,type)-instance-method","html_id":"align(offset,type)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(offset, type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L278","def":{"name":"align","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"align = align(type)\n(((offset + align) - 1) / align) * align\n"}},{"id":"align(type:Type)-instance-method","html_id":"align(type:Type)-instance-method","name":"align","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L225","def":{"name":"align","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) / 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  8\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    1\n  else\n    type.struct_element_types.reduce(1) do |memo, elem|\n      Math.max(memo, align(elem))\n    end\n  end\nwhen Type::Kind::Array\n  align(type.element_type)\nelse\n  raise(\"Unhandled Type::Kind in align: #{type.kind}\")\nend"}},{"id":"all_mem(reg_classes)-instance-method","html_id":"all_mem(reg_classes)-instance-method","name":"all_mem","doc":null,"summary":null,"abstract":false,"args":[{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"args_string":"(reg_classes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L186","def":{"name":"all_mem","args":[{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reg_classes.fill(RegClass::Memory)"}},{"id":"classify(ty,cls,ix,off)-instance-method","html_id":"classify(ty,cls,ix,off)-instance-method","name":"classify","doc":null,"summary":null,"abstract":false,"args":[{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"ix","doc":null,"default_value":"","external_name":"ix","restriction":""},{"name":"off","doc":null,"default_value":"","external_name":"off","restriction":""}],"args_string":"(ty, cls, ix, off)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L67","def":{"name":"classify","args":[{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"ix","doc":null,"default_value":"","external_name":"ix","restriction":""},{"name":"off","doc":null,"default_value":"","external_name":"off","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"t_align = align(ty)\nt_size = size(ty)\nmisalign = off % t_align\nif misalign != 0\n  i = off / 8\n  e = ((off + t_size) + 7) / 8\n  while i < e\n    unify(cls, ix + 1, RegClass::Memory)\n    i = i + 1\n  end\n  return\nend\ncase ty.kind\nwhen Type::Kind::Integer, Type::Kind::Pointer\n  unify(cls, ix + (off / 8), RegClass::Int)\nwhen Type::Kind::Float\n  unify(cls, ix + (off / 8), (  (off % 8) == 4) ? RegClass::SSEFv : RegClass::SSEFs)\nwhen Type::Kind::Double\n  unify(cls, ix + (off / 8), RegClass::SSEDs)\nwhen Type::Kind::Struct\n  classify_struct(ty.struct_element_types, cls, ix, off, ty.packed_struct?)\nwhen Type::Kind::Array\n  len = ty.array_size\n  elt = ty.element_type\n  eltsz = size(elt)\n  i = 0\n  while i < len\n    classify(elt, cls, ix, off + (i * eltsz))\n    i = i + 1\n  end\nelse\n  raise(\"Unhandled Type::Kind in classify: #{ty.kind}\")\nend\n"}},{"id":"classify(type)-instance-method","html_id":"classify(type)-instance-method","name":"classify","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L55","def":{"name":"classify","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"words = ((size(type)) + 7) / 8\nreg_classes = Array.new(words, RegClass::NoClass)\nif words > 4\n  all_mem(reg_classes)\nelse\n  classify(type, reg_classes, 0, 0)\n  fixup(type, reg_classes)\nend\nreg_classes\n"}},{"id":"classify_struct(tys,cls,i,off,packed)-instance-method","html_id":"classify_struct(tys,cls,i,off,packed)-instance-method","name":"classify_struct","doc":null,"summary":null,"abstract":false,"args":[{"name":"tys","doc":null,"default_value":"","external_name":"tys","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"off","doc":null,"default_value":"","external_name":"off","restriction":""},{"name":"packed","doc":null,"default_value":"","external_name":"packed","restriction":""}],"args_string":"(tys, cls, i, off, packed)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L105","def":{"name":"classify_struct","args":[{"name":"tys","doc":null,"default_value":"","external_name":"tys","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"off","doc":null,"default_value":"","external_name":"off","restriction":""},{"name":"packed","doc":null,"default_value":"","external_name":"packed","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"field_off = off\ntys.each do |ty|\n  if packed\n  else\n    field_off = align(field_off, ty)\n  end\n  classify(ty, cls, i, field_off)\n  field_off = field_off + (size(ty))\nend\n"}},{"id":"fixup(ty,cls)-instance-method","html_id":"fixup(ty,cls)-instance-method","name":"fixup","doc":null,"summary":null,"abstract":false,"args":[{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"args_string":"(ty, cls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L114","def":{"name":"fixup","args":[{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""},{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"i = 0\nty_kind = ty.kind\ne = cls.size\nif e > 2 && ((ty_kind == Type::Kind::Struct) || (ty_kind == Type::Kind::Array))\n  if cls[i].sse?\n    i = i + 1\n    while i < e\n      if cls[i] != RegClass::SSEUp\n        all_mem(cls)\n        return\n      end\n      i = i + 1\n    end\n  else\n    all_mem(cls)\n    return\n  end\nelse\n  while i < e\n    case\n    when cls[i] == RegClass::Memory\n      all_mem(cls)\n      return\n    when cls[i] == RegClass::X87Up\n      all_mem(cls)\n      return\n    when cls[i] == RegClass::SSEUp\n      cls[i] = RegClass::SSEDv\n    when cls[i].sse?\n      i = i + 1\n      while (i != e) && (cls[i] == RegClass::SSEUp)\n        i = i + 1\n      end\n    when cls[i] == RegClass::X87\n      i = i + 1\n      while (i != e) && (cls[i] == RegClass::X87Up)\n        i = i + 1\n      end\n    else\n      i = i + 1\n    end\n  end\nend\n"}},{"id":"llreg(context,reg_classes)-instance-method","html_id":"llreg(context,reg_classes)-instance-method","name":"llreg","doc":null,"summary":null,"abstract":false,"args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""},{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"args_string":"(context, reg_classes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L190","def":{"name":"llreg","args":[{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""},{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"types = Array(Type).new\ni = 0\ne = reg_classes.size\nwhile i < e\n  case reg_classes[i]\n  when RegClass::Int\n    types << context.int64\n  when RegClass::SSEFv\n    vec_len = llvec_len(reg_classes[(i + 1)..-1])\n    vec_type = context.float.vector(vec_len * 2)\n    types << vec_type\n    i = i + vec_len\n    next\n  when RegClass::SSEFs\n    types << context.float\n  when RegClass::SSEDs\n    types << context.double\n  else\n    raise(\"Unhandled RegClass: #{reg_classes[i]}\")\n  end\n  i = i + 1\nend\ncontext.struct(types)\n"}},{"id":"llvec_len(reg_classes)-instance-method","html_id":"llvec_len(reg_classes)-instance-method","name":"llvec_len","doc":null,"summary":null,"abstract":false,"args":[{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"args_string":"(reg_classes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L216","def":{"name":"llvec_len","args":[{"name":"reg_classes","doc":null,"default_value":"","external_name":"reg_classes","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"len = 1\nreg_classes.each do |reg_class|\n  if reg_class != RegClass::SSEUp\n    break\n  end\n  len = len + 1\nend\nlen\n"}},{"id":"pass_by_val?(cls)-instance-method","html_id":"pass_by_val?(cls)-instance-method","name":"pass_by_val?","doc":null,"summary":null,"abstract":false,"args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"args_string":"(cls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L42","def":{"name":"pass_by_val?","args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if cls.empty?\n  return false\nend\ncl = cls.first\n((cl == RegClass::Memory) || (cl == RegClass::X87)) || (cl == RegClass::ComplexX87)\n"}},{"id":"register?(type)-instance-method","html_id":"register?(type)-instance-method","name":"register?","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L33","def":{"name":"register?","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Float, Type::Kind::Double, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"id":"size(type:Type)-instance-method","html_id":"size(type:Type)-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L250","def":{"name":"size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) / 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  8\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    type.struct_element_types.reduce(0) do |memo, elem|\n      memo + (size(elem))\n    end\n  else\n    size = type.struct_element_types.reduce(0) do |memo, elem|\n      (align(memo, elem)) + (size(elem))\n    end\n    align(size, type)\n  end\nwhen Type::Kind::Array\n  (size(type.element_type)) * type.array_size\nelse\n  raise(\"Unhandled Type::Kind in size: #{type.kind}\")\nend"}},{"id":"sret?(cls)-instance-method","html_id":"sret?(cls)-instance-method","name":"sret?","doc":null,"summary":null,"abstract":false,"args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"args_string":"(cls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L49","def":{"name":"sret?","args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if cls.empty?\n  return false\nend\ncls.first == RegClass::Memory\n"}},{"id":"unify(cls,i,newv)-instance-method","html_id":"unify(cls,i,newv)-instance-method","name":"unify","doc":null,"summary":null,"abstract":false,"args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"newv","doc":null,"default_value":"","external_name":"newv","restriction":""}],"args_string":"(cls, i, newv)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L162","def":{"name":"unify","args":[{"name":"cls","doc":null,"default_value":"","external_name":"cls","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"newv","doc":null,"default_value":"","external_name":"newv","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case\nwhen cls[i] == newv\n  return\nwhen cls[i] == RegClass::NoClass\n  cls[i] = newv\nwhen newv == RegClass::NoClass\n  return\nwhen cls[i] == RegClass::Memory, newv == RegClass::Memory\n  return\nwhen cls[i] == RegClass::Int, newv == RegClass::Int\n  return\nwhen cls[i] == RegClass::X87, cls[i] == RegClass::X87Up, cls[i] == RegClass::ComplexX87, newv == RegClass::X87, newv == RegClass::X87Up, newv == RegClass::ComplexX87\n  cls[i] = RegClass::Memory\nelse\n  cls[i] = newv\nend"}},{"id":"x86_64_type(type,ind_attr,context,&block)-instance-method","html_id":"x86_64_type(type,ind_attr,context,&amp;block)-instance-method","name":"x86_64_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"ind_attr","doc":null,"default_value":"","external_name":"ind_attr","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"args_string":"(type, ind_attr, context, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L19","def":{"name":"x86_64_type","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"ind_attr","doc":null,"default_value":"","external_name":"ind_attr","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if register?(type)\n  attr = type == context.int1 ? Attribute::ZExt : nil\n  ArgType.direct(type, attr: attr)\nelse\n  cls = classify(type)\n  if yield cls\n    ArgType.indirect(type, ind_attr)\n  else\n    ArgType.direct(type, llreg(context, cls))\n  end\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86_64/RegClass","path":"LLVM/ABI/X86_64/RegClass.html","kind":"enum","full_name":"LLVM::ABI::X86_64::RegClass","name":"RegClass","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/abi/x86_64.cr","line_number":283,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"NoClass","name":"NoClass","value":"0","doc":null,"summary":null},{"id":"Int","name":"Int","value":"1","doc":null,"summary":null},{"id":"SSEFs","name":"SSEFs","value":"2","doc":null,"summary":null},{"id":"SSEFv","name":"SSEFv","value":"3","doc":null,"summary":null},{"id":"SSEDs","name":"SSEDs","value":"4","doc":null,"summary":null},{"id":"SSEDv","name":"SSEDv","value":"5","doc":null,"summary":null},{"id":"SSEInt","name":"SSEInt","value":"6","doc":null,"summary":null},{"id":"SSEUp","name":"SSEUp","value":"7","doc":null,"summary":null},{"id":"X87","name":"X87","value":"8","doc":null,"summary":null},{"id":"X87Up","name":"X87Up","value":"9","doc":null,"summary":null},{"id":"ComplexX87","name":"ComplexX87","value":"10","doc":null,"summary":null},{"id":"Memory","name":"Memory","value":"11","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/X86_64","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"complex_x87?-instance-method","html_id":"complex_x87?-instance-method","name":"complex_x87?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L294","def":{"name":"complex_x87?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ComplexX87"}},{"id":"int?-instance-method","html_id":"int?-instance-method","name":"int?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L285","def":{"name":"int?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Int"}},{"id":"memory?-instance-method","html_id":"memory?-instance-method","name":"memory?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L295","def":{"name":"memory?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Memory"}},{"id":"no_class?-instance-method","html_id":"no_class?-instance-method","name":"no_class?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L284","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L284","def":{"name":"no_class?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NoClass"}},{"id":"sse?-instance-method","html_id":"sse?-instance-method","name":"sse?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L297","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L297","def":{"name":"sse?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case self\nwhen SSEFs, SSEFv, SSEDs\n  true\nelse\n  false\nend"}},{"id":"sse_ds?-instance-method","html_id":"sse_ds?-instance-method","name":"sse_ds?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L288","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L288","def":{"name":"sse_ds?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEDs"}},{"id":"sse_dv?-instance-method","html_id":"sse_dv?-instance-method","name":"sse_dv?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L289","def":{"name":"sse_dv?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEDv"}},{"id":"sse_fs?-instance-method","html_id":"sse_fs?-instance-method","name":"sse_fs?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L286","def":{"name":"sse_fs?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEFs"}},{"id":"sse_fv?-instance-method","html_id":"sse_fv?-instance-method","name":"sse_fv?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L287","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L287","def":{"name":"sse_fv?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEFv"}},{"id":"sse_int?-instance-method","html_id":"sse_int?-instance-method","name":"sse_int?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L290","def":{"name":"sse_int?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEInt"}},{"id":"sse_up?-instance-method","html_id":"sse_up?-instance-method","name":"sse_up?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L291","def":{"name":"sse_up?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SSEUp"}},{"id":"x87?-instance-method","html_id":"x87?-instance-method","name":"x87?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L292","def":{"name":"x87?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X87"}},{"id":"x87_up?-instance-method","html_id":"x87_up?-instance-method","name":"x87_up?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L293","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/abi/x86_64.cr#L293","def":{"name":"x87_up?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X87Up"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/LLVM/AtomicOrdering","path":"LLVM/AtomicOrdering.html","kind":"enum","full_name":"LLVM::AtomicOrdering","name":"AtomicOrdering","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":323,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"NotAtomic","name":"NotAtomic","value":"0","doc":null,"summary":null},{"id":"Unordered","name":"Unordered","value":"1","doc":null,"summary":null},{"id":"Monotonic","name":"Monotonic","value":"2","doc":null,"summary":null},{"id":"Acquire","name":"Acquire","value":"4","doc":null,"summary":null},{"id":"Release","name":"Release","value":"5","doc":null,"summary":null},{"id":"AcquireRelease","name":"AcquireRelease","value":"6","doc":null,"summary":null},{"id":"SequentiallyConsistent","name":"SequentiallyConsistent","value":"7","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"acquire?-instance-method","html_id":"acquire?-instance-method","name":"acquire?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L327","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L327","def":{"name":"acquire?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Acquire"}},{"id":"acquire_release?-instance-method","html_id":"acquire_release?-instance-method","name":"acquire_release?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L329","def":{"name":"acquire_release?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AcquireRelease"}},{"id":"monotonic?-instance-method","html_id":"monotonic?-instance-method","name":"monotonic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L326","def":{"name":"monotonic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Monotonic"}},{"id":"not_atomic?-instance-method","html_id":"not_atomic?-instance-method","name":"not_atomic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L324","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L324","def":{"name":"not_atomic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NotAtomic"}},{"id":"release?-instance-method","html_id":"release?-instance-method","name":"release?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L328","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L328","def":{"name":"release?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Release"}},{"id":"sequentially_consistent?-instance-method","html_id":"sequentially_consistent?-instance-method","name":"sequentially_consistent?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L330","def":{"name":"sequentially_consistent?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SequentiallyConsistent"}},{"id":"unordered?-instance-method","html_id":"unordered?-instance-method","name":"unordered?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L325","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L325","def":{"name":"unordered?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Unordered"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/AtomicRMWBinOp","path":"LLVM/AtomicRMWBinOp.html","kind":"enum","full_name":"LLVM::AtomicRMWBinOp","name":"AtomicRMWBinOp","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":333,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Xchg","name":"Xchg","value":"0","doc":null,"summary":null},{"id":"Add","name":"Add","value":"1","doc":null,"summary":null},{"id":"Sub","name":"Sub","value":"2","doc":null,"summary":null},{"id":"And","name":"And","value":"3","doc":null,"summary":null},{"id":"Nand","name":"Nand","value":"4","doc":null,"summary":null},{"id":"Or","name":"Or","value":"5","doc":null,"summary":null},{"id":"Xor","name":"Xor","value":"6","doc":null,"summary":null},{"id":"Max","name":"Max","value":"7","doc":null,"summary":null},{"id":"Min","name":"Min","value":"8","doc":null,"summary":null},{"id":"UMax","name":"UMax","value":"9","doc":null,"summary":null},{"id":"UMin","name":"UMin","value":"10","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"add?-instance-method","html_id":"add?-instance-method","name":"add?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L335","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L335","def":{"name":"add?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Add"}},{"id":"and?-instance-method","html_id":"and?-instance-method","name":"and?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L337","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L337","def":{"name":"and?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == And"}},{"id":"max?-instance-method","html_id":"max?-instance-method","name":"max?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L341","def":{"name":"max?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Max"}},{"id":"min?-instance-method","html_id":"min?-instance-method","name":"min?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L342","def":{"name":"min?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Min"}},{"id":"nand?-instance-method","html_id":"nand?-instance-method","name":"nand?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L338","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L338","def":{"name":"nand?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Nand"}},{"id":"or?-instance-method","html_id":"or?-instance-method","name":"or?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L339","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L339","def":{"name":"or?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Or"}},{"id":"sub?-instance-method","html_id":"sub?-instance-method","name":"sub?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L336","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L336","def":{"name":"sub?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Sub"}},{"id":"u_max?-instance-method","html_id":"u_max?-instance-method","name":"u_max?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L343","def":{"name":"u_max?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UMax"}},{"id":"u_min?-instance-method","html_id":"u_min?-instance-method","name":"u_min?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L344","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L344","def":{"name":"u_min?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UMin"}},{"id":"xchg?-instance-method","html_id":"xchg?-instance-method","name":"xchg?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L334","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L334","def":{"name":"xchg?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Xchg"}},{"id":"xor?-instance-method","html_id":"xor?-instance-method","name":"xor?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L340","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L340","def":{"name":"xor?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Xor"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Attribute","path":"LLVM/Attribute.html","kind":"enum","full_name":"LLVM::Attribute","name":"Attribute","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Alignment","name":"Alignment","value":"1_u64","doc":null,"summary":null},{"id":"AllocSize","name":"AllocSize","value":"2_u64","doc":null,"summary":null},{"id":"AlwaysInline","name":"AlwaysInline","value":"4_u64","doc":null,"summary":null},{"id":"ArgMemOnly","name":"ArgMemOnly","value":"8_u64","doc":null,"summary":null},{"id":"Builtin","name":"Builtin","value":"16_u64","doc":null,"summary":null},{"id":"ByVal","name":"ByVal","value":"32_u64","doc":null,"summary":null},{"id":"Cold","name":"Cold","value":"64_u64","doc":null,"summary":null},{"id":"Convergent","name":"Convergent","value":"128_u64","doc":null,"summary":null},{"id":"Dereferenceable","name":"Dereferenceable","value":"256_u64","doc":null,"summary":null},{"id":"DereferenceableOrNull","name":"DereferenceableOrNull","value":"512_u64","doc":null,"summary":null},{"id":"InAlloca","name":"InAlloca","value":"1024_u64","doc":null,"summary":null},{"id":"InReg","name":"InReg","value":"2048_u64","doc":null,"summary":null},{"id":"InaccessibleMemOnly","name":"InaccessibleMemOnly","value":"4096_u64","doc":null,"summary":null},{"id":"InaccessibleMemOrArgMemOnly","name":"InaccessibleMemOrArgMemOnly","value":"8192_u64","doc":null,"summary":null},{"id":"InlineHint","name":"InlineHint","value":"16384_u64","doc":null,"summary":null},{"id":"JumpTable","name":"JumpTable","value":"32768_u64","doc":null,"summary":null},{"id":"MinSize","name":"MinSize","value":"65536_u64","doc":null,"summary":null},{"id":"Naked","name":"Naked","value":"131072_u64","doc":null,"summary":null},{"id":"Nest","name":"Nest","value":"262144_u64","doc":null,"summary":null},{"id":"NoAlias","name":"NoAlias","value":"524288_u64","doc":null,"summary":null},{"id":"NoBuiltin","name":"NoBuiltin","value":"1048576_u64","doc":null,"summary":null},{"id":"NoCapture","name":"NoCapture","value":"2097152_u64","doc":null,"summary":null},{"id":"NoDuplicate","name":"NoDuplicate","value":"4194304_u64","doc":null,"summary":null},{"id":"NoImplicitFloat","name":"NoImplicitFloat","value":"8388608_u64","doc":null,"summary":null},{"id":"NoInline","name":"NoInline","value":"16777216_u64","doc":null,"summary":null},{"id":"NoRecurse","name":"NoRecurse","value":"33554432_u64","doc":null,"summary":null},{"id":"NoRedZone","name":"NoRedZone","value":"67108864_u64","doc":null,"summary":null},{"id":"NoReturn","name":"NoReturn","value":"134217728_u64","doc":null,"summary":null},{"id":"NoUnwind","name":"NoUnwind","value":"268435456_u64","doc":null,"summary":null},{"id":"NonLazyBind","name":"NonLazyBind","value":"536870912_u64","doc":null,"summary":null},{"id":"NonNull","name":"NonNull","value":"1073741824_u64","doc":null,"summary":null},{"id":"OptimizeForSize","name":"OptimizeForSize","value":"2147483648_u64","doc":null,"summary":null},{"id":"OptimizeNone","name":"OptimizeNone","value":"4294967296_u64","doc":null,"summary":null},{"id":"ReadNone","name":"ReadNone","value":"8589934592_u64","doc":null,"summary":null},{"id":"ReadOnly","name":"ReadOnly","value":"17179869184_u64","doc":null,"summary":null},{"id":"Returned","name":"Returned","value":"34359738368_u64","doc":null,"summary":null},{"id":"ReturnsTwice","name":"ReturnsTwice","value":"68719476736_u64","doc":null,"summary":null},{"id":"SExt","name":"SExt","value":"137438953472_u64","doc":null,"summary":null},{"id":"SafeStack","name":"SafeStack","value":"274877906944_u64","doc":null,"summary":null},{"id":"SanitizeAddress","name":"SanitizeAddress","value":"549755813888_u64","doc":null,"summary":null},{"id":"SanitizeMemory","name":"SanitizeMemory","value":"1099511627776_u64","doc":null,"summary":null},{"id":"SanitizeThread","name":"SanitizeThread","value":"2199023255552_u64","doc":null,"summary":null},{"id":"StackAlignment","name":"StackAlignment","value":"4398046511104_u64","doc":null,"summary":null},{"id":"StackProtect","name":"StackProtect","value":"8796093022208_u64","doc":null,"summary":null},{"id":"StackProtectReq","name":"StackProtectReq","value":"17592186044416_u64","doc":null,"summary":null},{"id":"StackProtectStrong","name":"StackProtectStrong","value":"35184372088832_u64","doc":null,"summary":null},{"id":"StructRet","name":"StructRet","value":"70368744177664_u64","doc":null,"summary":null},{"id":"SwiftError","name":"SwiftError","value":"140737488355328_u64","doc":null,"summary":null},{"id":"SwiftSelf","name":"SwiftSelf","value":"281474976710656_u64","doc":null,"summary":null},{"id":"UWTable","name":"UWTable","value":"562949953421312_u64","doc":null,"summary":null},{"id":"WriteOnly","name":"WriteOnly","value":"1125899906842624_u64","doc":null,"summary":null},{"id":"ZExt","name":"ZExt","value":"2251799813685248_u64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"from_kind(kind)-class-method","html_id":"from_kind(kind)-class-method","name":"from_kind","doc":null,"summary":null,"abstract":false,"args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""}],"args_string":"(kind)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"from_kind","args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@kind_ids.key_for(kind)"}},{"id":"kind_for(member)-class-method","html_id":"kind_for(member)-class-method","name":"kind_for","doc":null,"summary":null,"abstract":false,"args":[{"name":"member","doc":null,"default_value":"","external_name":"member","restriction":""}],"args_string":"(member)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"kind_for","args":[{"name":"member","doc":null,"default_value":"","external_name":"member","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@kind_ids[member]"}}],"constructors":[],"instance_methods":[{"id":"alignment?-instance-method","html_id":"alignment?-instance-method","name":"alignment?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"alignment?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Alignment)"}},{"id":"alloc_size?-instance-method","html_id":"alloc_size?-instance-method","name":"alloc_size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"alloc_size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(AllocSize)"}},{"id":"always_inline?-instance-method","html_id":"always_inline?-instance-method","name":"always_inline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"always_inline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(AlwaysInline)"}},{"id":"arg_mem_only?-instance-method","html_id":"arg_mem_only?-instance-method","name":"arg_mem_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"arg_mem_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ArgMemOnly)"}},{"id":"builtin?-instance-method","html_id":"builtin?-instance-method","name":"builtin?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"builtin?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Builtin)"}},{"id":"by_val?-instance-method","html_id":"by_val?-instance-method","name":"by_val?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"by_val?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ByVal)"}},{"id":"cold?-instance-method","html_id":"cold?-instance-method","name":"cold?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"cold?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Cold)"}},{"id":"convergent?-instance-method","html_id":"convergent?-instance-method","name":"convergent?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"convergent?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Convergent)"}},{"id":"dereferenceable?-instance-method","html_id":"dereferenceable?-instance-method","name":"dereferenceable?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"dereferenceable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Dereferenceable)"}},{"id":"dereferenceable_or_null?-instance-method","html_id":"dereferenceable_or_null?-instance-method","name":"dereferenceable_or_null?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"dereferenceable_or_null?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(DereferenceableOrNull)"}},{"id":"each_kind(&block)-instance-method","html_id":"each_kind(&amp;block)-instance-method","name":"each_kind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"each_kind","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if value == 0\n  return\nend\n{% for member in @type.constants %}\n          {% if member.stringify != \"All\" %}\n            if includes?({{ @type }}::{{ member }})\n              yield @@kind_ids[{{ @type }}::{{ member }}]\n            end\n          {% end %}\n        {% end %}\n"}},{"id":"in_alloca?-instance-method","html_id":"in_alloca?-instance-method","name":"in_alloca?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"in_alloca?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(InAlloca)"}},{"id":"in_reg?-instance-method","html_id":"in_reg?-instance-method","name":"in_reg?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"in_reg?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(InReg)"}},{"id":"inaccessible_mem_only?-instance-method","html_id":"inaccessible_mem_only?-instance-method","name":"inaccessible_mem_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"inaccessible_mem_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(InaccessibleMemOnly)"}},{"id":"inaccessible_mem_or_arg_mem_only?-instance-method","html_id":"inaccessible_mem_or_arg_mem_only?-instance-method","name":"inaccessible_mem_or_arg_mem_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"inaccessible_mem_or_arg_mem_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(InaccessibleMemOrArgMemOnly)"}},{"id":"inline_hint?-instance-method","html_id":"inline_hint?-instance-method","name":"inline_hint?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"inline_hint?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(InlineHint)"}},{"id":"jump_table?-instance-method","html_id":"jump_table?-instance-method","name":"jump_table?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"jump_table?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(JumpTable)"}},{"id":"min_size?-instance-method","html_id":"min_size?-instance-method","name":"min_size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"min_size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(MinSize)"}},{"id":"naked?-instance-method","html_id":"naked?-instance-method","name":"naked?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"naked?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Naked)"}},{"id":"nest?-instance-method","html_id":"nest?-instance-method","name":"nest?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"nest?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Nest)"}},{"id":"no_alias?-instance-method","html_id":"no_alias?-instance-method","name":"no_alias?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_alias?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoAlias)"}},{"id":"no_builtin?-instance-method","html_id":"no_builtin?-instance-method","name":"no_builtin?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_builtin?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoBuiltin)"}},{"id":"no_capture?-instance-method","html_id":"no_capture?-instance-method","name":"no_capture?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_capture?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoCapture)"}},{"id":"no_duplicate?-instance-method","html_id":"no_duplicate?-instance-method","name":"no_duplicate?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_duplicate?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoDuplicate)"}},{"id":"no_implicit_float?-instance-method","html_id":"no_implicit_float?-instance-method","name":"no_implicit_float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_implicit_float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoImplicitFloat)"}},{"id":"no_inline?-instance-method","html_id":"no_inline?-instance-method","name":"no_inline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_inline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoInline)"}},{"id":"no_recurse?-instance-method","html_id":"no_recurse?-instance-method","name":"no_recurse?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_recurse?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoRecurse)"}},{"id":"no_red_zone?-instance-method","html_id":"no_red_zone?-instance-method","name":"no_red_zone?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_red_zone?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoRedZone)"}},{"id":"no_return?-instance-method","html_id":"no_return?-instance-method","name":"no_return?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_return?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoReturn)"}},{"id":"no_unwind?-instance-method","html_id":"no_unwind?-instance-method","name":"no_unwind?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"no_unwind?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NoUnwind)"}},{"id":"non_lazy_bind?-instance-method","html_id":"non_lazy_bind?-instance-method","name":"non_lazy_bind?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"non_lazy_bind?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NonLazyBind)"}},{"id":"non_null?-instance-method","html_id":"non_null?-instance-method","name":"non_null?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"non_null?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NonNull)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"optimize_for_size?-instance-method","html_id":"optimize_for_size?-instance-method","name":"optimize_for_size?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"optimize_for_size?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OptimizeForSize)"}},{"id":"optimize_none?-instance-method","html_id":"optimize_none?-instance-method","name":"optimize_none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"optimize_none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OptimizeNone)"}},{"id":"read_none?-instance-method","html_id":"read_none?-instance-method","name":"read_none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"read_none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ReadNone)"}},{"id":"read_only?-instance-method","html_id":"read_only?-instance-method","name":"read_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"read_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ReadOnly)"}},{"id":"returned?-instance-method","html_id":"returned?-instance-method","name":"returned?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"returned?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(Returned)"}},{"id":"returns_twice?-instance-method","html_id":"returns_twice?-instance-method","name":"returns_twice?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"returns_twice?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ReturnsTwice)"}},{"id":"s_ext?-instance-method","html_id":"s_ext?-instance-method","name":"s_ext?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"s_ext?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SExt)"}},{"id":"safe_stack?-instance-method","html_id":"safe_stack?-instance-method","name":"safe_stack?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"safe_stack?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SafeStack)"}},{"id":"sanitize_address?-instance-method","html_id":"sanitize_address?-instance-method","name":"sanitize_address?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"sanitize_address?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SanitizeAddress)"}},{"id":"sanitize_memory?-instance-method","html_id":"sanitize_memory?-instance-method","name":"sanitize_memory?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"sanitize_memory?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SanitizeMemory)"}},{"id":"sanitize_thread?-instance-method","html_id":"sanitize_thread?-instance-method","name":"sanitize_thread?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"sanitize_thread?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SanitizeThread)"}},{"id":"stack_alignment?-instance-method","html_id":"stack_alignment?-instance-method","name":"stack_alignment?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"stack_alignment?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(StackAlignment)"}},{"id":"stack_protect?-instance-method","html_id":"stack_protect?-instance-method","name":"stack_protect?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"stack_protect?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(StackProtect)"}},{"id":"stack_protect_req?-instance-method","html_id":"stack_protect_req?-instance-method","name":"stack_protect_req?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"stack_protect_req?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(StackProtectReq)"}},{"id":"stack_protect_strong?-instance-method","html_id":"stack_protect_strong?-instance-method","name":"stack_protect_strong?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"stack_protect_strong?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(StackProtectStrong)"}},{"id":"struct_ret?-instance-method","html_id":"struct_ret?-instance-method","name":"struct_ret?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"struct_ret?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(StructRet)"}},{"id":"swift_error?-instance-method","html_id":"swift_error?-instance-method","name":"swift_error?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"swift_error?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SwiftError)"}},{"id":"swift_self?-instance-method","html_id":"swift_self?-instance-method","name":"swift_self?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"swift_self?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SwiftSelf)"}},{"id":"uw_table?-instance-method","html_id":"uw_table?-instance-method","name":"uw_table?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"uw_table?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(UWTable)"}},{"id":"write_only?-instance-method","html_id":"write_only?-instance-method","name":"write_only?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"write_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(WriteOnly)"}},{"id":"z_ext?-instance-method","html_id":"z_ext?-instance-method","name":"z_ext?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L2","def":{"name":"z_ext?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ZExt)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/AttributeIndex","path":"LLVM/AttributeIndex.html","kind":"enum","full_name":"LLVM::AttributeIndex","name":"AttributeIndex","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":176,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ReturnIndex","name":"ReturnIndex","value":"0_u32","doc":null,"summary":null},{"id":"FunctionIndex","name":"FunctionIndex","value":"4294967295_u32","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":"Attribute index are either ReturnIndex (0), FunctionIndex (-1) or a\nparameter number ranging from 1 to N.","summary":"<p>Attribute index are either ReturnIndex (0), FunctionIndex (-1) or a parameter number ranging from 1 to N.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"function_index?-instance-method","html_id":"function_index?-instance-method","name":"function_index?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L178","def":{"name":"function_index?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FunctionIndex"}},{"id":"return_index?-instance-method","html_id":"return_index?-instance-method","name":"return_index?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L177","def":{"name":"return_index?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ReturnIndex"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/BasicBlock","path":"LLVM/BasicBlock.html","kind":"struct","full_name":"LLVM::BasicBlock","name":"BasicBlock","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/basic_block.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"null-class-method","html_id":"null-class-method","name":"null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L5","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::BasicBlock.new(Pointer(::Void).null.as(LibLLVM::BasicBlockRef))"}}],"constructors":[{"id":"new(unwrap:LibLLVM::BasicBlockRef)-class-method","html_id":"new(unwrap:LibLLVM::BasicBlockRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::BasicBlockRef"}],"args_string":"(unwrap : LibLLVM::BasicBlockRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::BasicBlockRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"delete-instance-method","html_id":"delete-instance-method","name":"delete","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L13","def":{"name":"delete","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.delete_basic_block(self)"}},{"id":"instructions-instance-method","html_id":"instructions-instance-method","name":"instructions","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L9","def":{"name":"instructions","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"InstructionCollection.new(self)"}},{"id":"to_unsafe:LibLLVM::BasicBlockRef-instance-method","html_id":"to_unsafe:LibLLVM::BasicBlockRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::BasicBlockRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block.cr#L17","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/BasicBlockCollection","path":"LLVM/BasicBlockCollection.html","kind":"struct","full_name":"LLVM::BasicBlockCollection","name":"BasicBlockCollection","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/basic_block_collection.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(function:Function)-class-method","html_id":"new(function:Function)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"function","doc":null,"default_value":"","external_name":"function","restriction":"Function"}],"args_string":"(function : Function)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L2","def":{"name":"new","args":[{"name":"function","doc":null,"default_value":"","external_name":"function","restriction":"Function"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(function)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"append(name=&quot;&quot;)-instance-method","html_id":"append(name=&amp;quot;&amp;quot;)-instance-method","name":"append","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L5","def":{"name":"append","args":[{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"context = LibLLVM.get_module_context(LibLLVM.get_global_parent(@function))\nBasicBlock.new(LibLLVM.append_basic_block_in_context(context, @function, name))\n"}},{"id":"append(name=&quot;&quot;,&block)-instance-method","html_id":"append(name=&amp;quot;&amp;quot;,&amp;block)-instance-method","name":"append","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(name = <span class=\"s\">&quot;&quot;</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/basic_block_collection.cr#L10","def":{"name":"append","args":[{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"context = LibLLVM.get_module_context(LibLLVM.get_global_parent(@function))\nblock = append(name)\nbuilder = Builder.new(LibLLVM.create_builder_in_context(context))\nbuilder.position_at_end(block)\nyield builder\nblock\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Builder","path":"LLVM/Builder.html","kind":"class","full_name":"LLVM::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/builder.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::BuilderRef)-class-method","html_id":"new(unwrap:LibLLVM::BuilderRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::BuilderRef"}],"args_string":"(unwrap : LibLLVM::BuilderRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L4","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::BuilderRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"add(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"add","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_add(self, lhs, rhs, name))"}},{"id":"add_handler(catch_switch_ref,handler)-instance-method","html_id":"add_handler(catch_switch_ref,handler)-instance-method","name":"add_handler","doc":null,"summary":null,"abstract":false,"args":[{"name":"catch_switch_ref","doc":null,"default_value":"","external_name":"catch_switch_ref","restriction":""},{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":""}],"args_string":"(catch_switch_ref, handler)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L190","def":{"name":"add_handler","args":[{"name":"catch_switch_ref","doc":null,"default_value":"","external_name":"catch_switch_ref","restriction":""},{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.add_handler(catch_switch_ref, handler)"}},{"id":"alloca(type,name=&quot;&quot;)-instance-method","html_id":"alloca(type,name=&amp;quot;&amp;quot;)-instance-method","name":"alloca","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L73","def":{"name":"alloca","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_alloca(self, type, name))"}},{"id":"and(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"and(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"and","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"and","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_and(self, lhs, rhs, name))"}},{"id":"ashr(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"ashr(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"ashr","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"ashr","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_ashr(self, lhs, rhs, name))"}},{"id":"atomicrmw(op,ptr,val,ordering,singlethread)-instance-method","html_id":"atomicrmw(op,ptr,val,ordering,singlethread)-instance-method","name":"atomicrmw","doc":null,"summary":null,"abstract":false,"args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""},{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":""},{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""},{"name":"singlethread","doc":null,"default_value":"","external_name":"singlethread","restriction":""}],"args_string":"(op, ptr, val, ordering, singlethread)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L218","def":{"name":"atomicrmw","args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""},{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":""},{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""},{"name":"singlethread","doc":null,"default_value":"","external_name":"singlethread","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_atomicrmw(self, op, ptr, val, ordering, singlethread ? 1 : 0))"}},{"id":"bit_cast(value,type,name=&quot;&quot;)-instance-method","html_id":"bit_cast(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"bit_cast","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"bit_cast","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_bit_cast(self, value, type, name))"}},{"id":"br(block)-instance-method","html_id":"br(block)-instance-method","name":"br","doc":null,"summary":null,"abstract":false,"args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"args_string":"(block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L25","def":{"name":"br","args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_br(self, block))"}},{"id":"build_catch_ret(pad,basic_block)-instance-method","html_id":"build_catch_ret(pad,basic_block)-instance-method","name":"build_catch_ret","doc":null,"summary":null,"abstract":false,"args":[{"name":"pad","doc":null,"default_value":"","external_name":"pad","restriction":""},{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":""}],"args_string":"(pad, basic_block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L198","def":{"name":"build_catch_ret","args":[{"name":"pad","doc":null,"default_value":"","external_name":"pad","restriction":""},{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.build_catch_ret(self, pad, basic_block)"}},{"id":"build_operand_bundle_def(name,values:Array(LLVM::Value))-instance-method","html_id":"build_operand_bundle_def(name,values:Array(LLVM::Value))-instance-method","name":"build_operand_bundle_def","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"}],"args_string":"(name, values : Array(LLVM::Value))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L194","def":{"name":"build_operand_bundle_def","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::OperandBundleDef.new(LibLLVMExt.build_operand_bundle_def(name, values.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), values.size))"}},{"id":"call(func,name:String=&quot;&quot;)-instance-method","html_id":"call(func,name:String=&amp;quot;&amp;quot;)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(func, name : String = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L52","def":{"name":"call","args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_call(self, func, nil, 0, name))"}},{"id":"call(func,arg:LLVM::Value,name:String=&quot;&quot;)-instance-method","html_id":"call(func,arg:LLVM::Value,name:String=&amp;quot;&amp;quot;)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"arg","doc":null,"default_value":"","external_name":"arg","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(func, arg : LLVM::Value, name : String = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L58","def":{"name":"call","args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"arg","doc":null,"default_value":"","external_name":"arg","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value = arg.to_unsafe\nValue.new(LibLLVM.build_call(self, func, pointerof(value), 1, name))\n"}},{"id":"call(func,args:Array(LLVM::Value),name:String=&quot;&quot;,bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null)-instance-method","html_id":"call(func,args:Array(LLVM::Value),name:String=&amp;quot;&amp;quot;,bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null)-instance-method","name":"call","doc":null,"summary":null,"abstract":false,"args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"},{"name":"bundle","doc":null,"default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"}],"args_string":"(func, args : Array(LLVM::Value), name : String = <span class=\"s\">&quot;&quot;</span>, bundle : LLVM::OperandBundleDef = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">OperandBundleDef</span>.null)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L66","def":{"name":"call","args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":"String"},{"name":"bundle","doc":null,"default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVMExt.build_call(self, func, (args.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), args.size, bundle, name))"}},{"id":"catch_pad(parent_pad,args:Array(LLVM::Value),name=&quot;&quot;)-instance-method","html_id":"catch_pad(parent_pad,args:Array(LLVM::Value),name=&amp;quot;&amp;quot;)-instance-method","name":"catch_pad","doc":null,"summary":null,"abstract":false,"args":[{"name":"parent_pad","doc":null,"default_value":"","external_name":"parent_pad","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(parent_pad, args : Array(LLVM::Value), name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L186","def":{"name":"catch_pad","args":[{"name":"parent_pad","doc":null,"default_value":"","external_name":"parent_pad","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVMExt.build_catch_pad(self, parent_pad, args.size, args.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), name))"}},{"id":"catch_switch(parent_pad,basic_block,num_handlers,name=&quot;&quot;)-instance-method","html_id":"catch_switch(parent_pad,basic_block,num_handlers,name=&amp;quot;&amp;quot;)-instance-method","name":"catch_switch","doc":null,"summary":null,"abstract":false,"args":[{"name":"parent_pad","doc":null,"default_value":"","external_name":"parent_pad","restriction":""},{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":""},{"name":"num_handlers","doc":null,"default_value":"","external_name":"num_handlers","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(parent_pad, basic_block, num_handlers, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L182","def":{"name":"catch_switch","args":[{"name":"parent_pad","doc":null,"default_value":"","external_name":"parent_pad","restriction":""},{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":""},{"name":"num_handlers","doc":null,"default_value":"","external_name":"num_handlers","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVMExt.build_catch_switch(self, parent_pad, basic_block, num_handlers, name))"}},{"id":"cmpxchg(pointer,cmp,new,success_ordering,failure_ordering)-instance-method","html_id":"cmpxchg(pointer,cmp,new,success_ordering,failure_ordering)-instance-method","name":"cmpxchg","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":""},{"name":"cmp","doc":null,"default_value":"","external_name":"cmp","restriction":""},{"name":"new","doc":null,"default_value":"","external_name":"new","restriction":""},{"name":"success_ordering","doc":null,"default_value":"","external_name":"success_ordering","restriction":""},{"name":"failure_ordering","doc":null,"default_value":"","external_name":"failure_ordering","restriction":""}],"args_string":"(pointer, cmp, new, success_ordering, failure_ordering)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L222","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L222","def":{"name":"cmpxchg","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":""},{"name":"cmp","doc":null,"default_value":"","external_name":"cmp","restriction":""},{"name":"new","doc":null,"default_value":"","external_name":"new","restriction":""},{"name":"success_ordering","doc":null,"default_value":"","external_name":"success_ordering","restriction":""},{"name":"failure_ordering","doc":null,"default_value":"","external_name":"failure_ordering","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVMExt.build_cmpxchg(self, pointer, cmp, new, success_ordering, failure_ordering))"}},{"id":"cond(cond,then_block,else_block)-instance-method","html_id":"cond(cond,then_block,else_block)-instance-method","name":"cond","doc":null,"summary":null,"abstract":false,"args":[{"name":"cond","doc":null,"default_value":"","external_name":"cond","restriction":""},{"name":"then_block","doc":null,"default_value":"","external_name":"then_block","restriction":""},{"name":"else_block","doc":null,"default_value":"","external_name":"else_block","restriction":""}],"args_string":"(cond, then_block, else_block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L29","def":{"name":"cond","args":[{"name":"cond","doc":null,"default_value":"","external_name":"cond","restriction":""},{"name":"then_block","doc":null,"default_value":"","external_name":"then_block","restriction":""},{"name":"else_block","doc":null,"default_value":"","external_name":"else_block","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_cond(self, cond, then_block, else_block))"}},{"id":"current_debug_location-instance-method","html_id":"current_debug_location-instance-method","name":"current_debug_location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L238","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L238","def":{"name":"current_debug_location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.get_current_debug_location(self))"}},{"id":"exact_sdiv(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"exact_sdiv(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"exact_sdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"exact_sdiv","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_exact_sdiv(self, lhs, rhs, name))"}},{"id":"extract_value(value,index,name=&quot;&quot;)-instance-method","html_id":"extract_value(value,index,name=&amp;quot;&amp;quot;)-instance-method","name":"extract_value","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L116","def":{"name":"extract_value","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_extract_value(self, value, index, name))"}},{"id":"fadd(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"fadd(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"fadd","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"fadd","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fadd(self, lhs, rhs, name))"}},{"id":"fcmp(op,lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"fcmp(op,lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"fcmp","doc":null,"summary":null,"abstract":false,"args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(op, lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L140","def":{"name":"fcmp","args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fcmp(self, op, lhs, rhs, name))"}},{"id":"fdiv(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"fdiv(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"fdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"fdiv","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fdiv(self, lhs, rhs, name))"}},{"id":"fence(ordering,singlethread,name=&quot;&quot;)-instance-method","html_id":"fence(ordering,singlethread,name=&amp;quot;&amp;quot;)-instance-method","name":"fence","doc":null,"summary":null,"abstract":false,"args":[{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""},{"name":"singlethread","doc":null,"default_value":"","external_name":"singlethread","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(ordering, singlethread, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L226","def":{"name":"fence","args":[{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""},{"name":"singlethread","doc":null,"default_value":"","external_name":"singlethread","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fence(self, ordering, singlethread ? 1 : 0, name))"}},{"id":"fmul(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"fmul(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"fmul","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"fmul","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fmul(self, lhs, rhs, name))"}},{"id":"fp2si(value,type,name=&quot;&quot;)-instance-method","html_id":"fp2si(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"fp2si","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"fp2si","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fp2si(self, value, type, name))"}},{"id":"fp2ui(value,type,name=&quot;&quot;)-instance-method","html_id":"fp2ui(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"fp2ui","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"fp2ui","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fp2ui(self, value, type, name))"}},{"id":"fpext(value,type,name=&quot;&quot;)-instance-method","html_id":"fpext(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"fpext","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"fpext","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fpext(self, value, type, name))"}},{"id":"fptrunc(value,type,name=&quot;&quot;)-instance-method","html_id":"fptrunc(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"fptrunc","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"fptrunc","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fptrunc(self, value, type, name))"}},{"id":"fsub(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"fsub(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"fsub","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"fsub","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_fsub(self, lhs, rhs, name))"}},{"id":"gep(value,indices:Array(LLVM::ValueRef),name=&quot;&quot;)-instance-method","html_id":"gep(value,indices:Array(LLVM::ValueRef),name=&amp;quot;&amp;quot;)-instance-method","name":"gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"indices","doc":null,"default_value":"","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, indices : Array(LLVM::ValueRef), name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"indices","doc":null,"default_value":"","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), indices.size, name))"}},{"id":"gep(value,index1:LLVM::Value,index2:LLVM::Value,name=&quot;&quot;)-instance-method","html_id":"gep(value,index1:LLVM::Value,index2:LLVM::Value,name=&amp;quot;&amp;quot;)-instance-method","name":"gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","doc":null,"default_value":"","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index1 : LLVM::Value, index2 : LLVM::Value, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","doc":null,"default_value":"","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indices = uninitialized ::StaticArray(LLVM::Value, 2)\nindices[0] = index1\nindices[1] = index2\nValue.new(LibLLVM.build_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), 2, name))\n"}},{"id":"gep(value,index:LLVM::Value,name=&quot;&quot;)-instance-method","html_id":"gep(value,index:LLVM::Value,name=&amp;quot;&amp;quot;)-instance-method","name":"gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index : LLVM::Value, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indices = (pointerof(index)).as(::Pointer(LibLLVM::ValueRef))\nValue.new(LibLLVM.build_gep(self, value, indices, 1, name))\n"}},{"id":"global_string_pointer(string,name=&quot;&quot;)-instance-method","html_id":"global_string_pointer(string,name=&amp;quot;&amp;quot;)-instance-method","name":"global_string_pointer","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(string, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L167","def":{"name":"global_string_pointer","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_global_string_ptr(self, string, name))"}},{"id":"icmp(op,lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"icmp(op,lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"icmp","doc":null,"summary":null,"abstract":false,"args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(op, lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L140","def":{"name":"icmp","args":[{"name":"op","doc":null,"default_value":"","external_name":"op","restriction":""},{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_icmp(self, op, lhs, rhs, name))"}},{"id":"inbounds_gep(value,indices:Array(LLVM::ValueRef),name=&quot;&quot;)-instance-method","html_id":"inbounds_gep(value,indices:Array(LLVM::ValueRef),name=&amp;quot;&amp;quot;)-instance-method","name":"inbounds_gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"indices","doc":null,"default_value":"","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, indices : Array(LLVM::ValueRef), name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"inbounds_gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"indices","doc":null,"default_value":"","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_inbounds_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), indices.size, name))"}},{"id":"inbounds_gep(value,index1:LLVM::Value,index2:LLVM::Value,name=&quot;&quot;)-instance-method","html_id":"inbounds_gep(value,index1:LLVM::Value,index2:LLVM::Value,name=&amp;quot;&amp;quot;)-instance-method","name":"inbounds_gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","doc":null,"default_value":"","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index1 : LLVM::Value, index2 : LLVM::Value, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"inbounds_gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index1","doc":null,"default_value":"","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","doc":null,"default_value":"","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indices = uninitialized ::StaticArray(LLVM::Value, 2)\nindices[0] = index1\nindices[1] = index2\nValue.new(LibLLVM.build_inbounds_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), 2, name))\n"}},{"id":"inbounds_gep(value,index:LLVM::Value,name=&quot;&quot;)-instance-method","html_id":"inbounds_gep(value,index:LLVM::Value,name=&amp;quot;&amp;quot;)-instance-method","name":"inbounds_gep","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index : LLVM::Value, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L92","def":{"name":"inbounds_gep","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"LLVM::Value"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"indices = (pointerof(index)).as(::Pointer(LibLLVM::ValueRef))\nValue.new(LibLLVM.build_inbounds_gep(self, value, indices, 1, name))\n"}},{"id":"insert_block-instance-method","html_id":"insert_block-instance-method","name":"insert_block","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L11","def":{"name":"insert_block","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BasicBlock.new(LibLLVM.get_insert_block(self))"}},{"id":"int2ptr(value,type,name=&quot;&quot;)-instance-method","html_id":"int2ptr(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"int2ptr","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"int2ptr","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_int2ptr(self, value, type, name))"}},{"id":"invoke(fn,args:Array(LLVM::Value),a_then,a_catch,bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null,name=&quot;&quot;)-instance-method","html_id":"invoke(fn,args:Array(LLVM::Value),a_then,a_catch,bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null,name=&amp;quot;&amp;quot;)-instance-method","name":"invoke","doc":null,"summary":null,"abstract":false,"args":[{"name":"fn","doc":null,"default_value":"","external_name":"fn","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"a_then","doc":null,"default_value":"","external_name":"a_then","restriction":""},{"name":"a_catch","doc":null,"default_value":"","external_name":"a_catch","restriction":""},{"name":"bundle","doc":null,"default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(fn, args : Array(LLVM::Value), a_then, a_catch, bundle : LLVM::OperandBundleDef = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">OperandBundleDef</span>.null, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L202","def":{"name":"invoke","args":[{"name":"fn","doc":null,"default_value":"","external_name":"fn","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"a_then","doc":null,"default_value":"","external_name":"a_then","restriction":""},{"name":"a_catch","doc":null,"default_value":"","external_name":"a_catch","restriction":""},{"name":"bundle","doc":null,"default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVMExt.build_invoke(self, fn, (args.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), args.size, a_then, a_catch, bundle, name))"}},{"id":"landing_pad(type,personality,clauses,name=&quot;&quot;)-instance-method","html_id":"landing_pad(type,personality,clauses,name=&amp;quot;&amp;quot;)-instance-method","name":"landing_pad","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"personality","doc":null,"default_value":"","external_name":"personality","restriction":""},{"name":"clauses","doc":null,"default_value":"","external_name":"clauses","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, personality, clauses, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L171","def":{"name":"landing_pad","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"personality","doc":null,"default_value":"","external_name":"personality","restriction":""},{"name":"clauses","doc":null,"default_value":"","external_name":"clauses","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"lpad = LibLLVM.build_landing_pad(self, type, personality, clauses.size, name)\nLibLLVM.set_cleanup(lpad, 1)\nclauses.each do |clause|\n  LibLLVM.add_clause(lpad, clause)\nend\nValue.new(lpad)\n"}},{"id":"load(ptr,name=&quot;&quot;)-instance-method","html_id":"load(ptr,name=&amp;quot;&amp;quot;)-instance-method","name":"load","doc":null,"summary":null,"abstract":false,"args":[{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(ptr, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L86","def":{"name":"load","args":[{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_load(self, ptr, name))"}},{"id":"lshr(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"lshr(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"lshr","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"lshr","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_lshr(self, lhs, rhs, name))"}},{"id":"mul(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"mul(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"mul","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"mul","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_mul(self, lhs, rhs, name))"}},{"id":"not(value,name=&quot;&quot;)-instance-method","html_id":"not(value,name=&amp;quot;&amp;quot;)-instance-method","name":"not","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L149","def":{"name":"not","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_not(self, value, name))"}},{"id":"or(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"or(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"or","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"or","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_or(self, lhs, rhs, name))"}},{"id":"phi(type,table:LLVM::PhiTable,name=&quot;&quot;)-instance-method","html_id":"phi(type,table:LLVM::PhiTable,name=&amp;quot;&amp;quot;)-instance-method","name":"phi","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"table","doc":null,"default_value":"","external_name":"table","restriction":"LLVM::PhiTable"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, table : LLVM::PhiTable, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L35","def":{"name":"phi","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"table","doc":null,"default_value":"","external_name":"table","restriction":"LLVM::PhiTable"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"phi(type, table.blocks, table.values, name)"}},{"id":"phi(type,incoming_blocks:Array(LLVM::BasicBlock),incoming_values:Array(LLVM::Value),name=&quot;&quot;)-instance-method","html_id":"phi(type,incoming_blocks:Array(LLVM::BasicBlock),incoming_values:Array(LLVM::Value),name=&amp;quot;&amp;quot;)-instance-method","name":"phi","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"incoming_blocks","doc":null,"default_value":"","external_name":"incoming_blocks","restriction":"Array(LLVM::BasicBlock)"},{"name":"incoming_values","doc":null,"default_value":"","external_name":"incoming_values","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, incoming_blocks : Array(LLVM::BasicBlock), incoming_values : Array(LLVM::Value), name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L41","def":{"name":"phi","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"incoming_blocks","doc":null,"default_value":"","external_name":"incoming_blocks","restriction":"Array(LLVM::BasicBlock)"},{"name":"incoming_values","doc":null,"default_value":"","external_name":"incoming_values","restriction":"Array(LLVM::Value)"},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"phi_node = LibLLVM.build_phi(self, type, name)\nLibLLVM.add_incoming(phi_node, (incoming_values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), (incoming_blocks.to_unsafe.as(::Pointer(LibLLVM::BasicBlockRef))), incoming_blocks.size)\nValue.new(phi_node)\n"}},{"id":"position_at_end(block)-instance-method","html_id":"position_at_end(block)-instance-method","name":"position_at_end","doc":null,"summary":null,"abstract":false,"args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"args_string":"(block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L7","def":{"name":"position_at_end","args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.position_builder_at_end(self, block)"}},{"id":"ptr2int(value,type,name=&quot;&quot;)-instance-method","html_id":"ptr2int(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"ptr2int","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"ptr2int","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_ptr2int(self, value, type, name))"}},{"id":"ret-instance-method","html_id":"ret-instance-method","name":"ret","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L15","def":{"name":"ret","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_ret_void(self))"}},{"id":"ret(value)-instance-method","html_id":"ret(value)-instance-method","name":"ret","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L19","def":{"name":"ret","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_ret(self, value))"}},{"id":"sdiv(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"sdiv(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"sdiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"sdiv","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_sdiv(self, lhs, rhs, name))"}},{"id":"select(cond,a_then,a_else,name=&quot;&quot;)-instance-method","html_id":"select(cond,a_then,a_else,name=&amp;quot;&amp;quot;)-instance-method","name":"select","doc":null,"summary":null,"abstract":false,"args":[{"name":"cond","doc":null,"default_value":"","external_name":"cond","restriction":""},{"name":"a_then","doc":null,"default_value":"","external_name":"a_then","restriction":""},{"name":"a_else","doc":null,"default_value":"","external_name":"a_else","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(cond, a_then, a_else, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L159","def":{"name":"select","args":[{"name":"cond","doc":null,"default_value":"","external_name":"cond","restriction":""},{"name":"a_then","doc":null,"default_value":"","external_name":"a_then","restriction":""},{"name":"a_else","doc":null,"default_value":"","external_name":"a_else","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_select(self, cond, a_then, a_else, name))"}},{"id":"set_current_debug_location(line,column,scope,inlined_at=nil)-instance-method","html_id":"set_current_debug_location(line,column,scope,inlined_at=nil)-instance-method","name":"set_current_debug_location","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":""},{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"inlined_at","doc":null,"default_value":"nil","external_name":"inlined_at","restriction":""}],"args_string":"(line, column, scope, inlined_at = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L230","def":{"name":"set_current_debug_location","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":""},{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"inlined_at","doc":null,"default_value":"nil","external_name":"inlined_at","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.set_current_debug_location(self, line, column, scope, inlined_at)"}},{"id":"set_metadata(value,kind,node)-instance-method","html_id":"set_metadata(value,kind,node)-instance-method","name":"set_metadata","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"args_string":"(value, kind, node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L234","def":{"name":"set_metadata","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":""},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_metadata(value, kind, node)"}},{"id":"sext(value,type,name=&quot;&quot;)-instance-method","html_id":"sext(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"sext","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"sext","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_sext(self, value, type, name))"}},{"id":"shl(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"shl(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"shl","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"shl","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_shl(self, lhs, rhs, name))"}},{"id":"si2fp(value,type,name=&quot;&quot;)-instance-method","html_id":"si2fp(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"si2fp","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"si2fp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_si2fp(self, value, type, name))"}},{"id":"srem(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"srem(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"srem","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"srem","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_srem(self, lhs, rhs, name))"}},{"id":"store(value,ptr)-instance-method","html_id":"store(value,ptr)-instance-method","name":"store","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""}],"args_string":"(value, ptr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L79","def":{"name":"store","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"ptr","doc":null,"default_value":"","external_name":"ptr","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_store(self, value, ptr))"}},{"id":"sub(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"sub(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"sub","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"sub","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_sub(self, lhs, rhs, name))"}},{"id":"switch(value,otherwise,cases)-instance-method","html_id":"switch(value,otherwise,cases)-instance-method","name":"switch","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"otherwise","doc":null,"default_value":"","external_name":"otherwise","restriction":""},{"name":"cases","doc":null,"default_value":"","external_name":"cases","restriction":""}],"args_string":"(value, otherwise, cases)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L208","def":{"name":"switch","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"otherwise","doc":null,"default_value":"","external_name":"otherwise","restriction":""},{"name":"cases","doc":null,"default_value":"","external_name":"cases","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"switch = LibLLVM.build_switch(self, value, otherwise, cases.size)\ncases.each do |case_value, block|\n  LibLLVM.add_case(switch, case_value, block)\nend\nswitch\n"}},{"id":"to_unsafe:LibLLVM::BuilderRef-instance-method","html_id":"to_unsafe:LibLLVM::BuilderRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::BuilderRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L242","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"trunc(value,type,name=&quot;&quot;)-instance-method","html_id":"trunc(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"trunc","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"trunc","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_trunc(self, value, type, name))"}},{"id":"udiv(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"udiv(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"udiv","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"udiv","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_udiv(self, lhs, rhs, name))"}},{"id":"ui2fp(value,type,name=&quot;&quot;)-instance-method","html_id":"ui2fp(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"ui2fp","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"ui2fp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_ui2fp(self, value, type, name))"}},{"id":"unreachable-instance-method","html_id":"unreachable-instance-method","name":"unreachable","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L155","def":{"name":"unreachable","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_unreachable(self))"}},{"id":"urem(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"urem(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"urem","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"urem","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_urem(self, lhs, rhs, name))"}},{"id":"xor(lhs,rhs,name=&quot;&quot;)-instance-method","html_id":"xor(lhs,rhs,name=&amp;quot;&amp;quot;)-instance-method","name":"xor","doc":null,"summary":null,"abstract":false,"args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L131","def":{"name":"xor","args":[{"name":"lhs","doc":null,"default_value":"","external_name":"lhs","restriction":""},{"name":"rhs","doc":null,"default_value":"","external_name":"rhs","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_xor(self, lhs, rhs, name))"}},{"id":"zext(value,type,name=&quot;&quot;)-instance-method","html_id":"zext(value,type,name=&amp;quot;&amp;quot;)-instance-method","name":"zext","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/builder.cr#L122","def":{"name":"zext","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"\"\"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.build_zext(self, value, type, name))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/CallConvention","path":"LLVM/CallConvention.html","kind":"enum","full_name":"LLVM::CallConvention","name":"CallConvention","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":288,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"C","name":"C","value":"0","doc":null,"summary":null},{"id":"Fast","name":"Fast","value":"8","doc":null,"summary":null},{"id":"Cold","name":"Cold","value":"9","doc":null,"summary":null},{"id":"WebKit_JS","name":"WebKit_JS","value":"12","doc":null,"summary":null},{"id":"AnyReg","name":"AnyReg","value":"13","doc":null,"summary":null},{"id":"X86_StdCall","name":"X86_StdCall","value":"64","doc":null,"summary":null},{"id":"X86_FastCall","name":"X86_FastCall","value":"65","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"any_reg?-instance-method","html_id":"any_reg?-instance-method","name":"any_reg?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L293","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L293","def":{"name":"any_reg?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AnyReg"}},{"id":"c?-instance-method","html_id":"c?-instance-method","name":"c?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L289","def":{"name":"c?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == C"}},{"id":"cold?-instance-method","html_id":"cold?-instance-method","name":"cold?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L291","def":{"name":"cold?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Cold"}},{"id":"fast?-instance-method","html_id":"fast?-instance-method","name":"fast?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L290","def":{"name":"fast?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Fast"}},{"id":"web_kit_js?-instance-method","html_id":"web_kit_js?-instance-method","name":"web_kit_js?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L292","def":{"name":"web_kit_js?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WebKit_JS"}},{"id":"x86_fast_call?-instance-method","html_id":"x86_fast_call?-instance-method","name":"x86_fast_call?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L295","def":{"name":"x86_fast_call?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86_FastCall"}},{"id":"x86_std_call?-instance-method","html_id":"x86_std_call?-instance-method","name":"x86_std_call?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L294","def":{"name":"x86_std_call?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86_StdCall"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/CodeGenFileType","path":"LLVM/CodeGenFileType.html","kind":"enum","full_name":"LLVM::CodeGenFileType","name":"CodeGenFileType","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":261,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"AssemblyFile","name":"AssemblyFile","value":"0","doc":null,"summary":null},{"id":"ObjectFile","name":"ObjectFile","value":"1","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"assembly_file?-instance-method","html_id":"assembly_file?-instance-method","name":"assembly_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L262","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L262","def":{"name":"assembly_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AssemblyFile"}},{"id":"object_file?-instance-method","html_id":"object_file?-instance-method","name":"object_file?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L263","def":{"name":"object_file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ObjectFile"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/CodeGenOptLevel","path":"LLVM/CodeGenOptLevel.html","kind":"enum","full_name":"LLVM::CodeGenOptLevel","name":"CodeGenOptLevel","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":254,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"None","name":"None","value":"0","doc":null,"summary":null},{"id":"Less","name":"Less","value":"1","doc":null,"summary":null},{"id":"Default","name":"Default","value":"2","doc":null,"summary":null},{"id":"Aggressive","name":"Aggressive","value":"3","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"aggressive?-instance-method","html_id":"aggressive?-instance-method","name":"aggressive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L258","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L258","def":{"name":"aggressive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Aggressive"}},{"id":"default?-instance-method","html_id":"default?-instance-method","name":"default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L257","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L257","def":{"name":"default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Default"}},{"id":"less?-instance-method","html_id":"less?-instance-method","name":"less?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L256","def":{"name":"less?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Less"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L255","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == None"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/CodeModel","path":"LLVM/CodeModel.html","kind":"enum","full_name":"LLVM::CodeModel","name":"CodeModel","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":273,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Default","name":"Default","value":"0","doc":null,"summary":null},{"id":"JITDefault","name":"JITDefault","value":"1","doc":null,"summary":null},{"id":"Small","name":"Small","value":"2","doc":null,"summary":null},{"id":"Kernel","name":"Kernel","value":"3","doc":null,"summary":null},{"id":"Medium","name":"Medium","value":"4","doc":null,"summary":null},{"id":"Large","name":"Large","value":"5","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"default?-instance-method","html_id":"default?-instance-method","name":"default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L274","def":{"name":"default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Default"}},{"id":"jit_default?-instance-method","html_id":"jit_default?-instance-method","name":"jit_default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L275","def":{"name":"jit_default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == JITDefault"}},{"id":"kernel?-instance-method","html_id":"kernel?-instance-method","name":"kernel?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L277","def":{"name":"kernel?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Kernel"}},{"id":"large?-instance-method","html_id":"large?-instance-method","name":"large?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L279","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L279","def":{"name":"large?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Large"}},{"id":"medium?-instance-method","html_id":"medium?-instance-method","name":"medium?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L278","def":{"name":"medium?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Medium"}},{"id":"small?-instance-method","html_id":"small?-instance-method","name":"small?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L276","def":{"name":"small?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Small"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Context","path":"LLVM/Context.html","kind":"class","full_name":"LLVM::Context","name":"Context","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/context.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::ContextRef,dispose_on_finalize=true)-class-method","html_id":"new(unwrap:LibLLVM::ContextRef,dispose_on_finalize=true)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ContextRef"},{"name":"dispose_on_finalize","doc":null,"default_value":"true","external_name":"dispose_on_finalize","restriction":""}],"args_string":"(unwrap : LibLLVM::ContextRef, dispose_on_finalize = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L6","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ContextRef"},{"name":"dispose_on_finalize","doc":null,"default_value":"true","external_name":"dispose_on_finalize","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, dispose_on_finalize)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L2","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(LibLLVM.create_context)"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L114","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap == (other.@unwrap)"}},{"id":"const_string(string:String):Value-instance-method","html_id":"const_string(string:String):Value-instance-method","name":"const_string","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L86","def":{"name":"const_string","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_string_in_context(self, string, string.bytesize, 0))"}},{"id":"const_struct(values:Array(LLVM::Value),packed=false):Value-instance-method","html_id":"const_struct(values:Array(LLVM::Value),packed=false):Value-instance-method","name":"const_struct","doc":null,"summary":null,"abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"args_string":"(values : Array(LLVM::Value), packed = <span class=\"n\">false</span>) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L90","def":{"name":"const_struct","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_struct_in_context(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size, packed ? 1 : 0))"}},{"id":"double:Type-instance-method","html_id":"double:Type-instance-method","name":"double","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L62","def":{"name":"double","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.double_type_in_context(self))"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L122","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @dispose_on_finalize\nelse\n  return\nend\nif @disposed\n  return\nend\n@disposed = true\n@builders.each(&.dispose)\nLibLLVM.dispose_context(self)\n"}},{"id":"float:Type-instance-method","html_id":"float:Type-instance-method","name":"float","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L58","def":{"name":"float","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.float_type_in_context(self))"}},{"id":"int(bits:Int):Type-instance-method","html_id":"int(bits:Int):Type-instance-method","name":"int","doc":null,"summary":null,"abstract":false,"args":[{"name":"bits","doc":null,"default_value":"","external_name":"bits","restriction":"Int"}],"args_string":"(bits : Int) : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L54","def":{"name":"int","args":[{"name":"bits","doc":null,"default_value":"","external_name":"bits","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int_type_in_context(self, bits))"}},{"id":"int1:Type-instance-method","html_id":"int1:Type-instance-method","name":"int1","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L30","def":{"name":"int1","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int1_type_in_context(self))"}},{"id":"int128:Type-instance-method","html_id":"int128:Type-instance-method","name":"int128","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L50","def":{"name":"int128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int128_type_in_context(self))"}},{"id":"int16:Type-instance-method","html_id":"int16:Type-instance-method","name":"int16","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L38","def":{"name":"int16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int16_type_in_context(self))"}},{"id":"int32:Type-instance-method","html_id":"int32:Type-instance-method","name":"int32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L42","def":{"name":"int32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int32_type_in_context(self))"}},{"id":"int64:Type-instance-method","html_id":"int64:Type-instance-method","name":"int64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L46","def":{"name":"int64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int64_type_in_context(self))"}},{"id":"int8:Type-instance-method","html_id":"int8:Type-instance-method","name":"int8","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L34","def":{"name":"int8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int8_type_in_context(self))"}},{"id":"md_node(values:Array(Value)):Value-instance-method","html_id":"md_node(values:Array(Value)):Value-instance-method","name":"md_node","doc":null,"summary":null,"abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(Value)"}],"args_string":"(values : Array(Value)) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L98","def":{"name":"md_node","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(Value)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.md_node_in_context(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size))"}},{"id":"md_string(value:String):Value-instance-method","html_id":"md_string(value:String):Value-instance-method","name":"md_string","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L94","def":{"name":"md_string","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"LLVM::Value.new(LibLLVM.md_string_in_context(self, value, value.bytesize))"}},{"id":"new_builder:Builder-instance-method","html_id":"new_builder:Builder-instance-method","name":"new_builder","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Builder","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L19","def":{"name":"new_builder","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Builder","visibility":"Public","body":"builder = Builder.new(LibLLVM.create_builder_in_context(self))\n@builders << builder\nbuilder\n"}},{"id":"new_module(name:String):Module-instance-method","html_id":"new_module(name:String):Module-instance-method","name":"new_module","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Module","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L11","def":{"name":"new_module","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Module","visibility":"Public","body":"{% if LibLLVM::IS_38 %}\n      Module.new(LibLLVM.module_create_with_name_in_context(name, self), name, self)\n    {% else %} # LLVM >= 3.9\n      Module.new(LibLLVM.module_create_with_name_in_context(name, self), self)\n    {% end %}"}},{"id":"parse_ir(buf:MemoryBuffer)-instance-method","html_id":"parse_ir(buf:MemoryBuffer)-instance-method","name":"parse_ir","doc":null,"summary":null,"abstract":false,"args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"MemoryBuffer"}],"args_string":"(buf : MemoryBuffer)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L102","def":{"name":"parse_ir","args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"MemoryBuffer"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibLLVM.parse_ir_in_context(self, buf, out mod, out msg)\nif (ret != 0) && msg\n  raise(LLVM.string_and_dispose(msg))\nend\n{% if LibLLVM::IS_38 %}\n      Module.new(mod, \"unknown\", self)\n    {% else %} # LLVM >= 3.9\n      Module.new(mod, self)\n    {% end %}\n"}},{"id":"struct(name:String,packed=false,&block):Type-instance-method","html_id":"struct(name:String,packed=false,&amp;block):Type-instance-method","name":"struct","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"args_string":"(name : String, packed = <span class=\"n\">false</span>, &block) : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L70","def":{"name":"struct","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Type","visibility":"Public","body":"llvm_struct = LibLLVM.struct_create_named(self, name)\nthe_struct = Type.new(llvm_struct)\nelement_types = (yield the_struct).as(Array(LLVM::Type))\nLibLLVM.struct_set_body(llvm_struct, (element_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), element_types.size, packed ? 1 : 0)\nthe_struct\n"}},{"id":"struct(element_types:Array(LLVM::Type),name=nil,packed=false):Type-instance-method","html_id":"struct(element_types:Array(LLVM::Type),name=nil,packed=false):Type-instance-method","name":"struct","doc":null,"summary":null,"abstract":false,"args":[{"name":"element_types","doc":null,"default_value":"","external_name":"element_types","restriction":"Array(LLVM::Type)"},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":""},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"args_string":"(element_types : Array(LLVM::Type), name = <span class=\"n\">nil</span>, packed = <span class=\"n\">false</span>) : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L78","def":{"name":"struct","args":[{"name":"element_types","doc":null,"default_value":"","external_name":"element_types","restriction":"Array(LLVM::Type)"},{"name":"name","doc":null,"default_value":"nil","external_name":"name","restriction":""},{"name":"packed","doc":null,"default_value":"false","external_name":"packed","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"if name\n  self.struct(name, packed) do\n    element_types\n  end\nelse\n  Type.new(LibLLVM.struct_type_in_context(self, (  element_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), element_types.size, packed ? 1 : 0))\nend"}},{"id":"to_unsafe:LibLLVM::ContextRef-instance-method","html_id":"to_unsafe:LibLLVM::ContextRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::ContextRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L118","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"void:Type-instance-method","html_id":"void:Type-instance-method","name":"void","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L26","def":{"name":"void","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.void_type_in_context(self))"}},{"id":"void_pointer:Type-instance-method","html_id":"void_pointer:Type-instance-method","name":"void_pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/context.cr#L66","def":{"name":"void_pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"int8.pointer"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/DIBuilder","path":"LLVM/DIBuilder.html","kind":"struct","full_name":"LLVM::DIBuilder","name":"DIBuilder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/di_builder.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(llvm_module:Module)-class-method","html_id":"new(llvm_module:Module)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"llvm_module","doc":null,"default_value":"","external_name":"llvm_module","restriction":"Module"}],"args_string":"(llvm_module : Module)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L4","def":{"name":"new","args":[{"name":"llvm_module","doc":null,"default_value":"","external_name":"llvm_module","restriction":"Module"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(llvm_module)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"create_auto_variable(scope,name,file,line,type,align_in_bits)-instance-method","html_id":"create_auto_variable(scope,name,file,line,type,align_in_bits)-instance-method","name":"create_auto_variable","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""}],"args_string":"(scope, name, file, line, type, align_in_bits)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L38","def":{"name":"create_auto_variable","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_auto_variable(self, scope, name, file, line, type, 0, DIFlags::Zero, align_in_bits)"}},{"id":"create_basic_type(name,size_in_bits,align_in_bits,encoding)-instance-method","html_id":"create_basic_type(name,size_in_bits,align_in_bits,encoding)-instance-method","name":"create_basic_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":""}],"args_string":"(name, size_in_bits, align_in_bits, encoding)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L12","def":{"name":"create_basic_type","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_basic_type(self, name, size_in_bits, align_in_bits, encoding.value)"}},{"id":"create_compile_unit(lang,file,dir,producer,optimized,flags,runtime_version)-instance-method","html_id":"create_compile_unit(lang,file,dir,producer,optimized,flags,runtime_version)-instance-method","name":"create_compile_unit","doc":null,"summary":null,"abstract":false,"args":[{"name":"lang","doc":null,"default_value":"","external_name":"lang","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"dir","doc":null,"default_value":"","external_name":"dir","restriction":""},{"name":"producer","doc":null,"default_value":"","external_name":"producer","restriction":""},{"name":"optimized","doc":null,"default_value":"","external_name":"optimized","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"runtime_version","doc":null,"default_value":"","external_name":"runtime_version","restriction":""}],"args_string":"(lang, file, dir, producer, optimized, flags, runtime_version)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L8","def":{"name":"create_compile_unit","args":[{"name":"lang","doc":null,"default_value":"","external_name":"lang","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"dir","doc":null,"default_value":"","external_name":"dir","restriction":""},{"name":"producer","doc":null,"default_value":"","external_name":"producer","restriction":""},{"name":"optimized","doc":null,"default_value":"","external_name":"optimized","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"runtime_version","doc":null,"default_value":"","external_name":"runtime_version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_compile_unit(self, lang, file, dir, producer, optimized ? 1 : 0, flags, runtime_version)"}},{"id":"create_enumeration_type(scope,name,file,line_number,size_in_bits,align_in_bits,elements,underlying_type)-instance-method","html_id":"create_enumeration_type(scope,name,file,line_number,size_in_bits,align_in_bits,elements,underlying_type)-instance-method","name":"create_enumeration_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"underlying_type","doc":null,"default_value":"","external_name":"underlying_type","restriction":""}],"args_string":"(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L62","def":{"name":"create_enumeration_type","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"underlying_type","doc":null,"default_value":"","external_name":"underlying_type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_enumeration_type(self, scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)"}},{"id":"create_enumerator(name,value)-instance-method","html_id":"create_enumerator(name,value)-instance-method","name":"create_enumerator","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L58","def":{"name":"create_enumerator","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_enumerator(self, name, value)"}},{"id":"create_expression(addr,length)-instance-method","html_id":"create_expression(addr,length)-instance-method","name":"create_expression","doc":null,"summary":null,"abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":""}],"args_string":"(addr, length)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L46","def":{"name":"create_expression","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"length","doc":null,"default_value":"","external_name":"length","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_expression(self, addr, length)"}},{"id":"create_file(file,dir)-instance-method","html_id":"create_file(file,dir)-instance-method","name":"create_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"dir","doc":null,"default_value":"","external_name":"dir","restriction":""}],"args_string":"(file, dir)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L24","def":{"name":"create_file","args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"dir","doc":null,"default_value":"","external_name":"dir","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_file(self, file, dir)"}},{"id":"create_function(scope,name,linkage_name,file,line,composite_type,is_local_to_unit,is_definition,scope_line,flags,is_optimized,func)-instance-method","html_id":"create_function(scope,name,linkage_name,file,line,composite_type,is_local_to_unit,is_definition,scope_line,flags,is_optimized,func)-instance-method","name":"create_function","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"linkage_name","doc":null,"default_value":"","external_name":"linkage_name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"composite_type","doc":null,"default_value":"","external_name":"composite_type","restriction":""},{"name":"is_local_to_unit","doc":null,"default_value":"","external_name":"is_local_to_unit","restriction":""},{"name":"is_definition","doc":null,"default_value":"","external_name":"is_definition","restriction":""},{"name":"scope_line","doc":null,"default_value":"","external_name":"scope_line","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"is_optimized","doc":null,"default_value":"","external_name":"is_optimized","restriction":""},{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""}],"args_string":"(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L32","def":{"name":"create_function","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"linkage_name","doc":null,"default_value":"","external_name":"linkage_name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"composite_type","doc":null,"default_value":"","external_name":"composite_type","restriction":""},{"name":"is_local_to_unit","doc":null,"default_value":"","external_name":"is_local_to_unit","restriction":""},{"name":"is_definition","doc":null,"default_value":"","external_name":"is_definition","restriction":""},{"name":"scope_line","doc":null,"default_value":"","external_name":"scope_line","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"is_optimized","doc":null,"default_value":"","external_name":"is_optimized","restriction":""},{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_function(self, scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)"}},{"id":"create_lexical_block(scope,file,line,column)-instance-method","html_id":"create_lexical_block(scope,file,line,column)-instance-method","name":"create_lexical_block","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":""}],"args_string":"(scope, file, line, column)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L28","def":{"name":"create_lexical_block","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"column","doc":null,"default_value":"","external_name":"column","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_lexical_block(self, scope, file, line, column)"}},{"id":"create_member_type(scope,name,file,line,size_in_bits,align_in_bits,offset_in_bits,flags,ty)-instance-method","html_id":"create_member_type(scope,name,file,line,size_in_bits,align_in_bits,offset_in_bits,flags,ty)-instance-method","name":"create_member_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"offset_in_bits","doc":null,"default_value":"","external_name":"offset_in_bits","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""}],"args_string":"(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L72","def":{"name":"create_member_type","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"offset_in_bits","doc":null,"default_value":"","external_name":"offset_in_bits","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"ty","doc":null,"default_value":"","external_name":"ty","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_member_type(self, scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)"}},{"id":"create_parameter_variable(scope,name,argno,file,line,type)-instance-method","html_id":"create_parameter_variable(scope,name,argno,file,line,type)-instance-method","name":"create_parameter_variable","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"argno","doc":null,"default_value":"","external_name":"argno","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(scope, name, argno, file, line, type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L42","def":{"name":"create_parameter_variable","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"argno","doc":null,"default_value":"","external_name":"argno","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_parameter_variable(self, scope, name, argno, file, line, type, 0, DIFlags::Zero)"}},{"id":"create_pointer_type(pointee,size_in_bits,align_in_bits,name)-instance-method","html_id":"create_pointer_type(pointee,size_in_bits,align_in_bits,name)-instance-method","name":"create_pointer_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointee","doc":null,"default_value":"","external_name":"pointee","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(pointee, size_in_bits, align_in_bits, name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L77","def":{"name":"create_pointer_type","args":[{"name":"pointee","doc":null,"default_value":"","external_name":"pointee","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_pointer_type(self, pointee, size_in_bits, align_in_bits, name)"}},{"id":"create_replaceable_composite_type(scope,name,file,line,context:Context)-instance-method","html_id":"create_replaceable_composite_type(scope,name,file,line,context:Context)-instance-method","name":"create_replaceable_composite_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(scope, name, file, line, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L81","def":{"name":"create_replaceable_composite_type","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_replaceable_composite_type(self, scope, name, file, line)"}},{"id":"create_struct_type(scope,name,file,line,size_in_bits,align_in_bits,flags,derived_from,element_types)-instance-method","html_id":"create_struct_type(scope,name,file,line,size_in_bits,align_in_bits,flags,derived_from,element_types)-instance-method","name":"create_struct_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"derived_from","doc":null,"default_value":"","external_name":"derived_from","restriction":""},{"name":"element_types","doc":null,"default_value":"","external_name":"element_types","restriction":""}],"args_string":"(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L67","def":{"name":"create_struct_type","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"size_in_bits","doc":null,"default_value":"","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","doc":null,"default_value":"","external_name":"align_in_bits","restriction":""},{"name":"flags","doc":null,"default_value":"","external_name":"flags","restriction":""},{"name":"derived_from","doc":null,"default_value":"","external_name":"derived_from","restriction":""},{"name":"element_types","doc":null,"default_value":"","external_name":"element_types","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_struct_type(self, scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)"}},{"id":"create_subroutine_type(file,parameter_types)-instance-method","html_id":"create_subroutine_type(file,parameter_types)-instance-method","name":"create_subroutine_type","doc":null,"summary":null,"abstract":false,"args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"parameter_types","doc":null,"default_value":"","external_name":"parameter_types","restriction":""}],"args_string":"(file, parameter_types)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L20","def":{"name":"create_subroutine_type","args":[{"name":"file","doc":null,"default_value":"","external_name":"file","restriction":""},{"name":"parameter_types","doc":null,"default_value":"","external_name":"parameter_types","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_create_subroutine_type(self, file, parameter_types)"}},{"id":"end-instance-method","html_id":"end-instance-method","name":"end","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L89","def":{"name":"end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_finalize(self)"}},{"id":"get_or_create_array(elements:Array(LibLLVMExt::Metadata))-instance-method","html_id":"get_or_create_array(elements:Array(LibLLVMExt::Metadata))-instance-method","name":"get_or_create_array","doc":null,"summary":null,"abstract":false,"args":[{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":"Array(LibLLVMExt::Metadata)"}],"args_string":"(elements : Array(LibLLVMExt::Metadata))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L54","def":{"name":"get_or_create_array","args":[{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":"Array(LibLLVMExt::Metadata)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_get_or_create_array(self, elements, elements.size)"}},{"id":"get_or_create_type_array(types:Array(LibLLVMExt::Metadata))-instance-method","html_id":"get_or_create_type_array(types:Array(LibLLVMExt::Metadata))-instance-method","name":"get_or_create_type_array","doc":null,"summary":null,"abstract":false,"args":[{"name":"types","doc":null,"default_value":"","external_name":"types","restriction":"Array(LibLLVMExt::Metadata)"}],"args_string":"(types : Array(LibLLVMExt::Metadata))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L16","def":{"name":"get_or_create_type_array","args":[{"name":"types","doc":null,"default_value":"","external_name":"types","restriction":"Array(LibLLVMExt::Metadata)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_get_or_create_type_array(self, types, types.size)"}},{"id":"insert_declare_at_end(storage,var_info,expr,dl,block)-instance-method","html_id":"insert_declare_at_end(storage,var_info,expr,dl,block)-instance-method","name":"insert_declare_at_end","doc":null,"summary":null,"abstract":false,"args":[{"name":"storage","doc":null,"default_value":"","external_name":"storage","restriction":""},{"name":"var_info","doc":null,"default_value":"","external_name":"var_info","restriction":""},{"name":"expr","doc":null,"default_value":"","external_name":"expr","restriction":""},{"name":"dl","doc":null,"default_value":"","external_name":"dl","restriction":""},{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"args_string":"(storage, var_info, expr, dl, block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L50","def":{"name":"insert_declare_at_end","args":[{"name":"storage","doc":null,"default_value":"","external_name":"storage","restriction":""},{"name":"var_info","doc":null,"default_value":"","external_name":"var_info","restriction":""},{"name":"expr","doc":null,"default_value":"","external_name":"expr","restriction":""},{"name":"dl","doc":null,"default_value":"","external_name":"dl","restriction":""},{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_insert_declare_at_end(self, storage, var_info, expr, dl, block)"}},{"id":"replace_temporary(from,to)-instance-method","html_id":"replace_temporary(from,to)-instance-method","name":"replace_temporary","doc":null,"summary":null,"abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":""},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(from, to)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L85","def":{"name":"replace_temporary","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":""},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.di_builder_replace_temporary(self, from, to)"}},{"id":"to_unsafe:LibLLVMExt::DIBuilder-instance-method","html_id":"to_unsafe:LibLLVMExt::DIBuilder-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVMExt::DIBuilder","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/di_builder.cr#L93","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/DIFlags","path":"LLVM/DIFlags.html","kind":"enum","full_name":"LLVM::DIFlags","name":"DIFlags","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":347,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Zero","name":"Zero","value":"0_u32","doc":null,"summary":null},{"id":"Private","name":"Private","value":"1_u32","doc":null,"summary":null},{"id":"Protected","name":"Protected","value":"2_u32","doc":null,"summary":null},{"id":"Public","name":"Public","value":"3_u32","doc":null,"summary":null},{"id":"FwdDecl","name":"FwdDecl","value":"4_u32","doc":null,"summary":null},{"id":"AppleBlock","name":"AppleBlock","value":"8_u32","doc":null,"summary":null},{"id":"BlockByrefStruct","name":"BlockByrefStruct","value":"16_u32","doc":null,"summary":null},{"id":"Virtual","name":"Virtual","value":"32_u32","doc":null,"summary":null},{"id":"Artificial","name":"Artificial","value":"64_u32","doc":null,"summary":null},{"id":"Explicit","name":"Explicit","value":"128_u32","doc":null,"summary":null},{"id":"Prototyped","name":"Prototyped","value":"256_u32","doc":null,"summary":null},{"id":"ObjcClassComplete","name":"ObjcClassComplete","value":"512_u32","doc":null,"summary":null},{"id":"ObjectPointer","name":"ObjectPointer","value":"1024_u32","doc":null,"summary":null},{"id":"Vector","name":"Vector","value":"2048_u32","doc":null,"summary":null},{"id":"StaticMember","name":"StaticMember","value":"4096_u32","doc":null,"summary":null},{"id":"LValueReference","name":"LValueReference","value":"8192_u32","doc":null,"summary":null},{"id":"RValueReference","name":"RValueReference","value":"16384_u32","doc":null,"summary":null},{"id":"ExternalTypeRef","name":"ExternalTypeRef","value":"32768_u32","doc":null,"summary":null},{"id":"SingleInheritance","name":"SingleInheritance","value":"65536_u32","doc":null,"summary":null},{"id":"MultipleInheritance","name":"MultipleInheritance","value":"131072_u32","doc":null,"summary":null},{"id":"VirtualInheritance","name":"VirtualInheritance","value":"196608_u32","doc":null,"summary":null},{"id":"IntroducedVirtual","name":"IntroducedVirtual","value":"262144_u32","doc":null,"summary":null},{"id":"BitField","name":"BitField","value":"524288_u32","doc":null,"summary":null},{"id":"NoReturn","name":"NoReturn","value":"1048576_u32","doc":null,"summary":null},{"id":"MainSubprogram","name":"MainSubprogram","value":"2097152_u32","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"apple_block?-instance-method","html_id":"apple_block?-instance-method","name":"apple_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L353","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L353","def":{"name":"apple_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AppleBlock"}},{"id":"artificial?-instance-method","html_id":"artificial?-instance-method","name":"artificial?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L356","def":{"name":"artificial?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Artificial"}},{"id":"bit_field?-instance-method","html_id":"bit_field?-instance-method","name":"bit_field?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L370","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L370","def":{"name":"bit_field?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BitField"}},{"id":"block_byref_struct?-instance-method","html_id":"block_byref_struct?-instance-method","name":"block_byref_struct?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L354","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L354","def":{"name":"block_byref_struct?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BlockByrefStruct"}},{"id":"explicit?-instance-method","html_id":"explicit?-instance-method","name":"explicit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L357","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L357","def":{"name":"explicit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Explicit"}},{"id":"external_type_ref?-instance-method","html_id":"external_type_ref?-instance-method","name":"external_type_ref?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L365","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L365","def":{"name":"external_type_ref?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ExternalTypeRef"}},{"id":"fwd_decl?-instance-method","html_id":"fwd_decl?-instance-method","name":"fwd_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L352","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L352","def":{"name":"fwd_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FwdDecl"}},{"id":"introduced_virtual?-instance-method","html_id":"introduced_virtual?-instance-method","name":"introduced_virtual?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L369","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L369","def":{"name":"introduced_virtual?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IntroducedVirtual"}},{"id":"l_value_reference?-instance-method","html_id":"l_value_reference?-instance-method","name":"l_value_reference?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L363","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L363","def":{"name":"l_value_reference?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LValueReference"}},{"id":"main_subprogram?-instance-method","html_id":"main_subprogram?-instance-method","name":"main_subprogram?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L372","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L372","def":{"name":"main_subprogram?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MainSubprogram"}},{"id":"multiple_inheritance?-instance-method","html_id":"multiple_inheritance?-instance-method","name":"multiple_inheritance?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L367","def":{"name":"multiple_inheritance?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MultipleInheritance"}},{"id":"no_return?-instance-method","html_id":"no_return?-instance-method","name":"no_return?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L371","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L371","def":{"name":"no_return?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NoReturn"}},{"id":"objc_class_complete?-instance-method","html_id":"objc_class_complete?-instance-method","name":"objc_class_complete?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L359","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L359","def":{"name":"objc_class_complete?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ObjcClassComplete"}},{"id":"object_pointer?-instance-method","html_id":"object_pointer?-instance-method","name":"object_pointer?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L360","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L360","def":{"name":"object_pointer?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ObjectPointer"}},{"id":"private?-instance-method","html_id":"private?-instance-method","name":"private?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L349","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L349","def":{"name":"private?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Private"}},{"id":"protected?-instance-method","html_id":"protected?-instance-method","name":"protected?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L350","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L350","def":{"name":"protected?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Protected"}},{"id":"prototyped?-instance-method","html_id":"prototyped?-instance-method","name":"prototyped?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L358","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L358","def":{"name":"prototyped?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Prototyped"}},{"id":"public?-instance-method","html_id":"public?-instance-method","name":"public?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L351","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L351","def":{"name":"public?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Public"}},{"id":"r_value_reference?-instance-method","html_id":"r_value_reference?-instance-method","name":"r_value_reference?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L364","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L364","def":{"name":"r_value_reference?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RValueReference"}},{"id":"single_inheritance?-instance-method","html_id":"single_inheritance?-instance-method","name":"single_inheritance?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L366","def":{"name":"single_inheritance?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SingleInheritance"}},{"id":"static_member?-instance-method","html_id":"static_member?-instance-method","name":"static_member?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L362","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L362","def":{"name":"static_member?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == StaticMember"}},{"id":"vector?-instance-method","html_id":"vector?-instance-method","name":"vector?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L361","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L361","def":{"name":"vector?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Vector"}},{"id":"virtual?-instance-method","html_id":"virtual?-instance-method","name":"virtual?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L355","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L355","def":{"name":"virtual?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Virtual"}},{"id":"virtual_inheritance?-instance-method","html_id":"virtual_inheritance?-instance-method","name":"virtual_inheritance?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L368","def":{"name":"virtual_inheritance?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == VirtualInheritance"}},{"id":"zero?-instance-method","html_id":"zero?-instance-method","name":"zero?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L348","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L348","def":{"name":"zero?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Zero"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/DwarfTag","path":"LLVM/DwarfTag.html","kind":"enum","full_name":"LLVM::DwarfTag","name":"DwarfTag","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":298,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"AutoVariable","name":"AutoVariable","value":"256","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"auto_variable?-instance-method","html_id":"auto_variable?-instance-method","name":"auto_variable?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L299","def":{"name":"auto_variable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AutoVariable"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/DwarfTypeEncoding","path":"LLVM/DwarfTypeEncoding.html","kind":"enum","full_name":"LLVM::DwarfTypeEncoding","name":"DwarfTypeEncoding","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":302,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Address","name":"Address","value":"1","doc":null,"summary":null},{"id":"Boolean","name":"Boolean","value":"2","doc":null,"summary":null},{"id":"ComplexFloat","name":"ComplexFloat","value":"3","doc":null,"summary":null},{"id":"Float","name":"Float","value":"4","doc":null,"summary":null},{"id":"Signed","name":"Signed","value":"5","doc":null,"summary":null},{"id":"SignedChar","name":"SignedChar","value":"6","doc":null,"summary":null},{"id":"Unsigned","name":"Unsigned","value":"7","doc":null,"summary":null},{"id":"UnsignedChar","name":"UnsignedChar","value":"8","doc":null,"summary":null},{"id":"ImaginaryFloat","name":"ImaginaryFloat","value":"9","doc":null,"summary":null},{"id":"PackedDecimal","name":"PackedDecimal","value":"10","doc":null,"summary":null},{"id":"NumericString","name":"NumericString","value":"11","doc":null,"summary":null},{"id":"Edited","name":"Edited","value":"12","doc":null,"summary":null},{"id":"SignedFixed","name":"SignedFixed","value":"13","doc":null,"summary":null},{"id":"UnsignedFixed","name":"UnsignedFixed","value":"14","doc":null,"summary":null},{"id":"DecimalFloat","name":"DecimalFloat","value":"15","doc":null,"summary":null},{"id":"Utf","name":"Utf","value":"16","doc":null,"summary":null},{"id":"LoUser","name":"LoUser","value":"128","doc":null,"summary":null},{"id":"HiUser","name":"HiUser","value":"255","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"address?-instance-method","html_id":"address?-instance-method","name":"address?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L303","def":{"name":"address?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Address"}},{"id":"boolean?-instance-method","html_id":"boolean?-instance-method","name":"boolean?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L304","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L304","def":{"name":"boolean?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Boolean"}},{"id":"complex_float?-instance-method","html_id":"complex_float?-instance-method","name":"complex_float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L305","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L305","def":{"name":"complex_float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ComplexFloat"}},{"id":"decimal_float?-instance-method","html_id":"decimal_float?-instance-method","name":"decimal_float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L317","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L317","def":{"name":"decimal_float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DecimalFloat"}},{"id":"edited?-instance-method","html_id":"edited?-instance-method","name":"edited?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L314","def":{"name":"edited?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Edited"}},{"id":"float?-instance-method","html_id":"float?-instance-method","name":"float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L306","def":{"name":"float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Float"}},{"id":"hi_user?-instance-method","html_id":"hi_user?-instance-method","name":"hi_user?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L320","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L320","def":{"name":"hi_user?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HiUser"}},{"id":"imaginary_float?-instance-method","html_id":"imaginary_float?-instance-method","name":"imaginary_float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L311","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L311","def":{"name":"imaginary_float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ImaginaryFloat"}},{"id":"lo_user?-instance-method","html_id":"lo_user?-instance-method","name":"lo_user?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L319","def":{"name":"lo_user?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LoUser"}},{"id":"numeric_string?-instance-method","html_id":"numeric_string?-instance-method","name":"numeric_string?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L313","def":{"name":"numeric_string?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NumericString"}},{"id":"packed_decimal?-instance-method","html_id":"packed_decimal?-instance-method","name":"packed_decimal?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L312","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L312","def":{"name":"packed_decimal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PackedDecimal"}},{"id":"signed?-instance-method","html_id":"signed?-instance-method","name":"signed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L307","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L307","def":{"name":"signed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Signed"}},{"id":"signed_char?-instance-method","html_id":"signed_char?-instance-method","name":"signed_char?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L308","def":{"name":"signed_char?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SignedChar"}},{"id":"signed_fixed?-instance-method","html_id":"signed_fixed?-instance-method","name":"signed_fixed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L315","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L315","def":{"name":"signed_fixed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SignedFixed"}},{"id":"unsigned?-instance-method","html_id":"unsigned?-instance-method","name":"unsigned?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L309","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L309","def":{"name":"unsigned?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Unsigned"}},{"id":"unsigned_char?-instance-method","html_id":"unsigned_char?-instance-method","name":"unsigned_char?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L310","def":{"name":"unsigned_char?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UnsignedChar"}},{"id":"unsigned_fixed?-instance-method","html_id":"unsigned_fixed?-instance-method","name":"unsigned_fixed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L316","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L316","def":{"name":"unsigned_fixed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UnsignedFixed"}},{"id":"utf?-instance-method","html_id":"utf?-instance-method","name":"utf?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L318","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L318","def":{"name":"utf?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Utf"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Function","path":"LLVM/Function.html","kind":"struct","full_name":"LLVM::Function","name":"Function","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/function.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"add_attribute(attribute:Attribute,index=AttributeIndex::FunctionIndex)-instance-method","html_id":"add_attribute(attribute:Attribute,index=AttributeIndex::FunctionIndex)-instance-method","name":"add_attribute","doc":null,"summary":null,"abstract":false,"args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"Attribute"},{"name":"index","doc":null,"default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"args_string":"(attribute : Attribute, index = <span class=\"t\">AttributeIndex</span><span class=\"t\">::</span><span class=\"t\">FunctionIndex</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L18","def":{"name":"add_attribute","args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"Attribute"},{"name":"index","doc":null,"default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if attribute.value == 0\n  return\nend\n{% if LibLLVM.has_constant?(:AttributeRef) %}\n      context = LibLLVM.get_module_context(LibLLVM.get_global_parent(self))\n      attribute.each_kind do |kind|\n        attribute_ref = LibLLVM.create_enum_attribute(context, kind, 0)\n        LibLLVM.add_attribute_at_index(self, index, attribute_ref)\n      end\n    {% else %}\n      case index\n      when AttributeIndex::FunctionIndex\n        LibLLVM.add_function_attr(self, attribute)\n      when AttributeIndex::ReturnIndex\n        raise \"Unsupported: can't set attributes on function return type in LLVM < 3.9\"\n      else\n        LibLLVM.add_attribute(params[index.to_i - 1], attribute)\n      end\n    {% end %}\n"}},{"id":"add_target_dependent_attribute(name,value)-instance-method","html_id":"add_target_dependent_attribute(name,value)-instance-method","name":"add_target_dependent_attribute","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L38","def":{"name":"add_target_dependent_attribute","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.add_target_dependent_function_attr(self, name, value)"}},{"id":"attributes(index=AttributeIndex::FunctionIndex)-instance-method","html_id":"attributes(index=AttributeIndex::FunctionIndex)-instance-method","name":"attributes","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"args_string":"(index = <span class=\"t\">AttributeIndex</span><span class=\"t\">::</span><span class=\"t\">FunctionIndex</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L42","def":{"name":"attributes","args":[{"name":"index","doc":null,"default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if LibLLVM.has_constant?(:AttributeRef) %}\n      attrs = Attribute::None\n      0.upto(LibLLVM.get_last_enum_attribute_kind) do |kind|\n        if LibLLVM.get_enum_attribute_at_index(self, index, kind)\n          attrs |= Attribute.from_kind(kind)\n        end\n      end\n      attrs\n    {% else %}\n      case index\n      when AttributeIndex::FunctionIndex\n        LibLLVM.get_function_attr(self)\n      when AttributeIndex::ReturnIndex\n        raise \"Unsupported: can't get attributes from function return type in LLVM < 3.9\"\n      else\n        LibLLVM.get_attribute(params[index.to_i - 1])\n      end\n    {% end %}"}},{"id":"basic_blocks-instance-method","html_id":"basic_blocks-instance-method","name":"basic_blocks","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L6","def":{"name":"basic_blocks","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BasicBlockCollection.new(self)"}},{"id":"call_convention-instance-method","html_id":"call_convention-instance-method","name":"call_convention","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L10","def":{"name":"call_convention","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::CallConvention.new(LibLLVM.get_function_call_convention(self))"}},{"id":"call_convention=(cc)-instance-method","html_id":"call_convention=(cc)-instance-method","name":"call_convention=","doc":null,"summary":null,"abstract":false,"args":[{"name":"cc","doc":null,"default_value":"","external_name":"cc","restriction":""}],"args_string":"(cc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L14","def":{"name":"call_convention=","args":[{"name":"cc","doc":null,"default_value":"","external_name":"cc","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_function_call_convention(self, cc)"}},{"id":"function_type-instance-method","html_id":"function_type-instance-method","name":"function_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L63","def":{"name":"function_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Type.new(LibLLVM.get_element_type(LibLLVM.type_of(self)))"}},{"id":"params-instance-method","html_id":"params-instance-method","name":"params","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L75","def":{"name":"params","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ParameterCollection.new(self)"}},{"id":"return_type-instance-method","html_id":"return_type-instance-method","name":"return_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L67","def":{"name":"return_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"function_type.return_type"}},{"id":"varargs?-instance-method","html_id":"varargs?-instance-method","name":"varargs?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function.cr#L71","def":{"name":"varargs?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"function_type.varargs?"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionCollection","path":"LLVM/FunctionCollection.html","kind":"struct","full_name":"LLVM::FunctionCollection","name":"FunctionCollection","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/function_collection.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(mod:Module)-class-method","html_id":"new(mod:Module)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L2","def":{"name":"new","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"[](name)-instance-method","html_id":"[](name)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L19","def":{"name":"[]","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"func = self[name]?\nfunc || (raise(\"Undefined llvm function: #{name}\"))\n"}},{"id":"[]?(name)-instance-method","html_id":"[]?(name)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L24","def":{"name":"[]?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"func = LibLLVM.get_named_function(@mod, name)\nfunc ? Function.new(func) : nil\n"}},{"id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false)-instance-method","html_id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","doc":null,"default_value":"","external_name":"ret_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(name, arg_types : Array(LLVM::Type), ret_type, varargs = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L5","def":{"name":"add","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","doc":null,"default_value":"","external_name":"ret_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fun_type = LLVM::Type.function(arg_types, ret_type, varargs)\nfunc = LibLLVM.add_function(@mod, name, fun_type)\nFunction.new(func)\n"}},{"id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false,&block)-instance-method","html_id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false,&amp;block)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","doc":null,"default_value":"","external_name":"ret_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(name, arg_types : Array(LLVM::Type), ret_type, varargs = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L13","def":{"name":"add","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","doc":null,"default_value":"","external_name":"ret_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"func = add(name, arg_types, ret_type, varargs)\nyield func\nfunc\n"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_collection.cr#L29","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"f = LibLLVM.get_first_function(@mod)\nwhile f\n  yield LLVM::Function.new(f)\n  f = LibLLVM.get_next_function(f)\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionPassManager","path":"LLVM/FunctionPassManager.html","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/function_pass_manager.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::PassManagerRef)-class-method","html_id":"new(unwrap:LibLLVM::PassManagerRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::PassManagerRef"}],"args_string":"(unwrap : LibLLVM::PassManagerRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::PassManagerRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L30","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dispose_pass_manager(@unwrap)"}},{"id":"run(mod:Module)-instance-method","html_id":"run(mod:Module)-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L5","def":{"name":"run","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"changed = false\nrun do |runner|\n  mod.functions.each do |func|\n    changed || (changed = runner.run(func))\n  end\nend\nchanged\n"}},{"id":"run(&block)-instance-method","html_id":"run(&amp;block)-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L15","def":{"name":"run","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_function_pass_manager(self)\nrunner = Runner.new(self)\nyield runner\nLibLLVM.finalize_function_pass_manager(self)\nself\n"}},{"id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","html_id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::PassManagerRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L26","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionPassManager/Runner","path":"LLVM/FunctionPassManager/Runner.html","kind":"struct","full_name":"LLVM::FunctionPassManager::Runner","name":"Runner","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/function_pass_manager.cr","line_number":34,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionPassManager","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(fpm)-class-method","html_id":"new(fpm)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"fpm","doc":null,"default_value":"","external_name":"fpm","restriction":""}],"args_string":"(fpm)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L37","def":{"name":"new","args":[{"name":"fpm","doc":null,"default_value":"","external_name":"fpm","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(fpm)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"run(f:LLVM::Function)-instance-method","html_id":"run(f:LLVM::Function)-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[{"name":"f","doc":null,"default_value":"","external_name":"f","restriction":"LLVM::Function"}],"args_string":"(f : LLVM::Function)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/function_pass_manager.cr#L40","def":{"name":"run","args":[{"name":"f","doc":null,"default_value":"","external_name":"f","restriction":"LLVM::Function"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibLLVM.run_function_pass_manager(@fpm, f)) != 0"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/LLVM/GenericValue","path":"LLVM/GenericValue.html","kind":"class","full_name":"LLVM::GenericValue","name":"GenericValue","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/generic_value.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::GenericValueRef,context:LLVM::Context)-class-method","html_id":"new(unwrap:LibLLVM::GenericValueRef,context:LLVM::Context)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::GenericValueRef"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"LLVM::Context"}],"args_string":"(unwrap : LibLLVM::GenericValueRef, context : LLVM::Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::GenericValueRef"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"LLVM::Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, context)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L37","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dispose_generic_value(@unwrap)"}},{"id":"to_b-instance-method","html_id":"to_b-instance-method","name":"to_b","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L13","def":{"name":"to_b","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i != 0"}},{"id":"to_f32-instance-method","html_id":"to_f32-instance-method","name":"to_f32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L17","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.generic_value_to_float(@context.float, self)"}},{"id":"to_f64-instance-method","html_id":"to_f64-instance-method","name":"to_f64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L21","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.generic_value_to_float(@context.double, self)"}},{"id":"to_i-instance-method","html_id":"to_i-instance-method","name":"to_i","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L5","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.generic_value_to_int(self, 1)"}},{"id":"to_pointer-instance-method","html_id":"to_pointer-instance-method","name":"to_pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L29","def":{"name":"to_pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.generic_value_to_pointer(self)"}},{"id":"to_string-instance-method","html_id":"to_string-instance-method","name":"to_string","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L25","def":{"name":"to_string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_pointer.as(String)"}},{"id":"to_u64-instance-method","html_id":"to_u64-instance-method","name":"to_u64","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L9","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i"}},{"id":"to_unsafe:LibLLVM::GenericValueRef-instance-method","html_id":"to_unsafe:LibLLVM::GenericValueRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::GenericValueRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/generic_value.cr#L33","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/GlobalCollection","path":"LLVM/GlobalCollection.html","kind":"struct","full_name":"LLVM::GlobalCollection","name":"GlobalCollection","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/global_collection.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(mod:Module)-class-method","html_id":"new(mod:Module)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L2","def":{"name":"new","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":"Module"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"[](name)-instance-method","html_id":"[](name)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L16","def":{"name":"[]","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"global = self[name]?\nif global\n  global\nelse\n  raise(\"Global not found: #{name}\")\nend\n"}},{"id":"[]?(name)-instance-method","html_id":"[]?(name)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L11","def":{"name":"[]?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"global = LibLLVM.get_named_global(@mod, name)\nglobal ? Value.new(global) : nil\n"}},{"id":"add(type,name)-instance-method","html_id":"add(type,name)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(type, name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/global_collection.cr#L5","def":{"name":"add","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.add_global(@mod, type, name))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/InstructionCollection","path":"LLVM/InstructionCollection.html","kind":"struct","full_name":"LLVM::InstructionCollection","name":"InstructionCollection","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/instruction_collection.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(basic_block:BasicBlock)-class-method","html_id":"new(basic_block:BasicBlock)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":"BasicBlock"}],"args_string":"(basic_block : BasicBlock)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L2","def":{"name":"new","args":[{"name":"basic_block","doc":null,"default_value":"","external_name":"basic_block","restriction":"BasicBlock"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(basic_block)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L5","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"llvm_first.null?"}},{"id":"first-instance-method","html_id":"first-instance-method","name":"first","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L14","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"first?.not_nil!"}},{"id":"first?-instance-method","html_id":"first?-instance-method","name":"first?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/instruction_collection.cr#L9","def":{"name":"first?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value = llvm_first\nvalue ? Value.new(value) : nil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/IntPredicate","path":"LLVM/IntPredicate.html","kind":"enum","full_name":"LLVM::IntPredicate","name":"IntPredicate","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":201,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"EQ","name":"EQ","value":"32","doc":null,"summary":null},{"id":"NE","name":"NE","value":"33","doc":null,"summary":null},{"id":"UGT","name":"UGT","value":"34","doc":null,"summary":null},{"id":"UGE","name":"UGE","value":"35","doc":null,"summary":null},{"id":"ULT","name":"ULT","value":"36","doc":null,"summary":null},{"id":"ULE","name":"ULE","value":"37","doc":null,"summary":null},{"id":"SGT","name":"SGT","value":"38","doc":null,"summary":null},{"id":"SGE","name":"SGE","value":"39","doc":null,"summary":null},{"id":"SLT","name":"SLT","value":"40","doc":null,"summary":null},{"id":"SLE","name":"SLE","value":"41","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"eq?-instance-method","html_id":"eq?-instance-method","name":"eq?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L202","def":{"name":"eq?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == EQ"}},{"id":"ne?-instance-method","html_id":"ne?-instance-method","name":"ne?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L203","def":{"name":"ne?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NE"}},{"id":"sge?-instance-method","html_id":"sge?-instance-method","name":"sge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L209","def":{"name":"sge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SGE"}},{"id":"sgt?-instance-method","html_id":"sgt?-instance-method","name":"sgt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L208","def":{"name":"sgt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SGT"}},{"id":"sle?-instance-method","html_id":"sle?-instance-method","name":"sle?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L211","def":{"name":"sle?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SLE"}},{"id":"slt?-instance-method","html_id":"slt?-instance-method","name":"slt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L210","def":{"name":"slt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SLT"}},{"id":"uge?-instance-method","html_id":"uge?-instance-method","name":"uge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L205","def":{"name":"uge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UGE"}},{"id":"ugt?-instance-method","html_id":"ugt?-instance-method","name":"ugt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L204","def":{"name":"ugt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UGT"}},{"id":"ule?-instance-method","html_id":"ule?-instance-method","name":"ule?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L207","def":{"name":"ule?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ULE"}},{"id":"ult?-instance-method","html_id":"ult?-instance-method","name":"ult?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L206","def":{"name":"ult?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ULT"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/JITCompiler","path":"LLVM/JITCompiler.html","kind":"class","full_name":"LLVM::JITCompiler","name":"JITCompiler","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/jit_compiler.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(mod)-class-method","html_id":"new(mod)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"args_string":"(mod)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L2","def":{"name":"new","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(mod,&block)-class-method","html_id":"new(mod,&amp;block)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"args_string":"(mod, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L15","def":{"name":"new","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"jit = new(mod)\nbegin\n  yield jit\nensure\n  jit.dispose\nend\n"}}],"instance_methods":[{"id":"dispose-instance-method","html_id":"dispose-instance-method","name":"dispose","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L38","def":{"name":"dispose","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @finalized\n  return\nend\n@finalized = true\nfinalize\n"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L44","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @finalized\n  return\nend\nLibLLVM.dispose_execution_engine(@unwrap)\n"}},{"id":"get_pointer_to_global(value)-instance-method","html_id":"get_pointer_to_global(value)-instance-method","name":"get_pointer_to_global","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L30","def":{"name":"get_pointer_to_global","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.get_pointer_to_global(self, value)"}},{"id":"run_function(func,args:Array(LLVM::GenericValue),context:Context)-instance-method","html_id":"run_function(func,args:Array(LLVM::GenericValue),context:Context)-instance-method","name":"run_function","doc":null,"summary":null,"abstract":false,"args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::GenericValue)"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(func, args : Array(LLVM::GenericValue), context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L25","def":{"name":"run_function","args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"Array(LLVM::GenericValue)"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibLLVM.run_function(self, func, args.size, (args.to_unsafe.as(::Pointer(LibLLVM::GenericValueRef))))\nGenericValue.new(ret, context)\n"}},{"id":"run_function(func,context:Context)-instance-method","html_id":"run_function(func,context:Context)-instance-method","name":"run_function","doc":null,"summary":null,"abstract":false,"args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(func, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L20","def":{"name":"run_function","args":[{"name":"func","doc":null,"default_value":"","external_name":"func","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibLLVM.run_function(self, func, 0, nil)\nGenericValue.new(ret, context)\n"}},{"id":"to_unsafe:LibLLVM::ExecutionEngineRef-instance-method","html_id":"to_unsafe:LibLLVM::ExecutionEngineRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::ExecutionEngineRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/jit_compiler.cr#L34","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Linkage","path":"LLVM/Linkage.html","kind":"enum","full_name":"LLVM::Linkage","name":"Linkage","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":181,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"External","name":"External","value":"0","doc":null,"summary":null},{"id":"AvailableExternally","name":"AvailableExternally","value":"1","doc":null,"summary":null},{"id":"LinkOnceAny","name":"LinkOnceAny","value":"2","doc":null,"summary":null},{"id":"LinkOnceODR","name":"LinkOnceODR","value":"3","doc":null,"summary":null},{"id":"LinkOnceODRAutoHide","name":"LinkOnceODRAutoHide","value":"4","doc":null,"summary":null},{"id":"WeakAny","name":"WeakAny","value":"5","doc":null,"summary":null},{"id":"WeakODR","name":"WeakODR","value":"6","doc":null,"summary":null},{"id":"Appending","name":"Appending","value":"7","doc":null,"summary":null},{"id":"Internal","name":"Internal","value":"8","doc":null,"summary":null},{"id":"Private","name":"Private","value":"9","doc":null,"summary":null},{"id":"DLLImport","name":"DLLImport","value":"10","doc":null,"summary":null},{"id":"DLLExport","name":"DLLExport","value":"11","doc":null,"summary":null},{"id":"ExternalWeak","name":"ExternalWeak","value":"12","doc":null,"summary":null},{"id":"Ghost","name":"Ghost","value":"13","doc":null,"summary":null},{"id":"Common","name":"Common","value":"14","doc":null,"summary":null},{"id":"LinkerPrivate","name":"LinkerPrivate","value":"15","doc":null,"summary":null},{"id":"LinkerPrivateWeak","name":"LinkerPrivateWeak","value":"16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"appending?-instance-method","html_id":"appending?-instance-method","name":"appending?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L189","def":{"name":"appending?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Appending"}},{"id":"available_externally?-instance-method","html_id":"available_externally?-instance-method","name":"available_externally?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L183","def":{"name":"available_externally?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AvailableExternally"}},{"id":"common?-instance-method","html_id":"common?-instance-method","name":"common?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L196","def":{"name":"common?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Common"}},{"id":"dll_export?-instance-method","html_id":"dll_export?-instance-method","name":"dll_export?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L193","def":{"name":"dll_export?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DLLExport"}},{"id":"dll_import?-instance-method","html_id":"dll_import?-instance-method","name":"dll_import?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L192","def":{"name":"dll_import?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DLLImport"}},{"id":"external?-instance-method","html_id":"external?-instance-method","name":"external?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L182","def":{"name":"external?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == External"}},{"id":"external_weak?-instance-method","html_id":"external_weak?-instance-method","name":"external_weak?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L194","def":{"name":"external_weak?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ExternalWeak"}},{"id":"ghost?-instance-method","html_id":"ghost?-instance-method","name":"ghost?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L195","def":{"name":"ghost?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Ghost"}},{"id":"internal?-instance-method","html_id":"internal?-instance-method","name":"internal?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L190","def":{"name":"internal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Internal"}},{"id":"link_once_any?-instance-method","html_id":"link_once_any?-instance-method","name":"link_once_any?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L184","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L184","def":{"name":"link_once_any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LinkOnceAny"}},{"id":"link_once_odr?-instance-method","html_id":"link_once_odr?-instance-method","name":"link_once_odr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L185","def":{"name":"link_once_odr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LinkOnceODR"}},{"id":"link_once_odr_auto_hide?-instance-method","html_id":"link_once_odr_auto_hide?-instance-method","name":"link_once_odr_auto_hide?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L186","def":{"name":"link_once_odr_auto_hide?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LinkOnceODRAutoHide"}},{"id":"linker_private?-instance-method","html_id":"linker_private?-instance-method","name":"linker_private?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L197","def":{"name":"linker_private?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LinkerPrivate"}},{"id":"linker_private_weak?-instance-method","html_id":"linker_private_weak?-instance-method","name":"linker_private_weak?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L198","def":{"name":"linker_private_weak?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LinkerPrivateWeak"}},{"id":"private?-instance-method","html_id":"private?-instance-method","name":"private?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L191","def":{"name":"private?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Private"}},{"id":"weak_any?-instance-method","html_id":"weak_any?-instance-method","name":"weak_any?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L187","def":{"name":"weak_any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WeakAny"}},{"id":"weak_odr?-instance-method","html_id":"weak_odr?-instance-method","name":"weak_odr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L188","def":{"name":"weak_odr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WeakODR"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/MemoryBuffer","path":"LLVM/MemoryBuffer.html","kind":"class","full_name":"LLVM::MemoryBuffer","name":"MemoryBuffer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/memory_buffer.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"from_file(filename:String)-class-method","html_id":"from_file(filename:String)-class-method","name":"from_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L2","def":{"name":"from_file","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibLLVM.create_memory_buffer_with_contents_of_file(filename, out mem_buf, out msg)\nif (ret != 0) && msg\n  raise(LLVM.string_and_dispose(msg))\nend\nnew(mem_buf)\n"}}],"constructors":[{"id":"new(unwrap:LibLLVM::MemoryBufferRef)-class-method","html_id":"new(unwrap:LibLLVM::MemoryBufferRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::MemoryBufferRef"}],"args_string":"(unwrap : LibLLVM::MemoryBufferRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L10","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::MemoryBufferRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"dispose-instance-method","html_id":"dispose-instance-method","name":"dispose","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L21","def":{"name":"dispose","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @finalized\n  return\nend\n@finalized = true\nfinalize\n"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L27","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @finalized\n  return\nend\nLibLLVM.dispose_memory_buffer(@unwrap)\n"}},{"id":"to_slice-instance-method","html_id":"to_slice-instance-method","name":"to_slice","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L14","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Slice.new(LibLLVM.get_buffer_start(@unwrap), LibLLVM.get_buffer_size(@unwrap))"}},{"id":"to_unsafe:LibLLVM::MemoryBufferRef-instance-method","html_id":"to_unsafe:LibLLVM::MemoryBufferRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::MemoryBufferRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/memory_buffer.cr#L33","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Module","path":"LLVM/Module.html","kind":"class","full_name":"LLVM::Module","name":"Module","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/module.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::ModuleRef,context:Context)-class-method","html_id":"new(unwrap:LibLLVM::ModuleRef,context:Context)-class-method","name":"new","doc":"LLVM >= 3.9","summary":"<p>LLVM >= 3.9</p>","abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ModuleRef"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"args_string":"(unwrap : LibLLVM::ModuleRef, context : Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ModuleRef"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, context)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L100","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap == (other.@unwrap)"}},{"id":"add_named_metadata_operand(name:String,value:Value):Nil-instance-method","html_id":"add_named_metadata_operand(name:String,value:Value):Nil-instance-method","name":"add_named_metadata_operand","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Value"}],"args_string":"(name : String, value : Value) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L96","def":{"name":"add_named_metadata_operand","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Value"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"LibLLVM.add_named_metadata_operand(self, name, value)"}},{"id":"context:Context-instance-method","html_id":"context:Context-instance-method","name":"context","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Context","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L7","def":{"name":"context","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Context","visibility":"Public","body":"@context"}},{"id":"data_layout=(data:TargetData)-instance-method","html_id":"data_layout=(data:TargetData)-instance-method","name":"data_layout=","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"TargetData"}],"args_string":"(data : TargetData)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L36","def":{"name":"data_layout=","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"TargetData"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if LibLLVM::IS_38 %}\n      LibLLVM.set_data_layout(self, data.to_data_layout_string)\n    {% else %} # LLVM >= 3.9\n      LibLLVM.set_module_data_layout(self, data)\n    {% end %}"}},{"id":"dump-instance-method","html_id":"dump-instance-method","name":"dump","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L44","def":{"name":"dump","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dump_module(self)"}},{"id":"functions-instance-method","html_id":"functions-instance-method","name":"functions","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L48","def":{"name":"functions","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"FunctionCollection.new(self)"}},{"id":"globals-instance-method","html_id":"globals-instance-method","name":"globals","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L52","def":{"name":"globals","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"GlobalCollection.new(self)"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"bytes = LibLLVM.get_module_identifier(self, out bytesize)\nString.new(Slice.new(bytes, bytesize))\n"}},{"id":"name=(name:String)-instance-method","html_id":"name=(name:String)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L9","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_module_identifier(self, name, name.bytesize)"}},{"id":"new_function_pass_manager-instance-method","html_id":"new_function_pass_manager-instance-method","name":"new_function_pass_manager","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L92","def":{"name":"new_function_pass_manager","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"FunctionPassManager.new(LibLLVM.create_function_pass_manager_for_module(self))"}},{"id":"print_to_file(filename)-instance-method","html_id":"print_to_file(filename)-instance-method","name":"print_to_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(filename)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L85","def":{"name":"print_to_file","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibLLVM.print_module_to_file(self, filename, out error_msg)) != 0\n  raise(LLVM.string_and_dispose(error_msg))\nend\nself\n"}},{"id":"take_ownership(&block)-instance-method","html_id":"take_ownership(&amp;block)-instance-method","name":"take_ownership","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L113","def":{"name":"take_ownership","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if @owned\n  yield\nelse\n  @owned = true\nend"}},{"id":"target=(target)-instance-method","html_id":"target=(target)-instance-method","name":"target=","doc":null,"summary":null,"abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":""}],"args_string":"(target)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L32","def":{"name":"target=","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_target(self, target)"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L104","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_module_to_string(self), io)\nself\n"}},{"id":"to_unsafe:LibLLVM::ModuleRef-instance-method","html_id":"to_unsafe:LibLLVM::ModuleRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::ModuleRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L109","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"verify-instance-method","html_id":"verify-instance-method","name":"verify","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L74","def":{"name":"verify","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"error = LibLLVM.verify_module(self, LLVM::VerifierFailureAction::ReturnStatusAction, out message)\nbegin\n  if error == 1\n    raise(\"Module validation failed: #{String.new(message)}\")\n  end\nensure\n  LibLLVM.dispose_message(message)\nend\n"}},{"id":"write_bitcode_to_fd(fd:Int,should_close=false,buffered=false)-instance-method","html_id":"write_bitcode_to_fd(fd:Int,should_close=false,buffered=false)-instance-method","name":"write_bitcode_to_fd","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int"},{"name":"should_close","doc":null,"default_value":"false","external_name":"should_close","restriction":""},{"name":"buffered","doc":null,"default_value":"false","external_name":"buffered","restriction":""}],"args_string":"(fd : Int, should_close = <span class=\"n\">false</span>, buffered = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L70","def":{"name":"write_bitcode_to_fd","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int"},{"name":"should_close","doc":null,"default_value":"false","external_name":"should_close","restriction":""},{"name":"buffered","doc":null,"default_value":"false","external_name":"buffered","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.write_bitcode_to_fd(self, fd, should_close ? 1 : 0, buffered ? 1 : 0)"}},{"id":"write_bitcode_to_file(filename:String)-instance-method","html_id":"write_bitcode_to_file(filename:String)-instance-method","name":"write_bitcode_to_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L56","def":{"name":"write_bitcode_to_file","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.write_bitcode_to_file(self, filename)"}},{"id":"write_bitcode_to_memory_buffer-instance-method","html_id":"write_bitcode_to_memory_buffer-instance-method","name":"write_bitcode_to_memory_buffer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L66","def":{"name":"write_bitcode_to_memory_buffer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"MemoryBuffer.new(LibLLVM.write_bitcode_to_memory_buffer(self))"}},{"id":"write_bitcode_with_summary_to_file(filename:String)-instance-method","html_id":"write_bitcode_with_summary_to_file(filename:String)-instance-method","name":"write_bitcode_with_summary_to_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module.cr#L60","def":{"name":"write_bitcode_with_summary_to_file","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.write_bitcode_with_summary_to_file(self, filename)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ModuleFlag","path":"LLVM/ModuleFlag.html","kind":"enum","full_name":"LLVM::ModuleFlag","name":"ModuleFlag","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":409,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Warning","name":"Warning","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"warning?-instance-method","html_id":"warning?-instance-method","name":"warning?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L410","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L410","def":{"name":"warning?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Warning"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ModulePassManager","path":"LLVM/ModulePassManager.html","kind":"class","full_name":"LLVM::ModulePassManager","name":"ModulePassManager","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/module_pass_manager.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L2","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L14","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dispose_pass_manager(@unwrap)"}},{"id":"run(mod)-instance-method","html_id":"run(mod)-instance-method","name":"run","doc":null,"summary":null,"abstract":false,"args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"args_string":"(mod)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L6","def":{"name":"run","args":[{"name":"mod","doc":null,"default_value":"","external_name":"mod","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibLLVM.run_pass_manager(self, mod)) != 0"}},{"id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","html_id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::PassManagerRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/module_pass_manager.cr#L10","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/OperandBundleDef","path":"LLVM/OperandBundleDef.html","kind":"struct","full_name":"LLVM::OperandBundleDef","name":"OperandBundleDef","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/operand_bundle_def.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"null-class-method","html_id":"null-class-method","name":"null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L5","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::OperandBundleDef.new(Pointer(::Void).null.as(LibLLVMExt::OperandBundleDefRef))"}}],"constructors":[{"id":"new(unwrap:LibLLVMExt::OperandBundleDefRef)-class-method","html_id":"new(unwrap:LibLLVMExt::OperandBundleDefRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVMExt::OperandBundleDefRef"}],"args_string":"(unwrap : LibLLVMExt::OperandBundleDefRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVMExt::OperandBundleDefRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"to_unsafe:LibLLVMExt::OperandBundleDefRef-instance-method","html_id":"to_unsafe:LibLLVMExt::OperandBundleDefRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVMExt::OperandBundleDefRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/operand_bundle_def.cr#L9","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ParameterCollection","path":"LLVM/ParameterCollection.html","kind":"struct","full_name":"LLVM::ParameterCollection","name":"ParameterCollection","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/parameter_collection.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(function:Function)-class-method","html_id":"new(function:Function)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"function","doc":null,"default_value":"","external_name":"function","restriction":"Function"}],"args_string":"(function : Function)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L2","def":{"name":"new","args":[{"name":"function","doc":null,"default_value":"","external_name":"function","restriction":"Function"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(function)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"[](index)-instance-method","html_id":"[](index)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L17","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"param_size = size()\nif index < 0\n  index = index + param_size\nend\nif 0 <= index && index < param_size\nelse\n  raise(IndexError.new)\nend\nValue.new(LibLLVM.get_param(@function, index))\n"}},{"id":"first-instance-method","html_id":"first-instance-method","name":"first","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L28","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == 0\n  raise(IndexError.new)\nend\nValue.new(LibLLVM.get_param(@function, 0))\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L5","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@function.function_type.params_size"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L9","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"param_size = size()\nArray(LLVM::Value).build(param_size) do |buffer|\n  LibLLVM.get_params(@function, buffer.as(::Pointer(LibLLVM::ValueRef)))\n  param_size\nend\n"}},{"id":"types-instance-method","html_id":"types-instance-method","name":"types","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/parameter_collection.cr#L34","def":{"name":"types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@function.function_type.params_types"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/PassManagerBuilder","path":"LLVM/PassManagerBuilder.html","kind":"class","full_name":"LLVM::PassManagerBuilder","name":"PassManagerBuilder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/pass_manager_builder.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L2","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"disable_simplify_lib_calls=(value)-instance-method","html_id":"disable_simplify_lib_calls=(value)-instance-method","name":"disable_simplify_lib_calls=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L18","def":{"name":"disable_simplify_lib_calls=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_set_disable_simplify_lib_calls(self, value ? 1 : 0)"}},{"id":"disable_unroll_loops=(value)-instance-method","html_id":"disable_unroll_loops=(value)-instance-method","name":"disable_unroll_loops=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L14","def":{"name":"disable_unroll_loops=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_set_disable_unroll_loops(self, value ? 1 : 0)"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L38","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dispose_pass_manager_builder(@unwrap)"}},{"id":"opt_level=(level)-instance-method","html_id":"opt_level=(level)-instance-method","name":"opt_level=","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L6","def":{"name":"opt_level=","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_set_opt_level(self, level)"}},{"id":"populate(pm:FunctionPassManager)-instance-method","html_id":"populate(pm:FunctionPassManager)-instance-method","name":"populate","doc":null,"summary":null,"abstract":false,"args":[{"name":"pm","doc":null,"default_value":"","external_name":"pm","restriction":"FunctionPassManager"}],"args_string":"(pm : FunctionPassManager)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L26","def":{"name":"populate","args":[{"name":"pm","doc":null,"default_value":"","external_name":"pm","restriction":"FunctionPassManager"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_populate_function_pass_manager(self, pm)"}},{"id":"populate(pm:ModulePassManager)-instance-method","html_id":"populate(pm:ModulePassManager)-instance-method","name":"populate","doc":null,"summary":null,"abstract":false,"args":[{"name":"pm","doc":null,"default_value":"","external_name":"pm","restriction":"ModulePassManager"}],"args_string":"(pm : ModulePassManager)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L30","def":{"name":"populate","args":[{"name":"pm","doc":null,"default_value":"","external_name":"pm","restriction":"ModulePassManager"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_populate_module_pass_manager(self, pm)"}},{"id":"size_level=(level)-instance-method","html_id":"size_level=(level)-instance-method","name":"size_level=","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L10","def":{"name":"size_level=","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_set_size_level(self, level)"}},{"id":"to_unsafe:LibLLVM::PassManagerBuilderRef-instance-method","html_id":"to_unsafe:LibLLVM::PassManagerBuilderRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::PassManagerBuilderRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L34","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"use_inliner_with_threshold=(threshold)-instance-method","html_id":"use_inliner_with_threshold=(threshold)-instance-method","name":"use_inliner_with_threshold=","doc":null,"summary":null,"abstract":false,"args":[{"name":"threshold","doc":null,"default_value":"","external_name":"threshold","restriction":""}],"args_string":"(threshold)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_manager_builder.cr#L22","def":{"name":"use_inliner_with_threshold=","args":[{"name":"threshold","doc":null,"default_value":"","external_name":"threshold","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.pass_manager_builder_use_inliner_with_threshold(self, threshold)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/PassRegistry","path":"LLVM/PassRegistry.html","kind":"struct","full_name":"LLVM::PassRegistry","name":"PassRegistry","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/pass_registry.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"Inits","name":"Inits","value":"[\"core\", \"transform_utils\", \"scalar_opts\", \"obj_c_arc_opts\", \"vectorization\", \"inst_combine\", \"ipo\", \"instrumentation\", \"analysis\", \"ipa\", \"code_gen\", \"target\"] of ::String","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"instance:self-class-method","html_id":"instance:self-class-method","name":"instance","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L2","def":{"name":"instance","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(LibLLVM.get_global_pass_registry)"}},{"id":"new(unwrap:LibLLVM::PassRegistryRef)-class-method","html_id":"new(unwrap:LibLLVM::PassRegistryRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::PassRegistryRef"}],"args_string":"(unwrap : LibLLVM::PassRegistryRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L6","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::PassRegistryRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"initialize_all-instance-method","html_id":"initialize_all-instance-method","name":"initialize_all","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L17","def":{"name":"initialize_all","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for name in Inits %}\n      initialize_{{ name.id }}\n    {% end %}"}},{"id":"initialize_analysis-instance-method","html_id":"initialize_analysis-instance-method","name":"initialize_analysis","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_analysis","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_analysis(self)"}},{"id":"initialize_code_gen-instance-method","html_id":"initialize_code_gen-instance-method","name":"initialize_code_gen","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_code_gen","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_code_gen(self)"}},{"id":"initialize_core-instance-method","html_id":"initialize_core-instance-method","name":"initialize_core","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_core","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_core(self)"}},{"id":"initialize_inst_combine-instance-method","html_id":"initialize_inst_combine-instance-method","name":"initialize_inst_combine","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_inst_combine","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_inst_combine(self)"}},{"id":"initialize_instrumentation-instance-method","html_id":"initialize_instrumentation-instance-method","name":"initialize_instrumentation","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_instrumentation","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_instrumentation(self)"}},{"id":"initialize_ipa-instance-method","html_id":"initialize_ipa-instance-method","name":"initialize_ipa","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_ipa","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_ipa(self)"}},{"id":"initialize_ipo-instance-method","html_id":"initialize_ipo-instance-method","name":"initialize_ipo","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_ipo","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_ipo(self)"}},{"id":"initialize_obj_c_arc_opts-instance-method","html_id":"initialize_obj_c_arc_opts-instance-method","name":"initialize_obj_c_arc_opts","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_obj_c_arc_opts","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_obj_c_arc_opts(self)"}},{"id":"initialize_scalar_opts-instance-method","html_id":"initialize_scalar_opts-instance-method","name":"initialize_scalar_opts","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_scalar_opts","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_scalar_opts(self)"}},{"id":"initialize_target-instance-method","html_id":"initialize_target-instance-method","name":"initialize_target","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_target","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_target(self)"}},{"id":"initialize_transform_utils-instance-method","html_id":"initialize_transform_utils-instance-method","name":"initialize_transform_utils","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_transform_utils","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_transform_utils(self)"}},{"id":"initialize_vectorization-instance-method","html_id":"initialize_vectorization-instance-method","name":"initialize_vectorization","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L11","def":{"name":"initialize_vectorization","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.initialize_vectorization(self)"}},{"id":"to_unsafe:LibLLVM::PassRegistryRef-instance-method","html_id":"to_unsafe:LibLLVM::PassRegistryRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::PassRegistryRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/pass_registry.cr#L23","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/PhiTable","path":"LLVM/PhiTable.html","kind":"struct","full_name":"LLVM::PhiTable","name":"PhiTable","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/phi_table.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L5","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add(block,value)-instance-method","html_id":"add(block,value)-instance-method","name":"add","doc":null,"summary":null,"abstract":false,"args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(block, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L10","def":{"name":"add","args":[{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@blocks << block\n@values << value.to_value\n"}},{"id":"blocks:Array(LLVM::BasicBlock)-instance-method","html_id":"blocks:Array(LLVM::BasicBlock)-instance-method","name":"blocks","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(LLVM::BasicBlock)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L2","def":{"name":"blocks","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(LLVM::BasicBlock)","visibility":"Public","body":"@blocks"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L15","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@blocks.empty?"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L19","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@blocks.size"}},{"id":"values:Array(LLVM::Value)-instance-method","html_id":"values:Array(LLVM::Value)-instance-method","name":"values","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Array(LLVM::Value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/phi_table.cr#L3","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(LLVM::Value)","visibility":"Public","body":"@values"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/RealPredicate","path":"LLVM/RealPredicate.html","kind":"enum","full_name":"LLVM::RealPredicate","name":"RealPredicate","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":214,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"PredicateFalse","name":"PredicateFalse","value":"0","doc":null,"summary":null},{"id":"OEQ","name":"OEQ","value":"1","doc":null,"summary":null},{"id":"OGT","name":"OGT","value":"2","doc":null,"summary":null},{"id":"OGE","name":"OGE","value":"3","doc":null,"summary":null},{"id":"OLT","name":"OLT","value":"4","doc":null,"summary":null},{"id":"OLE","name":"OLE","value":"5","doc":null,"summary":null},{"id":"ONE","name":"ONE","value":"6","doc":null,"summary":null},{"id":"ORD","name":"ORD","value":"7","doc":null,"summary":null},{"id":"UNO","name":"UNO","value":"8","doc":null,"summary":null},{"id":"UEQ","name":"UEQ","value":"9","doc":null,"summary":null},{"id":"UGT","name":"UGT","value":"10","doc":null,"summary":null},{"id":"UGE","name":"UGE","value":"11","doc":null,"summary":null},{"id":"ULT","name":"ULT","value":"12","doc":null,"summary":null},{"id":"ULE","name":"ULE","value":"13","doc":null,"summary":null},{"id":"UNE","name":"UNE","value":"14","doc":null,"summary":null},{"id":"PredicateTrue","name":"PredicateTrue","value":"15","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"oeq?-instance-method","html_id":"oeq?-instance-method","name":"oeq?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L216","def":{"name":"oeq?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OEQ"}},{"id":"oge?-instance-method","html_id":"oge?-instance-method","name":"oge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L218","def":{"name":"oge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OGE"}},{"id":"ogt?-instance-method","html_id":"ogt?-instance-method","name":"ogt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L217","def":{"name":"ogt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OGT"}},{"id":"ole?-instance-method","html_id":"ole?-instance-method","name":"ole?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L220","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L220","def":{"name":"ole?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OLE"}},{"id":"olt?-instance-method","html_id":"olt?-instance-method","name":"olt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L219","def":{"name":"olt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == OLT"}},{"id":"one?-instance-method","html_id":"one?-instance-method","name":"one?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L221","def":{"name":"one?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ONE"}},{"id":"ord?-instance-method","html_id":"ord?-instance-method","name":"ord?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L222","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L222","def":{"name":"ord?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ORD"}},{"id":"predicate_false?-instance-method","html_id":"predicate_false?-instance-method","name":"predicate_false?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L215","def":{"name":"predicate_false?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PredicateFalse"}},{"id":"predicate_true?-instance-method","html_id":"predicate_true?-instance-method","name":"predicate_true?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L230","def":{"name":"predicate_true?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PredicateTrue"}},{"id":"ueq?-instance-method","html_id":"ueq?-instance-method","name":"ueq?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L224","def":{"name":"ueq?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UEQ"}},{"id":"uge?-instance-method","html_id":"uge?-instance-method","name":"uge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L226","def":{"name":"uge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UGE"}},{"id":"ugt?-instance-method","html_id":"ugt?-instance-method","name":"ugt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L225","def":{"name":"ugt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UGT"}},{"id":"ule?-instance-method","html_id":"ule?-instance-method","name":"ule?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L228","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L228","def":{"name":"ule?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ULE"}},{"id":"ult?-instance-method","html_id":"ult?-instance-method","name":"ult?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L227","def":{"name":"ult?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ULT"}},{"id":"une?-instance-method","html_id":"une?-instance-method","name":"une?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L229","def":{"name":"une?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNE"}},{"id":"uno?-instance-method","html_id":"uno?-instance-method","name":"uno?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L223","def":{"name":"uno?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNO"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/RelocMode","path":"LLVM/RelocMode.html","kind":"enum","full_name":"LLVM::RelocMode","name":"RelocMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":266,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Default","name":"Default","value":"0","doc":null,"summary":null},{"id":"Static","name":"Static","value":"1","doc":null,"summary":null},{"id":"PIC","name":"PIC","value":"2","doc":null,"summary":null},{"id":"DynamicNoPIC","name":"DynamicNoPIC","value":"3","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"default?-instance-method","html_id":"default?-instance-method","name":"default?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L267","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L267","def":{"name":"default?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Default"}},{"id":"dynamic_no_pic?-instance-method","html_id":"dynamic_no_pic?-instance-method","name":"dynamic_no_pic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L270","def":{"name":"dynamic_no_pic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DynamicNoPIC"}},{"id":"pic?-instance-method","html_id":"pic?-instance-method","name":"pic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L269","def":{"name":"pic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PIC"}},{"id":"static?-instance-method","html_id":"static?-instance-method","name":"static?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L268","def":{"name":"static?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Static"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Target","path":"LLVM/Target.html","kind":"struct","full_name":"LLVM::Target","name":"Target","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/target.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"each(&block)-class-method","html_id":"each(&amp;block)-class-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L2","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"target = LibLLVM.get_first_target\nwhile target\n  yield Target.new(target)\n  target = LibLLVM.get_next_target(target)\nend\n"}}],"constructors":[{"id":"first:self-class-method","html_id":"first:self-class-method","name":"first","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L10","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"first? || (raise(\"No LLVM targets available (did you forget to invoke LLVM.init_x86?)\"))"}},{"id":"first?:self?-class-method","html_id":"first?:self?-class-method","name":"first?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L14","def":{"name":"first?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self | ::Nil","visibility":"Public","body":"target = LibLLVM.get_first_target\ntarget ? Target.new(target) : nil\n"}},{"id":"from_triple(triple):self-class-method","html_id":"from_triple(triple):self-class-method","name":"from_triple","doc":null,"summary":null,"abstract":false,"args":[{"name":"triple","doc":null,"default_value":"","external_name":"triple","restriction":""}],"args_string":"(triple) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L19","def":{"name":"from_triple","args":[{"name":"triple","doc":null,"default_value":"","external_name":"triple","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"return_code = LibLLVM.get_target_from_triple(triple, out target, out error)\nif return_code == 0\nelse\n  raise(ArgumentError.new(LLVM.string_and_dispose(error)))\nend\nnew(target)\n"}},{"id":"new(unwrap:LibLLVM::TargetRef)-class-method","html_id":"new(unwrap:LibLLVM::TargetRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetRef"}],"args_string":"(unwrap : LibLLVM::TargetRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L25","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"create_target_machine(triple,cpu=&quot;&quot;,features=&quot;&quot;,opt_level=LLVM::CodeGenOptLevel::Default,reloc=LLVM::RelocMode::PIC,code_model=LLVM::CodeModel::Default)-instance-method","html_id":"create_target_machine(triple,cpu=&amp;quot;&amp;quot;,features=&amp;quot;&amp;quot;,opt_level=LLVM::CodeGenOptLevel::Default,reloc=LLVM::RelocMode::PIC,code_model=LLVM::CodeModel::Default)-instance-method","name":"create_target_machine","doc":null,"summary":null,"abstract":false,"args":[{"name":"triple","doc":null,"default_value":"","external_name":"triple","restriction":""},{"name":"cpu","doc":null,"default_value":"\"\"","external_name":"cpu","restriction":""},{"name":"features","doc":null,"default_value":"\"\"","external_name":"features","restriction":""},{"name":"opt_level","doc":null,"default_value":"LLVM::CodeGenOptLevel::Default","external_name":"opt_level","restriction":""},{"name":"reloc","doc":null,"default_value":"LLVM::RelocMode::PIC","external_name":"reloc","restriction":""},{"name":"code_model","doc":null,"default_value":"LLVM::CodeModel::Default","external_name":"code_model","restriction":""}],"args_string":"(triple, cpu = <span class=\"s\">&quot;&quot;</span>, features = <span class=\"s\">&quot;&quot;</span>, opt_level = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">CodeGenOptLevel</span><span class=\"t\">::</span><span class=\"t\">Default</span>, reloc = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">RelocMode</span><span class=\"t\">::</span><span class=\"t\">PIC</span>, code_model = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">CodeModel</span><span class=\"t\">::</span><span class=\"t\">Default</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L36","def":{"name":"create_target_machine","args":[{"name":"triple","doc":null,"default_value":"","external_name":"triple","restriction":""},{"name":"cpu","doc":null,"default_value":"\"\"","external_name":"cpu","restriction":""},{"name":"features","doc":null,"default_value":"\"\"","external_name":"features","restriction":""},{"name":"opt_level","doc":null,"default_value":"LLVM::CodeGenOptLevel::Default","external_name":"opt_level","restriction":""},{"name":"reloc","doc":null,"default_value":"LLVM::RelocMode::PIC","external_name":"reloc","restriction":""},{"name":"code_model","doc":null,"default_value":"LLVM::CodeModel::Default","external_name":"code_model","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target_machine = LibLLVM.create_target_machine(self, triple, cpu, features, opt_level, reloc, code_model)\ntarget_machine ? TargetMachine.new(target_machine) : raise(\"Couldn't create target machine\")\n"}},{"id":"description-instance-method","html_id":"description-instance-method","name":"description","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L32","def":{"name":"description","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibLLVM.get_target_description(self))"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L52","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"name-instance-method","html_id":"name-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L28","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibLLVM.get_target_name(self))"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L44","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"LLVM::Target(name=\"\nname.inspect(io)\nio << \", description=\"\ndescription.inspect(io)\nio << ')'\n"}},{"id":"to_unsafe:LibLLVM::TargetRef-instance-method","html_id":"to_unsafe:LibLLVM::TargetRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::TargetRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target.cr#L56","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/TargetData","path":"LLVM/TargetData.html","kind":"struct","full_name":"LLVM::TargetData","name":"TargetData","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/target_data.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::TargetDataRef)-class-method","html_id":"new(unwrap:LibLLVM::TargetDataRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetDataRef"}],"args_string":"(unwrap : LibLLVM::TargetDataRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetDataRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"abi_alignment(type)-instance-method","html_id":"abi_alignment(type)-instance-method","name":"abi_alignment","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L17","def":{"name":"abi_alignment","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.abi_alignment_of_type(self, type)"}},{"id":"abi_size(type)-instance-method","html_id":"abi_size(type)-instance-method","name":"abi_size","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L13","def":{"name":"abi_size","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.abi_size_of_type(self, type)"}},{"id":"offset_of_element(struct_type,element)-instance-method","html_id":"offset_of_element(struct_type,element)-instance-method","name":"offset_of_element","doc":null,"summary":null,"abstract":false,"args":[{"name":"struct_type","doc":null,"default_value":"","external_name":"struct_type","restriction":""},{"name":"element","doc":null,"default_value":"","external_name":"element","restriction":""}],"args_string":"(struct_type, element)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L25","def":{"name":"offset_of_element","args":[{"name":"struct_type","doc":null,"default_value":"","external_name":"struct_type","restriction":""},{"name":"element","doc":null,"default_value":"","external_name":"element","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.offset_of_element(self, struct_type, element)"}},{"id":"size_in_bits(type)-instance-method","html_id":"size_in_bits(type)-instance-method","name":"size_in_bits","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L5","def":{"name":"size_in_bits","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.size_of_type_in_bits(self, type)"}},{"id":"size_in_bytes(type)-instance-method","html_id":"size_in_bytes(type)-instance-method","name":"size_in_bytes","doc":null,"summary":null,"abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L9","def":{"name":"size_in_bytes","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(size_in_bits(type)) / 8"}},{"id":"to_data_layout_string-instance-method","html_id":"to_data_layout_string-instance-method","name":"to_data_layout_string","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L29","def":{"name":"to_data_layout_string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibLLVM.copy_string_rep_of_target_data(self))"}},{"id":"to_unsafe:LibLLVM::TargetDataRef-instance-method","html_id":"to_unsafe:LibLLVM::TargetDataRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::TargetDataRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_data.cr#L21","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/TargetMachine","path":"LLVM/TargetMachine.html","kind":"class","full_name":"LLVM::TargetMachine","name":"TargetMachine","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/target_machine.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::TargetMachineRef)-class-method","html_id":"new(unwrap:LibLLVM::TargetMachineRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetMachineRef"}],"args_string":"(unwrap : LibLLVM::TargetMachineRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TargetMachineRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"abi-instance-method","html_id":"abi-instance-method","name":"abi","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L42","def":{"name":"abi","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"triple = self.triple\ncase triple\nwhen /x86_64|amd64/\n  ABI::X86_64.new(self)\nwhen /i386|i486|i586|i686/\n  ABI::X86.new(self)\nwhen /aarch64/\n  ABI::AArch64.new(self)\nwhen /arm/\n  ABI::ARM.new(self)\nelse\n  raise(\"Unsupported ABI for target triple: #{triple}\")\nend\n"}},{"id":"data_layout-instance-method","html_id":"data_layout-instance-method","name":"data_layout","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L10","def":{"name":"data_layout","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@layout || (@layout = (begin\n  layout = {% if LibLLVM::IS_38 %}\n                 LibLLVM.get_target_machine_data(self)\n               {% else %} # LLVM >= 3.9\n                 LibLLVM.create_target_data_layout(self)\n               {% end %}\n  layout ? TargetData.new(layout) : raise(\"Missing layout for #{self}\")\nend))"}},{"id":"emit_asm_to_file(llvm_mod,filename)-instance-method","html_id":"emit_asm_to_file(llvm_mod,filename)-instance-method","name":"emit_asm_to_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"llvm_mod","doc":null,"default_value":"","external_name":"llvm_mod","restriction":""},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(llvm_mod, filename)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L30","def":{"name":"emit_asm_to_file","args":[{"name":"llvm_mod","doc":null,"default_value":"","external_name":"llvm_mod","restriction":""},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit_to_file(llvm_mod, filename, LLVM::CodeGenFileType::AssemblyFile)"}},{"id":"emit_obj_to_file(llvm_mod,filename)-instance-method","html_id":"emit_obj_to_file(llvm_mod,filename)-instance-method","name":"emit_obj_to_file","doc":null,"summary":null,"abstract":false,"args":[{"name":"llvm_mod","doc":null,"default_value":"","external_name":"llvm_mod","restriction":""},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(llvm_mod, filename)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L26","def":{"name":"emit_obj_to_file","args":[{"name":"llvm_mod","doc":null,"default_value":"","external_name":"llvm_mod","restriction":""},{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit_to_file(llvm_mod, filename, LLVM::CodeGenFileType::ObjectFile)"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L62","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dispose_target_machine(@unwrap)"}},{"id":"target-instance-method","html_id":"target-instance-method","name":"target","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L5","def":{"name":"target","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target = LibLLVM.get_target_machine_target(self)\ntarget ? Target.new(target) : raise(\"Couldn't get target\")\n"}},{"id":"to_unsafe:LibLLVM::TargetMachineRef-instance-method","html_id":"to_unsafe:LibLLVM::TargetMachineRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::TargetMachineRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L58","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"triple-instance-method","html_id":"triple-instance-method","name":"triple","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/target_machine.cr#L21","def":{"name":"triple","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"triple_c = LibLLVM.get_target_machine_triple(self)\nLLVM.string_and_dispose(triple_c)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Type","path":"LLVM/Type.html","kind":"struct","full_name":"LLVM::Type","name":"Type","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":233,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"},{"filename":"llvm/type.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"function(arg_types:Array(LLVM::Type),return_type,varargs=false):self-class-method","html_id":"function(arg_types:Array(LLVM::Type),return_type,varargs=false):self-class-method","name":"function","doc":null,"summary":null,"abstract":false,"args":[{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"return_type","doc":null,"default_value":"","external_name":"return_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(arg_types : Array(LLVM::Type), return_type, varargs = <span class=\"n\">false</span>) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L11","def":{"name":"function","args":[{"name":"arg_types","doc":null,"default_value":"","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"return_type","doc":null,"default_value":"","external_name":"return_type","restriction":""},{"name":"varargs","doc":null,"default_value":"false","external_name":"varargs","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(LibLLVM.function_type(return_type, (arg_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), arg_types.size, varargs ? 1 : 0))"}},{"id":"new(unwrap:LibLLVM::TypeRef)-class-method","html_id":"new(unwrap:LibLLVM::TypeRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TypeRef"}],"args_string":"(unwrap : LibLLVM::TypeRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L4","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::TypeRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"array(count)-instance-method","html_id":"array(count)-instance-method","name":"array","doc":null,"summary":null,"abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L48","def":{"name":"array","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Type.new(LibLLVM.array_type(self, count))"}},{"id":"array_size-instance-method","html_id":"array_size-instance-method","name":"array_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L95","def":{"name":"array_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Array\nelse\n  raise(\"Not an Array\")\nend\n(LibLLVM.get_array_length(self)).to_i32\n"}},{"id":"const_array(values:Array(LLVM::Value)):Value-instance-method","html_id":"const_array(values:Array(LLVM::Value)):Value-instance-method","name":"const_array","doc":null,"summary":null,"abstract":false,"args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"}],"args_string":"(values : Array(LLVM::Value)) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L148","def":{"name":"const_array","args":[{"name":"values","doc":null,"default_value":"","external_name":"values","restriction":"Array(LLVM::Value)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_array(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size))"}},{"id":"const_double(string:String):Value-instance-method","html_id":"const_double(string:String):Value-instance-method","name":"const_double","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L144","def":{"name":"const_double","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real_of_string(self, string))"}},{"id":"const_double(value:Float64):Value-instance-method","html_id":"const_double(value:Float64):Value-instance-method","name":"const_double","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L140","def":{"name":"const_double","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real(self, value))"}},{"id":"const_float(value:String):Value-instance-method","html_id":"const_float(value:String):Value-instance-method","name":"const_float","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L136","def":{"name":"const_float","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real_of_string(self, value))"}},{"id":"const_float(value:Float32):Value-instance-method","html_id":"const_float(value:Float32):Value-instance-method","name":"const_float","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L132","def":{"name":"const_float","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real(self, value))"}},{"id":"const_inline_asm(asm_string,constraints,has_side_effects=false,is_align_stack=false)-instance-method","html_id":"const_inline_asm(asm_string,constraints,has_side_effects=false,is_align_stack=false)-instance-method","name":"const_inline_asm","doc":null,"summary":null,"abstract":false,"args":[{"name":"asm_string","doc":null,"default_value":"","external_name":"asm_string","restriction":""},{"name":"constraints","doc":null,"default_value":"","external_name":"constraints","restriction":""},{"name":"has_side_effects","doc":null,"default_value":"false","external_name":"has_side_effects","restriction":""},{"name":"is_align_stack","doc":null,"default_value":"false","external_name":"is_align_stack","restriction":""}],"args_string":"(asm_string, constraints, has_side_effects = <span class=\"n\">false</span>, is_align_stack = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L152","def":{"name":"const_inline_asm","args":[{"name":"asm_string","doc":null,"default_value":"","external_name":"asm_string","restriction":""},{"name":"constraints","doc":null,"default_value":"","external_name":"constraints","restriction":""},{"name":"has_side_effects","doc":null,"default_value":"false","external_name":"has_side_effects","restriction":""},{"name":"is_align_stack","doc":null,"default_value":"false","external_name":"is_align_stack","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.const_inline_asm(self, asm_string, constraints, (has_side_effects ? 1 : 0), (is_align_stack ? 1 : 0)))"}},{"id":"const_int(value):Value-instance-method","html_id":"const_int(value):Value-instance-method","name":"const_int","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value) : Value","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L128","def":{"name":"const_int","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_int(self, value, 0))"}},{"id":"context:Context-instance-method","html_id":"context:Context-instance-method","name":"context","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Context","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L156","def":{"name":"context","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Context","visibility":"Public","body":"Context.new(LibLLVM.get_type_context(self), dispose_on_finalize: false)"}},{"id":"element_type-instance-method","html_id":"element_type-instance-method","name":"element_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L86","def":{"name":"element_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case kind\nwhen Kind::Array, Kind::Vector, Kind::Pointer\n  Type.new(LibLLVM.get_element_type(self))\nelse\n  raise(\"Not a sequential type\")\nend"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L160","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_type_to_string(self), io)\nself\n"}},{"id":"int_width-instance-method","html_id":"int_width-instance-method","name":"int_width","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L56","def":{"name":"int_width","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Integer\nelse\n  raise(\"Not an Integer\")\nend\n(LibLLVM.get_int_type_width(self)).to_i32\n"}},{"id":"kind-instance-method","html_id":"kind-instance-method","name":"kind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L24","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.get_type_kind(self)"}},{"id":"null-instance-method","html_id":"null-instance-method","name":"null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L32","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.const_null(self))"}},{"id":"null_pointer-instance-method","html_id":"null_pointer-instance-method","name":"null_pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L36","def":{"name":"null_pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.const_pointer_null(self))"}},{"id":"packed_struct?-instance-method","html_id":"packed_struct?-instance-method","name":"packed_struct?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L61","def":{"name":"packed_struct?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"Not a Struct\")\nend\n(LibLLVM.is_packed_struct(self)) != 0\n"}},{"id":"params_size-instance-method","html_id":"params_size-instance-method","name":"params_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L118","def":{"name":"params_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\n(LibLLVM.count_param_types(self)).to_i\n"}},{"id":"params_types-instance-method","html_id":"params_types-instance-method","name":"params_types","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L110","def":{"name":"params_types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"params_size = self.params_size\nArray(LLVM::Type).build(params_size) do |buffer|\n  LibLLVM.get_param_types(self, buffer.as(::Pointer(LibLLVM::TypeRef)))\n  params_size\nend\n"}},{"id":"pointer-instance-method","html_id":"pointer-instance-method","name":"pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L44","def":{"name":"pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Type.new(LibLLVM.pointer_type(self, 0))"}},{"id":"return_type-instance-method","html_id":"return_type-instance-method","name":"return_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L105","def":{"name":"return_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\nType.new(LibLLVM.get_return_type(self))\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L15","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if void?\n  context.int64.const_int(1)\nelse\n  Value.new(LibLLVM.size_of(self))\nend"}},{"id":"struct_element_types-instance-method","html_id":"struct_element_types-instance-method","name":"struct_element_types","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L76","def":{"name":"struct_element_types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"Not a Struct\")\nend\ncount = LibLLVM.count_struct_element_types(self)\nArray(LLVM::Type).build(count) do |buffer|\n  LibLLVM.get_struct_element_types(self, buffer.as(::Pointer(LibLLVM::TypeRef)))\n  count\nend\n"}},{"id":"struct_name:String?-instance-method","html_id":"struct_name:String?-instance-method","name":"struct_name","doc":"Assuming this type is a struct, returns its name.\nThe name can be `nil` if the struct is anynomous.\nRaises if this type is not a struct.","summary":"<p>Assuming this type is a struct, returns its name.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L69","def":{"name":"struct_name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"not a Struct\")\nend\nname = LibLLVM.get_struct_name(self)\nname ? String.new(name) : nil\n"}},{"id":"to_unsafe:LibLLVM::TypeRef-instance-method","html_id":"to_unsafe:LibLLVM::TypeRef-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::TypeRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L7","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"undef-instance-method","html_id":"undef-instance-method","name":"undef","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L40","def":{"name":"undef","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Value.new(LibLLVM.get_undef(self))"}},{"id":"unwrap:LibLLVM::TypeRef-instance-method","html_id":"unwrap:LibLLVM::TypeRef-instance-method","name":"unwrap","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibLLVM::TypeRef","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L2","def":{"name":"unwrap","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibLLVM::TypeRef","visibility":"Public","body":"@unwrap"}},{"id":"varargs?-instance-method","html_id":"varargs?-instance-method","name":"varargs?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L123","def":{"name":"varargs?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\n(LibLLVM.is_function_var_arg(self)) != 0\n"}},{"id":"vector(count):self-instance-method","html_id":"vector(count):self-instance-method","name":"vector","doc":null,"summary":null,"abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(count) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L52","def":{"name":"vector","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"Type.new(LibLLVM.vector_type(self, count))"}},{"id":"vector_size-instance-method","html_id":"vector_size-instance-method","name":"vector_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L100","def":{"name":"vector_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == Kind::Vector\nelse\n  raise(\"not a Vector\")\nend\n(LibLLVM.get_vector_size(self)).to_i32\n"}},{"id":"void?-instance-method","html_id":"void?-instance-method","name":"void?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/type.cr#L28","def":{"name":"void?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"kind == Kind::Void"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/Type/Kind","path":"LLVM/Type/Kind.html","kind":"enum","full_name":"LLVM::Type::Kind","name":"Kind","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":234,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Void","name":"Void","value":"0","doc":null,"summary":null},{"id":"Half","name":"Half","value":"1","doc":null,"summary":null},{"id":"Float","name":"Float","value":"2","doc":null,"summary":null},{"id":"Double","name":"Double","value":"3","doc":null,"summary":null},{"id":"X86_FP80","name":"X86_FP80","value":"4","doc":null,"summary":null},{"id":"FP128","name":"FP128","value":"5","doc":null,"summary":null},{"id":"PPC_FP128","name":"PPC_FP128","value":"6","doc":null,"summary":null},{"id":"Label","name":"Label","value":"7","doc":null,"summary":null},{"id":"Integer","name":"Integer","value":"8","doc":null,"summary":null},{"id":"Function","name":"Function","value":"9","doc":null,"summary":null},{"id":"Struct","name":"Struct","value":"10","doc":null,"summary":null},{"id":"Array","name":"Array","value":"11","doc":null,"summary":null},{"id":"Pointer","name":"Pointer","value":"12","doc":null,"summary":null},{"id":"Vector","name":"Vector","value":"13","doc":null,"summary":null},{"id":"Metadata","name":"Metadata","value":"14","doc":null,"summary":null},{"id":"X86_MMX","name":"X86_MMX","value":"15","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/Type","kind":"struct","full_name":"LLVM::Type","name":"Type"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"array?-instance-method","html_id":"array?-instance-method","name":"array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L246","def":{"name":"array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Array"}},{"id":"double?-instance-method","html_id":"double?-instance-method","name":"double?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L238","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L238","def":{"name":"double?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Double"}},{"id":"float?-instance-method","html_id":"float?-instance-method","name":"float?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L237","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L237","def":{"name":"float?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Float"}},{"id":"fp128?-instance-method","html_id":"fp128?-instance-method","name":"fp128?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L240","def":{"name":"fp128?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FP128"}},{"id":"function?-instance-method","html_id":"function?-instance-method","name":"function?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L244","def":{"name":"function?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Function"}},{"id":"half?-instance-method","html_id":"half?-instance-method","name":"half?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L236","def":{"name":"half?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Half"}},{"id":"integer?-instance-method","html_id":"integer?-instance-method","name":"integer?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L243","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L243","def":{"name":"integer?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Integer"}},{"id":"label?-instance-method","html_id":"label?-instance-method","name":"label?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L242","def":{"name":"label?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Label"}},{"id":"metadata?-instance-method","html_id":"metadata?-instance-method","name":"metadata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L249","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L249","def":{"name":"metadata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Metadata"}},{"id":"pointer?-instance-method","html_id":"pointer?-instance-method","name":"pointer?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L247","def":{"name":"pointer?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Pointer"}},{"id":"ppc_fp128?-instance-method","html_id":"ppc_fp128?-instance-method","name":"ppc_fp128?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L241","def":{"name":"ppc_fp128?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PPC_FP128"}},{"id":"struct?-instance-method","html_id":"struct?-instance-method","name":"struct?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L245","def":{"name":"struct?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Struct"}},{"id":"vector?-instance-method","html_id":"vector?-instance-method","name":"vector?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L248","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L248","def":{"name":"vector?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Vector"}},{"id":"void?-instance-method","html_id":"void?-instance-method","name":"void?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L235","def":{"name":"void?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Void"}},{"id":"x86_fp80?-instance-method","html_id":"x86_fp80?-instance-method","name":"x86_fp80?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L239","def":{"name":"x86_fp80?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86_FP80"}},{"id":"x86_mmx?-instance-method","html_id":"x86_mmx?-instance-method","name":"x86_mmx?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L250","def":{"name":"x86_mmx?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == X86_MMX"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/LLVM/Value","path":"LLVM/Value.html","kind":"struct","full_name":"LLVM::Value","name":"Value","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":375,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"},{"filename":"llvm/value.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[{"id":"null-class-method","html_id":"null-class-method","name":"null","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value.cr#L6","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::Value.new(Pointer(::Void).null.as(LibLLVM::ValueRef))"}}],"constructors":[],"instance_methods":[{"id":"to_value-instance-method","html_id":"to_value-instance-method","name":"to_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value.cr#L10","def":{"name":"to_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/Value/Kind","path":"LLVM/Value/Kind.html","kind":"enum","full_name":"LLVM::Value::Kind","name":"Kind","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":376,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Argument","name":"Argument","value":"0","doc":null,"summary":null},{"id":"BasicBlock","name":"BasicBlock","value":"1","doc":null,"summary":null},{"id":"MemoryUse","name":"MemoryUse","value":"2","doc":null,"summary":null},{"id":"MemoryDef","name":"MemoryDef","value":"3","doc":null,"summary":null},{"id":"MemoryPhi","name":"MemoryPhi","value":"4","doc":null,"summary":null},{"id":"Function","name":"Function","value":"5","doc":null,"summary":null},{"id":"GlobalAlias","name":"GlobalAlias","value":"6","doc":null,"summary":null},{"id":"GlobalIFunc","name":"GlobalIFunc","value":"7","doc":null,"summary":null},{"id":"GlobalVariable","name":"GlobalVariable","value":"8","doc":null,"summary":null},{"id":"BlockAddress","name":"BlockAddress","value":"9","doc":null,"summary":null},{"id":"ConstantExpr","name":"ConstantExpr","value":"10","doc":null,"summary":null},{"id":"ConstantArray","name":"ConstantArray","value":"11","doc":null,"summary":null},{"id":"ConstantStruct","name":"ConstantStruct","value":"12","doc":null,"summary":null},{"id":"ConstantVector","name":"ConstantVector","value":"13","doc":null,"summary":null},{"id":"UndefValue","name":"UndefValue","value":"14","doc":null,"summary":null},{"id":"ConstantAggregateZero","name":"ConstantAggregateZero","value":"15","doc":null,"summary":null},{"id":"ConstantDataArray","name":"ConstantDataArray","value":"16","doc":null,"summary":null},{"id":"ConstantDataVector","name":"ConstantDataVector","value":"17","doc":null,"summary":null},{"id":"ConstantInt","name":"ConstantInt","value":"18","doc":null,"summary":null},{"id":"ConstantFP","name":"ConstantFP","value":"19","doc":null,"summary":null},{"id":"ConstantPointerNull","name":"ConstantPointerNull","value":"20","doc":null,"summary":null},{"id":"ConstantTokenNone","name":"ConstantTokenNone","value":"21","doc":null,"summary":null},{"id":"MetadataAsValue","name":"MetadataAsValue","value":"22","doc":null,"summary":null},{"id":"InlineAsm","name":"InlineAsm","value":"23","doc":null,"summary":null},{"id":"Instruction","name":"Instruction","value":"24","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"argument?-instance-method","html_id":"argument?-instance-method","name":"argument?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L377","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L377","def":{"name":"argument?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Argument"}},{"id":"basic_block?-instance-method","html_id":"basic_block?-instance-method","name":"basic_block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L378","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L378","def":{"name":"basic_block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BasicBlock"}},{"id":"block_address?-instance-method","html_id":"block_address?-instance-method","name":"block_address?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L387","def":{"name":"block_address?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BlockAddress"}},{"id":"constant_aggregate_zero?-instance-method","html_id":"constant_aggregate_zero?-instance-method","name":"constant_aggregate_zero?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L394","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L394","def":{"name":"constant_aggregate_zero?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantAggregateZero"}},{"id":"constant_array?-instance-method","html_id":"constant_array?-instance-method","name":"constant_array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L389","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L389","def":{"name":"constant_array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantArray"}},{"id":"constant_data_array?-instance-method","html_id":"constant_data_array?-instance-method","name":"constant_data_array?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L395","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L395","def":{"name":"constant_data_array?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantDataArray"}},{"id":"constant_data_vector?-instance-method","html_id":"constant_data_vector?-instance-method","name":"constant_data_vector?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L396","def":{"name":"constant_data_vector?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantDataVector"}},{"id":"constant_expr?-instance-method","html_id":"constant_expr?-instance-method","name":"constant_expr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L388","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L388","def":{"name":"constant_expr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantExpr"}},{"id":"constant_fp?-instance-method","html_id":"constant_fp?-instance-method","name":"constant_fp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L398","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L398","def":{"name":"constant_fp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantFP"}},{"id":"constant_int?-instance-method","html_id":"constant_int?-instance-method","name":"constant_int?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L397","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L397","def":{"name":"constant_int?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantInt"}},{"id":"constant_pointer_null?-instance-method","html_id":"constant_pointer_null?-instance-method","name":"constant_pointer_null?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L399","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L399","def":{"name":"constant_pointer_null?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantPointerNull"}},{"id":"constant_struct?-instance-method","html_id":"constant_struct?-instance-method","name":"constant_struct?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L390","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L390","def":{"name":"constant_struct?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantStruct"}},{"id":"constant_token_none?-instance-method","html_id":"constant_token_none?-instance-method","name":"constant_token_none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L400","def":{"name":"constant_token_none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantTokenNone"}},{"id":"constant_vector?-instance-method","html_id":"constant_vector?-instance-method","name":"constant_vector?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L391","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L391","def":{"name":"constant_vector?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ConstantVector"}},{"id":"function?-instance-method","html_id":"function?-instance-method","name":"function?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L383","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L383","def":{"name":"function?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Function"}},{"id":"global_alias?-instance-method","html_id":"global_alias?-instance-method","name":"global_alias?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L384","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L384","def":{"name":"global_alias?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == GlobalAlias"}},{"id":"global_i_func?-instance-method","html_id":"global_i_func?-instance-method","name":"global_i_func?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L385","def":{"name":"global_i_func?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == GlobalIFunc"}},{"id":"global_variable?-instance-method","html_id":"global_variable?-instance-method","name":"global_variable?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L386","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L386","def":{"name":"global_variable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == GlobalVariable"}},{"id":"inline_asm?-instance-method","html_id":"inline_asm?-instance-method","name":"inline_asm?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L403","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L403","def":{"name":"inline_asm?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == InlineAsm"}},{"id":"instruction?-instance-method","html_id":"instruction?-instance-method","name":"instruction?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L405","def":{"name":"instruction?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Instruction"}},{"id":"memory_def?-instance-method","html_id":"memory_def?-instance-method","name":"memory_def?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L380","def":{"name":"memory_def?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MemoryDef"}},{"id":"memory_phi?-instance-method","html_id":"memory_phi?-instance-method","name":"memory_phi?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L381","def":{"name":"memory_phi?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MemoryPhi"}},{"id":"memory_use?-instance-method","html_id":"memory_use?-instance-method","name":"memory_use?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L379","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L379","def":{"name":"memory_use?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MemoryUse"}},{"id":"metadata_as_value?-instance-method","html_id":"metadata_as_value?-instance-method","name":"metadata_as_value?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L402","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L402","def":{"name":"metadata_as_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MetadataAsValue"}},{"id":"undef_value?-instance-method","html_id":"undef_value?-instance-method","name":"undef_value?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L393","def":{"name":"undef_value?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UndefValue"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/LLVM/ValueMethods","path":"LLVM/ValueMethods.html","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"llvm/value_methods.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/LLVM/Function","kind":"struct","full_name":"LLVM::Function","name":"Function"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(unwrap:LibLLVM::ValueRef)-class-method","html_id":"new(unwrap:LibLLVM::ValueRef)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ValueRef"}],"args_string":"(unwrap : LibLLVM::ValueRef)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L2","def":{"name":"new","args":[{"name":"unwrap","doc":null,"default_value":"","external_name":"unwrap","restriction":"LibLLVM::ValueRef"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add_instruction_attribute(index:Int,attribute:LLVM::Attribute,context:LLVM::Context)-instance-method","html_id":"add_instruction_attribute(index:Int,attribute:LLVM::Attribute,context:LLVM::Context)-instance-method","name":"add_instruction_attribute","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"LLVM::Attribute"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"LLVM::Context"}],"args_string":"(index : Int, attribute : LLVM::Attribute, context : LLVM::Context)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L17","def":{"name":"add_instruction_attribute","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"LLVM::Attribute"},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"LLVM::Context"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if attribute.value == 0\n  return\nend\n{% if LibLLVM.has_constant?(:AttributeRef) %}\n      attribute.each_kind do |kind|\n        attribute_ref = LibLLVM.create_enum_attribute(context, kind, 0)\n        LibLLVM.add_call_site_attribute(self, index, attribute_ref)\n      end\n    {% else %}\n      LibLLVM.add_instr_attribute(self, index, attribute)\n    {% end %}\n"}},{"id":"alignment=(bytes)-instance-method","html_id":"alignment=(bytes)-instance-method","name":"alignment=","doc":null,"summary":null,"abstract":false,"args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":""}],"args_string":"(bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L86","def":{"name":"alignment=","args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_alignment(self, bytes)"}},{"id":"call_convention-instance-method","html_id":"call_convention-instance-method","name":"call_convention","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L57","def":{"name":"call_convention","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.get_instruction_call_convention(self)"}},{"id":"call_convention=(call_convention)-instance-method","html_id":"call_convention=(call_convention)-instance-method","name":"call_convention=","doc":null,"summary":null,"abstract":false,"args":[{"name":"call_convention","doc":null,"default_value":"","external_name":"call_convention","restriction":""}],"args_string":"(call_convention)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L53","def":{"name":"call_convention=","args":[{"name":"call_convention","doc":null,"default_value":"","external_name":"call_convention","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_instruction_call_convention(self, call_convention)"}},{"id":"const_int_get_sext_value-instance-method","html_id":"const_int_get_sext_value-instance-method","name":"const_int_get_sext_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L90","def":{"name":"const_int_get_sext_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.const_int_get_sext_value(self)"}},{"id":"const_int_get_zext_value-instance-method","html_id":"const_int_get_zext_value-instance-method","name":"const_int_get_zext_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L94","def":{"name":"const_int_get_zext_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.const_int_get_zext_value(self)"}},{"id":"constant?-instance-method","html_id":"constant?-instance-method","name":"constant?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L29","def":{"name":"constant?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibLLVM.is_constant(self)) != 0"}},{"id":"dump-instance-method","html_id":"dump-instance-method","name":"dump","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L102","def":{"name":"dump","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.dump_value(self)"}},{"id":"global_constant=(global_constant)-instance-method","html_id":"global_constant=(global_constant)-instance-method","name":"global_constant=","doc":null,"summary":null,"abstract":false,"args":[{"name":"global_constant","doc":null,"default_value":"","external_name":"global_constant","restriction":""}],"args_string":"(global_constant)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L61","def":{"name":"global_constant=","args":[{"name":"global_constant","doc":null,"default_value":"","external_name":"global_constant","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_global_constant(self, global_constant ? 1 : 0)"}},{"id":"global_constant?-instance-method","html_id":"global_constant?-instance-method","name":"global_constant?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L65","def":{"name":"global_constant?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibLLVM.is_global_constant(self)) != 0"}},{"id":"initializer-instance-method","html_id":"initializer-instance-method","name":"initializer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L73","def":{"name":"initializer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"init = LibLLVM.get_initializer(self)\ninit ? LLVM::Value.new(init) : nil\n"}},{"id":"initializer=(initializer)-instance-method","html_id":"initializer=(initializer)-instance-method","name":"initializer=","doc":null,"summary":null,"abstract":false,"args":[{"name":"initializer","doc":null,"default_value":"","external_name":"initializer","restriction":""}],"args_string":"(initializer)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L69","def":{"name":"initializer=","args":[{"name":"initializer","doc":null,"default_value":"","external_name":"initializer","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_initializer(self, initializer)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L106","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_value_to_string(self), io)\nself\n"}},{"id":"kind-instance-method","html_id":"kind-instance-method","name":"kind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L13","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.get_value_kind(self)"}},{"id":"linkage-instance-method","html_id":"linkage-instance-method","name":"linkage","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L49","def":{"name":"linkage","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.get_linkage(self)"}},{"id":"linkage=(linkage)-instance-method","html_id":"linkage=(linkage)-instance-method","name":"linkage=","doc":null,"summary":null,"abstract":false,"args":[{"name":"linkage","doc":null,"default_value":"","external_name":"linkage","restriction":""}],"args_string":"(linkage)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L45","def":{"name":"linkage=","args":[{"name":"linkage","doc":null,"default_value":"","external_name":"linkage","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_linkage(self, linkage)"}},{"id":"name-instance-method","html_id":"name-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L9","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibLLVM.get_value_name(self))"}},{"id":"name=(name)-instance-method","html_id":"name=(name)-instance-method","name":"name=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L5","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_value_name(self, name)"}},{"id":"ordering=(ordering)-instance-method","html_id":"ordering=(ordering)-instance-method","name":"ordering=","doc":null,"summary":null,"abstract":false,"args":[{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""}],"args_string":"(ordering)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L82","def":{"name":"ordering=","args":[{"name":"ordering","doc":null,"default_value":"","external_name":"ordering","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVMExt.set_ordering(self, ordering)"}},{"id":"thread_local=(thread_local)-instance-method","html_id":"thread_local=(thread_local)-instance-method","name":"thread_local=","doc":null,"summary":null,"abstract":false,"args":[{"name":"thread_local","doc":null,"default_value":"","external_name":"thread_local","restriction":""}],"args_string":"(thread_local)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L37","def":{"name":"thread_local=","args":[{"name":"thread_local","doc":null,"default_value":"","external_name":"thread_local","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_thread_local(self, thread_local ? 1 : 0)"}},{"id":"thread_local?-instance-method","html_id":"thread_local?-instance-method","name":"thread_local?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L41","def":{"name":"thread_local?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibLLVM.is_thread_local(self)) != 0"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L111","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@unwrap"}},{"id":"to_value-instance-method","html_id":"to_value-instance-method","name":"to_value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L98","def":{"name":"to_value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LLVM::Value.new(unwrap)"}},{"id":"type-instance-method","html_id":"type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L33","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Type.new(LibLLVM.type_of(self))"}},{"id":"volatile=(volatile)-instance-method","html_id":"volatile=(volatile)-instance-method","name":"volatile=","doc":null,"summary":null,"abstract":false,"args":[{"name":"volatile","doc":null,"default_value":"","external_name":"volatile","restriction":""}],"args_string":"(volatile)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/value_methods.cr#L78","def":{"name":"volatile=","args":[{"name":"volatile","doc":null,"default_value":"","external_name":"volatile","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibLLVM.set_volatile(self, volatile ? 1 : 0)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/LLVM/VerifierFailureAction","path":"LLVM/VerifierFailureAction.html","kind":"enum","full_name":"LLVM::VerifierFailureAction","name":"VerifierFailureAction","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"llvm/enums.cr","line_number":282,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"AbortProcessAction","name":"AbortProcessAction","value":"0","doc":null,"summary":null},{"id":"PrintMessageAction","name":"PrintMessageAction","value":"1","doc":"verifier will print to stderr and abort()","summary":"<p>verifier will print to stderr and abort()</p>"},{"id":"ReturnStatusAction","name":"ReturnStatusAction","value":"2","doc":"verifier will print to stderr and return 1","summary":"<p>verifier will print to stderr and return 1</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"abort_process_action?-instance-method","html_id":"abort_process_action?-instance-method","name":"abort_process_action?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L283","def":{"name":"abort_process_action?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == AbortProcessAction"}},{"id":"print_message_action?-instance-method","html_id":"print_message_action?-instance-method","name":"print_message_action?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L284","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L284","def":{"name":"print_message_action?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PrintMessageAction"}},{"id":"return_status_action?-instance-method","html_id":"return_status_action?-instance-method","name":"return_status_action?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/llvm/enums.cr#L285","def":{"name":"return_status_action?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ReturnStatusAction"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Logger","path":"Logger.html","kind":"class","full_name":"Logger","name":"Logger","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"logger.cr","line_number":39,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEBUG","name":"DEBUG","value":"Severity::DEBUG","doc":null,"summary":null},{"id":"ERROR","name":"ERROR","value":"Severity::ERROR","doc":null,"summary":null},{"id":"FATAL","name":"FATAL","value":"Severity::FATAL","doc":null,"summary":null},{"id":"INFO","name":"INFO","value":"Severity::INFO","doc":null,"summary":null},{"id":"UNKNOWN","name":"UNKNOWN","value":"Severity::UNKNOWN","doc":null,"summary":null},{"id":"WARN","name":"WARN","value":"Severity::WARN","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The `Logger` class provides a simple but sophisticated logging utility that you can use to output messages.\n\nThe messages have associated levels, such as `INFO` or `ERROR` that indicate their importance.\nYou can then give the `Logger` a level, and only messages at that level of higher will be printed.\n\nFor instance, in a production system, you may have your `Logger` set to `INFO` or even `WARN`.\nWhen you are developing the system, however, you probably want to know about the program’s internal state,\nand would set the `Logger` to `DEBUG`.\n\nIf logging to multiple locations is required, an `IO::MultiWriter` can be\nused.\n\n### Example\n\n```\nrequire \"logger\"\n\nlog = Logger.new(STDOUT)\nlog.level = Logger::WARN\n\n# or\nlog = Logger.new(STDOUT, level: Logger::WARN)\n\nlog.debug(\"Created logger\")\nlog.info(\"Program started\")\nlog.warn(\"Nothing to do!\")\n\nbegin\n  File.each_line(\"/foo/bar.log\") do |line|\n    unless line =~ /^(\\w+) = (.*)$/\n      log.error(\"Line in wrong format: #{line}\")\n    end\n  end\nrescue err\n  log.fatal(\"Caught exception; exiting\")\n  log.fatal(err)\nend\n```","summary":"<p>The <code><a href=\"Logger.html\">Logger</a></code> class provides a simple but sophisticated logging utility that you can use to output messages.</p>","class_methods":[],"constructors":[{"id":"new(io:IO?,level=Severity::INFO,formatter=DEFAULT_FORMATTER,progname=&quot;&quot;)-class-method","html_id":"new(io:IO?,level=Severity::INFO,formatter=DEFAULT_FORMATTER,progname=&amp;quot;&amp;quot;)-class-method","name":"new","doc":"Creates a new logger that will log to the given *io*.\nIf *io* is `nil` then all log calls will be silently ignored.","summary":"<p>Creates a new logger that will log to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO | ::Nil"},{"name":"level","doc":null,"default_value":"Severity::INFO","external_name":"level","restriction":""},{"name":"formatter","doc":null,"default_value":"DEFAULT_FORMATTER","external_name":"formatter","restriction":""},{"name":"progname","doc":null,"default_value":"\"\"","external_name":"progname","restriction":""}],"args_string":"(io : IO?, level = <span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">INFO</span>, formatter = <span class=\"t\">DEFAULT_FORMATTER</span>, progname = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L113","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO | ::Nil"},{"name":"level","doc":null,"default_value":"Severity::INFO","external_name":"level","restriction":""},{"name":"formatter","doc":null,"default_value":"DEFAULT_FORMATTER","external_name":"formatter","restriction":""},{"name":"progname","doc":null,"default_value":"\"\"","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, level, formatter, progname)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Calls the *close* method on the object passed to `initialize`.","summary":"<p>Calls the <em>close</em> method on the object passed to <code>initialize</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L119","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\nif io = @io\nelse\n  return\nend\n@closed = true\n@mutex.synchronize do\n  io.close\nend\n"}},{"id":"debug(progname=nil,&block)-instance-method","html_id":"debug(progname=nil,&amp;block)-instance-method","name":"debug","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `DEBUG`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#DEBUG\">DEBUG</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"debug","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::DEBUG, progname) do\n  yield\nend"}},{"id":"debug(message,progname=nil)-instance-method","html_id":"debug(message,progname=nil)-instance-method","name":"debug","doc":"Logs *message* if the logger's current severity is lower or equal to `DEBUG`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#DEBUG\">DEBUG</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"debug","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::DEBUG, message, progname)"}},{"id":"debug?-instance-method","html_id":"debug?-instance-method","name":"debug?","doc":"Returns `true` if the logger's current severity is lower or equal to `DEBUG`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#DEBUG\">DEBUG</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"debug?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::DEBUG"}},{"id":"error(progname=nil,&block)-instance-method","html_id":"error(progname=nil,&amp;block)-instance-method","name":"error","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `ERROR`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#ERROR\">ERROR</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"error","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::ERROR, progname) do\n  yield\nend"}},{"id":"error(message,progname=nil)-instance-method","html_id":"error(message,progname=nil)-instance-method","name":"error","doc":"Logs *message* if the logger's current severity is lower or equal to `ERROR`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#ERROR\">ERROR</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"error","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::ERROR, message, progname)"}},{"id":"error?-instance-method","html_id":"error?-instance-method","name":"error?","doc":"Returns `true` if the logger's current severity is lower or equal to `ERROR`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#ERROR\">ERROR</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"error?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::ERROR"}},{"id":"fatal(progname=nil,&block)-instance-method","html_id":"fatal(progname=nil,&amp;block)-instance-method","name":"fatal","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `FATAL`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#FATAL\">FATAL</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"fatal","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::FATAL, progname) do\n  yield\nend"}},{"id":"fatal(message,progname=nil)-instance-method","html_id":"fatal(message,progname=nil)-instance-method","name":"fatal","doc":"Logs *message* if the logger's current severity is lower or equal to `FATAL`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#FATAL\">FATAL</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"fatal","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::FATAL, message, progname)"}},{"id":"fatal?-instance-method","html_id":"fatal?-instance-method","name":"fatal?","doc":"Returns `true` if the logger's current severity is lower or equal to `FATAL`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#FATAL\">FATAL</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"fatal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::FATAL"}},{"id":"formatter:Logger::Severity,Time,String,String,IO->Nil-instance-method","html_id":"formatter:Logger::Severity,Time,String,String,IO-&gt;Nil-instance-method","name":"formatter","doc":"Customizable `Proc` (with a reasonable default)\nwhich the `Logger` uses to format and print its entries.\n\nUse this setter to provide a custom formatter.\nThe `Logger` will invoke it with the following arguments:\n - severity: a `Logger::Severity`\n - datetime: `Time`, the entry's timestamp\n - progname: `String`, the program name, if set when the logger was built\n - message: `String`, the body of a message\n - io: `IO`, the Logger's stream, to which you must write the final output\n\nExample:\n\n```\nrequire \"logger\"\n\nlogger = Logger.new(STDOUT)\nlogger.progname = \"YodaBot\"\n\nlogger.formatter = Logger::Formatter.new do |severity, datetime, progname, message, io|\n  label = severity.unknown? ? \"ANY\" : severity.to_s\n  io << label[0] << \", [\" << datetime << \" #\" << Process.pid << \"] \"\n  io << label.rjust(5) << \" -- \" << progname << \": \" << message\nend\n\nlogger.warn(\"Fear leads to anger. Anger leads to hate. Hate leads to suffering.\")\n\n# Prints to the console:\n# \"W, [2017-05-06 18:00:41 -0300 #11927]  WARN --\n#  YodaBot: Fear leads to anger. Anger leads to hate. Hate leads to suffering.\"\n```","summary":"<p>Customizable <code><a href=\"Proc.html\">Proc</a></code> (with a reasonable default) which the <code><a href=\"Logger.html\">Logger</a></code> uses to format and print its entries.</p>","abstract":false,"args":[],"args_string":" : Logger::Severity, Time, String, String, IO -> Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L74","def":{"name":"formatter","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@formatter"}},{"id":"formatter=(formatter)-instance-method","html_id":"formatter=(formatter)-instance-method","name":"formatter=","doc":"Customizable `Proc` (with a reasonable default)\nwhich the `Logger` uses to format and print its entries.\n\nUse this setter to provide a custom formatter.\nThe `Logger` will invoke it with the following arguments:\n - severity: a `Logger::Severity`\n - datetime: `Time`, the entry's timestamp\n - progname: `String`, the program name, if set when the logger was built\n - message: `String`, the body of a message\n - io: `IO`, the Logger's stream, to which you must write the final output\n\nExample:\n\n```\nrequire \"logger\"\n\nlogger = Logger.new(STDOUT)\nlogger.progname = \"YodaBot\"\n\nlogger.formatter = Logger::Formatter.new do |severity, datetime, progname, message, io|\n  label = severity.unknown? ? \"ANY\" : severity.to_s\n  io << label[0] << \", [\" << datetime << \" #\" << Process.pid << \"] \"\n  io << label.rjust(5) << \" -- \" << progname << \": \" << message\nend\n\nlogger.warn(\"Fear leads to anger. Anger leads to hate. Hate leads to suffering.\")\n\n# Prints to the console:\n# \"W, [2017-05-06 18:00:41 -0300 #11927]  WARN --\n#  YodaBot: Fear leads to anger. Anger leads to hate. Hate leads to suffering.\"\n```","summary":"<p>Customizable <code><a href=\"Proc.html\">Proc</a></code> (with a reasonable default) which the <code><a href=\"Logger.html\">Logger</a></code> uses to format and print its entries.</p>","abstract":false,"args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"args_string":"(formatter)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L74","def":{"name":"formatter=","args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@formatter = formatter"}},{"id":"info(message,progname=nil)-instance-method","html_id":"info(message,progname=nil)-instance-method","name":"info","doc":"Logs *message* if the logger's current severity is lower or equal to `INFO`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#INFO\">INFO</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"info","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::INFO, message, progname)"}},{"id":"info(progname=nil,&block)-instance-method","html_id":"info(progname=nil,&amp;block)-instance-method","name":"info","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `INFO`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#INFO\">INFO</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"info","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::INFO, progname) do\n  yield\nend"}},{"id":"info?-instance-method","html_id":"info?-instance-method","name":"info?","doc":"Returns `true` if the logger's current severity is lower or equal to `INFO`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#INFO\">INFO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"info?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::INFO"}},{"id":"level:Severity-instance-method","html_id":"level:Severity-instance-method","name":"level","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Severity","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L40","def":{"name":"level","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Severity","visibility":"Public","body":"@level"}},{"id":"level=(level:Severity)-instance-method","html_id":"level=(level:Severity)-instance-method","name":"level=","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Severity"}],"args_string":"(level : Severity)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L40","def":{"name":"level=","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Severity"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@level = level"}},{"id":"log(severity,message,progname=nil)-instance-method","html_id":"log(severity,message,progname=nil)-instance-method","name":"log","doc":"Logs *message* if *severity* is higher or equal with the logger's current\nseverity. *progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if <em>severity</em> is higher or equal with the logger's current severity.</p>","abstract":false,"args":[{"name":"severity","doc":null,"default_value":"","external_name":"severity","restriction":""},{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(severity, message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L153","def":{"name":"log","args":[{"name":"severity","doc":null,"default_value":"","external_name":"severity","restriction":""},{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if severity < level || (!@io)\n  return\nend\nwrite(severity, Time.now, progname || @progname, message)\n"}},{"id":"log(severity,progname=nil,&block)-instance-method","html_id":"log(severity,progname=nil,&amp;block)-instance-method","name":"log","doc":"Logs the message as returned from the given block if *severity*\nis higher or equal with the loggers current severity. The block is not run\nif *severity* is lower. *progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if <em>severity</em> is higher or equal with the loggers current severity.</p>","abstract":false,"args":[{"name":"severity","doc":null,"default_value":"","external_name":"severity","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(severity, progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L161","def":{"name":"log","args":[{"name":"severity","doc":null,"default_value":"","external_name":"severity","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if severity < level || (!@io)\n  return\nend\nwrite(severity, Time.now, progname || @progname, yield)\n"}},{"id":"progname:String-instance-method","html_id":"progname:String-instance-method","name":"progname","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L41","def":{"name":"progname","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@progname"}},{"id":"progname=(progname:String)-instance-method","html_id":"progname=(progname:String)-instance-method","name":"progname=","doc":null,"summary":null,"abstract":false,"args":[{"name":"progname","doc":null,"default_value":"","external_name":"progname","restriction":"String"}],"args_string":"(progname : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L41","def":{"name":"progname=","args":[{"name":"progname","doc":null,"default_value":"","external_name":"progname","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@progname = progname"}},{"id":"unknown(message,progname=nil)-instance-method","html_id":"unknown(message,progname=nil)-instance-method","name":"unknown","doc":"Logs *message* if the logger's current severity is lower or equal to `UNKNOWN`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#UNKNOWN\">UNKNOWN</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"unknown","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::UNKNOWN, message, progname)"}},{"id":"unknown(progname=nil,&block)-instance-method","html_id":"unknown(progname=nil,&amp;block)-instance-method","name":"unknown","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `UNKNOWN`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#UNKNOWN\">UNKNOWN</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"unknown","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::UNKNOWN, progname) do\n  yield\nend"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":"Returns `true` if the logger's current severity is lower or equal to `UNKNOWN`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#UNKNOWN\">UNKNOWN</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::UNKNOWN"}},{"id":"warn(progname=nil,&block)-instance-method","html_id":"warn(progname=nil,&amp;block)-instance-method","name":"warn","doc":"Logs the message as returned from the given block if the logger's current severity\nis lower or equal to `WARN`. The block is not run if the severity is higher.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs the message as returned from the given block if the logger's current severity is lower or equal to <code><a href=\"Logger.html#WARN\">WARN</a></code>.</p>","abstract":false,"args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(progname = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"warn","args":[{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::WARN, progname) do\n  yield\nend"}},{"id":"warn(message,progname=nil)-instance-method","html_id":"warn(message,progname=nil)-instance-method","name":"warn","doc":"Logs *message* if the logger's current severity is lower or equal to `WARN`.\n*progname* overrides a default progname set in this logger.","summary":"<p>Logs <em>message</em> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#WARN\">WARN</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"args_string":"(message, progname = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"warn","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"progname","doc":null,"default_value":"nil","external_name":"progname","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(Severity::WARN, message, progname)"}},{"id":"warn?-instance-method","html_id":"warn?-instance-method","name":"warn?","doc":"Returns `true` if the logger's current severity is lower or equal to `WARN`.","summary":"<p>Returns <code>true</code> if the logger's current severity is lower or equal to <code><a href=\"Logger.html#WARN\">WARN</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L129","def":{"name":"warn?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"level <= Severity::WARN"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Logger/Formatter","path":"Logger/Formatter.html","kind":"alias","full_name":"Logger::Formatter","name":"Formatter","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"logger.cr","line_number":96,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"Proc(Logger::Severity, Time, String, String, IO, Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Logger","kind":"class","full_name":"Logger","name":"Logger"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Logger/Severity","path":"Logger/Severity.html","kind":"enum","full_name":"Logger::Severity","name":"Severity","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"logger.cr","line_number":77,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEBUG","name":"DEBUG","value":"0","doc":"Low-level information for developers","summary":"<p>Low-level information for developers</p>"},{"id":"INFO","name":"INFO","value":"1","doc":"Generic (useful) information about system operation","summary":"<p>Generic (useful) information about system operation</p>"},{"id":"WARN","name":"WARN","value":"2","doc":"A warning","summary":"<p>A warning</p>"},{"id":"ERROR","name":"ERROR","value":"3","doc":"A handleable error condition","summary":"<p>A handleable error condition</p>"},{"id":"FATAL","name":"FATAL","value":"4","doc":"An unhandleable error that results in a program crash","summary":"<p>An unhandleable error that results in a program crash</p>"},{"id":"UNKNOWN","name":"UNKNOWN","value":"5","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Logger","kind":"class","full_name":"Logger","name":"Logger"},"doc":"A logger severity level.","summary":"<p>A logger severity level.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"debug?-instance-method","html_id":"debug?-instance-method","name":"debug?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L79","def":{"name":"debug?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DEBUG"}},{"id":"error?-instance-method","html_id":"error?-instance-method","name":"error?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L88","def":{"name":"error?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ERROR"}},{"id":"fatal?-instance-method","html_id":"fatal?-instance-method","name":"fatal?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L91","def":{"name":"fatal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FATAL"}},{"id":"info?-instance-method","html_id":"info?-instance-method","name":"info?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L82","def":{"name":"info?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == INFO"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L93","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNKNOWN"}},{"id":"warn?-instance-method","html_id":"warn?-instance-method","name":"warn?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/logger.cr#L85","def":{"name":"warn?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WARN"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Markdown","path":"Markdown.html","kind":"class","full_name":"Markdown","name":"Markdown","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Markdown library parses Markdown text. It supports rendering to HTML text.\n\nUsage:\n\n```\nrequire \"markdown\"\n\ntext = \"## This is title \\n This is a [link](http://crystal-lang.org)\"\n\nMarkdown.to_html(text)\n# => <h2>This is title</h2>\n# => <p>This is a <a href=\"http://crystal-lang.org\">link</a></p>\n```\n\nNOTE: This library is in its early stage. Many features are still in development.","summary":"<p>Markdown library parses Markdown text.</p>","class_methods":[{"id":"parse(text,renderer)-class-method","html_id":"parse(text,renderer)-class-method","name":"parse","doc":null,"summary":null,"abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""},{"name":"renderer","doc":null,"default_value":"","external_name":"renderer","restriction":""}],"args_string":"(text, renderer)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown.cr#L17","def":{"name":"parse","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""},{"name":"renderer","doc":null,"default_value":"","external_name":"renderer","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parser = Parser.new(text, renderer)\nparser.parse\n"}},{"id":"to_html(text):String-class-method","html_id":"to_html(text):String-class-method","name":"to_html","doc":null,"summary":null,"abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"args_string":"(text) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown.cr#L22","def":{"name":"to_html","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  parse(text, Markdown::HTMLRenderer.new(io))\nend"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Markdown/HTMLRenderer","path":"Markdown/HTMLRenderer.html","kind":"class","full_name":"Markdown::HTMLRenderer","name":"HTMLRenderer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Markdown/Renderer","kind":"module","full_name":"Markdown::Renderer","name":"Renderer"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown/html_renderer.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Markdown/Renderer","kind":"module","full_name":"Markdown::Renderer","name":"Renderer"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown","kind":"class","full_name":"Markdown","name":"Markdown"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L6","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"begin_bold-instance-method","html_id":"begin_bold-instance-method","name":"begin_bold","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L25","def":{"name":"begin_bold","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<strong>\""}},{"id":"begin_code(language)-instance-method","html_id":"begin_code(language)-instance-method","name":"begin_code","doc":null,"summary":null,"abstract":false,"args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":""}],"args_string":"(language)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L53","def":{"name":"begin_code","args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if language.nil?\n  @io << \"<pre><code>\"\nelse\n  @io << \"<pre><code class=\\\"language-#{language}\\\">\"\nend"}},{"id":"begin_header(level)-instance-method","html_id":"begin_header(level)-instance-method","name":"begin_header","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L33","def":{"name":"begin_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<h\"\n@io << level\n@io << '>'\n"}},{"id":"begin_inline_code-instance-method","html_id":"begin_inline_code-instance-method","name":"begin_inline_code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L45","def":{"name":"begin_inline_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<code>\""}},{"id":"begin_italic-instance-method","html_id":"begin_italic-instance-method","name":"begin_italic","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L17","def":{"name":"begin_italic","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<em>\""}},{"id":"begin_link(url)-instance-method","html_id":"begin_link(url)-instance-method","name":"begin_link","doc":null,"summary":null,"abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""}],"args_string":"(url)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L97","def":{"name":"begin_link","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<a href=\\\"\"\n@io << url\n@io << \"\\\">\"\n"}},{"id":"begin_list_item-instance-method","html_id":"begin_list_item-instance-method","name":"begin_list_item","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L89","def":{"name":"begin_list_item","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<li>\""}},{"id":"begin_ordered_list-instance-method","html_id":"begin_ordered_list-instance-method","name":"begin_ordered_list","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L81","def":{"name":"begin_ordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<ol>\""}},{"id":"begin_paragraph-instance-method","html_id":"begin_paragraph-instance-method","name":"begin_paragraph","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L9","def":{"name":"begin_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<p>\""}},{"id":"begin_quote-instance-method","html_id":"begin_quote-instance-method","name":"begin_quote","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L65","def":{"name":"begin_quote","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<blockquote>\""}},{"id":"begin_unordered_list-instance-method","html_id":"begin_unordered_list-instance-method","name":"begin_unordered_list","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L73","def":{"name":"begin_unordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<ul>\""}},{"id":"end_bold-instance-method","html_id":"end_bold-instance-method","name":"end_bold","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L29","def":{"name":"end_bold","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</strong>\""}},{"id":"end_code-instance-method","html_id":"end_code-instance-method","name":"end_code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L61","def":{"name":"end_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</code></pre>\""}},{"id":"end_header(level)-instance-method","html_id":"end_header(level)-instance-method","name":"end_header","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L39","def":{"name":"end_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</h\"\n@io << level\n@io << '>'\n"}},{"id":"end_inline_code-instance-method","html_id":"end_inline_code-instance-method","name":"end_inline_code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L49","def":{"name":"end_inline_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</code>\""}},{"id":"end_italic-instance-method","html_id":"end_italic-instance-method","name":"end_italic","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L21","def":{"name":"end_italic","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</em>\""}},{"id":"end_link-instance-method","html_id":"end_link-instance-method","name":"end_link","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L103","def":{"name":"end_link","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</a>\""}},{"id":"end_list_item-instance-method","html_id":"end_list_item-instance-method","name":"end_list_item","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L93","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L93","def":{"name":"end_list_item","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</li>\""}},{"id":"end_ordered_list-instance-method","html_id":"end_ordered_list-instance-method","name":"end_ordered_list","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L85","def":{"name":"end_ordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</ol>\""}},{"id":"end_paragraph-instance-method","html_id":"end_paragraph-instance-method","name":"end_paragraph","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L13","def":{"name":"end_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</p>\""}},{"id":"end_quote-instance-method","html_id":"end_quote-instance-method","name":"end_quote","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L69","def":{"name":"end_quote","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</blockquote>\""}},{"id":"end_unordered_list-instance-method","html_id":"end_unordered_list-instance-method","name":"end_unordered_list","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L77","def":{"name":"end_unordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"</ul>\""}},{"id":"horizontal_rule-instance-method","html_id":"horizontal_rule-instance-method","name":"horizontal_rule","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L119","def":{"name":"horizontal_rule","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<hr/>\""}},{"id":"image(url,alt)-instance-method","html_id":"image(url,alt)-instance-method","name":"image","doc":null,"summary":null,"abstract":false,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"alt","doc":null,"default_value":"","external_name":"alt","restriction":""}],"args_string":"(url, alt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L107","def":{"name":"image","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"alt","doc":null,"default_value":"","external_name":"alt","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << \"<img src=\\\"\"\n@io << url\n@io << \"\\\" alt=\\\"\"\n@io << alt\n@io << \"\\\"/>\"\n"}},{"id":"text(text)-instance-method","html_id":"text(text)-instance-method","name":"text","doc":null,"summary":null,"abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"args_string":"(text)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/html_renderer.cr#L115","def":{"name":"text","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io << (text.gsub('<', \"&lt;\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser","path":"Markdown/Parser.html","kind":"class","full_name":"Markdown::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown/parser.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown","kind":"class","full_name":"Markdown","name":"Markdown"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(text:String,renderer:Renderer)-class-method","html_id":"new(text:String,renderer:Renderer)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"},{"name":"renderer","doc":null,"default_value":"","external_name":"renderer","restriction":"Renderer"}],"args_string":"(text : String, renderer : Renderer)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L8","def":{"name":"new","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"},{"name":"renderer","doc":null,"default_value":"","external_name":"renderer","restriction":"Renderer"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(text, renderer)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"append_double_newline_if_has_more-instance-method","html_id":"append_double_newline_if_has_more-instance-method","name":"append_double_newline_if_has_more","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L287","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L287","def":{"name":"append_double_newline_if_has_more","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @line < @lines.size\n  newline\n  newline\nend"}},{"id":"check_link(str,pos,bytesize)-instance-method","html_id":"check_link(str,pos,bytesize)-instance-method","name":"check_link","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"args_string":"(str, pos, bytesize)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L432","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L432","def":{"name":"check_link","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bracket_count = 1\nwhile pos < bytesize\n  case str[pos].unsafe_chr\n  when '['\n    bracket_count = bracket_count + 1\n  when ']'\n    bracket_count = bracket_count - 1\n    if bracket_count == 0\n      break\n    end\n  end\n  pos = pos + 1\nend\nif bracket_count == 0\nelse\n  return nil\nend\nbracket_idx = pos\nif str[bracket_idx + 1] === '('\nelse\n  return nil\nend\nparen_idx = (((str + bracket_idx) + 1).to_slice((bytesize - bracket_idx) - 1)).index(')'.ord)\nif paren_idx\nelse\n  return nil\nend\nString.new(Slice.new((str + bracket_idx) + 2, paren_idx - 1))\n"}},{"id":"classify(line)-instance-method","html_id":"classify(line)-instance-method","name":"classify","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L48","def":{"name":"classify","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?(line)\n  return :empty\nend\nif pounds = count_pounds(line)\n  return PrefixHeader.new(pounds)\nend\nif line.starts_with?(\"    \")\n  return :code\nend\nif horizontal_rule?(line)\n  return :horizontal_rule\nend\nif starts_with_bullet_list_marker?(line, '*')\n  return UnorderedList.new('*')\nend\nif starts_with_bullet_list_marker?(line, '+')\n  return UnorderedList.new('+')\nend\nif starts_with_bullet_list_marker?(line, '-')\n  return UnorderedList.new('-')\nend\nif (code_fence = code_fence?(line))\n  return code_fence\nend\nif starts_with_digits_dot?(line)\n  return :ordered_list\nend\nif line.starts_with?(\">\")\n  return :quote\nend\nif next_line_is_all?('=')\n  return :header1\nend\nif next_line_is_all?('-')\n  return :header2\nend\nnil\n"}},{"id":"code_fence?(line)-instance-method","html_id":"code_fence?(line)-instance-method","name":"code_fence?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L529","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L529","def":{"name":"code_fence?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if line.starts_with?(\"```\")\nelse\n  return nil\nend\nlanguage = (line.lstrip('`')).strip\nif language.includes?('`')\n  return nil\nend\nCodeFence.new(language)\n"}},{"id":"count_pounds(line)-instance-method","html_id":"count_pounds(line)-instance-method","name":"count_pounds","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L475","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L475","def":{"name":"count_pounds","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = 0\nwhile (pos < bytesize && pos < 6) && (str[pos].unsafe_chr == '#')\n  pos = pos + 1\nend\npos == 0 ? nil : pos\n"}},{"id":"empty?(line)-instance-method","html_id":"empty?(line)-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L415","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L415","def":{"name":"empty?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line_is_all?(line, ' ')"}},{"id":"has_closing?(char,count,str,pos,bytesize)-instance-method","html_id":"has_closing?(char,count,str,pos,bytesize)-instance-method","name":"has_closing?","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""},{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"args_string":"(char, count, str, pos, bytesize)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L419","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L419","def":{"name":"has_closing?","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""},{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"","external_name":"pos","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"str = str + pos\nbytesize = bytesize - pos\nidx = (str.to_slice(bytesize)).index(char.ord)\nif idx\nelse\n  return false\nend\nif count == 2\n  if (idx + 1) < bytesize && (str[idx + 1].unsafe_chr == char)\n  else\n    return false\n  end\nend\n!str[idx - 1].unsafe_chr.ascii_whitespace?\n"}},{"id":"has_code_spaces?(line)-instance-method","html_id":"has_code_spaces?(line)-instance-method","name":"has_code_spaces?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L485","def":{"name":"has_code_spaces?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = 0\nwhile (pos < bytesize && pos < 4) && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\nif pos < 4\n  pos == bytesize\nelse\n  true\nend\n"}},{"id":"horizontal_rule?(line)-instance-method","html_id":"horizontal_rule?(line)-instance-method","name":"horizontal_rule?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L575","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L575","def":{"name":"horizontal_rule?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"non_space_char = nil\ncount = 1\nline.each_char do |char|\n  if char.ascii_whitespace?\n    next\n  end\n  if non_space_char\n    if char == non_space_char\n      count = count + 1\n    else\n      return false\n    end\n  else\n    case char\n    when '*', '-', '_'\n      non_space_char = char\n    else\n      return false\n    end\n  end\nend\ncount >= 3\n"}},{"id":"join_next_lines(continue_on=:none,stop_on=:none)-instance-method","html_id":"join_next_lines(continue_on=:none,stop_on=:none)-instance-method","name":"join_next_lines","doc":"Join this line with next lines if they form a paragraph,\nuntil next lines don't start another entity like a list,\nheader, etc.","summary":"<p>Join this line with next lines if they form a paragraph, until next lines don't start another entity like a list, header, etc.</p>","abstract":false,"args":[{"name":"continue_on","doc":null,"default_value":":none","external_name":"continue_on","restriction":""},{"name":"stop_on","doc":null,"default_value":":none","external_name":"stop_on","restriction":""}],"args_string":"(continue_on = <span class=\"n\">:none</span>, stop_on = <span class=\"n\">:none</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L613","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L613","def":{"name":"join_next_lines","args":[{"name":"continue_on","doc":null,"default_value":":none","external_name":"continue_on","restriction":""},{"name":"stop_on","doc":null,"default_value":":none","external_name":"stop_on","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"start = @line\nline = @line\nline = line + 1\nwhile line < @lines.size\n  item = classify(@lines[line])\n  case item\n  when continue_on\n  when stop_on\n    line = line - 1\n    break\n  when nil\n  else\n    line = line - 1\n    break\n  end\n  line = line + 1\nend\nif line == @lines.size\n  line = line - 1\nend\nif line > start\n  @lines[line] = (start..line).join('\\n') do |i|\n    @lines[i]\n  end\n  @line = line\nend\n"}},{"id":"line_is_all?(line,char)-instance-method","html_id":"line_is_all?(line,char)-instance-method","name":"line_is_all?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""}],"args_string":"(line, char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L468","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L468","def":{"name":"line_is_all?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line.each_byte do |byte|\n  if byte != char.ord\n    return false\n  end\nend\ntrue\n"}},{"id":"newline-instance-method","html_id":"newline-instance-method","name":"newline","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L606","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L606","def":{"name":"newline","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.text(\"\\n\")"}},{"id":"next_line_is_all?(char)-instance-method","html_id":"next_line_is_all?(char)-instance-method","name":"next_line_is_all?","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""}],"args_string":"(char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L459","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L459","def":{"name":"next_line_is_all?","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@line + 1) < @lines.size\nelse\n  return false\nend\nline = @lines[@line + 1]\nif line.empty?\n  return false\nend\nline_is_all?(line, char)\n"}},{"id":"next_line_is_not_intended?-instance-method","html_id":"next_line_is_not_intended?-instance-method","name":"next_line_is_not_intended?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L522","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L522","def":{"name":"next_line_is_not_intended?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@line + 1) < @lines.size\nelse\n  return true\nend\nnext_line = @lines[@line + 1]\n!(next_line.starts_with?(\"  \"))\n"}},{"id":"next_lines_empty_of_code?-instance-method","html_id":"next_lines_empty_of_code?-instance-method","name":"next_lines_empty_of_code?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L555","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L555","def":{"name":"next_lines_empty_of_code?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line_number = @line\nwhile line_number < @lines.size\n  line = @lines[line_number]\n  if empty?(line)\n  else\n    if has_code_spaces?(line)\n      return false\n    else\n      return true\n    end\n  end\n  line_number = line_number + 1\nend\nreturn true\n"}},{"id":"parse-instance-method","html_id":"parse-instance-method","name":"parse","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L13","def":{"name":"parse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"while @line < @lines.size\n  process_paragraph\nend"}},{"id":"previous_line_is_not_intended_and_starts_with_bullet_list_marker?(prefix)-instance-method","html_id":"previous_line_is_not_intended_and_starts_with_bullet_list_marker?(prefix)-instance-method","name":"previous_line_is_not_intended_and_starts_with_bullet_list_marker?","doc":null,"summary":null,"abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""}],"args_string":"(prefix)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L517","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L517","def":{"name":"previous_line_is_not_intended_and_starts_with_bullet_list_marker?","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"previous_line = @lines[@line - 1]\n(!(previous_line.starts_with?(\"  \"))) && (starts_with_bullet_list_marker?(previous_line, prefix))\n"}},{"id":"process_line(line)-instance-method","html_id":"process_line(line)-instance-method","name":"process_line","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L294","def":{"name":"process_line","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = 0\nwhile pos < bytesize && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\ncursor = pos\none_star = false\ntwo_stars = false\none_underscore = false\ntwo_underscores = false\none_backtick = false\nin_link = false\nlast_is_space = true\nwhile pos < bytesize\n  case str[pos].unsafe_chr\n  when '*'\n    if (pos + 1) < bytesize && (str[pos + 1].unsafe_chr == '*')\n      if two_stars || (has_closing?('*', 2, str, (      pos + 2), bytesize))\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        pos = pos + 1\n        cursor = pos + 1\n        if two_stars\n          @renderer.end_bold\n        else\n          @renderer.begin_bold\n        end\n        two_stars = !two_stars\n      end\n    else\n      if one_star || (has_closing?('*', 1, str, (      pos + 1), bytesize))\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        cursor = pos + 1\n        if one_star\n          @renderer.end_italic\n        else\n          @renderer.begin_italic\n        end\n        one_star = !one_star\n      end\n    end\n  when '_'\n    if (pos + 1) < bytesize && (str[pos + 1].unsafe_chr == '_')\n      if two_underscores || (last_is_space && (has_closing?('_', 2, str, (      pos + 2), bytesize)))\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        pos = pos + 1\n        cursor = pos + 1\n        if two_underscores\n          @renderer.end_bold\n        else\n          @renderer.begin_bold\n        end\n        two_underscores = !two_underscores\n      end\n    else\n      if one_underscore || (last_is_space && (has_closing?('_', 1, str, (      pos + 1), bytesize)))\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        cursor = pos + 1\n        if one_underscore\n          @renderer.end_italic\n        else\n          @renderer.begin_italic\n        end\n        one_underscore = !one_underscore\n      end\n    end\n  when '`'\n    if one_backtick || (has_closing?('`', 1, str, (    pos + 1), bytesize))\n      @renderer.text(line.byte_slice(cursor, pos - cursor))\n      cursor = pos + 1\n      if one_backtick\n        @renderer.end_inline_code\n      else\n        @renderer.begin_inline_code\n      end\n      one_backtick = !one_backtick\n    end\n  when '!'\n    if (pos + 1) < bytesize && (str[pos + 1] === '[')\n      link = check_link(str, (      pos + 2), bytesize)\n      if link\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        bracket_idx = ((((str + pos) + 2).to_slice((bytesize - pos) - 2)).index(']'.ord)).not_nil!\n        alt = line.byte_slice(pos + 2, bracket_idx)\n        @renderer.image(link, alt)\n        paren_idx = ((((((str + pos) + 2) + bracket_idx) + 1).to_slice((((bytesize - pos) - 2) - bracket_idx) - 1)).index(')'.ord)).not_nil!\n        pos = pos + (((2 + bracket_idx) + 1) + paren_idx)\n        cursor = pos + 1\n      end\n    end\n  when '['\n    if in_link\n    else\n      link = check_link(str, (      pos + 1), bytesize)\n      if link\n        @renderer.text(line.byte_slice(cursor, pos - cursor))\n        cursor = pos + 1\n        @renderer.begin_link(link)\n        in_link = true\n      end\n    end\n  when ']'\n    if in_link\n      @renderer.text(line.byte_slice(cursor, pos - cursor))\n      @renderer.end_link\n      paren_idx = ((((str + pos) + 1).to_slice((bytesize - pos) - 1)).index(')'.ord)).not_nil!\n      pos = pos + (paren_idx + 1)\n      cursor = pos + 1\n      in_link = false\n    end\n  end\n  last_is_space = pos < bytesize && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\n@renderer.text(line.byte_slice(cursor, pos - cursor))\n"}},{"id":"process_paragraph-instance-method","html_id":"process_paragraph-instance-method","name":"process_paragraph","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L19","def":{"name":"process_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line = @lines[@line]\ncase item = classify(line)\nwhen :empty\n  @line = @line + 1\nwhen :header1\n  render_header(1, line, 2)\nwhen :header2\n  render_header(2, line, 2)\nwhen PrefixHeader\n  render_prefix_header(item.count, line)\nwhen :code\n  render_code\nwhen :horizontal_rule\n  render_horizontal_rule\nwhen UnorderedList\n  render_unordered_list(item.char)\nwhen CodeFence\n  render_fenced_code(item.language)\nwhen :ordered_list\n  render_ordered_list\nwhen :quote\n  render_quote\nelse\n  render_paragraph\nend\n"}},{"id":"render_code-instance-method","html_id":"render_code-instance-method","name":"render_code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L132","def":{"name":"render_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_code(nil)\nwhile true\n  line = @lines[@line]\n  if has_code_spaces?(line)\n  else\n    break\n  end\n  @renderer.text(line.byte_slice(Math.min(line.bytesize, 4)))\n  @line = @line + 1\n  if @line == @lines.size\n    break\n  end\n  if next_lines_empty_of_code?\n    break\n  end\n  newline\nend\n@renderer.end_code\nappend_double_newline_if_has_more\n"}},{"id":"render_fenced_code(language:String)-instance-method","html_id":"render_fenced_code(language:String)-instance-method","name":"render_fenced_code","doc":null,"summary":null,"abstract":false,"args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":"String"}],"args_string":"(language : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L159","def":{"name":"render_fenced_code","args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line = @lines[@line]\nif language.empty?\n  @renderer.begin_code(nil)\nelse\n  @renderer.begin_code(language)\nend\n@line = @line + 1\nif @line < @lines.size\n  while true\n    line = @lines[@line]\n    @renderer.text(line)\n    @line = @line + 1\n    if (    @line == @lines.size)\n      break\n    end\n    if code_fence?(@lines[@line])\n      @line = @line + 1\n      break\n    end\n    newline\n  end\nend\n@renderer.end_code\nappend_double_newline_if_has_more\n"}},{"id":"render_header(level,line,increment)-instance-method","html_id":"render_header(level,line,increment)-instance-method","name":"render_header","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"increment","doc":null,"default_value":"","external_name":"increment","restriction":""}],"args_string":"(level, line, increment)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L111","def":{"name":"render_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"increment","doc":null,"default_value":"","external_name":"increment","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_header(level)\nprocess_line(line)\n@renderer.end_header(level)\n@line = @line + increment\nappend_double_newline_if_has_more\n"}},{"id":"render_horizontal_rule-instance-method","html_id":"render_horizontal_rule-instance-method","name":"render_horizontal_rule","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L601","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L601","def":{"name":"render_horizontal_rule","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.horizontal_rule\n@line = @line + 1\n"}},{"id":"render_ordered_list-instance-method","html_id":"render_ordered_list-instance-method","name":"render_ordered_list","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L253","def":{"name":"render_ordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_ordered_list\nwhile true\n  if starts_with_digits_dot?(@lines[@line])\n  else\n    break\n  end\n  join_next_lines(continue_on: nil, stop_on: :ordered_list)\n  line = @lines[@line]\n  if empty?(line)\n    @line = @line + 1\n    if @line == @lines.size\n      break\n    end\n    next\n  end\n  @renderer.begin_list_item\n  process_line(line.byte_slice((line.index('.')).not_nil! + 1))\n  @renderer.end_list_item\n  @line = @line + 1\n  if @line == @lines.size\n    break\n  end\nend\n@renderer.end_ordered_list\nappend_double_newline_if_has_more\n"}},{"id":"render_paragraph-instance-method","html_id":"render_paragraph-instance-method","name":"render_paragraph","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L120","def":{"name":"render_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_paragraph\njoin_next_lines(continue_on: nil)\nprocess_line(@lines[@line])\n@line = @line + 1\n@renderer.end_paragraph\nappend_double_newline_if_has_more\n"}},{"id":"render_prefix_header(level,line)-instance-method","html_id":"render_prefix_header(level,line)-instance-method","name":"render_prefix_header","doc":null,"summary":null,"abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(level, line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L100","def":{"name":"render_prefix_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""},{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = level\nwhile pos < bytesize && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\nrender_header(level, line.byte_slice(pos), 1)\n"}},{"id":"render_quote-instance-method","html_id":"render_quote-instance-method","name":"render_quote","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L195","def":{"name":"render_quote","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_quote\njoin_next_lines(continue_on: :quote)\nline = @lines[@line]\nprocess_line(line.byte_slice((line.index('>')).not_nil! + 1))\n@line = @line + 1\n@renderer.end_quote\nappend_double_newline_if_has_more\n"}},{"id":"render_unordered_list(prefix=&#39;*&#39;)-instance-method","html_id":"render_unordered_list(prefix=&amp;#39;*&amp;#39;)-instance-method","name":"render_unordered_list","doc":null,"summary":null,"abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"'*'","external_name":"prefix","restriction":""}],"args_string":"(prefix = <span class=\"s\">&#39;*&#39;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L210","def":{"name":"render_unordered_list","args":[{"name":"prefix","doc":null,"default_value":"'*'","external_name":"prefix","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@renderer.begin_unordered_list\nwhile true\n  if starts_with_bullet_list_marker?(@lines[@line], prefix)\n  else\n    break\n  end\n  join_next_lines(continue_on: nil, stop_on: UnorderedList.new(prefix))\n  line = @lines[@line]\n  if empty?(line)\n    @line = @line + 1\n    if @line == @lines.size\n      break\n    end\n    next\n  end\n  if (line.starts_with?(\"  \")) && (previous_line_is_not_intended_and_starts_with_bullet_list_marker?(prefix))\n    @renderer.begin_unordered_list\n  end\n  @renderer.begin_list_item\n  process_line(line.byte_slice((line.index(prefix)).not_nil! + 1))\n  @renderer.end_list_item\n  if (line.starts_with?(\"  \")) && next_line_is_not_intended?\n    @renderer.end_unordered_list\n  end\n  @line = @line + 1\n  if @line == @lines.size\n    break\n  end\nend\n@renderer.end_unordered_list\nappend_double_newline_if_has_more\n"}},{"id":"starts_with_bullet_list_marker?(line,prefix=nil)-instance-method","html_id":"starts_with_bullet_list_marker?(line,prefix=nil)-instance-method","name":"starts_with_bullet_list_marker?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"prefix","doc":null,"default_value":"nil","external_name":"prefix","restriction":""}],"args_string":"(line, prefix = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L500","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L500","def":{"name":"starts_with_bullet_list_marker?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""},{"name":"prefix","doc":null,"default_value":"nil","external_name":"prefix","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = 0\nwhile pos < bytesize && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\nif pos < bytesize\nelse\n  return false\nend\nif prefix ? str[pos].unsafe_chr == prefix : (((str[pos].unsafe_chr == '*') || (str[pos].unsafe_chr == '-')) || (str[pos].unsafe_chr == '+'))\nelse\n  return false\nend\npos = pos + 1\nif pos < bytesize\nelse\n  return false\nend\nstr[pos].unsafe_chr.ascii_whitespace?\n"}},{"id":"starts_with_digits_dot?(line)-instance-method","html_id":"starts_with_digits_dot?(line)-instance-method","name":"starts_with_digits_dot?","doc":null,"summary":null,"abstract":false,"args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"args_string":"(line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L536","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L536","def":{"name":"starts_with_digits_dot?","args":[{"name":"line","doc":null,"default_value":"","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize = line.bytesize\nstr = line.to_unsafe\npos = 0\nwhile pos < bytesize && str[pos].unsafe_chr.ascii_whitespace?\n  pos = pos + 1\nend\nif pos < bytesize\nelse\n  return false\nend\nif str[pos].unsafe_chr.ascii_number?\nelse\n  return false\nend\nwhile pos < bytesize && str[pos].unsafe_chr.ascii_number?\n  pos = pos + 1\nend\nif pos < bytesize\nelse\n  return false\nend\nstr[pos].unsafe_chr == '.'\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/CodeFence","path":"Markdown/Parser/CodeFence.html","kind":"struct","full_name":"Markdown::Parser::CodeFence","name":"CodeFence","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown/parser.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser","kind":"class","full_name":"Markdown::Parser","name":"Parser"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(language:String)-class-method","html_id":"new(language:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":"String"}],"args_string":"(language : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","def":{"name":"new","args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(language)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CodeFence.new(@language.clone)"}},{"id":"copy_with(language_language=@language)-instance-method","html_id":"copy_with(language_language=@language)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_language","doc":null,"default_value":"@language","external_name":"language","restriction":""}],"args_string":"(language _language = @language)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L4","def":{"name":"copy_with","args":[{"name":"_language","doc":null,"default_value":"@language","external_name":"language","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CodeFence.new(_language)"}},{"id":"language:String-instance-method","html_id":"language:String-instance-method","name":"language","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":null,"source_link":null,"def":{"name":"language","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@language"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/PrefixHeader","path":"Markdown/Parser/PrefixHeader.html","kind":"struct","full_name":"Markdown::Parser::PrefixHeader","name":"PrefixHeader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown/parser.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser","kind":"class","full_name":"Markdown::Parser","name":"Parser"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(count:Int32)-class-method","html_id":"new(count:Int32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int32"}],"args_string":"(count : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","def":{"name":"new","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(count)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"PrefixHeader.new(@count.clone)"}},{"id":"copy_with(count_count=@count)-instance-method","html_id":"copy_with(count_count=@count)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_count","doc":null,"default_value":"@count","external_name":"count","restriction":""}],"args_string":"(count _count = @count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L2","def":{"name":"copy_with","args":[{"name":"_count","doc":null,"default_value":"@count","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"PrefixHeader.new(_count)"}},{"id":"count:Int32-instance-method","html_id":"count:Int32-instance-method","name":"count","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":null,"source_link":null,"def":{"name":"count","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@count"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/UnorderedList","path":"Markdown/Parser/UnorderedList.html","kind":"struct","full_name":"Markdown::Parser::UnorderedList","name":"UnorderedList","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"markdown/parser.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser","kind":"class","full_name":"Markdown::Parser","name":"Parser"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(char:Char)-class-method","html_id":"new(char:Char)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","def":{"name":"new","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"char:Char-instance-method","html_id":"char:Char-instance-method","name":"char","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Char","source_link":null,"source_link":null,"def":{"name":"char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"@char"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UnorderedList.new(@char.clone)"}},{"id":"copy_with(char_char=@char)-instance-method","html_id":"copy_with(char_char=@char)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_char","doc":null,"default_value":"@char","external_name":"char","restriction":""}],"args_string":"(char _char = @char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/parser.cr#L3","def":{"name":"copy_with","args":[{"name":"_char","doc":null,"default_value":"@char","external_name":"char","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UnorderedList.new(_char)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Markdown/Renderer","path":"Markdown/Renderer.html","kind":"module","full_name":"Markdown::Renderer","name":"Renderer","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"markdown/renderer.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Markdown/HTMLRenderer","kind":"class","full_name":"Markdown::HTMLRenderer","name":"HTMLRenderer"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Markdown","kind":"class","full_name":"Markdown","name":"Markdown"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"begin_bold-instance-method","html_id":"begin_bold-instance-method","name":"begin_bold","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L6","def":{"name":"begin_bold","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_code(language)-instance-method","html_id":"begin_code(language)-instance-method","name":"begin_code","doc":null,"summary":null,"abstract":true,"args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":""}],"args_string":"(language)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L12","def":{"name":"begin_code","args":[{"name":"language","doc":null,"default_value":"","external_name":"language","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_header(level)-instance-method","html_id":"begin_header(level)-instance-method","name":"begin_header","doc":null,"summary":null,"abstract":true,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L8","def":{"name":"begin_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_inline_code-instance-method","html_id":"begin_inline_code-instance-method","name":"begin_inline_code","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L10","def":{"name":"begin_inline_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_italic-instance-method","html_id":"begin_italic-instance-method","name":"begin_italic","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L4","def":{"name":"begin_italic","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_link(url)-instance-method","html_id":"begin_link(url)-instance-method","name":"begin_link","doc":null,"summary":null,"abstract":true,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""}],"args_string":"(url)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L22","def":{"name":"begin_link","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_list_item-instance-method","html_id":"begin_list_item-instance-method","name":"begin_list_item","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L20","def":{"name":"begin_list_item","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_ordered_list-instance-method","html_id":"begin_ordered_list-instance-method","name":"begin_ordered_list","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L18","def":{"name":"begin_ordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_paragraph-instance-method","html_id":"begin_paragraph-instance-method","name":"begin_paragraph","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L2","def":{"name":"begin_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_quote-instance-method","html_id":"begin_quote-instance-method","name":"begin_quote","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L14","def":{"name":"begin_quote","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"begin_unordered_list-instance-method","html_id":"begin_unordered_list-instance-method","name":"begin_unordered_list","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L16","def":{"name":"begin_unordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_bold-instance-method","html_id":"end_bold-instance-method","name":"end_bold","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L7","def":{"name":"end_bold","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_code-instance-method","html_id":"end_code-instance-method","name":"end_code","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L13","def":{"name":"end_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_header(level)-instance-method","html_id":"end_header(level)-instance-method","name":"end_header","doc":null,"summary":null,"abstract":true,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"args_string":"(level)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L9","def":{"name":"end_header","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_inline_code-instance-method","html_id":"end_inline_code-instance-method","name":"end_inline_code","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L11","def":{"name":"end_inline_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_italic-instance-method","html_id":"end_italic-instance-method","name":"end_italic","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L5","def":{"name":"end_italic","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_link-instance-method","html_id":"end_link-instance-method","name":"end_link","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L23","def":{"name":"end_link","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_list_item-instance-method","html_id":"end_list_item-instance-method","name":"end_list_item","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L21","def":{"name":"end_list_item","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_ordered_list-instance-method","html_id":"end_ordered_list-instance-method","name":"end_ordered_list","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L19","def":{"name":"end_ordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_paragraph-instance-method","html_id":"end_paragraph-instance-method","name":"end_paragraph","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L3","def":{"name":"end_paragraph","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_quote-instance-method","html_id":"end_quote-instance-method","name":"end_quote","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L15","def":{"name":"end_quote","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"end_unordered_list-instance-method","html_id":"end_unordered_list-instance-method","name":"end_unordered_list","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L17","def":{"name":"end_unordered_list","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"horizontal_rule-instance-method","html_id":"horizontal_rule-instance-method","name":"horizontal_rule","doc":null,"summary":null,"abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L26","def":{"name":"horizontal_rule","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"image(url,alt)-instance-method","html_id":"image(url,alt)-instance-method","name":"image","doc":null,"summary":null,"abstract":true,"args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"alt","doc":null,"default_value":"","external_name":"alt","restriction":""}],"args_string":"(url, alt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L24","def":{"name":"image","args":[{"name":"url","doc":null,"default_value":"","external_name":"url","restriction":""},{"name":"alt","doc":null,"default_value":"","external_name":"alt","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"text(text)-instance-method","html_id":"text(text)-instance-method","name":"text","doc":null,"summary":null,"abstract":true,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"args_string":"(text)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/markdown/renderer.cr#L25","def":{"name":"text","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Math","path":"Math.html","kind":"module","full_name":"Math","name":"Math","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"math/math.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr"},{"filename":"big/big_int.cr","line_number":552,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr"},{"filename":"big/big_float.cr","line_number":288,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr"},{"filename":"big/big_rational.cr","line_number":275,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"E","name":"E","value":"LibM.exp_f64(1.0)","doc":null,"summary":null},{"id":"LOG10","name":"LOG10","value":"LibM.log_f64(10.0)","doc":null,"summary":null},{"id":"LOG2","name":"LOG2","value":"LibM.log_f64(2.0)","doc":null,"summary":null},{"id":"PI","name":"PI","value":"3.14159265358979323846","doc":null,"summary":null}],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Math","kind":"module","full_name":"Math","name":"Math"}],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"acos(value:Float32)-instance-method","html_id":"acos(value:Float32)-instance-method","name":"acos","doc":"Calculates the acos of *value*.","summary":"<p>Calculates the acos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.acos_f32(value)"}},{"id":"acos(value:Float64)-instance-method","html_id":"acos(value:Float64)-instance-method","name":"acos","doc":"Calculates the acos of *value*.","summary":"<p>Calculates the acos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.acos_f64(value)"}},{"id":"acos(value)-instance-method","html_id":"acos(value)-instance-method","name":"acos","doc":"Calculates the acos of *value*.","summary":"<p>Calculates the acos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"acos(value.to_f)"}},{"id":"acosh(value:Float32)-instance-method","html_id":"acosh(value:Float32)-instance-method","name":"acosh","doc":"Calculates the acosh of *value*.","summary":"<p>Calculates the acosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.acosh_f32(value)"}},{"id":"acosh(value:Float64)-instance-method","html_id":"acosh(value:Float64)-instance-method","name":"acosh","doc":"Calculates the acosh of *value*.","summary":"<p>Calculates the acosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.acosh_f64(value)"}},{"id":"acosh(value)-instance-method","html_id":"acosh(value)-instance-method","name":"acosh","doc":"Calculates the acosh of *value*.","summary":"<p>Calculates the acosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"acosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"acosh(value.to_f)"}},{"id":"asin(value:Float32)-instance-method","html_id":"asin(value:Float32)-instance-method","name":"asin","doc":"Calculates the asin of *value*.","summary":"<p>Calculates the asin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.asin_f32(value)"}},{"id":"asin(value:Float64)-instance-method","html_id":"asin(value:Float64)-instance-method","name":"asin","doc":"Calculates the asin of *value*.","summary":"<p>Calculates the asin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.asin_f64(value)"}},{"id":"asin(value)-instance-method","html_id":"asin(value)-instance-method","name":"asin","doc":"Calculates the asin of *value*.","summary":"<p>Calculates the asin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"asin(value.to_f)"}},{"id":"asinh(value:Float32)-instance-method","html_id":"asinh(value:Float32)-instance-method","name":"asinh","doc":"Calculates the asinh of *value*.","summary":"<p>Calculates the asinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.asinh_f32(value)"}},{"id":"asinh(value:Float64)-instance-method","html_id":"asinh(value:Float64)-instance-method","name":"asinh","doc":"Calculates the asinh of *value*.","summary":"<p>Calculates the asinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.asinh_f64(value)"}},{"id":"asinh(value)-instance-method","html_id":"asinh(value)-instance-method","name":"asinh","doc":"Calculates the asinh of *value*.","summary":"<p>Calculates the asinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"asinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"asinh(value.to_f)"}},{"id":"atan(value)-instance-method","html_id":"atan(value)-instance-method","name":"atan","doc":"Calculates the atan of *value*.","summary":"<p>Calculates the atan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"atan(value.to_f)"}},{"id":"atan(value:Float64)-instance-method","html_id":"atan(value:Float64)-instance-method","name":"atan","doc":"Calculates the atan of *value*.","summary":"<p>Calculates the atan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atan_f64(value)"}},{"id":"atan(value:Float32)-instance-method","html_id":"atan(value:Float32)-instance-method","name":"atan","doc":"Calculates the atan of *value*.","summary":"<p>Calculates the atan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atan_f32(value)"}},{"id":"atan2(value1:Float32,value2:Float32)-instance-method","html_id":"atan2(value1:Float32,value2:Float32)-instance-method","name":"atan2","doc":"Calculates atan2 with parameters *value1* and *value2*.","summary":"<p>Calculates atan2 with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"atan2","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atan2_f32(value1, value2)"}},{"id":"atan2(value1:Float64,value2:Float64)-instance-method","html_id":"atan2(value1:Float64,value2:Float64)-instance-method","name":"atan2","doc":"Calculates atan2 with parameters *value1* and *value2*.","summary":"<p>Calculates atan2 with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"atan2","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atan2_f64(value1, value2)"}},{"id":"atan2(value1,value2)-instance-method","html_id":"atan2(value1,value2)-instance-method","name":"atan2","doc":"Calculates atan2 with parameters *value1* and *value2*.","summary":"<p>Calculates atan2 with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"atan2","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"atan2(value1.to_f, value2.to_f)"}},{"id":"atanh(value:Float32)-instance-method","html_id":"atanh(value:Float32)-instance-method","name":"atanh","doc":"Calculates the atanh of *value*.","summary":"<p>Calculates the atanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atanh_f32(value)"}},{"id":"atanh(value:Float64)-instance-method","html_id":"atanh(value:Float64)-instance-method","name":"atanh","doc":"Calculates the atanh of *value*.","summary":"<p>Calculates the atanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.atanh_f64(value)"}},{"id":"atanh(value)-instance-method","html_id":"atanh(value)-instance-method","name":"atanh","doc":"Calculates the atanh of *value*.","summary":"<p>Calculates the atanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"atanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"atanh(value.to_f)"}},{"id":"besselj(value1:Int32,value2:Float64)-instance-method","html_id":"besselj(value1:Int32,value2:Float64)-instance-method","name":"besselj","doc":"Calculates besselj with parameters *value1* and *value2*.","summary":"<p>Calculates besselj with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Int32, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"besselj","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj_f64(value1, value2)"}},{"id":"besselj(value1:Int32,value2:Float32)-instance-method","html_id":"besselj(value1:Int32,value2:Float32)-instance-method","name":"besselj","doc":"Calculates besselj with parameters *value1* and *value2*.","summary":"<p>Calculates besselj with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Int32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"besselj","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj_f32(value1, value2)"}},{"id":"besselj(value1,value2)-instance-method","html_id":"besselj(value1,value2)-instance-method","name":"besselj","doc":"Calculates besselj with parameters *value1* and *value2*.","summary":"<p>Calculates besselj with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"besselj","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"besselj(value1.to_i32, value1.to_f)"}},{"id":"besselj0(value)-instance-method","html_id":"besselj0(value)-instance-method","name":"besselj0","doc":"Calculates the besselj0 function of *value*.","summary":"<p>Calculates the besselj0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"besselj0(value.to_f)"}},{"id":"besselj0(value:Float64)-instance-method","html_id":"besselj0(value:Float64)-instance-method","name":"besselj0","doc":"Calculates the besselj0 function of *value*.","summary":"<p>Calculates the besselj0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj0_f64(value)"}},{"id":"besselj0(value:Float32)-instance-method","html_id":"besselj0(value:Float32)-instance-method","name":"besselj0","doc":"Calculates the besselj0 function of *value*.","summary":"<p>Calculates the besselj0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj0_f32(value)"}},{"id":"besselj1(value)-instance-method","html_id":"besselj1(value)-instance-method","name":"besselj1","doc":"Calculates the besselj1 function of *value*.","summary":"<p>Calculates the besselj1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"besselj1(value.to_f)"}},{"id":"besselj1(value:Float64)-instance-method","html_id":"besselj1(value:Float64)-instance-method","name":"besselj1","doc":"Calculates the besselj1 function of *value*.","summary":"<p>Calculates the besselj1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj1_f64(value)"}},{"id":"besselj1(value:Float32)-instance-method","html_id":"besselj1(value:Float32)-instance-method","name":"besselj1","doc":"Calculates the besselj1 function of *value*.","summary":"<p>Calculates the besselj1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"besselj1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.besselj1_f32(value)"}},{"id":"bessely(value1:Int32,value2:Float32)-instance-method","html_id":"bessely(value1:Int32,value2:Float32)-instance-method","name":"bessely","doc":"Calculates bessely with parameters *value1* and *value2*.","summary":"<p>Calculates bessely with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Int32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"bessely","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely_f32(value1, value2)"}},{"id":"bessely(value1:Int32,value2:Float64)-instance-method","html_id":"bessely(value1:Int32,value2:Float64)-instance-method","name":"bessely","doc":"Calculates bessely with parameters *value1* and *value2*.","summary":"<p>Calculates bessely with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Int32, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"bessely","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Int32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely_f64(value1, value2)"}},{"id":"bessely(value1,value2)-instance-method","html_id":"bessely(value1,value2)-instance-method","name":"bessely","doc":"Calculates bessely with parameters *value1* and *value2*.","summary":"<p>Calculates bessely with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L143","def":{"name":"bessely","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bessely(value1.to_i32, value1.to_f)"}},{"id":"bessely0(value:Float64)-instance-method","html_id":"bessely0(value:Float64)-instance-method","name":"bessely0","doc":"Calculates the bessely0 function of *value*.","summary":"<p>Calculates the bessely0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely0_f64(value)"}},{"id":"bessely0(value)-instance-method","html_id":"bessely0(value)-instance-method","name":"bessely0","doc":"Calculates the bessely0 function of *value*.","summary":"<p>Calculates the bessely0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bessely0(value.to_f)"}},{"id":"bessely0(value:Float32)-instance-method","html_id":"bessely0(value:Float32)-instance-method","name":"bessely0","doc":"Calculates the bessely0 function of *value*.","summary":"<p>Calculates the bessely0 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely0","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely0_f32(value)"}},{"id":"bessely1(value)-instance-method","html_id":"bessely1(value)-instance-method","name":"bessely1","doc":"Calculates the bessely1 function of *value*.","summary":"<p>Calculates the bessely1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bessely1(value.to_f)"}},{"id":"bessely1(value:Float64)-instance-method","html_id":"bessely1(value:Float64)-instance-method","name":"bessely1","doc":"Calculates the bessely1 function of *value*.","summary":"<p>Calculates the bessely1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely1_f64(value)"}},{"id":"bessely1(value:Float32)-instance-method","html_id":"bessely1(value:Float32)-instance-method","name":"bessely1","doc":"Calculates the bessely1 function of *value*.","summary":"<p>Calculates the bessely1 function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L29","def":{"name":"bessely1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.bessely1_f32(value)"}},{"id":"cbrt(value)-instance-method","html_id":"cbrt(value)-instance-method","name":"cbrt","doc":"Calculates the cbrt of *value*.","summary":"<p>Calculates the cbrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cbrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cbrt(value.to_f)"}},{"id":"cbrt(value:Float64)-instance-method","html_id":"cbrt(value:Float64)-instance-method","name":"cbrt","doc":"Calculates the cbrt of *value*.","summary":"<p>Calculates the cbrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cbrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cbrt_f64(value)"}},{"id":"cbrt(value:Float32)-instance-method","html_id":"cbrt(value:Float32)-instance-method","name":"cbrt","doc":"Calculates the cbrt of *value*.","summary":"<p>Calculates the cbrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cbrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cbrt_f32(value)"}},{"id":"copysign(value1,value2)-instance-method","html_id":"copysign(value1,value2)-instance-method","name":"copysign","doc":"Calculates copysign with parameters *value1* and *value2*.","summary":"<p>Calculates copysign with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"copysign","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"copysign(value1.to_f, value2.to_f)"}},{"id":"copysign(value1:Float64,value2:Float64)-instance-method","html_id":"copysign(value1:Float64,value2:Float64)-instance-method","name":"copysign","doc":"Calculates copysign with parameters *value1* and *value2*.","summary":"<p>Calculates copysign with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"copysign","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.copysign_f64(value1, value2)"}},{"id":"copysign(value1:Float32,value2:Float32)-instance-method","html_id":"copysign(value1:Float32,value2:Float32)-instance-method","name":"copysign","doc":"Calculates copysign with parameters *value1* and *value2*.","summary":"<p>Calculates copysign with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"copysign","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.copysign_f32(value1, value2)"}},{"id":"cos(value:Float64)-instance-method","html_id":"cos(value:Float64)-instance-method","name":"cos","doc":"Calculates the cos of *value*.","summary":"<p>Calculates the cos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cos_f64(value)"}},{"id":"cos(value:Float32)-instance-method","html_id":"cos(value:Float32)-instance-method","name":"cos","doc":"Calculates the cos of *value*.","summary":"<p>Calculates the cos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cos_f32(value)"}},{"id":"cos(value)-instance-method","html_id":"cos(value)-instance-method","name":"cos","doc":"Calculates the cos of *value*.","summary":"<p>Calculates the cos of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cos","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cos(value.to_f)"}},{"id":"cosh(value:Float32)-instance-method","html_id":"cosh(value:Float32)-instance-method","name":"cosh","doc":"Calculates the cosh of *value*.","summary":"<p>Calculates the cosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cosh_f32(value)"}},{"id":"cosh(value:Float64)-instance-method","html_id":"cosh(value:Float64)-instance-method","name":"cosh","doc":"Calculates the cosh of *value*.","summary":"<p>Calculates the cosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.cosh_f64(value)"}},{"id":"cosh(value)-instance-method","html_id":"cosh(value)-instance-method","name":"cosh","doc":"Calculates the cosh of *value*.","summary":"<p>Calculates the cosh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"cosh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cosh(value.to_f)"}},{"id":"erf(value:Float32)-instance-method","html_id":"erf(value:Float32)-instance-method","name":"erf","doc":"Calculates the erf of *value*.","summary":"<p>Calculates the erf of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erf","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.erf_f32(value)"}},{"id":"erf(value:Float64)-instance-method","html_id":"erf(value:Float64)-instance-method","name":"erf","doc":"Calculates the erf of *value*.","summary":"<p>Calculates the erf of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erf","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.erf_f64(value)"}},{"id":"erf(value)-instance-method","html_id":"erf(value)-instance-method","name":"erf","doc":"Calculates the erf of *value*.","summary":"<p>Calculates the erf of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erf","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"erf(value.to_f)"}},{"id":"erfc(value:Float32)-instance-method","html_id":"erfc(value:Float32)-instance-method","name":"erfc","doc":"Calculates the erfc of *value*.","summary":"<p>Calculates the erfc of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erfc","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.erfc_f32(value)"}},{"id":"erfc(value:Float64)-instance-method","html_id":"erfc(value:Float64)-instance-method","name":"erfc","doc":"Calculates the erfc of *value*.","summary":"<p>Calculates the erfc of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erfc","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.erfc_f64(value)"}},{"id":"erfc(value)-instance-method","html_id":"erfc(value)-instance-method","name":"erfc","doc":"Calculates the erfc of *value*.","summary":"<p>Calculates the erfc of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"erfc","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"erfc(value.to_f)"}},{"id":"exp(value:Float32)-instance-method","html_id":"exp(value:Float32)-instance-method","name":"exp","doc":"Calculates the exp of *value*.","summary":"<p>Calculates the exp of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.exp_f32(value)"}},{"id":"exp(value:Float64)-instance-method","html_id":"exp(value:Float64)-instance-method","name":"exp","doc":"Calculates the exp of *value*.","summary":"<p>Calculates the exp of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.exp_f64(value)"}},{"id":"exp(value)-instance-method","html_id":"exp(value)-instance-method","name":"exp","doc":"Calculates the exp of *value*.","summary":"<p>Calculates the exp of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"exp(value.to_f)"}},{"id":"exp2(value:Float64)-instance-method","html_id":"exp2(value:Float64)-instance-method","name":"exp2","doc":"Calculates the exp2 of *value*.","summary":"<p>Calculates the exp2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.exp2_f64(value)"}},{"id":"exp2(value)-instance-method","html_id":"exp2(value)-instance-method","name":"exp2","doc":"Calculates the exp2 of *value*.","summary":"<p>Calculates the exp2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"exp2(value.to_f)"}},{"id":"exp2(value:Float32)-instance-method","html_id":"exp2(value:Float32)-instance-method","name":"exp2","doc":"Calculates the exp2 of *value*.","summary":"<p>Calculates the exp2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"exp2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.exp2_f32(value)"}},{"id":"expm1(value:Float32)-instance-method","html_id":"expm1(value:Float32)-instance-method","name":"expm1","doc":"Calculates the expm1 of *value*.","summary":"<p>Calculates the expm1 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"expm1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.expm1_f32(value)"}},{"id":"expm1(value:Float64)-instance-method","html_id":"expm1(value:Float64)-instance-method","name":"expm1","doc":"Calculates the expm1 of *value*.","summary":"<p>Calculates the expm1 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"expm1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.expm1_f64(value)"}},{"id":"expm1(value)-instance-method","html_id":"expm1(value)-instance-method","name":"expm1","doc":"Calculates the expm1 of *value*.","summary":"<p>Calculates the expm1 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"expm1","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expm1(value.to_f)"}},{"id":"frexp(value)-instance-method","html_id":"frexp(value)-instance-method","name":"frexp","doc":"Decomposes given floating point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes given floating point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L209","def":{"name":"frexp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"frexp(value.to_f)"}},{"id":"frexp(value:BigFloat)-instance-method","html_id":"frexp(value:BigFloat)-instance-method","name":"frexp","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigFloat"}],"args_string":"(value : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L289","def":{"name":"frexp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibGMP.mpf_get_d_2exp(out exp, value)\nfrac = BigFloat.new do |mpf|\n  if exp >= 0\n    LibGMP.mpf_div_2exp(mpf, value, exp)\n  else\n    LibGMP.mpf_mul_2exp(mpf, value, -exp)\n  end\nend\n{frac, exp}\n"}},{"id":"frexp(value:Float64)-instance-method","html_id":"frexp(value:Float64)-instance-method","name":"frexp","doc":"Decomposes given floating point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes given floating point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L203","def":{"name":"frexp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"frac = LibM.frexp_f64(value, out exp)\n{frac, exp}\n"}},{"id":"frexp(value:Float32)-instance-method","html_id":"frexp(value:Float32)-instance-method","name":"frexp","doc":"Decomposes given floating point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes given floating point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L197","def":{"name":"frexp","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"frac = LibM.frexp_f32(value, out exp)\n{frac, exp}\n"}},{"id":"gamma(value:Float64)-instance-method","html_id":"gamma(value:Float64)-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L59","def":{"name":"gamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tgamma_f64(value)"}},{"id":"gamma(value)-instance-method","html_id":"gamma(value)-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L64","def":{"name":"gamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"gamma(value.to_f)"}},{"id":"gamma(value:Float32)-instance-method","html_id":"gamma(value:Float32)-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L54","def":{"name":"gamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tgamma_f32(value)"}},{"id":"hypot(value1:Float32,value2:Float32)-instance-method","html_id":"hypot(value1:Float32,value2:Float32)-instance-method","name":"hypot","doc":"Calculates hypot with parameters *value1* and *value2*.","summary":"<p>Calculates hypot with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"hypot","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.hypot_f32(value1, value2)"}},{"id":"hypot(value1:Float64,value2:Float64)-instance-method","html_id":"hypot(value1:Float64,value2:Float64)-instance-method","name":"hypot","doc":"Calculates hypot with parameters *value1* and *value2*.","summary":"<p>Calculates hypot with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"hypot","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.hypot_f64(value1, value2)"}},{"id":"hypot(value1,value2)-instance-method","html_id":"hypot(value1,value2)-instance-method","name":"hypot","doc":"Calculates hypot with parameters *value1* and *value2*.","summary":"<p>Calculates hypot with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L95","def":{"name":"hypot","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hypot(value1.to_f, value2.to_f)"}},{"id":"ilogb(value:Float32)-instance-method","html_id":"ilogb(value:Float32)-instance-method","name":"ilogb","doc":"Calculates the ilogb of *value*.","summary":"<p>Calculates the ilogb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"ilogb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ilogb_f32(value)"}},{"id":"ilogb(value:Float64)-instance-method","html_id":"ilogb(value:Float64)-instance-method","name":"ilogb","doc":"Calculates the ilogb of *value*.","summary":"<p>Calculates the ilogb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"ilogb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ilogb_f64(value)"}},{"id":"ilogb(value)-instance-method","html_id":"ilogb(value)-instance-method","name":"ilogb","doc":"Calculates the ilogb of *value*.","summary":"<p>Calculates the ilogb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"ilogb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ilogb(value.to_f)"}},{"id":"ldexp(value1:Float32,value2:Int32)-instance-method","html_id":"ldexp(value1:Float32,value2:Int32)-instance-method","name":"ldexp","doc":"Calculates ldexp with parameters *value1* and *value2*.","summary":"<p>Calculates ldexp with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"args_string":"(value1 : Float32, value2 : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"ldexp","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ldexp_f32(value1, value2)"}},{"id":"ldexp(value1:Float64,value2:Int32)-instance-method","html_id":"ldexp(value1:Float64,value2:Int32)-instance-method","name":"ldexp","doc":"Calculates ldexp with parameters *value1* and *value2*.","summary":"<p>Calculates ldexp with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"args_string":"(value1 : Float64, value2 : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"ldexp","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.ldexp_f64(value1, value2)"}},{"id":"ldexp(value1,value2)-instance-method","html_id":"ldexp(value1,value2)-instance-method","name":"ldexp","doc":"Calculates ldexp with parameters *value1* and *value2*.","summary":"<p>Calculates ldexp with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"ldexp","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ldexp(value1.to_f, value2.to_i32)"}},{"id":"lgamma(value)-instance-method","html_id":"lgamma(value)-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis the same as\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L91","def":{"name":"lgamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"lgamma(value.to_f)"}},{"id":"lgamma(value:Float64)-instance-method","html_id":"lgamma(value:Float64)-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis the same as\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L86","def":{"name":"lgamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.gamma_f64(value)"}},{"id":"lgamma(value:Float32)-instance-method","html_id":"lgamma(value:Float32)-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis the same as\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L77","def":{"name":"lgamma","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if flag?(:darwin) %}\n      LibM.gamma_f64(value).to_f32\n    {% else %}\n      LibM.gamma_f32(value)\n    {% end %}"}},{"id":"log(numeric,base)-instance-method","html_id":"log(numeric,base)-instance-method","name":"log","doc":"Returns the logarithm of *numeric* to the base *base*.","summary":"<p>Returns the logarithm of <em>numeric</em> to the base <em>base</em>.</p>","abstract":false,"args":[{"name":"numeric","doc":null,"default_value":"","external_name":"numeric","restriction":""},{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":""}],"args_string":"(numeric, base)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L113","def":{"name":"log","args":[{"name":"numeric","doc":null,"default_value":"","external_name":"numeric","restriction":""},{"name":"base","doc":null,"default_value":"","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(log(numeric)) / (log(base))"}},{"id":"log(value:Float64)-instance-method","html_id":"log(value:Float64)-instance-method","name":"log","doc":"Calculates the log of *value*.","summary":"<p>Calculates the log of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log_f64(value)"}},{"id":"log(value)-instance-method","html_id":"log(value)-instance-method","name":"log","doc":"Calculates the log of *value*.","summary":"<p>Calculates the log of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log(value.to_f)"}},{"id":"log(value:Float32)-instance-method","html_id":"log(value:Float32)-instance-method","name":"log","doc":"Calculates the log of *value*.","summary":"<p>Calculates the log of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log_f32(value)"}},{"id":"log10(value:Float32)-instance-method","html_id":"log10(value:Float32)-instance-method","name":"log10","doc":"Calculates the log10 of *value*.","summary":"<p>Calculates the log10 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log10","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log10_f32(value)"}},{"id":"log10(value)-instance-method","html_id":"log10(value)-instance-method","name":"log10","doc":"Calculates the log10 of *value*.","summary":"<p>Calculates the log10 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log10","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log10(value.to_f)"}},{"id":"log10(value:Float64)-instance-method","html_id":"log10(value:Float64)-instance-method","name":"log10","doc":"Calculates the log10 of *value*.","summary":"<p>Calculates the log10 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log10","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log10_f64(value)"}},{"id":"log1p(value)-instance-method","html_id":"log1p(value)-instance-method","name":"log1p","doc":"Calculates the log1p of *value*.","summary":"<p>Calculates the log1p of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log1p","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log1p(value.to_f)"}},{"id":"log1p(value:Float64)-instance-method","html_id":"log1p(value:Float64)-instance-method","name":"log1p","doc":"Calculates the log1p of *value*.","summary":"<p>Calculates the log1p of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log1p","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log1p_f64(value)"}},{"id":"log1p(value:Float32)-instance-method","html_id":"log1p(value:Float32)-instance-method","name":"log1p","doc":"Calculates the log1p of *value*.","summary":"<p>Calculates the log1p of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log1p","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log1p_f32(value)"}},{"id":"log2(value)-instance-method","html_id":"log2(value)-instance-method","name":"log2","doc":"Calculates the log2 of *value*.","summary":"<p>Calculates the log2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"log2(value.to_f)"}},{"id":"log2(value:Float64)-instance-method","html_id":"log2(value:Float64)-instance-method","name":"log2","doc":"Calculates the log2 of *value*.","summary":"<p>Calculates the log2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log2_f64(value)"}},{"id":"log2(value:Float32)-instance-method","html_id":"log2(value:Float32)-instance-method","name":"log2","doc":"Calculates the log2 of *value*.","summary":"<p>Calculates the log2 of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"log2","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.log2_f32(value)"}},{"id":"logb(value)-instance-method","html_id":"logb(value)-instance-method","name":"logb","doc":"Calculates the logb of *value*.","summary":"<p>Calculates the logb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"logb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"logb(value.to_f)"}},{"id":"logb(value:Float64)-instance-method","html_id":"logb(value:Float64)-instance-method","name":"logb","doc":"Calculates the logb of *value*.","summary":"<p>Calculates the logb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"logb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.logb_f64(value)"}},{"id":"logb(value:Float32)-instance-method","html_id":"logb(value:Float32)-instance-method","name":"logb","doc":"Calculates the logb of *value*.","summary":"<p>Calculates the logb of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"logb","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.logb_f32(value)"}},{"id":"max(value1:Float64,value2:Float64)-instance-method","html_id":"max(value1:Float64,value2:Float64)-instance-method","name":"max","doc":null,"summary":null,"abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L121","def":{"name":"max","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.max_f64(value1, value2)"}},{"id":"max(value1,value2)-instance-method","html_id":"max(value1,value2)-instance-method","name":"max","doc":"Returns the greater of *value1* and *value2*.","summary":"<p>Returns the greater of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L126","def":{"name":"max","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value1 >= value2 ? value1 : value2"}},{"id":"max(value1:Float32,value2:Float32)-instance-method","html_id":"max(value1:Float32,value2:Float32)-instance-method","name":"max","doc":null,"summary":null,"abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L117","def":{"name":"max","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.max_f32(value1, value2)"}},{"id":"min(value1:Float32,value2:Float32)-instance-method","html_id":"min(value1:Float32,value2:Float32)-instance-method","name":"min","doc":null,"summary":null,"abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L130","def":{"name":"min","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.min_f32(value1, value2)"}},{"id":"min(value1:Float64,value2:Float64)-instance-method","html_id":"min(value1:Float64,value2:Float64)-instance-method","name":"min","doc":null,"summary":null,"abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L134","def":{"name":"min","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.min_f64(value1, value2)"}},{"id":"min(value1,value2)-instance-method","html_id":"min(value1,value2)-instance-method","name":"min","doc":"Returns the smaller of *value1* and *value2*.","summary":"<p>Returns the smaller of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L139","def":{"name":"min","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value1 <= value2 ? value1 : value2"}},{"id":"pw2ceil(v)-instance-method","html_id":"pw2ceil(v)-instance-method","name":"pw2ceil","doc":"Computes the next highest power of 2 of *v*.\n\n```\nMath.pw2ceil(33) # => 64\n```","summary":"<p>Computes the next highest power of 2 of <em>v</em>.</p>","abstract":false,"args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":""}],"args_string":"(v)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L218","def":{"name":"pw2ceil","args":[{"name":"v","doc":null,"default_value":"","external_name":"v","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"v = v - 1\nv = v | (v >> 1)\nv = v | (v >> 2)\nv = v | (v >> 4)\nv = v | (v >> 8)\nv = v | (v >> 16)\nv = v + 1\n"}},{"id":"scalbln(value,exp)-instance-method","html_id":"scalbln(value,exp)-instance-method","name":"scalbln","doc":"Multiplies *value* by 2 raised to power *exp*.","summary":"<p>Multiplies <em>value</em> by 2 raised to power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"args_string":"(value, exp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L192","def":{"name":"scalbln","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalbln(value.to_f, exp.to_i64)"}},{"id":"scalbln(value:Float64,exp:Int64)-instance-method","html_id":"scalbln(value:Float64,exp:Int64)-instance-method","name":"scalbln","doc":"Multiplies *value* by 2 raised to power *exp*.","summary":"<p>Multiplies <em>value</em> by 2 raised to power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int64"}],"args_string":"(value : Float64, exp : Int64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L187","def":{"name":"scalbln","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.scalbln_f64(value, exp)"}},{"id":"scalbln(value:Float32,exp:Int64)-instance-method","html_id":"scalbln(value:Float32,exp:Int64)-instance-method","name":"scalbln","doc":"Multiplies *value* by 2 raised to power *exp*.","summary":"<p>Multiplies <em>value</em> by 2 raised to power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int64"}],"args_string":"(value : Float32, exp : Int64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L182","def":{"name":"scalbln","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"},{"name":"exp","doc":null,"default_value":"","external_name":"exp","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.scalbln_f32(value, exp)"}},{"id":"scalbn(value1,value2)-instance-method","html_id":"scalbn(value1,value2)-instance-method","name":"scalbn","doc":"Calculates scalbn with parameters *value1* and *value2*.","summary":"<p>Calculates scalbn with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"scalbn","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":""},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scalbn(value1.to_f, value2.to_i32)"}},{"id":"scalbn(value1:Float64,value2:Int32)-instance-method","html_id":"scalbn(value1:Float64,value2:Int32)-instance-method","name":"scalbn","doc":"Calculates scalbn with parameters *value1* and *value2*.","summary":"<p>Calculates scalbn with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"args_string":"(value1 : Float64, value2 : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"scalbn","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float64"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.scalbn_f64(value1, value2)"}},{"id":"scalbn(value1:Float32,value2:Int32)-instance-method","html_id":"scalbn(value1:Float32,value2:Int32)-instance-method","name":"scalbn","doc":"Calculates scalbn with parameters *value1* and *value2*.","summary":"<p>Calculates scalbn with parameters <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"args_string":"(value1 : Float32, value2 : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L164","def":{"name":"scalbn","args":[{"name":"value1","doc":null,"default_value":"","external_name":"value1","restriction":"Float32"},{"name":"value2","doc":null,"default_value":"","external_name":"value2","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.scalbn_f32(value1, value2)"}},{"id":"sin(value:Float32)-instance-method","html_id":"sin(value:Float32)-instance-method","name":"sin","doc":"Calculates the sin of *value*.","summary":"<p>Calculates the sin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sin_f32(value)"}},{"id":"sin(value:Float64)-instance-method","html_id":"sin(value:Float64)-instance-method","name":"sin","doc":"Calculates the sin of *value*.","summary":"<p>Calculates the sin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sin_f64(value)"}},{"id":"sin(value)-instance-method","html_id":"sin(value)-instance-method","name":"sin","doc":"Calculates the sin of *value*.","summary":"<p>Calculates the sin of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sin","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sin(value.to_f)"}},{"id":"sinh(value:Float32)-instance-method","html_id":"sinh(value:Float32)-instance-method","name":"sinh","doc":"Calculates the sinh of *value*.","summary":"<p>Calculates the sinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sinh_f32(value)"}},{"id":"sinh(value:Float64)-instance-method","html_id":"sinh(value:Float64)-instance-method","name":"sinh","doc":"Calculates the sinh of *value*.","summary":"<p>Calculates the sinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sinh_f64(value)"}},{"id":"sinh(value)-instance-method","html_id":"sinh(value)-instance-method","name":"sinh","doc":"Calculates the sinh of *value*.","summary":"<p>Calculates the sinh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sinh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sinh(value.to_f)"}},{"id":"sqrt(value:Float32)-instance-method","html_id":"sqrt(value:Float32)-instance-method","name":"sqrt","doc":"Calculates the sqrt of *value*.","summary":"<p>Calculates the sqrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sqrt_f32(value)"}},{"id":"sqrt(value:Float64)-instance-method","html_id":"sqrt(value:Float64)-instance-method","name":"sqrt","doc":"Calculates the sqrt of *value*.","summary":"<p>Calculates the sqrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.sqrt_f64(value)"}},{"id":"sqrt(value:BigInt)-instance-method","html_id":"sqrt(value:BigInt)-instance-method","name":"sqrt","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigInt"}],"args_string":"(value : BigInt)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L553","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L553","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigInt"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sqrt(value.to_big_f)"}},{"id":"sqrt(value:BigFloat)-instance-method","html_id":"sqrt(value:BigFloat)-instance-method","name":"sqrt","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigFloat"}],"args_string":"(value : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L301","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_sqrt(mpf, value)\nend"}},{"id":"sqrt(value:BigRational)-instance-method","html_id":"sqrt(value:BigRational)-instance-method","name":"sqrt","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigRational"}],"args_string":"(value : BigRational)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_rational.cr#L276","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"BigRational"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sqrt(value.to_big_f)"}},{"id":"sqrt(value)-instance-method","html_id":"sqrt(value)-instance-method","name":"sqrt","doc":"Calculates the sqrt of *value*.","summary":"<p>Calculates the sqrt of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"sqrt","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sqrt(value.to_f)"}},{"id":"tan(value:Float32)-instance-method","html_id":"tan(value:Float32)-instance-method","name":"tan","doc":"Calculates the tan of *value*.","summary":"<p>Calculates the tan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tan_f32(value)"}},{"id":"tan(value:Float64)-instance-method","html_id":"tan(value:Float64)-instance-method","name":"tan","doc":"Calculates the tan of *value*.","summary":"<p>Calculates the tan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tan_f64(value)"}},{"id":"tan(value)-instance-method","html_id":"tan(value)-instance-method","name":"tan","doc":"Calculates the tan of *value*.","summary":"<p>Calculates the tan of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tan","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"tan(value.to_f)"}},{"id":"tanh(value:Float32)-instance-method","html_id":"tanh(value:Float32)-instance-method","name":"tanh","doc":"Calculates the tanh of *value*.","summary":"<p>Calculates the tanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tanh_f32(value)"}},{"id":"tanh(value:Float64)-instance-method","html_id":"tanh(value:Float64)-instance-method","name":"tanh","doc":"Calculates the tanh of *value*.","summary":"<p>Calculates the tanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibM.tanh_f64(value)"}},{"id":"tanh(value)-instance-method","html_id":"tanh(value)-instance-method","name":"tanh","doc":"Calculates the tanh of *value*.","summary":"<p>Calculates the tanh of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/math/math.cr#L11","def":{"name":"tanh","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"tanh(value.to_f)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Mutex","path":"Mutex.html","kind":"class","full_name":"Mutex","name":"Mutex","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"mutex.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A fiber-safe mutex.\n\nTODO: this isn't thread-safe yet.","summary":"<p>A fiber-safe mutex.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L7","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"lock-instance-method","html_id":"lock-instance-method","name":"lock","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L11","def":{"name":"lock","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"mutex_fiber = @mutex_fiber\ncurrent_fiber = Fiber.current\nif !mutex_fiber\n  @mutex_fiber = current_fiber\nelse\n  if mutex_fiber == current_fiber\n    @lock_count = @lock_count + 1\n  else\n    queue = @queue || (@queue = Deque(Fiber).new)\n    queue << current_fiber\n    Scheduler.reschedule\n  end\nend\nnil\n"}},{"id":"synchronize(&block)-instance-method","html_id":"synchronize(&amp;block)-instance-method","name":"synchronize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L48","def":{"name":"synchronize","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"lock\nbegin\n  yield\nensure\n  unlock\nend\n"}},{"id":"unlock-instance-method","html_id":"unlock-instance-method","name":"unlock","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/mutex.cr#L28","def":{"name":"unlock","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @mutex_fiber == Fiber.current\nelse\n  raise(\"Attempt to unlock a mutex which is not locked\")\nend\nif @lock_count > 0\n  @lock_count = @lock_count - 1\n  return\nend\nif fiber = @queue.try(&.shift?)\n  @mutex_fiber = fiber\n  Scheduler.enqueue(fiber)\nelse\n  @mutex_fiber = nil\nend\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/NamedTuple","path":"NamedTuple.html","kind":"struct","full_name":"NamedTuple(**T)","name":"NamedTuple","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"named_tuple.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr"},{"filename":"json/to_json.cr","line_number":101,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":50,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A named tuple is a fixed-size, immutable, stack-allocated mapping\nof a fixed set of keys to values.\n\nYou can think of a `NamedTuple` as an immutable `Hash` whose keys (which\nare of type `Symbol`), and the types for each key, are known at compile time.\n\nA named tuple can be created with a named tuple literal:\n\n```\nlanguage = {name: \"Crystal\", year: 2011} # NamedTuple(name: String, year: Int32)\n\nlanguage[:name]  # => \"Crystal\"\nlanguage[:year]  # => 2011\nlanguage[:other] # compile time error\n```\n\nThe compiler knows what types are in each key, so when indexing a named tuple\nwith a symbol literal the compiler will return the value for that key and\nwith the expected type, like in the above snippet. Indexing with a symbol\nliteral for which there's no key will give a compile-time error.\n\nIndexing with a symbol that is only known at runtime will return\na value whose type is the union of all the types in the named tuple,\nand might raise `KeyError`.","summary":"<p>A named tuple is a fixed-size, immutable, stack-allocated mapping of a fixed set of keys to values.</p>","class_methods":[{"id":"types-class-method","html_id":"types-class-method","name":"types","doc":"Returns the types of this named tuple type.\n\n```\ntuple = {a: 1, b: \"hello\", c: 'x'}\ntuple.class.types # => {a: Int32, b: String, c: Char}\n```","summary":"<p>Returns the types of this named tuple type.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L202","def":{"name":"types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"NamedTuple.new(**{{ T }})"}}],"constructors":[{"id":"from(hash:Hash):self-class-method","html_id":"from(hash:Hash):self-class-method","name":"from","doc":"Creates a named tuple from the given hash, with elements casted to the given types.\nHere the Int32 | String union is cast to Int32.\n\n```\nnum_or_str = 42.as(Int32 | String)\nNamedTuple(name: String, val: Int32).from({\"name\" => \"number\", \"val\" => num_or_str}) # => {name: \"number\", val: 42}\n\nnum_or_str = \"a string\".as(Int32 | String)\nNamedTuple(name: String, val: Int32).from({\"name\" => \"number\", \"val\" => num_or_str}) # raises TypeCastError (cast from String to Int32 failed)\n```\nSee also: `#from`.","summary":"<p>Creates a named tuple from the given hash, with elements casted to the given types.</p>","abstract":false,"args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash"}],"args_string":"(hash : Hash) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L51","def":{"name":"from","args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"{% if true %}\n    NamedTuple.new(**{{ T }}).from(hash)\n    {% end %}"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L135","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Mapping)\nelse\n  node.raise(\"Expected mapping, not #{node.class}\")\nend\n{% if true %}\n    {% for key in T.keys %}\n      %var{key.id} = nil\n    {% end %}\n\n    YAML::Schema::Core.each(node) do |key, value|\n      key = String.new(ctx, key)\n      case key\n        {% for key, type in T %}\n          when {{ key.stringify }}\n            %var{key.id} = {{ type }}.new(ctx, value)\n        {% end %}\n      end\n    end\n\n    {% for key in T.keys %}\n      if %var{key.id}.nil?\n        node.raise \"Missing yaml attribute: {{ key }}\"\n      end\n    {% end %}\n\n    {\n      {% for key in T.keys %}\n        {{ key }}: %var{key.id},\n      {% end %}\n    }\n  {% end %}\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L148","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n    {% for key in T.keys %}\n      %var{key.id} = nil\n    {% end %}\n\n    location = pull.location\n\n    pull.read_object do |key|\n      case key\n        {% for key, type in T %}\n          when {{ key.stringify }}\n            %var{key.id} = {{ type }}.new(pull)\n        {% end %}\n      else\n        pull.skip\n      end\n    end\n\n    {% for key in T.keys %}\n      if %var{key.id}.nil?\n        raise JSON::ParseException.new(\"Missing json attribute: {{ key }}\", *location)\n      end\n    {% end %}\n\n    {\n      {% for key in T.keys %}\n        {{ key }}: %var{key.id},\n      {% end %}\n    }\n  {% end %}"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a named tuple that will contain the given arguments.\n\nThis method is useful in macros and generic code because with it you can\ncreates empty named tuples, something that you can't do with a tuple literal.\n\n```\nNamedTuple.new(name: \"Crystal\", year: 2011) #=> {name: \"Crystal\", year: 2011}\nNamedTuple.new # => {}\n{}             # syntax error\n```","summary":"<p>Creates a named tuple that will contain the given arguments.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L36","def":{"name":"new","args":[],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":"**T"},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"options"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same keys as *other*, and values\nfor each key are the same in `self` and *other*.\n\n```\ntuple1 = {name: \"Crystal\", year: 2011}\ntuple2 = {year: 2011, name: \"Crystal\"}\ntuple3 = {name: \"Crystal\", year: 2012}\ntuple4 = {name: \"Crystal\", year: 2011.0}\n\ntuple1 == tuple2 # => true\ntuple1 == tuple3 # => false\ntuple1 == tuple4 # => true\n```","summary":"<p>Returns <code>true</code> if this tuple has the same keys as <em>other</em>, and values for each key are the same in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L488","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L488","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for key in T %}\n      return false unless self[{{ key.symbolize }}] == other[{{ key.symbolize }}]\n    {% end %}\ntrue\n"}},{"id":"==(other:NamedTuple)-instance-method","html_id":"==(other:NamedTuple)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same keys as *other*, and values\nfor each key are the same in `self` and *other*.\n\n```\ntuple1 = {name: \"Crystal\", year: 2011}\ntuple2 = {year: 2011, name: \"Crystal\"}\ntuple3 = {name: \"Crystal\", year: 2012}\ntuple4 = {name: \"Crystal\", year: 2011.0}\n\ntuple1 == tuple2 # => true\ntuple1 == tuple3 # => false\ntuple1 == tuple4 # => true\n```","summary":"<p>Returns <code>true</code> if this tuple has the same keys as <em>other</em>, and values for each key are the same in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NamedTuple"}],"args_string":"(other : NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L496","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L496","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if sorted_keys == other.sorted_keys\nelse\n  return false\nend\n{% for key in T %}\n      return false unless self[{{ key.symbolize }}] == other[{{ key.symbolize }}]?\n    {% end %}\nreturn true\n"}},{"id":"[](key:Symbol|String)-instance-method","html_id":"[](key:Symbol|String)-instance-method","name":"[]","doc":"Returns the value for the given *key*, if there's such key, otherwise raises `KeyError`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\n\nkey = :name\ntuple[key] # => \"Crystal\"\n\nkey = \"year\"\ntuple[key] # => 2011\n\nkey = :other\ntuple[key] # raises KeyError\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"}],"args_string":"(key : Symbol | String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L100","def":{"name":"[]","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key) do\n  raise(KeyError.new(\"Missing named tuple key: #{key.inspect}\"))\nend"}},{"id":"[]?(key:Symbol|String)-instance-method","html_id":"[]?(key:Symbol|String)-instance-method","name":"[]?","doc":"Returns the value for the given *key*, if there's such key, otherwise returns `nil`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\n\nkey = :name\ntuple[key]? # => \"Crystal\"\n\nkey = \"year\"\ntuple[key] # => 2011\n\nkey = :other\ntuple[key]? # => nil\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"}],"args_string":"(key : Symbol | String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L118","def":{"name":"[]?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key, nil)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a named tuple with the same keys but with cloned values, using the `clone` method.","summary":"<p>Returns a named tuple with the same keys but with cloned values, using the <code><a href=\"NamedTuple.html#clone-instance-method\">#clone</a></code> method.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L507","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L507","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      {\n        {% for key in T %}\n          {{ key.stringify }}: self[{{ key.symbolize }}].clone,\n        {% end %}\n      }\n    {% end %}"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Yields each key and value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each do |key, value|\n  puts \"#{key} = #{value}\"\nend\n```\n\nOutput:\n\n```text\nname = Crystal\nyear = 2011\n```","summary":"<p>Yields each key and value in this named tuple.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L337","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L337","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield {{ key.symbolize }}, self[{{ key.symbolize }}]\n    {% end %}"}},{"id":"each_key(&block):Nil-instance-method","html_id":"each_key(&amp;block):Nil-instance-method","name":"each_key","doc":"Yields each key in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_key do |key|\n  puts key\nend\n```\n\nOutput:\n\n```text\nname\nyear\n```","summary":"<p>Yields each key in this named tuple.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L358","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L358","def":{"name":"each_key","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield {{ key.symbolize }}\n    {% end %}"}},{"id":"each_value(&block):Nil-instance-method","html_id":"each_value(&amp;block):Nil-instance-method","name":"each_value","doc":"Yields each value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_value do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\nCrystal\n2011\n```","summary":"<p>Yields each value in this named tuple.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L379","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L379","def":{"name":"each_value","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield self[{{ key.symbolize }}]\n    {% end %}"}},{"id":"each_with_index(offset=0,&block)-instance-method","html_id":"each_with_index(offset=0,&amp;block)-instance-method","name":"each_with_index","doc":"Yields each key and value, together with an index starting at *offset*, in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_with_index do |key, value, i|\n  puts \"#{i + 1}) #{key} = #{value}\"\nend\n```\n\nOutput:\n\n```text\n1) name = Crystal\n2) year = 2011\n```","summary":"<p>Yields each key and value, together with an index starting at <em>offset</em>, in this named tuple.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = <span class=\"n\">0</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L400","def":{"name":"each_with_index","args":[{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":3,"block_arg":null,"return_type":"","visibility":"Public","body":"i = offset\neach do |key, value|\n  yield key, value, i\n  i = i + 1\nend\n"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if this named tuple is empty.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.empty? # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L471","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L471","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size == 0"}},{"id":"fetch(key:String,&block)-instance-method","html_id":"fetch(key:String,&amp;block)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise the value returned by the block.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(\"name\") { \"Unknown\" } # => \"Crystal\"\ntuple.fetch(\"other\") { 0 }        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise the value returned by the block.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L155","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for key in T %}\n      return self[{{ key.symbolize }}] if {{ key.stringify }} == key\n    {% end %}\nyield\n"}},{"id":"fetch(key:Symbol,&block)-instance-method","html_id":"fetch(key:Symbol,&amp;block)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise the value returned by the block.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(:name) { \"Unknown\" } # => \"Crystal\"\ntuple.fetch(:other) { 0 }        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise the value returned by the block.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L141","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for key in T %}\n      return self[{{ key.symbolize }}] if {{ key.symbolize }} == key\n    {% end %}\nyield\n"}},{"id":"fetch(key:Symbol|String,default_value)-instance-method","html_id":"fetch(key:Symbol|String,default_value)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise returns *default_value*.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(:name, \"Unknown\") # => \"Crystal\"\ntuple.fetch(\"year\", 0)        # => 2011\ntuple.fetch(:other, 0)        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise returns <em>default_value</em>.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"},{"name":"default_value","doc":null,"default_value":"","external_name":"default_value","restriction":""}],"args_string":"(key : Symbol | String, default_value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L130","def":{"name":"fetch","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol | String"},{"name":"default_value","doc":null,"default_value":"","external_name":"default_value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fetch(key) do\n  default_value\nend"}},{"id":"from(hash:Hash)-instance-method","html_id":"from(hash:Hash)-instance-method","name":"from","doc":"Expects to be called on a named tuple whose values are types, creates a tuple from the given hash,\nwith types casted appropriately. The hash keys must be either symbols or strings.\n\nThis allows you to easily pass a hash as individual named arguments to a method.\n\n```\nrequire \"json\"\n\ndef speak_about(thing : String, n : Int64)\n  \"I see #{n} #{thing}s\"\nend\n\ndata = JSON.parse(%({\"thing\": \"world\", \"n\": 2})).as_h\nspeak_about(**{thing: String, n: Int64}.from(data)) # => \"I see 2 worlds\"\n```","summary":"<p>Expects to be called on a named tuple whose values are types, creates a tuple from the given hash, with types casted appropriately.</p>","abstract":false,"args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash"}],"args_string":"(hash : Hash)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L72","def":{"name":"from","args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size != hash.size\n  raise(ArgumentError.new(\"Expected a hash with #{size} keys but one with #{hash.size} keys was given.\"))\nend\n{% if true %}\n      NamedTuple.new(\n      {% for key, value in T %}\n        {{ key.stringify }}: self[{{ key.symbolize }}].cast(hash.fetch({{ key.symbolize }}) { hash[\"{{ key }}\"] }),\n      {% end %}\n      )\n    {% end %}\n"}},{"id":"has_key?(key:Symbol):Bool-instance-method","html_id":"has_key?(key:Symbol):Bool-instance-method","name":"has_key?","doc":"Returns `true` if this named tuple has the given *key*, `false` otherwise.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.has_key?(:name)  # => true\ntuple.has_key?(:other) # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple has the given <em>key</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L260","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% for key in T %}\n      return true if {{ key.symbolize }} == key\n    {% end %}\nfalse\n"}},{"id":"has_key?(key:String):Bool-instance-method","html_id":"has_key?(key:String):Bool-instance-method","name":"has_key?","doc":"Returns `true` if this named tuple has the given *key*, `false` otherwise.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.has_key?(:name)  # => true\ntuple.has_key?(:other) # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple has the given <em>key</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L268","def":{"name":"has_key?","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"{% for key in T %}\n      return true if {{ key.stringify }} == key\n    {% end %}\nfalse\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"Returns a hash value based on this name tuple's size, keys and values.\n\nSee also: `Object#hash`.\nSee `Object#hash(hasher)`","summary":"<p>Returns a hash value based on this name tuple's size, keys and values.</p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L188","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for key in T.keys.sort %}\n      hasher = {{ key.symbolize }}.hash(hasher)\n      hasher = self[{{ key.symbolize }}].hash(hasher)\n    {% end %}\nhasher\n"}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":"Same as `to_s`.","summary":"<p>Same as <code><a href=\"NamedTuple.html#to_s%28io%29-instance-method\">#to_s</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L207","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s"}},{"id":"keys-instance-method","html_id":"keys-instance-method","name":"keys","doc":"Returns a `Tuple` of symbols with the keys in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.keys # => {:name, :year}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> of symbols with the keys in this named tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L217","def":{"name":"keys","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for key in T %}\n          {{ key.symbolize }},\n        {% end %}\n      )\n    {% end %}"}},{"id":"map(&block)-instance-method","html_id":"map(&amp;block)-instance-method","name":"map","doc":"Returns an `Array` populated with the results of each iteration in the given block,\nwhich is given each key and value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.map { |k, v| \"#{k}: #{v}\" } # => [\"name: Crystal\", \"year: 2011\"]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> populated with the results of each iteration in the given block, which is given each key and value in this named tuple.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L415","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L415","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"array = Array(typeof(yield first_key_internal, first_value_internal)).new(size)\neach do |k, v|\n  array.push(yield k, v)\nend\narray\n"}},{"id":"merge-instance-method","html_id":"merge-instance-method","name":"merge","doc":"Merges two named tuples into one, returning a new named tuple.\nIf a key is defined in both tuples, the value and its type is used from *other*.\n\n```\na = {foo: \"Hello\", bar: \"Old\"}\nb = {bar: \"New\", baz: \"Bye\"}\na.merge(b) # => {foo: \"Hello\", bar: \"New\", baz: \"Bye\"}\n```","summary":"<p>Merges two named tuples into one, returning a new named tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L175","def":{"name":"merge","args":[],"double_splat":{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"**U"},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n    {\n      {% for k in T %} {% if U.keys.includes?(k) %}{% else %} {{ k.stringify }}: self[{{ k.symbolize }}],{% end %} {% end %}\n      {% for k in U %} {{ k.stringify }}: other[{{ k.symbolize }}], {% end %}\n    }\n    {% end %}"}},{"id":"merge(other:NamedTuple)-instance-method","html_id":"merge(other:NamedTuple)-instance-method","name":"merge","doc":"Merges two named tuples into one, returning a new named tuple.\nIf a key is defined in both tuples, the value and its type is used from *other*.\n\n```\na = {foo: \"Hello\", bar: \"Old\"}\nb = {bar: \"New\", baz: \"Bye\"}\na.merge(b) # => {foo: \"Hello\", bar: \"New\", baz: \"Bye\"}\n```","summary":"<p>Merges two named tuples into one, returning a new named tuple.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NamedTuple"}],"args_string":"(other : NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L170","def":{"name":"merge","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"merge(**other)"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L299","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.surround(\"{\", \"}\", left_break: nil, right_break: nil) do\n  {% for key, value, i in T %}\n        {% if i > 0 %}\n          pp.comma\n        {% end %}\n        pp.group do\n          key = {{ key.stringify }}\n          if Symbol.needs_quotes?(key)\n            pp.text key.inspect\n          else\n            pp.text key\n          end\n          pp.text \": \"\n          pp.nest do\n            pp.breakable \"\"\n            self[{{ key.symbolize }}].pretty_print(pp)\n          end\n        end\n      {% end %}\nend"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.size # => 2\n```","summary":"<p>Returns the number of elements in this named tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L461","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L461","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{{ T.size }}"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":"Returns a new `Array` of tuples populated with each key-value pair.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_a # => [{:name, \"Crystal\"}, {:year, 2011}]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> of tuples populated with each key-value pair.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L429","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L429","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(::Tuple(typeof(first_key_internal), typeof(first_value_internal))).new(size)\neach do |key, value|\n  ary << {key.as(typeof(first_key_internal)), value.as(typeof(first_value_internal))}\nend\nary\n"}},{"id":"to_h-instance-method","html_id":"to_h-instance-method","name":"to_h","doc":"Returns a `Hash` with the keys and values in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_h # => {:name => \"Crystal\", :year => 2011}\n```","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> with the keys and values in this named tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L443","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L443","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T.size == 0 %}\n      {% raise(\"Can't convert an empty NamedTuple to a Hash\") %}\n    {% else %}\n      {\n        {% for key in T %}\n          {{ key.symbolize }} => self[{{ key.symbolize }}],\n        {% end %}\n      }\n    {% end %}"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L102","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.object do\n  {% for key in T.keys %}\n        json.field {{ key.stringify }} do\n          self[{{ key.symbolize }}].to_json(json)\n        end\n      {% end %}\nend"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Appends a string representation of this named tuple to the given `IO`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_s # => %({name: \"Crystal\", year: 2011})\n```","summary":"<p>Appends a string representation of this named tuple to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L281","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L281","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '{'\n{% for key, value, i in T %}\n      {% if i > 0 %}\n        io << \", \"\n      {% end %}\n      key = {{ key.stringify }}\n      if Symbol.needs_quotes?(key)\n        key.inspect(io)\n      else\n        io << key\n      end\n      io << \": \"\n      self[{{ key.symbolize }}].inspect(io)\n    {% end %}\nio << '}'\n"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L51","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.mapping do\n  {% for key in T.keys %}\n        {{ key.symbolize }}.to_yaml(yaml)\n        self[{{ key.symbolize }}].to_yaml(yaml)\n      {% end %}\nend"}},{"id":"values-instance-method","html_id":"values-instance-method","name":"values","doc":"Returns a `Tuple` with the values in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.values # => {\"Crystal\", 2011}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the values in this named tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L243","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/named_tuple.cr#L243","def":{"name":"values","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for key in T %}\n          self[{{ key.symbolize }}],\n        {% end %}\n      )\n    {% end %}"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Nil","path":"Nil.html","kind":"struct","full_name":"Nil","name":"Nil","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"nil.cr","line_number":42,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr"},{"filename":"json/to_json.cr","line_number":27,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":77,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The `Nil` type has only one possible value: `nil`.\n\n`nil` is commonly used to represent the absence of a value.\nFor example, `String#index` returns the position of the character or `nil` if it's not\nin the string:\n\n```\nstr = \"Hello world\"\nstr.index 'e' # => 1\nstr.index 'a' # => nil\n```\n\nIn the above example, trying to invoke a method on the returned value will\ngive a compile time error unless both `Int32` and `Nil` define that method:\n\n```\nstr = \"Hello world\"\nidx = str.index 'e'\nidx + 1 # Error: undefined method '+' for Nil\n```\n\nThe language and the standard library provide short, readable, easy ways to deal with `nil`,\nsuch as `Object#try` and `Object#not_nil!`:\n\n```\nstr = \"Hello world\"\n\n# The index of 'e' in str or 0 if not found\nidx1 = str.index('e') || 0\n\nidx2 = str.index('a')\nif idx2\n  # Compiles: idx2 can't be nil here\n  idx2 + 1\nend\n\n# Tell the compiler that we are sure the returned\n# value is not nil: raises a runtime exception\n# if our assumption doesn't hold.\nidx3 = str.index('o').not_nil!\n```","summary":"<p>The <code><a href=\"Nil.html\">Nil</a></code> type has only one possible value: <code>nil</code>.</p>","class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L41","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L61","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pull.read_null"}}],"instance_methods":[{"id":"==(other:Nil)-instance-method","html_id":"==(other:Nil)-instance-method","name":"==","doc":"Returns `true`: `Nil` has only one singleton value: `nil`.","summary":"<p>Returns <code>true</code>: <code><a href=\"Nil.html\">Nil</a></code> has only one singleton value: <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L56","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"true"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L109","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L71","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.nil"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":"Writes `\"nil\"` to the given `IO`.","summary":"<p>Writes <code>\"nil\"</code> to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L91","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"nil\""}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":"Returns `\"nil\"`.","summary":"<p>Returns <code>\"nil\"</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L86","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"nil\""}},{"id":"not_nil!-instance-method","html_id":"not_nil!-instance-method","name":"not_nil!","doc":"Raises an exception.\n\nSee also: `Object#not_nil!`.","summary":"<p>Raises an exception.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L105","def":{"name":"not_nil!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(\"Nil assertion failed\")"}},{"id":"object_id-instance-method","html_id":"object_id-instance-method","name":"object_id","doc":"Returns `0_u64`. Even though `Nil` is not a `Reference` type, it is usually\nmixed with them to form nilable types so it's useful to have an\nobject id for `nil`.","summary":"<p>Returns <code>0_u64</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L46","def":{"name":"object_id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"0_u64"}},{"id":"same?(other:Nil)-instance-method","html_id":"same?(other:Nil)-instance-method","name":"same?","doc":"Returns `true`: `Nil` has only one singleton value: `nil`.","summary":"<p>Returns <code>true</code>: <code><a href=\"Nil.html\">Nil</a></code> has only one singleton value: <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L61","def":{"name":"same?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"true"}},{"id":"same?(other:Reference)-instance-method","html_id":"same?(other:Reference)-instance-method","name":"same?","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Reference"}],"args_string":"(other : Reference)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L66","def":{"name":"same?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Reference"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L28","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.null"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Doesn't write anything to the given `IO`.","summary":"<p>Doesn't write anything to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L81","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns an empty string.","summary":"<p>Returns an empty string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L76","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"\""}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L78","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(\"\")"}},{"id":"try(&block)-instance-method","html_id":"try(&amp;block)-instance-method","name":"try","doc":"Doesn't yield to the block.\n\nSee also: `Object#try`.","summary":"<p>Doesn't yield to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/nil.cr#L98","def":{"name":"try","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/NotImplementedError","path":"NotImplementedError.html","kind":"class","full_name":"NotImplementedError","name":"NotImplementedError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":136,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when a method is not implemented.\n\nThis can be used either to stub out method bodies, or when the method is not\nimplemented on the current platform.","summary":"<p>Raised when a method is not implemented.</p>","class_methods":[],"constructors":[{"id":"new(item)-class-method","html_id":"new(item)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"item","doc":null,"default_value":"","external_name":"item","restriction":""}],"args_string":"(item)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L137","def":{"name":"new","args":[{"name":"item","doc":null,"default_value":"","external_name":"item","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(item)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Number","path":"Number.html","kind":"struct","full_name":"Number","name":"Number","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"number.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr"},{"filename":"big/big_float.cr","line_number":254,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr"},{"filename":"yaml/to_yaml.cr","line_number":71,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"},{"filename":"complex.cr","line_number":239,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/BigDecimal","kind":"struct","full_name":"BigDecimal","name":"BigDecimal"},{"html_id":"github.com/crystal-lang/crystal/BigRational","kind":"struct","full_name":"BigRational","name":"BigRational"},{"html_id":"github.com/crystal-lang/crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"}],"including_types":[],"namespace":null,"doc":"The top-level number type.","summary":"<p>The top-level number type.</p>","class_methods":[],"constructors":[{"id":"zero:self-class-method","html_id":"zero:self-class-method","name":"zero","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L7","def":{"name":"zero","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(0)"}}],"instance_methods":[{"id":"*(other:Complex)-instance-method","html_id":"*(other:Complex)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L264","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(self * other.real, self * other.imag)"}},{"id":"*(other:BigFloat)-instance-method","html_id":"*(other:BigFloat)-instance-method","name":"*","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other * self"}},{"id":"+(other:BigFloat)-instance-method","html_id":"+(other:BigFloat)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L261","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other + self"}},{"id":"+(other:Complex)-instance-method","html_id":"+(other:Complex)-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L256","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(self + other.real, other.imag)"}},{"id":"+-instance-method","html_id":"+-instance-method","name":"+","doc":"Returns self.","summary":"<p>Returns self.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L12","def":{"name":"+","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"-(other:Complex)-instance-method","html_id":"-(other:Complex)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L260","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(self - other.real, -other.imag)"}},{"id":"-(other:BigFloat)-instance-method","html_id":"-(other:BigFloat)-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L265","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_f - other"}},{"id":"/(other:Complex)-instance-method","html_id":"/(other:Complex)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L268","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self * other.inv"}},{"id":"/(other:BigFloat)-instance-method","html_id":"/(other:BigFloat)-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L273","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_big_f / other"}},{"id":"(other:BigFloat)-instance-method","html_id":"(other:BigFloat)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L257","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L257","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"BigFloat"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"-(other <=> self)"}},{"id":"(other)-instance-method","html_id":"(other)-instance-method","name":"<=>","doc":"Implements the comparison operator.\n\nSee also: `Object#<=>`.","summary":"<p>Implements the comparison operator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L167","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self > other ? 1 : (self < other ? -1 : 0)"}},{"id":"==(other:Complex)-instance-method","html_id":"==(other:Complex)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L248","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L248","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Complex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_c == other"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L125","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self < 0 ? -self : self"}},{"id":"abs2-instance-method","html_id":"abs2-instance-method","name":"abs2","doc":"Returns the square of `self` (`self * self`).\n\n```\n4.abs2   # => 16\n1.5.abs2 # => 2.25\n```","summary":"<p>Returns the square of <code>self</code> (<code>self * self</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L135","def":{"name":"abs2","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self * self"}},{"id":"cis-instance-method","html_id":"cis-instance-method","name":"cis","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L252","def":{"name":"cis","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(Math.cos(self), Math.sin(self))"}},{"id":"clamp(min,max)-instance-method","html_id":"clamp(min,max)-instance-method","name":"clamp","doc":"Clamps a value between *min* and *max*.\n\n```\n5.clamp(10, 100)   # => 10\n50.clamp(10, 100)  # => 50\n500.clamp(10, 100) # => 100\n```","summary":"<p>Clamps a value between <em>min</em> and <em>max</em>.</p>","abstract":false,"args":[{"name":"min","doc":null,"default_value":"","external_name":"min","restriction":""},{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":""}],"args_string":"(min, max)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L242","def":{"name":"clamp","args":[{"name":"min","doc":null,"default_value":"","external_name":"min","restriction":""},{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if self > max\n  return max\nend\nif self < min\n  return min\nend\nself\n"}},{"id":"clamp(range:Range)-instance-method","html_id":"clamp(range:Range)-instance-method","name":"clamp","doc":"Clamps a value within *range*.\n\n```\n5.clamp(10..100)   # => 10\n50.clamp(10..100)  # => 50\n500.clamp(10..100) # => 100\n```","summary":"<p>Clamps a value within <em>range</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L230","def":{"name":"clamp","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if range.exclusive?\n  raise(ArgumentError.new(\"Can't clamp an exclusive range\"))\nend\nclamp(range.begin, range.end)\n"}},{"id":"divmod(number)-instance-method","html_id":"divmod(number)-instance-method","name":"divmod","doc":"Returns a `Tuple` of two elements containing the quotient\nand modulus obtained by dividing `self` by *number*.\n\n```\n11.divmod(3)  # => {3, 2}\n11.divmod(-3) # => {-4, -1}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> of two elements containing the quotient and modulus obtained by dividing <code>self</code> by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":""}],"args_string":"(number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L160","def":{"name":"divmod","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{(self / number).floor, self % number}"}},{"id":"i-instance-method","html_id":"i-instance-method","name":"i","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L244","def":{"name":"i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(0, self)"}},{"id":"round(digits=0,base=10)-instance-method","html_id":"round(digits=0,base=10)-instance-method","name":"round","doc":"Rounds this number to a given precision in decimal *digits*.\n\n```\n-1763.116.round(2) # => -1763.12\n```","summary":"<p>Rounds this number to a given precision in decimal <em>digits</em>.</p>","abstract":false,"args":[{"name":"digits","doc":null,"default_value":"0","external_name":"digits","restriction":""},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(digits = <span class=\"n\">0</span>, base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L212","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L212","def":{"name":"round","args":[{"name":"digits","doc":null,"default_value":"0","external_name":"digits","restriction":""},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = self.to_f\nif digits < 0\n  y = base ** (-digits)\n  self.class.new((x / y).round * y)\nelse\n  y = base ** digits\n  self.class.new((x * y).round / y)\nend\n"}},{"id":"sign-instance-method","html_id":"sign-instance-method","name":"sign","doc":"Returns the sign of this number as an `Int32`.\n* `-1` if this number is negative\n* `0` if this number is zero\n* `1` if this number is positive\n\n```\n123.sign # => 1\n0.sign   # => 0\n-42.sign # => -1\n```","summary":"<p>Returns the sign of this number as an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L149","def":{"name":"sign","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self < 0 ? -1 : (self == 0 ? 0 : 1)"}},{"id":"significant(digits,base=10)-instance-method","html_id":"significant(digits,base=10)-instance-method","name":"significant","doc":"Keeps *digits* significants digits of this number in the given *base*.\n\n```\n1234.567.significant(1) # => 1000\n1234.567.significant(2) # => 1200\n1234.567.significant(3) # => 1230\n1234.567.significant(4) # => 1235\n1234.567.significant(5) # => 1234.6\n1234.567.significant(6) # => 1234.57\n1234.567.significant(7) # => 1234.567\n1234.567.significant(8) # => 1234.567\n\n15.159.significant(1, base = 2) # => 16\n```","summary":"<p>Keeps <em>digits</em> significants digits of this number in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"digits","doc":null,"default_value":"","external_name":"digits","restriction":""},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(digits, base = <span class=\"n\">10</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L185","def":{"name":"significant","args":[{"name":"digits","doc":null,"default_value":"","external_name":"digits","restriction":""},{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if digits < 0\n  raise(ArgumentError.new(\"digits should be non-negative\"))\nend\nx = self.to_f\nif x == 0\n  return x\nend\ny = if base == 10\n  10 ** ((((Math.log10(self.abs)) - digits) + 1).floor)\nelse\n  if base == 2\n    2 ** ((((Math.log2(self.abs)) - digits) + 1).floor)\n  else\n    base ** (((((Math.log2(self.abs)) / (Math.log2(base))) - digits) + 1).floor)\n  end\nend\nself.class.new((x / y).round * y)\n"}},{"id":"step(*,to=nil,by=1)-instance-method","html_id":"step(*,to=nil,by=1)-instance-method","name":"step","doc":null,"summary":null,"abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"to","doc":null,"default_value":"nil","external_name":"to","restriction":""},{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"args_string":"(*, to = <span class=\"n\">nil</span>, by = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L115","def":{"name":"step","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"to","doc":null,"default_value":"nil","external_name":"to","restriction":""},{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StepIterator.new(self + (by - by), to, by)"}},{"id":"step(*,to=nil,by=1,&block)-instance-method","html_id":"step(*,to=nil,by=1,&amp;block)-instance-method","name":"step","doc":"Invokes the given block with the sequence of numbers starting at `self`,\nincremented by *by* on each call, and with an optional *to*.\n\n```\n3.step(to: 10, by: 2) do |n|\n  puts n\nend\n```\n\nOutput:\n\n```text\n3\n5\n7\n9\n```","summary":"<p>Invokes the given block with the sequence of numbers starting at <code>self</code>, incremented by <em>by</em> on each call, and with an optional <em>to</em>.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"to","doc":null,"default_value":"nil","external_name":"to","restriction":""},{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"args_string":"(*, to = <span class=\"n\">nil</span>, by = <span class=\"n\">1</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L90","def":{"name":"step","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"to","doc":null,"default_value":"nil","external_name":"to","restriction":""},{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"x = self + (by - by)\nif to\n  if by > 0\n    while x <= to\n      yield x\n      x = x + by\n    end\n  else\n    if by < 0\n      while x >= to\n        yield x\n        x = x + by\n      end\n    end\n  end\nelse\n  while true\n    yield x\n    x = x + by\n  end\nend\nself\n"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L277","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new(self)"}},{"id":"to_c-instance-method","html_id":"to_c-instance-method","name":"to_c","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/complex.cr#L240","def":{"name":"to_c","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Complex.new(self, 0)"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L72","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(self.to_s)"}},{"id":"zero?:Bool-instance-method","html_id":"zero?:Bool-instance-method","name":"zero?","doc":"Returns `true` if value is equal to zero.\n\n```\n0.zero? # => true\n5.zero? # => false\n```","summary":"<p>Returns <code>true</code> if value is equal to zero.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L254","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L254","def":{"name":"zero?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"self == 0"}}],"macros":[{"id":"[](*nums)-macro","html_id":"[](*nums)-macro","name":"[]","doc":"Creates an `Array` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\n```\nfloats = Float64[1, 2, 3, 4]\nfloats.class # => Array(Float64)\n\nints = Int64[1, 2, 3]\nints.class # => Array(Int64)\n```","summary":"<p>Creates an <code><a href=\"Array.html\">Array</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""}],"args_string":"(*nums)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L26","def":{"name":"[]","args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    Array(\n{{ @type }}\n).build(\n{{ nums.size }}\n) do |\n%buffer\n|\n      \n{% for num, i in nums %}\n        %buffer[{{ i }}] = {{ @type }}.new({{ num }})\n      {% end %}\n\n      \n{{ nums.size }}\n\n    \nend\n  \n"}},{"id":"slice(*nums,read_only=false)-macro","html_id":"slice(*nums,read_only=false)-macro","name":"slice","doc":"Creates a `Slice` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\nThe slice is allocated on the heap.\n\n```\nfloats = Float64.slice(1, 2, 3, 4)\nfloats.class # => Slice(Float64)\n\nints = Int64.slice(1, 2, 3)\nints.class # => Slice(Int64)\n```","summary":"<p>Creates a <code><a href=\"Slice.html\">Slice</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*nums, read_only = false)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L47","def":{"name":"slice","args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n%slice\n = Slice(\n{{ @type }}\n).new(\n{{ nums.size }}\n, read_only: \n{{ read_only }}\n)\n    \n{% for num, i in nums %}\n      %slice.to_unsafe[{{ i }}] = {{ @type }}.new({{ num }})\n    {% end %}\n\n    \n%slice\n\n  \n"}},{"id":"static_array(*nums)-macro","html_id":"static_array(*nums)-macro","name":"static_array","doc":"Creates a `StaticArray` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\n```\nfloats = Float64.static_array(1, 2, 3, 4)\nfloats.class # => StaticArray(Float64, 4)\n\nints = Int64.static_array(1, 2, 3)\nints.class # => StaticArray(Int64, 3)\n```","summary":"<p>Creates a <code><a href=\"StaticArray.html\">StaticArray</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""}],"args_string":"(*nums)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr#L65","def":{"name":"static_array","args":[{"name":"nums","doc":null,"default_value":"","external_name":"nums","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n%array\n = uninitialized StaticArray(\n{{ @type }}\n, \n{{ nums.size }}\n)\n    \n{% for num, i in nums %}\n      %array.to_unsafe[{{ i }}] = {{ @type }}.new({{ num }})\n    {% end %}\n\n    \n%array\n\n  \n"}}],"types":[{"html_id":"github.com/crystal-lang/crystal/Number/Primitive","path":"Number/Primitive.html","kind":"alias","full_name":"Number::Primitive","name":"Primitive","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"number.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/number.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Float32 | Float64 | Int128 | Int16 | Int32 | Int64 | Int8 | UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OAuth","path":"OAuth.html","kind":"module","full_name":"OAuth","name":"OAuth","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"oauth/access_token.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr"},{"filename":"oauth/oauth.cr","line_number":38,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/oauth.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The OAuth module provides an `OAuth::Consumer` as specified by\n[RFC 5849](https://tools.ietf.org/html/rfc5849).\n\n### Performing HTTP client requests with OAuth authentication\n\nAssuming you have an access token, its secret, the consumer key and the consumer secret,\nyou can setup an `HTTP::Client` to be authenticated with OAuth using this code:\n\n```\nrequire \"http/client\"\nrequire \"oauth\"\n\ntoken = \"some_token\"\nsecret = \"some_secret\"\nconsumer_key = \"some_consumer_key\"\nconsumer_secret = \"some_consumer_secret\"\n\n# Create an HTTP::Client as usual\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\n\n# Prepare it for using OAuth authentication\nOAuth.authenticate(client, token, secret, consumer_key, consumer_secret)\n\n# Execute requests as usual: they will be authenticated\nclient.get(\"/some_path\")\n```\n\nThis is implemented with `HTTP::Client#before_request` to add an authorization\nheader to every request.\n\nAlternatively, you can create an `OAuth::Consumer` and then invoke its\n`OAuth::Consumer#authenticate` method, or create an `OAuth::AccessToken`\nand invoke its `OAuth::AccessToken#authenticate`.\n\n### Obtaining access tokens\n\nSee `OAuth::Consumer` for an example.","summary":"<p>The OAuth module provides an <code><a href=\"OAuth/Consumer.html\">OAuth::Consumer</a></code> as specified by <a href=\"https://tools.ietf.org/html/rfc5849\" target=\"_blank\">RFC 5849</a>.</p>","class_methods":[{"id":"authenticate(client:HTTP::Client,token,token_secret,consumer_key,consumer_secret,extra_params=nil):Nil-class-method","html_id":"authenticate(client:HTTP::Client,token,token_secret,consumer_key,consumer_secret,extra_params=nil):Nil-class-method","name":"authenticate","doc":"Sets up an `HTTP::Client` to add an OAuth authorization header to every request performed.\nCheck this module's docs for an example usage.","summary":"<p>Sets up an <code><a href=\"HTTP/Client.html\">HTTP::Client</a></code> to add an OAuth authorization header to every request performed.</p>","abstract":false,"args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"},{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":""},{"name":"token_secret","doc":null,"default_value":"","external_name":"token_secret","restriction":""},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(client : HTTP::Client, token, token_secret, consumer_key, consumer_secret, extra_params = <span class=\"n\">nil</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/oauth.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/oauth.cr#L41","def":{"name":"authenticate","args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"},{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":""},{"name":"token_secret","doc":null,"default_value":"","external_name":"token_secret","restriction":""},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"client.before_request do |request|\n  authenticate(client, request, token, token_secret, consumer_key, consumer_secret, extra_params)\nend"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OAuth/AccessToken","path":"OAuth/AccessToken.html","kind":"class","full_name":"OAuth::AccessToken","name":"AccessToken","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth/access_token.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"from_response(response:String):self-class-method","html_id":"from_response(response:String):self-class-method","name":"from_response","doc":null,"summary":null,"abstract":false,"args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":"String"}],"args_string":"(response : String) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L16","def":{"name":"from_response","args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"token = nil\nsecret = nil\nextra = nil\nHTTP::Params.parse(response) do |key, value|\n  case key\n  when \"oauth_token\"\n    token = value\n  when \"oauth_token_secret\"\n    secret = value\n  else\n    extra || (extra = {} of String => String)\n    extra[key] = value\n  end\nend\nnew(token.not_nil!, secret.not_nil!, extra)\n"}},{"id":"new(token:String,secret:String,extra:Hash(String,String)?=nil)-class-method","html_id":"new(token:String,secret:String,extra:Hash(String,String)?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"String"},{"name":"secret","doc":null,"default_value":"","external_name":"secret","restriction":"String"},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"args_string":"(token : String, secret : String, extra : Hash(String, String)? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L5","def":{"name":"new","args":[{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"String"},{"name":"secret","doc":null,"default_value":"","external_name":"secret","restriction":"String"},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(token, secret, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L34","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"token = nil\nsecret = nil\nextra = nil\npull.read_object do |key|\n  case key\n  when \"oauth_token\"\n    token = pull.read_string\n  when \"oauth_token_secret\"\n    secret = pull.read_string\n  else\n    if pull.kind == (:STRING)\n      extra || (extra = {} of String => String)\n      extra[key] = pull.read_string\n    else\n      pull.skip\n    end\n  end\nend\nnew(token.not_nil!, secret.not_nil!, extra)\n"}}],"instance_methods":[{"id":"authenticate(client,consumer_key,consumer_secret,extra_params=nil)-instance-method","html_id":"authenticate(client,consumer_key,consumer_secret,extra_params=nil)-instance-method","name":"authenticate","doc":null,"summary":null,"abstract":false,"args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":""},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(client, consumer_key, consumer_secret, extra_params = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L8","def":{"name":"authenticate","args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":""},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"OAuth.authenticate(client, @token, @secret, consumer_key, consumer_secret, extra_params)"}},{"id":"extra-instance-method","html_id":"extra-instance-method","name":"extra","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L12","def":{"name":"extra","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra || (@extra = {} of String => String)"}},{"id":"secret:String-instance-method","html_id":"secret:String-instance-method","name":"secret","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L3","def":{"name":"secret","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@secret"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L58","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.object do\n  json.field(\"oauth_token\", @token)\n  json.field(\"oauth_token_secret\", @secret)\n  @extra.try(&.each do |key, value|\n    json.field(key, value)\n  end)\nend"}},{"id":"token:String-instance-method","html_id":"token:String-instance-method","name":"token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/access_token.cr#L2","def":{"name":"token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@token"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth/Consumer","path":"OAuth/Consumer.html","kind":"class","full_name":"OAuth::Consumer","name":"Consumer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth/consumer.cr","line_number":53,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"doc":"An OAuth consumer.\n\nFor a quick example of how to authenticate an `HTTP::Client` with OAuth if\nyou already have an access token, check the `OAuth` module description.\n\nThis class also provides methods to get request tokens, build authorize URIs\nand get access tokens, as specified by [RFC 5849](https://tools.ietf.org/html/rfc5849).\n\n### Example\n\n```\nrequire \"oauth\"\n\nconsumer_key = \"some_key\"\nconsumer_secret = \"some_secret\"\noauth_callback = \"http://some.callback\"\n\n# Create consumer, optionally pass custom URIs if needed,\n# if the request, authorize or access_token URIs are not the standard ones\n# (they can also be absolute URLs)\nconsumer = OAuth::Consumer.new(\"api.example.com\", consumer_key, consumer_secret)\n\n# Get a request token.\n# We probably need to save this somewhere to get it back in the\n# callback URL (saving token and secret should be enough)\nrequest_token = consumer.get_request_token(oauth_callback)\n\n# Build an authorize URI\nauthorize_uri = consumer.get_authorize_uri(request_token, oauth_callback)\n\n# Redirect the user to `authorize_uri`...\n#\n# ...\n#\n# When http://some.callback is hit, once the user authorized the access,\n# we resume our logic to finally get an access token. The callback URL\n# should receive an `oauth_verifier` parameter that we need to use.\noauth_verifier = request.params[\"oauth_verifier\"]\n\n# Get the access token\naccess_token = consumer.get_access_token(request_token, oauth_verifier)\n\n# Probably save the access token for reuse... This can be done\n# with `to_json` and `from_json`.\n\n# Use the token to authenticate an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\naccess_token.authenticate(client, consumer_key, consumer_secret)\n\n# And do requests as usual\nclient.get \"/some_path\"\n```","summary":"<p>An OAuth consumer.</p>","class_methods":[],"constructors":[{"id":"new(host:String,consumer_key:String,consumer_secret:String,port:Int32=443,scheme:String=&quot;https&quot;,request_token_uri:String=&quot;/oauth/request_token&quot;,authorize_uri:String=&quot;/oauth/authorize&quot;,access_token_uri:String=&quot;/oauth/access_token&quot;)-class-method","html_id":"new(host:String,consumer_key:String,consumer_secret:String,port:Int32=443,scheme:String=&amp;quot;https&amp;quot;,request_token_uri:String=&amp;quot;/oauth/request_token&amp;quot;,authorize_uri:String=&amp;quot;/oauth/authorize&amp;quot;,access_token_uri:String=&amp;quot;/oauth/access_token&amp;quot;)-class-method","name":"new","doc":"Creates an OAuth consumer.\n\nAny or all of the customizable URIs *request_token_uri*, *authorize_uri* and\n*access_token_uri* can be relative or absolute.\nIf they are relative, the given *host*, *port* and *scheme* will be used.\nIf they are absolute, the absolute URL will be used.","summary":"<p>Creates an OAuth consumer.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":"String"},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":"String"},{"name":"port","doc":null,"default_value":"443","external_name":"port","restriction":"Int32"},{"name":"scheme","doc":null,"default_value":"\"https\"","external_name":"scheme","restriction":"String"},{"name":"request_token_uri","doc":null,"default_value":"\"/oauth/request_token\"","external_name":"request_token_uri","restriction":"String"},{"name":"authorize_uri","doc":null,"default_value":"\"/oauth/authorize\"","external_name":"authorize_uri","restriction":"String"},{"name":"access_token_uri","doc":null,"default_value":"\"/oauth/access_token\"","external_name":"access_token_uri","restriction":"String"}],"args_string":"(host : String, consumer_key : String, consumer_secret : String, port : Int32 = <span class=\"n\">443</span>, scheme : String = <span class=\"s\">&quot;https&quot;</span>, request_token_uri : String = <span class=\"s\">&quot;/oauth/request_token&quot;</span>, authorize_uri : String = <span class=\"s\">&quot;/oauth/authorize&quot;</span>, access_token_uri : String = <span class=\"s\">&quot;/oauth/access_token&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L62","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"consumer_key","doc":null,"default_value":"","external_name":"consumer_key","restriction":"String"},{"name":"consumer_secret","doc":null,"default_value":"","external_name":"consumer_secret","restriction":"String"},{"name":"port","doc":null,"default_value":"443","external_name":"port","restriction":"Int32"},{"name":"scheme","doc":null,"default_value":"\"https\"","external_name":"scheme","restriction":"String"},{"name":"request_token_uri","doc":null,"default_value":"\"/oauth/request_token\"","external_name":"request_token_uri","restriction":"String"},{"name":"authorize_uri","doc":null,"default_value":"\"/oauth/authorize\"","external_name":"authorize_uri","restriction":"String"},{"name":"access_token_uri","doc":null,"default_value":"\"/oauth/access_token\"","external_name":"access_token_uri","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(host, consumer_key, consumer_secret, port, scheme, request_token_uri, authorize_uri, access_token_uri)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"authenticate(client:HTTP::Client,token:AccessToken):Nil-instance-method","html_id":"authenticate(client:HTTP::Client,token:AccessToken):Nil-instance-method","name":"authenticate","doc":"Authenticated an `HTTP::Client` to add an OAuth authorization header, as specified by\n[RFC 5849, Section 3](https://tools.ietf.org/html/rfc5849#section-3).","summary":"<p>Authenticated an <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code> to add an OAuth authorization header, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-3\" target=\"_blank\">RFC 5849, Section 3</a>.</p>","abstract":false,"args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"},{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"AccessToken"}],"args_string":"(client : HTTP::Client, token : AccessToken) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L131","def":{"name":"authenticate","args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"},{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"AccessToken"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"authenticate(client, token.token, token.secret, nil)"}},{"id":"get_access_token(request_token,oauth_verifier,extra_params=nil):AccessToken-instance-method","html_id":"get_access_token(request_token,oauth_verifier,extra_params=nil):AccessToken-instance-method","name":"get_access_token","doc":"Gets an access token from a previously obtained request token and an *oauth_verifier*\nobtained from an authorize URI, as specified by\n[RFC 5849, Section 2.3](https://tools.ietf.org/html/rfc5849#section-2.3).\n\nRaises `OAuth::Error` if there was an error getting the access token.","summary":"<p>Gets an access token from a previously obtained request token and an <em>oauth_verifier</em> obtained from an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.3\" target=\"_blank\">RFC 5849, Section 2.3</a>.</p>","abstract":false,"args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_verifier","doc":null,"default_value":"","external_name":"oauth_verifier","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(request_token, oauth_verifier, extra_params = <span class=\"n\">nil</span>) : AccessToken","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L121","def":{"name":"get_access_token","args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_verifier","doc":null,"default_value":"","external_name":"oauth_verifier","restriction":""},{"name":"extra_params","doc":null,"default_value":"nil","external_name":"extra_params","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"AccessToken","visibility":"Public","body":"extra_params || (extra_params = {} of String => String)\nextra_params[\"oauth_verifier\"] = oauth_verifier\npost(request_token.token, request_token.secret, extra_params, @access_token_uri) do |response|\n  AccessToken.from_response(response.body)\nend\n"}},{"id":"get_authorize_uri(request_token,oauth_callback=nil):String-instance-method","html_id":"get_authorize_uri(request_token,oauth_callback=nil):String-instance-method","name":"get_authorize_uri","doc":"Returns an authorize URI from a given request token to redirect the user\nto obtain an access token, as specified by\n[RFC 5849, Section 2.2](https://tools.ietf.org/html/rfc5849#section-2.2).","summary":"<p>Returns an authorize URI from a given request token to redirect the user to obtain an access token, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.2\" target=\"_blank\">RFC 5849, Section 2.2</a>.</p>","abstract":false,"args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_callback","doc":null,"default_value":"nil","external_name":"oauth_callback","restriction":""}],"args_string":"(request_token, oauth_callback = <span class=\"n\">nil</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L84","def":{"name":"get_authorize_uri","args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_callback","doc":null,"default_value":"nil","external_name":"oauth_callback","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"get_authorize_uri(request_token, oauth_callback) do\nend"}},{"id":"get_authorize_uri(request_token,oauth_callback=nil,&block:HTTP::Params::Builder->):String-instance-method","html_id":"get_authorize_uri(request_token,oauth_callback=nil,&amp;block:HTTP::Params::Builder-&gt;):String-instance-method","name":"get_authorize_uri","doc":"Returns an authorize URI from a given request token to redirect the user\nto obtain an access token, as specified by\n[RFC 5849, Section 2.2](https://tools.ietf.org/html/rfc5849#section-2.2).\n\nYields an `HTTP::Params::Builder` to add extra parameters other than those\ndefined by the standard.","summary":"<p>Returns an authorize URI from a given request token to redirect the user to obtain an access token, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.2\" target=\"_blank\">RFC 5849, Section 2.2</a>.</p>","abstract":false,"args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_callback","doc":null,"default_value":"nil","external_name":"oauth_callback","restriction":""}],"args_string":"(request_token, oauth_callback = <span class=\"n\">nil</span>, &block : HTTP::Params::Builder -> ) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L94","def":{"name":"get_authorize_uri","args":[{"name":"request_token","doc":null,"default_value":"","external_name":"request_token","restriction":""},{"name":"oauth_callback","doc":null,"default_value":"nil","external_name":"oauth_callback","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(HTTP::Params::Builder -> )"},"return_type":"String","visibility":"Public","body":"uri = URI.parse(@authorize_uri)\nif uri.host\nelse\n  uri = URI.new(@scheme, @host, @port, @authorize_uri)\nend\nuri.query = HTTP::Params.build do |form|\n  form.add(\"oauth_token\", request_token.token)\n  if oauth_callback\n    form.add(\"oauth_callback\", oauth_callback)\n  end\n  if query = uri.query\n    (HTTP::Params.parse(query)).each do |key, value|\n      form.add(key, value)\n    end\n  end\n  yield form\nend\nuri.to_s\n"}},{"id":"get_request_token(oauth_callback=&quot;oob&quot;)-instance-method","html_id":"get_request_token(oauth_callback=&amp;quot;oob&amp;quot;)-instance-method","name":"get_request_token","doc":"Obtains a request token, also known as \"temporary credentials\", as specified by\n[RFC 5849, Section 2.1](https://tools.ietf.org/html/rfc5849#section-2.1).\n\nRaises `OAuth::Error` if there was an error getting the request token.","summary":"<p>Obtains a request token, also known as \"temporary credentials\", as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.1\" target=\"_blank\">RFC 5849, Section 2.1</a>.</p>","abstract":false,"args":[{"name":"oauth_callback","doc":null,"default_value":"\"oob\"","external_name":"oauth_callback","restriction":""}],"args_string":"(oauth_callback = <span class=\"s\">&quot;oob&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/consumer.cr#L75","def":{"name":"get_request_token","args":[{"name":"oauth_callback","doc":null,"default_value":"\"oob\"","external_name":"oauth_callback","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"post(nil, nil, {\"oauth_callback\" => oauth_callback}, @request_token_uri) do |response|\n  RequestToken.from_response(response.body)\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth/Error","path":"OAuth/Error.html","kind":"class","full_name":"OAuth::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth/error.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(response)-class-method","html_id":"new(response)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":""}],"args_string":"(response)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/error.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/error.cr#L2","def":{"name":"new","args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(response)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth/RequestToken","path":"OAuth/RequestToken.html","kind":"class","full_name":"OAuth::RequestToken","name":"RequestToken","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth/request_token.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"from_response(response):self-class-method","html_id":"from_response(response):self-class-method","name":"from_response","doc":null,"summary":null,"abstract":false,"args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":""}],"args_string":"(response) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L8","def":{"name":"from_response","args":[{"name":"response","doc":null,"default_value":"","external_name":"response","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"token = nil\nsecret = nil\nHTTP::Params.parse(response) do |key, value|\n  case key\n  when \"oauth_token\"\n    token = value\n  when \"oauth_token_secret\"\n    secret = value\n  end\nend\nnew(token.not_nil!, secret.not_nil!)\n"}},{"id":"new(token:String,secret:String)-class-method","html_id":"new(token:String,secret:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"String"},{"name":"secret","doc":null,"default_value":"","external_name":"secret","restriction":"String"}],"args_string":"(token : String, secret : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L5","def":{"name":"new","args":[{"name":"token","doc":null,"default_value":"","external_name":"token","restriction":"String"},{"name":"secret","doc":null,"default_value":"","external_name":"secret","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(token, secret)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"secret:String-instance-method","html_id":"secret:String-instance-method","name":"secret","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L3","def":{"name":"secret","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@secret"}},{"id":"token:String-instance-method","html_id":"token:String-instance-method","name":"token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth/request_token.cr#L2","def":{"name":"token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@token"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OAuth2","path":"OAuth2.html","kind":"module","full_name":"OAuth2","name":"OAuth2","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"oauth2/client.cr","line_number":56,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr"},{"filename":"oauth2/oauth2.cr","line_number":33,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/oauth2.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The OAuth module provides an `OAuth2::Client` as specified\nby [RFC 6749](https://tools.ietf.org/html/rfc6749).\n\n### Performing HTTP client requests with OAuth2 authentication\n\nAssuming you have an access token, you can setup an `HTTP::Client`\nto be authenticated with OAuth2 using this code:\n\n```\nrequire \"http/client\"\nrequire \"oauth2\"\n\n# Here we use a bearer token, but it could be a mac token. We also set the\n# expires in value to 172,800 seconds, or 48 hours\naccess_token = OAuth2::AccessToken::Bearer.new(\"some_access_token\", 172_800)\n\n# Create an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\n\n# Prepare it for using OAuth2 authentication\naccess_token.authenticate(client)\n\n# Execute requests as usual: they will be authenticated\nclient.get(\"/some_path\")\n```\n\nThis is implemented with `HTTP::Client#before_request` to add an authorization\nheader to every request.\n\n### Obtaining access tokens\n\nSee `OAuth2::Client` for an example.","summary":"<p>The OAuth module provides an <code><a href=\"OAuth2/Client.html\">OAuth2::Client</a></code> as specified by <a href=\"https://tools.ietf.org/html/rfc6749\" target=\"_blank\">RFC 6749</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","path":"OAuth2/AccessToken.html","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/access_token/access_token.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken/Bearer","kind":"class","full_name":"OAuth2::AccessToken::Bearer","name":"Bearer"},{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken/Mac","kind":"class","full_name":"OAuth2::AccessToken::Mac","name":"Mac"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"Base class for the two possible access tokens: Bearer and Mac.\n\nUse `#authenticate` to authenticate an `HTTP::Client`.","summary":"<p>Base class for the two possible access tokens: Bearer and Mac.</p>","class_methods":[],"constructors":[{"id":"new(access_token:String,expires_in:Int?,refresh_token:String?=nil,scope:String?=nil,extra=nil)-class-method","html_id":"new(access_token:String,expires_in:Int?,refresh_token:String?=nil,scope:String?=nil,extra=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"String"},{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":"Int | ::Nil"},{"name":"refresh_token","doc":null,"default_value":"nil","external_name":"refresh_token","restriction":"String | ::Nil"},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":"String | ::Nil"},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":""}],"args_string":"(access_token : String, expires_in : Int?, refresh_token : String? = <span class=\"n\">nil</span>, scope : String? = <span class=\"n\">nil</span>, extra = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L57","def":{"name":"new","args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"String"},{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":"Int | ::Nil"},{"name":"refresh_token","doc":null,"default_value":"nil","external_name":"refresh_token","restriction":"String | ::Nil"},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":"String | ::Nil"},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(access_token, expires_in, refresh_token, scope, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L5","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"token_type = nil\naccess_token = nil\nexpires_in = nil\nrefresh_token = nil\nscope = nil\nmac_algorithm = nil\nmac_key = nil\nextra = nil\npull.read_object do |key|\n  case key\n  when \"token_type\"\n    token_type = pull.read_string\n  when \"access_token\"\n    access_token = pull.read_string\n  when \"expires_in\"\n    expires_in = pull.read_int\n  when \"refresh_token\"\n    refresh_token = pull.read_string_or_null\n  when \"scope\"\n    scope = pull.read_string_or_null\n  when \"mac_algorithm\"\n    mac_algorithm = pull.read_string\n  when \"mac_key\"\n    mac_key = pull.read_string\n  else\n    extra || (extra = {} of String => String)\n    extra[key] = pull.read_raw\n  end\nend\naccess_token = access_token.not_nil!\ntoken_type || (token_type = \"bearer\")\ncase token_type.downcase\nwhen \"bearer\"\n  Bearer.new(access_token, expires_in, refresh_token, scope, extra)\nwhen \"mac\"\n  Mac.new(access_token, expires_in, mac_algorithm.not_nil!, mac_key.not_nil!, refresh_token, scope, Time.now.epoch, extra)\nelse\n  raise(\"Unknown token_type in access token json: #{token_type}\")\nend\n"}}],"instance_methods":[{"id":"access_token:String-instance-method","html_id":"access_token:String-instance-method","name":"access_token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L44","def":{"name":"access_token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@access_token"}},{"id":"access_token=(access_token:String)-instance-method","html_id":"access_token=(access_token:String)-instance-method","name":"access_token=","doc":null,"summary":null,"abstract":false,"args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"String"}],"args_string":"(access_token : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L44","def":{"name":"access_token=","args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@access_token = access_token"}},{"id":"authenticate(request:HTTP::Request,tls)-instance-method","html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","doc":null,"summary":null,"abstract":true,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L61","def":{"name":"authenticate","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"authenticate(client:HTTP::Client)-instance-method","html_id":"authenticate(client:HTTP::Client)-instance-method","name":"authenticate","doc":null,"summary":null,"abstract":false,"args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"}],"args_string":"(client : HTTP::Client)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L63","def":{"name":"authenticate","args":[{"name":"client","doc":null,"default_value":"","external_name":"client","restriction":"HTTP::Client"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"client.before_request do |request|\n  authenticate(request, client.tls?)\nend"}},{"id":"expires_in:Int64?-instance-method","html_id":"expires_in:Int64?-instance-method","name":"expires_in","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L45","def":{"name":"expires_in","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64 | ::Nil","visibility":"Public","body":"@expires_in"}},{"id":"expires_in=(expires_in:Int64?)-instance-method","html_id":"expires_in=(expires_in:Int64?)-instance-method","name":"expires_in=","doc":null,"summary":null,"abstract":false,"args":[{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":"Int64 | ::Nil"}],"args_string":"(expires_in : Int64?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L45","def":{"name":"expires_in=","args":[{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":"Int64 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@expires_in = expires_in"}},{"id":"extra:Hash(String,String)?-instance-method","html_id":"extra:Hash(String,String)?-instance-method","name":"extra","doc":"JSON key-value pairs that are outside of the OAuth2 spec are\nstored in this property in case they are needed. Their value\nis the raw JSON string found in the JSON value (with possible\nchanges in the string format, but preserving JSON semantic).\nFor example if the value was `[1, 2, 3]` then the value in this hash\nwill be the string \"[1,2,3]\".","summary":"<p>JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.</p>","abstract":false,"args":[],"args_string":" : Hash(String, String)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L55","def":{"name":"extra","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(String, String) | ::Nil","visibility":"Public","body":"@extra"}},{"id":"extra=(extra:Hash(String,String)?)-instance-method","html_id":"extra=(extra:Hash(String,String)?)-instance-method","name":"extra=","doc":"JSON key-value pairs that are outside of the OAuth2 spec are\nstored in this property in case they are needed. Their value\nis the raw JSON string found in the JSON value (with possible\nchanges in the string format, but preserving JSON semantic).\nFor example if the value was `[1, 2, 3]` then the value in this hash\nwill be the string \"[1,2,3]\".","summary":"<p>JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.</p>","abstract":false,"args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"args_string":"(extra : Hash(String, String)?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L55","def":{"name":"extra=","args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra = extra"}},{"id":"refresh_token:String?-instance-method","html_id":"refresh_token:String?-instance-method","name":"refresh_token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L46","def":{"name":"refresh_token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@refresh_token"}},{"id":"refresh_token=(refresh_token:String?)-instance-method","html_id":"refresh_token=(refresh_token:String?)-instance-method","name":"refresh_token=","doc":null,"summary":null,"abstract":false,"args":[{"name":"refresh_token","doc":null,"default_value":"","external_name":"refresh_token","restriction":"String | ::Nil"}],"args_string":"(refresh_token : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L46","def":{"name":"refresh_token=","args":[{"name":"refresh_token","doc":null,"default_value":"","external_name":"refresh_token","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@refresh_token = refresh_token"}},{"id":"scope:String?-instance-method","html_id":"scope:String?-instance-method","name":"scope","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L47","def":{"name":"scope","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@scope"}},{"id":"scope=(scope:String?)-instance-method","html_id":"scope=(scope:String?)-instance-method","name":"scope=","doc":null,"summary":null,"abstract":false,"args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":"String | ::Nil"}],"args_string":"(scope : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/access_token.cr#L47","def":{"name":"scope=","args":[{"name":"scope","doc":null,"default_value":"","external_name":"scope","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@scope = scope"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken/Bearer","path":"OAuth2/AccessToken/Bearer.html","kind":"class","full_name":"OAuth2::AccessToken::Bearer","name":"Bearer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/access_token/bearer.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L4","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(OAuth2::AccessToken.new(pull)).as(self)"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":null,"source_link":null,"def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if access_token == other.access_token\nelse\n  return false\nend\nif expires_in == other.expires_in\nelse\n  return false\nend\nif refresh_token == other.refresh_token\nelse\n  return false\nend\nif scope == other.scope\nelse\n  return false\nend\ntrue\n"}},{"id":"authenticate(request:HTTP::Request,tls)-instance-method","html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","doc":null,"summary":null,"abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L12","def":{"name":"authenticate","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"request.headers[\"Authorization\"] = \"Bearer #{access_token}\""}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":null,"source_link":null,"def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = access_token.hash(hasher)\nhasher = expires_in.hash(hasher)\nhasher = refresh_token.hash(hasher)\nhasher = scope.hash(hasher)\nhasher\n"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L16","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.object do\n  json.field(\"token_type\", \"bearer\")\n  json.field(\"access_token\", access_token)\n  json.field(\"expires_in\", expires_in)\n  if refresh_token\n    json.field(\"refresh_token\", refresh_token)\n  end\n  if scope\n    json.field(\"scope\", scope)\n  end\nend"}},{"id":"token_type-instance-method","html_id":"token_type-instance-method","name":"token_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/bearer.cr#L8","def":{"name":"token_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"Bearer\""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken/Mac","path":"OAuth2/AccessToken/Mac.html","kind":"class","full_name":"OAuth2::AccessToken::Mac","name":"Mac","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/access_token/mac.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"doc":null,"summary":null,"class_methods":[{"id":"signature(ts,nonce,method,uri,host,port,ext,mac_algorithm,mac_key)-class-method","html_id":"signature(ts,nonce,method,uri,host,port,ext,mac_algorithm,mac_key)-class-method","name":"signature","doc":null,"summary":null,"abstract":false,"args":[{"name":"ts","doc":null,"default_value":"","external_name":"ts","restriction":""},{"name":"nonce","doc":null,"default_value":"","external_name":"nonce","restriction":""},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""},{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"ext","doc":null,"default_value":"","external_name":"ext","restriction":""},{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":""}],"args_string":"(ts, nonce, method, uri, host, port, ext, mac_algorithm, mac_key)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L37","def":{"name":"signature","args":[{"name":"ts","doc":null,"default_value":"","external_name":"ts","restriction":""},{"name":"nonce","doc":null,"default_value":"","external_name":"nonce","restriction":""},{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""},{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"ext","doc":null,"default_value":"","external_name":"ext","restriction":""},{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"normalized_request_string = \"#{ts}\\n#{nonce}\\n#{method}\\n#{uri}\\n#{host}\\n#{port}\\n#{ext}\\n\"\ndigest = case mac_algorithm\nwhen \"hmac-sha-1\"\n  :sha1\nwhen \"hmac-sha-256\"\n  :sha256\nelse\n  raise(\"Unsupported algorithm: #{mac_algorithm}\")\nend\nBase64.strict_encode(OpenSSL::HMAC.digest(digest, mac_key, normalized_request_string))\n"}}],"constructors":[{"id":"new(access_token,expires_in,mac_algorithm,mac_key,refresh_token=nil,scope=nil,issued_at=Time.now.epoch,extra=nil)-class-method","html_id":"new(access_token,expires_in,mac_algorithm,mac_key,refresh_token=nil,scope=nil,issued_at=Time.now.epoch,extra=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":""},{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":""},{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":""},{"name":"refresh_token","doc":null,"default_value":"nil","external_name":"refresh_token","restriction":""},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"issued_at","doc":null,"default_value":"Time.now.epoch","external_name":"issued_at","restriction":""},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":""}],"args_string":"(access_token, expires_in, mac_algorithm, mac_key, refresh_token = <span class=\"n\">nil</span>, scope = <span class=\"n\">nil</span>, issued_at = <span class=\"t\">Time</span>.now.epoch, extra = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L15","def":{"name":"new","args":[{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":""},{"name":"expires_in","doc":null,"default_value":"","external_name":"expires_in","restriction":""},{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":""},{"name":"refresh_token","doc":null,"default_value":"nil","external_name":"refresh_token","restriction":""},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"issued_at","doc":null,"default_value":"Time.now.epoch","external_name":"issued_at","restriction":""},{"name":"extra","doc":null,"default_value":"nil","external_name":"extra","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(access_token, expires_in, mac_algorithm, mac_key, refresh_token, scope, issued_at, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L7","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(OAuth2::AccessToken.new(pull)).as(self)"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":null,"source_link":null,"def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if access_token == other.access_token\nelse\n  return false\nend\nif expires_in == other.expires_in\nelse\n  return false\nend\nif mac_algorithm == other.mac_algorithm\nelse\n  return false\nend\nif mac_key == other.mac_key\nelse\n  return false\nend\nif refresh_token == other.refresh_token\nelse\n  return false\nend\nif scope == other.scope\nelse\n  return false\nend\ntrue\n"}},{"id":"authenticate(request:HTTP::Request,tls)-instance-method","html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","doc":null,"summary":null,"abstract":false,"args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L23","def":{"name":"authenticate","args":[{"name":"request","doc":null,"default_value":"","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","doc":null,"default_value":"","external_name":"tls","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ts = Time.now.epoch\nnonce = \"#{ts - @issued_at}:#{Random::Secure.hex}\"\nmethod = request.method\nuri = request.resource\nhost, port = host_and_port(request, tls)\next = \"\"\nmac = Mac.signature(ts, nonce, method, uri, host, port, ext, mac_algorithm, mac_key)\nheader = \"MAC id=\\\"#{access_token}\\\", nonce=\\\"#{nonce}\\\", ts=\\\"#{ts}\\\", mac=\\\"#{mac}\\\"\"\nrequest.headers[\"Authorization\"] = header\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":null,"source_link":null,"def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = access_token.hash(hasher)\nhasher = expires_in.hash(hasher)\nhasher = mac_algorithm.hash(hasher)\nhasher = mac_key.hash(hasher)\nhasher = refresh_token.hash(hasher)\nhasher = scope.hash(hasher)\nhasher\n"}},{"id":"issued_at:Int64-instance-method","html_id":"issued_at:Int64-instance-method","name":"issued_at","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L13","def":{"name":"issued_at","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@issued_at"}},{"id":"issued_at=(issued_at:Int64)-instance-method","html_id":"issued_at=(issued_at:Int64)-instance-method","name":"issued_at=","doc":null,"summary":null,"abstract":false,"args":[{"name":"issued_at","doc":null,"default_value":"","external_name":"issued_at","restriction":"Int64"}],"args_string":"(issued_at : Int64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L13","def":{"name":"issued_at=","args":[{"name":"issued_at","doc":null,"default_value":"","external_name":"issued_at","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@issued_at = issued_at"}},{"id":"mac_algorithm:String-instance-method","html_id":"mac_algorithm:String-instance-method","name":"mac_algorithm","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L11","def":{"name":"mac_algorithm","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@mac_algorithm"}},{"id":"mac_algorithm=(mac_algorithm:String)-instance-method","html_id":"mac_algorithm=(mac_algorithm:String)-instance-method","name":"mac_algorithm=","doc":null,"summary":null,"abstract":false,"args":[{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":"String"}],"args_string":"(mac_algorithm : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L11","def":{"name":"mac_algorithm=","args":[{"name":"mac_algorithm","doc":null,"default_value":"","external_name":"mac_algorithm","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mac_algorithm = mac_algorithm"}},{"id":"mac_key:String-instance-method","html_id":"mac_key:String-instance-method","name":"mac_key","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L12","def":{"name":"mac_key","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@mac_key"}},{"id":"mac_key=(mac_key:String)-instance-method","html_id":"mac_key=(mac_key:String)-instance-method","name":"mac_key=","doc":null,"summary":null,"abstract":false,"args":[{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":"String"}],"args_string":"(mac_key : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L12","def":{"name":"mac_key=","args":[{"name":"mac_key","doc":null,"default_value":"","external_name":"mac_key","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@mac_key = mac_key"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L48","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.object do\n  json.field(\"token_type\", \"mac\")\n  json.field(\"access_token\", access_token)\n  json.field(\"expires_in\", expires_in)\n  if refresh_token\n    json.field(\"refresh_token\", refresh_token)\n  end\n  if scope\n    json.field(\"scope\", scope)\n  end\n  json.field(\"mac_algorithm\", mac_algorithm)\n  json.field(\"mac_key\", mac_key)\nend"}},{"id":"token_type-instance-method","html_id":"token_type-instance-method","name":"token_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/access_token/mac.cr#L19","def":{"name":"token_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"\"Mac\""}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Client","path":"OAuth2/Client.html","kind":"class","full_name":"OAuth2::Client","name":"Client","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/client.cr","line_number":56,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"An OAuth2 client.\n\nFor a quick example of how to authenticate an `HTTP::Client` with OAuth2 if\nyou already have an access token, check the `OAuth2` module description.\n\nThis class also provides methods to build authorize URIs\nand get access tokens with different methods, as specified by\n[RFC 6749](https://tools.ietf.org/html/rfc6749).\n\n### Example\n\n```\nrequire \"oauth2\"\n\nclient_id = \"some_client_id\"\nclient_secret = \"some_client_secret\"\nredirect_uri = \"http://some.callback\"\n\n# Create oauth client, optionally pass custom URIs if needed,\n# if the authorize or token URIs are not the standard ones\n# (they can also be absolute URLs)\noauth2_client = OAuth2::Client.new(\"api.example.com\", client_id, client_secret,\n  redirect_uri: redirect_uri)\n\n# Build an authorize URI\nauthorize_uri = oauth2_client.get_authorize_uri\n\n# Redirect the user to `authorize_uri`...\n#\n# ...\n#\n# When http://some.callback is hit, once the user authorized the access,\n# we resume our logic to finally get an access token. The callback URL\n# should receive an `authorization_code` parameter that we need to use.\nauthorization_code = request.params[\"code\"]\n\n# Get the access token\naccess_token = oauth2_client.get_access_token_using_authorization_code(authorization_code)\n\n# Probably save the access token for reuse... This can be done\n# with `to_json` and `from_json`.\n\n# Use the token to authenticate an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\naccess_token.authenticate(client)\n\n# And do requests as usual\nclient.get \"/some_path\"\n\n# If the token expires, we can refresh it\nnew_access_token = oauth2_client.get_access_token_using_refresh_token(access_token.refresh_token)\n```\n\nYou can also use an `OAuth2::Session` to automatically refresh expired\ntokens before each request.","summary":"<p>An OAuth2 client.</p>","class_methods":[],"constructors":[{"id":"new(host:String,client_id:String,client_secret:String,port=443,scheme=&quot;https&quot;,authorize_uri=&quot;/oauth2/authorize&quot;,token_uri=&quot;/oauth2/token&quot;,redirect_uri:String?=nil)-class-method","html_id":"new(host:String,client_id:String,client_secret:String,port=443,scheme=&amp;quot;https&amp;quot;,authorize_uri=&amp;quot;/oauth2/authorize&amp;quot;,token_uri=&amp;quot;/oauth2/token&amp;quot;,redirect_uri:String?=nil)-class-method","name":"new","doc":"Creates an OAuth client.\n\nAny or all of the customizable URIs *authorize_uri* and\n*token_uri* can be relative or absolute.\nIf they are relative, the given *host*, *port* and *scheme* will be used.\nIf they are absolute, the absolute URL will be used.","summary":"<p>Creates an OAuth client.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"client_id","doc":null,"default_value":"","external_name":"client_id","restriction":"String"},{"name":"client_secret","doc":null,"default_value":"","external_name":"client_secret","restriction":"String"},{"name":"port","doc":null,"default_value":"443","external_name":"port","restriction":""},{"name":"scheme","doc":null,"default_value":"\"https\"","external_name":"scheme","restriction":""},{"name":"authorize_uri","doc":null,"default_value":"\"/oauth2/authorize\"","external_name":"authorize_uri","restriction":""},{"name":"token_uri","doc":null,"default_value":"\"/oauth2/token\"","external_name":"token_uri","restriction":""},{"name":"redirect_uri","doc":null,"default_value":"nil","external_name":"redirect_uri","restriction":"String | ::Nil"}],"args_string":"(host : String, client_id : String, client_secret : String, port = <span class=\"n\">443</span>, scheme = <span class=\"s\">&quot;https&quot;</span>, authorize_uri = <span class=\"s\">&quot;/oauth2/authorize&quot;</span>, token_uri = <span class=\"s\">&quot;/oauth2/token&quot;</span>, redirect_uri : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L63","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"client_id","doc":null,"default_value":"","external_name":"client_id","restriction":"String"},{"name":"client_secret","doc":null,"default_value":"","external_name":"client_secret","restriction":"String"},{"name":"port","doc":null,"default_value":"443","external_name":"port","restriction":""},{"name":"scheme","doc":null,"default_value":"\"https\"","external_name":"scheme","restriction":""},{"name":"authorize_uri","doc":null,"default_value":"\"/oauth2/authorize\"","external_name":"authorize_uri","restriction":""},{"name":"token_uri","doc":null,"default_value":"\"/oauth2/token\"","external_name":"token_uri","restriction":""},{"name":"redirect_uri","doc":null,"default_value":"nil","external_name":"redirect_uri","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(host, client_id, client_secret, port, scheme, authorize_uri, token_uri, redirect_uri)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"get_access_token_using_authorization_code(authorization_code):AccessToken-instance-method","html_id":"get_access_token_using_authorization_code(authorization_code):AccessToken-instance-method","name":"get_access_token_using_authorization_code","doc":"Gets an access token using an authorization code, as specified by\n[RFC 6749, Section 4.1.1](https://tools.ietf.org/html/rfc6749#section-4.1.3).","summary":"<p>Gets an access token using an authorization code, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.3\" target=\"_blank\">RFC 6749, Section 4.1.1</a>.</p>","abstract":false,"args":[{"name":"authorization_code","doc":null,"default_value":"","external_name":"authorization_code","restriction":""}],"args_string":"(authorization_code) : AccessToken","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L109","def":{"name":"get_access_token_using_authorization_code","args":[{"name":"authorization_code","doc":null,"default_value":"","external_name":"authorization_code","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"redirect_uri\", @redirect_uri)\n  form.add(\"grant_type\", \"authorization_code\")\n  form.add(\"code\", authorization_code)\nend"}},{"id":"get_access_token_using_client_credentials(scope=nil)-instance-method","html_id":"get_access_token_using_client_credentials(scope=nil)-instance-method","name":"get_access_token_using_client_credentials","doc":"Gets an access token using client credentials, as specified by\n[RFC 6749, Section 4.4.2](https://tools.ietf.org/html/rfc6749#section-4.4.2).","summary":"<p>Gets an access token using client credentials, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.4.2\" target=\"_blank\">RFC 6749, Section 4.4.2</a>.</p>","abstract":false,"args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""}],"args_string":"(scope = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L129","def":{"name":"get_access_token_using_client_credentials","args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"grant_type\", \"client_credentials\")\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\nend"}},{"id":"get_access_token_using_refresh_token(refresh_token,scope=nil):AccessToken-instance-method","html_id":"get_access_token_using_refresh_token(refresh_token,scope=nil):AccessToken-instance-method","name":"get_access_token_using_refresh_token","doc":"Gets an access token using a refresh token, as specified by\n[RFC 6749, Section 6](https://tools.ietf.org/html/rfc6749#section-6).","summary":"<p>Gets an access token using a refresh token, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-6\" target=\"_blank\">RFC 6749, Section 6</a>.</p>","abstract":false,"args":[{"name":"refresh_token","doc":null,"default_value":"","external_name":"refresh_token","restriction":""},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""}],"args_string":"(refresh_token, scope = <span class=\"n\">nil</span>) : AccessToken","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L119","def":{"name":"get_access_token_using_refresh_token","args":[{"name":"refresh_token","doc":null,"default_value":"","external_name":"refresh_token","restriction":""},{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"grant_type\", \"refresh_token\")\n  form.add(\"refresh_token\", refresh_token)\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\nend"}},{"id":"get_authorize_uri(scope=nil,state=nil):String-instance-method","html_id":"get_authorize_uri(scope=nil,state=nil):String-instance-method","name":"get_authorize_uri","doc":"Builds an authorize URI, as specified by\n[RFC 6749, Section 4.1.1](https://tools.ietf.org/html/rfc6749#section-4.1.1).","summary":"<p>Builds an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.1\" target=\"_blank\">RFC 6749, Section 4.1.1</a>.</p>","abstract":false,"args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"state","doc":null,"default_value":"nil","external_name":"state","restriction":""}],"args_string":"(scope = <span class=\"n\">nil</span>, state = <span class=\"n\">nil</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L73","def":{"name":"get_authorize_uri","args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"state","doc":null,"default_value":"nil","external_name":"state","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"get_authorize_uri(scope, state) do\nend"}},{"id":"get_authorize_uri(scope=nil,state=nil,&block:HTTP::Params::Builder->):String-instance-method","html_id":"get_authorize_uri(scope=nil,state=nil,&amp;block:HTTP::Params::Builder-&gt;):String-instance-method","name":"get_authorize_uri","doc":"Builds an authorize URI, as specified by\n[RFC 6749, Section 4.1.1](https://tools.ietf.org/html/rfc6749#section-4.1.1).\n\nYields an `HTTP::Params::Builder` to add extra parameters other than those\ndefined by the standard.","summary":"<p>Builds an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.1\" target=\"_blank\">RFC 6749, Section 4.1.1</a>.</p>","abstract":false,"args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"state","doc":null,"default_value":"nil","external_name":"state","restriction":""}],"args_string":"(scope = <span class=\"n\">nil</span>, state = <span class=\"n\">nil</span>, &block : HTTP::Params::Builder -> ) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/client.cr#L82","def":{"name":"get_authorize_uri","args":[{"name":"scope","doc":null,"default_value":"nil","external_name":"scope","restriction":""},{"name":"state","doc":null,"default_value":"nil","external_name":"state","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(HTTP::Params::Builder -> )"},"return_type":"String","visibility":"Public","body":"uri = URI.parse(@authorize_uri)\nif uri.host\nelse\n  uri = URI.new(@scheme, @host, @port, @authorize_uri)\nend\nuri.query = HTTP::Params.build do |form|\n  form.add(\"client_id\", @client_id)\n  form.add(\"redirect_uri\", @redirect_uri)\n  form.add(\"response_type\", \"code\")\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\n  if state.nil?\n  else\n    form.add(\"state\", state)\n  end\n  if query = uri.query\n    (HTTP::Params.parse(query)).each do |key, value|\n      form.add(key, value)\n    end\n  end\n  yield form\nend\nuri.to_s\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Error","path":"OAuth2/Error.html","kind":"class","full_name":"OAuth2::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/error.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(error,error_description)-class-method","html_id":"new(error,error_description)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"error","doc":null,"default_value":"","external_name":"error","restriction":""},{"name":"error_description","doc":null,"default_value":"","external_name":"error_description","restriction":""}],"args_string":"(error, error_description)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L5","def":{"name":"new","args":[{"name":"error","doc":null,"default_value":"","external_name":"error","restriction":""},{"name":"error_description","doc":null,"default_value":"","external_name":"error_description","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(error, error_description)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L13","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"error = nil\nerror_description = nil\npull.read_object do |key|\n  case key\n  when \"error\"\n    error = pull.read_string\n  when \"error_description\"\n    error_description = pull.read_string\n  else\n    raise(\"Unknown key in oauth2 error json: #{key}\")\n  end\nend\nnew(error.not_nil!, error_description)\n"}}],"instance_methods":[{"id":"error:String-instance-method","html_id":"error:String-instance-method","name":"error","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L2","def":{"name":"error","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@error"}},{"id":"error_description:String?-instance-method","html_id":"error_description:String?-instance-method","name":"error_description","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/error.cr#L3","def":{"name":"error_description","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@error_description"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Session","path":"OAuth2/Session.html","kind":"class","full_name":"OAuth2::Session","name":"Session","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"oauth2/session.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"An OAuth2 session makes it easy to implement APIs that need to refresh\nan access token once its expired before executing an HTTP request.","summary":"<p>An OAuth2 session makes it easy to implement APIs that need to refresh an access token once its expired before executing an HTTP request.</p>","class_methods":[],"constructors":[{"id":"new(oauth2_client:Client,access_token:AccessToken,expires_at=Time.utc_now,&callback:OAuth2::Session->)-class-method","html_id":"new(oauth2_client:Client,access_token:AccessToken,expires_at=Time.utc_now,&amp;callback:OAuth2::Session-&gt;)-class-method","name":"new","doc":"Creates an `OAuth2::Session`.\n\nParams:\n  * *oauth2_client*: the OAuth2::Client used to refresh an access token.\n  * *access_token*: the OAuth2::AccessToken to make requests.\n  * *expires_at*: the Time when the access token expires.\n  * *callback*: invoked when an access token is refreshed, giving you a chance to persist it.","summary":"<p>Creates an <code><a href=\"../OAuth2/Session.html\">OAuth2::Session</a></code>.</p>","abstract":false,"args":[{"name":"oauth2_client","doc":null,"default_value":"","external_name":"oauth2_client","restriction":"Client"},{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"AccessToken"},{"name":"expires_at","doc":null,"default_value":"Time.utc_now","external_name":"expires_at","restriction":""}],"args_string":"(oauth2_client : Client, access_token : AccessToken, expires_at = <span class=\"t\">Time</span>.utc_now, &callback : OAuth2::Session -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L15","def":{"name":"new","args":[{"name":"oauth2_client","doc":null,"default_value":"","external_name":"oauth2_client","restriction":"Client"},{"name":"access_token","doc":null,"default_value":"","external_name":"access_token","restriction":"AccessToken"},{"name":"expires_at","doc":null,"default_value":"Time.utc_now","external_name":"expires_at","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"callback","doc":null,"default_value":"","external_name":"callback","restriction":"(OAuth2::Session -> )"},"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(oauth2_client, access_token, expires_at, &callback) do |_arg0|\n  yield _arg0\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"access_token:AccessToken-instance-method","html_id":"access_token:AccessToken-instance-method","name":"access_token","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : AccessToken","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L5","def":{"name":"access_token","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"AccessToken","visibility":"Public","body":"@access_token"}},{"id":"authenticate(http_client)-instance-method","html_id":"authenticate(http_client)-instance-method","name":"authenticate","doc":"Authenticates an `HTTP::Client`, refreshing the access token if it is expired.\n\nInvoke this method on an `HTTP::Client` before executing an HTTP request.","summary":"<p>Authenticates an <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code>, refreshing the access token if it is expired.</p>","abstract":false,"args":[{"name":"http_client","doc":null,"default_value":"","external_name":"http_client","restriction":""}],"args_string":"(http_client)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L21","def":{"name":"authenticate","args":[{"name":"http_client","doc":null,"default_value":"","external_name":"http_client","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_refresh_token\n@access_token.authenticate(http_client)\n"}},{"id":"expires_at:Time?-instance-method","html_id":"expires_at:Time?-instance-method","name":"expires_at","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L6","def":{"name":"expires_at","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@expires_at"}},{"id":"oauth2_client:Client-instance-method","html_id":"oauth2_client:Client-instance-method","name":"oauth2_client","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Client","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/oauth2/session.cr#L4","def":{"name":"oauth2_client","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Client","visibility":"Public","body":"@oauth2_client"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Object","path":"Object.html","kind":"class","full_name":"Object","name":"Object","abstract":true,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Spec/ObjectExtensions","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions"},{"html_id":"github.com/crystal-lang/crystal/Colorize/ObjectExtensions","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions"}],"locations":[{"filename":"object.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr"},{"filename":"primitives.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"json/any.cr","line_number":264,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"json/to_json.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"colorize.cr","line_number":122,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/colorize.cr"},{"filename":"spec/expectations.cr","line_number":385,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr"},{"filename":"yaml/any.cr","line_number":275,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"},{"filename":"yaml/to_yaml.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Colorize/ObjectExtensions","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions"},{"html_id":"github.com/crystal-lang/crystal/Spec/ObjectExtensions","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"}],"including_types":[],"namespace":null,"doc":"`Object` is the base type of all Crystal objects.","summary":"<p><code><a href=\"Object.html\">Object</a></code> is the base type of all Crystal objects.</p>","class_methods":[],"constructors":[{"id":"from_json(string_or_io,root:String):self-class-method","html_id":"from_json(string_or_io,root:String):self-class-method","name":"from_json","doc":"Deserializes the given JSON in *string_or_io* into\nan instance of `self`, assuming the JSON consists\nof an JSON object with key *root*, and whose value is\nthe value to deserialize.\n\n```\nInt32.from_json(%({\"main\": 1}), root: \"main\") # => 1\n```","summary":"<p>Deserializes the given JSON in <em>string_or_io</em> into an instance of <code>self</code>, assuming the JSON consists of an JSON object with key <em>root</em>, and whose value is the value to deserialize.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""},{"name":"root","doc":null,"default_value":"","external_name":"root","restriction":"String"}],"args_string":"(string_or_io, root : String) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L24","def":{"name":"from_json","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""},{"name":"root","doc":null,"default_value":"","external_name":"root","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nparser.on_key!(root) do\n  new(parser)\nend\n"}},{"id":"from_json(string_or_io):self-class-method","html_id":"from_json(string_or_io):self-class-method","name":"from_json","doc":"Deserializes the given JSON in *string_or_io* into\nan instance of `self`. This simply creates a `parser = JSON::PullParser`\nand invokes `new(parser)`: classes that want to provide JSON\ndeserialization must provide an `def initialize(parser : JSON::PullParser)`\nmethod.\n\n```\nInt32.from_json(\"1\")                # => 1\nArray(Int32).from_json(\"[1, 2, 3]\") # => [1, 2, 3]\n```","summary":"<p>Deserializes the given JSON in <em>string_or_io</em> into an instance of <code>self</code>.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""}],"args_string":"(string_or_io) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L11","def":{"name":"from_json","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nnew(parser)\n"}},{"id":"from_yaml(string_or_io:String|IO):self-class-method","html_id":"from_yaml(string_or_io:String|IO):self-class-method","name":"from_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L1","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L1","def":{"name":"from_yaml","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(YAML::ParseContext.new, parse_yaml(string_or_io))"}}],"instance_methods":[{"id":"!=(other)-instance-method","html_id":"!=(other)-instance-method","name":"!=","doc":"Returns `true` if this object is not equal to *other*.\n\nBy default this method is implemented as `!(self == other)`\nso there's no need to override this unless there's a more efficient\nway to do it.","summary":"<p>Returns <code>true</code> if this object is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L13","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(self == other)"}},{"id":"!~(other)-instance-method","html_id":"!~(other)-instance-method","name":"!~","doc":"Shortcut to `!(self =~ other)`.","summary":"<p>Shortcut to <code>!(self =~ other)</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L18","def":{"name":"!~","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(self =~ other)"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if this object is equal to *other*.\n\nSubclasses override this method to provide class-specific meaning.","summary":"<p>Returns <code>true</code> if this object is equal to <em>other</em>.</p>","abstract":true,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L6","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"===(other:JSON::Any)-instance-method","html_id":"===(other:JSON::Any)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L265","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self === other.raw"}},{"id":"===(other:YAML::Any)-instance-method","html_id":"===(other:YAML::Any)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L276","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self === other.raw"}},{"id":"===(other)-instance-method","html_id":"===(other)-instance-method","name":"===","doc":"Case equality.\n\nThe `===` method is used in a `case ... when ... end` expression.\n\nFor example, this code:\n\n```\ncase value\nwhen x\n  # something when x\nwhen y\n  # something when y\nend\n```\n\nIs equivalent to this code:\n\n```\nif x === value\n  # something when x\nelsif y === value\n  # something when y\nend\n```\n\nObject simply implements `===` by invoking `==`, but subclasses\n(notably `Regex`) can override it to provide meaningful case-equality semantics.","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L49","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other"}},{"id":"=~(other)-instance-method","html_id":"=~(other)-instance-method","name":"=~","doc":"Pattern match.\n\nOverridden by descendants (notably `Regex` and `String`) to provide meaningful\npattern-match semantics.","summary":"<p>Pattern match.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L57","def":{"name":"=~","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"nil"}},{"id":"class-instance-method","html_id":"class-instance-method","name":"class","doc":"Returns the **runtime** `Class` of an object.\n\n```\n1.class       # => Int32\n\"hello\".class # => String\n```\n\nCompare it with `typeof`, which returns the **compile-time** type of an object:\n\n```\nrandom_value = rand # => 0.627423\nvalue = random_value < 0.5 ? 1 : \"hello\"\nvalue         # => \"hello\"\nvalue.class   # => String\ntypeof(value) # => Int32 | String\n```","summary":"<p>Returns the <strong>runtime</strong> <code><a href=\"Class.html\">Class</a></code> of an object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L27","def":{"name":"class","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"# primitive: class"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nAs a convention, `clone` is the method used to create a deep copy of\nan object, but this logic isn't defined generically for every type\nbecause cycles could be involved, and the clone logic might not need\nto clone everything.\n\nMany types in the standard library, like `Array`, `Hash`, `Set` and\n`Deque`, and all primitive types, define `dup` and `clone`.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":true,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L199","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L199","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"Appends this object's value to *hasher*, and returns the modified *hasher*.\n\nUsually the macro `def_hash` can be used to generate this method.\nOtherwise, invoke `hash(hasher)` on each object's instance variables to\naccumulate the result:\n\n```\ndef hash(hasher)\n  hasher = @some_ivar.hash(hasher)\n  hasher = @some_other_ivar.hash(hasher)\n  hasher\nend\n```","summary":"<p>Appends this object's value to <em>hasher</em>, and returns the modified <em>hasher</em>.</p>","abstract":true,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L74","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"hash-instance-method","html_id":"hash-instance-method","name":"hash","doc":"Generates an `UInt64` hash value for this object.\n\nThis method must have the property that `a == b` implies `a.hash == b.hash`.\n\nThe hash value is used along with `==` by the `Hash` class to determine if two objects\nreference the same hash key.\n\nSubclasses must not override this method. Instead, they must define `hash(hasher)`,\nthough usually the macro `def_hash` can be used to generate this method.","summary":"<p>Generates an <code><a href=\"UInt64.html\">UInt64</a></code> hash value for this object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L85","def":{"name":"hash","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(hash(Crystal::Hasher.new)).result"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Appends a string representation of this object\nto the given `IO` object.\n\nSimilar to `to_s(io)`, but usually appends more information\nabout this object.","summary":"<p>Appends a string representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L126","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":"Returns a `String` representation of this object.\n\nSimilar to `to_s`, but usually returns more information about\nthis object.\n\nClasses must usually **not** override this method. Instead,\nthey must override `inspect(io)`, which must append to the\ngiven `IO` object.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> representation of this object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L115","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  inspect(io)\nend"}},{"id":"itself-instance-method","html_id":"itself-instance-method","name":"itself","doc":"Return `self`.\n\n```\nstr = \"hello\"\nstr.itself.object_id == str.object_id # => true\n```","summary":"<p>Return <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L186","def":{"name":"itself","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"not_nil!-instance-method","html_id":"not_nil!-instance-method","name":"not_nil!","doc":"Returns `self`. `Nil` overrides this method and raises an exception.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L176","def":{"name":"not_nil!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"pretty_inspect(width=79,newline=&quot;\\n&quot;,indent=0):String-instance-method","html_id":"pretty_inspect(width=79,newline=&amp;quot;\\n&amp;quot;,indent=0):String-instance-method","name":"pretty_inspect","doc":"Returns a pretty printed version of `self`.","summary":"<p>Returns a pretty printed version of <code>self</code>.</p>","abstract":false,"args":[{"name":"width","doc":null,"default_value":"79","external_name":"width","restriction":""},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"args_string":"(width = <span class=\"n\">79</span>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L140","def":{"name":"pretty_inspect","args":[{"name":"width","doc":null,"default_value":"79","external_name":"width","restriction":""},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  PrettyPrint.format(self, io, width, newline, indent)\nend"}},{"id":"pretty_print(pp:PrettyPrint):Nil-instance-method","html_id":"pretty_print(pp:PrettyPrint):Nil-instance-method","name":"pretty_print","doc":"Pretty prints `self` into the given printer.\n\nBy default appends a text that is the result of invoking\n`#inspect` on `self`. Subclasses should override\nfor custom pretty printing.","summary":"<p>Pretty prints <code>self</code> into the given printer.</p>","abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":"PrettyPrint"}],"args_string":"(pp : PrettyPrint) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L135","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":"PrettyPrint"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"pp.text(inspect)"}},{"id":"tap(&block)-instance-method","html_id":"tap(&amp;block)-instance-method","name":"tap","doc":"Yields `self` to the block, and then returns `self`.\n\nThe primary purpose of this method is to \"tap into\" a method chain,\nin order to perform operations on intermediate results within the chain.\n\n```\n(1..10).tap { |x| puts \"original: #{x.inspect}\" }\n  .to_a.tap { |x| puts \"array: #{x.inspect}\" }\n  .select { |x| x % 2 == 0 }.tap { |x| puts \"evens: #{x.inspect}\" }\n  .map { |x| x*x }.tap { |x| puts \"squares: #{x.inspect}\" }\n```","summary":"<p>Yields <code>self</code> to the block, and then returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L157","def":{"name":"tap","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"yield self\nself\n"}},{"id":"to_json(io:IO)-instance-method","html_id":"to_json(io:IO)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L8","def":{"name":"to_json","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"JSON.build(io) do |json|\n  to_json(json)\nend"}},{"id":"to_json-instance-method","html_id":"to_json-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L2","def":{"name":"to_json","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  to_json(str)\nend"}},{"id":"to_pretty_json(indent:String=&quot;&quot;)-instance-method","html_id":"to_pretty_json(indent:String=&amp;quot;&amp;quot;)-instance-method","name":"to_pretty_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"indent","doc":null,"default_value":"\"  \"","external_name":"indent","restriction":"String"}],"args_string":"(indent : String = <span class=\"s\">&quot;  &quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L14","def":{"name":"to_pretty_json","args":[{"name":"indent","doc":null,"default_value":"\"  \"","external_name":"indent","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  to_pretty_json(str, indent: indent)\nend"}},{"id":"to_pretty_json(io:IO,indent:String=&quot;&quot;)-instance-method","html_id":"to_pretty_json(io:IO,indent:String=&amp;quot;&amp;quot;)-instance-method","name":"to_pretty_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"\"  \"","external_name":"indent","restriction":"String"}],"args_string":"(io : IO, indent : String = <span class=\"s\">&quot;  &quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L20","def":{"name":"to_pretty_json","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"\"  \"","external_name":"indent","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"JSON.build(io, indent: indent) do |json|\n  to_json(json)\nend"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L94","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  to_s(io)\nend"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":true,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L105","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"to_yaml(io:IO)-instance-method","html_id":"to_yaml(io:IO)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L8","def":{"name":"to_yaml","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"nodes_builder = YAML::Nodes::Builder.new\nto_yaml(nodes_builder)\nYAML.build(io) do |builder|\n  nodes_builder.document.to_yaml(builder)\nend\n"}},{"id":"to_yaml-instance-method","html_id":"to_yaml-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L2","def":{"name":"to_yaml","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  to_yaml(io)\nend"}},{"id":"try(&block)-instance-method","html_id":"try(&amp;block)-instance-method","name":"try","doc":"Yields `self`. `Nil` overrides this method and doesn't yield.\n\nThis method is useful for dealing with nilable types, to safely\nperform operations only when the value is not `nil`.\n\n```\n# First program argument in downcase, or nil\nARGV[0]?.try &.downcase\n```","summary":"<p>Yields <code>self</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L171","def":{"name":"try","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"yield self"}},{"id":"unsafe_as(type:T.class)forallT-instance-method","html_id":"unsafe_as(type:T.class)forallT-instance-method","name":"unsafe_as","doc":"Unsafely reinterprets the bytes of an object as being of another `type`.\n\nThis method is useful to treat a type that is represented as a chunk of\nbytes as another type where those bytes convey useful information. As an\nexample, you can check the individual bytes of an `Int32`:\n\n```\n0x01020304.unsafe_as(StaticArray(UInt8, 4)) # => StaticArray[4, 3, 2, 1]\n```\n\nOr treat the bytes of a `Float64` as an `Int64`:\n\n```\n1.234_f64.unsafe_as(Int64) # => 4608236261112822104\n```\n\nThis method is **unsafe** because it behaves unpredictably when the given\n`type` doesn't have the same bytesize as the receiver, or when the given\n`type` representation doesn't semantically match the underlying bytes.\n\nAlso note that because `unsafe_as` is a regular method, unlike the pseudo-method\n`as`, you can't specify some types in the type grammar using a short notation, so\nspecifying a static array must always be done as `StaticArray(T, N)`, a tuple\nas `Tuple(...)` and so on, never as `UInt8[4]` or `{Int32, Int32}`.","summary":"<p>Unsafely reinterprets the bytes of an object as being of another <code>type</code>.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"args_string":"(type : T.class) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L225","def":{"name":"unsafe_as","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = self\n((pointerof(x)).as(::Pointer(T))).value\n"}}],"macros":[{"id":"class_getter(*names)-macro","html_id":"class_getter(*names)-macro","name":"class_getter","doc":"Defines getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name\n    @@name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_getter name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_getter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  class_getter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  class_getter(birth_date) { Time.now }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.birth_date\n    @@birth_date ||= Time.now\n  end\nend\n```","summary":"<p>Defines getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_getter","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }}\n            @@{{ name.var.id }} ||= {{ yield }}\n          end\n        {% else %}\n          def self.{{ name.id }}\n            @@{{ name.id }} ||= {{ yield }}\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }} : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}\n              @@{{ name.target.id }}\n            end\n          {% else %}\n            def self.{{ name.id }}\n              @@{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"class_getter!(*names)-macro","html_id":"class_getter!(*names)-macro","name":"class_getter!","doc":"Defines raise-on-nil and nilable getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  class_getter! name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@name : String?\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil and nilable getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_getter!","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}?\n          {% name = name.var %}\n        {% end %}\n\n        def self.{{ name.id }}?\n          @@{{ name.id }}\n        end\n\n        def self.{{ name.id }}\n          @@{{ name.id }}.not_nil!\n        end\n      {% end %}\n\n    \n"}},{"id":"class_getter?(*names)-macro","html_id":"class_getter?(*names)-macro","name":"class_getter?","doc":"Defines query getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_getter? happy : Bool\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@happy : Bool\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_getter? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool = true\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  class_getter? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy = true\n\n  def self.happy?\n    @@happy\n  end\nend\n```","summary":"<p>Defines query getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_getter?","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}\n\n          def self.{{ name.var.id }}? : {{ name.type }}\n            @@{{ name.var.id }}\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @@{{ name }}\n\n          def self.{{ name.target.id }}?\n            @@{{ name.target.id }}\n          end\n        {% else %}\n          def self.{{ name.id }}?\n            @@{{ name.id }}\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"id":"class_property(*names)-macro","html_id":"class_property(*names)-macro","name":"class_property","doc":"Defines property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_property name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name=(@@name)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_property name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  class_property name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  class_property(birth_date) { Time.now }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.birth_date\n    @@birth_date ||= Time.now\n  end\n\n  def self.birth_date=(@@birth_date)\n  end\nend\n```","summary":"<p>Defines property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_property","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        class_setter {{ name }}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }}\n            @@{{ name.var.id }} ||= {{ yield }}\n          end\n        {% else %}\n          def self.{{ name.id }}\n            @@{{ name.id }} ||= {{ yield }}\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }} : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n\n            def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}\n              @@{{ name.target.id }}\n            end\n\n            def self.{{ name.target.id }}=(@@{{ name.target.id }})\n            end\n          {% else %}\n            def self.{{ name.id }}\n              @@{{ name.id }}\n            end\n\n            def self.{{ name.id }}=(@@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"class_property!(*names)-macro","html_id":"class_property!(*names)-macro","name":"class_property!","doc":"Defines raise-on-nil property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  class_property! name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String?\n\n  def self.name=(@@name)\n  end\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_property!","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      class_getter! \n{{ *names }}\n\n\n      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"class_property?(*names)-macro","html_id":"class_property?(*names)-macro","name":"class_property?","doc":"Defines query property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.happy=(@@happy)\n  end\n\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_property? happy : Bool\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool\n\n  def self.happy=(@@happy)\n  end\n\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_property? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool = true\n\n  def self.happy=(@@happy : Bool)\n  end\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  class_property? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy = true\n\n  def self.happy=(@@happy)\n  end\n\n  def self.happy?\n    @@happy\n  end\nend\n```","summary":"<p>Defines query property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_property?","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}\n\n          def self.{{ name.var.id }}? : {{ name.type }}\n            @@{{ name.var.id }}\n          end\n\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @@{{ name }}\n\n          def self.{{ name.target.id }}?\n            @@{{ name.target.id }}\n          end\n\n          def self.{{ name.target.id }}=(@@{{ name.target.id }})\n          end\n        {% else %}\n          def self.{{ name.id }}?\n            @@{{ name.id }}\n          end\n\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"id":"class_setter(*names)-macro","html_id":"class_setter(*names)-macro","name":"class_setter","doc":"Defines setter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_setter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_setter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_setter name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name=(@@name : String)\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_setter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  class_setter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name=(@@name)\n  end\nend\n```","summary":"<p>Defines setter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"class_setter","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}\n\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @@{{ name }}\n\n          def self.{{ name.target.id }}=(@@{{ name.target.id }})\n          end\n        {% else %}\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"id":"def_clone-macro","html_id":"def_clone-macro","name":"def_clone","doc":"Defines a `clone` method that returns a copy of this object with all\ninstance variables cloned (`clone` is in turn invoked on them).","summary":"<p>Defines a <code>clone</code> method that returns a copy of this object with all instance variables cloned (<code>clone</code> is in turn invoked on them).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1187","def":{"name":"def_clone","args":[],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    \n# Returns a copy of `self` with all instance variables cloned.\n\n    def clone\n      clone = \n\\{\n{@type}}.allocate\n      clone.initialize_copy(self)\n      GC.add_finalizer(clone) if clone.responds_to?(:finalize)\n      clone\n    \nend\n\n    protected def initialize_copy(other)\n      \n\\{% for\n ivar in @type.instance_vars %}\n        @\n\\{\n{ivar.id}} = other.@\n\\{\n{ivar.id}}.clone\n      \n\\{% end\n %}\n    \nend\n  \n"}},{"id":"def_equals(*fields)-macro","html_id":"def_equals(*fields)-macro","name":"def_equals","doc":"Defines an `==` method by comparing the given fields.\n\nThe generated `==` method has a `self` restriction.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a `==` method that compares @name and @age\n  def_equals @name, @age\nend\n```","summary":"<p>Defines an <code><a href=\"Object.html#%3D%3D%28other%29-instance-method\">#==</a></code> method by comparing the given fields.</p>","abstract":false,"args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"args_string":"(*fields)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1137","def":{"name":"def_equals","args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    def ==(other : self)\n      \n{% for field in fields %}\n        return false unless {{ field.id }} == other.{{ field.id }}\n      {% end %}\n\n      true\n    \nend\n  \n"}},{"id":"def_equals_and_hash(*fields)-macro","html_id":"def_equals_and_hash(*fields)-macro","name":"def_equals_and_hash","doc":"Defines `hash` and `==` method from the given fields.\n\nThe generated `==` method has a `self` restriction.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a hash method based on @name and @age\n  # Define a `==` method that compares @name and @age\n  def_equals_and_hash @name, @age\nend\n```","summary":"<p>Defines <code><a href=\"Object.html#hash-instance-method\">#hash</a></code> and <code><a href=\"Object.html#%3D%3D%28other%29-instance-method\">#==</a></code> method from the given fields.</p>","abstract":false,"args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"args_string":"(*fields)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1160","def":{"name":"def_equals_and_hash","args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    def_equals \n{{ *fields }}\n\n    def_hash \n{{ *fields }}\n\n  \n"}},{"id":"def_hash(*fields)-macro","html_id":"def_hash(*fields)-macro","name":"def_hash","doc":"Defines a `hash(hasher)` that will append a hash value for the given fields.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a hash(hasher) method based on @name and @age\n  def_hash @name, @age\nend\n```","summary":"<p>Defines a <code><a href=\"Object.html#hash%28hasher%29-instance-method\">#hash(hasher)</a></code> that will append a hash value for the given fields.</p>","abstract":false,"args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"args_string":"(*fields)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1115","def":{"name":"def_hash","args":[{"name":"fields","doc":null,"default_value":"","external_name":"fields","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    def hash(hasher)\n      \n{% for field in fields %}\n        hasher = {{ field }}.hash(hasher)\n      {% end %}\n\n      hasher\n    \nend\n  \n"}},{"id":"delegate(*methods,toobject)-macro","html_id":"delegate(*methods,toobject)-macro","name":"delegate","doc":"Delegate *methods* to *to*.\n\nNote that due to current language limitations this is only useful\nwhen no captured blocks are involved.\n\n```\nclass StringWrapper\n  def initialize(@string : String)\n  end\n\n  delegate downcase, to: @string\n  delegate gsub, to: @string\n  delegate empty?, capitalize, to: @string\n  delegate :[], to: @string\nend\n\nwrapper = StringWrapper.new \"HELLO\"\nwrapper.downcase       # => \"hello\"\nwrapper.gsub(/E/, \"A\") # => \"HALLO\"\nwrapper.empty?         # => false\nwrapper.capitalize     # => \"Hello\"\n```","summary":"<p>Delegate <em>methods</em> to <em>to</em>.</p>","abstract":false,"args":[{"name":"methods","doc":null,"default_value":"","external_name":"methods","restriction":""},{"name":"object","doc":null,"default_value":"","external_name":"to","restriction":""}],"args_string":"(*methods, to object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1084","def":{"name":"delegate","args":[{"name":"methods","doc":null,"default_value":"","external_name":"methods","restriction":""},{"name":"object","doc":null,"default_value":"","external_name":"to","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n{% for method in methods %}\n      {% if (method.id.ends_with?('=')) && (method.id != \"[]=\") %}\n        def {{ method.id }}(arg)\n          {{ object.id }}.{{ method.id }} arg\n        end\n      {% else %}\n        def {{ method.id }}(*args, **options)\n          {{ object.id }}.{{ method.id }}(*args, **options)\n        end\n\n        def {{ method.id }}(*args, **options)\n          {{ object.id }}.{{ method.id }}(*args, **options) do |*yield_args|\n            yield *yield_args\n          end\n        end\n      {% end %}\n    {% end %}\n\n  \n"}},{"id":"forward_missing_to(delegate)-macro","html_id":"forward_missing_to(delegate)-macro","name":"forward_missing_to","doc":"Forwards missing methods to *delegate*.\n\n```\nclass StringWrapper\n  def initialize(@string : String)\n  end\n\n  forward_missing_to @string\nend\n\nwrapper = StringWrapper.new \"HELLO\"\nwrapper.downcase       # => \"hello\"\nwrapper.gsub(/E/, \"A\") # => \"HALLO\"\n```","summary":"<p>Forwards missing methods to <em>delegate</em>.</p>","abstract":false,"args":[{"name":"delegate","doc":null,"default_value":"","external_name":"delegate","restriction":""}],"args_string":"(delegate)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L1179","def":{"name":"forward_missing_to","args":[{"name":"delegate","doc":null,"default_value":"","external_name":"delegate","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    macro method_missing(call)\n      \n{{ delegate }}\n.\n\\{\n{call}}\n    \nend\n  \n"}},{"id":"getter(*names)-macro","html_id":"getter(*names)-macro","name":"getter","doc":"Defines getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name\n    @name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  getter name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name : String\n    @name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  getter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name : String\n    @name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  getter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name : String\n    @name\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  getter(birth_date) { Time.now }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def birth_date\n    @birth_date ||= Time.now\n  end\nend\n```","summary":"<p>Defines getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"getter","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }}\n            @{{ name.var.id }} ||= {{ yield }}\n          end\n        {% else %}\n          def {{ name.id }}\n            @{{ name.id }} ||= {{ yield }}\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }} : {{ name.type }}\n              @{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}\n              @{{ name.target.id }}\n            end\n          {% else %}\n            def {{ name.id }}\n              @{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"getter!(*names)-macro","html_id":"getter!(*names)-macro","name":"getter!","doc":"Defines raise-on-nil and nilable getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  getter! name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @name : String?\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil and nilable getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"getter!","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}?\n          {% name = name.var %}\n        {% end %}\n\n        def {{ name.id }}?\n          @{{ name.id }}\n        end\n\n        def {{ name.id }}\n          @{{ name.id }}.not_nil!\n        end\n      {% end %}\n\n    \n"}},{"id":"getter?(*names)-macro","html_id":"getter?(*names)-macro","name":"getter?","doc":"Defines query getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def happy?\n    @happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  getter? happy : Bool\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @happy : Bool\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  getter? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool = true\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  getter? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy = true\n\n  def happy?\n    @happy\n  end\nend\n```","summary":"<p>Defines query getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"getter?","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}\n\n          def {{ name.var.id }}? : {{ name.type }}\n            @{{ name.var.id }}\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @{{ name }}\n\n          def {{ name.target.id }}?\n            @{{ name.target.id }}\n          end\n        {% else %}\n          def {{ name.id }}?\n            @{{ name.id }}\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"id":"property(*names)-macro","html_id":"property(*names)-macro","name":"property","doc":"Defines property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  property name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name=(@name)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  property name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name=(@name : String)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  property name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name=(@name : String)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  property(birth_date) { Time.now }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def birth_date\n    @birth_date ||= Time.now\n  end\n\n  def birth_date=(@birth_date)\n  end\nend\n```","summary":"<p>Defines property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"property","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        setter {{ name }}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }}\n            @{{ name.var.id }} ||= {{ yield }}\n          end\n        {% else %}\n          def {{ name.id }}\n            @{{ name.id }} ||= {{ yield }}\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }} : {{ name.type }}\n              @{{ name.var.id }}\n            end\n\n            def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}\n              @{{ name.target.id }}\n            end\n\n            def {{ name.target.id }}=(@{{ name.target.id }})\n            end\n          {% else %}\n            def {{ name.id }}\n              @{{ name.id }}\n            end\n\n            def {{ name.id }}=(@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"property!(*names)-macro","html_id":"property!(*names)-macro","name":"property!","doc":"Defines raise-on-nil property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  property! name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String?\n\n  def name=(@name)\n  end\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"property!","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      getter! \n{{ *names }}\n\n\n      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"id":"property?(*names)-macro","html_id":"property?(*names)-macro","name":"property?","doc":"Defines query property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def happy=(@happy)\n  end\n\n  def happy?\n    @happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  property? happy : Bool\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool\n\n  def happy=(@happy)\n  end\n\n  def happy?\n    @happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  property? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool = true\n\n  def happy=(@happy : Bool)\n  end\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  property? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy = true\n\n  def happy=(@happy)\n  end\n\n  def happy?\n    @happy\n  end\nend\n```","summary":"<p>Defines query property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"property?","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}\n\n          def {{ name.var.id }}? : {{ name.type }}\n            @{{ name.var.id }}\n          end\n\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @{{ name }}\n\n          def {{ name.target.id }}?\n            @{{ name.target.id }}\n          end\n\n          def {{ name.target.id }}=(@{{ name.target.id }})\n          end\n        {% else %}\n          def {{ name.id }}?\n            @{{ name.id }}\n          end\n\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"id":"setter(*names)-macro","html_id":"setter(*names)-macro","name":"setter","doc":"Defines setter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  setter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  setter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  setter name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name=(@name : String)\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  setter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name=(@name : String)\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferrable from the initial value:\n\n```\nclass Person\n  setter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name=(@name)\n  end\nend\n```","summary":"<p>Defines setter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"args_string":"(*names)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/object.cr#L230","def":{"name":"setter","args":[{"name":"names","doc":null,"default_value":"","external_name":"names","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}\n\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @{{ name }}\n\n          def {{ name.target.id }}=(@{{ name.target.id }})\n          end\n        {% else %}\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL","path":"OpenSSL.html","kind":"module","full_name":"OpenSSL","name":"OpenSSL","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":66,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"},{"filename":"openssl/digest/digest_base.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr"},{"filename":"openssl/digest/digest.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr"},{"filename":"openssl/digest/digest_io.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"## OpenSSL Integration\n\n- TLS sockets need a context, potentially with keys (required for servers) and configuration.\n- TLS sockets will wrap the underlying TCP socket, and any further communication must happen through the `OpenSSL::SSL::Socket` only.\n\n## Usage Example\n\nRecommended ciphers can be taken from:\n- [OWASP Wiki](https://www.owasp.org/index.php/Transport_Layer_Protection_Cheat_Sheet#Rule_-_Only_Support_Strong_Cryptographic_Ciphers)\n- [Cipherli.st](https://cipherli.st/)\n- A full list is available at the [OpenSSL Docs](https://www.openssl.org/docs/man1.1.0/apps/ciphers.html#CIPHER-STRINGS)\n\nDo note that:\n- Crystal does its best to provide sane configuration defaults (see [Mozilla-Intermediate](https://wiki.mozilla.org/Security/Server_Side_TLS#Intermediate_compatibility_.28default.29)).\n- Linked version of OpenSSL need to be checked for supporting specific protocols and ciphers.\n- If any configurations or choices in Crystal regarding SSL settings and security are found to be lacking or need\n  improvement please [open an issue](https://github.com/crystal-lang/crystal/issues/new) and let us know.\n\n### Server side\n\nNOTE: For the below example to work, a key pair should be attained.\n\n```\nrequire \"socket\"\nrequire \"openssl\"\n\ndef server\n  # Bind new TCPSocket to port 5555\n  socket = TCPServer.new(5555)\n\n  context = OpenSSL::SSL::Context::Server.new\n  context.private_key = \"/path/to/private.key\"\n  context.certificate_chain = \"/path/to/public.cert\"\n\n  puts \"Server is up\"\n\n  socket.accept do |client|\n    puts \"Got client\"\n\n    bytes = Bytes.new(20)\n\n    ssl_socket = OpenSSL::SSL::Socket::Server.new(client, context)\n    ssl_socket.read(bytes)\n\n    puts String.new(bytes)\n  end\nend\n```\n\n### Client side\n\n```\nrequire \"socket\"\nrequire \"openssl\"\n\ndef client\n  socket = TCPSocket.new(\"127.0.0.1\", 5555)\n  context = OpenSSL::SSL::Context::Client.new\n\n  ssl_socket = OpenSSL::SSL::Socket::Client.new(socket, context)\n  ssl_socket << \"Testing\"\nend\n```","summary":"<h2>OpenSSL Integration</h2>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest","path":"OpenSSL/Digest.html","kind":"class","full_name":"OpenSSL::Digest","name":"Digest","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestBase","kind":"module","full_name":"OpenSSL::DigestBase","name":"DigestBase"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/digest/digest.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestBase","kind":"module","full_name":"OpenSSL::DigestBase","name":"DigestBase"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(name,ctx:LibCrypto::EVP_MD_CTX)-class-method","html_id":"new(name,ctx:LibCrypto::EVP_MD_CTX)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"LibCrypto::EVP_MD_CTX"}],"args_string":"(name, ctx : LibCrypto::EVP_MD_CTX)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L14","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"LibCrypto::EVP_MD_CTX"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, ctx)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(name)-class-method","html_id":"new(name)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L33","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(name, new_evp_mt_ctx(name))"}}],"instance_methods":[{"id":"block_size-instance-method","html_id":"block_size-instance-method","name":"block_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L73","def":{"name":"block_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrypto.evp_md_block_size(to_unsafe_md)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L41","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ctx = LibCrypto.evp_md_ctx_new\nif (LibCrypto.evp_md_ctx_copy(ctx, @ctx)) == 0\n  LibCrypto.evp_md_ctx_free(ctx)\n  raise(Error.new(\"Unable to clone digest\"))\nend\nDigest.new(@name, ctx)\n"}},{"id":"digest_size-instance-method","html_id":"digest_size-instance-method","name":"digest_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L69","def":{"name":"digest_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrypto.evp_md_size(to_unsafe_md)"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L37","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrypto.evp_md_ctx_free(self)"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L12","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name"}},{"id":"reset-instance-method","html_id":"reset-instance-method","name":"reset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L50","def":{"name":"reset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibCrypto.evp_digestinit_ex(self, to_unsafe_md, nil)) != 1\n  raise(Error.new(\"Digest initialization failed.\"))\nend\nself\n"}},{"id":"to_unsafe:Pointer(LibCrypto::EVP_MD_CTX_Struct)-instance-method","html_id":"to_unsafe:Pointer(LibCrypto::EVP_MD_CTX_Struct)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Pointer(LibCrypto::EVP_MD_CTX_Struct)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L81","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ctx"}},{"id":"to_unsafe_md-instance-method","html_id":"to_unsafe_md-instance-method","name":"to_unsafe_md","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L77","def":{"name":"to_unsafe_md","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrypto.evp_md_ctx_md(self)"}},{"id":"update(data:String|Slice)-instance-method","html_id":"update(data:String|Slice)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | Slice"}],"args_string":"(data : String | Slice)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr#L57","def":{"name":"update","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | Slice"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibCrypto.evp_digestupdate(self, data, data.size)\nself\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/Error","path":"OpenSSL/Digest/Error.html","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/digest/digest.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/UnsupportedError","kind":"class","full_name":"OpenSSL::Digest::UnsupportedError","name":"UnsupportedError"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/UnsupportedError","path":"OpenSSL/Digest/UnsupportedError.html","kind":"class","full_name":"OpenSSL::Digest::UnsupportedError","name":"UnsupportedError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/digest/digest.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestBase","path":"OpenSSL/DigestBase.html","kind":"module","full_name":"OpenSSL::DigestBase","name":"DigestBase","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl/digest/digest_base.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"<<(data)-instance-method","html_id":"&lt;&lt;(data)-instance-method","name":"<<","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(data)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L23","def":{"name":"<<","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"update(data)"}},{"id":"base64digest-instance-method","html_id":"base64digest-instance-method","name":"base64digest","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L27","def":{"name":"base64digest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Base64.encode(digest)"}},{"id":"digest-instance-method","html_id":"digest-instance-method","name":"digest","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L19","def":{"name":"digest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.clone.finish"}},{"id":"file(file_name)-instance-method","html_id":"file(file_name)-instance-method","name":"file","doc":null,"summary":null,"abstract":false,"args":[{"name":"file_name","doc":null,"default_value":"","external_name":"file_name","restriction":""}],"args_string":"(file_name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L5","def":{"name":"file","args":[{"name":"file_name","doc":null,"default_value":"","external_name":"file_name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"File.open(file_name) do |io|\n  self << io\nend"}},{"id":"hexdigest-instance-method","html_id":"hexdigest-instance-method","name":"hexdigest","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L31","def":{"name":"hexdigest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"digest.hexstring"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L35","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << hexdigest"}},{"id":"update(io:IO)-instance-method","html_id":"update(io:IO)-instance-method","name":"update","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_base.cr#L11","def":{"name":"update","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile (read_bytes = io.read(buffer.to_slice)) > 0\n  self << buffer.to_slice[0, read_bytes]\nend\nself\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestIO","path":"OpenSSL/DigestIO.html","kind":"class","full_name":"OpenSSL::DigestIO","name":"DigestIO","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/digest/digest_io.cr","line_number":17,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Wraps an IO by calculating a specified digest on read or write operations.\n\n### Example\n\n```\nrequire \"openssl\"\n\nunderlying_io = IO::Memory.new(\"foo\")\nio = OpenSSL::DigestIO.new(underlying_io, \"SHA256\")\nbuffer = Bytes.new(256)\nio.read(buffer)\nio.digest.hexstring # => \"2c26b46b68ffc68ff99b453c1d30413413422d706483bfa0f98a5e886266e7ae\"\n```","summary":"<p>Wraps an IO by calculating a specified digest on read or write operations.</p>","class_methods":[],"constructors":[{"id":"new(io:IO,digest_algorithm:OpenSSL::Digest,mode=DigestMode::Read)-class-method","html_id":"new(io:IO,digest_algorithm:OpenSSL::Digest,mode=DigestMode::Read)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"digest_algorithm","doc":null,"default_value":"","external_name":"digest_algorithm","restriction":"OpenSSL::Digest"},{"name":"mode","doc":null,"default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"args_string":"(io : IO, digest_algorithm : OpenSSL::Digest, mode = <span class=\"t\">DigestMode</span><span class=\"t\">::</span><span class=\"t\">Read</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L30","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"digest_algorithm","doc":null,"default_value":"","external_name":"digest_algorithm","restriction":"OpenSSL::Digest"},{"name":"mode","doc":null,"default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, digest_algorithm, mode)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(io:IO,algorithm:String,mode=DigestMode::Read)-class-method","html_id":"new(io:IO,algorithm:String,mode=DigestMode::Read)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"String"},{"name":"mode","doc":null,"default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"args_string":"(io : IO, algorithm : String, mode = <span class=\"t\">DigestMode</span><span class=\"t\">::</span><span class=\"t\">Read</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L33","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"String"},{"name":"mode","doc":null,"default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, algorithm, mode)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"base64digest(*args,**options)-instance-method","html_id":"base64digest(*args,**options)-instance-method","name":"base64digest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"base64digest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.base64digest(*args, **options)"}},{"id":"base64digest(*args,**options,&block)-instance-method","html_id":"base64digest(*args,**options,&amp;block)-instance-method","name":"base64digest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"base64digest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.base64digest(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"close(*args,**options)-instance-method","html_id":"close(*args,**options)-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"close","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.close(*args, **options)"}},{"id":"close(*args,**options,&block)-instance-method","html_id":"close(*args,**options,&amp;block)-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"close","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.close(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"closed?(*args,**options)-instance-method","html_id":"closed?(*args,**options)-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"closed?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.closed?(*args, **options)"}},{"id":"closed?(*args,**options,&block)-instance-method","html_id":"closed?(*args,**options,&amp;block)-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"closed?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.closed?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"digest(*args,**options,&block)-instance-method","html_id":"digest(*args,**options,&amp;block)-instance-method","name":"digest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"digest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.digest(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"digest(*args,**options)-instance-method","html_id":"digest(*args,**options)-instance-method","name":"digest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"digest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.digest(*args, **options)"}},{"id":"digest_algorithm:OpenSSL::Digest-instance-method","html_id":"digest_algorithm:OpenSSL::Digest-instance-method","name":"digest_algorithm","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : OpenSSL::Digest","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L19","def":{"name":"digest_algorithm","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"OpenSSL::Digest","visibility":"Public","body":"@digest_algorithm"}},{"id":"flush(*args,**options)-instance-method","html_id":"flush(*args,**options)-instance-method","name":"flush","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"flush","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.flush(*args, **options)"}},{"id":"flush(*args,**options,&block)-instance-method","html_id":"flush(*args,**options,&amp;block)-instance-method","name":"flush","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"flush","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.flush(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"hexdigest(*args,**options,&block)-instance-method","html_id":"hexdigest(*args,**options,&amp;block)-instance-method","name":"hexdigest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"hexdigest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.hexdigest(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"hexdigest(*args,**options)-instance-method","html_id":"hexdigest(*args,**options)-instance-method","name":"hexdigest","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L23","def":{"name":"hexdigest","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@digest_algorithm.hexdigest(*args, **options)"}},{"id":"io:IO-instance-method","html_id":"io:IO-instance-method","name":"io","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : IO","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L18","def":{"name":"io","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IO","visibility":"Public","body":"@io"}},{"id":"mode:DigestMode-instance-method","html_id":"mode:DigestMode-instance-method","name":"mode","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : DigestMode","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L20","def":{"name":"mode","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"DigestMode","visibility":"Public","body":"@mode"}},{"id":"peek(*args,**options)-instance-method","html_id":"peek(*args,**options)-instance-method","name":"peek","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"peek","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.peek(*args, **options)"}},{"id":"peek(*args,**options,&block)-instance-method","html_id":"peek(*args,**options,&amp;block)-instance-method","name":"peek","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"peek","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.peek(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L37","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read_bytes = io.read(slice)\nif @mode.read?\n  digest_algorithm.update(slice[0, read_bytes])\nend\nread_bytes\n"}},{"id":"rewind(*args,**options)-instance-method","html_id":"rewind(*args,**options)-instance-method","name":"rewind","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"rewind","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.rewind(*args, **options)"}},{"id":"rewind(*args,**options,&block)-instance-method","html_id":"rewind(*args,**options,&amp;block)-instance-method","name":"rewind","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"rewind","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.rewind(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"tty?(*args,**options,&block)-instance-method","html_id":"tty?(*args,**options,&amp;block)-instance-method","name":"tty?","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"tty?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.tty?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"id":"tty?(*args,**options)-instance-method","html_id":"tty?(*args,**options)-instance-method","name":"tty?","doc":null,"summary":null,"abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L22","def":{"name":"tty?","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":""},"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.tty?(*args, **options)"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L45","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if slice.empty?\n  return\nend\nif @mode.write?\n  digest_algorithm.update(slice)\nend\nio.write(slice)\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestIO/DigestMode","path":"OpenSSL/DigestIO/DigestMode.html","kind":"enum","full_name":"OpenSSL::DigestIO::DigestMode","name":"DigestMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/digest/digest_io.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Read","name":"Read","value":"0","doc":null,"summary":null},{"id":"Write","name":"Write","value":"1","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/DigestIO","kind":"class","full_name":"OpenSSL::DigestIO","name":"DigestIO"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"read?-instance-method","html_id":"read?-instance-method","name":"read?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L26","def":{"name":"read?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Read"}},{"id":"write?-instance-method","html_id":"write?-instance-method","name":"write?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/digest/digest_io.cr#L27","def":{"name":"write?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Write"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","path":"OpenSSL/Error.html","kind":"class","full_name":"OpenSSL::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl.cr","line_number":67,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Error","kind":"class","full_name":"OpenSSL::SSL::Error","name":"Error"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(message=nil,fetched=false)-class-method","html_id":"new(message=nil,fetched=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""},{"name":"fetched","doc":null,"default_value":"false","external_name":"fetched","restriction":""}],"args_string":"(message = <span class=\"n\">nil</span>, fetched = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L70","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""},{"name":"fetched","doc":null,"default_value":"false","external_name":"fetched","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, fetched)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"code-instance-method","html_id":"code-instance-method","name":"code","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L68","def":{"name":"code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@code.not_nil!"}},{"id":"code?:UInt64?-instance-method","html_id":"code?:UInt64?-instance-method","name":"code?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L68","def":{"name":"code?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@code"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/HMAC","path":"OpenSSL/HMAC.html","kind":"class","full_name":"OpenSSL::HMAC","name":"HMAC","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/hmac.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/hmac.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Allows computing Hash-based Message Authentication Code (HMAC).\n\nIt is a type of message authentication code (MAC)\ninvolving a hash function in combination with a key.\n\nHMAC can be used to verify the integrity of a message as well as the authenticity.\n\nSee also [RFC2104](https://tools.ietf.org/html/rfc2104.html).","summary":"<p>Allows computing Hash-based Message Authentication Code (HMAC).</p>","class_methods":[{"id":"digest(algorithm:Symbol,key,data):Bytes-class-method","html_id":"digest(algorithm:Symbol,key,data):Bytes-class-method","name":"digest","doc":"Returns the HMAC digest of *data* using the secret *key*.\n\nIt may contain non-ASCII bytes, including NUL bytes.\n\n*algorithm* is a `Symbol` of a supported digest algorithm:\n* `:md4`.\n* `:md5`.\n* `:ripemd160`.\n* `:sha1`.\n* `:sha224`.\n* `:sha256`.\n* `:sha384`.\n* `:sha512`.","summary":"<p>Returns the HMAC digest of <em>data</em> using the secret <em>key</em>.</p>","abstract":false,"args":[{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"Symbol"},{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(algorithm : Symbol, key, data) : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/hmac.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/hmac.cr#L25","def":{"name":"digest","args":[{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"Symbol"},{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"evp = case algorithm\nwhen :md4\n  LibCrypto.evp_md4\nwhen :md5\n  LibCrypto.evp_md5\nwhen :ripemd160\n  LibCrypto.evp_ripemd160\nwhen :sha1\n  LibCrypto.evp_sha1\nwhen :sha224\n  LibCrypto.evp_sha224\nwhen :sha256\n  LibCrypto.evp_sha256\nwhen :sha384\n  LibCrypto.evp_sha384\nwhen :sha512\n  LibCrypto.evp_sha512\nelse\n  raise(\"Unsupported digest algorithm: #{algorithm}\")\nend\nkey_slice = key.to_slice\ndata_slice = data.to_slice\nbuffer = Bytes.new(128)\nLibCrypto.hmac(evp, key_slice, key_slice.size, data_slice, data_slice.size, buffer, out buffer_len)\nbuffer[0, buffer_len.to_i]\n"}},{"id":"hexdigest(algorithm:Symbol,key,data):String-class-method","html_id":"hexdigest(algorithm:Symbol,key,data):String-class-method","name":"hexdigest","doc":"Returns the HMAC digest of *data* using the secret *key*,\nformatted as a hexadecimal string. This is neccesary to safely transfer\nthe digest where binary messages are not allowed.\n\nSee also `#digest`.","summary":"<p>Returns the HMAC digest of <em>data</em> using the secret <em>key</em>, formatted as a hexadecimal string.</p>","abstract":false,"args":[{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"Symbol"},{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"args_string":"(algorithm : Symbol, key, data) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/hmac.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/hmac.cr#L49","def":{"name":"hexdigest","args":[{"name":"algorithm","doc":null,"default_value":"","external_name":"algorithm","restriction":"Symbol"},{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"(digest(algorithm, key, data)).hexstring"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/MD5","path":"OpenSSL/MD5.html","kind":"class","full_name":"OpenSSL::MD5","name":"MD5","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/md5.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/md5.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Binds the OpenSSL MD5 hash functions.\n\nWarning: MD5 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Binds the OpenSSL MD5 hash functions.</p>","class_methods":[{"id":"hash(data:Pointer(UInt8),bytesize:Int):StaticArray(UInt8,16)-class-method","html_id":"hash(data:Pointer(UInt8),bytesize:Int):StaticArray(UInt8,16)-class-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"Int"}],"args_string":"(data : Pointer(UInt8), bytesize : Int) : StaticArray(UInt8, 16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/md5.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/md5.cr#L14","def":{"name":"hash","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::StaticArray(UInt8, 16)","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nLibCrypto.md5(data, bytesize, buffer)\nbuffer\n"}},{"id":"hash(data:String):StaticArray(UInt8,16)-class-method","html_id":"hash(data:String):StaticArray(UInt8,16)-class-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"args_string":"(data : String) : StaticArray(UInt8, 16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/md5.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/md5.cr#L10","def":{"name":"hash","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::StaticArray(UInt8, 16)","visibility":"Public","body":"hash(data.to_unsafe, data.bytesize)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SHA1","path":"OpenSSL/SHA1.html","kind":"class","full_name":"OpenSSL::SHA1","name":"SHA1","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/sha1.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/sha1.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Binds the OpenSSL SHA1 hash functions.\n\nWarning: SHA1 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Binds the OpenSSL SHA1 hash functions.</p>","class_methods":[{"id":"hash(data:Pointer(UInt8),bytesize:LibC::SizeT)-class-method","html_id":"hash(data:Pointer(UInt8),bytesize:LibC::SizeT)-class-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"LibC::SizeT"}],"args_string":"(data : Pointer(UInt8), bytesize : LibC::SizeT)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/sha1.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/sha1.cr#L14","def":{"name":"hash","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":"LibC::SizeT"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 20)\nLibCrypto.sha1(data, bytesize, buffer)\nbuffer\n"}},{"id":"hash(data:String)-class-method","html_id":"hash(data:String)-class-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"args_string":"(data : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/sha1.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/sha1.cr#L10","def":{"name":"hash","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash(data.to_unsafe, LibC::SizeT.new(data.bytesize))"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","path":"OpenSSL/SSL.html","kind":"module","full_name":"OpenSSL::SSL","name":"SSL","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":88,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","path":"OpenSSL/SSL/Context.html","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/context.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"CIPHERS","name":"CIPHERS","value":"([\"ECDHE-ECDSA-CHACHA20-POLY1305\", \"ECDHE-RSA-CHACHA20-POLY1305\", \"ECDHE-ECDSA-AES128-GCM-SHA256\", \"ECDHE-RSA-AES128-GCM-SHA256\", \"ECDHE-ECDSA-AES256-GCM-SHA384\", \"ECDHE-RSA-AES256-GCM-SHA384\", \"DHE-RSA-AES128-GCM-SHA256\", \"DHE-RSA-AES256-GCM-SHA384\", \"ECDHE-ECDSA-AES128-SHA256\", \"ECDHE-RSA-AES128-SHA256\", \"ECDHE-ECDSA-AES128-SHA\", \"ECDHE-RSA-AES256-SHA384\", \"ECDHE-RSA-AES128-SHA\", \"ECDHE-ECDSA-AES256-SHA384\", \"ECDHE-ECDSA-AES256-SHA\", \"ECDHE-RSA-AES256-SHA\", \"DHE-RSA-AES128-SHA256\", \"DHE-RSA-AES128-SHA\", \"DHE-RSA-AES256-SHA256\", \"DHE-RSA-AES256-SHA\", \"ECDHE-ECDSA-DES-CBC3-SHA\", \"ECDHE-RSA-DES-CBC3-SHA\", \"EDH-RSA-DES-CBC3-SHA\", \"AES128-GCM-SHA256\", \"AES256-GCM-SHA384\", \"AES128-SHA256\", \"AES256-SHA256\", \"AES128-SHA\", \"AES256-SHA\", \"DES-CBC3-SHA\", \"!RC4\", \"!aNULL\", \"!eNULL\", \"!LOW\", \"!3DES\", \"!MD5\", \"!EXP\", \"!PSK\", \"!SRP\", \"!DSS\"] of ::String).join(' ')","doc":"The list of secure ciphers (intermediate security) as of May 2016 as per\nhttps://wiki.mozilla.org/Security/Server_Side_TLS","summary":"<p>The list of secure ciphers (intermediate security) as of May 2016 as per https://wiki.mozilla.org/Security/Server_Side_TLS</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context/Client","kind":"class","full_name":"OpenSSL::SSL::Context::Client","name":"Client"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context/Server","kind":"class","full_name":"OpenSSL::SSL::Context::Server","name":"Server"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(method:LibSSL::SSLMethod)-class-method","html_id":"new(method:LibSSL::SSLMethod)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L148","def":{"name":"new","args":[{"name":"method","doc":null,"default_value":"","external_name":"method","restriction":"LibSSL::SSLMethod"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(method)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"add_modes(mode:OpenSSL::SSL::Modes)-instance-method","html_id":"add_modes(mode:OpenSSL::SSL::Modes)-instance-method","name":"add_modes","doc":"Adds modes to the TLS context.","summary":"<p>Adds modes to the TLS context.</p>","abstract":false,"args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"args_string":"(mode : OpenSSL::SSL::Modes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L245","def":{"name":"add_modes","args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_MODE, mode, nil))"}},{"id":"add_options(options:OpenSSL::SSL::Options)-instance-method","html_id":"add_options(options:OpenSSL::SSL::Options)-instance-method","name":"add_options","doc":"Adds options to the TLS context.\n\nExample:\n```\ncontext.add_options(\n  OpenSSL::SSL::Options::ALL |       # various workarounds\n  OpenSSL::SSL::Options::NO_SSL_V2 | # disable overly deprecated SSLv2\n  OpenSSL::SSL::Options::NO_SSL_V3   # disable deprecated SSLv3\n)\n```","summary":"<p>Adds options to the TLS context.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"args_string":"(options : OpenSSL::SSL::Options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L274","def":{"name":"add_options","args":[{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"opts = {% if LibSSL::OPENSSL_110 %}\n      LibSSL.ssl_ctx_set_options(@handle, options)\n    {% else %}\n      LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_OPTIONS, options, nil)\n    {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"id":"ca_certificates=(file_path:String)-instance-method","html_id":"ca_certificates=(file_path:String)-instance-method","name":"ca_certificates=","doc":"Sets the path to a file containing all CA certificates, in PEM format, used to\nvalidate the peers certificate.","summary":"<p>Sets the path to a file containing all CA certificates, in PEM format, used to validate the peers certificate.</p>","abstract":false,"args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L196","def":{"name":"ca_certificates=","args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibSSL.ssl_ctx_load_verify_locations(@handle, file_path, nil)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_load_verify_locations\"))\nend\n"}},{"id":"ca_certificates_path=(dir_path:String)-instance-method","html_id":"ca_certificates_path=(dir_path:String)-instance-method","name":"ca_certificates_path=","doc":"Sets the path to a directory containing all CA certificates used to\nvalidate the peers certificate. The certificates should be in PEM format\nand the `c_rehash(1)` utility must have been run in the directory.","summary":"<p>Sets the path to a directory containing all CA certificates used to validate the peers certificate.</p>","abstract":false,"args":[{"name":"dir_path","doc":null,"default_value":"","external_name":"dir_path","restriction":"String"}],"args_string":"(dir_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L204","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L204","def":{"name":"ca_certificates_path=","args":[{"name":"dir_path","doc":null,"default_value":"","external_name":"dir_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibSSL.ssl_ctx_load_verify_locations(@handle, nil, dir_path)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_load_verify_locations\"))\nend\n"}},{"id":"certificate_chain=(file_path:String)-instance-method","html_id":"certificate_chain=(file_path:String)-instance-method","name":"certificate_chain=","doc":"Specify the path to the certificate chain file to use. In server mode this\nis presented to the client, in client mode this used as client certificate.","summary":"<p>Specify the path to the certificate chain file to use.</p>","abstract":false,"args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L211","def":{"name":"certificate_chain=","args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibSSL.ssl_ctx_use_certificate_chain_file(@handle, file_path)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_use_certificate_chain_file\"))\nend\n"}},{"id":"ciphers=(ciphers:String)-instance-method","html_id":"ciphers=(ciphers:String)-instance-method","name":"ciphers=","doc":"Specify a list of TLS ciphers to use or discard.","summary":"<p>Specify a list of TLS ciphers to use or discard.</p>","abstract":false,"args":[{"name":"ciphers","doc":null,"default_value":"","external_name":"ciphers","restriction":"String"}],"args_string":"(ciphers : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L224","def":{"name":"ciphers=","args":[{"name":"ciphers","doc":null,"default_value":"","external_name":"ciphers","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibSSL.ssl_ctx_set_cipher_list(@handle, ciphers)\nif ret == 0\n  raise(OpenSSL::Error.new(\"SSL_CTX_set_cipher_list\"))\nend\nciphers\n"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L185","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibSSL.ssl_ctx_free(@handle)"}},{"id":"modes-instance-method","html_id":"modes-instance-method","name":"modes","doc":"Returns the current modes set on the TLS context.","summary":"<p>Returns the current modes set on the TLS context.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L240","def":{"name":"modes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_MODE, 0, nil))"}},{"id":"options-instance-method","html_id":"options-instance-method","name":"options","doc":"Returns the current options set on the TLS context.","summary":"<p>Returns the current options set on the TLS context.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L255","def":{"name":"options","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"opts = {% if LibSSL::OPENSSL_110 %}\n      LibSSL.ssl_ctx_get_options(@handle)\n    {% else %}\n      LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_OPTIONS, 0, nil)\n    {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"id":"private_key=(file_path:String)-instance-method","html_id":"private_key=(file_path:String)-instance-method","name":"private_key=","doc":"Specify the path to the private key to use. The key must in PEM format.\nThe key must correspond to the entity certificate set by `certificate_chain=`.","summary":"<p>Specify the path to the private key to use.</p>","abstract":false,"args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L218","def":{"name":"private_key=","args":[{"name":"file_path","doc":null,"default_value":"","external_name":"file_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibSSL.ssl_ctx_use_privatekey_file(@handle, file_path, LibSSL::SSLFileType::PEM)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_use_PrivateKey_file\"))\nend\n"}},{"id":"remove_modes(mode:OpenSSL::SSL::Modes)-instance-method","html_id":"remove_modes(mode:OpenSSL::SSL::Modes)-instance-method","name":"remove_modes","doc":"Removes modes from the TLS context.","summary":"<p>Removes modes from the TLS context.</p>","abstract":false,"args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"args_string":"(mode : OpenSSL::SSL::Modes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L250","def":{"name":"remove_modes","args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_CLEAR_MODE, mode, nil))"}},{"id":"remove_options(options:OpenSSL::SSL::Options)-instance-method","html_id":"remove_options(options:OpenSSL::SSL::Options)-instance-method","name":"remove_options","doc":"Removes options from the TLS context.\n\nExample:\n```\ncontext.remove_options(OpenSSL::SSL::Options::NO_SSL_V3)\n```","summary":"<p>Removes options from the TLS context.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"args_string":"(options : OpenSSL::SSL::Options)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L289","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L289","def":{"name":"remove_options","args":[{"name":"options","doc":null,"default_value":"","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"opts = {% if LibSSL::OPENSSL_110 %}\n      LibSSL.ssl_ctx_clear_options(@handle, options)\n    {% else %}\n      LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_CLEAR_OPTIONS, options, nil)\n    {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"id":"set_default_verify_paths-instance-method","html_id":"set_default_verify_paths-instance-method","name":"set_default_verify_paths","doc":"Sets the default paths for `ca_certiifcates=` and `ca_certificates_path=`.","summary":"<p>Sets the default paths for <code>ca_certiifcates=</code> and <code><a href=\"../../OpenSSL/SSL/Context.html#ca_certificates_path%3D%28dir_path%3AString%29-instance-method\">#ca_certificates_path=</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L190","def":{"name":"set_default_verify_paths","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibSSL.ssl_ctx_set_default_verify_paths(@handle)"}},{"id":"set_tmp_ecdh_key(curve=LibCrypto::NID_X9_62_prime256v1)-instance-method","html_id":"set_tmp_ecdh_key(curve=LibCrypto::NID_X9_62_prime256v1)-instance-method","name":"set_tmp_ecdh_key","doc":"Adds a temporary ECDH key curve to the TLS context. This is required to\nenable the EECDH cipher suites. By default the prime256 curve will be used.","summary":"<p>Adds a temporary ECDH key curve to the TLS context.</p>","abstract":false,"args":[{"name":"curve","doc":null,"default_value":"LibCrypto::NID_X9_62_prime256v1","external_name":"curve","restriction":""}],"args_string":"(curve = <span class=\"t\">LibCrypto</span><span class=\"t\">::</span><span class=\"t\">NID_X9_62_prime256v1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L232","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L232","def":{"name":"set_tmp_ecdh_key","args":[{"name":"curve","doc":null,"default_value":"LibCrypto::NID_X9_62_prime256v1","external_name":"curve","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"key = LibCrypto.ec_key_new_by_curve_name(curve)\nif key.null?\n  raise(OpenSSL::Error.new(\"ec_key_new_by_curve_name\"))\nend\nLibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_SET_TMP_ECDH, 0, key)\nLibCrypto.ec_key_free(key)\n"}},{"id":"to_unsafe:LibSSL::SSLContext-instance-method","html_id":"to_unsafe:LibSSL::SSLContext-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibSSL::SSLContext","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L362","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L362","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@handle"}},{"id":"verify_mode-instance-method","html_id":"verify_mode-instance-method","name":"verify_mode","doc":"Returns the current verify mode. See the `SSL_CTX_set_verify(3)` manpage for more details.","summary":"<p>Returns the current verify mode.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L299","def":{"name":"verify_mode","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibSSL.ssl_ctx_get_verify_mode(@handle)"}},{"id":"verify_mode=(mode:OpenSSL::SSL::VerifyMode)-instance-method","html_id":"verify_mode=(mode:OpenSSL::SSL::VerifyMode)-instance-method","name":"verify_mode=","doc":"Sets the verify mode. See the `SSL_CTX_set_verify(3)` manpage for more details.","summary":"<p>Sets the verify mode.</p>","abstract":false,"args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::VerifyMode"}],"args_string":"(mode : OpenSSL::SSL::VerifyMode)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L304","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L304","def":{"name":"verify_mode=","args":[{"name":"mode","doc":null,"default_value":"","external_name":"mode","restriction":"OpenSSL::SSL::VerifyMode"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibSSL.ssl_ctx_set_verify(@handle, mode, nil)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context/Client","path":"OpenSSL/SSL/Context/Client.html","kind":"class","full_name":"OpenSSL::SSL::Context::Client","name":"Client","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/context.cr","line_number":56,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"doc":null,"summary":null,"class_methods":[{"id":"insecure(method:LibSSL::SSLMethod=Context.default_method)-class-method","html_id":"insecure(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"insecure","doc":"Returns a new TLS client context with only the given method set.\n\nFor everything else this uses the defaults of your OpenSSL.\nUse this only if undoing the defaults that `new` sets is too much hassle.","summary":"<p>Returns a new TLS client context with only the given method set.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L88","def":{"name":"insecure","args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"super(method)"}}],"constructors":[{"id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","html_id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"new","doc":"Generates a new TLS client context with sane defaults for a client connection.\n\nDefaults to `TLS_method` or `SSLv23_method` (depending on OpenSSL version)\nwhich tells OpenSSL to negotiate the TLS or SSL protocol with the remote\nendpoint.\n\nDon't change the method unless you must restrict a specific protocol to be\nused (eg: TLSv1.2) and nothing else. You should specify options to disable\nspecific protocols, yet allow to negotiate from various other ones. For\nexample the following snippet will enable the TLSv1, TLSv1.1 and TLSv1.2\nprotocols but disable the deprecated SSLv2 and SSLv3 protocols:\n\n```\nrequire \"openssl\"\n\ncontext = OpenSSL::SSL::Context::Client.new\ncontext.add_options(OpenSSL::SSL::Options::NO_SSL_V2 | OpenSSL::SSL::Options::NO_SSL_V3)\n```","summary":"<p>Generates a new TLS client context with sane defaults for a client connection.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L75","def":{"name":"new","args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(method)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context/Server","path":"OpenSSL/SSL/Context/Server.html","kind":"class","full_name":"OpenSSL::SSL::Context::Server","name":"Server","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/context.cr","line_number":111,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"doc":null,"summary":null,"class_methods":[{"id":"insecure(method:LibSSL::SSLMethod=Context.default_method)-class-method","html_id":"insecure(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"insecure","doc":"Returns a new TLS server context with only the given method set.\n\nFor everything else this uses the defaults of your OpenSSL.\nUse this only if undoing the defaults that `new` sets is too much hassle.","summary":"<p>Returns a new TLS server context with only the given method set.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L143","def":{"name":"insecure","args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"super(method)"}}],"constructors":[{"id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","html_id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"new","doc":"Generates a new TLS server context with sane defaults for a server connection.\n\nDefaults to `TLS_method` or `SSLv23_method` (depending on OpenSSL version)\nwhich tells OpenSSL to negotiate the TLS or SSL protocol with the remote\nendpoint.\n\nDon't change the method unless you must restrict a specific protocol to be\nused (eg: TLSv1.2) and nothing else. You should specify options to disable\nspecific protocols, yet allow to negotiate from various other ones. For\nexample the following snippet will enable the TLSv1, TLSv1.1 and TLSv1.2\nprotocols but disable the deprecated SSLv2 and SSLv3 protocols:\n\n```\ncontext = OpenSSL::SSL::Context::Server.new\ncontext.add_options(OpenSSL::SSL::Options::NO_SSL_V2 | OpenSSL::SSL::Options::NO_SSL_V3)\n```","summary":"<p>Generates a new TLS server context with sane defaults for a server connection.</p>","abstract":false,"args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/context.cr#L128","def":{"name":"new","args":[{"name":"method","doc":null,"default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(method)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Error","path":"OpenSSL/SSL/Error.html","kind":"class","full_name":"OpenSSL::SSL::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl.cr","line_number":97,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ssl:LibSSL::SSL,return_code:LibSSL::Int,func=nil)-class-method","html_id":"new(ssl:LibSSL::SSL,return_code:LibSSL::Int,func=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ssl","doc":null,"default_value":"","external_name":"ssl","restriction":"LibSSL::SSL"},{"name":"return_code","doc":null,"default_value":"","external_name":"return_code","restriction":"LibSSL::Int"},{"name":"func","doc":null,"default_value":"nil","external_name":"func","restriction":""}],"args_string":"(ssl : LibSSL::SSL, return_code : LibSSL::Int, func = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L100","def":{"name":"new","args":[{"name":"ssl","doc":null,"default_value":"","external_name":"ssl","restriction":"LibSSL::SSL"},{"name":"return_code","doc":null,"default_value":"","external_name":"return_code","restriction":"LibSSL::Int"},{"name":"func","doc":null,"default_value":"nil","external_name":"func","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(ssl, return_code, func)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"error:ErrorType-instance-method","html_id":"error:ErrorType-instance-method","name":"error","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : ErrorType","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr#L98","def":{"name":"error","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ErrorType","visibility":"Public","body":"@error"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/ErrorType","path":"OpenSSL/SSL/ErrorType.html","kind":"alias","full_name":"OpenSSL::SSL::ErrorType","name":"ErrorType","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":92,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::SSLError","const":false,"constants":[{"id":"NONE","name":"NONE","value":"0","doc":null,"summary":null},{"id":"SSL","name":"SSL","value":"1","doc":null,"summary":null},{"id":"SYSCALL","name":"SYSCALL","value":"5","doc":null,"summary":null},{"id":"WANT_ACCEPT","name":"WANT_ACCEPT","value":"8","doc":null,"summary":null},{"id":"WANT_CONNECT","name":"WANT_CONNECT","value":"7","doc":null,"summary":null},{"id":"WANT_READ","name":"WANT_READ","value":"2","doc":null,"summary":null},{"id":"WANT_WRITE","name":"WANT_WRITE","value":"3","doc":null,"summary":null},{"id":"WANT_X509_LOOKUP","name":"WANT_X509_LOOKUP","value":"4","doc":null,"summary":null},{"id":"ZERO_RETURN","name":"ZERO_RETURN","value":"6","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Modes","path":"OpenSSL/SSL/Modes.html","kind":"alias","full_name":"OpenSSL::SSL::Modes","name":"Modes","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":89,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::Modes","const":false,"constants":[{"id":"ACCEPT_MOVING_WRITE_BUFFER","name":"ACCEPT_MOVING_WRITE_BUFFER","value":"2_u64","doc":null,"summary":null},{"id":"AUTO_RETRY","name":"AUTO_RETRY","value":"4_u64","doc":null,"summary":null},{"id":"ENABLE_PARTIAL_WRITE","name":"ENABLE_PARTIAL_WRITE","value":"1_u64","doc":null,"summary":null},{"id":"NO_AUTO_CHAIN","name":"NO_AUTO_CHAIN","value":"8_u64","doc":null,"summary":null},{"id":"RELEASE_BUFFERS","name":"RELEASE_BUFFERS","value":"16_u64","doc":null,"summary":null},{"id":"SEND_CLIENTHELLO_TIME","name":"SEND_CLIENTHELLO_TIME","value":"32_u64","doc":null,"summary":null},{"id":"SEND_FALLBACK_SCSV","name":"SEND_FALLBACK_SCSV","value":"128_u64","doc":null,"summary":null},{"id":"SEND_SERVERHELLO_TIME","name":"SEND_SERVERHELLO_TIME","value":"64_u64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Options","path":"OpenSSL/SSL/Options.html","kind":"alias","full_name":"OpenSSL::SSL::Options","name":"Options","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":90,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::Options","const":false,"constants":[{"id":"ALL","name":"ALL","value":"2147486719_u64","doc":"Various bug workarounds that should be rather harmless.\nThis used to be `0x000FFFFF` before 0.9.7","summary":"<p>Various bug workarounds that should be rather harmless.</p>"},{"id":"ALLOW_UNSAFE_LEGACY_RENEGOTIATION","name":"ALLOW_UNSAFE_LEGACY_RENEGOTIATION","value":"262144_u64","doc":null,"summary":null},{"id":"CIPHER_SERVER_PREFERENCE","name":"CIPHER_SERVER_PREFERENCE","value":"4194304_u64","doc":null,"summary":null},{"id":"CISCO_ANYCONNECT","name":"CISCO_ANYCONNECT","value":"32768_u64","doc":null,"summary":null},{"id":"COOKIE_EXCHANGE","name":"COOKIE_EXCHANGE","value":"8192_u64","doc":null,"summary":null},{"id":"CRYPTOPRO_TLSEXT_BUG","name":"CRYPTOPRO_TLSEXT_BUG","value":"2147483648_u64","doc":null,"summary":null},{"id":"DONT_INSERT_EMPTY_FRAGMENTS","name":"DONT_INSERT_EMPTY_FRAGMENTS","value":"2048_u64","doc":null,"summary":null},{"id":"LEGACY_SERVER_CONNECT","name":"LEGACY_SERVER_CONNECT","value":"4_u64","doc":null,"summary":null},{"id":"NETSCAPE_CA_DN_BUG","name":"NETSCAPE_CA_DN_BUG","value":"536870912_u64","doc":null,"summary":null},{"id":"NETSCAPE_DEMO_CIPHER_CHANGE_BUG","name":"NETSCAPE_DEMO_CIPHER_CHANGE_BUG","value":"1073741824_u64","doc":null,"summary":null},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"131072_u64","doc":null,"summary":null},{"id":"NO_QUERY_MTU","name":"NO_QUERY_MTU","value":"4096_u64","doc":null,"summary":null},{"id":"NO_SESSION_RESUMPTION_ON_RENEGOTIATION","name":"NO_SESSION_RESUMPTION_ON_RENEGOTIATION","value":"65536_u64","doc":null,"summary":null},{"id":"NO_SSL_V3","name":"NO_SSL_V3","value":"33554432_u64","doc":null,"summary":null},{"id":"NO_TICKET","name":"NO_TICKET","value":"16384_u64","doc":null,"summary":null},{"id":"NO_TLS_V1","name":"NO_TLS_V1","value":"67108864_u64","doc":null,"summary":null},{"id":"NO_TLS_V1_1","name":"NO_TLS_V1_1","value":"268435456_u64","doc":null,"summary":null},{"id":"NO_TLS_V1_2","name":"NO_TLS_V1_2","value":"134217728_u64","doc":null,"summary":null},{"id":"SAFARI_ECDHE_ECDSA_BUG","name":"SAFARI_ECDHE_ECDSA_BUG","value":"64_u64","doc":null,"summary":null},{"id":"TLS_ROLLBACK_BUG","name":"TLS_ROLLBACK_BUG","value":"8388608_u64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","path":"OpenSSL/SSL/Socket.html","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/socket.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket/Client","kind":"class","full_name":"OpenSSL::SSL::Socket::Client","name":"Client"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket/Server","kind":"class","full_name":"OpenSSL::SSL::Socket::Server","name":"Server"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(io,context:Context,sync_close:Bool=false)-class-method","html_id":"new(io,context:Context,sync_close:Bool=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io, context : Context, sync_close : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L79","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"","external_name":"context","restriction":"Context"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, context, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L77","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@closed"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L90","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibSSL.ssl_free(@ssl)"}},{"id":"sync_close=(sync_close:Bool)-instance-method","html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this socket will\nclose the underlying IO.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Socket.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this socket will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L75","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this socket will\nclose the underlying IO.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Socket.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this socket will close the underlying IO.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L75","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"id":"unbuffered_close-instance-method","html_id":"unbuffered_close-instance-method","name":"unbuffered_close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L133","def":{"name":"unbuffered_close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nbegin\n  loop do\n    begin\n      ret = LibSSL.ssl_shutdown(@ssl)\n      if ret == 1\n        break\n      end\n      if ret < 0\n        raise(OpenSSL::SSL::Error.new(@ssl, ret, \"SSL_shutdown\"))\n      end\n    rescue e : Errno\n      case e.errno\n      when 0\n        break\n      when Errno::EAGAIN\n      when Errno::EINPROGRESS\n      else\n        raise(e)\n      end\n    rescue e : OpenSSL::SSL::Error\n      case e.error\n      when .want_read?, .want_write?\n      else\n        raise(e)\n      end\n    end\n  end\nrescue IO::Error\nensure\n  if @sync_close\n    @bio.io.close\n  end\nend\n"}},{"id":"unbuffered_flush-instance-method","html_id":"unbuffered_flush-instance-method","name":"unbuffered_flush","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L120","def":{"name":"unbuffered_flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bio.io.flush"}},{"id":"unbuffered_read(slice:Bytes)-instance-method","html_id":"unbuffered_read(slice:Bytes)-instance-method","name":"unbuffered_read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L94","def":{"name":"unbuffered_read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\ncount = slice.size\nif count == 0\n  return 0\nend\n(LibSSL.ssl_read(@ssl, slice.pointer(count), count)).tap do |bytes|\n  if bytes <= 0 && (!(LibSSL.ssl_get_error(@ssl, bytes)).zero_return?)\n    raise(OpenSSL::SSL::Error.new(@ssl, bytes, \"SSL_read\"))\n  end\nend\n"}},{"id":"unbuffered_rewind-instance-method","html_id":"unbuffered_rewind-instance-method","name":"unbuffered_rewind","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L173","def":{"name":"unbuffered_rewind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't rewind OpenSSL::SSL::Socket::Client\"))"}},{"id":"unbuffered_write(slice:Bytes)-instance-method","html_id":"unbuffered_write(slice:Bytes)-instance-method","name":"unbuffered_write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L107","def":{"name":"unbuffered_write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\ncount = slice.size\nbytes = LibSSL.ssl_write(@ssl, slice.pointer(count), count)\nif bytes > 0\nelse\n  raise(OpenSSL::SSL::Error.new(@ssl, bytes, \"SSL_write\"))\nend\nnil\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket/Client","path":"OpenSSL/SSL/Socket/Client.html","kind":"class","full_name":"OpenSSL::SSL::Socket::Client","name":"Client","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/socket.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[{"id":"open(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil,&block)-class-method","html_id":"open(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil,&amp;block)-class-method","name":"open","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","doc":null,"default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"args_string":"(io, context : Context::Client = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Client</span>.<span class=\"k\">new</span>, sync_close : Bool = <span class=\"n\">false</span>, hostname : String? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L38","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","doc":null,"default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"socket = new(io, context, sync_close, hostname)\nbegin\n  yield socket\nensure\n  socket.close\nend\n"}}],"constructors":[{"id":"new(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil)-class-method","html_id":"new(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","doc":null,"default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"args_string":"(io, context : Context::Client = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Client</span>.<span class=\"k\">new</span>, sync_close : Bool = <span class=\"n\">false</span>, hostname : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L3","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","doc":null,"default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, context, sync_close, hostname)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket/Server","path":"OpenSSL/SSL/Socket/Server.html","kind":"class","full_name":"OpenSSL::SSL::Socket::Server","name":"Server","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"openssl/ssl/socket.cr","line_number":49,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[{"id":"open(io,context:Context::Server=Context::Server.new,sync_close:Bool=false,&block)-class-method","html_id":"open(io,context:Context::Server=Context::Server.new,sync_close:Bool=false,&amp;block)-class-method","name":"open","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io, context : Context::Server = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : Bool = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L60","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"socket = new(io, context, sync_close)\nbegin\n  yield socket\nensure\n  socket.close\nend\n"}}],"constructors":[{"id":"new(io,context:Context::Server=Context::Server.new,sync_close:Bool=false)-class-method","html_id":"new(io,context:Context::Server=Context::Server.new,sync_close:Bool=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io, context : Context::Server = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl/ssl/socket.cr#L50","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"context","doc":null,"default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, context, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/VerifyMode","path":"OpenSSL/SSL/VerifyMode.html","kind":"alias","full_name":"OpenSSL::SSL::VerifyMode","name":"VerifyMode","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"openssl.cr","line_number":91,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/openssl.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::VerifyMode","const":false,"constants":[{"id":"CLIENT_ONCE","name":"CLIENT_ONCE","value":"4","doc":null,"summary":null},{"id":"FAIL_IF_NO_PEER_CERT","name":"FAIL_IF_NO_PEER_CERT","value":"2","doc":null,"summary":null},{"id":"NONE","name":"NONE","value":"0","doc":null,"summary":null},{"id":"PEER","name":"PEER","value":"1","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/OptionParser","path":"OptionParser.html","kind":"class","full_name":"OptionParser","name":"OptionParser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"option_parser.cr","line_number":32,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"`OptionParser` is a class for command-line options processing. It supports:\n\n* Short and long modifier style options (example: `-h`, `--help`)\n* Passing arguments to the flags (example: `-f filename.txt`)\n* Automatic help message generation\n\nRun `crystal` for an example of a CLI built with `OptionParser`.\n\nShort example:\n\n```\nrequire \"option_parser\"\n\nupcase = false\ndestination = \"World\"\n\nOptionParser.parse! do |parser|\n  parser.banner = \"Usage: salute [arguments]\"\n  parser.on(\"-u\", \"--upcase\", \"Upcases the salute\") { upcase = true }\n  parser.on(\"-t NAME\", \"--to=NAME\", \"Specifies the name to salute\") { |name| destination = name }\n  parser.on(\"-h\", \"--help\", \"Show this help\") { puts parser }\n  parser.invalid_option do |flag|\n    STDERR.puts \"ERROR: #{flag} is not a valid option.\"\n    STDERR.puts parser\n    exit(1)\n  end\nend\n\ndestination = destination.upcase if upcase\nputs \"Hello #{destination}!\"\n```","summary":"<p><code><a href=\"OptionParser.html\">OptionParser</a></code> is a class for command-line options processing.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a new parser.","summary":"<p>Creates a new parser.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L75","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(&block)-class-method","html_id":"new(&amp;block)-class-method","name":"new","doc":"Creates a new parser, with its configuration specified in the block.","summary":"<p>Creates a new parser, with its configuration specified in the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L83","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"new.tap do |parser|\n  yield parser\nend"}},{"id":"parse(args,&block):self-class-method","html_id":"parse(args,&amp;block):self-class-method","name":"parse","doc":"Creates a new parser, with its configuration specified in the block,\nand uses it to parse the passed *args*.","summary":"<p>Creates a new parser, with its configuration specified in the block, and uses it to parse the passed <em>args</em>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(args, &block) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L55","def":{"name":"parse","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"self","visibility":"Public","body":"parser = OptionParser.new\nyield parser\nparser.parse(args)\nparser\n"}},{"id":"parse!(&block):self-class-method","html_id":"parse!(&amp;block):self-class-method","name":"parse!","doc":"Creates a new parser, with its configuration specified in the block,\nand uses it to parse the arguments passed to the program.","summary":"<p>Creates a new parser, with its configuration specified in the block, and uses it to parse the arguments passed to the program.</p>","abstract":false,"args":[],"args_string":"(&block) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L64","def":{"name":"parse!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"self","visibility":"Public","body":"parse(ARGV) do |parser|\n  yield parser\nend"}}],"instance_methods":[{"id":"banner=(banner:String?)-instance-method","html_id":"banner=(banner:String?)-instance-method","name":"banner=","doc":"Establishes the initial message for the help printout.\nTypically, you want to write here the name of your program,\nand a one-line template of its invocation.\n\nExample:\n\n```\nparser = OptionParser.new\nparser.banner = \"Usage: crystal [command] [switches] [program file] [--] [arguments]\"\n```","summary":"<p>Establishes the initial message for the help printout.</p>","abstract":false,"args":[{"name":"banner","doc":null,"default_value":"","external_name":"banner","restriction":"String | ::Nil"}],"args_string":"(banner : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L97","def":{"name":"banner=","args":[{"name":"banner","doc":null,"default_value":"","external_name":"banner","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@banner = banner"}},{"id":"invalid_option(&invalid_option:String->)-instance-method","html_id":"invalid_option(&amp;invalid_option:String-&gt;)-instance-method","name":"invalid_option","doc":"Sets a handler for option arguments that didn't match any of the setup options.\n\nYou typically use this to display a help message.\nThe default raises `InvalidOption`.","summary":"<p>Sets a handler for option arguments that didn't match any of the setup options.</p>","abstract":false,"args":[],"args_string":"(&invalid_option : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L162","def":{"name":"invalid_option","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"invalid_option","doc":null,"default_value":"","external_name":"invalid_option","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@invalid_option = invalid_option"}},{"id":"missing_option(&missing_option:String->)-instance-method","html_id":"missing_option(&amp;missing_option:String-&gt;)-instance-method","name":"missing_option","doc":"Sets a handler for when a option that expects an argument wasn't given any.\n\nYou typically use this to display a help message.\nThe default raises `MissingOption`.","summary":"<p>Sets a handler for when a option that expects an argument wasn't given any.</p>","abstract":false,"args":[],"args_string":"(&missing_option : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L155","def":{"name":"missing_option","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"missing_option","doc":null,"default_value":"","external_name":"missing_option","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"@missing_option = missing_option"}},{"id":"on(short_flag:String,long_flag:String,description:String,&block:String->)-instance-method","html_id":"on(short_flag:String,long_flag:String,description:String,&amp;block:String-&gt;)-instance-method","name":"on","doc":"Establishes a handler for a pair of short and long flags.\n\nSee the other definition of `on` for examples.","summary":"<p>Establishes a handler for a pair of short and long flags.</p>","abstract":false,"args":[{"name":"short_flag","doc":null,"default_value":"","external_name":"short_flag","restriction":"String"},{"name":"long_flag","doc":null,"default_value":"","external_name":"long_flag","restriction":"String"},{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":"String"}],"args_string":"(short_flag : String, long_flag : String, description : String, &block : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L120","def":{"name":"on","args":[{"name":"short_flag","doc":null,"default_value":"","external_name":"short_flag","restriction":"String"},{"name":"long_flag","doc":null,"default_value":"","external_name":"long_flag","restriction":"String"},{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"check_starts_with_dash(short_flag, \"short_flag\", allow_empty: true)\ncheck_starts_with_dash(long_flag, \"long_flag\")\nappend_flag(\"#{short_flag}, #{long_flag}\", description)\nhas_argument = /([ =].+)/\nif long_flag =~ has_argument\n  argument = $~[1]\n  if short_flag =~ has_argument\n  else\n    short_flag = short_flag + argument\n  end\nend\n@handlers << (Handler.new(short_flag, block))\n@handlers << (Handler.new(long_flag, block))\n"}},{"id":"on(flag:String,description:String,&block:String->)-instance-method","html_id":"on(flag:String,description:String,&amp;block:String-&gt;)-instance-method","name":"on","doc":"Establishes a handler for a *flag*.\n\nFlags must start with a dash or double dash. They can also have\nan optional argument, which will get passed to the block.\nEach flag has a description, which will be used for the help message.\n\nExamples of valid flags:\n\n* `-a`, `-B`\n* `--something-longer`\n* `-f FILE`, `--file FILE`, `--file=FILE` (these will yield the passed value to the block as a string)","summary":"<p>Establishes a handler for a <em>flag</em>.</p>","abstract":false,"args":[{"name":"flag","doc":null,"default_value":"","external_name":"flag","restriction":"String"},{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":"String"}],"args_string":"(flag : String, description : String, &block : String -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L110","def":{"name":"on","args":[{"name":"flag","doc":null,"default_value":"","external_name":"flag","restriction":"String"},{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> )"},"return_type":"","visibility":"Public","body":"check_starts_with_dash(flag, \"flag\")\nappend_flag(flag, description)\n@handlers << (Handler.new(flag, block))\n"}},{"id":"parse(args)-instance-method","html_id":"parse(args)-instance-method","name":"parse","doc":"Parses the passed *args*, running the handlers associated to each option.","summary":"<p>Parses the passed <em>args</em>, running the handlers associated to each option.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(args)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L183","def":{"name":"parse","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(ParseTask.new(self, args)).parse"}},{"id":"parse!-instance-method","html_id":"parse!-instance-method","name":"parse!","doc":"Parses the passed the arguments passed to the program,\nrunning the handlers associated to each option.","summary":"<p>Parses the passed the arguments passed to the program, running the handlers associated to each option.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L189","def":{"name":"parse!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse(ARGV)"}},{"id":"separator(message=&quot;&quot;)-instance-method","html_id":"separator(message=&amp;quot;&amp;quot;)-instance-method","name":"separator","doc":"Adds a separator, with an optional header message,\nthat will be used to print the help.\n\nThis way, you can group the different options in an easier to read way.","summary":"<p>Adds a separator, with an optional header message, that will be used to print the help.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L140","def":{"name":"separator","args":[{"name":"message","doc":null,"default_value":"\"\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@flags << message.to_s"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Returns all the setup options, formatted in a help message.","summary":"<p>Returns all the setup options, formatted in a help message.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L166","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L166","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if banner = @banner\n  io << banner\n  io << '\\n'\nend\n@flags.join('\\n', io)\n"}},{"id":"unknown_args(&unknown_args:Array(String),Array(String)->)-instance-method","html_id":"unknown_args(&amp;unknown_args:Array(String),Array(String)-&gt;)-instance-method","name":"unknown_args","doc":"Sets a handler for regular arguments that didn't match any of the setup options.\n\nYou typically use this to get the main arguments (not modifiers)\nthat your program expects (for example, filenames)","summary":"<p>Sets a handler for regular arguments that didn't match any of the setup options.</p>","abstract":false,"args":[],"args_string":"(&unknown_args : Array(String), Array(String) -> )","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L148","def":{"name":"unknown_args","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"unknown_args","doc":null,"default_value":"","external_name":"unknown_args","restriction":"(Array(String), Array(String) -> )"},"return_type":"","visibility":"Public","body":"@unknown_args = unknown_args"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","path":"OptionParser/Exception.html","kind":"class","full_name":"OptionParser::Exception","name":"Exception","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"option_parser.cr","line_number":33,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/OptionParser/InvalidOption","kind":"class","full_name":"OptionParser::InvalidOption","name":"InvalidOption"},{"html_id":"github.com/crystal-lang/crystal/OptionParser/MissingOption","kind":"class","full_name":"OptionParser::MissingOption","name":"MissingOption"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OptionParser/InvalidOption","path":"OptionParser/InvalidOption.html","kind":"class","full_name":"OptionParser::InvalidOption","name":"InvalidOption","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"option_parser.cr","line_number":36,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(option)-class-method","html_id":"new(option)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"option","doc":null,"default_value":"","external_name":"option","restriction":""}],"args_string":"(option)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L37","def":{"name":"new","args":[{"name":"option","doc":null,"default_value":"","external_name":"option","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(option)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/OptionParser/MissingOption","path":"OptionParser/MissingOption.html","kind":"class","full_name":"OptionParser::MissingOption","name":"MissingOption","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"option_parser.cr","line_number":42,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(option)-class-method","html_id":"new(option)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"option","doc":null,"default_value":"","external_name":"option","restriction":""}],"args_string":"(option)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/option_parser.cr#L43","def":{"name":"new","args":[{"name":"option","doc":null,"default_value":"","external_name":"option","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(option)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/PartialComparable","path":"PartialComparable.html","kind":"module","full_name":"PartialComparable(T)","name":"PartialComparable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"partial_comparable.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The `PartialComparable` mixin is used by classes whose objects may be partially ordered.\n\nIncluding types must provide an `<=>` method, which compares the receiver against\nanother object, returning `-1`, `0`, `+1` or `nil` depending on whether\nthe receiver is less than, equal to, greater than the other object,\nor no order can be established.\n\n`PartialComparable` uses `<=>` to implement the conventional\ncomparison operators (`<`, `<=`, `==`, `>=`, and `>`).","summary":"<p>The <code><a href=\"PartialComparable.html\">PartialComparable</a></code> mixin is used by classes whose objects may be partially ordered.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<(other:T)-instance-method","html_id":"&lt;(other:T)-instance-method","name":"<","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `-1`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"PartialComparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>-1</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L13","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"compare_with(other) do |cmp|\n  cmp < 0\nend"}},{"id":"<=(other:T)-instance-method","html_id":"&lt;=(other:T)-instance-method","name":"<=","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `-1` or `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"PartialComparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>-1</code> or <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L21","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"compare_with(other) do |cmp|\n  cmp <= 0\nend"}},{"id":"(other:T)-instance-method","html_id":"(other:T)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":true,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L65","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":""}},{"id":"==(other:T)-instance-method","html_id":"==(other:T)-instance-method","name":"==","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `0`.\nAlso returns `true` if this and *other* are the same object.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"PartialComparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L30","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if self.is_a?(Reference) && (other.is_a?(Reference) || other.is_a?(Nil))\n  if self.same?(other)\n    return true\n  end\nend\ncompare_with(other) do |cmp|\n  cmp == 0\nend\n"}},{"id":">(other:T)-instance-method","html_id":"&gt;(other:T)-instance-method","name":">","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `1`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"PartialComparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>1</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L42","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"compare_with(other) do |cmp|\n  cmp > 0\nend"}},{"id":">=(other:T)-instance-method","html_id":"&gt;=(other:T)-instance-method","name":">=","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `1` or `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"PartialComparable.html#%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>1</code> or <code>0</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L50","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"compare_with(other) do |cmp|\n  cmp >= 0\nend"}},{"id":"compare_with(other:T,&block)-instance-method","html_id":"compare_with(other:T,&amp;block)-instance-method","name":"compare_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"args_string":"(other : T, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/partial_comparable.cr#L56","def":{"name":"compare_with","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"cmp = self <=> other\nif cmp\n  yield cmp\nelse\n  false\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Pointer","path":"Pointer.html","kind":"struct","full_name":"Pointer(T)","name":"Pointer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"pointer.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr"},{"filename":"primitives.cr","line_number":135,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A typed pointer to some memory.\n\nThis is the only unsafe type in Crystal. If you are using a pointer, you are writing\nunsafe code because a pointer doesn't know where it's pointing to nor how much memory\nstarting from it is valid. However, pointers make it possible to interface with C and\nto implement efficient data structures. For example, both `Array` and `Hash` are\nimplemented using pointers.\n\nYou can obtain pointers in four ways: `#new`, `#malloc`, `pointerof` and by calling a C\nfunction that returns a pointer.\n\n`pointerof(x)`, where *x* is a variable or an instance variable, returns a pointer to\nthat variable:\n\n```\nx = 1\nptr = pointerof(x)\nptr.value = 2\nx # => 2\n```\n\nNote that a pointer is *falsey* if it's null (if it's address is zero).\n\nWhen calling a C function that expects a pointer you can also pass `nil` instead of using\n`Pointer.null` to construct a null pointer.\n\nFor a safe alternative, see `Slice`, which is a pointer with a size and with bounds checking.","summary":"<p>A typed pointer to some memory.</p>","class_methods":[{"id":"malloc(size:Int,value:T)-class-method","html_id":"malloc(size:Int,value:T)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto *value* and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# An Int32 occupies 4 bytes, so here we are requesting 8 bytes\n# initialized to the number 42\nptr = Pointer.malloc(2, 42)\nptr[0] # => 42\nptr[1] # => 42\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to <em>value</em> and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L451","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L451","def":{"name":"malloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ptr = Pointer(T).malloc(size)\nsize.times do |i|\n  ptr[i] = value\nend\nptr\n"}},{"id":"malloc(size:UInt64)-class-method","html_id":"malloc(size:UInt64)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto zero and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# Allocate memory for an Int32: 4 bytes\nptr = Pointer(Int32).malloc(1_u64)\nptr.value # => 0\n\n# Allocate memory for 10 Int32: 40 bytes\nptr = Pointer(Int32).malloc(10_u64)\nptr[0] # => 0\n# ...\nptr[9] # => 0\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to zero and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt64"}],"args_string":"(size : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L153","def":{"name":"malloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"# primitive: pointer_malloc"}},{"id":"malloc(size:Int=1)-class-method","html_id":"malloc(size:Int=1)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto zero and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# Allocate memory for an Int32: 4 bytes\nptr = Pointer(Int32).malloc\nptr.value # => 0\n\n# Allocate memory for 10 Int32: 40 bytes\nptr = Pointer(Int32).malloc(10)\nptr[0] # => 0\n# ...\nptr[9] # => 0\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to zero and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"1","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L431","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L431","def":{"name":"malloc","args":[{"name":"size","doc":null,"default_value":"1","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative Pointer#malloc size\"))\nend\nmalloc(size.to_u64)\n"}},{"id":"malloc(size:Int,&block:Int32->T)-class-method","html_id":"malloc(size:Int,&amp;block:Int32-&gt;T)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto the value returned by the block (which is invoked once with each index in the range `0...size`)\nand returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# An Int32 occupies 4 bytes, so here we are requesting 16 bytes.\n# i is an index in the range 0 .. 3\nptr = Pointer.malloc(4) { |i| i + 10 }\nptr[0] # => 10\nptr[1] # => 11\nptr[2] # => 12\nptr[3] # => 13\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to the value returned by the block (which is invoked once with each index in the range <code>0...size</code>) and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, &block : Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L472","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L472","def":{"name":"malloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Int32 -> T)"},"return_type":"","visibility":"Public","body":"ptr = Pointer(T).malloc(size)\nsize.times do |i|\n  ptr[i] = yield i\nend\nptr\n"}},{"id":"null-class-method","html_id":"null-class-method","name":"null","doc":"Returns a pointer whose memory address is zero. This doesn't allocate memory.\n\nWhen calling a C function you can also pass `nil` instead of constructing a\nnull pointer with this method.\n\n```\nptr = Pointer(Int32).null\nptr.address # => 0\n```","summary":"<p>Returns a pointer whose memory address is zero.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L401","def":{"name":"null","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(0_u64)"}}],"constructors":[{"id":"new(address:UInt64)-class-method","html_id":"new(address:UInt64)-class-method","name":"new","doc":"Returns a pointer that points to the given memory address.\nThis doesn't allocate memory.\n\n```\nptr = Pointer(Int32).new(5678_u64)\nptr.address # => 5678\n```","summary":"<p>Returns a pointer that points to the given memory address.</p>","abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"}],"args_string":"(address : UInt64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L164","def":{"name":"new","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"# primitive: pointer_new"}},{"id":"new(address:Int)-class-method","html_id":"new(address:Int)-class-method","name":"new","doc":"Returns a pointer that points to the given memory address. This doesn't allocate memory.\n\n```\nptr = Pointer(Int32).new(5678)\nptr.address # => 5678\n```","summary":"<p>Returns a pointer that points to the given memory address.</p>","abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"Int"}],"args_string":"(address : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L411","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L411","def":{"name":"new","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(address.to_u64)"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L30","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"id":"+(offset:Int64):self-instance-method","html_id":"+(offset:Int64):self-instance-method","name":"+","doc":"Returns a new pointer whose address is this pointer's address\nincremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr + 1_u64\nptr2.address # => 1238\n```","summary":"<p>Returns a new pointer whose address is this pointer's address incremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int64"}],"args_string":"(offset : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L230","def":{"name":"+","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: pointer_add"}},{"id":"+(other:Int)-instance-method","html_id":"+(other:Int)-instance-method","name":"+","doc":"Returns a new pointer whose address is this pointer's address incremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr + 1\nptr2.address # => 1238\n```","summary":"<p>Returns a new pointer whose address is this pointer's address incremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L80","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self + other.to_i64"}},{"id":"-(other:Int)-instance-method","html_id":"-(other:Int)-instance-method","name":"-","doc":"Returns a new pointer whose address is this pointer's address decremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr - 1\nptr2.address # => 1230\n```","summary":"<p>Returns a new pointer whose address is this pointer's address decremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L94","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self + (-other)"}},{"id":"-(other:self):Int64-instance-method","html_id":"-(other:self):Int64-instance-method","name":"-","doc":"Returns how many T elements are there between this pointer and *other*.\nThat is, this is `(self.address - other.address) / sizeof(T)`.\n\n```\nptr1 = Pointer(Int32).malloc(4)\nptr2 = ptr1 + 2\nptr2 - ptr1 # => 2\n```","summary":"<p>Returns how many T elements are there between this pointer and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L242","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L242","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: pointer_diff"}},{"id":"(other:self)-instance-method","html_id":"(other:self)-instance-method","name":"<=>","doc":"Returns -1, 0 or 1 if this pointer's address is less, equal or greater than *other*'s address,\nrespectively.\n\nSee also: `Object#<=>`.","summary":"<p>Returns -1, 0 or 1 if this pointer's address is less, equal or greater than <em>other</em>'s address, respectively.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L102","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"address <=> other.address"}},{"id":"[](offset)-instance-method","html_id":"[](offset)-instance-method","name":"[]","doc":"Gets the value pointed at this pointer's address plus `offset * sizeof(T)`.\n\n```\nptr = Pointer.malloc(4) { |i| i + 10 }\nptr[0] # => 10\nptr[1] # => 11\nptr[2] # => 12\nptr[3] # => 13\n```","summary":"<p>Gets the value pointed at this pointer's address plus <code>offset * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"args_string":"(offset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L115","def":{"name":"[]","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self + offset).value"}},{"id":"[]=(offset,value:T)-instance-method","html_id":"[]=(offset,value:T)-instance-method","name":"[]=","doc":"Sets the value pointed at this pointer's address plus `offset * sizeof(T)`.\n\n```\nptr = Pointer(Int32).malloc(4) # [0, 0, 0, 0]\nptr[1] = 42\n\nptr2 = ptr + 1\nptr2.value # => 42\n```","summary":"<p>Sets the value pointed at this pointer's address plus <code>offset * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(offset, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L128","def":{"name":"[]=","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(self + offset).value = value"}},{"id":"address:UInt64-instance-method","html_id":"address:UInt64-instance-method","name":"address","doc":"Returns the address of this pointer.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n```","summary":"<p>Returns the address of this pointer.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L196","def":{"name":"address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: pointer_address"}},{"id":"appender-instance-method","html_id":"appender-instance-method","name":"appender","doc":"Returns a `Pointer::Appender` for this pointer.","summary":"<p>Returns a <code><a href=\"Pointer/Appender.html\">Pointer::Appender</a></code> for this pointer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L479","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L479","def":{"name":"appender","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Pointer::Appender.new(self)"}},{"id":"clear(count=1)-instance-method","html_id":"clear(count=1)-instance-method","name":"clear","doc":"Clears (sets to \"zero\" bytes) a number of values pointed by this pointer.\n\n```\nptr = Pointer.malloc(6) { |i| i + 10 } # [10, 11, 12, 13, 14, 15]\nptr.clear(3)\nptr.to_slice(6) # => Slice[0, 0, 0, 13, 14, 15]\n```","summary":"<p>Clears (sets to \"zero\" bytes) a number of values pointed by this pointer.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"1","external_name":"count","restriction":""}],"args_string":"(count = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L501","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L501","def":{"name":"clear","args":[{"name":"count","doc":null,"default_value":"1","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.memset(self.as(::Pointer(Void)), 0_u8, bytesize(count), 0_u32, false)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L505","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L505","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"copy_from(source:Pointer(T),count:Int)-instance-method","html_id":"copy_from(source:Pointer(T),count:Int)-instance-method","name":"copy_from","doc":"Copies *count* elements from *source* into `self`.\nIf *source* and `self` overlap, behaviour is undefined.\nUse `#move_from` if they overlap (slower but always works).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\n# ptr2 -> [11, 12, 13, 14]\n#          ^---^           <- copy this\n# ptr1 -> [1,  2,  3,  4]\n#          ^---^           <- here\nptr1.copy_from(ptr2, 2)\nptr1[0] # => 11\nptr1[1] # => 12\nptr1[2] # => 3\nptr1[3] # => 4\n```","summary":"<p>Copies <em>count</em> elements from <em>source</em> into <code>self</code>.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(source : Pointer(T), count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L150","def":{"name":"copy_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"source.copy_to(self, count)"}},{"id":"copy_to(target:Pointer,count:Int)-instance-method","html_id":"copy_to(target:Pointer,count:Int)-instance-method","name":"copy_to","doc":"Copies *count* elements from `self` into *target*.\nIf `self` and *target* overlap, behaviour is undefined.\nUse `#move_to` if they overlap (slower but always works).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\n# ptr1 -> [1,  2,  3,  4]\n#          ^---^           <- copy this\n# ptr2 -> [11, 12, 13, 14]\n#          ^---^           <- here\nptr1.copy_to(ptr2, 2)\nptr2[0] # => 1\nptr2[1] # => 2\nptr2[2] # => 13\nptr2[3] # => 14\n```","summary":"<p>Copies <em>count</em> elements from <code>self</code> into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(target : Pointer, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L181","def":{"name":"copy_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target.copy_from_impl(self, count)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"Returns the address of this pointer.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.hash # => 1234\n```","summary":"<p>Returns the address of this pointer.</p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L308","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = address.hash(hasher)\nhasher\n"}},{"id":"map!(count:Int,&block)-instance-method","html_id":"map!(count:Int,&amp;block)-instance-method","name":"map!","doc":"Sets *count* consecutive values pointed by this pointer to the\nvalues returned by the block.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr.map!(4) { |value| value * 2 }\nptr # [2, 4, 6, 8]\n```","summary":"<p>Sets <em>count</em> consecutive values pointed by this pointer to the values returned by the block.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L378","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L378","def":{"name":"map!","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"count.times do |i|\n  self[i] = yield self[i]\nend"}},{"id":"map_with_index!(count:Int,&block)-instance-method","html_id":"map_with_index!(count:Int,&amp;block)-instance-method","name":"map_with_index!","doc":"Like `map!`, but yield 2 arugments, the element and it's index","summary":"<p>Like <code><a href=\"Pointer.html#map%21%28count%3AInt%2C%26block%29-instance-method\">#map!</a></code>, but yield 2 arugments, the element and it's index</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(count : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L385","def":{"name":"map_with_index!","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"count.times do |i|\n  self[i] = yield self[i], i\nend\nself\n"}},{"id":"memcmp(other:Pointer(T),count:Int)-instance-method","html_id":"memcmp(other:Pointer(T),count:Int)-instance-method","name":"memcmp","doc":"Compares *count* elements from this pointer and *other*, byte by byte.\n\nReturns 0 if both pointers point to the same sequence of *count* bytes. Otherwise\nreturns the difference between the first two differing bytes (treated as UInt8).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\nptr1.memcmp(ptr2, 4) # => -10\nptr2.memcmp(ptr1, 4) # => 10\nptr1.memcmp(ptr1, 4) # => 0\n```","summary":"<p>Compares <em>count</em> elements from this pointer and <em>other</em>, byte by byte.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(other : Pointer(T), count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L284","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L284","def":{"name":"memcmp","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibC.memcmp(self.as(::Pointer(Void)), (other.as(::Pointer(Void))), (count * (sizeof(T))))"}},{"id":"move_from(source:Pointer(T),count:Int)-instance-method","html_id":"move_from(source:Pointer(T),count:Int)-instance-method","name":"move_from","doc":"Copies *count* elements from *source* into `self`.\n*source* and `self` may overlap; the copy is always done in a non-destructive manner.\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 } # ptr1 -> [1, 2, 3, 4]\nptr2 = ptr1 + 1                        #             ^--------- ptr2\n\n# [1, 2, 3, 4]\n#  ^-----^       <- copy this\n#     ^------^   <- here\nptr2.move_from(ptr1, 3)\n\nptr1[0] # => 1\nptr1[1] # => 1\nptr1[2] # => 2\nptr1[3] # => 3\n```","summary":"<p>Copies <em>count</em> elements from <em>source</em> into <code>self</code>.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(source : Pointer(T), count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L202","def":{"name":"move_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"source.move_to(self, count)"}},{"id":"move_to(target:Pointer,count:Int)-instance-method","html_id":"move_to(target:Pointer,count:Int)-instance-method","name":"move_to","doc":"Copies *count* elements from `self` into *source*.\n*source* and `self` may overlap; the copy is always done in a non-destructive manner.\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 } # ptr1 -> [1, 2, 3, 4]\nptr2 = ptr1 + 1                        #             ^--------- ptr2\n\n# [1, 2, 3, 4]\n#  ^-----^       <- copy this\n#     ^------^   <- here\nptr1.move_to(ptr2, 3)\n\nptr1[0] # => 1\nptr1[1] # => 1\nptr1[2] # => 2\nptr1[3] # => 3\n```","summary":"<p>Copies <em>count</em> elements from <code>self</code> into <em>source</em>.</p>","abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(target : Pointer, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L232","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L232","def":{"name":"move_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target.move_from_impl(self, count)"}},{"id":"null?-instance-method","html_id":"null?-instance-method","name":"null?","doc":"Returns `true` if this pointer's address is zero.\n\n```\na = 1\npointerof(a).null? # => false\n\nb = Pointer(Int32).new(0)\nb.null? # => true\n```","summary":"<p>Returns <code>true</code> if this pointer's address is zero.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L66","def":{"name":"null?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"address == 0"}},{"id":"realloc(size:UInt64):self-instance-method","html_id":"realloc(size:UInt64):self-instance-method","name":"realloc","doc":"Tries to change the size of the allocation pointed to by this pointer to *size*,\nand returns that pointer.\n\nSince the space after the end of the block may be in use, realloc may find it\nnecessary to copy the block to a new address where more free space is available.\nThe value of realloc is the new address of the block.\nIf the block needs to be moved, realloc copies the old contents.\n\nRemember to always assign the value of realloc.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr = ptr.realloc(8_u8)\nptr # [1, 2, 3, 4, 0, 0, 0, 0]\n```","summary":"<p>Tries to change the size of the allocation pointed to by this pointer to <em>size</em>, and returns that pointer.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt64"}],"args_string":"(size : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L215","def":{"name":"realloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: pointer_realloc"}},{"id":"realloc(size:Int)-instance-method","html_id":"realloc(size:Int)-instance-method","name":"realloc","doc":"Tries to change the size of the allocation pointed to by this pointer to *size*,\nand returns that pointer.\n\nSince the space after the end of the block may be in use, realloc may find it\nnecessary to copy the block to a new address where more free space is available.\nThe value of realloc is the new address of the block.\nIf the block needs to be moved, realloc copies the old contents.\n\nRemember to always assign the value of realloc.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr = ptr.realloc(8)\nptr # [1, 2, 3, 4, 0, 0, 0, 0]\n```","summary":"<p>Tries to change the size of the allocation pointed to by this pointer to <em>size</em>, and returns that pointer.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"args_string":"(size : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L347","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L347","def":{"name":"realloc","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative size\"))\nend\nrealloc(size.to_u64)\n"}},{"id":"shuffle!(count:Int,random=Random::DEFAULT)-instance-method","html_id":"shuffle!(count:Int,random=Random::DEFAULT)-instance-method","name":"shuffle!","doc":"Shuffles *count* consecutive values pointed by this pointer.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr.shuffle!(4)\nptr # [3, 4, 1, 2]\n```","summary":"<p>Shuffles <em>count</em> consecutive values pointed by this pointer.</p>","abstract":false,"args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(count : Int, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L362","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L362","def":{"name":"shuffle!","args":[{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"},{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(count - 1).downto(1) do |i|\n  j = random.rand(i + 1)\n  swap(i, j)\nend\nself\n"}},{"id":"swap(i,j)-instance-method","html_id":"swap(i,j)-instance-method","name":"swap","doc":"Swaps the contents pointed at the offsets *i* and *j*.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 }\nptr[2] # => 3\nptr[3] # => 4\nptr.swap(2, 3)\nptr[2] # => 4\nptr[3] # => 3\n```","summary":"<p>Swaps the contents pointed at the offsets <em>i</em> and <em>j</em>.</p>","abstract":false,"args":[{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"j","doc":null,"default_value":"","external_name":"j","restriction":""}],"args_string":"(i, j)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L298","def":{"name":"swap","args":[{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"j","doc":null,"default_value":"","external_name":"j","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[i], self[j] = self[j], self[i]"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends a string representation of this pointer to the given `IO`,\nincluding its type and address in hexadecimal.\n\n```\nptr1 = Pointer(Int32).new(1234)\nptr1.to_s # => \"Pointer(Int32)@0x4d2\"\n\nptr2 = Pointer(Int32).new(0)\nptr2.to_s # => \"Pointer(Int32).null\"\n```","summary":"<p>Appends a string representation of this pointer to the given <code><a href=\"IO.html\">IO</a></code>, including its type and address in hexadecimal.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L320","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L320","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"Pointer(\"\nio << T.to_s\nio << ')'\nif address == 0\n  io << \".null\"\nelse\n  io << \"@0x\"\n  address.to_s(16, io)\nend\n"}},{"id":"to_slice(size)-instance-method","html_id":"to_slice(size)-instance-method","name":"to_slice","doc":"Returns a `Slice` that points to this pointer and is bounded by the given *size*.\n\n```\nptr = Pointer.malloc(6) { |i| i + 10 } # [10, 11, 12, 13, 14, 15]\nslice = ptr.to_slice(4)                # => Slice[10, 11, 12, 13]\nslice.class                            # => Slice(Int32)\n```","summary":"<p>Returns a <code><a href=\"Slice.html\">Slice</a></code> that points to this pointer and is bounded by the given <em>size</em>.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L490","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L490","def":{"name":"to_slice","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Slice.new(self, size)"}},{"id":"value:T-instance-method","html_id":"value:T-instance-method","name":"value","doc":"Gets the value pointed by this pointer.\n\n```\nptr = Pointer(Int32).malloc(4)\nptr.value = 42\nptr.value # => 42\n```","summary":"<p>Gets the value pointed by this pointer.</p>","abstract":false,"args":[],"args_string":" : T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L175","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"T","visibility":"Public","body":"# primitive: pointer_get"}},{"id":"value=(value:T)-instance-method","html_id":"value=(value:T)-instance-method","name":"value=","doc":"Sets the value pointed by this pointer.\n\n```\nptr = Pointer(Int32).malloc(4)\nptr.value = 42\nptr.value # => 42\n```","summary":"<p>Sets the value pointed by this pointer.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L186","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"# primitive: pointer_set"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Pointer/Appender","path":"Pointer/Appender.html","kind":"struct","full_name":"Pointer::Appender(T)","name":"Appender","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"pointer.cr","line_number":36,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},"doc":"Unsafe wrapper around a `Pointer` that allows to write values to\nit while advancing the location and keeping track of how many elements\nwere written.\n\nSee also: `Pointer#appender`.","summary":"<p>Unsafe wrapper around a <code><a href=\"../Pointer.html\">Pointer</a></code> that allows to write values to it while advancing the location and keeping track of how many elements were written.</p>","class_methods":[],"constructors":[{"id":"new(pointer:Pointer(T))-class-method","html_id":"new(pointer:Pointer(T))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"Pointer(T)"}],"args_string":"(pointer : Pointer(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L37","def":{"name":"new","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"Pointer(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Appender(T).allocate\n_.initialize(pointer)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"<<(value:T)-instance-method","html_id":"&lt;&lt;(value:T)-instance-method","name":"<<","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L41","def":{"name":"<<","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pointer.value = value\n@pointer = @pointer + 1\n"}},{"id":"pointer-instance-method","html_id":"pointer-instance-method","name":"pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L50","def":{"name":"pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pointer"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pointer.cr#L46","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pointer - @start"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/PrettyPrint","path":"PrettyPrint.html","kind":"class","full_name":"PrettyPrint","name":"PrettyPrint","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"pretty_print.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"This class implements a pretty printing algorithm.\nIt finds line breaks and nice indentations for grouped structure.\n\n### References\n\n* [Ruby's prettyprint.rb](https://github.com/ruby/ruby/blob/trunk/lib/prettyprint.rb)\n* [Christian Lindig, Strictly Pretty, March 2000](http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.34.2200)\n* [Philip Wadler, A prettier printer, March 1998](http://homepages.inf.ed.ac.uk/wadler/topics/language-design.html#prettier)","summary":"<p>This class implements a pretty printing algorithm.</p>","class_methods":[{"id":"format(obj,io:IO,width:Int32,newline=&quot;\\n&quot;,indent=0)-class-method","html_id":"format(obj,io:IO,width:Int32,newline=&amp;quot;\\n&amp;quot;,indent=0)-class-method","name":"format","doc":"Pretty prints *obj* into *io* with the given\n*width* as a limit and starting with\nthe given *indent*ation.","summary":"<p>Pretty prints <em>obj</em> into <em>io</em> with the given <em>width</em> as a limit and starting with the given <em>indent</em>ation.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"width","doc":null,"default_value":"","external_name":"width","restriction":"Int32"},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"args_string":"(obj, io : IO, width : Int32, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L291","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L291","def":{"name":"format","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"width","doc":null,"default_value":"","external_name":"width","restriction":"Int32"},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"format(io, width, newline, indent) do |printer|\n  obj.pretty_print(printer)\nend"}},{"id":"format(io:IO,width:Int32,newline=&quot;\\n&quot;,indent=0,&block)-class-method","html_id":"format(io:IO,width:Int32,newline=&amp;quot;\\n&amp;quot;,indent=0,&amp;block)-class-method","name":"format","doc":"Creates a pretty printer and yields it to the block,\nappending any output to the given *io*.","summary":"<p>Creates a pretty printer and yields it to the block, appending any output to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"width","doc":null,"default_value":"","external_name":"width","restriction":"Int32"},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"args_string":"(io : IO, width : Int32, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L299","def":{"name":"format","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"width","doc":null,"default_value":"","external_name":"width","restriction":"Int32"},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"printer = PrettyPrint.new(io, width, newline, indent)\nyield printer\nprinter.flush\nio\n"}}],"constructors":[{"id":"new(output:IO,maxwidth=79,newline=&quot;\\n&quot;,indent=0)-class-method","html_id":"new(output:IO,maxwidth=79,newline=&amp;quot;\\n&amp;quot;,indent=0)-class-method","name":"new","doc":"Creates a new pretty printer that will write to the given *output*\nand be capped at *maxwidth*.","summary":"<p>Creates a new pretty printer that will write to the given <em>output</em> and be capped at <em>maxwidth</em>.</p>","abstract":false,"args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"},{"name":"maxwidth","doc":null,"default_value":"79","external_name":"maxwidth","restriction":""},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"args_string":"(output : IO, maxwidth = <span class=\"n\">79</span>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L16","def":{"name":"new","args":[{"name":"output","doc":null,"default_value":"","external_name":"output","restriction":"IO"},{"name":"maxwidth","doc":null,"default_value":"79","external_name":"maxwidth","restriction":""},{"name":"newline","doc":null,"default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(output, maxwidth, newline, indent)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"breakable(sep=&quot;&quot;)-instance-method","html_id":"breakable(sep=&amp;quot;&amp;quot;)-instance-method","name":"breakable","doc":"Appends an element that can turn into a newline if necessary.","summary":"<p>Appends an element that can turn into a newline if necessary.</p>","abstract":false,"args":[{"name":"sep","doc":null,"default_value":"\" \"","external_name":"sep","restriction":""}],"args_string":"(sep = <span class=\"s\">&quot; &quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L87","def":{"name":"breakable","args":[{"name":"sep","doc":null,"default_value":"\" \"","external_name":"sep","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"width = sep.size\ngroup = @group_stack.last\nif group.break?\n  flush\n  @output << @newline\n  @indent.times do\n    @output << ' '\n  end\n  @output_width = @indent\n  @buffer_width = 0\nelse\n  @buffer << (Breakable.new(sep, width, self))\n  @buffer_width = @buffer_width + width\n  break_outmost_groups\nend\n"}},{"id":"comma-instance-method","html_id":"comma-instance-method","name":"comma","doc":"Same as:\n\n```\ntext \",\"\nbreakable\n```","summary":"<p>Same as:</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L152","def":{"name":"comma","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"text(\",\")\nbreakable\n"}},{"id":"fill_breakable(sep=&quot;&quot;)-instance-method","html_id":"fill_breakable(sep=&amp;quot;&amp;quot;)-instance-method","name":"fill_breakable","doc":"Similar to `#breakable` except\nthe decision to break or not is determined individually.","summary":"<p>Similar to <code><a href=\"PrettyPrint.html#breakable%28sep%3D%26quot%3B%26quot%3B%29-instance-method\">#breakable</a></code> except the decision to break or not is determined individually.</p>","abstract":false,"args":[{"name":"sep","doc":null,"default_value":"\" \"","external_name":"sep","restriction":""}],"args_string":"(sep = <span class=\"s\">&quot; &quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L105","def":{"name":"fill_breakable","args":[{"name":"sep","doc":null,"default_value":"\" \"","external_name":"sep","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"group do\n  breakable(sep)\nend"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Outputs any buffered data.","summary":"<p>Outputs any buffered data.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L188","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer.each do |data|\n  @output_width = data.output(@output, @output_width)\nend\n@buffer.clear\n@buffer_width = 0\n"}},{"id":"group(indent=0,open_obj=&quot;&quot;,close_obj=&quot;&quot;,&block)-instance-method","html_id":"group(indent=0,open_obj=&amp;quot;&amp;quot;,close_obj=&amp;quot;&amp;quot;,&amp;block)-instance-method","name":"group","doc":"Creates a group of objects. Inside a group all breakable\nobjects are either turned into newlines or are output\nas is, depending on the available width.","summary":"<p>Creates a group of objects.</p>","abstract":false,"args":[{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""},{"name":"open_obj","doc":null,"default_value":"\"\"","external_name":"open_obj","restriction":""},{"name":"close_obj","doc":null,"default_value":"\"\"","external_name":"close_obj","restriction":""}],"args_string":"(indent = <span class=\"n\">0</span>, open_obj = <span class=\"s\">&quot;&quot;</span>, close_obj = <span class=\"s\">&quot;&quot;</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L112","def":{"name":"group","args":[{"name":"indent","doc":null,"default_value":"0","external_name":"indent","restriction":""},{"name":"open_obj","doc":null,"default_value":"\"\"","external_name":"open_obj","restriction":""},{"name":"close_obj","doc":null,"default_value":"\"\"","external_name":"close_obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"text(open_obj)\ngroup_sub do\n  nest(indent) do\n    yield\n  end\nend\ntext(close_obj)\n"}},{"id":"list(left,elements,right,&block):Nil-instance-method","html_id":"list(left,elements,right,&amp;block):Nil-instance-method","name":"list","doc":"Appends a list of elements surrounded by *left* and *right*\nand separated by commas, yielding each element to the given block.","summary":"<p>Appends a list of elements surrounded by <em>left</em> and <em>right</em> and separated by commas, yielding each element to the given block.</p>","abstract":false,"args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""}],"args_string":"(left, elements, right, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L170","def":{"name":"list","args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"group(1, left, right) do\n  elements.each_with_index do |elem, i|\n    if i > 0\n      comma\n    end\n    yield elem\n  end\nend"}},{"id":"list(left,elements,right):Nil-instance-method","html_id":"list(left,elements,right):Nil-instance-method","name":"list","doc":"Appends a list of elements surrounded by *left* and *right*\nand separated by commas.","summary":"<p>Appends a list of elements surrounded by <em>left</em> and <em>right</em> and separated by commas.</p>","abstract":false,"args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""}],"args_string":"(left, elements, right) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L181","def":{"name":"list","args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"elements","doc":null,"default_value":"","external_name":"elements","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"list(left, elements, right) do |elem|\n  elem.pretty_print(self)\nend"}},{"id":"nest(indent=1,&block)-instance-method","html_id":"nest(indent=1,&amp;block)-instance-method","name":"nest","doc":"Increases the indentation for breakables inside the current group.","summary":"<p>Increases the indentation for breakables inside the current group.</p>","abstract":false,"args":[{"name":"indent","doc":null,"default_value":"1","external_name":"indent","restriction":""}],"args_string":"(indent = <span class=\"n\">1</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L137","def":{"name":"nest","args":[{"name":"indent","doc":null,"default_value":"1","external_name":"indent","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"@indent = @indent + indent\nbegin\n  yield\nensure\n  @indent = @indent - indent\nend\n"}},{"id":"surround(left,right,left_break=&quot;&quot;,right_break=&quot;&quot;,&block):Nil-instance-method","html_id":"surround(left,right,left_break=&amp;quot;&amp;quot;,right_break=&amp;quot;&amp;quot;,&amp;block):Nil-instance-method","name":"surround","doc":"Appends a group that is surrounded by the given *left* and *right*\nobjects, and optionally is surrounded by the given breakable\nobjects.","summary":"<p>Appends a group that is surrounded by the given <em>left</em> and <em>right</em> objects, and optionally is surrounded by the given breakable objects.</p>","abstract":false,"args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""},{"name":"left_break","doc":null,"default_value":"\"\"","external_name":"left_break","restriction":""},{"name":"right_break","doc":null,"default_value":"\"\"","external_name":"right_break","restriction":""}],"args_string":"(left, right, left_break = <span class=\"s\">&quot;&quot;</span>, right_break = <span class=\"s\">&quot;&quot;</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L160","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L160","def":{"name":"surround","args":[{"name":"left","doc":null,"default_value":"","external_name":"left","restriction":""},{"name":"right","doc":null,"default_value":"","external_name":"right","restriction":""},{"name":"left_break","doc":null,"default_value":"\"\"","external_name":"left_break","restriction":""},{"name":"right_break","doc":null,"default_value":"\"\"","external_name":"right_break","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"group(1, left, right) do\n  if left_break\n    breakable(left_break)\n  end\n  yield\n  if right_break\n    breakable(right_break)\n  end\nend"}},{"id":"text(obj)-instance-method","html_id":"text(obj)-instance-method","name":"text","doc":"Appends a text element.","summary":"<p>Appends a text element.</p>","abstract":false,"args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"args_string":"(obj)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/pretty_print.cr#L66","def":{"name":"text","args":[{"name":"obj","doc":null,"default_value":"","external_name":"obj","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"obj = obj.to_s\nwidth = obj.size\nif width == 0\n  return\nend\nif @buffer.empty?\n  @output << obj\n  @output_width = @output_width + width\nelse\n  text = @buffer.last\n  if text.is_a?(Text)\n  else\n    text = Text.new\n    @buffer << text\n  end\n  text.add(obj, width)\n  @buffer_width = @buffer_width + width\n  break_outmost_groups\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Proc","path":"Proc.html","kind":"struct","full_name":"Proc(*T, R)","name":"Proc","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"primitives.cr","line_number":246,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"proc.cr","line_number":100,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Proc` represents a function pointer with an optional context (the closure data).\nIt is typically created with a proc literal:\n\n```\n# A proc without arguments\n->{ 1 } # Proc(Int32)\n\n# A proc with one argument\n->(x : Int32) { x.to_s } # Proc(Int32, String)\n\n# A proc with two arguments:\n->(x : Int32, y : Int32) { x + y } # Proc(Int32, Int32, Int32)\n```\n\nThe types of the arguments (`T`) are mandatory, except when directly\nsending a proc literal to a lib fun in C bindings.\n\nThe return type (`R`) is inferred from the proc's body.\n\nA special new method is provided too:\n\n```\nProc(Int32, String).new { |x| x.to_s } # Proc(Int32, String)\n```\n\nThis form allows you to specify the return type and to check it\nagainst the proc's body.\n\nAnother way to create a `Proc` is by capturing a block:\n\n```\ndef capture(&block : Int32 -> Int32)\n  # block argument is used, so block is turned into a Proc\n  block\nend\n\nproc = capture { |x| x + 1 } # Proc(Int32, Int32)\nproc.call(1)                 # => 2\n```\n\nWhen capturing blocks, the type of the arguments and return type\nmust be specified in the capturing method block signature.\n\n### Passing a Proc to a C function\n\nPassing a `Proc` to a C function, for example as a callback, is possible\nas long as the `Proc` isn't a closure. If it is, either a compile-time or\nruntime error will happen depending on whether the compiler can check this.\nThe reason is that a `Proc` is internally represented as two void pointers,\none having the function pointer and another the closure data. If just\nthe function pointer is passed, the closure data will be missing at invocation time.\n\nMost of the time a C function that allows setting a callback also provide\nan argument for custom data. This custom data is then sent as an argument\nto the callback. For example, suppose a C function that invokes a callback\nat every tick, passing that tick:\n\n```\nlib LibTicker\n  fun on_tick(callback : (Int32, Void* ->), data : Void*)\nend\n```\n\nTo properly define a wrapper for this function we must send the `Proc` as the\ncallback data, and then convert that callback data to the `Proc` and finally invoke it.\n\n```\nmodule Ticker\n  # The callback for the user doesn't have a Void*\n  @@box : Pointer(Void)?\n\n  def self.on_tick(&callback : Int32 ->)\n    # Since Proc is a {Void*, Void*}, we can't turn that into a Void*, so we\n    # \"box\" it: we allocate memory and store the Proc there\n    boxed_data = Box.box(callback)\n\n    # We must save this in Crystal-land so the GC doesn't collect it (*)\n    @@box = boxed_data\n\n    # We pass a callback that doesn't form a closure, and pass the boxed_data as\n    # the callback data\n    LibTicker.on_tick(->(tick, data) {\n      # Now we turn data back into the Proc, using Box.unbox\n      data_as_callback = Box(typeof(callback)).unbox(data)\n      # And finally invoke the user's callback\n      data_as_callback.call(tick)\n    }, boxed_data)\n  end\nend\n\nTicker.on_tick do |tick|\n  puts tick\nend\n```\n\nNote that we save the box in `@@box`. The reason is that if we don't do it,\nand our code doesn't reference it anymore, the GC will collect it.\nThe C library will of course store the callback, but Crystal's GC has\nno way of knowing that.","summary":"<p>A <code><a href=\"Proc.html\">Proc</a></code> represents a function pointer with an optional context (the closure data).</p>","class_methods":[],"constructors":[{"id":"new(pointer:Pointer(Void),closure_data:Pointer(Void))-class-method","html_id":"new(pointer:Pointer(Void),closure_data:Pointer(Void))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"closure_data","doc":null,"default_value":"","external_name":"closure_data","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void), closure_data : Pointer(Void))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L101","def":{"name":"new","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"closure_data","doc":null,"default_value":"","external_name":"closure_data","restriction":"::Pointer(Void)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"func = {pointer, closure_data}\nptr = (pointerof(func)).as(::Pointer(self))\nptr.value\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L172","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(pointer == other.pointer) && (closure_data == other.closure_data)"}},{"id":"===(other:self)-instance-method","html_id":"===(other:self)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L176","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other"}},{"id":"===(other)-instance-method","html_id":"===(other)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L180","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"call(other)"}},{"id":"arity-instance-method","html_id":"arity-instance-method","name":"arity","doc":"Returns the number of arguments of this `Proc`.\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.arity # => 2\n\nneg = ->(x : Int32) { -x }\nneg.arity # => 1\n```","summary":"<p>Returns the number of arguments of this <code><a href=\"Proc.html\">Proc</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L150","def":{"name":"arity","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{{ T.size }}"}},{"id":"call(*args:*T):R-instance-method","html_id":"call(*args:*T):R-instance-method","name":"call","doc":"Invokes this `Proc` and returns the result.\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.call(1, 2) # => 3\n```","summary":"<p>Invokes this <code><a href=\"Proc.html\">Proc</a></code> and returns the result.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*T"}],"args_string":"(*args : *T) : R","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L255","def":{"name":"call","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*T"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"R","visibility":"Public","body":"# primitive: proc_call"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L189","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"closure?-instance-method","html_id":"closure?-instance-method","name":"closure?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L162","def":{"name":"closure?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!closure_data.null?"}},{"id":"closure_data-instance-method","html_id":"closure_data-instance-method","name":"closure_data","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L158","def":{"name":"closure_data","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"internal_representation[1]"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L185","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"internal_representation.hash(hasher)"}},{"id":"partial(*args:*U)forallU-instance-method","html_id":"partial(*args:*U)forallU-instance-method","name":"partial","doc":"Returns a new `Proc` that has its first arguments fixed to\nthe values given by *args*.\n\nSee [Wikipedia, Partial application](https://en.wikipedia.org/wiki/Partial_application)\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.call(1, 2) # => 3\n\nadd_one = add.partial(1)\nadd_one.call(2)  # => 3\nadd_one.call(10) # => 11\n\nadd_one_and_two = add_one.partial(2)\nadd_one_and_two.call # => 3\n```","summary":"<p>Returns a new <code><a href=\"Proc.html\">Proc</a></code> that has its first arguments fixed to the values given by <em>args</em>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*U"}],"args_string":"(*args : *U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L123","def":{"name":"partial","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*U"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      {% remaining = (T.size - U.size) %}\n      ->(\n          {% for i in 0...remaining %}\n            arg{{ i }} : {{ T[i + U.size] }},\n          {% end %}\n        ) {\n        call(\n          *args,\n          {% for i in 0...remaining %}\n            arg{{ i }},\n          {% end %}\n        )\n      }\n    {% end %}"}},{"id":"pointer-instance-method","html_id":"pointer-instance-method","name":"pointer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L154","def":{"name":"pointer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"internal_representation[0]"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/proc.cr#L193","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<\"\nio << ({{ @type.name.stringify }})\nio << \":0x\"\npointer.address.to_s(16, io)\nif closure?\n  io << \":closure\"\nend\nio << '>'\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Process","path":"Process.html","kind":"class","full_name":"Process","name":"Process","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"kernel.cr","line_number":459,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr"},{"filename":"process.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr"},{"filename":"process/executable_path.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr"},{"filename":"process/executable_path.cr","line_number":54,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"PATH_DELIMITER","name":"PATH_DELIMITER","value":"{% if flag?(:windows) %} ';' {% else %} ':' {% end %}","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"after_fork_child_callbacks-class-method","html_id":"after_fork_child_callbacks-class-method","name":"after_fork_child_callbacks","doc":"Hooks are defined here due to load order problems.","summary":"<p>Hooks are defined here due to load order problems.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L461","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/kernel.cr#L461","def":{"name":"after_fork_child_callbacks","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@after_fork_child_callbacks || (@@after_fork_child_callbacks = [->Scheduler.after_fork, ->Crystal::Signal.after_fork, ->Crystal::SignalChildHandler.after_fork, ->Random::DEFAULT.new_seed] of (-> Nil))"}},{"id":"chroot(path:String):Nil-class-method","html_id":"chroot(path:String):Nil-class-method","name":"chroot","doc":"Changes the root directory and the current working directory for the current\nprocess.\n\nSecurity: `chroot` on its own is not an effective means of mitigation. At minimum\nthe process needs to also drop privilages as soon as feasible after the `chroot`.\nChanges to the directory hierarchy or file descriptors passed via `recvmsg(2)` from\noutside the `chroot` jail may allow a restricted process to escape, even if it is\nunprivileged.\n\n```\nProcess.chroot(\"/var/empty\")\n```","summary":"<p>Changes the root directory and the current working directory for the current process.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L430","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L430","def":{"name":"chroot","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"path.check_no_null_byte\nif (LibC.chroot(path)) != 0\n  raise(Errno.new(\"Failed to chroot\"))\nend\nif (LibC.chdir(\"/\")) != 0\n  errno = Errno.new(\"chdir after chroot failed\")\n  errno.callstack = CallStack.new\n  errno.inspect_with_backtrace(STDERR)\n  abort(\"Unresolvable state, exiting...\")\nend\n"}},{"id":"exec(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Inherit,output:Stdio=Redirect::Inherit,error:Stdio=Redirect::Inherit,chdir:String?=nil)-class-method","html_id":"exec(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Inherit,output:Stdio=Redirect::Inherit,error:Stdio=Redirect::Inherit,chdir:String?=nil)-class-method","name":"exec","doc":"Replaces the current process with a new one.\n\nThe possible values for *input*, *output* and *error* are:\n* `false`: no `IO` (`/dev/null`)\n* `true`: inherit from parent\n* `IO`: use the given `IO`","summary":"<p>Replaces the current process with a new one.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Inherit","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Inherit","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Inherit","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = <span class=\"n\">nil</span>, env : Env = <span class=\"n\">nil</span>, clear_env : Bool = <span class=\"n\">false</span>, shell : Bool = <span class=\"n\">false</span>, input : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, output : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, error : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, chdir : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L183","def":{"name":"exec","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Inherit","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Inherit","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Inherit","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"command, argv = prepare_argv(command, args, shell)\nexec_internal(command, argv, env, clear_env, input, output, error, chdir)\n"}},{"id":"executable_path-class-method","html_id":"executable_path-class-method","name":"executable_path","doc":"Returns an absolute path to the executable file of the currently running\nprogram. This is in opposition to `PROGRAM_NAME` which may be a relative or\nabsolute path, just the executable file name or a symlink.\n\nThe executable path will be canonicalized (all symlinks and relative paths\nwill be expanded).\n\nReturns `nil` if the file can't be found.","summary":"<p>Returns an absolute path to the executable file of the currently running program.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr#L22","def":{"name":"executable_path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if executable = executable_path_impl\n  begin\n    File.real_path(executable)\n  rescue Errno\n  end\nend"}},{"id":"exists?(pid:Int)-class-method","html_id":"exists?(pid:Int)-class-method","name":"exists?","doc":"Returns `true` if the process identified by *pid* is valid for\na currently registered process, `false` otherwise. Note that this\nreturns `true` for a process in the zombie or similar state.","summary":"<p>Returns <code>true</code> if the process identified by <em>pid</em> is valid for a currently registered process, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"pid","doc":null,"default_value":"","external_name":"pid","restriction":"Int"}],"args_string":"(pid : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L50","def":{"name":"exists?","args":[{"name":"pid","doc":null,"default_value":"","external_name":"pid","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ret = LibC.kill(pid, 0)\nif ret == 0\n  true\nelse\n  if Errno.value == Errno::ESRCH\n    return false\n  end\n  raise(Errno.new(\"kill\"))\nend\n"}},{"id":"exit(status=0)-class-method","html_id":"exit(status=0)-class-method","name":"exit","doc":"Terminate the current process immediately. All open files, pipes and sockets\nare flushed and closed, all child processes are inherited by PID 1. This does\nnot run any handlers registered with `at_exit`, use `::exit` for that.\n\n*status* is the exit status of the current process.","summary":"<p>Terminate the current process immediately.</p>","abstract":false,"args":[{"name":"status","doc":null,"default_value":"0","external_name":"status","restriction":""}],"args_string":"(status = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L12","def":{"name":"exit","args":[{"name":"status","doc":null,"default_value":"0","external_name":"status","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibC.exit(status)"}},{"id":"find_executable(name,path=ENV[&quot;PATH&quot;]?,pwd=Dir.current)-class-method","html_id":"find_executable(name,path=ENV[&amp;quot;PATH&amp;quot;]?,pwd=Dir.current)-class-method","name":"find_executable","doc":"Searches an executable, checking for an absolute path, a path relative to\n*pwd* or absolute path, then eventually searching in directories declared\nin *path*.","summary":"<p>Searches an executable, checking for an absolute path, a path relative to <em>pwd</em> or absolute path, then eventually searching in directories declared in <em>path</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"path","doc":null,"default_value":"ENV[\"PATH\"]?","external_name":"path","restriction":""},{"name":"pwd","doc":null,"default_value":"Dir.current","external_name":"pwd","restriction":""}],"args_string":"(name, path = <span class=\"t\">ENV</span>[<span class=\"s\">&quot;PATH&quot;</span>]?, pwd = <span class=\"t\">Dir</span>.current)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/executable_path.cr#L34","def":{"name":"find_executable","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"path","doc":null,"default_value":"ENV[\"PATH\"]?","external_name":"path","restriction":""},{"name":"pwd","doc":null,"default_value":"Dir.current","external_name":"pwd","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if name.starts_with?(File::SEPARATOR)\n  return name\nend\nif name.includes?(File::SEPARATOR)\n  return File.expand_path(name, pwd)\nend\nif path\nelse\n  return\nend\n(path.split(PATH_DELIMITER)).each do |path|\n  executable = File.join(path, name)\n  if File.exists?(executable)\n    return executable\n  end\nend\nnil\n"}},{"id":"fork(&block)-class-method","html_id":"fork(&amp;block)-class-method","name":"fork","doc":"Runs the given block inside a new process and\nreturns a `Process` representing the new child process.","summary":"<p>Runs the given block inside a new process and returns a <code><a href=\"Process.html\">Process</a></code> representing the new child process.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L79","def":{"name":"fork","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"pid = fork_internal do\n  with self yield self\nend\nnew(pid)\n"}},{"id":"kill(signal:Signal,*pids:Int)-class-method","html_id":"kill(signal:Signal,*pids:Int)-class-method","name":"kill","doc":"Sends a *signal* to the processes identified by the given *pids*.","summary":"<p>Sends a <em>signal</em> to the processes identified by the given <em>pids</em>.</p>","abstract":false,"args":[{"name":"signal","doc":null,"default_value":"","external_name":"signal","restriction":"Signal"},{"name":"pids","doc":null,"default_value":"","external_name":"pids","restriction":"Int"}],"args_string":"(signal : Signal, *pids : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L39","def":{"name":"kill","args":[{"name":"signal","doc":null,"default_value":"","external_name":"signal","restriction":"Signal"},{"name":"pids","doc":null,"default_value":"","external_name":"pids","restriction":"Int"}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pids.each do |pid|\n  ret = LibC.kill(pid, signal.value)\n  if ret < 0\n    raise(Errno.new(\"kill\"))\n  end\nend\nnil\n"}},{"id":"pgid:LibC::PidT-class-method","html_id":"pgid:LibC::PidT-class-method","name":"pgid","doc":"Returns the process group identifier of the current process.","summary":"<p>Returns the process group identifier of the current process.</p>","abstract":false,"args":[],"args_string":" : LibC::PidT","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L22","def":{"name":"pgid","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::PidT","visibility":"Public","body":"pgid(0)"}},{"id":"pgid(pid:Int32):LibC::PidT-class-method","html_id":"pgid(pid:Int32):LibC::PidT-class-method","name":"pgid","doc":"Returns the process group identifier of the process identified by *pid*.","summary":"<p>Returns the process group identifier of the process identified by <em>pid</em>.</p>","abstract":false,"args":[{"name":"pid","doc":null,"default_value":"","external_name":"pid","restriction":"Int32"}],"args_string":"(pid : Int32) : LibC::PidT","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L27","def":{"name":"pgid","args":[{"name":"pid","doc":null,"default_value":"","external_name":"pid","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::PidT","visibility":"Public","body":"ret = LibC.getpgid(pid)\nif ret < 0\n  raise(Errno.new(\"getpgid\"))\nend\nret\n"}},{"id":"pid:LibC::PidT-class-method","html_id":"pid:LibC::PidT-class-method","name":"pid","doc":"Returns the process identifier of the current process.","summary":"<p>Returns the process identifier of the current process.</p>","abstract":false,"args":[],"args_string":" : LibC::PidT","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L17","def":{"name":"pid","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::PidT","visibility":"Public","body":"LibC.getpid"}},{"id":"ppid:LibC::PidT-class-method","html_id":"ppid:LibC::PidT-class-method","name":"ppid","doc":"Returns the process identifier of the parent process of the current process.","summary":"<p>Returns the process identifier of the parent process of the current process.</p>","abstract":false,"args":[],"args_string":" : LibC::PidT","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L34","def":{"name":"ppid","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"LibC::PidT","visibility":"Public","body":"LibC.getppid"}},{"id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil):Process::Status-class-method","html_id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil):Process::Status-class-method","name":"run","doc":"Executes a process and waits for it to complete.\n\nBy default the process is configured without input, output or error.","summary":"<p>Executes a process and waits for it to complete.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = <span class=\"n\">nil</span>, env : Env = <span class=\"n\">nil</span>, clear_env : Bool = <span class=\"n\">false</span>, shell : Bool = <span class=\"n\">false</span>, input : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, output : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, error : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, chdir : String? = <span class=\"n\">nil</span>) : Process::Status","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L151","def":{"name":"run","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Process::Status","visibility":"Public","body":"status = (new(command, args, env, clear_env, shell, input, output, error, chdir)).wait\n$? = status\nstatus\n"}},{"id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Pipe,output:Stdio=Redirect::Pipe,error:Stdio=Redirect::Pipe,chdir:String?=nil,&block)-class-method","html_id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Pipe,output:Stdio=Redirect::Pipe,error:Stdio=Redirect::Pipe,chdir:String?=nil,&amp;block)-class-method","name":"run","doc":"Executes a process, yields the block, and then waits for it to finish.\n\nBy default the process is configured to use pipes for input, output and error. These\nwill be closed automatically at the end of the block.\n\nReturns the block's value.","summary":"<p>Executes a process, yields the block, and then waits for it to finish.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Pipe","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Pipe","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Pipe","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = <span class=\"n\">nil</span>, env : Env = <span class=\"n\">nil</span>, clear_env : Bool = <span class=\"n\">false</span>, shell : Bool = <span class=\"n\">false</span>, input : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, output : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, error : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, chdir : String? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L164","def":{"name":"run","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Pipe","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Pipe","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Pipe","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"process = new(command, args, env, clear_env, shell, input, output, error, chdir)\nbegin\n  value = yield process\n  $? = process.wait\n  value\nrescue ex\n  process.kill\n  raise(ex)\nend\n"}},{"id":"times:Tms-class-method","html_id":"times:Tms-class-method","name":"times","doc":"Returns a `Tms` for the current process. For the children times, only those\nof terminated children are returned.","summary":"<p>Returns a <code><a href=\"Process/Tms.html\">Tms</a></code> for the current process.</p>","abstract":false,"args":[],"args_string":" : Tms","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L71","def":{"name":"times","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Tms","visibility":"Public","body":"hertz = (LibC.sysconf(LibC::SC_CLK_TCK)).to_f\nLibC.times(out tms)\nTms.new(tms.tms_utime / hertz, tms.tms_stime / hertz, tms.tms_cutime / hertz, tms.tms_cstime / hertz)\n"}}],"constructors":[{"id":"fork:self?-class-method","html_id":"fork:self?-class-method","name":"fork","doc":"Duplicates the current process.\nReturns a `Process` representing the new child process in the current process\nand `nil` inside the new child process.","summary":"<p>Duplicates the current process.</p>","abstract":false,"args":[],"args_string":" : self?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L89","def":{"name":"fork","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self | ::Nil","visibility":"Public","body":"if pid = fork_internal\n  new(pid)\nelse\n  nil\nend"}},{"id":"new(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil)-class-method","html_id":"new(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil)-class-method","name":"new","doc":"Creates a process, executes it, but doesn't wait for it to complete.\n\nTo wait for it to finish, invoke `wait`.\n\nBy default the process is configured without input, output or error.","summary":"<p>Creates a process, executes it, but doesn't wait for it to complete.</p>","abstract":false,"args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = <span class=\"n\">nil</span>, env : Env = <span class=\"n\">nil</span>, clear_env : Bool = <span class=\"n\">false</span>, shell : Bool = <span class=\"n\">false</span>, input : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, output : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, error : Stdio = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, chdir : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L207","def":{"name":"new","args":[{"name":"command","doc":null,"default_value":"","external_name":"command","restriction":"String"},{"name":"args","doc":null,"default_value":"nil","external_name":"args","restriction":""},{"name":"env","doc":null,"default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","doc":null,"default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","doc":null,"default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","doc":null,"default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","doc":null,"default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","doc":null,"default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","doc":null,"default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(command, args, env, clear_env, shell, input, output, error, chdir)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes any pipes to the child process.","summary":"<p>Closes any pipes to the child process.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L306","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"close_io(@input)\nclose_io(@output)\nclose_io(@error)\n"}},{"id":"error-instance-method","html_id":"error-instance-method","name":"error","doc":"A pipe to this process's error. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's error.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L198","def":{"name":"error","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@error.not_nil!"}},{"id":"error?:IO::FileDescriptor?-instance-method","html_id":"error?:IO::FileDescriptor?-instance-method","name":"error?","doc":"A pipe to this process's error. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's error.</p>","abstract":false,"args":[],"args_string":" : IO::FileDescriptor?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L198","def":{"name":"error?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@error"}},{"id":"exists?-instance-method","html_id":"exists?-instance-method","name":"exists?","doc":"Whether the process is still registered in the system.\nNote that this returns `true` for processes in the zombie or similar state.","summary":"<p>Whether the process is still registered in the system.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L296","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L296","def":{"name":"exists?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!terminated?"}},{"id":"input-instance-method","html_id":"input-instance-method","name":"input","doc":"A pipe to this process's input. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's input.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L192","def":{"name":"input","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@input.not_nil!"}},{"id":"input?:IO::FileDescriptor?-instance-method","html_id":"input?:IO::FileDescriptor?-instance-method","name":"input?","doc":"A pipe to this process's input. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's input.</p>","abstract":false,"args":[],"args_string":" : IO::FileDescriptor?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L192","def":{"name":"input?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@input"}},{"id":"kill(sig=Signal::TERM)-instance-method","html_id":"kill(sig=Signal::TERM)-instance-method","name":"kill","doc":"See also: `Process.kill`","summary":"<p>See also: <code><a href=\"Process.html#kill%28signal%3ASignal%2C%2Apids%3AInt%29-class-method\">Process.kill</a></code></p>","abstract":false,"args":[{"name":"sig","doc":null,"default_value":"Signal::TERM","external_name":"sig","restriction":""}],"args_string":"(sig = <span class=\"t\">Signal</span><span class=\"t\">::</span><span class=\"t\">TERM</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L275","def":{"name":"kill","args":[{"name":"sig","doc":null,"default_value":"Signal::TERM","external_name":"sig","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Process.kill(sig, @pid)"}},{"id":"output-instance-method","html_id":"output-instance-method","name":"output","doc":"A pipe to this process's output. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's output.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L195","def":{"name":"output","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@output.not_nil!"}},{"id":"output?:IO::FileDescriptor?-instance-method","html_id":"output?:IO::FileDescriptor?-instance-method","name":"output?","doc":"A pipe to this process's output. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process's output.</p>","abstract":false,"args":[],"args_string":" : IO::FileDescriptor?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L195","def":{"name":"output?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@output"}},{"id":"pid:Int32-instance-method","html_id":"pid:Int32-instance-method","name":"pid","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L189","def":{"name":"pid","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@pid"}},{"id":"terminated?-instance-method","html_id":"terminated?-instance-method","name":"terminated?","doc":"Whether this process is already terminated.","summary":"<p>Whether this process is already terminated.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L301","def":{"name":"terminated?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@waitpid.closed? || (!(Process.exists?(@pid)))"}},{"id":"wait:Process::Status-instance-method","html_id":"wait:Process::Status-instance-method","name":"wait","doc":"Waits for this process to complete and closes any pipes.","summary":"<p>Waits for this process to complete and closes any pipes.</p>","abstract":false,"args":[],"args_string":" : Process::Status","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L280","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L280","def":{"name":"wait","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Process::Status","visibility":"Public","body":"begin\n  close_io(@input)\n  @wait_count.times do\n    ex = channel.receive\n    if ex\n      raise(ex)\n    end\n  end\n  @wait_count = 0\n  Process::Status.new(@waitpid.receive)\nensure\n  close\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Process/Env","path":"Process/Env.html","kind":"alias","full_name":"Process::Env","name":"Env","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"process.cr","line_number":146,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Hash(String, Nil) | Hash(String, String | Nil) | Hash(String, String) | Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Process/Redirect","path":"Process/Redirect.html","kind":"enum","full_name":"Process::Redirect","name":"Redirect","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"process.cr","line_number":132,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Pipe","name":"Pipe","value":"0","doc":"Pipe the IO so the parent process can read (or write) to the process IO\nthrought `#input`, `#output` or `#error`.","summary":"<p>Pipe the IO so the parent process can read (or write) to the process IO throught <code>#input</code>, <code>#output</code> or <code>#error</code>.</p>"},{"id":"Close","name":"Close","value":"1","doc":"Discards the IO.","summary":"<p>Discards the IO.</p>"},{"id":"Inherit","name":"Inherit","value":"2","doc":"Use the IO of the parent process.","summary":"<p>Use the IO of the parent process.</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"How to redirect the standard input, output and error IO of a process.","summary":"<p>How to redirect the standard input, output and error IO of a process.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"close?-instance-method","html_id":"close?-instance-method","name":"close?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L138","def":{"name":"close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Close"}},{"id":"inherit?-instance-method","html_id":"inherit?-instance-method","name":"inherit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L141","def":{"name":"inherit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Inherit"}},{"id":"pipe?-instance-method","html_id":"pipe?-instance-method","name":"pipe?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L135","def":{"name":"pipe?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Pipe"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Process/Status","path":"Process/Status.html","kind":"class","full_name":"Process::Status","name":"Status","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"process/status.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"The status of a terminated process.","summary":"<p>The status of a terminated process.</p>","class_methods":[],"constructors":[{"id":"new(exit_status:Int32)-class-method","html_id":"new(exit_status:Int32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"exit_status","doc":null,"default_value":"","external_name":"exit_status","restriction":"Int32"}],"args_string":"(exit_status : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L5","def":{"name":"new","args":[{"name":"exit_status","doc":null,"default_value":"","external_name":"exit_status","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(exit_status)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"exit_code-instance-method","html_id":"exit_code-instance-method","name":"exit_code","doc":"If `normal_exit?` is `true`, returns the exit code of the process.","summary":"<p>If <code><a href=\"../Process/Status.html#normal_exit%3F-instance-method\">#normal_exit?</a></code> is <code>true</code>, returns the exit code of the process.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L27","def":{"name":"exit_code","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@exit_status & 65280) >> 8"}},{"id":"exit_signal-instance-method","html_id":"exit_signal-instance-method","name":"exit_signal","doc":"If `signal_exit?` is `true`, returns the *Signal* the process\nreceived and didn't handle. Will raise if `signal_exit?` is `false`.","summary":"<p>If <code><a href=\"../Process/Status.html#signal_exit%3F-instance-method\">#signal_exit?</a></code> is <code>true</code>, returns the <em>Signal</em> the process received and didn't handle.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L22","def":{"name":"exit_signal","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Signal.from_value(signal_code)"}},{"id":"exit_status:Int32-instance-method","html_id":"exit_status:Int32-instance-method","name":"exit_status","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L3","def":{"name":"exit_status","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@exit_status"}},{"id":"normal_exit?-instance-method","html_id":"normal_exit?-instance-method","name":"normal_exit?","doc":"Returns `true` if the process terminated normally.","summary":"<p>Returns <code>true</code> if the process terminated normally.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L15","def":{"name":"normal_exit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"signal_code == 0"}},{"id":"signal_exit?-instance-method","html_id":"signal_exit?-instance-method","name":"signal_exit?","doc":"Returns `true` if the process was terminated by a signal.","summary":"<p>Returns <code>true</code> if the process was terminated by a signal.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L9","def":{"name":"signal_exit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(((LibC::SChar.new(@exit_status & 127)) + 1) >> 1) > 0"}},{"id":"success?-instance-method","html_id":"success?-instance-method","name":"success?","doc":"Returns `true` if the process exited normally with an exit code of `0`.","summary":"<p>Returns <code>true</code> if the process exited normally with an exit code of <code>0</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process/status.cr#L33","def":{"name":"success?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"normal_exit? && (exit_code == 0)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Process/Stdio","path":"Process/Stdio.html","kind":"alias","full_name":"Process::Stdio","name":"Stdio","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"process.cr","line_number":145,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(IO | Process::Redirect)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"The standard `IO` configuration of a process.","summary":"<p>The standard <code><a href=\"../IO.html\">IO</a></code> configuration of a process.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Process/Tms","path":"Process/Tms.html","kind":"struct","full_name":"Process::Tms","name":"Tms","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"process.cr","line_number":67,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"A struct representing the CPU current times of the process,\nin fractions of seconds.\n\n* *utime*: CPU time a process spent in userland.\n* *stime*: CPU time a process spent in the kernel.\n* *cutime*: CPU time a processes terminated children (and their terminated children) spent in the userland.\n* *cstime*: CPU time a processes terminated children (and their terminated children) spent in the kernel.","summary":"<p>A struct representing the CPU current times of the process, in fractions of seconds.</p>","class_methods":[],"constructors":[{"id":"new(utime:Float64,stime:Float64,cutime:Float64,cstime:Float64)-class-method","html_id":"new(utime:Float64,stime:Float64,cutime:Float64,cstime:Float64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"utime","doc":null,"default_value":"","external_name":"utime","restriction":"Float64"},{"name":"stime","doc":null,"default_value":"","external_name":"stime","restriction":"Float64"},{"name":"cutime","doc":null,"default_value":"","external_name":"cutime","restriction":"Float64"},{"name":"cstime","doc":null,"default_value":"","external_name":"cstime","restriction":"Float64"}],"args_string":"(utime : Float64, stime : Float64, cutime : Float64, cstime : Float64)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","def":{"name":"new","args":[{"name":"utime","doc":null,"default_value":"","external_name":"utime","restriction":"Float64"},{"name":"stime","doc":null,"default_value":"","external_name":"stime","restriction":"Float64"},{"name":"cutime","doc":null,"default_value":"","external_name":"cutime","restriction":"Float64"},{"name":"cstime","doc":null,"default_value":"","external_name":"cstime","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(utime, stime, cutime, cstime)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Tms.new(@utime.clone, @stime.clone, @cutime.clone, @cstime.clone)"}},{"id":"copy_with(utime_utime=@utime,stime_stime=@stime,cutime_cutime=@cutime,cstime_cstime=@cstime)-instance-method","html_id":"copy_with(utime_utime=@utime,stime_stime=@stime,cutime_cutime=@cutime,cstime_cstime=@cstime)-instance-method","name":"copy_with","doc":null,"summary":null,"abstract":false,"args":[{"name":"_utime","doc":null,"default_value":"@utime","external_name":"utime","restriction":""},{"name":"_stime","doc":null,"default_value":"@stime","external_name":"stime","restriction":""},{"name":"_cutime","doc":null,"default_value":"@cutime","external_name":"cutime","restriction":""},{"name":"_cstime","doc":null,"default_value":"@cstime","external_name":"cstime","restriction":""}],"args_string":"(utime _utime = @utime, stime _stime = @stime, cutime _cutime = @cutime, cstime _cstime = @cstime)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/process.cr#L67","def":{"name":"copy_with","args":[{"name":"_utime","doc":null,"default_value":"@utime","external_name":"utime","restriction":""},{"name":"_stime","doc":null,"default_value":"@stime","external_name":"stime","restriction":""},{"name":"_cutime","doc":null,"default_value":"@cutime","external_name":"cutime","restriction":""},{"name":"_cstime","doc":null,"default_value":"@cstime","external_name":"cstime","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Tms.new(_utime, _stime, _cutime, _cstime)"}},{"id":"cstime:Float64-instance-method","html_id":"cstime:Float64-instance-method","name":"cstime","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":null,"source_link":null,"def":{"name":"cstime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@cstime"}},{"id":"cutime:Float64-instance-method","html_id":"cutime:Float64-instance-method","name":"cutime","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":null,"source_link":null,"def":{"name":"cutime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@cutime"}},{"id":"stime:Float64-instance-method","html_id":"stime:Float64-instance-method","name":"stime","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":null,"source_link":null,"def":{"name":"stime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@stime"}},{"id":"utime:Float64-instance-method","html_id":"utime:Float64-instance-method","name":"utime","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Float64","source_link":null,"source_link":null,"def":{"name":"utime","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@utime"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Random","path":"Random.html","kind":"module","full_name":"Random","name":"Random","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"random/secure.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr"},{"filename":"random.cr","line_number":52,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DEFAULT","name":"DEFAULT","value":"PCG32.new","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Random/ISAAC","kind":"class","full_name":"Random::ISAAC","name":"ISAAC"},{"html_id":"github.com/crystal-lang/crystal/Random/PCG32","kind":"class","full_name":"Random::PCG32","name":"PCG32"}],"namespace":null,"doc":"`Random` provides an interface for random values generation, using a pseudo random number generator (PRNG).\n\n```\nRandom.rand    # => 0.167595\nRandom.rand(5) # => 2\n```\n\nThe above methods delegate to a `Random` instance.\n\n```\nr = Random.new\nr.rand      # => 0.0372991\nr.next_bool # => true\nr.next_int  # => 2223112\n```\n\nThis module also defines a global method `#rand`, which `Array#sample` and `Array#shuffle` delegates.\n\n```\nrand     # => 0.293829\nrand(10) # => 8\n```\n\nAn instance of each class that includes `Random` is a random number generator with its own state.\nUsually such RNGs can be initialized with a seed, which defines their initial state. It is\nguaranteed that after initializing two different instances with the same seed, and then executing\nthe same calls on both of them, you will get the same results. This allows exactly reproducing the\nsame seemingly random events by just keeping the seed.\n\nIt is possible to make a custom RNG by including `Random` and implementing `next_u` to return an\nunsigned number of a pre-determined type (usually `UInt32`). The numbers generated by your RNG\nmust be uniformly distributed in the whole range of possible values for that type (e.g.\n`0u32..UInt32::MAX`). This allows all other methods of `Random` to be based on this and still\nproduce uniformly distributed results. Your `Random` class should also have a way to initialize\nit. For pseudo-random number generators that will usually be an integer seed, but there are no\nrigid requirements for the initialization.\n\nThe default PRNG is `Random::PCG32` which has a good overall statistical\ndistribution (low bias of generated numbers) and is fast for overall usages on\ndifferent platforms, but isn't cryptographically secure. If a third party has\naccess to some generated numbers, she may deduce incoming numbers, putting\nyour application at risk.\n\nIt is recommended to use a secure source, such as `Random::Secure`,\n`Random::ISAAC` or ChaCha20 for anything that needs security, such as online\ngames, identification tokens, salts, initializing a PRNG, ... These PRNG are\nslower but cryptographically secure, so a third party can't deduce incoming\nnumbers.","summary":"<p><code><a href=\"Random.html\">Random</a></code> provides an interface for random values generation, using a pseudo random number generator (PRNG).</p>","class_methods":[{"id":"rand(x)-class-method","html_id":"rand(x)-class-method","name":"rand","doc":"See `#rand(x)`.","summary":"<p>See <code><a href=\"Random.html#rand%28max%3AInt%29%3AInt-instance-method\">#rand(x)</a></code>.</p>","abstract":false,"args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""}],"args_string":"(x)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L381","def":{"name":"rand","args":[{"name":"x","doc":null,"default_value":"","external_name":"x","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"DEFAULT.rand(x)"}},{"id":"rand:Float64-class-method","html_id":"rand:Float64-class-method","name":"rand","doc":"See `#rand`.","summary":"<p>See <code><a href=\"Random.html#rand%3AFloat64-instance-method\">#rand</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L376","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L376","def":{"name":"rand","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"DEFAULT.rand"}}],"constructors":[{"id":"new(seed,sequence=0_u64)-class-method","html_id":"new(seed,sequence=0_u64)-class-method","name":"new","doc":"Initializes an instance with the given *seed* and *sequence*.","summary":"<p>Initializes an instance with the given <em>seed</em> and <em>sequence</em>.</p>","abstract":false,"args":[{"name":"seed","doc":null,"default_value":"","external_name":"seed","restriction":""},{"name":"sequence","doc":null,"default_value":"0_u64","external_name":"sequence","restriction":""}],"args_string":"(seed, sequence = <span class=\"n\">0_u64</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L56","def":{"name":"new","args":[{"name":"seed","doc":null,"default_value":"","external_name":"seed","restriction":""},{"name":"sequence","doc":null,"default_value":"0_u64","external_name":"sequence","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"PCG32.new(seed.to_u64, sequence)"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Initializes an instance seeded from a system source.","summary":"<p>Initializes an instance seeded from a system source.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L61","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"PCG32.new"}}],"instance_methods":[{"id":"base64(n:Int=16):String-instance-method","html_id":"base64(n:Int=16):String-instance-method","name":"base64","doc":"Generates *n* random bytes that are encoded into base64.\n\nCheck `Base64#strict_encode` for details.\n\n```\nRandom::Secure.base64(4) # => \"fK1eYg==\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>Generates <em>n</em> random bytes that are encoded into base64.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = <span class=\"n\">16</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L339","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L339","def":{"name":"base64","args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Base64.strict_encode(random_bytes(n))"}},{"id":"hex(n:Int=16):String-instance-method","html_id":"hex(n:Int=16):String-instance-method","name":"hex","doc":"Generates a hexadecimal string based on *n* random bytes.\n\nThe bytes are encoded into a string of two-digit hexadecimal\nnumber (00-ff) per byte.\n\n```\nRandom::Secure.hex    # => \"05f100a1123f6bdbb427698ab664ff5f\"\nRandom::Secure.hex(1) # => \"1a\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>Generates a hexadecimal string based on <em>n</em> random bytes.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = <span class=\"n\">16</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L371","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L371","def":{"name":"hex","args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"(random_bytes(n)).hexstring"}},{"id":"next_bool:Bool-instance-method","html_id":"next_bool:Bool-instance-method","name":"next_bool","doc":"Generates a random `Bool`.\n\n```\nRandom.new.next_bool # => true\n```","summary":"<p>Generates a random <code><a href=\"Bool.html\">Bool</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L76","def":{"name":"next_bool","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"next_u.odd?"}},{"id":"next_float:Float64-instance-method","html_id":"next_float:Float64-instance-method","name":"next_float","doc":"See `#rand`.","summary":"<p>See <code><a href=\"Random.html#rand%3AFloat64-instance-method\">#rand</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L86","def":{"name":"next_float","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"max_prec = 1_u64 << 53\n(rand(max_prec)) / (max_prec - 1).to_f64\n"}},{"id":"next_int:Int32-instance-method","html_id":"next_int:Int32-instance-method","name":"next_int","doc":"Same as `rand(Int32::MIN..Int32::MAX)`.","summary":"<p>Same as <code><a href=\"Random.html#rand%28max%3AInt%29%3AInt-instance-method\">#rand(Int32::MIN..Int32::MAX)</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L81","def":{"name":"next_int","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"rand_type(Int32)"}},{"id":"next_u:UInt-instance-method","html_id":"next_u:UInt-instance-method","name":"next_u","doc":"Generates a random unsigned integer.\n\nThe integers must be uniformly distributed between `0` and\nthe maximal value for the chosen type.","summary":"<p>Generates a random unsigned integer.</p>","abstract":true,"args":[],"args_string":" : UInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L69","def":{"name":"next_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt","visibility":"Public","body":""}},{"id":"rand(max:Int):Int-instance-method","html_id":"rand(max:Int):Int-instance-method","name":"rand","doc":"Generates a random integer which is greater than or equal to `0`\nand less than *max*.\n\nThe return type always matches the supplied argument.\n\n```\nRandom.new.rand(10)   # => 5\nRandom.new.rand(5000) # => 2243\n```","summary":"<p>Generates a random integer which is greater than or equal to <code>0</code> and less than <em>max</em>.</p>","abstract":false,"args":[{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":"Int"}],"args_string":"(max : Int) : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L111","def":{"name":"rand","args":[{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"rand_int(max)"}},{"id":"rand(max:Float):Float64-instance-method","html_id":"rand(max:Float):Float64-instance-method","name":"rand","doc":"Returns a random `Float64` which is greater than or equal to `0`\nand less than *max*.\n\n```\nRandom.new.rand(3.5)    # => 2.88938\nRandom.new.rand(10.725) # => 7.70147\n```","summary":"<p>Returns a random <code><a href=\"Float64.html\">Float64</a></code> which is greater than or equal to <code>0</code> and less than <em>max</em>.</p>","abstract":false,"args":[{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":"Float"}],"args_string":"(max : Float) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L256","def":{"name":"rand","args":[{"name":"max","doc":null,"default_value":"","external_name":"max","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"if max >= 0\nelse\n  raise(ArgumentError.new(\"Invalid bound for rand: #{max}\"))\nend\nmax_prec = 1_u64 << 53\n((rand(max_prec)) / max_prec.to_f64) * max\n"}},{"id":"rand(range:Range(Int,Int)):Int-instance-method","html_id":"rand(range:Range(Int,Int)):Int-instance-method","name":"rand","doc":"Returns a random integer in the given *range*.\n\nThe return type always matches the supplied argument.\n\n```\nRandom.new.rand(10..20)                 # => 14\nRandom.new.rand(Int64::MIN..Int64::MAX) # => -5297435808626736140\n```","summary":"<p>Returns a random integer in the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int)) : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L272","def":{"name":"rand","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"rand_range(range)"}},{"id":"rand(range:Range(Float,Float)):Float64-instance-method","html_id":"rand(range:Range(Float,Float)):Float64-instance-method","name":"rand","doc":"Returns a random `Float64` in the given *range*.\n\n```\nRandom.new.rand(6.2..21.768) # => 15.2989\n```","summary":"<p>Returns a random <code><a href=\"Float64.html\">Float64</a></code> in the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Float, Float)"}],"args_string":"(range : Range(Float, Float)) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L281","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L281","def":{"name":"rand","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Float, Float)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"span = range.end - range.begin\nif range.excludes_end?\n  if range.begin < range.end\n  else\n    raise(ArgumentError.new(\"Invalid range for rand: #{range}\"))\n  end\n  range.begin + (rand(span))\nelse\n  if range.begin <= range.end\n  else\n    raise(ArgumentError.new(\"Invalid range for rand: #{range}\"))\n  end\n  range.begin + (rand * span)\nend\n"}},{"id":"rand:Float64-instance-method","html_id":"rand:Float64-instance-method","name":"rand","doc":"Generates a random `Float64` between `0` and `1`.\n\n```\nr = Random.new\nr.rand # => 0.167595\nr.rand # => 0.0372991\n```","summary":"<p>Generates a random <code><a href=\"Float64.html\">Float64</a></code> between <code>0</code> and <code>1</code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L98","def":{"name":"rand","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"next_float"}},{"id":"random_bytes(n:Int=16):Bytes-instance-method","html_id":"random_bytes(n:Int=16):Bytes-instance-method","name":"random_bytes","doc":"Generates a slice filled with *n* random bytes.\n\n```\nRandom.new.random_bytes    # => [145, 255, 191, 133, 132, 139, 53, 136, 93, 238, 2, 37, 138, 244, 3, 216]\nRandom.new.random_bytes(4) # => [217, 118, 38, 196]\n```","summary":"<p>Generates a slice filled with <em>n</em> random bytes.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = <span class=\"n\">16</span>) : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L324","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L324","def":{"name":"random_bytes","args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Negative size: #{n}\"))\nend\n(Bytes.new(n)).tap do |buf|\n  random_bytes(buf)\nend\n"}},{"id":"random_bytes(buf:Bytes):Nil-instance-method","html_id":"random_bytes(buf:Bytes):Nil-instance-method","name":"random_bytes","doc":"Fills a given slice with random bytes.\n\n```\nslice = Bytes.new(4) # => [0, 0, 0, 0]\nRandom.new.random_bytes(slice)\nslice # => [217, 118, 38, 196]\n```","summary":"<p>Fills a given slice with random bytes.</p>","abstract":false,"args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L303","def":{"name":"random_bytes","args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"ptr = buf.to_unsafe\nfinish = buf.to_unsafe + buf.size\nwhile ptr < finish\n  random = next_u\n  rand_ptr = (pointerof(random)).as(::Pointer(UInt8))\n  if IO::ByteFormat::SystemEndian != IO::ByteFormat::LittleEndian\n    (rand_ptr.to_slice(sizeof(typeof(next_u)))).reverse!\n  end\n  rand_ptr.copy_to(ptr, {finish - ptr, sizeof(typeof(next_u))}.min)\n  ptr = ptr + (sizeof(typeof(next_u)))\nend\n"}},{"id":"urlsafe_base64(n:Int=16,padding=false):String-instance-method","html_id":"urlsafe_base64(n:Int=16,padding=false):String-instance-method","name":"urlsafe_base64","doc":"URL-safe variant of `#base64`.\n\nCheck `Base64#urlsafe_encode` for details.\n\n```\nRandom::Secure.urlsafe_base64                    # => \"MAD2bw8QaBdvITCveBNCrw\"\nRandom::Secure.urlsafe_base64(8, padding: true)  # => \"vvP1kcs841I=\"\nRandom::Secure.urlsafe_base64(16, padding: true) # => \"og2aJrELDZWSdJfVGkxNKw==\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>URL-safe variant of <code><a href=\"Random.html#base64%28n%3AInt%3D16%29%3AString-instance-method\">#base64</a></code>.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"},{"name":"padding","doc":null,"default_value":"false","external_name":"padding","restriction":""}],"args_string":"(n : Int = <span class=\"n\">16</span>, padding = <span class=\"n\">false</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L355","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random.cr#L355","def":{"name":"urlsafe_base64","args":[{"name":"n","doc":null,"default_value":"16","external_name":"n","restriction":"Int"},{"name":"padding","doc":null,"default_value":"false","external_name":"padding","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Base64.urlsafe_encode(random_bytes(n), padding)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Random/ISAAC","path":"Random/ISAAC.html","kind":"class","full_name":"Random::ISAAC","name":"ISAAC","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"random/isaac.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(seeds=random_seeds)-class-method","html_id":"new(seeds=random_seeds)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"seeds","doc":null,"default_value":"random_seeds","external_name":"seeds","restriction":""}],"args_string":"(seeds = random_seeds)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L24","def":{"name":"new","args":[{"name":"seeds","doc":null,"default_value":"random_seeds","external_name":"seeds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(seeds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"new_seed(seeds=random_seeds)-instance-method","html_id":"new_seed(seeds=random_seeds)-instance-method","name":"new_seed","doc":null,"summary":null,"abstract":false,"args":[{"name":"seeds","doc":null,"default_value":"random_seeds","external_name":"seeds","restriction":""}],"args_string":"(seeds = random_seeds)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L32","def":{"name":"new_seed","args":[{"name":"seeds","doc":null,"default_value":"random_seeds","external_name":"seeds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@aa = @bb = @cc = 0_u32\ninit_by_array(seeds)\n"}},{"id":"next_u-instance-method","html_id":"next_u-instance-method","name":"next_u","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/isaac.cr#L37","def":{"name":"next_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@counter = @counter - 1) == -1\n  isaac\n  @counter = 255\nend\n@rsl[counter]\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Random/PCG32","path":"Random/PCG32.html","kind":"class","full_name":"Random::PCG32","name":"PCG32","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"random/pcg32.cr","line_number":34,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"PCG_DEFAULT_MULTIPLIER_64","name":"PCG_DEFAULT_MULTIPLIER_64","value":"6364136223846793005_u64","doc":null,"summary":null}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},"doc":"pcg32_random_r:\n      -  result:      32-bit unsigned int (uint32_t)\n      -  period:      2^64   (* 2^63 streams)\n      -  state type:  pcg32_random_t (16 bytes)\n      -  output func: XSH-RR","summary":"<p>pcg32_random_r:       -  result:      32-bit unsigned int (uint32_t)       -  period:      2^64   (* 2^63 streams)       -  state type:  pcg32_random_t (16 bytes)       -  output func: XSH-RR</p>","class_methods":[],"constructors":[{"id":"new(initstate:UInt64,initseq=0_u64)-class-method","html_id":"new(initstate:UInt64,initseq=0_u64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"initstate","doc":null,"default_value":"","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","doc":null,"default_value":"0_u64","external_name":"initseq","restriction":""}],"args_string":"(initstate : UInt64, initseq = <span class=\"n\">0_u64</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L46","def":{"name":"new","args":[{"name":"initstate","doc":null,"default_value":"","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","doc":null,"default_value":"0_u64","external_name":"initseq","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(initstate, initseq)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L42","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(Random::Secure.rand(UInt64::MIN..UInt64::MAX), Random::Secure.rand(UInt64::MIN..UInt64::MAX))"}}],"instance_methods":[{"id":"jump(delta)-instance-method","html_id":"jump(delta)-instance-method","name":"jump","doc":null,"summary":null,"abstract":false,"args":[{"name":"delta","doc":null,"default_value":"","external_name":"delta","restriction":""}],"args_string":"(delta)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L73","def":{"name":"jump","args":[{"name":"delta","doc":null,"default_value":"","external_name":"delta","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"deltau64 = UInt64.new(delta)\nacc_mult = 1_u64\nacc_plus = 0_u64\ncur_plus = @inc\ncur_mult = PCG_DEFAULT_MULTIPLIER_64\nwhile (deltau64 > 0)\n  if (deltau64 & 1) > 0\n    acc_mult = acc_mult * cur_mult\n    acc_plus = (acc_plus * cur_mult) + cur_plus\n  end\n  cur_plus = (cur_mult + 1) * cur_plus\n  cur_mult = cur_mult * cur_mult\n  deltau64 = deltau64 / 2\nend\n@state = (acc_mult * @state) + acc_plus\n"}},{"id":"new_seed(initstate:UInt64,initseq=0_u64)-instance-method","html_id":"new_seed(initstate:UInt64,initseq=0_u64)-instance-method","name":"new_seed","doc":null,"summary":null,"abstract":false,"args":[{"name":"initstate","doc":null,"default_value":"","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","doc":null,"default_value":"0_u64","external_name":"initseq","restriction":""}],"args_string":"(initstate : UInt64, initseq = <span class=\"n\">0_u64</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L57","def":{"name":"new_seed","args":[{"name":"initstate","doc":null,"default_value":"","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","doc":null,"default_value":"0_u64","external_name":"initseq","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@state = 0_u64\n@inc = (initseq << 1) | 1\nnext_u\n@state = @state + initstate\nnext_u\n"}},{"id":"new_seed-instance-method","html_id":"new_seed-instance-method","name":"new_seed","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L53","def":{"name":"new_seed","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_seed(Random::Secure.rand(UInt64::MIN..UInt64::MAX), Random::Secure.rand(UInt64::MIN..UInt64::MAX))"}},{"id":"next_u-instance-method","html_id":"next_u-instance-method","name":"next_u","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/pcg32.cr#L65","def":{"name":"next_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"oldstate = @state\n@state = (oldstate * PCG_DEFAULT_MULTIPLIER_64) + @inc\nxorshifted = UInt32.new(((oldstate >> 18) ^ oldstate) >> 27)\nrot = UInt32.new(oldstate >> 59)\nreturn UInt32.new((xorshifted >> rot) | (xorshifted << (((~rot) + 1) & 31)))\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Random/Secure","path":"Random/Secure.html","kind":"module","full_name":"Random::Secure","name":"Secure","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"random/secure.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"github.com/crystal-lang/crystal/Random/Secure","kind":"module","full_name":"Random::Secure","name":"Secure"}],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Random","kind":"module","full_name":"Random","name":"Random"},"doc":"Generates random numbers from a secure source provided by the system.\n\nFor example `arc4random` is used on OpenBSD, whereas on Linux it uses\n`getrandom` (if the kernel supports it) and fallbacks on reading from\n`/dev/urandom` on UNIX systems.\n\n```\nRandom::Secure.rand(6)            # => 4\n[1, 5, 6].shuffle(Random::Secure) # => [6, 1, 5]\n```","summary":"<p>Generates random numbers from a secure source provided by the system.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"next_u-instance-method","html_id":"next_u-instance-method","name":"next_u","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr#L17","def":{"name":"next_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Random.next_u"}},{"id":"random_bytes(buf:Bytes)-instance-method","html_id":"random_bytes(buf:Bytes)-instance-method","name":"random_bytes","doc":null,"summary":null,"abstract":false,"args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/random/secure.cr#L21","def":{"name":"random_bytes","args":[{"name":"buf","doc":null,"default_value":"","external_name":"buf","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System::Random.random_bytes(buf)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Range","path":"Range.html","kind":"struct","full_name":"Range(B, E)","name":"Range","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"range.cr","line_number":54,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr"},{"filename":"range/bsearch.cr","line_number":70,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range/bsearch.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Range` represents an interval: a set of values with a beginning and an end.\n\nRanges may be constructed using the usual `new` method or with literals:\n\n```\nx..y  # an inclusive range, in mathematics: [x, y]\nx...y # an exclusive range, in mathematics: [x, y)\n```\n\nAn easy way to remember which one is inclusive and which one is exclusive it\nto think of the extra dot as if it pushes *y* further away, thus leaving it outside of the range.\n\nRanges typically involve integers, but can be created using arbitrary objects\nas long as they define `succ` (or `pred` for `reverse_each`), to get the\nnext element in the range, and `<` and `==`, to know when the range reached the end:\n\n```\n# Represents a string of 'x's.\nstruct Xs\n  include Comparable(Xs)\n\n  getter size\n\n  def initialize(@size : Int32)\n  end\n\n  def succ\n    Xs.new(@size + 1)\n  end\n\n  def <=>(other)\n    @size <=> other.size\n  end\n\n  def inspect(io)\n    @size.times { io << 'x' }\n  end\n\n  def to_s(io)\n    io << @size << ' '\n    inspect(io)\n  end\nend\n```\n\nAn example of using `Xs` to construct a range:\n\n```\nr = Xs.new(3)..Xs.new(6)\nr.to_s                 # => \"xxx..xxxxxx\"\nr.to_a                 # => [Xs.new(3), Xs.new(4), Xs.new(5), Xs.new(6)]\nr.includes?(Xs.new(5)) # => true\n```","summary":"<p>A <code><a href=\"Range.html\">Range</a></code> represents an interval: a set of values with a beginning and an end.</p>","class_methods":[],"constructors":[{"id":"new(begin:B,end:E,exclusive:Bool=false)-class-method","html_id":"new(begin:B,end:E,exclusive:Bool=false)-class-method","name":"new","doc":"Constructs a `Range` using the given beginning and end.\n\n```\nRange.new(1, 10)                  # => 1..10\nRange.new(1, 10, exclusive: true) # => 1...10\n```","summary":"<p>Constructs a <code><a href=\"Range.html\">Range</a></code> using the given beginning and end.</p>","abstract":false,"args":[{"name":"begin","doc":null,"default_value":"","external_name":"begin","restriction":"B"},{"name":"end","doc":null,"default_value":"","external_name":"end","restriction":"E"},{"name":"exclusive","doc":null,"default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(begin : B, end : E, exclusive : Bool = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L84","def":{"name":"new","args":[{"name":"begin","doc":null,"default_value":"","external_name":"begin","restriction":"B"},{"name":"end","doc":null,"default_value":"","external_name":"end","restriction":"E"},{"name":"exclusive","doc":null,"default_value":"false","external_name":"exclusive","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Range(B, E).allocate\n_.initialize(begin, end, exclusive)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"===(value)-instance-method","html_id":"===(value)-instance-method","name":"===","doc":"Same as `includes?`, useful for the `case` expression.\n\n```\ncase 79\nwhen 1..50   then puts \"low\"\nwhen 51..75  then puts \"medium\"\nwhen 76..100 then puts \"high\"\nend\n```\n\nProduces:\n\n```text\nhigh\n```\n\nSee also: `Object#===`.","summary":"<p>Same as <code><a href=\"Range.html#includes%3F%28value%29-instance-method\">#includes?</a></code>, useful for the <code>case</code> expression.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L239","def":{"name":"===","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"includes?(value)"}},{"id":"begin:B-instance-method","html_id":"begin:B-instance-method","name":"begin","doc":"Returns the object that defines the beginning of this range.\n\n```\n(1..10).begin  # => 1\n(1...10).begin # => 1\n```","summary":"<p>Returns the object that defines the beginning of this range.</p>","abstract":false,"args":[],"args_string":" : B","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L64","def":{"name":"begin","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"B","visibility":"Public","body":"@begin"}},{"id":"bsearch(&block)-instance-method","html_id":"bsearch(&amp;block)-instance-method","name":"bsearch","doc":"By using binary search, returns the first value\nfor which the passed block returns `true`.\n\nIf the block returns `false`, the finding value exists\nbehind. If the block returns `true`, the finding value\nis itself or exists infront.\n\n```\n(0..10).bsearch { |x| x >= 5 }                       # => 5\n(0..Float64::INFINITY).bsearch { |x| x ** 4 >= 256 } # => 4\n```\n\nReturns `nil` if the block didn't return `true` for any value.","summary":"<p>By using binary search, returns the first value for which the passed block returns <code>true</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range/bsearch.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range/bsearch.cr#L84","def":{"name":"bsearch","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"from = self.begin\nto = self.end\n{% for v in [\"from\", \"to\"] of ::String %}\n      if {{ v.id }}.is_a?(Float::Primitive)\n        return bsearch_internal from, to, self.excludes_end? do |value|\n          yield value\n        end\n      end\n    {% end %}\nsaved_to = to\nsatisfied = nil\nwhile from < to\n  mid = from + ((to - from) / 2)\n  if yield mid\n    satisfied = mid\n    to = mid\n  else\n    from = mid + 1\n  end\nend\nif ((!self.excludes_end?) && (from == saved_to)) && (yield from)\n  satisfied = from\nend\nsatisfied\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Range` with `begin` and `end` cloned.","summary":"<p>Returns a new <code><a href=\"Range.html\">Range</a></code> with <code><a href=\"Range.html#begin%3AB-instance-method\">#begin</a></code> and <code><a href=\"Range.html#end%3AE-instance-method\">#end</a></code> cloned.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L275","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Range.new(@begin.clone, @end.clone, @exclusive)"}},{"id":"covers?(value)-instance-method","html_id":"covers?(value)-instance-method","name":"covers?","doc":"Same as `includes?`.","summary":"<p>Same as <code><a href=\"Range.html#includes%3F%28value%29-instance-method\">#includes?</a></code>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L218","def":{"name":"covers?","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"includes?(value)"}},{"id":"cycle-instance-method","html_id":"cycle-instance-method","name":"cycle","doc":"Returns an `Iterator` that cycles over the values of this range.\n\n```\n(1..3).cycle.first(5).to_a # => [1, 2, 3, 1, 2]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> that cycles over the values of this range.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L92","def":{"name":"cycle","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each.cycle"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Iterates over the elements of this range, passing each in turn to the block.\n\n```\n(10..15).each { |n| print n, ' ' }\n# prints: 10 11 12 13 14 15\n```","summary":"<p>Iterates over the elements of this range, passing each in turn to the block.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L102","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"current = @begin\nwhile current < @end\n  yield current\n  current = current.succ\nend\nif (!@exclusive) && (current == @end)\n  yield current\nend\n"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Returns an `Iterator` over the elements of this range.\n\n```\n(1..3).each.skip(1).to_a # => [2, 3]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of this range.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L116","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ItemIterator.new(self)"}},{"id":"end:E-instance-method","html_id":"end:E-instance-method","name":"end","doc":"Returns the object that defines the end of the range.\n\n```\n(1..10).end  # => 10\n(1...10).end # => 10\n```","summary":"<p>Returns the object that defines the end of the range.</p>","abstract":false,"args":[],"args_string":" : E","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L72","def":{"name":"end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"E","visibility":"Public","body":"@end"}},{"id":"excludes_end?-instance-method","html_id":"excludes_end?-instance-method","name":"excludes_end?","doc":"Returns `true` if this range excludes the *end* element.\n\n```\n(1..10).excludes_end?  # => false\n(1...10).excludes_end? # => true\n```","summary":"<p>Returns <code>true</code> if this range excludes the <em>end</em> element.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L195","def":{"name":"excludes_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@exclusive"}},{"id":"exclusive?:Bool-instance-method","html_id":"exclusive?:Bool-instance-method","name":"exclusive?","doc":"Returns `true` if the range is exclusive.\nReturns `false` otherwise (default).","summary":"<p>Returns <code>true</code> if the range is exclusive.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L76","def":{"name":"exclusive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@exclusive"}},{"id":"includes?(value)-instance-method","html_id":"includes?(value)-instance-method","name":"includes?","doc":"Returns `true` if this range includes the given *value*.\n\n```\n(1..10).includes?(4)  # => true\n(1..10).includes?(10) # => true\n(1..10).includes?(11) # => false\n\n(1...10).includes?(9)  # => true\n(1...10).includes?(10) # => false\n```","summary":"<p>Returns <code>true</code> if this range includes the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L209","def":{"name":"includes?","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @exclusive\n  @begin <= value && value < @end\nelse\n  @begin <= value && value <= @end\nend"}},{"id":"reverse_each(&block):Nil-instance-method","html_id":"reverse_each(&amp;block):Nil-instance-method","name":"reverse_each","doc":"Iterates over the elements of this range in reverse order,\npassing each in turn to the block.\n\n```\n(10...15).reverse_each { |n| print n, ' ' }\n# prints: 14 13 12 11 10\n```","summary":"<p>Iterates over the elements of this range in reverse order, passing each in turn to the block.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L127","def":{"name":"reverse_each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if (!@exclusive) && (!(@end < @begin))\n  yield @end\nend\ncurrent = @end\nwhile @begin < current\n  current = current.pred\n  yield current\nend\n"}},{"id":"reverse_each-instance-method","html_id":"reverse_each-instance-method","name":"reverse_each","doc":"Returns a reverse `Iterator` over the elements of this range.\n\n```\n(1..3).reverse_each.skip(1).to_a # => [2, 1]\n```","summary":"<p>Returns a reverse <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of this range.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L141","def":{"name":"reverse_each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ReverseIterator.new(self)"}},{"id":"step(by=1)-instance-method","html_id":"step(by=1)-instance-method","name":"step","doc":"Returns an `Iterator` that returns each nth element in this range.\n\n```\n(1..10).step(3).skip(1).to_a # => [4, 7, 10]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> that returns each nth element in this range.</p>","abstract":false,"args":[{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"args_string":"(by = <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L185","def":{"name":"step","args":[{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"StepIterator(self, B, typeof(by)).new(self, by)"}},{"id":"step(by=1,&block)-instance-method","html_id":"step(by=1,&amp;block)-instance-method","name":"step","doc":"Iterates over this range, passing each nth element to the block.\n\n```\nrange = Xs.new(1)..Xs.new(10)\nrange.step(2) { |x| puts x }\nputs\nrange.step(3) { |x| puts x }\n```\n\nProduces:\n\n```text\n1 x\n3 xxx\n5 xxxxx\n7 xxxxxxx\n9 xxxxxxxxx\n\n1 x\n4 xxxx\n7 xxxxxxx\n10 xxxxxxxxxx\n```\n\nSee `Range`'s overview for the definition of `Xs`.","summary":"<p>Iterates over this range, passing each nth element to the block.</p>","abstract":false,"args":[{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"args_string":"(by = <span class=\"n\">1</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L170","def":{"name":"step","args":[{"name":"by","doc":null,"default_value":"1","external_name":"by","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"current = @begin\nwhile current < @end\n  yield current\n  by.times do\n    current = current.succ\n  end\nend\nif (!@exclusive) && (current == @end)\n  yield current\nend\nself\n"}},{"id":"sum(initial)-instance-method","html_id":"sum(initial)-instance-method","name":"sum","doc":"If `self` is a `Int` range, it provides O(1) implementation,\notherwise it is same as `Enumerable#sum`.","summary":"<p>If <code>self</code> is a <code><a href=\"Int.html\">Int</a></code> range, it provides O(1) implementation, otherwise it is same as <code><a href=\"Enumerable.html#sum-instance-method\">Enumerable#sum</a></code>.</p>","abstract":false,"args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"args_string":"(initial)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L257","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/range.cr#L257","def":{"name":"sum","args":[{"name":"initial","doc":null,"default_value":"","external_name":"initial","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"b = self.begin\ne = self.end\nif b.is_a?(Int) && e.is_a?(Int)\n  if @exclusive\n    e = e - 1\n  end\n  n = (e - b) + 1\n  if n >= 0\n    initial + ((n * (b + e)) / 2)\n  else\n    initial\n  end\nelse\n  super(initial)\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Readline","path":"Readline.html","kind":"module","full_name":"Readline","name":"Readline","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"readline.cr","line_number":28,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"KeyBindingHandler","name":"KeyBindingHandler","value":"->(count : LibReadline::Int, key : LibReadline::Int) do\n  if (handlers = @@key_bind_handlers) && handlers[key.to_i32]?\n    res = handlers[key].call(count.to_i32, key.to_i32)\n    LibReadline::Int.new(res)\n  else\n    LibReadline::Int.new(1)\n  end\nend","doc":null,"summary":null}],"included_modules":[],"extended_modules":[{"html_id":"github.com/crystal-lang/crystal/Readline","kind":"module","full_name":"Readline","name":"Readline"}],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"autocomplete(&completion_proc:CompletionProc)-instance-method","html_id":"autocomplete(&amp;completion_proc:CompletionProc)-instance-method","name":"autocomplete","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&completion_proc : CompletionProc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L53","def":{"name":"autocomplete","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"completion_proc","doc":null,"default_value":"","external_name":"completion_proc","restriction":"CompletionProc"},"return_type":"","visibility":"Public","body":"@@completion_proc = completion_proc"}},{"id":"bind_key(c:Char,&f:KeyBindingProc)-instance-method","html_id":"bind_key(c:Char,&amp;f:KeyBindingProc)-instance-method","name":"bind_key","doc":null,"summary":null,"abstract":false,"args":[{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":"Char"}],"args_string":"(c : Char, &f : KeyBindingProc)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L67","def":{"name":"bind_key","args":[{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"f","doc":null,"default_value":"","external_name":"f","restriction":"KeyBindingProc"},"return_type":"","visibility":"Public","body":"if c.ascii?\nelse\n  raise(ArgumentError.new(\"Not a valid ASCII character: #{c.inspect}\"))\nend\nhandlers = (@@key_bind_handlers || (@@key_bind_handlers = {} of LibReadline::Int => KeyBindingProc))\nhandlers[c.ord] = f\nres = (LibReadline.rl_bind_key(c.ord, KeyBindingHandler)).to_i32\nif res == 0\nelse\n  raise(ArgumentError.new(\"Invalid key: #{c.inspect}\"))\nend\n"}},{"id":"done-instance-method","html_id":"done-instance-method","name":"done","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L87","def":{"name":"done","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibReadline.rl_done != 0"}},{"id":"done=(val:Bool)-instance-method","html_id":"done=(val:Bool)-instance-method","name":"done=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L91","def":{"name":"done=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibReadline.rl_done = val.hash"}},{"id":"line_buffer-instance-method","html_id":"line_buffer-instance-method","name":"line_buffer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L56","def":{"name":"line_buffer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line = LibReadline.rl_line_buffer\nif line\nelse\n  return nil\nend\nString.new(line)\n"}},{"id":"point-instance-method","html_id":"point-instance-method","name":"point","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L63","def":{"name":"point","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibReadline.rl_point"}},{"id":"readline(prompt=&quot;&quot;,add_history=false)-instance-method","html_id":"readline(prompt=&amp;quot;&amp;quot;,add_history=false)-instance-method","name":"readline","doc":null,"summary":null,"abstract":false,"args":[{"name":"prompt","doc":null,"default_value":"\"\"","external_name":"prompt","restriction":""},{"name":"add_history","doc":null,"default_value":"false","external_name":"add_history","restriction":""}],"args_string":"(prompt = <span class=\"s\">&quot;&quot;</span>, add_history = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L43","def":{"name":"readline","args":[{"name":"prompt","doc":null,"default_value":"\"\"","external_name":"prompt","restriction":""},{"name":"add_history","doc":null,"default_value":"false","external_name":"add_history","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"line = LibReadline.readline(prompt)\nif line\n  if add_history\n    LibReadline.add_history(line)\n  end\n  (String.new(line)).tap do\n    LibC.free(line.as(::Pointer(Void)))\n  end\nelse\n  nil\nend\n"}},{"id":"unbind_key(c:Char)-instance-method","html_id":"unbind_key(c:Char)-instance-method","name":"unbind_key","doc":null,"summary":null,"abstract":false,"args":[{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":"Char"}],"args_string":"(c : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr#L77","def":{"name":"unbind_key","args":[{"name":"c","doc":null,"default_value":"","external_name":"c","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (handlers = @@key_bind_handlers) && handlers[c.ord]?\n  handlers.delete(c.ord)\n  res = (LibReadline.rl_unbind_key(c.ord)).to_i32\n  if res == 0\n  else\n    raise(Exception.new(\"Error unbinding key: #{c.inspect}\"))\n  end\nelse\n  raise(KeyError.new(\"Key not bound: #{c.inspect}\"))\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Readline/CompletionProc","path":"Readline/CompletionProc.html","kind":"alias","full_name":"Readline::CompletionProc","name":"CompletionProc","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"readline.cr","line_number":31,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"Proc(String, (Array(String) | Nil))","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Readline","kind":"module","full_name":"Readline","name":"Readline"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Readline/KeyBindingProc","path":"Readline/KeyBindingProc.html","kind":"alias","full_name":"Readline::KeyBindingProc","name":"KeyBindingProc","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"readline.cr","line_number":33,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/readline.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"Proc(Int32, Int32, Int32)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Readline","kind":"module","full_name":"Readline","name":"Readline"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Reference","path":"Reference.html","kind":"class","full_name":"Reference","name":"Reference","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"primitives.cr","line_number":36,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"reference.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr"},{"filename":"json/any.cr","line_number":276,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"yaml/any.cr","line_number":287,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM/Job","kind":"class","full_name":"Benchmark::BM::Job","name":"Job"},{"html_id":"github.com/crystal-lang/crystal/Benchmark/BM/Tms","kind":"class","full_name":"Benchmark::BM::Tms","name":"Tms"},{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS/Entry","kind":"class","full_name":"Benchmark::IPS::Entry","name":"Entry"},{"html_id":"github.com/crystal-lang/crystal/Benchmark/IPS/Job","kind":"class","full_name":"Benchmark::IPS::Job","name":"Job"},{"html_id":"github.com/crystal-lang/crystal/Box","kind":"class","full_name":"Box(T)","name":"Box"},{"html_id":"github.com/crystal-lang/crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"},{"html_id":"github.com/crystal-lang/crystal/Crypto/Bcrypt/Password","kind":"class","full_name":"Crypto::Bcrypt::Password","name":"Password"},{"html_id":"github.com/crystal-lang/crystal/Crypto/Blowfish","kind":"class","full_name":"Crypto::Blowfish","name":"Blowfish"},{"html_id":"github.com/crystal-lang/crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"github.com/crystal-lang/crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},{"html_id":"github.com/crystal-lang/crystal/CSV/Builder","kind":"class","full_name":"CSV::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/CSV/Lexer","kind":"class","full_name":"CSV::Lexer","name":"Lexer"},{"html_id":"github.com/crystal-lang/crystal/CSV/Parser","kind":"class","full_name":"CSV::Parser","name":"Parser"},{"html_id":"github.com/crystal-lang/crystal/Deque","kind":"class","full_name":"Deque(T)","name":"Deque"},{"html_id":"github.com/crystal-lang/crystal/Digest/Base","kind":"class","full_name":"Digest::Base","name":"Base"},{"html_id":"github.com/crystal-lang/crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Fiber","kind":"class","full_name":"Fiber","name":"Fiber"},{"html_id":"github.com/crystal-lang/crystal/Gzip/Header","kind":"class","full_name":"Gzip::Header","name":"Header"},{"html_id":"github.com/crystal-lang/crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Client/Response","kind":"class","full_name":"HTTP::Client::Response","name":"Response"},{"html_id":"github.com/crystal-lang/crystal/HTTP/CompressHandler","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Cookie","kind":"class","full_name":"HTTP::Cookie","name":"Cookie"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Cookies","kind":"class","full_name":"HTTP::Cookies","name":"Cookies"},{"html_id":"github.com/crystal-lang/crystal/HTTP/ErrorHandler","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Builder","kind":"class","full_name":"HTTP::FormData::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Parser","kind":"class","full_name":"HTTP::FormData::Parser","name":"Parser"},{"html_id":"github.com/crystal-lang/crystal/HTTP/LogHandler","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Builder","kind":"class","full_name":"HTTP::Multipart::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Multipart/Parser","kind":"class","full_name":"HTTP::Multipart::Parser","name":"Parser"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Params/Builder","kind":"class","full_name":"HTTP::Params::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Request","kind":"class","full_name":"HTTP::Request","name":"Request"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/Context","kind":"class","full_name":"HTTP::Server::Context","name":"Context"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Server/RequestProcessor","kind":"class","full_name":"HTTP::Server::RequestProcessor","name":"RequestProcessor"},{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocket","kind":"class","full_name":"HTTP::WebSocket","name":"WebSocket"},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocketHandler","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler"},{"html_id":"github.com/crystal-lang/crystal/INI","kind":"class","full_name":"INI","name":"INI"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Iterator/Stop","kind":"class","full_name":"Iterator::Stop","name":"Stop"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/JSON/Lexer","kind":"class","full_name":"JSON::Lexer","name":"Lexer"},{"html_id":"github.com/crystal-lang/crystal/JSON/Parser","kind":"class","full_name":"JSON::Parser","name":"Parser"},{"html_id":"github.com/crystal-lang/crystal/JSON/PullParser","kind":"class","full_name":"JSON::PullParser","name":"PullParser"},{"html_id":"github.com/crystal-lang/crystal/JSON/Token","kind":"class","full_name":"JSON::Token","name":"Token"},{"html_id":"github.com/crystal-lang/crystal/Levenshtein/Finder","kind":"class","full_name":"Levenshtein::Finder","name":"Finder"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/FunctionType","kind":"class","full_name":"LLVM::ABI::FunctionType","name":"FunctionType"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Builder","kind":"class","full_name":"LLVM::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Context","kind":"class","full_name":"LLVM::Context","name":"Context"},{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionPassManager","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager"},{"html_id":"github.com/crystal-lang/crystal/LLVM/GenericValue","kind":"class","full_name":"LLVM::GenericValue","name":"GenericValue"},{"html_id":"github.com/crystal-lang/crystal/LLVM/JITCompiler","kind":"class","full_name":"LLVM::JITCompiler","name":"JITCompiler"},{"html_id":"github.com/crystal-lang/crystal/LLVM/MemoryBuffer","kind":"class","full_name":"LLVM::MemoryBuffer","name":"MemoryBuffer"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Module","kind":"class","full_name":"LLVM::Module","name":"Module"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ModulePassManager","kind":"class","full_name":"LLVM::ModulePassManager","name":"ModulePassManager"},{"html_id":"github.com/crystal-lang/crystal/LLVM/PassManagerBuilder","kind":"class","full_name":"LLVM::PassManagerBuilder","name":"PassManagerBuilder"},{"html_id":"github.com/crystal-lang/crystal/LLVM/TargetMachine","kind":"class","full_name":"LLVM::TargetMachine","name":"TargetMachine"},{"html_id":"github.com/crystal-lang/crystal/Logger","kind":"class","full_name":"Logger","name":"Logger"},{"html_id":"github.com/crystal-lang/crystal/Markdown","kind":"class","full_name":"Markdown","name":"Markdown"},{"html_id":"github.com/crystal-lang/crystal/Markdown/HTMLRenderer","kind":"class","full_name":"Markdown::HTMLRenderer","name":"HTMLRenderer"},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser","kind":"class","full_name":"Markdown::Parser","name":"Parser"},{"html_id":"github.com/crystal-lang/crystal/Mutex","kind":"class","full_name":"Mutex","name":"Mutex"},{"html_id":"github.com/crystal-lang/crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Client","kind":"class","full_name":"OAuth2::Client","name":"Client"},{"html_id":"github.com/crystal-lang/crystal/OAuth2/Session","kind":"class","full_name":"OAuth2::Session","name":"Session"},{"html_id":"github.com/crystal-lang/crystal/OAuth/AccessToken","kind":"class","full_name":"OAuth::AccessToken","name":"AccessToken"},{"html_id":"github.com/crystal-lang/crystal/OAuth/Consumer","kind":"class","full_name":"OAuth::Consumer","name":"Consumer"},{"html_id":"github.com/crystal-lang/crystal/OAuth/RequestToken","kind":"class","full_name":"OAuth::RequestToken","name":"RequestToken"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/HMAC","kind":"class","full_name":"OpenSSL::HMAC","name":"HMAC"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/MD5","kind":"class","full_name":"OpenSSL::MD5","name":"MD5"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SHA1","kind":"class","full_name":"OpenSSL::SHA1","name":"SHA1"},{"html_id":"github.com/crystal-lang/crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"github.com/crystal-lang/crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},{"html_id":"github.com/crystal-lang/crystal/PrettyPrint","kind":"class","full_name":"PrettyPrint","name":"PrettyPrint"},{"html_id":"github.com/crystal-lang/crystal/Process","kind":"class","full_name":"Process","name":"Process"},{"html_id":"github.com/crystal-lang/crystal/Process/Status","kind":"class","full_name":"Process::Status","name":"Status"},{"html_id":"github.com/crystal-lang/crystal/Random/ISAAC","kind":"class","full_name":"Random::ISAAC","name":"ISAAC"},{"html_id":"github.com/crystal-lang/crystal/Random/PCG32","kind":"class","full_name":"Random::PCG32","name":"PCG32"},{"html_id":"github.com/crystal-lang/crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},{"html_id":"github.com/crystal-lang/crystal/Spec/VerboseFormatter/Item","kind":"class","full_name":"Spec::VerboseFormatter::Item","name":"Item"},{"html_id":"github.com/crystal-lang/crystal/String","kind":"class","full_name":"String","name":"String"},{"html_id":"github.com/crystal-lang/crystal/StringPool","kind":"class","full_name":"StringPool","name":"StringPool"},{"html_id":"github.com/crystal-lang/crystal/StringScanner","kind":"class","full_name":"StringScanner","name":"StringScanner"},{"html_id":"github.com/crystal-lang/crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},{"html_id":"github.com/crystal-lang/crystal/URI","kind":"class","full_name":"URI","name":"URI"},{"html_id":"github.com/crystal-lang/crystal/URI/Punycode","kind":"class","full_name":"URI::Punycode","name":"Punycode"},{"html_id":"github.com/crystal-lang/crystal/WeakRef","kind":"class","full_name":"WeakRef(T)","name":"WeakRef"},{"html_id":"github.com/crystal-lang/crystal/YAML/Builder","kind":"class","full_name":"YAML::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Builder","kind":"class","full_name":"YAML::Nodes::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/YAML/ParseContext","kind":"class","full_name":"YAML::ParseContext","name":"ParseContext"},{"html_id":"github.com/crystal-lang/crystal/YAML/PullParser","kind":"class","full_name":"YAML::PullParser","name":"PullParser"},{"html_id":"github.com/crystal-lang/crystal/Zip/File","kind":"class","full_name":"Zip::File","name":"File"},{"html_id":"github.com/crystal-lang/crystal/Zip/File/Entry","kind":"class","full_name":"Zip::File::Entry","name":"Entry"},{"html_id":"github.com/crystal-lang/crystal/Zip/Reader","kind":"class","full_name":"Zip::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Zip/Reader/Entry","kind":"class","full_name":"Zip::Reader::Entry","name":"Entry"},{"html_id":"github.com/crystal-lang/crystal/Zip/Writer","kind":"class","full_name":"Zip::Writer","name":"Writer"},{"html_id":"github.com/crystal-lang/crystal/Zip/Writer/Entry","kind":"class","full_name":"Zip::Writer::Entry","name":"Entry"}],"including_types":[],"namespace":null,"doc":"`Reference` is the base class of classes you define in your program.\nIt is set as a class' superclass when you don't specify one:\n\n```\nclass MyClass # < Reference\nend\n```\n\nA reference type is passed by reference: when you pass it to methods,\nreturn it from methods or assign it to variables, a pointer is actually passed.\n\nInvoking `new` on a `Reference` allocates a new instance on the heap.\nThe instance's memory is automatically freed (garbage-collected) when\nthe instance is no longer referred by any other entity in the program.","summary":"<p><code><a href=\"Reference.html\">Reference</a></code> is the base class of classes you define in your program.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L36","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L17","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"same?(other)"}},{"id":"==(other:JSON::Any)-instance-method","html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L277","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other:YAML::Any)-instance-method","html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L288","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L288","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Returns `false` (other can only be a `Value` here).","summary":"<p>Returns <code>false</code> (other can only be a <code><a href=\"Value.html\">Value</a></code> here).</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L22","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L41","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if @type.abstract? %}\n      # This shouldn't happen, as the type is abstract,\n      # but we need to avoid the allocate invocation below\n      raise \"Can't dup {{ @type }}\"\n    {% else %}\n      dup = self.class.allocate\n      dup.as(Void*).copy_from(self.as(Void*), instance_sizeof(self))\n      GC.add_finalizer(dup) if dup.responds_to?(:finalize)\n      dup\n    {% end %}"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L55","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.reference(self)"}},{"id":"inspect(io:IO):Nil-instance-method","html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L59","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"((io << \"#<\") << ({{ @type.name.id.stringify }})) << \":0x\"\nobject_id.to_s(16, io)\nexecuted = exec_recursive(:inspect) do\n  {% for ivar, i in @type.instance_vars %}\n        {% if i > 0 %}\n          io << ','\n        {% end %}\n        io << \" @{{ ivar.id }}=\"\n        @{{ ivar.id }}.inspect io\n      {% end %}\nend\nif executed\nelse\n  io << \" ...\"\nend\nio << '>'\nnil\n"}},{"id":"object_id:UInt64-instance-method","html_id":"object_id:UInt64-instance-method","name":"object_id","doc":"Returns a `UInt64` that uniquely identifies this object.\n\nThe returned value is the memory address of this object.\n\n```\nstring = \"hello\"\nstring.object_id # => 4460249568\n\npointer = Pointer(String).new(string.object_id)\nstring2 = pointer.as(String)\nstring2.object_id == string.object_id # => true\n```","summary":"<p>Returns a <code><a href=\"UInt64.html\">UInt64</a></code> that uniquely identifies this object.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L50","def":{"name":"object_id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: object_id"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L79","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% if @type.overrides?(Reference, \"inspect\") %}\n      pp.text inspect\n    {% else %}\n      prefix = \"#<#{{{ @type.name.id.stringify }}}:0x#{object_id.to_s(16)}\"\n      executed = exec_recursive(:pretty_print) do\n        pp.surround(prefix, \">\", left_break: nil, right_break: nil) do\n          {% for ivar, i in @type.instance_vars.map(&.name).sort %}\n            {% if i == 0 %}\n              pp.breakable\n            {% else %}\n              pp.comma\n            {% end %}\n            pp.group do\n              pp.text \"@{{ ivar.id }}=\"\n              pp.nest do\n                pp.breakable \"\"\n                @{{ ivar.id }}.pretty_print(pp)\n              end\n            end\n          {% end %}\n        end\n      end\n      unless executed\n        pp.text \"#{prefix} ...>\"\n      end\n    {% end %}"}},{"id":"same?(other:Reference)-instance-method","html_id":"same?(other:Reference)-instance-method","name":"same?","doc":"Returns `true` if this reference is the same as *other*. This is only\n`true` if this reference's `object_id` is the same as *other*'s.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Reference"}],"args_string":"(other : Reference)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L28","def":{"name":"same?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Reference"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"object_id == other.object_id"}},{"id":"same?(other:Nil)-instance-method","html_id":"same?(other:Nil)-instance-method","name":"same?","doc":"Returns `false`: a reference is never `nil`.","summary":"<p>Returns <code>false</code>: a reference is never <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L33","def":{"name":"same?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"to_s(io:IO):Nil-instance-method","html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L108","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reference.cr#L108","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"((io << \"#<\") << self.class.name) << \":0x\"\nobject_id.to_s(16, io)\nio << '>'\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Reflect","path":"Reflect.html","kind":"struct","full_name":"Reflect(X)","name":"Reflect","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"reflect.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reflect.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"NOTE: This type might be removed.\n:nodoc:","summary":"<p><span class=\"flag purple\">NOTE</span>  This type might be removed.</p>","class_methods":[{"id":"first-class-method","html_id":"first-class-method","name":"first","doc":"For now it's just a way to implement `Enumerable#sum` in a way that the\ninitial value given to it has the type of the first type in the union,\nif the type is a union.","summary":"<p>For now it's just a way to implement <code><a href=\"Enumerable.html#sum-instance-method\">Enumerable#sum</a></code> in a way that the initial value given to it has the type of the first type in the union, if the type is a union.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reflect.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reflect.cr#L7","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if X.union? %}\n      {{ X.union_types.first }}\n    {% else %}\n      X\n    {% end %}"}}],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reflect.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/reflect.cr#L3","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Regex","path":"Regex.html","kind":"class","full_name":"Regex","name":"Regex","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"regex/match_data.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr"},{"filename":"regex.cr","line_number":194,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr"},{"filename":"json/any.cr","line_number":294,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"yaml/any.cr","line_number":305,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"SPECIAL_CHARACTERS","name":"SPECIAL_CHARACTERS","value":"{' ', '.', '\\\\', '+', '*', '?', '[', '^', ']', '$', '(', ')', '{', '}', '=', '!', '<', '>', '|', ':', '-'}","doc":"List of metacharacters that need to be escaped.\n\nSee `Regex.needs_escape?` and `Regex.escape`.","summary":"<p>List of metacharacters that need to be escaped.</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Regex` represents a regular expression, a pattern that describes the\ncontents of strings. A `Regex` can determine whether or not a string matches\nits description, and extract the parts of the string that match.\n\nA `Regex` can be created using the literal syntax, in which it is delimited by\nforward slashes (`/`):\n\n```\n/hay/ =~ \"haystack\"   # => 0\n/y/.match(\"haystack\") # => #<Regex::MatchData \"y\">\n```\n\nInterpolation works in regular expression literals just as it does in string\nliterals. Be aware that using this feature will cause an exception to be\nraised at runtime, if the resulting string would not be a valid regular\nexpression.\n\n```\nx = \"a\"\n/#{x}/.match(\"asdf\") # => #<Regex::MatchData \"a\">\nx = \"(\"\n/#{x}/ # raises ArgumentError\n```\n\nWhen we check to see if a particular regular expression describes a string,\nwe can say that we are performing a match or matching one against the other.\nIf we find that a regular expression does describe a string, we say that it\nmatches, and we can refer to a part of the string that was described as\na match.\n\nHere `\"haystack\"` does not contain the pattern `/needle/`, so it doesn't match:\n\n```\n/needle/.match(\"haystack\") # => nil\n```\n\nHere `\"haystack\"` contains the pattern `/hay/`, so it matches:\n\n```\n/hay/.match(\"haystack\") # => #<Regex::MatchData \"hay\">\n```\n\nRegex methods that perform a match usually return a truthy value if there was\na match and `nil` if there was no match. After performing a match, the\nspecial variable `$~` will be an instance of `Regex::MatchData` if it matched, `nil`\notherwise.\n\nWhen matching a regular expression using `=~` (either `String#=~` or\n`Regex#=~`), the returned value will be the index of the first match in the\nstring if the expression matched, `nil` otherwise.\n\n```\n/stack/ =~ \"haystack\"  # => 3\n\"haystack\" =~ /stack/  # => 3\n$~                     # => #<Regex::MatchData \"stack\">\n/needle/ =~ \"haystack\" # => nil\n\"haystack\" =~ /needle/ # => nil\n$~                     # raises Exception\n```\n\nWhen matching a regular expression using `#match` (either `String#match` or\n`Regex#match`), the returned value will be a `Regex::MatchData` if the expression\nmatched, `nil` otherwise.\n\n```\n/hay/.match(\"haystack\")    # => #<Regex::MatchData \"hay\">\n\"haystack\".match(/hay/)    # => #<Regex::MatchData \"hay\">\n$~                         # => #<Regex::MatchData \"hay\">\n/needle/.match(\"haystack\") # => nil\n\"haystack\".match(/needle/) # => nil\n$~                         # raises Exception\n```\n\n[Regular expressions](https://en.wikipedia.org/wiki/Regular_expression)\nhave their own language for describing strings.\n\nMany programming languages and tools implement their own regular expression\nlanguage, but Crystal uses [PCRE](http://www.pcre.org/), a popular C library\nfor providing regular expressions. Here give a brief summary of the most\nbasic features of regular expressions - grouping, repetition, and\nalternation - but the feature set of PCRE extends far beyond these, and we\ndon't attempt to describe it in full here. For more information, refer to\nthe PCRE documentation, especially the\n[full pattern syntax](http://www.pcre.org/original/doc/html/pcrepattern.html)\nor\n[syntax quick reference](http://www.pcre.org/original/doc/html/pcresyntax.html).\n\nThe regular expression language can be used to match much more than just the\nstatic substrings in the above examples. Certain characters, called\n[metacharacters](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC4),\nare given special treatment in regular expressions, and can be used to\ndescribe more complex patterns. To match metacharacters literally in a\nregular expression, they must be escaped by being preceded with a backslash\n(`\\`). `escape` will do this automatically for a given String.\n\nA group of characters (often called a capture group or\n[subpattern](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC14))\ncan be identified by enclosing it in parentheses (`()`). The contents of\neach capture group can be extracted on a successful match:\n\n```\n/a(sd)f/.match(\"_asdf_\")                     # => #<Regex::MatchData \"asdf\" 1:\"sd\">\n/a(sd)f/.match(\"_asdf_\").try &.[1]           # => \"sd\"\n/a(?<grp>sd)f/.match(\"_asdf_\")               # => #<Regex::MatchData \"asdf\" grp:\"sd\">\n/a(?<grp>sd)f/.match(\"_asdf_\").try &.[\"grp\"] # => \"sd\"\n```\n\nCapture groups are indexed starting from 1. Methods that accept a capture\ngroup index will usually also accept 0 to refer to the full match. Capture\ngroups can also be given names, using the `(?&lt;name&gt;...)` syntax, as in the\nprevious example.\n\nFollowing a match, the special variables $N (e.g., $1, $2, $3, ...) can be used\nto access a capture group. Trying to access an invalid capture group will raise an\nexception. Note that it is possible to have a successful match with a nil capture:\n\n```\n/(spice)(s)?/.match(\"spice\") # => #<Regex::MatchData \"spice\" 1:\"spice\" 2:nil>\n$1                           # => \"spice\"\n$2                           # => raises Exception\n```\n\nThis can be mitigated by using the nilable version of the above: $N?,\n(e.g., $1? $2?, $3?, ...). Changing the above to use `$2?` instead of `$2`\nwould return `nil`. `$2?.nil?` would return `true`.\n\nA character or group can be\n[repeated](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC17)\nor made optional using an asterisk (`*` - zero or more), a plus sign\n(`+` - one or more), integer bounds in curly braces\n(`{n,m}`) (at least `n`, no more than `m`), or a question mark\n(`?`) (zero or one).\n\n```\n/fo*/.match(\"_f_\")         # => #<Regex::MatchData \"f\">\n/fo+/.match(\"_f_\")         # => nil\n/fo*/.match(\"_foo_\")       # => #<Regex::MatchData \"foo\">\n/fo{3,}/.match(\"_foo_\")    # => nil\n/fo{1,3}/.match(\"_foo_\")   # => #<Regex::MatchData \"foo\">\n/fo*/.match(\"_foo_\")       # => #<Regex::MatchData \"foo\">\n/fo*/.match(\"_foooooooo_\") # => #<Regex::MatchData \"foooooooo\">\n/fo{,3}/.match(\"_foooo_\")  # => nil\n/f(op)*/.match(\"fopopo\")   # => #<Regex::MatchData \"fopop\" 1: \"op\">\n/foo?bar/.match(\"foobar\")  # => #<Regex::MatchData \"foobar\">\n/foo?bar/.match(\"fobar\")   # => #<Regex::MatchData \"fobar\">\n```\n\nAlternatives can be separated using a\n[vertical bar](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC12)\n(`|`). Any single character can be represented by\n[dot](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC7)\n(`.`). When matching only one character, specific\nalternatives can be expressed as a\n[character class](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC9),\nenclosed in square brackets (`[]`):\n\n```\n/foo|bar/.match(\"foo\")     # => #<Regex::MatchData \"foo\">\n/foo|bar/.match(\"bar\")     # => #<Regex::MatchData \"bar\">\n/_(x|y)_/.match(\"_x_\")     # => #<Regex::MatchData \"_x_\" 1: \"x\">\n/_(x|y)_/.match(\"_y_\")     # => #<Regex::MatchData \"_y_\" 1: \"y\">\n/_(x|y)_/.match(\"_(x|y)_\") # => nil\n/_(x|y)_/.match(\"_(x|y)_\") # => nil\n/_._/.match(\"_x_\")         # => #<Regex::MatchData \"_x_\">\n/_[xyz]_/.match(\"_x_\")     # => #<Regex::MatchData \"_x_\">\n/_[a-z]_/.match(\"_x_\")     # => #<Regex::MatchData \"_x_\">\n/_[^a-z]_/.match(\"_x_\")    # => nil\n/_[^a-wy-z]_/.match(\"_x_\") # => #<Regex::MatchData \"_x_\">\n```\n\nRegular expressions can be defined with these 3\n[optional flags](http://www.pcre.org/original/doc/html/pcreapi.html#SEC11):\n\n* `i`: ignore case (PCRE_CASELESS)\n* `m`: multiline (PCRE_MULTILINE and PCRE_DOTALL)\n* `x`: extended (PCRE_EXTENDED)\n\n```\n/asdf/ =~ \"ASDF\"    # => nil\n/asdf/i =~ \"ASDF\"   # => 0\n/^z/i =~ \"ASDF\\nZ\"  # => nil\n/^z/im =~ \"ASDF\\nZ\" # => 5\n```\n\nPCRE supports other encodings, but Crystal strings are UTF-8 only, so Crystal\nregular expressions are also UTF-8 only (by default).\n\nPCRE optionally permits named capture groups (named subpatterns) to not be\nunique. Crystal exposes the name table of a `Regex` as a\n`Hash` of `String` => `Int32`, and therefore requires named capture groups to have\nunique names within a single `Regex`.","summary":"<p>A <code><a href=\"Regex.html\">Regex</a></code> represents a regular expression, a pattern that describes the contents of strings.</p>","class_methods":[{"id":"error?(source)-class-method","html_id":"error?(source)-class-method","name":"error?","doc":"Determines Regex's source validity. If it is, `nil` is returned.\nIf it's not, a `String` containing the error message is returned.\n\n```\nRegex.error?(\"(foo|bar)\") # => nil\nRegex.error?(\"(foo|bar\")  # => \"missing ) at 8\"\n```","summary":"<p>Determines Regex's source validity.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":""}],"args_string":"(source)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L268","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L268","def":{"name":"error?","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"re = LibPCRE.compile(source, ((Options::UTF_8 | Options::NO_UTF8_CHECK) | Options::DUPNAMES), out errptr, out erroffset, nil)\nif re\n  nil\nelse\n  \"#{String.new(errptr)} at #{erroffset}\"\nend\n"}},{"id":"escape(str):String-class-method","html_id":"escape(str):String-class-method","name":"escape","doc":"Returns a `String` constructed by escaping any metacharacters in *str*.\n\n```\nstring = Regex.escape(\"\\*?{}.\") # => \"\\\\*\\\\?\\\\{\\\\}\\\\.\"\n/#{string}/                     # => /\\*\\?\\{\\}\\./\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> constructed by escaping any metacharacters in <em>str</em>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"args_string":"(str) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L304","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L304","def":{"name":"escape","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |result|\n  str.each_byte do |byte|\n    {% if true %}\n          case byte.unsafe_chr\n          when {{ *SPECIAL_CHARACTERS }}\n            result << '\\\\'\n            result.write_byte byte\n          else\n            result.write_byte byte\n          end\n        {% end %}\n  end\nend"}},{"id":"needs_escape?(char:Char):Bool-class-method","html_id":"needs_escape?(char:Char):Bool-class-method","name":"needs_escape?","doc":"Returns `true` if *char* need to be escaped, `false` otherwise.\n\n```\nRegex.needs_escape?('*') # => true\nRegex.needs_escape?('@') # => false\n```","summary":"<p>Returns <code>true</code> if <em>char</em> need to be escaped, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L283","def":{"name":"needs_escape?","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"SPECIAL_CHARACTERS.includes?(char)"}},{"id":"needs_escape?(str:String):Bool-class-method","html_id":"needs_escape?(str:String):Bool-class-method","name":"needs_escape?","doc":"Returns `true` if *str* need to be escaped, `false` otherwise.\n\n```\nRegex.needs_escape?(\"10$\") # => true\nRegex.needs_escape?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if <em>str</em> need to be escaped, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L293","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L293","def":{"name":"needs_escape?","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"str.each_char do |char|\n  if SPECIAL_CHARACTERS.includes?(char)\n    return true\n  end\nend\nfalse\n"}}],"constructors":[{"id":"new(source:String,options:Options=Options::None)-class-method","html_id":"new(source:String,options:Options=Options::None)-class-method","name":"new","doc":"Creates a new `Regex` out of the given source `String`.\n\n```\nRegex.new(\"^a-z+:\\\\s+\\\\w+\")                   # => /^a-z+:\\s+\\w+/\nRegex.new(\"cat\", Regex::Options::IGNORE_CASE) # => /cat/i\noptions = Regex::Options::IGNORE_CASE | Regex::Options::EXTENDED\nRegex.new(\"dog\", options) # => /dog/ix\n```","summary":"<p>Creates a new <code><a href=\"Regex.html\">Regex</a></code> out of the given source <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"String"},{"name":"options","doc":null,"default_value":"Options::None","external_name":"options","restriction":"Options"}],"args_string":"(source : String, options : Options = <span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L249","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L249","def":{"name":"new","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"String"},{"name":"options","doc":null,"default_value":"Options::None","external_name":"options","restriction":"Options"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(source, options)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"union(patterns:Enumerable(Regex|String)):self-class-method","html_id":"union(patterns:Enumerable(Regex|String)):self-class-method","name":"union","doc":"Union. Returns a `Regex` that matches any of *patterns*.\n\nAll capture groups in the patterns after the first one will have their\nindexes offset.\n\n```\nre = Regex.union([/skiing/i, \"sledding\"])\nre.match(\"Skiing\")   # => #<Regex::MatchData \"Skiing\">\nre.match(\"sledding\") # => #<Regex::MatchData \"sledding\">\nre = Regex.union({/skiing/i, \"sledding\"})\nre.match(\"Skiing\")   # => #<Regex::MatchData \"Skiing\">\nre.match(\"sledding\") # => #<Regex::MatchData \"sledding\">\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(Regex | String)"}],"args_string":"(patterns : Enumerable(Regex | String)) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L333","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L333","def":{"name":"union","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Enumerable(Regex | String)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"new(patterns.map do |pattern|\n  union_part(pattern)\nend.join('|'))"}},{"id":"union(*patterns:Regex|String):self-class-method","html_id":"union(*patterns:Regex|String):self-class-method","name":"union","doc":"Union. Returns a `Regex` that matches any of *patterns*.\n\nAll capture groups in the patterns after the first one will have their\nindexes offset.\n\n```\nre = Regex.union(/skiing/i, \"sledding\")\nre.match(\"Skiing\")   # => #<Regex::MatchData \"Skiing\">\nre.match(\"sledding\") # => #<Regex::MatchData \"sledding\">\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Regex | String"}],"args_string":"(*patterns : Regex | String) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L347","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L347","def":{"name":"union","args":[{"name":"patterns","doc":null,"default_value":"","external_name":"patterns","restriction":"Regex | String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"union(patterns)"}}],"instance_methods":[{"id":"+(other)-instance-method","html_id":"+(other)-instance-method","name":"+","doc":"Union. Returns a `Regex` that matches either of the operands.\n\nAll capture groups in the second operand will have their indexes\noffset.\n\n```\nre = /skiing/i + /sledding/\nre.match(\"Skiing\")   # => #<Regex::MatchData \"Skiing\">\nre.match(\"sledding\") # => #<Regex::MatchData \"sledding\">\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L369","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L369","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Regex.union(self, other)"}},{"id":"==(other:Regex)-instance-method","html_id":"==(other:Regex)-instance-method","name":"==","doc":"Equality. Two regexes are equal if their sources and options are the same.\n\n```\n/abc/ == /abc/i  # => false\n/abc/i == /ABC/i # => false\n/abc/i == /abc/i # => true\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Regex"}],"args_string":"(other : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L380","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(source == other.source) && (options == other.options)"}},{"id":"===(other:String)-instance-method","html_id":"===(other:String)-instance-method","name":"===","doc":"Case equality. This is equivalent to `#match` or `#=~` but only returns\n`true` or `false`. Used in `case` expressions. The special variable\n`$~` will contain a `Regex::MatchData` if there was a match, `nil` otherwise.\n\n```\na = \"HELLO\"\nb = case a\n    when /^[a-z]*$/\n      \"Lower case\"\n    when /^[A-Z]*$/\n      \"Upper case\"\n    else\n      \"Mixed case\"\n    end\nb # => \"Upper case\"\n```","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"args_string":"(other : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L400","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = match(other)\n$~ = match\n!match.nil?\n"}},{"id":"===(other:JSON::Any)-instance-method","html_id":"===(other:JSON::Any)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L295","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value = self === other.raw\n$~ = $~\nvalue\n"}},{"id":"===(other:YAML::Any)-instance-method","html_id":"===(other:YAML::Any)-instance-method","name":"===","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L306","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value = self === other.raw\n$~ = $~\nvalue\n"}},{"id":"=~(other:String)-instance-method","html_id":"=~(other:String)-instance-method","name":"=~","doc":"Match. Matches a regular expression against *other* and returns\nthe starting position of the match if *other* is a matching `String`,\notherwise `nil`. `$~` will contain a `Regex::MatchData` if there was a match,\n`nil` otherwise.\n\n```\n/at/ =~ \"input data\" # => 7\n/ax/ =~ \"input data\" # => nil\n```","summary":"<p>Match.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"args_string":"(other : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L415","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L415","def":{"name":"=~","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = self.match(other)\n$~ = match\nmatch.try(&.begin(0))\n"}},{"id":"=~(other)-instance-method","html_id":"=~(other)-instance-method","name":"=~","doc":"Match. When the argument is not a `String`, always returns `nil`.\n\n```\n/at/ =~ \"input data\" # => 7\n/ax/ =~ \"input data\" # => nil\n```","summary":"<p>Match.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L427","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L427","def":{"name":"=~","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"nil"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L572","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L572","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L568","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L568","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Convert to `String` in literal format. Returns the source as a `String` in\nRegex literal format, delimited in forward slashes (`/`), with any\noptional flags included.\n\n```\n/ab+c/ix.inspect # => \"/ab+c/ix\"\n```","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in literal format.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L438","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L438","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '/'\nRegex.append_source(source, io)\nio << '/'\nif options.ignore_case?\n  io << 'i'\nend\nif options.multiline?\n  io << 'm'\nend\nif options.extended?\n  io << 'x'\nend\n"}},{"id":"match(str,pos=0,options=Regex::Options::None):MatchData?-instance-method","html_id":"match(str,pos=0,options=Regex::Options::None):MatchData?-instance-method","name":"match","doc":"Match at character index. Matches a regular expression against `String`\n*str*. Starts at the character index given by *pos* if given, otherwise at\nthe start of *str*. Returns a `Regex::MatchData` if *str* matched, otherwise\n`nil`. `$~` will contain the same value that was returned.\n\n```\n/(.)(.)(.)/.match(\"abc\").try &.[2]   # => \"b\"\n/(.)(.)/.match(\"abc\", 1).try &.[2]   # => \"c\"\n/(.)(.)/.match(\"クリスタル\", 3).try &.[2] # => \"ル\"\n```","summary":"<p>Match at character index.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""},{"name":"options","doc":null,"default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, pos = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : MatchData?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L457","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L457","def":{"name":"match","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""},{"name":"options","doc":null,"default_value":"Regex::Options::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MatchData | ::Nil","visibility":"Public","body":"if byte_index = str.char_index_to_byte_index(pos)\n  match = match_at_byte_index(str, byte_index, options)\nelse\n  match = nil\nend\n$~ = match\n"}},{"id":"match_at_byte_index(str,byte_index=0,options=Regex::Options::None):MatchData?-instance-method","html_id":"match_at_byte_index(str,byte_index=0,options=Regex::Options::None):MatchData?-instance-method","name":"match_at_byte_index","doc":"Match at byte index. Matches a regular expression against `String`\n*str*. Starts at the byte index given by *pos* if given, otherwise at\nthe start of *str*. Returns a `Regex::MatchData` if *str* matched, otherwise\n`nil`. `$~` will contain the same value that was returned.\n\n```\n/(.)(.)(.)/.match_at_byte_index(\"abc\").try &.[2]   # => \"b\"\n/(.)(.)/.match_at_byte_index(\"abc\", 1).try &.[2]   # => \"c\"\n/(.)(.)/.match_at_byte_index(\"クリスタル\", 3).try &.[2] # => \"ス\"\n```","summary":"<p>Match at byte index.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"byte_index","doc":null,"default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","doc":null,"default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, byte_index = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : MatchData?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L477","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L477","def":{"name":"match_at_byte_index","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":""},{"name":"byte_index","doc":null,"default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","doc":null,"default_value":"Regex::Options::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MatchData | ::Nil","visibility":"Public","body":"if byte_index > str.bytesize\n  return (  $~ = nil)\nend\novector_size = (@captures + 1) * 3\novector = Pointer(Int32).malloc(ovector_size)\nret = LibPCRE.exec(@re, @extra, str, str.bytesize, byte_index, (options | Options::NO_UTF8_CHECK), ovector, ovector_size)\nif ret > 0\n  match = MatchData.new(self, @re, str, byte_index, ovector, @captures)\nelse\n  match = nil\nend\n$~ = match\n"}},{"id":"name_table:Hash(UInt16,String)-instance-method","html_id":"name_table:Hash(UInt16,String)-instance-method","name":"name_table","doc":"Returns a `Hash` where the values are the names of capture groups and the\nkeys are their indexes. Non-named capture groups will not have entries in\nthe `Hash`. Capture groups are indexed starting from `1`.\n\n```\n/(.)/.name_table                         # => {}\n/(?<foo>.)/.name_table                   # => {1 => \"foo\"}\n/(?<foo>.)(?<bar>.)/.name_table          # => {2 => \"bar\", 1 => \"foo\"}\n/(.)(?<foo>.)(.)(?<bar>.)(.)/.name_table # => {4 => \"bar\", 2 => \"foo\"}\n```","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> where the values are the names of capture groups and the keys are their indexes.</p>","abstract":false,"args":[],"args_string":" : Hash(UInt16, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L502","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L502","def":{"name":"name_table","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(UInt16, String)","visibility":"Public","body":"LibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMECOUNT, out name_count)\nLibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMEENTRYSIZE, out name_entry_size)\ntable_pointer = Pointer(UInt8).null\nLibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMETABLE, (pointerof(table_pointer)).as(Pointer(Int32)))\nname_table = table_pointer.to_slice(name_entry_size * name_count)\nlookup = Hash(UInt16, String).new\nname_count.times do |i|\n  capture_offset = i * name_entry_size\n  capture_number = (name_table[capture_offset].to_u16 << 8) | name_table[capture_offset + 1].to_u16\n  name_offset = capture_offset + 2\n  name = String.new((name_table + name_offset).pointer(name_entry_size - 3))\n  lookup[capture_number] = name\nend\nlookup\n"}},{"id":"options:Options-instance-method","html_id":"options:Options-instance-method","name":"options","doc":"Return a `Regex::Options` representing the optional flags applied to this `Regex`.\n\n```\n/ab+c/ix.options      # => Regex::Options::IGNORE_CASE | Regex::Options::EXTENDED\n/ab+c/ix.options.to_s # => \"IGNORE_CASE | EXTENDED\"\n```","summary":"<p>Return a <code><a href=\"Regex/Options.html\">Regex::Options</a></code> representing the optional flags applied to this <code><a href=\"Regex.html\">Regex</a></code>.</p>","abstract":false,"args":[],"args_string":" : Options","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L232","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L232","def":{"name":"options","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Options","visibility":"Public","body":"@options"}},{"id":"source:String-instance-method","html_id":"source:String-instance-method","name":"source","doc":"Return the original `String` representation of the `Regex` pattern.\n\n```\n/ab+c/x.source # => \"ab+c\"\n```","summary":"<p>Return the original <code><a href=\"String.html\">String</a></code> representation of the <code><a href=\"Regex.html\">Regex</a></code> pattern.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L239","def":{"name":"source","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@source"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Convert to `String` in subpattern format. Produces a `String` which can be\nembedded in another `Regex` via interpolation, where it will be interpreted\nas a non-capturing subexpression in another regular expression.\n\n```\nre = /A*/i                 # => /A*/i\nre.to_s                    # => \"(?i-msx:A*)\"\n\"Crystal\".match(/t#{re}l/) # => #<Regex::MatchData \"tal\">\nre = /A*/                  # => \"(?-imsx:A*)\"\n\"Crystal\".match(/t#{re}l/) # => nil\n```","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in subpattern format.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L535","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L535","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"(?\"\nif options.ignore_case?\n  io << 'i'\nend\nif options.multiline?\n  io << \"ms\"\nend\nif options.extended?\n  io << 'x'\nend\nio << '-'\nif options.ignore_case?\nelse\n  io << 'i'\nend\nif options.multiline?\nelse\n  io << \"ms\"\nend\nif options.extended?\nelse\n  io << 'x'\nend\nio << ':'\nRegex.append_source(source, io)\nio << ')'\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Regex/MatchData","path":"Regex/MatchData.html","kind":"struct","full_name":"Regex::MatchData","name":"MatchData","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"regex/match_data.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},"doc":"`Regex::MatchData` is the type of the special variable `$~`, and is the type\nreturned by `Regex#match` and `String#match`. It encapsulates all the\nresults of a regular expression match.\n\n```\nif md = \"Crystal\".match(/[p-s]/)\n  md.string # => \"Crystal\"\n  md[0]     # => \"r\"\n  md[1]?    # => nil\nend\n```\n\nMany `Regex::MatchData` methods deal with capture groups, and accept an integer\nargument to select the desired capture group. Capture groups are numbered\nstarting from `1`, so that `0` can be used to refer to the entire regular\nexpression without needing to capture it explicitly.","summary":"<p><code><a href=\"../Regex/MatchData.html\">Regex::MatchData</a></code> is the type of the special variable <code>$~</code>, and is the type returned by <code><a href=\"../Regex.html#match%28str%2Cpos%3D0%2Coptions%3DRegex%3A%3AOptions%3A%3ANone%29%3AMatchData%3F-instance-method\">Regex#match</a></code> and <code><a href=\"../String.html#match%28regex%3ARegex%2Cpos%3D0%29%3ARegex%3A%3AMatchData%3F-instance-method\">String#match</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"==(other:Regex::MatchData)-instance-method","html_id":"==(other:Regex::MatchData)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Regex::MatchData"}],"args_string":"(other : Regex::MatchData)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L372","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L372","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Regex::MatchData"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nif regex == other.regex\nelse\n  return false\nend\nif string == other.string\nelse\n  return false\nend\nreturn (@ovector.memcmp(other.@ovector, size * 2)) == 0\n"}},{"id":"[](group_name:String)-instance-method","html_id":"[](group_name:String)-instance-method","name":"[]","doc":"Returns the match of the capture group named by *group_name*, or\nraises an `KeyError` if there is no such named capture group.\n\n```\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ok\"] # => \"ys\"\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ng\"] # raises KeyError\n```\n\nWhen there are capture groups having same name, it returns the last\nmatched capture group.\n\n```\n\"Crystal\".match(/(?<ok>Cr).*(?<ok>al)/).not_nil![\"ok\"] # => \"al\"\n```","summary":"<p>Returns the match of the capture group named by <em>group_name</em>, or raises an <code><a href=\"../KeyError.html\">KeyError</a></code> if there is no such named capture group.</p>","abstract":false,"args":[{"name":"group_name","doc":null,"default_value":"","external_name":"group_name","restriction":"String"}],"args_string":"(group_name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L194","def":{"name":"[]","args":[{"name":"group_name","doc":null,"default_value":"","external_name":"group_name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = self[group_name]?\nif match\nelse\n  named_capture_number(group_name) do\n    raise(KeyError.new(\"Capture group '#{group_name}' was not matched\"))\n  end\n  raise(KeyError.new(\"Capture group '#{group_name}' does not exist\"))\nend\nmatch\n"}},{"id":"[](n)-instance-method","html_id":"[](n)-instance-method","name":"[]","doc":"Returns the match of the *n*th capture group, or raises an `IndexError`\nif there is no *n*th capture group.\n\n```\n\"Crystal\".match(/r(ys)/).not_nil![1] # => \"ys\"\n\"Crystal\".match(/r(ys)/).not_nil![2] # raises IndexError\n```","summary":"<p>Returns the match of the <em>n</em>th capture group, or raises an <code><a href=\"../IndexError.html\">IndexError</a></code> if there is no <em>n</em>th capture group.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L144","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L144","def":{"name":"[]","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\nvalue = self[n]?\nif value.nil?\n  raise_capture_group_was_not_matched(n)\nend\nvalue\n"}},{"id":"[]?(group_name:String)-instance-method","html_id":"[]?(group_name:String)-instance-method","name":"[]?","doc":"Returns the match of the capture group named by *group_name*, or\n`nil` if there is no such named capture group.\n\n```\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ok\"]? # => \"ys\"\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ng\"]? # => nil\n```\n\nWhen there are capture groups having same name, it returns the last\nmatched capture group.\n\n```\n\"Crystal\".match(/(?<ok>Cr).*(?<ok>al)/).not_nil![\"ok\"]? # => \"al\"\n```","summary":"<p>Returns the match of the capture group named by <em>group_name</em>, or <code>nil</code> if there is no such named capture group.</p>","abstract":false,"args":[{"name":"group_name","doc":null,"default_value":"","external_name":"group_name","restriction":"String"}],"args_string":"(group_name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L167","def":{"name":"[]?","args":[{"name":"group_name","doc":null,"default_value":"","external_name":"group_name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"max_start = -1\nmatch = nil\nnamed_capture_number(group_name) do |n|\n  start = @ovector[n * 2]\n  if start > max_start\n    max_start = start\n    match = self[n]?\n  end\nend\nmatch\n"}},{"id":"[]?(n)-instance-method","html_id":"[]?(n)-instance-method","name":"[]?","doc":"Returns the match of the *n*th capture group, or `nil` if there isn't\nan *n*th capture group.\n\nWhen *n* is `0`, returns the match for the entire `Regex`.\n\n```\n\"Crystal\".match(/r(ys)/).not_nil![0]? # => \"rys\"\n\"Crystal\".match(/r(ys)/).not_nil![1]? # => \"ys\"\n\"Crystal\".match(/r(ys)/).not_nil![2]? # => nil\n```","summary":"<p>Returns the match of the <em>n</em>th capture group, or <code>nil</code> if there isn't an <em>n</em>th capture group.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L127","def":{"name":"[]?","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if valid_group?(n)\nelse\n  return\nend\nif n < 0\n  n = n + size\nend\nstart = @ovector[n * 2]\nfinish = @ovector[(n * 2) + 1]\nif start < 0\n  return\nend\n@string.byte_slice(start, finish - start)\n"}},{"id":"begin(n=0)-instance-method","html_id":"begin(n=0)-instance-method","name":"begin","doc":"Return the position of the first character of the *n*th match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.begin(0)     # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.begin(1) # => 2\n\"クリスタル\".match(/リ(ス)/).not_nil!.begin(0)    # => 1\n```","summary":"<p>Return the position of the first character of the <em>n</em>th match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L67","def":{"name":"begin","args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@string.byte_index_to_char_index(byte_begin(n))"}},{"id":"byte_begin(n=0)-instance-method","html_id":"byte_begin(n=0)-instance-method","name":"byte_begin","doc":"Return the position of the first byte of the *n*th match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.byte_begin(0)     # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.byte_begin(1) # => 2\n\"クリスタル\".match(/リ(ス)/).not_nil!.byte_begin(0)    # => 3\n```","summary":"<p>Return the position of the first byte of the <em>n</em>th match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L95","def":{"name":"byte_begin","args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\n@ovector[n * 2]\n"}},{"id":"byte_end(n=0)-instance-method","html_id":"byte_end(n=0)-instance-method","name":"byte_end","doc":"Return the position of the next byte after the match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.byte_end(0)     # => 2\n\"Crystal\".match(/r(ys)/).not_nil!.byte_end(1) # => 4\n\"クリスタル\".match(/リ(ス)/).not_nil!.byte_end(0)    # => 9\n```","summary":"<p>Return the position of the next byte after the match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L111","def":{"name":"byte_end","args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\n@ovector[(n * 2) + 1]\n"}},{"id":"captures-instance-method","html_id":"captures-instance-method","name":"captures","doc":"Returns an array of unnamed capture groups.\n\nIt is a difference from `to_a` that the result array does not contain the match for the entire `Regex` (`self[0]`).\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.captures # => [\"Cr\", \"st\"]\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(stal)?/).not_nil!\nmatch.captures # => [\"Cr\", nil]\n```","summary":"<p>Returns an array of unnamed capture groups.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L252","def":{"name":"captures","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"name_table = @regex.name_table\ncaps = [] of String | ::Nil\n(1...size).each do |i|\n  if name_table.has_key?(i)\n  else\n    caps << self[i]?\n  end\nend\ncaps\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L368","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L364","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L364","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"end(n=0)-instance-method","html_id":"end(n=0)-instance-method","name":"end","doc":"Return the position of the next character after the match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.end(0)     # => 2\n\"Crystal\".match(/r(ys)/).not_nil!.end(1) # => 4\n\"クリスタル\".match(/リ(ス)/).not_nil!.end(0)    # => 3\n```","summary":"<p>Return the position of the next character after the match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L81","def":{"name":"end","args":[{"name":"n","doc":null,"default_value":"0","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@string.byte_index_to_char_index(byte_end(n))"}},{"id":"group_size:Int32-instance-method","html_id":"group_size:Int32-instance-method","name":"group_size","doc":"Returns the number of capture groups, including named capture groups.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.group_size          # => 0\n\"Crystal\".match(/r(ys)/).not_nil!.group_size          # => 1\n\"Crystal\".match(/r(ys)(?<ok>ta)/).not_nil!.group_size # => 2\n```","summary":"<p>Returns the number of capture groups, including named capture groups.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L33","def":{"name":"group_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@group_size"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L328","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L328","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"named_captures-instance-method","html_id":"named_captures-instance-method","name":"named_captures","doc":"Returns a hash of named capture groups.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.named_captures # => {\"name1\" => \"y\", \"name2\" => \"al\"}\n\n# When this regex has an optional group, result hash may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(?<name1>Cr)(?<name2>stal)?/).not_nil!\nmatch.named_captures # => {\"name1\" => \"Cr\", \"name2\" => nil}\n```","summary":"<p>Returns a hash of named capture groups.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L274","def":{"name":"named_captures","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"name_table = @regex.name_table\ncaps = {} of String => String | ::Nil\n(1...size).each do |i|\n  if (name = name_table[i]?) && (!(caps.has_key?(name)))\n    caps[name] = self[name]?\n  end\nend\ncaps\n"}},{"id":"post_match-instance-method","html_id":"post_match-instance-method","name":"post_match","doc":"Returns the part of the original string after the match. If the match ends\nat the end of the string, returns the empty string.\n\n```\n\"Crystal\".match(/yst/).not_nil!.post_match # => \"al\"\n```","summary":"<p>Returns the part of the original string after the match.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L235","def":{"name":"post_match","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@string.byte_slice(byte_end(0))"}},{"id":"pre_match-instance-method","html_id":"pre_match-instance-method","name":"pre_match","doc":"Returns the part of the original string before the match. If the match\nstarts at the start of the string, returns the empty string.\n\n```\n\"Crystal\".match(/yst/).not_nil!.pre_match # => \"Cr\"\n```","summary":"<p>Returns the part of the original string before the match.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L225","def":{"name":"pre_match","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@string.byte_slice(0, byte_begin(0))"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L343","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L343","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"name_table = @regex.name_table\npp.surround(\"Regex::MatchData(\", \")\", left_break: nil, right_break: nil) do\n  size.times do |i|\n    if i > 0\n      pp.breakable\n    end\n    pp.group do\n      if i == 0\n        self[i].pretty_print(pp)\n      else\n        pp.text(\"#{name_table.fetch(i, i)}:\")\n        pp.nest do\n          pp.breakable(\"\")\n          self[i]?.pretty_print(pp)\n        end\n      end\n    end\n  end\nend\n"}},{"id":"regex:Regex-instance-method","html_id":"regex:Regex-instance-method","name":"regex","doc":"Returns the original regular expression.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.regex # => /[p-s]/\n```","summary":"<p>Returns the original regular expression.</p>","abstract":false,"args":[],"args_string":" : Regex","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L24","def":{"name":"regex","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Regex","visibility":"Public","body":"@regex"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this match object.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.size          # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.size          # => 2\n\"Crystal\".match(/r(ys)(?<ok>ta)/).not_nil!.size # => 3\n```","summary":"<p>Returns the number of elements in this match object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L53","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"group_size + 1"}},{"id":"string:String-instance-method","html_id":"string:String-instance-method","name":"string","doc":"Returns the original string.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.string # => \"Crystal\"\n```","summary":"<p>Returns the original string.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L40","def":{"name":"string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@string"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":"Convert this match data into an array.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.to_a # => [\"Crystal\", \"Cr\", \"y\", \"st\", \"al\"]\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(?<name1>stal)?/).not_nil!\nmatch.to_a # => [\"Cr\", \"Cr\", nil]\n```","summary":"<p>Convert this match data into an array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L298","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(0...size).map do |i|\n  self[i]?\nend"}},{"id":"to_h-instance-method","html_id":"to_h-instance-method","name":"to_h","doc":"Convert this match data into a hash.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.to_h # => {0 => \"Crystal\", 1 => \"Cr\", \"name1\" => \"y\", 3 => \"st\", \"name2\" => \"al\"}\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(?<name1>stal)?/).not_nil!\nmatch.to_h # => {0 => \"Cr\", 1 => \"Cr\", \"name1\" => nil}\n```","summary":"<p>Convert this match data into a hash.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L313","def":{"name":"to_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"name_table = @regex.name_table\nhash = {} of String | Int32 => String | ::Nil\n(0...size).each do |i|\n  if name = name_table[i]?\n    if hash.has_key?(name)\n    else\n      hash[name] = self[name]?\n    end\n  else\n    hash[i] = self[i]?\n  end\nend\nhash\n"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L332","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex/match_data.cr#L332","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"name_table = @regex.name_table\nio << \"Regex::MatchData(\"\nsize.times do |i|\n  if i > 0\n    ((io << ' ') << (name_table.fetch(i, i))) << ':'\n  end\n  self[i]?.inspect(io)\nend\nio << ')'\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Regex/Options","path":"Regex/Options.html","kind":"enum","full_name":"Regex::Options","name":"Options","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"regex.cr","line_number":205,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"IGNORE_CASE","name":"IGNORE_CASE","value":"1","doc":null,"summary":null},{"id":"MULTILINE","name":"MULTILINE","value":"6","doc":"PCRE native `PCRE_MULTILINE` flag is `2`, and `PCRE_DOTALL` is `4`\n- `PCRE_DOTALL` changes the \"`.`\" meaning\n- `PCRE_MULTILINE` changes \"`^`\" and \"`$`\" meanings\n\nCrystal modifies this meaning to have essentially one unique \"`m`\"\nflag that activates both behaviours, so here we do the same by\nmapping `MULTILINE` to `PCRE_MULTILINE | PCRE_DOTALL`.","summary":"<p>PCRE native <code>PCRE_MULTILINE</code> flag is <code>2</code>, and <code>PCRE_DOTALL</code> is <code>4</code> - <code>PCRE_DOTALL</code> changes the \"<code>.</code>\" meaning - <code>PCRE_MULTILINE</code> changes \"<code>^</code>\" and \"<code>$</code>\" meanings</p>"},{"id":"EXTENDED","name":"EXTENDED","value":"8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"anchored?-instance-method","html_id":"anchored?-instance-method","name":"anchored?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L217","def":{"name":"anchored?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ANCHORED)"}},{"id":"dupnames?-instance-method","html_id":"dupnames?-instance-method","name":"dupnames?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L223","def":{"name":"dupnames?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(DUPNAMES)"}},{"id":"extended?-instance-method","html_id":"extended?-instance-method","name":"extended?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L215","def":{"name":"extended?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(EXTENDED)"}},{"id":"ignore_case?-instance-method","html_id":"ignore_case?-instance-method","name":"ignore_case?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L206","def":{"name":"ignore_case?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNORE_CASE)"}},{"id":"multiline?-instance-method","html_id":"multiline?-instance-method","name":"multiline?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L214","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L214","def":{"name":"multiline?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(MULTILINE)"}},{"id":"no_utf8_check?-instance-method","html_id":"no_utf8_check?-instance-method","name":"no_utf8_check?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L221","def":{"name":"no_utf8_check?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NO_UTF8_CHECK)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L205","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"utf_8?-instance-method","html_id":"utf_8?-instance-method","name":"utf_8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/regex.cr#L219","def":{"name":"utf_8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(UTF_8)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Set","path":"Set.html","kind":"struct","full_name":"Set(T)","name":"Set","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"set.cr","line_number":23,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr"},{"filename":"json/to_json.cr","line_number":71,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":89,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"`Set` implements a collection of unordered values with no duplicates.\n\nAn `Enumerable` object can be converted to `Set` using the `#to_set` method.\n\n`Set` uses `Hash` as storage, so you must note the following points:\n\n* Equality of elements is determined according to `Object#==` and `Object#hash`.\n* `Set` assumes that the identity of each element does not change while it is stored. Modifying an element of a set will render the set to an unreliable state.\n\n### Example\n\n```\ns1 = Set{1, 2}\ns2 = [1, 2].to_set\ns3 = Set.new [1, 2]\ns1 == s2 # => true\ns1 == s3 # => true\ns1.add(2)\ns1.concat([6, 8])\ns1.subset? s2 # => false\ns2.subset? s1 # => true\n```","summary":"<p><code><a href=\"Set.html\">Set</a></code> implements a collection of unordered values with no duplicates.</p>","class_methods":[],"constructors":[{"id":"new(other:Indexable(T))-class-method","html_id":"new(other:Indexable(T))-class-method","name":"new","doc":"Optimized version of `new` used when *other* is also an `Indexable`","summary":"<p>Optimized version of <code>new</code> used when <em>other</em> is also an <code><a href=\"Indexable.html\">Indexable</a></code></p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(T)"}],"args_string":"(other : Indexable(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L41","def":{"name":"new","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Indexable(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(Set(T).new(other.size)).concat(other)"}},{"id":"new(enumerable:Enumerable(T))-class-method","html_id":"new(enumerable:Enumerable(T))-class-method","name":"new","doc":"Creates a new set from the elements in *enumerable*.\n\n```\na = [1, 3, 5]\ns = Set.new a\ns.empty? # => false\n```","summary":"<p>Creates a new set from the elements in <em>enumerable</em>.</p>","abstract":false,"args":[{"name":"enumerable","doc":null,"default_value":"","external_name":"enumerable","restriction":"Enumerable(T)"}],"args_string":"(enumerable : Enumerable(T))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L52","def":{"name":"new","args":[{"name":"enumerable","doc":null,"default_value":"","external_name":"enumerable","restriction":"Enumerable(T)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Set(T).new.concat(enumerable)"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L115","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"set = new\npull.read_array do\n  set << (T.new(pull))\nend\nset\n"}},{"id":"new(initial_capacity=nil)-class-method","html_id":"new(initial_capacity=nil)-class-method","name":"new","doc":"Creates a new, empty `Set`.\n\n```\ns = Set(Int32).new\ns.empty? # => true\n```\n\nAn initial capacity can be specified, and it will be set as the initial capacity\nof the internal `Hash`.","summary":"<p>Creates a new, empty <code><a href=\"Set.html\">Set</a></code>.</p>","abstract":false,"args":[{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(initial_capacity = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L36","def":{"name":"new","args":[{"name":"initial_capacity","doc":null,"default_value":"nil","external_name":"initial_capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Set(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"&(other:Set)-instance-method","html_id":"&amp;(other:Set)-instance-method","name":"&","doc":"Intersection: returns a new set containing elements common to both sets.\n\n```\nSet{1, 1, 3, 5} & Set{1, 2, 3}               # => Set{1, 3}\nSet{'a', 'b', 'b', 'z'} & Set{'a', 'b', 'c'} # => Set{'a', 'b'}\n```","summary":"<p>Intersection: returns a new set containing elements common to both sets.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L165","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"smallest, largest = self, other\nif largest.size < smallest.size\n  smallest, largest = largest, smallest\nend\nset = Set(T).new\nsmallest.each do |value|\n  if largest.includes?(value)\n    set.add(value)\n  end\nend\nset\n"}},{"id":"-(other:Enumerable)-instance-method","html_id":"-(other:Enumerable)-instance-method","name":"-","doc":"Difference: returns a new set containing elements in this set that are not\npresent in the other enumerable.\n\n```\nSet{1, 2, 3, 4, 5} - [2, 4]               # => Set{1, 3, 5}\nSet{'a', 'b', 'b', 'z'} - ['a', 'b', 'c'] # => Set{'z'}\n```","summary":"<p>Difference: returns a new set containing elements in this set that are not present in the other enumerable.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L215","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"dup.subtract(other)"}},{"id":"-(other:Set)-instance-method","html_id":"-(other:Set)-instance-method","name":"-","doc":"Difference: returns a new set containing elements in this set that are not\npresent in the other.\n\n```\nSet{1, 2, 3, 4, 5} - Set{2, 4}               # => Set{1, 3, 5}\nSet{'a', 'b', 'b', 'z'} - Set{'a', 'b', 'c'} # => Set{'z'}\n```","summary":"<p>Difference: returns a new set containing elements in this set that are not present in the other.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L200","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"set = Set(T).new\neach do |value|\n  if other.includes?(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"id":"<<(object:T)-instance-method","html_id":"&lt;&lt;(object:T)-instance-method","name":"<<","doc":"Alias for `add`","summary":"<p>Alias for <code><a href=\"Set.html#add%28object%3AT%29-instance-method\">#add</a></code></p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L57","def":{"name":"<<","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"add(object)"}},{"id":"==(other:Set)-instance-method","html_id":"==(other:Set)-instance-method","name":"==","doc":"Returns `true` if both sets have the same elements.\n\n```\nSet{1, 5} == Set{1, 5} # => true\n```","summary":"<p>Returns <code>true</code> if both sets have the same elements.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L275","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(same?(other)) || (@hash == (other.@hash))"}},{"id":"===(object:T)-instance-method","html_id":"===(object:T)-instance-method","name":"===","doc":"Same as `#includes?`.\n\nIt is for convenience with using on `case` statement.\n\n```\nred_like = Set{\"red\", \"pink\", \"violet\"}\nblue_like = Set{\"blue\", \"azure\", \"violet\"}\n\ncase \"violet\"\nwhen red_like & blue_like\n  puts \"red & blue like color!\"\nwhen red_like\n  puts \"red like color!\"\nwhen blue_like\n  puts \"blue like color!\"\nend\n```\n\nSee also: `Object#===`.","summary":"<p>Same as <code><a href=\"Set.html#includes%3F%28object%29-instance-method\">#includes?</a></code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L298","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L298","def":{"name":"===","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"includes?(object)"}},{"id":"^(other:Enumerable(U))forallU-instance-method","html_id":"^(other:Enumerable(U))forallU-instance-method","name":"^","doc":"Symmetric Difference: returns a new set `(self - other) | (other - self)`.\nEquivalently, returns `(self | other) - (self & other)`.\n\n```\nSet{1, 2, 3, 4, 5} ^ [2, 4, 6]            # => Set{1, 3, 5, 6}\nSet{'a', 'b', 'b', 'z'} ^ ['a', 'b', 'c'] # => Set{'z', 'c'}\n```","summary":"<p>Symmetric Difference: returns a new set <code>(self - other) | (other - self)</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable(U)"}],"args_string":"(other : Enumerable(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L244","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"set = Set(T | U).new(self)\nother.each do |value|\n  if includes?(value)\n    set.delete(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"id":"^(other:Set(U))forallU-instance-method","html_id":"^(other:Set(U))forallU-instance-method","name":"^","doc":"Symmetric Difference: returns a new set `(self - other) | (other - self)`.\nEquivalently, returns `(self | other) - (self & other)`.\n\n```\nSet{1, 2, 3, 4, 5} ^ Set{2, 4, 6}            # => Set{1, 3, 5, 6}\nSet{'a', 'b', 'b', 'z'} ^ Set{'a', 'b', 'c'} # => Set{'z', 'c'}\n```","summary":"<p>Symmetric Difference: returns a new set <code>(self - other) | (other - self)</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set(U)"}],"args_string":"(other : Set(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L226","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"set = Set(T | U).new\neach do |value|\n  if other.includes?(value)\n  else\n    set.add(value)\n  end\nend\nother.each do |value|\n  if includes?(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"id":"add(object:T)-instance-method","html_id":"add(object:T)-instance-method","name":"add","doc":"Adds *object* to the set and returns `self`.\n\n```\ns = Set{1, 5}\ns.includes? 8 # => false\ns << 8\ns.includes? 8 # => true\n```","summary":"<p>Adds <em>object</em> to the set and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(object : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L69","def":{"name":"add","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash[object] = nil\nself\n"}},{"id":"clear-instance-method","html_id":"clear-instance-method","name":"clear","doc":"Removes all elements in the set, and returns `self`.\n\n```\ns = Set{1, 5}\ns.size # => 2\ns.clear\ns.size # => 0\n```","summary":"<p>Removes all elements in the set, and returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L130","def":{"name":"clear","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.clear\nself\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Set` with all of the elements cloned.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with all of the elements cloned.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L308","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"clone = Set(T).new(self.size)\neach do |element|\n  clone << element.clone\nend\nclone\n"}},{"id":"concat(elems)-instance-method","html_id":"concat(elems)-instance-method","name":"concat","doc":"Adds `#each` element of *elems* to the set and returns `self`.\n\n```\ns = Set{1, 5}\ns.concat [5, 5, 8, 9]\ns.size # => 4\n```\n\nSee also: `#|` to merge two sets and return a new one.","summary":"<p>Adds <code><a href=\"Set.html#each-instance-method\">#each</a></code> element of <em>elems</em> to the set and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"elems","doc":null,"default_value":"","external_name":"elems","restriction":""}],"args_string":"(elems)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L83","def":{"name":"concat","args":[{"name":"elems","doc":null,"default_value":"","external_name":"elems","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"elems.each do |elem|\n  self << elem\nend\nself\n"}},{"id":"delete(object)-instance-method","html_id":"delete(object)-instance-method","name":"delete","doc":"Removes the *object* from the set and returns `self`.\n\n```\ns = Set{1, 5}\ns.includes? 5 # => true\ns.delete 5\ns.includes? 5 # => false\n```","summary":"<p>Removes the <em>object</em> from the set and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L107","def":{"name":"delete","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.delete(object)\nself\n"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Set` with all of the same elements.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with all of the same elements.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L303","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Set.new(self)"}},{"id":"each-instance-method","html_id":"each-instance-method","name":"each","doc":"Returns an iterator for each element of the set.","summary":"<p>Returns an iterator for each element of the set.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L155","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.each_key"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":"Yields each element of the set, and returns `self`.","summary":"<p>Yields each element of the set, and returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L148","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.each_key do |key|\n  yield key\nend"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if the set is empty.\n\n```\ns = Set(Int32).new\ns.empty? # => true\ns << 3\ns.empty? # => false\n```","summary":"<p>Returns <code>true</code> if the set is empty.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L143","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.empty?"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L335","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L335","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = @hash.hash(hasher)\nhasher\n"}},{"id":"includes?(object)-instance-method","html_id":"includes?(object)-instance-method","name":"includes?","doc":"Returns `true` if *object* exists in the set.\n\n```\ns = Set{1, 5}\ns.includes? 5 # => true\ns.includes? 9 # => false\n```","summary":"<p>Returns <code>true</code> if <em>object</em> exists in the set.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L95","def":{"name":"includes?","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.has_key?(object)"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":"Alias of `#to_s`.","summary":"<p>Alias of <code><a href=\"Set.html#to_s%28io%29-instance-method\">#to_s</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L326","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"intersects?(other:Set)-instance-method","html_id":"intersects?(other:Set)-instance-method","name":"intersects?","doc":"Returns `true` if the set and the given set have at least one element in\ncommon.\n\n```\nSet{1, 2, 3}.intersects? Set{4, 5} # => false\nSet{1, 2, 3}.intersects? Set{3, 4} # => true\n```","summary":"<p>Returns <code>true</code> if the set and the given set have at least one element in common.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L344","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L344","def":{"name":"intersects?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size < other.size\n  any? do |o|\n    other.includes?(o)\n  end\nelse\n  other.any? do |o|\n    includes?(o)\n  end\nend"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L330","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"pp.list(\"Set{\", self, \"}\")"}},{"id":"proper_subset?(other:Set)-instance-method","html_id":"proper_subset?(other:Set)-instance-method","name":"proper_subset?","doc":"Returns `true` if the set is a proper subset of the *other* set.\n\nThis set must have fewer elements than the *other* set, and all\nof elements in this set must be present in the *other* set.\n\n```\nSet{1, 5}.proper_subset? Set{1, 3, 5}    # => true\nSet{1, 3, 5}.proper_subset? Set{1, 3, 5} # => false\n```","summary":"<p>Returns <code>true</code> if the set is a proper subset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L382","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L382","def":{"name":"proper_subset?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other.size <= size\n  return false\nend\nall? do |value|\n  other.includes?(value)\nend\n"}},{"id":"proper_superset?(other:Set)-instance-method","html_id":"proper_superset?(other:Set)-instance-method","name":"proper_superset?","doc":"Returns `true` if the set is a superset of the *other* set.\n\nThe *other* must have the same or fewer elements than this set, and all of\nelements in the *other* set must be present in this set.\n\n```\nSet{1, 3, 5}.proper_superset? Set{1, 5}    # => true\nSet{1, 3, 5}.proper_superset? Set{1, 3, 5} # => false\n```","summary":"<p>Returns <code>true</code> if the set is a superset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L409","def":{"name":"proper_superset?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.proper_subset?(self)"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in the set.\n\n```\ns = Set{1, 5}\ns.size # => 2\n```","summary":"<p>Returns the number of elements in the set.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L118","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.size"}},{"id":"subset?(other:Set)-instance-method","html_id":"subset?(other:Set)-instance-method","name":"subset?","doc":"Returns `true` if the set is a subset of the *other* set.\n\nThis set must have the same or fewer elements than the *other* set, and all\nof elements in this set must be present in the *other* set.\n\n```\nSet{1, 5}.subset? Set{1, 3, 5}    # => true\nSet{1, 3, 5}.subset? Set{1, 3, 5} # => true\n```","summary":"<p>Returns <code>true</code> if the set is a subset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L368","def":{"name":"subset?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other.size < size\n  return false\nend\nall? do |value|\n  other.includes?(value)\nend\n"}},{"id":"subtract(other:Enumerable)-instance-method","html_id":"subtract(other:Enumerable)-instance-method","name":"subtract","doc":"Returns `self` after removing from it those elements that are present in\nthe given enumerable.\n\n```\nSet{'a', 'b', 'b', 'z'}.subtract Set{'a', 'b', 'c'} # => Set{'z'}\nSet{1, 2, 3, 4, 5}.subtract [2, 4, 6]               # => Set{1, 3, 5}\n```","summary":"<p>Returns <code>self</code> after removing from it those elements that are present in the given enumerable.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L263","def":{"name":"subtract","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Enumerable"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.each do |value|\n  delete(value)\nend\nself\n"}},{"id":"superset?(other:Set)-instance-method","html_id":"superset?(other:Set)-instance-method","name":"superset?","doc":"Returns `true` if the set is a superset of the *other* set.\n\nThe *other* must have the same or fewer elements than this set, and all of\nelements in the *other* set must be present in this set.\n\n```\nSet{1, 3, 5}.superset? Set{1, 5}    # => true\nSet{1, 3, 5}.superset? Set{1, 3, 5} # => true\n```","summary":"<p>Returns <code>true</code> if the set is a superset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L396","def":{"name":"superset?","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"other.subset?(self)"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":"Returns the elements as an `Array`.\n\n```\nSet{1, 5}.to_a # => [1,5]\n```","summary":"<p>Returns the elements as an <code><a href=\"Array.html\">Array</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L321","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L321","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@hash.keys"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L72","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.array do\n  each(&.to_json(json))\nend"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Writes a string representation of the set to *io*.","summary":"<p>Writes a string representation of the set to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L353","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L353","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"Set{\"\njoin(\", \", io, &.inspect(io))\nio << '}'\n"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L90","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.sequence do\n  each(&.to_yaml(yaml))\nend"}},{"id":"|(other:Set(U))forallU-instance-method","html_id":"|(other:Set(U))forallU-instance-method","name":"|","doc":"Union: returns a new set containing all unique elements from both sets.\n\n```\nSet{1, 1, 3, 5} | Set{1, 2, 3}               # => Set{1, 3, 5, 2}\nSet{'a', 'b', 'b', 'z'} | Set{'a', 'b', 'c'} # => Set{'a', 'b', 'z', 'c'}\n```\n\nSee also: `#concat` to add elements from a set to `self`.","summary":"<p>Union: returns a new set containing all unique elements from both sets.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set(U)"}],"args_string":"(other : Set(U)) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/set.cr#L186","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Set(U)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"set = Set(T | U).new(Math.max(size, other.size))\neach do |value|\n  set.add(value)\nend\nother.each do |value|\n  set.add(value)\nend\nset\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Signal","path":"Signal.html","kind":"enum","full_name":"Signal","name":"Signal","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"signal.cr","line_number":29,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"HUP","name":"HUP","value":"1","doc":null,"summary":null},{"id":"INT","name":"INT","value":"2","doc":null,"summary":null},{"id":"QUIT","name":"QUIT","value":"3","doc":null,"summary":null},{"id":"ILL","name":"ILL","value":"4","doc":null,"summary":null},{"id":"TRAP","name":"TRAP","value":"5","doc":null,"summary":null},{"id":"IOT","name":"IOT","value":"6","doc":null,"summary":null},{"id":"ABRT","name":"ABRT","value":"6","doc":null,"summary":null},{"id":"FPE","name":"FPE","value":"8","doc":null,"summary":null},{"id":"KILL","name":"KILL","value":"9","doc":null,"summary":null},{"id":"BUS","name":"BUS","value":"7","doc":null,"summary":null},{"id":"SEGV","name":"SEGV","value":"11","doc":null,"summary":null},{"id":"SYS","name":"SYS","value":"31","doc":null,"summary":null},{"id":"PIPE","name":"PIPE","value":"13","doc":null,"summary":null},{"id":"ALRM","name":"ALRM","value":"14","doc":null,"summary":null},{"id":"TERM","name":"TERM","value":"15","doc":null,"summary":null},{"id":"URG","name":"URG","value":"23","doc":null,"summary":null},{"id":"STOP","name":"STOP","value":"19","doc":null,"summary":null},{"id":"TSTP","name":"TSTP","value":"20","doc":null,"summary":null},{"id":"CONT","name":"CONT","value":"18","doc":null,"summary":null},{"id":"CHLD","name":"CHLD","value":"17","doc":null,"summary":null},{"id":"TTIN","name":"TTIN","value":"21","doc":null,"summary":null},{"id":"TTOU","name":"TTOU","value":"22","doc":null,"summary":null},{"id":"IO","name":"IO","value":"29","doc":null,"summary":null},{"id":"XCPU","name":"XCPU","value":"24","doc":null,"summary":null},{"id":"XFSZ","name":"XFSZ","value":"25","doc":null,"summary":null},{"id":"VTALRM","name":"VTALRM","value":"26","doc":null,"summary":null},{"id":"USR1","name":"USR1","value":"10","doc":null,"summary":null},{"id":"USR2","name":"USR2","value":"12","doc":null,"summary":null},{"id":"WINCH","name":"WINCH","value":"28","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Safely handle inter-process signals on POSIX systems.\n\nSignals are dispatched to the event loop and later processed in a dedicated\nfiber. Some received signals may never be processed when the program\nterminates.\n\n```\nputs \"Ctrl+C still has the OS default action (stops the program)\"\nsleep 3\n\nSignal::INT.trap do\n  puts \"Gotcha!\"\nend\nputs \"Ctrl+C will be caught from now on\"\nsleep 3\n\nSignal::INT.reset\nputs \"Ctrl+C is back to the OS default action\"\nsleep 3\n```\n\nNote:\n- An uncaught exception in a signal handler is a fatal error.","summary":"<p>Safely handle inter-process signals on POSIX systems.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"abrt?-instance-method","html_id":"abrt?-instance-method","name":"abrt?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L36","def":{"name":"abrt?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ABRT"}},{"id":"alrm?-instance-method","html_id":"alrm?-instance-method","name":"alrm?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L43","def":{"name":"alrm?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ALRM"}},{"id":"bus?-instance-method","html_id":"bus?-instance-method","name":"bus?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L39","def":{"name":"bus?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BUS"}},{"id":"chld?-instance-method","html_id":"chld?-instance-method","name":"chld?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L49","def":{"name":"chld?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CHLD"}},{"id":"cont?-instance-method","html_id":"cont?-instance-method","name":"cont?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L48","def":{"name":"cont?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CONT"}},{"id":"fpe?-instance-method","html_id":"fpe?-instance-method","name":"fpe?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L37","def":{"name":"fpe?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FPE"}},{"id":"hup?-instance-method","html_id":"hup?-instance-method","name":"hup?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L30","def":{"name":"hup?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HUP"}},{"id":"ignore:Nil-instance-method","html_id":"ignore:Nil-instance-method","name":"ignore","doc":"Clears the handler for this signal and prevents the OS default action.\n\nNote that trying to ignore `CHLD` will actually set the default crystal\nhandler that monitors and reaps child processes. This prevents zombie\nprocesses and is required by `Process#wait` for example.","summary":"<p>Clears the handler for this signal and prevents the OS default action.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L100","def":{"name":"ignore","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Crystal::Signal.ignore(self)"}},{"id":"ill?-instance-method","html_id":"ill?-instance-method","name":"ill?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L33","def":{"name":"ill?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ILL"}},{"id":"int?-instance-method","html_id":"int?-instance-method","name":"int?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L31","def":{"name":"int?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == INT"}},{"id":"io?-instance-method","html_id":"io?-instance-method","name":"io?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L52","def":{"name":"io?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IO"}},{"id":"iot?-instance-method","html_id":"iot?-instance-method","name":"iot?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L35","def":{"name":"iot?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IOT"}},{"id":"kill?-instance-method","html_id":"kill?-instance-method","name":"kill?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L38","def":{"name":"kill?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == KILL"}},{"id":"pipe?-instance-method","html_id":"pipe?-instance-method","name":"pipe?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L42","def":{"name":"pipe?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PIPE"}},{"id":"quit?-instance-method","html_id":"quit?-instance-method","name":"quit?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L32","def":{"name":"quit?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == QUIT"}},{"id":"reset:Nil-instance-method","html_id":"reset:Nil-instance-method","name":"reset","doc":"Resets the handler for this signal to the OS default.\n\nNote that trying to reset `CHLD` will actually set the default crystal\nhandler that monitors and reaps child processes. This prevents zombie\nprocesses and is required by `Process#wait` for example.","summary":"<p>Resets the handler for this signal to the OS default.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L91","def":{"name":"reset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"Crystal::Signal.reset(self)"}},{"id":"segv?-instance-method","html_id":"segv?-instance-method","name":"segv?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L40","def":{"name":"segv?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SEGV"}},{"id":"stop?-instance-method","html_id":"stop?-instance-method","name":"stop?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L46","def":{"name":"stop?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STOP"}},{"id":"sys?-instance-method","html_id":"sys?-instance-method","name":"sys?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L41","def":{"name":"sys?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SYS"}},{"id":"term?-instance-method","html_id":"term?-instance-method","name":"term?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L44","def":{"name":"term?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TERM"}},{"id":"trap(&handler:Signal->):Nil-instance-method","html_id":"trap(&amp;handler:Signal-&gt;):Nil-instance-method","name":"trap","doc":"Sets the handler for this signal to the passed function.\n\nAfter executing this, whenever the current process receives the\ncorresponding signal, the passed function will be called (instead of the OS\ndefault). The handler will run in a signal-safe fiber thought the event\nloop; there is no limit to what functions can be called, unlike raw signals\nthat run on the sigaltstack.\n\nNote that `CHLD` is always trapped and child processes will always be reaped\nbefore the custom handler is called, hence a custom `CHLD` handler must\ncheck child processes using `Process.exists?`. Trying to use waitpid with a\nzero or negative value won't work.","summary":"<p>Sets the handler for this signal to the passed function.</p>","abstract":false,"args":[],"args_string":"(&handler : Signal -> ) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L78","def":{"name":"trap","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"handler","doc":null,"default_value":"","external_name":"handler","restriction":"(Signal -> )"},"return_type":"Nil","visibility":"Public","body":"if self == CHLD\n  Crystal::Signal.child_handler = handler\nelse\n  Crystal::Signal.trap(self, handler)\nend"}},{"id":"trap?-instance-method","html_id":"trap?-instance-method","name":"trap?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L34","def":{"name":"trap?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TRAP"}},{"id":"tstp?-instance-method","html_id":"tstp?-instance-method","name":"tstp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L47","def":{"name":"tstp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TSTP"}},{"id":"ttin?-instance-method","html_id":"ttin?-instance-method","name":"ttin?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L50","def":{"name":"ttin?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TTIN"}},{"id":"ttou?-instance-method","html_id":"ttou?-instance-method","name":"ttou?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L51","def":{"name":"ttou?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TTOU"}},{"id":"urg?-instance-method","html_id":"urg?-instance-method","name":"urg?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L45","def":{"name":"urg?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == URG"}},{"id":"usr1?-instance-method","html_id":"usr1?-instance-method","name":"usr1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L56","def":{"name":"usr1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == USR1"}},{"id":"usr2?-instance-method","html_id":"usr2?-instance-method","name":"usr2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L57","def":{"name":"usr2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == USR2"}},{"id":"vtalrm?-instance-method","html_id":"vtalrm?-instance-method","name":"vtalrm?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L55","def":{"name":"vtalrm?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == VTALRM"}},{"id":"winch?-instance-method","html_id":"winch?-instance-method","name":"winch?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L58","def":{"name":"winch?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == WINCH"}},{"id":"xcpu?-instance-method","html_id":"xcpu?-instance-method","name":"xcpu?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L53","def":{"name":"xcpu?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == XCPU"}},{"id":"xfsz?-instance-method","html_id":"xfsz?-instance-method","name":"xfsz?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/signal.cr#L54","def":{"name":"xfsz?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == XFSZ"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Slice","path":"Slice.html","kind":"struct","full_name":"Slice(T)","name":"Slice","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"slice.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr"},{"filename":"yaml/from_yaml.cr","line_number":240,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr"},{"filename":"yaml/to_yaml.cr","line_number":133,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `Slice` is a `Pointer` with an associated size.\n\nWhile a pointer is unsafe because no bound checks are performed when reading from and writing to it,\nreading from and writing to a slice involve bound checks.\nIn this way, a slice is a safe alternative to `Pointer`.\n\nA Slice can be created as read-only: trying to write to it\nwill raise. For example the slice of bytes returned by\n`String#to_slice` is read-only.","summary":"<p>A <code><a href=\"Slice.html\">Slice</a></code> is a <code><a href=\"Pointer.html\">Pointer</a></code> with an associated size.</p>","class_methods":[{"id":"empty-class-method","html_id":"empty-class-method","name":"empty","doc":"Creates an empty slice.\n\n```\nslice = Slice(UInt8).empty\nslice.size # => 0\n```","summary":"<p>Creates an empty slice.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L136","def":{"name":"empty","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(Pointer(T).null, 0)"}}],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L241","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T != UInt8 %}\n      {% raise(\"Can only deserialize Slice(UInt8), not #{@type}}\") %}\n    {% end %}\nparse_scalar(ctx, node, self)\n"}},{"id":"new(pointer:Pointer(T),size:Int,*,read_only=false)-class-method","html_id":"new(pointer:Pointer(T),size:Int,*,read_only=false)-class-method","name":"new","doc":"Creates a slice to the given *pointer*, bounded by the given *size*. This\nmethod does not allocate heap memory.\n\n```\nptr = Pointer.malloc(9) { |i| ('a'.ord + i).to_u8 }\n\nslice = Slice.new(ptr, 3)\nslice.size # => 3\nslice      # => Bytes[97, 98, 99]\n\nString.new(slice) # => \"abc\"\n```","summary":"<p>Creates a slice to the given <em>pointer</em>, bounded by the given <em>size</em>.</p>","abstract":false,"args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"Pointer(T)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(pointer : Pointer(T), size : Int, *, read_only = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L67","def":{"name":"new","args":[{"name":"pointer","doc":null,"default_value":"","external_name":"pointer","restriction":"Pointer(T)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = Slice(T).allocate\n_.initialize(pointer, size, read_only: read_only)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(size:Int,value:T,*,read_only=false)-class-method","html_id":"new(size:Int,value:T,*,read_only=false)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to *value*\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\nslice = Slice.new(3, 10)\nslice # => Slice[10, 10, 10]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to <em>value</em> and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, value : T, *, read_only = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L118","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(size, read_only: read_only) do\n  value\nend"}},{"id":"new(size:Int,*,read_only=false)-class-method","html_id":"new(size:Int,*,read_only=false)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to zero\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\nOnly works for primitive integers and floats (`UInt8`, `Int32`, `Float64`, etc.)\n\n```\nslice = Slice(UInt8).new(3)\nslice # => Bytes[0, 0, 0]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to zero and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, *, read_only = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L83","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":1,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T <= Int::Primitive || T <= Float::Primitive %}{% else %}\n      {% raise(\"Can only use primitive integers and floats with Slice.new(size), not #{T}\") %}\n    {% end %}\npointer = Pointer(T).malloc(size)\nnew(pointer, size, read_only: read_only)\n"}},{"id":"new(size:Int,*,read_only=false,&block)-class-method","html_id":"new(size:Int,*,read_only=false,&amp;block)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to the value\nreturned by the block (which is invoked once with each index in the range `0...size`)\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\nslice = Slice.new(3) { |i| i + 10 }\nslice # => Slice[10, 11, 12]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to the value returned by the block (which is invoked once with each index in the range <code>0..<a href=\"Slice.html#size%3AInt32-instance-method\">.size</a></code>) and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, *, read_only = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L103","def":{"name":"new","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":1,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"pointer = Pointer.malloc(size) do |i|\n  yield i\nend\nnew(pointer, size, read_only: read_only)\n"}}],"instance_methods":[{"id":"+(offset:Int)-instance-method","html_id":"+(offset:Int)-instance-method","name":"+","doc":"Returns a new slice that is *offset* elements apart from this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice2 = slice + 2\nslice2 # => Slice[12, 13, 14]\n```","summary":"<p>Returns a new slice that is <em>offset</em> elements apart from this slice.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L149","def":{"name":"+","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= offset && offset <= size\nelse\n  raise(IndexError.new)\nend\nSlice.new(@pointer + offset, @size - offset, read_only: @read_only)\n"}},{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L470","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L470","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize != other.bytesize\n  return false\nend\nreturn (LibC.memcmp(to_unsafe.as(::Pointer(Void)), other.to_unsafe.as(::Pointer(Void)), bytesize)) == 0\n"}},{"id":"[](start,count)-instance-method","html_id":"[](start,count)-instance-method","name":"[]","doc":"Returns a new slice that starts at *start* elements from this slice's start,\nand of *count* size.\n\nRaises `IndexError` if the new slice falls outside this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice2 = slice[1, 3]\nslice2 # => Slice[11, 12, 13]\n```","summary":"<p>Returns a new slice that starts at <em>start</em> elements from this slice's start, and of <em>count</em> size.</p>","abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(start, count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L194","def":{"name":"[]","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= start && start <= @size\nelse\n  raise(IndexError.new)\nend\nif 0 <= count && count <= (@size - start)\nelse\n  raise(IndexError.new)\nend\nSlice.new(@pointer + start, count, read_only: @read_only)\n"}},{"id":"[]=(index:Int,value:T)-instance-method","html_id":"[]=(index:Int,value:T)-instance-method","name":"[]=","doc":"Sets the given value at the given *index*.\n\nNegative indices can be used to start counting from the end of the slice.\nRaises `IndexError` if trying to set an element outside the slice's range.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice[0] = 20\nslice[-1] = 30\nslice # => Slice[20, 11, 12, 13, 30]\n\nslice[10] = 1 # raises IndexError\n```","summary":"<p>Sets the given value at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L171","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L171","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\nif index < 0\n  index = index + size\nend\nif 0 <= index && index < size\nelse\n  raise(IndexError.new)\nend\n@pointer[index] = value\n"}},{"id":"bytesize-instance-method","html_id":"bytesize-instance-method","name":"bytesize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L466","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L466","def":{"name":"bytesize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(sizeof(T)) * size"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a copy of this slice.\nThis method allocates memory for the slice copy.","summary":"<p>Returns a copy of this slice.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L124","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"copy = self.class.new(size)\ncopy.copy_from(self)\ncopy\n"}},{"id":"copy_from(source:self)-instance-method","html_id":"copy_from(source:self)-instance-method","name":"copy_from","doc":"Copies the contents of *source* into this slice.\n\nRaises `IndexError` if the desination slice cannot fit the data being transferred.","summary":"<p>Copies the contents of <em>source</em> into this slice.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"self"}],"args_string":"(source : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L313","def":{"name":"copy_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"source.copy_to(self)"}},{"id":"copy_from(source:Pointer(T),count)-instance-method","html_id":"copy_from(source:Pointer(T),count)-instance-method","name":"copy_from","doc":null,"summary":null,"abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(source : Pointer(T), count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L281","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L281","def":{"name":"copy_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\n(pointer(count)).copy_from(source, count)\n"}},{"id":"copy_to(target:Pointer(T),count)-instance-method","html_id":"copy_to(target:Pointer(T),count)-instance-method","name":"copy_to","doc":null,"summary":null,"abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(target : Pointer(T), count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L287","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L287","def":{"name":"copy_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(pointer(count)).copy_to(target, count)"}},{"id":"copy_to(target:self)-instance-method","html_id":"copy_to(target:self)-instance-method","name":"copy_to","doc":"Copies the contents of this slice into *target*.\n\nRaises `IndexError` if the desination slice cannot fit the data being transferred\ne.g. dest.size < self.size.\n\n```\nsrc = Slice['a', 'a', 'a']\ndst = Slice['b', 'b', 'b', 'b', 'b']\nsrc.copy_to dst\ndst             # => Slice['a', 'a', 'a', 'b', 'b']\ndst.copy_to src # raises IndexError\n```","summary":"<p>Copies the contents of this slice into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"self"}],"args_string":"(target : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L303","def":{"name":"copy_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target.check_writable\n@pointer.copy_to(target.pointer(size), size)\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L539","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L539","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T == UInt8 %}\n      hasher.bytes(self)\n    {% else %}\n      super hasher\n    {% end %}"}},{"id":"hexdump-instance-method","html_id":"hexdump-instance-method","name":"hexdump","doc":"Returns a hexdump of this slice, assuming it's a `Slice(UInt8)`.\nThis method is specially useful for debugging binary data and\nincoming/outgoing data in protocols.\n\n```\nslice = UInt8.slice(97, 62, 63, 8, 255)\nslice.hexdump # => \"00000000  61 3e 3f 08 ff                                    a>?..\"\n```","summary":"<p>Returns a hexdump of this slice, assuming it's a <code><a href=\"Slice.html\">Slice</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L400","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L400","def":{"name":"hexdump","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.as(Slice(UInt8))\nif empty?\n  return \"\"\nend\nfull_lines, leftover = size.divmod(16)\nif leftover == 0\n  str_size = (full_lines * 77) - 1\n  lines = full_lines\nelse\n  str_size = (((full_lines + 1) * 77) - (16 - leftover)) - 1\n  lines = full_lines + 1\nend\nString.new(str_size) do |buf|\n  index_offset = 0\n  hex_offset = 10\n  ascii_offset = 60\n  buffer = Slice.new(buf, str_size)\n  each_with_index do |v, i|\n    if (i % 16) == 0\n      0.upto(7) do |j|\n        buffer[(index_offset + 7) - j] = to_hex((i >> (4 * j)) & 15)\n      end\n      buffer[index_offset + 8] = ' '.ord.to_u8\n      buffer[index_offset + 9] = ' '.ord.to_u8\n      index_offset = index_offset + 77\n    end\n    buffer[hex_offset] = to_hex(v >> 4)\n    buffer[hex_offset + 1] = to_hex(v & 15)\n    buffer[hex_offset + 2] = ' '.ord.to_u8\n    hex_offset = hex_offset + 3\n    buffer[ascii_offset] = (    v > 31 && v < 127) ? v : '.'.ord.to_u8\n    ascii_offset = ascii_offset + 1\n    if (i % 8) == 7\n      buffer[hex_offset] = ' '.ord.to_u8\n      hex_offset = hex_offset + 1\n    end\n    if ((i % 16) == 15) && ascii_offset < str_size\n      buffer[ascii_offset] = '\\n'.ord.to_u8\n      hex_offset = hex_offset + 27\n      ascii_offset = ascii_offset + 61\n    end\n  end\n  while (hex_offset % 77) < 60\n    buffer[hex_offset] = ' '.ord.to_u8\n    hex_offset = hex_offset + 1\n  end\n  {str_size, str_size}\nend\n"}},{"id":"hexstring-instance-method","html_id":"hexstring-instance-method","name":"hexstring","doc":"Returns a hexstring representation of this slice, assuming it's\na `Slice(UInt8)`.\n\n```\nslice = UInt8.slice(97, 62, 63, 8, 255)\nslice.hexstring # => \"613e3f08ff\"\n```","summary":"<p>Returns a hexstring representation of this slice, assuming it's a <code><a href=\"Slice.html\">Slice</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L368","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L368","def":{"name":"hexstring","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.as(Slice(UInt8))\nstr_size = size * 2\nString.new(str_size) do |buffer|\n  hexstring(buffer)\n  {str_size, str_size}\nend\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L357","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L357","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"map(*,read_only=false,&block:T->U)forallU-instance-method","html_id":"map(*,read_only=false,&amp;block:T-&gt;U)forallU-instance-method","name":"map","doc":"Returns a new slice where elements are mapped by the given block.\n\n```\nslice = Slice[1, 2.5, \"a\"]\nslice.map &.to_s # => Slice[\"1\", \"2.5\", \"a\"]\n```","summary":"<p>Returns a new slice where elements are mapped by the given block.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*, read_only = <span class=\"n\">false</span>, &block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L264","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L264","def":{"name":"map","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":0,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"Slice.new(size, read_only: read_only) do |i|\n  yield @pointer[i]\nend"}},{"id":"map!(&block)-instance-method","html_id":"map!(&amp;block)-instance-method","name":"map!","doc":"Invokes the given block for each element of `self`, replacing the element\nwith the value returned by the block. Returns `self`.\n\n```\nslice = Slice[1, 2, 3]\nslice.map! { |x| x * x }\nslice # => Slice[1, 4, 9]\n```","summary":"<p>Invokes the given block for each element of <code>self</code>, replacing the element with the value returned by the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L251","def":{"name":"map!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\n@pointer.map!(size) do |e|\n  yield e\nend\nself\n"}},{"id":"map_with_index(*,read_only=false,&block:T,Int32->U)forallU-instance-method","html_id":"map_with_index(*,read_only=false,&amp;block:T,Int32-&gt;U)forallU-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.","summary":"<p>Like <code><a href=\"Slice.html#map%28%2A%2Cread_only%3Dfalse%2C%26block%3AT-%3EU%29forallU-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*, read_only = <span class=\"n\">false</span>, &block : T, Int32 -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L277","def":{"name":"map_with_index","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":0,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> U)"},"return_type":"","visibility":"Public","body":"Slice.new(size, read_only: read_only) do |i|\n  yield @pointer[i], i\nend"}},{"id":"map_with_index!(&block:T,Int32->T)-instance-method","html_id":"map_with_index!(&amp;block:T,Int32-&gt;T)-instance-method","name":"map_with_index!","doc":"Like `map!`, but the block gets passed both the element and its index.","summary":"<p>Like <code><a href=\"Slice.html#map%21%28%26block%29-instance-method\">#map!</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L269","def":{"name":"map_with_index!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> T)"},"return_type":"","visibility":"Public","body":"check_writable\n@pointer.map_with_index!(size) do |e, i|\n  yield e, i\nend\nself\n"}},{"id":"move_from(source:self)-instance-method","html_id":"move_from(source:self)-instance-method","name":"move_from","doc":"Moves the contents of *source* into this slice. *source* and `self` may\noverlap; the copy is always done in a non-destructive manner.\n\nRaises `IndexError` if the desination slice cannot fit the data being transferred.","summary":"<p>Moves the contents of <em>source</em> into this slice.</p>","abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"self"}],"args_string":"(source : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L353","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L353","def":{"name":"move_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"source.move_to(self)"}},{"id":"move_from(source:Pointer(T),count)-instance-method","html_id":"move_from(source:Pointer(T),count)-instance-method","name":"move_from","doc":null,"summary":null,"abstract":false,"args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(source : Pointer(T), count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L317","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L317","def":{"name":"move_from","args":[{"name":"source","doc":null,"default_value":"","external_name":"source","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\n(pointer(count)).move_from(source, count)\n"}},{"id":"move_to(target:Pointer(T),count)-instance-method","html_id":"move_to(target:Pointer(T),count)-instance-method","name":"move_to","doc":null,"summary":null,"abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(target : Pointer(T), count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L323","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L323","def":{"name":"move_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"Pointer(T)"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(pointer(count)).move_to(target, count)"}},{"id":"move_to(target:self)-instance-method","html_id":"move_to(target:self)-instance-method","name":"move_to","doc":"Moves the contents of this slice into *target*. *target* and `self` may\noverlap; the copy is always done in a non-destructive manner.\n\nRaises `IndexError` if the desination slice cannot fit the data being transferred\ne.g. `dest.size < self.size`.\n\n```\nsrc = Slice['a', 'a', 'a']\ndst = Slice['b', 'b', 'b', 'b', 'b']\nsrc.move_to dst\ndst             # => Slice['a', 'a', 'a', 'b', 'b']\ndst.move_to src # raises IndexError\n```\n\nSee also: `Pointer#move_to`.","summary":"<p>Moves the contents of this slice into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"self"}],"args_string":"(target : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L342","def":{"name":"move_to","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"target.check_writable\n@pointer.move_to(target.pointer(size), size)\n"}},{"id":"pointer(size)-instance-method","html_id":"pointer(size)-instance-method","name":"pointer","doc":null,"summary":null,"abstract":false,"args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L229","def":{"name":"pointer","args":[{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= size && size <= @size\nelse\n  raise(IndexError.new)\nend\n@pointer\n"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L492","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L492","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"prefix = T == UInt8 ? \"Bytes[\" : \"Slice[\"\npp.list(prefix, self, \"]\")\n"}},{"id":"read_only?:Bool-instance-method","html_id":"read_only?:Bool-instance-method","name":"read_only?","doc":"Returns `true` if this slice cannot be written to.","summary":"<p>Returns <code>true</code> if this slice cannot be written to.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L53","def":{"name":"read_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@read_only"}},{"id":"reverse!-instance-method","html_id":"reverse!-instance-method","name":"reverse!","doc":"Reverses in-place all the elements of `self`.","summary":"<p>Reverses in-place all the elements of <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L212","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L212","def":{"name":"reverse!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\nif size <= 1\n  return self\nend\np = @pointer\nq = (@pointer + size) - 1\nwhile p < q\n  p.value, q.value = q.value, p.value\n  p = p + 1\n  q = q - 1\nend\nself\n"}},{"id":"shuffle!(random=Random::DEFAULT)-instance-method","html_id":"shuffle!(random=Random::DEFAULT)-instance-method","name":"shuffle!","doc":null,"summary":null,"abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L237","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L237","def":{"name":"shuffle!","args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_writable\n@pointer.shuffle!(size, random)\n"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":"Returns the size of this slice.\n\n```\nSlice(UInt8).new(3).size # => 3\n```","summary":"<p>Returns the size of this slice.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L50","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L50","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"to_a-instance-method","html_id":"to_a-instance-method","name":"to_a","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L497","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L497","def":{"name":"to_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array(T).build(@size) do |pointer|\n  pointer.copy_from(@pointer, @size)\n  @size\nend"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L479","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L479","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if T == UInt8\n  io << \"Bytes[\"\n  join(\", \", io, &.to_s(io))\n  io << ']'\nelse\n  io << \"Slice[\"\n  join(\", \", io, &.inspect(io))\n  io << ']'\nend"}},{"id":"to_slice-instance-method","html_id":"to_slice-instance-method","name":"to_slice","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L475","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L475","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_unsafe:Pointer(T)-instance-method","html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns this slice's pointer.\n\n```\nslice = Slice.new(3, 10)\nslice.to_unsafe[0] # => 10\n```","summary":"<p>Returns this slice's pointer.</p>","abstract":false,"args":[],"args_string":" : Pointer(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L510","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L510","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Pointer(T)","visibility":"Public","body":"@pointer"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L134","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T != UInt8 %}\n      {% raise(\"Can only serialize Slice(UInt8), not #{@type}}\") %}\n    {% end %}\nyaml.scalar(Base64.encode(self), tag: \"tag:yaml.org,2002:binary\")\n"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L207","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@pointer[index]"}}],"macros":[{"id":"[](*args,read_only=false)-macro","html_id":"[](*args,read_only=false)-macro","name":"[]","doc":"Create a new `Slice` with the given *args*. The type of the\nslice will be the union of the type of the given *args*.\n\nThe slice is allocated on the heap.\n\n```\nslice = Slice[1, 'a']\nslice[0]    # => 1\nslice[1]    # => 'a'\nslice.class # => Slice(Char | Int32)\n```\n\nIf `T` is a `Number` then this is equivalent to\n`Number.slice` (numbers will be coerced to the type `T`)\n\nSee also: `Number.slice`.","summary":"<p>Create a new <code><a href=\"Slice.html\">Slice</a></code> with the given <em>args</em>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*args, read_only = false)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/slice.cr#L31","def":{"name":"[]","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""},{"name":"read_only","doc":null,"default_value":"false","external_name":"read_only","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n# TODO: there should be a better way to check this, probably\n\n    \n# asking if @type was instantiated or if T is defined\n\n    \n{% if (@type.name != \"Slice(T)\") && T < Number %}\n      {{ T }}.slice({{ *args }}, read_only: {{ read_only }})\n    {% else %}\n      %ptr = Pointer(typeof({{ *args }})).malloc({{ args.size }})\n      {% for arg, i in args %}\n        %ptr[{{ i }}] = {{ arg }}\n      {% end %}\n      Slice.new(%ptr, {{ args.size }}, read_only: {{ read_only }})\n    {% end %}\n\n  \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket","path":"Socket.html","kind":"class","full_name":"Socket","name":"Socket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr"},{"filename":"socket/address.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr"},{"filename":"socket/addrinfo.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr"},{"filename":"socket/server.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"}],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"github.com/crystal-lang/crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"}],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"fcntl(fd,cmd,arg=0)-class-method","html_id":"fcntl(fd,cmd,arg=0)-class-method","name":"fcntl","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"args_string":"(fd, cmd, arg = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L504","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L504","def":{"name":"fcntl","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":""},{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"r = LibC.fcntl(fd, cmd, arg)\nif r == -1\n  raise(Errno.new(\"fcntl() failed\"))\nend\nr\n"}},{"id":"ip?(string:String)-class-method","html_id":"ip?(string:String)-class-method","name":"ip?","doc":"Returns `true` if the string represents a valid IPv4 or IPv6 address.","summary":"<p>Returns <code>true</code> if the string represents a valid IPv4 or IPv6 address.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L474","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L474","def":{"name":"ip?","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"addr = LibC::In6Addr.new\nptr = (pointerof(addr)).as(::Pointer(Void))\n(LibC.inet_pton(LibC::AF_INET, string, ptr)) > 0 || (LibC.inet_pton(LibC::AF_INET6, string, ptr)) > 0\n"}},{"id":"tcp(family:Family,blocking=false)-class-method","html_id":"tcp(family:Family,blocking=false)-class-method","name":"tcp","doc":"Creates a TCP socket. Consider using `TCPSocket` or `TCPServer` unless you\nneed full control over the socket.","summary":"<p>Creates a TCP socket.</p>","abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L53","def":{"name":"tcp","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(family, Type::STREAM, Protocol::TCP, blocking)"}},{"id":"udp(family:Family,blocking=false)-class-method","html_id":"udp(family:Family,blocking=false)-class-method","name":"udp","doc":"Creates an UDP socket. Consider using `UDPSocket` unless you need full\ncontrol over the socket.","summary":"<p>Creates an UDP socket.</p>","abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L59","def":{"name":"udp","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(family, Type::DGRAM, Protocol::UDP, blocking)"}},{"id":"unix(type:Type=Type::STREAM,blocking=false)-class-method","html_id":"unix(type:Type=Type::STREAM,blocking=false)-class-method","name":"unix","doc":"Creates an UNIX socket. Consider using `UNIXSocket` or `UNIXServer` unless\nyou need full control over the socket.","summary":"<p>Creates an UNIX socket.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L65","def":{"name":"unix","args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(Family::UNIX, type, blocking: blocking)"}}],"constructors":[{"id":"new(fd:Int32,family,type,protocol=Protocol::IP,blocking=false)-class-method","html_id":"new(fd:Int32,family,type,protocol=Protocol::IP,blocking=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(fd : Int32, family, type, protocol = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L82","def":{"name":"new","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(fd, family, type, protocol, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(family,type,protocol=Protocol::IP,blocking=false)-class-method","html_id":"new(family,type,protocol=Protocol::IP,blocking=false)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family, type, protocol = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, blocking = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L69","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":""},{"name":"blocking","doc":null,"default_value":"false","external_name":"blocking","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(family, type, protocol, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"accept-instance-method","html_id":"accept-instance-method","name":"accept","doc":"Accepts an incoming connection.\n\nReturns the client socket. Raises an `IO::Error` (closed stream) exception\nif the server is closed after invoking this method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nsocket = server.accept\nsocket.puts Time.now\nsocket.close\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L211","def":{"name":"accept","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"accept? || (raise(IO::Error.new(\"Closed stream\")))"}},{"id":"accept?-instance-method","html_id":"accept?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client `Socket` or `nil` if the server is closed after invoking\nthis method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nif socket = server.accept?\n  socket.puts Time.now\n  socket.close\nend\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L229","def":{"name":"accept?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if client_fd = accept_impl\n  sock = Socket.new(client_fd)\n  sock.sync = sync?\n  sock\nend"}},{"id":"bind(addr,&block)-instance-method","html_id":"bind(addr,&amp;block)-instance-method","name":"bind","doc":"Tries to bind the socket to a local address.\nYields an `Errno` if the binding failed.","summary":"<p>Tries to bind the socket to a local address.</p>","abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""}],"args_string":"(addr, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L179","def":{"name":"bind","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibC.bind(fd, addr, addr.size)) == 0\nelse\n  yield Errno.new(\"bind\")\nend"}},{"id":"bind(host:String,port:Int)-instance-method","html_id":"bind(host:String,port:Int)-instance-method","name":"bind","doc":"Binds the socket to a local address.\n\n```\nsock = Socket.tcp(Socket::Family::INET)\nsock.bind \"localhost\", 1234\n```","summary":"<p>Binds the socket to a local address.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"}],"args_string":"(host : String, port : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L149","def":{"name":"bind","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Addrinfo.resolve(host, port, @family, @type, @protocol) do |addrinfo|\n  bind(addrinfo) do |errno|\n    errno\n  end\nend"}},{"id":"bind(port:Int)-instance-method","html_id":"bind(port:Int)-instance-method","name":"bind","doc":"Binds the socket on *port* to all local interfaces.\n\n```\nsock = Socket.tcp(Socket::Family::INET6)\nsock.bind 1234\n```","summary":"<p>Binds the socket on <em>port</em> to all local interfaces.</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"}],"args_string":"(port : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L161","def":{"name":"bind","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Addrinfo.resolve(\"::\", port, @family, @type, @protocol) do |addrinfo|\n  bind(addrinfo) do |errno|\n    errno\n  end\nend"}},{"id":"bind(addr)-instance-method","html_id":"bind(addr)-instance-method","name":"bind","doc":"Binds the socket to a local address.\n\n```\nsock = Socket.udp(Socket::Family::INET)\nsock.bind Socket::IPAddress.new(\"192.168.1.25\", 80)\n```","summary":"<p>Binds the socket to a local address.</p>","abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""}],"args_string":"(addr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L173","def":{"name":"bind","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bind(addr) do |errno|\n  raise(errno)\nend"}},{"id":"blocking-instance-method","html_id":"blocking-instance-method","name":"blocking","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L480","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L480","def":{"name":"blocking","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((fcntl(LibC::F_GETFL)) & LibC::O_NONBLOCK) == 0"}},{"id":"blocking=(value)-instance-method","html_id":"blocking=(value)-instance-method","name":"blocking=","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L484","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L484","def":{"name":"blocking=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"flags = fcntl(LibC::F_GETFL)\nif value\n  flags = flags & (~LibC::O_NONBLOCK)\nelse\n  flags = flags | LibC::O_NONBLOCK\nend\nfcntl(LibC::F_SETFL, flags)\n"}},{"id":"broadcast=(val:Bool)-instance-method","html_id":"broadcast=(val:Bool)-instance-method","name":"broadcast=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L405","def":{"name":"broadcast=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt_bool(LibC::SO_BROADCAST, val)"}},{"id":"broadcast?-instance-method","html_id":"broadcast?-instance-method","name":"broadcast?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L401","def":{"name":"broadcast?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt_bool(LibC::SO_BROADCAST)"}},{"id":"close_on_exec=(arg:Bool)-instance-method","html_id":"close_on_exec=(arg:Bool)-instance-method","name":"close_on_exec=","doc":null,"summary":null,"abstract":false,"args":[{"name":"arg","doc":null,"default_value":"","external_name":"arg","restriction":"Bool"}],"args_string":"(arg : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L499","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L499","def":{"name":"close_on_exec=","args":[{"name":"arg","doc":null,"default_value":"","external_name":"arg","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fcntl(LibC::F_SETFD, arg ? LibC::FD_CLOEXEC : 0)\narg\n"}},{"id":"close_on_exec?-instance-method","html_id":"close_on_exec?-instance-method","name":"close_on_exec?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L494","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L494","def":{"name":"close_on_exec?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"flags = fcntl(LibC::F_GETFD)\n(flags & LibC::FD_CLOEXEC) == LibC::FD_CLOEXEC\n"}},{"id":"close_read-instance-method","html_id":"close_read-instance-method","name":"close_read","doc":"Calls `shutdown(2)` with `SHUT_RD`","summary":"<p>Calls <code>shutdown(2)</code> with <code>SHUT_RD</code></p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L348","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L348","def":{"name":"close_read","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shutdown(LibC::SHUT_RD)"}},{"id":"close_write-instance-method","html_id":"close_write-instance-method","name":"close_write","doc":"Calls `shutdown(2)` with `SHUT_WR`","summary":"<p>Calls <code>shutdown(2)</code> with <code>SHUT_WR</code></p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L353","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L353","def":{"name":"close_write","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"shutdown(LibC::SHUT_WR)"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L520","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"connect(addr,timeout=nil,&block)-instance-method","html_id":"connect(addr,timeout=nil,&amp;block)-instance-method","name":"connect","doc":"Tries to connect to a remote address. Yields an `IO::Timeout` or an\n`Errno` error if the connection failed.","summary":"<p>Tries to connect to a remote address.</p>","abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(addr, timeout = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L124","def":{"name":"connect","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if timeout.is_a?(Time::Span | Nil)\nelse\n  timeout = timeout.seconds\nend\nloop do\n  if (LibC.connect(fd, addr, addr.size)) == 0\n    return\n  end\n  case Errno.value\n  when Errno::EISCONN\n    return\n  when Errno::EINPROGRESS, Errno::EALREADY\n    wait_writable(timeout: timeout) do |error|\n      return yield IO::Timeout.new(\"connect timed out\")\n    end\n  else\n    return yield Errno.new(\"connect\")\n  end\nend\n"}},{"id":"connect(addr,timeout=nil):Nil-instance-method","html_id":"connect(addr,timeout=nil):Nil-instance-method","name":"connect","doc":"Connects the socket to a remote address. Raises if the connection failed.\n\n```\nsock = Socket.unix\nsock.connect Socket::UNIXAddress.new(\"/tmp/service.sock\")\n```","summary":"<p>Connects the socket to a remote address.</p>","abstract":false,"args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(addr, timeout = <span class=\"n\">nil</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L118","def":{"name":"connect","args":[{"name":"addr","doc":null,"default_value":"","external_name":"addr","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"connect(addr, timeout) do |error|\n  raise(error)\nend"}},{"id":"connect(host:String,port:Int,connect_timeout=nil)-instance-method","html_id":"connect(host:String,port:Int,connect_timeout=nil)-instance-method","name":"connect","doc":"Connects the socket to a remote host:port.\n\n```\nsock = Socket.tcp(Socket::Family::INET)\nsock.connect \"crystal-lang.org\", 80\n```","summary":"<p>Connects the socket to a remote host:port.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"connect_timeout","doc":null,"default_value":"nil","external_name":"connect_timeout","restriction":""}],"args_string":"(host : String, port : Int, connect_timeout = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L106","def":{"name":"connect","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"connect_timeout","doc":null,"default_value":"nil","external_name":"connect_timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Addrinfo.resolve(host, port, @family, @type, @protocol) do |addrinfo|\n  connect(addrinfo, timeout: connect_timeout) do |error|\n    error\n  end\nend"}},{"id":"family:Family-instance-method","html_id":"family:Family-instance-method","name":"family","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Family","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L47","def":{"name":"family","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Family","visibility":"Public","body":"@family"}},{"id":"fcntl(cmd,arg=0)-instance-method","html_id":"fcntl(cmd,arg=0)-instance-method","name":"fcntl","doc":null,"summary":null,"abstract":false,"args":[{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"args_string":"(cmd, arg = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L510","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L510","def":{"name":"fcntl","args":[{"name":"cmd","doc":null,"default_value":"","external_name":"cmd","restriction":""},{"name":"arg","doc":null,"default_value":"0","external_name":"arg","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.class.fcntl(@fd, cmd, arg)"}},{"id":"fd:Int32-instance-method","html_id":"fd:Int32-instance-method","name":"fd","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L40","def":{"name":"fd","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@fd"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L514","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L514","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if closed?\n  return\nend\nbegin\n  close\nrescue\n  nil\nend\n"}},{"id":"getsockopt(optname,optval,level=LibC::SOL_SOCKET)-instance-method","html_id":"getsockopt(optname,optval,level=LibC::SOL_SOCKET)-instance-method","name":"getsockopt","doc":"Returns the modified *optval*.","summary":"<p>Returns the modified <em>optval</em>.</p>","abstract":false,"args":[{"name":"optname","doc":null,"default_value":"","external_name":"optname","restriction":""},{"name":"optval","doc":null,"default_value":"","external_name":"optval","restriction":""},{"name":"level","doc":null,"default_value":"LibC::SOL_SOCKET","external_name":"level","restriction":""}],"args_string":"(optname, optval, level = <span class=\"t\">LibC</span><span class=\"t\">::</span><span class=\"t\">SOL_SOCKET</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L447","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L447","def":{"name":"getsockopt","args":[{"name":"optname","doc":null,"default_value":"","external_name":"optname","restriction":""},{"name":"optval","doc":null,"default_value":"","external_name":"optval","restriction":""},{"name":"level","doc":null,"default_value":"LibC::SOL_SOCKET","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"optsize = LibC::SocklenT.new(sizeof(typeof(optval)))\nret = LibC.getsockopt(fd, level, optname, ((pointerof(optval)).as(::Pointer(Void))), pointerof(optsize))\nif ret == -1\n  raise(Errno.new(\"getsockopt\"))\nend\noptval\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L363","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L363","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<#{self.class}:fd #{@fd}>\""}},{"id":"keepalive=(val:Bool)-instance-method","html_id":"keepalive=(val:Bool)-instance-method","name":"keepalive=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L413","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L413","def":{"name":"keepalive=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt_bool(LibC::SO_KEEPALIVE, val)"}},{"id":"keepalive?-instance-method","html_id":"keepalive?-instance-method","name":"keepalive?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L409","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L409","def":{"name":"keepalive?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt_bool(LibC::SO_KEEPALIVE)"}},{"id":"linger-instance-method","html_id":"linger-instance-method","name":"linger","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L417","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L417","def":{"name":"linger","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"v = LibC::Linger.new\nret = getsockopt(LibC::SO_LINGER, v)\nret.l_onoff == 0 ? nil : ret.l_linger\n"}},{"id":"linger=(val:Int?)-instance-method","html_id":"linger=(val:Int?)-instance-method","name":"linger=","doc":"WARNING: The behavior of `SO_LINGER` is platform specific.\nBad things may happen especially with nonblocking sockets.\nSee [Cross-Platform Testing of SO_LINGER by Nybek](https://www.nybek.com/blog/2015/04/29/so_linger-on-non-blocking-sockets/)\nfor more information.\n\n* `nil`: disable `SO_LINGER`\n* `Int`: enable `SO_LINGER` and set timeout to `Int` seconds\n  * `0`: abort on close (socket buffer is discarded and RST sent to peer). Depends on platform and whether `shutdown()` was called first.\n  * `>=1`: abort after `Int` seconds on close. Linux and Cygwin may block on close.","summary":"<p>WARNING: The behavior of <code>SO_LINGER</code> is platform specific.</p>","abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int | ::Nil"}],"args_string":"(val : Int?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L432","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L432","def":{"name":"linger=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"v = LibC::Linger.new\ncase val\nwhen Int\n  v.l_onoff = 1\n  v.l_linger = val\nwhen nil\n  v.l_onoff = 0\nend\nsetsockopt(LibC::SO_LINGER, v)\nval\n"}},{"id":"listen(backlog=SOMAXCONN)-instance-method","html_id":"listen(backlog=SOMAXCONN)-instance-method","name":"listen","doc":"Tells the previously bound socket to listen for incoming connections.","summary":"<p>Tells the previously bound socket to listen for incoming connections.</p>","abstract":false,"args":[{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""}],"args_string":"(backlog = <span class=\"t\">SOMAXCONN</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L186","def":{"name":"listen","args":[{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"listen(backlog) do |errno|\n  raise(errno)\nend"}},{"id":"listen(backlog=SOMAXCONN,&block)-instance-method","html_id":"listen(backlog=SOMAXCONN,&amp;block)-instance-method","name":"listen","doc":"Tries to listen for connections on the previously bound socket.\nYields an `Errno` on failure.","summary":"<p>Tries to listen for connections on the previously bound socket.</p>","abstract":false,"args":[{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""}],"args_string":"(backlog = <span class=\"t\">SOMAXCONN</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L192","def":{"name":"listen","args":[{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if (LibC.listen(fd, backlog)) == 0\nelse\n  yield Errno.new(\"listen\")\nend"}},{"id":"protocol:Protocol-instance-method","html_id":"protocol:Protocol-instance-method","name":"protocol","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Protocol","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L49","def":{"name":"protocol","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Protocol","visibility":"Public","body":"@protocol"}},{"id":"receive(max_message_size=512):Tuple(String,Address)-instance-method","html_id":"receive(max_message_size=512):Tuple(String,Address)-instance-method","name":"receive","doc":"Receives a text message from the previously bound address.\n\n```\nserver = Socket.udp(Socket::Family::INET)\nserver.bind(\"localhost\", 1234)\n\nmessage, client_addr = server.receive\n```","summary":"<p>Receives a text message from the previously bound address.</p>","abstract":false,"args":[{"name":"max_message_size","doc":null,"default_value":"512","external_name":"max_message_size","restriction":""}],"args_string":"(max_message_size = <span class=\"n\">512</span>) : Tuple(String, Address)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L300","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L300","def":{"name":"receive","args":[{"name":"max_message_size","doc":null,"default_value":"512","external_name":"max_message_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(String, Address)","visibility":"Public","body":"address = nil\nmessage = String.new(max_message_size) do |buffer|\n  bytes_read, sockaddr, addrlen = recvfrom(Slice.new(buffer, max_message_size))\n  address = Address.from(sockaddr, addrlen)\n  {bytes_read, 0}\nend\n{message, address.not_nil!}\n"}},{"id":"receive(message:Bytes):Tuple(Int32,Address)-instance-method","html_id":"receive(message:Bytes):Tuple(Int32,Address)-instance-method","name":"receive","doc":"Receives a binary message from the previously bound address.\n\n```\nserver = Socket.udp(Socket::Family::INET)\nserver.bind(\"localhost\", 1234)\n\nmessage = Bytes.new(32)\nbytes_read, client_addr = server.receive(message)\n```","summary":"<p>Receives a binary message from the previously bound address.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"Bytes"}],"args_string":"(message : Bytes) : Tuple(Int32, Address)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L319","def":{"name":"receive","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(Int32, Address)","visibility":"Public","body":"bytes_read, sockaddr, addrlen = recvfrom(message)\n{bytes_read, Address.from(sockaddr, addrlen)}\n"}},{"id":"recv_buffer_size-instance-method","html_id":"recv_buffer_size-instance-method","name":"recv_buffer_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L376","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L376","def":{"name":"recv_buffer_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt(LibC::SO_RCVBUF, 0)"}},{"id":"recv_buffer_size=(val:Int32)-instance-method","html_id":"recv_buffer_size=(val:Int32)-instance-method","name":"recv_buffer_size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int32"}],"args_string":"(val : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L380","def":{"name":"recv_buffer_size=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt(LibC::SO_RCVBUF, val)\nval\n"}},{"id":"reuse_address=(val:Bool)-instance-method","html_id":"reuse_address=(val:Bool)-instance-method","name":"reuse_address=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L389","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L389","def":{"name":"reuse_address=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt_bool(LibC::SO_REUSEADDR, val)"}},{"id":"reuse_address?-instance-method","html_id":"reuse_address?-instance-method","name":"reuse_address?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L385","def":{"name":"reuse_address?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt_bool(LibC::SO_REUSEADDR)"}},{"id":"reuse_port=(val:Bool)-instance-method","html_id":"reuse_port=(val:Bool)-instance-method","name":"reuse_port=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L397","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L397","def":{"name":"reuse_port=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt_bool(LibC::SO_REUSEPORT, val)"}},{"id":"reuse_port?-instance-method","html_id":"reuse_port?-instance-method","name":"reuse_port?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L393","def":{"name":"reuse_port?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt_bool(LibC::SO_REUSEPORT)"}},{"id":"send(message,toaddr:Address)-instance-method","html_id":"send(message,toaddr:Address)-instance-method","name":"send","doc":"Sends a message to the specified remote address.\n\n```\nserver = Socket::IPAddress.new(\"10.0.3.1\", 2022)\nsock = Socket.udp(Socket::Family::INET)\nsock.connect(\"example.com\", 2000)\nsock.send(\"text query\", to: server)\n```","summary":"<p>Sends a message to the specified remote address.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"addr","doc":null,"default_value":"","external_name":"to","restriction":"Address"}],"args_string":"(message, to addr : Address)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L285","def":{"name":"send","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"addr","doc":null,"default_value":"","external_name":"to","restriction":"Address"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"slice = message.to_slice\nbytes_sent = LibC.sendto(fd, slice.to_unsafe.as(::Pointer(Void)), slice.size, 0, addr, addr.size)\nif bytes_sent == -1\n  raise(Errno.new(\"Error sending datagram to #{addr}\"))\nend\nbytes_sent\n"}},{"id":"send(message)-instance-method","html_id":"send(message)-instance-method","name":"send","doc":"Sends a message to a previously connected remote address.\n\n```\nsock = Socket.udp(Socket::Family::INET)\nsock.connect(\"example.com\", 2000)\nsock.send(\"text message\")\n\nsock = Socket.unix(Socket::Type::DGRAM)\nsock.connect Socket::UNIXAddress.new(\"/tmp/service.sock\")\nsock.send(Bytes[0])\n```","summary":"<p>Sends a message to a previously connected remote address.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"args_string":"(message)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L265","def":{"name":"send","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  slice = message.to_slice\n  bytes_sent = LibC.send(fd, slice.to_unsafe.as(::Pointer(Void)), slice.size, 0)\n  if bytes_sent == -1\n    raise(Errno.new(\"Error sending datagram\"))\n  end\n  bytes_sent\nensure\n  if (writers = @writers) && (!writers.empty?)\n    add_write_event\n  end\nend"}},{"id":"send_buffer_size-instance-method","html_id":"send_buffer_size-instance-method","name":"send_buffer_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L367","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L367","def":{"name":"send_buffer_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt(LibC::SO_SNDBUF, 0)"}},{"id":"send_buffer_size=(val:Int32)-instance-method","html_id":"send_buffer_size=(val:Int32)-instance-method","name":"send_buffer_size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int32"}],"args_string":"(val : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L371","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L371","def":{"name":"send_buffer_size=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt(LibC::SO_SNDBUF, val)\nval\n"}},{"id":"setsockopt(optname,optval,level=LibC::SOL_SOCKET)-instance-method","html_id":"setsockopt(optname,optval,level=LibC::SOL_SOCKET)-instance-method","name":"setsockopt","doc":"NOTE: *optval* is restricted to `Int32` until sizeof works on variables.","summary":"<p><span class=\"flag purple\">NOTE</span>  <em>optval</em> is restricted to <code><a href=\"Int32.html\">Int32</a></code> until sizeof works on variables.</p>","abstract":false,"args":[{"name":"optname","doc":null,"default_value":"","external_name":"optname","restriction":""},{"name":"optval","doc":null,"default_value":"","external_name":"optval","restriction":""},{"name":"level","doc":null,"default_value":"LibC::SOL_SOCKET","external_name":"level","restriction":""}],"args_string":"(optname, optval, level = <span class=\"t\">LibC</span><span class=\"t\">::</span><span class=\"t\">SOL_SOCKET</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L455","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L455","def":{"name":"setsockopt","args":[{"name":"optname","doc":null,"default_value":"","external_name":"optname","restriction":""},{"name":"optval","doc":null,"default_value":"","external_name":"optval","restriction":""},{"name":"level","doc":null,"default_value":"LibC::SOL_SOCKET","external_name":"level","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"optsize = LibC::SocklenT.new(sizeof(typeof(optval)))\nret = LibC.setsockopt(fd, level, optname, ((pointerof(optval)).as(::Pointer(Void))), optsize)\nif ret == -1\n  raise(Errno.new(\"setsockopt\"))\nend\nret\n"}},{"id":"tty?-instance-method","html_id":"tty?-instance-method","name":"tty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L524","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L524","def":{"name":"tty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibC.isatty(fd)) == 1"}},{"id":"type:Type-instance-method","html_id":"type:Type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L48","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"@type"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Socket/Address","path":"Socket/Address.html","kind":"struct","full_name":"Socket::Address","name":"Address","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/address.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Socket/IPAddress","kind":"struct","full_name":"Socket::IPAddress","name":"IPAddress"},{"html_id":"github.com/crystal-lang/crystal/Socket/UNIXAddress","kind":"struct","full_name":"Socket::UNIXAddress","name":"UNIXAddress"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):Address-class-method","html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):Address-class-method","name":"from","doc":"Returns either an `IPAddress` or `UNIXAddres` from the internal OS\nrepresentation. Only INET, INET6 and UNIX families are supported.","summary":"<p>Returns either an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> or <code>UNIXAddres</code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : Address","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L8","def":{"name":"from","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Address","visibility":"Public","body":"case family = Family.new(sockaddr.value.sa_family)\nwhen Family::INET6\n  IPAddress.new(sockaddr.as(::Pointer(LibC::SockaddrIn6)), addrlen.to_i)\nwhen Family::INET\n  IPAddress.new(sockaddr.as(::Pointer(LibC::SockaddrIn)), addrlen.to_i)\nwhen Family::UNIX\n  UNIXAddress.new(sockaddr.as(::Pointer(LibC::SockaddrUn)), addrlen.to_i)\nelse\n  raise(\"Unsupported family type: #{family} (#{family.value})\")\nend"}},{"id":"new(family:Family,size:Int32)-class-method","html_id":"new(family:Family,size:Int32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int32"}],"args_string":"(family : Family, size : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L21","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(family, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L26","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"family:Family-instance-method","html_id":"family:Family-instance-method","name":"family","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Family","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L3","def":{"name":"family","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Family","visibility":"Public","body":"@family"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L4","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":true,"args":[],"args_string":" : Pointer(LibC::Sockaddr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L24","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":""}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Addrinfo","path":"Socket/Addrinfo.html","kind":"struct","full_name":"Socket::Addrinfo","name":"Addrinfo","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/addrinfo.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"Domain name resolver.","summary":"<p>Domain name resolver.</p>","class_methods":[{"id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil):Array(Addrinfo)-class-method","html_id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil):Array(Addrinfo)-class-method","name":"resolve","doc":"Resolves a domain that best matches the given options.\n\n- *domain* may be an IP address or a domain name.\n- *service* may be a port number or a service name. It must be specified,\n  because different servers may handle the `mail` or `http` services for\n  example.\n- *family* is optional and defaults to `Family::UNSPEC`\n- *type* is the intented socket type (e.g. `Type::STREAM`) and must be\n  specified.\n- *protocol* is the intented socket protocol (e.g. `Protocol::TCP`) and\n  should be specified.\n\nExample:\n```\naddrinfos = Socket::Addrinfo.resolve(\"example.org\", \"http\", type: Socket::Type::STREAM, protocol: Socket::Protocol::TCP)\n```","summary":"<p>Resolves a domain that best matches the given options.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","doc":null,"default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family : Family? = <span class=\"n\">nil</span>, type : Type = <span class=\"n\">nil</span>, protocol : Protocol = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, timeout = <span class=\"n\">nil</span>) : Array(Addrinfo)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L30","def":{"name":"resolve","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","doc":null,"default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Addrinfo)","visibility":"Public","body":"addrinfos = [] of Addrinfo\ngetaddrinfo(domain, service, family, type, protocol, timeout) do |addrinfo|\n  loop do\n    addrinfos << addrinfo.not_nil!\n    if addrinfo = addrinfo.next?\n    else\n      return addrinfos\n    end\n  end\nend\n"}},{"id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil,&block)-class-method","html_id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil,&amp;block)-class-method","name":"resolve","doc":"Resolves a domain that best matches the given options.\n\nYields each possible `Addrinfo` resolution since a domain may resolve to\nmany IP. Implementations are supposed to try all the addresses until the\nsocket is connected (or bound) or there are no addresses to try anymore.\n\nRaising is an expensive operation, so instead of raising on a connect or\nbind error, just to rescue it immediately after, the block is expected to\nreturn the error instead, which will be raised once there are no more\naddresses to try.\n\nThe iteration will be stopped once the block returns something that isn't\nan `Exception` (e.g. a `Socket` or `nil`).","summary":"<p>Resolves a domain that best matches the given options.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","doc":null,"default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family : Family? = <span class=\"n\">nil</span>, type : Type = <span class=\"n\">nil</span>, protocol : Protocol = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, timeout = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L56","def":{"name":"resolve","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","doc":null,"default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"getaddrinfo(domain, service, family, type, protocol, timeout) do |addrinfo|\n  error = nil\n  loop do\n    value = yield addrinfo.not_nil!\n    if value.is_a?(Exception)\n      error = value\n    else\n      return value\n    end\n    if addrinfo = addrinfo.try(&.next?)\n    else\n      if error.is_a?(Errno) && (error.errno == Errno::ECONNREFUSED)\n        raise(Errno.new(\"Error connecting to '#{domain}:#{service}'\", error.errno))\n      else\n        if error\n          raise(error)\n        end\n      end\n    end\n  end\nend"}},{"id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","html_id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","name":"tcp","doc":"Resolves *domain* for the UDP protocol and returns an `Array` of possible\n`Addrinfo`. See `#resolve` for details.\n\nExample:\n```\naddrinfos = Socket::Addrinfo.tcp(\"example.org\", 80)\n```","summary":"<p>Resolves <em>domain</em> for the UDP protocol and returns an <code><a href=\"../Array.html\">Array</a></code> of possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>) : Array(Addrinfo)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L129","def":{"name":"tcp","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Addrinfo)","visibility":"Public","body":"resolve(domain, service, family, Type::STREAM, Protocol::TCP)"}},{"id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil,&block)-class-method","html_id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil,&amp;block)-class-method","name":"tcp","doc":"Resolves a domain for the TCP protocol with STREAM type, and yields each\npossible `Addrinfo`. See `#resolve` for details.","summary":"<p>Resolves a domain for the TCP protocol with STREAM type, and yields each possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L135","def":{"name":"tcp","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"resolve(domain, service, family, Type::STREAM, Protocol::TCP) do |addrinfo|\n  yield addrinfo\nend"}},{"id":"udp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","html_id":"udp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","name":"udp","doc":"Resolves *domain* for the UDP protocol and returns an `Array` of possible\n`Addrinfo`. See `#resolve` for details.\n\nExample:\n```\naddrinfos = Socket::Addrinfo.tcp(\"example.org\", 53)\n```","summary":"<p>Resolves <em>domain</em> for the UDP protocol and returns an <code><a href=\"../Array.html\">Array</a></code> of possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>) : Array(Addrinfo)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L146","def":{"name":"udp","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Addrinfo)","visibility":"Public","body":"resolve(domain, service, family, Type::DGRAM, Protocol::UDP)"}},{"id":"udp(domain,service,family=Family::UNSPEC,timeout=nil,&block)-class-method","html_id":"udp(domain,service,family=Family::UNSPEC,timeout=nil,&amp;block)-class-method","name":"udp","doc":"Resolves a domain for the UDP protocol with DGRAM type, and yields each\npossible `Addrinfo`. See `#resolve` for details.","summary":"<p>Resolves a domain for the UDP protocol with DGRAM type, and yields each possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L152","def":{"name":"udp","args":[{"name":"domain","doc":null,"default_value":"","external_name":"domain","restriction":""},{"name":"service","doc":null,"default_value":"","external_name":"service","restriction":""},{"name":"family","doc":null,"default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","doc":null,"default_value":"nil","external_name":"timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"resolve(domain, service, family, Type::DGRAM, Protocol::UDP) do |addrinfo|\n  yield addrinfo\nend"}}],"constructors":[{"id":"new(addrinfo:Pointer(LibC::Addrinfo))-class-method","html_id":"new(addrinfo:Pointer(LibC::Addrinfo))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"addrinfo","doc":null,"default_value":"","external_name":"addrinfo","restriction":"::Pointer(LibC::Addrinfo)"}],"args_string":"(addrinfo : Pointer(LibC::Addrinfo))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L156","def":{"name":"new","args":[{"name":"addrinfo","doc":null,"default_value":"","external_name":"addrinfo","restriction":"::Pointer(LibC::Addrinfo)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(addrinfo)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"family:Family-instance-method","html_id":"family:Family-instance-method","name":"family","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Family","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L6","def":{"name":"family","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Family","visibility":"Public","body":"@family"}},{"id":"ip_address-instance-method","html_id":"ip_address-instance-method","name":"ip_address","doc":"Returns an `IPAddress` matching this addrinfo.","summary":"<p>Returns an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> matching this addrinfo.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L176","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L176","def":{"name":"ip_address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ip_address || (@ip_address = IPAddress.from(to_unsafe, size))"}},{"id":"protocol:Protocol-instance-method","html_id":"protocol:Protocol-instance-method","name":"protocol","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Protocol","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L8","def":{"name":"protocol","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Protocol","visibility":"Public","body":"@protocol"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L9","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L180","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(pointerof(@addr)).as(::Pointer(LibC::Sockaddr))"}},{"id":"type:Type-instance-method","html_id":"type:Type-instance-method","name":"type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/addrinfo.cr#L7","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"@type"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Error","path":"Socket/Error.html","kind":"class","full_name":"Socket::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Family","path":"Socket/Family.html","kind":"enum","full_name":"Socket::Family","name":"Family","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"UNSPEC","name":"UNSPEC","value":"0_u16","doc":null,"summary":null},{"id":"UNIX","name":"UNIX","value":"1_u16","doc":null,"summary":null},{"id":"INET","name":"INET","value":"2_u16","doc":null,"summary":null},{"id":"INET6","name":"INET6","value":"10_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"inet6?-instance-method","html_id":"inet6?-instance-method","name":"inet6?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L34","def":{"name":"inet6?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == INET6"}},{"id":"inet?-instance-method","html_id":"inet?-instance-method","name":"inet?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L33","def":{"name":"inet?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == INET"}},{"id":"unix?-instance-method","html_id":"unix?-instance-method","name":"unix?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L32","def":{"name":"unix?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNIX"}},{"id":"unspec?-instance-method","html_id":"unspec?-instance-method","name":"unspec?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L31","def":{"name":"unspec?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UNSPEC"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/IPAddress","path":"Socket/IPAddress.html","kind":"struct","full_name":"Socket::IPAddress","name":"IPAddress","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/address.cr","line_number":46,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"IP address representation.\n\nHolds a binary representation of an IP address, either translated from a\n`String`, or directly received from an opened connection (e.g.\n`Socket#local_address`, `Socket#receive`).\n\nExample:\n```\nSocket::IPAddress.new(\"127.0.0.1\", 8080)\nSocket::IPAddress.new(\"fe80::2ab2:bdff:fe59:8e2c\", 1234)\n```\n\n`IPAddress` won't resolve domains, including `localhost`. If you must\nresolve an IP, or don't know whether a `String` constains an IP or a domain\nname, you should use `Addrinfo.resolve` instead.","summary":"<p>IP address representation.</p>","class_methods":[],"constructors":[{"id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):IPAddress-class-method","html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):IPAddress-class-method","name":"from","doc":"Creates an `IPAddress` from the internal OS representation. Supports both\nINET and INET6 families.","summary":"<p>Creates an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : IPAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L67","def":{"name":"from","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IPAddress","visibility":"Public","body":"case family = Family.new(sockaddr.value.sa_family)\nwhen Family::INET6\n  new(sockaddr.as(::Pointer(LibC::SockaddrIn6)), addrlen.to_i)\nwhen Family::INET\n  new(sockaddr.as(::Pointer(LibC::SockaddrIn)), addrlen.to_i)\nelse\n  raise(\"Unsupported family type: #{family} (#{family.value})\")\nend"}},{"id":"new(address:String,port:Int32)-class-method","html_id":"new(address:String,port:Int32)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"}],"args_string":"(address : String, port : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L53","def":{"name":"new","args":[{"name":"address","doc":null,"default_value":"","external_name":"address","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(address, port)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(sockaddr:Pointer(LibC::SockaddrIn6),size)-class-method","html_id":"new(sockaddr:Pointer(LibC::SockaddrIn6),size)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrIn6)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::SockaddrIn6), size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L78","def":{"name":"new","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrIn6)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(sockaddr, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(sockaddr:Pointer(LibC::SockaddrIn),size)-class-method","html_id":"new(sockaddr:Pointer(LibC::SockaddrIn),size)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrIn)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::SockaddrIn), size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L84","def":{"name":"new","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrIn)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(sockaddr, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:IPAddress)-instance-method","html_id":"==(other:IPAddress)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"IPAddress"}],"args_string":"(other : IPAddress)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L135","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"IPAddress"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"((family == other.family) && (port == other.port)) && (address == other.address)"}},{"id":"address-instance-method","html_id":"address-instance-method","name":"address","doc":"Returns a `String` representation of the IP address.\n\nExample:\n```\nip_address = socket.remote_address\nip_address.address # => \"127.0.0.1\"\n```","summary":"<p>Returns a <code><a href=\"../String.html\">String</a></code> representation of the IP address.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L107","def":{"name":"address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@address || (@address = (case family\nwhen Family::INET6\n  address(@addr6.not_nil!)\nwhen Family::INET\n  address(@addr4.not_nil!)\nelse\n  raise(\"Unsupported IP address family: #{family}\")\nend))"}},{"id":"port:Int32-instance-method","html_id":"port:Int32-instance-method","name":"port","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L47","def":{"name":"port","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@port"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L141","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if family == Family::INET6\n  ((((io << '[') << address) << ']') << ':') << port\nelse\n  ((io << address) << ':') << port\nend"}},{"id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Pointer(LibC::Sockaddr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L149","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":"case family\nwhen Family::INET6\n  to_sockaddr_in6\nwhen Family::INET\n  to_sockaddr_in\nelse\n  raise(\"Unsupported IP address family: #{family}\")\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Protocol","path":"Socket/Protocol.html","kind":"enum","full_name":"Socket::Protocol","name":"Protocol","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket.cr","line_number":22,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"IP","name":"IP","value":"0","doc":null,"summary":null},{"id":"TCP","name":"TCP","value":"6","doc":null,"summary":null},{"id":"UDP","name":"UDP","value":"17","doc":null,"summary":null},{"id":"RAW","name":"RAW","value":"255","doc":null,"summary":null},{"id":"ICMP","name":"ICMP","value":"1","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"icmp?-instance-method","html_id":"icmp?-instance-method","name":"icmp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L27","def":{"name":"icmp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ICMP"}},{"id":"ip?-instance-method","html_id":"ip?-instance-method","name":"ip?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L23","def":{"name":"ip?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IP"}},{"id":"raw?-instance-method","html_id":"raw?-instance-method","name":"raw?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L26","def":{"name":"raw?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RAW"}},{"id":"tcp?-instance-method","html_id":"tcp?-instance-method","name":"tcp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L24","def":{"name":"tcp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCP"}},{"id":"udp?-instance-method","html_id":"udp?-instance-method","name":"udp?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L25","def":{"name":"udp?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == UDP"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Server","path":"Socket/Server.html","kind":"module","full_name":"Socket::Server","name":"Server","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"socket/server.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/TCPServer","kind":"class","full_name":"TCPServer","name":"TCPServer"},{"html_id":"github.com/crystal-lang/crystal/UNIXServer","kind":"class","full_name":"UNIXServer","name":"UNIXServer"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"accept(&block)-instance-method","html_id":"accept(&amp;block)-instance-method","name":"accept","doc":"Accepts an incoming connection and yields the client socket to the block.\nEventually closes the connection when the block returns.\n\nReturns the value of the block. If the server is closed after invoking this\nmethod, an `IO::Error` (closed stream) exception will be raised.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nserver.accept do |socket|\n  socket.puts Time.now\nend\n```","summary":"<p>Accepts an incoming connection and yields the client socket to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr#L17","def":{"name":"accept","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sock = accept\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}},{"id":"accept?(&block)-instance-method","html_id":"accept?(&amp;block)-instance-method","name":"accept?","doc":"Accepts an incoming connection and yields the client socket to the block.\nEventualy closes the connection when the block returns.\n\nReturns the value of the block or `nil` if the server is closed after\ninvoking this method.\n\n```\nrequire \"socket\"\n\nserver = UNIXServer.new(\"/tmp/service.sock\")\nserver.accept? do |socket|\n  socket.puts Time.now\nend\n```","summary":"<p>Accepts an incoming connection and yields the client socket to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/server.cr#L40","def":{"name":"accept?","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sock = accept?\nif sock\nelse\n  return\nend\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/Type","path":"Socket/Type.html","kind":"enum","full_name":"Socket::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"STREAM","name":"STREAM","value":"1","doc":null,"summary":null},{"id":"DGRAM","name":"DGRAM","value":"2","doc":null,"summary":null},{"id":"RAW","name":"RAW","value":"3","doc":null,"summary":null},{"id":"SEQPACKET","name":"SEQPACKET","value":"5","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"dgram?-instance-method","html_id":"dgram?-instance-method","name":"dgram?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L17","def":{"name":"dgram?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DGRAM"}},{"id":"raw?-instance-method","html_id":"raw?-instance-method","name":"raw?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L18","def":{"name":"raw?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RAW"}},{"id":"seqpacket?-instance-method","html_id":"seqpacket?-instance-method","name":"seqpacket?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L19","def":{"name":"seqpacket?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SEQPACKET"}},{"id":"stream?-instance-method","html_id":"stream?-instance-method","name":"stream?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket.cr#L16","def":{"name":"stream?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STREAM"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Socket/UNIXAddress","path":"Socket/UNIXAddress.html","kind":"struct","full_name":"Socket::UNIXAddress","name":"UNIXAddress","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/address.cr","line_number":186,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"UNIX address representation.\n\nHolds the local path of an UNIX address, usually coming from an opened\nconnection (e.g. `Socket#local_address`, `Socket#receive`).\n\nExample:\n```\nSocket::UNIXAddress.new(\"/tmp/my.sock\")\n```","summary":"<p>UNIX address representation.</p>","class_methods":[],"constructors":[{"id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):UNIXAddress-class-method","html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):UNIXAddress-class-method","name":"from","doc":"Creates an `UNIXSocket` from the internal OS representation.","summary":"<p>Creates an <code><a href=\"../UNIXSocket.html\">UNIXSocket</a></code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L201","def":{"name":"from","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","doc":null,"default_value":"","external_name":"addrlen","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UNIXAddress","visibility":"Public","body":"new(sockaddr.as(::Pointer(LibC::SockaddrUn)), addrlen.to_i)"}},{"id":"new(sockaddr:Pointer(LibC::SockaddrUn),size)-class-method","html_id":"new(sockaddr:Pointer(LibC::SockaddrUn),size)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrUn)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::SockaddrUn), size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L205","def":{"name":"new","args":[{"name":"sockaddr","doc":null,"default_value":"","external_name":"sockaddr","restriction":"::Pointer(LibC::SockaddrUn)"},{"name":"size","doc":null,"default_value":"","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(sockaddr, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(path:String)-class-method","html_id":"new(path:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"args_string":"(path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L192","def":{"name":"new","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:UNIXAddress)-instance-method","html_id":"==(other:UNIXAddress)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UNIXAddress"}],"args_string":"(other : UNIXAddress)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L211","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UNIXAddress"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"path == other.path"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L187","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L215","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << path"}},{"id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Pointer(LibC::Sockaddr)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/address.cr#L219","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":"sockaddr = Pointer(LibC::SockaddrUn).malloc\nsockaddr.value.sun_family = family\nsockaddr.value.sun_path.to_unsafe.copy_from(@path.to_unsafe, @path.bytesize + 1)\nsockaddr.as(::Pointer(LibC::Sockaddr))\n"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Spec","path":"Spec.html","kind":"module","full_name":"Spec","name":"Spec","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"spec/dsl.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/dsl.cr"},{"filename":"spec/context.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/context.cr"},{"filename":"spec/expectations.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr"},{"filename":"spec/formatter.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/formatter.cr"},{"filename":"spec/junit_formatter.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/junit_formatter.cr"},{"filename":"spec/source.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/source.cr"},{"filename":"spec.cr","line_number":66,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Crystal's built-in testing library. It provides a structure for writing executable examples\nof how your code should behave. A domain specific language allows you to write them in a way similar to natural language.\n\nThe Crystal compiler has a `spec` command with tools to constrain which examples get run and tailor the output.\n\nA basic spec looks something like this:\n\n```\nrequire \"spec\"\n\ndescribe Array do\n  describe \"#size\" do\n    it \"correctly reports the number of elements in the Array\" do\n      [1, 2, 3].size.should eq 3\n    end\n  end\n\n  describe \"#empty?\" do\n    it \"is empty when no elements are in the array\" do\n      ([] of Int32).empty?.should be_true\n    end\n\n    it \"is not empty if there are elements in the array\" do\n      [1].empty?.should be_false\n    end\n  end\n\n  # lots more specs\n\nend\n```\n\nTest files are structured by use of the `describe` or `context` methods.\nTypically a top level `describe` defines the `outer` unit (such as a class)\nthat is to be tested by the spec. Further `describe` calls can be nested within\nthe outer unit to specify smaller units under test (such as individual methods).\n`describe` can also be used to set up a certain context - think empty `Array` versus\n`Array` with elements. The `context` method behaves just like the `describe` method\nand may be used instead, to emphasize context to the reader.\n\nWithin a `describe` block, concrete test cases are defined with `it` . A\ndescriptive string is supplied to `it` describing what the test case\ntests specifically.\n\nSpecs then use the `should` method to verify that the expected value is\nreturned. See the example above for details.\n\nBy convention, specs live in the `spec` directory of a project. You can compile\nand run the specs of a project by running `crystal spec`.\n\n```console\n# Run  all specs in files matching spec/**/*_spec.cr\ncrystal spec\n\n# Run all specs in files matching spec/my/test/**/*_spec.cr\ncrystal spec spec/my/test/\n\n# Run all specs in spec/my/test/file_spec.cr\ncrystal spec spec/my/test/file_spec.cr\n\n# Run the spec or group defined in line 14 of spec/my/test/file_spec.cr\ncrystal spec spec/my/test/file_spec.cr:14\n```","summary":"<p>Crystal's built-in testing library.</p>","class_methods":[{"id":"add_formatter(formatter)-class-method","html_id":"add_formatter(formatter)-class-method","name":"add_formatter","doc":null,"summary":null,"abstract":false,"args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"args_string":"(formatter)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/formatter.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/formatter.cr#L96","def":{"name":"add_formatter","args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@formatters << formatter"}},{"id":"after_each(&block)-class-method","html_id":"after_each(&amp;block)-class-method","name":"after_each","doc":"Instructs the spec runner to execute the given block\nafter each spec, regardless of where this method is invoked.","summary":"<p>Instructs the spec runner to execute the given block after each spec, regardless of where this method is invoked.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/dsl.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/dsl.cr#L153","def":{"name":"after_each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"after_each = @@after_each || (@@after_each = [] of (-> ))\nafter_each << block\n"}},{"id":"before_each(&block)-class-method","html_id":"before_each(&amp;block)-class-method","name":"before_each","doc":"Instructs the spec runner to execute the given block\nbefore each spec, regardless of where this method is invoked.","summary":"<p>Instructs the spec runner to execute the given block before each spec, regardless of where this method is invoked.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/dsl.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/dsl.cr#L146","def":{"name":"before_each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"before_each = @@before_each || (@@before_each = [] of (-> ))\nbefore_each << block\n"}},{"id":"override_default_formatter(formatter)-class-method","html_id":"override_default_formatter(formatter)-class-method","name":"override_default_formatter","doc":null,"summary":null,"abstract":false,"args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"args_string":"(formatter)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/formatter.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/formatter.cr#L92","def":{"name":"override_default_formatter","args":[{"name":"formatter","doc":null,"default_value":"","external_name":"formatter","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@formatters[0] = formatter"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Spec/Expectations","path":"Spec/Expectations.html","kind":"module","full_name":"Spec::Expectations","name":"Expectations","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"spec/expectations.cr","line_number":243,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"This module defines a number of methods to create expectations, which are\nautomatically included into the top level namespace.\n\nExpectations are used by `Spec::ObjectExtensions#should` and `Spec::ObjectExtensions#should_not`.","summary":"<p>This module defines a number of methods to create expectations, which are automatically included into the top level namespace.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"be(value)-instance-method","html_id":"be(value)-instance-method","name":"be","doc":"Creates an `Expectation` that passes if actual and *value* are identical (`.same?`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual and <em>value</em> are identical (<code>.same?</code>).</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L250","def":{"name":"be","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::BeExpectation.new(value)"}},{"id":"be-instance-method","html_id":"be-instance-method","name":"be","doc":"Returns a factory to create a comparison `Expectation` that:\n\n* passes if actual is lesser than *value*: `be < value`\n* passes if actual is lesser than or equal *value*: `be <= value`\n* passes if actual is greater than *value*: `be > value`\n* passes if actual is greater than or equal *value*: `be >= value`","summary":"<p>Returns a factory to create a comparison <code>Expectation</code> that:</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L290","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L290","def":{"name":"be","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::Be"}},{"id":"be_close(expected,delta)-instance-method","html_id":"be_close(expected,delta)-instance-method","name":"be_close","doc":"Creates an `Expectation` that passes if actual is within *delta* of *expected*.","summary":"<p>Creates an <code>Expectation</code> that passes if actual is within <em>delta</em> of <em>expected</em>.</p>","abstract":false,"args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""},{"name":"delta","doc":null,"default_value":"","external_name":"delta","restriction":""}],"args_string":"(expected, delta)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L280","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L280","def":{"name":"be_close","args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""},{"name":"delta","doc":null,"default_value":"","external_name":"delta","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::CloseExpectation.new(expected, delta)"}},{"id":"be_false-instance-method","html_id":"be_false-instance-method","name":"be_false","doc":"Creates an `Expectation` that passes if actual is false (`== false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is false (<code>== false</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L260","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L260","def":{"name":"be_false","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"eq(false)"}},{"id":"be_falsey-instance-method","html_id":"be_falsey-instance-method","name":"be_falsey","doc":"Creates an `Expectation` that passes if actual is falsy (`nil` or `false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is falsy (<code>nil</code> or <code>false</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L270","def":{"name":"be_falsey","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::BeFalseyExpectation.new"}},{"id":"be_nil-instance-method","html_id":"be_nil-instance-method","name":"be_nil","doc":"Creates an `Expectation` that passes if actual is nil (`== nil`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is nil (<code>== nil</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L275","def":{"name":"be_nil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::BeNilExpectation.new"}},{"id":"be_true-instance-method","html_id":"be_true-instance-method","name":"be_true","doc":"Creates an `Expectation` that passes if actual is true (`== true`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is true (<code>== true</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L255","def":{"name":"be_true","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"eq(true)"}},{"id":"be_truthy-instance-method","html_id":"be_truthy-instance-method","name":"be_truthy","doc":"Creates an `Expectation` that passes if actual is truthy (neither `nil` nor `false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is truthy (neither <code>nil</code> nor <code>false</code>).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L265","def":{"name":"be_truthy","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::BeTruthyExpectation.new"}},{"id":"contain(expected)-instance-method","html_id":"contain(expected)-instance-method","name":"contain","doc":"Creates an `Expectation` that  passes if actual includes *expected* (`.includes?`).\nWorks on collections and `String`.","summary":"<p>Creates an <code>Expectation</code> that  passes if actual includes <em>expected</em> (<code>.includes?</code>).</p>","abstract":false,"args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"args_string":"(expected)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L301","def":{"name":"contain","args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::ContainExpectation.new(expected)"}},{"id":"end_with(expected)-instance-method","html_id":"end_with(expected)-instance-method","name":"end_with","doc":"Creates an `Expectation` that  passes if actual ends with *expected* (`.ends_with?`).\nWorks on `String`.","summary":"<p>Creates an <code>Expectation</code> that  passes if actual ends with <em>expected</em> (<code>.ends_with?</code>).</p>","abstract":false,"args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"args_string":"(expected)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L313","def":{"name":"end_with","args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::EndWithExpectation.new(expected)"}},{"id":"eq(value)-instance-method","html_id":"eq(value)-instance-method","name":"eq","doc":"Creates an `Expectation` that passes if actual equals *value* (`==`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual equals <em>value</em> (<code>==</code>).</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L245","def":{"name":"eq","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::EqualExpectation.new(value)"}},{"id":"expect_raises(klass:T.class,message=nil,file=__FILE__,line=__LINE__,&block)forallT-instance-method","html_id":"expect_raises(klass:T.class,message=nil,file=__FILE__,line=__LINE__,&amp;block)forallT-instance-method","name":"expect_raises","doc":"Runs the block and passes if it raises an exception of type *klass* and the error message matches.\n\nIf *message* is a string, it matches if the exception's error message contains that string.\nIf *message* is a regular expression, it is used to match the error message.\n\nIt returns the rescued exception.","summary":"<p>Runs the block and passes if it raises an exception of type <em>klass</em> and the error message matches.</p>","abstract":false,"args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"T.class"},{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(klass : T.class, message = <span class=\"n\">nil</span>, file = __FILE__, line = __LINE__, &block) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L328","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L328","def":{"name":"expect_raises","args":[{"name":"klass","doc":null,"default_value":"","external_name":"klass","restriction":"T.class"},{"name":"message","doc":null,"default_value":"nil","external_name":"message","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  yield\nrescue ex : T\n  if ex.is_a?(Spec::AssertionFailed) && (klass != Spec::AssertionFailed)\n    raise(ex)\n  end\n  ex_to_s = ex.to_s\n  case message\n  when Regex\n    if (    ex_to_s =~ message)\n    else\n      backtrace = ex.backtrace.join('\\n') do |f|\n        \"  # #{f}\"\n      end\n      fail(\"Expected #{klass} with message matching #{message.inspect}, got #<#{ex.class}: #{ex_to_s}> with backtrace:\\n#{backtrace}\", file, line)\n    end\n  when String\n    if ex_to_s.includes?(message)\n    else\n      backtrace = ex.backtrace.join('\\n') do |f|\n        \"  # #{f}\"\n      end\n      fail(\"Expected #{klass} with #{message.inspect}, got #<#{ex.class}: #{ex_to_s}> with backtrace:\\n#{backtrace}\", file, line)\n    end\n  end\n  ex\nrescue ex\n  backtrace = ex.backtrace.join('\\n') do |f|\n    \"  # #{f}\"\n  end\n  fail(\"Expected #{klass}, got #<#{ex.class}: #{ex.to_s}> with backtrace:\\n#{backtrace}\", file, line)\nelse\n  fail(\"Expected #{klass} but nothing was raised\", file, line)\nend"}},{"id":"match(value)-instance-method","html_id":"match(value)-instance-method","name":"match","doc":"Creates an `Expectation` that passes if actual matches *value* (`=~`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual matches <em>value</em> (<code>=~</code>).</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L295","def":{"name":"match","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::MatchExpectation.new(value)"}},{"id":"start_with(expected)-instance-method","html_id":"start_with(expected)-instance-method","name":"start_with","doc":"Creates an `Expectation` that  passes if actual starts with *expected* (`.starts_with?`).\nWorks on `String`.","summary":"<p>Creates an <code>Expectation</code> that  passes if actual starts with <em>expected</em> (<code>.starts_with?</code>).</p>","abstract":false,"args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"args_string":"(expected)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L307","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L307","def":{"name":"start_with","args":[{"name":"expected","doc":null,"default_value":"","external_name":"expected","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Spec::StartWithExpectation.new(expected)"}}],"macros":[{"id":"be_a(type)-macro","html_id":"be_a(type)-macro","name":"be_a","doc":"Creates an `Expectation` that passes if actual is of type *type* (`is_a?`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is of type <em>type</em> (<code>is_a?</code>).</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"args_string":"(type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L318","def":{"name":"be_a","args":[{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"      Spec::BeAExpectation(\n{{ type }}\n).new\n    \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Spec/Methods","path":"Spec/Methods.html","kind":"module","full_name":"Spec::Methods","name":"Methods","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"spec/methods.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"assert(file=__FILE__,line=__LINE__,end_line=__END_LINE__,&block)-instance-method","html_id":"assert(file=__FILE__,line=__LINE__,end_line=__END_LINE__,&amp;block)-instance-method","name":"assert","doc":"DEPRECATED: Use `#it`","summary":"<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"../Spec/Methods.html#it%28description%3D%26quot%3Bassert%26quot%3B%2Cfile%3D__FILE__%2Cline%3D__LINE__%2Cend_line%3D__END_LINE__%2C%26block%29-instance-method\">#it</a></code></p>","abstract":false,"args":[{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"args_string":"(file = __FILE__, line = __LINE__, end_line = __END_LINE__, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L79","def":{"name":"assert","args":[{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{{ raise(\"'assert' was removed: use 'it' instead\".id) }}"}},{"id":"context(description,file=__FILE__,line=__LINE__,&block)-instance-method","html_id":"context(description,file=__FILE__,line=__LINE__,&amp;block)-instance-method","name":"context","doc":"Defines an example group that establishes a specific context,\nlike *empty array* versus *array with elements*.\nInside *&block* examples are defined by `#it` or `#pending`.\n\nIt is functionally equivalent to `#describe`.","summary":"<p>Defines an example group that establishes a specific context, like <em>empty array</em> versus <em>array with elements</em>.</p>","abstract":false,"args":[{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(description, file = __FILE__, line = __LINE__, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L24","def":{"name":"context","args":[{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"describe(description.to_s, file, line, &block)"}},{"id":"describe(description,file=__FILE__,line=__LINE__,&block)-instance-method","html_id":"describe(description,file=__FILE__,line=__LINE__,&amp;block)-instance-method","name":"describe","doc":"Defines an example group that describes a unit to be tested.\nInside *&block* examples are defined by `#it` or `#pending`.\n\nSeveral `describe` blocks can be nested.\n\nExample:\n```\ndescribe \"Int32\" do\n  describe \"+\" do\n    it \"adds\" { (1 + 1).should eq 2 }\n  end\nend\n```","summary":"<p>Defines an example group that describes a unit to be tested.</p>","abstract":false,"args":[{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(description, file = __FILE__, line = __LINE__, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L15","def":{"name":"describe","args":[{"name":"description","doc":null,"default_value":"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"Spec::RootContext.describe(description.to_s, file, line, &block)"}},{"id":"fail(msg,file=__FILE__,line=__LINE__)-instance-method","html_id":"fail(msg,file=__FILE__,line=__LINE__)-instance-method","name":"fail","doc":"Fails an example.\n\nThis method can be used to manually fail an example defined in an `#it` block.","summary":"<p>Fails an example.</p>","abstract":false,"args":[{"name":"msg","doc":null,"default_value":"","external_name":"msg","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(msg, file = __FILE__, line = __LINE__)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L86","def":{"name":"fail","args":[{"name":"msg","doc":null,"default_value":"","external_name":"msg","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(Spec::AssertionFailed.new(msg, file, line))"}},{"id":"it(description=&quot;assert&quot;,file=__FILE__,line=__LINE__,end_line=__END_LINE__,&block)-instance-method","html_id":"it(description=&amp;quot;assert&amp;quot;,file=__FILE__,line=__LINE__,end_line=__END_LINE__,&amp;block)-instance-method","name":"it","doc":"Defines a concrete test case.\n\nThe test is performed by the block supplied to *&block*.\n\nExample:\n```\nit \"adds\" { (1 + 1).should eq 2 }\n```\n\nIt is usually used inside a `#describe` or `#context` section.","summary":"<p>Defines a concrete test case.</p>","abstract":false,"args":[{"name":"description","doc":null,"default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"args_string":"(description = <span class=\"s\">&quot;assert&quot;</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L38","def":{"name":"it","args":[{"name":"description","doc":null,"default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":""},"return_type":"","visibility":"Public","body":"if Spec.matches?(description, file, line, end_line)\nelse\n  return\nend\nSpec.formatters.each(&.before_example(description))\nstart = Time.monotonic\nbegin\n  Spec.run_before_each_hooks\n  block.call\n  Spec::RootContext.report(:success, description, file, line, Time.monotonic - start)\nrescue ex : Spec::AssertionFailed\n  Spec::RootContext.report(:fail, description, file, line, Time.monotonic - start, ex)\n  if Spec.fail_fast?\n    Spec.abort!\n  end\nrescue ex\n  Spec::RootContext.report(:error, description, file, line, Time.monotonic - start, ex)\n  if Spec.fail_fast?\n    Spec.abort!\n  end\nensure\n  Spec.run_after_each_hooks\nend\n"}},{"id":"pending(description=&quot;assert&quot;,file=__FILE__,line=__LINE__,end_line=__END_LINE__,&block)-instance-method","html_id":"pending(description=&amp;quot;assert&amp;quot;,file=__FILE__,line=__LINE__,end_line=__END_LINE__,&amp;block)-instance-method","name":"pending","doc":"Defines a pending test case.\n\n*&block* is never evaluated.\nIt can be used to describe behaviour that is not yet implemented.\n\nExample:\n```\npending \"check cat\" { cat.alive? }\n```\n\nIt is usually used inside a `#describe` or `#context` section.","summary":"<p>Defines a pending test case.</p>","abstract":false,"args":[{"name":"description","doc":null,"default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"args_string":"(description = <span class=\"s\">&quot;assert&quot;</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/methods.cr#L70","def":{"name":"pending","args":[{"name":"description","doc":null,"default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","doc":null,"default_value":"__END_LINE__","external_name":"end_line","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if Spec.matches?(description, file, line, end_line)\nelse\n  return\nend\nSpec.formatters.each(&.before_example(description))\nSpec::RootContext.report(:pending, description, file, line)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Spec/ObjectExtensions","path":"Spec/ObjectExtensions.html","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"spec/expectations.cr","line_number":362,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"should(expectation,file=__FILE__,line=__LINE__)-instance-method","html_id":"should(expectation,file=__FILE__,line=__LINE__)-instance-method","name":"should","doc":"Validates an expectation and fails the example if it does not match.\n\nSee `Spec::Expecations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it does not match.</p>","abstract":false,"args":[{"name":"expectation","doc":null,"default_value":"","external_name":"expectation","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation, file = __FILE__, line = __LINE__)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L366","def":{"name":"should","args":[{"name":"expectation","doc":null,"default_value":"","external_name":"expectation","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if expectation.match(self)\nelse\n  fail(expectation.failure_message(self), file, line)\nend"}},{"id":"should_not(expectation,file=__FILE__,line=__LINE__)-instance-method","html_id":"should_not(expectation,file=__FILE__,line=__LINE__)-instance-method","name":"should_not","doc":"Validates an expectation and fails the example if it matches.\n\nSee `Spec::Expecations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it matches.</p>","abstract":false,"args":[{"name":"expectation","doc":null,"default_value":"","external_name":"expectation","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation, file = __FILE__, line = __LINE__)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L375","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/spec/expectations.cr#L375","def":{"name":"should_not","args":[{"name":"expectation","doc":null,"default_value":"","external_name":"expectation","restriction":""},{"name":"file","doc":null,"default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","doc":null,"default_value":"__LINE__","external_name":"line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if expectation.match(self)\n  fail(expectation.negative_failure_message(self), file, line)\nend"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/StaticArray","path":"StaticArray.html","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"static_array.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A fixed-size, stack allocated array.","summary":"<p>A fixed-size, stack allocated array.</p>","class_methods":[],"constructors":[{"id":"new(&block:Int32->T)-class-method","html_id":"new(&amp;block:Int32-&gt;T)-class-method","name":"new","doc":"Creates a new static array and invokes the\nblock once for each index of the array, assigning the\nblock's value in that index.\n\n```\nStaticArray(Int32, 3).new { |i| i * 2 } # => StaticArray[0, 2, 4]\n```","summary":"<p>Creates a new static array and invokes the block once for each index of the array, assigning the block's value in that index.</p>","abstract":false,"args":[],"args_string":"(&block : Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L32","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Int32 -> T)"},"return_type":"","visibility":"Public","body":"array = uninitialized self\nN.times do |i|\n  array.to_unsafe[i] = yield i\nend\narray\n"}},{"id":"new(value:T)-class-method","html_id":"new(value:T)-class-method","name":"new","doc":"Creates a new static array filled with the given value.\n\n```\nStaticArray(Int32, 3).new(42) # => StaticArray[42, 42, 42]\n```","summary":"<p>Creates a new static array filled with the given value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L45","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new do\n  value\nend"}}],"instance_methods":[{"id":"==(other:StaticArray)-instance-method","html_id":"==(other:StaticArray)-instance-method","name":"==","doc":"Equality. Returns `true` if each element in `self` is equal to each\ncorresponding element in *other*.\n\n```\narray = StaticArray(Int32, 3).new 0  # => StaticArray[0, 0, 0]\narray2 = StaticArray(Int32, 3).new 0 # => StaticArray[0, 0, 0]\narray3 = StaticArray(Int32, 3).new 1 # => StaticArray[1, 1, 1]\narray == array2                      # => true\narray == array3                      # => false\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StaticArray"}],"args_string":"(other : StaticArray)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L65","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"StaticArray"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\neach_with_index do |e, i|\n  if e == other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Equality with another object. Always returns `false`.\n\n```\narray = StaticArray(Int32, 3).new 0 # => StaticArray[0, 0, 0]\narray == nil                        # => false\n```","summary":"<p>Equality with another object.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L79","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"[]=(index:Int,value:T)-instance-method","html_id":"[]=(index:Int,value:T)-instance-method","name":"[]=","doc":"Sets the given value at the given *index*.\n\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to set an element outside the array's range.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 } # => StaticArray[1, 2, 3]\narray[2] = 2                                    # => 2\narray                                           # => StaticArray[1, 2, 2]\narray[4] = 4                                    # raises IndexError\n```","summary":"<p>Sets the given value at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L100","def":{"name":"[]=","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index)\nto_unsafe[index] = value\n"}},{"id":"[]=(value:T)-instance-method","html_id":"[]=(value:T)-instance-method","name":"[]=","doc":"Fills the array by substituting all elements with the given value.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.[]= 2 # => nil\narray       # => StaticArray[2, 2, 2]\n```","summary":"<p>Fills the array by substituting all elements with the given value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"args_string":"(value : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L137","def":{"name":"[]=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size.times do |i|\n  to_unsafe[i] = value\nend"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new `StaticArray` where each element is cloned from elements in `self`.","summary":"<p>Returns a new <code><a href=\"StaticArray.html\">StaticArray</a></code> where each element is cloned from elements in <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L244","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"array = uninitialized self\nN.times do |i|\n  array.to_unsafe[i] = to_unsafe[i].clone\nend\narray\n"}},{"id":"map(&block:T->U)forallU-instance-method","html_id":"map(&amp;block:T-&gt;U)forallU-instance-method","name":"map","doc":"Returns a new static array where elements are mapped by the given block.\n\n```\narray = StaticArray[1, 2.5, \"a\"]\narray.map &.to_s # => StaticArray[\"1\", \"2.5\", \"a\"]\n```","summary":"<p>Returns a new static array where elements are mapped by the given block.</p>","abstract":false,"args":[],"args_string":"(&block : T -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L174","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T -> U)"},"return_type":"","visibility":"Public","body":"StaticArray(U, N).new do |i|\n  yield to_unsafe[i]\nend"}},{"id":"map!(&block)-instance-method","html_id":"map!(&amp;block)-instance-method","name":"map!","doc":"Invokes the given block for each element of `self`, replacing the element\nwith the value returned by the block. Returns `self`.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.map! { |x| x*x } # => StaticArray[1, 4, 9]\n```","summary":"<p>Invokes the given block for each element of <code>self</code>, replacing the element with the value returned by the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L163","def":{"name":"map!","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"to_unsafe.map!(size) do |e|\n  yield e\nend\nself\n"}},{"id":"map_with_index(&block:T,Int32->U)forallU-instance-method","html_id":"map_with_index(&amp;block:T,Int32-&gt;U)forallU-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.","summary":"<p>Like <code><a href=\"StaticArray.html#map%28%26block%3AT-%3EU%29forallU-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> U) forall U","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L185","def":{"name":"map_with_index","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> U)"},"return_type":"","visibility":"Public","body":"StaticArray(U, N).new do |i|\n  yield to_unsafe[i], i\nend"}},{"id":"map_with_index!(&block:T,Int32->T)-instance-method","html_id":"map_with_index!(&amp;block:T,Int32-&gt;T)-instance-method","name":"map_with_index!","doc":"Like `map!`, but the block gets passed both the element and its index.","summary":"<p>Like <code><a href=\"StaticArray.html#map%21%28%26block%29-instance-method\">#map!</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[],"args_string":"(&block : T, Int32 -> T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L179","def":{"name":"map_with_index!","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(T, Int32 -> T)"},"return_type":"","visibility":"Public","body":"to_unsafe.map_with_index!(size) do |e, i|\n  yield e, i\nend\nself\n"}},{"id":"pretty_print(pp)-instance-method","html_id":"pretty_print(pp)-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L235","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pp.list(\"StaticArray[\", to_slice, \"]\")"}},{"id":"reverse!-instance-method","html_id":"reverse!-instance-method","name":"reverse!","doc":"Reverses the elements of this array in-place, then returns `self`.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.reverse! # => StaticArray[3, 2, 1]\n```","summary":"<p>Reverses the elements of this array in-place, then returns <code>self</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L195","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L195","def":{"name":"reverse!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.reverse!\nself\n"}},{"id":"shuffle!(random=Random::DEFAULT)-instance-method","html_id":"shuffle!(random=Random::DEFAULT)-instance-method","name":"shuffle!","doc":"Modifies `self` by randomizing the order of elements in the array\nusing the given *random* number generator.  Returns `self`.\n\n```\na = StaticArray(Int32, 3).new { |i| i + 1 } # => StaticArray[1, 2, 3]\na.shuffle!(Random.new(42))                  # => StaticArray[3, 2, 1]\na                                           # => StaticArray[3, 2, 1]\n```","summary":"<p>Modifies <code>self</code> by randomizing the order of elements in the array using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L151","def":{"name":"shuffle!","args":[{"name":"random","doc":null,"default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.shuffle!(random)\nself\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the size of `self`\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.size # => 3\n```","summary":"<p>Returns the size of <code>self</code></p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L126","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"N"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends a string representation of this static array to the given `IO`.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.to_s # => \"StaticArray[1, 2, 3]\"\n```","summary":"<p>Appends a string representation of this static array to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L229","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"StaticArray[\"\njoin(\", \", io, &.inspect(io))\nio << ']'\n"}},{"id":"to_slice-instance-method","html_id":"to_slice-instance-method","name":"to_slice","doc":"Returns a slice that points to the elements of this static array.\nChanges made to the returned slice also affect this static array.\n\n```\narray = StaticArray(Int32, 3).new(2)\nslice = array.to_slice # => Slice[2, 2, 2]\nslice[0] = 3\narray # => StaticArray[3, 2, 2]\n```","summary":"<p>Returns a slice that points to the elements of this static array.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L209","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Slice.new(to_unsafe, size)"}},{"id":"to_unsafe:Pointer(T)-instance-method","html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns a pointer to this static array's data.\n\n```\nary = StaticArray(Int32, 3).new(42)\nary.to_unsafe[0] # => 42\n```","summary":"<p>Returns a pointer to this static array's data.</p>","abstract":false,"args":[],"args_string":" : Pointer(T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L219","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Pointer(T)","visibility":"Public","body":"pointerof(@buffer)"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L84","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_unsafe[index]"}},{"id":"update(index:Int,&block)-instance-method","html_id":"update(index:Int,&amp;block)-instance-method","name":"update","doc":"Yields the current element at the given index and updates the value\nat the given *index* with the block's value.\nRaises `IndexError` if trying to set an element outside the array's range.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 } # => StaticArray[1, 2, 3]\narray.update(1) { |x| x * 2 }                   # => 4\narray                                           # => StaticArray[1, 4, 3]\narray.update(5) { |x| x * 2 }                   # raises IndexError\n```","summary":"<p>Yields the current element at the given index and updates the value at the given <em>index</em> with the block's value.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L115","def":{"name":"update","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"index = check_index_out_of_bounds(index)\nto_unsafe[index] = yield to_unsafe[index]\n"}}],"macros":[{"id":"[](*args)-macro","html_id":"[](*args)-macro","name":"[]","doc":"Create a new `StaticArray` with the given *args*. The type of the\nstatic array will be the union of the type of the given *args*,\nand its size will be the number of elements in *args*.\n\n```\nary = StaticArray[1, 'a']\nary[0]    # => 1\nary[1]    # => 'a'\nary.class # => StaticArray(Char | Int32, 2)\n```\n\nSee also: `Number.static_array`.","summary":"<p>Create a new <code><a href=\"StaticArray.html\">StaticArray</a></code> with the given <em>args</em>.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/static_array.cr#L17","def":{"name":"[]","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":null,"splat_index":0,"block_arg":null,"visibility":"Public","body":"    \n%array\n = uninitialized StaticArray(typeof(\n{{ *args }}\n), \n{{ args.size }}\n)\n    \n{% for arg, i in args %}\n      %array.to_unsafe[{{ i }}] = {{ arg }}\n    {% end %}\n\n    \n%array\n\n  \n"}}],"types":[]},{"html_id":"github.com/crystal-lang/crystal/String","path":"String.html","kind":"class","full_name":"String","name":"String","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"string.cr","line_number":132,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr"},{"filename":"string/utf16.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/utf16.cr"},{"filename":"big/big_int.cr","line_number":543,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr"},{"filename":"big/big_float.cr","line_number":282,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr"},{"filename":"big/big_decimal.cr","line_number":483,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr"},{"filename":"json/to_json.cr","line_number":51,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":61,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A `String` represents an immutable sequence of UTF-8 characters.\n\nA `String` is typically created with a string literal, enclosing UTF-8 characters\nin double quotes:\n\n```\n\"hello world\"\n```\n\nA backslash can be used to denote some characters inside the string:\n\n```\n\"\\\"\" # double quote\n\"\\\\\" # backslash\n\"\\e\" # escape\n\"\\f\" # form feed\n\"\\n\" # newline\n\"\\r\" # carriage return\n\"\\t\" # tab\n\"\\v\" # vertical tab\n```\n\nYou can use a backslash followed by an *u* and four hexadecimal characters to denote a unicode codepoint written:\n\n```\n\"\\u0041\" # == \"A\"\n```\n\nOr you can use curly braces and specify up to six hexadecimal numbers (0 to 10FFFF):\n\n```\n\"\\u{41}\" # == \"A\"\n```\n\nA string can span multiple lines:\n\n```\n\"hello\n      world\" # same as \"hello\\n      world\"\n```\n\nNote that in the above example trailing and leading spaces, as well as newlines,\nend up in the resulting string. To avoid this, you can split a string into multiple lines\nby joining multiple literals with a backslash:\n\n```\n\"hello \" \\\n\"world, \" \\\n\"no newlines\" # same as \"hello world, no newlines\"\n```\n\nAlternatively, a backslash followed by a newline can be inserted inside the string literal:\n\n```\n\"hello \\\n     world, \\\n     no newlines\" # same as \"hello world, no newlines\"\n```\n\nIn this case, leading whitespace is not included in the resulting string.\n\nIf you need to write a string that has many double quotes, parentheses, or similar\ncharacters, you can use alternative literals:\n\n```\n# Supports double quotes and nested parentheses\n%(hello (\"world\")) # same as \"hello (\\\"world\\\")\"\n\n# Supports double quotes and nested brackets\n%[hello [\"world\"]] # same as \"hello [\\\"world\\\"]\"\n\n# Supports double quotes and nested curlies\n%{hello {\"world\"}} # same as \"hello {\\\"world\\\"}\"\n\n# Supports double quotes and nested angles\n%<hello <\"world\">> # same as \"hello <\\\"world\\\">\"\n```\n\nTo create a `String` with embedded expressions, you can use string interpolation:\n\n```\na = 1\nb = 2\n\"sum = #{a + b}\" # \"sum = 3\"\n```\n\nThis ends up invoking `Object#to_s(IO)` on each expression enclosed by `#{...}`.\n\nIf you need to dynamically build a string, use `String#build` or `IO::Memory`.\n\n### Non UTF-8 valid strings\n\nString might end up being conformed of bytes which are an invalid\nbyte sequence according to UTF-8. This can happen if the string is created\nvia one of the constructors that accept bytes, or when getting a string\nfrom `String.build` or `IO::Memory`. No exception will be raised, but\ninvalid byte sequences, when asked as chars, will use the unicode replacement\nchar (value 0xFFFD). For example:\n\n```\n# here 255 is not a valid byte value in the UTF-8 encoding\nstring = String.new(Bytes[255, 97])\nstring.valid_encoding? # => false\n\n# The first char here is the unicode replacement char\nstring.chars # => ['�', 'a']\n```\n\nOne can also create strings with specific byte value in them by\nusing octal and hexadecimal escape sequences:\n\n```\n# Octal escape sequences\n\"\\101\" # # => \"A\"\n\"\\12\"  # # => \"\\n\"\n\"\\1\"   # string with one character with code point 1\n\"\\377\" # string with one byte with value 255\n\n# Hexadecimal escape sequences\n\"\\x41\" # # => \"A\"\n\"\\xFF\" # string with one byte with value 255\n```\n\nThe reason for allowing strings that don't have a valid UTF-8 sequence\nis that the world is full of content that isn't properly encoded,\nand having a program raise an exception or stop because of this\nis not good. It's better if programs are more resilient, but\nshow a replacement character when there's an error in incoming data.","summary":"<p>A <code><a href=\"String.html\">String</a></code> represents an immutable sequence of UTF-8 characters.</p>","class_methods":[],"constructors":[{"id":"build(capacity=64,&block):self-class-method","html_id":"build(capacity=64,&amp;block):self-class-method","name":"build","doc":"Builds a `String` by creating a `String::Builder` with the given initial capacity, yielding\nit to the block and finally getting a `String` out of it. The `String::Builder` automatically\nresizes as needed.\n\n```\nstr = String.build do |str|\n  str << \"hello \"\n  str << 1\nend\nstr # => \"hello 1\"\n```","summary":"<p>Builds a <code><a href=\"String.html\">String</a></code> by creating a <code><a href=\"String/Builder.html\">String::Builder</a></code> with the given initial capacity, yielding it to the block and finally getting a <code><a href=\"String.html\">String</a></code> out of it.</p>","abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":""}],"args_string":"(capacity = <span class=\"n\">64</span>, &block) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L267","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L267","def":{"name":"build","args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"self","visibility":"Public","body":"String::Builder.build(capacity) do |builder|\n  yield builder\nend"}},{"id":"from_utf16(slice:Slice(UInt16)|Pointer(UInt16)):String-class-method","html_id":"from_utf16(slice:Slice(UInt16)|Pointer(UInt16)):String-class-method","name":"from_utf16","doc":"Decodes the given *slice* UTF-16 sequence into a String.\n\nInvalid values are encoded using the unicode replacement char with\ncodepoint `0xfffd`.\n\n```\nslice = Slice[104_u16, 105_u16, 32_u16, 55296_u16, 56485_u16]\nString.from_utf16(slice) # => \"hi 𐂥\"\n```\n\nIf *slice* is a pointer, the string ends when a zero value is found.\n\n```\nslice = Slice[104_u16, 105_u16, 0_u16, 55296_u16, 56485_u16]\nString.from_utf16(slice)           # => \"hi\\0000𐂥\"\nString.from_utf16(slice.to_unsafe) # => \"hi\"\n```","summary":"<p>Decodes the given <em>slice</em> UTF-16 sequence into a String.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Slice(UInt16) | Pointer(UInt16)"}],"args_string":"(slice : Slice(UInt16) | Pointer(UInt16)) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/utf16.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/utf16.cr#L64","def":{"name":"from_utf16","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Slice(UInt16) | Pointer(UInt16)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"bytesize = 0\nsize = 0\neach_utf16_char(slice) do |char|\n  bytesize = bytesize + char.bytesize\n  size = size + 1\nend\nString.new(bytesize) do |buffer|\n  each_utf16_char(slice) do |char|\n    char.each_byte do |byte|\n      buffer.value = byte\n      buffer = buffer + 1\n    end\n  end\n  {bytesize, size}\nend\n"}},{"id":"new(bytes:Bytes,encoding:String,invalid:Symbol?=nil):String-class-method","html_id":"new(bytes:Bytes,encoding:String,invalid:Symbol?=nil):String-class-method","name":"new","doc":"Creates a new `String` from the given *bytes*, which are encoded in the given *encoding*.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\n```\nslice = Slice.new(2, 0_u8)\nslice[0] = 186_u8\nslice[1] = 195_u8\nString.new(slice, \"GB2312\") # => \"好\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> from the given <em>bytes</em>, which are encoded in the given <em>encoding</em>.</p>","abstract":false,"args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"},{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(bytes : Bytes, encoding : String, invalid : Symbol? = <span class=\"n\">nil</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L170","def":{"name":"new","args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"},{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |str|\n  String.encode(bytes, encoding, \"UTF-8\", str, invalid)\nend"}},{"id":"new(chars:Pointer(UInt8),bytesize,size=0)-class-method","html_id":"new(chars:Pointer(UInt8),bytesize,size=0)-class-method","name":"new","doc":"Creates a new `String` from a pointer, indicating its bytesize count\nand, optionally, the UTF-8 codepoints count (size). `Bytes` will be\ncopied from the pointer.\n\nIf the given size is zero, the amount of UTF-8 codepoints will be\nlazily computed when needed.\n\n```\nptr = Pointer.malloc(4) { |i| ('a'.ord + i).to_u8 }\nString.new(ptr, 2) # => \"ab\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> from a pointer, indicating its bytesize count and, optionally, the UTF-8 codepoints count (size).</p>","abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""},{"name":"size","doc":null,"default_value":"0","external_name":"size","restriction":""}],"args_string":"(chars : Pointer(UInt8), bytesize, size = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L205","def":{"name":"new","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"::Pointer(UInt8)"},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""},{"name":"size","doc":null,"default_value":"0","external_name":"size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize == 0\n  return \"\"\nend\nnew(bytesize) do |buffer|\n  buffer.copy_from(chars, bytesize)\n  {bytesize, size}\nend\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L55","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"id":"new(slice:Bytes)-class-method","html_id":"new(slice:Bytes)-class-method","name":"new","doc":"Creates a `String` from the given *slice*. `Bytes` will be copied from the slice.\n\nThis method is always safe to call, and the resulting string will have\nthe contents and size of the slice.\n\n```\nslice = Slice.new(4) { |i| ('a'.ord + i).to_u8 }\nString.new(slice) # => \"abcd\"\n```","summary":"<p>Creates a <code><a href=\"String.html\">String</a></code> from the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L154","def":{"name":"new","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(slice.pointer(slice.size), slice.size)"}},{"id":"new(chars:Pointer(UInt8))-class-method","html_id":"new(chars:Pointer(UInt8))-class-method","name":"new","doc":"Creates a `String` from a pointer. `Bytes` will be copied from the pointer.\n\nThis method is **unsafe**: the pointer must point to data that eventually\ncontains a zero byte that indicates the ends of the string. Otherwise,\nthe result of this method is undefined and might cause a segmentation fault.\n\nThis method is typically used in C bindings, where you get a `char*` from a\nlibrary and the library guarantees that this pointer eventually has an\nending zero byte.\n\n```\nptr = Pointer.malloc(5) { |i| i == 4 ? 0_u8 : ('a'.ord + i).to_u8 }\nString.new(ptr) # => \"abcd\"\n```","summary":"<p>Creates a <code><a href=\"String.html\">String</a></code> from a pointer.</p>","abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"::Pointer(UInt8)"}],"args_string":"(chars : Pointer(UInt8))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L190","def":{"name":"new","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"::Pointer(UInt8)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(chars, LibC.strlen(chars))"}},{"id":"new(capacity:Int,&block)-class-method","html_id":"new(capacity:Int,&amp;block)-class-method","name":"new","doc":"Creates a new `String` by allocating a buffer (`Pointer(UInt8)`) with the given capacity, then\nyielding that buffer. The block must return a tuple with the bytesize and size\n(UTF-8 codepoints count) of the String. If the returned size is zero, the UTF-8 codepoints\ncount will be lazily computed.\n\nThe bytesize returned by the block must be less than or equal to the\ncapacity given to this String, otherwise `ArgumentError` is raised.\n\nIf you need to build a `String` where the maximum capacity is unknown, use `String#build`.\n\n```\nstr = String.new(4) do |buffer|\n  buffer[0] = 'a'.ord.to_u8\n  buffer[1] = 'b'.ord.to_u8\n  {2, 2}\nend\nstr # => \"ab\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> by allocating a buffer (<code><a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>)</code>) with the given capacity, then yielding that buffer.</p>","abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L233","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L233","def":{"name":"new","args":[{"name":"capacity","doc":null,"default_value":"","external_name":"capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"check_capacity_in_bounds(capacity)\nstr = (GC.malloc_atomic((capacity.to_u32 + HEADER_SIZE) + 1)).as(::Pointer(UInt8))\nbuffer = (str.as(String)).to_unsafe\nbytesize, size = yield buffer\nif 0 <= bytesize && bytesize <= capacity\nelse\n  raise(ArgumentError.new(\"Bytesize out of capacity bounds\"))\nend\nbuffer[bytesize] = 0_u8\nif bytesize < capacity\n  str = str.realloc((bytesize.to_u32 + HEADER_SIZE) + 1)\nend\nstr_header = str.as(::Pointer(::Tuple(Int32, Int32, Int32)))\nstr_header.value = {TYPE_ID, bytesize.to_i, size.to_i}\nstr.as(String)\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L97","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"pull.read_string"}}],"instance_methods":[{"id":"%(other)-instance-method","html_id":"%(other)-instance-method","name":"%","doc":"Interpolates *other* into the string using `Kernel#sprintf`.\n\n```\n\"I have %d apples\" % 5                                             # => \"I have 5 apples\"\n\"%s, %s, %s, D\" % ['A', 'B', 'C']                                  # => \"A, B, C, D\"\n\"sum: %{one} + %{two} = %{three}\" % {one: 1, two: 2, three: 1 + 2} # => \"sum: 1 + 2 = 3\"\n\"I have %<apples>s apples\" % {apples: 4}                           # => \"I have 4 apples\"\n```","summary":"<p>Interpolates <em>other</em> into the string using <code>Kernel#sprintf</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4062","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4062","def":{"name":"%","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sprintf(self, other)"}},{"id":"*(times:Int)-instance-method","html_id":"*(times:Int)-instance-method","name":"*","doc":"Makes a new `String` by adding *str* to itself *times* times.\n\n```\n\"Developers! \" * 4\n# => \"Developers! Developers! Developers! Developers! \"\n```","summary":"<p>Makes a new <code><a href=\"String.html\">String</a></code> by adding <em>str</em> to itself <em>times</em> times.</p>","abstract":false,"args":[{"name":"times","doc":null,"default_value":"","external_name":"times","restriction":"Int"}],"args_string":"(times : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2498","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2498","def":{"name":"*","args":[{"name":"times","doc":null,"default_value":"","external_name":"times","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if times < 0\n  raise(ArgumentError.new(\"Negative argument\"))\nend\nif (times == 0) || (bytesize == 0)\n  return \"\"\nelse\n  if bytesize == 1\n    return String.new(times) do |buffer|\n      Intrinsics.memset(buffer.as(::Pointer(Void)), to_unsafe[0], times, 0, false)\n      {times, times}\n    end\n  end\nend\ntotal_bytesize = bytesize * times\nString.new(total_bytesize) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  n = bytesize\n  while n <= (total_bytesize / 2)\n    (buffer + n).copy_from(buffer, n)\n    n = n * 2\n  end\n  (buffer + n).copy_from(buffer, total_bytesize - n)\n  {total_bytesize, @length * times}\nend\n"}},{"id":"+(char:Char)-instance-method","html_id":"+(char:Char)-instance-method","name":"+","doc":"Concatenates *str* and *other*.\n\n```\n\"abc\" + \"def\" # => \"abcdef\"\n\"abc\" + 'd'   # => \"abcd\"\n```","summary":"<p>Concatenates <em>str</em> and <em>other</em>.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2477","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2477","def":{"name":"+","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytes, count = String.char_bytes_and_bytesize(char)\nsize = bytesize + count\nString.new(size) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  (buffer + bytesize).copy_from(bytes.to_unsafe, count)\n  if size_known?\n    {size, @length + 1}\n  else\n    {size, 0}\n  end\nend\n"}},{"id":"+(other:self)-instance-method","html_id":"+(other:self)-instance-method","name":"+","doc":"Concatenates *str* and *other*.\n\n```\n\"abc\" + \"def\" # => \"abcdef\"\n\"abc\" + 'd'   # => \"abcd\"\n```","summary":"<p>Concatenates <em>str</em> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2459","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2459","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if other.empty?\n  return self\nend\nif self.empty?\n  return other\nend\nsize = bytesize + other.bytesize\nString.new(size) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  (buffer + bytesize).copy_from(other.to_unsafe, other.bytesize)\n  if size_known? && other.size_known?\n    {size, @length + (other.@length)}\n  else\n    {size, 0}\n  end\nend\n"}},{"id":"(other:self)-instance-method","html_id":"(other:self)-instance-method","name":"<=>","doc":"Compares this string with *other*, returning `-1`, `0` or `+1` depending on whether\nthis string is less, equal or greater than *other*.\n\nComparison is done byte-per-byte: if a byte is less then the other corresponding\nbyte, `-1` is returned and so on.\n\nIf the strings are of different lengths, and the strings are equal when compared\nup to the shortest length, then the longer string is considered greater than\nthe shorter one.\n\n```\n\"abcdef\" <=> \"abcde\"   # => 1\n\"abcdef\" <=> \"abcdef\"  # => 0\n\"abcdef\" <=> \"abcdefg\" # => -1\n\"abcdef\" <=> \"ABCDEF\"  # => 1\n```","summary":"<p>Compares this string with <em>other</em>, returning <code>-1</code>, <code>0</code> or <code>+1</code> depending on whether this string is less, equal or greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2380","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2380","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if same?(other)\n  return 0\nend\nmin_bytesize = Math.min(bytesize, other.bytesize)\ncmp = to_unsafe.memcmp(other.to_unsafe, min_bytesize)\ncmp == 0 ? (bytesize <=> other.bytesize) : cmp.sign\n"}},{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2358","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2358","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if same?(other)\n  return true\nend\nif bytesize == other.bytesize\nelse\n  return false\nend\n(to_unsafe.memcmp(other.to_unsafe, bytesize)) == 0\n"}},{"id":"=~(regex:Regex)-instance-method","html_id":"=~(regex:Regex)-instance-method","name":"=~","doc":"Tests whether *str* matches *regex*.\nIf successful, it returns the position of the first match.\nIf unsuccessful, it returns `nil`.\n\nIf the argument isn't a `Regex`, it returns `nil`.\n\n```\n\"Haystack\" =~ /ay/ # => 1\n\"Haystack\" =~ /z/  # => nil\n\n\"Haystack\" =~ 45 # => nil\n```","summary":"<p>Tests whether <em>str</em> matches <em>regex</em>.</p>","abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2442","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2442","def":{"name":"=~","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = regex.match(self)\n$~ = match\nmatch.try(&.begin(0))\n"}},{"id":"=~(other)-instance-method","html_id":"=~(other)-instance-method","name":"=~","doc":"Tests whether *str* matches *regex*.\nIf successful, it returns the position of the first match.\nIf unsuccessful, it returns `nil`.\n\nIf the argument isn't a `Regex`, it returns `nil`.\n\n```\n\"Haystack\" =~ /ay/ # => 1\n\"Haystack\" =~ /z/  # => nil\n\n\"Haystack\" =~ 45 # => nil\n```","summary":"<p>Tests whether <em>str</em> matches <em>regex</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2449","def":{"name":"=~","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"nil"}},{"id":"[](start:Int,count:Int)-instance-method","html_id":"[](start:Int,count:Int)-instance-method","name":"[]","doc":"Returns a substring starting from the *start* character\nof size *count*.\n\nThe *start* argument can be negative to start counting\nfrom the end of the string.\n\nRaises `IndexError` if *start* isn't in range.\n\nRaises `ArgumentError` if *count* is negative.","summary":"<p>Returns a substring starting from the <em>start</em> character of size <em>count</em>.</p>","abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L745","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L745","def":{"name":"[]","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if ascii_only?\n  return byte_slice(start, count)\nend\nif start < 0\n  start = start + size\nend\nstart_pos = nil\nend_pos = nil\nreader = Char::Reader.new(self)\ni = 0\nreader.each do |char|\n  if i == start\n    start_pos = reader.pos\n  else\n    if count >= 0 && (i == (start + count))\n      end_pos = reader.pos\n      i = i + 1\n      break\n    end\n  end\n  i = i + 1\nend\nend_pos || (end_pos = reader.pos)\nif start_pos\n  if count < 0\n    raise(ArgumentError.new(\"Negative count\"))\n  end\n  if count == 0\n    return \"\"\n  end\n  count = end_pos - start_pos\n  if count == bytesize\n    return self\n  end\n  String.new(count) do |buffer|\n    buffer.copy_from(to_unsafe + start_pos, count)\n    {count, 0}\n  end\nelse\n  if start == i\n    if count >= 0\n      return \"\"\n    else\n      raise(ArgumentError.new(\"Negative count\"))\n    end\n  else\n    raise(IndexError.new)\n  end\nend\n"}},{"id":"[](regex:Regex,group)-instance-method","html_id":"[](regex:Regex,group)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"group","doc":null,"default_value":"","external_name":"group","restriction":""}],"args_string":"(regex : Regex, group)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L818","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L818","def":{"name":"[]","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"group","doc":null,"default_value":"","external_name":"group","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[regex, group]?.not_nil!"}},{"id":"[](index:Int)-instance-method","html_id":"[](index:Int)-instance-method","name":"[]","doc":"Returns the `Char` at the given *index*, or raises `IndexError` if out of bounds.\n\nNegative indices can be used to start counting from the end of the string.\n\n```\n\"hello\"[0]  # 'h'\n\"hello\"[1]  # 'e'\n\"hello\"[-1] # 'o'\n\"hello\"[-2] # 'l'\n\"hello\"[5]  # raises IndexError\n```","summary":"<p>Returns the <code><a href=\"Char.html\">Char</a></code> at the given <em>index</em>, or raises <code><a href=\"IndexError.html\">IndexError</a></code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L716","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L716","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  raise(IndexError.new)\nend"}},{"id":"[](range:Range(Int,Int))-instance-method","html_id":"[](range:Range(Int,Int))-instance-method","name":"[]","doc":"Returns a substring by using a Range's *begin* and *end*\nas character indices. Indices can be negative to start\ncounting from the end of the string.\n\nRaises `IndexError` if the range's start is not in range.\n\n```\n\"hello\"[0..2]   # \"hel\"\n\"hello\"[0...2]  # \"he\"\n\"hello\"[1..-1]  # \"ello\"\n\"hello\"[1...-1] # \"ell\"\n```","summary":"<p>Returns a substring by using a Range's <em>begin</em> and <em>end</em> as character indices.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L732","def":{"name":"[]","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[*Indexable.range_to_index_and_count(range, size)]"}},{"id":"[](str:String|Char)-instance-method","html_id":"[](str:String|Char)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String | Char"}],"args_string":"(str : String | Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L810","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L810","def":{"name":"[]","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String | Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[str]?.not_nil!"}},{"id":"[](regex:Regex)-instance-method","html_id":"[](regex:Regex)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L814","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L814","def":{"name":"[]","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[regex]?.not_nil!"}},{"id":"[]?(index:Int)-instance-method","html_id":"[]?(index:Int)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L793","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L793","def":{"name":"[]?","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  nil\nend"}},{"id":"[]?(regex:Regex,group)-instance-method","html_id":"[]?(regex:Regex,group)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"group","doc":null,"default_value":"","external_name":"group","restriction":""}],"args_string":"(regex : Regex, group)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L805","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L805","def":{"name":"[]?","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"group","doc":null,"default_value":"","external_name":"group","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = match(regex)\nif match\n  match[group]?\nend\n"}},{"id":"[]?(regex:Regex)-instance-method","html_id":"[]?(regex:Regex)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L801","def":{"name":"[]?","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[regex, 0]?"}},{"id":"[]?(str:String|Char)-instance-method","html_id":"[]?(str:String|Char)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String | Char"}],"args_string":"(str : String | Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L797","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L797","def":{"name":"[]?","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String | Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"includes?(str) ? str : nil"}},{"id":"ascii_only?-instance-method","html_id":"ascii_only?-instance-method","name":"ascii_only?","doc":"Returns `true` if this String is comprised in its entirety\nby ASCII characters.\n\n```\n\"hello\".ascii_only? # => true\n\"你好\".ascii_only?    # => false\n```","summary":"<p>Returns <code>true</code> if this String is comprised in its entirety by ASCII characters.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4092","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4092","def":{"name":"ascii_only?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytesize == size"}},{"id":"at(index:Int)-instance-method","html_id":"at(index:Int)-instance-method","name":"at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L822","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L822","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  raise(IndexError.new)\nend"}},{"id":"at(index:Int,&block)-instance-method","html_id":"at(index:Int,&amp;block)-instance-method","name":"at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L826","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L826","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if ascii_only?\n  byte = byte_at?(index)\n  if byte\n    return byte < 128 ? byte.unsafe_chr : Char::REPLACEMENT\n  else\n    return yield\n  end\nend\nif index < 0\n  index = index + size\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index && byte_index < @bytesize\n  reader = Char::Reader.new(self, pos: byte_index)\n  return reader.current_char\nelse\n  yield\nend\n"}},{"id":"blank?-instance-method","html_id":"blank?-instance-method","name":"blank?","doc":"Returns `true` if this string consists exclusively of unicode whitespace.\n\n```\n\"\".blank?        # => true\n\"   \".blank?     # => true\n\"   a   \".blank? # => false\n```","summary":"<p>Returns <code>true</code> if this string consists exclusively of unicode whitespace.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2351","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2351","def":{"name":"blank?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_char do |char|\n  if char.whitespace?\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"byte_at(index)-instance-method","html_id":"byte_at(index)-instance-method","name":"byte_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L886","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L886","def":{"name":"byte_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"byte_at(index) do\n  raise(IndexError.new)\nend"}},{"id":"byte_at(index,&block)-instance-method","html_id":"byte_at(index,&amp;block)-instance-method","name":"byte_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L894","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L894","def":{"name":"byte_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + bytesize\nend\nif 0 <= index && index < bytesize\n  to_unsafe[index]\nelse\n  yield\nend\n"}},{"id":"byte_at?(index)-instance-method","html_id":"byte_at?(index)-instance-method","name":"byte_at?","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L890","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L890","def":{"name":"byte_at?","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"byte_at(index) do\n  nil\nend"}},{"id":"byte_index(search:String,offset=0)-instance-method","html_id":"byte_index(search:String,offset=0)-instance-method","name":"byte_index","doc":null,"summary":null,"abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2860","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2860","def":{"name":"byte_index","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + bytesize\nend\nif offset < 0\n  return\nend\nif search.empty?\n  return bytesize < offset ? nil : offset\nend\nsearch_hash = 0_u32\nsearch.each_byte do |b|\n  search_hash = (search_hash * PRIME_RK) + b\nend\npow = PRIME_RK ** search.bytesize\npointer = head_pointer = to_unsafe + offset\nhash_end_pointer = pointer + search.bytesize\nend_pointer = to_unsafe + bytesize\nhash = 0_u32\nif hash_end_pointer > end_pointer\n  return\nend\nwhile pointer < hash_end_pointer\n  hash = (hash * PRIME_RK) + pointer.value\n  pointer = pointer + 1\nend\nwhile true\n  if (hash == search_hash) && ((head_pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return offset\n  end\n  if pointer >= end_pointer\n    return\n  end\n  hash = ((hash * PRIME_RK) + pointer.value) - (pow * head_pointer.value)\n  pointer = pointer + 1\n  head_pointer = head_pointer + 1\n  offset = offset + 1\nend\nnil\n"}},{"id":"byte_index(byte:Int,offset=0)-instance-method","html_id":"byte_index(byte:Int,offset=0)-instance-method","name":"byte_index","doc":null,"summary":null,"abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"Int"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(byte : Int, offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2851","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2851","def":{"name":"byte_index","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"Int"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"offset.upto(bytesize - 1) do |i|\n  if to_unsafe[i] == byte\n    return i\n  end\nend\nnil\n"}},{"id":"byte_index_to_char_index(index)-instance-method","html_id":"byte_index_to_char_index(index)-instance-method","name":"byte_index_to_char_index","doc":"Returns the char index of a byte index, or `nil` if out of bounds.\n\nIt is valid to pass `#bytesize` to *index*, and in this case the answer\nwill be the size of this string.","summary":"<p>Returns the char index of a byte index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2932","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2932","def":{"name":"byte_index_to_char_index","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if ascii_only?\n  return 0 <= index && index <= bytesize ? index : nil\nend\nsize = each_byte_index_and_char_index do |byte_index, char_index|\n  if index == byte_index\n    return char_index\n  end\nend\nif index == @bytesize\n  return size\nend\nnil\n"}},{"id":"byte_slice(start:Int,count:Int)-instance-method","html_id":"byte_slice(start:Int,count:Int)-instance-method","name":"byte_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L847","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L847","def":{"name":"byte_slice","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if start < 0\n  start = start + bytesize\nend\nsingle_byte_optimizable = ascii_only?\nif 0 <= start && start < bytesize\n  if count < 0\n    raise(ArgumentError.new(\"Negative count\"))\n  end\n  if (start + count) > bytesize\n    count = bytesize - start\n  end\n  if count == 0\n    return \"\"\n  end\n  if count == bytesize\n    return self\n  end\n  String.new(count) do |buffer|\n    buffer.copy_from(to_unsafe + start, count)\n    slice_size = single_byte_optimizable ? count : 0\n    {count, slice_size}\n  end\nelse\n  if start == bytesize\n    if count >= 0\n      return \"\"\n    else\n      raise(ArgumentError.new(\"Negative count\"))\n    end\n  else\n    raise(IndexError.new)\n  end\nend\n"}},{"id":"byte_slice(start:Int)-instance-method","html_id":"byte_slice(start:Int)-instance-method","name":"byte_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"}],"args_string":"(start : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L874","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L874","def":{"name":"byte_slice","args":[{"name":"start","doc":null,"default_value":"","external_name":"start","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"byte_slice(start, bytesize - start)"}},{"id":"bytes-instance-method","html_id":"bytes-instance-method","name":"bytes","doc":"Returns this string's bytes as an `Array(UInt8)`.\n\n```\n\"hello\".bytes # => [104, 101, 108, 108, 111]\n\"你好\".bytes    # => [228, 189, 160, 229, 165, 189]\n```","summary":"<p>Returns this string's bytes as an <code><a href=\"Array.html\">Array</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3828","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3828","def":{"name":"bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Array.new(bytesize) do |i|\n  to_unsafe[i]\nend"}},{"id":"bytesize:Int32-instance-method","html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Returns the number of bytes in this string.\n\n```\n\"hello\".bytesize # => 5\n\"你好\".bytesize    # => 6\n```","summary":"<p>Returns the number of bytes in this string.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L279","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L279","def":{"name":"bytesize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytesize"}},{"id":"camelcase-instance-method","html_id":"camelcase-instance-method","name":"camelcase","doc":"Converts underscores to camelcase boundaries.\n\n```\n\"eiffel_tower\".camelcase # => \"EiffelTower\"\n```","summary":"<p>Converts underscores to camelcase boundaries.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3454","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3454","def":{"name":"camelcase","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nfirst = true\nlast_is_underscore = false\nString.build(bytesize) do |str|\n  each_char do |char|\n    if first\n      str << char.upcase\n    else\n      if char == '_'\n        last_is_underscore = true\n      else\n        if last_is_underscore\n          str << char.upcase\n          last_is_underscore = false\n        else\n          str << char\n        end\n      end\n    end\n    first = false\n  end\nend\n"}},{"id":"capitalize(options=Unicode::CaseOptions::None)-instance-method","html_id":"capitalize(options=Unicode::CaseOptions::None)-instance-method","name":"capitalize","doc":"Returns a new `String` with the first letter converted to uppercase and every\nsubsequent letter converted to lowercase.\n\n```\n\"hEllO\".capitalize # => \"Hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first letter converted to uppercase and every subsequent letter converted to lowercase.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L967","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L967","def":{"name":"capitalize","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nif ascii_only? && (options.none? || options.ascii?)\n  String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      if i == 0\n        buffer[i] = to_unsafe[i].unsafe_chr.upcase.ord.to_u8\n      else\n        buffer[i] = to_unsafe[i].unsafe_chr.downcase.ord.to_u8\n      end\n    end\n    {@bytesize, @length}\n  end\nelse\n  String.build(bytesize) do |io|\n    each_char_with_index do |char, i|\n      if i == 0\n        char.upcase(options) do |c|\n          io << c\n        end\n      else\n        char.downcase(options) do |c|\n          io << c\n        end\n      end\n    end\n  end\nend\n"}},{"id":"char_at(index)-instance-method","html_id":"char_at(index)-instance-method","name":"char_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L882","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L882","def":{"name":"char_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[index]"}},{"id":"char_index_to_byte_index(index)-instance-method","html_id":"char_index_to_byte_index(index)-instance-method","name":"char_index_to_byte_index","doc":"Returns the byte index of a char index, or `nil` if out of bounds.\n\nIt is valid to pass `#size` to *index*, and in this case the answer\nwill be the bytesize of this string.\n\n```\n\"hello\".char_index_to_byte_index(1) # => 1\n\"hello\".char_index_to_byte_index(5) # => 5\n\"こんにちは\".char_index_to_byte_index(1) # => 3\n\"こんにちは\".char_index_to_byte_index(5) # => 15\n```","summary":"<p>Returns the byte index of a char index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2916","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2916","def":{"name":"char_index_to_byte_index","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if ascii_only?\n  return 0 <= index && index <= bytesize ? index : nil\nend\nsize = each_byte_index_and_char_index do |byte_index, char_index|\n  if index == char_index\n    return byte_index\n  end\nend\nif index == size\n  return @bytesize\nend\nnil\n"}},{"id":"chars-instance-method","html_id":"chars-instance-method","name":"chars","doc":"Returns an `Array` of all characters in the string.\n\n```\n\"ab☃\".chars # => ['a', 'b', '☃']\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all characters in the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3738","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3738","def":{"name":"chars","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"chars = Array(Char).new(@length > 0 ? @length : bytesize)\neach_char do |char|\n  chars << char\nend\nchars\n"}},{"id":"check_no_null_byte-instance-method","html_id":"check_no_null_byte-instance-method","name":"check_no_null_byte","doc":"Raises an `ArgumentError` if `self` has null bytes. Returns `self` otherwise.\n\nThis method should sometimes be called before passing a `String` to a C function.","summary":"<p>Raises an <code><a href=\"ArgumentError.html\">ArgumentError</a></code> if <code>self</code> has null bytes.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4247","def":{"name":"check_no_null_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if byte_index(0)\n  raise(ArgumentError.new(\"String contains null byte\"))\nend\nself\n"}},{"id":"chomp(suffix:String)-instance-method","html_id":"chomp(suffix:String)-instance-method","name":"chomp","doc":"Returns a new `String` with *suffix* removed from the end of the string.\nIf *suffix* is `\"\\n\"` then `\"\\r\\n\"` is also removed if the string ends with it,\n\n```\n\"hello\".chomp(\"llo\") # => \"he\"\n\"hello\".chomp(\"ol\")  # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"String"}],"args_string":"(suffix : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1045","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1045","def":{"name":"chomp","args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if suffix.bytesize == 1\n  chomp(suffix.to_unsafe[0].unsafe_chr)\nelse\n  if ends_with?(suffix)\n    unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\n  else\n    self\n  end\nend"}},{"id":"chomp(suffix:Char)-instance-method","html_id":"chomp(suffix:Char)-instance-method","name":"chomp","doc":"Returns a new `String` with *suffix* removed from the end of the string.\nIf *suffix* is `'\\n'` then `\"\\r\\n\"` is also removed if the string ends with it,\n\n```\n\"hello\".chomp('o') # => \"hell\"\n\"hello\".chomp('a') # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"Char"}],"args_string":"(suffix : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1028","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1028","def":{"name":"chomp","args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if suffix == '\\n'\n  chomp\nelse\n  if ends_with?(suffix)\n    unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\n  else\n    self\n  end\nend"}},{"id":"chomp-instance-method","html_id":"chomp-instance-method","name":"chomp","doc":"Returns a new `String` with the last carriage return removed (that is, it\nwill remove \\n, \\r, and \\r\\n).\n\n```\n\"string\\r\\n\".chomp # => \"string\"\n\"string\\n\\r\".chomp # => \"string\\n\"\n\"string\\n\".chomp   # => \"string\"\n\"string\".chomp     # => \"string\"\n\"x\".chomp.chomp    # => \"x\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the last carriage return removed (that is, it will remove \\n, \\r, and \\r\\n).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1004","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1004","def":{"name":"chomp","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\ncase to_unsafe[bytesize - 1]\nwhen '\\n'\n  if bytesize > 1 && (to_unsafe[bytesize - 2] === '\\r')\n    unsafe_byte_slice_string(0, bytesize - 2)\n  else\n    unsafe_byte_slice_string(0, bytesize - 1)\n  end\nwhen '\\r'\n  unsafe_byte_slice_string(0, bytesize - 1)\nelse\n  self\nend\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4188","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"codepoint_at(index)-instance-method","html_id":"codepoint_at(index)-instance-method","name":"codepoint_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L878","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L878","def":{"name":"codepoint_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(char_at(index)).ord"}},{"id":"codepoints-instance-method","html_id":"codepoints-instance-method","name":"codepoints","doc":"Returns an `Array` of the codepoints that make the string.\n\n```\n\"ab☃\".codepoints # => [97, 98, 9731]\n```\n\nSee also: `Char#ord`.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of the codepoints that make the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3784","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3784","def":{"name":"codepoints","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"codepoints = Array(Int32).new(@length > 0 ? @length : bytesize)\neach_codepoint do |codepoint|\n  codepoints << codepoint\nend\ncodepoints\n"}},{"id":"compare(other:String,case_insensitive=false)-instance-method","html_id":"compare(other:String,case_insensitive=false)-instance-method","name":"compare","doc":"Compares this string with *other*, returning `-1`, `0` or `+1` depending on whether\nthis string is less, equal or greater than *other*, optionally in a *case_insensitive*\nmanner.\n\nIf *case_insitive* is `false`, this method delegates to `<=>`. Otherwise,\nthe strings are compared char-by-char, and ASCII characters are compared in a\ncase-insensitive way.\n\n```\n\"abcdef\".compare(\"abcde\")   # => 1\n\"abcdef\".compare(\"abcdef\")  # => 0\n\"abcdef\".compare(\"abcdefg\") # => -1\n\"abcdef\".compare(\"ABCDEF\")  # => 1\n\n\"abcdef\".compare(\"ABCDEF\", case_insensitive: true) # => 0\n\"abcdef\".compare(\"ABCDEG\", case_insensitive: true) # => -1\n```","summary":"<p>Compares this string with <em>other</em>, returning <code>-1</code>, <code>0</code> or <code>+1</code> depending on whether this string is less, equal or greater than <em>other</em>, optionally in a <em>case_insensitive</em> manner.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"},{"name":"case_insensitive","doc":null,"default_value":"false","external_name":"case_insensitive","restriction":""}],"args_string":"(other : String, case_insensitive = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2405","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2405","def":{"name":"compare","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"},{"name":"case_insensitive","doc":null,"default_value":"false","external_name":"case_insensitive","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if case_insensitive\nelse\n  return self <=> other\nend\nreader1 = Char::Reader.new(self)\nreader2 = Char::Reader.new(other)\nch1 = reader1.current_char\nch2 = reader2.current_char\nwhile reader1.has_next? && reader2.has_next?\n  cmp = ch1.downcase <=> ch2.downcase\n  if cmp != 0\n    return cmp.sign\n  end\n  ch1 = reader1.next_char\n  ch2 = reader2.next_char\nend\nif reader1.has_next?\n  1\nelse\n  if reader2.has_next?\n    -1\n  else\n    0\n  end\nend\n"}},{"id":"count(&block)-instance-method","html_id":"count(&amp;block)-instance-method","name":"count","doc":"Yields each char in this string to the block,\nreturns the number of times the block returned a truthy value.\n\n```\n\"aabbcc\".count { |c| ['a', 'b'].includes?(c) } # => 4\n```","summary":"<p>Yields each char in this string to the block, returns the number of times the block returned a truthy value.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2227","def":{"name":"count","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"count = 0\neach_char do |char|\n  if yield char\n    count = count + 1\n  end\nend\ncount\n"}},{"id":"count(*sets)-instance-method","html_id":"count(*sets)-instance-method","name":"count","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns the number of characters\nin this string that match the given set.","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":""}],"args_string":"(*sets)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2247","def":{"name":"count","args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count do |char|\n  char.in_set?(*sets)\nend"}},{"id":"count(other:Char)-instance-method","html_id":"count(other:Char)-instance-method","name":"count","doc":"Counts the occurrences of *other* char in this string.\n\n```\n\"aabbcc\".count('a') # => 2\n```","summary":"<p>Counts the occurrences of <em>other</em> char in this string.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(other : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2240","def":{"name":"count","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"count do |char|\n  char == other\nend"}},{"id":"delete(&block)-instance-method","html_id":"delete(&amp;block)-instance-method","name":"delete","doc":"Yields each char in this string to the block.\nReturns a new `String` with all characters for which the\nblock returned a truthy value removed.\n\n```\n\"aabbcc\".delete { |c| ['a', 'b'].includes?(c) } # => \"cc\"\n```","summary":"<p>Yields each char in this string to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2258","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2258","def":{"name":"delete","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build(bytesize) do |buffer|\n  each_char do |char|\n    if yield char\n    else\n      buffer << char\n    end\n  end\nend"}},{"id":"delete(char:Char)-instance-method","html_id":"delete(char:Char)-instance-method","name":"delete","doc":"Returns a new `String` with all occurrences of *char* removed.\n\n```\n\"aabbcc\".delete('b') # => \"aacc\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with all occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2271","def":{"name":"delete","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"delete do |my_char|\n  my_char == char\nend"}},{"id":"delete(*sets)-instance-method","html_id":"delete(*sets)-instance-method","name":"delete","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns a new `String` with\nall characters that match the given set removed.\n\n```\n\"aabbccdd\".delete(\"a-c\") # => \"dd\"\n```","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":""}],"args_string":"(*sets)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2282","def":{"name":"delete","args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":""}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"delete do |char|\n  char.in_set?(*sets)\nend"}},{"id":"downcase(options=Unicode::CaseOptions::None)-instance-method","html_id":"downcase(options=Unicode::CaseOptions::None)-instance-method","name":"downcase","doc":"Returns a new `String` with each uppercase letter replaced with its lowercase\ncounterpart.\n\n```\n\"hEllO\".downcase # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with each uppercase letter replaced with its lowercase counterpart.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L913","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L913","def":{"name":"downcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nif ascii_only? && (options.none? || options.ascii?)\n  String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = to_unsafe[i].unsafe_chr.downcase.ord.to_u8\n    end\n    {@bytesize, @length}\n  end\nelse\n  String.build(bytesize) do |io|\n    each_char do |char|\n      char.downcase(options) do |res|\n        io << res\n      end\n    end\n  end\nend\n"}},{"id":"dump(io:IO):Nil-instance-method","html_id":"dump(io:IO):Nil-instance-method","name":"dump","doc":"Appends `self` to the given `IO` object using character escapes for special characters\nand and non-ascii characters (unicode codepoints > 128), wrapped in quotes.","summary":"<p>Appends <code>self</code> to the given <code><a href=\"IO.html\">IO</a></code> object using character escapes for special characters and and non-ascii characters (unicode codepoints > 128), wrapped in quotes.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3901","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3901","def":{"name":"dump","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"dump_or_inspect(io) do |char, error|\n  dump_char(char, error, io)\nend"}},{"id":"dump:String-instance-method","html_id":"dump:String-instance-method","name":"dump","doc":"Returns a representation of `self` using character escapes for special characters\nand and non-ascii characters (unicode codepoints > 128), wrapped in quotes.\n\n```\n\"\\u{1f48e} - à la carte\\n\".dump # => %(\"\\\\u{1F48E} - \\\\u00E0 la carte\\\\n\")\n```","summary":"<p>Returns a representation of <code>self</code> using character escapes for special characters and and non-ascii characters (unicode codepoints > 128), wrapped in quotes.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3893","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3893","def":{"name":"dump","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  dump(io)\nend"}},{"id":"dump_unquoted:String-instance-method","html_id":"dump_unquoted:String-instance-method","name":"dump_unquoted","doc":"Returns a representation of `self` using character escapes for special characters\nand and non-ascii characters (unicode codepoints > 128), but not wrapped in quotes.\n\n```\n\"\\u{1f48e} - à la carte\\n\".dump_unquoted # => %(\\\\u{1F48E} - \\\\u00E0 la carte\\\\n)\n```","summary":"<p>Returns a representation of <code>self</code> using character escapes for special characters and and non-ascii characters (unicode codepoints > 128), but not wrapped in quotes.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3913","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3913","def":{"name":"dump_unquoted","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  dump_unquoted(io)\nend"}},{"id":"dump_unquoted(io:IO):Nil-instance-method","html_id":"dump_unquoted(io:IO):Nil-instance-method","name":"dump_unquoted","doc":"Appends `self` to the given `IO` object using character escapes for special characters\nand and non-ascii characters (unicode codepoints > 128), but not wrapped in quotes.","summary":"<p>Appends <code>self</code> to the given <code><a href=\"IO.html\">IO</a></code> object using character escapes for special characters and and non-ascii characters (unicode codepoints > 128), but not wrapped in quotes.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3921","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3921","def":{"name":"dump_unquoted","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"dump_or_inspect_unquoted(io) do |char, error|\n  dump_char(char, error, io)\nend"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4192","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"each_byte-instance-method","html_id":"each_byte-instance-method","name":"each_byte","doc":"Returns an `Iterator` over each byte in the string.\n\n```\nbytes = \"ab☃\".each_byte\nbytes.next # => 97\nbytes.next # => 98\nbytes.next # => 226\nbytes.next # => 152\nbytes.next # => 131\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each byte in the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3818","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3818","def":{"name":"each_byte","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.each"}},{"id":"each_byte(&block)-instance-method","html_id":"each_byte(&amp;block)-instance-method","name":"each_byte","doc":"Yields each byte in the string to the block.\n\n```\narray = [] of UInt8\n\"ab☃\".each_byte do |byte|\n  array << byte\nend\narray # => [97, 98, 226, 152, 131]\n```","summary":"<p>Yields each byte in the string to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3801","def":{"name":"each_byte","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.each do |byte|\n  yield byte\nend\nnil\n"}},{"id":"each_char(&block):Nil-instance-method","html_id":"each_char(&amp;block):Nil-instance-method","name":"each_char","doc":"Yields each character in the string to the block.\n\n```\narray = [] of Char\n\"ab☃\".each_char do |char|\n  array << char\nend\narray # => ['a', 'b', '☃']\n```","summary":"<p>Yields each character in the string to the block.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3692","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3692","def":{"name":"each_char","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if ascii_only?\n  each_byte do |byte|\n    yield (    byte < 128 ? byte.unsafe_chr : Char::REPLACEMENT)\n  end\nelse\n  (Char::Reader.new(self)).each do |char|\n    yield char\n  end\nend"}},{"id":"each_char-instance-method","html_id":"each_char-instance-method","name":"each_char","doc":"Returns an `Iterator` over each character in the string.\n\n```\nchars = \"ab☃\".each_char\nchars.next # => 'a'\nchars.next # => 'b'\nchars.next # => '☃'\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each character in the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3712","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3712","def":{"name":"each_char","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"CharIterator.new(Char::Reader.new(self))"}},{"id":"each_char_with_index(&block)-instance-method","html_id":"each_char_with_index(&amp;block)-instance-method","name":"each_char_with_index","doc":"Yields each character and its index in the string to the block.\n\n```\narray = [] of Tuple(Char, Int32)\n\"ab☃\".each_char_with_index do |char, index|\n  array << {char, index}\nend\narray # => [{'a', 0}, {'b', 1}, {'☃', 2}]\n```","summary":"<p>Yields each character and its index in the string to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3725","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3725","def":{"name":"each_char_with_index","args":[],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"i = 0\neach_char do |char|\n  yield char, i\n  i = i + 1\nend\n"}},{"id":"each_codepoint-instance-method","html_id":"each_codepoint-instance-method","name":"each_codepoint","doc":"Returns an `Iterator` for each codepoint.\n\n```\ncodepoints = \"ab☃\".each_codepoint\ncodepoints.next # => 97\ncodepoints.next # => 98\ncodepoints.next # => 9731\n```\n\nSee also: `Char#ord`.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for each codepoint.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3773","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3773","def":{"name":"each_codepoint","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_char.map(&.ord)"}},{"id":"each_codepoint(&block)-instance-method","html_id":"each_codepoint(&amp;block)-instance-method","name":"each_codepoint","doc":"Yields each codepoint to the block.\n\n```\narray = [] of Int32\n\"ab☃\".each_codepoint do |codepoint|\n  array << codepoint\nend\narray # => [97, 98, 9731]\n```\n\nSee also: `Char#ord`.","summary":"<p>Yields each codepoint to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3757","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3757","def":{"name":"each_codepoint","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"each_char do |char|\n  yield char.ord\nend"}},{"id":"each_line(chomp=true)-instance-method","html_id":"each_line(chomp=true)-instance-method","name":"each_line","doc":"Returns an `Iterator` which yields each line of this string (see `String#each_line`).","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> which yields each line of this string (see <code><a href=\"String.html#each_line%28chomp%3Dtrue%29-instance-method\">String#each_line</a></code>).</p>","abstract":false,"args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3373","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3373","def":{"name":"each_line","args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LineIterator.new(self, chomp)"}},{"id":"each_line(chomp=true,&block):Nil-instance-method","html_id":"each_line(chomp=true,&amp;block):Nil-instance-method","name":"each_line","doc":"Splits the string after each newline and yields each line to a block.\n\n```\nhaiku = \"the first cold shower\neven the monkey seems to want\na little coat of straw\"\nhaiku.each_line do |stanza|\n  puts stanza.upcase\nend\n# => THE FIRST COLD SHOWER\n# => EVEN THE MONKEY SEEMS TO WANT\n# => A LITTLE COAT OF STRAW\n```","summary":"<p>Splits the string after each newline and yields each line to a block.</p>","abstract":false,"args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = <span class=\"n\">true</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3349","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3349","def":{"name":"each_line","args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if empty?\n  return\nend\noffset = 0\nwhile byte_index = byte_index('\\n'.ord.to_u8, offset)\n  count = (byte_index - offset) + 1\n  if chomp\n    count = count - 1\n    if (offset + count) > 0 && (to_unsafe[(offset + count) - 1] === '\\r')\n      count = count - 1\n    end\n  end\n  yield unsafe_byte_slice_string(offset, count)\n  offset = byte_index + 1\nend\nif offset == bytesize\nelse\n  yield unsafe_byte_slice_string(offset)\nend\n"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if this is the empty string, `\"\"`.","summary":"<p>Returns <code>true</code> if this is the empty string, <code>\"\"</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2340","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2340","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytesize == 0"}},{"id":"encode(encoding:String,invalid:Symbol?=nil):Bytes-instance-method","html_id":"encode(encoding:String,invalid:Symbol?=nil):Bytes-instance-method","name":"encode","doc":"Returns a slice of bytes containing this string encoded in the given encoding.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\n```\n\"好\".encode(\"GB2312\") # => Bytes[186, 195]\n\"好\".bytes            # => [229, 165, 189]\n```","summary":"<p>Returns a slice of bytes containing this string encoded in the given encoding.</p>","abstract":false,"args":[{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(encoding : String, invalid : Symbol? = <span class=\"n\">nil</span>) : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1159","def":{"name":"encode","args":[{"name":"encoding","doc":null,"default_value":"","external_name":"encoding","restriction":"String"},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"io = IO::Memory.new\nString.encode(to_slice, \"UTF-8\", encoding, io, invalid)\nio.to_slice\n"}},{"id":"ends_with?(char:Char)-instance-method","html_id":"ends_with?(char:Char)-instance-method","name":"ends_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4033","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4033","def":{"name":"ends_with?","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize > 0\nelse\n  return false\nend\nif char.ascii? || ascii_only?\n  return to_unsafe[bytesize - 1] == char.ord\nend\nbytes, count = String.char_bytes_and_bytesize(char)\nif bytesize < count\n  return false\nend\ncount.times do |i|\n  if to_unsafe[(bytesize - count) + i] == bytes[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"ends_with?(str:String)-instance-method","html_id":"ends_with?(str:String)-instance-method","name":"ends_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4028","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4028","def":{"name":"ends_with?","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if str.bytesize > bytesize\n  return false\nend\n(((to_unsafe + bytesize) - str.bytesize).memcmp(str.to_unsafe, str.bytesize)) == 0\n"}},{"id":"ends_with?(re:Regex)-instance-method","html_id":"ends_with?(re:Regex)-instance-method","name":"ends_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"re","doc":null,"default_value":"","external_name":"re","restriction":"Regex"}],"args_string":"(re : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4050","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4050","def":{"name":"ends_with?","args":[{"name":"re","doc":null,"default_value":"","external_name":"re","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(!($~ = (/#{re}\\z/).match(self)))"}},{"id":"gsub(string:String,&block)-instance-method","html_id":"gsub(string:String,&amp;block)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *string* are replaced\nwith the block's value.\n\n```\n\"hello yellow\".gsub(\"ll\") { \"dd\" } # => \"heddo yeddow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>string</em> are replaced with the block's value.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2135","def":{"name":"gsub","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"byte_offset = 0\nindex = self.byte_index(string, byte_offset)\nif index\nelse\n  return self\nend\nlast_byte_offset = 0\nString.build(bytesize) do |buffer|\n  while index\n    buffer.write(unsafe_byte_slice(last_byte_offset, index - last_byte_offset))\n    buffer << (yield string)\n    if string.bytesize == 0\n      byte_offset = index + 1\n      last_byte_offset = index\n    else\n      byte_offset = index + string.bytesize\n      last_byte_offset = byte_offset\n    end\n    index = self.byte_index(string, byte_offset)\n  end\n  if last_byte_offset < bytesize\n    buffer.write(unsafe_byte_slice(last_byte_offset))\n  end\nend\n"}},{"id":"gsub(&block:Char->_)-instance-method","html_id":"gsub(&amp;block:Char-&gt;_)-instance-method","name":"gsub","doc":"Returns a `String` where each character yielded to the given block\nis replaced by the block's return value.\n\n```\n\"hello\".gsub { |char| char + 1 } # => \"ifmmp\"\n\"hello\".gsub { \"hi\" }            # => \"hihihihihi\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where each character yielded to the given block is replaced by the block's return value.</p>","abstract":false,"args":[],"args_string":"(&block : Char -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1996","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1996","def":{"name":"gsub","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Char -> _)"},"return_type":"","visibility":"Public","body":"String.build(bytesize) do |buffer|\n  each_char do |my_char|\n    buffer << (yield my_char)\n  end\nend"}},{"id":"gsub(char:Char,replacement)-instance-method","html_id":"gsub(char:Char,replacement)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given char are\nreplaced with the given *replacement*.\n\n```\n\"hello\".gsub('l', \"lo\")      # => \"heloloo\"\n\"hello world\".gsub('o', 'a') # => \"hella warld\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given char are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"args_string":"(char : Char, replacement)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2011","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2011","def":{"name":"gsub","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if replacement.is_a?(String) && (replacement.bytesize == 1)\n  return gsub(char, (replacement.unsafe_byte_at(0)).unsafe_chr)\nend\nif includes?(char)\n  if (replacement.is_a?(Char) && char.ascii?) && replacement.ascii?\n    return gsub_ascii_char(char, replacement)\n  end\n  gsub do |my_char|\n    char == my_char ? replacement : my_char\n  end\nelse\n  self\nend\n"}},{"id":"gsub(pattern:Regex,hash:Hash(String,_)|NamedTuple)-instance-method","html_id":"gsub(pattern:Regex,hash:Hash(String,_)|NamedTuple)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nwith a *hash* of replacements. If the *hash* contains the matched pattern,\nthe corresponding value is used as a replacement. Otherwise the match is\nnot included in the returned string.\n\n```\n# \"he\" and \"l\" are matched and replaced,\n# but \"o\" is not and so is not included\n\"hello\".gsub(/(he|l|o)/, {\"he\": \"ha\", \"l\": \"la\"}) # => \"halala\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced with a <em>hash</em> of replacements.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"args_string":"(pattern : Regex, hash : Hash(String, _) | NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2109","def":{"name":"gsub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"gsub(pattern) do |match|\n  hash[match]?\nend"}},{"id":"gsub(pattern:Regex,replacement,backreferences=true)-instance-method","html_id":"gsub(pattern:Regex,replacement,backreferences=true)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nwith the given *replacement*.\n\n```\n\"hello\".gsub(/[aeiou]/, '*') # => \"h*ll*\"\n```\n\nWithin *replacement*, the special match variable `$~` will not refer to the\ncurrent match.\n\nIf *backreferences* is `true` (the default value), *replacement* can include backreferences:\n\n```\n\"hello\".gsub(/[aeiou]/, \"(\\\\0)\") # => \"h(e)ll(o)\"\n```\n\nWhen substitution is performed, any backreferences found in *replacement*\nwill be replaced with the contents of the corresponding capture group in\n*pattern*. Backreferences to capture groups that were not present in\n*pattern* or that did not match will be skipped. See `Regex` for information\nabout capture groups.\n\nBackreferences are expressed in the form `\"\\\\d\"`, where *d* is a group\nnumber, or `\"\\\\k<name>\"` where *name* is the name of a named capture group.\nA sequence of literal characters resembling a backreference can be\nexpressed by placing `\"\\\\\"` before the sequence.\n\n```\n\"foo\".gsub(/o/, \"x\\\\0x\")                  # => \"fxoxxox\"\n\"foofoo\".gsub(/(?<bar>oo)/, \"|\\\\k<bar>|\") # => \"f|oo|f|oo|\"\n\"foo\".gsub(/o/, \"\\\\\\\\0\")                  # => \"f\\\\0\\\\0\"\n```\n\nRaises `ArgumentError` if an incomplete named back-reference is present in\n*replacement*.\n\nRaises `IndexError` if a named group referenced in *replacement* is not present\nin *pattern*.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""},{"name":"backreferences","doc":null,"default_value":"true","external_name":"backreferences","restriction":""}],"args_string":"(pattern : Regex, replacement, backreferences = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2091","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2091","def":{"name":"gsub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""},{"name":"backreferences","doc":null,"default_value":"true","external_name":"backreferences","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (backreferences && replacement.is_a?(String)) && replacement.has_back_references?\n  gsub_append(pattern) do |_, match, buffer|\n    scan_backreferences(replacement, match, buffer)\n  end\nelse\n  gsub(pattern) do\n    replacement\n  end\nend"}},{"id":"gsub(string:String,replacement)-instance-method","html_id":"gsub(string:String,replacement)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *string* are replaced\nwith the given *replacement*.\n\n```\n\"hello yellow\".gsub(\"ll\", \"dd\") # => \"heddo yeddow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>string</em> are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"args_string":"(string : String, replacement)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2121","def":{"name":"gsub","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if string.bytesize == 1\n  gsub((string.unsafe_byte_at(0)).unsafe_chr, replacement)\nelse\n  gsub(string) do\n    replacement\n  end\nend"}},{"id":"gsub(hash:Hash(Char,_))-instance-method","html_id":"gsub(hash:Hash(Char,_))-instance-method","name":"gsub","doc":"Returns a `String` where all chars in the given hash are replaced\nby the corresponding *hash* values.\n\n```\n\"hello\".gsub({'e' => 'a', 'l' => 'd'}) # => \"haddo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all chars in the given hash are replaced by the corresponding <em>hash</em> values.</p>","abstract":false,"args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(Char, _)"}],"args_string":"(hash : Hash(Char, _))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2170","def":{"name":"gsub","args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(Char, _)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"gsub do |char|\n  hash[char]? || char\nend"}},{"id":"gsub(tuple:NamedTuple)-instance-method","html_id":"gsub(tuple:NamedTuple)-instance-method","name":"gsub","doc":"Returns a `String` where all chars in the given named tuple are replaced\nby the corresponding *tuple* values.\n\n```\n\"hello\".gsub({e: 'a', l: 'd'}) # => \"haddo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all chars in the given named tuple are replaced by the corresponding <em>tuple</em> values.</p>","abstract":false,"args":[{"name":"tuple","doc":null,"default_value":"","external_name":"tuple","restriction":"NamedTuple"}],"args_string":"(tuple : NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2182","def":{"name":"gsub","args":[{"name":"tuple","doc":null,"default_value":"","external_name":"tuple","restriction":"NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"gsub do |char|\n  tuple[char.to_s]? || char\nend"}},{"id":"gsub(pattern:Regex,&block)-instance-method","html_id":"gsub(pattern:Regex,&amp;block)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nby the block value's value.\n\n```\n\"hello\".gsub(/./) { |s| s[0].ord.to_s + ' ' } # => \"104 101 108 108 111 \"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced by the block value's value.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2046","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2046","def":{"name":"gsub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"gsub_append(pattern) do |string, match, buffer|\n  $~ = match\n  buffer << (yield string, match)\nend"}},{"id":"has_back_references?-instance-method","html_id":"has_back_references?-instance-method","name":"has_back_references?","doc":"This returns `true` if this string has `'\\\\'` in it. It might not be a back reference,\nbut `'\\\\'` is probably used for back references, so this check is faster than parsing\nthe whole thing.","summary":"<p>This returns <code>true</code> if this string has <code>'\\\\'</code> in it.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1936","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1936","def":{"name":"has_back_references?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.index('\\\\'.ord.to_u8)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4067","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4067","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.string(self)"}},{"id":"hexbytes:Bytes-instance-method","html_id":"hexbytes:Bytes-instance-method","name":"hexbytes","doc":"Interprets this string as containing a sequence of hexadecimal values\nand decodes it as a slice of bytes. Two consecutive bytes in the string\nrepresent a byte in the returned slice.\n\nRaises `ArgumentError` if this string does not denote an hexstring.\n\n```\n\"0102031aff\".hexbytes  # => Bytes[1, 2, 3, 26, 255]\n\"1\".hexbytes           # raises ArgumentError\n\"hello world\".hexbytes # raises ArgumentError\n```","summary":"<p>Interprets this string as containing a sequence of hexadecimal values and decodes it as a slice of bytes.</p>","abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1197","def":{"name":"hexbytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"hexbytes? || (raise(ArgumentError.new(\"#{self} is not a hexstring\")))"}},{"id":"hexbytes?:Bytes?-instance-method","html_id":"hexbytes?:Bytes?-instance-method","name":"hexbytes?","doc":"Interprets this string as containing a sequence of hexadecimal values\nand decodes it as a slice of bytes. Two consecutive bytes in the string\nrepresent a byte in the returned slice.\n\nReturns `nil` if this string does not denote an hexstring.\n\n```\n\"0102031aff\".hexbytes?  # => Bytes[1, 2, 3, 26, 255]\n\"1\".hexbytes?           # => nil\n\"hello world\".hexbytes? # => nil\n```","summary":"<p>Interprets this string as containing a sequence of hexadecimal values and decodes it as a slice of bytes.</p>","abstract":false,"args":[],"args_string":" : Bytes?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1212","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1212","def":{"name":"hexbytes?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes | ::Nil","visibility":"Public","body":"if bytesize.divisible_by?(2)\nelse\n  return\nend\nbytes = Bytes.new(bytesize / 2)\ni = 0\nwhile i < bytesize\n  high_nibble = to_unsafe[i].unsafe_chr.to_u8?(16)\n  low_nibble = to_unsafe[i + 1].unsafe_chr.to_u8?(16)\n  if high_nibble && low_nibble\n  else\n    return\n  end\n  bytes[i / 2] = (high_nibble << 4) | low_nibble\n  i = i + 2\nend\nbytes\n"}},{"id":"includes?(search:Char|String)-instance-method","html_id":"includes?(search:Char|String)-instance-method","name":"includes?","doc":"Returns `true` if the string contains *search*.\n\n```\n\"Team\".includes?('i')            # => false\n\"Dysfunctional\".includes?(\"fun\") # => true\n```","summary":"<p>Returns <code>true</code> if the string contains <em>search</em>.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2950","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2950","def":{"name":"includes?","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(!(index(search)))"}},{"id":"index(search:Regex,offset=0)-instance-method","html_id":"index(search:Regex,offset=0)-instance-method","name":"index","doc":"Returns the index of *search* in the string, or `nil` if the string is not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of <em>search</em> in the string, or <code>nil</code> if the string is not present.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : Regex, offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2641","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2641","def":{"name":"index","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif 0 <= offset && offset <= size\nelse\n  return nil\nend\n(self.match(search, offset)).try(&.begin)\n"}},{"id":"index(search:String,offset=0)-instance-method","html_id":"index(search:String,offset=0)-instance-method","name":"index","doc":"Returns the index of *search* in the string, or `nil` if the string is not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of <em>search</em> in the string, or <code>nil</code> if the string is not present.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2570","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2570","def":{"name":"index","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return\nend\nif search.empty?\n  return size < offset ? nil : offset\nend\nsearch_hash = 0_u32\nsearch.each_byte do |b|\n  search_hash = (search_hash * PRIME_RK) + b\nend\npow = PRIME_RK ** search.bytesize\nchar_index = 0\npointer = to_unsafe\nend_pointer = pointer + bytesize\nwhile char_index < offset && pointer < end_pointer\n  byte = pointer.value\n  if byte < 128\n    pointer = pointer + 1\n  else\n    if byte < 224\n      pointer = pointer + 2\n    else\n      if byte < 240\n        pointer = pointer + 3\n      else\n        pointer = pointer + 4\n      end\n    end\n  end\n  char_index = char_index + 1\nend\nhead_pointer = pointer\nhash = 0_u32\nhash_end_pointer = pointer + search.bytesize\nif hash_end_pointer > end_pointer\n  return\nend\nwhile pointer < hash_end_pointer\n  hash = (hash * PRIME_RK) + pointer.value\n  pointer = pointer + 1\nend\nwhile true\n  if (hash == search_hash) && ((head_pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return char_index\n  end\n  if pointer >= end_pointer\n    return\n  end\n  byte = head_pointer.value\n  if byte < 128\n    update_hash(1)\n  else\n    if byte < 224\n      update_hash(2)\n    else\n      if byte < 240\n        update_hash(3)\n      else\n        update_hash(4)\n      end\n    end\n  end\n  char_index = char_index + 1\nend\n"}},{"id":"index(search:Char,offset=0)-instance-method","html_id":"index(search:Char,offset=0)-instance-method","name":"index","doc":"Returns the index of *search* in the string, or `nil` if the string is not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of <em>search</em> in the string, or <code>nil</code> if the string is not present.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : Char, offset = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2551","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2551","def":{"name":"index","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char"},{"name":"offset","doc":null,"default_value":"0","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if search.ascii? && ascii_only?\n  return to_slice.index(search.ord.to_u8, offset)\nend\nif offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\neach_char_with_index do |char, i|\n  if i >= offset && (char == search)\n    return i\n  end\nend\nnil\n"}},{"id":"insert(index:Int,other:Char)-instance-method","html_id":"insert(index:Int,other:Char)-instance-method","name":"insert","doc":"Returns a new `String` that results of inserting *other* in `self` at *index*.\nNegative indices count from the end of the string, and insert **after**\nthe given index.\n\nRaises `IndexError` if the index is out of bounds.\n\n```\n\"abcd\".insert(0, 'X')  # => \"Xabcd\"\n\"abcd\".insert(3, 'X')  # => \"abcXd\"\n\"abcd\".insert(4, 'X')  # => \"abcdX\"\n\"abcd\".insert(-3, 'X') # => \"abXcd\"\n\"abcd\".insert(-1, 'X') # => \"abcdX\"\n\n\"abcd\".insert(5, 'X')  # raises IndexError\n\"abcd\".insert(-6, 'X') # raises IndexError\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> that results of inserting <em>other</em> in <code>self</code> at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"args_string":"(index : Int, other : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1246","def":{"name":"insert","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = index.to_i\nif index < 0\n  index = index + (size + 1)\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index\nelse\n  raise(IndexError.new)\nend\nbytes, count = String.char_bytes_and_bytesize(other)\nnew_bytesize = bytesize + count\nnew_size = (ascii_only? && other.ascii?) ? new_bytesize : 0\ninsert_impl(byte_index, bytes.to_unsafe, count, new_bytesize, new_size)\n"}},{"id":"insert(index:Int,other:String)-instance-method","html_id":"insert(index:Int,other:String)-instance-method","name":"insert","doc":"Returns a new `String` that results of inserting *other* in `self` at *index*.\nNegative indices count from the end of the string, and insert **after**\nthe given index.\n\nRaises `IndexError` if the index is out of bounds.\n\n```\n\"abcd\".insert(0, \"FOO\")  # => \"FOOabcd\"\n\"abcd\".insert(3, \"FOO\")  # => \"abcFOOd\"\n\"abcd\".insert(4, \"FOO\")  # => \"abcdFOO\"\n\"abcd\".insert(-3, \"FOO\") # => \"abFOOcd\"\n\"abcd\".insert(-1, \"FOO\") # => \"abcdFOO\"\n\n\"abcd\".insert(5, \"FOO\")  # raises IndexError\n\"abcd\".insert(-6, \"FOO\") # raises IndexError\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> that results of inserting <em>other</em> in <code>self</code> at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"args_string":"(index : Int, other : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1277","def":{"name":"insert","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"index = index.to_i\nif index < 0\n  index = index + (size + 1)\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index\nelse\n  raise(IndexError.new)\nend\nnew_bytesize = bytesize + other.bytesize\nnew_size = ascii_only? && other.ascii_only? ? new_bytesize : 0\ninsert_impl(byte_index, other.to_unsafe, other.bytesize, new_bytesize, new_size)\n"}},{"id":"inspect:String-instance-method","html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns a representation of `self` using character escapes for special characters and wrapped in quotes.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect # => %(\"\\u{1F48E} - à la carte\\\\n\")\n```","summary":"<p>Returns a representation of <code>self</code> using character escapes for special characters and wrapped in quotes.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3858","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3858","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"super()"}},{"id":"inspect(io:IO):Nil-instance-method","html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends `self` to the given `IO` object using character escapes for special characters and wrapped in double quotes.","summary":"<p>Appends <code>self</code> to the given <code><a href=\"IO.html\">IO</a></code> object using character escapes for special characters and wrapped in double quotes.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3863","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3863","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"dump_or_inspect(io) do |char, error|\n  inspect_char(char, error, io)\nend"}},{"id":"inspect_unquoted:String-instance-method","html_id":"inspect_unquoted:String-instance-method","name":"inspect_unquoted","doc":"Returns a representation of `self` using character escapes for special characters but not wrapped in quotes.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect_unquoted # => %(\\u{1F48E} - à la carte\\\\n)\n```","summary":"<p>Returns a representation of <code>self</code> using character escapes for special characters but not wrapped in quotes.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3874","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3874","def":{"name":"inspect_unquoted","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  inspect_unquoted(io)\nend"}},{"id":"inspect_unquoted(io:IO):Nil-instance-method","html_id":"inspect_unquoted(io:IO):Nil-instance-method","name":"inspect_unquoted","doc":"Appends `self` to the given `IO` object using character escapes for special characters but not wrapped in quotes.","summary":"<p>Appends <code>self</code> to the given <code><a href=\"IO.html\">IO</a></code> object using character escapes for special characters but not wrapped in quotes.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3881","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3881","def":{"name":"inspect_unquoted","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"dump_or_inspect_unquoted(io) do |char, error|\n  inspect_char(char, error, io)\nend"}},{"id":"lchop-instance-method","html_id":"lchop-instance-method","name":"lchop","doc":"Returns a new `String` with the first char removed from it.\nApplying lchop to an empty string returns an empty string.\n\n```\n\"hello\".lchop # => \"ello\"\n\"\".lchop      # => \"\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first char removed from it.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1062","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1062","def":{"name":"lchop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return \"\"\nend\nreader = Char::Reader.new(self)\nunsafe_byte_slice_string(reader.current_char_width, bytesize - reader.current_char_width)\n"}},{"id":"lchop(prefix:String)-instance-method","html_id":"lchop(prefix:String)-instance-method","name":"lchop","doc":"Returns a new `String` with *prefix* removed from the beginning of the string.\n\n```\n\"hello\".lchop(\"hel\") # => \"lo\"\n\"hello\".lchop(\"eh\")  # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>prefix</em> removed from the beginning of the string.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String"}],"args_string":"(prefix : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1089","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1089","def":{"name":"lchop","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if starts_with?(prefix)\n  unsafe_byte_slice_string(prefix.bytesize, bytesize - prefix.bytesize)\nelse\n  self\nend"}},{"id":"lchop(prefix:Char)-instance-method","html_id":"lchop(prefix:Char)-instance-method","name":"lchop","doc":"Returns a new `String` with *prefix* removed from the beginning of the string.\n\n```\n\"hello\".lchop('h') # => \"ello\"\n\"hello\".lchop('g') # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>prefix</em> removed from the beginning of the string.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"Char"}],"args_string":"(prefix : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1075","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1075","def":{"name":"lchop","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if starts_with?(prefix)\n  unsafe_byte_slice_string(prefix.bytesize, bytesize - prefix.bytesize)\nelse\n  self\nend"}},{"id":"lines(chomp=true)-instance-method","html_id":"lines(chomp=true)-instance-method","name":"lines","doc":null,"summary":null,"abstract":false,"args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3328","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3328","def":{"name":"lines","args":[{"name":"chomp","doc":null,"default_value":"true","external_name":"chomp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"lines = [] of String\neach_line(chomp: chomp) do |line|\n  lines << line\nend\nlines\n"}},{"id":"ljust(len,char:Char=&#39;&#39;)-instance-method","html_id":"ljust(len,char:Char=&amp;#39;&amp;#39;)-instance-method","name":"ljust","doc":"Adds instances of *char* to right of the string until it is at least size of *len*.\n\n```\n\"Purple\".ljust(8)      # => \"Purple  \"\n\"Purple\".ljust(8, '-') # => \"Purple--\"\n\"Aubergine\".ljust(8)   # => \"Aubergine\"\n```","summary":"<p>Adds instances of <em>char</em> to right of the string until it is at least size of <em>len</em>.</p>","abstract":false,"args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""},{"name":"char","doc":null,"default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(len, char : Char = <span class=\"s\">&#39; &#39;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3515","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3515","def":{"name":"ljust","args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""},{"name":"char","doc":null,"default_value":"' '","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"just(len, char, true)"}},{"id":"lstrip(chars:String)-instance-method","html_id":"lstrip(chars:String)-instance-method","name":"lstrip","doc":"Returns a new string where leading occurrences of any char\nin *chars* are removed. The *chars* argument is not a suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"bcadefcba\".lstrip(\"abc\") # => \"defcba\"\n```","summary":"<p>Returns a new string where leading occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"args_string":"(chars : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1460","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1460","def":{"name":"lstrip","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  self\nwhen 1\n  lstrip(chars[0])\nelse\n  remove_excess_left(calc_excess_left(chars))\nend\n"}},{"id":"lstrip(&block:Char->_)-instance-method","html_id":"lstrip(&amp;block:Char-&gt;_)-instance-method","name":"lstrip","doc":"Returns a new string where leading characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".lstrip { |c| 'a' <= c <= 'c' } # => \"defcba\"\n```","summary":"<p>Returns a new string where leading characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"args":[],"args_string":"(&block : Char -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1479","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1479","def":{"name":"lstrip","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Char -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left do |c|\n  yield c\nend\nremove_excess_left(excess_left)\n"}},{"id":"lstrip(char:Char)-instance-method","html_id":"lstrip(char:Char)-instance-method","name":"lstrip","doc":"Returns a new string with leading occurrences of *char* removed.\n\n```\n\"aaabcdaaa\".lstrip('a') # => \"bcdaaa\"\n```","summary":"<p>Returns a new string with leading occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1447","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1447","def":{"name":"lstrip","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nremove_excess_left(calc_excess_left(char))\n"}},{"id":"lstrip-instance-method","html_id":"lstrip-instance-method","name":"lstrip","doc":"Returns a new `String` with leading whitespace removed.\n\n```\n\"    hello    \".lstrip # => \"hello    \"\n\"\\tgoodbye\\r\\n\".lstrip # => \"goodbye\\r\\n\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with leading whitespace removed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1438","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1438","def":{"name":"lstrip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"remove_excess_left(calc_excess_left)"}},{"id":"match(regex:Regex,pos=0):Regex::MatchData?-instance-method","html_id":"match(regex:Regex,pos=0):Regex::MatchData?-instance-method","name":"match","doc":"Finds match of *regex*, starting at *pos*.","summary":"<p>Finds match of <em>regex</em>, starting at <em>pos</em>.</p>","abstract":false,"args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""}],"args_string":"(regex : Regex, pos = <span class=\"n\">0</span>) : Regex::MatchData?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3628","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3628","def":{"name":"match","args":[{"name":"regex","doc":null,"default_value":"","external_name":"regex","restriction":"Regex"},{"name":"pos","doc":null,"default_value":"0","external_name":"pos","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Regex::MatchData | ::Nil","visibility":"Public","body":"match = regex.match(self, pos)\n$~ = match\nmatch\n"}},{"id":"partition(search:Regex):Tuple(String,String,String)-instance-method","html_id":"partition(search:Regex):Tuple(String,String,String)-instance-method","name":"partition","doc":"Searches separator or pattern (`Regex`) in the string, and returns\na `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns str followed by two empty strings.\n\n```\n\"hello\".partition(\"l\") # => {\"he\", \"l\", \"lo\"}\n\"hello\".partition(\"x\") # => {\"hello\", \"\", \"\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"}],"args_string":"(search : Regex) : Tuple(String, String, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2780","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2780","def":{"name":"partition","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pre = mid = post = \"\"\ncase m = self.match(search)\nwhen .nil?\n  pre = self\nelse\n  pre = m.pre_match\n  mid = m[0]\n  post = m.post_match\nend\n{pre, mid, post}\n"}},{"id":"partition(search:Char|String):Tuple(String,String,String)-instance-method","html_id":"partition(search:Char|String):Tuple(String,String,String)-instance-method","name":"partition","doc":"Searches separator or pattern (`Regex`) in the string, and returns\na `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns str followed by two empty strings.\n\n```\n\"hello\".partition(\"l\") # => {\"he\", \"l\", \"lo\"}\n\"hello\".partition(\"x\") # => {\"hello\", \"\", \"\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String) : Tuple(String, String, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2762","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2762","def":{"name":"partition","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pre = mid = post = \"\"\nsearch_size = search.is_a?(Char) ? 1 : search.size\ncase pos = self.index(search)\nwhen .nil?\n  pre = self\nwhen 0\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nend\n{pre, mid, post}\n"}},{"id":"pretty_print(pp:PrettyPrint):Nil-instance-method","html_id":"pretty_print(pp:PrettyPrint):Nil-instance-method","name":"pretty_print","doc":"Pretty prints `self` into the given printer.","summary":"<p>Pretty prints <code>self</code> into the given printer.</p>","abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":"PrettyPrint"}],"args_string":"(pp : PrettyPrint) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3833","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3833","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":"PrettyPrint"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"printed_bytesize = 0\npp.group do\n  split('\\n') do |part|\n    printed_bytesize = printed_bytesize + part.bytesize\n    if printed_bytesize != bytesize\n      printed_bytesize = printed_bytesize + 1\n      pp.text(\"\\\"\")\n      pp.text(part.inspect_unquoted)\n      pp.text(\"\\\\n\\\"\")\n      if printed_bytesize == bytesize\n        break\n      end\n      pp.text(\" +\")\n      pp.breakable\n    else\n      pp.text(part.inspect)\n    end\n  end\nend\n"}},{"id":"rchop(suffix:Char)-instance-method","html_id":"rchop(suffix:Char)-instance-method","name":"rchop","doc":"Returns a new `String` with *suffix* removed from the end of the string.\n\n```\n\"string\".rchop('g') # => \"strin\"\n\"string\".rchop('x') # => \"string\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"Char"}],"args_string":"(suffix : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1123","def":{"name":"rchop","args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return \"\"\nend\nif ends_with?(suffix)\n  unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\nelse\n  self\nend\n"}},{"id":"rchop(suffix:String)-instance-method","html_id":"rchop(suffix:String)-instance-method","name":"rchop","doc":"Returns a new `String` with *suffix* removed from the end of the string.\n\n```\n\"string\".rchop(\"ing\") # => \"str\"\n\"string\".rchop(\"inx\") # => \"string\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"String"}],"args_string":"(suffix : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1139","def":{"name":"rchop","args":[{"name":"suffix","doc":null,"default_value":"","external_name":"suffix","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return \"\"\nend\nif ends_with?(suffix)\n  unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\nelse\n  self\nend\n"}},{"id":"rchop-instance-method","html_id":"rchop-instance-method","name":"rchop","doc":"Returns a new `String` with the last character removed.\nApplying rchop to an empty string returns an empty string.\n\n```\n\"string\\r\\n\".rchop # => \"string\\r\"\n\"string\\n\\r\".rchop # => \"string\\n\"\n\"string\\n\".rchop   # => \"string\"\n\"string\".rchop     # => \"strin\"\n\"x\".rchop.rchop    # => \"\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the last character removed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1107","def":{"name":"rchop","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize <= 1\n  return \"\"\nend\nif to_unsafe[bytesize - 1] < 128 || ascii_only?\n  return unsafe_byte_slice_string(0, bytesize - 1)\nend\nself[0, size - 1]\n"}},{"id":"reverse-instance-method","html_id":"reverse-instance-method","name":"reverse","doc":"Reverses the order of characters in the string.\n\n```\n\"Argentina\".reverse # => \"anitnegrA\"\n\"racecar\".reverse   # => \"racecar\"\n```","summary":"<p>Reverses the order of characters in the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3483","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3483","def":{"name":"reverse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize <= 1\n  return self\nend\nif ascii_only?\n  String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = self.to_unsafe[(bytesize - i) - 1]\n    end\n    {@bytesize, @length}\n  end\nelse\n  String.new(bytesize) do |buffer|\n    buffer = buffer + bytesize\n    scan(/\\X/) do |match|\n      grapheme = match[0]\n      buffer = buffer - grapheme.bytesize\n      buffer.copy_from(grapheme.to_unsafe, grapheme.bytesize)\n    end\n    {@bytesize, @length}\n  end\nend\n"}},{"id":"rindex(search:Char,offset=size-1)-instance-method","html_id":"rindex(search:Char,offset=size-1)-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char"},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(search : Char, offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2658","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2658","def":{"name":"rindex","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char"},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if search.ascii? && ascii_only?\n  return to_slice.rindex(search.ord.to_u8, offset)\nend\nif offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\nif offset == (size - 1)\n  reader = Char::Reader.new(at_end: self)\nelse\n  byte_index = char_index_to_byte_index(offset)\n  if byte_index\n  else\n    raise(IndexError.new)\n  end\n  reader = Char::Reader.new(self, pos: byte_index)\nend\nwhile true\n  if reader.current_char == search\n    return offset\n  else\n    if reader.has_previous?\n      reader.previous_char\n      offset = offset - 1\n    else\n      return nil\n    end\n  end\nend\n"}},{"id":"rindex(search:String,offset=size-search.size)-instance-method","html_id":"rindex(search:String,offset=size-search.size)-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"size - search.size","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = size <span class=\"o\">-</span> search.size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2688","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2688","def":{"name":"rindex","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"String"},{"name":"offset","doc":null,"default_value":"size - search.size","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return\nend\nsearch_hash = 0_u32\nsearch.to_slice.reverse_each do |b|\n  search_hash = (search_hash * PRIME_RK) + b\nend\npow = PRIME_RK ** search.bytesize\nhash = 0_u32\nchar_index = size\nbegin_pointer = to_unsafe\npointer = begin_pointer + bytesize\ntail_pointer = pointer\nhash_begin_pointer = pointer - search.bytesize\nif hash_begin_pointer < begin_pointer\n  return\nend\nwhile hash_begin_pointer < pointer\n  pointer = pointer - 1\n  byte = pointer.value\n  if (byte & 192) != 128\n    char_index = char_index - 1\n  end\n  hash = (hash * PRIME_RK) + byte\nend\nwhile true\n  if ((hash == search_hash) && char_index <= offset) && ((pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return char_index\n  end\n  if begin_pointer == pointer\n    return\n  end\n  pointer = pointer - 1\n  tail_pointer = tail_pointer - 1\n  byte = pointer.value\n  if (byte & 192) != 128\n    char_index = char_index - 1\n  end\n  hash = ((hash * PRIME_RK) + byte) - (pow * tail_pointer.value)\nend\n"}},{"id":"rindex(search:Regex,offset=size-1)-instance-method","html_id":"rindex(search:Regex,offset=size-1)-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(search : Regex, offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2741","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2741","def":{"name":"rindex","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"},{"name":"offset","doc":null,"default_value":"size - 1","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif 0 <= offset && offset <= size\nelse\n  return nil\nend\nmatch_result = nil\nscan(search) do |match_data|\n  if (index = match_data.begin) && index > offset\n    break\n  end\n  match_result = match_data\nend\nmatch_result.try(&.begin)\n"}},{"id":"rjust(len,char:Char=&#39;&#39;)-instance-method","html_id":"rjust(len,char:Char=&amp;#39;&amp;#39;)-instance-method","name":"rjust","doc":"Adds instances of *char* to left of the string until it is at least size of *len*.\n\n```\n\"Purple\".rjust(8)      # => \"  Purple\"\n\"Purple\".rjust(8, '-') # => \"--Purple\"\n\"Aubergine\".rjust(8)   # => \"Aubergine\"\n```","summary":"<p>Adds instances of <em>char</em> to left of the string until it is at least size of <em>len</em>.</p>","abstract":false,"args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""},{"name":"char","doc":null,"default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(len, char : Char = <span class=\"s\">&#39; &#39;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3526","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3526","def":{"name":"rjust","args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""},{"name":"char","doc":null,"default_value":"' '","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"just(len, char, false)"}},{"id":"rpartition(search:Regex):Tuple(String,String,String)-instance-method","html_id":"rpartition(search:Regex):Tuple(String,String,String)-instance-method","name":"rpartition","doc":"Searches separator or pattern (`Regex`) in the string from the end of the string,\nand returns a `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns two empty strings and str.\n\n```\n\"hello\".rpartition(\"l\")  # => {\"hel\", \"l\", \"o\"}\n\"hello\".rpartition(\"x\")  # => {\"\", \"\", \"hello\"}\n\"hello\".rpartition(/.l/) # => {\"he\", \"ll\", \"o\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string from the end of the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"}],"args_string":"(search : Regex) : Tuple(String, String, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2823","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2823","def":{"name":"rpartition","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Tuple(String, String, String)","visibility":"Public","body":"match_result = nil\npos = self.size - 1\nwhile pos >= 0\n  self[pos..-1].scan(search) do |m|\n    match_result = m\n  end\n  if match_result.nil?\n  else\n    break\n  end\n  pos = pos - 1\nend\npre = mid = post = \"\"\ncase\nwhen match_result.nil?\n  post = self\nwhen pos == 0\n  mid = match_result[0]\n  post = self[match_result[0].size..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = match_result.not_nil![0]\n  post = self[(pos + match_result.not_nil![0].size)..-1]\nend\n{pre, mid, post}\n"}},{"id":"rpartition(search:Char|String):Tuple(String,String,String)-instance-method","html_id":"rpartition(search:Char|String):Tuple(String,String,String)-instance-method","name":"rpartition","doc":"Searches separator or pattern (`Regex`) in the string from the end of the string,\nand returns a `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns two empty strings and str.\n\n```\n\"hello\".rpartition(\"l\")  # => {\"hel\", \"l\", \"o\"}\n\"hello\".rpartition(\"x\")  # => {\"\", \"\", \"hello\"}\n\"hello\".rpartition(/.l/) # => {\"he\", \"ll\", \"o\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string from the end of the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String) : Tuple(String, String, String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2802","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2802","def":{"name":"rpartition","args":[{"name":"search","doc":null,"default_value":"","external_name":"search","restriction":"Char | String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pos = self.rindex(search)\nsearch_size = search.is_a?(Char) ? 1 : search.size\npre = mid = post = \"\"\ncase pos\nwhen .nil?\n  post = self\nwhen 0\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nend\n{pre, mid, post}\n"}},{"id":"rstrip(chars:String)-instance-method","html_id":"rstrip(chars:String)-instance-method","name":"rstrip","doc":"Returns a new string where trailing occurrences of any char\nin *chars* are removed. The *chars* argument is not a suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"abcdefcba\".rstrip(\"abc\") # => \"abcdef\"\n```","summary":"<p>Returns a new string where trailing occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"args_string":"(chars : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1406","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1406","def":{"name":"rstrip","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  self\nwhen 1\n  rstrip(chars[0])\nelse\n  remove_excess_right(calc_excess_right(chars))\nend\n"}},{"id":"rstrip(char:Char)-instance-method","html_id":"rstrip(char:Char)-instance-method","name":"rstrip","doc":"Returns a new string with trailing occurrences of *char* removed.\n\n```\n\"aaabcdaaa\".rstrip('a') # => \"aaabcd\"\n```","summary":"<p>Returns a new string with trailing occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1393","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1393","def":{"name":"rstrip","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nremove_excess_right(calc_excess_right(char))\n"}},{"id":"rstrip-instance-method","html_id":"rstrip-instance-method","name":"rstrip","doc":"Returns a new `String` with trailing whitespace removed.\n\n```\n\"    hello    \".rstrip # => \"    hello\"\n\"\\tgoodbye\\r\\n\".rstrip # => \"\\tgoodbye\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with trailing whitespace removed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1384","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1384","def":{"name":"rstrip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"remove_excess_right(calc_excess_right)"}},{"id":"rstrip(&block:Char->_)-instance-method","html_id":"rstrip(&amp;block:Char-&gt;_)-instance-method","name":"rstrip","doc":"Returns a new string where trailing characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".rstrip { |c| 'a' <= c <= 'c' } # => \"bcadef\"\n```","summary":"<p>Returns a new string where trailing characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"args":[],"args_string":"(&block : Char -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1425","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1425","def":{"name":"rstrip","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Char -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nexcess_right = calc_excess_right do |c|\n  yield c\nend\nremove_excess_right(excess_right)\n"}},{"id":"scan(pattern:Regex,&block)-instance-method","html_id":"scan(pattern:Regex,&amp;block)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nyielding a `Regex::MatchData` for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, yielding a <code><a href=\"Regex/MatchData.html\">Regex::MatchData</a></code> for each match.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3636","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3636","def":{"name":"scan","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"byte_offset = 0\nwhile match = pattern.match_at_byte_index(self, byte_offset)\n  index = match.byte_begin(0)\n  $~ = match\n  yield match\n  match_bytesize = match[0].bytesize\n  if match_bytesize == 0\n    match_bytesize = match_bytesize + 1\n  end\n  byte_offset = index + match_bytesize\nend\nself\n"}},{"id":"scan(pattern:Regex)-instance-method","html_id":"scan(pattern:Regex)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nreturning an `Array` of `Regex::MatchData` for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, returning an <code><a href=\"Array.html\">Array</a></code> of <code><a href=\"Regex/MatchData.html\">Regex::MatchData</a></code> for each match.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3653","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3653","def":{"name":"scan","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"matches = [] of Regex::MatchData\nscan(pattern) do |match|\n  matches << match\nend\nmatches\n"}},{"id":"scan(pattern:String,&block)-instance-method","html_id":"scan(pattern:String,&amp;block)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nyielding the matched string for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, yielding the matched string for each match.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"}],"args_string":"(pattern : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3663","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3663","def":{"name":"scan","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if pattern.empty?\n  return self\nend\nindex = 0\nwhile index = byte_index(pattern, index)\n  yield pattern\n  index = index + pattern.bytesize\nend\nself\n"}},{"id":"scan(pattern:String)-instance-method","html_id":"scan(pattern:String)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nreturning an array of the matched string for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, returning an array of the matched string for each match.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"}],"args_string":"(pattern : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3675","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3675","def":{"name":"scan","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"matches = [] of String\nscan(pattern) do |match|\n  matches << match\nend\nmatches\n"}},{"id":"scrub(replacement=Char::REPLACEMENT):String-instance-method","html_id":"scrub(replacement=Char::REPLACEMENT):String-instance-method","name":"scrub","doc":"Returns a String where bytes that are invalid in the\nUTF-8 encoding are replaced with *replacement*.","summary":"<p>Returns a String where bytes that are invalid in the UTF-8 encoding are replaced with <em>replacement</em>.</p>","abstract":false,"args":[{"name":"replacement","doc":null,"default_value":"Char::REPLACEMENT","external_name":"replacement","restriction":""}],"args_string":"(replacement = <span class=\"t\">Char</span><span class=\"t\">::</span><span class=\"t\">REPLACEMENT</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4109","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4109","def":{"name":"scrub","args":[{"name":"replacement","doc":null,"default_value":"Char::REPLACEMENT","external_name":"replacement","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"result = nil\nreader = Char::Reader.new(self)\nwhile reader.has_next?\n  if reader.error\n    if result\n    else\n      result = String::Builder.new(bytesize)\n      result.write(to_slice[0, reader.pos])\n    end\n    result << replacement\n  else\n    if result\n      result << reader.current_char\n    end\n  end\n  reader.next_char\nend\nresult ? result.to_s : self\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of unicode codepoints in this string.\n\n```\n\"hello\".size # => 5\n\"你好\".size    # => 2\n```","summary":"<p>Returns the number of unicode codepoints in this string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4077","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4077","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @length > 0 || (@bytesize == 0)\n  return @length\nend\n@length = each_byte_index_and_char_index do\nend\n"}},{"id":"split(separator:String,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","html_id":"split(separator:String,limit=nil,*,remove_empty=false,&amp;block:String-&gt;_)-instance-method","name":"split","doc":"Splits the string after each string *separator* and yields each part to a block.\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty string (`\"\"`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nary = [] of String\nlong_river_name = \"Mississippi\"\n\nlong_river_name.split(\"ss\") { |s| ary << s }\nary # => [\"Mi\", \"i\", \"ippi\"]\nary.clear\n\nlong_river_name.split(\"i\") { |s| ary << s }\nary # => [\"M\", \"ss\", \"ss\", \"pp\", \"\"]\nary.clear\n\nlong_river_name.split(\"i\", remove_empty: true) { |s| ary << s }\nary # => [\"M\", \"ss\", \"ss\", \"pp\"]\nary.clear\n\nlong_river_name.split(\"\") { |s| ary << s }\nary # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Splits the string after each string <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"String"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : String, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3174","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"String"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nif separator.empty?\n  split_by_empty_separator(limit) do |string|\n    yield string\n  end\n  return\nend\nyielded = 0\nbyte_offset = 0\nseparator_bytesize = separator.bytesize\nsingle_byte_optimizable = ascii_only?\ni = 0\nstop = (bytesize - separator.bytesize) + 1\nwhile i < stop\n  if ((to_unsafe + i).memcmp(separator.to_unsafe, separator_bytesize)) == 0\n    piece_bytesize = i - byte_offset\n    piece_size = single_byte_optimizable ? piece_bytesize : 0\n    if remove_empty && (piece_bytesize == 0)\n    else\n      yield String.new(to_unsafe + byte_offset, piece_bytesize, piece_size)\n    end\n    yielded = yielded + 1\n    byte_offset = i + separator_bytesize\n    i = i + (separator_bytesize - 1)\n    if limit && ((yielded + 1) == limit)\n      break\n    end\n  end\n  i = i + 1\nend\npiece_bytesize = bytesize - byte_offset\nif remove_empty && (piece_bytesize == 0)\n  return\nend\npiece_size = single_byte_optimizable ? piece_bytesize : 0\nyield String.new(to_unsafe + byte_offset, piece_bytesize, piece_size)\n"}},{"id":"split(limit:Int32?=nil)-instance-method","html_id":"split(limit:Int32?=nil)-instance-method","name":"split","doc":"Makes an array by splitting the string on any amount of ASCII whitespace\ncharacters (and removing that whitespace).\n\nIf *limit* is present, up to *limit* new strings will be created, with the\nentire remainder added to the last string.\n\n```\nold_pond = \"\n  Old pond\n  a frog leaps in\n  water's sound\n\"\nold_pond.split    # => [\"Old\", \"pond\", \"a\", \"frog\", \"leaps\", \"in\", \"water's\", \"sound\"]\nold_pond.split(3) # => [\"Old\", \"pond\", \"a frog leaps in\\n  water's sound\\n\"]\n```","summary":"<p>Makes an array by splitting the string on any amount of ASCII whitespace characters (and removing that whitespace).</p>","abstract":false,"args":[{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"args_string":"(limit : Int32? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2969","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2969","def":{"name":"split","args":[{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(String).new\nsplit(limit) do |string|\n  ary << string\nend\nary\n"}},{"id":"split(separator:Regex,limit=nil,*,remove_empty=false)-instance-method","html_id":"split(separator:Regex,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Splits the string after each regex *separator* and yields each part to a block.\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty regex (`//`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nary = [] of String\nlong_river_name = \"Mississippi\"\n\nlong_river_name.split(/s+/) { |s| ary << s }\nary # => [\"Mi\", \"i\", \"ippi\"]\nary.clear\n\nlong_river_name.split(//) { |s| ary << s }\nary # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Splits the string after each regex <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Regex"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Regex, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3241","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Regex"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"id":"split(separator:Regex,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","html_id":"split(separator:Regex,limit=nil,*,remove_empty=false,&amp;block:String-&gt;_)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on *separator* (and removing instances of *separator*).\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty regex (`//`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nlong_river_name = \"Mississippi\"\nlong_river_name.split(/s+/) # => [\"Mi\", \"i\", \"ippi\"]\nlong_river_name.split(//)   # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on <em>separator</em> (and removing instances of <em>separator</em>).</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Regex"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Regex, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3263","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Regex"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nif separator.source.empty?\n  split_by_empty_separator(limit) do |string|\n    yield string\n  end\n  return\nend\ncount = 0\nmatch_offset = slice_offset = 0\nwhile match = separator.match_at_byte_index(self, match_offset)\n  index = match.byte_begin(0)\n  match_bytesize = match[0].bytesize\n  next_offset = index + match_bytesize\n  if next_offset == slice_offset\n    match_offset = next_offset + (char_bytesize_at(next_offset))\n  else\n    slice_size = index - slice_offset\n    if remove_empty && (slice_size == 0)\n    else\n      yield byte_slice(slice_offset, slice_size)\n    end\n    count = count + 1\n    1.upto(match.size) do |i|\n      if group = match[i]?\n        yield group\n      end\n    end\n    slice_offset = match_offset = next_offset\n  end\n  if limit && ((count + 1) == limit)\n    break\n  end\n  if match_offset >= bytesize\n    break\n  end\nend\nif remove_empty && (slice_offset == bytesize)\nelse\n  yield byte_slice(slice_offset)\nend\n"}},{"id":"split(limit:Int32?=nil,&block:String->_)-instance-method","html_id":"split(limit:Int32?=nil,&amp;block:String-&gt;_)-instance-method","name":"split","doc":"Splits the string after any amount of ASCII whitespace characters and yields\neach non-whitespace part to a block.\n\nIf *limit* is present, up to *limit* new strings will be created, with the\nentire remainder added to the last string.\n\n```\nary = [] of String\nold_pond = \"\n  Old pond\n  a frog leaps in\n  water's sound\n\"\n\nold_pond.split { |s| ary << s }\nary # => [\"Old\", \"pond\", \"a\", \"frog\", \"leaps\", \"in\", \"water's\", \"sound\"]\nary.clear\n\nold_pond.split(3) { |s| ary << s }\nary # => [\"Old\", \"pond\", \"a frog leaps in\\n  water's sound\\n\"]\n```","summary":"<p>Splits the string after any amount of ASCII whitespace characters and yields each non-whitespace part to a block.</p>","abstract":false,"args":[{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"args_string":"(limit : Int32? = <span class=\"n\">nil</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2998","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2998","def":{"name":"split","args":[{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"if limit && limit <= 1\n  yield self\n  return\nend\nyielded = 0\nsingle_byte_optimizable = ascii_only?\nindex = 0\ni = 0\nlooking_for_space = false\nlimit_reached = false\nwhile i < bytesize\n  if looking_for_space\n    while i < bytesize\n      c = to_unsafe[i]\n      i = i + 1\n      if c.unsafe_chr.ascii_whitespace?\n        piece_bytesize = (i - 1) - index\n        piece_size = single_byte_optimizable ? piece_bytesize : 0\n        yield String.new(to_unsafe + index, piece_bytesize, piece_size)\n        yielded = yielded + 1\n        looking_for_space = false\n        if limit && ((yielded + 1) == limit)\n          limit_reached = true\n        end\n        break\n      end\n    end\n  else\n    while i < bytesize\n      c = to_unsafe[i]\n      i = i + 1\n      if c.unsafe_chr.ascii_whitespace?\n      else\n        index = i - 1\n        looking_for_space = true\n        break\n      end\n    end\n    if limit_reached\n      break\n    end\n  end\nend\nif looking_for_space\n  piece_bytesize = bytesize - index\n  piece_size = single_byte_optimizable ? piece_bytesize : 0\n  yield String.new(to_unsafe + index, piece_bytesize, piece_size)\nend\n"}},{"id":"split(separator:Char,limit=nil,*,remove_empty=false)-instance-method","html_id":"split(separator:Char,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on the given character *separator*\n(and removing that character).\n\nIf *limit* is present, up to *limit* new strings will be created,\nwith the entire remainder added to the last string.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\n\"foo,,bar,baz\".split(',')                     # => [\"foo\", \"\", \"bar\", \"baz\"]\n\"foo,,bar,baz\".split(',', remove_empty: true) # => [\"foo\", \"bar\", \"baz\"]\n\"foo,bar,baz\".split(',', 2)                   # => [\"foo\", \"bar,baz\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on the given character <em>separator</em> (and removing that character).</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Char"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Char, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3063","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3063","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Char"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"id":"split(separator:Char,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","html_id":"split(separator:Char,limit=nil,*,remove_empty=false,&amp;block:String-&gt;_)-instance-method","name":"split","doc":"Splits the string after each character *separator* and yields each part to a block.\n\nIf *limit* is present, up to *limit* new strings will be created,\nwith the entire remainder added to the last string.\n\nIf *remove_empty* is `true`, any empty strings are not yielded.\n\n```\nary = [] of String\n\n\"foo,,bar,baz\".split(',') { |string| ary << string }\nary # => [\"foo\", \"\", \"bar\", \"baz\"]\nary.clear\n\n\"foo,,bar,baz\".split(',', remove_empty: true) { |string| ary << string }\nary # => [\"foo\", \"bar\", \"baz\"]\nary.clear\n\n\"foo,bar,baz\".split(',', 2) { |string| ary << string }\nary # => [\"foo\", \"bar,baz\"]\n```","summary":"<p>Splits the string after each character <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Char"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Char, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : String -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3092","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3092","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"Char"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(String -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nyielded = 0\nbyte_offset = 0\nreader = Char::Reader.new(self)\nreader.each do |char|\n  if char == separator\n    piece_bytesize = reader.pos - byte_offset\n    if remove_empty && (piece_bytesize == 0)\n    else\n      yield String.new(to_unsafe + byte_offset, piece_bytesize)\n    end\n    yielded = yielded + 1\n    byte_offset = reader.pos + reader.current_char_width\n    if limit && ((yielded + 1) == limit)\n      break\n    end\n  end\nend\npiece_bytesize = bytesize - byte_offset\nif remove_empty && (piece_bytesize == 0)\n  return\nend\nyield String.new(to_unsafe + byte_offset, piece_bytesize)\n"}},{"id":"split(separator:String,limit=nil,*,remove_empty=false)-instance-method","html_id":"split(separator:String,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on *separator* (and removing instances of *separator*).\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty string (`\"\"`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nlong_river_name = \"Mississippi\"\nlong_river_name.split(\"ss\")                    # => [\"Mi\", \"i\", \"ippi\"]\nlong_river_name.split(\"i\")                     # => [\"M\", \"ss\", \"ss\", \"pp\", \"\"]\nlong_river_name.split(\"i\", remove_empty: true) # => [\"M\", \"ss\", \"ss\", \"pp\"]\nlong_river_name.split(\"\")                      # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on <em>separator</em> (and removing instances of <em>separator</em>).</p>","abstract":false,"args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"String"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : String, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3138","def":{"name":"split","args":[{"name":"separator","doc":null,"default_value":"","external_name":"separator","restriction":"String"},{"name":"limit","doc":null,"default_value":"nil","external_name":"limit","restriction":""},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"remove_empty","doc":null,"default_value":"false","external_name":"remove_empty","restriction":""}],"double_splat":null,"splat_index":2,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"id":"squeeze(&block)-instance-method","html_id":"squeeze(&amp;block)-instance-method","name":"squeeze","doc":"Yields each char in this string to the block.\nReturns a new `String`, that has all characters removed,\nthat were the same as the previous one and for which the given\nblock returned a truthy value.\n\n```\n\"aaabbbccc\".squeeze { |c| ['a', 'b'].includes?(c) } # => \"abccc\"\n\"aaabbbccc\".squeeze { |c| ['a', 'c'].includes?(c) } # => \"abbbc\"\n```","summary":"<p>Yields each char in this string to the block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2295","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2295","def":{"name":"squeeze","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"previous = nil\nString.build(bytesize) do |buffer|\n  each_char do |char|\n    if (yield char) && (previous == char)\n    else\n      buffer << char\n    end\n    previous = char\n  end\nend\n"}},{"id":"squeeze(char:Char)-instance-method","html_id":"squeeze(char:Char)-instance-method","name":"squeeze","doc":"Returns a new `String`, with all runs of char replaced by one instance.\n\n```\n\"a    bbb\".squeeze(' ') # => \"a bbb\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code>, with all runs of char replaced by one instance.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2310","def":{"name":"squeeze","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"squeeze do |my_char|\n  char == my_char\nend"}},{"id":"squeeze-instance-method","html_id":"squeeze-instance-method","name":"squeeze","doc":"Returns a new `String`, that has all characters removed,\nthat were the same as the previous one.\n\n```\n\"a       bbb\".squeeze # => \"a b\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code>, that has all characters removed, that were the same as the previous one.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2335","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2335","def":{"name":"squeeze","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"squeeze do\n  true\nend"}},{"id":"squeeze(*sets:String)-instance-method","html_id":"squeeze(*sets:String)-instance-method","name":"squeeze","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns a new `String` with all\nruns of the same character replaced by one instance, if\nthey match the given set.\n\nIf no set is given, all characters are matched.\n\n```\n\"aaabbbcccddd\".squeeze(\"b-d\") # => \"aaabcd\"\n\"a       bbb\".squeeze         # => \"a b\"\n```","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":"String"}],"args_string":"(*sets : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2325","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L2325","def":{"name":"squeeze","args":[{"name":"sets","doc":null,"default_value":"","external_name":"sets","restriction":"String"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"squeeze do |char|\n  char.in_set?(*sets)\nend"}},{"id":"starts_with?(re:Regex)-instance-method","html_id":"starts_with?(re:Regex)-instance-method","name":"starts_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"re","doc":null,"default_value":"","external_name":"re","restriction":"Regex"}],"args_string":"(re : Regex)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4024","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4024","def":{"name":"starts_with?","args":[{"name":"re","doc":null,"default_value":"","external_name":"re","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!(!($~ = re.match_at_byte_index(self, 0, Regex::Options::ANCHORED)))"}},{"id":"starts_with?(char:Char)-instance-method","html_id":"starts_with?(char:Char)-instance-method","name":"starts_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4016","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4016","def":{"name":"starts_with?","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"each_char do |c|\n  return c == char\nend\nfalse\n"}},{"id":"starts_with?(str:String)-instance-method","html_id":"starts_with?(str:String)-instance-method","name":"starts_with?","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4011","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4011","def":{"name":"starts_with?","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if str.bytesize > bytesize\n  return false\nend\n(to_unsafe.memcmp(str.to_unsafe, str.bytesize)) == 0\n"}},{"id":"strip(char:Char)-instance-method","html_id":"strip(char:Char)-instance-method","name":"strip","doc":"Returns a new string where leading and trailing occurrences of *char* are removed.\n\n```\n\"aaabcdaaa\".strip('a') # => \"bcd\"\n```","summary":"<p>Returns a new string where leading and trailing occurrences of <em>char</em> are removed.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1322","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1322","def":{"name":"strip","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left(char)\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right(char)\nremove_excess(excess_left, excess_right)\n"}},{"id":"strip(chars:String)-instance-method","html_id":"strip(chars:String)-instance-method","name":"strip","doc":"Returns a new string where leading and trailing occurrences of any char\nin *chars* are removed. The *chars* argument is not a prefix or suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"abcdefcba\".strip(\"abc\") # => \"def\"\n```","summary":"<p>Returns a new string where leading and trailing occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"args_string":"(chars : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1341","def":{"name":"strip","args":[{"name":"chars","doc":null,"default_value":"","external_name":"chars","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  return self\nwhen 1\n  return strip(chars[0])\nend\nexcess_left = calc_excess_left(chars)\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right(chars)\nremove_excess(excess_left, excess_right)\n"}},{"id":"strip-instance-method","html_id":"strip-instance-method","name":"strip","doc":"Returns a new `String` with leading and trailing whitespace removed.\n\n```\n\"    hello    \".strip # => \"hello\"\n\"\\tgoodbye\\r\\n\".strip # => \"goodbye\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with leading and trailing whitespace removed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1307","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1307","def":{"name":"strip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"excess_left = calc_excess_left\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right\nremove_excess(excess_left, excess_right)\n"}},{"id":"strip(&block:Char->_)-instance-method","html_id":"strip(&amp;block:Char-&gt;_)-instance-method","name":"strip","doc":"Returns a new string where leading and trailing characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".strip { |c| 'a' <= c <= 'c' } # => \"def\"\n```","summary":"<p>Returns a new string where leading and trailing characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"args":[],"args_string":"(&block : Char -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1366","def":{"name":"strip","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Char -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left do |c|\n  yield c\nend\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right do |c|\n  yield c\nend\nremove_excess(excess_left, excess_right)\n"}},{"id":"sub(hash:Hash(Char,_))-instance-method","html_id":"sub(hash:Hash(Char,_))-instance-method","name":"sub","doc":"Returns a `String` where the first char in the string matching a key in the\ngiven *hash* is replaced by the corresponding hash value.\n\n```\n\"hello\".sub({'a' => 'b', 'l' => 'd'}) # => \"hedlo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first char in the string matching a key in the given <em>hash</em> is replaced by the corresponding hash value.</p>","abstract":false,"args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(Char, _)"}],"args_string":"(hash : Hash(Char, _))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1791","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1791","def":{"name":"sub","args":[{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(Char, _)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nString.build(bytesize) do |buffer|\n  reader = Char::Reader.new(self)\n  while reader.has_next?\n    if hash.has_key?(reader.current_char)\n      buffer << hash[reader.current_char]\n      reader.next_char\n      break\n    else\n      buffer << reader.current_char\n      reader.next_char\n    end\n  end\n  buffer << reader.current_char\n  if reader.has_next?\n    reader.next_char\n    buffer.write(unsafe_byte_slice(reader.pos))\n  end\nend\n"}},{"id":"sub(range:Range(Int,Int),replacement:String)-instance-method","html_id":"sub(range:Range(Int,Int),replacement:String)-instance-method","name":"sub","doc":"Returns a new `String` with characters at the given range\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1..2, \"eee\") # => \"heeelo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with characters at the given range replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"String"}],"args_string":"(range : Range(Int, Int), replacement : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1901","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1901","def":{"name":"sub","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub_range(range, replacement) do |buffer|\n  buffer.copy_from(replacement.to_unsafe, replacement.bytesize)\n  buffer = buffer + replacement.bytesize\n  {buffer, 0}\nend"}},{"id":"sub(range:Range(Int,Int),replacement:Char)-instance-method","html_id":"sub(range:Range(Int,Int),replacement:Char)-instance-method","name":"sub","doc":"Returns a new `String` with characters at the given range\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1..2, 'a') # => \"halo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with characters at the given range replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"Char"}],"args_string":"(range : Range(Int, Int), replacement : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1885","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1885","def":{"name":"sub","args":[{"name":"range","doc":null,"default_value":"","external_name":"range","restriction":"Range(Int, Int)"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub_range(range, replacement) do |buffer, from_index, to_index|\n  replacement.each_byte do |byte|\n    buffer.value = byte\n    buffer = buffer + 1\n  end\n  {buffer, ascii_only? ? (bytesize - (to_index - from_index)) + 1 : 0}\nend"}},{"id":"sub(pattern:Regex,&block)-instance-method","html_id":"sub(pattern:Regex,&amp;block)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *pattern* is replaced by\nthe block's return value.\n\n```\n\"hello\".sub(/./) { |s| s[0].ord.to_s + ' ' } # => \"104 ello\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>pattern</em> is replaced by the block's return value.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1687","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1687","def":{"name":"sub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"sub_append(pattern) do |str, match, buffer|\n  $~ = match\n  buffer << (yield str, match)\nend"}},{"id":"sub(string:String,replacement)-instance-method","html_id":"sub(string:String,replacement)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *string* is replaced\nwith the given *replacement*.\n\n```\n\"hello yellow\".sub(\"ll\", \"dd\") # => \"heddo yellow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>string</em> is replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"args_string":"(string : String, replacement)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1764","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1764","def":{"name":"sub","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub(string) do\n  replacement\nend"}},{"id":"sub(pattern:Regex,replacement,backreferences=true)-instance-method","html_id":"sub(pattern:Regex,replacement,backreferences=true)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *pattern* is replaced by\n*replacement*\n\n```\n\"hello\".sub(/[aeiou]/, \"*\") # => \"h*llo\"\n```\n\nWithin *replacement*, the special match variable `$~` will not refer to the\ncurrent match.\n\nIf *backreferences* is `true` (the default value), *replacement* can include backreferences:\n\n```\n\"hello\".sub(/[aeiou]/, \"(\\\\0)\") # => \"h(e)llo\"\n```\n\nWhen substitution is performed, any backreferences found in *replacement*\nwill be replaced with the contents of the corresponding capture group in\n*pattern*. Backreferences to capture groups that were not present in\n*pattern* or that did not match will be skipped. See `Regex` for information\nabout capture groups.\n\nBackreferences are expressed in the form `\"\\\\d\"`, where *d* is a group\nnumber, or `\"\\\\k&lt;name>\"` where *name* is the name of a named capture group.\nA sequence of literal characters resembling a backreference can be\nexpressed by placing `\"\\\\\"` before the sequence.\n\n```\n\"foo\".sub(/o/, \"x\\\\0x\")                  # => \"fxoxo\"\n\"foofoo\".sub(/(?<bar>oo)/, \"|\\\\k<bar>|\") # => \"f|oo|foo\"\n\"foo\".sub(/o/, \"\\\\\\\\0\")                  # => \"f\\\\0o\"\n```\n\nRaises `ArgumentError` if an incomplete named back-reference is present in\n*replacement*.\n\nRaises `IndexError` if a named group referenced in *replacement* is not present\nin *pattern*.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>pattern</em> is replaced by <em>replacement</em></p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""},{"name":"backreferences","doc":null,"default_value":"true","external_name":"backreferences","restriction":""}],"args_string":"(pattern : Regex, replacement, backreferences = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1732","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1732","def":{"name":"sub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""},{"name":"backreferences","doc":null,"default_value":"true","external_name":"backreferences","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (backreferences && replacement.is_a?(String)) && replacement.has_back_references?\n  sub_append(pattern) do |_, match, buffer|\n    scan_backreferences(replacement, match, buffer)\n  end\nelse\n  sub(pattern) do\n    replacement\n  end\nend"}},{"id":"sub(pattern:Regex,hash:Hash(String,_)|NamedTuple)-instance-method","html_id":"sub(pattern:Regex,hash:Hash(String,_)|NamedTuple)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *pattern* is replaced\nwith the matching entry from the *hash* of replacements. If the first match\nis not included in the *hash*, nothing is replaced.\n\n```\n\"hello\".sub(/(he|l|o)/, {\"he\": \"ha\", \"l\": \"la\"}) # => \"hallo\"\n\"hello\".sub(/(he|l|o)/, {\"l\": \"la\"})             # => \"hello\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>pattern</em> is replaced with the matching entry from the <em>hash</em> of replacements.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"args_string":"(pattern : Regex, hash : Hash(String, _) | NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1748","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1748","def":{"name":"sub","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"Regex"},{"name":"hash","doc":null,"default_value":"","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub(pattern) do |match|\n  if hash.has_key?(match)\n    hash[match]\n  else\n    return self\n  end\nend"}},{"id":"sub(char:Char,replacement)-instance-method","html_id":"sub(char:Char,replacement)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *char* is replaced by\n*replacement*.\n\n```\n\"hello\".sub('l', \"lo\")      # => \"helolo\"\n\"hello world\".sub('o', 'a') # => \"hella world\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>char</em> is replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"args_string":"(char : Char, replacement)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1660","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1660","def":{"name":"sub","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if includes?(char)\n  String.build(bytesize) do |buffer|\n    reader = Char::Reader.new(self)\n    while reader.has_next?\n      if reader.current_char == char\n        buffer << replacement\n        break\n      else\n        buffer << reader.current_char\n      end\n      reader.next_char\n    end\n    reader.next_char\n    buffer.write(unsafe_byte_slice(reader.pos))\n  end\nelse\n  self\nend"}},{"id":"sub(index:Int,replacement:String)-instance-method","html_id":"sub(index:Int,replacement:String)-instance-method","name":"sub","doc":"Returns a new `String` with the character at the given index\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1, \"eee\") # => \"heeello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the character at the given index replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"String"}],"args_string":"(index : Int, replacement : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1851","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1851","def":{"name":"sub","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub_index(index.to_i, replacement) do |buffer|\n  buffer.copy_from(replacement.to_unsafe, replacement.bytesize)\n  buffer = buffer + replacement.bytesize\n  {buffer, self.size_known? && replacement.size_known? ? (self.size + replacement.size) - 1 : 0}\nend"}},{"id":"sub(&block:Char->_)-instance-method","html_id":"sub(&amp;block:Char-&gt;_)-instance-method","name":"sub","doc":"Returns a new `String` where the first character is yielded to the given\nblock and replaced by its return value.\n\n```\n\"hello\".sub { |char| char + 1 } # => \"iello\"\n\"hello\".sub { \"hi\" }            # => \"hiello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> where the first character is yielded to the given block and replaced by its return value.</p>","abstract":false,"args":[],"args_string":"(&block : Char -> _)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1642","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1642","def":{"name":"sub","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":{"name":"block","doc":null,"default_value":"","external_name":"block","restriction":"(Char -> _)"},"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nString.build(bytesize) do |buffer|\n  reader = Char::Reader.new(self)\n  buffer << (yield reader.current_char)\n  reader.next_char\n  buffer.write(unsafe_byte_slice(reader.pos))\nend\n"}},{"id":"sub(string:String,&block)-instance-method","html_id":"sub(string:String,&amp;block)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *string* is replaced\nwith the block's value.\n\n```\n\"hello yellow\".sub(\"ll\") { \"dd\" } # => \"heddo yellow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>string</em> is replaced with the block's value.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1774","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1774","def":{"name":"sub","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"index = self.byte_index(string)\nif index\nelse\n  return self\nend\nString.build(bytesize) do |buffer|\n  buffer.write(unsafe_byte_slice(0, index))\n  buffer << (yield string)\n  buffer.write(unsafe_byte_slice(index + string.bytesize))\nend\n"}},{"id":"sub(index:Int,replacement:Char)-instance-method","html_id":"sub(index:Int,replacement:Char)-instance-method","name":"sub","doc":"Returns a new `String` with the character at the given index\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1, 'a') # => \"hallo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the character at the given index replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"Char"}],"args_string":"(index : Int, replacement : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1835","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1835","def":{"name":"sub","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"},{"name":"replacement","doc":null,"default_value":"","external_name":"replacement","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sub_index(index.to_i, replacement) do |buffer|\n  replacement.each_byte do |byte|\n    buffer.value = byte\n    buffer = buffer + 1\n  end\n  {buffer, @length}\nend"}},{"id":"succ-instance-method","html_id":"succ-instance-method","name":"succ","doc":"Returns the successor of the string. The successor is calculated\nby incrementing characters starting from the rightmost alphanumeric\n(or the rightmost character if there are no alphanumerics) in the string.\nIncrementing a digit always results in another digit, and incrementing\na letter results in another letter of the same case.\n\nIf the increment generates a \"carry\", the character to the left of it is\nincremented. This process repeats until there is no carry,\nadding an additional character if necessary.\n\n```\n\"abcd\".succ      # => \"abce\"\n\"THX1138\".succ   # => \"THX1139\"\n\"((koala))\".succ # => \"((koalb))\"\n\"1999zzz\".succ   # => \"2000aaa\"\n\"ZZZ9999\".succ   # => \"AAAA0000\"\n\"***\".succ       # => \"**+\"\n```","summary":"<p>Returns the successor of the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3580","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3580","def":{"name":"succ","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nchars = self.chars\ncarry = nil\nlast_alnum = 0\nindex = size - 1\nwhile index >= 0\n  s = chars[index]\n  if s.ascii_alphanumeric?\n    carry = 0\n    if (('0' <= s && s < '9') || ('a' <= s && s < 'z')) || ('A' <= s && s < 'Z')\n      chars[index] = s.succ\n      break\n    else\n      if s == '9'\n        chars[index] = '0'\n        carry = '1'\n      else\n        if s == 'z'\n          chars[index] = carry = 'a'\n        else\n          if s == 'Z'\n            chars[index] = carry = 'A'\n          end\n        end\n      end\n    end\n    last_alnum = index\n  end\n  index = index - 1\nend\nif carry.nil?\n  chars[size - 1] = chars[size - 1].succ\nend\nif carry.is_a?(Char) && index < 0\n  chars.insert(last_alnum, carry)\nend\nString.build(chars.size) do |str|\n  chars.each do |char|\n    str << char\n  end\nend\n"}},{"id":"to_big_d-instance-method","html_id":"to_big_d-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L485","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_decimal.cr#L485","def":{"name":"to_big_d","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigDecimal.new(self)"}},{"id":"to_big_f-instance-method","html_id":"to_big_f-instance-method","name":"to_big_f","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L283","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_float.cr#L283","def":{"name":"to_big_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"BigFloat.new(self)"}},{"id":"to_big_i(base=10):BigInt-instance-method","html_id":"to_big_i(base=10):BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` from this string, in the given *base*.\n\nRaises `ArgumentError` if this string doesn't denote a valid integer.","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> from this string, in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = <span class=\"n\">10</span>) : BigInt","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L547","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/big/big_int.cr#L547","def":{"name":"to_big_i","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"BigInt","visibility":"Public","body":"BigInt.new(self, base)"}},{"id":"to_f(whitespace=true,strict=true)-instance-method","html_id":"to_f(whitespace=true,strict=true)-instance-method","name":"to_f","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method raises an exception if the string is not a valid float representation.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f                # => 1234.5\n\"45.67 degrees\".to_f           # raises ArgumentError\n\"thx1138\".to_f(strict: false)  # raises ArgumentError\n\" 1.2\".to_f(whitespace: false) # raises ArgumentError\n\"1.2foo\".to_f(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L628","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L628","def":{"name":"to_f","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64(whitespace: whitespace, strict: strict)"}},{"id":"to_f32(whitespace=true,strict=true)-instance-method","html_id":"to_f32(whitespace=true,strict=true)-instance-method","name":"to_f32","doc":"Same as `#to_f` but returns a Float32.","summary":"<p>Same as <code><a href=\"String.html#to_f%28whitespace%3Dtrue%2Cstrict%3Dtrue%29-instance-method\">#to_f</a></code> but returns a Float32.</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L651","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L651","def":{"name":"to_f32","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f32?(whitespace: whitespace, strict: strict) || (raise(ArgumentError.new(\"Invalid Float32: #{self}\")))"}},{"id":"to_f32?(whitespace=true,strict=true)-instance-method","html_id":"to_f32?(whitespace=true,strict=true)-instance-method","name":"to_f32?","doc":"Same as `#to_f?` but returns a Float32.","summary":"<p>Same as <code><a href=\"String.html#to_f%3F%28whitespace%3Dtrue%2Cstrict%3Dtrue%29-instance-method\">#to_f?</a></code> but returns a Float32.</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L656","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L656","def":{"name":"to_f32?","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f_impl(whitespace: whitespace, strict: strict) do\n  v = LibC.strtof(self, out endptr)\n  {v, endptr}\nend"}},{"id":"to_f64(whitespace=true,strict=true)-instance-method","html_id":"to_f64(whitespace=true,strict=true)-instance-method","name":"to_f64","doc":"Same as `#to_f`.","summary":"<p>Same as <code><a href=\"String.html#to_f%28whitespace%3Dtrue%2Cstrict%3Dtrue%29-instance-method\">#to_f</a></code>.</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L664","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L664","def":{"name":"to_f64","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64?(whitespace: whitespace, strict: strict) || (raise(ArgumentError.new(\"Invalid Float64: #{self}\")))"}},{"id":"to_f64?(whitespace=true,strict=true)-instance-method","html_id":"to_f64?(whitespace=true,strict=true)-instance-method","name":"to_f64?","doc":"Same as `#to_f?`.","summary":"<p>Same as <code><a href=\"String.html#to_f%3F%28whitespace%3Dtrue%2Cstrict%3Dtrue%29-instance-method\">#to_f?</a></code>.</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L669","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L669","def":{"name":"to_f64?","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f_impl(whitespace: whitespace, strict: strict) do\n  v = LibC.strtod(self, out endptr)\n  {v, endptr}\nend"}},{"id":"to_f?(whitespace=true,strict=true)-instance-method","html_id":"to_f?(whitespace=true,strict=true)-instance-method","name":"to_f?","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method returns `nil` if the string is not a valid float representation.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f?                # => 1234.5\n\"45.67 degrees\".to_f?           # => nil\n\"thx1138\".to_f?                 # => nil\n\" 1.2\".to_f?(whitespace: false) # => nil\n\"1.2foo\".to_f?(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(whitespace = <span class=\"n\">true</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L646","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L646","def":{"name":"to_f?","args":[{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_f64?(whitespace: whitespace, strict: strict)"}},{"id":"to_i(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_i(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_i","doc":"Same as `#to_i`, but returns the block's value if there is not a valid number at the start\nof this string, or if the resulting integer doesn't fit an `Int32`.\n\n```\n\"12345\".to_i { 0 } # => 12345\n\"hello\".to_i { 0 } # => 0\n```","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code>, but returns the block's value if there is not a valid number at the start of this string, or if the resulting integer doesn't fit an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L341","def":{"name":"to_i","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict) do\n  yield\nend"}},{"id":"to_i(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true)-instance-method","html_id":"to_i(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true)-instance-method","name":"to_i","doc":"Returns the result of interpreting leading characters in this string as an\ninteger base *base* (between 2 and 36).\n\nIf there is not a valid number at the start of this string,\nor if the resulting integer doesn't fit an `Int32`, an `ArgumentError` is raised.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **underscore**: if `true`, underscores in numbers are allowed\n* **prefix**: if `true`, the prefixes `\"0x\"`, `\"0\"` and `\"0b\"` override the base\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"12345\".to_i             # => 12345\n\"0a\".to_i                # raises ArgumentError\n\"hello\".to_i             # raises ArgumentError\n\"0a\".to_i(16)            # => 10\n\"1100101\".to_i(2)        # => 101\n\"1100101\".to_i(8)        # => 294977\n\"1100101\".to_i(10)       # => 1100101\n\"1100101\".to_i(base: 16) # => 17826049\n\n\"12_345\".to_i                   # raises ArgumentError\n\"12_345\".to_i(underscore: true) # => 12345\n\n\"  12345  \".to_i                    # => 12345\n\"  12345  \".to_i(whitespace: false) # raises ArgumentError\n\n\"0x123abc\".to_i               # raises ArgumentError\n\"0x123abc\".to_i(prefix: true) # => 1194684\n\n\"99 red balloons\".to_i                # raises ArgumentError\n\"99 red balloons\".to_i(strict: false) # => 99\n```","summary":"<p>Returns the result of interpreting leading characters in this string as an integer base <em>base</em> (between 2 and 36).</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L317","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L317","def":{"name":"to_i","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict)"}},{"id":"to_i16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int16-instance-method","html_id":"to_i16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int16-instance-method","name":"to_i16","doc":"Same as `#to_i` but returns an `Int16`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L376","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L376","def":{"name":"to_i16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"to_i16(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid Int16: #{self}\"))\nend"}},{"id":"to_i16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_i16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_i16","doc":"Same as `#to_i` but returns an `Int16` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L386","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L386","def":{"name":"to_i16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(i16, 32767, 32768)"}},{"id":"to_i16?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int16?-instance-method","html_id":"to_i16?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int16?-instance-method","name":"to_i16?","doc":"Same as `#to_i` but returns an `Int16` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int16?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L381","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L381","def":{"name":"to_i16?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16 | ::Nil","visibility":"Public","body":"to_i16(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_i32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_i32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_i32","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L416","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L416","def":{"name":"to_i32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(i32, 2147483647, 2147483648_i64)"}},{"id":"to_i32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int32-instance-method","html_id":"to_i32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int32-instance-method","name":"to_i32","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L406","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L406","def":{"name":"to_i32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid Int32: #{self}\"))\nend"}},{"id":"to_i32?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int32?-instance-method","html_id":"to_i32?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int32?-instance-method","name":"to_i32?","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L411","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L411","def":{"name":"to_i32?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_i64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int64-instance-method","html_id":"to_i64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int64-instance-method","name":"to_i64","doc":"Same as `#to_i` but returns an `Int64`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L436","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L436","def":{"name":"to_i64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"to_i64(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid Int64: #{self}\"))\nend"}},{"id":"to_i64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_i64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_i64","doc":"Same as `#to_i` but returns an `Int64` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L446","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L446","def":{"name":"to_i64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(i64, 9223372036854775807_i64, 9223372036854775808_u64)"}},{"id":"to_i64?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int64?-instance-method","html_id":"to_i64?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int64?-instance-method","name":"to_i64?","doc":"Same as `#to_i` but returns an `Int64` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L441","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L441","def":{"name":"to_i64?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64 | ::Nil","visibility":"Public","body":"to_i64(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_i8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int8-instance-method","html_id":"to_i8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int8-instance-method","name":"to_i8","doc":"Same as `#to_i` but returns an `Int8`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L346","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L346","def":{"name":"to_i8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"to_i8(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid Int8: #{self}\"))\nend"}},{"id":"to_i8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_i8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_i8","doc":"Same as `#to_i` but returns an `Int8` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L356","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L356","def":{"name":"to_i8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(i8, 127, 128)"}},{"id":"to_i8?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int8?-instance-method","html_id":"to_i8?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):Int8?-instance-method","name":"to_i8?","doc":"Same as `#to_i` but returns an `Int8` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : Int8?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L351","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L351","def":{"name":"to_i8?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8 | ::Nil","visibility":"Public","body":"to_i8(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_i?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true)-instance-method","html_id":"to_i?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true)-instance-method","name":"to_i?","doc":"Same as `#to_i`, but returns `nil` if there is not a valid number at the start\nof this string, or if the resulting integer doesn't fit an `Int32`.\n\n```\n\"12345\".to_i?             # => 12345\n\"99 red balloons\".to_i?   # => nil\n\"0a\".to_i?(strict: false) # => 0\n\"hello\".to_i?             # => nil\n```","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code>, but returns <code>nil</code> if there is not a valid number at the start of this string, or if the resulting integer doesn't fit an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L330","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L330","def":{"name":"to_i?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_i32?(base, whitespace, underscore, prefix, strict)"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L52","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.string(self)"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4200","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4200","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io.write_utf8(to_slice)"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4196","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4196","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"to_slice:Bytes-instance-method","html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns the underlying bytes of this String in an **unsafe** way.\n\nThe returned slice is read-only.","summary":"<p>Returns the underlying bytes of this String in an <strong>unsafe</strong> way.</p>","abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4207","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4207","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"Slice.new(to_unsafe, bytesize, read_only: true)"}},{"id":"to_u16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt16-instance-method","html_id":"to_u16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt16-instance-method","name":"to_u16","doc":"Same as `#to_i` but returns an `UInt16`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L391","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L391","def":{"name":"to_u16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"to_u16(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid UInt16: #{self}\"))\nend"}},{"id":"to_u16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_u16(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_u16","doc":"Same as `#to_i` but returns an `UInt16` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L401","def":{"name":"to_u16","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(u16, 65535)"}},{"id":"to_u16?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt16?-instance-method","html_id":"to_u16?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt16?-instance-method","name":"to_u16?","doc":"Same as `#to_i` but returns an `UInt16` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt16?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L396","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L396","def":{"name":"to_u16?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16 | ::Nil","visibility":"Public","body":"to_u16(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_u32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt32-instance-method","html_id":"to_u32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt32-instance-method","name":"to_u32","doc":"Same as `#to_i` but returns an `UInt32`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L421","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L421","def":{"name":"to_u32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"to_u32(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid UInt32: #{self}\"))\nend"}},{"id":"to_u32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_u32(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_u32","doc":"Same as `#to_i` but returns an `UInt32` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L431","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L431","def":{"name":"to_u32","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(u32, 4294967295_i64)"}},{"id":"to_u32?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt32?-instance-method","html_id":"to_u32?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt32?-instance-method","name":"to_u32?","doc":"Same as `#to_i` but returns an `UInt32` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L426","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L426","def":{"name":"to_u32?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32 | ::Nil","visibility":"Public","body":"to_u32(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_u64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_u64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_u64","doc":"Same as `#to_i` but returns an `UInt64` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L461","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L461","def":{"name":"to_u64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(u64)"}},{"id":"to_u64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt64-instance-method","html_id":"to_u64(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt64-instance-method","name":"to_u64","doc":"Same as `#to_i` but returns an `UInt64`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L451","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L451","def":{"name":"to_u64","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"to_u64(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid UInt64: #{self}\"))\nend"}},{"id":"to_u64?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt64?-instance-method","html_id":"to_u64?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt64?-instance-method","name":"to_u64?","doc":"Same as `#to_i` but returns an `UInt64` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L456","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L456","def":{"name":"to_u64?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64 | ::Nil","visibility":"Public","body":"to_u64(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_u8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt8-instance-method","html_id":"to_u8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt8-instance-method","name":"to_u8","doc":"Same as `#to_i` but returns an `UInt8`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L361","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L361","def":{"name":"to_u8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"to_u8(base, whitespace, underscore, prefix, strict) do\n  raise(ArgumentError.new(\"Invalid UInt8: #{self}\"))\nend"}},{"id":"to_u8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&block)-instance-method","html_id":"to_u8(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true,&amp;block)-instance-method","name":"to_u8","doc":"Same as `#to_i` but returns an `UInt8` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L371","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L371","def":{"name":"to_u8","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"gen_to_(u8, 255)"}},{"id":"to_u8?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt8?-instance-method","html_id":"to_u8?(base:Int=10,whitespace=true,underscore=false,prefix=false,strict=true):UInt8?-instance-method","name":"to_u8?","doc":"Same as `#to_i` but returns an `UInt8` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3Dtrue%2Cunderscore%3Dfalse%2Cprefix%3Dfalse%2Cstrict%3Dtrue%2C%26block%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"args_string":"(base : Int = <span class=\"n\">10</span>, whitespace = <span class=\"n\">true</span>, underscore = <span class=\"n\">false</span>, prefix = <span class=\"n\">false</span>, strict = <span class=\"n\">true</span>) : UInt8?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L366","def":{"name":"to_u8?","args":[{"name":"base","doc":null,"default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","doc":null,"default_value":"true","external_name":"whitespace","restriction":""},{"name":"underscore","doc":null,"default_value":"false","external_name":"underscore","restriction":""},{"name":"prefix","doc":null,"default_value":"false","external_name":"prefix","restriction":""},{"name":"strict","doc":null,"default_value":"true","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8 | ::Nil","visibility":"Public","body":"to_u8(base, whitespace, underscore, prefix, strict) do\n  nil\nend"}},{"id":"to_unsafe:Pointer(UInt8)-instance-method","html_id":"to_unsafe:Pointer(UInt8)-instance-method","name":"to_unsafe","doc":"Returns a pointer to the underlying bytes of this String.","summary":"<p>Returns a pointer to the underlying bytes of this String.</p>","abstract":false,"args":[],"args_string":" : Pointer(UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4212","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4212","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Pointer(UInt8)","visibility":"Public","body":"pointerof(@c)"}},{"id":"to_utf16:Slice(UInt16)-instance-method","html_id":"to_utf16:Slice(UInt16)-instance-method","name":"to_utf16","doc":"Returns the UTF-16 encoding of the given *string*.\n\nInvalid chars (in the range U+D800..U+DFFF) are encoded with the\nunicode replacement char value `0xfffd`.\n\nThe byte following the end of this slice (but not included in it) is defined\nto be zero. This allows passing the result of this function into C functions\nthat expect a null-terminated `UInt16*`.\n\n```\n\"hi 𐂥\".to_utf16 # => Slice[104_u16, 105_u16, 32_u16, 55296_u16, 56485_u16]\n```","summary":"<p>Returns the UTF-16 encoding of the given <em>string</em>.</p>","abstract":false,"args":[],"args_string":" : Slice(UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/utf16.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/utf16.cr#L14","def":{"name":"to_utf16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Slice(UInt16)","visibility":"Public","body":"size = 0\neach_char do |char|\n  size = size + (char.ord < 65536 ? 1 : 2)\nend\nslice = Slice(UInt16).new(size + 1)\ni = 0\neach_char do |char|\n  ord = char.ord\n  if ord <= 55296 || (57344 <= ord && ord < 65536)\n    slice[i] = ord.to_u16\n  else\n    if ord >= 65536\n      ord = ord - 65536\n      slice[i] = 55296_u16 + ((ord >> 10) & 1023)\n      i = i + 1\n      slice[i] = 56320_u16 + (ord & 1023)\n    else\n      slice[i] = 65533_u16\n    end\n  end\n  i = i + 1\nend\nslice[i] = 0_u16\nslice[0, size]\n"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L62","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if YAML::Schema::Core.reserved_string?(self)\n  yaml.scalar(self, style: YAML::ScalarStyle::DOUBLE_QUOTED)\nelse\n  yaml.scalar(self)\nend"}},{"id":"tr(from:String,to:String)-instance-method","html_id":"tr(from:String,to:String)-instance-method","name":"tr","doc":"Returns a new string _tr_anslating characters using *from* and *to* as a\nmap. If *to* is shorter than *from*, the last character in *to* is used for\nthe rest. If *to* is empty, this acts like `String#delete`.\n\n```\n\"aabbcc\".tr(\"abc\", \"xyz\") # => \"xxyyzz\"\n\"aabbcc\".tr(\"abc\", \"x\")   # => \"xxxxxx\"\n\"aabbcc\".tr(\"a\", \"xyz\")   # => \"xxbbcc\"\n```","summary":"<p>Returns a new string <em>tr</em>anslating characters using <em>from</em> and <em>to</em> as a map.</p>","abstract":false,"args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"String"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"String"}],"args_string":"(from : String, to : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1590","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L1590","def":{"name":"tr","args":[{"name":"from","doc":null,"default_value":"","external_name":"from","restriction":"String"},{"name":"to","doc":null,"default_value":"","external_name":"to","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if to.empty?\n  return delete(from)\nend\nif from.bytesize == 1\n  return gsub((from.unsafe_byte_at(0)).unsafe_chr, to[0])\nend\nmulti = nil\ntable = StaticArray(Int32, 256).new(-1)\nreader = Char::Reader.new(to)\nchar = reader.current_char\nnext_char = reader.next_char\nfrom.each_char do |ch|\n  if ch.ord >= 256\n    multi || (multi = {} of Char => Char)\n    multi[ch] = char\n  else\n    table[ch.ord] = char.ord\n  end\n  if next_char != Char::ZERO\n    char = next_char\n    reader.next_char\n    next_char = reader.current_char\n  end\nend\nString.build(bytesize) do |buffer|\n  each_char do |ch|\n    if ch.ord < 256\n      if (a = table[ch.ord]) >= 0\n        buffer << a.unsafe_chr\n      else\n        buffer << ch\n      end\n    else\n      if a = multi.try(&.[]?(ch))\n        buffer << a\n      else\n        buffer << ch\n      end\n    end\n  end\nend\n"}},{"id":"underscore-instance-method","html_id":"underscore-instance-method","name":"underscore","doc":"Converts camelcase boundaries to underscores.\n\n```\n\"DoesWhatItSaysOnTheTin\".underscore # => \"does_what_it_says_on_the_tin\"\n\"PartyInTheUSA\".underscore          # => \"party_in_the_usa\"\n\"HTTP_CLIENT\".underscore            # => \"http_client\"\n\"3.14IsPi\".underscore               # => \"3.14_is_pi\"\n```","summary":"<p>Converts camelcase boundaries to underscores.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L3385","def":{"name":"underscore","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"first = true\nlast_is_downcase = false\nlast_is_upcase = false\nlast_is_digit = false\nmem = nil\nString.build(bytesize + 10) do |str|\n  each_char do |char|\n    digit = '0' <= char && char <= '9'\n    downcase = ('a' <= char && char <= 'z') || digit\n    upcase = 'A' <= char && char <= 'Z'\n    if first\n      str << char.downcase\n    else\n      if last_is_downcase && upcase\n        if mem\n          str << mem\n          mem = nil\n        end\n        str << '_'\n        str << char.downcase\n      else\n        if (last_is_upcase || last_is_digit) && (upcase || digit)\n          if mem\n            str << mem.downcase\n          end\n          mem = char\n        else\n          if mem\n            if char == '_'\n            else\n              if last_is_upcase && downcase\n                str << '_'\n              end\n            end\n            str << mem.downcase\n            mem = nil\n          end\n          str << char.downcase\n        end\n      end\n    end\n    last_is_downcase = downcase\n    last_is_upcase = upcase\n    last_is_digit = digit\n    first = false\n  end\n  if mem\n    str << mem.downcase\n  end\nend\n"}},{"id":"unsafe_byte_at(index)-instance-method","html_id":"unsafe_byte_at(index)-instance-method","name":"unsafe_byte_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"args_string":"(index)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L903","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L903","def":{"name":"unsafe_byte_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_unsafe[index]"}},{"id":"unsafe_byte_slice(byte_offset)-instance-method","html_id":"unsafe_byte_slice(byte_offset)-instance-method","name":"unsafe_byte_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"byte_offset","doc":null,"default_value":"","external_name":"byte_offset","restriction":""}],"args_string":"(byte_offset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4220","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4220","def":{"name":"unsafe_byte_slice","args":[{"name":"byte_offset","doc":null,"default_value":"","external_name":"byte_offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Slice.new(to_unsafe + byte_offset, bytesize - byte_offset, read_only: true)"}},{"id":"unsafe_byte_slice(byte_offset,count)-instance-method","html_id":"unsafe_byte_slice(byte_offset,count)-instance-method","name":"unsafe_byte_slice","doc":null,"summary":null,"abstract":false,"args":[{"name":"byte_offset","doc":null,"default_value":"","external_name":"byte_offset","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"args_string":"(byte_offset, count)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4216","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4216","def":{"name":"unsafe_byte_slice","args":[{"name":"byte_offset","doc":null,"default_value":"","external_name":"byte_offset","restriction":""},{"name":"count","doc":null,"default_value":"","external_name":"count","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Slice.new(to_unsafe + byte_offset, count, read_only: true)"}},{"id":"upcase(options=Unicode::CaseOptions::None)-instance-method","html_id":"upcase(options=Unicode::CaseOptions::None)-instance-method","name":"upcase","doc":"Returns a new `String` with each lowercase letter replaced with its uppercase\ncounterpart.\n\n```\n\"hEllO\".upcase # => \"HELLO\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with each lowercase letter replaced with its uppercase counterpart.</p>","abstract":false,"args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L940","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L940","def":{"name":"upcase","args":[{"name":"options","doc":null,"default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if empty?\n  return self\nend\nif ascii_only? && (options.none? || options.ascii?)\n  String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = to_unsafe[i].unsafe_chr.upcase.ord.to_u8\n    end\n    {@bytesize, @length}\n  end\nelse\n  String.build(bytesize) do |io|\n    each_char do |char|\n      char.upcase(options) do |res|\n        io << res\n      end\n    end\n  end\nend\n"}},{"id":"valid_encoding?-instance-method","html_id":"valid_encoding?-instance-method","name":"valid_encoding?","doc":"Returns `true` if this String is encoded correctly\naccording to the UTF-8 encoding.","summary":"<p>Returns <code>true</code> if this String is encoded correctly according to the UTF-8 encoding.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4098","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string.cr#L4098","def":{"name":"valid_encoding?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = Char::Reader.new(self)\nwhile reader.has_next?\n  if reader.error\n    return false\n  end\n  reader.next_char\nend\ntrue\n"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/String/Builder","path":"String/Builder.html","kind":"class","full_name":"String::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"string/builder.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/String","kind":"class","full_name":"String","name":"String"},"doc":"Similar to `IO::Memory`, but optimized for building a single string.\n\nYou should never have to deal with this class. Instead, use `String.build`.","summary":"<p>Similar to <code><a href=\"../IO/Memory.html\">IO::Memory</a></code>, but optimized for building a single string.</p>","class_methods":[{"id":"build(capacity:Int=64,&block):String-class-method","html_id":"build(capacity:Int=64,&amp;block):String-class-method","name":"build","doc":null,"summary":null,"abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = <span class=\"n\">64</span>, &block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L25","def":{"name":"build","args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"builder = new(capacity)\nyield builder\nbuilder.to_s\n"}}],"constructors":[{"id":"new(capacity:Int=64)-class-method","html_id":"new(capacity:Int=64)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = <span class=\"n\">64</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L11","def":{"name":"new","args":[{"name":"capacity","doc":null,"default_value":"64","external_name":"capacity","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(string:String)-class-method","html_id":"new(string:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L31","def":{"name":"new","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io = new(string.bytesize)\nio << string\nio\n"}}],"instance_methods":[{"id":"back(amount:Int)-instance-method","html_id":"back(amount:Int)-instance-method","name":"back","doc":"Moves the write pointer, and the resulting string bytesize,\nby the given *amount*.","summary":"<p>Moves the write pointer, and the resulting string bytesize, by the given <em>amount</em>.</p>","abstract":false,"args":[{"name":"amount","doc":null,"default_value":"","external_name":"amount","restriction":"Int"}],"args_string":"(amount : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L91","def":{"name":"back","args":[{"name":"amount","doc":null,"default_value":"","external_name":"amount","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if 0 <= amount && amount <= @bytesize\nelse\n  raise(ArgumentError.new(\"Invalid back amount\"))\nend\n@bytesize = @bytesize - amount\n"}},{"id":"buffer-instance-method","html_id":"buffer-instance-method","name":"buffer","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L69","def":{"name":"buffer","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@buffer + String::HEADER_SIZE"}},{"id":"bytesize:Int32-instance-method","html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L7","def":{"name":"bytesize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"id":"capacity:Int32-instance-method","html_id":"capacity:Int32-instance-method","name":"capacity","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L8","def":{"name":"capacity","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@capacity"}},{"id":"chomp!(byte:UInt8)-instance-method","html_id":"chomp!(byte:UInt8)-instance-method","name":"chomp!","doc":"Chomps the last byte from the string buffer.\nIf the byte is `'\\n'` and there's a `'\\r'` before it, it is also removed.","summary":"<p>Chomps the last byte from the string buffer.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L79","def":{"name":"chomp!","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if bytesize > 0 && (buffer[bytesize - 1] == byte)\n  back(1)\n  if ((byte === '\\n') && bytesize > 0) && (buffer[bytesize - 1] === '\\r')\n    back(1)\n  end\nend"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L73","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytesize == 0"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L37","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(\"Not implemented\")"}},{"id":"to_s-instance-method","html_id":"to_s-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L99","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @finished\n  raise(\"Can only invoke 'to_s' once on String::Builder\")\nend\n@finished = true\nwrite_byte(0_u8)\nreal_bytesize = real_bytesize()\nif @capacity > real_bytesize\n  resize_to_capacity(real_bytesize)\nend\nheader = @buffer.as(::Pointer(::Tuple(Int32, Int32, Int32)))\nheader.value = {String::TYPE_ID, @bytesize - 1, 0}\n@buffer.as(String)\n"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":null,"summary":null,"abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L41","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if slice.empty?\n  return\nend\ncount = slice.size\nnew_bytesize = real_bytesize + count\nif new_bytesize > @capacity\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\nslice.copy_to(@buffer + real_bytesize, count)\n@bytesize = @bytesize + count\nnil\n"}},{"id":"write_byte(byte:UInt8)-instance-method","html_id":"write_byte(byte:UInt8)-instance-method","name":"write_byte","doc":null,"summary":null,"abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string/builder.cr#L56","def":{"name":"write_byte","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_bytesize = real_bytesize + 1\nif new_bytesize > @capacity\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\n@buffer[real_bytesize] = byte\n@bytesize = @bytesize + 1\nnil\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/String/RawConverter","path":"String/RawConverter.html","kind":"module","full_name":"String::RawConverter","name":"RawConverter","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/from_json.cr","line_number":264,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr"},{"filename":"json/to_json.cr","line_number":205,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/String","kind":"class","full_name":"String","name":"String"},"doc":"Converter to be used with `JSON.mapping` to read the raw\nvalue of a JSON object property as a `String`.\n\nIt can be useful to read ints and floats without losing precision,\nor to read an object and deserialize it later based on some\ncondition.\n\n```\nrequire \"json\"\n\nclass Raw\n  JSON.mapping({\n    value: {type: String, converter: String::RawConverter},\n  })\nend\n\nraw = Raw.from_json(%({\"value\": 123456789876543212345678987654321}))\nraw.value   # => \"123456789876543212345678987654321\"\nraw.to_json # => %({\"value\":123456789876543212345678987654321})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON.html#mapping-macro\">JSON.mapping</a></code> to read the raw value of a JSON object property as a <code><a href=\"../String.html\">String</a></code>.</p>","class_methods":[{"id":"from_json(value:JSON::PullParser)-class-method","html_id":"from_json(value:JSON::PullParser)-class-method","name":"from_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L265","def":{"name":"from_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.read_raw"}},{"id":"to_json(value:String,json:JSON::Builder)-class-method","html_id":"to_json(value:String,json:JSON::Builder)-class-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : String, json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L206","def":{"name":"to_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.raw(value)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/StringPool","path":"StringPool.html","kind":"class","full_name":"StringPool","name":"StringPool","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"string_pool.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A string pool is a collection of strings.\nIt allows a runtime to save memory by preserving strings in a pool, allowing to\nreuse an instance of a common string instead of creating a new one.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\na = \"foo\" + \"bar\"\nb = \"foo\" + \"bar\"\na.object_id # => 136294360\nb.object_id # => 136294336\na = pool.get(a)\nb = pool.get(b)\na.object_id # => 136294312\nb.object_id # => 136294312\n```","summary":"<p>A string pool is a collection of strings.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":"Creates a new empty string pool.","summary":"<p>Creates a new empty string pool.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L34","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if the `StringPool` has no element otherwise returns `false`.\n\n```\npool = StringPool.new\npool.empty? # => true\npool.get(\"crystal\")\npool.empty? # => false\n```","summary":"<p>Returns <code>true</code> if the <code><a href=\"StringPool.html\">StringPool</a></code> has no element otherwise returns <code>false</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L49","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@size == 0"}},{"id":"get(str:Pointer(UInt8),len)-instance-method","html_id":"get(str:Pointer(UInt8),len)-instance-method","name":"get","doc":"Returns a `String` with the contents given by the pointer *str* of size *len*.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\npool = StringPool.new\npool.get(\"hey\".to_unsafe, 3)\npool.size # => 1\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents given by the pointer <em>str</em> of size <em>len</em>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"::Pointer(UInt8)"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"args_string":"(str : Pointer(UInt8), len)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L80","def":{"name":"get","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"::Pointer(UInt8)"},{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hash = hash(str, len)\nget(hash, str, len)\n"}},{"id":"get(slice:Bytes)-instance-method","html_id":"get(slice:Bytes)-instance-method","name":"get","doc":"Returns a `String` with the contents of the given *slice*.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\npool = StringPool.new\nptr = Pointer.malloc(9) { |i| ('a'.ord + i).to_u8 }\nslice = Slice.new(ptr, 3)\npool.empty? # => true\npool.get(slice)\npool.empty? # => false\n ```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L66","def":{"name":"get","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"get(slice.pointer(slice.size), slice.size)"}},{"id":"get(str:IO::Memory)-instance-method","html_id":"get(str:IO::Memory)-instance-method","name":"get","doc":"Returns a `String` with the contents of the given `IO::Memory`.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\npool = StringPool.new\nio = IO::Memory.new \"crystal\"\npool.empty? # => true\npool.get(io)\npool.empty? # => false\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given <code><a href=\"IO/Memory.html\">IO::Memory</a></code>.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"IO::Memory"}],"args_string":"(str : IO::Memory)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L133","def":{"name":"get","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"IO::Memory"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"get(str.buffer, str.bytesize)"}},{"id":"get(str:String)-instance-method","html_id":"get(str:String)-instance-method","name":"get","doc":"Returns a `String` with the contents of the given string.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\npool = StringPool.new\nstring = \"crystal\"\npool.empty? # => true\npool.get(string)\npool.empty? # => false\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given string.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L149","def":{"name":"get","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"get(str.to_unsafe, str.bytesize)"}},{"id":"rehash-instance-method","html_id":"rehash-instance-method","name":"rehash","doc":"Rebuilds the hash based on the current hash values for each key,\nif values of key objects have changed since they were inserted.\n\nCall this method if you modified a string submitted to the pool.","summary":"<p>Rebuilds the hash based on the current hash values for each key, if values of key objects have changed since they were inserted.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L157","def":{"name":"rehash","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (@capacity * 2) <= 0\n  raise(\"Hash table too big\")\nend\nold_capacity = @capacity\nold_hashes = @hashes\nold_values = @values\n@capacity = @capacity * 2\n@hashes = Pointer(UInt64).malloc(@capacity, 0_u64)\n@values = Pointer(String).malloc(@capacity, \"\")\nold_capacity.times do |i|\n  if old_hashes[i] != 0\n    put_on_rehash(old_hashes[i], old_values[i])\n  end\nend\n"}},{"id":"size:Int32-instance-method","html_id":"size:Int32-instance-method","name":"size","doc":"Returns the size\n\n```\npool = StringPool.new\npool.size # => 0\n```","summary":"<p>Returns the size</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_pool.cr#L31","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@size"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/StringScanner","path":"StringScanner.html","kind":"class","full_name":"StringScanner","name":"StringScanner","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"string_scanner.cr","line_number":61,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"`StringScanner` provides for lexical scanning operations on a `String`.\n\n### Example\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"This is an example string\")\ns.eos? # => false\n\ns.scan(/\\w+/) # => \"This\"\ns.scan(/\\w+/) # => nil\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\s+/) # => nil\ns.scan(/\\w+/) # => \"is\"\ns.eos?        # => false\n\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"an\"\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"example\"\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"string\"\ns.eos?        # => true\n\ns.scan(/\\s+/) # => nil\ns.scan(/\\w+/) # => nil\n```\n\nScanning a string means remembering the position of a _scan offset_, which is\njust an index. Scanning moves the offset forward, and matches are sought\nafter the offset; usually immediately after it.\n\n### Method Categories\n\nMethods that advance the scan offset:\n* `#scan`\n* `#scan_until`\n* `#skip`\n* `#skip_until`\n\nMethods that look ahead:\n* `#peek`\n* `#check`\n* `#check_until`\n\nMethods that deal with the position of the offset:\n* `#offset`\n* `#offset=`\n* `#eos?`\n* `#reset`\n* `#terminate`\n\nMethods that deal with the last match:\n* `#[]`\n* `#[]?`\n\nMiscellaneous methods:\n* `#inspect`\n* `#string`","summary":"<p><code><a href=\"StringScanner.html\">StringScanner</a></code> provides for lexical scanning operations on a <code><a href=\"String.html\">String</a></code>.</p>","class_methods":[],"constructors":[{"id":"new(str:String)-class-method","html_id":"new(str:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L64","def":{"name":"new","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"[](n)-instance-method","html_id":"[](n)-instance-method","name":"[]","doc":"Returns the *n*-th subgroup in the most recent match.\n\nRaises an exception if there was no last match or if there is no subgroup.\n\n```\ns = StringScanner.new(\"Fri Dec 12 1975 14:39\")\nregex = /(?<wday>\\w+) (?<month>\\w+) (?<day>\\d+)/\ns.scan(regex) # => \"Fri Dec 12\"\ns[0]          # => \"Fri Dec 12\"\ns[1]          # => \"Fri\"\ns[2]          # => \"Dec\"\ns[3]          # => \"12\"\ns[\"wday\"]     # => \"Fri\"\ns[\"month\"]    # => \"Dec\"\ns[\"day\"]      # => \"12\"\n```","summary":"<p>Returns the <em>n</em>-th subgroup in the most recent match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L193","def":{"name":"[]","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last_match.not_nil![n]"}},{"id":"[]?(n)-instance-method","html_id":"[]?(n)-instance-method","name":"[]?","doc":"Returns the nilable *n*-th subgroup in the most recent match.\n\nReturns `nil` if there was no last match or if there is no subgroup.\n\n```\ns = StringScanner.new(\"Fri Dec 12 1975 14:39\")\nregex = /(?<wday>\\w+) (?<month>\\w+) (?<day>\\d+)/\ns.scan(regex)  # => \"Fri Dec 12\"\ns[0]?          # => \"Fri Dec 12\"\ns[1]?          # => \"Fri\"\ns[2]?          # => \"Dec\"\ns[3]?          # => \"12\"\ns[4]?          # => nil\ns[\"wday\"]?     # => \"Fri\"\ns[\"month\"]?    # => \"Dec\"\ns[\"day\"]?      # => \"12\"\ns[\"year\"]?     # => nil\ns.scan(/more/) # => nil\ns[0]?          # => nil\n```","summary":"<p>Returns the nilable <em>n</em>-th subgroup in the most recent match.</p>","abstract":false,"args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"args_string":"(n)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L217","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L217","def":{"name":"[]?","args":[{"name":"n","doc":null,"default_value":"","external_name":"n","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last_match.try(&.[]?(n))"}},{"id":"check(pattern)-instance-method","html_id":"check(pattern)-instance-method","name":"check","doc":"Returns the value that `#scan` would return, without advancing the scan\noffset. The last match is still saved, however.\n\n```\ns = StringScanner.new(\"this is a string\")\ns.offset = 5\ns.check(/\\w+/) # => \"is\"\ns.check(/\\w+/) # => \"is\"\n```","summary":"<p>Returns the value that <code><a href=\"StringScanner.html#scan%28pattern%29-instance-method\">#scan</a></code> would return, without advancing the scan offset.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L161","def":{"name":"check","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match(pattern, advance: false, options: Regex::Options::ANCHORED)"}},{"id":"check_until(pattern)-instance-method","html_id":"check_until(pattern)-instance-method","name":"check_until","doc":"Returns the value that `#scan_until` would return, without advancing the\nscan offset. The last match is still saved, however.\n\n```\ns = StringScanner.new(\"test string\")\ns.check_until(/tr/) # => \"test str\"\ns.check_until(/g/)  # => \"test string\"\n```","summary":"<p>Returns the value that <code><a href=\"StringScanner.html#scan_until%28pattern%29-instance-method\">#scan_until</a></code> would return, without advancing the scan offset.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L173","def":{"name":"check_until","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match(pattern, advance: false, options: Regex::Options::None)"}},{"id":"eos?-instance-method","html_id":"eos?-instance-method","name":"eos?","doc":"Returns `true` if the scan offset is at the end of the string.\n\n```\ns = StringScanner.new(\"this is a string\")\ns.eos?                # => false\ns.scan(/(\\w+\\s?){4}/) # => \"this is a string\"\ns.eos?                # => true\n```","summary":"<p>Returns <code>true</code> if the scan offset is at the end of the string.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L229","def":{"name":"eos?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@byte_offset >= @str.bytesize"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Writes a representation of the scanner.\n\nIncludes the current position of the offset, the total size of the string,\nand five characters near the current position.","summary":"<p>Writes a representation of the scanner.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L271","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<StringScanner \"\noffset = offset()\n((io << offset) << '/') << @str.size\nstart = Math.min(Math.max(offset - 2, 0), Math.max(0, @str.size - 5))\n((io << \" \\\"\") << @str[start, 5]) << \"\\\" >\"\n"}},{"id":"offset-instance-method","html_id":"offset-instance-method","name":"offset","doc":"Returns the current position of the scan offset.","summary":"<p>Returns the current position of the scan offset.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L75","def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@str.byte_index_to_char_index(@byte_offset)).not_nil!"}},{"id":"offset=(position:Int)-instance-method","html_id":"offset=(position:Int)-instance-method","name":"offset=","doc":"Sets the *position* of the scan offset.","summary":"<p>Sets the <em>position</em> of the scan offset.</p>","abstract":false,"args":[{"name":"position","doc":null,"default_value":"","external_name":"position","restriction":"Int"}],"args_string":"(position : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L69","def":{"name":"offset=","args":[{"name":"position","doc":null,"default_value":"","external_name":"position","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if position >= 0\nelse\n  raise(IndexError.new)\nend\n@byte_offset = (@str.char_index_to_byte_index(position)) || @str.bytesize\n"}},{"id":"peek(len)-instance-method","html_id":"peek(len)-instance-method","name":"peek","doc":"Extracts a string corresponding to string[offset,*len*], without advancing\nthe scan offset.","summary":"<p>Extracts a string corresponding to string[offset,<em>len</em>], without advancing the scan offset.</p>","abstract":false,"args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"args_string":"(len)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L252","def":{"name":"peek","args":[{"name":"len","doc":null,"default_value":"","external_name":"len","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@str[offset, len]"}},{"id":"reset-instance-method","html_id":"reset-instance-method","name":"reset","doc":"Resets the scan offset to the beginning and clears the last match.","summary":"<p>Resets the scan offset to the beginning and clears the last match.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L234","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L234","def":{"name":"reset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last_match = nil\n@byte_offset = 0\n"}},{"id":"rest-instance-method","html_id":"rest-instance-method","name":"rest","doc":"Returns the remainder of the string after the scan offset.\n\n```\ns = StringScanner.new(\"this is a string\")\ns.scan(/(\\w+\\s?){2}/) # => \"this is \"\ns.rest                # => \"a string\"\n```","summary":"<p>Returns the remainder of the string after the scan offset.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L263","def":{"name":"rest","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@str.byte_slice(@byte_offset, @str.bytesize - @byte_offset)"}},{"id":"scan(pattern)-instance-method","html_id":"scan(pattern)-instance-method","name":"scan","doc":"Tries to match with *pattern* at the current position. If there's a match,\nthe scanner advances the scan offset, the last match is saved, and it\nreturns the matched string. Otherwise, the scanner returns `nil`.\n\n```\ns = StringScanner.new(\"test string\")\ns.scan(/\\w+/)   # => \"test\"\ns.scan(/\\w+/)   # => nil\ns.scan(/\\s\\w+/) # => \" string\"\ns.scan(/.*/)    # => \"\"\n```","summary":"<p>Tries to match with <em>pattern</em> at the current position.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L90","def":{"name":"scan","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match(pattern, advance: true, options: Regex::Options::ANCHORED)"}},{"id":"scan_until(pattern)-instance-method","html_id":"scan_until(pattern)-instance-method","name":"scan_until","doc":"Scans the string _until_ the *pattern* is matched. Returns the substring up\nto and including the end of the match, the last match is saved, and\nadvances the scan offset. Returns `nil` if no match.\n\n```\ns = StringScanner.new(\"test string\")\ns.scan_until(/tr/) # => \"test str\"\ns.scan_until(/tr/) # => nil\ns.scan_until(/g/)  # => \"ing\"\n```","summary":"<p>Scans the string <em>until</em> the <em>pattern</em> is matched.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L104","def":{"name":"scan_until","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match(pattern, advance: true, options: Regex::Options::None)"}},{"id":"skip(pattern)-instance-method","html_id":"skip(pattern)-instance-method","name":"skip","doc":"Attempts to skip over the given *pattern* beginning with the scan offset.\nIn other words, the pattern is not anchored to the current scan offset.\n\nIf there's a match, the scanner advances the scan offset, the last match is\nsaved, and it returns the size of the skipped match. Otherwise it returns\n`nil` and does not advance the offset.\n\nThis method is the same as `#scan`, but without returning the matched\nstring.","summary":"<p>Attempts to skip over the given <em>pattern</em> beginning with the scan offset.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L131","def":{"name":"skip","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = scan(pattern)\nif match\n  match.size\nend\n"}},{"id":"skip_until(pattern)-instance-method","html_id":"skip_until(pattern)-instance-method","name":"skip_until","doc":"Attempts to skip _until_ the given *pattern* is found after the scan\noffset. In other words, the pattern is not anchored to the current scan\noffset.\n\nIf there's a match, the scanner advances the scan offset, the last match is\nsaved, and it returns the size of the skip. Otherwise it returns `nil`\nand does not advance the\noffset.\n\nThis method is the same as `#scan_until`, but without returning the matched\nstring.","summary":"<p>Attempts to skip <em>until</em> the given <em>pattern</em> is found after the scan offset.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"args_string":"(pattern)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L147","def":{"name":"skip_until","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"match = scan_until(pattern)\nif match\n  match.size\nend\n"}},{"id":"string:String-instance-method","html_id":"string:String-instance-method","name":"string","doc":"Returns the string being scanned.","summary":"<p>Returns the string being scanned.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L246","def":{"name":"string","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@str"}},{"id":"terminate-instance-method","html_id":"terminate-instance-method","name":"terminate","doc":"Moves the scan offset to the end of the string and clears the last match.","summary":"<p>Moves the scan offset to the end of the string and clears the last match.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/string_scanner.cr#L240","def":{"name":"terminate","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@last_match = nil\n@byte_offset = @str.bytesize\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Struct","path":"Struct.html","kind":"struct","full_name":"Struct","name":"Struct","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"struct.cr","line_number":45,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Atomic","kind":"struct","full_name":"Atomic(T)","name":"Atomic"},{"html_id":"github.com/crystal-lang/crystal/BitArray","kind":"struct","full_name":"BitArray","name":"BitArray"},{"html_id":"github.com/crystal-lang/crystal/CallStack/RepeatedFrame","kind":"struct","full_name":"CallStack::RepeatedFrame","name":"RepeatedFrame"},{"html_id":"github.com/crystal-lang/crystal/Channel/ReceiveAction","kind":"struct","full_name":"Channel::ReceiveAction(C)","name":"ReceiveAction"},{"html_id":"github.com/crystal-lang/crystal/Channel/SendAction","kind":"struct","full_name":"Channel::SendAction(C, T)","name":"SendAction"},{"html_id":"github.com/crystal-lang/crystal/Char/Reader","kind":"struct","full_name":"Char::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/Colorize/Color256","kind":"struct","full_name":"Colorize::Color256","name":"Color256"},{"html_id":"github.com/crystal-lang/crystal/Colorize/ColorRGB","kind":"struct","full_name":"Colorize::ColorRGB","name":"ColorRGB"},{"html_id":"github.com/crystal-lang/crystal/Colorize/Object","kind":"struct","full_name":"Colorize::Object(T)","name":"Object"},{"html_id":"github.com/crystal-lang/crystal/Complex","kind":"struct","full_name":"Complex","name":"Complex"},{"html_id":"github.com/crystal-lang/crystal/CSV/Builder/Row","kind":"struct","full_name":"CSV::Builder::Row","name":"Row"},{"html_id":"github.com/crystal-lang/crystal/CSV/Row","kind":"struct","full_name":"CSV::Row","name":"Row"},{"html_id":"github.com/crystal-lang/crystal/CSV/Token","kind":"struct","full_name":"CSV::Token","name":"Token"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Abbrev","kind":"struct","full_name":"Debug::DWARF::Abbrev","name":"Abbrev"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Abbrev/Attribute","kind":"struct","full_name":"Debug::DWARF::Abbrev::Attribute","name":"Attribute"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Info","kind":"struct","full_name":"Debug::DWARF::Info","name":"Info"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers","kind":"struct","full_name":"Debug::DWARF::LineNumbers","name":"LineNumbers"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Register","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Register","name":"Register"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Row","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Row","name":"Row"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/LineNumbers/Sequence","kind":"struct","full_name":"Debug::DWARF::LineNumbers::Sequence","name":"Sequence"},{"html_id":"github.com/crystal-lang/crystal/Debug/DWARF/Strings","kind":"struct","full_name":"Debug::DWARF::Strings","name":"Strings"},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF","kind":"struct","full_name":"Debug::ELF","name":"ELF"},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/Ident","kind":"struct","full_name":"Debug::ELF::Ident","name":"Ident"},{"html_id":"github.com/crystal-lang/crystal/Debug/ELF/SectionHeader","kind":"struct","full_name":"Debug::ELF::SectionHeader","name":"SectionHeader"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/ConstantDirectory","kind":"struct","full_name":"Dir::Globber::ConstantDirectory","name":"ConstantDirectory"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/ConstantEntry","kind":"struct","full_name":"Dir::Globber::ConstantEntry","name":"ConstantEntry"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/DirectoriesOnly","kind":"struct","full_name":"Dir::Globber::DirectoriesOnly","name":"DirectoriesOnly"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/DirectoryMatch","kind":"struct","full_name":"Dir::Globber::DirectoryMatch","name":"DirectoryMatch"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/EntryMatch","kind":"struct","full_name":"Dir::Globber::EntryMatch","name":"EntryMatch"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/RecursiveDirectories","kind":"struct","full_name":"Dir::Globber::RecursiveDirectories","name":"RecursiveDirectories"},{"html_id":"github.com/crystal-lang/crystal/Dir/Globber/RootDirectory","kind":"struct","full_name":"Dir::Globber::RootDirectory","name":"RootDirectory"},{"html_id":"github.com/crystal-lang/crystal/Enumerable/Chunk/Alone","kind":"struct","full_name":"Enumerable::Chunk::Alone","name":"Alone"},{"html_id":"github.com/crystal-lang/crystal/Enumerable/Chunk/Drop","kind":"struct","full_name":"Enumerable::Chunk::Drop","name":"Drop"},{"html_id":"github.com/crystal-lang/crystal/Event/DnsBase","kind":"struct","full_name":"Event::DnsBase","name":"DnsBase"},{"html_id":"github.com/crystal-lang/crystal/Event/DnsBase/GetAddrInfoRequest","kind":"struct","full_name":"Event::DnsBase::GetAddrInfoRequest","name":"GetAddrInfoRequest"},{"html_id":"github.com/crystal-lang/crystal/File/Info","kind":"struct","full_name":"File::Info","name":"Info"},{"html_id":"github.com/crystal-lang/crystal/Float/Printer/CachedPowers/Power","kind":"struct","full_name":"Float::Printer::CachedPowers::Power","name":"Power"},{"html_id":"github.com/crystal-lang/crystal/Float/Printer/DiyFP","kind":"struct","full_name":"Float::Printer::DiyFP","name":"DiyFP"},{"html_id":"github.com/crystal-lang/crystal/GC/Stats","kind":"struct","full_name":"GC::Stats","name":"Stats"},{"html_id":"github.com/crystal-lang/crystal/HTTP/ComputedContentTypeHeader","kind":"struct","full_name":"HTTP::ComputedContentTypeHeader","name":"ComputedContentTypeHeader"},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/FileMetadata","kind":"struct","full_name":"HTTP::FormData::FileMetadata","name":"FileMetadata"},{"html_id":"github.com/crystal-lang/crystal/HTTP/FormData/Part","kind":"struct","full_name":"HTTP::FormData::Part","name":"Part"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Headers","kind":"struct","full_name":"HTTP::Headers","name":"Headers"},{"html_id":"github.com/crystal-lang/crystal/HTTP/Params","kind":"struct","full_name":"HTTP::Params","name":"Params"},{"html_id":"github.com/crystal-lang/crystal/HTTP/StaticFileHandler/DirectoryListing","kind":"struct","full_name":"HTTP::StaticFileHandler::DirectoryListing","name":"DirectoryListing"},{"html_id":"github.com/crystal-lang/crystal/HTTP/WebSocket/Protocol/PacketInfo","kind":"struct","full_name":"HTTP::WebSocket::Protocol::PacketInfo","name":"PacketInfo"},{"html_id":"github.com/crystal-lang/crystal/IO/EncodingOptions","kind":"struct","full_name":"IO::EncodingOptions","name":"EncodingOptions"},{"html_id":"github.com/crystal-lang/crystal/JSON/Any","kind":"struct","full_name":"JSON::Any","name":"Any"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/ArrayState","kind":"struct","full_name":"JSON::Builder::ArrayState","name":"ArrayState"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/DocumentEndState","kind":"struct","full_name":"JSON::Builder::DocumentEndState","name":"DocumentEndState"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/DocumentStartState","kind":"struct","full_name":"JSON::Builder::DocumentStartState","name":"DocumentStartState"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/ObjectState","kind":"struct","full_name":"JSON::Builder::ObjectState","name":"ObjectState"},{"html_id":"github.com/crystal-lang/crystal/JSON/Builder/StartState","kind":"struct","full_name":"JSON::Builder::StartState","name":"StartState"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ABI/ArgType","kind":"struct","full_name":"LLVM::ABI::ArgType","name":"ArgType"},{"html_id":"github.com/crystal-lang/crystal/LLVM/BasicBlock","kind":"struct","full_name":"LLVM::BasicBlock","name":"BasicBlock"},{"html_id":"github.com/crystal-lang/crystal/LLVM/BasicBlockCollection","kind":"struct","full_name":"LLVM::BasicBlockCollection","name":"BasicBlockCollection"},{"html_id":"github.com/crystal-lang/crystal/LLVM/DIBuilder","kind":"struct","full_name":"LLVM::DIBuilder","name":"DIBuilder"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Function","kind":"struct","full_name":"LLVM::Function","name":"Function"},{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionCollection","kind":"struct","full_name":"LLVM::FunctionCollection","name":"FunctionCollection"},{"html_id":"github.com/crystal-lang/crystal/LLVM/FunctionPassManager/Runner","kind":"struct","full_name":"LLVM::FunctionPassManager::Runner","name":"Runner"},{"html_id":"github.com/crystal-lang/crystal/LLVM/GlobalCollection","kind":"struct","full_name":"LLVM::GlobalCollection","name":"GlobalCollection"},{"html_id":"github.com/crystal-lang/crystal/LLVM/InstructionCollection","kind":"struct","full_name":"LLVM::InstructionCollection","name":"InstructionCollection"},{"html_id":"github.com/crystal-lang/crystal/LLVM/OperandBundleDef","kind":"struct","full_name":"LLVM::OperandBundleDef","name":"OperandBundleDef"},{"html_id":"github.com/crystal-lang/crystal/LLVM/ParameterCollection","kind":"struct","full_name":"LLVM::ParameterCollection","name":"ParameterCollection"},{"html_id":"github.com/crystal-lang/crystal/LLVM/PassRegistry","kind":"struct","full_name":"LLVM::PassRegistry","name":"PassRegistry"},{"html_id":"github.com/crystal-lang/crystal/LLVM/PhiTable","kind":"struct","full_name":"LLVM::PhiTable","name":"PhiTable"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Target","kind":"struct","full_name":"LLVM::Target","name":"Target"},{"html_id":"github.com/crystal-lang/crystal/LLVM/TargetData","kind":"struct","full_name":"LLVM::TargetData","name":"TargetData"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Type","kind":"struct","full_name":"LLVM::Type","name":"Type"},{"html_id":"github.com/crystal-lang/crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/CodeFence","kind":"struct","full_name":"Markdown::Parser::CodeFence","name":"CodeFence"},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/PrefixHeader","kind":"struct","full_name":"Markdown::Parser::PrefixHeader","name":"PrefixHeader"},{"html_id":"github.com/crystal-lang/crystal/Markdown/Parser/UnorderedList","kind":"struct","full_name":"Markdown::Parser::UnorderedList","name":"UnorderedList"},{"html_id":"github.com/crystal-lang/crystal/Pointer/Appender","kind":"struct","full_name":"Pointer::Appender(T)","name":"Appender"},{"html_id":"github.com/crystal-lang/crystal/Process/Tms","kind":"struct","full_name":"Process::Tms","name":"Tms"},{"html_id":"github.com/crystal-lang/crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"github.com/crystal-lang/crystal/Reflect","kind":"struct","full_name":"Reflect(X)","name":"Reflect"},{"html_id":"github.com/crystal-lang/crystal/Regex/MatchData","kind":"struct","full_name":"Regex::MatchData","name":"MatchData"},{"html_id":"github.com/crystal-lang/crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"},{"html_id":"github.com/crystal-lang/crystal/Slice","kind":"struct","full_name":"Slice(T)","name":"Slice"},{"html_id":"github.com/crystal-lang/crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"github.com/crystal-lang/crystal/Socket/Addrinfo","kind":"struct","full_name":"Socket::Addrinfo","name":"Addrinfo"},{"html_id":"github.com/crystal-lang/crystal/String/Formatter/Flags","kind":"struct","full_name":"String::Formatter::Flags","name":"Flags"},{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},{"html_id":"github.com/crystal-lang/crystal/Time/Location/Zone","kind":"struct","full_name":"Time::Location::Zone","name":"Zone"},{"html_id":"github.com/crystal-lang/crystal/Time/MonthSpan","kind":"struct","full_name":"Time::MonthSpan","name":"MonthSpan"},{"html_id":"github.com/crystal-lang/crystal/Time/Span","kind":"struct","full_name":"Time::Span","name":"Span"},{"html_id":"github.com/crystal-lang/crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},{"html_id":"github.com/crystal-lang/crystal/VaList","kind":"struct","full_name":"VaList","name":"VaList"},{"html_id":"github.com/crystal-lang/crystal/XML/Attributes","kind":"struct","full_name":"XML::Attributes","name":"Attributes"},{"html_id":"github.com/crystal-lang/crystal/XML/Builder","kind":"struct","full_name":"XML::Builder","name":"Builder"},{"html_id":"github.com/crystal-lang/crystal/XML/Namespace","kind":"struct","full_name":"XML::Namespace","name":"Namespace"},{"html_id":"github.com/crystal-lang/crystal/XML/Node","kind":"struct","full_name":"XML::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/XML/NodeSet","kind":"struct","full_name":"XML::NodeSet","name":"NodeSet"},{"html_id":"github.com/crystal-lang/crystal/XML/Reader","kind":"struct","full_name":"XML::Reader","name":"Reader"},{"html_id":"github.com/crystal-lang/crystal/XML/XPathContext","kind":"struct","full_name":"XML::XPathContext","name":"XPathContext"},{"html_id":"github.com/crystal-lang/crystal/YAML/Any","kind":"struct","full_name":"YAML::Any","name":"Any"}],"including_types":[],"namespace":null,"doc":"`Struct` is the base type of structs you create in your program.\nIt is set as a struct's superstruct when you don't specify one:\n\n```\nstruct Foo # < Struct\nend\n```\n\nStructs inherit from `Value` so they are allocated on the stack and passed\nby value. For this reason you should prefer using structs for immutable\ndata types and/or stateless wrappers of other types.\n\nMutable structs are still allowed, but code involving them must remember\nthat passing a struct to a method actually passes a copy to it, so the\nmethod should return the modified struct:\n\n```\nstruct Mutable\n  property value\n\n  def initialize(@value : Int32)\n  end\nend\n\ndef change_bad(mutable)\n  mutable.value = 2\nend\n\ndef change_good(mutable)\n  mutable.value = 2\n  mutable\nend\n\nmut = Mutable.new 1\nchange_bad(mut)\nmut.value # => 1\n\nmut = change_good(mut)\nmut.value # => 2\n```\n\nThe standard library provides a useful `record` macro that allows you to\ncreate immutable structs with some fields, similar to a `Tuple` but using\nnames instead of indices.","summary":"<p><code><a href=\"Struct.html\">Struct</a></code> is the base type of structs you create in your program.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"==(other):Bool-instance-method","html_id":"==(other):Bool-instance-method","name":"==","doc":"Returns `true` if this struct is equal to *other*.\n\nBoth structs's instance vars are compared to each other. Thus, two\nstructs are considered equal if each of their instance variables are\nequal. Subclasses should override this method to provide specific\nequality semantics.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np2 = Point.new 1, 2\np3 = Point.new 3, 4\n\np1 == p2 # => true\np1 == p3 # => false\n```","summary":"<p>Returns <code>true</code> if this struct is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L66","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if other.is_a?(self)\n  {% for ivar in @type.instance_vars %}\n        return false unless @{{ ivar.id }} == other.@{{ ivar.id }}\n      {% end %}\n  return true\nelse\n  return false\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L79","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for ivar in @type.instance_vars %}\n      hasher = @{{ ivar.id }}.hash(hasher)\n    {% end %}\nhasher\n"}},{"id":"inspect(io:IO):Nil-instance-method","html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L99","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"(io << ({{ @type.name.id.stringify }})) << '('\n{% for ivar, i in @type.instance_vars %}\n      {% if i > 0 %}\n        io << \", \"\n      {% end %}\n      io << \"@{{ ivar.id }}=\"\n      @{{ ivar.id }}.inspect(io)\n    {% end %}\nio << ')'\nnil\n"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L112","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% if @type.overrides?(Struct, \"inspect\") %}\n      pp.text inspect\n    {% else %}\n      prefix = \"#{{{ @type.name.id.stringify }}}(\"\n      pp.surround(prefix, \")\", left_break: \"\", right_break: nil) do\n        {% for ivar, i in @type.instance_vars.map(&.name).sort %}\n          {% if i > 0 %}\n            pp.comma\n          {% end %}\n          pp.group do\n            pp.text \"@{{ ivar.id }}=\"\n            pp.nest do\n              pp.breakable \"\"\n              @{{ ivar.id }}.pretty_print(pp)\n            end\n          end\n        {% end %}\n      end\n    {% end %}"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"Struct.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/struct.cr#L135","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"inspect(io)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Symbol","path":"Symbol.html","kind":"struct","full_name":"Symbol","name":"Symbol","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"primitives.cr","line_number":108,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"symbol.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr"},{"filename":"json/to_json.cr","line_number":57,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":97,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A symbol is a constant that is identified by a name without you having to give\nit a numeric value.\n\n```\n:hello\n:welcome\n:\"123\"\n:\"symbol with spaces\"\n```\n\nInternally a symbol is represented as an `Int32`, so it's very efficient.\n\nYou can't dynamically create symbols. When you compile your program, each symbol\ngets assigned a unique number.","summary":"<p>A symbol is a constant that is identified by a name without you having to give it a numeric value.</p>","class_methods":[{"id":"needs_quotes?(string):Bool-class-method","html_id":"needs_quotes?(string):Bool-class-method","name":"needs_quotes?","doc":"Determines if a string needs to be quoted to be used for a symbol.\n\n```\nSymbol.needs_quotes? \"string\"      # => false\nSymbol.needs_quotes? \"long string\" # => true\n```","summary":"<p>Determines if a string needs to be quoted to be used for a symbol.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L63","def":{"name":"needs_quotes?","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"case string\nwhen \"+\", \"-\", \"*\", \"/\", \"==\", \"<\", \"<=\", \">\", \">=\", \"!\", \"!=\", \"=~\", \"!~\"\nwhen \"&\", \"|\", \"^\", \"~\", \"**\", \">>\", \"<<\", \"%\", \"[]\", \"<=>\", \"===\", \"[]?\", \"[]=\"\nelse\n  string.each_char_with_index do |char, i|\n    if (i == 0) && char.ascii_number?\n      return true\n    end\n    case char\n    when .ascii_alphanumeric?, '_'\n    else\n      return true\n    end\n  end\nend\nfalse\n"}}],"constructors":[],"instance_methods":[{"id":"!=(other:Symbol):Bool-instance-method","html_id":"!=(other:Symbol):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L116","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"(other:Symbol)-instance-method","html_id":"(other:Symbol)-instance-method","name":"<=>","doc":"Compares symbol with other based on `String#<=>` method. Returns `-1`, `0`\nor `+1` depending on whether symbol is less than, equal to,\nor greater than *other*.\n\nSee `String#<=>` for more information.","summary":"<p>Compares symbol with other based on <code><a href=\"String.html#%28other%3Aself%29-instance-method\">String#<=></a></code> method.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L28","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s <=> other.to_s"}},{"id":"==(other:Symbol):Bool-instance-method","html_id":"==(other:Symbol):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L111","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Symbol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L86","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L19","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher.symbol(self)"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Returns the symbol literal representation as a string.\n\n```\n:crystal.inspect # => \":crystal\"\n```","summary":"<p>Returns the symbol literal representation as a string.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L37","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << ':'\nvalue = to_s\nif Symbol.needs_quotes?(value)\n  value.inspect(io)\nelse\n  value.to_s(io)\nend\n"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns a unique number for this symbol.","summary":"<p>Returns a unique number for this symbol.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L121","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L58","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.string(to_s)"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends the symbol's name to the passed `IO`.\n\n```\n:crystal.to_s # => \"crystal\"\n```","summary":"<p>Appends the symbol's name to the passed <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/symbol.cr#L53","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << to_s"}},{"id":"to_s:String-instance-method","html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns the symbol's name as a String.\n\n```\n:foo.to_s           # => \"foo\"\n:\"hello world\".to_s # => \"hello world\"\n```","summary":"<p>Returns the symbol's name as a String.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L131","def":{"name":"to_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"# primitive: symbol_to_s"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L98","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(self)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/System","path":"System.html","kind":"module","full_name":"System","name":"System","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"system.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/system.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"cpu_count-class-method","html_id":"cpu_count-class-method","name":"cpu_count","doc":"Returns the number of logical processors available to the system.\n\n```\nSystem.cpu_count # => 4\n```","summary":"<p>Returns the number of logical processors available to the system.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/system.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/system.cr#L22","def":{"name":"cpu_count","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System.cpu_count"}},{"id":"hostname-class-method","html_id":"hostname-class-method","name":"hostname","doc":"Returns the hostname.\n\nNOTE: Maximum of 253 characters are allowed, with 2 bytes reserved for\nstorage.\nIn practice, many platforms will disallow anything longer than 63 characters.\n\n```\nSystem.hostname # => \"host.example.org\"\n```","summary":"<p>Returns the hostname.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/system.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/system.cr#L13","def":{"name":"hostname","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Crystal::System.hostname"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/TCPServer","path":"TCPServer.html","kind":"class","full_name":"TCPServer","name":"TCPServer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"},{"html_id":"github.com/crystal-lang/crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/tcp_server.cr","line_number":23,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A Transmission Control Protocol (TCP/IP) server.\n\nUsage example:\n```\nrequire \"socket\"\n\ndef handle_client(client)\n  message = client.gets\n  client.puts message\nend\n\nserver = TCPServer.new(\"localhost\", 1234)\nwhile client = server.accept?\n  spawn handle_client(client)\nend\n```\n\nOptions:\n- *backlog* to specify how many pending connections are allowed;\n- *reuse_port* to enable multiple processes to bind to the same port (`SO_REUSEPORT`).","summary":"<p>A Transmission Control Protocol (TCP/IP) server.</p>","class_methods":[{"id":"open(port:Int,backlog=SOMAXCONN,reuse_port=false,&block)-class-method","html_id":"open(port:Int,backlog=SOMAXCONN,reuse_port=false,&amp;block)-class-method","name":"open","doc":"Creates a new TCP server, listening on all interfaces, and yields it to the\nblock. Eventually closes the server socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new TCP server, listening on all interfaces, and yields it to the block.</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(port : Int, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L73","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L73","def":{"name":"open","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"server = new(port, backlog, reuse_port: reuse_port)\nbegin\n  yield server\nensure\n  server.close\nend\n"}},{"id":"open(host,port,backlog=SOMAXCONN,reuse_port=false,&block)-class-method","html_id":"open(host,port,backlog=SOMAXCONN,reuse_port=false,&amp;block)-class-method","name":"open","doc":"Creates a new TCP server and yields it to the block. Eventually closes the\nserver socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new TCP server and yields it to the block.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(host, port, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L60","def":{"name":"open","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"server = new(host, port, backlog, reuse_port: reuse_port)\nbegin\n  yield server\nensure\n  server.close\nend\n"}}],"constructors":[{"id":"new(host:String,port:Int,backlog=SOMAXCONN,dns_timeout=nil,reuse_port=false)-class-method","html_id":"new(host:String,port:Int,backlog=SOMAXCONN,dns_timeout=nil,reuse_port=false)-class-method","name":"new","doc":"Binds a socket to the *host* and *port* combination.","summary":"<p>Binds a socket to the <em>host</em> and <em>port</em> combination.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"dns_timeout","doc":null,"default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(host : String, port : Int, backlog = <span class=\"t\">SOMAXCONN</span>, dns_timeout = <span class=\"n\">nil</span>, reuse_port = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L32","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"dns_timeout","doc":null,"default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(host, port, backlog, dns_timeout, reuse_port)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(family:Family=Family::INET)-class-method","html_id":"new(family:Family=Family::INET)-class-method","name":"new","doc":"Creates a new `TCPServer`, waiting to be bound.","summary":"<p>Creates a new <code><a href=\"TCPServer.html\">TCPServer</a></code>, waiting to be bound.</p>","abstract":false,"args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(family : Family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L27","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"super(family)"}},{"id":"new(port:Int,backlog=SOMAXCONN,reuse_port=false)-class-method","html_id":"new(port:Int,backlog=SOMAXCONN,reuse_port=false)-class-method","name":"new","doc":"Creates a new TCP server, listening on all local interfaces (`::`).","summary":"<p>Creates a new TCP server, listening on all local interfaces (<code>::</code>).</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(port : Int, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L52","def":{"name":"new","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int"},{"name":"backlog","doc":null,"default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","doc":null,"default_value":"false","external_name":"reuse_port","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(\"::\", port, backlog, reuse_port: reuse_port)"}}],"instance_methods":[{"id":"accept?-instance-method","html_id":"accept?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client `TCPSocket` or `nil` if the server is closed after invoking\nthis method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2022)\nloop do\n  if socket = server.accept?\n    # handle the client in a fiber\n    spawn handle_connection(socket)\n  else\n    # another fiber closed the server\n    break\n  end\nend\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_server.cr#L101","def":{"name":"accept?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if client_fd = accept_impl\n  sock = TCPSocket.new(client_fd, family, type, protocol)\n  sock.sync = sync?\n  sock\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/TCPSocket","path":"TCPSocket.html","kind":"class","full_name":"TCPSocket","name":"TCPSocket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/tcp_socket.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/TCPServer","kind":"class","full_name":"TCPServer","name":"TCPServer"}],"including_types":[],"namespace":null,"doc":"A Transmission Control Protocol (TCP/IP) socket.\n\nUsage example:\n```\nrequire \"socket\"\n\nclient = TCPSocket.new(\"localhost\", 1234)\nclient << \"message\\n\"\nresponse = client.gets\nclient.close\n```","summary":"<p>A Transmission Control Protocol (TCP/IP) socket.</p>","class_methods":[{"id":"open(host,port,&block)-class-method","html_id":"open(host,port,&amp;block)-class-method","name":"open","doc":"Opens a TCP socket to a remote TCP server, yields it to the block, then\neventually closes the socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Opens a TCP socket to a remote TCP server, yields it to the block, then eventually closes the socket when the block returns.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""}],"args_string":"(host, port, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L49","def":{"name":"open","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sock = new(host, port)\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}}],"constructors":[{"id":"new(fd:Int32,family:Family,type:Type,protocol:Protocol)-class-method","html_id":"new(fd:Int32,family:Family,type:Type,protocol:Protocol)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"","external_name":"protocol","restriction":"Protocol"}],"args_string":"(fd : Int32, family : Family, type : Type, protocol : Protocol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L41","def":{"name":"new","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"","external_name":"protocol","restriction":"Protocol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(fd, family, type, protocol)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(family:Family,type:Type,protocol:Protocol)-class-method","html_id":"new(family:Family,type:Type,protocol:Protocol)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"","external_name":"protocol","restriction":"Protocol"}],"args_string":"(family : Family, type : Type, protocol : Protocol)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L37","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"protocol","doc":null,"default_value":"","external_name":"protocol","restriction":"Protocol"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(family, type, protocol)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(host,port,dns_timeout=nil,connect_timeout=nil)-class-method","html_id":"new(host,port,dns_timeout=nil,connect_timeout=nil)-class-method","name":"new","doc":"Creates a new TCP connection to a remote TCP server.\n\nYou may limit the DNS resolution time with `dns_timeout` and limit the\nconnection time to the remote server with `connect_timeout`. Both values\nmust be in seconds (integers or floats).\n\nNote that `dns_timeout` is currently ignored.","summary":"<p>Creates a new TCP connection to a remote TCP server.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"dns_timeout","doc":null,"default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"connect_timeout","doc":null,"default_value":"nil","external_name":"connect_timeout","restriction":""}],"args_string":"(host, port, dns_timeout = <span class=\"n\">nil</span>, connect_timeout = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L27","def":{"name":"new","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":""},{"name":"dns_timeout","doc":null,"default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"connect_timeout","doc":null,"default_value":"nil","external_name":"connect_timeout","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(host, port, dns_timeout, connect_timeout)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(family:Family=Family::INET)-class-method","html_id":"new(family:Family=Family::INET)-class-method","name":"new","doc":"Creates a new `TCPSocket`, waiting to be connected.","summary":"<p>Creates a new <code><a href=\"TCPSocket.html\">TCPSocket</a></code>, waiting to be connected.</p>","abstract":false,"args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(family : Family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L16","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"super(family, Type::STREAM, Protocol::TCP)"}}],"instance_methods":[{"id":"tcp_keepalive_count-instance-method","html_id":"tcp_keepalive_count-instance-method","name":"tcp_keepalive_count","doc":"The number of probes sent, without response before dropping the connection.","summary":"<p>The number of probes sent, without response before dropping the connection.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_count","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt(LibC::TCP_KEEPCNT, 0, level: Protocol::TCP)"}},{"id":"tcp_keepalive_count=(val:Int)-instance-method","html_id":"tcp_keepalive_count=(val:Int)-instance-method","name":"tcp_keepalive_count=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_count=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt(LibC::TCP_KEEPCNT, val, level: Protocol::TCP)\nval\n"}},{"id":"tcp_keepalive_idle-instance-method","html_id":"tcp_keepalive_idle-instance-method","name":"tcp_keepalive_idle","doc":"The amount of time in seconds the connection must be idle before sending keepalive probes.","summary":"<p>The amount of time in seconds the connection must be idle before sending keepalive probes.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_idle","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"optname = LibC::TCP_KEEPIDLE\ngetsockopt(optname, 0, level: Protocol::TCP)\n"}},{"id":"tcp_keepalive_idle=(val:Int)-instance-method","html_id":"tcp_keepalive_idle=(val:Int)-instance-method","name":"tcp_keepalive_idle=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_idle=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"optname = LibC::TCP_KEEPIDLE\nsetsockopt(optname, val, level: Protocol::TCP)\nval\n"}},{"id":"tcp_keepalive_interval-instance-method","html_id":"tcp_keepalive_interval-instance-method","name":"tcp_keepalive_interval","doc":"The amount of time in seconds between keepalive probes.","summary":"<p>The amount of time in seconds between keepalive probes.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_interval","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt(LibC::TCP_KEEPINTVL, 0, level: Protocol::TCP)"}},{"id":"tcp_keepalive_interval=(val:Int)-instance-method","html_id":"tcp_keepalive_interval=(val:Int)-instance-method","name":"tcp_keepalive_interval=","doc":null,"summary":null,"abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L68","def":{"name":"tcp_keepalive_interval=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt(LibC::TCP_KEEPINTVL, val, level: Protocol::TCP)\nval\n"}},{"id":"tcp_nodelay=(val:Bool)-instance-method","html_id":"tcp_nodelay=(val:Bool)-instance-method","name":"tcp_nodelay=","doc":"Disable the Nagle algorithm when set to `true`, otherwise enables it.","summary":"<p>Disable the Nagle algorithm when set to <code>true</code>, otherwise enables it.</p>","abstract":false,"args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L64","def":{"name":"tcp_nodelay=","args":[{"name":"val","doc":null,"default_value":"","external_name":"val","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"setsockopt_bool(LibC::TCP_NODELAY, val, level: Protocol::TCP)"}},{"id":"tcp_nodelay?-instance-method","html_id":"tcp_nodelay?-instance-method","name":"tcp_nodelay?","doc":"Returns `true` if the Nable algorithm is disabled.","summary":"<p>Returns <code>true</code> if the Nable algorithm is disabled.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/tcp_socket.cr#L59","def":{"name":"tcp_nodelay?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"getsockopt_bool(LibC::TCP_NODELAY, level: Protocol::TCP)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Tempfile","path":"Tempfile.html","kind":"class","full_name":"Tempfile","name":"Tempfile","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/File","kind":"class","full_name":"File","name":"File"},{"html_id":"github.com/crystal-lang/crystal/Crystal/System/File","kind":"module","full_name":"Crystal::System::File","name":"File"},{"html_id":"github.com/crystal-lang/crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"tempfile.cr","line_number":41,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The `Tempfile` class is for managing temporary files.\nEvery tempfile is operated as a `File`, including\ninitializing, reading and writing.\n\n```\ntempfile = Tempfile.new(\"foo\")\n# or\ntempfile = Tempfile.open(\"foo\") do |file|\n  file.print(\"foobar\")\nend\n\nFile.size(tempfile.path)                   # => 6\nFile.info(tempfile.path).modification_time # => 2015-10-20 13:11:12 UTC\nFile.exists?(tempfile.path)                # => true\nFile.read_lines(tempfile.path)             # => [\"foobar\"]\n```\n\nFiles created from this class are stored in a directory that handles\ntemporary files.\n\n```\nTempfile.new(\"foo\").path # => \"/tmp/foo.ulBCPS\"\n```\n\nAlso, it is encouraged to delete a tempfile after using it, which\nensures they are not left behind in your filesystem until garbage collected.\n\n```\ntempfile = Tempfile.new(\"foo\")\ntempfile.delete\n```\n\nThe optional `extension` argument can be used to force the resulting filename\nto end with the given extension.\n\n```\nTempfile.new(\"foo\", \".png\").path # => \"/tmp/foo.ulBCPS.png\"\n```","summary":"<p>The <code><a href=\"Tempfile.html\">Tempfile</a></code> class is for managing temporary files.</p>","class_methods":[{"id":"dirname:String-class-method","html_id":"dirname:String-class-method","name":"dirname","doc":"Returns the tmp dir used for tempfile.\n\n```\nTempfile.dirname # => \"/tmp\"\n```","summary":"<p>Returns the tmp dir used for tempfile.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L100","def":{"name":"dirname","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"Crystal::System::File.tempdir"}},{"id":"open(filename,extension=nil,&block)-class-method","html_id":"open(filename,extension=nil,&amp;block)-class-method","name":"open","doc":"Creates a file with *filename* and *extension*, and yields it to the given\nblock. It is closed and returned at the end of this method call.\n\n```\ntempfile = Tempfile.open(\"foo\") do |file|\n  file.print(\"bar\")\nend\nFile.read(tempfile.path) # => \"bar\"\n```","summary":"<p>Creates a file with <em>filename</em> and <em>extension</em>, and yields it to the given block.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""}],"args_string":"(filename, extension = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L85","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"tempfile = Tempfile.new(filename, extension)\nbegin\n  yield tempfile\nensure\n  tempfile.close\nend\ntempfile\n"}},{"id":"tempname(extension=nil)-class-method","html_id":"tempname(extension=nil)-class-method","name":"tempname","doc":"Returns a fully-qualified path to a temporary file without actually\ncreating the file.\n\n```\nTempfile.tempname # => \"/tmp/20171206-1234-449386\"\n```\n\nThe optional `extension` argument can be used to make the resulting\nfilename to end with the given extension.\n\n```\nTempfile.tempname(\".sock\") # => \"/tmp/20171206-1234-449386.sock\"\n```","summary":"<p>Returns a fully-qualified path to a temporary file without actually creating the file.</p>","abstract":false,"args":[{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""}],"args_string":"(extension = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L70","def":{"name":"tempname","args":[{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"time = Time.now.to_s(\"%Y%m%d\")\nrand = (Random.rand(4294967296_i64)).to_s(36)\nFile.join(dirname, \"#{time}-#{Process.pid}-#{rand}#{extension}\")\n"}}],"constructors":[{"id":"new(name,extension=nil,encoding=nil,invalid=nil)-class-method","html_id":"new(name,extension=nil,encoding=nil,invalid=nil)-class-method","name":"new","doc":"Creates a `Tempfile` with the given filename and extension.\n\n*encoding* and *invalid* are passed to `IO#set_encoding`.","summary":"<p>Creates a <code><a href=\"Tempfile.html\">Tempfile</a></code> with the given filename and extension.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(name, extension = <span class=\"n\">nil</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L45","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"extension","doc":null,"default_value":"nil","external_name":"extension","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","doc":null,"default_value":"nil","external_name":"invalid","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, extension, encoding, invalid)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"delete-instance-method","html_id":"delete-instance-method","name":"delete","doc":"Deletes this tempfile.","summary":"<p>Deletes this tempfile.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L105","def":{"name":"delete","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"File.delete(@path)"}},{"id":"path:String-instance-method","html_id":"path:String-instance-method","name":"path","doc":"Retrieves the full path of a this tempfile.\n\n```\nTempfile.new(\"foo\").path # => \"/tmp/foo.ulBCPS\"\n```","summary":"<p>Retrieves the full path of a this tempfile.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tempfile.cr#L55","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@path"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios","path":"Termios.html","kind":"module","full_name":"Termios","name":"Termios","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"termios.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Termios/AttributeSelection","path":"Termios/AttributeSelection.html","kind":"enum","full_name":"Termios::AttributeSelection","name":"AttributeSelection","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":123,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"TCSANOW","name":"TCSANOW","value":"0","doc":null,"summary":null},{"id":"TCSADRAIN","name":"TCSADRAIN","value":"1","doc":null,"summary":null},{"id":"TCSAFLUSH","name":"TCSAFLUSH","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L123","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"tcsadrain?-instance-method","html_id":"tcsadrain?-instance-method","name":"tcsadrain?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L125","def":{"name":"tcsadrain?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TCSADRAIN)"}},{"id":"tcsaflush?-instance-method","html_id":"tcsaflush?-instance-method","name":"tcsaflush?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L126","def":{"name":"tcsaflush?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TCSAFLUSH)"}},{"id":"tcsanow?-instance-method","html_id":"tcsanow?-instance-method","name":"tcsanow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L124","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L124","def":{"name":"tcsanow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TCSANOW)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/BaudRate","path":"Termios/BaudRate.html","kind":"enum","full_name":"Termios::BaudRate","name":"BaudRate","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":76,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"B0","name":"B0","value":"0","doc":null,"summary":null},{"id":"B50","name":"B50","value":"1","doc":null,"summary":null},{"id":"B75","name":"B75","value":"2","doc":null,"summary":null},{"id":"B110","name":"B110","value":"3","doc":null,"summary":null},{"id":"B134","name":"B134","value":"4","doc":null,"summary":null},{"id":"B150","name":"B150","value":"5","doc":null,"summary":null},{"id":"B200","name":"B200","value":"6","doc":null,"summary":null},{"id":"B300","name":"B300","value":"7","doc":null,"summary":null},{"id":"B600","name":"B600","value":"8","doc":null,"summary":null},{"id":"B1200","name":"B1200","value":"9","doc":null,"summary":null},{"id":"B1800","name":"B1800","value":"10","doc":null,"summary":null},{"id":"B2400","name":"B2400","value":"11","doc":null,"summary":null},{"id":"B4800","name":"B4800","value":"12","doc":null,"summary":null},{"id":"B9600","name":"B9600","value":"13","doc":null,"summary":null},{"id":"B19200","name":"B19200","value":"14","doc":null,"summary":null},{"id":"B38400","name":"B38400","value":"15","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"b0?-instance-method","html_id":"b0?-instance-method","name":"b0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L77","def":{"name":"b0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B0"}},{"id":"b110?-instance-method","html_id":"b110?-instance-method","name":"b110?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L80","def":{"name":"b110?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B110"}},{"id":"b1200?-instance-method","html_id":"b1200?-instance-method","name":"b1200?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L86","def":{"name":"b1200?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B1200"}},{"id":"b134?-instance-method","html_id":"b134?-instance-method","name":"b134?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L81","def":{"name":"b134?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B134"}},{"id":"b150?-instance-method","html_id":"b150?-instance-method","name":"b150?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L82","def":{"name":"b150?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B150"}},{"id":"b1800?-instance-method","html_id":"b1800?-instance-method","name":"b1800?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L87","def":{"name":"b1800?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B1800"}},{"id":"b19200?-instance-method","html_id":"b19200?-instance-method","name":"b19200?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L91","def":{"name":"b19200?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B19200"}},{"id":"b200?-instance-method","html_id":"b200?-instance-method","name":"b200?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L83","def":{"name":"b200?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B200"}},{"id":"b2400?-instance-method","html_id":"b2400?-instance-method","name":"b2400?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L88","def":{"name":"b2400?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B2400"}},{"id":"b300?-instance-method","html_id":"b300?-instance-method","name":"b300?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L84","def":{"name":"b300?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B300"}},{"id":"b38400?-instance-method","html_id":"b38400?-instance-method","name":"b38400?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L92","def":{"name":"b38400?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B38400"}},{"id":"b4800?-instance-method","html_id":"b4800?-instance-method","name":"b4800?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L89","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L89","def":{"name":"b4800?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B4800"}},{"id":"b50?-instance-method","html_id":"b50?-instance-method","name":"b50?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L78","def":{"name":"b50?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B50"}},{"id":"b600?-instance-method","html_id":"b600?-instance-method","name":"b600?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L85","def":{"name":"b600?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B600"}},{"id":"b75?-instance-method","html_id":"b75?-instance-method","name":"b75?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L79","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L79","def":{"name":"b75?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B75"}},{"id":"b9600?-instance-method","html_id":"b9600?-instance-method","name":"b9600?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L90","def":{"name":"b9600?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == B9600"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/ControlMode","path":"Termios/ControlMode.html","kind":"enum","full_name":"Termios::ControlMode","name":"ControlMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":95,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"CSIZE","name":"CSIZE","value":"48","doc":null,"summary":null},{"id":"CS5","name":"CS5","value":"0","doc":null,"summary":null},{"id":"CS6","name":"CS6","value":"16","doc":null,"summary":null},{"id":"CS7","name":"CS7","value":"32","doc":null,"summary":null},{"id":"CS8","name":"CS8","value":"48","doc":null,"summary":null},{"id":"CSTOPB","name":"CSTOPB","value":"64","doc":null,"summary":null},{"id":"CREAD","name":"CREAD","value":"128","doc":null,"summary":null},{"id":"PARENB","name":"PARENB","value":"256","doc":null,"summary":null},{"id":"PARODD","name":"PARODD","value":"512","doc":null,"summary":null},{"id":"HUPCL","name":"HUPCL","value":"1024","doc":null,"summary":null},{"id":"CLOCAL","name":"CLOCAL","value":"2048","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"clocal?-instance-method","html_id":"clocal?-instance-method","name":"clocal?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L106","def":{"name":"clocal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CLOCAL"}},{"id":"cread?-instance-method","html_id":"cread?-instance-method","name":"cread?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L102","def":{"name":"cread?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CREAD"}},{"id":"cs5?-instance-method","html_id":"cs5?-instance-method","name":"cs5?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L97","def":{"name":"cs5?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CS5"}},{"id":"cs6?-instance-method","html_id":"cs6?-instance-method","name":"cs6?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L98","def":{"name":"cs6?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CS6"}},{"id":"cs7?-instance-method","html_id":"cs7?-instance-method","name":"cs7?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L99","def":{"name":"cs7?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CS7"}},{"id":"cs8?-instance-method","html_id":"cs8?-instance-method","name":"cs8?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L100","def":{"name":"cs8?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CS8"}},{"id":"csize?-instance-method","html_id":"csize?-instance-method","name":"csize?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L96","def":{"name":"csize?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CSIZE"}},{"id":"cstopb?-instance-method","html_id":"cstopb?-instance-method","name":"cstopb?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L101","def":{"name":"cstopb?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CSTOPB"}},{"id":"hupcl?-instance-method","html_id":"hupcl?-instance-method","name":"hupcl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L105","def":{"name":"hupcl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HUPCL"}},{"id":"parenb?-instance-method","html_id":"parenb?-instance-method","name":"parenb?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L103","def":{"name":"parenb?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PARENB"}},{"id":"parodd?-instance-method","html_id":"parodd?-instance-method","name":"parodd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L104","def":{"name":"parodd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PARODD"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/InputMode","path":"Termios/InputMode.html","kind":"enum","full_name":"Termios::InputMode","name":"InputMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"BRKINT","name":"BRKINT","value":"2","doc":null,"summary":null},{"id":"ICRNL","name":"ICRNL","value":"256","doc":null,"summary":null},{"id":"IGNBRK","name":"IGNBRK","value":"1","doc":null,"summary":null},{"id":"IGNCR","name":"IGNCR","value":"128","doc":null,"summary":null},{"id":"IGNPAR","name":"IGNPAR","value":"4","doc":null,"summary":null},{"id":"INLCR","name":"INLCR","value":"64","doc":null,"summary":null},{"id":"INPCK","name":"INPCK","value":"16","doc":null,"summary":null},{"id":"ISTRIP","name":"ISTRIP","value":"32","doc":null,"summary":null},{"id":"IXANY","name":"IXANY","value":"2048","doc":null,"summary":null},{"id":"IXOFF","name":"IXOFF","value":"4096","doc":null,"summary":null},{"id":"IXON","name":"IXON","value":"1024","doc":null,"summary":null},{"id":"PARMRK","name":"PARMRK","value":"8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"brkint?-instance-method","html_id":"brkint?-instance-method","name":"brkint?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L6","def":{"name":"brkint?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(BRKINT)"}},{"id":"icrnl?-instance-method","html_id":"icrnl?-instance-method","name":"icrnl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L7","def":{"name":"icrnl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ICRNL)"}},{"id":"ignbrk?-instance-method","html_id":"ignbrk?-instance-method","name":"ignbrk?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L8","def":{"name":"ignbrk?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNBRK)"}},{"id":"igncr?-instance-method","html_id":"igncr?-instance-method","name":"igncr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L9","def":{"name":"igncr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNCR)"}},{"id":"ignpar?-instance-method","html_id":"ignpar?-instance-method","name":"ignpar?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L10","def":{"name":"ignpar?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNPAR)"}},{"id":"inlcr?-instance-method","html_id":"inlcr?-instance-method","name":"inlcr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L11","def":{"name":"inlcr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(INLCR)"}},{"id":"inpck?-instance-method","html_id":"inpck?-instance-method","name":"inpck?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L12","def":{"name":"inpck?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(INPCK)"}},{"id":"istrip?-instance-method","html_id":"istrip?-instance-method","name":"istrip?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L13","def":{"name":"istrip?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ISTRIP)"}},{"id":"ixany?-instance-method","html_id":"ixany?-instance-method","name":"ixany?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L14","def":{"name":"ixany?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IXANY)"}},{"id":"ixoff?-instance-method","html_id":"ixoff?-instance-method","name":"ixoff?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L15","def":{"name":"ixoff?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IXOFF)"}},{"id":"ixon?-instance-method","html_id":"ixon?-instance-method","name":"ixon?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L16","def":{"name":"ixon?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IXON)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L5","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"parmrk?-instance-method","html_id":"parmrk?-instance-method","name":"parmrk?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L17","def":{"name":"parmrk?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(PARMRK)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/LineControl","path":"Termios/LineControl.html","kind":"enum","full_name":"Termios::LineControl","name":"LineControl","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":129,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"TCSANOW","name":"TCSANOW","value":"0","doc":null,"summary":null},{"id":"TCSADRAIN","name":"TCSADRAIN","value":"1","doc":null,"summary":null},{"id":"TCSAFLUSH","name":"TCSAFLUSH","value":"2","doc":null,"summary":null},{"id":"TCIFLUSH","name":"TCIFLUSH","value":"0","doc":null,"summary":null},{"id":"TCIOFLUSH","name":"TCIOFLUSH","value":"2","doc":null,"summary":null},{"id":"TCOFLUSH","name":"TCOFLUSH","value":"1","doc":null,"summary":null},{"id":"TCIOFF","name":"TCIOFF","value":"2","doc":null,"summary":null},{"id":"TCION","name":"TCION","value":"3","doc":null,"summary":null},{"id":"TCOOFF","name":"TCOOFF","value":"0","doc":null,"summary":null},{"id":"TCOON","name":"TCOON","value":"1","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"tciflush?-instance-method","html_id":"tciflush?-instance-method","name":"tciflush?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L133","def":{"name":"tciflush?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCIFLUSH"}},{"id":"tcioff?-instance-method","html_id":"tcioff?-instance-method","name":"tcioff?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L136","def":{"name":"tcioff?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCIOFF"}},{"id":"tcioflush?-instance-method","html_id":"tcioflush?-instance-method","name":"tcioflush?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L134","def":{"name":"tcioflush?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCIOFLUSH"}},{"id":"tcion?-instance-method","html_id":"tcion?-instance-method","name":"tcion?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L137","def":{"name":"tcion?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCION"}},{"id":"tcoflush?-instance-method","html_id":"tcoflush?-instance-method","name":"tcoflush?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L135","def":{"name":"tcoflush?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCOFLUSH"}},{"id":"tcooff?-instance-method","html_id":"tcooff?-instance-method","name":"tcooff?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L138","def":{"name":"tcooff?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCOOFF"}},{"id":"tcoon?-instance-method","html_id":"tcoon?-instance-method","name":"tcoon?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L139","def":{"name":"tcoon?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCOON"}},{"id":"tcsadrain?-instance-method","html_id":"tcsadrain?-instance-method","name":"tcsadrain?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L131","def":{"name":"tcsadrain?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCSADRAIN"}},{"id":"tcsaflush?-instance-method","html_id":"tcsaflush?-instance-method","name":"tcsaflush?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L132","def":{"name":"tcsaflush?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCSAFLUSH"}},{"id":"tcsanow?-instance-method","html_id":"tcsanow?-instance-method","name":"tcsanow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L130","def":{"name":"tcsanow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TCSANOW"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/LocalMode","path":"Termios/LocalMode.html","kind":"enum","full_name":"Termios::LocalMode","name":"LocalMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":110,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ECHO","name":"ECHO","value":"8_i64","doc":null,"summary":null},{"id":"ECHOE","name":"ECHOE","value":"16_i64","doc":null,"summary":null},{"id":"ECHOK","name":"ECHOK","value":"32_i64","doc":null,"summary":null},{"id":"ECHONL","name":"ECHONL","value":"64_i64","doc":null,"summary":null},{"id":"ICANON","name":"ICANON","value":"2_i64","doc":null,"summary":null},{"id":"IEXTEN","name":"IEXTEN","value":"32768_i64","doc":null,"summary":null},{"id":"ISIG","name":"ISIG","value":"1_i64","doc":null,"summary":null},{"id":"NOFLSH","name":"NOFLSH","value":"128_i64","doc":null,"summary":null},{"id":"TOSTOP","name":"TOSTOP","value":"256_i64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"echo?-instance-method","html_id":"echo?-instance-method","name":"echo?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L111","def":{"name":"echo?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ECHO)"}},{"id":"echoe?-instance-method","html_id":"echoe?-instance-method","name":"echoe?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L112","def":{"name":"echoe?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ECHOE)"}},{"id":"echok?-instance-method","html_id":"echok?-instance-method","name":"echok?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L113","def":{"name":"echok?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ECHOK)"}},{"id":"echonl?-instance-method","html_id":"echonl?-instance-method","name":"echonl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L114","def":{"name":"echonl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ECHONL)"}},{"id":"icanon?-instance-method","html_id":"icanon?-instance-method","name":"icanon?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L115","def":{"name":"icanon?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ICANON)"}},{"id":"iexten?-instance-method","html_id":"iexten?-instance-method","name":"iexten?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L116","def":{"name":"iexten?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IEXTEN)"}},{"id":"isig?-instance-method","html_id":"isig?-instance-method","name":"isig?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L117","def":{"name":"isig?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ISIG)"}},{"id":"noflsh?-instance-method","html_id":"noflsh?-instance-method","name":"noflsh?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L118","def":{"name":"noflsh?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOFLSH)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L110","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"tostop?-instance-method","html_id":"tostop?-instance-method","name":"tostop?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L119","def":{"name":"tostop?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TOSTOP)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Termios/OutputMode","path":"Termios/OutputMode.html","kind":"enum","full_name":"Termios::OutputMode","name":"OutputMode","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"termios.cr","line_number":20,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"OPOST","name":"OPOST","value":"1","doc":null,"summary":null},{"id":"ONLCR","name":"ONLCR","value":"4","doc":null,"summary":null},{"id":"OCRNL","name":"OCRNL","value":"8","doc":null,"summary":null},{"id":"ONOCR","name":"ONOCR","value":"16","doc":null,"summary":null},{"id":"ONLRET","name":"ONLRET","value":"32","doc":null,"summary":null},{"id":"OFDEL","name":"OFDEL","value":"128","doc":null,"summary":null},{"id":"OFILL","name":"OFILL","value":"64","doc":null,"summary":null},{"id":"CRDLY","name":"CRDLY","value":"1536","doc":null,"summary":null},{"id":"CR0","name":"CR0","value":"0","doc":null,"summary":null},{"id":"CR1","name":"CR1","value":"512","doc":null,"summary":null},{"id":"CR2","name":"CR2","value":"1024","doc":null,"summary":null},{"id":"CR3","name":"CR3","value":"1536","doc":null,"summary":null},{"id":"TABDLY","name":"TABDLY","value":"6144","doc":null,"summary":null},{"id":"TAB0","name":"TAB0","value":"0","doc":null,"summary":null},{"id":"TAB1","name":"TAB1","value":"2048","doc":null,"summary":null},{"id":"TAB2","name":"TAB2","value":"4096","doc":null,"summary":null},{"id":"TAB3","name":"TAB3","value":"6144","doc":null,"summary":null},{"id":"BSDLY","name":"BSDLY","value":"8192","doc":null,"summary":null},{"id":"BS0","name":"BS0","value":"0","doc":null,"summary":null},{"id":"BS1","name":"BS1","value":"8192","doc":null,"summary":null},{"id":"VTDLY","name":"VTDLY","value":"16384","doc":null,"summary":null},{"id":"VT0","name":"VT0","value":"0","doc":null,"summary":null},{"id":"VT1","name":"VT1","value":"16384","doc":null,"summary":null},{"id":"FFDLY","name":"FFDLY","value":"32768","doc":null,"summary":null},{"id":"FF0","name":"FF0","value":"0","doc":null,"summary":null},{"id":"FF1","name":"FF1","value":"32768","doc":null,"summary":null},{"id":"NLDLY","name":"NLDLY","value":"256","doc":null,"summary":null},{"id":"NL0","name":"NL0","value":"0","doc":null,"summary":null},{"id":"NL1","name":"NL1","value":"256","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"bs0?-instance-method","html_id":"bs0?-instance-method","name":"bs0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"bs0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(BS0)"}},{"id":"bs1?-instance-method","html_id":"bs1?-instance-method","name":"bs1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"bs1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(BS1)"}},{"id":"bsdly?-instance-method","html_id":"bsdly?-instance-method","name":"bsdly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"bsdly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(BSDLY)"}},{"id":"cr0?-instance-method","html_id":"cr0?-instance-method","name":"cr0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"cr0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(CR0)"}},{"id":"cr1?-instance-method","html_id":"cr1?-instance-method","name":"cr1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"cr1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(CR1)"}},{"id":"cr2?-instance-method","html_id":"cr2?-instance-method","name":"cr2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"cr2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(CR2)"}},{"id":"cr3?-instance-method","html_id":"cr3?-instance-method","name":"cr3?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"cr3?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(CR3)"}},{"id":"crdly?-instance-method","html_id":"crdly?-instance-method","name":"crdly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"crdly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(CRDLY)"}},{"id":"ff0?-instance-method","html_id":"ff0?-instance-method","name":"ff0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ff0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(FF0)"}},{"id":"ff1?-instance-method","html_id":"ff1?-instance-method","name":"ff1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ff1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(FF1)"}},{"id":"ffdly?-instance-method","html_id":"ffdly?-instance-method","name":"ffdly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ffdly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(FFDLY)"}},{"id":"nl0?-instance-method","html_id":"nl0?-instance-method","name":"nl0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"nl0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NL0)"}},{"id":"nl1?-instance-method","html_id":"nl1?-instance-method","name":"nl1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"nl1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NL1)"}},{"id":"nldly?-instance-method","html_id":"nldly?-instance-method","name":"nldly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"nldly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NLDLY)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"ocrnl?-instance-method","html_id":"ocrnl?-instance-method","name":"ocrnl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ocrnl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OCRNL)"}},{"id":"ofdel?-instance-method","html_id":"ofdel?-instance-method","name":"ofdel?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ofdel?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OFDEL)"}},{"id":"ofill?-instance-method","html_id":"ofill?-instance-method","name":"ofill?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"ofill?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OFILL)"}},{"id":"onlcr?-instance-method","html_id":"onlcr?-instance-method","name":"onlcr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"onlcr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ONLCR)"}},{"id":"onlret?-instance-method","html_id":"onlret?-instance-method","name":"onlret?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"onlret?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ONLRET)"}},{"id":"onocr?-instance-method","html_id":"onocr?-instance-method","name":"onocr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"onocr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(ONOCR)"}},{"id":"opost?-instance-method","html_id":"opost?-instance-method","name":"opost?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"opost?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OPOST)"}},{"id":"tab0?-instance-method","html_id":"tab0?-instance-method","name":"tab0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"tab0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TAB0)"}},{"id":"tab1?-instance-method","html_id":"tab1?-instance-method","name":"tab1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"tab1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TAB1)"}},{"id":"tab2?-instance-method","html_id":"tab2?-instance-method","name":"tab2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"tab2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TAB2)"}},{"id":"tab3?-instance-method","html_id":"tab3?-instance-method","name":"tab3?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"tab3?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TAB3)"}},{"id":"tabdly?-instance-method","html_id":"tabdly?-instance-method","name":"tabdly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"tabdly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(TABDLY)"}},{"id":"vt0?-instance-method","html_id":"vt0?-instance-method","name":"vt0?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"vt0?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(VT0)"}},{"id":"vt1?-instance-method","html_id":"vt1?-instance-method","name":"vt1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"vt1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(VT1)"}},{"id":"vtdly?-instance-method","html_id":"vtdly?-instance-method","name":"vtdly?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/termios.cr#L20","def":{"name":"vtdly?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(VTDLY)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Time","path":"Time.html","kind":"struct","full_name":"Time","name":"Time","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time.cr","line_number":200,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr"},{"filename":"json/to_json.cr","line_number":125,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":109,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"`Time` represents a date-time instant in\n[incremental time](https://www.w3.org/International/articles/definitions-time/#incremental_time)\nobserved in a specific time zone.\n\nThe calendaric calculations are based on the rules of the proleptic Gregorian\ncalendar as specified in [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\nLeap seconds are ignored.\n\nInternally, the time is stored as an `Int64` representing seconds from epoch\n(`0001-01-01 00:00:00.0 UTC`) and an `Int32` representing\nnanosecond-of-second with value range `0..999_999_999`.\n\nThe supported date range is `0001-01-01 00:00:00.0` to\n`9999-12-31 23:59:59.999_999_999` in any local time zone.\n\n### Telling the Time\n\nThere are several methods to retrieve a `Time` instance representing the\ncurrent time:\n\n```crystal\nTime.utc_now                                  # returns the current time in UTC\nTime.now Time::Location.load(\"Europe/Berlin\") # returns the current time in time zone Europe/Berlin\nTime.now                                      # returns the current time in current time zone\n```\n\nIt is generally recommended to keep instances in UTC and only apply a\nlocal time zone when formatting for user display, unless the domain logic\nrequires having a specific time zone (for example for calendaric operations).\n\n### Creating a Specific Instant\n\n`Time` instances representing a specific instant can be created by\n`.utc` or `.new` with the date-time specified as individual arguments:\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.to_s        # => 2016-02-15 10:20:30 UTC\ntime = Time.new(2016, 2, 15, 10, 20, 30, location: Time::Location.load(\"Europe/Berlin\"))\ntime.to_s        # => 2016-02-15 10:20:30 +01:00 Europe/Berlin\nThe time-of-day can be omitted and defaults to midnight (start of day):\ntime = Time.utc(2016, 2, 15)\ntime.to_s        # => 2016-02-15 00:00:00 UTC\n```\n\n### Retrieving Time Information\n\nEach `Time` instance allows querying calendar data:\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.year        # => 2016\ntime.month       # => 2\ntime.day         # => 15\ntime.hour        # => 10\ntime.minute      # => 20\ntime.second      # => 30\ntime.millisecond # => 0\ntime.nanosecond  # => 0\ntime.day_of_week # => Monday\ntime.day_of_year # => 46\ntime.monday?     # => true\ntime.time_of_day # => 15:10:30\n```\n\n### Time Zones\n\nEach time is attached to a specific time zone, represented by a `Location`\n(see `#location`).\n`#zone` returns the time zone observed in this location at the current time\n(i.e. the instant represented by this `Time`).\n`#offset` returns the offset of the current zone in seconds.\n\n```\ntime = Time.new(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime          # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime.location # => #<Time::Location Europe/Berlin>\ntime.zone     # => #<Time::Location::Zone CET +01:00 (3600s) STD>\ntime.offset   # => 3600\n```\n\nUsing `.utc`, the location is `Time::Location::UTC`:\n\n```\ntime = Time.utc(2018, 3, 8, 22, 5, 13)\ntime          # => 2016-02-15 10:20:30 UTC\ntime.location # => #<Time::Location UTC>\ntime.zone     # => #<Time::Location::Zone UTC +00:00 (0s) STD>\ntime.offset   # => 0\n```\n\nA `Time` instance can be transformed to a different time zone while retaining\nthe same instant using `#in`:\n\n```\ntime_de = Time.new(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = time_de.in Time::Location.load(\"America/Buenos_Aires\")\ntime_de # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime_ar # => 2018-03-08 18:05:13 -03:00 America/Buenos_Aires\n```\n\nBoth `Time` instances show a different local date-time, but they represent\nthe same date-time in the instant time-line, therefore they are considered\nequal:\n\n```\ntime_de.to_utc     # => 2018-03-08 21:05:13 UTC\ntime_ar.to_utc     # => 2018-03-08 21:05:13 UTC\ntime_de == time_ar # => true\n```\n\nThere are also two special methods for converting to UTC and local time zone:\n\n```\ntime.to_utc   # equals time.in(Location::UTC)\ntime.to_local # equals time.in(Location.local)\n```\n\n### Formatting and Parsing Time\n\nTo make date-time instances exchangeable between different computer systems\nor readable to humans, they are usually converted to and from a string\nrepresentation.\n\nThe method `#to_s` formats the date-time according to a specified pattern.\n\n```\ntime = Time.utc(2015, 10, 12, 10, 30, 0)\ntime.to_s(\"%Y-%m-%d %H:%M:%S %:z\") # => \"2015-10-12 10:30:00 +00:00\"\n```\n\nSimilarly, `Time.parse` is used to construct a `Time` instance from date-time\ninformation in a string, according to a specified pattern:\n\n```\nTime.parse(\"2015-10-12 10:30:00 +00:00\", \"%Y-%m-%d %H:%M:%S %z\")\n```\n\nSee `Time::Format` for all directives.\n\n### Calculations\n\n```\nTime.utc(2015, 10, 10) - 5.days # => 2015-10-05 00:00:00 +00:00\n\nspan = Time.utc(2015, 10, 10) - Time.utc(2015, 9, 10)\nspan.days          # => 30\nspan.total_hours   # => 720\nspan.total_minutes # => 43200\n```\n\n## Measuring Time\n\nThe typical time representation provided by the operating system is based on\na \"wall clock\" which is subject to changes for clock synchronization.\nThis can result in discontinuous jumps in the time-line making it not\nsuitable for accurately measuring elapsed time.\n\nInstances of `Time` are focused on telling time – using a \"wall clock\".\nWhen `Time.now` is called multiple times, the difference between the\nreturned instances is not guranteed to equal to the time elapsed between\nmaking the calls; even the order of the returned `Time` instances might\nnot reflect invocation order.\n\n```\nt1 = Time.utc_now\n# operation that takes 1 minute\nt2 = Time.utc_now\nt2 - t1 # => ?\n```\n\nThe resulting `Time::Span` could be anything, even negative, if the\ncomputer's wall clock has changed between both calls.\n\nAs an alternative, the operating system also provides a monotonic clock.\nIt's time-line has no specfied starting point but is strictly linearly\nincreasing.\n\nThis monotonic clock should always be used for measuring elapsed time.\n\nA reading from this clock can be taken using `.monotonic`:\n\n```\nt1 = Time.monotonic\n# operation that takes 1 minute\nt2 = Time.monotonic\nt2 - t1 # => 1.minute (approximately)\n```\n\nThe execution time of a block can be measured using `.measure`:\n\n```\nelapsed_time = Time.measure do\n  # operation that takes 20 milliseconds\nend\nelapsed_time # => 20.milliseconds (approximately)\n```","summary":"<p><code><a href=\"Time.html\">Time</a></code> represents a date-time instant in <a href=\"https://www.w3.org/International/articles/definitions-time/#incremental_time\" target=\"_blank\">incremental time</a> observed in a specific time zone.</p>","class_methods":[{"id":"days_in_month(year:Int,month:Int):Int32-class-method","html_id":"days_in_month(year:Int,month:Int):Int32-class-method","name":"days_in_month","doc":"Returns the number of days in *month* (value range: `1..12`) taking account\nof the *year*.\n\nThe returned value is either `28`, `29`, `30` or `31` depending on the\nmonth and whether *year* is leap.\n\n```\nTime.days_in_month(2016, 2) # => 29\nTime.days_in_month(1990, 4) # => 30\n```","summary":"<p>Returns the number of days in <em>month</em> (value range: <code>1..12</code>) taking account of the <em>year</em>.</p>","abstract":false,"args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int"}],"args_string":"(year : Int, month : Int) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L774","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L774","def":{"name":"days_in_month","args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"if 1 <= month && month <= 12\nelse\n  raise(ArgumentError.new(\"Invalid month\"))\nend\nif 1 <= year && year <= 9999\nelse\n  raise(ArgumentError.new(\"Invalid year\"))\nend\ndays = leap_year?(year) ? DAYS_MONTH_LEAP : DAYS_MONTH\ndays[month]\n"}},{"id":"days_in_year(year:Int):Int32-class-method","html_id":"days_in_year(year:Int):Int32-class-method","name":"days_in_year","doc":"Returns the number of days in *year*.\n\nA normal year has `365` days, a leap year `366` days.\n\n```\nTime.days_in_year(1990) # => 365\nTime.days_in_year(2004) # => 366\n```","summary":"<p>Returns the number of days in <em>year</em>.</p>","abstract":false,"args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"}],"args_string":"(year : Int) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L795","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L795","def":{"name":"days_in_year","args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"leap_year?(year) ? 366 : 365"}},{"id":"leap_year?(year:Int):Bool-class-method","html_id":"leap_year?(year:Int):Bool-class-method","name":"leap_year?","doc":"Returns `true` if *year* is a leap year in the proleptic Gregorian\ncalendar.","summary":"<p>Returns <code>true</code> if <em>year</em> is a leap year in the proleptic Gregorian calendar.</p>","abstract":false,"args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"}],"args_string":"(year : Int) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L801","def":{"name":"leap_year?","args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"if 1 <= year && year <= 9999\nelse\n  raise(ArgumentError.new(\"Invalid year\"))\nend\n((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0))\n"}},{"id":"measure(&block):Time::Span-class-method","html_id":"measure(&amp;block):Time::Span-class-method","name":"measure","doc":"Measures the execution time of *block*.\n\nThe measurement relies on the monotonic clock and is not\naffected by fluctuations of the system clock (see `#monotonic`).\n\n```\nelapsed_time = Time.measure do\n  # operation that takes 20 milliseconds\nend\nelapsed_time # => 20.milliseconds (approximately)\n```","summary":"<p>Measures the execution time of <em>block</em>.</p>","abstract":false,"args":[],"args_string":"(&block) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L326","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L326","def":{"name":"measure","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"start = monotonic\nyield\nmonotonic - start\n"}},{"id":"monotonic:Time::Span-class-method","html_id":"monotonic:Time::Span-class-method","name":"monotonic","doc":"Returns a reading from the monotonic clock to measure elapsed time.\n\nValues from the monotonic clock and wall clock are not comparable.\nThis method does not return a `Time` instance but a `Time::Span` amounting\nto the number of nanoseconds elapsed since the unspecified starting point\nof the monotonic clock.\nThe returned values are strictly linearly increasing.\n\nThis clock should be independent from discontinuous jumps in the\nsystem time, such as leap seconds, time zone adjustments or manual changes\nto the computer's clock.\n\nSubtracting two results from this method equals to the time elapsed between\nboth readings:\n\n```\nstart = Time.monotonic\n# operation that takes 20 milliseconds\nelapsed = Time.monotonic - start # => 20.milliseconds (approximately)\n# operation that takes 50 milliseconds\nelapsed_total = Time.monotonic - start # => 70.milliseconds (approximately)\n```\n\nThe execution time of a block can be measured using `.measure`.","summary":"<p>Returns a reading from the monotonic clock to measure elapsed time.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L310","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L310","def":{"name":"monotonic","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"seconds, nanoseconds = Crystal::System::Time.monotonic\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"id":"parse_iso8601(time:String)-class-method","html_id":"parse_iso8601(time:String)-class-method","name":"parse_iso8601","doc":"Parse datetime format specified by [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\n\nThis is similar to `.parse_rfc3339` but RFC 3339 defines a more strict format.\nIn ISO 8601 for examples, field delimiters (`-`, `:`) are optional.\n\nUse `#to_rfc3339` to format a `Time` according to .","summary":"<p>Parse datetime format specified by <a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"args_string":"(time : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L903","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L903","def":{"name":"parse_iso8601","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::ISO_8601_DATE_TIME.parse(time)"}},{"id":"parse_rfc2822(time:String)-class-method","html_id":"parse_rfc2822(time:String)-class-method","name":"parse_rfc2822","doc":"Parse time format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt).\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Parse time format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\" target=\"_blank\">RFC 2822</a>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"args_string":"(time : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L929","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L929","def":{"name":"parse_rfc2822","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_2822.parse(time)"}},{"id":"parse_rfc3339(time:String)-class-method","html_id":"parse_rfc3339(time:String)-class-method","name":"parse_rfc3339","doc":"Parse time format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).","summary":"<p>Parse time format specified by <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"args_string":"(time : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L893","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L893","def":{"name":"parse_rfc3339","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_3339.parse(time)"}}],"constructors":[{"id":"epoch(seconds:Int):Time-class-method","html_id":"epoch(seconds:Int):Time-class-method","name":"epoch","doc":"Creates a new `Time` instance that corresponds to the number of\n*seconds* elapsed since the Unix epoch (`1970-01-01 00:00:00 UTC`).\n\nThe time zone is always UTC.\n\n```\nTime.epoch(981173106) # => 2001-02-03 04:05:06 UTC\n```","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> elapsed since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"}],"args_string":"(seconds : Int) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L486","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L486","def":{"name":"epoch","args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"utc(seconds: UNIX_SECONDS + seconds, nanoseconds: 0)"}},{"id":"epoch_ms(milliseconds:Int):Time-class-method","html_id":"epoch_ms(milliseconds:Int):Time-class-method","name":"epoch_ms","doc":"Creates a new `Time` instance that corresponds to the number of\n*milliseconds* elapsed since the Unix epoch (`1970-01-01 00:00:00 UTC`).\n\nThe time zone is always UTC.\n\n```\ntime = Time.epoch_ms(981173106789) # => 2001-02-03 04:05:06.789 UTC\ntime.millisecond                   # => 789\n```","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>milliseconds</em> elapsed since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[{"name":"milliseconds","doc":null,"default_value":"","external_name":"milliseconds","restriction":"Int"}],"args_string":"(milliseconds : Int) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L499","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L499","def":{"name":"epoch_ms","args":[{"name":"milliseconds","doc":null,"default_value":"","external_name":"milliseconds","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"milliseconds = milliseconds.to_i64\nseconds = UNIX_SECONDS + (milliseconds / 1000)\nnanoseconds = (milliseconds % 1000) * NANOSECONDS_PER_MILLISECOND\nutc(seconds: seconds, nanoseconds: nanoseconds.to_i)\n"}},{"id":"new(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0,location:Location=Location.local):Time-class-method","html_id":"new(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0,location:Location=Location.local):Time-class-method","name":"new","doc":"Creates a new `Time` instance representing the given local date-time in\n*location* (defaults to local time zone).\n\n```\ntime = Time.new(2016, 2, 15, 10, 20, 30, location: Time::Location.load(\"Europe/Berlin\"))\ntime.to_s # => 2016-02-15 10:20:30 +01:00 Europe/Berlin\n```\n\nValid value ranges for the individual fields:\n\n* `year`: `1..9999`\n* `month`: `1..12`\n* `day`: `1` - `28`/`29`/`30`/`31` (depending on month and year)\n* `hour`: `0..23`\n* `minute`: `0..59`\n* `second`: `0..59`\n* `nanosecond`: `0..999_999_999`\n\nThe time-of-day can be omitted and defaults to midnight (start of day):\n\n```\ntime = Time.new(2016, 2, 15)\ntime.to_s # => 2016-02-15 00:00:00 +00:00 Local\n```\n\nThe local date-time representation is resolved to a single instant based on\nthe offset observed in the *location* at this time.\n\nThis process can sometimes be ambiguous, mostly due skipping or repeating\ntimes at time zone transitions. For example, in `America/New_York` the\ndate-time `2011-03-13 02:15:00` never occured, there is a gap between time\nzones. In return, `2011-11-06 01:15:00` occured twice because of overlapping\ntime zones.\n\nIn such cases, the choice of time zone, and therefore the time, is not\nwell-defined. This method returns a time that is correct in one of the two\nzones involved in the transition, but it does not guarantee which.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the given local date-time in <em>location</em> (defaults to local time zone).</p>","abstract":false,"args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int32"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int32"},{"name":"day","doc":null,"default_value":"","external_name":"day","restriction":"Int32"},{"name":"hour","doc":null,"default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","doc":null,"default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","doc":null,"default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanosecond","doc":null,"default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(year : Int32, month : Int32, day : Int32, hour : Int32 = <span class=\"n\">0</span>, minute : Int32 = <span class=\"n\">0</span>, second : Int32 = <span class=\"n\">0</span>, *, nanosecond : Int32 = <span class=\"n\">0</span>, location : Location = <span class=\"t\">Location</span>.local) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L388","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L388","def":{"name":"new","args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int32"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int32"},{"name":"day","doc":null,"default_value":"","external_name":"day","restriction":"Int32"},{"name":"hour","doc":null,"default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","doc":null,"default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","doc":null,"default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanosecond","doc":null,"default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"double_splat":null,"splat_index":6,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if ((((((1 <= year && year <= 9999) && (1 <= month && month <= 12)) && (1 <= day && day <= (Time.days_in_month(year, month)))) && (0 <= hour && hour <= 23)) && (0 <= minute && minute <= 59)) && (0 <= second && second <= 59)) && (0 <= nanosecond && nanosecond <= 999999999)\nelse\n  raise(ArgumentError.new(\"Invalid time\"))\nend\ndays = absolute_days(year, month, day)\nseconds = ((((1_i64 * SECONDS_PER_DAY) * days) + (SECONDS_PER_HOUR * hour)) + (SECONDS_PER_MINUTE * minute)) + second\nseconds = seconds - (zone_offset_at(seconds, location))\nnew(seconds: seconds, nanoseconds: nanosecond.to_i, location: location)\n"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L206","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L206","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parse_scalar(ctx, node, Time)"}},{"id":"new(location:Location=Location.local):Time-class-method","html_id":"new(location:Location=Location.local):Time-class-method","name":"new","doc":"Creates a new `Time` instance representing the current time from the\nsystem clock observed in *location* (defaults to local time zone).","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the current time from the system clock observed in <em>location</em> (defaults to local time zone).</p>","abstract":false,"args":[{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(location : Location = <span class=\"t\">Location</span>.local) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L334","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L334","def":{"name":"new","args":[{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"seconds, nanoseconds = Crystal::System::Time.compute_utc_seconds_and_nanoseconds\nnew(seconds: seconds, nanoseconds: nanoseconds, location: location)\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a string from JSON parser as a time formated according to [RFC 3339](https://tools.ietf.org/html/rfc3339)\nor other variations of [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\n\nThe JSON format itself does not specify a time data type, this method just\nassumes that a string holding a ISO 8601 time format can be # interpreted as a\ntime value.\n\nSee `#to_json` for reference.","summary":"<p>Reads a string from JSON parser as a time formated according to <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> or other variations of <a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a>.</p>","abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L241","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Time::Format::ISO_8601_DATE_TIME.parse(pull.read_string)"}},{"id":"new(*,seconds:Int64,nanoseconds:Int32,location:Location)-class-method","html_id":"new(*,seconds:Int64,nanoseconds:Int32,location:Location)-class-method","name":"new","doc":"Creates a new `Time` instance that corresponds to the number of *seconds*\nand *nanoseconds* elapsed from epoch (`0001-01-01 00:00:00.0 UTC`)\nobserved in *location*.\n\nValid range for *seconds* is `0..315_537_897_599`.\nFor *nanoseconds* it is `0..999_999_999`.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> and <em>nanoseconds</em> elapsed from epoch (<code>0001-01-01 00:00:00.0 UTC</code>) observed in <em>location</em>.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int32"},{"name":"location","doc":null,"default_value":"","external_name":"location","restriction":"Location"}],"args_string":"(*, seconds : Int64, nanoseconds : Int32, location : Location)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L449","def":{"name":"new","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int32"},{"name":"location","doc":null,"default_value":"","external_name":"location","restriction":"Location"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(seconds: seconds, nanoseconds: nanoseconds, location: location)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"now(location:Location=Location.local):Time-class-method","html_id":"now(location:Location=Location.local):Time-class-method","name":"now","doc":"Creates a new `Time` instance representing the current time from the\nsystem clock observed in *location* (defaults to local time zone).","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the current time from the system clock observed in <em>location</em> (defaults to local time zone).</p>","abstract":false,"args":[{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(location : Location = <span class=\"t\">Location</span>.local) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L341","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L341","def":{"name":"now","args":[{"name":"location","doc":null,"default_value":"Location.local","external_name":"location","restriction":"Location"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"new(location)"}},{"id":"parse(time:String,pattern:String,location:Location?=nil):Time-class-method","html_id":"parse(time:String,pattern:String,location:Location?=nil):Time-class-method","name":"parse","doc":"Parses a `Time` from *time* string using the given *pattern*.\n\nSee `Time::Format` for details.\n\n```\nTime.parse(\"2016-04-05\", \"%F\") # => 2016-04-05 00:00:00 +01:00\n```","summary":"<p>Parses a <code><a href=\"Time.html\">Time</a></code> from <em>time</em> string using the given <em>pattern</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"},{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"location","doc":null,"default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"args_string":"(time : String, pattern : String, location : Location? = <span class=\"n\">nil</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L940","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L940","def":{"name":"parse","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"String"},{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"location","doc":null,"default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"(Format.new(pattern, location)).parse(time)"}},{"id":"utc(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0):Time-class-method","html_id":"utc(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0):Time-class-method","name":"utc","doc":"Creates a new `Time` instance representing the given date-time in UTC.\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.to_s # => 2016-02-15 10:20:30 UTC\n```\n\nValid value ranges for the individual fields:\n\n* `year`: `1..9999`\n* `month`: `1..12`\n* `day`: `1` - `28`/`29`/`30`/`31` (depending on month and year)\n* `hour`: `0..23`\n* `minute`: `0..59`\n* `second`: `0..59`\n* `nanosecond`: `0..999_999_999`\n\nThe time-of-day can be omitted and defaults to midnight (start of day):\n\n```\ntime = Time.utc(2016, 2, 15)\ntime.to_s # => 2016-02-15 00:00:00 UTC\n```\n\nSince UTC does not have any time zone transitions, each date-time is\nunambiguously resolved.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the given date-time in UTC.</p>","abstract":false,"args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int32"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int32"},{"name":"day","doc":null,"default_value":"","external_name":"day","restriction":"Int32"},{"name":"hour","doc":null,"default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","doc":null,"default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","doc":null,"default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanosecond","doc":null,"default_value":"0","external_name":"nanosecond","restriction":"Int32"}],"args_string":"(year : Int32, month : Int32, day : Int32, hour : Int32 = <span class=\"n\">0</span>, minute : Int32 = <span class=\"n\">0</span>, second : Int32 = <span class=\"n\">0</span>, *, nanosecond : Int32 = <span class=\"n\">0</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L439","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L439","def":{"name":"utc","args":[{"name":"year","doc":null,"default_value":"","external_name":"year","restriction":"Int32"},{"name":"month","doc":null,"default_value":"","external_name":"month","restriction":"Int32"},{"name":"day","doc":null,"default_value":"","external_name":"day","restriction":"Int32"},{"name":"hour","doc":null,"default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","doc":null,"default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","doc":null,"default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanosecond","doc":null,"default_value":"0","external_name":"nanosecond","restriction":"Int32"}],"double_splat":null,"splat_index":6,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"new(year, month, day, hour, minute, second, nanosecond: nanosecond, location: Location::UTC)"}},{"id":"utc(*,seconds:Int64,nanoseconds:Int32):Time-class-method","html_id":"utc(*,seconds:Int64,nanoseconds:Int32):Time-class-method","name":"utc","doc":"Creates a new `Time` instance that corresponds to the number of *seconds*\nand *nanoseconds* elapsed from epoch (`0001-01-01 00:00:00.0 UTC`)\nin UTC.\n\nValid range for *seconds* is `0..315_537_897_599`.\nFor *nanoseconds* it is `0..999_999_999`.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> and <em>nanoseconds</em> elapsed from epoch (<code>0001-01-01 00:00:00.0 UTC</code>) in UTC.</p>","abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int32"}],"args_string":"(*, seconds : Int64, nanoseconds : Int32) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L465","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L465","def":{"name":"utc","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int32"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"new(seconds: seconds, nanoseconds: nanoseconds, location: Location::UTC)"}},{"id":"utc_now:Time-class-method","html_id":"utc_now:Time-class-method","name":"utc_now","doc":"Creates a new `Time` instance representing the current time from the\nsystem clock in UTC.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the current time from the system clock in UTC.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L347","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L347","def":{"name":"utc_now","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"now(Location::UTC)"}}],"instance_methods":[{"id":"+(span:Time::Span):Time-instance-method","html_id":"+(span:Time::Span):Time-instance-method","name":"+","doc":"Returns a copy of this `Time` with *span* added.\n\nSee `#add_span` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> added.</p>","abstract":false,"args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::Span"}],"args_string":"(span : Time::Span) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L513","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L513","def":{"name":"+","args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"add_span(span.to_i, span.nanoseconds)"}},{"id":"+(span:Time::MonthSpan):Time-instance-method","html_id":"+(span:Time::MonthSpan):Time-instance-method","name":"+","doc":"Returns a copy of this `Time` with *span* added.\n\nIt adds the number of months with overflow increasing the year.\nIf the resulting day-of-month would be invalid, it is adjusted to the last\nvalid day of the moneth.\n\nFor example, adding `1.month` to `2007-03-31` would result in the invalid\ndate `2007-04-31` which will be adjusted to `2007-04-30`.\n\nThis operates on the local time-line, such that the local date-time\nrepresenations of month and year are increased by the specified amount.\n\nIf the resulting date-time is ambiguous due to time zone transitions,\na correct time will be returned, but it does not guarantee which.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> added.</p>","abstract":false,"args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::MonthSpan"}],"args_string":"(span : Time::MonthSpan) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L538","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L538","def":{"name":"+","args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::MonthSpan"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"add_months(span.value)"}},{"id":"-(other:Time):Time::Span-instance-method","html_id":"-(other:Time):Time::Span-instance-method","name":"-","doc":"Returns a `Time::Span` amounting to the duration between *other* and `self`.\n\nThe time span is negative if `self` is before *other*.\n\nThe duration amounts to the actual time elapsed between both instances, on\nthe instant time-line.\nThe difference between local date-time representations may equal to a\ndifferent duration, depending on time zone transitions.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> amounting to the duration between <em>other</em> and <code>self</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L626","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L626","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: total_seconds - other.total_seconds, nanoseconds: nanosecond - other.nanosecond)"}},{"id":"-(span:Time::Span):Time-instance-method","html_id":"-(span:Time::Span):Time-instance-method","name":"-","doc":"Returns a copy of this `Time` with *span* subtracted.\n\nSee `#add_span` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> subtracted.</p>","abstract":false,"args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::Span"}],"args_string":"(span : Time::Span) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L520","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L520","def":{"name":"-","args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::Span"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"add_span(-span.to_i, -span.nanoseconds)"}},{"id":"-(span:Time::MonthSpan):Time-instance-method","html_id":"-(span:Time::MonthSpan):Time-instance-method","name":"-","doc":"Returns a copy of this `Time` with *span* subtracted.\n\nIt adds the number of months with overflow decreasing the year.\nIf the resulting day-of-month would be invalid, it is adjusted to the last\nvalid day of the moneth.\n\nFor example, subtracting `1.month` from `2007-05-31` would result in the invalid\ndate `2007-04-31` which will be adjusted to `2007-04-30`.\n\nThis operates on the local time-line, such that the local date-time\nrepresenations of month and year are decreased by the specified amount.\n\nIf the resulting date-time is ambiguous due to time zone transitions,\na correct time will be returned, but it does not guarantee which.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> subtracted.</p>","abstract":false,"args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::MonthSpan"}],"args_string":"(span : Time::MonthSpan) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L556","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L556","def":{"name":"-","args":[{"name":"span","doc":null,"default_value":"","external_name":"span","restriction":"Time::MonthSpan"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"add_months(-span.value)"}},{"id":"(other:Time):Int32-instance-method","html_id":"(other:Time):Int32-instance-method","name":"<=>","doc":"Compares this `Time` with *other*.\n\nThe comparison is based on the instant time-line, even if the local\ndate-time representation (wall clock) would compare differently.\n\nTo ensure the comparison is also true for local wall clock, both date-times\nneed to be transforemd to the same time zone.","summary":"<p>Compares this <code><a href=\"Time.html\">Time</a></code> with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L738","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L738","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"cmp = total_seconds <=> other.total_seconds\nif cmp == 0\n  cmp = nanosecond <=> other.nanosecond\nend\ncmp\n"}},{"id":"==(other:Time):Bool-instance-method","html_id":"==(other:Time):Bool-instance-method","name":"==","doc":"Compares this `Time` with *other* for equality.\n\nTwo instances are considered equal if they represent the same date-time in\nthe instant time-line, even if they show a different local date-time.\n\n```\ntime_de = Time.new(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = Time.new(2018, 3, 8, 18, 5, 13, location: Time::Location.load(\"America/Buenos_Aires\"))\ntime_de == time_ar # => true\n\n# both times represent the same instant:\ntime_de.to_utc # => 2018-03-08 21:05:13 UTC\ntime_ar.to_utc # => 2018-03-08 21:05:13 UTC\n```","summary":"<p>Compares this <code><a href=\"Time.html\">Time</a></code> with <em>other</em> for equality.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L758","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L758","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"(total_seconds == other.total_seconds) && (nanosecond == other.nanosecond)"}},{"id":"add_span(seconds:Int,nanoseconds:Int):Time-instance-method","html_id":"add_span(seconds:Int,nanoseconds:Int):Time-instance-method","name":"add_span","doc":"Returns a copy of this `Time` with the number of *seconds* and\n*nanoseconds* added.\n\nPositive values result in a later time, negative values in an earlier time.\n\nThis operates on the instant time-line, such that adding the eqivalent of\none hour will always be a duration of one hour later.\nThe local date-time representation may change by a different amount,\ndepending on time zone transitions.\n\nOverflow in *nanoseconds* will be transferred to *seconds*.\n\nThere is no explicit limit on the input values but the addition must result\nin a valid time between `0001-01-01 00:00:00.0` and\n`9999-12-31 23:59:59.999_999_999`. Otherwise `ArgumentError` is raised.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with the number of <em>seconds</em> and <em>nanoseconds</em> added.</p>","abstract":false,"args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(seconds : Int, nanoseconds : Int) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L597","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L597","def":{"name":"add_span","args":[{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if (seconds == 0) && (nanoseconds == 0)\n  return self\nend\nseconds = total_seconds + seconds\nnanoseconds = self.nanosecond.to_i64 + nanoseconds\nseconds = seconds + (nanoseconds.tdiv(NANOSECONDS_PER_SECOND))\nnanoseconds = nanoseconds.remainder(NANOSECONDS_PER_SECOND)\nif nanoseconds < 0\n  seconds = seconds - 1\n  nanoseconds = nanoseconds + NANOSECONDS_PER_SECOND\nend\nTime.new(seconds: seconds, nanoseconds: nanoseconds.to_i, location: location)\n"}},{"id":"at_beginning_of_day:Time-instance-method","html_id":"at_beginning_of_day:Time-instance-method","name":"at_beginning_of_day","doc":"Returns a copy of this `Time` representing the beginning of the day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the day.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1050","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1050","def":{"name":"at_beginning_of_day","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, day, location: location)\n"}},{"id":"at_beginning_of_hour:Time-instance-method","html_id":"at_beginning_of_hour:Time-instance-method","name":"at_beginning_of_hour","doc":"Returns a copy of this `Time` representing the beginning of the hour.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the hour.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1051","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1051","def":{"name":"at_beginning_of_hour","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, day, hour, location: location)\n"}},{"id":"at_beginning_of_minute:Time-instance-method","html_id":"at_beginning_of_minute:Time-instance-method","name":"at_beginning_of_minute","doc":"Returns a copy of this `Time` representing the beginning of the minute.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the minute.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1054","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1054","def":{"name":"at_beginning_of_minute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.new(seconds: total_seconds - second, nanoseconds: 0, location: location)"}},{"id":"at_beginning_of_month:Time-instance-method","html_id":"at_beginning_of_month:Time-instance-method","name":"at_beginning_of_month","doc":"Returns a copy of this `Time` representing the beginning of the month.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the month.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1049","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1049","def":{"name":"at_beginning_of_month","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, 1, location: location)\n"}},{"id":"at_beginning_of_quarter:Time-instance-method","html_id":"at_beginning_of_quarter:Time-instance-method","name":"at_beginning_of_quarter","doc":"Returns a copy of this `Time` representing the beginning of the quarter.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the quarter.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1048","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1048","def":{"name":"at_beginning_of_quarter","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, (((month - 1) / 3) * 3) + 1, 1, location: location)\n"}},{"id":"at_beginning_of_second:Time-instance-method","html_id":"at_beginning_of_second:Time-instance-method","name":"at_beginning_of_second","doc":"Returns a copy of this `Time` representing the beginning of the seconds.\n\nThis essentially scaps off `nanoseconds`.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the seconds.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1061","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1061","def":{"name":"at_beginning_of_second","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.new(seconds: total_seconds, nanoseconds: 0, location: location)"}},{"id":"at_beginning_of_semester:Time-instance-method","html_id":"at_beginning_of_semester:Time-instance-method","name":"at_beginning_of_semester","doc":"Returns a copy of this `Time` representing the beginning of the semester.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the semester.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1047","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1047","def":{"name":"at_beginning_of_semester","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, (((month - 1) / 6) * 6) + 1, 1, location: location)\n"}},{"id":"at_beginning_of_week:Time-instance-method","html_id":"at_beginning_of_week:Time-instance-method","name":"at_beginning_of_week","doc":"Returns a copy of this `Time` representing the beginning of the week.\n\nTODO: Ensure correctness in local time-line.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the week.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1068","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1068","def":{"name":"at_beginning_of_week","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"dow = day_of_week.value\nif dow == 0\n  (self - 6.days).at_beginning_of_day\nelse\n  (self - (dow - 1).days).at_beginning_of_day\nend\n"}},{"id":"at_beginning_of_year:Time-instance-method","html_id":"at_beginning_of_year:Time-instance-method","name":"at_beginning_of_year","doc":"Returns a copy of this `Time` representing the beginning of the year.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the year.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1046","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1046","def":{"name":"at_beginning_of_year","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, 1, 1, location: location)\n"}},{"id":"at_end_of_day:Time-instance-method","html_id":"at_end_of_day:Time-instance-method","name":"at_end_of_day","doc":"Returns a copy of this `Time` representing the end of the day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the day.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1119","def":{"name":"at_end_of_day","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_end_of_hour:Time-instance-method","html_id":"at_end_of_hour:Time-instance-method","name":"at_end_of_hour","doc":"Returns a copy of this `Time` representing the end of the hour.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the hour.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1120","def":{"name":"at_end_of_hour","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, day, hour, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_end_of_minute-instance-method","html_id":"at_end_of_minute-instance-method","name":"at_end_of_minute","doc":"Returns a copy of this `Time` representing the end of the minute.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the minute.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1123","def":{"name":"at_end_of_minute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Time.new(seconds: (total_seconds - second) + 59, nanoseconds: 999999999, location: location)"}},{"id":"at_end_of_month:Time-instance-method","html_id":"at_end_of_month:Time-instance-method","name":"at_end_of_month","doc":"Returns a copy of this `Time` representing the end of the month.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the month.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1105","def":{"name":"at_end_of_month","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, month, Time.days_in_month(year, month), 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_end_of_quarter:Time-instance-method","html_id":"at_end_of_quarter:Time-instance-method","name":"at_end_of_quarter","doc":"Returns a copy of this `Time` representing the end of the quarter.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the quarter.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1091","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1091","def":{"name":"at_end_of_quarter","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month = year_month_day_day_year\nif month <= 3\n  month, day = 3, 31\nelse\n  if month <= 6\n    month, day = 6, 30\n  else\n    if month <= 9\n      month, day = 9, 30\n    else\n      month, day = 12, 31\n    end\n  end\nend\nTime.new(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_end_of_second-instance-method","html_id":"at_end_of_second-instance-method","name":"at_end_of_second","doc":"Returns a copy of this `Time` representing the end of the second.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the second.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1128","def":{"name":"at_end_of_second","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Time.new(seconds: total_seconds, nanoseconds: 999999999, location: location)"}},{"id":"at_end_of_semester:Time-instance-method","html_id":"at_end_of_semester:Time-instance-method","name":"at_end_of_semester","doc":"Returns a copy of this `Time` representing the end of the semester.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the semester.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1080","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1080","def":{"name":"at_end_of_semester","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month = year_month_day_day_year\nif month <= 6\n  month, day = 6, 30\nelse\n  month, day = 12, 31\nend\nTime.new(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_end_of_week:Time-instance-method","html_id":"at_end_of_week:Time-instance-method","name":"at_end_of_week","doc":"Returns a copy of this `Time` representing the end of the week.\n\nTODO: Ensure correctness in local time-line.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the week.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1110","def":{"name":"at_end_of_week","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"dow = day_of_week.value\nif dow == 0\n  at_end_of_day\nelse\n  (self + (7 - dow).days).at_end_of_day\nend\n"}},{"id":"at_end_of_year:Time-instance-method","html_id":"at_end_of_year:Time-instance-method","name":"at_end_of_year","doc":"Returns a copy of this `Time` representing the end of the year.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the year.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1077","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1077","def":{"name":"at_end_of_year","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.new(year, 12, 31, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"id":"at_midday:Time-instance-method","html_id":"at_midday:Time-instance-method","name":"at_midday","doc":"Returns a copy of this `Time` representing midday (`12:00`) of the same day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing midday (<code>12:00</code>) of the same day.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1133","def":{"name":"at_midday","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"year, month, day = year_month_day_day_year\nTime.new(year, month, day, 12, 0, 0, nanosecond: 0, location: location)\n"}},{"id":"clone:Time-instance-method","html_id":"clone:Time-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L506","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L506","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"self"}},{"id":"date:Time-instance-method","html_id":"date:Time-instance-method","name":"date","doc":"Returns a copy of `self` with time-of-day components (hour, minute, second,\nnanoseconds) set to zero.\n\nThis equals `at_beginning_of_day` or\n`Time.new(year, month, day, 0, 0, 0, nanoseconds: 0, location: location)`.","summary":"<p>Returns a copy of <code>self</code> with time-of-day components (hour, minute, second, nanoseconds) set to zero.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L638","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L638","def":{"name":"date","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.new(year, month, day, location: location)"}},{"id":"day:Int32-instance-method","html_id":"day:Int32-instance-method","name":"day","doc":"Returns the day of the month (`1..31`).","summary":"<p>Returns the day of the month (<code>1..31</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L653","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L653","def":{"name":"day","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[2]"}},{"id":"day_of_week:Time::DayOfWeek-instance-method","html_id":"day_of_week:Time::DayOfWeek-instance-method","name":"day_of_week","doc":"Returns the day of the week (`Sunday..Saturday`).","summary":"<p>Returns the day of the week (<code>Sunday..Saturday</code>).</p>","abstract":false,"args":[],"args_string":" : Time::DayOfWeek","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L694","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L694","def":{"name":"day_of_week","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::DayOfWeek","visibility":"Public","body":"value = ((offset_seconds / SECONDS_PER_DAY) + 1) % 7\nDayOfWeek.new(value.to_i)\n"}},{"id":"day_of_year:Int32-instance-method","html_id":"day_of_year:Int32-instance-method","name":"day_of_year","doc":"Returns the day of the year.\n\nThe value range is `1..365` in normal yars and `1..366` in leap years.","summary":"<p>Returns the day of the year.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L702","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L702","def":{"name":"day_of_year","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[3]"}},{"id":"epoch:Int64-instance-method","html_id":"epoch:Int64-instance-method","name":"epoch","doc":"Returns the number of seconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`).\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5)\ntime.epoch # => 1452567845\n```","summary":"<p>Returns the number of seconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L951","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L951","def":{"name":"epoch","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"(total_seconds - UNIX_SECONDS).to_i64"}},{"id":"epoch_f:Float64-instance-method","html_id":"epoch_f:Float64-instance-method","name":"epoch_f","doc":"Returns the number of seconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`) as `Float64` with nanosecond precision.\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5, nanosecond: 678_000_000)\ntime.epoch_f # => 1452567845.678\n```","summary":"<p>Returns the number of seconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>) as <code><a href=\"Float64.html\">Float64</a></code> with nanosecond precision.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L973","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L973","def":{"name":"epoch_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"epoch.to_f + (nanosecond.to_f / 1e9)"}},{"id":"epoch_ms:Int64-instance-method","html_id":"epoch_ms:Int64-instance-method","name":"epoch_ms","doc":"Returns the number of milliseconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`).\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5, nanosecond: 678_000_000)\ntime.epoch_ms # => 1452567845678\n```","summary":"<p>Returns the number of milliseconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L962","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L962","def":{"name":"epoch_ms","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"(epoch * 1000) + (nanosecond / NANOSECONDS_PER_MILLISECOND)"}},{"id":"friday?:Bool-instance-method","html_id":"friday?:Bool-instance-method","name":"friday?","doc":"Returns `true` if the day of week is Friday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Friday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"friday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.friday?"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L762","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L762","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = total_seconds.hash(hasher)\nhasher = nanosecond.hash(hasher)\nhasher\n"}},{"id":"hour:Int32-instance-method","html_id":"hour:Int32-instance-method","name":"hour","doc":"Returns the hour of the day (`0..23`).","summary":"<p>Returns the hour of the day (<code>0..23</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L658","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L658","def":{"name":"hour","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"((offset_seconds % SECONDS_PER_DAY) / SECONDS_PER_HOUR).to_i"}},{"id":"in(location:Location):Time-instance-method","html_id":"in(location:Location):Time-instance-method","name":"in","doc":"Returns a copy of this `Time` representing the same instant observed in\n*location*.\n\nThis method changes the time zone and retains the instant, which will\nusually result in a different representation of local date-time (unless\nboth locations have the same offset).\n\nAmbiguous time zone transitions such as gaps and overlaps have no effect on\nthe result because it retains the same instant.\n\n```\ntime_de = Time.new(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = time_de.in Time::Location.load(\"America/Buenos_Aires\")\ntime_de # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime_ar # => 2018-03-08 18:05:13 -03:00 America/Buenos_Aires\n```","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant observed in <em>location</em>.</p>","abstract":false,"args":[{"name":"location","doc":null,"default_value":"","external_name":"location","restriction":"Location"}],"args_string":"(location : Location) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L993","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L993","def":{"name":"in","args":[{"name":"location","doc":null,"default_value":"","external_name":"location","restriction":"Location"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if location == self.location\n  return self\nend\nTime.new(seconds: total_seconds, nanoseconds: nanosecond, location: location)\n"}},{"id":"inspect(io:IO,with_nanoseconds=true)-instance-method","html_id":"inspect(io:IO,with_nanoseconds=true)-instance-method","name":"inspect","doc":"Prints this `Time` to *io*.\n\nThe local date-time is formatted as date string `YYYY-MM-DD HH:mm:ss.nnnnnnnnn +ZZ:ZZ:ZZ`.\nNanoseconds are omitted if *with_nanoseconds* is `false`.\nWhen the location is `UTC`, the offset is omitted. Offset seconds are omitted if `0`.\n\nThe name of the location is appended unless it is a fixed zone offset.","summary":"<p>Prints this <code><a href=\"Time.html\">Time</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"with_nanoseconds","doc":null,"default_value":"true","external_name":"with_nanoseconds","restriction":""}],"args_string":"(io : IO, with_nanoseconds = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L816","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L816","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"with_nanoseconds","doc":null,"default_value":"true","external_name":"with_nanoseconds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(\"%F %T\", io)\nif with_nanoseconds\n  if @nanoseconds == 0\n    io << \".0\"\n  else\n    to_s(\".%N\", io)\n  end\nend\nif utc?\n  io << \" UTC\"\nelse\n  io << ' '\n  zone.format(io)\n  if location.fixed?\n  else\n    (io << ' ') << location.name\n  end\nend\nio\n"}},{"id":"local?:Bool-instance-method","html_id":"local?:Bool-instance-method","name":"local?","doc":"Returns `true` if `#location` equals to the local time zone\n(`Time::Location.local`).\n\nSince the system's settings may change during a programm's runtime,\nthe result may not be identical between different invocations.","summary":"<p>Returns <code>true</code> if <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> equals to the local time zone (<code><a href=\"Time/Location.html#local-class-method\">Time::Location.local</a></code>).</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L727","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L727","def":{"name":"local?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"location.local?"}},{"id":"location:Location-instance-method","html_id":"location:Location-instance-method","name":"location","doc":"Returns `Location` representing the time-zone observed by this `Time`.","summary":"<p>Returns <code><a href=\"Time/Location.html\">Location</a></code> representing the time-zone observed by this <code><a href=\"Time.html\">Time</a></code>.</p>","abstract":false,"args":[],"args_string":" : Location","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L284","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L284","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Location","visibility":"Public","body":"@location"}},{"id":"millisecond:Int32-instance-method","html_id":"millisecond:Int32-instance-method","name":"millisecond","doc":"Returns the millisecond of the second (`0..999`).","summary":"<p>Returns the millisecond of the second (<code>0..999</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L673","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L673","def":{"name":"millisecond","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"nanosecond / NANOSECONDS_PER_MILLISECOND"}},{"id":"minute:Int32-instance-method","html_id":"minute:Int32-instance-method","name":"minute","doc":"Returns the minute of the hour (`0..59`).","summary":"<p>Returns the minute of the hour (<code>0..59</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L663","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L663","def":{"name":"minute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"((offset_seconds % SECONDS_PER_HOUR) / SECONDS_PER_MINUTE).to_i"}},{"id":"monday?:Bool-instance-method","html_id":"monday?:Bool-instance-method","name":"monday?","doc":"Returns `true` if the day of week is Monday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Monday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"monday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.monday?"}},{"id":"month:Int32-instance-method","html_id":"month:Int32-instance-method","name":"month","doc":"Returns the month of the year (`1..12`).","summary":"<p>Returns the month of the year (<code>1..12</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L648","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L648","def":{"name":"month","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[1]"}},{"id":"nanosecond:Int32-instance-method","html_id":"nanosecond:Int32-instance-method","name":"nanosecond","doc":"Returns the nanosecond of the second (`0..999_999_999`).","summary":"<p>Returns the nanosecond of the second (<code>0..999_999_999</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L678","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L678","def":{"name":"nanosecond","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@nanoseconds"}},{"id":"offset:Int32-instance-method","html_id":"offset:Int32-instance-method","name":"offset","doc":"Returns the offset from UTC (in seconds) in effect in `location` at\nthis instant.","summary":"<p>Returns the offset from UTC (in seconds) in effect in <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> at this instant.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L713","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L713","def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"zone.offset"}},{"id":"saturday?:Bool-instance-method","html_id":"saturday?:Bool-instance-method","name":"saturday?","doc":"Returns `true` if the day of week is Saturday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Saturday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"saturday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.saturday?"}},{"id":"second:Int32-instance-method","html_id":"second:Int32-instance-method","name":"second","doc":"Returns the second of the minute (`0..59`).","summary":"<p>Returns the second of the minute (<code>0..59</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L668","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L668","def":{"name":"second","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"(offset_seconds % SECONDS_PER_MINUTE).to_i"}},{"id":"sunday?:Bool-instance-method","html_id":"sunday?:Bool-instance-method","name":"sunday?","doc":"Returns `true` if the day of week is Sunday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Sunday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"sunday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.sunday?"}},{"id":"thursday?:Bool-instance-method","html_id":"thursday?:Bool-instance-method","name":"thursday?","doc":"Returns `true` if the day of week is Thursday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Thursday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"thursday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.thursday?"}},{"id":"time_of_day:Time::Span-instance-method","html_id":"time_of_day:Time::Span-instance-method","name":"time_of_day","doc":"Returns the duration between this `Time` and midnight of the same day.\n\nThis is equivalent to creating a `Time::Span` from the time-of-day fields:\n\n```\ntime.time_of_day == Time::Span.new(time.hour, time.minute, time.second, time.nanosecond)\n``","summary":"<p>Returns the duration between this <code><a href=\"Time.html\">Time</a></code> and midnight of the same day.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L689","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L689","def":{"name":"time_of_day","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(nanoseconds: (NANOSECONDS_PER_SECOND * (offset_seconds % SECONDS_PER_DAY)) + nanosecond)"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":"Emits a string formated according to [RFC 3339](https://tools.ietf.org/html/rfc3339)\n([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\n\nThe JSON format itself does not specify a time data type, this method just\nassumes that a string holding a RFC 3339 time format will be interpreted as\na time value.\n\nSee `#from_json` for reference.","summary":"<p>Emits a string formated according to <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L134","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L134","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.string(Time::Format::RFC_3339.format(self, fraction_digits: 0))"}},{"id":"to_local:Time-instance-method","html_id":"to_local:Time-instance-method","name":"to_local","doc":"Returns a copy of this `Time` representing the same instant in the local\ntime zone (`Time::Location.local`).\n\nSee `#in` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant in the local time zone (<code><a href=\"Time/Location.html#local-class-method\">Time::Location.local</a></code>).</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1022","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1022","def":{"name":"to_local","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if local?\n  self\nelse\n  in(Location.local)\nend"}},{"id":"to_rfc2822-instance-method","html_id":"to_rfc2822-instance-method","name":"to_rfc2822","doc":"Format this time using the format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt).\n\n```\nTime.new(2016, 2, 15).to_rfc2822 # => \"Mon, 15 Feb 2016 00:00:00 -0400\"\n```\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Format this time using the format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\" target=\"_blank\">RFC 2822</a>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L914","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L914","def":{"name":"to_rfc2822","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_2822.format(to_utc)"}},{"id":"to_rfc2822(io:IO)-instance-method","html_id":"to_rfc2822(io:IO)-instance-method","name":"to_rfc2822","doc":"Format this time using the format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt)\ninto the given *io*.\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Format this time using the format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\" target=\"_blank\">RFC 2822</a> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L922","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L922","def":{"name":"to_rfc2822","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_2822.format(to_utc, io)"}},{"id":"to_rfc3339-instance-method","html_id":"to_rfc3339-instance-method","name":"to_rfc3339","doc":"Format this time using the format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\n\n```\nTime.new(2016, 2, 15).to_rfc3339 # => \"2016-02-15T00:00:00+00:00\"\n```\n\nISO 8601 allows some freedom over the syntax and RFC 3339 exercises that\nfreedom to rigidly define a fixed format intended for use in internet\nprotocols and standards.","summary":"<p>Format this time using the format specified by <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a> profile).</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L882","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L882","def":{"name":"to_rfc3339","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_3339.format(to_utc)"}},{"id":"to_rfc3339(io:IO)-instance-method","html_id":"to_rfc3339(io:IO)-instance-method","name":"to_rfc3339","doc":"Format this time using the format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\ninto the given *io*.","summary":"<p>Format this time using the format specified by <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L888","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L888","def":{"name":"to_rfc3339","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Format::RFC_3339.format(to_utc, io)"}},{"id":"to_s(format:String):String-instance-method","html_id":"to_s(format:String):String-instance-method","name":"to_s","doc":"Formats this `Time` according to the pattern in *format*.\n\nSee `Time::Format` for details.\n\n```\ntime = Time.new(2016, 4, 5)\ntime.to_s(\"%F\") # => \"2016-04-05\"\n```","summary":"<p>Formats this <code><a href=\"Time.html\">Time</a></code> according to the pattern in <em>format</em>.</p>","abstract":false,"args":[{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"String"}],"args_string":"(format : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L862","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L862","def":{"name":"to_s","args":[{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"(Format.new(format)).format(self)"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Prints this `Time` to *io*.\n\nThe local date-time is formatted as date string `YYYY-MM-DD HH:mm:ss +ZZ:ZZ:ZZ`.\nNanoseconds are always omitted.\nWhen the location is `UTC`, the offset is replaced with the string `UTC`.\nOffset seconds are omitted if `0`.","summary":"<p>Prints this <code><a href=\"Time.html\">Time</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L844","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L844","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(\"%F %T \", io)\nif utc?\n  io << \"UTC\"\nelse\n  zone.format(io)\nend\n"}},{"id":"to_s(format:String,io:IO):Nil-instance-method","html_id":"to_s(format:String,io:IO):Nil-instance-method","name":"to_s","doc":"Formats this `Time` according to the pattern in *format* to the given *io*.\n\nSee `Time::Format` for details.","summary":"<p>Formats this <code><a href=\"Time.html\">Time</a></code> according to the pattern in <em>format</em> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(format : String, io : IO) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L869","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L869","def":{"name":"to_s","args":[{"name":"format","doc":null,"default_value":"","external_name":"format","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"(Format.new(format)).format(self, io)"}},{"id":"to_utc:Time-instance-method","html_id":"to_utc:Time-instance-method","name":"to_utc","doc":"Returns a copy of this `Time` representing the same instant in UTC\n(`Time::Location::UTC`).\n\nSee `#in` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant in UTC (<code><a href=\"Time/Location.html#UTC\">Time::Location::UTC</a></code>).</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1007","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1007","def":{"name":"to_utc","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if utc?\n  self\nelse\n  Time.utc(seconds: total_seconds, nanoseconds: nanosecond)\nend"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L110","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(Time::Format::YAML_DATE.format(self))"}},{"id":"tuesday?:Bool-instance-method","html_id":"tuesday?:Bool-instance-method","name":"tuesday?","doc":"Returns `true` if the day of week is Tuesday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Tuesday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"tuesday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.tuesday?"}},{"id":"utc?:Bool-instance-method","html_id":"utc?:Bool-instance-method","name":"utc?","doc":"Returns `true` if `#location` equals to `Location::UTC`.","summary":"<p>Returns <code>true</code> if <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> equals to <code><a href=\"Time/Location.html#UTC\">Location::UTC</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L718","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L718","def":{"name":"utc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"location.utc?"}},{"id":"wednesday?:Bool-instance-method","html_id":"wednesday?:Bool-instance-method","name":"wednesday?","doc":"Returns `true` if the day of week is Wednesday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Wednesday.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L1138","def":{"name":"wednesday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"day_of_week.wednesday?"}},{"id":"year:Int32-instance-method","html_id":"year:Int32-instance-method","name":"year","doc":"Returns the year of the proleptic Georgian Calendar (`0..9999`).","summary":"<p>Returns the year of the proleptic Georgian Calendar (<code>0..9999</code>).</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L643","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L643","def":{"name":"year","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[0]"}},{"id":"zone:Time::Location::Zone-instance-method","html_id":"zone:Time::Location::Zone-instance-method","name":"zone","doc":"Returns the time zone in effect in `location` at this instant.","summary":"<p>Returns the time zone in effect in <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> at this instant.</p>","abstract":false,"args":[],"args_string":" : Time::Location::Zone","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L707","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L707","def":{"name":"zone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Location::Zone","visibility":"Public","body":"location.lookup(self)"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Time/DayOfWeek","path":"Time/DayOfWeek.html","kind":"enum","full_name":"Time::DayOfWeek","name":"DayOfWeek","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time.cr","line_number":270,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Sunday","name":"Sunday","value":"0","doc":null,"summary":null},{"id":"Monday","name":"Monday","value":"1","doc":null,"summary":null},{"id":"Tuesday","name":"Tuesday","value":"2","doc":null,"summary":null},{"id":"Wednesday","name":"Wednesday","value":"3","doc":null,"summary":null},{"id":"Thursday","name":"Thursday","value":"4","doc":null,"summary":null},{"id":"Friday","name":"Friday","value":"5","doc":null,"summary":null},{"id":"Saturday","name":"Saturday","value":"6","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`DayOfWeek` represents a day-of-week in the Gregorian calendar.\n\n```\ntime = Time.new(2016, 2, 15)\ntime.day_of_week # => Time::DayOfWeek::Monday\n```\n\nAlternatively, you can use question methods:\n\n```\ntime.friday? # => false\ntime.monday? # => true\n```","summary":"<p><code><a href=\"../Time/DayOfWeek.html\">DayOfWeek</a></code> represents a day-of-week in the Gregorian calendar.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"friday?-instance-method","html_id":"friday?-instance-method","name":"friday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L276","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L276","def":{"name":"friday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Friday"}},{"id":"monday?-instance-method","html_id":"monday?-instance-method","name":"monday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L272","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L272","def":{"name":"monday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Monday"}},{"id":"saturday?-instance-method","html_id":"saturday?-instance-method","name":"saturday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L277","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L277","def":{"name":"saturday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Saturday"}},{"id":"sunday?-instance-method","html_id":"sunday?-instance-method","name":"sunday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L271","def":{"name":"sunday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Sunday"}},{"id":"thursday?-instance-method","html_id":"thursday?-instance-method","name":"thursday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L275","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L275","def":{"name":"thursday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Thursday"}},{"id":"tuesday?-instance-method","html_id":"tuesday?-instance-method","name":"tuesday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L273","def":{"name":"tuesday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Tuesday"}},{"id":"wednesday?-instance-method","html_id":"wednesday?-instance-method","name":"wednesday?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L274","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr#L274","def":{"name":"wednesday?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Wednesday"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/EpochConverter","path":"Time/EpochConverter.html","kind":"module","full_name":"Time::EpochConverter","name":"EpochConverter","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/from_json.cr","line_number":252,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr"},{"filename":"json/to_json.cr","line_number":156,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/from_yaml.cr","line_number":220,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr"},{"filename":"yaml/to_yaml.cr","line_number":121,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Converter to be used with `JSON.mapping` and `YAML.mapping`\nto serialize a `Time` instance as the number of seconds\nsince the unix epoch. See `Time.epoch`.\n\n```\nrequire \"json\"\n\nclass Person\n  JSON.mapping({\n    birth_date: {type: Time, converter: Time::EpochConverter},\n  })\nend\n\nperson = Person.from_json(%({\"birth_date\": 1459859781}))\nperson.birth_date # => 2016-04-05 12:36:21 UTC\nperson.to_json    # => %({\"birth_date\":1459859781})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON.html#mapping-macro\">JSON.mapping</a></code> and <code><a href=\"../YAML.html#mapping-macro\">YAML.mapping</a></code> to serialize a <code><a href=\"../Time.html\">Time</a></code> instance as the number of seconds since the unix epoch.</p>","class_methods":[{"id":"from_json(value:JSON::PullParser):Time-class-method","html_id":"from_json(value:JSON::PullParser):Time-class-method","name":"from_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L253","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L253","def":{"name":"from_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.epoch(value.read_int)"}},{"id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","name":"from_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L221","def":{"name":"from_yaml","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.class}\")\nend\nTime.epoch(node.value.to_i)\n"}},{"id":"to_json(value:Time,json:JSON::Builder)-class-method","html_id":"to_json(value:Time,json:JSON::Builder)-class-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L157","def":{"name":"to_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.number(value.epoch)"}},{"id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-class-method","html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-class-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L122","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L122","def":{"name":"to_yaml","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(value.epoch)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/EpochMillisConverter","path":"Time/EpochMillisConverter.html","kind":"module","full_name":"Time::EpochMillisConverter","name":"EpochMillisConverter","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"json/from_json.cr","line_number":258,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr"},{"filename":"json/to_json.cr","line_number":179,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/from_yaml.cr","line_number":230,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr"},{"filename":"yaml/to_yaml.cr","line_number":127,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Converter to be used with `JSON.mapping` and `YAML.mapping`\nto serialize a `Time` instance as the number of milliseconds\nsince the unix epoch. See `Time.epoch_ms`.\n\n```\nrequire \"json\"\n\nclass Timestamp\n  JSON.mapping({\n    value: {type: Time, converter: Time::EpochMillisConverter},\n  })\nend\n\ntimestamp = Timestamp.from_json(%({\"value\": 1459860483856}))\ntimestamp.value   # => 2016-04-05 12:48:03.856 UTC\ntimestamp.to_json # => %({\"value\":1459860483856})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON.html#mapping-macro\">JSON.mapping</a></code> and <code><a href=\"../YAML.html#mapping-macro\">YAML.mapping</a></code> to serialize a <code><a href=\"../Time.html\">Time</a></code> instance as the number of milliseconds since the unix epoch.</p>","class_methods":[{"id":"from_json(value:JSON::PullParser):Time-class-method","html_id":"from_json(value:JSON::PullParser):Time-class-method","name":"from_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L259","def":{"name":"from_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.epoch_ms(value.read_int)"}},{"id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","name":"from_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L231","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L231","def":{"name":"from_yaml","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.class}\")\nend\nTime.epoch_ms(node.value.to_i64)\n"}},{"id":"to_json(value:Time,json:JSON::Builder)-class-method","html_id":"to_json(value:Time,json:JSON::Builder)-class-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L180","def":{"name":"to_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.number(value.epoch_ms)"}},{"id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-class-method","html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-class-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L128","def":{"name":"to_yaml","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(value.epoch_ms)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/FloatingTimeConversionError","path":"Time/FloatingTimeConversionError.html","kind":"class","full_name":"Time::FloatingTimeConversionError","name":"FloatingTimeConversionError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time.cr","line_number":201,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format","path":"Time/Format.html","kind":"struct","full_name":"Time::Format","name":"Format","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/format/pattern.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/pattern.cr"},{"filename":"time/format/formatter.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/formatter.cr"},{"filename":"time/format/parser.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/parser.cr"},{"filename":"time/format.cr","line_number":58,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr"},{"filename":"time/format/custom/rfc_2822.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr"},{"filename":"time/format/custom/http_date.cr","line_number":17,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr"},{"filename":"time/format/custom/iso_8601.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr"},{"filename":"time/format/custom/rfc_3339.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr"},{"filename":"time/format/custom/yaml_date.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr"},{"filename":"json/from_json.cr","line_number":245,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr"},{"filename":"json/to_json.cr","line_number":113,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/from_yaml.cr","line_number":210,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr"},{"filename":"yaml/to_yaml.cr","line_number":115,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"The [RFC 3339](https://tools.ietf.org/html/rfc3339) datetime format ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).","summary":"<p>The <a href=\"https://tools.ietf.org/html/rfc3339\" target=\"_blank\">RFC 3339</a> datetime format (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\" target=\"_blank\">ISO 8601</a> profile).</p>","class_methods":[],"constructors":[{"id":"new(pattern:String,location:Location?=nil)-class-method","html_id":"new(pattern:String,location:Location?=nil)-class-method","name":"new","doc":"Creates a new `Time::Format` with the given *pattern*. The given time\n*location* will be used when parsing a `Time` and no time zone is found in it.","summary":"<p>Creates a new <code><a href=\"../Time/Format.html\">Time::Format</a></code> with the given <em>pattern</em>.</p>","abstract":false,"args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"location","doc":null,"default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"args_string":"(pattern : String, location : Location? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L74","def":{"name":"new","args":[{"name":"pattern","doc":null,"default_value":"","external_name":"pattern","restriction":"String"},{"name":"location","doc":null,"default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(pattern, location)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"format(time:Time,io:IO)-instance-method","html_id":"format(time:Time,io:IO)-instance-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L92","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.visit(pattern)\nio\n"}},{"id":"format(time:Time):String-instance-method","html_id":"format(time:Time):String-instance-method","name":"format","doc":"Turns a `Time` into a `String`.","summary":"<p>Turns a <code><a href=\"../Time.html\">Time</a></code> into a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L85","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |str|\n  format(time, str)\nend"}},{"id":"from_json(pull:JSON::PullParser)-instance-method","html_id":"from_json(pull:JSON::PullParser)-instance-method","name":"from_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L246","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L246","def":{"name":"from_json","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string = pull.read_string\nparse(string, Time::Location::UTC)\n"}},{"id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-instance-method","html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-instance-method","name":"from_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L211","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L211","def":{"name":"from_yaml","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.class}\")\nend\nparse(node.value, Time::Location::UTC)\n"}},{"id":"parse(string,location=@location):Time-instance-method","html_id":"parse(string,location=@location):Time-instance-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"@location","external_name":"location","restriction":""}],"args_string":"(string, location = @location) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L78","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"@location","external_name":"location","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.visit(pattern)\nparser.time(location)\n"}},{"id":"pattern:String-instance-method","html_id":"pattern:String-instance-method","name":"pattern","doc":"Returns the string pattern of this format.","summary":"<p>Returns the string pattern of this format.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr#L70","def":{"name":"pattern","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@pattern"}},{"id":"to_json(value:Time,json:JSON::Builder)-instance-method","html_id":"to_json(value:Time,json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L114","def":{"name":"to_json","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(format(value)).to_json(json)"}},{"id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L116","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L116","def":{"name":"to_yaml","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Time"},{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.scalar(format(value))"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Time/Format/Error","path":"Time/Format/Error.html","kind":"class","full_name":"Time::Format::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/format.cr","line_number":66,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"Error raised when an invalid pattern is used.","summary":"<p>Error raised when an invalid pattern is used.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/HTTP_DATE","path":"Time/Format/HTTP_DATE.html","kind":"module","full_name":"Time::Format::HTTP_DATE","name":"HTTP_DATE","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/http_date.cr","line_number":18,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":null,"summary":null,"class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.\n\n*time* is always converted to UTC.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L29","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time.to_utc, io)\nformatter.rfc_2822(time_zone_gmt: true, two_digit_day: true)\nio\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.\n\n*time* is always converted to UTC.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L38","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse(string,location=Time::Location::UTC):Time-class-method","html_id":"parse(string,location=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"args_string":"(string, location = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/http_date.cr#L20","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.http_date\nparser.time(location)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/ISO_8601_DATE","path":"Time/Format/ISO_8601_DATE.html","kind":"module","full_name":"Time::Format::ISO_8601_DATE","name":"ISO_8601_DATE","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/iso_8601.cr","line_number":130,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 date format.","summary":"<p>The ISO 8601 date format.</p>","class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L139","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.year_month_day_iso_8601\nio\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L146","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L132","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L132","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.year_month_day_iso_8601\nparser.time(location)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/ISO_8601_DATE_TIME","path":"Time/Format/ISO_8601_DATE_TIME.html","kind":"module","full_name":"Time::Format::ISO_8601_DATE_TIME","name":"ISO_8601_DATE_TIME","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/iso_8601.cr","line_number":154,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 date time format.","summary":"<p>The ISO 8601 date time format.</p>","class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L163","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_3339\nio\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L170","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L156","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.date_time_iso_8601\nparser.time(location)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/ISO_8601_TIME","path":"Time/Format/ISO_8601_TIME.html","kind":"module","full_name":"Time::Format::ISO_8601_TIME","name":"ISO_8601_TIME","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/iso_8601.cr","line_number":178,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 time format.","summary":"<p>The ISO 8601 time format.</p>","class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L187","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L187","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.time_iso_8601\nio\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L194","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L180","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/iso_8601.cr#L180","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.time_iso_8601\nparser.time(location)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/RFC_2822","path":"Time/Format/RFC_2822.html","kind":"module","full_name":"Time::Format::RFC_2822","name":"RFC_2822","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/rfc_2822.cr","line_number":5,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":null,"summary":null,"class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L14","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_2822\nio\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L21","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse(string,kind=Time::Location::UTC):Time-class-method","html_id":"parse(string,kind=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"kind","doc":null,"default_value":"Time::Location::UTC","external_name":"kind","restriction":""}],"args_string":"(string, kind = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_2822.cr#L7","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"kind","doc":null,"default_value":"Time::Location::UTC","external_name":"kind","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.rfc_2822\nparser.time(kind)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/RFC_3339","path":"Time/Format/RFC_3339.html","kind":"module","full_name":"Time::Format::RFC_3339","name":"RFC_3339","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/rfc_3339.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":null,"summary":null,"class_methods":[{"id":"format(time:Time,io:IO,fraction_digits=nil)-class-method","html_id":"format(time:Time,io:IO,fraction_digits=nil)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"fraction_digits","doc":null,"default_value":"nil","external_name":"fraction_digits","restriction":""}],"args_string":"(time : Time, io : IO, fraction_digits = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L12","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"fraction_digits","doc":null,"default_value":"nil","external_name":"fraction_digits","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_3339(fraction_digits: fraction_digits)\nio\n"}},{"id":"format(time:Time,fraction_digits=nil)-class-method","html_id":"format(time:Time,fraction_digits=nil)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"fraction_digits","doc":null,"default_value":"nil","external_name":"fraction_digits","restriction":""}],"args_string":"(time : Time, fraction_digits = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L19","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"fraction_digits","doc":null,"default_value":"nil","external_name":"fraction_digits","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io, fraction_digits: fraction_digits)\nend"}},{"id":"parse(string,location=Time::Location::UTC):Time-class-method","html_id":"parse(string,location=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"args_string":"(string, location = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/rfc_3339.cr#L5","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"location","doc":null,"default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.rfc_3339\nparser.time(location)\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Format/YAML_DATE","path":"Time/Format/YAML_DATE.html","kind":"module","full_name":"Time::Format::YAML_DATE","name":"YAML_DATE","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"time/format/custom/yaml_date.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"Even though the standard library has Time parsers given a *fixed* format,\nthe format in YAML, http://yaml.org/type/timestamp.html,\ncan consist of just the date part, and following it any number of spaces,\nor 't', or 'T' can follow, with many optional components. So, we implement\nthis in a more efficient way to avoid parsing the same string with many\npossible formats (there's also no way to specify any number of spaces\nwith Time::Format, or an \"or\" like in a Regex).\n\nAs an additional note, Ruby's Psych YAML parser also implements a\ncustom time parser, probably for this same reason.","summary":"<p>Even though the standard library has Time parsers given a <em>fixed</em> format, the format in YAML, http://yaml.org/type/timestamp.html, can consist of just the date part, and following it any number of spaces, or 't', or 'T' can follow, with many optional components.</p>","class_methods":[{"id":"format(time:Time,io:IO)-class-method","html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L24","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"formatter = Formatter.new(time, io)\nif (((time.hour == 0) && (time.minute == 0)) && (time.second == 0)) && (time.nanosecond == 0)\n  formatter.year_month_day_iso_8601\nelse\n  formatter.yaml_date_time\nend\n"}},{"id":"format(time:Time)-class-method","html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L35","def":{"name":"format","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"id":"parse?(string):Time?-class-method","html_id":"parse?(string):Time?-class-method","name":"parse?","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string) : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/format/custom/yaml_date.cr#L14","def":{"name":"parse?","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"parser = Parser.new(string)\nif parser.yaml_date_time?\n  begin\n    parser.time(Time::Location::UTC)\n  rescue\n    nil\n  end\nelse\n  nil\nend\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Time/Location","path":"Time/Location.html","kind":"class","full_name":"Time::Location","name":"Location","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/location/loader.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location/loader.cr"},{"filename":"time/location.cr","line_number":49,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"UTC","name":"UTC","value":"new(\"UTC\", [Zone::UTC])","doc":"Describes the Coordinated Universal Time (UTC).\n\nThe only time zone offset in this location is `Zone::UTC`.","summary":"<p>Describes the Coordinated Universal Time (UTC).</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`Location` maps time instants to the zone in use at that time.\nIt typically represents the collection of time offsets observed in\na certain geographical area.\n\nIt contains a list of zone offsets and rules for transitioning between them.\n\nIf a location has only one offset (such as `UTC`) it is considerd\n*fixed*.\n\nA `Location` instance is usually retrieved by name using\n`Time::Location.load`.\nIt loads the zone offsets and transitioning rules from the time zone database\nprovided by the operating system.\n\n```\nlocation = Time::Location.load(\"Europe/Berlin\")\nlocation # => #<Time::Location Europe/Berlin>\ntime = Time.new(2016, 2, 15, 21, 1, 10, location: location)\ntime # => 2016-02-15 21:01:10 +01:00 Europe/Berlin\n```\n\nA custom time zone database can be configured through the environment variable\n`ZONEINFO`. See `.load` for details.\n\n### Fixed Offset\n\nA fixed offset location is created using `Time::Location.fixed`:\n\n```\nlocation = Time::Location.fixed(3600)\nlocation       # => #<Time::Location +01:00>\nlocation.zones # => [#<Time::Location::Zone +01:00 (0s) STD>]\n```\n\n\n### Local Time Zone\n\nThe local time zone can be accessed as `Time::Location.local`.\n\nIt is initially configured according to system environment settings,\nbut it's value can be changed:\n\n```\nlocation = Time::Location.local\nTime::Location.local = Time::Location.load(\"America/New_York\")\n```","summary":"<p><code><a href=\"../Time/Location.html\">Location</a></code> maps time instants to the zone in use at that time.</p>","class_methods":[{"id":"fixed(offset:Int32)-class-method","html_id":"fixed(offset:Int32)-class-method","name":"fixed","doc":"Creates a `Location` instance with fixed *offset* in seconds from UTC.\n\nThe formatted *offset* is used as name.","summary":"<p>Creates a <code><a href=\"../Time/Location.html\">Location</a></code> instance with fixed <em>offset</em> in seconds from UTC.</p>","abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"}],"args_string":"(offset : Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L226","def":{"name":"fixed","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"zone = Zone.new(nil, offset, false)\nnew(zone.name, [zone])\n"}},{"id":"local-class-method","html_id":"local-class-method","name":"local","doc":"Returns the `Location` representing the application's local time zone.\n\n`Time` uses this property as default value for most method arguments\nexpecting a `Location`.\n\nThe initial value depends on the current application environment, see\n`.load_local` for details.\n\nThe value can be changed to overwrite the system default:\n\n```\nTime.now.location # => #<Time::Location America/New_York>\nTime::Location.local = Time::Location.load(\"Europe/Berlin\")\nTime.now.location # => #<Time::Location Europe/Berlin>\n```","summary":"<p>Returns the <code><a href=\"../Time/Location.html\">Location</a></code> representing the application's local time zone.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L320","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L320","def":{"name":"local","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@local || (@@local = (load_local))"}},{"id":"local=(local:Location)-class-method","html_id":"local=(local:Location)-class-method","name":"local=","doc":null,"summary":null,"abstract":false,"args":[{"name":"local","doc":null,"default_value":"","external_name":"local","restriction":"Location"}],"args_string":"(local : Location)","source_link":null,"source_link":null,"def":{"name":"local=","args":[{"name":"local","doc":null,"default_value":"","external_name":"local","restriction":"Location"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@@local = local"}}],"constructors":[{"id":"fixed(name:String,offset:Int32):Location-class-method","html_id":"fixed(name:String,offset:Int32):Location-class-method","name":"fixed","doc":"Creates a `Location` instance named *name* with fixed *offset* in seconds\nfrom UTC.","summary":"<p>Creates a <code><a href=\"../Time/Location.html\">Location</a></code> instance named <em>name</em> with fixed <em>offset</em> in seconds from UTC.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"}],"args_string":"(name : String, offset : Int32) : Location","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L219","def":{"name":"fixed","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Location","visibility":"Public","body":"new(name, [Zone.new(name, offset, false)])"}},{"id":"load(name:String):Location-class-method","html_id":"load(name:String):Location-class-method","name":"load","doc":"Loads the `Location` with the given *name*.\n\n```\nlocation = Time::Location.load(\"Europe/Berlin\")\n```\n\n*name* is understood to be a location name in the IANA Time\nZone database, such as `\"America/New_York\"`. As special cases,\n`\"UTC\"` and empty string (`\"\"`) return `Location::UTC`, and\n`\"Local\"` returns `Location.local`.\n\nThe implementation uses a list of system-specifc paths to look for a time\nzone database.\nThe first time zone database entry matching the given name that is\nsuccessfully loaded and parsed is returned.\nTypical paths on Unix-based operating systems are `/usr/share/zoneinfo/`,\n`/usr/share/lib/zoneinfo/`, or `/usr/lib/locale/TZ/`.\n\nA time zone database may not be present on all systems, especially non-Unix\nsystems. In this case, you may need to distribute a copy of the database\nwith an application that depends on time zone data being available.\n\nA custom lookup path can be set as environment variable `ZONEINFO`.\nThe path can point to the root of a directory structure or an\nuncompressed ZIP file, each representing the time zone database using files\nand folders of the expected names.\n\nExample:\n\n```\n# This tries to load the file `/usr/share/zoneinfo/Custom/Location`\nENV[\"ZONEINFO\"] = \"/usr/share/zoneinfo/\"\nLocation.load(\"Custom/Location\")\n\n# This tries to load the file `Custom/Location` in the uncompressed ZIP\n# file at `/path/to/zoneinfo.zip`\nENV[\"ZONEINFO\"] = \"/path/to/zoneinfo.zip\"\nLocation.load(\"Custom/Location\")\n```\n\nIf the location name cannot be found, `InvalidLocationNameError` is raised.\nIf the loader encounters a format error in the time zone database,\n`InvalidTZDataError` is raised.\n\nFiles are cached based on the modification time, so subsequent request for\nthe same location name will most likely return the same instance of\n`Location`, unless the time zone database has been updated in between.","summary":"<p>Loads the <code><a href=\"../Time/Location.html\">Location</a></code> with the given <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Location","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L278","def":{"name":"load","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Location","visibility":"Public","body":"case name\nwhen \"\", \"UTC\"\n  UTC\nwhen \"Local\"\n  local\nwhen .includes?(\"..\"), .starts_with?('/'), .starts_with?('\\\\')\n  raise(InvalidLocationNameError.new(name))\nelse\n  if zoneinfo = ENV[\"ZONEINFO\"]?\n    if location = load_from_dir_or_zip(name, zoneinfo)\n      return location\n    else\n      raise(InvalidLocationNameError.new(name, zoneinfo))\n    end\n  end\n  if location = load(name, Crystal::System::Time.zone_sources)\n    return location\n  end\n  raise(InvalidLocationNameError.new(name))\nend"}},{"id":"load_local:Location-class-method","html_id":"load_local:Location-class-method","name":"load_local","doc":"Loads the local time zone according to the current application environment.\n\nThe environment variable `ENV[\"TZ\"]` is consulted for finding the time zone\nto use.\n\n* `\"UTC\"` and empty string (`\"\"`) return `Location::UTC`\n* Any other value (such as `\"Europe/Berlin\"`) is tried to be resolved using\n  `Location.load`.\n* If `ENV[\"TZ\"]` is not set, the system's local time zone data will be used\n  (`/etc/localtime` on unix-based systems).\n* If no time zone data could be found (i.e. the previous methods failed),\n  `Location::UTC` is returned.","summary":"<p>Loads the local time zone according to the current application environment.</p>","abstract":false,"args":[],"args_string":" : Location","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L334","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L334","def":{"name":"load_local","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Location","visibility":"Public","body":"case tz = ENV[\"TZ\"]?\nwhen \"\", \"UTC\"\n  UTC\nwhen Nil\n  if localtime = Crystal::System::Time.load_localtime\n    return localtime\n  end\nelse\n  if location = load?(tz, Crystal::System::Time.zone_sources)\n    return location\n  end\nend\nUTC\n"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":null,"source_link":null,"def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if name == other.name\nelse\n  return false\nend\nif zones == other.zones\nelse\n  return false\nend\nif transitions == other.transitions\nelse\n  return false\nend\ntrue\n"}},{"id":"fixed?:Bool-instance-method","html_id":"fixed?:Bool-instance-method","name":"fixed?","doc":"Returns `true` if this location has a fixed offset.","summary":"<p>Returns <code>true</code> if this location has a fixed offset.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L459","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L459","def":{"name":"fixed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"zones.size <= 1"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":null,"source_link":null,"def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = name.hash(hasher)\nhasher = zones.hash(hasher)\nhasher = transitions.hash(hasher)\nhasher\n"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L366","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L366","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<Time::Location \"\nto_s(io)\nio << '>'\n"}},{"id":"local?:Bool-instance-method","html_id":"local?:Bool-instance-method","name":"local?","doc":"Returns `true` if this location equals to `Time::Location.local`.","summary":"<p>Returns <code>true</code> if this location equals to <code><a href=\"../Time/Location.html#local-class-method\">Time::Location.local</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L454","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L454","def":{"name":"local?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"self == Location.local"}},{"id":"lookup(time:Time):Zone-instance-method","html_id":"lookup(time:Time):Zone-instance-method","name":"lookup","doc":"Returns the time zone offset observed at *time*.","summary":"<p>Returns the time zone offset observed at <em>time</em>.</p>","abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : Zone","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L379","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L379","def":{"name":"lookup","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Zone","visibility":"Public","body":"lookup(time.epoch)"}},{"id":"lookup(epoch:Int):Zone-instance-method","html_id":"lookup(epoch:Int):Zone-instance-method","name":"lookup","doc":"Returns the time zone offset observed at *epoch*.\n\n*epoch* expresses the number of seconds since UNIX epoch\n(`1970-01-01 00:00:00 UTC`).","summary":"<p>Returns the time zone offset observed at <em>epoch</em>.</p>","abstract":false,"args":[{"name":"epoch","doc":null,"default_value":"","external_name":"epoch","restriction":"Int"}],"args_string":"(epoch : Int) : Zone","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L387","def":{"name":"lookup","args":[{"name":"epoch","doc":null,"default_value":"","external_name":"epoch","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Zone","visibility":"Public","body":"if @cached_range[0] <= epoch && epoch < @cached_range[1]\nelse\n  @cached_zone, @cached_range = lookup_with_boundaries(epoch)\nend\n@cached_zone\n"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":"Returns the name of this location.\n\nIt usually consists of a continent and city name separated by a slash, for\nexample `Europe/Berlin`.","summary":"<p>Returns the name of this location.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L202","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Prints `name` to *io*.","summary":"<p>Prints <code><a href=\"../Time/Location.html#name%3AString-instance-method\">#name</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L362","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L362","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << name"}},{"id":"utc?:Bool-instance-method","html_id":"utc?:Bool-instance-method","name":"utc?","doc":"Returns `true` if this location equals to `UTC`.","summary":"<p>Returns <code>true</code> if this location equals to <code><a href=\"../Time/Location.html#UTC\">UTC</a></code>.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L449","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L449","def":{"name":"utc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"self == UTC"}},{"id":"zones:Array(Zone)-instance-method","html_id":"zones:Array(Zone)-instance-method","name":"zones","doc":"Returns the array of time zone offsets (`Zone`) used in this time zone.","summary":"<p>Returns the array of time zone offsets (<code><a href=\"../Time/Location/Zone.html\">Zone</a></code>) used in this time zone.</p>","abstract":false,"args":[],"args_string":" : Array(Zone)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L205","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L205","def":{"name":"zones","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Zone)","visibility":"Public","body":"@zones"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidLocationNameError","path":"Time/Location/InvalidLocationNameError.html","kind":"class","full_name":"Time::Location::InvalidLocationNameError","name":"InvalidLocationNameError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/location.cr","line_number":54,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidLocationNameError` is raised if a location name cannot be found in\nthe time zone database.\n\nSee `Time::Location.load` for details.","summary":"<p><code><a href=\"../../Time/Location/InvalidLocationNameError.html\">InvalidLocationNameError</a></code> is raised if a location name cannot be found in the time zone database.</p>","class_methods":[],"constructors":[{"id":"new(name:String,source:String?=nil)-class-method","html_id":"new(name:String,source:String?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"source","doc":null,"default_value":"nil","external_name":"source","restriction":"String | ::Nil"}],"args_string":"(name : String, source : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L57","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"source","doc":null,"default_value":"nil","external_name":"source","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, source)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L55","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@name"}},{"id":"source:String?-instance-method","html_id":"source:String?-instance-method","name":"source","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L55","def":{"name":"source","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@source"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidTimezoneOffsetError","path":"Time/Location/InvalidTimezoneOffsetError.html","kind":"class","full_name":"Time::Location::InvalidTimezoneOffsetError","name":"InvalidTimezoneOffsetError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/location.cr","line_number":66,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidTimezoneOffsetError` is raised if `Time::Location::Zone.new`\nreceives an invalid time zone offset.","summary":"<p><code><a href=\"../../Time/Location/InvalidTimezoneOffsetError.html\">InvalidTimezoneOffsetError</a></code> is raised if <code>Time::Location::Zone.new</code> receives an invalid time zone offset.</p>","class_methods":[],"constructors":[{"id":"new(offset:Int)-class-method","html_id":"new(offset:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L67","def":{"name":"new","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(offset)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Location/InvalidTZDataError","path":"Time/Location/InvalidTZDataError.html","kind":"class","full_name":"Time::Location::InvalidTZDataError","name":"InvalidTZDataError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/location/loader.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location/loader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidTZDataError` is raised if a zoneinfo file contains invalid\ntime zone data.\n\nDetails on the exact cause can be found in the error message.","summary":"<p><code><a href=\"../../Time/Location/InvalidTZDataError.html\">InvalidTZDataError</a></code> is raised if a zoneinfo file contains invalid time zone data.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Location/Zone","path":"Time/Location/Zone.html","kind":"struct","full_name":"Time::Location::Zone","name":"Zone","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/location.cr","line_number":76,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"UTC","name":"UTC","value":"new(\"UTC\", 0, false)","doc":"This is the `UTC` time zone with offset `+00:00`.\n\nIt is the only zone offset used in `Time::Location::UTC`.","summary":"<p>This is the <code><a href=\"../../Time/Location/Zone.html#UTC\">UTC</a></code> time zone with offset <code>+00:00</code>.</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"A `Zone` represents a time zone offset in effect in a specific `Location`.\n\nSome zones have a `name` or abbreviation (such as `PDT`, `CEST`).\nFor an unnamed zone the formatted offset should be used as name.","summary":"<p>A <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> represents a time zone offset in effect in a specific <code><a href=\"../../Time/Location.html\">Location</a></code>.</p>","class_methods":[],"constructors":[{"id":"new(name:String?,offset:Int32,dst:Bool)-class-method","html_id":"new(name:String?,offset:Int32,dst:Bool)-class-method","name":"new","doc":"Creates a new `Zone` named *name* with *offset* from UTC in seconds.\nThe parameter *dst* is used to declare this zone as daylight savings time.\n\nIf `name` is `nil`, the formatted `offset` will be used as `name` (see\n`#format`).\n\nRaises `InvalidTimezoneOffsetError` if *seconds* is outside the supported\nvalue range `-86_400..86_400` seconds (`-24:00` to `+24:00`).","summary":"<p>Creates a new <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> named <em>name</em> with <em>offset</em> from UTC in seconds.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":"Bool"}],"args_string":"(name : String?, offset : Int32, dst : Bool)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L96","def":{"name":"new","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String | ::Nil"},{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":"Int32"},{"name":"dst","doc":null,"default_value":"","external_name":"dst","restriction":"Bool"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(name, offset, dst)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"dst?:Bool-instance-method","html_id":"dst?:Bool-instance-method","name":"dst?","doc":"Returns `true` if this zone offset is daylight savings time.","summary":"<p>Returns <code>true</code> if this zone offset is daylight savings time.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L86","def":{"name":"dst?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"@dst"}},{"id":"format(io:IO,with_colon=true,with_seconds=:auto)-instance-method","html_id":"format(io:IO,with_colon=true,with_seconds=:auto)-instance-method","name":"format","doc":"Prints `#offset` to *io* in the format `+HH:mm:ss`.\nWhen *with_colon* is `false`, the format is `+HHmmss`.\n\nWhen *with_seconds* is `false`, seconds are omitted; when `:auto`, seconds\nare ommitted if `0`.","summary":"<p>Prints <code><a href=\"../../Time/Location/Zone.html#offset%3AInt32-instance-method\">#offset</a></code> to <em>io</em> in the format <code>+HH:mm:ss</code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"with_colon","doc":null,"default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","doc":null,"default_value":":auto","external_name":"with_seconds","restriction":""}],"args_string":"(io : IO, with_colon = <span class=\"n\">true</span>, with_seconds = <span class=\"n\">:auto</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L130","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L130","def":{"name":"format","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"with_colon","doc":null,"default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","doc":null,"default_value":":auto","external_name":"with_seconds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"sign, hours, minutes, seconds = sign_hours_minutes_seconds\nio << sign\nif hours < 10\n  io << '0'\nend\nio << hours\nif with_colon\n  io << ':'\nend\nif minutes < 10\n  io << '0'\nend\nio << minutes\nif (with_seconds == true) || ((seconds != 0) && (with_seconds == (:auto)))\n  if with_colon\n    io << ':'\n  end\n  if seconds < 10\n    io << '0'\n  end\n  io << seconds\nend\n"}},{"id":"format(with_colon=true,with_seconds=:auto)-instance-method","html_id":"format(with_colon=true,with_seconds=:auto)-instance-method","name":"format","doc":"Returns the `#offset` formatted as `+HH:mm:ss`.\nWhen *with_colon* is `false`, the format is `+HHmmss`.\n\nWhen *with_seconds* is `false`, seconds are omitted; when `:auto`, seconds\nare ommitted if `0`.","summary":"<p>Returns the <code><a href=\"../../Time/Location/Zone.html#offset%3AInt32-instance-method\">#offset</a></code> formatted as <code>+HH:mm:ss</code>.</p>","abstract":false,"args":[{"name":"with_colon","doc":null,"default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","doc":null,"default_value":":auto","external_name":"with_seconds","restriction":""}],"args_string":"(with_colon = <span class=\"n\">true</span>, with_seconds = <span class=\"n\">:auto</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L152","def":{"name":"format","args":[{"name":"with_colon","doc":null,"default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","doc":null,"default_value":":auto","external_name":"with_seconds","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  format(io, with_colon: with_colon, with_seconds: with_seconds)\nend"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Prints this `Zone` to *io*.\n\nIt contains the `name`, hour-minute-second format (see `#format`),\n`offset` in seconds and `\"DST\"` if `#dst?`, otherwise `\"STD\"`.","summary":"<p>Prints this <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L112","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"Time::Location::Zone(\"\nif @name.nil?\nelse\n  (io << @name) << ' '\nend\nformat(io)\n((io << \" (\") << offset) << \"s)\"\nif dst?\n  io << \" DST\"\nelse\n  io << \" STD\"\nend\nio << ')'\n"}},{"id":"name:String-instance-method","html_id":"name:String-instance-method","name":"name","doc":"Returns the name of the zone.","summary":"<p>Returns the name of the zone.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L104","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@name || format"}},{"id":"offset:Int32-instance-method","html_id":"offset:Int32-instance-method","name":"offset","doc":"Returns the offset from UTC in seconds.","summary":"<p>Returns the offset from UTC in seconds.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/location.cr#L83","def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@offset"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Time/MonthSpan","path":"Time/MonthSpan.html","kind":"struct","full_name":"Time::MonthSpan","name":"MonthSpan","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/span.cr","line_number":535,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Represents a number of months passed. Used for shifting `Time`s by a\nspecified number of months.\n\n```\nTime.new(2016, 2, 1) + 13.months # => 2017-03-01 00:00:00\nTime.new(2016, 2, 29) + 2.years  # => 2018-02-28 00:00:00\n```","summary":"<p>Represents a number of months passed.</p>","class_methods":[],"constructors":[{"id":"new(value:Int)-class-method","html_id":"new(value:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Int"}],"args_string":"(value : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L539","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L539","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"ago:Time-instance-method","html_id":"ago:Time-instance-method","name":"ago","doc":"Returns a `Time` that happens N months before now.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens N months before now.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L549","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L549","def":{"name":"ago","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.now - self"}},{"id":"from_now:Time-instance-method","html_id":"from_now:Time-instance-method","name":"from_now","doc":"Returns a `Time` that happens N months after now.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens N months after now.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L544","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L544","def":{"name":"from_now","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.now + self"}},{"id":"value:Int64-instance-method","html_id":"value:Int64-instance-method","name":"value","doc":"The number of months.","summary":"<p>The number of months.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L537","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L537","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Time/Span","path":"Time/Span.html","kind":"struct","full_name":"Time::Span","name":"Span","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"time/span.cr","line_number":39,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"new(seconds: Int64::MAX, nanoseconds: 999999999)","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"new(seconds: Int64::MIN, nanoseconds: -999999999)","doc":null,"summary":null},{"id":"ZERO","name":"ZERO","value":"new(nanoseconds: 0)","doc":null,"summary":null}],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`Time::Span` represents one period of time.\n\nA `Time::Span` initializes with the specified period.\nDifferent numbers of arguments generate a `Time::Span` in different length.\nCheck all `#new` methods for details.\n\n```\nTime::Span.new(nanoseconds: 10_000) # => 00:00:00.000010000\nTime::Span.new(10, 10, 10)          # => 10:10:10\nTime::Span.new(10, 10, 10, 10)      # => 10.10:10:10\n```\n\nCalculation between `Time` also returns a `Time::Span`.\n\n```\nspan = Time.new(2015, 10, 10) - Time.new(2015, 9, 10)\nspan       # => 30.00:00:00\nspan.class # => Time::Span\n```\n\nInspection:\n\n```\nspan = Time::Span.new(20, 10, 10)\nspan.hours   # => 20\nspan.minutes # => 10\nspan.seconds # => 10\n```\n\nCalculation:\n\n```\na = Time::Span.new(20, 10, 10)\nb = Time::Span.new(10, 10, 10)\nc = a - b # => 10:00:00\nc.hours   # => 10\n```\n","summary":"<p><code><a href=\"../Time/Span.html\">Time::Span</a></code> represents one period of time.</p>","class_methods":[{"id":"zero:Time::Span-class-method","html_id":"zero:Time::Span-class-method","name":"zero","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L387","def":{"name":"zero","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"ZERO"}}],"constructors":[{"id":"new(days:Int,hours:Int,minutes:Int,seconds:Int,nanoseconds:Int=0)-class-method","html_id":"new(days:Int,hours:Int,minutes:Int,seconds:Int,nanoseconds:Int=0)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"days","doc":null,"default_value":"","external_name":"days","restriction":"Int"},{"name":"hours","doc":null,"default_value":"","external_name":"hours","restriction":"Int"},{"name":"minutes","doc":null,"default_value":"","external_name":"minutes","restriction":"Int"},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(days : Int, hours : Int, minutes : Int, seconds : Int, nanoseconds : Int = <span class=\"n\">0</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L60","def":{"name":"new","args":[{"name":"days","doc":null,"default_value":"","external_name":"days","restriction":"Int"},{"name":"hours","doc":null,"default_value":"","external_name":"hours","restriction":"Int"},{"name":"minutes","doc":null,"default_value":"","external_name":"minutes","restriction":"Int"},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(seconds: compute_seconds!(days, hours, minutes, seconds), nanoseconds: nanoseconds.to_i64)"}},{"id":"new(hours:Int,minutes:Int,seconds:Int)-class-method","html_id":"new(hours:Int,minutes:Int,seconds:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"hours","doc":null,"default_value":"","external_name":"hours","restriction":"Int"},{"name":"minutes","doc":null,"default_value":"","external_name":"minutes","restriction":"Int"},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"}],"args_string":"(hours : Int, minutes : Int, seconds : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L56","def":{"name":"new","args":[{"name":"hours","doc":null,"default_value":"","external_name":"hours","restriction":"Int"},{"name":"minutes","doc":null,"default_value":"","external_name":"minutes","restriction":"Int"},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(0, hours, minutes, seconds)"}},{"id":"new(*,seconds:Int,nanoseconds:Int)-class-method","html_id":"new(*,seconds:Int,nanoseconds:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, seconds : Int, nanoseconds : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L67","def":{"name":"new","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"seconds","doc":null,"default_value":"","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(seconds: seconds, nanoseconds: nanoseconds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(*,nanoseconds:Int)-class-method","html_id":"new(*,nanoseconds:Int)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, nanoseconds : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L87","def":{"name":"new","args":[{"name":"","doc":null,"default_value":"","external_name":"","restriction":""},{"name":"nanoseconds","doc":null,"default_value":"","external_name":"nanoseconds","restriction":"Int"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(seconds: nanoseconds.to_i64.tdiv(NANOSECONDS_PER_SECOND), nanoseconds: nanoseconds.to_i64.remainder(NANOSECONDS_PER_SECOND))"}}],"instance_methods":[{"id":"*(number:Float):Time::Span-instance-method","html_id":"*(number:Float):Time::Span-instance-method","name":"*","doc":"Returns a `Time::Span` that is *number* times longer.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is <em>number</em> times longer.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"args_string":"(number : Float) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L308","def":{"name":"*","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(total_nanoseconds * number).nanoseconds"}},{"id":"*(number:Int):Time::Span-instance-method","html_id":"*(number:Int):Time::Span-instance-method","name":"*","doc":"Returns a `Time::Span` that is *number* times longer.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is <em>number</em> times longer.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"args_string":"(number : Int) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L299","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L299","def":{"name":"*","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i * number, nanoseconds: nanoseconds.to_i64 * number)"}},{"id":"+:self-instance-method","html_id":"+:self-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L294","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L294","def":{"name":"+","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"self"}},{"id":"+(other:self):Time::Span-instance-method","html_id":"+(other:self):Time::Span-instance-method","name":"+","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L286","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L286","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i + other.to_i, nanoseconds: nanoseconds + other.nanoseconds)"}},{"id":"-:Time::Span-instance-method","html_id":"-:Time::Span-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L278","def":{"name":"-","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: -to_i, nanoseconds: -nanoseconds)"}},{"id":"-(other:self):Time::Span-instance-method","html_id":"-(other:self):Time::Span-instance-method","name":"-","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L270","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i - other.to_i, nanoseconds: nanoseconds - other.nanoseconds)"}},{"id":"/(other:self):Float64-instance-method","html_id":"/(other:self):Float64-instance-method","name":"/","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L332","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L332","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_nanoseconds.to_f64 / other.total_nanoseconds.to_f64"}},{"id":"/(number:Float):Time::Span-instance-method","html_id":"/(number:Float):Time::Span-instance-method","name":"/","doc":"Returns a `Time::Span` that is divided by *number*.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is divided by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"args_string":"(number : Float) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L328","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L328","def":{"name":"/","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Float"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"(total_nanoseconds / number).nanoseconds"}},{"id":"/(number:Int):Time::Span-instance-method","html_id":"/(number:Int):Time::Span-instance-method","name":"/","doc":"Returns a `Time::Span` that is divided by *number*.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is divided by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"args_string":"(number : Int) : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L313","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L313","def":{"name":"/","args":[{"name":"number","doc":null,"default_value":"","external_name":"number","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"seconds = to_i.tdiv(number)\nnanoseconds = self.nanoseconds.tdiv(number)\nremainder = to_i.remainder(number)\nnanoseconds = nanoseconds + ((remainder * NANOSECONDS_PER_SECOND) / number)\nSpan.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"id":"(other:self)-instance-method","html_id":"(other:self)-instance-method","name":"<=>","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L336","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L336","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"cmp = to_i <=> other.to_i\nif cmp == 0\n  cmp = nanoseconds <=> other.nanoseconds\nend\ncmp\n"}},{"id":"abs:Time::Span-instance-method","html_id":"abs:Time::Span-instance-method","name":"abs","doc":"Returns the absolute (non-negative) amount of time this `Time::Span`\nrepresents by removing the sign.","summary":"<p>Returns the absolute (non-negative) amount of time this <code><a href=\"../Time/Span.html\">Time::Span</a></code> represents by removing the sign.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L256","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i.abs, nanoseconds: nanoseconds.abs)"}},{"id":"ago:Time-instance-method","html_id":"ago:Time-instance-method","name":"ago","doc":"Returns a `Time` that happens earlier by `self` than the current time.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens earlier by <code>self</code> than the current time.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L266","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L266","def":{"name":"ago","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.now - self"}},{"id":"days:Int64-instance-method","html_id":"days:Int64-instance-method","name":"days","doc":"Returns the number of full days in this time span.\n\n```\n(5.days + 25.hours).days # => 6_i64\n```","summary":"<p>Returns the number of full days in this time span.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L156","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L156","def":{"name":"days","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"to_i.tdiv(SECONDS_PER_DAY)"}},{"id":"duration:Time::Span-instance-method","html_id":"duration:Time::Span-instance-method","name":"duration","doc":"Alias of `abs`.","summary":"<p>Alias of <code><a href=\"../Time/Span.html#abs%3ATime%3A%3ASpan-instance-method\">#abs</a></code>.</p>","abstract":false,"args":[],"args_string":" : Time::Span","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L250","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L250","def":{"name":"duration","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time::Span","visibility":"Public","body":"abs"}},{"id":"from_now:Time-instance-method","html_id":"from_now:Time-instance-method","name":"from_now","doc":"Returns a `Time` that happens later by `self` than the current time.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens later by <code>self</code> than the current time.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L261","def":{"name":"from_now","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"Time.now + self"}},{"id":"hours:Int32-instance-method","html_id":"hours:Int32-instance-method","name":"hours","doc":"Returns the number of full hours of the day (`0..23`) in this time span.","summary":"<p>Returns the number of full hours of the day (<code>0..23</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L161","def":{"name":"hours","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"((to_i.remainder(SECONDS_PER_DAY)).tdiv(SECONDS_PER_HOUR)).to_i"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L342","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if to_i < 0 || nanoseconds < 0\n  io << '-'\nend\nif days != 0\n  io << days.abs\n  io << '.'\nend\nhours = self.hours.abs\nif hours < 10\n  io << '0'\nend\nio << hours\nio << ':'\nminutes = self.minutes.abs\nif minutes < 10\n  io << '0'\nend\nio << minutes\nio << ':'\nseconds = self.seconds.abs\nif seconds < 10\n  io << '0'\nend\nio << seconds\nnanoseconds = self.nanoseconds.abs\nif nanoseconds != 0\n  io << '.'\n  if nanoseconds < 100000000\n    io << '0'\n  end\n  if nanoseconds < 10000000\n    io << '0'\n  end\n  if nanoseconds < 1000000\n    io << '0'\n  end\n  if nanoseconds < 100000\n    io << '0'\n  end\n  if nanoseconds < 10000\n    io << '0'\n  end\n  if nanoseconds < 1000\n    io << '0'\n  end\n  if nanoseconds < 100\n    io << '0'\n  end\n  if nanoseconds < 10\n    io << '0'\n  end\n  io << nanoseconds\nend\n"}},{"id":"microseconds:Int32-instance-method","html_id":"microseconds:Int32-instance-method","name":"microseconds","doc":"Returns the number of microseconds of the second (`0..999999`) in this time span.","summary":"<p>Returns the number of microseconds of the second (<code>0..999999</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L186","def":{"name":"microseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"nanoseconds / NANOSECONDS_PER_MICROSECOND"}},{"id":"milliseconds:Int32-instance-method","html_id":"milliseconds:Int32-instance-method","name":"milliseconds","doc":"Returns the number of milliseconds of the second (`0..999`) in this time span.","summary":"<p>Returns the number of milliseconds of the second (<code>0..999</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L181","def":{"name":"milliseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"nanoseconds / NANOSECONDS_PER_MILLISECOND"}},{"id":"minutes:Int32-instance-method","html_id":"minutes:Int32-instance-method","name":"minutes","doc":"Returns the number of full minutes of the hour (`0..59`) in this time span.","summary":"<p>Returns the number of full minutes of the hour (<code>0..59</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L168","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L168","def":{"name":"minutes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"((to_i.remainder(SECONDS_PER_HOUR)).tdiv(SECONDS_PER_MINUTE)).to_i"}},{"id":"nanoseconds:Int32-instance-method","html_id":"nanoseconds:Int32-instance-method","name":"nanoseconds","doc":"Returns the number of nanoseconds of the second (`0..999_999_999`)\nin this time span.","summary":"<p>Returns the number of nanoseconds of the second (<code>0..999_999_999</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L192","def":{"name":"nanoseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@nanoseconds"}},{"id":"seconds:Int32-instance-method","html_id":"seconds:Int32-instance-method","name":"seconds","doc":"Returns the number of full seconds of the minute (`0..59`) in this time span.","summary":"<p>Returns the number of full seconds of the minute (<code>0..59</code>) in this time span.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L175","def":{"name":"seconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"(to_i.remainder(SECONDS_PER_MINUTE)).to_i"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Alias of `total_seconds`.","summary":"<p>Alias of <code><a href=\"../Time/Span.html#total_seconds%3AFloat64-instance-method\">#total_seconds</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L240","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L240","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_seconds"}},{"id":"to_i:Int64-instance-method","html_id":"to_i:Int64-instance-method","name":"to_i","doc":"Returns the number of full seconds.","summary":"<p>Returns the number of full seconds.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L245","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L245","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@seconds"}},{"id":"total_days:Float64-instance-method","html_id":"total_days:Float64-instance-method","name":"total_days","doc":"Converts to a (possibly fractional) number of days.\n\n```\n(36.hours).total_days # => 1.5\n```","summary":"<p>Converts to a (possibly fractional) number of days.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L210","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L210","def":{"name":"total_days","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_hours / 24"}},{"id":"total_hours:Float64-instance-method","html_id":"total_hours:Float64-instance-method","name":"total_hours","doc":"Converts to a (possibly fractional) number of hours.","summary":"<p>Converts to a (possibly fractional) number of hours.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L215","def":{"name":"total_hours","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_minutes / 60"}},{"id":"total_milliseconds:Float64-instance-method","html_id":"total_milliseconds:Float64-instance-method","name":"total_milliseconds","doc":"Converts to a number of milliseconds.","summary":"<p>Converts to a number of milliseconds.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L235","def":{"name":"total_milliseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_nanoseconds / NANOSECONDS_PER_MILLISECOND"}},{"id":"total_minutes:Float64-instance-method","html_id":"total_minutes:Float64-instance-method","name":"total_minutes","doc":"Converts to a (possibly fractional) number of minutes.","summary":"<p>Converts to a (possibly fractional) number of minutes.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L220","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L220","def":{"name":"total_minutes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_seconds / 60"}},{"id":"total_nanoseconds:Float64-instance-method","html_id":"total_nanoseconds:Float64-instance-method","name":"total_nanoseconds","doc":"Converts to a number of nanoseconds.","summary":"<p>Converts to a number of nanoseconds.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L230","def":{"name":"total_nanoseconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"(to_i.to_f * NANOSECONDS_PER_SECOND) + nanoseconds"}},{"id":"total_seconds:Float64-instance-method","html_id":"total_seconds:Float64-instance-method","name":"total_seconds","doc":"Converts to a (possibly fractional) number of seconds.","summary":"<p>Converts to a (possibly fractional) number of seconds.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L225","def":{"name":"total_seconds","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"to_i.to_f + (nanoseconds.to_f / NANOSECONDS_PER_SECOND)"}},{"id":"total_weeks:Float64-instance-method","html_id":"total_weeks:Float64-instance-method","name":"total_weeks","doc":"Converts to a (possibly fractional) number of weeks.\n\n```\n(4.weeks + 5.days + 6.hours).total_weeks # => 4.75\n```","summary":"<p>Converts to a (possibly fractional) number of weeks.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L201","def":{"name":"total_weeks","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"total_days / 7"}},{"id":"zero?:Bool-instance-method","html_id":"zero?:Bool-instance-method","name":"zero?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L391","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/time/span.cr#L391","def":{"name":"zero?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"(to_i == 0) && (nanoseconds == 0)"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Tuple","path":"Tuple.html","kind":"struct","full_name":"Tuple(*T)","name":"Tuple","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"tuple.cr","line_number":65,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr"},{"filename":"json/to_json.cr","line_number":91,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr"},{"filename":"yaml/to_yaml.cr","line_number":42,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A tuple is a fixed-size, immutable, stack-allocated sequence of values\nof possibly different types.\n\nYou can think of a `Tuple` as an immutable `Array` whose types for each position\nare known at compile time.\n\nA tuple can be created with the usual `new` method or with a tuple literal:\n\n```\ntuple = {1, \"hello\", 'x'} # Tuple(Int32, String, Char)\ntuple[0]                  # => 1\ntuple[1]                  # => \"hello\"\ntuple[2]                  # => 'x'\n```\n\nThe compiler knows what types are in each position, so when indexing\na tuple with an integer literal the compiler will return\nthe value in that index and with the expected type, like in the above\nsnippet. Indexing with an integer literal outside the bounds of the tuple\nwill give a compile-time error.\n\nIndexing with an integer value that is only known at runtime will return\na value whose type is the union of all the types in the tuple, and might raise\n`IndexError`.\n\nTuples are the preferred way to return fixed-size multiple return\nvalues because no memory is needed to be allocated for them:\n\n```\ndef one_and_hello\n  {1, \"hello\"}\nend\n\none, hello = one_and_hello\none   # => 1\nhello # => \"hello\"\n```\n\nGood examples of the above are `Number#divmod` and `Enumerable#minmax`.\n\nTuples can be splat with the `*` operator and passed to methods:\n\n```\ndef multiply(string, value)\n  string * value\nend\n\ntuple = {\"hey\", 2}\nvalue = multiply(*tuple) # same as multiply tuple[0], tuple[1]\nvalue                    # => \"heyhey\"\n```\n\nFinally, when using a splat argument in a method definition its type\nwill be a tuple of the call arguments:\n\n```\ndef splat_test(*args)\n  args\nend\n\ntuple = splat_test 1, \"hello\", 'x'\ntuple.class # => Tuple(Int32, String, Char)\ntuple       # => {1, \"hello\", 'x'}\n```","summary":"<p>A tuple is a fixed-size, immutable, stack-allocated sequence of values of possibly different types.</p>","class_methods":[{"id":"types-class-method","html_id":"types-class-method","name":"types","doc":"Returns the types of this tuple type.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.class.types # => {Int32, String, Char}\n```","summary":"<p>Returns the types of this tuple type.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L370","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L370","def":{"name":"types","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Tuple.new(*{{ T }})"}}],"constructors":[{"id":"from(array:Array):self-class-method","html_id":"from(array:Array):self-class-method","name":"from","doc":"Creates a tuple from the given array, with elements casted to the given types.\n\n```\nTuple(String, Int64).from([\"world\", 2])       # => {\"world\", 2}\nTuple(String, Int64).from([\"world\", 2]).class # => {String, Int64}\n```\n\nSee also: `#from`.","summary":"<p>Creates a tuple from the given array, with elements casted to the given types.</p>","abstract":false,"args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array"}],"args_string":"(array : Array) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L92","def":{"name":"from","args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"{% if true %}\n    Tuple.new(*{{ T }}).from(array)\n    {% end %}"}},{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L117","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L117","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.class}\")\nend\nif node.nodes.size != ({{ T.size }})\n  node.raise(\"Expected #{{{ T.size }}} elements, not #{node.nodes.size}\")\nend\n{% if true %}\n    Tuple.new(\n      {% for i in 0...T.size %}\n        (self[{{ i }}].new(ctx, node.nodes[{{ i }}])),\n      {% end %}\n    )\n {% end %}\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L135","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n    pull.read_begin_array\n    value = Tuple.new(\n      {% for i in 0...T.size %}\n        (self[{{ i }}].new(pull)),\n      {% end %}\n    )\n    pull.read_end_array\n    value\n {% end %}"}},{"id":"new(*args:*T)-class-method","html_id":"new(*args:*T)-class-method","name":"new","doc":"Creates a tuple that will contain the given arguments.\n\nThis method is useful in macros and generic code because with it you can\ncreates empty tuples, something that you can't do with a tuple literal.\n\n```\nTuple.new(1, \"hello\", 'x') #=> {1, \"hello\", 'x'}\nTuple.new                  #=> {}\n\n{}                         # syntax error\n```","summary":"<p>Creates a tuple that will contain the given arguments.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*T"}],"args_string":"(*args : *T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L80","def":{"name":"new","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":"*T"}],"double_splat":null,"splat_index":0,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"args"}}],"instance_methods":[{"id":"+(other:Tuple)-instance-method","html_id":"+(other:Tuple)-instance-method","name":"+","doc":"Returns a tuple that contains `self`'s elements followed by *other*'s elements.\n\n```\nt1 = {1, 2}\nt2 = {\"foo\", \"bar\"}\nt3 = t1 + t2\nt3         # => {1, 2, \"foo\", \"bar\"}\ntypeof(t3) # => Tuple(Int32, Int32, String, String)\n```","summary":"<p>Returns a tuple that contains <code>self</code>'s elements followed by <em>other</em>'s elements.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L338","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L338","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"plus_implementation(other)"}},{"id":"(other:self)-instance-method","html_id":"(other:self)-instance-method","name":"<=>","doc":"Implements the comparison operator.\n\nEach object in each tuple is compared (using the `<=>` operator).\n\nTuples are compared in an \"element-wise\" manner; the first element of this tuple is\ncompared with the first one of *other* using the `<=>` operator, then each of the second elements,\netc. As soon as the result of any such comparison is non zero\n(i.e. the two corresponding elements are not equal), that result is returned for the whole tuple comparison.\n\nIf all the elements are equal, then the result is based on a comparison of the tuple sizes.\nThus, two tuples are \"equal\" according to `<=>` if, and only if, they have the same size\nand the value of each element is equal to the value of the corresponding element in the other tuple.\n\n```\n{\"a\", \"a\", \"c\"} <=> {\"a\", \"b\", \"c\"} # => -1\n{1, 2, 3, 4, 5, 6} <=> {1, 2}       # => +1\n{1, 2} <=> {1, 2.0}                 # => 0\n```\n\nSee also: `Object#<=>`.","summary":"<p>Implements the comparison operator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L292","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for i in 0...T.size %}\n      cmp = self[{{ i }}] <=> other[{{ i }}]\n      return cmp unless cmp == 0\n    {% end %}\n0\n"}},{"id":"(other:Tuple)-instance-method","html_id":"(other:Tuple)-instance-method","name":"<=>","doc":"Implements the comparison operator.\n\nEach object in each tuple is compared (using the `<=>` operator).\n\nTuples are compared in an \"element-wise\" manner; the first element of this tuple is\ncompared with the first one of *other* using the `<=>` operator, then each of the second elements,\netc. As soon as the result of any such comparison is non zero\n(i.e. the two corresponding elements are not equal), that result is returned for the whole tuple comparison.\n\nIf all the elements are equal, then the result is based on a comparison of the tuple sizes.\nThus, two tuples are \"equal\" according to `<=>` if, and only if, they have the same size\nand the value of each element is equal to the value of the corresponding element in the other tuple.\n\n```\n{\"a\", \"a\", \"c\"} <=> {\"a\", \"b\", \"c\"} # => -1\n{1, 2, 3, 4, 5, 6} <=> {1, 2}       # => +1\n{1, 2} <=> {1, 2.0}                 # => 0\n```\n\nSee also: `Object#<=>`.","summary":"<p>Implements the comparison operator.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L301","def":{"name":"<=>","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"min_size = Math.min(size, other.size)\nmin_size.times do |i|\n  cmp = self[i] <=> other[i]\n  if cmp == 0\n  else\n    return cmp\n  end\nend\nsize <=> other.size\n"}},{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same size as the other tuple\nand their elements are equal to each other when  compared with `==`.\n\n```\nt1 = {1, \"hello\"}\nt2 = {1.0, \"hello\"}\nt3 = {2, \"hello\"}\n\nt1 == t2 # => true\nt1 == t3 # => false\n```","summary":"<p>Returns <code>true</code> if this tuple has the same size as the other tuple and their elements are equal to each other when  compared with <code><a href=\"Tuple.html#%3D%3D%28other%3Aself%29-instance-method\">#==</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L218","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for i in 0...T.size %}\n      return false unless self[{{ i }}] == other[{{ i }}]\n    {% end %}\ntrue\n"}},{"id":"==(other:Tuple)-instance-method","html_id":"==(other:Tuple)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same size as the other tuple\nand their elements are equal to each other when  compared with `==`.\n\n```\nt1 = {1, \"hello\"}\nt2 = {1.0, \"hello\"}\nt3 = {2, \"hello\"}\n\nt1 == t2 # => true\nt1 == t3 # => false\n```","summary":"<p>Returns <code>true</code> if this tuple has the same size as the other tuple and their elements are equal to each other when  compared with <code><a href=\"Tuple.html#%3D%3D%28other%3Aself%29-instance-method\">#==</a></code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L226","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L226","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nsize.times do |i|\n  if self[i] == other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L235","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L235","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"===(other:self)-instance-method","html_id":"===(other:self)-instance-method","name":"===","doc":"Returns `true` if case equality holds for the elements in `self` and *other*.\n\n```\n{1, 2} === {1, 2} # => true\n{1, 2} === {1, 3} # => false\n```\n\nSee also: `Object#===`.","summary":"<p>Returns <code>true</code> if case equality holds for the elements in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L247","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for i in 0...T.size %}\n      return false unless self[{{ i }}] === other[{{ i }}]\n    {% end %}\ntrue\n"}},{"id":"===(other:Tuple)-instance-method","html_id":"===(other:Tuple)-instance-method","name":"===","doc":"Returns `true` if `self` and *other* have the same size and case equality holds\nfor the elements in `self` and *other*.\n\n```\n{1, 2} === {1, 2, 3}             # => false\n{/o+/, \"bar\"} === {\"foo\", \"bar\"} # => true\n```\n\nSee also: `Object#===`.","summary":"<p>Returns <code>true</code> if <code>self</code> and <em>other</em> have the same size and case equality holds for the elements in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L263","def":{"name":"===","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Tuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nsize.times do |i|\n  if self[i] === other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"id":"[](index:Int)-instance-method","html_id":"[](index:Int)-instance-method","name":"[]","doc":"Returns the element at the given *index*. Read the type docs to understand\nthe difference between indexing with a number literal or a variable.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple[0] # => 1 (Int32)\ntuple[3] # compile error: index out of bounds for tuple {Int32, String, Char}\n\ni = 0\ntuple[i] # => 1 (Int32 | String | Char)\n\ni = 3\ntuple[i] # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L143","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index)"}},{"id":"[]?(index:Int)-instance-method","html_id":"[]?(index:Int)-instance-method","name":"[]?","doc":"Returns the element at the given *index* or `nil` if out of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple[0]? # => 1\ntuple[3]? # => nil\n```","summary":"<p>Returns the element at the given <em>index</em> or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L154","def":{"name":"[]?","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  nil\nend"}},{"id":"at(index:Int)-instance-method","html_id":"at(index:Int)-instance-method","name":"at","doc":"Returns the element at the given *index* or raises IndexError if out of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.at(0) # => 1\ntuple.at(3) # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em> or raises IndexError if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L165","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L165","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"at(index) do\n  raise(IndexError.new)\nend"}},{"id":"at(index:Int,&block)-instance-method","html_id":"at(index:Int,&amp;block)-instance-method","name":"at","doc":"Returns the element at the given *index* or the value returned by the block if\nout of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.at(0) { 10 } # => 1\ntuple.at(3) { 10 } # => 10\n```","summary":"<p>Returns the element at the given <em>index</em> or the value returned by the block if out of bounds.</p>","abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L177","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L177","def":{"name":"at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + size\nend\n{% for i in 0...T.size %}\n      return self[{{ i }}] if {{ i }} == index\n    {% end %}\nyield\n"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a tuple containing cloned elements of this tuple using the `clone` method.","summary":"<p>Returns a tuple containing cloned elements of this tuple using the <code><a href=\"Tuple.html#clone-instance-method\">#clone</a></code> method.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L319","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L319","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          self[{{ i }}].clone,\n        {% end %}\n      )\n    {% end %}"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":"Yields each of the elements in this tuple.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.each do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\n1\n\"hello\"\n'x'\n```","summary":"<p>Yields each of the elements in this tuple.</p>","abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L201","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"{% for i in 0...T.size %}\n      yield self[{{ i }}]\n    {% end %}"}},{"id":"first-instance-method","html_id":"first-instance-method","name":"first","doc":"Returns the first element of this tuple. Doesn't compile\nif the tuple is empty.\n\n```\ntuple = {1, 2.5}\ntuple.first # => 1\n```","summary":"<p>Returns the first element of this tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L473","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L473","def":{"name":"first","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[0]"}},{"id":"first?-instance-method","html_id":"first?-instance-method","name":"first?","doc":"Returns the first element of this tuple, or `nil` if this\nis the empty tuple.\n\n```\ntuple = {1, 2.5}\ntuple.first? # => 1\n\nempty = Tuple.new\nempty.first? # => nil\n```","summary":"<p>Returns the first element of this tuple, or <code>nil</code> if this is the empty tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L487","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L487","def":{"name":"first?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T.size == 0 %}\n      nil\n    {% else %}\n      self[0]\n    {% end %}"}},{"id":"from(array:Array)-instance-method","html_id":"from(array:Array)-instance-method","name":"from","doc":"Expects to be called on a tuple of types, creates a tuple from the given array,\nwith types casted appropriately.\n\nThis allows you to easily pass an array as individual arguments to a method.\n\n```\ndef speak_about(thing : String, n : Int64)\n  \"I see #{n} #{thing}s\"\nend\n\ndata = JSON.parse(%([\"world\", 2])).as_a\nspeak_about(*{String, Int64}.from(data)) # => \"I see 2 worlds\"\n```","summary":"<p>Expects to be called on a tuple of types, creates a tuple from the given array, with types casted appropriately.</p>","abstract":false,"args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array"}],"args_string":"(array : Array)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L111","def":{"name":"from","args":[{"name":"array","doc":null,"default_value":"","external_name":"array","restriction":"Array"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if size != array.size\n  raise(ArgumentError.new(\"Expected array of size #{size} but one of size #{array.size} was given.\"))\nend\n{% if true %}\n    Tuple.new(\n    {% for i in 0...@type.size %}\n      self[{{ i }}].cast(array[{{ i }}]),\n    {% end %}\n    )\n    {% end %}\n"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L311","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L311","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for i in 0...T.size %}\n      hasher = self[{{ i }}].hash(hasher)\n    {% end %}\nhasher\n"}},{"id":"inspect-instance-method","html_id":"inspect-instance-method","name":"inspect","doc":"Same as `to_s`.","summary":"<p>Same as <code><a href=\"Tuple.html#to_s%28io%29-instance-method\">#to_s</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L375","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L375","def":{"name":"inspect","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s"}},{"id":"last-instance-method","html_id":"last-instance-method","name":"last","doc":"Returns the last element of this tuple. Doesn't compile\nif the tuple is empty.\n\n```\ntuple = {1, 2.5}\ntuple.last # => 2.5\n```","summary":"<p>Returns the last element of this tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L502","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L502","def":{"name":"last","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      self[{{ T.size - 1 }}]\n    {% end %}"}},{"id":"last?-instance-method","html_id":"last?-instance-method","name":"last?","doc":"Returns the last element of this tuple, or `nil` if this\nis the empty tuple.\n\n```\ntuple = {1, 2.5}\ntuple.last? # => 2.5\n\nempty = Tuple.new\nempty.last? # => nil\n```","summary":"<p>Returns the last element of this tuple, or <code>nil</code> if this is the empty tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L518","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L518","def":{"name":"last?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if T.size == 0 %}\n      nil\n    {% else %}\n      self[{{ T.size - 1 }}]\n    {% end %}"}},{"id":"map(&block)-instance-method","html_id":"map(&amp;block)-instance-method","name":"map","doc":"Returns a new tuple where elements are mapped by the given block.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.map &.to_s # => {\"1\", \"2.5\", \"a\"}\n```","summary":"<p>Returns a new tuple where elements are mapped by the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L401","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L401","def":{"name":"map","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          (yield self[{{ i }}]),\n        {% end %}\n      )\n   {% end %}"}},{"id":"map_with_index(&block)-instance-method","html_id":"map_with_index(&amp;block)-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.map_with_index { |e, i| \"tuple[#{i}]: #{e}\" } # => {\"tuple[0]: 1\", \"tuple[1]: 2.5\", \"tuple[2]: a\"}\n```","summary":"<p>Like <code><a href=\"Tuple.html#map%28%26block%29-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L417","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L417","def":{"name":"map_with_index","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          (yield self[{{ i }}], {{ i }}),\n        {% end %}\n      )\n    {% end %}"}},{"id":"pretty_print(pp):Nil-instance-method","html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","doc":null,"summary":null,"abstract":false,"args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L391","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L391","def":{"name":"pretty_print","args":[{"name":"pp","doc":null,"default_value":"","external_name":"pp","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"pp.list(\"{\", self, \"}\")"}},{"id":"reverse-instance-method","html_id":"reverse-instance-method","name":"reverse","doc":"Returns a new tuple where the elements are in reverse order.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.reverse # => {\"a\", 2.5, 1}\n```","summary":"<p>Returns a new tuple where the elements are in reverse order.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L433","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L433","def":{"name":"reverse","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 1..T.size %}\n          self[{{ T.size - i }}],\n        {% end %}\n      )\n    {% end %}"}},{"id":"reverse_each(&block)-instance-method","html_id":"reverse_each(&amp;block)-instance-method","name":"reverse_each","doc":"Yields each of the elements in this tuple in reverse order.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.reverse_each do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\n'x'\n\"hello\"\n1\n```","summary":"<p>Yields each of the elements in this tuple in reverse order.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L459","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L459","def":{"name":"reverse_each","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"{% for i in 1..T.size %}\n      yield self[{{ T.size - i }}]\n    {% end %}\nnil\n"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this tuple.\n\n```\n{'a', 'b'}.size # => 2\n```","summary":"<p>Returns the number of elements in this tuple.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L360","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L360","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{{ T.size }}"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/to_json.cr#L92","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.array do\n  {% for i in 0...T.size %}\n        self[{{ i }}].to_json(json)\n      {% end %}\nend"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":"Appends a string representation of this tuple to the given `IO`.\n\n```\ntuple = {1, \"hello\"}\ntuple.to_s # => \"{1, \\\"hello\\\"}\"\n```","summary":"<p>Appends a string representation of this tuple to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L385","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L385","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '{'\njoin(\", \", io, &.inspect(io))\nio << '}'\n"}},{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/to_yaml.cr#L43","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"yaml.sequence do\n  each(&.to_yaml(yaml))\nend"}},{"id":"unsafe_at(index:Int)-instance-method","html_id":"unsafe_at(index:Int)-instance-method","name":"unsafe_at","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/tuple.cr#L125","def":{"name":"unsafe_at","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[index]"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/TypeCastError","path":"TypeCastError.html","kind":"class","full_name":"TypeCastError","name":"TypeCastError","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"exception.cr","line_number":100,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Raised when the type cast failed.\n\n```\n[1, \"hi\"][1].as(Int32) # raises TypeCastError (cast to Int32 failed)\n```","summary":"<p>Raised when the type cast failed.</p>","class_methods":[],"constructors":[{"id":"new(message=&quot;TypeCasterror&quot;)-class-method","html_id":"new(message=&amp;quot;TypeCasterror&amp;quot;)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"\"Type Cast error\"","external_name":"message","restriction":""}],"args_string":"(message = <span class=\"s\">&quot;Type Cast error&quot;</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/exception.cr#L101","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"\"Type Cast error\"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UDPSocket","path":"UDPSocket.html","kind":"class","full_name":"UDPSocket","name":"UDPSocket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/udp_socket.cr","line_number":55,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A User Datagram Protocol (UDP) socket.\n\nUDP runs on top of the Internet Protocol (IP) and was developed for applications that do\nnot require reliability, acknowledgement, or flow control features at the transport layer.\nThis simple protocol provides transport layer addressing in the form of UDP ports and an\noptional checksum capability.\n\nUDP is a very simple protocol. Messages, so called datagrams, are sent to other hosts on\nan IP network without the need to set up special transmission channels or data paths\nbeforehand. The UDP socket only needs to be opened for communication. It listens for\nincoming messages and sends outgoing messages on request.\n\nThis implementation supports both IPv4 and IPv6 addresses. For IPv4 addresses you must use\n`Socket::Family::INET` family (default) or `Socket::Family::INET6` for IPv6 # addresses.\n\nUsage example:\n\n```\nrequire \"socket\"\n\n# Create server\nserver = UDPSocket.new\nserver.bind \"localhost\", 1234\n\n# Create client and connect to server\nclient = UDPSocket.new\nclient.connect \"localhost\", 1234\n\n# Send a text message to server\nclient.send \"message\"\n\n# Receive text message from client\nmessage, client_addr = server.receive\n\n# Close client and server\nclient.close\nserver.close\n```\n\nThe `send` methods may sporadically fail with `Errno::ECONNREFUSED` when sending datagrams\nto a non-listening server.\nWrap with an exception handler to prevent raising. Example:\n\n```\nbegin\n  client.send(message, @destination)\nrescue ex : Errno\n  if ex.errno == Errno::ECONNREFUSED\n    p ex.inspect\n  end\nend\n```","summary":"<p>A User Datagram Protocol (UDP) socket.</p>","class_methods":[],"constructors":[{"id":"new(family:Family=Family::INET)-class-method","html_id":"new(family:Family=Family::INET)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(family : Family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L56","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"Family::INET","external_name":"family","restriction":"Family"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(family)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"receive(message:Bytes):Tuple(Int32,IPAddress)-instance-method","html_id":"receive(message:Bytes):Tuple(Int32,IPAddress)-instance-method","name":"receive","doc":"Receives a binary message from the previously bound address.\n\n```\nserver = UDPSocket.new\nserver.bind \"localhost\", 1234\n\nmessage = Bytes.new(32)\nbytes_read, client_addr = server.receive(message)\n```","summary":"<p>Receives a binary message from the previously bound address.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"Bytes"}],"args_string":"(message : Bytes) : Tuple(Int32, IPAddress)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L87","def":{"name":"receive","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(Int32, IPAddress)","visibility":"Public","body":"bytes_read, sockaddr, addrlen = recvfrom(message)\n{bytes_read, IPAddress.from(sockaddr, addrlen)}\n"}},{"id":"receive(max_message_size=512):Tuple(String,IPAddress)-instance-method","html_id":"receive(max_message_size=512):Tuple(String,IPAddress)-instance-method","name":"receive","doc":"Receives a text message from the previously bound address.\n\n```\nserver = UDPSocket.new\nserver.bind(\"localhost\", 1234)\n\nmessage, client_addr = server.receive\n```","summary":"<p>Receives a text message from the previously bound address.</p>","abstract":false,"args":[{"name":"max_message_size","doc":null,"default_value":"512","external_name":"max_message_size","restriction":""}],"args_string":"(max_message_size = <span class=\"n\">512</span>) : Tuple(String, IPAddress)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/udp_socket.cr#L68","def":{"name":"receive","args":[{"name":"max_message_size","doc":null,"default_value":"512","external_name":"max_message_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(String, IPAddress)","visibility":"Public","body":"address = nil\nmessage = String.new(max_message_size) do |buffer|\n  bytes_read, sockaddr, addrlen = recvfrom(Slice.new(buffer, max_message_size))\n  address = IPAddress.from(sockaddr, addrlen)\n  {bytes_read, 0}\nend\n{message, address.not_nil!}\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UInt128","path":"UInt128.html","kind":"struct","full_name":"UInt128","name":"UInt128","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":791,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"~MIN","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"new(0)","doc":"TODO: eventually update to literals once UInt128 bit support is finished","summary":"<p><span class=\"flag orange\">TODO</span>  eventually update to literals once UInt128 bit support is finished</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `UInt128` by invoking `to_u128` on *value*.","summary":"<p>Returns an <code><a href=\"UInt128.html\">UInt128</a></code> by invoking <code><a href=\"UInt128.html#to_u128%3AUInt128-instance-method\">#to_u128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L797","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L797","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_u128"}}],"instance_methods":[{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L801","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L801","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L809","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L809","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L805","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L805","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount128(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UInt16","path":"UInt16.html","kind":"struct","full_name":"UInt16","name":"UInt16","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":725,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"65535_u16","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"0_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt16.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt16.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `UInt16` by invoking `to_u16` on *value*.","summary":"<p>Returns an <code><a href=\"UInt16.html\">UInt16</a></code> by invoking <code><a href=\"UInt16.html#to_u16%3AUInt16-instance-method\">#to_u16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L730","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L730","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_u16"}}],"instance_methods":[{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L734","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L734","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L742","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L742","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L738","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L738","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount16(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UInt32","path":"UInt32.html","kind":"struct","full_name":"UInt32","name":"UInt32","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":747,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"4294967295_u32","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"0_u32","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt32.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt32.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `UInt32` by invoking `to_u32` on *value*.","summary":"<p>Returns an <code><a href=\"UInt32.html\">UInt32</a></code> by invoking <code><a href=\"UInt32.html#to_u32%3AUInt32-instance-method\">#to_u32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L752","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L752","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_u32"}}],"instance_methods":[{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L756","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L756","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L764","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L764","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L760","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L760","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount32(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UInt64","path":"UInt64.html","kind":"struct","full_name":"UInt64","name":"UInt64","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":769,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"18446744073709551615_u64","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"0_u64","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt64.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt64.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `UInt64` by invoking `to_u64` on *value*.","summary":"<p>Returns an <code><a href=\"UInt64.html\">UInt64</a></code> by invoking <code><a href=\"UInt64.html#to_u64%3AUInt64-instance-method\">#to_u64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L774","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L774","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_u64"}}],"instance_methods":[{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L778","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L778","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L786","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L786","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L782","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L782","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount64(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UInt8","path":"UInt8.html","kind":"struct","full_name":"UInt8","name":"UInt8","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"int.cr","line_number":703,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"},{"filename":"primitives.cr","line_number":269,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"MAX","name":"MAX","value":"255_u8","doc":null,"summary":null},{"id":"MIN","name":"MIN","value":"0_u8","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L49","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt8.new(parse_scalar(ctx, node, Int64))"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L69","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UInt8.new(pull.read_int)"}},{"id":"new(value)-class-method","html_id":"new(value)-class-method","name":"new","doc":"Returns an `UInt8` by invoking `to_u8` on *value*.","summary":"<p>Returns an <code><a href=\"UInt8.html\">UInt8</a></code> by invoking <code><a href=\"UInt8.html#to_u8%3AUInt8-instance-method\">#to_u8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L708","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L708","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value.to_u8"}}],"instance_methods":[{"id":"!=(other:UInt16):Bool-instance-method","html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float32):Bool-instance-method","html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt128):Bool-instance-method","html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt64):Bool-instance-method","html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt32):Bool-instance-method","html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int8):Bool-instance-method","html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int16):Bool-instance-method","html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int32):Bool-instance-method","html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int64):Bool-instance-method","html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Int128):Bool-instance-method","html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:Float64):Bool-instance-method","html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"!=(other:UInt8):Bool-instance-method","html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"!=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int16):self-instance-method","html_id":"&amp;(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int32):self-instance-method","html_id":"&amp;(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int64):self-instance-method","html_id":"&amp;(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int128):self-instance-method","html_id":"&amp;(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt8):self-instance-method","html_id":"&amp;(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt16):self-instance-method","html_id":"&amp;(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt32):self-instance-method","html_id":"&amp;(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt64):self-instance-method","html_id":"&amp;(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:UInt128):self-instance-method","html_id":"&amp;(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"&(other:Int8):self-instance-method","html_id":"&amp;(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"&","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int8):self-instance-method","html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int16):self-instance-method","html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int32):self-instance-method","html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt8):self-instance-method","html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt16):self-instance-method","html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt32):self-instance-method","html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt64):self-instance-method","html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:UInt128):self-instance-method","html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float32):Float32-instance-method","html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Float64):Float64-instance-method","html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int128):self-instance-method","html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"*(other:Int64):self-instance-method","html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"*","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int8):self-instance-method","html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int16):self-instance-method","html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int32):self-instance-method","html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int64):self-instance-method","html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Int128):self-instance-method","html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt8):self-instance-method","html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt16):self-instance-method","html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt32):self-instance-method","html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt64):self-instance-method","html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:UInt128):self-instance-method","html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float32):Float32-instance-method","html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"+(other:Float64):Float64-instance-method","html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"+","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int64):self-instance-method","html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int32):self-instance-method","html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int16):self-instance-method","html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int8):self-instance-method","html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float64):Float64-instance-method","html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Float32):Float32-instance-method","html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt128):self-instance-method","html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt64):self-instance-method","html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt32):self-instance-method","html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt16):self-instance-method","html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:UInt8):self-instance-method","html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"-(other:Int128):self-instance-method","html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"-","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float32):Float32-instance-method","html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"id":"/(other:Float64):Float64-instance-method","html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of dividing `self` and *other*.","summary":"<p>Returns the result of dividing <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"/","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float32):Bool-instance-method","html_id":"&lt;(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Float64):Bool-instance-method","html_id":"&lt;(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt128):Bool-instance-method","html_id":"&lt;(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt64):Bool-instance-method","html_id":"&lt;(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt32):Bool-instance-method","html_id":"&lt;(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt16):Bool-instance-method","html_id":"&lt;(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:UInt8):Bool-instance-method","html_id":"&lt;(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int128):Bool-instance-method","html_id":"&lt;(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int64):Bool-instance-method","html_id":"&lt;(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int32):Bool-instance-method","html_id":"&lt;(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int16):Bool-instance-method","html_id":"&lt;(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<(other:Int8):Bool-instance-method","html_id":"&lt;(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int128):Bool-instance-method","html_id":"&lt;=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int16):Bool-instance-method","html_id":"&lt;=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int32):Bool-instance-method","html_id":"&lt;=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int64):Bool-instance-method","html_id":"&lt;=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt32):Bool-instance-method","html_id":"&lt;=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt8):Bool-instance-method","html_id":"&lt;=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt16):Bool-instance-method","html_id":"&lt;=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Int8):Bool-instance-method","html_id":"&lt;=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt64):Bool-instance-method","html_id":"&lt;=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:UInt128):Bool-instance-method","html_id":"&lt;=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float32):Bool-instance-method","html_id":"&lt;=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"<=(other:Float64):Bool-instance-method","html_id":"&lt;=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"<=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt128):Bool-instance-method","html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int8):Bool-instance-method","html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int16):Bool-instance-method","html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int32):Bool-instance-method","html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int64):Bool-instance-method","html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Int128):Bool-instance-method","html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt8):Bool-instance-method","html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt16):Bool-instance-method","html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt32):Bool-instance-method","html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float64):Bool-instance-method","html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:Float32):Bool-instance-method","html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"==(other:UInt64):Bool-instance-method","html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float64):Bool-instance-method","html_id":"&gt;(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int64):Bool-instance-method","html_id":"&gt;(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt128):Bool-instance-method","html_id":"&gt;(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt64):Bool-instance-method","html_id":"&gt;(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt32):Bool-instance-method","html_id":"&gt;(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt16):Bool-instance-method","html_id":"&gt;(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:UInt8):Bool-instance-method","html_id":"&gt;(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int128):Bool-instance-method","html_id":"&gt;(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int8):Bool-instance-method","html_id":"&gt;(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int16):Bool-instance-method","html_id":"&gt;(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Int32):Bool-instance-method","html_id":"&gt;(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">(other:Float32):Bool-instance-method","html_id":"&gt;(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int32):Bool-instance-method","html_id":"&gt;=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float64):Bool-instance-method","html_id":"&gt;=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Float32):Bool-instance-method","html_id":"&gt;=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Float32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt128):Bool-instance-method","html_id":"&gt;=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt64):Bool-instance-method","html_id":"&gt;=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt32):Bool-instance-method","html_id":"&gt;=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt16):Bool-instance-method","html_id":"&gt;=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:UInt8):Bool-instance-method","html_id":"&gt;=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int128):Bool-instance-method","html_id":"&gt;=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int64):Bool-instance-method","html_id":"&gt;=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int16):Bool-instance-method","html_id":"&gt;=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":">=(other:Int8):Bool-instance-method","html_id":"&gt;=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":">=","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt32):self-instance-method","html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt16):self-instance-method","html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt8):self-instance-method","html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int128):self-instance-method","html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int64):self-instance-method","html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int32):self-instance-method","html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int16):self-instance-method","html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt128):self-instance-method","html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:UInt64):self-instance-method","html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"^(other:Int8):self-instance-method","html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"^","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"abs-instance-method","html_id":"abs-instance-method","name":"abs","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L712","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L712","def":{"name":"abs","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L720","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L720","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}},{"id":"popcount-instance-method","html_id":"popcount-instance-method","name":"popcount","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L716","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/int.cr#L716","def":{"name":"popcount","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Intrinsics.popcount8(self)"}},{"id":"to_f:Float64-instance-method","html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f32:Float32-instance-method","html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_f64:Float64-instance-method","html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_f64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i:Int32-instance-method","html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i128:Int128-instance-method","html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i16:Int16-instance-method","html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i32:Int32-instance-method","html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i64:Int64-instance-method","html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_i8:Int8-instance-method","html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_i8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int8","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u:UInt32-instance-method","html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u128:UInt128-instance-method","html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u128","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt128","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u16:UInt16-instance-method","html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u16","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u32:UInt32-instance-method","html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt32","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u64:UInt64-instance-method","html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt64","visibility":"Public","body":"# primitive: cast"}},{"id":"to_u8:UInt8-instance-method","html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[],"args_string":" : UInt8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"to_u8","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt8","visibility":"Public","body":"# primitive: cast"}},{"id":"unsafe_chr:Char-instance-method","html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0x10ffff</code>).</p>","abstract":false,"args":[],"args_string":" : Char","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"unsafe_chr","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Char","visibility":"Public","body":"# primitive: cast"}},{"id":"|(other:UInt128):self-instance-method","html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt64):self-instance-method","html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt32):self-instance-method","html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt8):self-instance-method","html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int128):self-instance-method","html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int128"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int64):self-instance-method","html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int64"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int32):self-instance-method","html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int32"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int16):self-instance-method","html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:Int8):self-instance-method","html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Int8"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"id":"|(other:UInt16):self-instance-method","html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/primitives.cr#L269","def":{"name":"|","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"# primitive: binary"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Union","path":"Union.html","kind":"struct","full_name":"Union(*T)","name":"Union","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"union.cr","line_number":19,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/union.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A union type represents the possibility of a variable or an expression\nhaving more than one possible type at compile time.\n\nWhen invoking a method on a union type, the language checks that the\nmethod exists and can be resolved (typed) for each type in the union.\nFor this reason, adding instance methods to `Union` makes no sense and\nhas no effect. However, adding class method to `Union` is possible\nand can be useful. One example is parsing `JSON` into one of many\npossible types.\n\nUnion is special in that it is a generic type but instantiating it\nmight not return a union type:\n\n```\nUnion(Int32 | String)      # => (Int32 | String)\nUnion(Int32)               # => Int32\nUnion(Int32, Int32, Int32) # => Int32\n```","summary":"<p>A union type represents the possibility of a variable or an expression having more than one possible type at compile time.</p>","class_methods":[{"id":"nilable?-class-method","html_id":"nilable?-class-method","name":"nilable?","doc":"Returns `true` if this union includes the `Nil` type.\n\n```\n(Int32 | String).nilable? # => false\n(Int32 | Nil).nilable?    # => true\n```","summary":"<p>Returns <code>true</code> if this union includes the <code><a href=\"Nil.html\">Nil</a></code> type.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/union.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/union.cr#L26","def":{"name":"nilable?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{{ T.any?(&.==(::Nil)) }}"}}],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/from_yaml.cr#L182","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Alias)\n  {% for type in T %}\n      {% if type < ::Reference %}\n        ctx.read_alias?(node, {{ type }}) do |obj|\n          return obj\n        end\n      {% end %}\n    {% end %}\n  node.raise(\"Error deserailizing alias\")\nend\n{% for type in T %}\n    begin\n      return {{ type }}.new(ctx, node)\n    rescue YAML::ParseException\n      # Ignore\n    end\n  {% end %}\nnode.raise(\"Couldn't parse #{self}\")\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L192","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/from_json.cr#L192","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"location = pull.location\n{% if true %}\n    # Here we store types that are not primitive types\n    {% non_primitives = [] of Nil %}\n\n    {% for type, index in T %}\n      {% if type == Nil %}\n        return pull.read_null if pull.kind == :null\n      {% else %}{% if (((((((((((type == Bool) || (type == Int8)) || (type == Int16)) || (type == Int32)) || (type == Int64)) || (type == UInt8)) || (type == UInt16)) || (type == UInt32)) || (type == UInt64)) || (type == Float32)) || (type == Float64)) || (type == String) %}\n        value = pull.read?({{ type }})\n        return value unless value.nil?\n      {% else %}\n        {% non_primitives << type %}\n      {% end %}{% end %}\n    {% end %}\n\n    # If after traversing all the types we are left with just one\n    # non-primitive type, we can parse it directly (no need to use `read_raw`)\n    {% if non_primitives.size == 1 %}\n      return {{ non_primitives[0] }}.new(pull)\n    {% end %}\n  {% end %}\nstring = pull.read_raw\n{% for type in T %}\n    begin\n      return {{ type }}.from_json(string)\n    rescue JSON::ParseException\n      # Ignore\n    end\n  {% end %}\nraise(JSON::ParseException.new(\"Couldn't parse #{self} from #{string}\", *location))\n"}},{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/union.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/union.cr#L19","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UNIXServer","path":"UNIXServer.html","kind":"class","full_name":"UNIXServer","name":"UNIXServer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"},{"html_id":"github.com/crystal-lang/crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"},{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/unix_server.cr","line_number":21,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"A local interprocess communication server socket.\n\nOnly available on UNIX and UNIX-like operating systems.\n\nExample usage:\n```\nrequire \"socket\"\n\ndef handle_client(client)\n  message = client.gets\n  client.puts message\nend\n\nserver = UNIXServer.new(\"/tmp/myapp.sock\")\nwhile client = server.accept?\n  spawn handle_client(client)\nend\n```","summary":"<p>A local interprocess communication server socket.</p>","class_methods":[{"id":"open(path,type:Type=Type::STREAM,backlog=128,&block)-class-method","html_id":"open(path,type:Type=Type::STREAM,backlog=128,&amp;block)-class-method","name":"open","doc":"Creates a new UNIX server and yields it to the block. Eventually closes the\nserver socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new UNIX server and yields it to the block.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","doc":null,"default_value":"128","external_name":"backlog","restriction":""}],"args_string":"(path, type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, backlog = <span class=\"n\">128</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L52","def":{"name":"open","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","doc":null,"default_value":"128","external_name":"backlog","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"server = new(path, type, backlog)\nbegin\n  yield server\nensure\n  server.close\nend\n"}}],"constructors":[{"id":"new(path:String,type:Type=Type::STREAM,backlog=128)-class-method","html_id":"new(path:String,type:Type=Type::STREAM,backlog=128)-class-method","name":"new","doc":"Creates a named UNIX socket, listening on a filesystem pathname.\n\nAlways deletes any existing filesystam pathname first, in order to cleanup\nany leftover socket file.\n\nThe server is of stream type by default, but this can be changed for\nanother type. For example datagram messages:\n```\nUNIXServer.new(\"/tmp/dgram.sock\", Socket::Type::DGRAM)\n```","summary":"<p>Creates a named UNIX socket, listening on a filesystem pathname.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","doc":null,"default_value":"128","external_name":"backlog","restriction":""}],"args_string":"(path : String, type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, backlog = <span class=\"n\">128</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L34","def":{"name":"new","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","doc":null,"default_value":"128","external_name":"backlog","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(path, type, backlog)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"accept?:UNIXSocket?-instance-method","html_id":"accept?:UNIXSocket?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client socket or `nil` if the server is closed after invoking\nthis method.","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"args":[],"args_string":" : UNIXSocket?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L65","def":{"name":"accept?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UNIXSocket | ::Nil","visibility":"Public","body":"if client_fd = accept_impl\n  sock = UNIXSocket.new(client_fd, type, @path)\n  sock.sync = sync?\n  sock\nend"}},{"id":"close(delete=true)-instance-method","html_id":"close(delete=true)-instance-method","name":"close","doc":"Closes the socket, then deletes the filesystem pathname if it exists.","summary":"<p>Closes the socket, then deletes the filesystem pathname if it exists.</p>","abstract":false,"args":[{"name":"delete","doc":null,"default_value":"true","external_name":"delete","restriction":""}],"args_string":"(delete = <span class=\"n\">true</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_server.cr#L74","def":{"name":"close","args":[{"name":"delete","doc":null,"default_value":"true","external_name":"delete","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"begin\n  super()\nensure\n  if delete && (path = @path)\n    if File.exists?(path)\n      File.delete(path)\n    end\n    @path = nil\n  end\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UNIXSocket","path":"UNIXSocket.html","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"github.com/crystal-lang/crystal/IO/Syscall","kind":"module","full_name":"IO::Syscall","name":"Syscall"},{"html_id":"github.com/crystal-lang/crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"socket/unix_socket.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/UNIXServer","kind":"class","full_name":"UNIXServer","name":"UNIXServer"}],"including_types":[],"namespace":null,"doc":"A local interprocess communication clientsocket.\n\nOnly available on UNIX and UNIX-like operating systems.\n\nExample usage:\n```\nrequire \"socket\"\n\nsock = UNIXSocket.new(\"/tmp/myapp.sock\")\nsock.puts \"message\"\nresponse = sock.gets\nsock.close\n```","summary":"<p>A local interprocess communication clientsocket.</p>","class_methods":[{"id":"open(path,type:Type=Type::STREAM,&block)-class-method","html_id":"open(path,type:Type=Type::STREAM,&amp;block)-class-method","name":"open","doc":"Opens an UNIX socket to a filesystem pathname, yields it to the block, then\neventually closes the socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Opens an UNIX socket to a filesystem pathname, yields it to the block, then eventually closes the socket when the block returns.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(path, type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L39","def":{"name":"open","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"sock = new(path, type)\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}},{"id":"pair(type:Type=Type::STREAM)-class-method","html_id":"pair(type:Type=Type::STREAM)-class-method","name":"pair","doc":"Returns a pair of unamed UNIX sockets.\n\n```\nleft, right = UNIXSocket.pair\n\nspawn do\n  # echo server\n  message = right.gets\n  right.puts message\nend\n\nleft.puts \"message\"\nleft.gets # => \"message\"\n```","summary":"<p>Returns a pair of unamed UNIX sockets.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L62","def":{"name":"pair","args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"fds = uninitialized ::StaticArray(Int32, 2)\nsocktype = type.value\n{% if LibC.has_constant?(:SOCK_CLOEXEC) %}\n      socktype |= LibC::SOCK_CLOEXEC\n    {% end %}\nif (LibC.socketpair(Family::UNIX, socktype, 0, fds)) != 0\n  raise(Errno.new(\"socketpair:\"))\nend\n{UNIXSocket.new(fds[0], type), UNIXSocket.new(fds[1], type)}\n"}},{"id":"pair(type:Type=Type::STREAM,&block)-class-method","html_id":"pair(type:Type=Type::STREAM,&amp;block)-class-method","name":"pair","doc":"Creates a pair of unamed UNIX sockets (see `pair`) and yields them to the\nblock. Eventually closes both sockets when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a pair of unamed UNIX sockets (see <code><a href=\"UNIXSocket.html#pair%28type%3AType%3DType%3A%3ASTREAM%29-class-method\">.pair</a></code>) and yields them to the block.</p>","abstract":false,"args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L81","def":{"name":"pair","args":[{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":2,"block_arg":null,"return_type":"","visibility":"Public","body":"left, right = pair(type)\nbegin\n  yield left, right\nensure\n  left.close\n  right.close\nend\n"}}],"constructors":[{"id":"new(path:String,type:Type=Type::STREAM)-class-method","html_id":"new(path:String,type:Type=Type::STREAM)-class-method","name":"new","doc":"Connects a named UNIX socket, bound to a filesystem pathname.","summary":"<p>Connects a named UNIX socket, bound to a filesystem pathname.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(path : String, type : Type = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L18","def":{"name":"new","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String"},{"name":"type","doc":null,"default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(path, type)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(family:Family,type:Type)-class-method","html_id":"new(family:Family,type:Type)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"args_string":"(family : Family, type : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L27","def":{"name":"new","args":[{"name":"family","doc":null,"default_value":"","external_name":"family","restriction":"Family"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(family, type)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(fd:Int32,type:Type,path:String?=nil)-class-method","html_id":"new(fd:Int32,type:Type,path:String?=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"path","doc":null,"default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"args_string":"(fd : Int32, type : Type, path : String? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L31","def":{"name":"new","args":[{"name":"fd","doc":null,"default_value":"","external_name":"fd","restriction":"Int32"},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"Type"},{"name":"path","doc":null,"default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(fd, type, path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"local_address-instance-method","html_id":"local_address-instance-method","name":"local_address","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L91","def":{"name":"local_address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UNIXAddress.new(path.to_s)"}},{"id":"path:String?-instance-method","html_id":"path:String?-instance-method","name":"path","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L15","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@path"}},{"id":"receive-instance-method","html_id":"receive-instance-method","name":"receive","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L99","def":{"name":"receive","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytes_read, sockaddr, addrlen = recvfrom\n{bytes_read, UNIXAddress.from(sockaddr, addrlen)}\n"}},{"id":"remote_address-instance-method","html_id":"remote_address-instance-method","name":"remote_address","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/socket/unix_socket.cr#L95","def":{"name":"remote_address","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"UNIXAddress.new(path.to_s)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/URI","path":"URI.html","kind":"class","full_name":"URI","name":"URI","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uri/punycode.cr","line_number":14,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr"},{"filename":"uri/uri_parser.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/uri_parser.cr"},{"filename":"uri.cr","line_number":22,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"This class represents a URI reference as defined by [RFC 3986: Uniform Resource Identifier\n(URI): Generic Syntax](https://www.ietf.org/rfc/rfc3986.txt).\n\nThis class provides constructors for creating URI instances from\ntheir components or by parsing their string forms and methods for accessing the various\ncomponents of an instance.\n\nBasic example:\n\n```\nrequire \"uri\"\n\nuri = URI.parse \"http://foo.com/posts?id=30&limit=5#time=1305298413\"\n# => #<URI:0x1003f1e40 @scheme=\"http\", @host=\"foo.com\", @port=nil, @path=\"/posts\", @query=\"id=30&limit=5\", ... >\nuri.scheme # => \"http\"\nuri.host   # => \"foo.com\"\nuri.query  # => \"id=30&limit=5\"\nuri.to_s   # => \"http://foo.com/posts?id=30&limit=5#time=1305298413\"\n```","summary":"<p>This class represents a URI reference as defined by <a href=\"https://www.ietf.org/rfc/rfc3986.txt\" target=\"_blank\">RFC 3986: Uniform Resource Identifier (URI): Generic Syntax</a>.</p>","class_methods":[{"id":"default_port(scheme:String):Int32?-class-method","html_id":"default_port(scheme:String):Int32?-class-method","name":"default_port","doc":"Returns the default port for the given *scheme* if known,\notherwise returns `nil`.\n\n```\nURI.default_port \"http\"  # => 80\nURI.default_port \"ponzi\" # => nil\n```","summary":"<p>Returns the default port for the given <em>scheme</em> if known, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String"}],"args_string":"(scheme : String) : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L503","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L503","def":{"name":"default_port","args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"@@default_ports[scheme.downcase]?"}},{"id":"escape(string:String,io:IO,space_to_plus=false)-class-method","html_id":"escape(string:String,io:IO,space_to_plus=false)-class-method","name":"escape","doc":"URL-encode a `String` and write the result to an `IO`.","summary":"<p>URL-encode a <code><a href=\"String.html\">String</a></code> and write the result to an <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"args_string":"(string : String, io : IO, space_to_plus = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L278","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L278","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.escape(string, io, space_to_plus) do |byte|\n  URI.unreserved?(byte)\nend"}},{"id":"escape(string:String,space_to_plus=false):String-class-method","html_id":"escape(string:String,space_to_plus=false):String-class-method","name":"escape","doc":"URL-encode a `String`.\n\nIf *space_to_plus* is `true`, it replace space character (0x20) to `'+'` and `'+'` is\nencoded to `'%2B'`. e.g. `application/x-www-form-urlencoded` want this replace.\n\n```\nURI.escape(\"'Stop!' said Fred\")                      # => \"%27Stop%21%27%20said%20Fred\"\nURI.escape(\"'Stop!' said Fred\", space_to_plus: true) # => \"%27Stop%21%27+said+Fred\"\n```","summary":"<p>URL-encode a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"args_string":"(string : String, space_to_plus = <span class=\"n\">false</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L256","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  escape(string, io, space_to_plus)\nend"}},{"id":"escape(string:String,io:IO,space_to_plus=false,&block)-class-method","html_id":"escape(string:String,io:IO,space_to_plus=false,&amp;block)-class-method","name":"escape","doc":"URL-encode a `String` and write the result to an `IO`.\n\nThis method requires block.","summary":"<p>URL-encode a <code><a href=\"String.html\">String</a></code> and write the result to an <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"args_string":"(string : String, io : IO, space_to_plus = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L285","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L285","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"string.each_byte do |byte|\n  char = byte.unsafe_chr\n  if (char == ' ') && space_to_plus\n    io.write_byte('+'.ord.to_u8)\n  else\n    if (char.ascii? && (yield byte)) && ((!space_to_plus) || (char != '+'))\n      io.write_byte(byte)\n    else\n      io.write_byte('%'.ord.to_u8)\n      if byte < 16\n        io.write_byte('0'.ord.to_u8)\n      end\n      byte.to_s(16, io, upcase: true)\n    end\n  end\nend\nio\n"}},{"id":"escape(string:String,space_to_plus=false,&block):String-class-method","html_id":"escape(string:String,space_to_plus=false,&amp;block):String-class-method","name":"escape","doc":"URL-encode a `String`.\n\nThis method requires block, the block is called with each characters\nwhose code is less than `0x80`. The characters that block returns\n`true` are not escaped, other characters are escaped.\n\n```\n# Escape URI path\nURI.escape(\"/foo/file?(1).txt\") do |byte|\n  URI.unreserved?(byte) || byte.chr == '/'\nend\n# => \"/foo/file%3F%281%29.txt\"\n```","summary":"<p>URL-encode a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"args_string":"(string : String, space_to_plus = <span class=\"n\">false</span>, &block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L273","def":{"name":"escape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"space_to_plus","doc":null,"default_value":"false","external_name":"space_to_plus","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  escape(string, io, space_to_plus) do |byte|\n    yield byte\n  end\nend"}},{"id":"reserved?(byte):Bool-class-method","html_id":"reserved?(byte):Bool-class-method","name":"reserved?","doc":"Returns whether given byte is reserved character defined in\n[RFC 3986](https://tools.ietf.org/html/rfc3986).\n\nReserved characters are ':', '/', '?', '#', '[', ']', '@', '!',\n'$', '&', \"'\", '(', ')', '*', '+', ',', ';' and '='.","summary":"<p>Returns whether given byte is reserved character defined in <a href=\"https://tools.ietf.org/html/rfc3986\" target=\"_blank\">RFC 3986</a>.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""}],"args_string":"(byte) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L306","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L306","def":{"name":"reserved?","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"char = byte.unsafe_chr\n('&' <= char && char <= ',') || ({'!', '#', '$', '/', ':', ';', '?', '@', '[', ']', '='}.includes?(char))\n"}},{"id":"set_default_port(scheme:String,port:Int32?):Nil-class-method","html_id":"set_default_port(scheme:String,port:Int32?):Nil-class-method","name":"set_default_port","doc":"Registers the default port for the given *scheme*.\n\nIf *port* is `nil`, the existing default port for the\n*scheme*, if any, will be unregistered.\n\n```\nURI.set_default_port \"ponzi\", 9999\n```","summary":"<p>Registers the default port for the given <em>scheme</em>.</p>","abstract":false,"args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32 | ::Nil"}],"args_string":"(scheme : String, port : Int32?) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L515","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L515","def":{"name":"set_default_port","args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String"},{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if port\n  @@default_ports[scheme.downcase] = port\nelse\n  @@default_ports.delete(scheme.downcase)\nend"}},{"id":"unescape(string:String,io:IO,plus_to_space=false)-class-method","html_id":"unescape(string:String,io:IO,plus_to_space=false)-class-method","name":"unescape","doc":"URL-decode a string and write the result to an `IO`.","summary":"<p>URL-decode a string and write the result to an <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"args_string":"(string : String, io : IO, plus_to_space = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L229","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L229","def":{"name":"unescape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.unescape(string, io, plus_to_space) do\n  false\nend"}},{"id":"unescape(string:String,plus_to_space=false):String-class-method","html_id":"unescape(string:String,plus_to_space=false):String-class-method","name":"unescape","doc":"URL-decode a `String`.\n\nIf *plus_to_space* is `true`, it replace plus character (`0x2B`) to ' '.\ne.g. `application/x-www-form-urlencoded` wants this replace.\n\n```\nURI.unescape(\"%27Stop%21%27%20said%20Fred\")                  # => \"'Stop!' said Fred\"\nURI.unescape(\"%27Stop%21%27+said+Fred\", plus_to_space: true) # => \"'Stop!' said Fred\"\n```","summary":"<p>URL-decode a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"args_string":"(string : String, plus_to_space = <span class=\"n\">false</span>) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L215","def":{"name":"unescape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  unescape(string, io, plus_to_space)\nend"}},{"id":"unescape(string:String,io:IO,plus_to_space=false,&block)-class-method","html_id":"unescape(string:String,io:IO,plus_to_space=false,&amp;block)-class-method","name":"unescape","doc":"URL-decode a `String` and write the result to an `IO`.\n\nThis method requires block.","summary":"<p>URL-decode a <code><a href=\"String.html\">String</a></code> and write the result to an <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"args_string":"(string : String, io : IO, plus_to_space = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L236","def":{"name":"unescape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"i = 0\nbytesize = string.bytesize\nwhile i < bytesize\n  byte = string.unsafe_byte_at(i)\n  char = byte.unsafe_chr\n  i = unescape_one(string, bytesize, i, byte, char, io, plus_to_space) do |byte|\n    yield byte\n  end\nend\nio\n"}},{"id":"unescape(string:String,plus_to_space=false,&block):String-class-method","html_id":"unescape(string:String,plus_to_space=false,&amp;block):String-class-method","name":"unescape","doc":"URL-decode a `String`.\n\nThis method requires block, the block is called with each bytes\nwhose is less than `0x80`. The bytes that block returns `true`\nare not unescaped, other characters are unescaped.","summary":"<p>URL-decode a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"args_string":"(string : String, plus_to_space = <span class=\"n\">false</span>, &block) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L224","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L224","def":{"name":"unescape","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  unescape(string, io, plus_to_space) do |byte|\n    yield byte\n  end\nend"}},{"id":"unescape_one(string,bytesize,i,byte,char,io,plus_to_space=false,&block)-class-method","html_id":"unescape_one(string,bytesize,i,byte,char,io,plus_to_space=false,&amp;block)-class-method","name":"unescape_one","doc":":nodoc:\nUnescapes one character. Private API","summary":"<p>:nodoc: Unescapes one character.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""},{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"args_string":"(string, bytesize, i, byte, char, io, plus_to_space = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L342","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L342","def":{"name":"unescape_one","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"bytesize","doc":null,"default_value":"","external_name":"bytesize","restriction":""},{"name":"i","doc":null,"default_value":"","external_name":"i","restriction":""},{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""},{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""},{"name":"plus_to_space","doc":null,"default_value":"false","external_name":"plus_to_space","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if plus_to_space && (char == '+')\n  io.write_byte(' '.ord.to_u8)\n  i = i + 1\n  return i\nend\nif (char == '%') && i < (bytesize - 2)\n  i = i + 1\n  first = string.unsafe_byte_at(i)\n  first_num = first.unsafe_chr.to_i?(16)\n  if first_num\n  else\n    io.write_byte(byte)\n    return i\n  end\n  i = i + 1\n  second = string.unsafe_byte_at(i)\n  second_num = second.unsafe_chr.to_i?(16)\n  if second_num\n  else\n    io.write_byte(byte)\n    io.write_byte(first)\n    return i\n  end\n  encoded = ((first_num * 16) + second_num).to_u8\n  i = i + 1\n  if encoded < 128 && (yield encoded)\n    io.write_byte(byte)\n    io.write_byte(first)\n    io.write_byte(second)\n    return i\n  end\n  io.write_byte(encoded)\n  return i\nend\nio.write_byte(byte)\ni = i + 1\ni\n"}},{"id":"unreserved?(byte):Bool-class-method","html_id":"unreserved?(byte):Bool-class-method","name":"unreserved?","doc":"Returns whether given byte is unreserved character defined in\n[RFC 3986](https://tools.ietf.org/html/rfc3986).\n\nUnreserved characters are alphabet, digit, '_', '.', '-', '~'.","summary":"<p>Returns whether given byte is unreserved character defined in <a href=\"https://tools.ietf.org/html/rfc3986\" target=\"_blank\">RFC 3986</a>.</p>","abstract":false,"args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""}],"args_string":"(byte) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L316","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L316","def":{"name":"unreserved?","args":[{"name":"byte","doc":null,"default_value":"","external_name":"byte","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"char = byte.unsafe_chr\nchar.ascii_alphanumeric? || ({'_', '.', '-', '~'}.includes?(char))\n"}}],"constructors":[{"id":"new(scheme=nil,host=nil,port=nil,path=nil,query=nil,user=nil,password=nil,fragment=nil,opaque=nil)-class-method","html_id":"new(scheme=nil,host=nil,port=nil,path=nil,query=nil,user=nil,password=nil,fragment=nil,opaque=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"scheme","doc":null,"default_value":"nil","external_name":"scheme","restriction":""},{"name":"host","doc":null,"default_value":"nil","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"path","doc":null,"default_value":"nil","external_name":"path","restriction":""},{"name":"query","doc":null,"default_value":"nil","external_name":"query","restriction":""},{"name":"user","doc":null,"default_value":"nil","external_name":"user","restriction":""},{"name":"password","doc":null,"default_value":"nil","external_name":"password","restriction":""},{"name":"fragment","doc":null,"default_value":"nil","external_name":"fragment","restriction":""},{"name":"opaque","doc":null,"default_value":"nil","external_name":"opaque","restriction":""}],"args_string":"(scheme = <span class=\"n\">nil</span>, host = <span class=\"n\">nil</span>, port = <span class=\"n\">nil</span>, path = <span class=\"n\">nil</span>, query = <span class=\"n\">nil</span>, user = <span class=\"n\">nil</span>, password = <span class=\"n\">nil</span>, fragment = <span class=\"n\">nil</span>, opaque = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L119","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L119","def":{"name":"new","args":[{"name":"scheme","doc":null,"default_value":"nil","external_name":"scheme","restriction":""},{"name":"host","doc":null,"default_value":"nil","external_name":"host","restriction":""},{"name":"port","doc":null,"default_value":"nil","external_name":"port","restriction":""},{"name":"path","doc":null,"default_value":"nil","external_name":"path","restriction":""},{"name":"query","doc":null,"default_value":"nil","external_name":"query","restriction":""},{"name":"user","doc":null,"default_value":"nil","external_name":"user","restriction":""},{"name":"password","doc":null,"default_value":"nil","external_name":"password","restriction":""},{"name":"fragment","doc":null,"default_value":"nil","external_name":"fragment","restriction":""},{"name":"opaque","doc":null,"default_value":"nil","external_name":"opaque","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(scheme, host, port, path, query, user, password, fragment, opaque)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"parse(raw_url:String):URI-class-method","html_id":"parse(raw_url:String):URI-class-method","name":"parse","doc":"Parses `raw_url` into an URI. The `raw_url` may be relative or absolute.\n\n```\nrequire \"uri\"\n\nuri = URI.parse(\"http://crystal-lang.org\") # => #<URI:0x1068a7e40 @scheme=\"http\", @host=\"crystal-lang.org\", ... >\nuri.scheme                                 # => \"http\"\nuri.host                                   # => \"crystal-lang.org\"\n```","summary":"<p>Parses <code>raw_url</code> into an URI.</p>","abstract":false,"args":[{"name":"raw_url","doc":null,"default_value":"","external_name":"raw_url","restriction":"String"}],"args_string":"(raw_url : String) : URI","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L202","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L202","def":{"name":"parse","args":[{"name":"raw_url","doc":null,"default_value":"","external_name":"raw_url","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"URI","visibility":"Public","body":"(URI::Parser.new(raw_url)).run.uri"}}],"instance_methods":[{"id":"==(other:self)-instance-method","html_id":"==(other:self)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"args_string":"(other : self)","source_link":null,"source_link":null,"def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"self"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if scheme == other.scheme\nelse\n  return false\nend\nif host == other.host\nelse\n  return false\nend\nif port == other.port\nelse\n  return false\nend\nif path == other.path\nelse\n  return false\nend\nif query == other.query\nelse\n  return false\nend\nif user == other.user\nelse\n  return false\nend\nif password == other.password\nelse\n  return false\nend\nif fragment == other.fragment\nelse\n  return false\nend\nif opaque == other.opaque\nelse\n  return false\nend\ntrue\n"}},{"id":"fragment:String?-instance-method","html_id":"fragment:String?-instance-method","name":"fragment","doc":"Returns the fragment component of the URI.\n\n```\nURI.parse(\"http://foo.com/bar#section1\").fragment # => \"section1\"\n```","summary":"<p>Returns the fragment component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L102","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L102","def":{"name":"fragment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@fragment"}},{"id":"fragment=(fragment:String?)-instance-method","html_id":"fragment=(fragment:String?)-instance-method","name":"fragment=","doc":"Sets the fragment component of the URI.","summary":"<p>Sets the fragment component of the URI.</p>","abstract":false,"args":[{"name":"fragment","doc":null,"default_value":"","external_name":"fragment","restriction":"String | ::Nil"}],"args_string":"(fragment : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L105","def":{"name":"fragment=","args":[{"name":"fragment","doc":null,"default_value":"","external_name":"fragment","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@fragment = fragment"}},{"id":"full_path-instance-method","html_id":"full_path-instance-method","name":"full_path","doc":"Returns the full path of this URI.\n\n```\nuri = URI.parse \"http://foo.com/posts?id=30&limit=5#time=1305298413\"\nuri.full_path # => \"/posts?id=30&limit=5\"\n```","summary":"<p>Returns the full path of this URI.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L138","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L138","def":{"name":"full_path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  str << (@path.try do |p|\n    !p.empty?\n  end ? @path : '/')\n  if (query = @query) && (!query.empty?)\n    (str << '?') << query\n  end\nend"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":null,"summary":null,"abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":null,"source_link":null,"def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = scheme.hash(hasher)\nhasher = host.hash(hasher)\nhasher = port.hash(hasher)\nhasher = path.hash(hasher)\nhasher = query.hash(hasher)\nhasher = user.hash(hasher)\nhasher = password.hash(hasher)\nhasher = fragment.hash(hasher)\nhasher = opaque.hash(hasher)\nhasher\n"}},{"id":"host:String?-instance-method","html_id":"host:String?-instance-method","name":"host","doc":"Returns the host component of the URI.\n\n```\nURI.parse(\"http://foo.com\").host # => \"foo.com\"\n```","summary":"<p>Returns the host component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L42","def":{"name":"host","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@host"}},{"id":"host=(host:String?)-instance-method","html_id":"host=(host:String?)-instance-method","name":"host=","doc":"Sets the host component of the URI.","summary":"<p>Sets the host component of the URI.</p>","abstract":false,"args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String | ::Nil"}],"args_string":"(host : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L45","def":{"name":"host=","args":[{"name":"host","doc":null,"default_value":"","external_name":"host","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@host = host"}},{"id":"hostname-instance-method","html_id":"hostname-instance-method","name":"hostname","doc":"Returns the host part of the URI and unwrap brackets for IPv6 addresses.\n\n```\nURI.parse(\"http://[::1]/bar\").hostname # => \"::1\"\nURI.parse(\"http://[::1]/bar\").host     # => \"[::1]\"\n```","summary":"<p>Returns the host part of the URI and unwrap brackets for IPv6 addresses.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L128","def":{"name":"hostname","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"host.try do |host|\n  (host.starts_with?('[')) && (host.ends_with?(']')) ? host[1..-2] : host\nend"}},{"id":"normalize-instance-method","html_id":"normalize-instance-method","name":"normalize","doc":"Returns normalized URI.","summary":"<p>Returns normalized URI.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L182","def":{"name":"normalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"uri = dup\nuri.normalize!\nuri\n"}},{"id":"normalize!-instance-method","html_id":"normalize!-instance-method","name":"normalize!","doc":"Destructive normalize.","summary":"<p>Destructive normalize.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L189","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L189","def":{"name":"normalize!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@path = remove_dot_segments(path)"}},{"id":"opaque:String?-instance-method","html_id":"opaque:String?-instance-method","name":"opaque","doc":"Returns the opaque component of the URI.\n\n```\nURI.parse(\"mailto:alice@example.com\").opaque # => \"alice@example.com\"\n```","summary":"<p>Returns the opaque component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L112","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L112","def":{"name":"opaque","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@opaque"}},{"id":"opaque=(opaque:String?)-instance-method","html_id":"opaque=(opaque:String?)-instance-method","name":"opaque=","doc":"Sets the opaque component of the URI.","summary":"<p>Sets the opaque component of the URI.</p>","abstract":false,"args":[{"name":"opaque","doc":null,"default_value":"","external_name":"opaque","restriction":"String | ::Nil"}],"args_string":"(opaque : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L115","def":{"name":"opaque=","args":[{"name":"opaque","doc":null,"default_value":"","external_name":"opaque","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@opaque = opaque"}},{"id":"password:String?-instance-method","html_id":"password:String?-instance-method","name":"password","doc":"Returns the password component of the URI.\n\n```\nURI.parse(\"http://admin:password@foo.com\").password # => \"password\"\n```","summary":"<p>Returns the password component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L92","def":{"name":"password","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@password"}},{"id":"password=(password:String?)-instance-method","html_id":"password=(password:String?)-instance-method","name":"password=","doc":"Sets the password component of the URI.","summary":"<p>Sets the password component of the URI.</p>","abstract":false,"args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"String | ::Nil"}],"args_string":"(password : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L95","def":{"name":"password=","args":[{"name":"password","doc":null,"default_value":"","external_name":"password","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@password = password"}},{"id":"path:String?-instance-method","html_id":"path:String?-instance-method","name":"path","doc":"Returns the path component of the URI.\n\n```\nURI.parse(\"http://foo.com/bar\").path # => \"/bar\"\n```","summary":"<p>Returns the path component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L62","def":{"name":"path","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@path"}},{"id":"path=(path:String?)-instance-method","html_id":"path=(path:String?)-instance-method","name":"path=","doc":"Sets the path component of the URI.","summary":"<p>Sets the path component of the URI.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String | ::Nil"}],"args_string":"(path : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L65","def":{"name":"path=","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@path = path"}},{"id":"port:Int32?-instance-method","html_id":"port:Int32?-instance-method","name":"port","doc":"Returns the port component of the URI.\n\n```\nURI.parse(\"http://foo.com:5432\").port # => 5432\n```","summary":"<p>Returns the port component of the URI.</p>","abstract":false,"args":[],"args_string":" : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L52","def":{"name":"port","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"@port"}},{"id":"port=(port:Int32?)-instance-method","html_id":"port=(port:Int32?)-instance-method","name":"port=","doc":"Sets the port component of the URI.","summary":"<p>Sets the port component of the URI.</p>","abstract":false,"args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32 | ::Nil"}],"args_string":"(port : Int32?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L55","def":{"name":"port=","args":[{"name":"port","doc":null,"default_value":"","external_name":"port","restriction":"Int32 | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@port = port"}},{"id":"query:String?-instance-method","html_id":"query:String?-instance-method","name":"query","doc":"Returns the query component of the URI.\n\n```\nURI.parse(\"http://foo.com/bar?q=1\").query # => \"q=1\"\n```","summary":"<p>Returns the query component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L72","def":{"name":"query","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@query"}},{"id":"query=(query:String?)-instance-method","html_id":"query=(query:String?)-instance-method","name":"query=","doc":"Sets the query component of the URI.","summary":"<p>Sets the query component of the URI.</p>","abstract":false,"args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String | ::Nil"}],"args_string":"(query : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L75","def":{"name":"query=","args":[{"name":"query","doc":null,"default_value":"","external_name":"query","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@query = query"}},{"id":"scheme:String?-instance-method","html_id":"scheme:String?-instance-method","name":"scheme","doc":"Returns the scheme component of the URI.\n\n```\nURI.parse(\"http://foo.com\").scheme           # => \"http\"\nURI.parse(\"mailto:alice@example.com\").scheme # => \"mailto\"\n```","summary":"<p>Returns the scheme component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L32","def":{"name":"scheme","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@scheme"}},{"id":"scheme=(scheme:String?)-instance-method","html_id":"scheme=(scheme:String?)-instance-method","name":"scheme=","doc":"Sets the scheme component of the URI.","summary":"<p>Sets the scheme component of the URI.</p>","abstract":false,"args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String | ::Nil"}],"args_string":"(scheme : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L35","def":{"name":"scheme=","args":[{"name":"scheme","doc":null,"default_value":"","external_name":"scheme","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@scheme = scheme"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L147","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if scheme\n  io << scheme\n  io << ':'\n  if opaque\n  else\n    io << \"//\"\n  end\nend\nif opaque\n  io << opaque\n  return\nend\nif user = @user\n  userinfo(user, io)\n  io << '@'\nend\nif host\n  io << host\nend\nif port.nil? || default_port?\nelse\n  io << ':'\n  io << port\nend\nif path\n  io << path\nend\nif query\n  io << '?'\n  io << query\nend\nif fragment\n  io << '#'\n  io << fragment\nend\n"}},{"id":"user:String?-instance-method","html_id":"user:String?-instance-method","name":"user","doc":"Returns the user component of the URI.\n\n```\nURI.parse(\"http://admin:password@foo.com\").user # => \"admin\"\n```","summary":"<p>Returns the user component of the URI.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L82","def":{"name":"user","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@user"}},{"id":"user=(user:String?)-instance-method","html_id":"user=(user:String?)-instance-method","name":"user=","doc":"Sets the user component of the URI.","summary":"<p>Sets the user component of the URI.</p>","abstract":false,"args":[{"name":"user","doc":null,"default_value":"","external_name":"user","restriction":"String | ::Nil"}],"args_string":"(user : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L85","def":{"name":"user=","args":[{"name":"user","doc":null,"default_value":"","external_name":"user","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@user = user"}},{"id":"userinfo-instance-method","html_id":"userinfo-instance-method","name":"userinfo","doc":"Returns the user-information component containing\nthe provided username and password.\n\n```\nuri = URI.parse \"http://admin:password@foo.com\"\nuri.userinfo # => \"admin:password\"\n```","summary":"<p>Returns the user-information component containing the provided username and password.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L329","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr#L329","def":{"name":"userinfo","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if user = @user\n  String.build do |io|\n    userinfo(user, io)\n  end\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/URI/Error","path":"URI/Error.html","kind":"class","full_name":"URI::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uri.cr","line_number":23,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/URI","kind":"class","full_name":"URI","name":"URI"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/URI/Punycode","path":"URI/Punycode.html","kind":"class","full_name":"URI::Punycode","name":"Punycode","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uri/punycode.cr","line_number":15,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/URI","kind":"class","full_name":"URI","name":"URI"},"doc":null,"summary":null,"class_methods":[{"id":"decode(string)-class-method","html_id":"decode(string)-class-method","name":"decode","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L100","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L100","def":{"name":"decode","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"output, _, rest = string.rpartition(DELIMITER)\noutput = output.chars\nn = INITIAL_N\nbias = INITIAL_BIAS\ni = 0\ninit = true\nw = oldi = k = 0\nrest.each_char do |c|\n  if init\n    w = 1\n    oldi = i\n    k = BASE\n    init = false\n  end\n  digit = case c\n  when .ascii_lowercase?\n    c.ord - 97\n  when .ascii_uppercase?\n    c.ord - 65\n  when .ascii_number?\n    (c.ord - 48) + 26\n  else\n    raise(ArgumentError.new(\"Invalid input\"))\n  end\n  i = i + (digit * w)\n  t = k <= bias ? TMIN : k >= (bias + TMAX) ? TMAX : k - bias\n  if digit < t\n    outsize = output.size + 1\n    bias = adapt(i - oldi, outsize, oldi == 0)\n    n = n + (i / outsize)\n    i = i % outsize\n    output.insert(i, n.chr)\n    i = i + 1\n    init = true\n  else\n    w = w * (BASE - t)\n    k = k + BASE\n  end\nend\nif init\nelse\n  raise(ArgumentError.new(\"Invalid input\"))\nend\noutput.join\n"}},{"id":"encode(string,io)-class-method","html_id":"encode(string,io)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(string, io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L43","def":{"name":"encode","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"others = [] of Char\nstring.each_char do |c|\n  if c < '\\u{80}'\n    io << c\n  else\n    others.push(c)\n  end\nend\nif others.empty?\n  return\nend\nothers.sort!\nh = (string.size - others.size) + 1\ndelta = 0_u32\nn = INITIAL_N\nbias = INITIAL_BIAS\nfirsttime = true\nprev = nil\nif h > 1\n  io << DELIMITER\nend\nothers.each do |m|\n  if m == prev\n    next\n  end\n  prev = m\n  if (m.ord - n) > ((Int32::MAX - delta) / h)\n    raise(Exception.new(\"Overflow: input needs wider integers to process\"))\n  end\n  delta = delta + ((m.ord - n) * h)\n  n = m.ord + 1\n  string.each_char do |c|\n    if c < m\n      if delta > (Int32::MAX - 1)\n        raise(Exception.new(\"Overflow: input needs wider integers to process\"))\n      end\n      delta = delta + 1\n    else\n      if c == m\n        q = delta\n        k = BASE\n        loop do\n          t = k <= bias ? TMIN : k >= (bias + TMAX) ? TMAX : k - bias\n          if q < t\n            break\n          end\n          io << BASE36[t + ((q - t) % (BASE - t))]\n          q = (q - t) / (BASE - t)\n          k = k + BASE\n        end\n        io << BASE36[q]\n        bias = adapt(delta, h, firsttime)\n        delta = 0\n        h = h + 1\n        firsttime = false\n      end\n    end\n  end\n  delta = delta + 1\nend\n"}},{"id":"encode(string)-class-method","html_id":"encode(string)-class-method","name":"encode","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L39","def":{"name":"encode","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |io|\n  encode(string, io)\nend"}},{"id":"to_ascii(string)-class-method","html_id":"to_ascii(string)-class-method","name":"to_ascii","doc":null,"summary":null,"abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L151","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uri/punycode.cr#L151","def":{"name":"to_ascii","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if string.ascii_only?\n  return string\nend\nString.build do |io|\n  first = true\n  string.split('.') do |part|\n    if first\n    else\n      io << \".\"\n    end\n    if part.ascii_only?\n      io << part\n    else\n      io << \"xn--\"\n      encode(part, io)\n    end\n    first = false\n  end\nend\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/UUID","path":"UUID.html","kind":"struct","full_name":"UUID","name":"UUID","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uuid.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr"},{"filename":"uuid/json.cr","line_number":22,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid/json.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Adds JSON support to `UUID` for use in a JSON mapping.\n\nNOTE: `require \"uuid/json\"` is required to opt-in to this feature.\n\n```\nrequire \"json\"\nrequire \"uuid\"\nrequire \"uuid/json\"\n\nclass Example\n  JSON.mapping id: UUID\nend\n\nexample = Example.from_json(%({\"id\": \"ba714f86-cac6-42c7-8956-bcf5105e1b81\"}))\n\nuuid = UUID.new(\"87b3042b-9b9a-41b7-8b15-a93d3f17025e\")\nuuid.to_json # => \"87b3042b-9b9a-41b7-8b15-a93d3f17025e\"\n```","summary":"<p>Adds JSON support to <code><a href=\"UUID.html\">UUID</a></code> for use in a JSON mapping.</p>","class_methods":[{"id":"empty-class-method","html_id":"empty-class-method","name":"empty","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L120","def":{"name":"empty","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(StaticArray(UInt8, 16).new(0_u8), UUID::Variant::NCS, UUID::Version::V4)"}},{"id":"random(random=Random::Secure,variant=Variant::RFC4122,version=Version::V4)-class-method","html_id":"random(random=Random::Secure,variant=Variant::RFC4122,version=Version::V4)-class-method","name":"random","doc":"Generates RFC 4122 v4 UUID.\n\nIt is strongly recommended to use a cryptographically random source for\n*random*, such as `Random::Secure`.","summary":"<p>Generates RFC 4122 v4 UUID.</p>","abstract":false,"args":[{"name":"random","doc":null,"default_value":"Random::Secure","external_name":"random","restriction":""},{"name":"variant","doc":null,"default_value":"Variant::RFC4122","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"Version::V4","external_name":"version","restriction":""}],"args_string":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">Secure</span>, variant = <span class=\"t\">Variant</span><span class=\"t\">::</span><span class=\"t\">RFC4122</span>, version = <span class=\"t\">Version</span><span class=\"t\">::</span><span class=\"t\">V4</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L113","def":{"name":"random","args":[{"name":"random","doc":null,"default_value":"Random::Secure","external_name":"random","restriction":""},{"name":"variant","doc":null,"default_value":"Variant::RFC4122","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"Version::V4","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new_bytes = uninitialized ::StaticArray(UInt8, 16)\nrandom.random_bytes(new_bytes.to_slice)\nnew(new_bytes, variant, version)\n"}}],"constructors":[{"id":"new(bytes:StaticArray(UInt8,16),variant:UUID::Variant?=nil,version:UUID::Version?=nil)-class-method","html_id":"new(bytes:StaticArray(UInt8,16),variant:UUID::Variant?=nil,version:UUID::Version?=nil)-class-method","name":"new","doc":"Generates UUID from *bytes*, applying *version* and *variant* to the UUID if\npresent.","summary":"<p>Generates UUID from <em>bytes</em>, applying <em>version</em> and <em>variant</em> to the UUID if present.</p>","abstract":false,"args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"StaticArray(UInt8, 16)"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":"UUID::Variant | ::Nil"},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"UUID::Version | ::Nil"}],"args_string":"(bytes : StaticArray(UInt8, 16), variant : UUID::Variant? = <span class=\"n\">nil</span>, version : UUID::Version? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L24","def":{"name":"new","args":[{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"StaticArray(UInt8, 16)"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":"UUID::Variant | ::Nil"},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"UUID::Version | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(bytes, variant, version)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(slice:Slice(UInt8),variant=nil,version=nil)-class-method","html_id":"new(slice:Slice(UInt8),variant=nil,version=nil)-class-method","name":"new","doc":"Creates UUID from 16-bytes slice. Raises if *slice* isn't 16 bytes long. See\n`#initialize` for *variant* and *version*.","summary":"<p>Creates UUID from 16-bytes slice.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Slice(UInt8)"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"args_string":"(slice : Slice(UInt8), variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L48","def":{"name":"new","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Slice(UInt8)"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if slice.size == 16\nelse\n  raise(ArgumentError.new(\"Invalid bytes length #{slice.size}, expected 16\"))\nend\nbytes = uninitialized ::StaticArray(UInt8, 16)\nslice.copy_to(bytes.to_slice)\nnew(bytes, variant, version)\n"}},{"id":"new(uuid:UUID,variant=nil,version=nil)-class-method","html_id":"new(uuid:UUID,variant=nil,version=nil)-class-method","name":"new","doc":"Creates another `UUID` which is a copy of *uuid*, but allows overriding\n*variant* or *version*.","summary":"<p>Creates another <code><a href=\"UUID.html\">UUID</a></code> which is a copy of <em>uuid</em>, but allows overriding <em>variant</em> or <em>version</em>.</p>","abstract":false,"args":[{"name":"uuid","doc":null,"default_value":"","external_name":"uuid","restriction":"UUID"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"args_string":"(uuid : UUID, variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L59","def":{"name":"new","args":[{"name":"uuid","doc":null,"default_value":"","external_name":"uuid","restriction":"UUID"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(uuid.bytes, variant, version)"}},{"id":"new(value:String,variant=nil,version=nil)-class-method","html_id":"new(value:String,variant=nil,version=nil)-class-method","name":"new","doc":"Creates new UUID by decoding `value` string from hyphenated (ie. `ba714f86-cac6-42c7-8956-bcf5105e1b81`),\nhexstring (ie. `89370a4ab66440c8add39e06f2bb6af6`) or URN (ie. `urn:uuid:3f9eaf9e-cdb0-45cc-8ecb-0e5b2bfb0c20`)\nformat.","summary":"<p>Creates new UUID by decoding <code>value</code> string from hyphenated (ie.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"args_string":"(value : String, variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L66","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L66","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"},{"name":"variant","doc":null,"default_value":"nil","external_name":"variant","restriction":""},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"bytes = uninitialized ::StaticArray(UInt8, 16)\ncase value.size\nwhen 36\n  [8, 13, 18, 23].each do |offset|\n    if value[offset] != '-'\n      raise(ArgumentError.new(\"Invalid UUID string format, expected hyphen at char #{offset}\"))\n    end\n  end\n  [0, 2, 4, 6, 9, 11, 14, 16, 19, 21, 24, 26, 28, 30, 32, 34].each_with_index do |offset, i|\n    string_has_hex_pair_at!(value, offset)\n    bytes[i] = value[offset, 2].to_u8(16)\n  end\nwhen 32\n  16.times do |i|\n    string_has_hex_pair_at!(value, i * 2)\n    bytes[i] = value[i * 2, 2].to_u8(16)\n  end\nwhen 45\n  if value.starts_with?(\"urn:uuid:\")\n  else\n    raise(ArgumentError.new(\"Invalid URN UUID format, expected string starting with \\\"urn:uuid:\\\"\"))\n  end\n  [9, 11, 13, 15, 18, 20, 23, 25, 28, 30, 33, 35, 37, 39, 41, 43].each_with_index do |offset, i|\n    string_has_hex_pair_at!(value, offset)\n    bytes[i] = value[offset, 2].to_u8(16)\n  end\nelse\n  raise(ArgumentError.new(\"Invalid string length #{value.size} for UUID, expected 32 (hexstring), 36 (hyphenated) or 45 (urn)\"))\nend\nnew(bytes, variant, version)\n"}},{"id":"new(pull:JSON::PullParser)-class-method","html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid/json.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid/json.cr#L23","def":{"name":"new","args":[{"name":"pull","doc":null,"default_value":"","external_name":"pull","restriction":"JSON::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(pull.read_string)"}}],"instance_methods":[{"id":"==(other:UUID)-instance-method","html_id":"==(other:UUID)-instance-method","name":"==","doc":"Returns `true` if `other` UUID represents the same UUID, `false` otherwise.","summary":"<p>Returns <code>true</code> if <code>other</code> UUID represents the same UUID, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UUID"}],"args_string":"(other : UUID)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L163","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L163","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"UUID"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice == other.to_slice"}},{"id":"hexstring-instance-method","html_id":"hexstring-instance-method","name":"hexstring","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L190","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L190","def":{"name":"hexstring","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_slice.hexstring"}},{"id":"inspect(io:IO)-instance-method","html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Convert to `String` in literal format.","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in literal format.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L168","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L168","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"UUID(\"\nto_s(io)\nio << ')'\n"}},{"id":"to_json(json:JSON::Builder)-instance-method","html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":null,"summary":null,"abstract":false,"args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid/json.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid/json.cr#L27","def":{"name":"to_json","args":[{"name":"json","doc":null,"default_value":"","external_name":"json","restriction":"JSON::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"json.string(to_s)"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L174","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L174","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"slice = to_slice\nbuffer = uninitialized ::StaticArray(UInt8, 36)\nbuffer_ptr = buffer.to_unsafe\nbuffer_ptr[8] = buffer_ptr[13] = buffer_ptr[18] = buffer_ptr[23] = '-'.ord.to_u8\nslice[0, 4].hexstring(buffer_ptr + 0)\nslice[4, 2].hexstring(buffer_ptr + 9)\nslice[6, 2].hexstring(buffer_ptr + 14)\nslice[8, 2].hexstring(buffer_ptr + 19)\nslice[10, 6].hexstring(buffer_ptr + 24)\nio.write(buffer.to_slice)\n"}},{"id":"to_slice-instance-method","html_id":"to_slice-instance-method","name":"to_slice","doc":"Returns 16-byte slice.","summary":"<p>Returns 16-byte slice.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L153","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L153","def":{"name":"to_slice","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytes.to_slice"}},{"id":"to_unsafe-instance-method","html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":"Returns unsafe pointer to 16-bytes.","summary":"<p>Returns unsafe pointer to 16-bytes.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L158","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L158","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@bytes.to_unsafe"}},{"id":"urn-instance-method","html_id":"urn-instance-method","name":"urn","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L194","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L194","def":{"name":"urn","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build(45) do |str|\n  str << \"urn:uuid:\"\n  to_s(str)\nend"}},{"id":"v1!-instance-method","html_id":"v1!-instance-method","name":"v1!","doc":"Returns `true` if UUID looks is a V1, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V1, raises <code>Error</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v1!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if v1?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V1\"))\nend"}},{"id":"v1?-instance-method","html_id":"v1?-instance-method","name":"v1?","doc":"Returns `true` if UUID looks is a V1, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V1, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == RFC4122::Version::V1)"}},{"id":"v2!-instance-method","html_id":"v2!-instance-method","name":"v2!","doc":"Returns `true` if UUID looks is a V2, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V2, raises <code>Error</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v2!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if v2?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V2\"))\nend"}},{"id":"v2?-instance-method","html_id":"v2?-instance-method","name":"v2?","doc":"Returns `true` if UUID looks is a V2, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V2, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == RFC4122::Version::V2)"}},{"id":"v3!-instance-method","html_id":"v3!-instance-method","name":"v3!","doc":"Returns `true` if UUID looks is a V3, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V3, raises <code>Error</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v3!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if v3?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V3\"))\nend"}},{"id":"v3?-instance-method","html_id":"v3?-instance-method","name":"v3?","doc":"Returns `true` if UUID looks is a V3, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V3, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v3?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == RFC4122::Version::V3)"}},{"id":"v4!-instance-method","html_id":"v4!-instance-method","name":"v4!","doc":"Returns `true` if UUID looks is a V4, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V4, raises <code>Error</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v4!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if v4?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V4\"))\nend"}},{"id":"v4?-instance-method","html_id":"v4?-instance-method","name":"v4?","doc":"Returns `true` if UUID looks is a V4, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V4, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v4?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == RFC4122::Version::V4)"}},{"id":"v5!-instance-method","html_id":"v5!-instance-method","name":"v5!","doc":"Returns `true` if UUID looks is a V5, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V5, raises <code>Error</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v5!","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if v5?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V5\"))\nend"}},{"id":"v5?-instance-method","html_id":"v5?-instance-method","name":"v5?","doc":"Returns `true` if UUID looks is a V5, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID looks is a V5, <code>false</code> otherwise.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L201","def":{"name":"v5?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == RFC4122::Version::V5)"}},{"id":"variant-instance-method","html_id":"variant-instance-method","name":"variant","doc":"Returns UUID variant.","summary":"<p>Returns UUID variant.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L125","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L125","def":{"name":"variant","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case\nwhen (@bytes[8] & 128) == 0\n  Variant::NCS\nwhen (@bytes[8] & 192) == 128\n  Variant::RFC4122\nwhen (@bytes[8] & 224) == 192\n  Variant::Microsoft\nwhen (@bytes[8] & 224) == 224\n  Variant::Future\nelse\n  Variant::Unknown\nend"}},{"id":"version-instance-method","html_id":"version-instance-method","name":"version","doc":"Returns version based on RFC4122 format. See also `#variant`.","summary":"<p>Returns version based on RFC4122 format.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L141","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case @bytes[6] >> 4\nwhen 1\n  Version::V1\nwhen 2\n  Version::V2\nwhen 3\n  Version::V3\nwhen 4\n  Version::V4\nwhen 5\n  Version::V5\nelse\n  Version::Unknown\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/UUID/Variant","path":"UUID/Variant.html","kind":"enum","full_name":"UUID::Variant","name":"Variant","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uuid.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Unknown","name":"Unknown","value":"0","doc":"variants with 16 bytes.","summary":"<p>variants with 16 bytes.</p>"},{"id":"NCS","name":"NCS","value":"1","doc":"Unknown (ie. custom, your own).","summary":"<p>Unknown (ie.</p>"},{"id":"RFC4122","name":"RFC4122","value":"2","doc":"Reserved by the NCS for backward compatibility.","summary":"<p>Reserved by the NCS for backward compatibility.</p>"},{"id":"Microsoft","name":"Microsoft","value":"3","doc":"Reserved for RFC4122 Specification (default).","summary":"<p>Reserved for RFC4122 Specification (default).</p>"},{"id":"Future","name":"Future","value":"4","doc":"Reserved by Microsoft for backward compatibility.","summary":"<p>Reserved by Microsoft for backward compatibility.</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"future?-instance-method","html_id":"future?-instance-method","name":"future?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L8","def":{"name":"future?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Future"}},{"id":"microsoft?-instance-method","html_id":"microsoft?-instance-method","name":"microsoft?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L7","def":{"name":"microsoft?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Microsoft"}},{"id":"ncs?-instance-method","html_id":"ncs?-instance-method","name":"ncs?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L5","def":{"name":"ncs?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NCS"}},{"id":"rfc4122?-instance-method","html_id":"rfc4122?-instance-method","name":"rfc4122?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L6","def":{"name":"rfc4122?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == RFC4122"}},{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L4","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Unknown"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/UUID/Version","path":"UUID/Version.html","kind":"enum","full_name":"UUID::Version","name":"Version","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"uuid.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"Unknown","name":"Unknown","value":"0","doc":"RFC4122 UUID versions.","summary":"<p>RFC4122 UUID versions.</p>"},{"id":"V1","name":"V1","value":"1","doc":"Unknown version.","summary":"<p>Unknown version.</p>"},{"id":"V2","name":"V2","value":"2","doc":"date-time and MAC address.","summary":"<p>date-time and MAC address.</p>"},{"id":"V3","name":"V3","value":"3","doc":"DCE security.","summary":"<p>DCE security.</p>"},{"id":"V4","name":"V4","value":"4","doc":"MD5 hash and namespace.","summary":"<p>MD5 hash and namespace.</p>"},{"id":"V5","name":"V5","value":"5","doc":"random.","summary":"<p>random.</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"unknown?-instance-method","html_id":"unknown?-instance-method","name":"unknown?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L12","def":{"name":"unknown?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == Unknown"}},{"id":"v1?-instance-method","html_id":"v1?-instance-method","name":"v1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L13","def":{"name":"v1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == V1"}},{"id":"v2?-instance-method","html_id":"v2?-instance-method","name":"v2?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L14","def":{"name":"v2?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == V2"}},{"id":"v3?-instance-method","html_id":"v3?-instance-method","name":"v3?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L15","def":{"name":"v3?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == V3"}},{"id":"v4?-instance-method","html_id":"v4?-instance-method","name":"v4?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L16","def":{"name":"v4?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == V4"}},{"id":"v5?-instance-method","html_id":"v5?-instance-method","name":"v5?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/uuid.cr#L17","def":{"name":"v5?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == V5"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/VaList","path":"VaList.html","kind":"struct","full_name":"VaList","name":"VaList","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"va_list.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/va_list.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":null,"summary":null,"class_methods":[{"id":"open(&block)-class-method","html_id":"open(&amp;block)-class-method","name":"open","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/va_list.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/va_list.cr#L11","def":{"name":"open","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"ap = uninitialized LibC::VaList\nIntrinsics.va_start(pointerof(ap))\nbegin\n  yield new(ap)\nensure\n  Intrinsics.va_end(pointerof(ap))\nend\n"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Value","path":"Value.html","kind":"struct","full_name":"Value","name":"Value","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"value.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/value.cr"},{"filename":"json/any.cr","line_number":270,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr"},{"filename":"yaml/any.cr","line_number":281,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/Bool","kind":"struct","full_name":"Bool","name":"Bool"},{"html_id":"github.com/crystal-lang/crystal/Char","kind":"struct","full_name":"Char","name":"Char"},{"html_id":"github.com/crystal-lang/crystal/Class","kind":"class","full_name":"Class","name":"Class"},{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/NamedTuple","kind":"struct","full_name":"NamedTuple(**T)","name":"NamedTuple"},{"html_id":"github.com/crystal-lang/crystal/Nil","kind":"struct","full_name":"Nil","name":"Nil"},{"html_id":"github.com/crystal-lang/crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"github.com/crystal-lang/crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},{"html_id":"github.com/crystal-lang/crystal/Proc","kind":"struct","full_name":"Proc(*T, R)","name":"Proc"},{"html_id":"github.com/crystal-lang/crystal/StaticArray","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Symbol","kind":"struct","full_name":"Symbol","name":"Symbol"},{"html_id":"github.com/crystal-lang/crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"},{"html_id":"github.com/crystal-lang/crystal/Union","kind":"struct","full_name":"Union(*T)","name":"Union"}],"including_types":[],"namespace":null,"doc":"`Value` is the base type of the primitive types (`Nil`, `Bool`, `Char`, `Number`),\n`Symbol`, `Pointer`, `Tuple`, `StaticArray` and all structs.\n\nA `Value` is passed by value: when you pass it to methods,\nreturn it from methods or assign it to variables, a copy\nof the value is actually passed.\nThis is not important for nil, bools, integers, floats, symbols,\npointers and tuples, because they are immutable, but with a mutable\n`Struct` or with a `StaticArray` you have to be careful. Read their\ndocumentation to learn more about this.","summary":"<p><code><a href=\"Value.html\">Value</a></code> is the base type of the primitive types (<code><a href=\"Nil.html\">Nil</a></code>, <code><a href=\"Bool.html\">Bool</a></code>, <code><a href=\"Char.html\">Char</a></code>, <code><a href=\"Number.html\">Number</a></code>), <code><a href=\"Symbol.html\">Symbol</a></code>, <code><a href=\"Pointer.html\">Pointer</a></code>, <code><a href=\"Tuple.html\">Tuple</a></code>, <code><a href=\"StaticArray.html\">StaticArray</a></code> and all structs.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"==(other:JSON::Any)-instance-method","html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L271","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/json/any.cr#L271","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"JSON::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other:YAML::Any)-instance-method","html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":null,"summary":null,"abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L282","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L282","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == other.raw"}},{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/value.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/value.cr#L13","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"false"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/value.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/value.cr#L22","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/WeakRef","path":"WeakRef.html","kind":"class","full_name":"WeakRef(T)","name":"WeakRef","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"weak_ref.cr","line_number":9,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/weak_ref.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"Weak Reference class that allows a referenced object to be garbage-collected.\n\n```\nref = WeakRef.new(\"oof\".reverse)\np ref.value # => \"foo\"\nGC.collect\np ref.value # => nil\n```","summary":"<p>Weak Reference class that allows a referenced object to be garbage-collected.</p>","class_methods":[],"constructors":[{"id":"new(target:T)-class-method","html_id":"new(target:T)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"T"}],"args_string":"(target : T)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/weak_ref.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/weak_ref.cr#L12","def":{"name":"new","args":[{"name":"target","doc":null,"default_value":"","external_name":"target","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = WeakRef(T).allocate\n_.initialize(target)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"value-instance-method","html_id":"value-instance-method","name":"value","doc":"Returns the referenced object or `Nil` if it has been garbage-collected.","summary":"<p>Returns the referenced object or <code><a href=\"Nil.html\">Nil</a></code> if it has been garbage-collected.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/weak_ref.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/weak_ref.cr#L27","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@target.as(T | ::Nil)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML","path":"XML.html","kind":"module","full_name":"XML","name":"XML","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"xml.cr","line_number":49,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr"},{"filename":"xml/builder.cr","line_number":288,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The XML module allows parsing and generating [XML](https://www.w3.org/XML/) documents.\n\n### Parsing\n\n`XML#parse` will parse xml from `String` or `IO` and return xml document as an `XML::Node` which represents all kinds of xml nodes.\n\nExample:\n\n```\nrequire \"xml\"\n\nxml = <<-XML\n <person id=\"1\">\n  <firstname>Jane</firstname>\n  <lastname>Doe</lastname>\n </person>\nXML\n\ndocument = XML.parse(xml)             # : XML::Node\nperson = document.first_element_child # : XML::Node?\nif person\n  puts person[\"id\"] # \"1\" : String?\n\n  puts typeof(person.children)                       # XML::NodeSet\n  person.children.select(&.element?).each do |child| # Select only element children\n    puts typeof(child)                               # XML::Node\n    puts child.name                                  # firstname : String\n    puts child.content                               # Jane : String?\n  end\nend\n```\n\n## Generating\n\nUse `XML.build`, which uses an `XML::Builder`:\n\n```\nrequire \"xml\"\n\nstring = XML.build(indent: \"  \") do |xml|\n  xml.element(\"person\", id: 1) do\n    xml.element(\"firstname\") { xml.text \"Jane\" }\n    xml.element(\"lastname\") { xml.text \"Doe\" }\n  end\nend\n\nstring # => \"<?xml version=\\\"1.0\\\"?>\\n<person id=\\\"1\\\">\\n  <firstname>Jane</firstname>\\n  <lastname>Doe</lastname>\\n</person>\\n\"\n```","summary":"<p>The XML module allows parsing and generating <a href=\"https://www.w3.org/XML/\" target=\"_blank\">XML</a> documents.</p>","class_methods":[{"id":"build(version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&block)-class-method","html_id":"build(version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&amp;block)-class-method","name":"build","doc":"Returns the resulting `String` of writing XML to the yielded `XML::Builder`.\n\n```\nrequire \"xml\"\n\nstring = XML.build(indent: \"  \") do |xml|\n  xml.element(\"person\", id: 1) do\n    xml.element(\"firstname\") { xml.text \"Jane\" }\n    xml.element(\"lastname\") { xml.text \"Doe\" }\n  end\nend\n\nstring # => \"<?xml version=\\\"1.0\\\"?>\\n<person id=\\\"1\\\">\\n  <firstname>Jane</firstname>\\n  <lastname>Doe</lastname>\\n</person>\\n\"\n```","summary":"<p>Returns the resulting <code><a href=\"String.html\">String</a></code> of writing XML to the yielded <code><a href=\"XML/Builder.html\">XML::Builder</a></code>.</p>","abstract":false,"args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","doc":null,"default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(version : String? = <span class=\"n\">nil</span>, encoding : String? = <span class=\"n\">nil</span>, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L303","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L303","def":{"name":"build","args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","doc":null,"default_value":"nil","external_name":"quote_char","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  build(str, version, encoding, indent, quote_char) do |xml|\n    yield xml\n  end\nend"}},{"id":"build(io:IO,version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&block)-class-method","html_id":"build(io:IO,version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&amp;block)-class-method","name":"build","doc":"Writes XML into the given `IO`. An `XML::Builder` is yielded to the block.","summary":"<p>Writes XML into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","doc":null,"default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(io : IO, version : String? = <span class=\"n\">nil</span>, encoding : String? = <span class=\"n\">nil</span>, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L312","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L312","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","doc":null,"default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","doc":null,"default_value":"nil","external_name":"quote_char","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"xml = XML::Builder.new(io)\nif indent\n  xml.indent = indent\nend\nif quote_char\n  xml.quote_char = quote_char\nend\nv = xml.document(version, encoding) do\n  yield xml\nend\nxml.flush\nv\n"}},{"id":"parse(string:String,options:ParserOptions=ParserOptions.default):Node-class-method","html_id":"parse(string:String,options:ParserOptions=ParserOptions.default):Node-class-method","name":"parse","doc":"Parses an XML document from *string* with *options* into an `XML::Node`.\n\nSee `ParserOptions.default` for default options.","summary":"<p>Parses an XML document from <em>string</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"options","doc":null,"default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"args_string":"(string : String, options : ParserOptions = <span class=\"t\">ParserOptions</span>.default) : Node","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L53","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L53","def":{"name":"parse","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"options","doc":null,"default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node","visibility":"Public","body":"if string.empty?\n  raise(XML::Error.new(\"Document is empty\", 0))\nend\nfrom_ptr(LibXML.xmlReadMemory(string, string.bytesize, nil, nil, options))\n"}},{"id":"parse(io:IO,options:ParserOptions=ParserOptions.default):Node-class-method","html_id":"parse(io:IO,options:ParserOptions=ParserOptions.default):Node-class-method","name":"parse","doc":"Parses an XML document from *io* with *options* into an `XML::Node`.\n\nSee `ParserOptions.default` for default options.","summary":"<p>Parses an XML document from <em>io</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"options","doc":null,"default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"args_string":"(io : IO, options : ParserOptions = <span class=\"t\">ParserOptions</span>.default) : Node","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L61","def":{"name":"parse","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"options","doc":null,"default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node","visibility":"Public","body":"from_ptr(LibXML.xmlReadIO(->(ctx, buffer, len) do\n  LibC::Int.new((Box(IO).unbox(ctx)).read(Slice.new(buffer, len)))\nend, ->(ctx) do\n  0\nend, Box(IO).box(io), nil, nil, options))"}},{"id":"parse_html(string:String,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","html_id":"parse_html(string:String,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","name":"parse_html","doc":"Parses an HTML document from *string* with *options* into an `XML::Node`.\n\nSee `HTMLParserOptions.default` for default options.","summary":"<p>Parses an HTML document from <em>string</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"options","doc":null,"default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"args_string":"(string : String, options : HTMLParserOptions = <span class=\"t\">HTMLParserOptions</span>.default) : Node","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L77","def":{"name":"parse_html","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"},{"name":"options","doc":null,"default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node","visibility":"Public","body":"if string.empty?\n  raise(XML::Error.new(\"Document is empty\", 0))\nend\nfrom_ptr(LibXML.htmlReadMemory(string, string.bytesize, nil, nil, options))\n"}},{"id":"parse_html(io:IO,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","html_id":"parse_html(io:IO,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","name":"parse_html","doc":"Parses an HTML document from *io* with *options* into an `XML::Node`.\n\nSee `HTMLParserOptions.default` for default options.","summary":"<p>Parses an HTML document from <em>io</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"options","doc":null,"default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"args_string":"(io : IO, options : HTMLParserOptions = <span class=\"t\">HTMLParserOptions</span>.default) : Node","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml.cr#L85","def":{"name":"parse_html","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"options","doc":null,"default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node","visibility":"Public","body":"from_ptr(LibXML.htmlReadIO(->(ctx, buffer, len) do\n  LibC::Int.new((Box(IO).unbox(ctx)).read(Slice.new(buffer, len)))\nend, ->(ctx) do\n  0\nend, Box(IO).box(io), nil, nil, options))"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/XML/Attributes","path":"XML/Attributes.html","kind":"struct","full_name":"XML::Attributes","name":"Attributes","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/attributes.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(node:Node)-class-method","html_id":"new(node:Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"Node"}],"args_string":"(node : Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L6","def":{"name":"new","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"[](index:Int)-instance-method","html_id":"[](index:Int)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L16","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size = self.size\nif index < 0\n  index = index + size\nend\nif 0 <= index && index < size\nelse\n  raise(IndexError.new)\nend\neach_with_index do |node, i|\n  if i == index\n    return node\n  end\nend\nraise(IndexError.new)\n"}},{"id":"[](name:String)-instance-method","html_id":"[](name:String)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L32","def":{"name":"[]","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self[name]? || (raise(KeyError.new(\"Missing attribute: #{name}\")))"}},{"id":"[]=(name:String,value)-instance-method","html_id":"[]=(name:String,value)-instance-method","name":"[]=","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name : String, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L40","def":{"name":"[]=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibXML.xmlSetProp(@node, name, value.to_s)\nvalue\n"}},{"id":"[]?(name:String)-instance-method","html_id":"[]?(name:String)-instance-method","name":"[]?","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L36","def":{"name":"[]?","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"find do |node|\n  node.name == name\nend"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L45","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if @node.element?\nelse\n  return\nend\nprops = self.props\nwhile !props.null?\n  yield Node.new(props)\n  props = props.value.next\nend\n"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L9","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @node.element?\nelse\n  return true\nend\nprops = self.props\nprops.null?\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L61","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attributes.cr#L55","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '['\njoin(\", \", io, &.inspect(io))\nio << ']'\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/AttributeType","path":"XML/AttributeType.html","kind":"enum","full_name":"XML::AttributeType","name":"AttributeType","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/attribute_type.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"CDATA","name":"CDATA","value":"1","doc":null,"summary":null},{"id":"ID","name":"ID","value":"2","doc":null,"summary":null},{"id":"IDREF","name":"IDREF","value":"3","doc":null,"summary":null},{"id":"IDREFS","name":"IDREFS","value":"4","doc":null,"summary":null},{"id":"ENTITY","name":"ENTITY","value":"5","doc":null,"summary":null},{"id":"ENTITIES","name":"ENTITIES","value":"6","doc":null,"summary":null},{"id":"NMTOKEN","name":"NMTOKEN","value":"7","doc":null,"summary":null},{"id":"NMTOKENS","name":"NMTOKENS","value":"8","doc":null,"summary":null},{"id":"ENUMERATION","name":"ENUMERATION","value":"9","doc":null,"summary":null},{"id":"NOTATION","name":"NOTATION","value":"10","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"cdata?-instance-method","html_id":"cdata?-instance-method","name":"cdata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L2","def":{"name":"cdata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CDATA"}},{"id":"entities?-instance-method","html_id":"entities?-instance-method","name":"entities?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L7","def":{"name":"entities?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENTITIES"}},{"id":"entity?-instance-method","html_id":"entity?-instance-method","name":"entity?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L6","def":{"name":"entity?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENTITY"}},{"id":"enumeration?-instance-method","html_id":"enumeration?-instance-method","name":"enumeration?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L10","def":{"name":"enumeration?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENUMERATION"}},{"id":"id?-instance-method","html_id":"id?-instance-method","name":"id?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L3","def":{"name":"id?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ID"}},{"id":"idref?-instance-method","html_id":"idref?-instance-method","name":"idref?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L4","def":{"name":"idref?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IDREF"}},{"id":"idrefs?-instance-method","html_id":"idrefs?-instance-method","name":"idrefs?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L5","def":{"name":"idrefs?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == IDREFS"}},{"id":"nmtoken?-instance-method","html_id":"nmtoken?-instance-method","name":"nmtoken?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L8","def":{"name":"nmtoken?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NMTOKEN"}},{"id":"nmtokens?-instance-method","html_id":"nmtokens?-instance-method","name":"nmtokens?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L9","def":{"name":"nmtokens?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NMTOKENS"}},{"id":"notation?-instance-method","html_id":"notation?-instance-method","name":"notation?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/attribute_type.cr#L11","def":{"name":"notation?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NOTATION"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Builder","path":"XML/Builder.html","kind":"struct","full_name":"XML::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/builder.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":"An XML builder generates valid XML.\n\nAn `XML::Error` is raised if attempting to generate\nan invalid XML (for example, if invoking `end_element`\nwithout a matching `start_element`, or trying to use\na non-string value as an object's field name)","summary":"<p>An XML builder generates valid XML.</p>","class_methods":[],"constructors":[{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a builder that writes to the given *io*.","summary":"<p>Creates a builder that writes to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L11","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"attribute(name:String,value):Nil-instance-method","html_id":"attribute(name:String,value):Nil-instance-method","name":"attribute","doc":"Emits an attribute with a *value*.","summary":"<p>Emits an attribute with a <em>value</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name : String, value) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L135","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L135","def":{"name":"attribute","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteAttribute, string_to_unsafe(name), string_to_unsafe(value.to_s))"}},{"id":"attribute(prefix:String?,name:String,namespace_uri:String?,value):Nil-instance-method","html_id":"attribute(prefix:String?,name:String,namespace_uri:String?,value):Nil-instance-method","name":"attribute","doc":"Emits an attribute with namespace info and a *value*.","summary":"<p>Emits an attribute with namespace info and a <em>value</em>.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, value) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L140","def":{"name":"attribute","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteAttributeNS, string_to_unsafe(prefix), string_to_unsafe(name), string_to_unsafe(namespace_uri), string_to_unsafe(value.to_s))"}},{"id":"attribute(*args,**nargs,&block)-instance-method","html_id":"attribute(*args,**nargs,&amp;block)-instance-method","name":"attribute","doc":"Emits the start of an attribute, invokes the block,\nand then emits the end of the attribute.","summary":"<p>Emits the start of an attribute, invokes the block, and then emits the end of the attribute.</p>","abstract":false,"args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"args_string":"(*args, **nargs, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L129","def":{"name":"attribute","args":[{"name":"args","doc":null,"default_value":"","external_name":"args","restriction":""}],"double_splat":{"name":"nargs","doc":null,"default_value":"","external_name":"nargs","restriction":""},"splat_index":0,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_attribute(*args, **nargs)\n(yield).tap do\n  end_attribute\nend\n"}},{"id":"attributes(attributes:Hash|NamedTuple)-instance-method","html_id":"attributes(attributes:Hash|NamedTuple)-instance-method","name":"attributes","doc":"Emits the given *attributes* with their values.","summary":"<p>Emits the given <em>attributes</em> with their values.</p>","abstract":false,"args":[{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(attributes : Hash | NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L150","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L150","def":{"name":"attributes","args":[{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"attributes.each do |key, value|\n  attribute(key.to_s, value)\nend"}},{"id":"attributes-instance-method","html_id":"attributes-instance-method","name":"attributes","doc":"Emits the given *attributes* with their values.","summary":"<p>Emits the given <em>attributes</em> with their values.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L145","def":{"name":"attributes","args":[],"double_splat":{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":""},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"attributes(attributes)"}},{"id":"cdata(text:String):Nil-instance-method","html_id":"cdata(text:String):Nil-instance-method","name":"cdata","doc":"Emits a `CDATA` section.","summary":"<p>Emits a <code>CDATA</code> section.</p>","abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"}],"args_string":"(text : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L181","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L181","def":{"name":"cdata","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteCDATA, string_to_unsafe(text))"}},{"id":"cdata(&block)-instance-method","html_id":"cdata(&amp;block)-instance-method","name":"cdata","doc":"Emits the start of a `CDATA` section, invokes the block\nand then emits the end of the `CDATA` section.","summary":"<p>Emits the start of a <code>CDATA</code> section, invokes the block and then emits the end of the <code>CDATA</code> section.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L175","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L175","def":{"name":"cdata","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_cdata\n(yield).tap do\n  end_cdata\nend\n"}},{"id":"comment(text:String):Nil-instance-method","html_id":"comment(text:String):Nil-instance-method","name":"comment","doc":"Emits a comment.","summary":"<p>Emits a comment.</p>","abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"}],"args_string":"(text : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L203","def":{"name":"comment","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteComment, string_to_unsafe(text))"}},{"id":"comment(&block)-instance-method","html_id":"comment(&amp;block)-instance-method","name":"comment","doc":"Emits the start of a comment, invokes the block\nand then emits the end of the comment.","summary":"<p>Emits the start of a comment, invokes the block and then emits the end of the comment.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L197","def":{"name":"comment","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_comment\n(yield).tap do\n  end_comment\nend\n"}},{"id":"document(version=nil,encoding=nil,&block)-instance-method","html_id":"document(version=nil,encoding=nil,&amp;block)-instance-method","name":"document","doc":"Emits the start of the document, invokes the block,\nand then emits the end of the document.","summary":"<p>Emits the start of the document, invokes the block, and then emits the end of the document.</p>","abstract":false,"args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""}],"args_string":"(version = <span class=\"n\">nil</span>, encoding = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L40","def":{"name":"document","args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_document(version, encoding)\n(yield).tap do\n  end_document\nend\n"}},{"id":"dtd(name:String,pubid:String,sysid:String,subset:String?=nil):Nil-instance-method","html_id":"dtd(name:String,pubid:String,sysid:String,subset:String?=nil):Nil-instance-method","name":"dtd","doc":"Emits a `DTD`.","summary":"<p>Emits a <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"},{"name":"subset","doc":null,"default_value":"nil","external_name":"subset","restriction":"String | ::Nil"}],"args_string":"(name : String, pubid : String, sysid : String, subset : String? = <span class=\"n\">nil</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L225","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L225","def":{"name":"dtd","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"},{"name":"subset","doc":null,"default_value":"nil","external_name":"subset","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteDTD, string_to_unsafe(name), string_to_unsafe(pubid), string_to_unsafe(sysid), string_to_unsafe(subset))"}},{"id":"dtd(name:String,pubid:String,sysid:String,&block):Nil-instance-method","html_id":"dtd(name:String,pubid:String,sysid:String,&amp;block):Nil-instance-method","name":"dtd","doc":"Emits the start of a `DTD`, invokes the block\nand then emits the end of the `DTD`.","summary":"<p>Emits the start of a <code>DTD</code>, invokes the block and then emits the end of the <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"}],"args_string":"(name : String, pubid : String, sysid : String, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L219","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L219","def":{"name":"dtd","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"start_dtd(name, pubid, sysid)\n(yield).tap do\n  end_dtd\nend\n"}},{"id":"element(__name__:String,**attributes,&block)-instance-method","html_id":"element(__name__:String,**attributes,&amp;block)-instance-method","name":"element","doc":"Emits the start of an element with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"}],"args_string":"(__name__ : String, **attributes, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L62","def":{"name":"element","args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"}],"double_splat":{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":""},"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"element(__name__, attributes) do\n  yield\nend"}},{"id":"element(prefix:String?,name:String,namespace_uri:String?,attributes:Hash|NamedTuple)-instance-method","html_id":"element(prefix:String?,name:String,namespace_uri:String?,attributes:Hash|NamedTuple)-instance-method","name":"element","doc":"Emits an element with namespace info with the given *attributes*.","summary":"<p>Emits an element with namespace info with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, attributes : Hash | NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L106","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L106","def":{"name":"element","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"start_element(prefix, name, namespace_uri)\nattributes(attributes)\nend_element\n"}},{"id":"element(prefix:String?,name:String,namespace_uri:String?,**attributes)-instance-method","html_id":"element(prefix:String?,name:String,namespace_uri:String?,**attributes)-instance-method","name":"element","doc":"Emits an element with namespace info with the given *attributes*.","summary":"<p>Emits an element with namespace info with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, **attributes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L101","def":{"name":"element","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"double_splat":{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":""},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"element(prefix, name, namespace_uri, attributes)"}},{"id":"element(name:String,attributes:Hash|NamedTuple)-instance-method","html_id":"element(name:String,attributes:Hash|NamedTuple)-instance-method","name":"element","doc":"Emits an element with the given *attributes*.","summary":"<p>Emits an element with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(name : String, attributes : Hash | NamedTuple)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L81","def":{"name":"element","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"element(name, attributes) do\nend"}},{"id":"element(__name__:String,**attributes)-instance-method","html_id":"element(__name__:String,**attributes)-instance-method","name":"element","doc":"Emits an element with the given *attributes*.","summary":"<p>Emits an element with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"}],"args_string":"(__name__ : String, **attributes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L76","def":{"name":"element","args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"}],"double_splat":{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":""},"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"element(__name__, attributes)"}},{"id":"element(__name__:String,attributes:Hash|NamedTuple,&block)-instance-method","html_id":"element(__name__:String,attributes:Hash|NamedTuple,&amp;block)-instance-method","name":"element","doc":"Emits the start of an element with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(__name__ : String, attributes : Hash | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L69","def":{"name":"element","args":[{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_element(__name__)\nattributes(attributes)\n(yield).tap do\n  end_element\nend\n"}},{"id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,**attributes,&block)-instance-method","html_id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,**attributes,&amp;block)-instance-method","name":"element","doc":"Emits the start of an element with namespace info with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with namespace info with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__prefix__","doc":null,"default_value":"","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","doc":null,"default_value":"","external_name":"__namespace_uri__","restriction":"String | ::Nil"}],"args_string":"(__prefix__ : String?, __name__ : String, __namespace_uri__ : String?, **attributes, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L87","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L87","def":{"name":"element","args":[{"name":"__prefix__","doc":null,"default_value":"","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","doc":null,"default_value":"","external_name":"__namespace_uri__","restriction":"String | ::Nil"}],"double_splat":{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":""},"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"element(__prefix__, __name__, __namespace_uri__, attributes) do\n  yield\nend"}},{"id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,attributes:Hash|NamedTuple,&block)-instance-method","html_id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,attributes:Hash|NamedTuple,&amp;block)-instance-method","name":"element","doc":"Emits the start of an element with namespace info with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with namespace info with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__prefix__","doc":null,"default_value":"","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","doc":null,"default_value":"","external_name":"__namespace_uri__","restriction":"String | ::Nil"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(__prefix__ : String?, __name__ : String, __namespace_uri__ : String?, attributes : Hash | NamedTuple, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L94","def":{"name":"element","args":[{"name":"__prefix__","doc":null,"default_value":"","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","doc":null,"default_value":"","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","doc":null,"default_value":"","external_name":"__namespace_uri__","restriction":"String | ::Nil"},{"name":"attributes","doc":null,"default_value":"","external_name":"attributes","restriction":"Hash | NamedTuple"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_element(__prefix__, __name__, __namespace_uri__)\nattributes(attributes)\n(yield).tap do\n  end_element\nend\n"}},{"id":"end_attribute:Nil-instance-method","html_id":"end_attribute:Nil-instance-method","name":"end_attribute","doc":"Emits the end of an attribute.","summary":"<p>Emits the end of an attribute.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L123","def":{"name":"end_attribute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndAttribute)"}},{"id":"end_cdata:Nil-instance-method","html_id":"end_cdata:Nil-instance-method","name":"end_cdata","doc":"Emits the end of a `CDATA` section.","summary":"<p>Emits the end of a <code>CDATA</code> section.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L169","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L169","def":{"name":"end_cdata","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndCDATA)"}},{"id":"end_comment:Nil-instance-method","html_id":"end_comment:Nil-instance-method","name":"end_comment","doc":"Emits the end of a comment.","summary":"<p>Emits the end of a comment.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L191","def":{"name":"end_comment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndComment)"}},{"id":"end_document:Nil-instance-method","html_id":"end_document:Nil-instance-method","name":"end_document","doc":"Emits the end of a document.","summary":"<p>Emits the end of a document.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L34","def":{"name":"end_document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndDocument)"}},{"id":"end_dtd:Nil-instance-method","html_id":"end_dtd:Nil-instance-method","name":"end_dtd","doc":"Emits the end of a `DTD`.","summary":"<p>Emits the end of a <code>DTD</code>.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L213","def":{"name":"end_dtd","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndDTD)"}},{"id":"end_element:Nil-instance-method","html_id":"end_element:Nil-instance-method","name":"end_element","doc":"Emits the end of an element.","summary":"<p>Emits the end of an element.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L56","def":{"name":"end_element","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(EndElement)"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Forces content written to this writer to be flushed to\nthis writer's `IO`.","summary":"<p>Forces content written to this writer to be flushed to this writer's <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L236","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L236","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"call(Flush)"}},{"id":"indent=(level:Int)-instance-method","html_id":"indent=(level:Int)-instance-method","name":"indent=","doc":"Sets the indent *level* (number of spaces).","summary":"<p>Sets the indent <em>level</em> (number of spaces).</p>","abstract":false,"args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Int"}],"args_string":"(level : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L251","def":{"name":"indent=","args":[{"name":"level","doc":null,"default_value":"","external_name":"level","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if level <= 0\n  call(SetIndent, 0)\nelse\n  call(SetIndent, 1)\n  call(SetIndentString, \" \" * level)\nend"}},{"id":"indent=(str:String)-instance-method","html_id":"indent=(str:String)-instance-method","name":"indent=","doc":"Sets the indent string.","summary":"<p>Sets the indent string.</p>","abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L241","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L241","def":{"name":"indent=","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if str.empty?\n  call(SetIndent, 0)\nelse\n  call(SetIndent, 1)\n  call(SetIndentString, string_to_unsafe(str))\nend"}},{"id":"namespace(prefix,uri)-instance-method","html_id":"namespace(prefix,uri)-instance-method","name":"namespace","doc":"Emits a namespace.","summary":"<p>Emits a namespace.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""}],"args_string":"(prefix, uri)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L230","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L230","def":{"name":"namespace","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"attribute(prefix, \"xmlns\", nil, uri)"}},{"id":"quote_char=(char:Char)-instance-method","html_id":"quote_char=(char:Char)-instance-method","name":"quote_char=","doc":"Sets the quote char to use, either `'` or `\"`.","summary":"<p>Sets the quote char to use, either <code>'</code> or <code>\"</code>.</p>","abstract":false,"args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L261","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L261","def":{"name":"quote_char=","args":[{"name":"char","doc":null,"default_value":"","external_name":"char","restriction":"Char"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if (char == '\\'') || (char == '\"')\nelse\n  raise(ArgumentError.new(\"Quote char must be ' or \\\", not #{char}\"))\nend\ncall(SetQuoteChar, char.ord)\n"}},{"id":"start_attribute(name:String):Nil-instance-method","html_id":"start_attribute(name:String):Nil-instance-method","name":"start_attribute","doc":"Emits the start of an attribute.","summary":"<p>Emits the start of an attribute.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L113","def":{"name":"start_attribute","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartAttribute, string_to_unsafe(name))"}},{"id":"start_attribute(prefix:String?,name:String,namespace_uri:String?)-instance-method","html_id":"start_attribute(prefix:String?,name:String,namespace_uri:String?)-instance-method","name":"start_attribute","doc":"Emits the start of an attribute with namespace info.","summary":"<p>Emits the start of an attribute with namespace info.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L118","def":{"name":"start_attribute","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"call(StartAttributeNS, string_to_unsafe(prefix), string_to_unsafe(name), string_to_unsafe(namespace_uri))"}},{"id":"start_cdata:Nil-instance-method","html_id":"start_cdata:Nil-instance-method","name":"start_cdata","doc":"Emits the start of a `CDATA` section.","summary":"<p>Emits the start of a <code>CDATA</code> section.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L164","def":{"name":"start_cdata","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartCDATA)"}},{"id":"start_comment:Nil-instance-method","html_id":"start_comment:Nil-instance-method","name":"start_comment","doc":"Emits the start of a comment.","summary":"<p>Emits the start of a comment.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L186","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L186","def":{"name":"start_comment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartComment)"}},{"id":"start_document(version=nil,encoding=nil):Nil-instance-method","html_id":"start_document(version=nil,encoding=nil):Nil-instance-method","name":"start_document","doc":"Emits the start of the document.","summary":"<p>Emits the start of the document.</p>","abstract":false,"args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""}],"args_string":"(version = <span class=\"n\">nil</span>, encoding = <span class=\"n\">nil</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L29","def":{"name":"start_document","args":[{"name":"version","doc":null,"default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","doc":null,"default_value":"nil","external_name":"encoding","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartDocument, string_to_unsafe(version), string_to_unsafe(encoding), nil)"}},{"id":"start_dtd(name:String,pubid:String,sysid:String):Nil-instance-method","html_id":"start_dtd(name:String,pubid:String,sysid:String):Nil-instance-method","name":"start_dtd","doc":"Emits the start of a `DTD`.","summary":"<p>Emits the start of a <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"}],"args_string":"(name : String, pubid : String, sysid : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L208","def":{"name":"start_dtd","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"pubid","doc":null,"default_value":"","external_name":"pubid","restriction":"String"},{"name":"sysid","doc":null,"default_value":"","external_name":"sysid","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartDTD, string_to_unsafe(name), string_to_unsafe(pubid), string_to_unsafe(sysid))"}},{"id":"start_element(name:String):Nil-instance-method","html_id":"start_element(name:String):Nil-instance-method","name":"start_element","doc":"Emits the start of an element.","summary":"<p>Emits the start of an element.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L46","def":{"name":"start_element","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartElement, string_to_unsafe(name))"}},{"id":"start_element(prefix:String?,name:String,namespace_uri:String?):Nil-instance-method","html_id":"start_element(prefix:String?,name:String,namespace_uri:String?):Nil-instance-method","name":"start_element","doc":"Emits the start of an element with namespace info.","summary":"<p>Emits the start of an element with namespace info.</p>","abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L51","def":{"name":"start_element","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"namespace_uri","doc":null,"default_value":"","external_name":"namespace_uri","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(StartElementNS, string_to_unsafe(prefix), string_to_unsafe(name), string_to_unsafe(namespace_uri))"}},{"id":"text(content:String):Nil-instance-method","html_id":"text(content:String):Nil-instance-method","name":"text","doc":"Emits text content.\n\nText content can happen inside of an `element`, `attribute` value, `cdata`, `dtd`, etc.","summary":"<p>Emits text content.</p>","abstract":false,"args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":"String"}],"args_string":"(content : String) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/builder.cr#L159","def":{"name":"text","args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"call(WriteString, string_to_unsafe(content))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Error","path":"XML/Error.html","kind":"class","full_name":"XML::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/error.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[{"id":"errors-class-method","html_id":"errors-class-method","name":"errors","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L43","def":{"name":"errors","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @@errors.empty?\n  nil\nelse\n  errors = @@errors.dup\n  @@errors.clear\n  errors\nend"}}],"constructors":[{"id":"new(message,line_number)-class-method","html_id":"new(message,line_number)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""}],"args_string":"(message, line_number)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L10","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(error:Pointer(LibXML::Error))-class-method","html_id":"new(error:Pointer(LibXML::Error))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"error","doc":null,"default_value":"","external_name":"error","restriction":"::Pointer(LibXML::Error)"}],"args_string":"(error : Pointer(LibXML::Error))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L6","def":{"name":"new","args":[{"name":"error","doc":null,"default_value":"","external_name":"error","restriction":"::Pointer(LibXML::Error)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new((String.new(error.value.message)).chomp, error.value.line)"}}],"instance_methods":[{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/error.cr#L4","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/HTMLParserOptions","path":"XML/HTMLParserOptions.html","kind":"enum","full_name":"XML::HTMLParserOptions","name":"HTMLParserOptions","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/html_parser_options.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"RECOVER","name":"RECOVER","value":"1","doc":"Relaxed parsing","summary":"<p>Relaxed parsing</p>"},{"id":"NODEFDTD","name":"NODEFDTD","value":"4","doc":"Do not default a doctype if not found","summary":"<p>Do not default a doctype if not found</p>"},{"id":"NOERROR","name":"NOERROR","value":"32","doc":"Suppress error reports","summary":"<p>Suppress error reports</p>"},{"id":"NOWARNING","name":"NOWARNING","value":"64","doc":"Suppress warning reports","summary":"<p>Suppress warning reports</p>"},{"id":"PEDANTIC","name":"PEDANTIC","value":"128","doc":"Pedantic error reporting","summary":"<p>Pedantic error reporting</p>"},{"id":"NOBLANKS","name":"NOBLANKS","value":"256","doc":"Remove blank nodes","summary":"<p>Remove blank nodes</p>"},{"id":"NONET","name":"NONET","value":"2048","doc":"Forbid network access","summary":"<p>Forbid network access</p>"},{"id":"NOIMPLIED","name":"NOIMPLIED","value":"8192","doc":"Do not add implied html/body... elements","summary":"<p>Do not add implied html/body...</p>"},{"id":"COMPACT","name":"COMPACT","value":"65536","doc":"Compact small text nodes","summary":"<p>Compact small text nodes</p>"},{"id":"IGNORE_ENC","name":"IGNORE_ENC","value":"2097152","doc":"Ignore internal document encoding hint","summary":"<p>Ignore internal document encoding hint</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"default:self-class-method","html_id":"default:self-class-method","name":"default","doc":"Returns default options for parsing HTML documents.\n\nDefault flags are: `RECOVER` | `NOERROR` | `NOWARNING`","summary":"<p>Returns default options for parsing HTML documents.</p>","abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L36","def":{"name":"default","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"(RECOVER | NOERROR) | NOWARNING"}}],"instance_methods":[{"id":"compact?-instance-method","html_id":"compact?-instance-method","name":"compact?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L28","def":{"name":"compact?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(COMPACT)"}},{"id":"ignore_enc?-instance-method","html_id":"ignore_enc?-instance-method","name":"ignore_enc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L31","def":{"name":"ignore_enc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNORE_ENC)"}},{"id":"noblanks?-instance-method","html_id":"noblanks?-instance-method","name":"noblanks?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L19","def":{"name":"noblanks?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOBLANKS)"}},{"id":"nodefdtd?-instance-method","html_id":"nodefdtd?-instance-method","name":"nodefdtd?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L7","def":{"name":"nodefdtd?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NODEFDTD)"}},{"id":"noerror?-instance-method","html_id":"noerror?-instance-method","name":"noerror?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L10","def":{"name":"noerror?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOERROR)"}},{"id":"noimplied?-instance-method","html_id":"noimplied?-instance-method","name":"noimplied?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L25","def":{"name":"noimplied?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOIMPLIED)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L2","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"nonet?-instance-method","html_id":"nonet?-instance-method","name":"nonet?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L22","def":{"name":"nonet?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NONET)"}},{"id":"nowarning?-instance-method","html_id":"nowarning?-instance-method","name":"nowarning?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L13","def":{"name":"nowarning?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOWARNING)"}},{"id":"pedantic?-instance-method","html_id":"pedantic?-instance-method","name":"pedantic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L16","def":{"name":"pedantic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(PEDANTIC)"}},{"id":"recover?-instance-method","html_id":"recover?-instance-method","name":"recover?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/html_parser_options.cr#L4","def":{"name":"recover?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(RECOVER)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Namespace","path":"XML/Namespace.html","kind":"struct","full_name":"XML::Namespace","name":"Namespace","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/namespace.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(document:Node,ns:Pointer(LibXML::NS))-class-method","html_id":"new(document:Node,ns:Pointer(LibXML::NS))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"document","doc":null,"default_value":"","external_name":"document","restriction":"Node"},{"name":"ns","doc":null,"default_value":"","external_name":"ns","restriction":"::Pointer(LibXML::NS)"}],"args_string":"(document : Node, ns : Pointer(LibXML::NS))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L4","def":{"name":"new","args":[{"name":"document","doc":null,"default_value":"","external_name":"document","restriction":"Node"},{"name":"ns","doc":null,"default_value":"","external_name":"ns","restriction":"::Pointer(LibXML::NS)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(document, ns)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"document:Node-instance-method","html_id":"document:Node-instance-method","name":"document","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Node","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L2","def":{"name":"document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node","visibility":"Public","body":"@document"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L8","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"id":"href-instance-method","html_id":"href-instance-method","name":"href","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L10","def":{"name":"href","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ns.value.href ? String.new(@ns.value.href) : nil"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L40","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_s(io)"}},{"id":"object_id-instance-method","html_id":"object_id-instance-method","name":"object_id","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L14","def":{"name":"object_id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ns.address"}},{"id":"prefix-instance-method","html_id":"prefix-instance-method","name":"prefix","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L18","def":{"name":"prefix","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ns.value.prefix ? String.new(@ns.value.prefix) : nil"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/namespace.cr#L22","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<XML::Namespace:0x\"\nobject_id.to_s(16, io)\nif prefix = self.prefix\n  io << \" prefix=\"\n  prefix.inspect(io)\nend\nif href = self.href\n  io << \" href=\"\n  href.inspect(io)\nend\nio << '>'\nio\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Node","path":"XML/Node.html","kind":"struct","full_name":"XML::Node","name":"Node","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/node.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"LOOKS_LIKE_XPATH","name":"LOOKS_LIKE_XPATH","value":"/^(\\.\\/|\\/|\\.\\.|\\.$)/","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(node:Pointer(LibXML::Attr))-class-method","html_id":"new(node:Pointer(LibXML::Attr))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Attr)"}],"args_string":"(node : Pointer(LibXML::Attr))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L5","def":{"name":"new","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Attr)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(node:Pointer(LibXML::Doc))-class-method","html_id":"new(node:Pointer(LibXML::Doc))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Doc)"}],"args_string":"(node : Pointer(LibXML::Doc))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L15","def":{"name":"new","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Doc)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(node:Pointer(LibXML::Node))-class-method","html_id":"new(node:Pointer(LibXML::Node))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Node)"}],"args_string":"(node : Pointer(LibXML::Node))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L20","def":{"name":"new","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::Pointer(LibXML::Node)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other:Node)-instance-method","html_id":"==(other:Node)-instance-method","name":"==","doc":"Compares with *other*.","summary":"<p>Compares with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Node"}],"args_string":"(other : Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L49","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@node == (other.@node)"}},{"id":"[](attribute:String):String-instance-method","html_id":"[](attribute:String):String-instance-method","name":"[]","doc":"Gets the attribute content for the *attribute* given by name.\nRaises `KeyError` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L25","def":{"name":"[]","args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"attributes[attribute].content || (raise(KeyError.new(\"Missing attribute: #{attribute}\")))"}},{"id":"[]=(name:String,value)-instance-method","html_id":"[]=(name:String,value)-instance-method","name":"[]=","doc":"Sets *attribute* of this node to *value*.\nRaises `XML::Error` if this node does not support attributes.","summary":"<p>Sets <em>attribute</em> of this node to <em>value</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name : String, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L37","def":{"name":"[]=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if element?\nelse\n  raise(XML::Error.new(\"Can't set attribute of #{type}\", 0))\nend\nattributes[name] = value\n"}},{"id":"[]?(attribute:String):String?-instance-method","html_id":"[]?(attribute:String):String?-instance-method","name":"[]?","doc":"Gets the attribute content for the *attribute* given by name.\nReturns `nil` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L31","def":{"name":"[]?","args":[{"name":"attribute","doc":null,"default_value":"","external_name":"attribute","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"attributes[attribute]?.try(&.content)"}},{"id":"attribute?-instance-method","html_id":"attribute?-instance-method","name":"attribute?","doc":"Returns `true` if this is an attribute node.","summary":"<p>Returns <code>true</code> if this is an attribute node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L59","def":{"name":"attribute?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::ATTRIBUTE_NODE"}},{"id":"attributes-instance-method","html_id":"attributes-instance-method","name":"attributes","doc":"Returns attributes of this node as an `XML::Attributes`.","summary":"<p>Returns attributes of this node as an <code><a href=\"../XML/Attributes.html\">XML::Attributes</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L54","def":{"name":"attributes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Attributes.new(self)"}},{"id":"cdata?-instance-method","html_id":"cdata?-instance-method","name":"cdata?","doc":"Returns `true` if this is a `CDATA` section node.","summary":"<p>Returns <code>true</code> if this is a <code>CDATA</code> section node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L64","def":{"name":"cdata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::CDATA_SECTION_NODE"}},{"id":"children-instance-method","html_id":"children-instance-method","name":"children","doc":"Gets the list of children for this node as a `XML::NodeSet`.","summary":"<p>Gets the list of children for this node as a <code><a href=\"../XML/NodeSet.html\">XML::NodeSet</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L69","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L69","def":{"name":"children","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"child = @node.value.children\nset = LibXML.xmlXPathNodeSetCreate(child)\nif child\n  child = child.value.next\n  while child\n    LibXML.xmlXPathNodeSetAddUnique(set, child)\n    child = child.value.next\n  end\nend\nNodeSet.new(document, set)\n"}},{"id":"comment?-instance-method","html_id":"comment?-instance-method","name":"comment?","doc":"Returns `true` if this is a comment node.","summary":"<p>Returns <code>true</code> if this is a comment node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L86","def":{"name":"comment?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::COMMENT_NODE"}},{"id":"content:String-instance-method","html_id":"content:String-instance-method","name":"content","doc":"Returns the content for this Node. An empty string is\nreturned if the node has no content.","summary":"<p>Returns the content for this Node.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L92","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L92","def":{"name":"content","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"content = LibXML.xmlNodeGetContent(self)\ncontent ? String.new(content) : \"\"\n"}},{"id":"content=(content)-instance-method","html_id":"content=(content)-instance-method","name":"content=","doc":"Sets the Node's content to a Text node containing string.\nThe string gets XML escaped, not interpreted as markup.","summary":"<p>Sets the Node's content to a Text node containing string.</p>","abstract":false,"args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""}],"args_string":"(content)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L99","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L99","def":{"name":"content=","args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"content = escape(content.to_s)\nLibXML.xmlNodeSetContent(self, content)\n"}},{"id":"delete(name:String)-instance-method","html_id":"delete(name:String)-instance-method","name":"delete","doc":"Deletes attribute given by *name*.\nReturns attributes value, or `nil` if attribute not found.","summary":"<p>Deletes attribute given by <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"args_string":"(name : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L44","def":{"name":"delete","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"attributes.delete(name)"}},{"id":"document-instance-method","html_id":"document-instance-method","name":"document","doc":"Gets the document for this Node as a `XML::Node`.","summary":"<p>Gets the document for this Node as a <code><a href=\"../XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L105","def":{"name":"document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Node.new(@node.value.doc)"}},{"id":"document?-instance-method","html_id":"document?-instance-method","name":"document?","doc":"Returns `true` if this is a Document or HTML Document node.","summary":"<p>Returns <code>true</code> if this is a Document or HTML Document node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L110","def":{"name":"document?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type\nwhen XML::Type::DOCUMENT_NODE, XML::Type::HTML_DOCUMENT_NODE\n  true\nelse\n  false\nend"}},{"id":"element?-instance-method","html_id":"element?-instance-method","name":"element?","doc":"Returns `true` if this is an Element node.","summary":"<p>Returns <code>true</code> if this is an Element node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L141","def":{"name":"element?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::ELEMENT_NODE"}},{"id":"encoding-instance-method","html_id":"encoding-instance-method","name":"encoding","doc":"Returns the encoding of this node's document.","summary":"<p>Returns the encoding of this node's document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L121","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L121","def":{"name":"encoding","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if document?\n  encoding = (@node.as(::Pointer(LibXML::Doc))).value.encoding\n  encoding ? String.new(encoding) : nil\nelse\n  document.encoding\nend"}},{"id":"errors-instance-method","html_id":"errors-instance-method","name":"errors","doc":"Returns the list of `XML::Error` found when parsing this document.\nReturns `nil` if no errors were found.","summary":"<p>Returns the list of <code><a href=\"../XML/Error.html\">XML::Error</a></code> found when parsing this document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L555","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L555","def":{"name":"errors","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ptr = @node.value._private\nptr ? (ptr.as(Array(XML::Error))) : nil\n"}},{"id":"first_element_child-instance-method","html_id":"first_element_child-instance-method","name":"first_element_child","doc":"Returns the first child node of this node that is an element.\nReturns `nil` if not found.","summary":"<p>Returns the first child node of this node that is an element.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L147","def":{"name":"first_element_child","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"child = @node.value.children\nwhile child\n  if child.value.type == XML::Type::ELEMENT_NODE\n    return Node.new(child)\n  end\n  child = child.value.next\nend\nnil\n"}},{"id":"fragment?-instance-method","html_id":"fragment?-instance-method","name":"fragment?","doc":"Returns `true` if this is a DocumentFragment.","summary":"<p>Returns <code>true</code> if this is a DocumentFragment.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L159","def":{"name":"fragment?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::DOCUMENT_FRAG_NODE"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L164","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"id":"inner_text-instance-method","html_id":"inner_text-instance-method","name":"inner_text","doc":"Returns the content for this Node.","summary":"<p>Returns the content for this Node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L167","def":{"name":"inner_text","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"content"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":"Returns detailed information for this node including node type, name, attributes and children.","summary":"<p>Returns detailed information for this node including node type, name, attributes and children.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L172","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << \"#<XML::\"\ncase type\nwhen XML::Type::ELEMENT_NODE\n  io << \"Element\"\nwhen XML::Type::ATTRIBUTE_NODE\n  io << \"Attribute\"\nwhen XML::Type::TEXT_NODE\n  io << \"Text\"\nwhen XML::Type::CDATA_SECTION_NODE\n  io << \"CData\"\nwhen XML::Type::ENTITY_REF_NODE\n  io << \"EntityRef\"\nwhen XML::Type::ENTITY_NODE\n  io << \"Entity\"\nwhen XML::Type::PI_NODE\n  io << \"ProcessingInstruction\"\nwhen XML::Type::COMMENT_NODE\n  io << \"Comment\"\nwhen XML::Type::DOCUMENT_NODE\n  io << \"Document\"\nwhen XML::Type::DOCUMENT_TYPE_NODE\n  io << \"DocumentType\"\nwhen XML::Type::DOCUMENT_FRAG_NODE\n  io << \"DocumentFragment\"\nwhen XML::Type::NOTATION_NODE\n  io << \"Notation\"\nwhen XML::Type::HTML_DOCUMENT_NODE\n  io << \"HTMLDocument\"\nwhen XML::Type::DTD_NODE\n  io << \"DTD\"\nwhen XML::Type::ELEMENT_DECL\n  io << \"Element\"\nwhen XML::Type::ATTRIBUTE_DECL\n  io << \"AttributeDecl\"\nwhen XML::Type::ENTITY_DECL\n  io << \"EntityDecl\"\nwhen XML::Type::NAMESPACE_DECL\n  io << \"NamespaceDecl\"\nwhen XML::Type::XINCLUDE_START\n  io << \"XIncludeStart\"\nwhen XML::Type::XINCLUDE_END\n  io << \"XIncludeEnd\"\nwhen XML::Type::DOCB_DOCUMENT_NODE\n  io << \"DOCBDocument\"\nend\nio << \":0x\"\nobject_id.to_s(16, io)\nif text?\n  io << ' '\n  content.inspect(io)\nelse\n  if document?\n  else\n    io << \" name=\"\n    name.inspect(io)\n  end\n  if attribute?\n    io << \" value=\"\n    content.inspect(io)\n  else\n    attributes = self.attributes\n    if attributes.empty?\n    else\n      io << \" attributes=\"\n      attributes.inspect(io)\n    end\n    children = self.children\n    if children.empty?\n    else\n      io << \" children=\"\n      children.inspect(io)\n    end\n  end\nend\nio << '>'\nio\n"}},{"id":"name-instance-method","html_id":"name-instance-method","name":"name","doc":"Returns the name for this Node.","summary":"<p>Returns the name for this Node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L256","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L256","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if document?\n  \"document\"\nelse\n  if text?\n    \"text\"\n  else\n    if cdata?\n      \"#cdata-section\"\n    else\n      if fragment?\n        \"#document-fragment\"\n      else\n        if @node.value && @node.value.name\n          String.new(@node.value.name)\n        else\n          \"\"\n        end\n      end\n    end\n  end\nend"}},{"id":"name=(name)-instance-method","html_id":"name=(name)-instance-method","name":"name=","doc":"Sets the name for this Node.","summary":"<p>Sets the name for this Node.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L273","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L273","def":{"name":"name=","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if ((document? || text?) || cdata?) || fragment?\n  raise(XML::Error.new(\"Can't set name of XML #{type}\", 0))\nend\nname = name.to_s\nif name.includes?('\\u{0}')\n  raise(XML::Error.new(\"Invalid node name: #{name.inspect} (contains null character)\", 0))\nend\nif (LibXML.xmlValidateNameValue(name)) == 0\n  raise(XML::Error.new(\"Invalid node name: #{name.inspect}\", 0))\nend\nLibXML.xmlNodeSetName(self, name)\n"}},{"id":"namespace-instance-method","html_id":"namespace-instance-method","name":"namespace","doc":"Returns the namespace for this node or `nil` if not found.","summary":"<p>Returns the namespace for this node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L292","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L292","def":{"name":"namespace","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case type\nwhen Type::DOCUMENT_NODE, Type::ATTRIBUTE_DECL, Type::DTD_NODE, Type::ELEMENT_DECL\n  return nil\nend\nns = @node.value.ns\nns ? Namespace.new(document, ns) : nil\n"}},{"id":"namespace_scopes-instance-method","html_id":"namespace_scopes-instance-method","name":"namespace_scopes","doc":"Returns namespaces in scope for self – those defined on self element\ndirectly or any ancestor node – as an `Array` of `XML::Namespace` objects.\n\nDefault namespaces (`\"xmlns=\"` style) for self are included in this array;\nDefault namespaces for ancestors, however, are not.\n\nSee also `#namespaces`","summary":"<p>Returns namespaces in scope for self – those defined on self element directly or any ancestor node – as an <code><a href=\"../Array.html\">Array</a></code> of <code><a href=\"../XML/Namespace.html\">XML::Namespace</a></code> objects.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L309","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L309","def":{"name":"namespace_scopes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"scopes = [] of Namespace\nns_list = LibXML.xmlGetNsList(@node.value.doc, @node)\nif ns_list\n  while ns_list.value\n    scopes << (Namespace.new(document, ns_list.value))\n    ns_list = ns_list + 1\n  end\nend\nscopes\n"}},{"id":"namespaces-instance-method","html_id":"namespaces-instance-method","name":"namespaces","doc":"Returns a `Hash(String, String?) of prefix => href` for all namespaces\non this node and its ancestors.\n\nThis method returns the same namespaces as `#namespace_scopes`.\n\nReturns namespaces in scope for self – those defined on self element\ndirectly or any ancestor node – as a `Hash` of attribute-name/value pairs.\n\nNOTE: Note that the keys in this hash XML attributes that would be used to\ndefine this namespace, such as `\"xmlns:prefix\"`, not just the prefix.","summary":"<p>Returns a <code><a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>?) of prefix => href</code> for all namespaces on this node and its ancestors.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L334","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L334","def":{"name":"namespaces","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"namespaces = {} of String => String | ::Nil\nns_list = LibXML.xmlGetNsList(@node.value.doc, @node)\nif ns_list\n  while ns_list.value\n    namespace = Namespace.new(document, ns_list.value)\n    prefix = namespace.prefix\n    namespaces[prefix ? \"xmlns:#{prefix}\" : \"xmlns\"] = namespace.href\n    ns_list = ns_list + 1\n  end\nend\nnamespaces\n"}},{"id":"next-instance-method","html_id":"next-instance-method","name":"next","doc":"Returns the next sibling node or `nil` if not found.","summary":"<p>Returns the next sibling node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L233","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L233","def":{"name":"next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"next_node = @node.value.next\nnext_node ? Node.new(next_node) : nil\n"}},{"id":"next_element-instance-method","html_id":"next_element-instance-method","name":"next_element","doc":"Returns the next element node sibling or `nil` if not found.","summary":"<p>Returns the next element node sibling or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L244","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L244","def":{"name":"next_element","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"next_node = @node.value.next\nwhile next_node\n  if next_node.value.type == XML::Type::ELEMENT_NODE\n    return Node.new(next_node)\n  end\n  next_node = next_node.value.next\nend\nnil\n"}},{"id":"next_sibling-instance-method","html_id":"next_sibling-instance-method","name":"next_sibling","doc":"Returns the next sibling node or `nil` if not found.","summary":"<p>Returns the next sibling node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L239","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L239","def":{"name":"next_sibling","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.next"}},{"id":"object_id-instance-method","html_id":"object_id-instance-method","name":"object_id","doc":"Returns the address of underlying `LibXML::Node*` in memory.","summary":"<p>Returns the address of underlying <code>LibXML::Node*</code> in memory.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L352","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L352","def":{"name":"object_id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@node.address"}},{"id":"parent-instance-method","html_id":"parent-instance-method","name":"parent","doc":"Returns the parent node or `nil` if not found.","summary":"<p>Returns the parent node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L357","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L357","def":{"name":"parent","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"parent = @node.value.parent\nparent ? Node.new(parent) : nil\n"}},{"id":"previous-instance-method","html_id":"previous-instance-method","name":"previous","doc":"Returns the previous sibling node or `nil` if not found.","summary":"<p>Returns the previous sibling node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L363","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L363","def":{"name":"previous","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"prev_node = @node.value.prev\nprev_node ? Node.new(prev_node) : nil\n"}},{"id":"previous_element-instance-method","html_id":"previous_element-instance-method","name":"previous_element","doc":"Returns the previous sibling node that is an element or `nil` if not found.","summary":"<p>Returns the previous sibling node that is an element or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L369","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L369","def":{"name":"previous_element","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"prev_node = @node.value.prev\nwhile prev_node\n  if prev_node.value.type == XML::Type::ELEMENT_NODE\n    return Node.new(prev_node)\n  end\n  prev_node = prev_node.value.prev\nend\nnil\n"}},{"id":"previous_sibling-instance-method","html_id":"previous_sibling-instance-method","name":"previous_sibling","doc":"Returns the previous sibling node or `nil` if not found.\nSame with `#previous`.","summary":"<p>Returns the previous sibling node or <code>nil</code> if not found.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L382","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L382","def":{"name":"previous_sibling","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"previous"}},{"id":"processing_instruction?-instance-method","html_id":"processing_instruction?-instance-method","name":"processing_instruction?","doc":"Returns `true` if this is a Processing Instruction node.","summary":"<p>Returns <code>true</code> if this is a Processing Instruction node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L387","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L387","def":{"name":"processing_instruction?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::PI_NODE"}},{"id":"root-instance-method","html_id":"root-instance-method","name":"root","doc":"Returns the root node for this document or `nil`.","summary":"<p>Returns the root node for this document or <code>nil</code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L392","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L392","def":{"name":"root","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"root = LibXML.xmlDocGetRootElement(@node.value.doc)\nroot ? Node.new(root) : nil\n"}},{"id":"text-instance-method","html_id":"text-instance-method","name":"text","doc":"Same as `#content`.","summary":"<p>Same as <code><a href=\"../XML/Node.html#content%3AString-instance-method\">#content</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L398","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L398","def":{"name":"text","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"content"}},{"id":"text=(text)-instance-method","html_id":"text=(text)-instance-method","name":"text=","doc":"Same as `#content=`.","summary":"<p>Same as <code><a href=\"../XML/Node.html#content%3D%28content%29-instance-method\">#content=</a></code>.</p>","abstract":false,"args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"args_string":"(text)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L403","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L403","def":{"name":"text=","args":[{"name":"text","doc":null,"default_value":"","external_name":"text","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.content = text"}},{"id":"text?-instance-method","html_id":"text?-instance-method","name":"text?","doc":"Returns `true` if this is a Text node.","summary":"<p>Returns <code>true</code> if this is a Text node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L408","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L408","def":{"name":"text?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::TEXT_NODE"}},{"id":"to_s(io:IO)-instance-method","html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Serialize this Node as XML to *io* using default options.\n\nSee `#to_xml`.","summary":"<p>Serialize this Node as XML to <em>io</em> using default options.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L415","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L415","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"to_xml(io)"}},{"id":"to_unsafe:Pointer(LibXML::Node)-instance-method","html_id":"to_unsafe:Pointer(LibXML::Node)-instance-method","name":"to_unsafe","doc":"Returns underlying `LibXML::Node*` instance.","summary":"<p>Returns underlying <code>LibXML::Node*</code> instance.</p>","abstract":false,"args":[],"args_string":" : Pointer(LibXML::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L466","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L466","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@node"}},{"id":"to_xml(indent:Int=2,indent_text=&quot;&quot;,options:SaveOptions=SaveOptions.xml_default)-instance-method","html_id":"to_xml(indent:Int=2,indent_text=&amp;quot;&amp;quot;,options:SaveOptions=SaveOptions.xml_default)-instance-method","name":"to_xml","doc":"Serialize this Node as XML and return a `String` using default options.\n\nSee `XML::SaveOptions.xml_default` for default options.","summary":"<p>Serialize this Node as XML and return a <code><a href=\"../String.html\">String</a></code> using default options.</p>","abstract":false,"args":[{"name":"indent","doc":null,"default_value":"2","external_name":"indent","restriction":"Int"},{"name":"indent_text","doc":null,"default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","doc":null,"default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"args_string":"(indent : Int = <span class=\"n\">2</span>, indent_text = <span class=\"s\">&quot; &quot;</span>, options : SaveOptions = <span class=\"t\">SaveOptions</span>.xml_default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L422","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L422","def":{"name":"to_xml","args":[{"name":"indent","doc":null,"default_value":"2","external_name":"indent","restriction":"Int"},{"name":"indent_text","doc":null,"default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","doc":null,"default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  to_xml(str, indent, indent_text, options)\nend"}},{"id":"to_xml(io:IO,indent=2,indent_text=&quot;&quot;,options:SaveOptions=SaveOptions.xml_default)-instance-method","html_id":"to_xml(io:IO,indent=2,indent_text=&amp;quot;&amp;quot;,options:SaveOptions=SaveOptions.xml_default)-instance-method","name":"to_xml","doc":"Serialize this Node as XML to *io* using default options.\n\nSee `XML::SaveOptions.xml_default` for default options.","summary":"<p>Serialize this Node as XML to <em>io</em> using default options.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"2","external_name":"indent","restriction":""},{"name":"indent_text","doc":null,"default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","doc":null,"default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"args_string":"(io : IO, indent = <span class=\"n\">2</span>, indent_text = <span class=\"s\">&quot; &quot;</span>, options : SaveOptions = <span class=\"t\">SaveOptions</span>.xml_default)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L434","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L434","def":{"name":"to_xml","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"indent","doc":null,"default_value":"2","external_name":"indent","restriction":""},{"name":"indent_text","doc":null,"default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","doc":null,"default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"SAVE_MUTEX.synchronize do\n  oldXmlIndentTreeOutput = LibXML.xmlIndentTreeOutput\n  LibXML.xmlIndentTreeOutput = 1\n  oldXmlTreeIndentString = LibXML.xmlTreeIndentString\n  LibXML.xmlTreeIndentString = (indent_text * indent).to_unsafe\n  save_ctx = LibXML.xmlSaveToIO(->(ctx, buffer, len) do\n    (Box(IO).unbox(ctx)).write(Slice.new(buffer, len))\n    len\n  end, ->(ctx) do\n    (Box(IO).unbox(ctx)).flush\n    0\n  end, Box(IO).box(io), @node.value.doc.value.encoding, options)\n  LibXML.xmlSaveTree(save_ctx, self)\n  LibXML.xmlSaveClose(save_ctx)\n  LibXML.xmlIndentTreeOutput = oldXmlIndentTreeOutput\n  LibXML.xmlTreeIndentString = oldXmlTreeIndentString\nend\nio\n"}},{"id":"type-instance-method","html_id":"type-instance-method","name":"type","doc":"Returns the type for this Node as `XML::Type`.","summary":"<p>Returns the type for this Node as <code><a href=\"../XML/Type.html\">XML::Type</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L471","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L471","def":{"name":"type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@node.value.type"}},{"id":"unlink-instance-method","html_id":"unlink-instance-method","name":"unlink","doc":"Removes the node from the XML document.","summary":"<p>Removes the node from the XML document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L476","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L476","def":{"name":"unlink","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibXML.xmlUnlinkNode(self)"}},{"id":"version-instance-method","html_id":"version-instance-method","name":"version","doc":"Returns the version of this node's document.","summary":"<p>Returns the version of this node's document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L131","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if document?\n  version = (@node.as(::Pointer(LibXML::Doc))).value.version\n  version ? String.new(version) : nil\nelse\n  document.version\nend"}},{"id":"xml?-instance-method","html_id":"xml?-instance-method","name":"xml?","doc":"Returns `true` if this is an xml Document node.","summary":"<p>Returns <code>true</code> if this is an xml Document node.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L481","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L481","def":{"name":"xml?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"type == XML::Type::DOCUMENT_NODE"}},{"id":"xpath(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath(path,namespaces=nil,variables=nil)-instance-method","name":"xpath","doc":"Searches this node for XPath *path*. Returns result with appropriate type\n(`Bool | Float64 | String | XML::NodeSet`).\n\nRaises `XML::Error` on evaluation error.","summary":"<p>Searches this node for XPath <em>path</em>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L489","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L489","def":{"name":"xpath","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"ctx = XPathContext.new(self)\nif namespaces\n  ctx.register_namespaces(namespaces)\nend\nif variables\n  ctx.register_variables(variables)\nend\nctx.evaluate(path)\n"}},{"id":"xpath_bool(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath_bool(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_bool","doc":"Searches this node for XPath *path* and restricts the return type to `Bool`.\n\n```\nrequire \"xml\"\ndoc = XML.parse(\"<person></person>\")\n\ndoc.xpath_bool(\"count(//person) > 0\") # => true\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../Bool.html\">Bool</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L504","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L504","def":{"name":"xpath_bool","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(xpath(path, namespaces, variables)).as(Bool)"}},{"id":"xpath_float(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath_float(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_float","doc":"Searches this node for XPath *path* and restricts the return type to `Float64`.\n\n```\ndoc.xpath_float(\"count(//person)\") # => 1.0\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L513","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L513","def":{"name":"xpath_float","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(xpath(path, namespaces, variables)).as(Float64)"}},{"id":"xpath_node(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath_node(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_node","doc":"Searches this node for XPath *path* for nodes and returns the first one.\nor `nil` if not found\n\n```\ndoc.xpath_node(\"//person\")  # => #<XML::Node:0x2013e80 name=\"person\">\ndoc.xpath_node(\"//invalid\") # => nil\n```","summary":"<p>Searches this node for XPath <em>path</em> for nodes and returns the first one.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L535","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L535","def":{"name":"xpath_node","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(xpath_nodes(path, namespaces, variables)).first?"}},{"id":"xpath_nodes(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath_nodes(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_nodes","doc":"Searches this node for XPath *path* and restricts the return type to `NodeSet`.\n\n```\nnodes = doc.xpath_nodes(\"//person\")\nnodes.class       # => XML::NodeSet\nnodes.map(&.name) # => [\"person\"]\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../XML/NodeSet.html\">NodeSet</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L524","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L524","def":{"name":"xpath_nodes","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(xpath(path, namespaces, variables)).as(NodeSet)"}},{"id":"xpath_string(path,namespaces=nil,variables=nil)-instance-method","html_id":"xpath_string(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_string","doc":"Searches this node for XPath *path* and restricts the return type to `String`.\n\n```\ndoc.xpath_string(\"string(/persons/person[1])\")\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L544","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node.cr#L544","def":{"name":"xpath_string","args":[{"name":"path","doc":null,"default_value":"","external_name":"path","restriction":""},{"name":"namespaces","doc":null,"default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","doc":null,"default_value":"nil","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(xpath(path, namespaces, variables)).as(String)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/NodeSet","path":"XML/NodeSet.html","kind":"struct","full_name":"XML::NodeSet","name":"NodeSet","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/node_set.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(doc:Node,set:Pointer(LibXML::NodeSet))-class-method","html_id":"new(doc:Node,set:Pointer(LibXML::NodeSet))-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"doc","doc":null,"default_value":"","external_name":"doc","restriction":"Node"},{"name":"set","doc":null,"default_value":"","external_name":"set","restriction":"::Pointer(LibXML::NodeSet)"}],"args_string":"(doc : Node, set : Pointer(LibXML::NodeSet))","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L4","def":{"name":"new","args":[{"name":"doc","doc":null,"default_value":"","external_name":"doc","restriction":"Node"},{"name":"set","doc":null,"default_value":"","external_name":"set","restriction":"::Pointer(LibXML::NodeSet)"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(doc, set)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(doc:Node)-class-method","html_id":"new(doc:Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"doc","doc":null,"default_value":"","external_name":"doc","restriction":"Node"}],"args_string":"(doc : Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L7","def":{"name":"new","args":[{"name":"doc","doc":null,"default_value":"","external_name":"doc","restriction":"Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(doc, LibXML.xmlXPathNodeSetCreate(nil))"}}],"instance_methods":[{"id":"[](index:Int)-instance-method","html_id":"[](index:Int)-instance-method","name":"[]","doc":null,"summary":null,"abstract":false,"args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L11","def":{"name":"[]","args":[{"name":"index","doc":null,"default_value":"","external_name":"index","restriction":"Int"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if index < 0\n  index = index + size\nend\nif 0 <= index && index < size\nelse\n  raise(IndexError.new)\nend\ninternal_at(index)\n"}},{"id":"each(&block):Nil-instance-method","html_id":"each(&amp;block):Nil-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L21","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"size.times do |i|\n  yield internal_at(i)\nend"}},{"id":"empty?-instance-method","html_id":"empty?-instance-method","name":"empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L27","def":{"name":"empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"size == 0"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L32","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"id":"inspect(io)-instance-method","html_id":"inspect(io)-instance-method","name":"inspect","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L34","def":{"name":"inspect","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"io << '['\njoin(\", \", io, &.inspect(io))\nio << ']'\n"}},{"id":"object_id-instance-method","html_id":"object_id-instance-method","name":"object_id","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L44","def":{"name":"object_id","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@set.address"}},{"id":"size-instance-method","html_id":"size-instance-method","name":"size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L40","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@set.value.node_nr"}},{"id":"to_s(io)-instance-method","html_id":"to_s(io)-instance-method","name":"to_s","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"args_string":"(io)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L48","def":{"name":"to_s","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"join('\\n', io)"}},{"id":"to_unsafe:Pointer(LibXML::NodeSet)-instance-method","html_id":"to_unsafe:Pointer(LibXML::NodeSet)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Pointer(LibXML::NodeSet)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/node_set.cr#L52","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@set"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/ParserOptions","path":"XML/ParserOptions.html","kind":"enum","full_name":"XML::ParserOptions","name":"ParserOptions","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/parser_options.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"RECOVER","name":"RECOVER","value":"1","doc":"Recover on errors","summary":"<p>Recover on errors</p>"},{"id":"NOENT","name":"NOENT","value":"2","doc":"Substitute entities","summary":"<p>Substitute entities</p>"},{"id":"DTDLOAD","name":"DTDLOAD","value":"4","doc":"Load the external subset","summary":"<p>Load the external subset</p>"},{"id":"DTDATTR","name":"DTDATTR","value":"8","doc":"Default DTD attributes","summary":"<p>Default DTD attributes</p>"},{"id":"DTDVALID","name":"DTDVALID","value":"16","doc":"Validate with the DTD","summary":"<p>Validate with the DTD</p>"},{"id":"NOERROR","name":"NOERROR","value":"32","doc":"Suppress error reports","summary":"<p>Suppress error reports</p>"},{"id":"NOWARNING","name":"NOWARNING","value":"64","doc":"Suppress warning reports","summary":"<p>Suppress warning reports</p>"},{"id":"PEDANTIC","name":"PEDANTIC","value":"128","doc":"Pedantic error reporting","summary":"<p>Pedantic error reporting</p>"},{"id":"NOBLANKS","name":"NOBLANKS","value":"256","doc":"Remove blank nodes","summary":"<p>Remove blank nodes</p>"},{"id":"SAX1","name":"SAX1","value":"512","doc":"Use the SAX1 interface internally","summary":"<p>Use the SAX1 interface internally</p>"},{"id":"XINCLUDE","name":"XINCLUDE","value":"1024","doc":"Implement XInclude substitution","summary":"<p>Implement XInclude substitution</p>"},{"id":"NONET","name":"NONET","value":"2048","doc":"Forbid network access","summary":"<p>Forbid network access</p>"},{"id":"NODICT","name":"NODICT","value":"4096","doc":"Do not reuse the context dictionary","summary":"<p>Do not reuse the context dictionary</p>"},{"id":"NSCLEAN","name":"NSCLEAN","value":"8192","doc":"Remove redundant namespaces declarations","summary":"<p>Remove redundant namespaces declarations</p>"},{"id":"NOCDATA","name":"NOCDATA","value":"16384","doc":"Merge CDATA as text nodes","summary":"<p>Merge CDATA as text nodes</p>"},{"id":"NOXINCNODE","name":"NOXINCNODE","value":"32768","doc":"Do not generate XINCLUDE START/END nodes","summary":"<p>Do not generate XINCLUDE START/END nodes</p>"},{"id":"COMPACT","name":"COMPACT","value":"65536","doc":"Compact small text nodes; no modification of the tree allowed afterwards (will possibly crash if you try to modify the tree)","summary":"<p>Compact small text nodes; no modification of the tree allowed afterwards (will possibly crash if you try to modify the tree)</p>"},{"id":"OLD10","name":"OLD10","value":"131072","doc":"Parse using XML-1.0 before update 5","summary":"<p>Parse using XML-1.0 before update 5</p>"},{"id":"NOBASEFIX","name":"NOBASEFIX","value":"262144","doc":"Do not fixup XINCLUDE xml:base uris","summary":"<p>Do not fixup XINCLUDE xml:base uris</p>"},{"id":"HUGE","name":"HUGE","value":"524288","doc":"Relax any hardcoded limit from the parser","summary":"<p>Relax any hardcoded limit from the parser</p>"},{"id":"OLDSAX","name":"OLDSAX","value":"1048576","doc":"Parse using SAX2 interface before 2.7.0","summary":"<p>Parse using SAX2 interface before 2.7.0</p>"},{"id":"IGNORE_ENC","name":"IGNORE_ENC","value":"2097152","doc":"Ignore internal document encoding hint","summary":"<p>Ignore internal document encoding hint</p>"},{"id":"BIG_LINES","name":"BIG_LINES","value":"4194304","doc":"Store big lines numbers in text PSVI field","summary":"<p>Store big lines numbers in text PSVI field</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"default:self-class-method","html_id":"default:self-class-method","name":"default","doc":"Returns default options for parsing XML documents.\n\nDefault flags are: `RECOVER` | `NOERROR` | `NOWARNING` | `NONET`","summary":"<p>Returns default options for parsing XML documents.</p>","abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L75","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L75","def":{"name":"default","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"((RECOVER | NOERROR) | NOWARNING) | NONET"}}],"instance_methods":[{"id":"big_lines?-instance-method","html_id":"big_lines?-instance-method","name":"big_lines?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L70","def":{"name":"big_lines?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(BIG_LINES)"}},{"id":"compact?-instance-method","html_id":"compact?-instance-method","name":"compact?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L52","def":{"name":"compact?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(COMPACT)"}},{"id":"dtdattr?-instance-method","html_id":"dtdattr?-instance-method","name":"dtdattr?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L13","def":{"name":"dtdattr?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(DTDATTR)"}},{"id":"dtdload?-instance-method","html_id":"dtdload?-instance-method","name":"dtdload?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L10","def":{"name":"dtdload?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(DTDLOAD)"}},{"id":"dtdvalid?-instance-method","html_id":"dtdvalid?-instance-method","name":"dtdvalid?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L16","def":{"name":"dtdvalid?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(DTDVALID)"}},{"id":"huge?-instance-method","html_id":"huge?-instance-method","name":"huge?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L61","def":{"name":"huge?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(HUGE)"}},{"id":"ignore_enc?-instance-method","html_id":"ignore_enc?-instance-method","name":"ignore_enc?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L67","def":{"name":"ignore_enc?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(IGNORE_ENC)"}},{"id":"nobasefix?-instance-method","html_id":"nobasefix?-instance-method","name":"nobasefix?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L58","def":{"name":"nobasefix?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOBASEFIX)"}},{"id":"noblanks?-instance-method","html_id":"noblanks?-instance-method","name":"noblanks?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L28","def":{"name":"noblanks?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOBLANKS)"}},{"id":"nocdata?-instance-method","html_id":"nocdata?-instance-method","name":"nocdata?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L46","def":{"name":"nocdata?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOCDATA)"}},{"id":"nodict?-instance-method","html_id":"nodict?-instance-method","name":"nodict?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L40","def":{"name":"nodict?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NODICT)"}},{"id":"noent?-instance-method","html_id":"noent?-instance-method","name":"noent?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L7","def":{"name":"noent?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOENT)"}},{"id":"noerror?-instance-method","html_id":"noerror?-instance-method","name":"noerror?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L19","def":{"name":"noerror?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOERROR)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L2","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"nonet?-instance-method","html_id":"nonet?-instance-method","name":"nonet?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L37","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L37","def":{"name":"nonet?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NONET)"}},{"id":"nowarning?-instance-method","html_id":"nowarning?-instance-method","name":"nowarning?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L22","def":{"name":"nowarning?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOWARNING)"}},{"id":"noxincnode?-instance-method","html_id":"noxincnode?-instance-method","name":"noxincnode?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L49","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L49","def":{"name":"noxincnode?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NOXINCNODE)"}},{"id":"nsclean?-instance-method","html_id":"nsclean?-instance-method","name":"nsclean?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L43","def":{"name":"nsclean?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NSCLEAN)"}},{"id":"old10?-instance-method","html_id":"old10?-instance-method","name":"old10?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L55","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L55","def":{"name":"old10?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OLD10)"}},{"id":"oldsax?-instance-method","html_id":"oldsax?-instance-method","name":"oldsax?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L64","def":{"name":"oldsax?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(OLDSAX)"}},{"id":"pedantic?-instance-method","html_id":"pedantic?-instance-method","name":"pedantic?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L25","def":{"name":"pedantic?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(PEDANTIC)"}},{"id":"recover?-instance-method","html_id":"recover?-instance-method","name":"recover?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L4","def":{"name":"recover?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(RECOVER)"}},{"id":"sax1?-instance-method","html_id":"sax1?-instance-method","name":"sax1?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L31","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L31","def":{"name":"sax1?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(SAX1)"}},{"id":"xinclude?-instance-method","html_id":"xinclude?-instance-method","name":"xinclude?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/parser_options.cr#L34","def":{"name":"xinclude?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(XINCLUDE)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Reader","path":"XML/Reader.html","kind":"struct","full_name":"XML::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/reader.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(str:String)-class-method","html_id":"new(str:String)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"args_string":"(str : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L4","def":{"name":"new","args":[{"name":"str","doc":null,"default_value":"","external_name":"str","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L14","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"attributes_count-instance-method","html_id":"attributes_count-instance-method","name":"attributes_count","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L44","def":{"name":"attributes_count","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibXML.xmlTextReaderAttributeCount(@reader)"}},{"id":"empty_element?-instance-method","html_id":"empty_element?-instance-method","name":"empty_element?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L36","def":{"name":"empty_element?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibXML.xmlTextReaderIsEmptyElement(@reader)) == 1"}},{"id":"has_attributes?-instance-method","html_id":"has_attributes?-instance-method","name":"has_attributes?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L40","def":{"name":"has_attributes?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibXML.xmlTextReaderHasAttributes(@reader)) == 1"}},{"id":"move_to_first_attribute-instance-method","html_id":"move_to_first_attribute-instance-method","name":"move_to_first_attribute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L48","def":{"name":"move_to_first_attribute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToFirstAttribute(@reader)) == 1"}},{"id":"move_to_next_attribute-instance-method","html_id":"move_to_next_attribute-instance-method","name":"move_to_next_attribute","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L52","def":{"name":"move_to_next_attribute","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToNextAttribute(@reader)) == 1"}},{"id":"name-instance-method","html_id":"name-instance-method","name":"name","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L32","def":{"name":"name","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibXML.xmlTextReaderConstName(@reader))"}},{"id":"node_type-instance-method","html_id":"node_type-instance-method","name":"node_type","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L28","def":{"name":"node_type","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibXML.xmlTextReaderNodeType(@reader)"}},{"id":"read-instance-method","html_id":"read-instance-method","name":"read","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L24","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L24","def":{"name":"read","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(LibXML.xmlTextReaderRead(@reader)) == 1"}},{"id":"to_unsafe:LibXML::XMLTextReader-instance-method","html_id":"to_unsafe:LibXML::XMLTextReader-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : LibXML::XMLTextReader","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L60","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L60","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@reader"}},{"id":"value-instance-method","html_id":"value-instance-method","name":"value","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/reader.cr#L56","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"String.new(LibXML.xmlTextReaderConstValue(@reader))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/SaveOptions","path":"XML/SaveOptions.html","kind":"enum","full_name":"XML::SaveOptions","name":"SaveOptions","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/save_options.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"FORMAT","name":"FORMAT","value":"1","doc":"Format save output","summary":"<p>Format save output</p>"},{"id":"NO_DECL","name":"NO_DECL","value":"2","doc":"Drop the xml declaration","summary":"<p>Drop the xml declaration</p>"},{"id":"NO_EMPTY","name":"NO_EMPTY","value":"4","doc":"No empty tags","summary":"<p>No empty tags</p>"},{"id":"NO_XHTML","name":"NO_XHTML","value":"8","doc":"Disable XHTML1 specific rules","summary":"<p>Disable XHTML1 specific rules</p>"},{"id":"XHTML","name":"XHTML","value":"16","doc":"Force XHTML1 specific rules","summary":"<p>Force XHTML1 specific rules</p>"},{"id":"AS_XML","name":"AS_XML","value":"32","doc":"Force XML serialization on HTML doc","summary":"<p>Force XML serialization on HTML doc</p>"},{"id":"AS_HTML","name":"AS_HTML","value":"64","doc":"Force HTML serialization on XML doc","summary":"<p>Force HTML serialization on XML doc</p>"},{"id":"WSNONSIG","name":"WSNONSIG","value":"128","doc":"Format with non-significant whitespace","summary":"<p>Format with non-significant whitespace</p>"}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"xml_default:self-class-method","html_id":"xml_default:self-class-method","name":"xml_default","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : self","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L27","def":{"name":"xml_default","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"self","visibility":"Public","body":"FORMAT | AS_XML"}}],"instance_methods":[{"id":"as_html?-instance-method","html_id":"as_html?-instance-method","name":"as_html?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L22","def":{"name":"as_html?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(AS_HTML)"}},{"id":"as_xml?-instance-method","html_id":"as_xml?-instance-method","name":"as_xml?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L19","def":{"name":"as_xml?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(AS_XML)"}},{"id":"format?-instance-method","html_id":"format?-instance-method","name":"format?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L4","def":{"name":"format?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(FORMAT)"}},{"id":"no_decl?-instance-method","html_id":"no_decl?-instance-method","name":"no_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L7","def":{"name":"no_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NO_DECL)"}},{"id":"no_empty?-instance-method","html_id":"no_empty?-instance-method","name":"no_empty?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L10","def":{"name":"no_empty?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NO_EMPTY)"}},{"id":"no_xhtml?-instance-method","html_id":"no_xhtml?-instance-method","name":"no_xhtml?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L13","def":{"name":"no_xhtml?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(NO_XHTML)"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L2","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"value == 0"}},{"id":"wsnonsig?-instance-method","html_id":"wsnonsig?-instance-method","name":"wsnonsig?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L25","def":{"name":"wsnonsig?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(WSNONSIG)"}},{"id":"xhtml?-instance-method","html_id":"xhtml?-instance-method","name":"xhtml?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/save_options.cr#L16","def":{"name":"xhtml?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self.includes?(XHTML)"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/Type","path":"XML/Type.html","kind":"enum","full_name":"XML::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/type.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ELEMENT_NODE","name":"ELEMENT_NODE","value":"1","doc":null,"summary":null},{"id":"ATTRIBUTE_NODE","name":"ATTRIBUTE_NODE","value":"2","doc":null,"summary":null},{"id":"TEXT_NODE","name":"TEXT_NODE","value":"3","doc":null,"summary":null},{"id":"CDATA_SECTION_NODE","name":"CDATA_SECTION_NODE","value":"4","doc":null,"summary":null},{"id":"ENTITY_REF_NODE","name":"ENTITY_REF_NODE","value":"5","doc":null,"summary":null},{"id":"ENTITY_NODE","name":"ENTITY_NODE","value":"6","doc":null,"summary":null},{"id":"PI_NODE","name":"PI_NODE","value":"7","doc":null,"summary":null},{"id":"COMMENT_NODE","name":"COMMENT_NODE","value":"8","doc":null,"summary":null},{"id":"DOCUMENT_NODE","name":"DOCUMENT_NODE","value":"9","doc":null,"summary":null},{"id":"DOCUMENT_TYPE_NODE","name":"DOCUMENT_TYPE_NODE","value":"10","doc":null,"summary":null},{"id":"DOCUMENT_FRAG_NODE","name":"DOCUMENT_FRAG_NODE","value":"11","doc":null,"summary":null},{"id":"NOTATION_NODE","name":"NOTATION_NODE","value":"12","doc":null,"summary":null},{"id":"HTML_DOCUMENT_NODE","name":"HTML_DOCUMENT_NODE","value":"13","doc":null,"summary":null},{"id":"DTD_NODE","name":"DTD_NODE","value":"14","doc":null,"summary":null},{"id":"ELEMENT_DECL","name":"ELEMENT_DECL","value":"15","doc":null,"summary":null},{"id":"ATTRIBUTE_DECL","name":"ATTRIBUTE_DECL","value":"16","doc":null,"summary":null},{"id":"ENTITY_DECL","name":"ENTITY_DECL","value":"17","doc":null,"summary":null},{"id":"NAMESPACE_DECL","name":"NAMESPACE_DECL","value":"18","doc":null,"summary":null},{"id":"XINCLUDE_START","name":"XINCLUDE_START","value":"19","doc":null,"summary":null},{"id":"XINCLUDE_END","name":"XINCLUDE_END","value":"20","doc":null,"summary":null},{"id":"DOCB_DOCUMENT_NODE","name":"DOCB_DOCUMENT_NODE","value":"21","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"attribute_decl?-instance-method","html_id":"attribute_decl?-instance-method","name":"attribute_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L17","def":{"name":"attribute_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ATTRIBUTE_DECL"}},{"id":"attribute_node?-instance-method","html_id":"attribute_node?-instance-method","name":"attribute_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L3","def":{"name":"attribute_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ATTRIBUTE_NODE"}},{"id":"cdata_section_node?-instance-method","html_id":"cdata_section_node?-instance-method","name":"cdata_section_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L5","def":{"name":"cdata_section_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == CDATA_SECTION_NODE"}},{"id":"comment_node?-instance-method","html_id":"comment_node?-instance-method","name":"comment_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L9","def":{"name":"comment_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == COMMENT_NODE"}},{"id":"docb_document_node?-instance-method","html_id":"docb_document_node?-instance-method","name":"docb_document_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L22","def":{"name":"docb_document_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCB_DOCUMENT_NODE"}},{"id":"document_frag_node?-instance-method","html_id":"document_frag_node?-instance-method","name":"document_frag_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L12","def":{"name":"document_frag_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCUMENT_FRAG_NODE"}},{"id":"document_node?-instance-method","html_id":"document_node?-instance-method","name":"document_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L10","def":{"name":"document_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCUMENT_NODE"}},{"id":"document_type_node?-instance-method","html_id":"document_type_node?-instance-method","name":"document_type_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L11","def":{"name":"document_type_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCUMENT_TYPE_NODE"}},{"id":"dtd_node?-instance-method","html_id":"dtd_node?-instance-method","name":"dtd_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L15","def":{"name":"dtd_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DTD_NODE"}},{"id":"element_decl?-instance-method","html_id":"element_decl?-instance-method","name":"element_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L16","def":{"name":"element_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ELEMENT_DECL"}},{"id":"element_node?-instance-method","html_id":"element_node?-instance-method","name":"element_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L2","def":{"name":"element_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ELEMENT_NODE"}},{"id":"entity_decl?-instance-method","html_id":"entity_decl?-instance-method","name":"entity_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L18","def":{"name":"entity_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENTITY_DECL"}},{"id":"entity_node?-instance-method","html_id":"entity_node?-instance-method","name":"entity_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L7","def":{"name":"entity_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENTITY_NODE"}},{"id":"entity_ref_node?-instance-method","html_id":"entity_ref_node?-instance-method","name":"entity_ref_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L6","def":{"name":"entity_ref_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ENTITY_REF_NODE"}},{"id":"html_document_node?-instance-method","html_id":"html_document_node?-instance-method","name":"html_document_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L14","def":{"name":"html_document_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == HTML_DOCUMENT_NODE"}},{"id":"namespace_decl?-instance-method","html_id":"namespace_decl?-instance-method","name":"namespace_decl?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L19","def":{"name":"namespace_decl?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NAMESPACE_DECL"}},{"id":"notation_node?-instance-method","html_id":"notation_node?-instance-method","name":"notation_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L13","def":{"name":"notation_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NOTATION_NODE"}},{"id":"pi_node?-instance-method","html_id":"pi_node?-instance-method","name":"pi_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L8","def":{"name":"pi_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PI_NODE"}},{"id":"text_node?-instance-method","html_id":"text_node?-instance-method","name":"text_node?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L4","def":{"name":"text_node?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == TEXT_NODE"}},{"id":"xinclude_end?-instance-method","html_id":"xinclude_end?-instance-method","name":"xinclude_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L21","def":{"name":"xinclude_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == XINCLUDE_END"}},{"id":"xinclude_start?-instance-method","html_id":"xinclude_start?-instance-method","name":"xinclude_start?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/type.cr#L20","def":{"name":"xinclude_start?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == XINCLUDE_START"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/XML/XPathContext","path":"XML/XPathContext.html","kind":"struct","full_name":"XML::XPathContext","name":"XPathContext","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"xml/xpath_context.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":null,"summary":null,"class_methods":[],"constructors":[{"id":"new(node:Node)-class-method","html_id":"new(node:Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"Node"}],"args_string":"(node : Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L2","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L2","def":{"name":"new","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"evaluate(search_path:String)-instance-method","html_id":"evaluate(search_path:String)-instance-method","name":"evaluate","doc":null,"summary":null,"abstract":false,"args":[{"name":"search_path","doc":null,"default_value":"","external_name":"search_path","restriction":"String"}],"args_string":"(search_path : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L7","def":{"name":"evaluate","args":[{"name":"search_path","doc":null,"default_value":"","external_name":"search_path","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"xpath = LibXML.xmlXPathEvalExpression(search_path, self)\nif xpath\nelse\n  {% if (flag?(:arm)) || (flag?(:aarch64)) %}\n        if errors = XML::Error.errors\n          raise errors.last\n        end\n      {% end %}\n  raise(XML::Error.new(\"Error in '#{search_path}' expression\", 0))\nend\nif xpath.value\nelse\n  raise(XML::Error.new(\"Error in '#{search_path}' expression\", 0))\nend\ncase xpath.value.type\nwhen LibXML::XPathObjectType::STRING\n  String.new(xpath.value.stringval)\nwhen LibXML::XPathObjectType::NUMBER\n  xpath.value.floatval\nwhen LibXML::XPathObjectType::BOOLEAN\n  xpath.value.boolval != 0\nwhen LibXML::XPathObjectType::NODESET\n  if xpath.value.nodesetval\n    NodeSet.new(Node.new(@ctx.value.doc), xpath.value.nodesetval)\n  else\n    NodeSet.new(Node.new(@ctx.value.doc))\n  end\nelse\n  NodeSet.new(Node.new(@ctx.value.doc))\nend\n"}},{"id":"register_namespace(prefix,uri)-instance-method","html_id":"register_namespace(prefix,uri)-instance-method","name":"register_namespace","doc":null,"summary":null,"abstract":false,"args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""}],"args_string":"(prefix, uri)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L44","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L44","def":{"name":"register_namespace","args":[{"name":"prefix","doc":null,"default_value":"","external_name":"prefix","restriction":""},{"name":"uri","doc":null,"default_value":"","external_name":"uri","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibXML.xmlXPathRegisterNs(self, prefix.to_s, uri.to_s)"}},{"id":"register_namespaces(namespaces)-instance-method","html_id":"register_namespaces(namespaces)-instance-method","name":"register_namespaces","doc":null,"summary":null,"abstract":false,"args":[{"name":"namespaces","doc":null,"default_value":"","external_name":"namespaces","restriction":""}],"args_string":"(namespaces)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L38","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L38","def":{"name":"register_namespaces","args":[{"name":"namespaces","doc":null,"default_value":"","external_name":"namespaces","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"namespaces.each do |prefix, uri|\n  register_namespace(prefix, uri)\nend"}},{"id":"register_variable(name,value)-instance-method","html_id":"register_variable(name,value)-instance-method","name":"register_variable","doc":null,"summary":null,"abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(name, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L54","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L54","def":{"name":"register_variable","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case value\nwhen Bool\n  obj = LibXML.xmlXPathNewBoolean(value ? 1 : 0)\nwhen Number\n  obj = LibXML.xmlXPathNewFloat(value.to_f64)\nelse\n  obj = LibXML.xmlXPathNewCString(value.to_s)\nend\nLibXML.xmlXPathRegisterVariable(self, name, obj)\n"}},{"id":"register_variables(variables)-instance-method","html_id":"register_variables(variables)-instance-method","name":"register_variables","doc":null,"summary":null,"abstract":false,"args":[{"name":"variables","doc":null,"default_value":"","external_name":"variables","restriction":""}],"args_string":"(variables)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L48","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L48","def":{"name":"register_variables","args":[{"name":"variables","doc":null,"default_value":"","external_name":"variables","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"variables.each do |name, value|\n  register_variable(name, value)\nend"}},{"id":"to_unsafe:Pointer(LibXML::XPathContext)-instance-method","html_id":"to_unsafe:Pointer(LibXML::XPathContext)-instance-method","name":"to_unsafe","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Pointer(LibXML::XPathContext)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/xml/xpath_context.cr#L67","def":{"name":"to_unsafe","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@ctx"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/YAML","path":"YAML.html","kind":"module","full_name":"YAML","name":"YAML","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/any.cr","line_number":26,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"},{"filename":"yaml/builder.cr","line_number":165,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr"},{"filename":"yaml/enums.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr"},{"filename":"yaml/mapping.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/mapping.cr"},{"filename":"yaml/serialization.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"},{"filename":"yaml.cr","line_number":76,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The YAML module provides serialization and deserialization of YAML\nversion 1.1 to/from native Crystal data structures, with the additional\nindependent types specified in http://yaml.org/type/\n\n### Parsing with `#parse` and `#parse_all`\n\n`YAML.parse` will return an `Any`, which is a convenient wrapper around all possible\nYAML core types, making it easy to traverse a complex YAML structure but requires\nsome casts from time to time, mostly via some method invocations.\n\n```\nrequire \"yaml\"\n\ndata = YAML.parse <<-END\n         ---\n         foo:\n           bar:\n             baz:\n               - qux\n               - fox\n         END\ndata[\"foo\"][\"bar\"][\"baz\"][1].as_s # => \"fox\"\n```\n\n`YAML.parse` can read from an `IO` directly (such as a file) which saves\nallocating a string:\n\n```\nrequire \"yaml\"\n\nyaml = File.open(\"path/to/file.yml\") do |file|\n  YAML.parse(file)\nend\n```\n\n### Parsing with `from_yaml`\n\nA type `T` can be deserialized from YAML by invoking `T.from_yaml(string_or_io)`.\nFor this to work, `T` must implement\n`new(ctx : YAML::PullParser, node : YAML::Nodes::Node)` and decode\na value from the given *node*, using *ctx* to store and retrieve\nanchored values (see `YAML::PullParser` for an explanation of this).\n\nCrystal primitive types, `Time`, `Bytes` and `Union` implement\nthis method. `YAML.mapping` can be used to implement this method\nfor user types.\n\n### Dumping with `YAML.dump` or `#to_yaml`\n\n`YAML.dump` generates the YAML representation for an object.\nAn `IO` can be passed and it will be written there,\notherwise it will be returned as a string. Similarly, `#to_yaml`\n(with or without an `IO`) on any object does the same.\n\nFor this to work, the type given to `YAML.dump` must implement\n`to_yaml(builder : YAML::Nodes::Builder`).\n\nCrystal primitive types, `Time` and `Bytes` implement\nthis method. `YAML.mapping` can be used to implement this method\nfor user types.\n\n```\nyaml = YAML.dump({hello: \"world\"})                               # => \"---\\nhello: world\\n\"\nFile.open(\"foo.yml\", \"w\") { |f| YAML.dump({hello: \"world\"}, f) } # writes it to the file\n# or:\nyaml = {hello: \"world\"}.to_yaml                               # => \"---\\nhello: world\\n\"\nFile.open(\"foo.yml\", \"w\") { |f| {hello: \"world\"}.to_yaml(f) } # writes it to the file\n```","summary":"<p>The YAML module provides serialization and deserialization of YAML version 1.1 to/from native Crystal data structures, with the additional independent types specified in http://yaml.org/type/</p>","class_methods":[{"id":"build(io:IO,&block)-class-method","html_id":"build(io:IO,&amp;block)-class-method","name":"build","doc":"Writes YAML into the given `IO`. A `YAML::Builder` is yielded to the block.","summary":"<p>Writes YAML into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L191","def":{"name":"build","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"YAML::Builder.new(io) do |yaml|\n  yaml.stream do\n    yaml.document do\n      yield yaml\n    end\n  end\nend"}},{"id":"build(&block)-class-method","html_id":"build(&amp;block)-class-method","name":"build","doc":"Returns the resulting String of writing YAML to the yielded `YAML::Builder`.\n\n```\nrequire \"yaml\"\n\nstring = YAML.build do |yaml|\n  yaml.mapping do\n    yaml.scalar \"foo\"\n    yaml.sequence do\n      yaml.scalar 1\n      yaml.scalar 2\n    end\n  end\nend\nstring # => \"---\\nfoo:\\n- 1\\n- 2\\n\"\n```","summary":"<p>Returns the resulting String of writing YAML to the yielded <code><a href=\"YAML/Builder.html\">YAML::Builder</a></code>.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L182","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L182","def":{"name":"build","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"String.build do |str|\n  build(str) do |yaml|\n    yield yaml\n  end\nend"}},{"id":"dump(object,io:IO)-class-method","html_id":"dump(object,io:IO)-class-method","name":"dump","doc":"Serializes an object to YAML, writing it to *io*.","summary":"<p>Serializes an object to YAML, writing it to <em>io</em>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(object, io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L157","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L157","def":{"name":"dump","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""},{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"object.to_yaml(io)"}},{"id":"dump(object):String-class-method","html_id":"dump(object):String-class-method","name":"dump","doc":"Serializes an object to YAML, returning it as a `String`.","summary":"<p>Serializes an object to YAML, returning it as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"args_string":"(object) : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L152","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L152","def":{"name":"dump","args":[{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"object.to_yaml"}},{"id":"parse(data:String|IO):Any-class-method","html_id":"parse(data:String|IO):Any-class-method","name":"parse","doc":"Deserializes a YAML document according to the core schema.\n\n```yaml\n# ./foo.yml\ndata:\n  string: \"foobar\"\n  array:\n    - John\n    - Sarah\n  hash: {key: value}\n  paragraph: |\n    foo\n    bar\n```\n\n```\nrequire \"yaml\"\n\nYAML.parse(File.read(\"./foo.yml\"))\n# => {\n# => \"data\" => {\n# => \"string\" => \"foobar\",\n# => \"array\" => [\"John\", \"Sarah\"],\n# => \"hash\" => {\"key\" => \"value\"},\n# => \"paragraph\" => \"foo\\nbar\\n\"\n# => }\n```","summary":"<p>Deserializes a YAML document according to the core schema.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L128","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L128","def":{"name":"parse","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Any","visibility":"Public","body":"YAML::Schema::Core.parse(data)"}},{"id":"parse_all(data:String):Array(Any)-class-method","html_id":"parse_all(data:String):Array(Any)-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents according to the core schema.\n\n```yaml\n# ./foo.yml\nfoo: bar\n---\nhello: world\n```\n\n```\nrequire \"yaml\"\n\nYAML.parse_all(File.read(\"./foo.yml\"))\n# => [{\"foo\" => \"bar\"}, {\"hello\" => \"world\"}]\n```","summary":"<p>Deserializes multiple YAML documents according to the core schema.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"args_string":"(data : String) : Array(Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L147","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L147","def":{"name":"parse_all","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Any)","visibility":"Public","body":"YAML::Schema::Core.parse_all(data)"}}],"constructors":[],"instance_methods":[],"macros":[{"id":"mapping(_properties_,strict=false)-macro","html_id":"mapping(_properties_,strict=false)-macro","name":"mapping","doc":"The `YAML.mapping` macro defines how an object is mapped to YAML.\n\nIt takes named arguments, a named tuple literal or a hash literal as argument,\nin which attributes and types are defined.\nOnce defined, `Object#from_yaml` populates properties of the class from the\nYAML document.\n\n```\nrequire \"yaml\"\n\nclass Employee\n  YAML.mapping(\n    title: String,\n    name: String,\n  )\nend\n\nemployee = Employee.from_yaml(\"title: Manager\\nname: John\")\nemployee.title # => \"Manager\"\nemployee.name  # => \"John\"\n\nemployee.name = \"Jenny\"\nemployee.name # => \"Jenny\"\n```\n\nAttributes not mapped with `YAML.mapping` are not defined as properties.\nAlso, missing attributes raise a `ParseException`.\n\n```\nemployee = Employee.from_yaml(\"title: Manager\\nname: John\\nage: 30\")\nemployee.age # undefined method 'age'. (compile error)\n\nEmployee.from_yaml(\"title: Manager\") # raises YAML::ParseException\n```\n\nYou can also define attributes for each property.\n\n```\nclass Employer\n  YAML.mapping(\n    title: String,\n    name: {\n      type:    String,\n      nilable: true,\n      key:     \"firstname\",\n    },\n  )\nend\n```\n\nAvailable attributes:\n\n* *type* (required) defines its type. In the example above, *title: String* is a shortcut to *title: {type: String}*.\n* *nilable* defines if a property can be a `Nil`. Passing `T?` as a type has the same effect.\n* **default**: value to use if the property is missing in the YAML document, or if it's `null` and `nilable` was not set to `true`. If the default value creates a new instance of an object (for example `[1, 2, 3]` or `SomeObject.new`), a different instance will be used each time a YAML document is parsed.\n* *key* defines which key to read from a YAML document. It defaults to the name of the property.\n* *converter* takes an alternate type for parsing. It requires a `#from_yaml` method in that class, and returns an instance of the given type. Examples of converters are `Time::Format` and `Time::EpochConverter` for `Time`.\n* **setter**: if `true`, will generate a setter for the variable, `true` by default\n* **getter**: if `true`, will generate a getter for the variable, `true` by default\n* **presence**: if `true`, a `{{key}}_present?` method will be generated when the key was present (even if it has a `null` value), `false` by default\n\nThis macro by default defines getters and setters for each variable (this can be overrided with *setter* and *getter*).\nThe mapping doesn't define a constructor accepting these variables as arguments, but you can provide an overload.\n\nThe macro basically defines a constructor accepting a `YAML::PullParser` that reads from\nit and initializes this type's instance variables.\n\nThis macro also declares instance variables of the types given in the mapping.","summary":"<p>The <code><a href=\"YAML.html#mapping-macro\">YAML.mapping</a></code> macro defines how an object is mapped to YAML.</p>","abstract":false,"args":[{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},{"name":"strict","doc":null,"default_value":"false","external_name":"strict","restriction":""}],"args_string":"(_properties_, strict = false)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/mapping.cr#L70","def":{"name":"mapping","args":[{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},{"name":"strict","doc":null,"default_value":"false","external_name":"strict","restriction":""}],"double_splat":null,"splat_index":null,"block_arg":null,"visibility":"Public","body":"    \n{% for key, value in _properties_ %}\n      {% unless value.is_a?(HashLiteral) || value.is_a?(NamedTupleLiteral)\n  _properties_[key] = {type: value}\nend %}\n    {% end %}\n\n\n    \n{% for key, value in _properties_ %}\n      {% _properties_[key][:key_id] = key.id.gsub(/\\?$/, \"\") %}\n    {% end %}\n\n\n    \n{% for key, value in _properties_ %}\n      @{{ value[:key_id] }} : {{ value[:type] }} {{ (value[:nilable] ? \"?\" : \"\").id }}\n\n      {% if value[:setter] == nil ? true : value[:setter] %}\n        def {{ value[:key_id] }}=(_{{ value[:key_id] }} : {{ value[:type] }} {{ (value[:nilable] ? \"?\" : \"\").id }})\n          @{{ value[:key_id] }} = _{{ value[:key_id] }}\n        end\n      {% end %}\n\n      {% if value[:getter] == nil ? true : value[:getter] %}\n        def {{ key.id }}\n          @{{ value[:key_id] }}\n        end\n      {% end %}\n\n      {% if value[:presence] %}\n        @{{ value[:key_id] }}_present : Bool = false\n\n        def {{ value[:key_id] }}_present?\n          @{{ value[:key_id] }}_present\n        end\n      {% end %}\n    {% end %}\n\n\n    def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)\n      ctx.read_alias(node, \n\\{\n{@type}}) do |obj|\n        return obj\n      \nend\n\n      instance = allocate\n\n      ctx.record_anchor(node, instance)\n\n      instance.initialize(ctx, node, nil)\n      GC.add_finalizer(instance) if instance.responds_to?(:finalize)\n      instance\n    \nend\n\n    \n# `new` and `initialize` with just `pull` as an argument collide\n\n    \n# and the compiler just sees the last one. This is why we add a\n\n    \n# dummy argument.\n\n    \n#\n\n    \n# FIXME: remove the dummy argument if we ever fix this.\n\n\n    def initialize(ctx : YAML::ParseContext, node : ::YAML::Nodes::Node, _dummy : Nil)\n      \n{% for key, value in _properties_ %}\n        %var{key.id} = nil\n        %found{key.id} = false\n      {% end %}\n\n\n      case node\n      when YAML::Nodes::Mapping\n        YAML::Schema::Core.each(node) do |key_node, value_node|\n          unless key_node.is_a?(YAML::Nodes::Scalar)\n            key_node.raise \"Expected scalar as key for mapping\"\n          \nend\n\n          key = key_node.value\n\n          case key\n          \n{% for key, value in _properties_ %}\n            when {{ value[:key] || value[:key_id].stringify }}\n              %found{key.id} = true\n\n              %var{key.id} =\n                {% if value[:nilable] || (value[:default] != nil) %} YAML::Schema::Core.parse_null_or(value_node) { {% end %}\n\n                {% if value[:converter] %}\n                  {{ value[:converter] }}.from_yaml(ctx, value_node)\n                {% else %}{% if value[:type].is_a?(Path) || value[:type].is_a?(Generic) %}\n                  {{ value[:type] }}.new(ctx, value_node)\n                {% else %}\n                  ::Union({{ value[:type] }}).new(ctx, value_node)\n                {% end %}{% end %}\n\n                {% if value[:nilable] || (value[:default] != nil) %} } {% end %}\n          {% end %}\n\n          \nelse\n            \n{% if strict %}\n              key_node.raise \"Unknown yaml attribute: #{key}\"\n            {% end %}\n\n          \nend\n        \nend\n      when YAML::Nodes::Scalar\n        if node.value.empty? && node.style.plain? && !node.tag\n          \n# We consider an empty scalar as an empty mapping\n\n        \nelse\n          node.raise \"Expected mapping, not #{node.class}\"\n        \nend\n      \nelse\n        node.raise \"Expected mapping, not #{node.class}\"\n      \nend\n\n      \n{% for key, value in _properties_ %}\n        {% if value[:nilable] || (value[:default] != nil) %}{% else %}\n          if %var{key.id}.nil? && !%found{key.id} && !::Union({{ value[:type] }}).nilable?\n            node.raise \"Missing yaml attribute: {{ (value[:key] || value[:key_id]).id }}\"\n          end\n        {% end %}\n\n        {% if value[:nilable] %}\n          {% if value[:default] != nil %}\n            @{{ value[:key_id] }} = %found{key.id} ? %var{key.id} : {{ value[:default] }}\n          {% else %}\n            @{{ value[:key_id] }} = %var{key.id}\n          {% end %}\n        {% else %}{% if value[:default] != nil %}\n          @{{ value[:key_id] }} = %var{key.id}.nil? ? {{ value[:default] }} : %var{key.id}\n        {% else %}\n          @{{ value[:key_id] }} = %var{key.id}.as({{ value[:type] }})\n        {% end %}{% end %}\n\n        {% if value[:presence] %}\n          @{{ value[:key_id] }}_present = %found{key.id}\n        {% end %}\n      {% end %}\n\n    \nend\n\n    def to_yaml(\n%yaml\n : ::YAML::Nodes::Builder)\n      \n%yaml\n.mapping(reference: self) do\n        \n{% for key, value in _properties_ %}\n          _{{ value[:key_id] }} = @{{ value[:key_id] }}\n\n          unless _{{ value[:key_id] }}.nil?\n            # Key\n            {{ value[:key] || value[:key_id].stringify }}.to_yaml(%yaml)\n\n            # Value\n            {% if value[:converter] %}\n              {{ value[:converter] }}.to_yaml(_{{ value[:key_id] }}, %yaml)\n            {% else %}\n              _{{ value[:key_id] }}.to_yaml(%yaml)\n            {% end %}\n          end\n        {% end %}\n\n      \nend\n    \nend\n  \n"}},{"id":"mapping-macro","html_id":"mapping-macro","name":"mapping","doc":"This is a convenience method to allow invoking `YAML.mapping`\nwith named arguments instead of with a hash/named-tuple literal.","summary":"<p>This is a convenience method to allow invoking <code><a href=\"YAML.html#mapping-macro\">YAML.mapping</a></code> with named arguments instead of with a hash/named-tuple literal.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/mapping.cr#L220","def":{"name":"mapping","args":[],"double_splat":{"name":"_properties_","doc":null,"default_value":"","external_name":"_properties_","restriction":""},"splat_index":null,"block_arg":null,"visibility":"Public","body":"    ::YAML.mapping(\n{{ _properties_ }}\n)\n  \n"}}],"types":[{"html_id":"github.com/crystal-lang/crystal/YAML/Any","path":"YAML/Any.html","kind":"struct","full_name":"YAML::Any","name":"Any","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/any.cr","line_number":26,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"`YAML::Any` is a convenient wrapper around all possible YAML core types\n(`YAML::Any::Type`) and can be used for traversing dynamic or\nunknown YAML structures.\n\n```\nrequire \"yaml\"\n\ndata = YAML.parse <<-END\n         ---\n         foo:\n           bar:\n             baz:\n               - qux\n               - fox\n         END\ndata[\"foo\"][\"bar\"][\"baz\"][0].as_s # => \"qux\"\ndata[\"foo\"][\"bar\"][\"baz\"].as_a    # => [\"qux\", \"fox\"]\n```\n\nNote that methods used to traverse a YAML structure, `#[]`, `#[]?` and `#each`,\nalways return a `YAML::Any` to allow further traversal. To convert them to `String`,\n`Array`, etc., use the `as_` methods, such as `#as_s`, `#as_a`, which perform\na type check against the raw underlying value. This means that invoking `#as_s`\nwhen the underlying value is not a `String` will raise: the value won't automatically\nbe converted (parsed) to a `String`.","summary":"<p><code><a href=\"../YAML/Any.html\">YAML::Any</a></code> is a convenient wrapper around all possible YAML core types (<code><a href=\"../YAML/Any/Type.html\">YAML::Any::Type</a></code>) and can be used for traversing dynamic or unknown YAML structures.</p>","class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L30","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"anchors = {} of String => Any\nconvert(node, anchors)\n"}},{"id":"new(raw:Type)-class-method","html_id":"new(raw:Type)-class-method","name":"new","doc":"Creates a `Any` that wraps the given `Type`.","summary":"<p>Creates a <code><a href=\"../YAML/Any.html\">Any</a></code> that wraps the given <code><a href=\"../YAML/Any/Type.html\">Type</a></code>.</p>","abstract":false,"args":[{"name":"raw","doc":null,"default_value":"","external_name":"raw","restriction":"Type"}],"args_string":"(raw : Type)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L74","def":{"name":"new","args":[{"name":"raw","doc":null,"default_value":"","external_name":"raw","restriction":"Type"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(raw)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"==(other)-instance-method","html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if the raw object is equal to *other*.","summary":"<p>Returns <code>true</code> if the raw object is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"args_string":"(other)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L252","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L252","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw == other"}},{"id":"==(other:YAML::Any)-instance-method","html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":"Returns `true` if both `self` and *other*'s raw object are equal.","summary":"<p>Returns <code>true</code> if both <code>self</code> and <em>other</em>'s raw object are equal.</p>","abstract":false,"args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L247","def":{"name":"==","args":[{"name":"other","doc":null,"default_value":"","external_name":"other","restriction":"YAML::Any"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raw == other.raw"}},{"id":"[](index_or_key):YAML::Any-instance-method","html_id":"[](index_or_key):YAML::Any-instance-method","name":"[]","doc":"Assumes the underlying value is an `Array` or `Hash`\nand returns the element at the given *index_or_key*.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>.</p>","abstract":false,"args":[{"name":"index_or_key","doc":null,"default_value":"","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : YAML::Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L95","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L95","def":{"name":"[]","args":[{"name":"index_or_key","doc":null,"default_value":"","external_name":"index_or_key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"YAML::Any","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]\n  else\n    raise(\"Expected int key for Array#[], not #{object.class}\")\n  end\nwhen Hash\n  object[index_or_key]\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"id":"[]?(index_or_key):YAML::Any?-instance-method","html_id":"[]?(index_or_key):YAML::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is an `Array` or `Hash` and returns the element\nat the given *index_or_key*, or `nil` if out of bounds or the key is missing.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>, or <code>nil</code> if out of bounds or the key is missing.</p>","abstract":false,"args":[{"name":"index_or_key","doc":null,"default_value":"","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : YAML::Any?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L114","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L114","def":{"name":"[]?","args":[{"name":"index_or_key","doc":null,"default_value":"","external_name":"index_or_key","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"YAML::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]?\n  else\n    nil\n  end\nwhen Hash\n  object[index_or_key]?\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"id":"as_a:Array(Any)-instance-method","html_id":"as_a:Array(Any)-instance-method","name":"as_a","doc":"Checks that the underlying value is `Array`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Array(Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L197","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L197","def":{"name":"as_a","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Any)","visibility":"Public","body":"@raw.as(Array)"}},{"id":"as_a?:Array(Any)?-instance-method","html_id":"as_a?:Array(Any)?-instance-method","name":"as_a?","doc":"Checks that the underlying value is `Array`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Array(Any)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L203","def":{"name":"as_a?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Any) | ::Nil","visibility":"Public","body":"@raw.as?(Array)"}},{"id":"as_bytes:Bytes-instance-method","html_id":"as_bytes:Bytes-instance-method","name":"as_bytes","doc":"Checks that the underlying value is `Bytes`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bytes.html\">Bytes</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L221","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L221","def":{"name":"as_bytes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes","visibility":"Public","body":"@raw.as(Bytes)"}},{"id":"as_bytes?:Bytes?-instance-method","html_id":"as_bytes?:Bytes?-instance-method","name":"as_bytes?","doc":"Checks that the underlying value is `Bytes`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bytes.html\">Bytes</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Bytes?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L227","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L227","def":{"name":"as_bytes?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bytes | ::Nil","visibility":"Public","body":"@raw.as?(Bytes)"}},{"id":"as_f:Float64-instance-method","html_id":"as_f:Float64-instance-method","name":"as_f","doc":"Checks that the underlying value is `Float64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Float64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L173","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L173","def":{"name":"as_f","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64","visibility":"Public","body":"@raw.as(Float64)"}},{"id":"as_f?:Float64?-instance-method","html_id":"as_f?:Float64?-instance-method","name":"as_f?","doc":"Checks that the underlying value is `Float64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Float64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L179","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L179","def":{"name":"as_f?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Float64 | ::Nil","visibility":"Public","body":"@raw.as?(Float64)"}},{"id":"as_h:Hash(Any,Any)-instance-method","html_id":"as_h:Hash(Any,Any)-instance-method","name":"as_h","doc":"Checks that the underlying value is `Hash`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Hash(Any, Any)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L209","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L209","def":{"name":"as_h","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(Any, Any)","visibility":"Public","body":"@raw.as(Hash)"}},{"id":"as_h?:Hash(Any,Any)?-instance-method","html_id":"as_h?:Hash(Any,Any)?-instance-method","name":"as_h?","doc":"Checks that the underlying value is `Hash`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Hash(Any, Any)?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L215","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L215","def":{"name":"as_h?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Hash(Any, Any) | ::Nil","visibility":"Public","body":"@raw.as?(Hash)"}},{"id":"as_i:Int32-instance-method","html_id":"as_i:Int32-instance-method","name":"as_i","doc":"Checks that the underlying value is `Int64`, and returns its value as `Int32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value as <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L161","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L161","def":{"name":"as_i","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"(@raw.as(Int64)).to_i"}},{"id":"as_i64:Int64-instance-method","html_id":"as_i64:Int64-instance-method","name":"as_i64","doc":"Checks that the underlying value is `Int64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Int64","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L149","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L149","def":{"name":"as_i64","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64","visibility":"Public","body":"@raw.as(Int64)"}},{"id":"as_i64?:Int64?-instance-method","html_id":"as_i64?:Int64?-instance-method","name":"as_i64?","doc":"Checks that the underlying value is `Int64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Int64?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L155","def":{"name":"as_i64?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int64 | ::Nil","visibility":"Public","body":"@raw.as?(Int64)"}},{"id":"as_i?:Int32?-instance-method","html_id":"as_i?:Int32?-instance-method","name":"as_i?","doc":"Checks that the underlying value is `Int64`, and returns its value as `Int32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value as <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[],"args_string":" : Int32?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L167","def":{"name":"as_i?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32 | ::Nil","visibility":"Public","body":"(@raw.as?(Int64)).try(&.to_i)"}},{"id":"as_nil:Nil-instance-method","html_id":"as_nil:Nil-instance-method","name":"as_nil","doc":"Checks that the underlying value is `Nil`, and returns `nil`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Nil.html\">Nil</a></code>, and returns <code>nil</code>.</p>","abstract":false,"args":[],"args_string":" : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L131","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L131","def":{"name":"as_nil","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"@raw.as(Nil)"}},{"id":"as_s:String-instance-method","html_id":"as_s:String-instance-method","name":"as_s","doc":"Checks that the underlying value is `String`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L137","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L137","def":{"name":"as_s","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@raw.as(String)"}},{"id":"as_s?:String?-instance-method","html_id":"as_s?:String?-instance-method","name":"as_s?","doc":"Checks that the underlying value is `String`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L143","def":{"name":"as_s?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@raw.as?(String)"}},{"id":"as_time:Time-instance-method","html_id":"as_time:Time-instance-method","name":"as_time","doc":"Checks that the underlying value is `Time`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L185","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L185","def":{"name":"as_time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"@raw.as(Time)"}},{"id":"as_time?:Time?-instance-method","html_id":"as_time?:Time?-instance-method","name":"as_time?","doc":"Checks that the underlying value is `Time`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"args":[],"args_string":" : Time?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L191","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L191","def":{"name":"as_time?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time | ::Nil","visibility":"Public","body":"@raw.as?(Time)"}},{"id":"clone-instance-method","html_id":"clone-instance-method","name":"clone","doc":"Returns a new YAML::Any instance with the `raw` value `clone`ed.","summary":"<p>Returns a new YAML::Any instance with the <code><a href=\"../YAML/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../YAML/Any.html#clone-instance-method\">#clone</a></code>ed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L270","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L270","def":{"name":"clone","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Any.new(raw.clone)"}},{"id":"dup-instance-method","html_id":"dup-instance-method","name":"dup","doc":"Returns a new YAML::Any instance with the `raw` value `dup`ed.","summary":"<p>Returns a new YAML::Any instance with the <code><a href=\"../YAML/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../YAML/Any.html#dup-instance-method\">#dup</a></code>ed.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L265","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L265","def":{"name":"dup","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Any.new(raw.dup)"}},{"id":"hash(hasher)-instance-method","html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"args_string":"(hasher)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L257","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L257","def":{"name":"hash","args":[{"name":"hasher","doc":null,"default_value":"","external_name":"hasher","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"hasher = raw.hash(hasher)\nhasher\n"}},{"id":"raw:Type-instance-method","html_id":"raw:Type-instance-method","name":"raw","doc":"Returns the raw underlying value, a `Type`.","summary":"<p>Returns the raw underlying value, a <code><a href=\"../YAML/Any/Type.html\">Type</a></code>.</p>","abstract":false,"args":[],"args_string":" : Type","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L71","def":{"name":"raw","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Type","visibility":"Public","body":"@raw"}},{"id":"size:Int-instance-method","html_id":"size:Int-instance-method","name":"size","doc":"Assumes the underlying value is an `Array` or `Hash` and returns its size.\n\nRaises if the underlying value is not an `Array` or `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns its size.</p>","abstract":false,"args":[],"args_string":" : Int","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L80","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr#L80","def":{"name":"size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int","visibility":"Public","body":"case object = @raw\nwhen Array\n  object.size\nwhen Hash\n  object.size\nelse\n  raise(\"Expected Array or Hash for #size, not #{object.class}\")\nend"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/YAML/Any/Type","path":"YAML/Any/Type.html","kind":"alias","full_name":"YAML::Any::Type","name":"Type","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/any.cr","line_number":28,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/any.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":true,"aliased":"(Array(YAML::Any) | Bool | Float64 | Hash(YAML::Any, YAML::Any) | Int64 | Set(YAML::Any) | Slice(UInt8) | String | Time | Nil)","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Any","kind":"struct","full_name":"YAML::Any","name":"Any"},"doc":"All valid YAML core schema types.","summary":"<p>All valid YAML core schema types.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/YAML/Builder","path":"YAML/Builder.html","kind":"class","full_name":"YAML::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/builder.cr","line_number":26,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"A YAML builder generates valid YAML.\n\nA `YAML::Error` is raised if attempting to generate\nan invalid YAML (for example, if invoking `end_sequence`\nwithout a matching `start_sequence`)\n\n```\nrequire \"yaml\"\n\nstring = YAML.build do |yaml|\n  yaml.mapping do\n    yaml.scalar \"foo\"\n    yaml.sequence do\n      yaml.scalar 1\n      yaml.scalar 2\n    end\n    yaml.scalar \"bar\"\n    yaml.mapping do\n      yaml.scalar \"baz\"\n      yaml.scalar \"qux\"\n    end\n  end\nend\nstring # => \"---\\nfoo:\\n- 1\\n- 2\\nbar:\\n  baz: qux\\n\"\n```","summary":"<p>A YAML builder generates valid YAML.</p>","class_methods":[],"constructors":[{"id":"new(io:IO)-class-method","html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a `YAML::Builder` that will write to the given `IO`.","summary":"<p>Creates a <code><a href=\"../YAML/Builder.html\">YAML::Builder</a></code> that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L30","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(io:IO,&block)-class-method","html_id":"new(io:IO,&amp;block)-class-method","name":"new","doc":"Creates a `YAML::Builder` that will write to the given `IO`,\ninvokes the block and closes the builder.","summary":"<p>Creates a <code><a href=\"../YAML/Builder.html\">YAML::Builder</a></code> that will write to the given <code><a href=\"../IO.html\">IO</a></code>, invokes the block and closes the builder.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"args_string":"(io : IO, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L45","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"emitter = new(io)\nbegin\n  yield emitter\nensure\n  emitter.close\nend\n"}}],"instance_methods":[{"id":"alias(anchor:String)-instance-method","html_id":"alias(anchor:String)-instance-method","name":"alias","doc":null,"summary":null,"abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L123","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L123","def":{"name":"alias","args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibYAML.yaml_alias_event_initialize(pointerof(@event), anchor)\nyaml_emit(\"alias\")\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes the builder, freeing up resources.","summary":"<p>Closes the builder, freeing up resources.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L139","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"finalize\n@closed = true\n"}},{"id":"document(&block)-instance-method","html_id":"document(&amp;block)-instance-method","name":"document","doc":"Starts a document, invokes the block, and then ends it.","summary":"<p>Starts a document, invokes the block, and then ends it.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L77","def":{"name":"document","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_document\n(yield).tap do\n  end_document\nend\n"}},{"id":"end_document-instance-method","html_id":"end_document-instance-method","name":"end_document","doc":"Ends a document.","summary":"<p>Ends a document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L72","def":{"name":"end_document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(document_end, 1)"}},{"id":"end_mapping-instance-method","html_id":"end_mapping-instance-method","name":"end_mapping","doc":"Ends a mapping.","summary":"<p>Ends a mapping.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L113","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L113","def":{"name":"end_mapping","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(mapping_end)"}},{"id":"end_sequence-instance-method","html_id":"end_sequence-instance-method","name":"end_sequence","doc":"Ends a sequence.","summary":"<p>Ends a sequence.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L96","def":{"name":"end_sequence","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(sequence_end)"}},{"id":"end_stream-instance-method","html_id":"end_stream-instance-method","name":"end_stream","doc":"Ends a YAML stream.","summary":"<p>Ends a YAML stream.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L56","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L56","def":{"name":"end_stream","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(stream_end)"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L133","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L133","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\nLibYAML.yaml_emitter_delete(@emitter)\n"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes any pending data to the underlying `IO`.","summary":"<p>Flushes any pending data to the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L129","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L129","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"LibYAML.yaml_emitter_flush(@emitter)"}},{"id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,&block)-instance-method","html_id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,&amp;block)-instance-method","name":"mapping","doc":"Starts a mapping, invokes the block, and then ends it.","summary":"<p>Starts a mapping, invokes the block, and then ends it.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::MappingStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L118","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L118","def":{"name":"mapping","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_mapping(anchor, tag, style)\n(yield).tap do\n  end_mapping\nend\n"}},{"id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY)-instance-method","html_id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY)-instance-method","name":"scalar","doc":"Emits a scalar value.","summary":"<p>Emits a scalar value.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"}],"args_string":"(value, anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::ScalarStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">ScalarStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L83","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"string = value.to_s\nimplicit = tag ? 0 : 1\nemit(scalar, get_anchor(anchor), string_to_unsafe(tag), string, string.bytesize, implicit, implicit, style)\n"}},{"id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,&block)-instance-method","html_id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,&amp;block)-instance-method","name":"sequence","doc":"Starts a sequence, invokes the block, and the ends it.","summary":"<p>Starts a sequence, invokes the block, and the ends it.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::SequenceStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L101","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L101","def":{"name":"sequence","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_sequence(anchor, tag, style)\n(yield).tap do\n  end_sequence\nend\n"}},{"id":"start_document-instance-method","html_id":"start_document-instance-method","name":"start_document","doc":"Starts a document.","summary":"<p>Starts a document.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L67","def":{"name":"start_document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(document_start, nil, nil, nil, 0)"}},{"id":"start_mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY)-instance-method","html_id":"start_mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY)-instance-method","name":"start_mapping","doc":"Starts a mapping.","summary":"<p>Starts a mapping.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::MappingStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L107","def":{"name":"start_mapping","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"implicit = tag ? 0 : 1\nemit(mapping_start, get_anchor(anchor), string_to_unsafe(tag), implicit, style)\n"}},{"id":"start_sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY)-instance-method","html_id":"start_sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY)-instance-method","name":"start_sequence","doc":"Starts a sequence.","summary":"<p>Starts a sequence.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::SequenceStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L90","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L90","def":{"name":"start_sequence","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"implicit = tag ? 0 : 1\nemit(sequence_start, get_anchor(anchor), string_to_unsafe(tag), implicit, style)\n"}},{"id":"start_stream-instance-method","html_id":"start_stream-instance-method","name":"start_stream","doc":"Starts a YAML stream.","summary":"<p>Starts a YAML stream.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L51","def":{"name":"start_stream","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"emit(stream_start, LibYAML::Encoding::UTF8)"}},{"id":"stream(&block)-instance-method","html_id":"stream(&amp;block)-instance-method","name":"stream","doc":"Starts a YAML stream, invokes the block, and ends it.","summary":"<p>Starts a YAML stream, invokes the block, and ends it.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L61","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/builder.cr#L61","def":{"name":"stream","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"start_stream\n(yield).tap do\n  end_stream\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Error","path":"YAML/Error.html","kind":"class","full_name":"YAML::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml.cr","line_number":77,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/YAML/ParseException","kind":"class","full_name":"YAML::ParseException","name":"ParseException"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/EventKind","path":"YAML/EventKind.html","kind":"enum","full_name":"YAML::EventKind","name":"EventKind","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/enums.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"NONE","name":"NONE","value":"0","doc":null,"summary":null},{"id":"STREAM_START","name":"STREAM_START","value":"1","doc":null,"summary":null},{"id":"STREAM_END","name":"STREAM_END","value":"2","doc":null,"summary":null},{"id":"DOCUMENT_START","name":"DOCUMENT_START","value":"3","doc":null,"summary":null},{"id":"DOCUMENT_END","name":"DOCUMENT_END","value":"4","doc":null,"summary":null},{"id":"ALIAS","name":"ALIAS","value":"5","doc":null,"summary":null},{"id":"SCALAR","name":"SCALAR","value":"6","doc":null,"summary":null},{"id":"SEQUENCE_START","name":"SEQUENCE_START","value":"7","doc":null,"summary":null},{"id":"SEQUENCE_END","name":"SEQUENCE_END","value":"8","doc":null,"summary":null},{"id":"MAPPING_START","name":"MAPPING_START","value":"9","doc":null,"summary":null},{"id":"MAPPING_END","name":"MAPPING_END","value":"10","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"alias?-instance-method","html_id":"alias?-instance-method","name":"alias?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L8","def":{"name":"alias?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ALIAS"}},{"id":"document_end?-instance-method","html_id":"document_end?-instance-method","name":"document_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L7","def":{"name":"document_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCUMENT_END"}},{"id":"document_start?-instance-method","html_id":"document_start?-instance-method","name":"document_start?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L6","def":{"name":"document_start?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOCUMENT_START"}},{"id":"mapping_end?-instance-method","html_id":"mapping_end?-instance-method","name":"mapping_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L13","def":{"name":"mapping_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MAPPING_END"}},{"id":"mapping_start?-instance-method","html_id":"mapping_start?-instance-method","name":"mapping_start?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L12","def":{"name":"mapping_start?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == MAPPING_START"}},{"id":"none?-instance-method","html_id":"none?-instance-method","name":"none?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L3","def":{"name":"none?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == NONE"}},{"id":"scalar?-instance-method","html_id":"scalar?-instance-method","name":"scalar?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L9","def":{"name":"scalar?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SCALAR"}},{"id":"sequence_end?-instance-method","html_id":"sequence_end?-instance-method","name":"sequence_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L11","def":{"name":"sequence_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SEQUENCE_END"}},{"id":"sequence_start?-instance-method","html_id":"sequence_start?-instance-method","name":"sequence_start?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L10","def":{"name":"sequence_start?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SEQUENCE_START"}},{"id":"stream_end?-instance-method","html_id":"stream_end?-instance-method","name":"stream_end?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L5","def":{"name":"stream_end?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STREAM_END"}},{"id":"stream_start?-instance-method","html_id":"stream_start?-instance-method","name":"stream_start?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L4","def":{"name":"stream_start?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STREAM_START"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Field","path":"YAML/Field.html","kind":"annotation","full_name":"YAML::Field","name":"Field","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/serialization.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/MappingStyle","path":"YAML/MappingStyle.html","kind":"enum","full_name":"YAML::MappingStyle","name":"MappingStyle","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/enums.cr","line_number":31,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ANY","name":"ANY","value":"0","doc":null,"summary":null},{"id":"BLOCK","name":"BLOCK","value":"1","doc":null,"summary":null},{"id":"FLOW","name":"FLOW","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"any?-instance-method","html_id":"any?-instance-method","name":"any?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L32","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ANY"}},{"id":"block?-instance-method","html_id":"block?-instance-method","name":"block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L33","def":{"name":"block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BLOCK"}},{"id":"flow?-instance-method","html_id":"flow?-instance-method","name":"flow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L34","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L34","def":{"name":"flow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FLOW"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","path":"YAML/Nodes.html","kind":"module","full_name":"YAML::Nodes","name":"Nodes","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/nodes.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes.cr"},{"filename":"yaml/nodes/nodes.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"The YAML::Nodes module provides an implementation of an\nin-memory YAML document tree. This tree can be generated\nwith the `YAML::Nodes.parse` method or created with a\n`YAML::Nodes::Builder`.\n\nThis document tree can then be converted to YAML be\ninvoking `to_yaml` on the document object.","summary":"<p>The YAML::Nodes module provides an implementation of an in-memory YAML document tree.</p>","class_methods":[{"id":"parse(string_or_io:String|IO):Document-class-method","html_id":"parse(string_or_io:String|IO):Document-class-method","name":"parse","doc":"Parses a `String` or `IO` into a `YAML::Document`.","summary":"<p>Parses a <code><a href=\"../String.html\">String</a></code> or <code><a href=\"../IO.html\">IO</a></code> into a <code>YAML::Document</code>.</p>","abstract":false,"args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO) : Document","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes.cr#L12","def":{"name":"parse","args":[{"name":"string_or_io","doc":null,"default_value":"","external_name":"string_or_io","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Document","visibility":"Public","body":"Parser.new(string_or_io, &.parse)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Alias","path":"YAML/Nodes/Alias.html","kind":"class","full_name":"YAML::Nodes::Alias","name":"Alias","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":137,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"An alias.","summary":"<p>An alias.</p>","class_methods":[],"constructors":[{"id":"new(anchor:String)-class-method","html_id":"new(anchor:String)-class-method","name":"new","doc":"Creates an alias with tha given *anchor*.","summary":"<p>Creates an alias with tha given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L143","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L143","def":{"name":"new","args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(anchor)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"to_yaml(builder:YAML::Builder)-instance-method","html_id":"to_yaml(builder:YAML::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L146","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L146","def":{"name":"to_yaml","args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"builder.alias(anchor.not_nil!)"}},{"id":"value:Node?-instance-method","html_id":"value:Node?-instance-method","name":"value","doc":"The node this alias points to.\nThis is set by `YAML::Nodes.parse`, and is `nil` by default.","summary":"<p>The node this alias points to.</p>","abstract":false,"args":[],"args_string":" : Node?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L140","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Node | ::Nil","visibility":"Public","body":"@value"}},{"id":"value=(value:Node?)-instance-method","html_id":"value=(value:Node?)-instance-method","name":"value=","doc":"The node this alias points to.\nThis is set by `YAML::Nodes.parse`, and is `nil` by default.","summary":"<p>The node this alias points to.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Node | ::Nil"}],"args_string":"(value : Node?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L140","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L140","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"Node | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value = value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Builder","path":"YAML/Nodes/Builder.html","kind":"class","full_name":"YAML::Nodes::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/builder.cr","line_number":12,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"Builds a tree of YAML nodes.\n\nThis builder is similar to `YAML::Builder`, but instead of\ndirectly emitting the output to an IO it builds a YAML document\ntree in memory.\n\nAll \"emitting\" methods support specifying a \"reference\" object\nthat will be associated to the emitted object,\nso that when that reference object is emitted again an anchor\nand an alias will be created. This generates both more compact\ndocuments and allows handling recursive data structures.","summary":"<p>Builds a tree of YAML nodes.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L18","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"document:Document-instance-method","html_id":"document:Document-instance-method","name":"document","doc":"The document this builder builds.","summary":"<p>The document this builder builds.</p>","abstract":false,"args":[],"args_string":" : Document","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L16","def":{"name":"document","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Document","visibility":"Public","body":"@document"}},{"id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,reference=nil,&block):Nil-instance-method","html_id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,reference=nil,&amp;block):Nil-instance-method","name":"mapping","doc":null,"summary":null,"abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::MappingStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L57","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L57","def":{"name":"mapping","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"node = Mapping.new\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_to_stack(node) do\n  yield\nend\n"}},{"id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY,reference=nil):Nil-instance-method","html_id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY,reference=nil):Nil-instance-method","name":"scalar","doc":null,"summary":null,"abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(value, anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::ScalarStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">ScalarStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L25","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L25","def":{"name":"scalar","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""},{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"node = Scalar.new(value.to_s)\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_node(node)\n"}},{"id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,reference=nil,&block):Nil-instance-method","html_id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,reference=nil,&amp;block):Nil-instance-method","name":"sequence","doc":null,"summary":null,"abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(anchor : String? = <span class=\"n\">nil</span>, tag : String? = <span class=\"n\">nil</span>, style : YAML::SequenceStyle = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>, &block) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L40","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/builder.cr#L40","def":{"name":"sequence","args":[{"name":"anchor","doc":null,"default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","doc":null,"default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","doc":null,"default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"},{"name":"reference","doc":null,"default_value":"nil","external_name":"reference","restriction":""}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"node = Sequence.new\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_to_stack(node) do\n  yield\nend\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Document","path":"YAML/Nodes/Document.html","kind":"class","full_name":"YAML::Nodes::Document","name":"Document","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":35,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A YAML document.","summary":"<p>A YAML document.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<<(node)-instance-method","html_id":"&lt;&lt;(node)-instance-method","name":"<<","doc":"Appends a node to this document. Raises if more\nthan one node is appended.","summary":"<p>Appends a node to this document.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"args_string":"(node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L43","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L43","def":{"name":"<<","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if nodes.empty?\n  nodes << node\nelse\n  raise(ArgumentError.new(\"Attempted to append more than one node\"))\nend"}},{"id":"nodes:Array(YAML::Nodes::Node)-instance-method","html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes inside this document.\n\nA document can hold at most one node.","summary":"<p>The nodes inside this document.</p>","abstract":false,"args":[],"args_string":" : Array(YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L39","def":{"name":"nodes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes"}},{"id":"to_yaml(builder:YAML::Builder)-instance-method","html_id":"to_yaml(builder:YAML::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L51","def":{"name":"to_yaml","args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"nodes.each(&.to_yaml(builder))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Mapping","path":"YAML/Nodes/Mapping.html","kind":"class","full_name":"YAML::Nodes::Mapping","name":"Mapping","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":102,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A mapping of nodes.","summary":"<p>A mapping of nodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<<(node)-instance-method","html_id":"&lt;&lt;(node)-instance-method","name":"<<","doc":"Appends a single node into this mapping.","summary":"<p>Appends a single node into this mapping.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"args_string":"(node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L115","def":{"name":"<<","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes << node"}},{"id":"[]=(key,value)-instance-method","html_id":"[]=(key,value)-instance-method","name":"[]=","doc":"Appends two nodes into this mapping.","summary":"<p>Appends two nodes into this mapping.</p>","abstract":false,"args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"args_string":"(key, value)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L110","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L110","def":{"name":"[]=","args":[{"name":"key","doc":null,"default_value":"","external_name":"key","restriction":""},{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"(@nodes << key) << value"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":"Yields each key-value pair in this mapping.","summary":"<p>Yields each key-value pair in this mapping.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L120","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L120","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"0.step(by: 2, to: @nodes.size - 1) do |i|\n  yield {@nodes[i], @nodes[i + 1]}\nend"}},{"id":"nodes:Array(YAML::Nodes::Node)-instance-method","html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes inside this mapping, stored linearly\nas key1 - value1 - key2 - value2 - etc.","summary":"<p>The nodes inside this mapping, stored linearly as key1 - value1 - key2 - value2 - etc.</p>","abstract":false,"args":[],"args_string":" : Array(YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L107","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L107","def":{"name":"nodes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes"}},{"id":"style:MappingStyle-instance-method","html_id":"style:MappingStyle-instance-method","name":"style","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : MappingStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L103","def":{"name":"style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MappingStyle","visibility":"Public","body":"@style"}},{"id":"style=(style:MappingStyle)-instance-method","html_id":"style=(style:MappingStyle)-instance-method","name":"style=","doc":null,"summary":null,"abstract":false,"args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"MappingStyle"}],"args_string":"(style : MappingStyle)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L103","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L103","def":{"name":"style=","args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"MappingStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@style = style"}},{"id":"to_yaml(builder:YAML::Builder)-instance-method","html_id":"to_yaml(builder:YAML::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L126","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L126","def":{"name":"to_yaml","args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"builder.mapping(anchor, tag, style) do\n  each do |key, value|\n    key.to_yaml(builder)\n    value.to_yaml(builder)\n  end\nend"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","path":"YAML/Nodes/Node.html","kind":"class","full_name":"YAML::Nodes::Node","name":"Node","abstract":true,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Alias","kind":"class","full_name":"YAML::Nodes::Alias","name":"Alias"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Document","kind":"class","full_name":"YAML::Nodes::Document","name":"Document"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Mapping","kind":"class","full_name":"YAML::Nodes::Mapping","name":"Mapping"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Scalar","kind":"class","full_name":"YAML::Nodes::Scalar","name":"Scalar"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Sequence","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence"}],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"Abstract class of all YAML tree nodes.","summary":"<p>Abstract class of all YAML tree nodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"anchor:String?-instance-method","html_id":"anchor:String?-instance-method","name":"anchor","doc":"The optional anchor of a node.","summary":"<p>The optional anchor of a node.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L8","def":{"name":"anchor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@anchor"}},{"id":"anchor=(anchor:String?)-instance-method","html_id":"anchor=(anchor:String?)-instance-method","name":"anchor=","doc":"The optional anchor of a node.","summary":"<p>The optional anchor of a node.</p>","abstract":false,"args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String | ::Nil"}],"args_string":"(anchor : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L8","def":{"name":"anchor=","args":[{"name":"anchor","doc":null,"default_value":"","external_name":"anchor","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@anchor = anchor"}},{"id":"end_column:Int32-instance-method","html_id":"end_column:Int32-instance-method","name":"end_column","doc":"The column where this node ends.","summary":"<p>The column where this node ends.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L20","def":{"name":"end_column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@end_column"}},{"id":"end_column=(end_column)-instance-method","html_id":"end_column=(end_column)-instance-method","name":"end_column=","doc":"The column where this node ends.","summary":"<p>The column where this node ends.</p>","abstract":false,"args":[{"name":"end_column","doc":null,"default_value":"","external_name":"end_column","restriction":""}],"args_string":"(end_column)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L20","def":{"name":"end_column=","args":[{"name":"end_column","doc":null,"default_value":"","external_name":"end_column","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@end_column = end_column"}},{"id":"end_line:Int32-instance-method","html_id":"end_line:Int32-instance-method","name":"end_line","doc":"The line where this node ends.","summary":"<p>The line where this node ends.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L17","def":{"name":"end_line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@end_line"}},{"id":"end_line=(end_line)-instance-method","html_id":"end_line=(end_line)-instance-method","name":"end_line=","doc":"The line where this node ends.","summary":"<p>The line where this node ends.</p>","abstract":false,"args":[{"name":"end_line","doc":null,"default_value":"","external_name":"end_line","restriction":""}],"args_string":"(end_line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L17","def":{"name":"end_line=","args":[{"name":"end_line","doc":null,"default_value":"","external_name":"end_line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@end_line = end_line"}},{"id":"location:Tuple(Int32,Int32)-instance-method","html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","doc":"Returns a tuple of `start_line` and `start_column`.","summary":"<p>Returns a tuple of <code><a href=\"../../YAML/Nodes/Node.html#start_line%3AInt32-instance-method\">#start_line</a></code> and <code><a href=\"../../YAML/Nodes/Node.html#start_column%3AInt32-instance-method\">#start_column</a></code>.</p>","abstract":false,"args":[],"args_string":" : Tuple(Int32, Int32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L23","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"{start_line, start_column}"}},{"id":"raise(message)-instance-method","html_id":"raise(message)-instance-method","name":"raise","doc":"Raises a `YAML::ParseException` with the given message\nlocated at this node's `location`.","summary":"<p>Raises a <code><a href=\"../../YAML/ParseException.html\">YAML::ParseException</a></code> with the given message located at this node's <code><a href=\"../../YAML/Nodes/Node.html#location%3ATuple%28Int32%2CInt32%29-instance-method\">#location</a></code>.</p>","abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"args_string":"(message)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L29","def":{"name":"raise","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"::raise(YAML::ParseException.new(message, *location))"}},{"id":"start_column:Int32-instance-method","html_id":"start_column:Int32-instance-method","name":"start_column","doc":"The column where this node starts.","summary":"<p>The column where this node starts.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L14","def":{"name":"start_column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@start_column"}},{"id":"start_column=(start_column)-instance-method","html_id":"start_column=(start_column)-instance-method","name":"start_column=","doc":"The column where this node starts.","summary":"<p>The column where this node starts.</p>","abstract":false,"args":[{"name":"start_column","doc":null,"default_value":"","external_name":"start_column","restriction":""}],"args_string":"(start_column)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L14","def":{"name":"start_column=","args":[{"name":"start_column","doc":null,"default_value":"","external_name":"start_column","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@start_column = start_column"}},{"id":"start_line:Int32-instance-method","html_id":"start_line:Int32-instance-method","name":"start_line","doc":"The line where this node starts.","summary":"<p>The line where this node starts.</p>","abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L11","def":{"name":"start_line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@start_line"}},{"id":"start_line=(start_line)-instance-method","html_id":"start_line=(start_line)-instance-method","name":"start_line=","doc":"The line where this node starts.","summary":"<p>The line where this node starts.</p>","abstract":false,"args":[{"name":"start_line","doc":null,"default_value":"","external_name":"start_line","restriction":""}],"args_string":"(start_line)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L11","def":{"name":"start_line=","args":[{"name":"start_line","doc":null,"default_value":"","external_name":"start_line","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@start_line = start_line"}},{"id":"tag:String?-instance-method","html_id":"tag:String?-instance-method","name":"tag","doc":"The optional tag of a node.","summary":"<p>The optional tag of a node.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L5","def":{"name":"tag","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"@tag"}},{"id":"tag=(tag:String?)-instance-method","html_id":"tag=(tag:String?)-instance-method","name":"tag=","doc":"The optional tag of a node.","summary":"<p>The optional tag of a node.</p>","abstract":false,"args":[{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":"String | ::Nil"}],"args_string":"(tag : String?)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L5","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L5","def":{"name":"tag=","args":[{"name":"tag","doc":null,"default_value":"","external_name":"tag","restriction":"String | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@tag = tag"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Scalar","path":"YAML/Nodes/Scalar.html","kind":"class","full_name":"YAML::Nodes::Scalar","name":"Scalar","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":57,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A scalar value.","summary":"<p>A scalar value.</p>","class_methods":[],"constructors":[{"id":"new(value:String)-class-method","html_id":"new(value:String)-class-method","name":"new","doc":"Creates a scalar with the given *value*.","summary":"<p>Creates a scalar with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L65","def":{"name":"new","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"style:ScalarStyle-instance-method","html_id":"style:ScalarStyle-instance-method","name":"style","doc":"The style of this scalar.","summary":"<p>The style of this scalar.</p>","abstract":false,"args":[],"args_string":" : ScalarStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L59","def":{"name":"style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ScalarStyle","visibility":"Public","body":"@style"}},{"id":"style=(style:ScalarStyle)-instance-method","html_id":"style=(style:ScalarStyle)-instance-method","name":"style=","doc":"The style of this scalar.","summary":"<p>The style of this scalar.</p>","abstract":false,"args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"ScalarStyle"}],"args_string":"(style : ScalarStyle)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L59","def":{"name":"style=","args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"ScalarStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@style = style"}},{"id":"to_yaml(builder:YAML::Builder)-instance-method","html_id":"to_yaml(builder:YAML::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L68","def":{"name":"to_yaml","args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"builder.scalar(value, anchor, tag, style)"}},{"id":"value:String-instance-method","html_id":"value:String-instance-method","name":"value","doc":"The value of this scalar.","summary":"<p>The value of this scalar.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L62","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"@value"}},{"id":"value=(value:String)-instance-method","html_id":"value=(value:String)-instance-method","name":"value=","doc":"The value of this scalar.","summary":"<p>The value of this scalar.</p>","abstract":false,"args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"args_string":"(value : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L62","def":{"name":"value=","args":[{"name":"value","doc":null,"default_value":"","external_name":"value","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@value = value"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Sequence","path":"YAML/Nodes/Sequence.html","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/nodes/nodes.cr","line_number":74,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A sequence of nodes.","summary":"<p>A sequence of nodes.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"<<(node)-instance-method","html_id":"&lt;&lt;(node)-instance-method","name":"<<","doc":"Appends a node into this sequence.","summary":"<p>Appends a node into this sequence.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"args_string":"(node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L84","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L84","def":{"name":"<<","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes << node"}},{"id":"each(&block)-instance-method","html_id":"each(&amp;block)-instance-method","name":"each","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L88","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L88","def":{"name":"each","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes.each do |node|\n  yield node\nend"}},{"id":"nodes:Array(YAML::Nodes::Node)-instance-method","html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes in this sequence.","summary":"<p>The nodes in this sequence.</p>","abstract":false,"args":[],"args_string":" : Array(YAML::Nodes::Node)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L78","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L78","def":{"name":"nodes","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@nodes"}},{"id":"style:SequenceStyle-instance-method","html_id":"style:SequenceStyle-instance-method","name":"style","doc":"The style of this sequence.","summary":"<p>The style of this sequence.</p>","abstract":false,"args":[],"args_string":" : SequenceStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L81","def":{"name":"style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SequenceStyle","visibility":"Public","body":"@style"}},{"id":"style=(style:SequenceStyle)-instance-method","html_id":"style=(style:SequenceStyle)-instance-method","name":"style=","doc":"The style of this sequence.","summary":"<p>The style of this sequence.</p>","abstract":false,"args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"SequenceStyle"}],"args_string":"(style : SequenceStyle)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L81","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L81","def":{"name":"style=","args":[{"name":"style","doc":null,"default_value":"","external_name":"style","restriction":"SequenceStyle"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@style = style"}},{"id":"to_yaml(builder:YAML::Builder)-instance-method","html_id":"to_yaml(builder:YAML::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L94","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/nodes/nodes.cr#L94","def":{"name":"to_yaml","args":[{"name":"builder","doc":null,"default_value":"","external_name":"builder","restriction":"YAML::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"builder.sequence(anchor, tag, style) do\n  each(&.to_yaml(builder))\nend"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/YAML/ParseContext","path":"YAML/ParseContext.html","kind":"class","full_name":"YAML::ParseContext","name":"ParseContext","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/parse_context.cr","line_number":11,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"Parsing context that holds anchors and what they refer to.\n\nWhen implementing `new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)`\nto deserialize an object from a node, `Reference` types must invoke\nboth `read_alias` and `record_anchor` in order to support parsing\nrecursive data structures.\n\n- `read_alias` must be invoked before an instance is created\n- `record_anchor` must be invoked after an instance is created and\n  before its members are deserialized.","summary":"<p>Parsing context that holds anchors and what they refer to.</p>","class_methods":[],"constructors":[{"id":"new-class-method","html_id":"new-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L12","def":{"name":"new","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"read_alias(node,type:T.class,&block)forallT-instance-method","html_id":"read_alias(node,type:T.class,&amp;block)forallT-instance-method","name":"read_alias","doc":"Tries to read an alias from `node` of type `T`. Invokes\nthe block if successful, and invokers must return this object\ninstead of deserializing their members.","summary":"<p>Tries to read an alias from <code>node</code> of type <code>T</code>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"args_string":"(node, type : T.class, &block) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L33","def":{"name":"read_alias","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if ptr = read_alias_impl(node, T.crystal_instance_type_id, raise_on_alias: true)\n  yield ptr.unsafe_as(T)\nend"}},{"id":"read_alias?(node,type:T.class,&block)forallT-instance-method","html_id":"read_alias?(node,type:T.class,&amp;block)forallT-instance-method","name":"read_alias?","doc":"Similar to `read_alias` but doesn't raise if an alias exists\nbut an instance of type T isn't associated with the current anchor.","summary":"<p>Similar to <code><a href=\"../YAML/ParseContext.html#read_alias%28node%2Ctype%3AT.class%2C%26block%29forallT-instance-method\">#read_alias</a></code> but doesn't raise if an alias exists but an instance of type T isn't associated with the current anchor.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"args_string":"(node, type : T.class, &block) forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L41","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L41","def":{"name":"read_alias?","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"type","doc":null,"default_value":"","external_name":"type","restriction":"T.class"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"if ptr = read_alias_impl(node, T.crystal_instance_type_id, raise_on_alias: false)\n  yield ptr.unsafe_as(T)\nend"}},{"id":"record_anchor(node,object:T):NilforallT-instance-method","html_id":"record_anchor(node,object:T):NilforallT-instance-method","name":"record_anchor","doc":"Associates an object with an anchor.","summary":"<p>Associates an object with an anchor.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"args_string":"(node, object : T) : Nil forall T","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/parse_context.cr#L18","def":{"name":"record_anchor","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":""},{"name":"object","doc":null,"default_value":"","external_name":"object","restriction":"T"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"if object.is_a?(Reference)\nelse\n  return\nend\nrecord_anchor(node.anchor, object.object_id, object.crystal_type_id)\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/ParseException","path":"YAML/ParseException.html","kind":"class","full_name":"YAML::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"},{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml.cr","line_number":81,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"Exception thrown on a YAML parse error.","summary":"<p>Exception thrown on a YAML parse error.</p>","class_methods":[],"constructors":[{"id":"new(message,line_number,column_number,context_info=nil)-class-method","html_id":"new(message,line_number,column_number,context_info=nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""},{"name":"context_info","doc":null,"default_value":"nil","external_name":"context_info","restriction":""}],"args_string":"(message, line_number, column_number, context_info = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L85","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L85","def":{"name":"new","args":[{"name":"message","doc":null,"default_value":"","external_name":"message","restriction":""},{"name":"line_number","doc":null,"default_value":"","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"","external_name":"column_number","restriction":""},{"name":"context_info","doc":null,"default_value":"nil","external_name":"context_info","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number, context_info)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"column_number:Int32-instance-method","html_id":"column_number:Int32-instance-method","name":"column_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L83","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L83","def":{"name":"column_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@column_number"}},{"id":"line_number:Int32-instance-method","html_id":"line_number:Int32-instance-method","name":"line_number","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Int32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L82","def":{"name":"line_number","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Int32","visibility":"Public","body":"@line_number"}},{"id":"location-instance-method","html_id":"location-instance-method","name":"location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L96","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml.cr#L96","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{line_number, column_number}"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/PullParser","path":"YAML/PullParser.html","kind":"class","full_name":"YAML::PullParser","name":"PullParser","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/pull_parser.cr","line_number":10,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"A pull parser allows parsing a YAML document by events.\n\nWhen creating an instance, the parser is positioned in\nthe first event. To get the event kind invoke `kind`.\nIf the event is a scalar you can invoke `value` to get\nits **string** value. Other methods like `tag`, `anchor`\nand `scalar_style` let you inspect other information from events.\n\nInvoking `read_next` reads the next event.","summary":"<p>A pull parser allows parsing a YAML document by events.</p>","class_methods":[],"constructors":[{"id":"new(content:String|IO)-class-method","html_id":"new(content:String|IO)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":"String | IO"}],"args_string":"(content : String | IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L13","def":{"name":"new","args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(content)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(content,&block)-class-method","html_id":"new(content,&amp;block)-class-method","name":"new","doc":"Creates a parser, yields it to the block, and closes\nthe parser at the end of it.","summary":"<p>Creates a parser, yields it to the block, and closes the parser at the end of it.</p>","abstract":false,"args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""}],"args_string":"(content, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L39","def":{"name":"new","args":[{"name":"content","doc":null,"default_value":"","external_name":"content","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"parser = new(content)\nbegin\n  yield parser\nensure\n  parser.close\nend\n"}}],"instance_methods":[{"id":"anchor-instance-method","html_id":"anchor-instance-method","name":"anchor","doc":"Returns the anchor associated to the current event, or `nil`\nif there's no anchor.","summary":"<p>Returns the anchor associated to the current event, or <code>nil</code> if there's no anchor.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L74","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L74","def":{"name":"anchor","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case kind\nwhen .scalar?\n  read_anchor(@event.data.scalar.anchor)\nwhen .sequence_start?\n  read_anchor(@event.data.sequence_start.anchor)\nwhen .mapping_start?\n  read_anchor(@event.data.mapping_start.anchor)\nwhen .alias?\n  read_anchor(@event.data.alias.anchor)\nelse\n  nil\nend"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L308","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L308","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"finalize\n@closed = true\n"}},{"id":"end_column-instance-method","html_id":"end_column-instance-method","name":"end_column","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L263","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L263","def":{"name":"end_column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@event.end_mark.column + 1"}},{"id":"end_line-instance-method","html_id":"end_line-instance-method","name":"end_line","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L259","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L259","def":{"name":"end_line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@event.end_mark.line + 1"}},{"id":"expect_kind(kind:EventKind)-instance-method","html_id":"expect_kind(kind:EventKind)-instance-method","name":"expect_kind","doc":"Raises if the current kind is not the expected one.","summary":"<p>Raises if the current kind is not the expected one.</p>","abstract":false,"args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":"EventKind"}],"args_string":"(kind : EventKind)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L314","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L314","def":{"name":"expect_kind","args":[{"name":"kind","doc":null,"default_value":"","external_name":"kind","restriction":"EventKind"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if kind == self.kind\nelse\n  raise(\"Expected #{kind} but was #{self.kind}\")\nend"}},{"id":"finalize-instance-method","html_id":"finalize-instance-method","name":"finalize","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L301","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L301","def":{"name":"finalize","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\nLibYAML.yaml_parser_delete(@parser)\nLibYAML.yaml_event_delete(pointerof(@event))\n"}},{"id":"kind:EventKind-instance-method","html_id":"kind:EventKind-instance-method","name":"kind","doc":"The current event kind.","summary":"<p>The current event kind.</p>","abstract":false,"args":[],"args_string":" : EventKind","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L45","def":{"name":"kind","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"EventKind","visibility":"Public","body":"@event.type"}},{"id":"location-instance-method","html_id":"location-instance-method","name":"location","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L247","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L247","def":{"name":"location","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{start_line, start_column}"}},{"id":"mapping_style:MappingStyle-instance-method","html_id":"mapping_style:MappingStyle-instance-method","name":"mapping_style","doc":"Returns the mapping style, assuming the pull parser is located\nat a mapping begin event. Raises otherwise.","summary":"<p>Returns the mapping style, assuming the pull parser is located at a mapping begin event.</p>","abstract":false,"args":[],"args_string":" : MappingStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L98","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L98","def":{"name":"mapping_style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"MappingStyle","visibility":"Public","body":"expect_kind(EventKind::MAPPING_START)\n@event.data.mapping_start.style\n"}},{"id":"raise(msg:String,line_number=self.start_line,column_number=self.start_column,context_info=nil)-instance-method","html_id":"raise(msg:String,line_number=self.start_line,column_number=self.start_column,context_info=nil)-instance-method","name":"raise","doc":null,"summary":null,"abstract":false,"args":[{"name":"msg","doc":null,"default_value":"","external_name":"msg","restriction":"String"},{"name":"line_number","doc":null,"default_value":"self.start_line","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"self.start_column","external_name":"column_number","restriction":""},{"name":"context_info","doc":null,"default_value":"nil","external_name":"context_info","restriction":""}],"args_string":"(msg : String, line_number = <span class=\"k\">self</span>.start_line, column_number = <span class=\"k\">self</span>.start_column, context_info = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L322","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L322","def":{"name":"raise","args":[{"name":"msg","doc":null,"default_value":"","external_name":"msg","restriction":"String"},{"name":"line_number","doc":null,"default_value":"self.start_line","external_name":"line_number","restriction":""},{"name":"column_number","doc":null,"default_value":"self.start_column","external_name":"column_number","restriction":""},{"name":"context_info","doc":null,"default_value":"nil","external_name":"context_info","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"::raise(ParseException.new(msg, line_number, column_number, context_info))"}},{"id":"read(expected_kind:EventKind):EventKind-instance-method","html_id":"read(expected_kind:EventKind):EventKind-instance-method","name":"read","doc":"Reads an expected event kind.","summary":"<p>Reads an expected event kind.</p>","abstract":false,"args":[{"name":"expected_kind","doc":null,"default_value":"","external_name":"expected_kind","restriction":"EventKind"}],"args_string":"(expected_kind : EventKind) : EventKind","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L218","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L218","def":{"name":"read","args":[{"name":"expected_kind","doc":null,"default_value":"","external_name":"expected_kind","restriction":"EventKind"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"EventKind","visibility":"Public","body":"expect_kind(expected_kind)\nread_next\n"}},{"id":"read_alias-instance-method","html_id":"read_alias-instance-method","name":"read_alias","doc":"Reads an alias event, returning its anchor.","summary":"<p>Reads an alias event, returning its anchor.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L162","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L162","def":{"name":"read_alias","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(EventKind::ALIAS)\nanchor = self.anchor\nread_next\nanchor\n"}},{"id":"read_document(&block)-instance-method","html_id":"read_document(&amp;block)-instance-method","name":"read_document","doc":"Reads a \"document start\" event, yields to the block,\nand then reads a \"document end\" event.","summary":"<p>Reads a \"document start\" event, yields to the block, and then reads a \"document end\" event.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L136","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L136","def":{"name":"read_document","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_document_start\nvalue = yield\nread_document_end\nvalue\n"}},{"id":"read_document_end-instance-method","html_id":"read_document_end-instance-method","name":"read_document_end","doc":"Reads a \"document end\" event.","summary":"<p>Reads a \"document end\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L193","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L193","def":{"name":"read_document_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::DOCUMENT_END)"}},{"id":"read_document_start-instance-method","html_id":"read_document_start-instance-method","name":"read_document_start","doc":"Reads a \"document start\" event.","summary":"<p>Reads a \"document start\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L188","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L188","def":{"name":"read_document_start","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::DOCUMENT_START)"}},{"id":"read_mapping(&block)-instance-method","html_id":"read_mapping(&amp;block)-instance-method","name":"read_mapping","doc":"Reads a \"mapping start\" event, yields to the block,\nand then reads a \"mapping end\" event.","summary":"<p>Reads a \"mapping start\" event, yields to the block, and then reads a \"mapping end\" event.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L154","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L154","def":{"name":"read_mapping","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_mapping_start\nvalue = yield\nread_mapping_end\nvalue\n"}},{"id":"read_mapping_end-instance-method","html_id":"read_mapping_end-instance-method","name":"read_mapping_end","doc":"Reads a \"mapping end\" event.","summary":"<p>Reads a \"mapping end\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L213","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L213","def":{"name":"read_mapping_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::MAPPING_END)"}},{"id":"read_mapping_start-instance-method","html_id":"read_mapping_start-instance-method","name":"read_mapping_start","doc":"Reads a \"mapping start\" event.","summary":"<p>Reads a \"mapping start\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L208","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L208","def":{"name":"read_mapping_start","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::MAPPING_START)"}},{"id":"read_next:EventKind-instance-method","html_id":"read_next:EventKind-instance-method","name":"read_next","doc":"Reads the next event.","summary":"<p>Reads the next event.</p>","abstract":false,"args":[],"args_string":" : EventKind","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L111","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L111","def":{"name":"read_next","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"EventKind","visibility":"Public","body":"LibYAML.yaml_event_delete(pointerof(@event))\nLibYAML.yaml_parser_parse(@parser, pointerof(@event))\nif problem = problem?\n  msg = String.new(problem)\n  location = {problem_line_number, problem_column_number}\n  if context = context?\n    context_info = {String.new(context), context_line_number, context_column_number}\n  end\n  raise(msg, *location, context_info)\nend\nkind\n"}},{"id":"read_scalar-instance-method","html_id":"read_scalar-instance-method","name":"read_scalar","doc":"Reads a scalar, returning its value.","summary":"<p>Reads a scalar, returning its value.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L170","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L170","def":{"name":"read_scalar","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\nvalue = self.value\nread_next\nvalue\n"}},{"id":"read_sequence(&block)-instance-method","html_id":"read_sequence(&amp;block)-instance-method","name":"read_sequence","doc":"Reads a \"sequence start\" event, yields to the block,\nand then reads a \"sequence end\" event.","summary":"<p>Reads a \"sequence start\" event, yields to the block, and then reads a \"sequence end\" event.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L145","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L145","def":{"name":"read_sequence","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_sequence_start\nvalue = yield\nread_sequence_end\nvalue\n"}},{"id":"read_sequence_end-instance-method","html_id":"read_sequence_end-instance-method","name":"read_sequence_end","doc":"Reads a \"sequence end\" event.","summary":"<p>Reads a \"sequence end\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L203","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L203","def":{"name":"read_sequence_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::SEQUENCE_END)"}},{"id":"read_sequence_start-instance-method","html_id":"read_sequence_start-instance-method","name":"read_sequence_start","doc":"Reads a \"sequence start\" event.","summary":"<p>Reads a \"sequence start\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L198","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L198","def":{"name":"read_sequence_start","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::SEQUENCE_START)"}},{"id":"read_stream(&block)-instance-method","html_id":"read_stream(&amp;block)-instance-method","name":"read_stream","doc":"Reads a \"stream start\" event, yields to the block,\nand then reads a \"stream end\" event.","summary":"<p>Reads a \"stream start\" event, yields to the block, and then reads a \"stream end\" event.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L127","def":{"name":"read_stream","args":[],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"read_stream_start\nvalue = yield\nread_stream_end\nvalue\n"}},{"id":"read_stream_end-instance-method","html_id":"read_stream_end-instance-method","name":"read_stream_end","doc":"Reads a \"stream end\" event.","summary":"<p>Reads a \"stream end\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L183","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L183","def":{"name":"read_stream_end","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::STREAM_END)"}},{"id":"read_stream_start-instance-method","html_id":"read_stream_start-instance-method","name":"read_stream_start","doc":"Reads a \"stream start\" event.","summary":"<p>Reads a \"stream start\" event.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L178","def":{"name":"read_stream_start","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"read(EventKind::STREAM_START)"}},{"id":"scalar_style:ScalarStyle-instance-method","html_id":"scalar_style:ScalarStyle-instance-method","name":"scalar_style","doc":"Returns the scalar style, assuming the pull parser is located\nat a scalar event. Raises otherwise.","summary":"<p>Returns the scalar style, assuming the pull parser is located at a scalar event.</p>","abstract":false,"args":[],"args_string":" : ScalarStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L105","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L105","def":{"name":"scalar_style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"ScalarStyle","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\n@event.data.scalar.style\n"}},{"id":"sequence_style:SequenceStyle-instance-method","html_id":"sequence_style:SequenceStyle-instance-method","name":"sequence_style","doc":"Returns the sequence style, assuming the pull parser is located\nat a sequence begin event. Raises otherwise.","summary":"<p>Returns the sequence style, assuming the pull parser is located at a sequence begin event.</p>","abstract":false,"args":[],"args_string":" : SequenceStyle","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L91","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L91","def":{"name":"sequence_style","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"SequenceStyle","visibility":"Public","body":"expect_kind(EventKind::SEQUENCE_START)\n@event.data.sequence_start.style\n"}},{"id":"skip-instance-method","html_id":"skip-instance-method","name":"skip","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L223","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L223","def":{"name":"skip","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"case kind\nwhen .scalar?\n  read_next\nwhen .alias?\n  read_next\nwhen .sequence_start?\n  read_next\n  while !kind.sequence_end?\n    skip\n  end\n  read_next\nwhen .mapping_start?\n  read_next\n  while !kind.mapping_end?\n    skip\n    skip\n  end\n  read_next\nend"}},{"id":"start_column-instance-method","html_id":"start_column-instance-method","name":"start_column","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L255","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L255","def":{"name":"start_column","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@event.start_mark.column + 1"}},{"id":"start_line-instance-method","html_id":"start_line-instance-method","name":"start_line","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L251","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L251","def":{"name":"start_line","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@event.start_mark.line + 1"}},{"id":"tag:String?-instance-method","html_id":"tag:String?-instance-method","name":"tag","doc":"Returns the tag associated to the current event, or `nil`\nif there's no tag.","summary":"<p>Returns the tag associated to the current event, or <code>nil</code> if there's no tag.</p>","abstract":false,"args":[],"args_string":" : String?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L51","def":{"name":"tag","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String | ::Nil","visibility":"Public","body":"case kind\nwhen .mapping_start?\n  ptr = @event.data.mapping_start.tag\nwhen .sequence_start?\n  ptr = @event.data.sequence_start.tag\nwhen .scalar?\n  ptr = @event.data.scalar.tag\nend\nptr ? String.new(ptr) : nil\n"}},{"id":"value:String-instance-method","html_id":"value:String-instance-method","name":"value","doc":"Returns the scalar value, assuming the pull parser\nis located at a scalar. Raises otherwise.","summary":"<p>Returns the scalar value, assuming the pull parser is located at a scalar.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/pull_parser.cr#L65","def":{"name":"value","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"String","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\nptr = @event.data.scalar.value\nptr ? String.new(ptr, @event.data.scalar.length) : \"\"\n"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/ScalarStyle","path":"YAML/ScalarStyle.html","kind":"enum","full_name":"YAML::ScalarStyle","name":"ScalarStyle","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/enums.cr","line_number":16,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ANY","name":"ANY","value":"0","doc":null,"summary":null},{"id":"PLAIN","name":"PLAIN","value":"1","doc":null,"summary":null},{"id":"SINGLE_QUOTED","name":"SINGLE_QUOTED","value":"2","doc":null,"summary":null},{"id":"DOUBLE_QUOTED","name":"DOUBLE_QUOTED","value":"3","doc":null,"summary":null},{"id":"LITERAL","name":"LITERAL","value":"4","doc":null,"summary":null},{"id":"FOLDED","name":"FOLDED","value":"5","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"any?-instance-method","html_id":"any?-instance-method","name":"any?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L17","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ANY"}},{"id":"double_quoted?-instance-method","html_id":"double_quoted?-instance-method","name":"double_quoted?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L20","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L20","def":{"name":"double_quoted?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DOUBLE_QUOTED"}},{"id":"folded?-instance-method","html_id":"folded?-instance-method","name":"folded?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L22","def":{"name":"folded?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FOLDED"}},{"id":"literal?-instance-method","html_id":"literal?-instance-method","name":"literal?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L21","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L21","def":{"name":"literal?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == LITERAL"}},{"id":"plain?-instance-method","html_id":"plain?-instance-method","name":"plain?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L18","def":{"name":"plain?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == PLAIN"}},{"id":"single_quoted?-instance-method","html_id":"single_quoted?-instance-method","name":"single_quoted?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L19","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L19","def":{"name":"single_quoted?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == SINGLE_QUOTED"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Schema","path":"YAML/Schema.html","kind":"module","full_name":"YAML::Schema","name":"Schema","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/schema/core.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/YAML/Schema/Core","path":"YAML/Schema/Core.html","kind":"module","full_name":"YAML::Schema::Core","name":"Core","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/schema/core.cr","line_number":3,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Schema","kind":"module","full_name":"YAML::Schema","name":"Schema"},"doc":"Provides utility methods for the YAML 1.1 core schema\nwith the additional independent types specified in http://yaml.org/type/","summary":"<p>Provides utility methods for the YAML 1.1 core schema with the additional independent types specified in http://yaml.org/type/</p>","class_methods":[{"id":"each(node:YAML::Nodes::Mapping,&block)-class-method","html_id":"each(node:YAML::Nodes::Mapping,&amp;block)-class-method","name":"each","doc":"Invokes the block for each of the given *node*s keys and\nvalues, resolving merge keys (<<) when found (keys and\nvalues of the resolved merge mappings are yielded,\nrecursively).","summary":"<p>Invokes the block for each of the given <em>node</em>s keys and values, resolving merge keys (&lt;&lt;) when found (keys and values of the resolved merge mappings are yielded, recursively).</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Mapping"}],"args_string":"(node : YAML::Nodes::Mapping, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L139","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L139","def":{"name":"each","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Mapping"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"stack = [{node, 0}]\nvisited = Set(YAML::Nodes::Mapping).new\nwhile !stack.empty?\n  mapping, index = stack.pop\n  visited << mapping\n  while index < mapping.nodes.size\n    key = mapping.nodes[index]\n    index = index + 1\n    value = mapping.nodes[index]\n    index = index + 1\n    if ((key.is_a?(YAML::Nodes::Scalar) && (key.value == \"<<\")) && (key.tag != \"tag:yaml.org,2002:str\")) && (solve_merge(stack, mapping, index, value, visited))\n      break\n    else\n      yield {key, value}\n    end\n  end\nend\n"}},{"id":"parse(data:String|IO)-class-method","html_id":"parse(data:String|IO)-class-method","name":"parse","doc":"Deserializes a YAML document.\n\nSame as `YAML.parse`.","summary":"<p>Deserializes a YAML document.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L7","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L7","def":{"name":"parse","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Parser.new(data, &.parse)"}},{"id":"parse_all(data:String|IO)-class-method","html_id":"parse_all(data:String|IO)-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents.\n\nSame as `YAML.parse_all`.","summary":"<p>Deserializes multiple YAML documents.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L14","def":{"name":"parse_all","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"Parser.new(data, &.parse_all)"}},{"id":"parse_null_or(node:YAML::Nodes::Node,&block)-class-method","html_id":"parse_null_or(node:YAML::Nodes::Node,&amp;block)-class-method","name":"parse_null_or","doc":"If `node` parses to a null value, returns `nil`, otherwise\ninvokes the given block.","summary":"<p>If <code>node</code> parses to a null value, returns <code>nil</code>, otherwise invokes the given block.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(node : YAML::Nodes::Node, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L127","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L127","def":{"name":"parse_null_or","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Node"}],"double_splat":null,"splat_index":null,"yields":0,"block_arg":null,"return_type":"","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar) && (parse_null?(node.value))\n  nil\nelse\n  yield\nend"}},{"id":"parse_scalar(pull_parser:YAML::PullParser):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","html_id":"parse_scalar(pull_parser:YAML::PullParser):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Assuming the *pull_parser* is positioned in a scalar,\nparses it according to the core schema, taking the\nscalar's style and tag into account, then advances\nthe pull parser.","summary":"<p>Assuming the <em>pull_parser</em> is positioned in a scalar, parses it according to the core schema, taking the scalar's style and tag into account, then advances the pull parser.</p>","abstract":false,"args":[{"name":"pull_parser","doc":null,"default_value":"","external_name":"pull_parser","restriction":"YAML::PullParser"}],"args_string":"(pull_parser : YAML::PullParser) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L22","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L22","def":{"name":"parse_scalar","args":[{"name":"pull_parser","doc":null,"default_value":"","external_name":"pull_parser","restriction":"YAML::PullParser"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"string = pull_parser.value\nprocess_scalar_tag(pull_parser, pull_parser.tag) do |value|\n  return value\nend\nif pull_parser.scalar_style.plain?\nelse\n  return string\nend\nparse_scalar(string)\n"}},{"id":"parse_scalar(string:String):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","html_id":"parse_scalar(string:String):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Parses a string according to the core schema, assuming\nthe string had a plain style.\n\n```\nYAML::Schema::Core.parse_scalar(\"hello\") # => \"hello\"\nYAML::Schema::Core.parse_scalar(\"1.2\")   # => 1.2\nYAML::Schema::Core.parse_scalar(\"false\") # => false\n```","summary":"<p>Parses a string according to the core schema, assuming the string had a plain style.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L63","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L63","def":{"name":"parse_scalar","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"if parse_null?(string)\n  return nil\nend\nvalue = parse_bool?(string)\nif value.nil?\nelse\n  return value\nend\nvalue = parse_float_infinity_and_nan?(string)\nif value\n  return value\nend\ncase string\nwhen .starts_with?(\"0x\"), .starts_with?(\"+0x\"), .starts_with?(\"-0x\")\n  value = string.to_i64?(base: 16, prefix: true)\n  return value || string\nwhen .starts_with?(\"0.\"), .starts_with?('.')\n  value = parse_float?(string)\n  return value || string\nwhen .starts_with?('0')\n  if string.size == 1\n    return 0_i64\n  end\n  value = string.to_i64?(base: 8, prefix: true)\n  return value || string\nwhen .starts_with?('-'), .starts_with?('+')\n  value = parse_number?(string)\n  return value || string\nend\nif string[0].ascii_number?\n  value = parse_number?(string)\n  if value\n    return value\n  end\n  value = parse_time?(string)\n  if value\n    return value\n  end\nend\nstring\n"}},{"id":"parse_scalar(node:YAML::Nodes::Scalar):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","html_id":"parse_scalar(node:YAML::Nodes::Scalar):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Parses a scalar value from the given *node*.","summary":"<p>Parses a scalar value from the given <em>node</em>.</p>","abstract":false,"args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Scalar"}],"args_string":"(node : YAML::Nodes::Scalar) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L39","def":{"name":"parse_scalar","args":[{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"YAML::Nodes::Scalar"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"string = node.value\nprocess_scalar_tag(node) do |value|\n  return value\nend\nif node.style.plain?\nelse\n  return string\nend\nparse_scalar(string)\n"}},{"id":"reserved_string?(string):Bool-class-method","html_id":"reserved_string?(string):Bool-class-method","name":"reserved_string?","doc":"Returns whether a string is reserved and must non be output\nwith a plain style, according to the core schema.\n\n```\nYAML::Schema::Core.reserved_string?(\"hello\") # => false\nYAML::Schema::Core.reserved_string?(\"1.2\")   # => true\nYAML::Schema::Core.reserved_string?(\"false\") # => true\n```","summary":"<p>Returns whether a string is reserved and must non be output with a plain style, according to the core schema.</p>","abstract":false,"args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"args_string":"(string) : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L115","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/core.cr#L115","def":{"name":"reserved_string?","args":[{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Bool","visibility":"Public","body":"!parse_scalar(string).is_a?(String)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Schema/FailSafe","path":"YAML/Schema/FailSafe.html","kind":"module","full_name":"YAML::Schema::FailSafe","name":"FailSafe","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/schema/fail_safe.cr","line_number":4,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/fail_safe.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Schema","kind":"module","full_name":"YAML::Schema","name":"Schema"},"doc":"Provides a way to parse a YAML document according to the\nfail-safe schema, as specified in http://www.yaml.org/spec/1.2/spec.html#id2802346,\nwhere all scalar values are considered strings.","summary":"<p>Provides a way to parse a YAML document according to the fail-safe schema, as specified in http://www.yaml.org/spec/1.2/spec.html#id2802346, where all scalar values are considered strings.</p>","class_methods":[{"id":"parse(data:String|IO):Any-class-method","html_id":"parse(data:String|IO):Any-class-method","name":"parse","doc":"Deserializes a YAML document.","summary":"<p>Deserializes a YAML document.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/fail_safe.cr#L6","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/fail_safe.cr#L6","def":{"name":"parse","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Any","visibility":"Public","body":"Parser.new(data, &.parse)"}},{"id":"parse_all(data:String|IO):Any-class-method","html_id":"parse_all(data:String|IO):Any-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents.","summary":"<p>Deserializes multiple YAML documents.</p>","abstract":false,"args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Any","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/fail_safe.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/schema/fail_safe.cr#L11","def":{"name":"parse_all","args":[{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"String | IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Any","visibility":"Public","body":"Parser.new(data, &.parse_all)"}}],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/YAML/SequenceStyle","path":"YAML/SequenceStyle.html","kind":"enum","full_name":"YAML::SequenceStyle","name":"SequenceStyle","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"yaml/enums.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"ANY","name":"ANY","value":"0","doc":null,"summary":null},{"id":"BLOCK","name":"BLOCK","value":"1","doc":null,"summary":null},{"id":"FLOW","name":"FLOW","value":"2","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"any?-instance-method","html_id":"any?-instance-method","name":"any?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L26","def":{"name":"any?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == ANY"}},{"id":"block?-instance-method","html_id":"block?-instance-method","name":"block?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L27","def":{"name":"block?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == BLOCK"}},{"id":"flow?-instance-method","html_id":"flow?-instance-method","name":"flow?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L28","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/enums.cr#L28","def":{"name":"flow?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == FLOW"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable","path":"YAML/Serializable.html","kind":"module","full_name":"YAML::Serializable","name":"Serializable","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/serialization.cr","line_number":109,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"The `YAML::Serializable` module automatically generates methods for YAML serialization when included.\n\n### Example\n\n```\nrequire \"yaml\"\n\nclass Location\n  include YAML::Serializable\n\n  @[YAML::Field(key: \"lat\")]\n  property latitude : Float64\n\n  @[YAML::Field(key: \"lng\")]\n  property longitude : Float64\nend\n\nclass House\n  include YAML::Serializable\n  property address : String\n  property location : Location?\nend\n\nhouse = House.from_yaml(%({\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}))\nhouse.address  # => \"Crystal Road 1234\"\nhouse.location # => #<Location:0x10cd93d80 @latitude=12.3, @longitude=34.5>\nhouse.to_yaml  # => \"---\\naddress: Crystal Road 1234\\nlocation:\\n  lat: 12.3\\n  lng: 34.5\\n\"\n\nhouses = Array(House).from_yaml(\"---\\n- address: Crystal Road 1234\\n  location:\\n    lat: 12.3\\n    lng: 34.5\\n\")\nhouses.size    # => 1\nhouses.to_yaml # => \"---\\n- address: Crystal Road 1234\\n  location:\\n    lat: 12.3\\n    lng: 34.5\\n\"\n```\n\n### Usage\n\nIncluding `YAML::Serializable` will create `#to_yaml` and `self.from_yaml` methods on the current class,\nand a constructor which takes a `YAML::PullParser`. By default, these methods serialize into a yaml\nobject containing the value of every instance variable, the keys being the instance variable name.\nMost primitives and collections supported as instance variable values (string, integer, array, hash, etc.),\nalong with objects which define to_yaml and a constructor taking a `YAML::PullParser`.\nUnion types are also supported, including unions with nil. If multiple types in a union parse correctly,\nit is undefined which one will be chosen.\n\nTo change how individual instance variables are parsed and serialized, the annotation `YAML::Field`\ncan be placed on the instance variable. Annotating property, getter and setter macros is also allowed.\n```\nclass A\n  include YAML::Serializable\n\n  @[YAML::Field(key: \"my_key\", emit_null: true)]\n  getter a : Int32?\nend\n```\n\n`YAML::Field` properties:\n* **ignore**: if `true` skip this field in seriazation and deserialization (by default false)\n* **key**: the value of the key in the yaml object (by default the name of the instance variable)\n* **converter**: specify an alternate type for parsing and generation. The converter must define `from_yaml(YAML::PullParser)` and `to_yaml(value, YAML::Builder)` as class methods. Examples of converters are `Time::Format` and `Time::EpochConverter` for `Time`.\n* **presense**: if `true`, a `@{{key}}_present` instance variable will be generated when the key was present (even if it has a `null` value), `false` by default\n* **emit_null**: if `true`, emits a `null` value for nilable property (by default nulls are not emitted)\n\nDeserialization also respects default values of variables:\n```\nstruct A\n  include YAML::Serializable\n  @a : Int32\n  @b : Float64 = 1.0\nend\n\nA.from_yaml(\"---\\na: 1\\n\") # => A(@a=1, @b=1.0)\n```\n\n### Extensions: `YAML::Serializable::Strict` and `YAML::Serializable::Unmapped`.\n\nIf the `YAML::Serializable::Strict` module is included, unknown properties in the YAML\ndocument will raise a parse exception. By default the unknown properties\nare silently ignored.\nIf the `YAML::Serializable::Unmapped` module is included, unknown properties in the YAML\ndocument will be stored in a `Hash(String, YAML::Any)`. On serialization, any keys inside yaml_unmapped\nwill be serialized appended to the current yaml object.\n```\nstruct A\n  include YAML::Serializable\n  include YAML::Serializable::Unmapped\n  @a : Int32\nend\n\na = A.from_yaml(\"---\\na: 1\\nb: 2\\n\") # => A(@yaml_unmapped={\"b\" => 2_i64}, @a=1)\na.to_yaml                            # => \"---\\na: 1\\nb: 2\\n\"\n```\n\n\n### Class annotation `YAML::Serializable::Options`\n\nsupported properties:\n* **emit_nulls**: if `true`, emits a `null` value for all nilable properties (by default nulls are not emitted)\n\n```\n@[YAML::Serializable::Options(emit_nulls: true)]\nclass A\n  include YAML::Serializable\n  @a : Int32?\nend\n```","summary":"<p>The <code><a href=\"../YAML/Serializable.html\">YAML::Serializable</a></code> module automatically generates methods for YAML serialization when included.</p>","class_methods":[],"constructors":[{"id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,dummy:Nil)-class-method","html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,dummy:Nil)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::YAML::Nodes::Node"},{"name":"dummy","doc":null,"default_value":"","external_name":"dummy","restriction":"Nil"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, dummy : Nil)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L141","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L141","def":{"name":"new","args":[{"name":"ctx","doc":null,"default_value":"","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","doc":null,"default_value":"","external_name":"node","restriction":"::YAML::Nodes::Node"},{"name":"dummy","doc":null,"default_value":"","external_name":"dummy","restriction":"Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(ctx, node, dummy)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"::YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L248","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L248","def":{"name":"to_yaml","args":[{"name":"yaml","doc":null,"default_value":"","external_name":"yaml","restriction":"::YAML::Nodes::Builder"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"{% if true %}\n        {% options = @type.annotation(::YAML::Serializable::Options) %}\n        {% emit_nulls = options && options[:emit_nulls] %}\n\n        {% properties = {} of Nil => Nil %}\n        {% for ivar in @type.instance_vars %}\n          {% ann = ivar.annotation(::YAML::Field) %}\n          {% if ann && ann[:ignore] %}{% else %}\n            {% properties[ivar.id] = {type: ivar.type, key: ((ann && ann[:key]) || ivar).id.stringify, converter: ann && ann[:converter], emit_null: (ann && (ann[:emit_null] != nil) ? ann[:emit_null] : emit_nulls)} %}\n          {% end %}\n        {% end %}\n\n        yaml.mapping(reference: self) do\n          {% for name, value in properties %}\n            _{{ name }} = @{{ name }}\n\n            {% if value[:emit_null] %}{% else %}\n              unless _{{ name }}.nil?\n            {% end %}\n\n              {{ value[:key] }}.to_yaml(yaml)\n\n              {% if value[:converter] %}\n                if _{{ name }}\n                  {{ value[:converter] }}.to_yaml(_{{ name }}, yaml)\n                else\n                  nil.to_yaml(yaml)\n                end\n              {% else %}\n                _{{ name }}.to_yaml(yaml)\n              {% end %}\n\n            {% if value[:emit_null] %}{% else %}\n              end\n            {% end %}\n          {% end %}\n          on_to_yaml(yaml)\n        end\n      {% end %}"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable/Options","path":"YAML/Serializable/Options.html","kind":"annotation","full_name":"YAML::Serializable::Options","name":"Options","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/serialization.cr","line_number":110,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable/Strict","path":"YAML/Serializable/Strict.html","kind":"module","full_name":"YAML::Serializable::Strict","name":"Strict","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/serialization.cr","line_number":297,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable/Unmapped","path":"YAML/Serializable/Unmapped.html","kind":"module","full_name":"YAML::Serializable::Unmapped","name":"Unmapped","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"yaml/serialization.cr","line_number":303,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[{"id":"yaml_unmapped-instance-method","html_id":"yaml_unmapped-instance-method","name":"yaml_unmapped","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L305","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L305","def":{"name":"yaml_unmapped","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@yaml_unmapped"}},{"id":"yaml_unmapped=(yaml_unmapped)-instance-method","html_id":"yaml_unmapped=(yaml_unmapped)-instance-method","name":"yaml_unmapped=","doc":null,"summary":null,"abstract":false,"args":[{"name":"yaml_unmapped","doc":null,"default_value":"","external_name":"yaml_unmapped","restriction":""}],"args_string":"(yaml_unmapped)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L305","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/yaml/serialization.cr#L305","def":{"name":"yaml_unmapped=","args":[{"name":"yaml_unmapped","doc":null,"default_value":"","external_name":"yaml_unmapped","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@yaml_unmapped = yaml_unmapped"}}],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/Zip","path":"Zip.html","kind":"module","full_name":"Zip","name":"Zip","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"zip/checksum_reader.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/checksum_reader.cr"},{"filename":"zip/checksum_writer.cr","line_number":1,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/checksum_writer.cr"},{"filename":"zip/zip.cr","line_number":30,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/zip.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"CENTRAL_DIRECTORY_HEADER_SIGNATURE","name":"CENTRAL_DIRECTORY_HEADER_SIGNATURE","value":"33639248","doc":null,"summary":null},{"id":"END_OF_CENTRAL_DIRECTORY_HEADER_SIGNATURE","name":"END_OF_CENTRAL_DIRECTORY_HEADER_SIGNATURE","value":"101010256","doc":null,"summary":null},{"id":"VERSION","name":"VERSION","value":"20_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The Zip module contains readers and writers of the zip\nfile format, described at [PKWARE's site](https://pkware.cachefly.net/webdocs/APPNOTE/APPNOTE-6.3.3.TXT).\n\n### Reading zip files\n\nTwo types are provided to read from zip files:\n* `Zip::File`: can read zip entries from a `File` or from an `IO::Memory`\nand provides random read access to its entries.\n* `Zip::Reader`: can only read zip entries sequentially from any `IO.\n\n`Zip::File` is the preferred method to read zip files if you\ncan provide a `File`, because it's a bit more flexible and provides\nmore complete information for zip entries (such as comments).\n\nWhen reading zip files, CRC32 checksum values are automatically\nverified when finishing reading an entry, and `Zip::Error` will\nbe raised if the computed CRC32 checksum does not match.\n\n### Writer zip files\n\nUse `Zip::Writer`, which writes zip entries sequentially to\nany `IO`.\n\nNOTE: only compression methods 0 (STORED) and 8 (DEFLATED) are\nsupported. Additionally, ZIP64 is not yet supported.","summary":"<p>The Zip module contains readers and writers of the zip file format, described at <a href=\"https://pkware.cachefly.net/webdocs/APPNOTE/APPNOTE-6.3.3.TXT\" target=\"_blank\">PKWARE's site</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Zip/CompressionMethod","path":"Zip/CompressionMethod.html","kind":"enum","full_name":"Zip::CompressionMethod","name":"CompressionMethod","abstract":false,"superclass":null,"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"github.com/crystal-lang/crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"github.com/crystal-lang/crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/compression_method.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/compression_method.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":true,"alias":false,"aliased":"","const":false,"constants":[{"id":"STORED","name":"STORED","value":"0_u16","doc":null,"summary":null},{"id":"DEFLATED","name":"DEFLATED","value":"8_u16","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":"Supported compression methods in the current implementation.","summary":"<p>Supported compression methods in the current implementation.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"deflated?-instance-method","html_id":"deflated?-instance-method","name":"deflated?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/compression_method.cr#L4","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/compression_method.cr#L4","def":{"name":"deflated?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == DEFLATED"}},{"id":"stored?-instance-method","html_id":"stored?-instance-method","name":"stored?","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/compression_method.cr#L3","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/compression_method.cr#L3","def":{"name":"stored?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"self == STORED"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Zip/Error","path":"Zip/Error.html","kind":"class","full_name":"Zip::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/zip.cr","line_number":35,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/zip.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Zip/File","path":"Zip/File.html","kind":"class","full_name":"Zip::File","name":"File","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/file.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":"Provides random read access to zip file entries stores inside\na `File` or an `IO::Memory`.\n\n### Example\n\n```\nZip::File.open(\"./file.zip\") do |file|\n  # Iterate through all entries printing their filename and contents\n  file.entries.each do |entry|\n    p entry.filename\n    entry.open do |io|\n      p io.gets_to_end\n    end\n  end\n\n  # Random access to entries by filename is also provided\n  entry = file[\"some_file.txt\"]\n  entry.open do |io|\n    p io.gets_to_end\n  end\nend\n```","summary":"<p>Provides random read access to zip file entries stores inside a <code><a href=\"../Zip/File.html\">File</a></code> or an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code>.</p>","class_methods":[{"id":"open(io:IO,sync_close=false,&block)-class-method","html_id":"open(io:IO,sync_close=false,&amp;block)-class-method","name":"open","doc":"Opens a `Zip::File` for reading from the given *io*, yields\nit to the given block, and closes it at the end.","summary":"<p>Opens a <code><a href=\"../Zip/File.html\">Zip::File</a></code> for reading from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L51","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L51","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"zip = new(io, sync_close)\nbegin\n  yield zip\nensure\n  zip.close\nend\n"}},{"id":"open(filename:String,&block)-class-method","html_id":"open(filename:String,&amp;block)-class-method","name":"open","doc":"Opens a `Zip::File` for reading from the given *filename*, yields\nit to the given block, and closes it at the end.","summary":"<p>Opens a <code><a href=\"../Zip/File.html\">Zip::File</a></code> for reading from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L58","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L58","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"zip = new(filename)\nbegin\n  yield zip\nensure\n  zip.close\nend\n"}}],"constructors":[{"id":"new(io:IO,sync_close=false)-class-method","html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Opens a `Zip::File` for reading from the given *io*.","summary":"<p>Opens a <code><a href=\"../Zip/File.html\">Zip::File</a></code> for reading from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L36","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String)-class-method","html_id":"new(filename:String)-class-method","name":"new","doc":"Opens a `Zip::File` for reading from the given *filename*.","summary":"<p>Opens a <code><a href=\"../Zip/File.html\">Zip::File</a></code> for reading from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L45","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"id":"[](filename:String):Entry-instance-method","html_id":"[](filename:String):Entry-instance-method","name":"[]","doc":"Returns the entry that has the given filename, or\nraises `KeyError` if no such entry exists.","summary":"<p>Returns the entry that has the given filename, or raises <code><a href=\"../KeyError.html\">KeyError</a></code> if no such entry exists.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String) : Entry","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L65","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L65","def":{"name":"[]","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Entry","visibility":"Public","body":"self[filename]? || (raise(KeyError.new(\"Missing zip entry: #{filename}\")))"}},{"id":"[]?(filename:String):Entry?-instance-method","html_id":"[]?(filename:String):Entry?-instance-method","name":"[]?","doc":"Returns the entry that has the given filename, or\n`nil` if no such entry exists.","summary":"<p>Returns the entry that has the given filename, or <code>nil</code> if no such entry exists.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String) : Entry?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L71","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L71","def":{"name":"[]?","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Entry | ::Nil","visibility":"Public","body":"@entries_by_filename[filename]?"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this zip file.","summary":"<p>Closes this zip file.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L76","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L76","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this zip file is closed.","summary":"<p>Returns <code>true</code> if this zip file is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L30","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"comment:String-instance-method","html_id":"comment:String-instance-method","name":"comment","doc":"Returns the zip file comment.","summary":"<p>Returns the zip file comment.</p>","abstract":false,"args":[],"args_string":" : String","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L33","def":{"name":"comment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@comment"}},{"id":"entries:Array(Entry)-instance-method","html_id":"entries:Array(Entry)-instance-method","name":"entries","doc":"Returns all entries inside this zip file.","summary":"<p>Returns all entries inside this zip file.</p>","abstract":false,"args":[],"args_string":" : Array(Entry)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L27","def":{"name":"entries","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Array(Entry)","visibility":"Public","body":"@entries"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Zip/File/Entry","path":"Zip/File/Entry.html","kind":"class","full_name":"Zip::File::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/file.cr","line_number":157,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip/File","kind":"class","full_name":"Zip::File","name":"File"},"doc":"An entry inside a `Zip::File`.\n\nUse the `open` method to read from it.","summary":"<p>An entry inside a <code><a href=\"../../Zip/File.html\">Zip::File</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"open(&block)-instance-method","html_id":"open(&amp;block)-instance-method","name":"open","doc":"Yields an `IO` to read this entry's contents.\nMultiple entries can be opened and read concurrently.","summary":"<p>Yields an <code><a href=\"../../IO.html\">IO</a></code> to read this entry's contents.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L167","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file.cr#L167","def":{"name":"open","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"@io.read_at(data_offset.to_i32, compressed_size.to_i32) do |io|\n  io = decompressor_for(io, is_sized: true)\n  checksum_reader = ChecksumReader.new(io, filename, verify: crc32)\n  yield checksum_reader\nend"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","path":"Zip/FileInfo.html","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"zip/file_info.cr","line_number":2,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"DATA_DESCRIPTOR_SIGNATURE","name":"DATA_DESCRIPTOR_SIGNATURE","value":"134695760","doc":null,"summary":null},{"id":"DEFLATE_END_SIGNATURE","name":"DEFLATE_END_SIGNATURE","value":"Bytes[80, 75, 7, 8, read_only: true]","doc":null,"summary":null},{"id":"SIGNATURE","name":"SIGNATURE","value":"67324752","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[{"html_id":"github.com/crystal-lang/crystal/Zip/File/Entry","kind":"class","full_name":"Zip::File::Entry","name":"Entry"},{"html_id":"github.com/crystal-lang/crystal/Zip/Reader/Entry","kind":"class","full_name":"Zip::Reader::Entry","name":"Entry"},{"html_id":"github.com/crystal-lang/crystal/Zip/Writer/Entry","kind":"class","full_name":"Zip::Writer::Entry","name":"Entry"}],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":"Base type for file information related to zip entries.","summary":"<p>Base type for file information related to zip entries.</p>","class_methods":[],"constructors":[{"id":"new(filename:String,time=Time.now,comment=&quot;&quot;,extra=Bytes.empty)-class-method","html_id":"new(filename:String,time=Time.now,comment=&amp;quot;&amp;quot;,extra=Bytes.empty)-class-method","name":"new","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":""},{"name":"comment","doc":null,"default_value":"\"\"","external_name":"comment","restriction":""},{"name":"extra","doc":null,"default_value":"Bytes.empty","external_name":"extra","restriction":""}],"args_string":"(filename : String, time = <span class=\"t\">Time</span>.now, comment = <span class=\"s\">&quot;&quot;</span>, extra = <span class=\"t\">Bytes</span>.empty)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L68","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L68","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"time","doc":null,"default_value":"Time.now","external_name":"time","restriction":""},{"name":"comment","doc":null,"default_value":"\"\"","external_name":"comment","restriction":""},{"name":"extra","doc":null,"default_value":"Bytes.empty","external_name":"extra","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(filename, time, comment, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"comment-instance-method","html_id":"comment-instance-method","name":"comment","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L17","def":{"name":"comment","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@comment"}},{"id":"comment=(comment)-instance-method","html_id":"comment=(comment)-instance-method","name":"comment=","doc":null,"summary":null,"abstract":false,"args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":""}],"args_string":"(comment)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L17","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L17","def":{"name":"comment=","args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@comment = comment"}},{"id":"compressed_size-instance-method","html_id":"compressed_size-instance-method","name":"compressed_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L13","def":{"name":"compressed_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@compressed_size"}},{"id":"compressed_size=(compressed_size)-instance-method","html_id":"compressed_size=(compressed_size)-instance-method","name":"compressed_size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"compressed_size","doc":null,"default_value":"","external_name":"compressed_size","restriction":""}],"args_string":"(compressed_size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L13","def":{"name":"compressed_size=","args":[{"name":"compressed_size","doc":null,"default_value":"","external_name":"compressed_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@compressed_size = compressed_size"}},{"id":"compression_method-instance-method","html_id":"compression_method-instance-method","name":"compression_method","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L10","def":{"name":"compression_method","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@compression_method"}},{"id":"compression_method=(compression_method)-instance-method","html_id":"compression_method=(compression_method)-instance-method","name":"compression_method=","doc":null,"summary":null,"abstract":false,"args":[{"name":"compression_method","doc":null,"default_value":"","external_name":"compression_method","restriction":""}],"args_string":"(compression_method)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L10","def":{"name":"compression_method=","args":[{"name":"compression_method","doc":null,"default_value":"","external_name":"compression_method","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@compression_method = compression_method"}},{"id":"crc32-instance-method","html_id":"crc32-instance-method","name":"crc32","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L12","def":{"name":"crc32","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@crc32"}},{"id":"crc32=(crc32)-instance-method","html_id":"crc32=(crc32)-instance-method","name":"crc32=","doc":null,"summary":null,"abstract":false,"args":[{"name":"crc32","doc":null,"default_value":"","external_name":"crc32","restriction":""}],"args_string":"(crc32)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L12","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L12","def":{"name":"crc32=","args":[{"name":"crc32","doc":null,"default_value":"","external_name":"crc32","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@crc32 = crc32"}},{"id":"dir?-instance-method","html_id":"dir?-instance-method","name":"dir?","doc":"Returns `true` if this entry is a directory.","summary":"<p>Returns <code>true</code> if this entry is a directory.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L72","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L72","def":{"name":"dir?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"filename.ends_with?('/')"}},{"id":"extra-instance-method","html_id":"extra-instance-method","name":"extra","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L16","def":{"name":"extra","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra"}},{"id":"extra=(extra)-instance-method","html_id":"extra=(extra)-instance-method","name":"extra=","doc":null,"summary":null,"abstract":false,"args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":""}],"args_string":"(extra)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L16","def":{"name":"extra=","args":[{"name":"extra","doc":null,"default_value":"","external_name":"extra","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@extra = extra"}},{"id":"file?-instance-method","html_id":"file?-instance-method","name":"file?","doc":"Returns `true` if this entry is a file.","summary":"<p>Returns <code>true</code> if this entry is a file.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L77","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L77","def":{"name":"file?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"!dir?"}},{"id":"filename-instance-method","html_id":"filename-instance-method","name":"filename","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L15","def":{"name":"filename","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@filename"}},{"id":"filename=(filename)-instance-method","html_id":"filename=(filename)-instance-method","name":"filename=","doc":null,"summary":null,"abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"args_string":"(filename)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L15","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L15","def":{"name":"filename=","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@filename = filename"}},{"id":"general_purpose_bit_flag-instance-method","html_id":"general_purpose_bit_flag-instance-method","name":"general_purpose_bit_flag","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L9","def":{"name":"general_purpose_bit_flag","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@general_purpose_bit_flag"}},{"id":"general_purpose_bit_flag=(general_purpose_bit_flag)-instance-method","html_id":"general_purpose_bit_flag=(general_purpose_bit_flag)-instance-method","name":"general_purpose_bit_flag=","doc":null,"summary":null,"abstract":false,"args":[{"name":"general_purpose_bit_flag","doc":null,"default_value":"","external_name":"general_purpose_bit_flag","restriction":""}],"args_string":"(general_purpose_bit_flag)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L9","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L9","def":{"name":"general_purpose_bit_flag=","args":[{"name":"general_purpose_bit_flag","doc":null,"default_value":"","external_name":"general_purpose_bit_flag","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@general_purpose_bit_flag = general_purpose_bit_flag"}},{"id":"offset-instance-method","html_id":"offset-instance-method","name":"offset","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L18","def":{"name":"offset","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset"}},{"id":"offset=(offset)-instance-method","html_id":"offset=(offset)-instance-method","name":"offset=","doc":null,"summary":null,"abstract":false,"args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"args_string":"(offset)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L18","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L18","def":{"name":"offset=","args":[{"name":"offset","doc":null,"default_value":"","external_name":"offset","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@offset = offset"}},{"id":"time:Time-instance-method","html_id":"time:Time-instance-method","name":"time","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : Time","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L11","def":{"name":"time","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Time","visibility":"Public","body":"@time"}},{"id":"time=(time:Time)-instance-method","html_id":"time=(time:Time)-instance-method","name":"time=","doc":null,"summary":null,"abstract":false,"args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L11","def":{"name":"time=","args":[{"name":"time","doc":null,"default_value":"","external_name":"time","restriction":"Time"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@time = time"}},{"id":"uncompressed_size-instance-method","html_id":"uncompressed_size-instance-method","name":"uncompressed_size","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L14","def":{"name":"uncompressed_size","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@uncompressed_size"}},{"id":"uncompressed_size=(uncompressed_size)-instance-method","html_id":"uncompressed_size=(uncompressed_size)-instance-method","name":"uncompressed_size=","doc":null,"summary":null,"abstract":false,"args":[{"name":"uncompressed_size","doc":null,"default_value":"","external_name":"uncompressed_size","restriction":""}],"args_string":"(uncompressed_size)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L14","def":{"name":"uncompressed_size=","args":[{"name":"uncompressed_size","doc":null,"default_value":"","external_name":"uncompressed_size","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@uncompressed_size = uncompressed_size"}},{"id":"version:UInt16-instance-method","html_id":"version:UInt16-instance-method","name":"version","doc":null,"summary":null,"abstract":false,"args":[],"args_string":" : UInt16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L8","def":{"name":"version","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"UInt16","visibility":"Public","body":"@version"}},{"id":"version=(version:UInt16)-instance-method","html_id":"version=(version:UInt16)-instance-method","name":"version=","doc":null,"summary":null,"abstract":false,"args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"args_string":"(version : UInt16)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/file_info.cr#L8","def":{"name":"version=","args":[{"name":"version","doc":null,"default_value":"","external_name":"version","restriction":"UInt16"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@version = version"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Zip/Reader","path":"Zip/Reader.html","kind":"class","full_name":"Zip::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/reader.cr","line_number":25,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":"Reads zip file entries sequentially from an `IO`.\n\nNOTE: Entries might not have correct values\nfor crc32, compressed_size, uncompressed_size and comment,\nbecause when reading a zip file directly from a stream this\ninformation might be stored later in the zip stream.\nIf you need this information, consider using `Zip::File`.\n\n### Example\n\n```\nFile.open(\"./file.zip\") do |file|\n  Zip::Reader.open(file) do |zip|\n    zip.each_entry do |entry|\n      p entry.filename\n      p entry.file?\n      p entry.dir?\n      p entry.io.gets_to_end\n    end\n  end\nend\n```","summary":"<p>Reads zip file entries sequentially from an <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[{"id":"open(io:IO,sync_close=false,&block)-class-method","html_id":"open(io:IO,sync_close=false,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L45","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L45","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(io, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"id":"open(filename:String,&block)-class-method","html_id":"open(filename:String,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L52","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(filename)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"id":"new(io:IO,sync_close=false)-class-method","html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L33","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L33","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String)-class-method","html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new reader from the given *filename*.","summary":"<p>Creates a new reader from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L39","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L39","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this zip reader.","summary":"<p>Closes this zip reader.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L104","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L104","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L30","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L30","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"each_entry(&block)-instance-method","html_id":"each_entry(&amp;block)-instance-method","name":"each_entry","doc":"Yields each entry in the zip to the given block.","summary":"<p>Yields each entry in the zip to the given block.</p>","abstract":false,"args":[],"args_string":"(&block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L97","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L97","def":{"name":"each_entry","args":[],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"while entry = next_entry\n  yield entry\nend"}},{"id":"next_entry:Entry?-instance-method","html_id":"next_entry:Entry?-instance-method","name":"next_entry","doc":"Reads the next entry in the zip, or `nil` if there\nare no more entries.\n\nAfter reading a next entry, previous entries can no\nlonger be read (their `IO` will be closed.)","summary":"<p>Reads the next entry in the zip, or <code>nil</code> if there are no more entries.</p>","abstract":false,"args":[],"args_string":" : Entry?","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L62","def":{"name":"next_entry","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Entry | ::Nil","visibility":"Public","body":"if @reached_end\n  return nil\nend\nif last_entry = @last_entry\n  last_entry.close\n  skip_data_descriptor(last_entry)\nend\nwhile true\n  signature = read(UInt32)\n  case signature\n  when FileInfo::SIGNATURE\n    break\n  when FileInfo::DATA_DESCRIPTOR_SIGNATURE\n    if last_entry && (!@read_data_descriptor)\n      read_data_descriptor(last_entry)\n      next\n    else\n      raise(Error.new(\"Unexpected data descriptor when reading zip\"))\n    end\n  else\n    @reached_end = true\n    return nil\n  end\nend\n@last_entry = Entry.new(@io)\n"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L27","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L27","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L27","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Zip/Reader/Entry","path":"Zip/Reader/Entry.html","kind":"class","full_name":"Zip::Reader::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/reader.cr","line_number":148,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip/Reader","kind":"class","full_name":"Zip::Reader","name":"Reader"},"doc":"A entry inside a `Zip::Reader`.\n\nUse the `io` method to read from it.","summary":"<p>A entry inside a <code><a href=\"../../Zip/Reader.html\">Zip::Reader</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[{"id":"io:IO-instance-method","html_id":"io:IO-instance-method","name":"io","doc":"Returns an `IO` to the entry's data.","summary":"<p>Returns an <code><a href=\"../../IO.html\">IO</a></code> to the entry's data.</p>","abstract":false,"args":[],"args_string":" : IO","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L159","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/reader.cr#L159","def":{"name":"io","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"IO","visibility":"Public","body":"@io"}}],"macros":[],"types":[]}]},{"html_id":"github.com/crystal-lang/crystal/Zip/Writer","path":"Zip/Writer.html","kind":"class","full_name":"Zip::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/writer.cr","line_number":24,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip","kind":"module","full_name":"Zip","name":"Zip"},"doc":"Writes (streams) zip entries to an `IO`.\n\n### Example\n\n```\nFile.open(\"./file.zip\", \"w\") do |file|\n  Zip::Writer.open(file) do |zip|\n    # Add a file with a String content\n    zip.add \"foo.txt\", \"contents of foo\"\n\n    # Add a file and write data to it through an IO\n    zip.add(\"bar.txt\") do |io|\n      io << \"contents of bar\"\n    end\n\n    # Add a file by referencing a file in the filesystem\n    # (the file is automatically closed after this call)\n    zip.add(\"baz.txt\", File.open(\"./some_file.txt\"))\n  end\nend\n```","summary":"<p>Writes (streams) zip entries to an <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[{"id":"open(io:IO,sync_close=false,&block)-class-method","html_id":"open(io:IO,sync_close=false,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L52","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L52","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(io, sync_close: sync_close)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"id":"open(filename:String,&block)-class-method","html_id":"open(filename:String,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L59","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(filename)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"id":"new(io:IO,sync_close=false)-class-method","html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L35","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L35","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String)-class-method","html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L46","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L46","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename, \"w\"), sync_close: true)"}}],"instance_methods":[{"id":"add(filename:String,&block)-instance-method","html_id":"add(filename:String,&amp;block)-instance-method","name":"add","doc":"Adds an entry that will have the given *filename* and current\ntime (`Time.now`) and yields an `IO` to write that entry's\ncontents.","summary":"<p>Adds an entry that will have the given <em>filename</em> and current time (<code>Time.now</code>) and yields an <code><a href=\"../IO.html\">IO</a></code> to write that entry's contents.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L67","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L67","def":{"name":"add","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"add(Entry.new(filename)) do |io|\n  yield io\nend"}},{"id":"add(entry:Entry,&block)-instance-method","html_id":"add(entry:Entry,&amp;block)-instance-method","name":"add","doc":"Adds an entry and yields `IO` to write that entry's contents.\n\nYou can choose the Entry's compression method before adding it.\n\n* If the STORED compression method is used, its crc32, compressed\nsize and uncompressed size **must** be set and be correct with\nrespect to the data that will be written to the yielded `IO`.\n* If the DEFLATED compression method is used, crc32, compresed\nsize and uncompressed size will be computed from the data\nwritten to the yielded IO.\n\nYou can also set the Entry's time (which is `Time.now` by default)\n and extra data before adding it to the zip stream.","summary":"<p>Adds an entry and yields <code><a href=\"../IO.html\">IO</a></code> to write that entry's contents.</p>","abstract":false,"args":[{"name":"entry","doc":null,"default_value":"","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L86","def":{"name":"add","args":[{"name":"entry","doc":null,"default_value":"","external_name":"entry","restriction":"Entry"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"entry.general_purpose_bit_flag = entry.general_purpose_bit_flag | (1 << 3)\nentry.general_purpose_bit_flag = entry.general_purpose_bit_flag | (1 << 11)\nentry.offset = @written\n@written = @written + (entry.to_io(@io))\ncase entry.compression_method\nwhen .stored?\n  if entry.compressed_size != entry.uncompressed_size\n    raise(Error.new(\"Entry compressed size (#{entry.compressed_size}) is not equal to its uncompressed size (#{entry.uncompressed_size})\"))\n  end\n  @uncompressed_size_counter.io = @io\n  yield @uncompressed_size_counter\nwhen .deflated?\n  @compressed_size_counter.io = @io\n  io = Flate::Writer.new(@compressed_size_counter)\n  @uncompressed_size_counter.io = io\n  yield @uncompressed_size_counter\n  io.close\nelse\n  raise(\"Unsupported compression method: #{entry.compression_method}\")\nend\n@written = @written + @compressed_size_counter.count\ncrc32 = @uncompressed_size_counter.crc32.to_u32\nuncompressed_size = @uncompressed_size_counter.count\nif entry.compression_method.stored?\n  compressed_size = uncompressed_size\nelse\n  compressed_size = @compressed_size_counter.count\nend\nif entry.compression_method.stored?\n  if entry.crc32 != crc32\n    raise(Error.new(\"Entry CRC32 mistmacth (#{entry.crc32} given but was #{crc32})\"))\n  end\n  if entry.uncompressed_size != uncompressed_size\n    raise(Error.new(\"Entry uncompressed size mistmatch (#{entry.uncompressed_size} given but was #{uncompressed_size})\"))\n  end\nelse\n  entry.crc32 = crc32\n  entry.compressed_size = compressed_size\n  entry.uncompressed_size = uncompressed_size\nend\nif entry.compression_method.stored?\nelse\n  @written = @written + (entry.write_data_descriptor(@io))\nend\n@entries << entry\n"}},{"id":"add(filename_or_entry:String|Entry,string:String)-instance-method","html_id":"add(filename_or_entry:String|Entry,string:String)-instance-method","name":"add","doc":"Adds an entry that will have *string* as its contents.","summary":"<p>Adds an entry that will have <em>string</em> as its contents.</p>","abstract":false,"args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"args_string":"(filename_or_entry : String | Entry, string : String)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L148","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L148","def":{"name":"add","args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"string","doc":null,"default_value":"","external_name":"string","restriction":"String"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"add(filename_or_entry) do |io|\n  io << string\nend"}},{"id":"add(filename_or_entry:String|Entry,bytes:Bytes)-instance-method","html_id":"add(filename_or_entry:String|Entry,bytes:Bytes)-instance-method","name":"add","doc":"Adds an entry that will have *bytes* as its contents.","summary":"<p>Adds an entry that will have <em>bytes</em> as its contents.</p>","abstract":false,"args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"args_string":"(filename_or_entry : String | Entry, bytes : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L155","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L155","def":{"name":"add","args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"bytes","doc":null,"default_value":"","external_name":"bytes","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"add(filename_or_entry) do |io|\n  io.write(bytes)\nend"}},{"id":"add(filename_or_entry:String|Entry,data:IO)-instance-method","html_id":"add(filename_or_entry:String|Entry,data:IO)-instance-method","name":"add","doc":"Adds an entry that will have its data copied from the given *data*.\nIf the given *data* is a `::File`, it is automatically closed\nafter data is copied from it.","summary":"<p>Adds an entry that will have its data copied from the given <em>data</em>.</p>","abstract":false,"args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"IO"}],"args_string":"(filename_or_entry : String | Entry, data : IO)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L164","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L164","def":{"name":"add","args":[{"name":"filename_or_entry","doc":null,"default_value":"","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"data","doc":null,"default_value":"","external_name":"data","restriction":"IO"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"add(filename_or_entry) do |io|\n  IO.copy(data, io)\n  if data.is_a?(::File)\n    data.close\n  end\nend"}},{"id":"add_dir(name)-instance-method","html_id":"add_dir(name)-instance-method","name":"add_dir","doc":"Adds a directory entry that will have the given *name*.","summary":"<p>Adds a directory entry that will have the given <em>name</em>.</p>","abstract":false,"args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"args_string":"(name)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L172","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L172","def":{"name":"add_dir","args":[{"name":"name","doc":null,"default_value":"","external_name":"name","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if name.ends_with?('/')\nelse\n  name = name + '/'\nend\nadd(Entry.new(name)) do\nend\n"}},{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this zip writer.","summary":"<p>Closes this zip writer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L178","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L178","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nstart_offset = @written\nwrite_central_directory\nwrite_end_of_central_directory(start_offset, @written - start_offset)\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L29","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"comment=(comment)-instance-method","html_id":"comment=(comment)-instance-method","name":"comment=","doc":"Sets the zip file comment","summary":"<p>Sets the zip file comment</p>","abstract":false,"args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":""}],"args_string":"(comment)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L32","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L32","def":{"name":"comment=","args":[{"name":"comment","doc":null,"default_value":"","external_name":"comment","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@comment = comment"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L26","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L26","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr#L26","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}}],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Zip/Writer/Entry","path":"Zip/Writer/Entry.html","kind":"class","full_name":"Zip::Writer::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zip/writer.cr","line_number":233,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zip/writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[{"html_id":"github.com/crystal-lang/crystal/Zip/FileInfo","kind":"module","full_name":"Zip::FileInfo","name":"FileInfo"}],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zip/Writer","kind":"class","full_name":"Zip::Writer","name":"Writer"},"doc":"An entry to write into a `Zip::Writer`.","summary":"<p>An entry to write into a <code><a href=\"../../Zip/Writer.html\">Zip::Writer</a></code>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]}]}]},{"html_id":"github.com/crystal-lang/crystal/Zlib","path":"Zlib.html","kind":"module","full_name":"Zlib","name":"Zlib","abstract":false,"superclass":null,"ancestors":[],"locations":[{"filename":"zlib/reader.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr"},{"filename":"zlib/zlib.cr","line_number":7,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/zlib.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"Flate::BEST_COMPRESSION","doc":null,"summary":null},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"Flate::BEST_SPEED","doc":null,"summary":null},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"Flate::DEFAULT_COMPRESSION","doc":null,"summary":null},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"Flate::NO_COMPRESSION","doc":null,"summary":null}],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":null,"doc":"The Zlib module contains readers and writers of zlib format compressed\ndata, as specified in [RFC 1950](https://www.ietf.org/rfc/rfc1950.txt).","summary":"<p>The Zlib module contains readers and writers of zlib format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1950.txt\" target=\"_blank\">RFC 1950</a>.</p>","class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[{"html_id":"github.com/crystal-lang/crystal/Zlib/Error","path":"Zlib/Error.html","kind":"class","full_name":"Zlib::Error","name":"Error","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zlib/zlib.cr","line_number":13,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/zlib.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zlib","kind":"module","full_name":"Zlib","name":"Zlib"},"doc":null,"summary":null,"class_methods":[],"constructors":[],"instance_methods":[],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Zlib/Reader","path":"Zlib/Reader.html","kind":"class","full_name":"Zlib::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zlib/reader.cr","line_number":6,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zlib","kind":"module","full_name":"Zlib","name":"Zlib"},"doc":"A read-only `IO` object to decompress data in the zlib format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.","summary":"<p>A read-only <code><a href=\"../IO.html\">IO</a></code> object to decompress data in the zlib format.</p>","class_methods":[{"id":"open(io:IO,sync_close=false,dict:Bytes?=nil,&block)-class-method","html_id":"open(io:IO,sync_close=false,dict:Bytes?=nil,&amp;block)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L23","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"reader = new(io, sync_close: sync_close, dict: dict)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"id":"new(io:IO,sync_close=false,dict:Bytes?=nil)-class-method","html_id":"new(io:IO,sync_close=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L14","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L14","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":null,"summary":null,"abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L86","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L86","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@flate_io.close\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L11","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L11","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L59","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L59","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nif @end\n  return 0\nend\nread_bytes = @flate_io.read(slice)\nif read_bytes == 0\n  @end = true\n  @flate_io.close\n  adler32 = @io.read_bytes(UInt32, IO::ByteFormat::BigEndian)\n  if adler32 != @adler32\n    raise(Zlib::Error.new(\"ADLER-32 checksum mismatch\"))\n  end\nelse\n  @adler32 = Adler32.update(slice[0, read_bytes], @adler32)\nend\nread_bytes\n"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L8","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L8","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L8","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes)-instance-method","html_id":"write(slice:Bytes)-instance-method","name":"write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L82","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/reader.cr#L82","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Zlib::Reader\"))"}}],"macros":[],"types":[]},{"html_id":"github.com/crystal-lang/crystal/Zlib/Writer","path":"Zlib/Writer.html","kind":"class","full_name":"Zlib::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"github.com/crystal-lang/crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"github.com/crystal-lang/crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"github.com/crystal-lang/crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"zlib/writer.cr","line_number":8,"url":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr"}],"repository_name":"github.com/crystal-lang/crystal","program":false,"enum":false,"alias":false,"aliased":"","const":false,"constants":[],"included_modules":[],"extended_modules":[],"subclasses":[],"including_types":[],"namespace":{"html_id":"github.com/crystal-lang/crystal/Zlib","kind":"module","full_name":"Zlib","name":"Zlib"},"doc":"A write-only `IO` object to compress data in the zlib format.\n\nInstances of this class wrap another IO object. When you write to this\ninstance, it compresses the data and writes it to the underlying IO.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a Zlib::Writer instance.","summary":"<p>A write-only <code><a href=\"../IO.html\">IO</a></code> object to compress data in the zlib format.</p>","class_methods":[{"id":"open(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil,&block)-class-method","html_id":"open(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L29","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L29","def":{"name":"open","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(io, level: level, sync_close: sync_close, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"id":"open(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil,&block)-class-method","html_id":"open(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil,&amp;block)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(filename : String, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, dict : Bytes? = <span class=\"n\">nil</span>, &block)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L36","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L36","def":{"name":"open","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":1,"block_arg":null,"return_type":"","visibility":"Public","body":"writer = new(filename, level: level, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"id":"new(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil)-class-method","html_id":"new(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, dict : Bytes? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L16","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L16","def":{"name":"new","args":[{"name":"io","doc":null,"default_value":"","external_name":"io","restriction":"IO"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","doc":null,"default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"_ = allocate\n_.initialize(io, level, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"id":"new(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil)-class-method","html_id":"new(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(filename : String, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, dict : Bytes? = <span class=\"n\">nil</span>)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L23","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L23","def":{"name":"new","args":[{"name":"filename","doc":null,"default_value":"","external_name":"filename","restriction":"String"},{"name":"level","doc":null,"default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","doc":null,"default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"new(::File.new(filename, \"w\"), level: level, sync_close: true, dict: dict)"}}],"instance_methods":[{"id":"close-instance-method","html_id":"close-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L70","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L70","def":{"name":"close","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.close\n@io.write_bytes(@adler32, IO::ByteFormat::BigEndian)\nif @sync_close\n  @io.close\nend\n"}},{"id":"closed?:Bool-instance-method","html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L13","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L13","def":{"name":"closed?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@closed"}},{"id":"flush-instance-method","html_id":"flush-instance-method","name":"flush","doc":"Flushes data, forcing writing the zlib header if no\ndata has been written yet.\n\nSee `IO#flush`.","summary":"<p>Flushes data, forcing writing the zlib header if no data has been written yet.</p>","abstract":false,"args":[],"args_string":"","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L62","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L62","def":{"name":"flush","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"check_open\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.flush\n"}},{"id":"read(slice:Bytes)-instance-method","html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L42","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L42","def":{"name":"read","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from Gzip::Writer\"))"}},{"id":"sync_close=(sync_close)-instance-method","html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L10","def":{"name":"sync_close=","args":[{"name":"sync_close","doc":null,"default_value":"","external_name":"sync_close","restriction":""}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close = sync_close"}},{"id":"sync_close?:Bool-instance-method","html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[],"args_string":" : Bool","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L10","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L10","def":{"name":"sync_close?","args":[],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"","visibility":"Public","body":"@sync_close"}},{"id":"write(slice:Bytes):Nil-instance-method","html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L47","source_link":"https://github.com/crystal-lang/crystal/blob/b782738fffb1b9fba98f7aa44f9da11c3da259a1/src/zlib/writer.cr#L47","def":{"name":"write","args":[{"name":"slice","doc":null,"default_value":"","external_name":"slice","restriction":"Bytes"}],"double_splat":null,"splat_index":null,"yields":null,"block_arg":null,"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.write(slice)\n@adler32 = Adler32.update(slice, @adler32)\n"}}],"macros":[],"types":[]}]}]}})